/* Tecnisa - Tecnologia em Informtica

Nome: 9005_CTBSTP_ATUALIZA_SALDO_GERENCIAL.SQL

Descrio:
 Procedimento para atualizao do saldo gerencial.
*/

IF EXISTS(SELECT name FROM sysobjects
          WHERE name = 'ATUALIZA_SALDO_GERENCIAL' AND type = 'P')
  DROP PROCEDURE ATUALIZA_SALDO_GERENCIAL
  GO

CREATE PROCEDURE ATUALIZA_SALDO_GERENCIAL
					  @P_CDEMPRESA VARCHAR(2)
AS

DECLARE @V_DTFINACONT DATETIME;
DECLARE @V_DATAINIC   DATETIME;
DECLARE @V_CONTSALDO  VARCHAR(1);
DECLARE @DATA_SALDO   DATETIME;
DECLARE @DATA_AUX     DATETIME;

DECLARE @V_NRSEQ              VARCHAR(10);
DECLARE @SOMACONTA_CDFILIAL   VARCHAR(4);
DECLARE @SOMACONTA_CDCENTCUST VARCHAR(4);
DECLARE @SOMACONTA_CDCONTCTBL VARCHAR(20);
DECLARE @SOMACONTA_VALORSALDO DOUBLE PRECISION;

BEGIN
   SELECT @V_DATAINIC = MIN(DTLANCCONT)
   FROM LANCCONT
	WHERE (LANCCONT.CDEMPRESA   = @P_CDEMPRESA) AND
         (LANCCONT.IDLANCSALDO = 'N');

   DECLARE C_LANCGERE CURSOR FOR
      SELECT LANCCONT.CDEMPRESA, LANCCONT.CDCONTCTBL, IDLANCSALDO, VRLANCAMENT,
             SALDCCUS.CDEMPRESA, SALDCCUS.CDCONTCTBL, DTSALDCCUS,  VRSALDCCUS
      FROM LANCCONT,LANCCCUSTO,  SALDCCUS WITH (UPDLOCK)
      WHERE (LANCCONT.CDEMPRESA    = @P_CDEMPRESA)          AND
            (LANCCONT.IDLANCSALDO  = 'N')                   AND
            (LANCCONT.CDEMPRESA    = LANCCCUSTO.CDEMPRESA)  AND
            (LANCCONT.NRLANCCONT   = LANCCCUSTO.NRLANCCONT) AND
            (LANCCONT.NRSEQLANC    = LANCCCUSTO.NRSEQLANC)  AND
            (LANCCCUSTO.CDEMPRESA  = SALDCCUS.CDEMPRESA)    AND
            (LANCCCUSTO.CDFILIAL   = SALDCCUS.CDFILIAL)     AND
            (LANCCCUSTO.CDCENTCUST = SALDCCUS.CDCENTCUST)   AND
            (LANCCONT.CDCONTCTBL   = SALDCCUS.CDCONTCTBL)   AND
            (SALDCCUS.DTSALDCCUS >= @V_DATAINIC);

   DECLARE C_LANCCEXC CURSOR FOR
         SELECT NRSEQCCEX
         FROM LANCCEXC WITH (UPDLOCK)
         WHERE (CDEMPRESA  = @P_CDEMPRESA) AND
               (DTLANCCCEX >= @V_DATAINIC)


   SELECT @V_DTFINACONT = MAX(DTFINACONT)
   FROM CONTOPECTBL
   WHERE CDEMPRESA = @P_CDEMPRESA;

   IF @V_DTFINACONT IS NOT NULL BEGIN

      SELECT @V_DATAINIC = MIN(DTLANCCONT)
      FROM LANCCONT
      WHERE (LANCCONT.CDEMPRESA   = @P_CDEMPRESA) AND
            (LANCCONT.IDSALDLANGE = 'N');

      IF @V_DATAINIC IS NULL BEGIN
         SELECT @V_DATAINIC = MIN(DTLANCCCEX)
         FROM LANCCEXC
         WHERE (CDEMPRESA = @P_CDEMPRESA);
      END;

      OPEN C_LANCGERE;
      CLOSE C_LANCGERE;

      OPEN C_LANCCEXC;

      SET @DATA_SALDO = DATEADD(MM, 1, @V_DATAINIC) - DAY(DATEADD(MM, 1, @V_DATAINIC));

      WHILE (@DATA_SALDO <= @V_DTFINACONT) BEGIN

         DECLARE C_SOMACONTA CURSOR FOR
            (SELECT LANCCCUSTO.CDFILIAL, LANCCCUSTO.CDCENTCUST,
                    LANCCONT.CDCONTCTBL, SUM(LANCCCUSTO.VRLANCCUST) AS VALORSALDO
             FROM LANCCONT,LANCCCUSTO
             WHERE (LANCCONT.CDEMPRESA   = @P_CDEMPRESA)                     AND
                   (LANCCONT.IDSALDLANGE = 'N')                              AND
                   (LANCCCUSTO.DTCOMPCUSTO BETWEEN @V_DATAINIC AND @DATA_SALDO) AND
                   (LANCCCUSTO.CDEMPRESA = @P_CDEMPRESA)                     AND
                   (LANCCONT.NRLANCCONT  = LANCCCUSTO.NRLANCCONT)            AND
                   (LANCCONT.NRSEQLANC   = LANCCCUSTO.NRSEQLANC)
             GROUP BY CDFILIAL, CDCENTCUST, CDCONTCTBL
             UNION ALL
             SELECT CDFILIALEX AS CDFILIAL, CDCENTCUSEX AS CDCENTCUST, CDCONTCCEX AS CDCONTCTBL,
                    SUM(VRLANCCCEX) AS VALORSALDO
             FROM LANCCEXC
             WHERE (CDEMPRESA = @P_CDEMPRESA) AND
                   (DTLANCCCEX BETWEEN @V_DATAINIC AND @DATA_SALDO)
             GROUP BY CDFILIALEX, CDCENTCUSEX, CDCONTCCEX );

         OPEN C_SOMACONTA;
         FETCH NEXT FROM C_SOMACONTA INTO @SOMACONTA_CDFILIAL,   @SOMACONTA_CDCENTCUST,
                                          @SOMACONTA_CDCONTCTBL, @SOMACONTA_VALORSALDO;

         WHILE (@@FETCH_STATUS = 0) BEGIN

             SELECT @V_CONTSALDO = COUNT(*)
             FROM SALDCCUS
             WHERE (SALDCCUS.CDEMPRESA = @P_CDEMPRESA)          AND
                  (SALDCCUS.CDFILIAL   = @SOMACONTA_CDFILIAL)   AND
                  (SALDCCUS.CDCENTCUST = @SOMACONTA_CDCENTCUST) AND
                  (SALDCCUS.CDCONTCTBL = @SOMACONTA_CDCONTCTBL) AND
                  (SALDCCUS.DTSALDCCUS = @DATA_SALDO);

             IF @V_CONTSALDO > 0 BEGIN

               INSERT INTO SALDCCUS
                   (CDEMPRESA,  CDFILIAL,   CDCENTCUST,
                    CDCONTCTBL, DTSALDCCUS, VRSALDCCUS)
               (SELECT @P_CDEMPRESA, @SOMACONTA_CDFILIAL, @SOMACONTA_CDCENTCUST,
                       CDCONTCTBL,   @DATA_SALDO, 0
                FROM CONTCTBL
                WHERE (CDCONTCTBL NOT IN (SELECT DISTINCT CDCONTCTBL
                                          FROM SALDCCUS
                                          WHERE (SALDCCUS.CDEMPRESA  = @P_CDEMPRESA)          AND
                                                (SALDCCUS.CDFILIAL   = @SOMACONTA_CDFILIAL)   AND
                                                (SALDCCUS.CDCENTCUST = @SOMACONTA_CDCENTCUST) AND
                                                (SALDCCUS.DTSALDCCUS = @DATA_SALDO)) )        AND
                           (CHARINDEX(RTRIM(CONTCTBL.CDCONTCTBL), @SOMACONTA_CDCONTCTBL) = 1));
            END;

            UPDATE SALDCCUS
            SET VRSALDCCUS = VRSALDCCUS + @SOMACONTA_VALORSALDO
            WHERE (SALDCCUS.DTSALDCCUS = @DATA_SALDO)           AND
                  (SALDCCUS.CDEMPRESA  = @P_CDEMPRESA)          AND
                  (SALDCCUS.CDFILIAL   = @SOMACONTA_CDFILIAL)   AND
                  (SALDCCUS.CDCENTCUST = @SOMACONTA_CDCENTCUST) AND
                  (CHARINDEX(RTRIM(SALDCCUS.CDCONTCTBL), @SOMACONTA_CDCONTCTBL) = 1);

            FETCH NEXT FROM C_SOMACONTA INTO @SOMACONTA_CDFILIAL,   @SOMACONTA_CDCENTCUST,
                                             @SOMACONTA_CDCONTCTBL, @SOMACONTA_VALORSALDO;

         END;

         CLOSE C_SOMACONTA;
         DEALLOCATE C_SOMACONTA;

         SET @DATA_AUX   = DATEADD(MM, 1, @DATA_SALDO);
         SET @DATA_SALDO = DATEADD(MM, 1, @DATA_AUX) - DAY(DATEADD(MM, 1, @DATA_AUX));

      END;

      FETCH NEXT FROM C_LANCCEXC INTO @V_NRSEQ;
      WHILE (@@FETCH_STATUS = 0) BEGIN
         DELETE FROM LANCCEXC
         WHERE (NRSEQCCEX = @V_NRSEQ);
         FETCH NEXT FROM C_LANCCEXC INTO @V_NRSEQ;
      END;
      CLOSE C_LANCCEXC;
      DEALLOCATE C_LANCCEXC;

      UPDATE LANCCONT
      SET IDSALDLANGE = 'S'
      WHERE (CDEMPRESA   = @P_CDEMPRESA) AND
            (IDSALDLANGE = 'N') ;

   END;
   DEALLOCATE C_LANCGERE;

END;
GO



-- VERSAO --
EXEC ATUVEROBJ 'ATUALIZA_SALDO_GERENCIAL','5.05.020';
GO

