-- ======================================================================================
--   TABLE: DADOSFISCREGRA
-- ======================================================================================
ALTER TABLE DADOSFISCREGRA ADD CDBENEFFISCAL VARCHAR2(10) 
/ 
-- ======================================================================================
--   TABLE: DADOSFISCNCM
-- ======================================================================================
ALTER TABLE DADOSFISCNCM ADD CDBENEFFISCAL VARCHAR2(10)
/
-- ======================================================================================
--   TABLE: DADOSFISCPROD
-- ======================================================================================
ALTER TABLE DADOSFISCPROD ADD CDBENEFFISCAL VARCHAR2(10)
/
-- ======================================================================================
--   TABLE: CODAJUSTEEFDICMS
-- ======================================================================================
ALTER TABLE CODAJUSTEEFDICMS DROP CONSTRAINT CKC_IDTPAJUSTE_CODAJUSTEEFDICM
/
ALTER TABLE CODAJUSTEEFDICMS ADD CONSTRAINT CKC_IDTPAJUSTE_CODAJUSTEEFDICM CHECK (IDTPAJUSTE IN ('A', 'B', 'D'))
/
-- ======================================================================================
--   TABLE: ALIQTEMP
-- ======================================================================================
ALTER TABLE ALIQTEMP ADD CDBENEFFISCAL VARCHAR2(10)
/
-- ======================================================================================
--   TABLE: ALIQUOTA
-- ======================================================================================
ALTER TABLE ALIQUOTA ADD CDBENEFFISCAL VARCHAR2(10)
/
-- ======================================================================================
--   TABLE: ITEMPROIMPOS
-- ======================================================================================
ALTER TABLE ITEMPROIMPOS ADD CDBENEFFISCAL VARCHAR2(10)
/
-- ======================================================================================
--   TABLE: ITEMPROIMPOSORIG
-- ======================================================================================
ALTER TABLE ITEMPROIMPOSORIG ADD CDBENEFFISCAL VARCHAR2(10)
/
-- ======================================================================================
--   TABLE: TRABITPROIMPOS
-- ======================================================================================
ALTER TABLE TRABITPROIMPOS ADD CDBENEFFISCAL VARCHAR2(10)
/
-- ======================================================================================
-- Table: DADOSFISCREGRA
-- ======================================================================================
ALTER TABLE DADOSFISCREGRA ADD IDIMPODESONERA VARCHAR2(1) DEFAULT 'N' NOT NULL
/
ALTER TABLE DADOSFISCREGRA ADD IDCONSDESONVRNF VARCHAR2(1) DEFAULT 'N' NOT NULL
/
-- ======================================================================================
-- Table: DADOSFISCNCM
-- ======================================================================================
ALTER TABLE DADOSFISCNCM ADD IDIMPODESONERA VARCHAR2(1) DEFAULT 'N' NOT NULL
/
ALTER TABLE DADOSFISCNCM ADD IDCONSDESONVRNF VARCHAR2(1) DEFAULT 'N' NOT NULL
/
-- ======================================================================================
-- Table: DADOSFISCPROD
-- ======================================================================================
ALTER TABLE DADOSFISCPROD ADD IDIMPODESONERA VARCHAR2(1) DEFAULT 'N' NOT NULL
/
ALTER TABLE DADOSFISCPROD ADD IDCONSDESONVRNF VARCHAR2(1) DEFAULT 'N' NOT NULL
/
-- ======================================================================================
-- Table: ALIQTEMP 
-- ======================================================================================
ALTER TABLE ALIQTEMP ADD IDIMPODESONERA VARCHAR2(1) DEFAULT 'N' NOT NULL
/
ALTER TABLE ALIQTEMP ADD IDCONSDESONVRNF VARCHAR2(1) DEFAULT 'N' NOT NULL
/
-- ======================================================================================
--   TABLE: ALIQUOTA
-- ======================================================================================
ALTER TABLE ALIQUOTA ADD IDIMPODESONERA VARCHAR2(1) DEFAULT 'N' NOT NULL
/
ALTER TABLE ALIQUOTA ADD IDCONSDESONVRNF VARCHAR2(1) DEFAULT 'N' NOT NULL
/
-- ======================================================================================
--   TABLE: ITEMPROIMPOS
-- ======================================================================================
ALTER TABLE ITEMPROIMPOS ADD IDDESONERAREGRA VARCHAR2(1) DEFAULT 'N' NOT NULL
/
ALTER TABLE ITEMPROIMPOS ADD IDCONSDESONVRNF VARCHAR2(1) DEFAULT 'N' NOT NULL
/
ALTER TABLE ITEMPROIMPOS ADD VRIMPOSTODESON FLOAT
/
-- ============================================================
-- TABLE: TRABITPROIMPOS
-- ============================================================
ALTER TABLE TRABITPROIMPOS ADD VRIMPOSTODESON FLOAT
/
/*
 Tecnisa - Tecnologia em Informática
 Nome: CONSULTA_REGRA_FISCAL
  Descrição:
  Função para detectar a regra fiscal a ser considerada e, posteriormente, preencher as tabelas temporárias de alíquota,
  incidência, cfop e cst conforme a regra encontrada.
 Criação:
 23/05/2012 - Marcelo Alexsandro Souza Silva
*/
DROP FUNCTION CONSULTA_REGRA_FISCAL
/
DROP TYPE REGRAFISCAL_TABLE
/
DROP TYPE REGRAFISCAL_TYPE
/
CREATE TYPE REGRAFISCAL_TYPE AS
OBJECT (CDREGRAFISC      VARCHAR2(10),
        NMREGRAFISC      VARCHAR2(50),
        NRSEQDADOSFISC   VARCHAR2(10),
        CDCLASFISC       VARCHAR2(10),
        CDPRODUTO        VARCHAR2(10),
        DSMENSREGRAFISC  VARCHAR2(150),
        CDIMPOSTO        VARCHAR2(2),
        CDFISCAL         VARCHAR2(1),
        CDSITUTRIB       VARCHAR2(2),
        VRALIQUOTA       FLOAT(126),
        IDMODBCNFE       VARCHAR2(1),
        IDMODBCSTNFE     VARCHAR2(1),
        IDMOTIDESSTNFE   VARCHAR2(2),
        CDTPCRPICOSTNFE  VARCHAR2(3),
        CDNATUBCPCSTNFE  VARCHAR2(2),
        VRINIFAIXA       FLOAT(126),
        VRFIMFAIXA       FLOAT(126),
        VRPARDEDUZ       FLOAT(126),
        VR1PERREDBC      FLOAT(126),
        VRPERREDBC       FLOAT(126),
        VRPBCSUBTRIB     FLOAT(126),
        IDTRATIMPST      VARCHAR2(1),
        IDPMCBASECA      VARCHAR2(1),
        IDCSTINTEREST    VARCHAR2(1),
        IDCSTINTERNA     VARCHAR2(1),
        CDFISCOPER       VARCHAR2(10),
        IDCFOPINTEREST   VARCHAR2(1),
        IDDIFEALIQ       VARCHAR2(1),
        IDDIFALIQCUSPR   VARCHAR2(1),
        IDTIPODESTFISC   VARCHAR2(1),
        CDDETALHEFISC    VARCHAR2(5),
        IDTIPOREGISTRO   VARCHAR2(4),
        IDMENSAGEM       VARCHAR2(1),
        CDENQLEGALIPI    VARCHAR2(3),
        CDCEST           VARCHAR2(9),
        VRADICALIQFECP   FLOAT(126),
        CDBENEFFISCAL    VARCHAR2(10),
        IDCONSMVAPMC     VARCHAR2(1),
        IDCONSCOMPBCPMC  VARCHAR2(1),
        IDCONSDIFALIQ    VARCHAR2(1),
        IDIMPODESONERA   VARCHAR2(1),
        IDCONSDESONVRNF  VARCHAR2(1));
/
CREATE TYPE REGRAFISCAL_TABLE AS
TABLE OF REGRAFISCAL_TYPE
/
CREATE OR REPLACE FUNCTION CONSULTA_REGRA_FISCAL
(P_CDIMPOSTO   IN IMPOSTO.CDIMPOSTO%TYPE,
 P_EMPRESA     IN INCIDENCIA.CDEMPRESA%TYPE,
 P_CDGRUPOFISC IN INCIDENCIA.CDGRUPOFISC%TYPE,
 P_ENTRSAIDIN  IN INCIDENCIA.IDENTRSAIDIN%TYPE,
 P_TIPOOPER    IN INCIDENCIA.CDTIPOOPER%TYPE,
 P_INSCESTA    IN INCIDENCIA.CDINSCESTA%TYPE,
 P_CDARVPROD   IN PRODUTO.CDARVPROD%TYPE,
 P_DTENTRSAID  IN NOTAFISCAL.DTENTRSAID%TYPE,
 P_PAISORIG    IN PAIS.CDPAIS%TYPE,
 P_ESTAORIG    IN ESTADO.SGESTADO%TYPE,
 P_MUNIORIG    IN MUNICIPIO.CDMUNICIPIO%TYPE,
 P_PAISDEST    IN PAIS.CDPAIS%TYPE,
 P_ESTADEST    IN ESTADO.SGESTADO%TYPE,
 P_MUNIDEST    IN MUNICIPIO.CDMUNICIPIO%TYPE,
 P_BASECALC    IN ALIQUOTA.VRFIMFAIXA%TYPE,
 P_CFOP        IN INCIDENCIA.IDENTRSAIDIN%TYPE,
 P_IDORIGEMPROD IN VARCHAR2 DEFAULT 'N') RETURN REGRAFISCAL_TABLE PIPELINED
IS
V_CDREGRAFISC         REGRAFISCAL.CDREGRAFISC%TYPE;
V_NMREGRAFISC         REGRAFISCAL.NMREGRAFISC%TYPE;
V_DSMENSREGRAFISC     REGRAFISCAL.DSMENSREGRAFISC%TYPE;
V_CDFISCOPER          VARCHAR2(10);
V_IDCFOPINTEREST      VARCHAR2(1);
V_IDDIFEALIQ          VARCHAR2(1);
V_IDDIFALIQCUSPR      VARCHAR2(1);
V_UTFAIXVLR           IMPOSTO.IDUTFAIXVLR%TYPE;
V_UTMUNIORIG          IMPOSTO.IDUTMUNIORIG%TYPE;
V_UTUFORIG            IMPOSTO.IDUTUFORIG%TYPE;
V_UTUFDEST            IMPOSTO.IDUTUFDEST%TYPE;
V_CDFISCAL            VARCHAR2(1);
V_CDSITUTRIB          VARCHAR2(2);
V_VRALIQUOTA          FLOAT(126);
V_IDMODBCNFE          VARCHAR2(1);
V_IDMODBCSTNFE        VARCHAR2(1);
V_IDMOTIDESSTNFE      VARCHAR2(2);
V_CDTPCRPICOSTNFE     VARCHAR2(3);
V_CDNATUBCPCSTNFE     VARCHAR2(2);
V_VRINIFAIXA          FLOAT(126);
V_VRFIMFAIXA          FLOAT(126);
V_VRPARDEDUZ          FLOAT(126);
V_VR1PERREDBC         FLOAT(126);
V_VRPERREDBC          FLOAT(126);
V_VRPBCSUBTRIB        FLOAT(126);
V_IDTRATIMPST         VARCHAR2(1);
V_IDPMCBASECA         VARCHAR2(1);
V_IDCSTINTEREST       VARCHAR2(1);
V_IDCSTINTERNA        VARCHAR2(1);
V_IDTIPODESTFISC      VARCHAR2(1);
V_CDDETALHEFISC       VARCHAR2(5);
V_STATUSESTADUAL      VARCHAR2(1);
V_STATUSINTERNACIONAL VARCHAR2(1);
V_IDTIPOREGISTRO      VARCHAR2(4);
V_NRSEQDADOSFISC      VARCHAR2(10);
V_IDMENSAGEM          VARCHAR2(01);
V_CDCLASFISC          VARCHAR2(10);
V_CDPRODUTO           VARCHAR2(10);
V_VRQTDEMB            FLOAT(126);
V_SGUNIDEMB           VARCHAR2(5);
V_UTILRANGE           VARCHAR2(1);
V_IDORIGEMPROD        VARCHAR2(1);
V_CDIMPOSTONFE        VARCHAR2(2);
V_CDENQLEGALIPI       VARCHAR2(3);
V_CDCEST              VARCHAR2(9);
V_IDUTORIGPROD        VARCHAR2(1);
V_VRADICALIQFECP      FLOAT(126);
V_CDBENEFFISCAL       VARCHAR2(10);
V_IDCONSMVAPMC        VARCHAR2(01);
V_IDCONSCOMPBCPMC     VARCHAR2(01);
V_IDCONSDIFALIQ       VARCHAR2(1);
V_IDIMPODESONERA      VARCHAR2(1);
V_IDCONSDESONVRNF     VARCHAR2(1);
OUT_RECORD REGRAFISCAL_TYPE := REGRAFISCAL_TYPE (NULL, NULL, NULL, NULL,
                                                 NULL, NULL, NULL, NULL,
                                                 NULL, NULL, NULL, NULL,
                                                 NULL, NULL, NULL, NULL,
                                                 NULL, NULL, NULL, NULL,
                                                 NULL, NULL, NULL, NULL,
                                                 NULL, NULL, NULL, NULL,
                                                 NULL, NULL, NULL, NULL,
                                                 NULL, NULL, NULL, NULL,
                                                 NULL, NULL, NULL, NULL,
                                                 NULL, NULL);
BEGIN
   FOR C_REGRAFISCAL IN
      (SELECT V.CDIMPOSTO, MIN(V.NRORDPRIORIDADE||'_'||R.CDREGRAFISC) ORDEM
         FROM REGRAFISCAL R,
          (
           SELECT MAX(TO_CHAR(REGAUX.DTVALREGRAFISC, 'YYYYMMDD')||'_'||REGAUX.CDREGRAFISC) NUMERO, NRORDPRIORIDADE, IMPREGRAFISCAL.CDIMPOSTO
             FROM VINCULOFISREGRA, IMPREGRAFISCAL, REGRAFISCAL REGAUX
            WHERE VINCULOFISREGRA.CDEMPRESA      = P_EMPRESA
              AND VINCULOFISREGRA.CDREGRAFISC    = REGAUX.CDREGRAFISC
              AND REGAUX.IDATIVREGRAFISC = 'S'
              AND ((REGAUX.DTVALREGRAFISC <= TRUNC(P_DTENTRSAID)) OR (REGAUX.DTVALREGRAFISC IS NULL) OR (P_DTENTRSAID IS NULL))
              AND (VINCULOFISREGRA.IDENTRSAIDOP  = P_ENTRSAIDIN   OR IDENTRSAIDOP IS NULL)
              AND (VINCULOFISREGRA.CDTIPOOPER    = P_TIPOOPER     OR CDTIPOOPER IS NULL)
              AND (VINCULOFISREGRA.CDINSCESTA    = P_INSCESTA     OR CDINSCESTA IS NULL)
              AND (IMPREGRAFISCAL.CDIMPOSTO      = P_CDIMPOSTO    OR P_CDIMPOSTO IS NULL)
              AND (IMPREGRAFISCAL.CDREGRAFISC = REGAUX.CDREGRAFISC)
              AND (IMPREGRAFISCAL.IDIMPOBRIGREGRA = 'S')
              AND ((VINCULOFISREGRA.DTVALVINCFISC >= TRUNC(P_DTENTRSAID)) OR (VINCULOFISREGRA.DTVALVINCFISC IS NULL) OR (P_DTENTRSAID IS NULL))
              AND ((P_CDGRUPOFISC IS NULL     AND NOT EXISTS (SELECT 1 FROM GRUPOFISCREGRA  WHERE GRUPOFISCREGRA.CDREGRAFISC = REGAUX.CDREGRAFISC)) OR
                   (P_CDGRUPOFISC IS NOT NULL AND     EXISTS (SELECT 1 FROM GRUPOFISCREGRA WHERE GRUPOFISCREGRA.CDREGRAFISC = REGAUX.CDREGRAFISC AND GRUPOFISCREGRA.CDGRUPOFISC = P_CDGRUPOFISC)))
           GROUP BY NRORDPRIORIDADE, IMPREGRAFISCAL.CDIMPOSTO) V
       WHERE R.CDREGRAFISC = SUBSTR(V.NUMERO, (INSTR(V.NUMERO, '_')) + 1, 10)
       GROUP BY V.CDIMPOSTO
       ORDER BY V.CDIMPOSTO
       )
   LOOP
      BEGIN
         SELECT IDUTFAIXVLR, IDUTMUNIORIG, IDUTUFORIG, IDUTUFDEST, CDIMPOSTONFE
           INTO V_UTFAIXVLR, V_UTMUNIORIG, V_UTUFORIG, V_UTUFDEST, V_CDIMPOSTONFE
           FROM IMPOSTO
          WHERE IMPOSTO.CDIMPOSTO = C_REGRAFISCAL.CDIMPOSTO;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN BEGIN
            V_UTFAIXVLR    := 'N';
            V_UTMUNIORIG   := 'N';
            V_UTUFORIG     := 'N';
            V_UTUFDEST     := 'N';
            V_CDIMPOSTONFE := NULL;
         END;
      END;
      V_CDFISCOPER     := NULL;
      V_IDCFOPINTEREST := NULL;
      V_IDDIFEALIQ     := NULL;
      V_IDDIFALIQCUSPR := NULL;
      V_IDTIPOREGISTRO := NULL;
      V_IDMENSAGEM     := NULL;
      V_CDCLASFISC     := NULL;
      V_CDPRODUTO      := NULL;
      V_IDORIGEMPROD   := NULL;
      IF (V_CDIMPOSTONFE = '00') THEN
         BEGIN
            SELECT NVL(IDUTORIGPROD, 'N')
              INTO V_IDUTORIGPROD
              FROM PARAMGERAL
             WHERE CDPARGERAL = '0001';
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_IDUTORIGPROD := 'N';
         END;
         IF V_IDUTORIGPROD = 'S' THEN
            V_IDORIGEMPROD := P_IDORIGEMPROD;
         ELSE
            V_IDORIGEMPROD := 'N';
         END IF;
      ELSE
         V_IDORIGEMPROD := 'N';
      END IF;
      V_CDREGRAFISC := SUBSTR(C_REGRAFISCAL.ORDEM, (INSTR(C_REGRAFISCAL.ORDEM, '_')) + 1, 10);
      BEGIN
         IF (P_PAISORIG||P_ESTAORIG) <> (P_PAISDEST||P_ESTADEST) THEN
            SELECT MAX(CDFISCOPER), MAX(IDCFOPINTEREST), MAX(IDDIFEALIQ), MAX(IDDIFALIQCUSPR), TO_CHAR(MAX('PROD')), MAX(CFOPREGRAFISCAL.CDPRODUTO)
              INTO V_CDFISCOPER, V_IDCFOPINTEREST, V_IDDIFEALIQ, V_IDDIFALIQCUSPR, V_IDTIPOREGISTRO, V_CDPRODUTO
              FROM CFOPREGRAFISCAL, PRODUTO PRODUTOREGRA
             WHERE CFOPREGRAFISCAL.CDREGRAFISC = V_CDREGRAFISC
               AND PRODUTOREGRA.CDPRODUTO = CFOPREGRAFISCAL.CDPRODUTO
               AND ((IDCFOPINTEREST = 'I') OR (IDCFOPINTEREST = 'T'))
               AND PRODUTOREGRA.CDARVPROD = (SELECT MAX(B.CDARVPROD)
                                               FROM CFOPREGRAFISCAL A, PRODUTO B
                                              WHERE A.CDREGRAFISC = V_CDREGRAFISC
                                                AND A.CDPRODUTO = B.CDPRODUTO
                                                AND INSTR(P_CDARVPROD, B.CDARVPROD) = 1);
            BEGIN
               SELECT DECODE(COUNT(MSGCFOPREGFISC.CDREGRAFISC), 0, 'N', 'S')
                 INTO V_IDMENSAGEM
                 FROM MSGCFOPREGFISC
                WHERE CDREGRAFISC = V_CDREGRAFISC
                  AND IDCFOPINTEREST = V_IDCFOPINTEREST
                  AND CDPRODUTO = V_CDPRODUTO;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN BEGIN
                  V_IDMENSAGEM      := 'N';
               END;
            END;
            IF V_CDFISCOPER IS NULL THEN
               SELECT MAX(CDFISCOPER), MAX(IDCFOPINTEREST), MAX(IDDIFEALIQ), MAX(IDDIFALIQCUSPR), TO_CHAR(MAX('NCM')), MAX(CDCLASFISC)
                 INTO V_CDFISCOPER, V_IDCFOPINTEREST, V_IDDIFEALIQ, V_IDDIFALIQCUSPR, V_IDTIPOREGISTRO, V_CDCLASFISC
                 FROM CFOPNCMREGRAFIS
                WHERE CFOPNCMREGRAFIS.CDREGRAFISC = V_CDREGRAFISC
                  AND ((IDCFOPINTEREST = 'I') OR (IDCFOPINTEREST = 'T'))
                  AND CFOPNCMREGRAFIS.CDCLASFISC = (SELECT MAX(A.CDCLASFISC)
                                                      FROM CFOPNCMREGRAFIS A, PRODUTO B
                                                     WHERE A.CDREGRAFISC = V_CDREGRAFISC
                                                       AND B.CDARVPROD = P_CDARVPROD
                                                       AND INSTR(B.CDCLASFISC, A.CDCLASFISC)=1);
               BEGIN
                  SELECT DECODE(COUNT(MSGCFOPNCM.CDREGRAFISC), 0, 'N', 'S')
                    INTO V_IDMENSAGEM
                    FROM MSGCFOPNCM
                   WHERE CDREGRAFISC = V_CDREGRAFISC
                     AND CDCLASFISC = V_CDCLASFISC
                     AND IDCFOPINTEREST = V_IDCFOPINTEREST;
               EXCEPTION
                  WHEN NO_DATA_FOUND THEN BEGIN
                     V_IDMENSAGEM      := 'N';
                  END;
               END;
               IF V_CDFISCOPER IS NULL THEN
                  SELECT MAX(CDFISCOPER), MAX(IDCFOPINTEREST), MAX(IDDIFEALIQ), MAX(IDDIFALIQCUSPR), TO_CHAR(MAX('PAD'))
                    INTO V_CDFISCOPER, V_IDCFOPINTEREST, V_IDDIFEALIQ, V_IDDIFALIQCUSPR, V_IDTIPOREGISTRO
                    FROM CFOPADRAOREGFIS
                   WHERE CFOPADRAOREGFIS.CDREGRAFISC = V_CDREGRAFISC
                     AND ((IDCFOPINTEREST = 'I') OR (IDCFOPINTEREST = 'T'));
                  BEGIN
                     SELECT DECODE(COUNT(MSGCFOPADRAO.CDREGRAFISC), 0, 'N', 'S')
                       INTO V_IDMENSAGEM
                       FROM MSGCFOPADRAO
                      WHERE CDREGRAFISC = V_CDREGRAFISC
                        AND IDCFOPINTEREST = V_IDCFOPINTEREST;
                  EXCEPTION
                     WHEN NO_DATA_FOUND THEN BEGIN
                        V_IDMENSAGEM      := 'N';
                     END;
                  END;
               END IF;
            END IF;
         ELSE
            SELECT MAX(CDFISCOPER), MAX(IDCFOPINTEREST), MAX(IDDIFEALIQ), MAX(IDDIFALIQCUSPR), TO_CHAR(MAX('PROD')), MAX(CFOPREGRAFISCAL.CDPRODUTO)
              INTO V_CDFISCOPER, V_IDCFOPINTEREST, V_IDDIFEALIQ, V_IDDIFALIQCUSPR, V_IDTIPOREGISTRO, V_CDPRODUTO
              FROM CFOPREGRAFISCAL, PRODUTO PRODUTOREGRA
             WHERE CFOPREGRAFISCAL.CDREGRAFISC = V_CDREGRAFISC
               AND PRODUTOREGRA.CDPRODUTO = CFOPREGRAFISCAL.CDPRODUTO
               AND ((IDCFOPINTEREST = 'E') OR (IDCFOPINTEREST = 'T'))
               AND PRODUTOREGRA.CDARVPROD = (SELECT MAX(B.CDARVPROD)
                                               FROM CFOPREGRAFISCAL A, PRODUTO B
                                              WHERE A.CDREGRAFISC = V_CDREGRAFISC
                                                AND A.CDPRODUTO = B.CDPRODUTO
                                                AND INSTR(P_CDARVPROD, B.CDARVPROD) = 1);
            BEGIN
               SELECT DECODE(COUNT(MSGCFOPREGFISC.CDREGRAFISC), 0, 'N', 'S')
                 INTO V_IDMENSAGEM
                 FROM MSGCFOPREGFISC
                WHERE CDREGRAFISC = V_CDREGRAFISC
                  AND IDCFOPINTEREST = V_IDCFOPINTEREST
                  AND CDPRODUTO = V_CDPRODUTO;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN BEGIN
                  V_IDMENSAGEM      := 'N';
               END;
            END;
            IF V_CDFISCOPER IS NULL THEN
               SELECT MAX(CDFISCOPER), MAX(IDCFOPINTEREST), MAX(IDDIFEALIQ), MAX(IDDIFALIQCUSPR), TO_CHAR(MAX('NCM')), MAX(CDCLASFISC)
                 INTO V_CDFISCOPER, V_IDCFOPINTEREST, V_IDDIFEALIQ, V_IDDIFALIQCUSPR, V_IDTIPOREGISTRO, V_CDCLASFISC
                 FROM CFOPNCMREGRAFIS
                WHERE CFOPNCMREGRAFIS.CDREGRAFISC = V_CDREGRAFISC
                  AND ((IDCFOPINTEREST = 'E') OR (IDCFOPINTEREST = 'T'))
                  AND CFOPNCMREGRAFIS.CDCLASFISC = (SELECT MAX(A.CDCLASFISC)
                                                      FROM CFOPNCMREGRAFIS A, PRODUTO B
                                                     WHERE A.CDREGRAFISC = V_CDREGRAFISC
                                                       AND B.CDARVPROD = P_CDARVPROD
                                                       AND INSTR(B.CDCLASFISC, A.CDCLASFISC)=1);
               BEGIN
                  SELECT DECODE(COUNT(MSGCFOPNCM.CDREGRAFISC), 0, 'N', 'S')
                    INTO V_IDMENSAGEM
                    FROM MSGCFOPNCM
                   WHERE CDREGRAFISC = V_CDREGRAFISC
                     AND CDCLASFISC = V_CDCLASFISC
                     AND IDCFOPINTEREST = V_IDCFOPINTEREST;
               EXCEPTION
                  WHEN NO_DATA_FOUND THEN BEGIN
                     V_IDMENSAGEM      := 'N';
                  END;
               END;
               IF V_CDFISCOPER IS NULL THEN
                  SELECT MAX(CDFISCOPER), MAX(IDCFOPINTEREST), MAX(IDDIFEALIQ), MAX(IDDIFALIQCUSPR), TO_CHAR(MAX('PAD'))
                    INTO V_CDFISCOPER, V_IDCFOPINTEREST, V_IDDIFEALIQ, V_IDDIFALIQCUSPR, V_IDTIPOREGISTRO
                    FROM CFOPADRAOREGFIS
                   WHERE CFOPADRAOREGFIS.CDREGRAFISC = V_CDREGRAFISC
                     AND ((IDCFOPINTEREST = 'E') OR (IDCFOPINTEREST = 'T'));
                  BEGIN
                     SELECT DECODE(COUNT(MSGCFOPADRAO.CDREGRAFISC), 0, 'N', 'S')
                       INTO V_IDMENSAGEM
                       FROM MSGCFOPADRAO
                      WHERE CDREGRAFISC = V_CDREGRAFISC
                        AND IDCFOPINTEREST = V_IDCFOPINTEREST;
                  EXCEPTION
                     WHEN NO_DATA_FOUND THEN BEGIN
                        V_IDMENSAGEM      := 'N';
                     END;
                  END;
               END IF;
            END IF;
         END IF;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN BEGIN
            V_CDFISCOPER     := NULL;
            V_IDCFOPINTEREST := NULL;
            V_IDDIFEALIQ     := NULL;
            V_IDDIFALIQCUSPR := NULL;
            V_IDTIPOREGISTRO := NULL;
            V_IDMENSAGEM     := NULL;
            V_CDCLASFISC     := NULL;
            V_CDPRODUTO      := NULL;
         END;
      END;
      V_CDFISCAL        := NULL;
      V_CDSITUTRIB      := NULL;
      V_VRALIQUOTA      := NULL;
      V_IDMODBCNFE      := NULL;
      V_IDMODBCSTNFE    := NULL;
      V_IDMOTIDESSTNFE  := NULL;
      V_CDTPCRPICOSTNFE := NULL;
      V_CDNATUBCPCSTNFE := NULL;
      V_VRINIFAIXA      := NULL;
      V_VRFIMFAIXA      := NULL;
      V_VRPARDEDUZ      := NULL;
      V_VR1PERREDBC     := NULL;
      V_VRPERREDBC      := NULL;
      V_VRPBCSUBTRIB    := NULL;
      V_IDTRATIMPST     := NULL;
      V_IDPMCBASECA     := NULL;
      V_IDCSTINTEREST   := NULL;
      V_IDCSTINTERNA    := NULL;
      V_IDTIPODESTFISC  := NULL;
      V_CDDETALHEFISC   := NULL;
      V_CDENQLEGALIPI   := NULL;
      V_CDCEST          := NULL;
      V_VRADICALIQFECP  := NULL;
      V_CDBENEFFISCAL   := NULL;
      V_IDCONSMVAPMC    := NULL;
      V_IDCONSCOMPBCPMC := NULL;
      V_IDCONSDIFALIQ   := NULL;
      V_IDIMPODESONERA  := NULL;
      V_IDCONSDESONVRNF := NULL;
      IF P_CFOP = 'N' THEN
         IF (P_PAISORIG||P_ESTAORIG) <> (P_PAISDEST||P_ESTADEST) THEN
            V_STATUSESTADUAL := 'I';
         ELSE
            V_STATUSESTADUAL := 'E';
         END IF;
         IF (P_PAISORIG) <> (P_PAISDEST) THEN
            V_STATUSINTERNACIONAL := 'I';
         ELSE
            V_STATUSINTERNACIONAL := 'N';
         END IF;
         BEGIN
            SELECT
               CDFISCAL,
               CDSITUTRIB,
               VRALIQUOTA,
               IDMODBCNFE,
               IDMODBCSTNFE,
               IDMOTIDESSTNFE,
               CDTPCRPICOSTNFE,
               CDNATUBCPCSTNFE,
               VRINIFAIXA,
               VRFIMFAIXA,
               VRPARDEDUZ,
               VR1PERREDBC,
               VRPERREDBC,
               VRPBCSUBTRIB,
               IDTRATIMPST,
               IDPMCBASECA,
               IDCSTINTEREST,
               IDCSTINTERNA,
               IDTIPODESTFISC,
               CDDETALHEFISC,
               TO_CHAR('PROD'),
               NRSEQDADOSFISC,
               '',
               DADOSFISCPROD.CDPRODUTO,
               CDFISCOPER,
               IDDIFEALIQ,
               IDDIFALIQCUSPR,
               CDENQLEGALIPI,
               DADOSFISCPROD.CDCEST,
               DADOSFISCPROD.VRADICALIQFECP,
               DADOSFISCPROD.CDBENEFFISCAL,
               DADOSFISCPROD.IDCONSMVAPMC,
               DADOSFISCPROD.IDCONSCOMPBCPMC,
               DADOSFISCPROD.IDCONSDIFALIQ,
               DADOSFISCPROD.IDIMPODESONERA,
               DADOSFISCPROD.IDCONSDESONVRNF
            INTO
               V_CDFISCAL,
               V_CDSITUTRIB,
               V_VRALIQUOTA,
               V_IDMODBCNFE,
               V_IDMODBCSTNFE,
               V_IDMOTIDESSTNFE,
               V_CDTPCRPICOSTNFE,
               V_CDNATUBCPCSTNFE,
               V_VRINIFAIXA,
               V_VRFIMFAIXA,
               V_VRPARDEDUZ,
               V_VR1PERREDBC,
               V_VRPERREDBC,
               V_VRPBCSUBTRIB,
               V_IDTRATIMPST,
               V_IDPMCBASECA,
               V_IDCSTINTEREST,
               V_IDCSTINTERNA,
               V_IDTIPODESTFISC,
               V_CDDETALHEFISC,
               V_IDTIPOREGISTRO,
               V_NRSEQDADOSFISC,
               V_CDCLASFISC,
               V_CDPRODUTO,
               V_CDFISCOPER,
               V_IDDIFEALIQ,
               V_IDDIFALIQCUSPR,
               V_CDENQLEGALIPI,
               V_CDCEST,
               V_VRADICALIQFECP,
               V_CDBENEFFISCAL,
               V_IDCONSMVAPMC,
               V_IDCONSCOMPBCPMC,
               V_IDCONSDIFALIQ,
               V_IDIMPODESONERA,
               V_IDCONSDESONVRNF
              FROM DADOSFISCPROD, PRODUTO PRODUTOREGRA
             WHERE DADOSFISCPROD.CDREGRAFISC = V_CDREGRAFISC
               AND DADOSFISCPROD.CDIMPOSTO = C_REGRAFISCAL.CDIMPOSTO
               AND PRODUTOREGRA.CDPRODUTO = DADOSFISCPROD.CDPRODUTO
               AND (IDCSTINTEREST = V_STATUSESTADUAL OR IDCSTINTEREST = 'T')
               AND (IDCSTINTERNA  = V_STATUSINTERNACIONAL OR IDCSTINTERNA = 'T')
               AND (((CDPAISORIG = P_PAISORIG) AND (SGESTAORIG = P_ESTAORIG)) OR  V_UTUFORIG = 'N' OR IDTIPOORIGFISC = 'T')
               AND (((CDPAISDEST = P_PAISDEST) AND (SGESTADEST = P_ESTADEST)) OR  V_UTUFDEST = 'N' OR IDTIPODESTFISC = 'T')
               AND (((CDMUNIORIG = P_MUNIORIG  AND V_UTMUNIORIG = 'O') OR (IDTIPOORIGFISC = 'T') OR ((CDMUNIORIG IS NULL) AND  (V_UTMUNIORIG = 'D'))) AND
                    ((CDMUNIDEST = P_MUNIDEST  AND V_UTMUNIORIG = 'D') OR (IDTIPODESTFISC = 'T') OR ((CDMUNIDEST IS NULL) AND  (V_UTMUNIORIG = 'O'))) OR
                    (V_UTMUNIORIG = 'N'))
               AND ((VRINIFAIXA  <= P_BASECALC) AND (VRFIMFAIXA  >= P_BASECALC) OR  V_UTFAIXVLR = 'N')
               AND (NVL(IDORIGEMPRODIMP, 'N') = NVL(V_IDORIGEMPROD, 'N'))
               AND PRODUTOREGRA.CDARVPROD = (SELECT MAX(B.CDARVPROD)
                                               FROM DADOSFISCPROD A, PRODUTO B
                                              WHERE A.CDREGRAFISC = V_CDREGRAFISC
                                                AND A.CDPRODUTO = B.CDPRODUTO
                                                AND A.CDIMPOSTO = C_REGRAFISCAL.CDIMPOSTO
                                                AND INSTR(P_CDARVPROD, B.CDARVPROD) = 1
                                                AND (IDCSTINTEREST = V_STATUSESTADUAL OR IDCSTINTEREST = 'T')
                                                AND (IDCSTINTERNA  = V_STATUSINTERNACIONAL OR IDCSTINTERNA = 'T')
                                                AND (((CDPAISORIG = P_PAISORIG) AND (SGESTAORIG = P_ESTAORIG)) OR  V_UTUFORIG = 'N' OR IDTIPOORIGFISC = 'T')
                                                AND (((CDPAISDEST = P_PAISDEST) AND (SGESTADEST = P_ESTADEST)) OR  V_UTUFDEST = 'N' OR IDTIPODESTFISC = 'T')
                                                AND (((CDMUNIORIG = P_MUNIORIG  AND V_UTMUNIORIG = 'O') OR (IDTIPOORIGFISC = 'T') OR ((CDMUNIORIG IS NULL) AND  (V_UTMUNIORIG = 'D'))) AND
                                                     ((CDMUNIDEST = P_MUNIDEST  AND V_UTMUNIORIG = 'D') OR (IDTIPODESTFISC = 'T') OR ((CDMUNIDEST IS NULL) AND  (V_UTMUNIORIG = 'O'))) OR
                                                     (V_UTMUNIORIG = 'N'))
                                                AND (NVL(IDORIGEMPRODIMP, 'N') = NVL(V_IDORIGEMPROD, 'N')));
         EXCEPTION
            WHEN TOO_MANY_ROWS THEN BEGIN
               RAISE_APPLICATION_ERROR(-20000, 'Operação Bloqueada! Existe cadastro duplicado na regra fiscal ' || V_CDREGRAFISC || ' (imposto ' || C_REGRAFISCAL.CDIMPOSTO || ', produto ' || P_CDARVPROD || ', página "Por Produto").', TRUE);
            END;
            WHEN NO_DATA_FOUND THEN BEGIN
               V_CDFISCAL        := NULL;
               V_CDSITUTRIB      := NULL;
               V_VRALIQUOTA      := NULL;
               V_IDMODBCNFE      := NULL;
               V_IDMODBCSTNFE    := NULL;
               V_IDMOTIDESSTNFE  := NULL;
               V_CDTPCRPICOSTNFE := NULL;
               V_CDNATUBCPCSTNFE := NULL;
               V_VRINIFAIXA      := NULL;
               V_VRFIMFAIXA      := NULL;
               V_VRPARDEDUZ      := NULL;
               V_VR1PERREDBC     := NULL;
               V_VRPERREDBC      := NULL;
               V_VRPBCSUBTRIB    := NULL;
               V_IDTRATIMPST     := NULL;
               V_IDPMCBASECA     := NULL;
               V_IDCSTINTEREST   := NULL;
               V_IDCSTINTERNA    := NULL;
               V_IDTIPODESTFISC  := NULL;
               V_CDDETALHEFISC   := NULL;
               V_IDTIPOREGISTRO  := NULL;
               V_NRSEQDADOSFISC  := NULL;
               V_CDCLASFISC      := NULL;
               V_CDPRODUTO       := NULL;
               V_CDENQLEGALIPI   := NULL;
               V_CDCEST          := NULL;
               V_VRADICALIQFECP  := NULL;
               V_CDBENEFFISCAL   := NULL;
               V_IDCONSMVAPMC    := NULL; 
               V_IDCONSCOMPBCPMC := NULL;
               V_IDCONSDIFALIQ   := NULL;
               V_IDIMPODESONERA  := NULL;
               V_IDCONSDESONVRNF := NULL;
            END;
         END;
         BEGIN
            SELECT DECODE(COUNT(MSGFISCPROD.CDREGRAFISC), 0, 'N', 'S')
              INTO V_IDMENSAGEM
              FROM MSGFISCPROD
             WHERE CDREGRAFISC = V_CDREGRAFISC
               AND CDIMPOSTO = C_REGRAFISCAL.CDIMPOSTO
               AND NRSEQDADOSFISC = V_NRSEQDADOSFISC
               AND CDPRODUTO = V_CDPRODUTO;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN BEGIN
               V_IDMENSAGEM      := 'N';
            END;
         END;
         IF V_CDFISCAL IS NULL THEN
            SELECT NVL(MAX(VRQTDEMB), NULL) VRQTDEMB,
                   NVL(MAX(SGUNIDEMB), NULL) SGUNIDEMB
              INTO V_VRQTDEMB, V_SGUNIDEMB
              FROM PRODUTO
             WHERE CDARVPROD = P_CDARVPROD;
            BEGIN
               SELECT
                  CDFISCAL,
                  CDSITUTRIB,
                  VRALIQUOTA,
                  IDMODBCNFE,
                  IDMODBCSTNFE,
                  IDMOTIDESSTNFE,
                  CDTPCRPICOSTNFE,
                  CDNATUBCPCSTNFE,
                  VRINIFAIXA,
                  VRFIMFAIXA,
                  VRPARDEDUZ,
                  VR1PERREDBC,
                  VRPERREDBC,
                  VRPBCSUBTRIB,
                  IDTRATIMPST,
                  IDPMCBASECA,
                  IDCSTINTEREST,
                  IDCSTINTERNA,
                  IDTIPODESTFISC,
                  CDDETALHEFISC,
                  TO_CHAR('NCM'),
                  NRSEQDADOSFISC,
                  CDCLASFISC,
                  '',
                  CDFISCOPER,
                  IDDIFEALIQ,
                  IDDIFALIQCUSPR,
                  CDENQLEGALIPI,
                  CDCEST,
                  VRADICALIQFECP,
                  CDBENEFFISCAL,
                  IDCONSMVAPMC,
                  IDCONSCOMPBCPMC,
                  IDCONSDIFALIQ,
                  IDIMPODESONERA,
                  IDCONSDESONVRNF
               INTO
                  V_CDFISCAL,
                  V_CDSITUTRIB,
                  V_VRALIQUOTA,
                  V_IDMODBCNFE,
                  V_IDMODBCSTNFE,
                  V_IDMOTIDESSTNFE,
                  V_CDTPCRPICOSTNFE,
                  V_CDNATUBCPCSTNFE,
                  V_VRINIFAIXA,
                  V_VRFIMFAIXA,
                  V_VRPARDEDUZ,
                  V_VR1PERREDBC,
                  V_VRPERREDBC,
                  V_VRPBCSUBTRIB,
                  V_IDTRATIMPST,
                  V_IDPMCBASECA,
                  V_IDCSTINTEREST,
                  V_IDCSTINTERNA,
                  V_IDTIPODESTFISC,
                  V_CDDETALHEFISC,
                  V_IDTIPOREGISTRO,
                  V_NRSEQDADOSFISC,
                  V_CDCLASFISC,
                  V_CDPRODUTO,
                  V_CDFISCOPER,
                  V_IDDIFEALIQ,
                  V_IDDIFALIQCUSPR,
                  V_CDENQLEGALIPI,
                  V_CDCEST,
                  V_VRADICALIQFECP,
                  V_CDBENEFFISCAL,
                  V_IDCONSMVAPMC,
                  V_IDCONSCOMPBCPMC,
                  V_IDCONSDIFALIQ,
                  V_IDIMPODESONERA,
                  V_IDCONSDESONVRNF
                 FROM DADOSFISCNCM
                WHERE DADOSFISCNCM.CDREGRAFISC = V_CDREGRAFISC
                  AND DADOSFISCNCM.CDIMPOSTO = C_REGRAFISCAL.CDIMPOSTO
                  AND (IDCSTINTEREST = V_STATUSESTADUAL OR IDCSTINTEREST = 'T')
                  AND (IDCSTINTERNA  = V_STATUSINTERNACIONAL OR IDCSTINTERNA = 'T')
                  AND (((CDPAISORIG = P_PAISORIG) AND (SGESTAORIG = P_ESTAORIG)) OR  V_UTUFORIG = 'N' OR IDTIPOORIGFISC = 'T')
                  AND (((CDPAISDEST = P_PAISDEST) AND (SGESTADEST = P_ESTADEST)) OR  V_UTUFDEST = 'N' OR IDTIPODESTFISC = 'T')
                  AND (((CDMUNIORIG = P_MUNIORIG  AND V_UTMUNIORIG = 'O') OR (IDTIPOORIGFISC = 'T') OR ((CDMUNIORIG IS NULL) AND  (V_UTMUNIORIG = 'D'))) AND
                       ((CDMUNIDEST = P_MUNIDEST  AND V_UTMUNIORIG = 'D') OR (IDTIPODESTFISC = 'T') OR ((CDMUNIDEST IS NULL) AND  (V_UTMUNIORIG = 'O'))) OR
                       (V_UTMUNIORIG = 'N'))
                  AND ((VRINIFAIXA  <= P_BASECALC) AND (VRFIMFAIXA  >= P_BASECALC) OR  V_UTFAIXVLR = 'N')
                  AND ((VRRANGINI   <= V_VRQTDEMB) AND (VRRANGFIM   >= V_VRQTDEMB) AND  SGUNIDEMB = V_SGUNIDEMB)
                  AND (NVL(IDORIGEMPRODIMP, 'N') = NVL(V_IDORIGEMPROD, 'N'))
                  AND DADOSFISCNCM.CDCLASFISC = (SELECT MAX(A.CDCLASFISC)
                                                   FROM DADOSFISCNCM A, PRODUTO B
                                                  WHERE A.CDREGRAFISC = V_CDREGRAFISC
                                                    AND B.CDARVPROD = P_CDARVPROD
                                                    AND A.CDIMPOSTO = C_REGRAFISCAL.CDIMPOSTO
                                                    AND INSTR(B.CDCLASFISC, A.CDCLASFISC)=1
                                                    AND (IDCSTINTEREST = V_STATUSESTADUAL OR IDCSTINTEREST = 'T')
                                                    AND (IDCSTINTERNA  = V_STATUSINTERNACIONAL OR IDCSTINTERNA = 'T')
                                                    AND (((CDPAISORIG = P_PAISORIG) AND (SGESTAORIG = P_ESTAORIG)) OR  V_UTUFORIG = 'N' OR IDTIPOORIGFISC = 'T')
                                                    AND (((CDPAISDEST = P_PAISDEST) AND (SGESTADEST = P_ESTADEST)) OR  V_UTUFDEST = 'N' OR IDTIPODESTFISC = 'T')
                                                    AND (((CDMUNIORIG = P_MUNIORIG  AND V_UTMUNIORIG = 'O') OR (IDTIPOORIGFISC = 'T') OR ((CDMUNIORIG IS NULL) AND  (V_UTMUNIORIG = 'D'))) AND
                                                         ((CDMUNIDEST = P_MUNIDEST  AND V_UTMUNIORIG = 'D') OR (IDTIPODESTFISC = 'T') OR ((CDMUNIDEST IS NULL) AND  (V_UTMUNIORIG = 'O'))) OR
                                                         (V_UTMUNIORIG = 'N'))
                                                    AND (NVL(IDORIGEMPRODIMP, 'N') = NVL(V_IDORIGEMPROD, 'N')));
            EXCEPTION
               WHEN TOO_MANY_ROWS THEN BEGIN
                  RAISE_APPLICATION_ERROR(-20000, 'Operação Bloqueada! Existe cadastro duplicado na regra fiscal ' || V_CDREGRAFISC || ' (imposto ' || C_REGRAFISCAL.CDIMPOSTO || ', produto ' || P_CDARVPROD || ', página "Por NCM").', TRUE);
               END;
               WHEN NO_DATA_FOUND THEN BEGIN
                  V_CDFISCAL        := NULL;
                  V_CDSITUTRIB      := NULL;
                  V_VRALIQUOTA      := NULL;
                  V_IDMODBCNFE      := NULL;
                  V_IDMODBCSTNFE    := NULL;
                  V_IDMOTIDESSTNFE  := NULL;
                  V_CDTPCRPICOSTNFE := NULL;
                  V_CDNATUBCPCSTNFE := NULL;
                  V_VRINIFAIXA      := NULL;
                  V_VRFIMFAIXA      := NULL;
                  V_VRPARDEDUZ      := NULL;
                  V_VR1PERREDBC     := NULL;
                  V_VRPERREDBC      := NULL;
                  V_VRPBCSUBTRIB    := NULL;
                  V_IDTRATIMPST     := NULL;
                  V_IDPMCBASECA     := NULL;
                  V_IDCSTINTEREST   := NULL;
                  V_IDCSTINTERNA    := NULL;
                  V_IDTIPODESTFISC  := NULL;
                  V_CDDETALHEFISC   := NULL;
                  V_IDTIPOREGISTRO  := NULL;
                  V_NRSEQDADOSFISC  := NULL;
                  V_CDCLASFISC      := NULL;
                  V_CDPRODUTO       := NULL;
                  V_CDFISCOPER      := NULL;
                  V_IDDIFEALIQ      := NULL;
                  V_IDDIFALIQCUSPR  := NULL;
                  V_CDENQLEGALIPI   := NULL;
                  V_CDCEST          := NULL;
                  V_VRADICALIQFECP  := NULL;
                  V_CDBENEFFISCAL   := NULL;
                  V_IDCONSMVAPMC    := NULL;
                  V_IDCONSCOMPBCPMC := NULL;
                  V_IDCONSDIFALIQ   := NULL;
                  V_IDIMPODESONERA  := NULL;
                  V_IDCONSDESONVRNF := NULL;
               END;
            END;
            BEGIN
               SELECT DECODE(COUNT(MSGFISCNCM.CDREGRAFISC), 0, 'N', 'S')
                 INTO V_IDMENSAGEM
                 FROM MSGFISCNCM
                WHERE CDREGRAFISC = V_CDREGRAFISC
                  AND CDIMPOSTO = C_REGRAFISCAL.CDIMPOSTO
                  AND CDCLASFISC = V_CDCLASFISC
                  AND NRSEQDADOSFISC = V_NRSEQDADOSFISC;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN BEGIN
                  V_IDMENSAGEM      := 'N';
               END;
            END;
            IF V_CDFISCAL IS NULL THEN
               BEGIN
                  SELECT
                     CDFISCAL,
                     CDSITUTRIB,
                     VRALIQUOTA,
                     IDMODBCNFE,
                     IDMODBCSTNFE,
                     IDMOTIDESSTNFE,
                     CDTPCRPICOSTNFE,
                     CDNATUBCPCSTNFE,
                     VRINIFAIXA,
                     VRFIMFAIXA,
                     VRPARDEDUZ,
                     VR1PERREDBC,
                     VRPERREDBC,
                     VRPBCSUBTRIB,
                     IDTRATIMPST,
                     IDPMCBASECA,
                     IDCSTINTEREST,
                     IDCSTINTERNA,
                     IDTIPODESTFISC,
                     CDDETALHEFISC,
                     TO_CHAR('NCM'),
                     NRSEQDADOSFISC,
                     CDCLASFISC,
                     '',
                     CDFISCOPER,
                     IDDIFEALIQ,
                     IDDIFALIQCUSPR,
                     CDENQLEGALIPI,
                     CDCEST,
                     VRADICALIQFECP,
                     CDBENEFFISCAL,
                     IDCONSMVAPMC,
                     IDCONSCOMPBCPMC,
                     IDCONSDIFALIQ,
                     IDIMPODESONERA,
                     IDCONSDESONVRNF
                  INTO
                     V_CDFISCAL,
                     V_CDSITUTRIB,
                     V_VRALIQUOTA,
                     V_IDMODBCNFE,
                     V_IDMODBCSTNFE,
                     V_IDMOTIDESSTNFE,
                     V_CDTPCRPICOSTNFE,
                     V_CDNATUBCPCSTNFE,
                     V_VRINIFAIXA,
                     V_VRFIMFAIXA,
                     V_VRPARDEDUZ,
                     V_VR1PERREDBC,
                     V_VRPERREDBC,
                     V_VRPBCSUBTRIB,
                     V_IDTRATIMPST,
                     V_IDPMCBASECA,
                     V_IDCSTINTEREST,
                     V_IDCSTINTERNA,
                     V_IDTIPODESTFISC,
                     V_CDDETALHEFISC,
                     V_IDTIPOREGISTRO,
                     V_NRSEQDADOSFISC,
                     V_CDCLASFISC,
                     V_CDPRODUTO,
                     V_CDFISCOPER,
                     V_IDDIFEALIQ,
                     V_IDDIFALIQCUSPR,
                     V_CDENQLEGALIPI,
                     V_CDCEST,
                     V_VRADICALIQFECP,
                     V_CDBENEFFISCAL,
                     V_IDCONSMVAPMC,
                     V_IDCONSCOMPBCPMC,
                     V_IDCONSDIFALIQ,
                     V_IDIMPODESONERA,
                     V_IDCONSDESONVRNF
                    FROM DADOSFISCNCM
                   WHERE DADOSFISCNCM.CDREGRAFISC = V_CDREGRAFISC
                     AND DADOSFISCNCM.CDIMPOSTO = C_REGRAFISCAL.CDIMPOSTO
                     AND (IDCSTINTEREST = V_STATUSESTADUAL OR IDCSTINTEREST = 'T')
                     AND (IDCSTINTERNA  = V_STATUSINTERNACIONAL OR IDCSTINTERNA = 'T')
                     AND (((CDPAISORIG = P_PAISORIG) AND (SGESTAORIG = P_ESTAORIG)) OR  V_UTUFORIG = 'N' OR IDTIPOORIGFISC = 'T')
                     AND (((CDPAISDEST = P_PAISDEST) AND (SGESTADEST = P_ESTADEST)) OR  V_UTUFDEST = 'N' OR IDTIPODESTFISC = 'T')
                     AND (((CDMUNIORIG = P_MUNIORIG  AND V_UTMUNIORIG = 'O') OR (IDTIPOORIGFISC = 'T') OR ((CDMUNIORIG IS NULL) AND  (V_UTMUNIORIG = 'D'))) AND
                          ((CDMUNIDEST = P_MUNIDEST  AND V_UTMUNIORIG = 'D') OR (IDTIPODESTFISC = 'T') OR ((CDMUNIDEST IS NULL) AND  (V_UTMUNIORIG = 'O'))) OR
                          (V_UTMUNIORIG = 'N'))
                     AND ((VRINIFAIXA  <= P_BASECALC) AND (VRFIMFAIXA  >= P_BASECALC) OR  V_UTFAIXVLR = 'N')
                     AND ((VRRANGINI IS NULL) AND (VRRANGFIM IS NULL))
                     AND (NVL(IDORIGEMPRODIMP, 'N') = NVL(V_IDORIGEMPROD, 'N'))
                     AND DADOSFISCNCM.CDCLASFISC = (SELECT MAX(A.CDCLASFISC)
                                                      FROM DADOSFISCNCM A, PRODUTO B
                                                     WHERE A.CDREGRAFISC = V_CDREGRAFISC
                                                       AND B.CDARVPROD = P_CDARVPROD
                                                       AND A.CDIMPOSTO = C_REGRAFISCAL.CDIMPOSTO
                                                       AND INSTR(B.CDCLASFISC, A.CDCLASFISC)=1
                                                       AND (IDCSTINTEREST = V_STATUSESTADUAL OR IDCSTINTEREST = 'T')
                                                       AND (IDCSTINTERNA  = V_STATUSINTERNACIONAL OR IDCSTINTERNA = 'T')
                                                       AND (((CDPAISORIG = P_PAISORIG) AND (SGESTAORIG = P_ESTAORIG)) OR  V_UTUFORIG = 'N' OR IDTIPOORIGFISC = 'T')
                                                       AND (((CDPAISDEST = P_PAISDEST) AND (SGESTADEST = P_ESTADEST)) OR  V_UTUFDEST = 'N' OR IDTIPODESTFISC = 'T')
                                                       AND (((CDMUNIORIG = P_MUNIORIG  AND V_UTMUNIORIG = 'O') OR (IDTIPOORIGFISC = 'T') OR ((CDMUNIORIG IS NULL) AND  (V_UTMUNIORIG = 'D'))) AND
                                                            ((CDMUNIDEST = P_MUNIDEST  AND V_UTMUNIORIG = 'D') OR (IDTIPODESTFISC = 'T') OR ((CDMUNIDEST IS NULL) AND  (V_UTMUNIORIG = 'O'))) OR
                                                            (V_UTMUNIORIG = 'N'))
                                                       AND (NVL(IDORIGEMPRODIMP, 'N') = NVL(V_IDORIGEMPROD, 'N')));
               EXCEPTION
                  WHEN TOO_MANY_ROWS THEN BEGIN
                     RAISE_APPLICATION_ERROR(-20000, 'Operação Bloqueada! Existe cadastro duplicado na regra fiscal ' || V_CDREGRAFISC || ' (imposto ' || C_REGRAFISCAL.CDIMPOSTO || ', produto ' || P_CDARVPROD || ', página "Por NCM").', TRUE);
                  END;
                  WHEN NO_DATA_FOUND THEN BEGIN
                     V_CDFISCAL        := NULL;
                     V_CDSITUTRIB      := NULL;
                     V_VRALIQUOTA      := NULL;
                     V_IDMODBCNFE      := NULL;
                     V_IDMODBCSTNFE    := NULL;
                     V_IDMOTIDESSTNFE  := NULL;
                     V_CDTPCRPICOSTNFE := NULL;
                     V_CDNATUBCPCSTNFE := NULL;
                     V_VRINIFAIXA      := NULL;
                     V_VRFIMFAIXA      := NULL;
                     V_VRPARDEDUZ      := NULL;
                     V_VR1PERREDBC     := NULL;
                     V_VRPERREDBC      := NULL;
                     V_VRPBCSUBTRIB    := NULL;
                     V_IDTRATIMPST     := NULL;
                     V_IDPMCBASECA     := NULL;
                     V_IDCSTINTEREST   := NULL;
                     V_IDCSTINTERNA    := NULL;
                     V_IDTIPODESTFISC  := NULL;
                     V_CDDETALHEFISC   := NULL;
                     V_IDTIPOREGISTRO  := NULL;
                     V_NRSEQDADOSFISC  := NULL;
                     V_CDCLASFISC      := NULL;
                     V_CDPRODUTO       := NULL;
                     V_CDFISCOPER      := NULL;
                     V_IDDIFEALIQ      := NULL;
                     V_IDDIFALIQCUSPR  := NULL;
                     V_CDENQLEGALIPI   := NULL;
                     V_CDCEST          := NULL;
                     V_VRADICALIQFECP  := NULL;
                     V_CDBENEFFISCAL   := NULL;
                     V_IDCONSMVAPMC    := NULL;
                     V_IDCONSCOMPBCPMC := NULL;
                     V_IDCONSDIFALIQ   := NULL;
                     V_IDIMPODESONERA  := NULL;
                     V_IDCONSDESONVRNF := NULL;
                  END;
               END;
               BEGIN
                  SELECT DECODE(COUNT(MSGFISCNCM.CDREGRAFISC), 0, 'N', 'S')
                    INTO V_IDMENSAGEM
                    FROM MSGFISCNCM
                   WHERE CDREGRAFISC = V_CDREGRAFISC
                     AND CDIMPOSTO = C_REGRAFISCAL.CDIMPOSTO
                     AND CDCLASFISC = V_CDCLASFISC
                     AND NRSEQDADOSFISC = V_NRSEQDADOSFISC;
               EXCEPTION
                  WHEN NO_DATA_FOUND THEN BEGIN
                     V_IDMENSAGEM      := 'N';
                  END;
               END;
            END IF;
            IF V_CDFISCAL IS NULL THEN
               SELECT NVL(MAX(VRQTDEMB), NULL) VRQTDEMB,
                      NVL(MAX(SGUNIDEMB), NULL) SGUNIDEMB
                 INTO V_VRQTDEMB, V_SGUNIDEMB
                 FROM PRODUTO
                WHERE CDARVPROD = P_CDARVPROD;
               SELECT NVL(MAX(IDUTRANGEMB), NULL) IDUTRANGEMB
                 INTO V_UTILRANGE
                 FROM IMPOSTO
                WHERE CDIMPOSTO = C_REGRAFISCAL.CDIMPOSTO;
               BEGIN
                  SELECT
                     CDFISCAL,
                     CDSITUTRIB,
                     VRALIQUOTA,
                     IDMODBCNFE,
                     IDMODBCSTNFE,
                     IDMOTIDESSTNFE,
                     CDTPCRPICOSTNFE,
                     CDNATUBCPCSTNFE,
                     VRINIFAIXA,
                     VRFIMFAIXA,
                     VRPARDEDUZ,
                     VR1PERREDBC,
                     VRPERREDBC,
                     VRPBCSUBTRIB,
                     IDTRATIMPST,
                     IDPMCBASECA,
                     IDCSTINTEREST,
                     IDCSTINTERNA,
                     IDTIPODESTFISC,
                     CDDETALHEFISC,
                     TO_CHAR('PAD'),
                     NRSEQDADOSFISC,
                     '',
                     '',
                     CDFISCOPER,
                     IDDIFEALIQ,
                     IDDIFALIQCUSPR,
                     CDENQLEGALIPI,
                     CDCEST,
                     VRADICALIQFECP,
                     CDBENEFFISCAL,
                     IDCONSMVAPMC,
                     IDCONSCOMPBCPMC,
                     IDCONSDIFALIQ,
                     IDIMPODESONERA,
                     IDCONSDESONVRNF
                  INTO
                     V_CDFISCAL,
                     V_CDSITUTRIB,
                     V_VRALIQUOTA,
                     V_IDMODBCNFE,
                     V_IDMODBCSTNFE,
                     V_IDMOTIDESSTNFE,
                     V_CDTPCRPICOSTNFE,
                     V_CDNATUBCPCSTNFE,
                     V_VRINIFAIXA,
                     V_VRFIMFAIXA,
                     V_VRPARDEDUZ,
                     V_VR1PERREDBC,
                     V_VRPERREDBC,
                     V_VRPBCSUBTRIB,
                     V_IDTRATIMPST,
                     V_IDPMCBASECA,
                     V_IDCSTINTEREST,
                     V_IDCSTINTERNA,
                     V_IDTIPODESTFISC,
                     V_CDDETALHEFISC,
                     V_IDTIPOREGISTRO,
                     V_NRSEQDADOSFISC,
                     V_CDCLASFISC,
                     V_CDPRODUTO,
                     V_CDFISCOPER,
                     V_IDDIFEALIQ,
                     V_IDDIFALIQCUSPR,
                     V_CDENQLEGALIPI,
                     V_CDCEST,
                     V_VRADICALIQFECP,
                     V_CDBENEFFISCAL,
                     V_IDCONSMVAPMC,
                     V_IDCONSCOMPBCPMC,
                     V_IDCONSDIFALIQ,
                     V_IDIMPODESONERA,
                     V_IDCONSDESONVRNF
                    FROM DADOSFISCREGRA
                  WHERE DADOSFISCREGRA.CDREGRAFISC = V_CDREGRAFISC
                     AND DADOSFISCREGRA.CDIMPOSTO = C_REGRAFISCAL.CDIMPOSTO
                     AND (IDCSTINTEREST = V_STATUSESTADUAL OR IDCSTINTEREST = 'T')
                     AND (IDCSTINTERNA  = V_STATUSINTERNACIONAL OR IDCSTINTERNA = 'T')
                     AND (((CDPAISORIG = P_PAISORIG) AND (SGESTAORIG = P_ESTAORIG)) OR  V_UTUFORIG = 'N' OR IDTIPOORIGFISC = 'T')
                     AND (((CDPAISDEST = P_PAISDEST)  AND (SGESTADEST = P_ESTADEST)) OR V_UTUFDEST = 'N' OR IDTIPODESTFISC = 'T')
                     AND (((CDMUNIORIG = P_MUNIORIG  AND V_UTMUNIORIG = 'O') OR (IDTIPOORIGFISC = 'T') OR ((CDMUNIORIG IS NULL) AND  (V_UTMUNIORIG = 'D'))) AND
                          ((CDMUNIDEST = P_MUNIDEST AND V_UTMUNIORIG = 'D') OR (IDTIPODESTFISC = 'T') OR ((CDMUNIDEST IS NULL) AND  (V_UTMUNIORIG = 'O'))) OR
                          (V_UTMUNIORIG = 'N'))
                     AND ((VRINIFAIXA  <= P_BASECALC) AND (VRFIMFAIXA  >= P_BASECALC) OR  V_UTFAIXVLR = 'N')
                     AND (((V_VRQTDEMB IS NULL) AND (V_UTILRANGE = 'S')) OR (V_UTILRANGE <> 'S'))
                     AND (NVL(IDORIGEMPRODIMP, 'N') = NVL(V_IDORIGEMPROD, 'N'));
               EXCEPTION
                  WHEN TOO_MANY_ROWS THEN BEGIN
                     RAISE_APPLICATION_ERROR(-20000, 'Operação Bloqueada! Existe cadastro duplicado na regra fiscal ' || V_CDREGRAFISC || ' (imposto ' || C_REGRAFISCAL.CDIMPOSTO || ', página "Padrão").', TRUE);
                  END;
                  WHEN NO_DATA_FOUND THEN BEGIN
                     V_CDFISCAL        := NULL;
                     V_CDSITUTRIB      := NULL;
                     V_VRALIQUOTA      := NULL;
                     V_IDMODBCNFE      := NULL;
                     V_IDMODBCSTNFE    := NULL;
                     V_IDMOTIDESSTNFE  := NULL;
                     V_CDTPCRPICOSTNFE := NULL;
                     V_CDNATUBCPCSTNFE := NULL;
                     V_VRINIFAIXA      := NULL;
                     V_VRFIMFAIXA      := NULL;
                     V_VRPARDEDUZ      := NULL;
                     V_VR1PERREDBC     := NULL;
                     V_VRPERREDBC      := NULL;
                     V_VRPBCSUBTRIB    := NULL;
                     V_IDTRATIMPST     := NULL;
                     V_IDPMCBASECA     := NULL;
                     V_IDCSTINTEREST   := NULL;
                     V_IDCSTINTERNA    := NULL;
                     V_IDTIPODESTFISC  := NULL;
                     V_CDDETALHEFISC   := NULL;
                     V_IDTIPOREGISTRO  := NULL;
                     V_NRSEQDADOSFISC  := NULL;
                     V_CDCLASFISC      := NULL;
                     V_CDPRODUTO       := NULL;
                     V_CDENQLEGALIPI   := NULL;
                     V_CDCEST          := NULL;
                     V_VRADICALIQFECP  := NULL;
                     V_CDBENEFFISCAL   := NULL;
                     V_IDCONSMVAPMC    := NULL;
                     V_IDCONSCOMPBCPMC := NULL;
                     V_IDCONSDIFALIQ   := NULL;
                     V_IDIMPODESONERA  := NULL;
                     V_IDCONSDESONVRNF := NULL;
                  END;
               END;
               BEGIN
                  SELECT DECODE(COUNT(MSGFISCREGRA.CDREGRAFISC), 0, 'N', 'S')
                    INTO V_IDMENSAGEM
                    FROM MSGFISCREGRA
                   WHERE CDREGRAFISC = V_CDREGRAFISC
                     AND CDIMPOSTO = C_REGRAFISCAL.CDIMPOSTO
                     AND NRSEQDADOSFISC = V_NRSEQDADOSFISC;
               EXCEPTION
                  WHEN NO_DATA_FOUND THEN BEGIN
                     V_IDMENSAGEM      := 'N';
                  END;
               END;
            END IF;
         END IF;
      END IF;
      BEGIN
         SELECT NMREGRAFISC, DSMENSREGRAFISC
           INTO V_NMREGRAFISC, V_DSMENSREGRAFISC
           FROM REGRAFISCAL
          WHERE CDREGRAFISC = V_CDREGRAFISC;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN BEGIN
            V_NMREGRAFISC     := NULL;
            V_DSMENSREGRAFISC := NULL;
         END;
      END;
      IF V_CDREGRAFISC IS NOT NULL THEN
         IF V_CDFISCAL        IS NOT NULL OR
            V_CDSITUTRIB      IS NOT NULL OR
            V_VRALIQUOTA      IS NOT NULL OR
            V_IDMODBCNFE      IS NOT NULL OR
            V_IDMODBCSTNFE    IS NOT NULL OR
            V_IDMOTIDESSTNFE  IS NOT NULL OR
            V_CDTPCRPICOSTNFE IS NOT NULL OR
            V_CDNATUBCPCSTNFE IS NOT NULL OR
            V_VRINIFAIXA      IS NOT NULL OR
            V_VRFIMFAIXA      IS NOT NULL OR
            V_VRPARDEDUZ      IS NOT NULL OR
            V_VR1PERREDBC     IS NOT NULL OR
            V_VRPERREDBC      IS NOT NULL OR
            V_VRPBCSUBTRIB    IS NOT NULL OR
            V_IDTRATIMPST     IS NOT NULL OR
            V_IDPMCBASECA     IS NOT NULL OR
            V_IDCSTINTEREST   IS NOT NULL OR
            V_IDCSTINTERNA    IS NOT NULL OR
            V_CDFISCOPER      IS NOT NULL OR
            V_IDCFOPINTEREST  IS NOT NULL OR
            V_IDDIFEALIQ      IS NOT NULL OR
            V_IDDIFALIQCUSPR  IS NOT NULL OR
            V_IDTIPODESTFISC  IS NOT NULL OR
            V_CDDETALHEFISC   IS NOT NULL OR
            V_IDTIPOREGISTRO  IS NOT NULL OR
            V_NRSEQDADOSFISC  IS NOT NULL OR
            V_IDMENSAGEM      IS NOT NULL OR
            V_CDCLASFISC      IS NOT NULL OR
            V_CDPRODUTO       IS NOT NULL OR
            V_CDENQLEGALIPI   IS NOT NULL OR
            V_CDCEST          IS NOT NULL OR
            V_VRADICALIQFECP  IS NOT NULL OR
            V_CDBENEFFISCAL   IS NOT NULL OR
            V_IDCONSMVAPMC    IS NOT NULL OR
            V_IDCONSCOMPBCPMC IS NOT NULL OR
            V_IDCONSDIFALIQ   IS NOT NULL OR
            V_IDIMPODESONERA  IS NOT NULL OR
            V_IDCONSDESONVRNF IS NOT NULL THEN
            OUT_RECORD.CDREGRAFISC        := V_CDREGRAFISC;
            OUT_RECORD.NMREGRAFISC        := V_NMREGRAFISC;
            OUT_RECORD.DSMENSREGRAFISC    := V_DSMENSREGRAFISC;
            OUT_RECORD.CDIMPOSTO          := C_REGRAFISCAL.CDIMPOSTO;
            OUT_RECORD.CDFISCAL           := V_CDFISCAL;
            OUT_RECORD.CDSITUTRIB         := V_CDSITUTRIB;
            OUT_RECORD.VRALIQUOTA         := V_VRALIQUOTA;
            OUT_RECORD.IDMODBCNFE         := V_IDMODBCNFE;
            OUT_RECORD.IDMODBCSTNFE       := V_IDMODBCSTNFE;
            OUT_RECORD.IDMOTIDESSTNFE     := V_IDMOTIDESSTNFE;
            OUT_RECORD.CDTPCRPICOSTNFE    := V_CDTPCRPICOSTNFE;
            OUT_RECORD.CDNATUBCPCSTNFE    := V_CDNATUBCPCSTNFE;
            OUT_RECORD.VRINIFAIXA         := V_VRINIFAIXA;
            OUT_RECORD.VRFIMFAIXA         := V_VRFIMFAIXA;
            OUT_RECORD.VRPARDEDUZ         := V_VRPARDEDUZ;
            OUT_RECORD.VR1PERREDBC        := V_VR1PERREDBC;
            OUT_RECORD.VRPERREDBC         := V_VRPERREDBC;
            OUT_RECORD.VRPBCSUBTRIB       := V_VRPBCSUBTRIB;
            OUT_RECORD.IDTRATIMPST        := V_IDTRATIMPST;
            OUT_RECORD.IDPMCBASECA        := V_IDPMCBASECA;
            OUT_RECORD.IDCSTINTEREST      := V_IDCSTINTEREST;
            OUT_RECORD.IDCSTINTERNA       := V_IDCSTINTERNA;
            OUT_RECORD.CDFISCOPER         := V_CDFISCOPER;
            OUT_RECORD.IDCFOPINTEREST     := V_IDCFOPINTEREST;
            OUT_RECORD.IDDIFEALIQ         := V_IDDIFEALIQ;
            OUT_RECORD.IDDIFALIQCUSPR     := V_IDDIFALIQCUSPR;
            OUT_RECORD.IDTIPODESTFISC     := V_IDTIPODESTFISC;
            OUT_RECORD.CDDETALHEFISC      := V_CDDETALHEFISC;
            OUT_RECORD.IDTIPOREGISTRO     := V_IDTIPOREGISTRO;
            OUT_RECORD.NRSEQDADOSFISC     := V_NRSEQDADOSFISC;
            OUT_RECORD.IDMENSAGEM         := V_IDMENSAGEM;
            OUT_RECORD.CDCLASFISC         := V_CDCLASFISC;
            OUT_RECORD.CDPRODUTO          := V_CDPRODUTO;
            OUT_RECORD.CDENQLEGALIPI      := V_CDENQLEGALIPI;
            OUT_RECORD.CDCEST             := V_CDCEST;
            OUT_RECORD.VRADICALIQFECP     := V_VRADICALIQFECP;
            OUT_RECORD.CDBENEFFISCAL      := V_CDBENEFFISCAL;
            OUT_RECORD.IDCONSMVAPMC       := V_IDCONSMVAPMC;
            OUT_RECORD.IDCONSCOMPBCPMC    := V_IDCONSCOMPBCPMC;
            OUT_RECORD.IDCONSDIFALIQ      := V_IDCONSDIFALIQ;
            OUT_RECORD.IDIMPODESONERA     := V_IDIMPODESONERA;
            OUT_RECORD.IDCONSDESONVRNF    := V_IDCONSDESONVRNF;
            PIPE ROW (OUT_RECORD);
         END IF;
      END IF;
   END LOOP;
END;
/
/*
@C:\WEB_619\Sql\End_Conv\Oracle\5001_FISSTPO_Consulta_Aliquota.SQL
Descrição:
Procedure para consulta dos impostos dos produtos do lançamento
*/
CREATE OR REPLACE PROCEDURE CONSULTA_ALIQUOTA(
    P_IMPOSTO     IN ALIQUOTA.CDIMPOSTO%TYPE,
    P_ENTRSAIDAL  IN ALIQUOTA.IDENTRSAIDAL%TYPE,
    P_EMPRESA     IN ALIQUOTA.CDEMPRESA%TYPE,
    P_PRODUTO     IN PRODUTO.CDARVPROD%TYPE,
    P_INSCESTA    IN ALIQUOTA.CDINSCESTA%TYPE,
    P_PAISORIG    IN PAIS.CDPAIS%TYPE,
    P_ESTAORIG    IN ESTADO.SGESTADO%TYPE,
    P_PAISDEST    IN PAIS.CDPAIS%TYPE,
    P_ESTADEST    IN ESTADO.SGESTADO%TYPE,
    P_MUNIORIG    IN MUNICIPIO.CDMUNICIPIO%TYPE,
    P_BASECALC    IN ALIQUOTA.VRFIMFAIXA%TYPE,
    P_INIVALID    IN ALIQUOTA.DTINIVALID%TYPE,
    P_FILIAL      IN VARCHAR2,
    P_LANCTONF    IN VARCHAR2,
    P_CDGRUPOFISC IN ALIQUOTA.CDGRUPOFISC%TYPE,
    P_CDTIPOOPER  IN TIPOOPERAC.CDTIPOOPER%TYPE DEFAULT NULL,
    P_IDSISTEMA   IN VARCHAR2 DEFAULT NULL,
    P_LANCPRODUTO IN VARCHAR2 DEFAULT NULL,  --Exclusivo Unificação
    P_VRPRODUTO   IN NUMBER   DEFAULT NULL,  --Exclusivo Unificação
    P_CDFILIRECE  IN VARCHAR2 DEFAULT NULL,  --Exclusivo Unificação
    P_CDFORNECED  IN VARCHAR2 DEFAULT NULL,  --Exclusivo Unificação
    P_CDCLIENTE   IN VARCHAR2 DEFAULT NULL,  --Exclusivo Unificação
    P_IDORIGEMPROD IN VARCHAR2 DEFAULT 'N')
IS
    V_SEQUENCIA   VARCHAR2(02); /*Varíavel para gerar o sequencial da alíquota*/
    V_CDARVPROD   VARCHAR2(20); /*Código de árvore do produto(Alíquota por nível ou todos)*/
    V_UTUFORIG       CHAR(1);   /*Utiliza UF de origem*/
    V_UTUFDEST       CHAR(1);   /*Utiliza UF de destino*/
    V_UTMUNIORIG     CHAR(1);   /*Utiliza municipio (origem ou destino)*/
    V_UTFAIXVLR      CHAR(1);   /*Utiliza faixa de valores*/
    V_IDUTALIQTPOPER CHAR(1);   /*Utiliza alíquota por tipo de operação*/
    V_IDPRODNOTA  VARCHAR2(01); /*Visualização do imposto: C-No corpo da nota, P-No produto*/
    V_VRITEMPROD  FLOAT;       /*Valor líquido do item*/
    V_CONTADOR    NUMBER;      /*Varíavel para o total de alíquotas encontradas*/
    w_N           Char(1):= 'N';
    w_S           Char(1):= 'S';
    w_P           Char(1):= 'P';
    w_O           Char(1):= 'O';
    w_D           Char(1):= 'D';
    V_CDGRUPOFISC VARCHAR2(03); /*Código do grupo fiscal*/
    V_CDTIPOOPER  VARCHAR2(02); /*Código do tipo de operação*/
    V_EXISTE      INTEGER;
    V_COUNTMENS     INTEGER;
    V_DSMENSALIQU VARCHAR2(120);
    V_COUNT        INTEGER;
    V_MUNIORIG    VARCHAR2(04);
    V_MUNIDEST    VARCHAR2(04);
    V_ALIQSIMPLES   INTEGER;
    V_VRALIQSIMPLES NUMBER;
BEGIN
   /*Parametros do Imposto */
   Begin
      SELECT NVL(MAX(IDUTUFORIG), w_N), NVL(MAX(IDUTUFDEST), w_N), NVL(MAX(IDUTMUNIORIG), w_N),
             NVL(MAX(IDUTFAIXVLR), w_N), MAX(IDPRODNOTA), NVL(MAX(IDUTALIQTPOPER), w_N)
      INTO V_UTUFORIG, V_UTUFDEST, V_UTMUNIORIG, V_UTFAIXVLR, V_IDPRODNOTA,
           V_IDUTALIQTPOPER
      FROM IMPOSTO
      WHERE (CDIMPOSTO = P_IMPOSTO);
   Exception
      When No_Data_Found Then
         V_UTUFORIG   := w_N;  --Utiliza UF de origem
         V_UTUFDEST   := w_N;  --Utiliza UF de destino
         V_UTMUNIORIG := w_N;  --Utiliza municipio (Origem ou destino)
         V_UTFAIXVLR  := w_N;  --Utiliza faixa de valores
         V_IDPRODNOTA := Null; --Visualização do imposto (C-Corpo da nota; P-Produto)
         V_IDUTALIQTPOPER := Null; --Utiliza aliquota por tipo de operação
   End;
   IF V_UTMUNIORIG = W_O THEN
      V_MUNIORIG := P_MUNIORIG;
      V_MUNIDEST := NULL;
   END IF;
   IF V_UTMUNIORIG = W_D THEN
      V_MUNIORIG := NULL;
      V_MUNIDEST := P_MUNIORIG;
   END IF;
   IF V_UTMUNIORIG = W_N THEN
      V_MUNIORIG := NULL;
      V_MUNIDEST := NULL;
   END IF;
   IF (P_LANCTONF <> '0000000000') THEN /*Se a consulta_alíquota for chamada a partir de um lançamento*/
      IF (V_UTFAIXVLR = w_S) AND (V_IDPRODNOTA = w_P) AND (P_ENTRSAIDAL = w_S) THEN
         IF P_IDSISTEMA = 'PED' THEN
            SELECT SUM((VRPREUNITPED * QTITEMPED) - ((VRPREUNITPED * QTITEMPED) * (VRDESITPED/100)))
              INTO V_VRITEMPROD
              FROM ITEMPEDIDO
             WHERE CDFILIAL = SUBSTR(P_FILIAL,1,4) AND
                   NRPEDIDO = SUBSTR(P_FILIAL,5,10);
         ELSE
            SELECT SUM(VRTOTAITEM - VRDESCITEM)
            INTO V_VRITEMPROD
            FROM ITEMPRODUTO
            WHERE CDFILIAL   = P_FILIAL AND
                  NRLANCTONF = P_LANCTONF;
         END IF;
      ELSE
         IF(P_LANCPRODUTO = 'S') THEN
            V_VRITEMPROD := P_VRPRODUTO;
         ELSE
            V_VRITEMPROD := P_BASECALC;
         END IF;
      END IF;
   ELSE /*Se a Consulta_alíquota não for chamada a partir de um lançamento*/
      IF(P_LANCPRODUTO = 'S') THEN
         V_VRITEMPROD := P_VRPRODUTO;
      ELSE
         V_VRITEMPROD := P_BASECALC;
      END IF;
   END IF;
   V_SEQUENCIA := '01';
   V_CDGRUPOFISC := NULL;
   /* Verificação das aliquotas referente as filiais parametrizadas na tela Parâmetros de Grupo Fiscal (Imposto/Inscrição Estadual) */
      /*Por Fornecedor*/
   V_CDGRUPOFISC := NULL;
   BEGIN
      SELECT MAX(G.CDGRUPOFISC)
        INTO V_CDGRUPOFISC
        FROM GRFISIMPIEFORN G, (SELECT CDFORNECED
                                  FROM NOTAFISCAL
                                 WHERE CDFILIAL = P_FILIAL
                                   AND NRLANCTONF = P_LANCTONF
                                   AND P_CDFORNECED IS NULL
                                 UNION ALL
                                SELECT CDFORNECED
                                  FROM FORNECEDOR
                                 WHERE CDFORNECED = P_CDFORNECED) F
       WHERE G.CDIMPOSTO = P_IMPOSTO
         AND G.CDFORNECED = F.CDFORNECED
         AND G.CDEMPRESA = P_EMPRESA
         AND G.CDINSCESTA = P_INSCESTA;
   EXCEPTION
      WHEN No_Data_Found THEN
         V_CDGRUPOFISC := NULL;
   END;
   IF NOT (V_CDGRUPOFISC IS NULL) THEN /*Se há grupo fiscal na tela Parâmetros de Grupo Fiscal na aba Imposto/Inscrição Estadual*/
      FOR C_REGRA IN (SELECT *
                     FROM TABLE(CONSULTA_REGRA_FISCAL(P_IMPOSTO, P_EMPRESA, V_CDGRUPOFISC, P_ENTRSAIDAL, P_CDTIPOOPER, P_INSCESTA, P_PRODUTO, P_INIVALID,
                                                      P_PAISORIG, P_ESTAORIG, V_MUNIORIG, P_PAISDEST, P_ESTADEST, V_MUNIDEST, P_BASECALC, 'N', P_IDORIGEMPROD))
                       WHERE VRALIQUOTA IS NOT NULL) LOOP
          SELECT COUNT(*)
            INTO V_EXISTE
            FROM ALIQTEMP
           WHERE NRALIQTEMP  = P_FILIAL||P_LANCTONF;
          IF V_EXISTE > 0 THEN
             DELETE FROM ALIQTEMP
             WHERE NRALIQTEMP  = P_FILIAL||P_LANCTONF;
          END IF;
          V_ALIQSIMPLES := 0;
          BEGIN
             SELECT VRALIQUOTA, COUNT(*)
               INTO V_VRALIQSIMPLES, V_ALIQSIMPLES
               FROM ALIQSIMPNAC
              WHERE CDFORNECED  = P_CDFORNECED
                AND CDREGRAFISC = C_REGRA.CDREGRAFISC
                AND CDIMPOSTO   = P_IMPOSTO
              GROUP BY VRALIQUOTA;
          EXCEPTION
             WHEN NO_DATA_FOUND THEN
                V_VRALIQSIMPLES := NULL; V_ALIQSIMPLES := 0;
          END;
          IF (V_ALIQSIMPLES > 0) THEN
             INSERT INTO ALIQTEMP
                (NRALIQTEMP, NRSEQUALIQ, VRPREDBCTMP, VRPARDEDTMP, VRALIQUTMP, DSMENSALITMP,
                 IDTRIMPSTTMP, VRPBCSTTMP, IDPMCBSCALTMP, CDINSCESTAATMP, VR1PREDBCTMP, CDREGRATMP,
                 CDTIPOOPERTMP, CDFISCOPER, IDDIFEALIQ, IDDIFALIQCUSPR, VRADICALIQFECP, CDBENEFFISCAL,
                 IDCONSMVAPMC, IDCONSCOMPBCPMC, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF)
             VALUES
                (P_FILIAL||P_LANCTONF, V_SEQUENCIA, 0, 0, V_VRALIQSIMPLES, NULL,
                 C_REGRA.IDTRATIMPST, C_REGRA.VRPBCSUBTRIB, C_REGRA.IDPMCBASECA,NULL, 0, C_REGRA.CDREGRAFISC,
                 P_CDTIPOOPER, C_REGRA.CDFISCOPER, 'N', 'N', C_REGRA.VRADICALIQFECP, C_REGRA.CDBENEFFISCAL,
                 C_REGRA.IDCONSMVAPMC, C_REGRA.IDCONSCOMPBCPMC, C_REGRA.IDCONSDIFALIQ, C_REGRA.IDIMPODESONERA, C_REGRA.IDCONSDESONVRNF);
          ELSE
             INSERT INTO ALIQTEMP
                (NRALIQTEMP, NRSEQUALIQ, VRPREDBCTMP, VRPARDEDTMP, VRALIQUTMP, DSMENSALITMP,
                 IDTRIMPSTTMP, VRPBCSTTMP, IDPMCBSCALTMP, CDINSCESTAATMP, VR1PREDBCTMP, CDREGRATMP,
                 CDTIPOOPERTMP, CDFISCOPER, IDDIFEALIQ, IDDIFALIQCUSPR, VRADICALIQFECP, CDBENEFFISCAL,
                 IDCONSMVAPMC, IDCONSCOMPBCPMC, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF)
             VALUES
                (P_FILIAL||P_LANCTONF, V_SEQUENCIA, C_REGRA.VRPERREDBC, C_REGRA.VRPARDEDUZ, C_REGRA.VRALIQUOTA, NULL,
                 C_REGRA.IDTRATIMPST, C_REGRA.VRPBCSUBTRIB, C_REGRA.IDPMCBASECA,NULL, C_REGRA.VR1PERREDBC, C_REGRA.CDREGRAFISC,
                 P_CDTIPOOPER, C_REGRA.CDFISCOPER, C_REGRA.IDDIFEALIQ, C_REGRA.IDDIFALIQCUSPR, C_REGRA.VRADICALIQFECP, C_REGRA.CDBENEFFISCAL,
                 C_REGRA.IDCONSMVAPMC, C_REGRA.IDCONSCOMPBCPMC, C_REGRA.IDCONSDIFALIQ, C_REGRA.IDIMPODESONERA, C_REGRA.IDCONSDESONVRNF);
          END IF;
          V_SEQUENCIA := LPAD(RTRIM(V_SEQUENCIA + '01'),2,0);
      END LOOP;
   ELSE
       /*Por Cliente*/  
      BEGIN
        SELECT MAX(G.CDGRUPOFISC)
          INTO V_CDGRUPOFISC
          FROM GRFISIMPIECLIE G, (SELECT CDCLIENTE
                                    FROM NOTAFISCAL
                                   WHERE CDFILIAL = P_FILIAL
                                     AND NRLANCTONF = P_LANCTONF
                                     AND P_CDCLIENTE IS NULL
                                   UNION ALL
                                  SELECT CDCLIENTE
                                    FROM CLIENTE
                                   WHERE CDCLIENTE = P_CDCLIENTE) F
         WHERE G.CDIMPOSTO = P_IMPOSTO
           AND G.CDCLIENTE = F.CDCLIENTE
           AND G.CDEMPRESA = P_EMPRESA
           AND G.CDINSCESTA = P_INSCESTA;
      EXCEPTION
        WHEN No_Data_Found THEN
           V_CDGRUPOFISC := NULL;
      END;
      IF NOT (V_CDGRUPOFISC IS NULL) THEN /*Se há grupo fiscal na tela Parâmetros de Grupo Fiscal na aba Imposto/Inscrição Estadual*/
         FOR C_REGRA IN (SELECT *
                        FROM TABLE(CONSULTA_REGRA_FISCAL(P_IMPOSTO, P_EMPRESA, V_CDGRUPOFISC, P_ENTRSAIDAL, P_CDTIPOOPER, P_INSCESTA, P_PRODUTO, P_INIVALID,
                                                         P_PAISORIG, P_ESTAORIG, V_MUNIORIG, P_PAISDEST, P_ESTADEST, V_MUNIDEST, P_BASECALC, 'N', P_IDORIGEMPROD))
                          WHERE VRALIQUOTA IS NOT NULL) LOOP
             SELECT COUNT(*)
               INTO V_EXISTE
               FROM ALIQTEMP
              WHERE NRALIQTEMP  = P_FILIAL||P_LANCTONF;
             IF V_EXISTE > 0 THEN
                DELETE FROM ALIQTEMP
                WHERE NRALIQTEMP  = P_FILIAL||P_LANCTONF;
             END IF;
             V_ALIQSIMPLES := 0;
             BEGIN
                SELECT VRALIQUOTA, COUNT(*)
                  INTO V_VRALIQSIMPLES, V_ALIQSIMPLES
                  FROM ALIQSIMPNAC
                 WHERE CDFORNECED  = P_CDFORNECED
                   AND CDREGRAFISC = C_REGRA.CDREGRAFISC
                   AND CDIMPOSTO   = P_IMPOSTO
                 GROUP BY VRALIQUOTA;
             EXCEPTION
                WHEN NO_DATA_FOUND THEN
                   V_VRALIQSIMPLES := NULL; V_ALIQSIMPLES := 0;
             END;
             IF (V_ALIQSIMPLES > 0) THEN
                INSERT INTO ALIQTEMP
                   (NRALIQTEMP, NRSEQUALIQ, VRPREDBCTMP, VRPARDEDTMP, VRALIQUTMP, DSMENSALITMP,
                    IDTRIMPSTTMP, VRPBCSTTMP, IDPMCBSCALTMP, CDINSCESTAATMP, VR1PREDBCTMP, CDREGRATMP,
                    CDTIPOOPERTMP, CDFISCOPER, IDDIFEALIQ, IDDIFALIQCUSPR, VRADICALIQFECP, CDBENEFFISCAL,
                    IDCONSMVAPMC, IDCONSCOMPBCPMC, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF)
                VALUES
                   (P_FILIAL||P_LANCTONF, V_SEQUENCIA, 0, 0, V_VRALIQSIMPLES, NULL,
                    C_REGRA.IDTRATIMPST, C_REGRA.VRPBCSUBTRIB, C_REGRA.IDPMCBASECA,NULL, 0, C_REGRA.CDREGRAFISC,
                    P_CDTIPOOPER, C_REGRA.CDFISCOPER, 'N', 'N', C_REGRA.VRADICALIQFECP, C_REGRA.CDBENEFFISCAL,
                    C_REGRA.IDCONSMVAPMC, C_REGRA.IDCONSCOMPBCPMC, C_REGRA.IDCONSDIFALIQ, C_REGRA.IDIMPODESONERA, C_REGRA.IDCONSDESONVRNF);
             ELSE
                INSERT INTO ALIQTEMP
                   (NRALIQTEMP, NRSEQUALIQ, VRPREDBCTMP, VRPARDEDTMP, VRALIQUTMP, DSMENSALITMP,
                    IDTRIMPSTTMP, VRPBCSTTMP, IDPMCBSCALTMP, CDINSCESTAATMP, VR1PREDBCTMP, CDREGRATMP,
                    CDTIPOOPERTMP, CDFISCOPER, IDDIFEALIQ, IDDIFALIQCUSPR, VRADICALIQFECP, CDBENEFFISCAL,
                    IDCONSMVAPMC, IDCONSCOMPBCPMC, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF)
                VALUES
                   (P_FILIAL||P_LANCTONF, V_SEQUENCIA, C_REGRA.VRPERREDBC, C_REGRA.VRPARDEDUZ, C_REGRA.VRALIQUOTA, NULL,
                    C_REGRA.IDTRATIMPST, C_REGRA.VRPBCSUBTRIB, C_REGRA.IDPMCBASECA,NULL, C_REGRA.VR1PERREDBC, C_REGRA.CDREGRAFISC,
                    P_CDTIPOOPER, C_REGRA.CDFISCOPER, C_REGRA.IDDIFEALIQ, C_REGRA.IDDIFALIQCUSPR, C_REGRA.VRADICALIQFECP, C_REGRA.CDBENEFFISCAL,
                    C_REGRA.IDCONSMVAPMC, C_REGRA.IDCONSCOMPBCPMC, C_REGRA.IDCONSDIFALIQ, C_REGRA.IDIMPODESONERA, C_REGRA.IDCONSDESONVRNF);
             END IF;
             V_SEQUENCIA := LPAD(RTRIM(V_SEQUENCIA + '01'),2,0);
         END LOOP;
      ELSE
         BEGIN
            SELECT MAX(G.CDGRUPOFISC)
              INTO V_CDGRUPOFISC
              FROM GRUPOFISCIMPFIL G, (SELECT DECODE(P_ENTRSAIDAL, 'E', CDFILIRECE, CDFILIEMIT) AS CDFILIAL
                                         FROM NOTAFISCAL
                                        WHERE CDFILIAL = P_FILIAL
                                          AND NRLANCTONF = P_LANCTONF
                                          AND P_IDSISTEMA IS NULL
                                          AND P_CDFILIRECE IS NULL
                                       UNION ALL
                                       SELECT CDFILIAL
                                         FROM PEDIDO
                                        WHERE CDFILIAL = SUBSTR(P_FILIAL,1,4)
                                          AND NRPEDIDO = SUBSTR(P_FILIAL,5,10)
                                          AND P_IDSISTEMA = 'PED'
                                       UNION ALL
                                       SELECT CDFILIAL
                                         FROM FILIAL
                                        WHERE CDFILIAL = P_CDFILIRECE) F
             WHERE G.CDIMPOSTO = P_IMPOSTO
               AND G.CDFILIAL = F.CDFILIAL;
         EXCEPTION
            WHEN No_Data_Found THEN
               V_CDGRUPOFISC := NULL;
         END;
         IF NOT (V_CDGRUPOFISC IS NULL) THEN /*Se há grupo fiscal na tela Parâmetros de Grupo Fiscal na aba Imposto/Filial*/
            FOR C_REGRA IN (SELECT *
                           FROM TABLE(CONSULTA_REGRA_FISCAL(P_IMPOSTO, P_EMPRESA, V_CDGRUPOFISC, P_ENTRSAIDAL, P_CDTIPOOPER, P_INSCESTA, P_PRODUTO, P_INIVALID,
                                                            P_PAISORIG, P_ESTAORIG, V_MUNIORIG, P_PAISDEST, P_ESTADEST, V_MUNIDEST, P_BASECALC, 'N', P_IDORIGEMPROD))
                             WHERE VRALIQUOTA IS NOT NULL) LOOP
                SELECT COUNT(*)
                  INTO V_EXISTE
                  FROM ALIQTEMP
                 WHERE NRALIQTEMP  = P_FILIAL||P_LANCTONF;
                IF V_EXISTE > 0 THEN
                   DELETE FROM ALIQTEMP
                   WHERE NRALIQTEMP  = P_FILIAL||P_LANCTONF;
                END IF;
                V_ALIQSIMPLES := 0;
                BEGIN
                   SELECT VRALIQUOTA, COUNT(*)
                     INTO V_VRALIQSIMPLES, V_ALIQSIMPLES
                     FROM ALIQSIMPNAC
                    WHERE CDFORNECED  = P_CDFORNECED
                      AND CDREGRAFISC = C_REGRA.CDREGRAFISC
                      AND CDIMPOSTO   = P_IMPOSTO
                    GROUP BY VRALIQUOTA;
                EXCEPTION
                   WHEN NO_DATA_FOUND THEN
                      V_VRALIQSIMPLES := NULL; V_ALIQSIMPLES := 0;
                END;
                IF (V_ALIQSIMPLES > 0) THEN
                   INSERT INTO ALIQTEMP
                      (NRALIQTEMP, NRSEQUALIQ, VRPREDBCTMP, VRPARDEDTMP, VRALIQUTMP, DSMENSALITMP,
                       IDTRIMPSTTMP, VRPBCSTTMP, IDPMCBSCALTMP, CDINSCESTAATMP, VR1PREDBCTMP, CDREGRATMP,
                       CDTIPOOPERTMP, CDFISCOPER, IDDIFEALIQ, IDDIFALIQCUSPR, VRADICALIQFECP, CDBENEFFISCAL,
                       IDCONSMVAPMC, IDCONSCOMPBCPMC, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF)
                   VALUES
                      (P_FILIAL||P_LANCTONF, V_SEQUENCIA, 0, 0, V_VRALIQSIMPLES, NULL,
                       C_REGRA.IDTRATIMPST, C_REGRA.VRPBCSUBTRIB, C_REGRA.IDPMCBASECA,NULL, 0, C_REGRA.CDREGRAFISC,
                       P_CDTIPOOPER, C_REGRA.CDFISCOPER, 'N', 'N', C_REGRA.VRADICALIQFECP, C_REGRA.CDBENEFFISCAL,
                       C_REGRA.IDCONSMVAPMC, C_REGRA.IDCONSCOMPBCPMC, C_REGRA.IDCONSDIFALIQ, C_REGRA.IDIMPODESONERA, C_REGRA.IDCONSDESONVRNF);
                ELSE
                   INSERT INTO ALIQTEMP
                      (NRALIQTEMP, NRSEQUALIQ, VRPREDBCTMP, VRPARDEDTMP, VRALIQUTMP, DSMENSALITMP,
                       IDTRIMPSTTMP, VRPBCSTTMP, IDPMCBSCALTMP, CDINSCESTAATMP, VR1PREDBCTMP, CDREGRATMP,
                       CDTIPOOPERTMP, CDFISCOPER, IDDIFEALIQ, IDDIFALIQCUSPR, VRADICALIQFECP, CDBENEFFISCAL,
                       IDCONSMVAPMC, IDCONSCOMPBCPMC, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF)
                   VALUES
                      (P_FILIAL||P_LANCTONF, V_SEQUENCIA, C_REGRA.VRPERREDBC, C_REGRA.VRPARDEDUZ, C_REGRA.VRALIQUOTA, NULL,
                       C_REGRA.IDTRATIMPST, C_REGRA.VRPBCSUBTRIB, C_REGRA.IDPMCBASECA,NULL, C_REGRA.VR1PERREDBC, C_REGRA.CDREGRAFISC,
                       P_CDTIPOOPER, C_REGRA.CDFISCOPER, C_REGRA.IDDIFEALIQ, C_REGRA.IDDIFALIQCUSPR, C_REGRA.VRADICALIQFECP, C_REGRA.CDBENEFFISCAL,
                       C_REGRA.IDCONSMVAPMC, C_REGRA.IDCONSCOMPBCPMC, C_REGRA.IDCONSDIFALIQ, C_REGRA.IDIMPODESONERA, C_REGRA.IDCONSDESONVRNF);
                END IF;
                V_SEQUENCIA := LPAD(RTRIM(V_SEQUENCIA + '01'),2,0);
            END LOOP;
         ELSE
            FOR C_REGRA IN (SELECT *
                              FROM TABLE(CONSULTA_REGRA_FISCAL(P_IMPOSTO, P_EMPRESA, P_CDGRUPOFISC, P_ENTRSAIDAL, P_CDTIPOOPER, P_INSCESTA, P_PRODUTO, P_INIVALID,
                                                               P_PAISORIG, P_ESTAORIG, V_MUNIORIG, P_PAISDEST, P_ESTADEST, V_MUNIDEST, P_BASECALC, 'N', P_IDORIGEMPROD))
                             WHERE VRALIQUOTA IS NOT NULL) LOOP
                SELECT COUNT(*)
                  INTO V_EXISTE
                  FROM ALIQTEMP
                 WHERE NRALIQTEMP  = P_FILIAL||P_LANCTONF
                   AND CDREGRATMP IS NULL;
                IF V_EXISTE > 0 THEN
                   DELETE FROM ALIQTEMP
                   WHERE NRALIQTEMP  = P_FILIAL||P_LANCTONF
                     AND CDREGRATMP IS NULL;
                END IF;
                V_ALIQSIMPLES := 0;
                BEGIN
                   SELECT VRALIQUOTA, COUNT(*)
                     INTO V_VRALIQSIMPLES, V_ALIQSIMPLES
                     FROM ALIQSIMPNAC
                    WHERE CDFORNECED  = P_CDFORNECED
                      AND CDREGRAFISC = C_REGRA.CDREGRAFISC
                      AND CDIMPOSTO   = P_IMPOSTO
                    GROUP BY VRALIQUOTA;
                EXCEPTION
                   WHEN NO_DATA_FOUND THEN
                      V_VRALIQSIMPLES := NULL; V_ALIQSIMPLES := 0;
                END;
                IF (V_ALIQSIMPLES > 0) THEN
                   INSERT INTO ALIQTEMP
                      (NRALIQTEMP, NRSEQUALIQ, VRPREDBCTMP, VRPARDEDTMP, VRALIQUTMP, DSMENSALITMP,
                       IDTRIMPSTTMP, VRPBCSTTMP, IDPMCBSCALTMP, CDINSCESTAATMP, VR1PREDBCTMP, CDREGRATMP,
                       CDTIPOOPERTMP, CDFISCOPER, IDDIFEALIQ, IDDIFALIQCUSPR, VRADICALIQFECP, CDBENEFFISCAL,
                       IDCONSMVAPMC, IDCONSCOMPBCPMC, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF)
                   VALUES
                      (P_FILIAL||P_LANCTONF, V_SEQUENCIA, 0, 0, V_VRALIQSIMPLES, NULL,
                       C_REGRA.IDTRATIMPST, C_REGRA.VRPBCSUBTRIB, C_REGRA.IDPMCBASECA,NULL, 0, C_REGRA.CDREGRAFISC,
                       P_CDTIPOOPER, C_REGRA.CDFISCOPER, 'N', 'N', C_REGRA.VRADICALIQFECP, C_REGRA.CDBENEFFISCAL,
                       C_REGRA.IDCONSMVAPMC, C_REGRA.IDCONSCOMPBCPMC, C_REGRA.IDCONSDIFALIQ, C_REGRA.IDIMPODESONERA, C_REGRA.IDCONSDESONVRNF);
                ELSE
                   INSERT INTO ALIQTEMP
                      (NRALIQTEMP, NRSEQUALIQ, VRPREDBCTMP, VRPARDEDTMP, VRALIQUTMP, DSMENSALITMP,
                       IDTRIMPSTTMP, VRPBCSTTMP, IDPMCBSCALTMP, CDINSCESTAATMP, VR1PREDBCTMP, CDREGRATMP,
                       CDTIPOOPERTMP, CDFISCOPER, IDDIFEALIQ, IDDIFALIQCUSPR, VRADICALIQFECP, CDBENEFFISCAL,
                       IDCONSMVAPMC, IDCONSCOMPBCPMC, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF)
                   VALUES
                      (P_FILIAL||P_LANCTONF, V_SEQUENCIA, C_REGRA.VRPERREDBC, C_REGRA.VRPARDEDUZ, C_REGRA.VRALIQUOTA, NULL,
                       C_REGRA.IDTRATIMPST, C_REGRA.VRPBCSUBTRIB, C_REGRA.IDPMCBASECA,NULL, C_REGRA.VR1PERREDBC, C_REGRA.CDREGRAFISC,
                       P_CDTIPOOPER, C_REGRA.CDFISCOPER, C_REGRA.IDDIFEALIQ, C_REGRA.IDDIFALIQCUSPR, C_REGRA.VRADICALIQFECP, C_REGRA.CDBENEFFISCAL,
                       C_REGRA.IDCONSMVAPMC, C_REGRA.IDCONSCOMPBCPMC, C_REGRA.IDCONSDIFALIQ, C_REGRA.IDIMPODESONERA, C_REGRA.IDCONSDESONVRNF);
                END IF;
                V_SEQUENCIA := LPAD(RTRIM(V_SEQUENCIA + '01'),2,0);
            END LOOP;
         END IF;
      END IF;
   END IF;
   V_EXISTE := 0;
   SELECT COUNT(*)
     INTO V_EXISTE
     FROM ALIQTEMP
    WHERE NRALIQTEMP  = P_FILIAL||P_LANCTONF
      AND CDREGRATMP IS NOT NULL;
   IF NOT(V_EXISTE > 0) THEN
      IF P_CDGRUPOFISC IS NOT NULL THEN /*Se há grupo fiscal*/
         IF V_IDPRODNOTA = w_P THEN /*Se imposto do item*/
            SELECT MAX(CDTIPOOPER), COUNT(*)
              INTO V_CDTIPOOPER, V_CONTADOR
              FROM ALIQUOTA A, PRODUTO P
             WHERE (CDIMPOSTO    = P_IMPOSTO)
               AND (IDENTRSAIDAL = P_ENTRSAIDAL)
               AND (CDEMPRESA    = P_EMPRESA)
               AND (CDINSCESTA   = RTRIM(P_INSCESTA))
               AND (CDGRUPOFISC  = P_CDGRUPOFISC)
               AND ((CDPAISORIG  = P_PAISORIG) AND (SGESTAORIG  = P_ESTAORIG) OR V_UTUFORIG = w_N)
               AND ((CDPAISDEST  = P_PAISDEST) AND (SGESTADEST  = P_ESTADEST) OR V_UTUFDEST = w_N)
               AND ((CDMUNIORIG  = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
               AND ((VRINIFAIXA  < V_VRITEMPROD) AND (VRFIMFAIXA  >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
               AND (INSTR(NVL(P_CDTIPOOPER,'_'), NVL(RTRIM(CDTIPOOPER), NVL(P_CDTIPOOPER,'_'))) = 1  OR V_IDUTALIQTPOPER = w_N)
               AND (A.CDPRODUTO = P.CDPRODUTO(+))
               AND (INSTR(NVL(P_PRODUTO,'_'),NVL(RTRIM(P.CDARVPROD),NVL(P_PRODUTO,'_'))) = 1);
            IF NOT (V_CDTIPOOPER IS NULL) THEN /*Se possui alíquota por tipo de operação*/
               SELECT MAX(P.CDARVPROD)
               INTO V_CDARVPROD
               FROM ALIQUOTA A, PRODUTO P
               WHERE (CDIMPOSTO    = P_IMPOSTO)
                 AND (IDENTRSAIDAL = P_ENTRSAIDAL)
                 AND (CDEMPRESA    = P_EMPRESA)
                 AND (CDINSCESTA   = RTRIM(P_INSCESTA))
                 AND (CDGRUPOFISC  = P_CDGRUPOFISC)
                 AND ((CDPAISORIG  = P_PAISORIG) AND (SGESTAORIG  = P_ESTAORIG) OR V_UTUFORIG = w_N)
                 AND ((CDPAISDEST  = P_PAISDEST) AND (SGESTADEST  = P_ESTADEST) OR V_UTUFDEST = w_N)
                 AND ((CDMUNIORIG  = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                 AND ((VRINIFAIXA  < V_VRITEMPROD) AND (VRFIMFAIXA  >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                 AND (CDTIPOOPER = V_CDTIPOOPER OR V_IDUTALIQTPOPER = w_N)
                 AND (A.CDPRODUTO = P.CDPRODUTO(+))
                 AND (INSTR(NVL(P_PRODUTO,'_'),NVL(RTRIM(P.CDARVPROD),NVL(P_PRODUTO,'_'))) = 1);
            ELSIF (V_CDTIPOOPER IS NULL) THEN /*Se não possui alíquota por tipo de operação*/
               SELECT MAX(P.CDARVPROD)
                 INTO V_CDARVPROD
                 FROM ALIQUOTA A, PRODUTO P
                WHERE (CDIMPOSTO    = P_IMPOSTO)
                  AND (IDENTRSAIDAL = P_ENTRSAIDAL)
                  AND (CDEMPRESA    = P_EMPRESA)
                  AND (CDINSCESTA   = RTRIM(P_INSCESTA))
                  AND (CDGRUPOFISC  = P_CDGRUPOFISC)
                  AND ((CDPAISORIG  = P_PAISORIG) AND (SGESTAORIG  = P_ESTAORIG) OR V_UTUFORIG = w_N)
                  AND ((CDPAISDEST  = P_PAISDEST) AND (SGESTADEST  = P_ESTADEST) OR V_UTUFDEST = w_N)
                  AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                  AND ((VRINIFAIXA  < V_VRITEMPROD) AND (VRFIMFAIXA  >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                  AND (INSTR(NVL(P_CDTIPOOPER,'_'), NVL(RTRIM(CDTIPOOPER), NVL(P_CDTIPOOPER,'_'))) = 1  OR V_IDUTALIQTPOPER = w_N)
                  AND (A.CDPRODUTO = P.CDPRODUTO(+))
                  AND (INSTR(NVL(P_PRODUTO,'_'),NVL(RTRIM(P.CDARVPROD),NVL(P_PRODUTO,'_'))) = 1);
            END IF;
         ELSE /*Se imposto da nota*/
            SELECT MAX(A.CDPRODUTO), COUNT(*), MAX(CDTIPOOPER)
            INTO V_CDARVPROD, V_CONTADOR, V_CDTIPOOPER
            FROM ALIQUOTA A
            WHERE (CDIMPOSTO    = P_IMPOSTO)
              AND (IDENTRSAIDAL = P_ENTRSAIDAL)
              AND (CDEMPRESA    = P_EMPRESA)
              AND (CDINSCESTA   = RTRIM(P_INSCESTA))
              AND (CDGRUPOFISC  = P_CDGRUPOFISC)
              AND ((CDPAISORIG  = P_PAISORIG) AND (SGESTAORIG  = P_ESTAORIG) OR V_UTUFORIG = w_N)
              AND ((CDPAISDEST  = P_PAISDEST) AND (SGESTADEST  = P_ESTADEST) OR V_UTUFDEST = w_N)
              AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
              AND ((VRINIFAIXA  < V_VRITEMPROD) AND (VRFIMFAIXA  >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
              AND (INSTR(NVL(P_CDTIPOOPER,'_'), NVL(RTRIM(CDTIPOOPER), NVL(P_CDTIPOOPER,'_'))) = 1  OR V_IDUTALIQTPOPER = w_N)
              AND (A.CDPRODUTO IS NULL);
         END IF;
         IF V_CONTADOR > 0 THEN /*Se encontrou alíquota para o grupo fiscal*/
            IF NOT (V_CDTIPOOPER IS NULL) THEN /*Se possui alíquota por tipo de operação*/
               IF NOT (V_CDARVPROD IS NULL) THEN /*Se há alíquota para o produto de maior nível*/
                  FOR C_ALIQUOTA IN (
                      SELECT A.NRALIQUOTA, VRPERREDBC, VR1PERREDBC, VRPARDEDUZ, VRALIQUOTA, DSMENSALIQU, IDTRATIMPST,
                             VRPBCSUBTRIB, IDPMCBASECAL, A.CDTIPOOPER, CDMENSAGEM, VRADICALIQFECP, CDBENEFFISCAL,
                             IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF
                        FROM ALIQUOTA A, MENSALIQU, PRODUTO P
                       WHERE (A.NRALIQUOTA = MENSALIQU.NRALIQUOTA(+))
                         AND (A.CDIMPOSTO = P_IMPOSTO)
                         AND (A.IDENTRSAIDAL = P_ENTRSAIDAL)
                         AND (A.CDEMPRESA = P_EMPRESA)
                         AND (A.CDINSCESTA = RTRIM(P_INSCESTA))
                         AND (A.CDGRUPOFISC = P_CDGRUPOFISC)
                         AND (A.CDPRODUTO = P.CDPRODUTO(+))
                         AND (P.CDARVPROD = V_CDARVPROD)
                         AND ((A.CDPAISORIG = P_PAISORIG)
                         AND (A.SGESTAORIG = P_ESTAORIG) OR V_UTUFORIG = w_N)
                         AND ((A.CDPAISDEST = P_PAISDEST) AND (A.SGESTADEST = P_ESTADEST) OR V_UTUFDEST = w_N)
                         AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                         AND ((A.VRINIFAIXA < V_VRITEMPROD) AND (A.VRFIMFAIXA >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                         AND (CDTIPOOPER = V_CDTIPOOPER)
                         AND (A.DTINIVALID = ( SELECT MAX(DTINIVALID)
                                               FROM ALIQUOTA A, PRODUTO P
                                               WHERE (CDIMPOSTO = P_IMPOSTO)
                                                 AND (IDENTRSAIDAL = P_ENTRSAIDAL)
                                                 AND (CDEMPRESA = P_EMPRESA)
                                                 AND (CDINSCESTA = RTRIM(P_INSCESTA))
                                                 AND (CDGRUPOFISC = P_CDGRUPOFISC)
                                                 AND (A.CDPRODUTO = P.CDPRODUTO(+))
                                                 AND (P.CDARVPROD = V_CDARVPROD)
                                                 AND ((CDPAISORIG = P_PAISORIG)
                                                 AND (SGESTAORIG = P_ESTAORIG) OR V_UTUFORIG = w_N)
                                                 AND ((CDPAISDEST = P_PAISDEST) AND (SGESTADEST = P_ESTADEST) OR V_UTUFDEST = w_N)
                                                 AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                                                 AND ((VRINIFAIXA < V_VRITEMPROD) AND (VRFIMFAIXA >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                                                 AND (CDTIPOOPER = V_CDTIPOOPER)
                                                 AND (DTINIVALID <= P_INIVALID)))) LOOP
                      SELECT COUNT(*)
                        INTO V_COUNTMENS
                        FROM MENSAGEM
                       WHERE CDMENSAGEM = C_ALIQUOTA.CDMENSAGEM
                         AND IDSITUACAOMENS = 'I';
                      IF V_COUNTMENS > 0 THEN
                         V_DSMENSALIQU := NULL;
                      ELSE
                         V_DSMENSALIQU := C_ALIQUOTA.DSMENSALIQU;
                      END IF;
                      INSERT INTO ALIQTEMP
                         (NRALIQTEMP, NRSEQUALIQ, VRPREDBCTMP, VRPARDEDTMP,
                          VRALIQUTMP, DSMENSALITMP, IDTRIMPSTTMP, VRPBCSTTMP,
                          IDPMCBSCALTMP, CDTIPOOPERTMP, VR1PREDBCTMP, CDINSCESTAATMP,
                          VRADICALIQFECP, CDBENEFFISCAL, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF)
                      VALUES
                        (P_FILIAL||P_LANCTONF, V_SEQUENCIA, C_ALIQUOTA.VRPERREDBC, C_ALIQUOTA.VRPARDEDUZ,
                         C_ALIQUOTA.VRALIQUOTA, V_DSMENSALIQU, C_ALIQUOTA.IDTRATIMPST, C_ALIQUOTA.VRPBCSUBTRIB, C_ALIQUOTA.IDPMCBASECAL,
                         C_ALIQUOTA.CDTIPOOPER, C_ALIQUOTA.VR1PERREDBC, P_INSCESTA,
                         C_ALIQUOTA.VRADICALIQFECP, C_ALIQUOTA.CDBENEFFISCAL, C_ALIQUOTA.IDCONSDIFALIQ, C_ALIQUOTA.IDIMPODESONERA, C_ALIQUOTA.IDCONSDESONVRNF);
                      V_SEQUENCIA := LPAD(RTRIM(V_SEQUENCIA + '01'),2,0);
                  END LOOP;
               ELSIF (V_CDARVPROD IS NULL) THEN /*Se há alíquota para o produto todos*/
                  FOR C_ALIQUOTA IN (
                     SELECT A.NRALIQUOTA, VRPERREDBC, VR1PERREDBC, VRPARDEDUZ, VRALIQUOTA, DSMENSALIQU, IDTRATIMPST, VRPBCSUBTRIB, IDPMCBASECAL, A.CDTIPOOPER,
                            CDMENSAGEM, VRADICALIQFECP, CDBENEFFISCAL, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF
                       FROM ALIQUOTA A, MENSALIQU
                      WHERE (A.NRALIQUOTA = MENSALIQU.NRALIQUOTA(+))
                        AND (A.CDIMPOSTO = P_IMPOSTO)
                        AND (A.IDENTRSAIDAL = P_ENTRSAIDAL)
                        AND (A.CDEMPRESA = P_EMPRESA)
                        AND (A.CDINSCESTA = RTRIM(P_INSCESTA))
                        AND (A.CDGRUPOFISC = P_CDGRUPOFISC)
                        AND (A.CDPRODUTO IS NULL)
                        AND ((A.CDPAISORIG = P_PAISORIG)
                        AND (A.SGESTAORIG = P_ESTAORIG) OR V_UTUFORIG = w_N)
                        AND ((A.CDPAISDEST = P_PAISDEST) AND (A.SGESTADEST = P_ESTADEST) OR V_UTUFDEST = w_N)
                        AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                        AND ((A.VRINIFAIXA < V_VRITEMPROD) AND (A.VRFIMFAIXA >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                        AND (CDTIPOOPER = V_CDTIPOOPER)
                        AND (A.DTINIVALID = ( SELECT MAX(DTINIVALID)
                                                FROM ALIQUOTA
                                               WHERE (CDIMPOSTO = P_IMPOSTO)
                                                 AND (IDENTRSAIDAL = P_ENTRSAIDAL)
                                                 AND (CDEMPRESA = P_EMPRESA)
                                                 AND (CDINSCESTA = RTRIM(P_INSCESTA))
                                                 AND (CDGRUPOFISC = P_CDGRUPOFISC)
                                                 AND (CDPRODUTO IS NULL)
                                                 AND ((CDPAISORIG = P_PAISORIG)
                                                 AND (SGESTAORIG = P_ESTAORIG) OR V_UTUFORIG = w_N)
                                                 AND ((CDPAISDEST = P_PAISDEST)
                                                 AND (SGESTADEST = P_ESTADEST) OR V_UTUFDEST = w_N)
                                                 AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                                                 AND ((VRINIFAIXA < V_VRITEMPROD)
                                                 AND (VRFIMFAIXA >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                                                 AND (CDTIPOOPER = V_CDTIPOOPER)
                                                 AND (DTINIVALID <= P_INIVALID)))) LOOP
                     SELECT COUNT(*)
                       INTO V_COUNTMENS
                       FROM MENSAGEM
                      WHERE CDMENSAGEM = C_ALIQUOTA.CDMENSAGEM
                        AND IDSITUACAOMENS = 'I';
                     IF V_COUNTMENS > 0 THEN
                        V_DSMENSALIQU := NULL;
                     ELSE
                        V_DSMENSALIQU := C_ALIQUOTA.DSMENSALIQU;
                     END IF;
                     INSERT INTO ALIQTEMP
                        (NRALIQTEMP, NRSEQUALIQ, VRPREDBCTMP, VRPARDEDTMP,
                         VRALIQUTMP, DSMENSALITMP, IDTRIMPSTTMP, VRPBCSTTMP,
                         IDPMCBSCALTMP, CDTIPOOPERTMP, VR1PREDBCTMP, CDINSCESTAATMP,
                         VRADICALIQFECP, CDBENEFFISCAL, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF)
                     VALUES
                        (P_FILIAL||P_LANCTONF, V_SEQUENCIA, C_ALIQUOTA.VRPERREDBC, C_ALIQUOTA.VRPARDEDUZ,
                         C_ALIQUOTA.VRALIQUOTA, V_DSMENSALIQU, C_ALIQUOTA.IDTRATIMPST, C_ALIQUOTA.VRPBCSUBTRIB,
                         C_ALIQUOTA.IDPMCBASECAL, C_ALIQUOTA.CDTIPOOPER, C_ALIQUOTA.VR1PERREDBC, P_INSCESTA,
                         C_ALIQUOTA.VRADICALIQFECP, C_ALIQUOTA.CDBENEFFISCAL, C_ALIQUOTA.IDCONSDIFALIQ, C_ALIQUOTA.IDIMPODESONERA, C_ALIQUOTA.IDCONSDESONVRNF);
                     V_SEQUENCIA := LPAD(RTRIM(V_SEQUENCIA + '01'),2,0);
                  END LOOP;
               END IF;
            ELSIF (V_CDTIPOOPER IS NULL) THEN /*Se não possui alíquota por tipo de operação*/
               IF NOT (V_CDARVPROD IS NULL) THEN /*Se há alíquota para o produto de maior nível*/
                  FOR C_ALIQUOTA IN (
                      SELECT A.NRALIQUOTA, VRPERREDBC, VR1PERREDBC, VRPARDEDUZ, VRALIQUOTA, DSMENSALIQU, IDTRATIMPST, VRPBCSUBTRIB, IDPMCBASECAL, CDMENSAGEM,
                             VRADICALIQFECP, CDBENEFFISCAL, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF
                        FROM ALIQUOTA A, MENSALIQU, PRODUTO P
                       WHERE (A.NRALIQUOTA = MENSALIQU.NRALIQUOTA(+))
                         AND (A.CDIMPOSTO = P_IMPOSTO)
                         AND (A.IDENTRSAIDAL = P_ENTRSAIDAL)
                         AND (A.CDEMPRESA = P_EMPRESA)
                         AND (A.CDINSCESTA = RTRIM(P_INSCESTA))
                         AND (A.CDGRUPOFISC = P_CDGRUPOFISC)
                         AND (A.CDPRODUTO = P.CDPRODUTO(+))
                         AND (P.CDARVPROD = V_CDARVPROD)
                         AND ((A.CDPAISORIG = P_PAISORIG)
                         AND (A.SGESTAORIG = P_ESTAORIG) OR V_UTUFORIG = w_N)
                         AND ((A.CDPAISDEST = P_PAISDEST) AND (A.SGESTADEST = P_ESTADEST) OR V_UTUFDEST = w_N)
                         AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                         AND ((A.VRINIFAIXA < V_VRITEMPROD) AND (A.VRFIMFAIXA >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                         AND (INSTR(NVL(P_CDTIPOOPER,'_'), NVL(RTRIM(CDTIPOOPER), NVL(P_CDTIPOOPER,'_'))) = 1  OR V_IDUTALIQTPOPER = w_N)
                         AND (A.DTINIVALID = ( SELECT MAX(DTINIVALID)
                                               FROM ALIQUOTA A, PRODUTO P
                                               WHERE (CDIMPOSTO = P_IMPOSTO)
                                                 AND (IDENTRSAIDAL = P_ENTRSAIDAL)
                                                 AND (CDEMPRESA = P_EMPRESA)
                                                 AND (CDINSCESTA = RTRIM(P_INSCESTA))
                                                 AND (CDGRUPOFISC = P_CDGRUPOFISC)
                                                 AND (A.CDPRODUTO = P.CDPRODUTO(+))
                                                 AND (P.CDARVPROD = V_CDARVPROD)
                                                 AND ((CDPAISORIG = P_PAISORIG)
                                                 AND (SGESTAORIG = P_ESTAORIG) OR V_UTUFORIG = w_N)
                                                 AND ((CDPAISDEST = P_PAISDEST) AND (SGESTADEST = P_ESTADEST) OR V_UTUFDEST = w_N)
                                                 AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                                                 AND ((VRINIFAIXA < V_VRITEMPROD) AND (VRFIMFAIXA >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                                                 AND (INSTR(NVL(P_CDTIPOOPER,'_'), NVL(RTRIM(CDTIPOOPER), NVL(P_CDTIPOOPER,'_'))) = 1  OR V_IDUTALIQTPOPER = w_N)
                                                 AND (DTINIVALID <= P_INIVALID)))) LOOP
                      SELECT COUNT(*)
                        INTO V_COUNTMENS
                        FROM MENSAGEM
                       WHERE CDMENSAGEM = C_ALIQUOTA.CDMENSAGEM
                         AND IDSITUACAOMENS = 'I';
                      IF V_COUNTMENS > 0 THEN
                         V_DSMENSALIQU := NULL;
                      ELSE
                         V_DSMENSALIQU := C_ALIQUOTA.DSMENSALIQU;
                      END IF;
                      INSERT INTO ALIQTEMP
                         (NRALIQTEMP, NRSEQUALIQ, VRPREDBCTMP, VRPARDEDTMP,
                          VRALIQUTMP, DSMENSALITMP, IDTRIMPSTTMP, VRPBCSTTMP,
                          IDPMCBSCALTMP, VR1PREDBCTMP, CDINSCESTAATMP,
                          VRADICALIQFECP, CDBENEFFISCAL, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF)
                      VALUES
                        (P_FILIAL||P_LANCTONF, V_SEQUENCIA, C_ALIQUOTA.VRPERREDBC, C_ALIQUOTA.VRPARDEDUZ,
                         C_ALIQUOTA.VRALIQUOTA, V_DSMENSALIQU, C_ALIQUOTA.IDTRATIMPST, C_ALIQUOTA.VRPBCSUBTRIB,
                         C_ALIQUOTA.IDPMCBASECAL, C_ALIQUOTA.VR1PERREDBC, P_INSCESTA,
                         C_ALIQUOTA.VRADICALIQFECP, C_ALIQUOTA.CDBENEFFISCAL, C_ALIQUOTA.IDCONSDIFALIQ, C_ALIQUOTA.IDIMPODESONERA, C_ALIQUOTA.IDCONSDESONVRNF);
                      V_SEQUENCIA := LPAD(RTRIM(V_SEQUENCIA + '01'),2,0);
                  END LOOP;
               ELSIF (V_CDARVPROD IS NULL) THEN /*Se há alíquota para o produto todos*/
                  FOR C_ALIQUOTA IN (
                     SELECT A.NRALIQUOTA, VRPERREDBC, VR1PERREDBC, VRPARDEDUZ, VRALIQUOTA, DSMENSALIQU, IDTRATIMPST, VRPBCSUBTRIB, IDPMCBASECAL, CDMENSAGEM,
                            VRADICALIQFECP, CDBENEFFISCAL, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF
                       FROM ALIQUOTA A, MENSALIQU
                      WHERE (A.NRALIQUOTA = MENSALIQU.NRALIQUOTA(+))
                        AND (A.CDIMPOSTO = P_IMPOSTO)
                        AND (A.IDENTRSAIDAL = P_ENTRSAIDAL)
                        AND (A.CDEMPRESA = P_EMPRESA)
                        AND (A.CDINSCESTA = RTRIM(P_INSCESTA))
                        AND (A.CDGRUPOFISC = P_CDGRUPOFISC)
                        AND (A.CDPRODUTO IS NULL)
                        AND ((A.CDPAISORIG = P_PAISORIG)
                        AND (A.SGESTAORIG = P_ESTAORIG) OR V_UTUFORIG = w_N)
                        AND ((A.CDPAISDEST = P_PAISDEST) AND (A.SGESTADEST = P_ESTADEST) OR V_UTUFDEST = w_N)
                        AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                        AND ((A.VRINIFAIXA < V_VRITEMPROD) AND (A.VRFIMFAIXA >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                        AND (INSTR(NVL(P_CDTIPOOPER,'_'), NVL(RTRIM(CDTIPOOPER), NVL(P_CDTIPOOPER,'_'))) = 1  OR V_IDUTALIQTPOPER = w_N)
                        AND (A.DTINIVALID = ( SELECT MAX(DTINIVALID)
                                                FROM ALIQUOTA
                                               WHERE (CDIMPOSTO = P_IMPOSTO)
                                                 AND (IDENTRSAIDAL = P_ENTRSAIDAL)
                                                 AND (CDEMPRESA = P_EMPRESA)
                                                 AND (CDINSCESTA = RTRIM(P_INSCESTA))
                                                 AND (CDGRUPOFISC = P_CDGRUPOFISC)
                                                 AND (CDPRODUTO IS NULL)
                                                 AND ((CDPAISORIG = P_PAISORIG)
                                                 AND (SGESTAORIG = P_ESTAORIG) OR V_UTUFORIG = w_N)
                                                 AND ((CDPAISDEST = P_PAISDEST)
                                                 AND (SGESTADEST = P_ESTADEST) OR V_UTUFDEST = w_N)
                                                 AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                                                 AND ((VRINIFAIXA < V_VRITEMPROD)
                                                 AND (VRFIMFAIXA >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                                                 AND (INSTR(NVL(P_CDTIPOOPER,'_'), NVL(RTRIM(CDTIPOOPER), NVL(P_CDTIPOOPER,'_'))) = 1  OR V_IDUTALIQTPOPER = w_N)
                                                 AND (DTINIVALID <= P_INIVALID)))) LOOP
                     SELECT COUNT(*)
                       INTO V_COUNTMENS
                       FROM MENSAGEM
                      WHERE CDMENSAGEM = C_ALIQUOTA.CDMENSAGEM
                        AND IDSITUACAOMENS = 'I';
                     IF V_COUNTMENS > 0 THEN
                        V_DSMENSALIQU := NULL;
                     ELSE
                        V_DSMENSALIQU := C_ALIQUOTA.DSMENSALIQU;
                     END IF;
                     INSERT INTO ALIQTEMP
                        (NRALIQTEMP, NRSEQUALIQ, VRPREDBCTMP, VRPARDEDTMP,
                         VRALIQUTMP, DSMENSALITMP, IDTRIMPSTTMP, VRPBCSTTMP,
                         IDPMCBSCALTMP, VR1PREDBCTMP, CDINSCESTAATMP, VRADICALIQFECP,
                         CDBENEFFISCAL, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF)
                     VALUES
                        (P_FILIAL||P_LANCTONF, V_SEQUENCIA, C_ALIQUOTA.VRPERREDBC, C_ALIQUOTA.VRPARDEDUZ,
                         C_ALIQUOTA.VRALIQUOTA, V_DSMENSALIQU, C_ALIQUOTA.IDTRATIMPST, C_ALIQUOTA.VRPBCSUBTRIB,
                         C_ALIQUOTA.IDPMCBASECAL, C_ALIQUOTA.VR1PERREDBC, P_INSCESTA, C_ALIQUOTA.VRADICALIQFECP, 
                         C_ALIQUOTA.CDBENEFFISCAL, C_ALIQUOTA.IDCONSDIFALIQ, C_ALIQUOTA.IDIMPODESONERA, C_ALIQUOTA.IDCONSDESONVRNF);
                     V_SEQUENCIA := LPAD(RTRIM(V_SEQUENCIA + '01'),2,0);
                  END LOOP;
               END IF;
            END IF;
         END IF;
      ELSE /*Se não há grupo fiscal*/
         SELECT MAX(A.CDTIPOOPER)
         INTO V_CDTIPOOPER
         FROM ALIQUOTA A, PRODUTO P
         WHERE (CDIMPOSTO    = P_IMPOSTO)
           AND (IDENTRSAIDAL = P_ENTRSAIDAL)
           AND (CDEMPRESA    = P_EMPRESA)
           AND (CDINSCESTA   = RTRIM(P_INSCESTA))
           AND (CDGRUPOFISC IS NULL)
           AND ((CDPAISORIG  = P_PAISORIG) AND (SGESTAORIG  = P_ESTAORIG) OR V_UTUFORIG = w_N)
           AND ((CDPAISDEST  = P_PAISDEST) AND (SGESTADEST  = P_ESTADEST) OR V_UTUFDEST = w_N)
           AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
           AND ((VRINIFAIXA  < V_VRITEMPROD) AND (VRFIMFAIXA  >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
           AND (INSTR(NVL(P_CDTIPOOPER,'_'), NVL(RTRIM(CDTIPOOPER), NVL(P_CDTIPOOPER,'_'))) = 1  OR V_IDUTALIQTPOPER = w_N)
           AND (A.CDPRODUTO = P.CDPRODUTO(+))
           AND (INSTR(NVL(P_PRODUTO,'_'),NVL(RTRIM(P.CDARVPROD),NVL(P_PRODUTO,'_'))) = 1);
         IF NOT (V_CDTIPOOPER IS NULL) THEN /*Se possui alíquota por tipo de operação*/
            SELECT MAX(P.CDARVPROD)
              INTO V_CDARVPROD
              FROM ALIQUOTA A, PRODUTO P
             WHERE (CDIMPOSTO    = P_IMPOSTO)
               AND (IDENTRSAIDAL = P_ENTRSAIDAL)
               AND (CDEMPRESA    = P_EMPRESA)
               AND (CDINSCESTA   = RTRIM(P_INSCESTA))
               AND (CDGRUPOFISC IS NULL)
               AND ((CDPAISORIG  = P_PAISORIG) AND (SGESTAORIG  = P_ESTAORIG) OR V_UTUFORIG = w_N)
               AND ((CDPAISDEST  = P_PAISDEST) AND (SGESTADEST  = P_ESTADEST) OR V_UTUFDEST = w_N)
               AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
               AND ((VRINIFAIXA  < V_VRITEMPROD) AND (VRFIMFAIXA  >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
               AND (CDTIPOOPER = V_CDTIPOOPER OR V_IDUTALIQTPOPER = w_N)
               AND (A.CDPRODUTO = P.CDPRODUTO(+))
               AND (INSTR(NVL(P_PRODUTO,'_'),NVL(RTRIM(P.CDARVPROD),NVL(P_PRODUTO,'_'))) = 1);
         ELSIF (V_CDTIPOOPER IS NULL) THEN /*Se não possui alíquota por tipo de operação*/
            SELECT MAX(P.CDARVPROD)
              INTO V_CDARVPROD
              FROM ALIQUOTA A, PRODUTO P
             WHERE (CDIMPOSTO    = P_IMPOSTO)
               AND (IDENTRSAIDAL = P_ENTRSAIDAL)
               AND (CDEMPRESA    = P_EMPRESA)
               AND (CDINSCESTA   = RTRIM(P_INSCESTA))
               AND (CDGRUPOFISC IS NULL)
               AND ((CDPAISORIG  = P_PAISORIG) AND (SGESTAORIG  = P_ESTAORIG) OR V_UTUFORIG = w_N)
               AND ((CDPAISDEST  = P_PAISDEST) AND (SGESTADEST  = P_ESTADEST) OR V_UTUFDEST = w_N)
               AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
               AND ((VRINIFAIXA  < V_VRITEMPROD) AND (VRFIMFAIXA  >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
               AND (INSTR(NVL(P_CDTIPOOPER,'_'), NVL(RTRIM(CDTIPOOPER), NVL(P_CDTIPOOPER,'_'))) = 1  OR V_IDUTALIQTPOPER = w_N)
               AND (A.CDPRODUTO = P.CDPRODUTO(+))
               AND (INSTR(NVL(P_PRODUTO,'_'),NVL(RTRIM(P.CDARVPROD),NVL(P_PRODUTO,'_'))) = 1);
         END IF;
         IF NOT (V_CDARVPROD IS NULL) THEN /*Se há alíquota para o maior nivel*/
            IF NOT (V_CDTIPOOPER IS NULL) THEN /*Se possui alíquota por tipo de operação*/
               FOR C_ALIQUOTA IN (
                   SELECT A.NRALIQUOTA, VRPERREDBC, VR1PERREDBC, VRPARDEDUZ, VRALIQUOTA, DSMENSALIQU, IDTRATIMPST, VRPBCSUBTRIB, IDPMCBASECAL, A.CDTIPOOPER,
                          CDMENSAGEM, VRADICALIQFECP, CDBENEFFISCAL, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF
                     FROM ALIQUOTA A, MENSALIQU, PRODUTO P
                    WHERE (A.NRALIQUOTA = MENSALIQU.NRALIQUOTA(+))
                      AND (A.CDIMPOSTO = P_IMPOSTO)
                      AND (A.IDENTRSAIDAL = P_ENTRSAIDAL)
                      AND (A.CDEMPRESA = P_EMPRESA)
                      AND (A.CDINSCESTA = RTRIM(P_INSCESTA))
                      AND (A.CDGRUPOFISC IS NULL)
                      AND (A.CDPRODUTO = P.CDPRODUTO(+))
                      AND (P.CDARVPROD = V_CDARVPROD)
                      AND ((A.CDPAISORIG = P_PAISORIG)
                      AND (A.SGESTAORIG = P_ESTAORIG) OR V_UTUFORIG = w_N)
                      AND ((A.CDPAISDEST = P_PAISDEST)
                      AND (A.SGESTADEST = P_ESTADEST) OR V_UTUFDEST = w_N)
                      AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                      AND ((A.VRINIFAIXA < V_VRITEMPROD)
                      AND (A.VRFIMFAIXA >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                      AND (CDTIPOOPER = V_CDTIPOOPER)
                      AND (A.DTINIVALID = ( SELECT MAX(DTINIVALID)
                                              FROM ALIQUOTA A, PRODUTO P
                                             WHERE (CDIMPOSTO = P_IMPOSTO)
                                               AND (IDENTRSAIDAL = P_ENTRSAIDAL)
                                               AND (CDEMPRESA = P_EMPRESA)
                                               AND (CDINSCESTA = RTRIM(P_INSCESTA))
                                               AND (CDGRUPOFISC IS NULL)
                                               AND (A.CDPRODUTO = P.CDPRODUTO(+))
                                               AND (P.CDARVPROD = V_CDARVPROD)
                                               AND ((CDPAISORIG = P_PAISORIG)
                                               AND (SGESTAORIG = P_ESTAORIG) OR V_UTUFORIG = w_N)
                                               AND ((CDPAISDEST = P_PAISDEST)
                                               AND (SGESTADEST = P_ESTADEST) OR V_UTUFDEST = w_N)
                                               AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                                               AND ((VRINIFAIXA < V_VRITEMPROD)
                                               AND (VRFIMFAIXA >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                                               AND (CDTIPOOPER = V_CDTIPOOPER)
                                               AND (DTINIVALID <= P_INIVALID)))) LOOP
                  SELECT COUNT(*)
                    INTO V_COUNTMENS
                    FROM MENSAGEM
                   WHERE CDMENSAGEM = C_ALIQUOTA.CDMENSAGEM
                     AND IDSITUACAOMENS = 'I';
                  IF V_COUNTMENS > 0 THEN
                     V_DSMENSALIQU := NULL;
                  ELSE
                     V_DSMENSALIQU := C_ALIQUOTA.DSMENSALIQU;
                  END IF;
                  INSERT INTO ALIQTEMP
                    (NRALIQTEMP, NRSEQUALIQ, VRPREDBCTMP, VRPARDEDTMP,
                     VRALIQUTMP, DSMENSALITMP, IDTRIMPSTTMP, VRPBCSTTMP,
                     IDPMCBSCALTMP, CDTIPOOPERTMP, VR1PREDBCTMP, CDINSCESTAATMP,
                     VRADICALIQFECP, CDBENEFFISCAL, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF)
                  VALUES
                    (P_FILIAL||P_LANCTONF, V_SEQUENCIA, C_ALIQUOTA.VRPERREDBC, C_ALIQUOTA.VRPARDEDUZ,
                     C_ALIQUOTA.VRALIQUOTA, V_DSMENSALIQU, C_ALIQUOTA.IDTRATIMPST, C_ALIQUOTA.VRPBCSUBTRIB,
                     C_ALIQUOTA.IDPMCBASECAL, C_ALIQUOTA.CDTIPOOPER,C_ALIQUOTA.VR1PERREDBC, P_INSCESTA,
                     C_ALIQUOTA.VRADICALIQFECP, C_ALIQUOTA.CDBENEFFISCAL, C_ALIQUOTA.IDCONSDIFALIQ, C_ALIQUOTA.IDIMPODESONERA, C_ALIQUOTA.IDCONSDESONVRNF);
                  V_SEQUENCIA := LPAD(RTRIM(V_SEQUENCIA + '01'),2,0);
               END LOOP;
            ELSIF (V_CDTIPOOPER IS NULL) THEN /*Se não possui alíquota por tipo de operação*/
               FOR C_ALIQUOTA IN (
                   SELECT A.NRALIQUOTA, VRPERREDBC, VR1PERREDBC, VRPARDEDUZ, VRALIQUOTA, DSMENSALIQU, IDTRATIMPST, VRPBCSUBTRIB, IDPMCBASECAL,
                          CDMENSAGEM, VRADICALIQFECP, CDBENEFFISCAL, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF
                     FROM ALIQUOTA A, MENSALIQU, PRODUTO P
                    WHERE (A.NRALIQUOTA = MENSALIQU.NRALIQUOTA(+))
                      AND (A.CDIMPOSTO = P_IMPOSTO)
                      AND (A.IDENTRSAIDAL = P_ENTRSAIDAL)
                      AND (A.CDEMPRESA = P_EMPRESA)
                      AND (A.CDINSCESTA = RTRIM(P_INSCESTA))
                      AND (A.CDGRUPOFISC IS NULL)
                      AND (A.CDPRODUTO = P.CDPRODUTO(+))
                      AND (P.CDARVPROD = V_CDARVPROD)
                      AND ((A.CDPAISORIG = P_PAISORIG)
                      AND (A.SGESTAORIG = P_ESTAORIG) OR V_UTUFORIG = w_N)
                      AND ((A.CDPAISDEST = P_PAISDEST)
                      AND (A.SGESTADEST = P_ESTADEST) OR V_UTUFDEST = w_N)
                      AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                      AND ((A.VRINIFAIXA < V_VRITEMPROD)
                      AND (A.VRFIMFAIXA >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                      AND (INSTR(NVL(P_CDTIPOOPER,'_'), NVL(RTRIM(CDTIPOOPER), NVL(P_CDTIPOOPER,'_'))) = 1  OR V_IDUTALIQTPOPER = w_N)
                      AND (A.DTINIVALID = ( SELECT MAX(DTINIVALID)
                                              FROM ALIQUOTA A, PRODUTO P
                                             WHERE (CDIMPOSTO = P_IMPOSTO)
                                               AND (IDENTRSAIDAL = P_ENTRSAIDAL)
                                               AND (CDEMPRESA = P_EMPRESA)
                                               AND (CDINSCESTA = RTRIM(P_INSCESTA))
                                               AND (CDGRUPOFISC IS NULL)
                                               AND (A.CDPRODUTO = P.CDPRODUTO(+))
                                               AND (P.CDARVPROD = V_CDARVPROD)
                                               AND ((CDPAISORIG = P_PAISORIG)
                                               AND (SGESTAORIG = P_ESTAORIG) OR V_UTUFORIG = w_N)
                                               AND ((CDPAISDEST = P_PAISDEST)
                                               AND (SGESTADEST = P_ESTADEST) OR V_UTUFDEST = w_N)
                                               AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                                               AND ((VRINIFAIXA < V_VRITEMPROD)
                                               AND (VRFIMFAIXA >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                                               AND (INSTR(NVL(P_CDTIPOOPER,'_'), NVL(RTRIM(CDTIPOOPER), NVL(P_CDTIPOOPER,'_'))) = 1  OR V_IDUTALIQTPOPER = w_N)
                                               AND (DTINIVALID <= P_INIVALID)))) LOOP
                  SELECT COUNT(*)
                    INTO V_COUNTMENS
                    FROM MENSAGEM
                   WHERE CDMENSAGEM = C_ALIQUOTA.CDMENSAGEM
                     AND IDSITUACAOMENS = 'I';
                  IF V_COUNTMENS > 0 THEN
                     V_DSMENSALIQU := NULL;
                  ELSE
                     V_DSMENSALIQU := C_ALIQUOTA.DSMENSALIQU;
                  END IF;
                  INSERT INTO ALIQTEMP
                    (NRALIQTEMP, NRSEQUALIQ, VRPREDBCTMP, VRPARDEDTMP,
                     VRALIQUTMP, DSMENSALITMP, IDTRIMPSTTMP, VRPBCSTTMP,
                     IDPMCBSCALTMP, VR1PREDBCTMP, CDINSCESTAATMP, VRADICALIQFECP,
                     CDBENEFFISCAL, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF)
                  VALUES
                    (P_FILIAL||P_LANCTONF, V_SEQUENCIA, C_ALIQUOTA.VRPERREDBC, C_ALIQUOTA.VRPARDEDUZ,
                     C_ALIQUOTA.VRALIQUOTA, V_DSMENSALIQU, C_ALIQUOTA.IDTRATIMPST, C_ALIQUOTA.VRPBCSUBTRIB,
                     C_ALIQUOTA.IDPMCBASECAL,C_ALIQUOTA.VR1PERREDBC, P_INSCESTA, C_ALIQUOTA.VRADICALIQFECP, 
                     C_ALIQUOTA.CDBENEFFISCAL, C_ALIQUOTA.IDCONSDIFALIQ, C_ALIQUOTA.IDIMPODESONERA, C_ALIQUOTA.IDCONSDESONVRNF);
                  V_SEQUENCIA := LPAD(RTRIM(V_SEQUENCIA + '01'),2,0);
               END LOOP;
            END IF;
         ELSIF (V_CDARVPROD IS NULL) THEN /*Se há alíquota para todos*/
            IF NOT (V_CDTIPOOPER IS NULL) THEN /*Se há alíquota por tipo de operação*/
               FOR C_ALIQUOTA IN (
                  SELECT A.NRALIQUOTA, VRPERREDBC, VR1PERREDBC, VRPARDEDUZ, VRALIQUOTA, DSMENSALIQU, IDTRATIMPST, VRPBCSUBTRIB, IDPMCBASECAL, A.CDTIPOOPER,
                         CDMENSAGEM, VRADICALIQFECP, CDBENEFFISCAL, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF
                  FROM ALIQUOTA A, MENSALIQU
                  WHERE (A.NRALIQUOTA = MENSALIQU.NRALIQUOTA(+))
                    AND (A.CDIMPOSTO = P_IMPOSTO)
                    AND (A.IDENTRSAIDAL = P_ENTRSAIDAL)
                    AND (A.CDEMPRESA = P_EMPRESA)
                    AND (A.CDINSCESTA = RTRIM(P_INSCESTA))
                    AND (A.CDGRUPOFISC IS NULL)
                    AND (A.CDPRODUTO IS NULL)
                    AND ((A.CDPAISORIG = P_PAISORIG)
                    AND (A.SGESTAORIG = P_ESTAORIG) OR V_UTUFORIG = w_N)
                    AND ((A.CDPAISDEST = P_PAISDEST)
                    AND (A.SGESTADEST = P_ESTADEST) OR V_UTUFDEST = w_N)
                    AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                    AND ((A.VRINIFAIXA < V_VRITEMPROD)
                    AND (A.VRFIMFAIXA >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                    AND (CDTIPOOPER = V_CDTIPOOPER)
                    AND (A.DTINIVALID = ( SELECT MAX(DTINIVALID)
                                          FROM ALIQUOTA
                                          WHERE (CDIMPOSTO = P_IMPOSTO)
                                            AND (IDENTRSAIDAL = P_ENTRSAIDAL)
                                            AND (CDEMPRESA = P_EMPRESA)
                                            AND (CDINSCESTA = RTRIM(P_INSCESTA))
                                            AND (CDGRUPOFISC IS NULL)
                                            AND (CDPRODUTO IS NULL)
                                            AND ((CDPAISORIG = P_PAISORIG)
                                            AND (SGESTAORIG = P_ESTAORIG) OR V_UTUFORIG = w_N)
                                            AND ((CDPAISDEST = P_PAISDEST)
                                            AND (SGESTADEST = P_ESTADEST) OR V_UTUFDEST = w_N)
                                            AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                                            AND ((VRINIFAIXA < V_VRITEMPROD)
                                            AND (VRFIMFAIXA >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                                            AND (CDTIPOOPER = V_CDTIPOOPER)
                                            AND (DTINIVALID <= P_INIVALID)))) LOOP
                  SELECT COUNT(*)
                    INTO V_COUNTMENS
                    FROM MENSAGEM
                   WHERE CDMENSAGEM = C_ALIQUOTA.CDMENSAGEM
                     AND IDSITUACAOMENS = 'I';
                  IF V_COUNTMENS > 0 THEN
                     V_DSMENSALIQU := NULL;
                  ELSE
                     V_DSMENSALIQU := C_ALIQUOTA.DSMENSALIQU;
                  END IF;
                  INSERT INTO ALIQTEMP
                     (NRALIQTEMP, NRSEQUALIQ, VRPREDBCTMP, VRPARDEDTMP,
                      VRALIQUTMP, DSMENSALITMP, IDTRIMPSTTMP, VRPBCSTTMP,
                      IDPMCBSCALTMP, CDTIPOOPERTMP, VR1PREDBCTMP, CDINSCESTAATMP,
                      VRADICALIQFECP, CDBENEFFISCAL, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF)
                  VALUES
                     (P_FILIAL||P_LANCTONF, V_SEQUENCIA, C_ALIQUOTA.VRPERREDBC, C_ALIQUOTA.VRPARDEDUZ,
                      C_ALIQUOTA.VRALIQUOTA, V_DSMENSALIQU, C_ALIQUOTA.IDTRATIMPST, C_ALIQUOTA.VRPBCSUBTRIB,
                      C_ALIQUOTA.IDPMCBASECAL, C_ALIQUOTA.CDTIPOOPER,C_ALIQUOTA.VR1PERREDBC, P_INSCESTA,
                      C_ALIQUOTA.VRADICALIQFECP, C_ALIQUOTA.CDBENEFFISCAL, C_ALIQUOTA.IDCONSDIFALIQ, C_ALIQUOTA.IDIMPODESONERA, C_ALIQUOTA.IDCONSDESONVRNF);
                  V_SEQUENCIA := LPAD(RTRIM(V_SEQUENCIA + '01'),2,0);
               END LOOP;
            ELSIF (V_CDTIPOOPER IS NULL) THEN /*Se não possui alíquota por tipo de operação*/
               FOR C_ALIQUOTA IN (
                  SELECT A.NRALIQUOTA, VRPERREDBC, VR1PERREDBC, VRPARDEDUZ, VRALIQUOTA, DSMENSALIQU, IDTRATIMPST, VRPBCSUBTRIB, IDPMCBASECAL,
                         CDMENSAGEM, VRADICALIQFECP, CDBENEFFISCAL, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF
                  FROM ALIQUOTA A, MENSALIQU
                  WHERE (A.NRALIQUOTA = MENSALIQU.NRALIQUOTA(+))
                    AND (A.CDIMPOSTO = P_IMPOSTO)
                    AND (A.IDENTRSAIDAL = P_ENTRSAIDAL)
                    AND (A.CDEMPRESA = P_EMPRESA)
                    AND (A.CDINSCESTA = RTRIM(P_INSCESTA))
                    AND (A.CDGRUPOFISC IS NULL)
                    AND (A.CDPRODUTO IS NULL)
                    AND ((A.CDPAISORIG = P_PAISORIG)
                    AND (A.SGESTAORIG = P_ESTAORIG) OR V_UTUFORIG = w_N)
                    AND ((A.CDPAISDEST = P_PAISDEST)
                    AND (A.SGESTADEST = P_ESTADEST) OR V_UTUFDEST = w_N)
                    AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                    AND ((A.VRINIFAIXA < V_VRITEMPROD)
                    AND (A.VRFIMFAIXA >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                    AND (INSTR(NVL(P_CDTIPOOPER,'_'), NVL(RTRIM(CDTIPOOPER), NVL(P_CDTIPOOPER,'_'))) = 1  OR V_IDUTALIQTPOPER = w_N)
                    AND (A.DTINIVALID = ( SELECT MAX(DTINIVALID)
                                          FROM ALIQUOTA
                                          WHERE (CDIMPOSTO = P_IMPOSTO)
                                            AND (IDENTRSAIDAL = P_ENTRSAIDAL)
                                            AND (CDEMPRESA = P_EMPRESA)
                                            AND (CDINSCESTA = RTRIM(P_INSCESTA))
                                            AND (CDGRUPOFISC IS NULL)
                                            AND (CDPRODUTO IS NULL)
                                            AND ((CDPAISORIG = P_PAISORIG)
                                            AND (SGESTAORIG = P_ESTAORIG) OR V_UTUFORIG = w_N)
                                            AND ((CDPAISDEST = P_PAISDEST)
                                            AND (SGESTADEST = P_ESTADEST) OR V_UTUFDEST = w_N)
                                            AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                                            AND ((VRINIFAIXA < V_VRITEMPROD)
                                            AND (VRFIMFAIXA >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                                            AND (INSTR(NVL(P_CDTIPOOPER,'_'), NVL(RTRIM(CDTIPOOPER), NVL(P_CDTIPOOPER,'_'))) = 1  OR V_IDUTALIQTPOPER = w_N)
                                            AND (DTINIVALID <= P_INIVALID)))) LOOP
                  SELECT COUNT(*)
                    INTO V_COUNTMENS
                    FROM MENSAGEM
                   WHERE CDMENSAGEM = C_ALIQUOTA.CDMENSAGEM
                     AND IDSITUACAOMENS = 'I';
                  IF V_COUNTMENS > 0 THEN
                     V_DSMENSALIQU := NULL;
                  ELSE
                     V_DSMENSALIQU := C_ALIQUOTA.DSMENSALIQU;
                  END IF;
                  INSERT INTO ALIQTEMP
                     (NRALIQTEMP, NRSEQUALIQ, VRPREDBCTMP, VRPARDEDTMP,
                      VRALIQUTMP, DSMENSALITMP, IDTRIMPSTTMP, VRPBCSTTMP,
                      IDPMCBSCALTMP, VR1PREDBCTMP, CDINSCESTAATMP, VRADICALIQFECP,
                      CDBENEFFISCAL, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF)
                  VALUES
                     (P_FILIAL||P_LANCTONF, V_SEQUENCIA, C_ALIQUOTA.VRPERREDBC, C_ALIQUOTA.VRPARDEDUZ,
                      C_ALIQUOTA.VRALIQUOTA, V_DSMENSALIQU, C_ALIQUOTA.IDTRATIMPST, C_ALIQUOTA.VRPBCSUBTRIB,
                      C_ALIQUOTA.IDPMCBASECAL, C_ALIQUOTA.VR1PERREDBC, P_INSCESTA, C_ALIQUOTA.VRADICALIQFECP, 
                      C_ALIQUOTA.CDBENEFFISCAL, C_ALIQUOTA.IDCONSDIFALIQ, C_ALIQUOTA.IDIMPODESONERA, C_ALIQUOTA.IDCONSDESONVRNF);
                  V_SEQUENCIA := LPAD(RTRIM(V_SEQUENCIA + '01'),2,0);
               END LOOP;
            END IF;
         END IF;
      END IF;
      /* Verificação das aliquotas referente as filiais parametrizadas na tela Parâmetros de Grupo Fiscal (Imposto/Filial) */
      V_CDGRUPOFISC := NULL;
      BEGIN
         SELECT MAX(G.CDGRUPOFISC)
           INTO V_CDGRUPOFISC
           FROM GRUPOFISCIMPFIL G, (SELECT DECODE(P_ENTRSAIDAL, 'E', CDFILIRECE, CDFILIEMIT) AS CDFILIAL
                                      FROM NOTAFISCAL
                                     WHERE CDFILIAL = P_FILIAL
                                       AND NRLANCTONF = P_LANCTONF
                                       AND P_IDSISTEMA IS NULL
                                       AND P_CDFILIRECE IS NULL
                                    UNION ALL
                                    SELECT CDFILIAL
                                      FROM PEDIDO
                                     WHERE CDFILIAL = SUBSTR(P_FILIAL,1,4)
                                       AND NRPEDIDO = SUBSTR(P_FILIAL,5,10)
                                       AND P_IDSISTEMA = 'PED'
                                     UNION ALL
                                    SELECT CDFILIAL
                                      FROM FILIAL
                                     WHERE CDFILIAL = P_CDFILIRECE) F
          WHERE G.CDIMPOSTO = P_IMPOSTO
            AND G.CDFILIAL = F.CDFILIAL;
      EXCEPTION
         WHEN No_Data_Found THEN
            V_CDGRUPOFISC := NULL;
      END;
      IF NOT (V_CDGRUPOFISC IS NULL) THEN /*Se há grupo fiscal na tela Parâmetros de Grupo Fiscal na aba Imposto/Filial*/
         IF V_IDPRODNOTA = w_P THEN /*Se imposto do item*/
            SELECT MAX(CDTIPOOPER), COUNT(*)
              INTO V_CDTIPOOPER, V_CONTADOR
              FROM ALIQUOTA A, PRODUTO P
             WHERE (CDIMPOSTO    = P_IMPOSTO)
               AND (IDENTRSAIDAL = P_ENTRSAIDAL)
               AND (CDEMPRESA    = P_EMPRESA)
               AND (CDINSCESTA   = RTRIM(P_INSCESTA))
               AND (CDGRUPOFISC  = V_CDGRUPOFISC)
               AND ((CDPAISORIG  = P_PAISORIG) AND (SGESTAORIG  = P_ESTAORIG) OR V_UTUFORIG = w_N)
               AND ((CDPAISDEST  = P_PAISDEST) AND (SGESTADEST  = P_ESTADEST) OR V_UTUFDEST = w_N)
               AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
               AND ((VRINIFAIXA  < V_VRITEMPROD) AND (VRFIMFAIXA  >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
               AND (INSTR(NVL(P_CDTIPOOPER,'_'), NVL(RTRIM(CDTIPOOPER), NVL(P_CDTIPOOPER,'_'))) = 1  OR V_IDUTALIQTPOPER = w_N)
               AND (A.CDPRODUTO = P.CDPRODUTO(+))
               AND (INSTR(NVL(P_PRODUTO,'_'),NVL(RTRIM(P.CDARVPROD),NVL(P_PRODUTO,'_'))) = 1);
            IF NOT (V_CDTIPOOPER IS NULL) THEN /*Se possui alíquota por tipo de operação*/
               SELECT MAX(P.CDARVPROD)
                 INTO V_CDARVPROD
                 FROM ALIQUOTA A, PRODUTO P
                WHERE (CDIMPOSTO    = P_IMPOSTO)
                  AND (IDENTRSAIDAL = P_ENTRSAIDAL)
                  AND (CDEMPRESA    = P_EMPRESA)
                  AND (CDINSCESTA   = RTRIM(P_INSCESTA))
                  AND (CDGRUPOFISC  = V_CDGRUPOFISC)
                  AND ((CDPAISORIG  = P_PAISORIG) AND (SGESTAORIG  = P_ESTAORIG) OR V_UTUFORIG = w_N)
                  AND ((CDPAISDEST  = P_PAISDEST) AND (SGESTADEST  = P_ESTADEST) OR V_UTUFDEST = w_N)
                  AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                  AND ((VRINIFAIXA  < V_VRITEMPROD) AND (VRFIMFAIXA  >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                  AND (CDTIPOOPER = V_CDTIPOOPER OR V_IDUTALIQTPOPER = w_N)
                  AND (A.CDPRODUTO = P.CDPRODUTO(+))
                  AND (INSTR(NVL(P_PRODUTO,'_'),NVL(RTRIM(P.CDARVPROD),NVL(P_PRODUTO,'_'))) = 1);
            ELSIF (V_CDTIPOOPER IS NULL) THEN /*Se não possui alíquota por tipo de operação*/
               SELECT MAX(P.CDARVPROD)
               INTO V_CDARVPROD
               FROM ALIQUOTA A, PRODUTO P
               WHERE (CDIMPOSTO    = P_IMPOSTO)
                 AND (IDENTRSAIDAL = P_ENTRSAIDAL)
                 AND (CDEMPRESA    = P_EMPRESA)
                 AND (CDINSCESTA   = RTRIM(P_INSCESTA))
                 AND (CDGRUPOFISC  = V_CDGRUPOFISC)
                 AND ((CDPAISORIG  = P_PAISORIG) AND (SGESTAORIG  = P_ESTAORIG) OR V_UTUFORIG = w_N)
                 AND ((CDPAISDEST  = P_PAISDEST) AND (SGESTADEST  = P_ESTADEST) OR V_UTUFDEST = w_N)
                 AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                 AND ((VRINIFAIXA  < V_VRITEMPROD) AND (VRFIMFAIXA  >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                 AND (INSTR(NVL(P_CDTIPOOPER,'_'), NVL(RTRIM(CDTIPOOPER), NVL(P_CDTIPOOPER,'_'))) = 1  OR V_IDUTALIQTPOPER = w_N)
                 AND (A.CDPRODUTO = P.CDPRODUTO(+))
                 AND (INSTR(NVL(P_PRODUTO,'_'),NVL(RTRIM(P.CDARVPROD),NVL(P_PRODUTO,'_'))) = 1);
            END IF;
         ELSE /*Se imposto da nota*/
            SELECT MAX(A.CDPRODUTO), COUNT(*), MAX(CDTIPOOPER)
            INTO V_CDARVPROD, V_CONTADOR, V_CDTIPOOPER
            FROM ALIQUOTA A
            WHERE (CDIMPOSTO    = P_IMPOSTO)
              AND (IDENTRSAIDAL = P_ENTRSAIDAL)
              AND (CDEMPRESA    = P_EMPRESA)
              AND (CDINSCESTA   = RTRIM(P_INSCESTA))
              AND (CDGRUPOFISC  = V_CDGRUPOFISC)
              AND ((CDPAISORIG  = P_PAISORIG) AND (SGESTAORIG  = P_ESTAORIG) OR V_UTUFORIG = w_N)
              AND ((CDPAISDEST  = P_PAISDEST) AND (SGESTADEST  = P_ESTADEST) OR V_UTUFDEST = w_N)
              AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
              AND ((VRINIFAIXA  < V_VRITEMPROD) AND (VRFIMFAIXA  >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
              AND (INSTR(NVL(P_CDTIPOOPER,'_'), NVL(RTRIM(CDTIPOOPER), NVL(P_CDTIPOOPER,'_'))) = 1  OR V_IDUTALIQTPOPER = w_N)
              AND (A.CDPRODUTO IS NULL);
         END IF;
         IF NOT (V_CDTIPOOPER IS NULL) THEN /*Se possui alíquota por tipo de operação*/
            IF NOT (V_CDARVPROD IS NULL) THEN /*Se há alíquota para o maior nivel*/
               FOR C_ALIQUOTA IN (
                    SELECT A.NRALIQUOTA, VRPERREDBC, VR1PERREDBC, VRPARDEDUZ, VRALIQUOTA, DSMENSALIQU, IDTRATIMPST, VRPBCSUBTRIB, IDPMCBASECAL, CDTIPOOPER,
                           CDMENSAGEM, VRADICALIQFECP, CDBENEFFISCAL, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF
                      FROM ALIQUOTA A, MENSALIQU M, PRODUTO P
                     WHERE (A.NRALIQUOTA = M.NRALIQUOTA(+))
                       AND (A.CDIMPOSTO = P_IMPOSTO)
                       AND (A.IDENTRSAIDAL = P_ENTRSAIDAL)
                       AND (A.CDEMPRESA = P_EMPRESA)
                       AND (A.CDINSCESTA = RTRIM(P_INSCESTA))
                       AND (A.CDGRUPOFISC = V_CDGRUPOFISC)
                       AND (A.CDPRODUTO = P.CDPRODUTO(+))
                       AND (P.CDARVPROD = V_CDARVPROD)
                       AND ((A.CDPAISORIG = P_PAISORIG)
                       AND (A.SGESTAORIG = P_ESTAORIG) OR V_UTUFORIG = w_N)
                       AND ((A.CDPAISDEST = P_PAISDEST)
                       AND (A.SGESTADEST = P_ESTADEST) OR V_UTUFDEST = w_N)
                       AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                       AND ((A.VRINIFAIXA < V_VRITEMPROD)
                       AND (A.VRFIMFAIXA >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                       AND (CDTIPOOPER = V_CDTIPOOPER)
                       AND (A.DTINIVALID = (SELECT MAX(DTINIVALID)
                                              FROM ALIQUOTA A, PRODUTO P
                                             WHERE (CDIMPOSTO = P_IMPOSTO)
                                               AND (IDENTRSAIDAL = P_ENTRSAIDAL)
                                               AND (CDEMPRESA = P_EMPRESA)
                                               AND (CDINSCESTA = RTRIM(P_INSCESTA))
                                               AND (A.CDGRUPOFISC = V_CDGRUPOFISC)
                                               AND (A.CDPRODUTO = P.CDPRODUTO(+))
                                               AND (P.CDARVPROD = V_CDARVPROD)
                                               AND ((CDPAISORIG = P_PAISORIG)
                                               AND (SGESTAORIG = P_ESTAORIG) OR V_UTUFORIG = w_N)
                                               AND ((CDPAISDEST = P_PAISDEST)
                                               AND (SGESTADEST = P_ESTADEST) OR V_UTUFDEST = w_N)
                                               AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                                               AND ((VRINIFAIXA < V_VRITEMPROD)
                                               AND (VRFIMFAIXA >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                                               AND (CDTIPOOPER = V_CDTIPOOPER)
                                               AND (DTINIVALID <= P_INIVALID)))) LOOP
                  SELECT COUNT(*)
                    INTO V_COUNTMENS
                    FROM MENSAGEM
                   WHERE CDMENSAGEM = C_ALIQUOTA.CDMENSAGEM
                     AND IDSITUACAOMENS = 'I';
                  IF V_COUNTMENS > 0 THEN
                     V_DSMENSALIQU := NULL;
                  ELSE
                     V_DSMENSALIQU := C_ALIQUOTA.DSMENSALIQU;
                  END IF;
                  INSERT INTO ALIQTEMP
                     (NRALIQTEMP, NRSEQUALIQ, VRPREDBCTMP, VRPARDEDTMP,
                      VRALIQUTMP, DSMENSALITMP, IDTRIMPSTTMP, VRPBCSTTMP,
                      IDPMCBSCALTMP, CDTIPOOPERTMP, VR1PREDBCTMP, CDINSCESTAATMP,
                      VRADICALIQFECP, CDBENEFFISCAL, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF)
                  VALUES
                     (P_FILIAL||P_LANCTONF, V_SEQUENCIA, C_ALIQUOTA.VRPERREDBC, C_ALIQUOTA.VRPARDEDUZ,
                      C_ALIQUOTA.VRALIQUOTA, V_DSMENSALIQU, C_ALIQUOTA.IDTRATIMPST, C_ALIQUOTA.VRPBCSUBTRIB,
                      C_ALIQUOTA.IDPMCBASECAL, C_ALIQUOTA.CDTIPOOPER, C_ALIQUOTA.VR1PERREDBC, P_INSCESTA,
                      C_ALIQUOTA.VRADICALIQFECP, C_ALIQUOTA.CDBENEFFISCAL, C_ALIQUOTA.IDCONSDIFALIQ, C_ALIQUOTA.IDIMPODESONERA, C_ALIQUOTA.IDCONSDESONVRNF);
                  V_SEQUENCIA := LPAD(RTRIM(V_SEQUENCIA + '01'),2,0);
               END LOOP;
            ELSIF (V_CDARVPROD IS NULL) THEN /*Se há alíquota para o produto todos*/
               FOR C_ALIQUOTA IN (
                    SELECT A.NRALIQUOTA, VRPERREDBC, VR1PERREDBC, VRPARDEDUZ, VRALIQUOTA, DSMENSALIQU, IDTRATIMPST, VRPBCSUBTRIB, IDPMCBASECAL, A.CDTIPOOPER,
                           CDMENSAGEM, VRADICALIQFECP, CDBENEFFISCAL, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF
                      FROM ALIQUOTA A, MENSALIQU M
                     WHERE (A.NRALIQUOTA = M.NRALIQUOTA(+))
                       AND (A.CDIMPOSTO = P_IMPOSTO)
                       AND (A.IDENTRSAIDAL = P_ENTRSAIDAL)
                       AND (A.CDEMPRESA = P_EMPRESA)
                       AND (A.CDINSCESTA = RTRIM(P_INSCESTA))
                       AND (A.CDGRUPOFISC = V_CDGRUPOFISC)
                       AND (A.CDPRODUTO IS NULL)
                       AND ((A.CDPAISORIG = P_PAISORIG)
                       AND (A.SGESTAORIG = P_ESTAORIG) OR V_UTUFORIG = w_N)
                       AND ((A.CDPAISDEST = P_PAISDEST)
                       AND (A.SGESTADEST = P_ESTADEST) OR V_UTUFDEST = w_N)
                       AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                       AND ((A.VRINIFAIXA < V_VRITEMPROD)
                       AND (A.VRFIMFAIXA >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                       AND (CDTIPOOPER = V_CDTIPOOPER)
                       AND (A.DTINIVALID = (SELECT MAX(DTINIVALID)
                                              FROM ALIQUOTA
                                             WHERE (CDIMPOSTO = P_IMPOSTO)
                                               AND (IDENTRSAIDAL = P_ENTRSAIDAL)
                                               AND (CDEMPRESA = P_EMPRESA)
                                               AND (CDINSCESTA = RTRIM(P_INSCESTA))
                                               AND (A.CDGRUPOFISC = V_CDGRUPOFISC)
                                               AND (CDPRODUTO IS NULL)
                                               AND ((CDPAISORIG = P_PAISORIG)
                                               AND (SGESTAORIG = P_ESTAORIG) OR V_UTUFORIG = w_N)
                                               AND ((CDPAISDEST = P_PAISDEST)
                                               AND (SGESTADEST = P_ESTADEST) OR V_UTUFDEST = w_N)
                                               AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                                               AND ((VRINIFAIXA < V_VRITEMPROD)
                                               AND (VRFIMFAIXA >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                                               AND (CDTIPOOPER = V_CDTIPOOPER)
                                               AND (DTINIVALID <= P_INIVALID)))) LOOP
                  SELECT COUNT(*)
                    INTO V_COUNTMENS
                    FROM MENSAGEM
                   WHERE CDMENSAGEM = C_ALIQUOTA.CDMENSAGEM
                     AND IDSITUACAOMENS = 'I';
                  IF V_COUNTMENS > 0 THEN
                     V_DSMENSALIQU := NULL;
                  ELSE
                     V_DSMENSALIQU := C_ALIQUOTA.DSMENSALIQU;
                  END IF;
                  INSERT INTO ALIQTEMP
                     (NRALIQTEMP, NRSEQUALIQ, VRPREDBCTMP, VRPARDEDTMP,
                      VRALIQUTMP, DSMENSALITMP, IDTRIMPSTTMP, VRPBCSTTMP,
                       IDPMCBSCALTMP, CDTIPOOPERTMP, VR1PREDBCTMP, CDINSCESTAATMP,
                       VRADICALIQFECP, CDBENEFFISCAL, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF)
                  VALUES
                     (P_FILIAL||P_LANCTONF, V_SEQUENCIA, C_ALIQUOTA.VRPERREDBC, C_ALIQUOTA.VRPARDEDUZ,
                      C_ALIQUOTA.VRALIQUOTA, V_DSMENSALIQU, C_ALIQUOTA.IDTRATIMPST, C_ALIQUOTA.VRPBCSUBTRIB,
                      C_ALIQUOTA.IDPMCBASECAL, C_ALIQUOTA.CDTIPOOPER, C_ALIQUOTA.VR1PERREDBC, P_INSCESTA,
                      C_ALIQUOTA.VRADICALIQFECP, C_ALIQUOTA.CDBENEFFISCAL, C_ALIQUOTA.IDCONSDIFALIQ, C_ALIQUOTA.IDIMPODESONERA, C_ALIQUOTA.IDCONSDESONVRNF);
                  V_SEQUENCIA := LPAD(RTRIM(V_SEQUENCIA + '01'),2,0);
               END LOOP;
            END IF;
         ELSIF (V_CDTIPOOPER IS NULL) THEN /*Se não possui alíquota por tipo de operação*/
            IF NOT (V_CDARVPROD IS NULL) THEN /*Se há alíquota para o maior nivel*/
               FOR C_ALIQUOTA IN (
                    SELECT A.NRALIQUOTA, VRPERREDBC, VR1PERREDBC, VRPARDEDUZ, VRALIQUOTA, DSMENSALIQU, IDTRATIMPST, VRPBCSUBTRIB, IDPMCBASECAL, CDMENSAGEM,
                           VRADICALIQFECP, CDBENEFFISCAL, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF
                      FROM ALIQUOTA A, MENSALIQU M, PRODUTO P
                     WHERE (A.NRALIQUOTA = M.NRALIQUOTA(+))
                       AND (A.CDIMPOSTO = P_IMPOSTO)
                       AND (A.IDENTRSAIDAL = P_ENTRSAIDAL)
                       AND (A.CDEMPRESA = P_EMPRESA)
                       AND (A.CDINSCESTA = RTRIM(P_INSCESTA))
                       AND (A.CDGRUPOFISC = V_CDGRUPOFISC)
                       AND (A.CDPRODUTO = P.CDPRODUTO(+))
                       AND (P.CDARVPROD = V_CDARVPROD)
                       AND ((A.CDPAISORIG = P_PAISORIG)
                       AND (A.SGESTAORIG = P_ESTAORIG) OR V_UTUFORIG = w_N)
                       AND ((A.CDPAISDEST = P_PAISDEST)
                       AND (A.SGESTADEST = P_ESTADEST) OR V_UTUFDEST = w_N)
                       AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                       AND ((A.VRINIFAIXA < V_VRITEMPROD)
                       AND (A.VRFIMFAIXA >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                       AND (INSTR(NVL(P_CDTIPOOPER,'_'), NVL(RTRIM(CDTIPOOPER), NVL(P_CDTIPOOPER,'_'))) = 1  OR V_IDUTALIQTPOPER = w_N)
                       AND (A.DTINIVALID = (SELECT MAX(DTINIVALID)
                                              FROM ALIQUOTA A, PRODUTO P
                                             WHERE (CDIMPOSTO = P_IMPOSTO)
                                               AND (IDENTRSAIDAL = P_ENTRSAIDAL)
                                               AND (CDEMPRESA = P_EMPRESA)
                                               AND (CDINSCESTA = RTRIM(P_INSCESTA))
                                               AND (A.CDGRUPOFISC = V_CDGRUPOFISC)
                                               AND (A.CDPRODUTO = P.CDPRODUTO(+))
                                               AND (P.CDARVPROD = V_CDARVPROD)
                                               AND ((CDPAISORIG = P_PAISORIG)
                                               AND (SGESTAORIG = P_ESTAORIG) OR V_UTUFORIG = w_N)
                                               AND ((CDPAISDEST = P_PAISDEST)
                                               AND (SGESTADEST = P_ESTADEST) OR V_UTUFDEST = w_N)
                                               AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                                               AND ((VRINIFAIXA < V_VRITEMPROD)
                                               AND (VRFIMFAIXA >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                                               AND (INSTR(NVL(P_CDTIPOOPER,'_'), NVL(RTRIM(CDTIPOOPER), NVL(P_CDTIPOOPER,'_'))) = 1  OR V_IDUTALIQTPOPER = w_N)
                                               AND (DTINIVALID <= P_INIVALID)))) LOOP
                  SELECT COUNT(*)
                    INTO V_EXISTE
                    FROM ALIQTEMP
                   WHERE NRALIQTEMP = P_FILIAL||P_LANCTONF;
                  IF V_EXISTE > 0 THEN
                     DELETE FROM ALIQTEMP
                     WHERE NRALIQTEMP = P_FILIAL||P_LANCTONF;
                  END IF;
                  SELECT COUNT(*)
                    INTO V_COUNTMENS
                    FROM MENSAGEM
                   WHERE CDMENSAGEM = C_ALIQUOTA.CDMENSAGEM
                     AND IDSITUACAOMENS = 'I';
                  IF V_COUNTMENS > 0 THEN
                     V_DSMENSALIQU := NULL;
                  ELSE
                     V_DSMENSALIQU := C_ALIQUOTA.DSMENSALIQU;
                  END IF;
                  INSERT INTO ALIQTEMP
                     (NRALIQTEMP, NRSEQUALIQ, VRPREDBCTMP, VRPARDEDTMP,
                      VRALIQUTMP, DSMENSALITMP, IDTRIMPSTTMP, VRPBCSTTMP,
                      IDPMCBSCALTMP, VR1PREDBCTMP, CDINSCESTAATMP, VRADICALIQFECP,
                      CDBENEFFISCAL, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF)
                  VALUES
                     (P_FILIAL||P_LANCTONF, V_SEQUENCIA, C_ALIQUOTA.VRPERREDBC, C_ALIQUOTA.VRPARDEDUZ,
                      C_ALIQUOTA.VRALIQUOTA, V_DSMENSALIQU, C_ALIQUOTA.IDTRATIMPST, C_ALIQUOTA.VRPBCSUBTRIB,
                      C_ALIQUOTA.IDPMCBASECAL, C_ALIQUOTA.VR1PERREDBC, P_INSCESTA, C_ALIQUOTA.VRADICALIQFECP, 
                      C_ALIQUOTA.CDBENEFFISCAL, C_ALIQUOTA.IDCONSDIFALIQ, C_ALIQUOTA.IDIMPODESONERA, C_ALIQUOTA.IDCONSDESONVRNF);
                  V_SEQUENCIA := LPAD(RTRIM(V_SEQUENCIA + '01'),2,0);
               END LOOP;
            ELSIF (V_CDARVPROD IS NULL) THEN /*Se há alíquota para o produto todos*/
               FOR C_ALIQUOTA IN (
                    SELECT A.NRALIQUOTA, VRPERREDBC, VR1PERREDBC, VRPARDEDUZ, VRALIQUOTA, DSMENSALIQU, IDTRATIMPST, VRPBCSUBTRIB, IDPMCBASECAL, CDMENSAGEM,
                           VRADICALIQFECP, CDBENEFFISCAL, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF
                      FROM ALIQUOTA A, MENSALIQU M
                     WHERE (A.NRALIQUOTA = M.NRALIQUOTA(+))
                       AND (A.CDIMPOSTO = P_IMPOSTO)
                       AND (A.IDENTRSAIDAL = P_ENTRSAIDAL)
                       AND (A.CDEMPRESA = P_EMPRESA)
                       AND (A.CDINSCESTA = RTRIM(P_INSCESTA))
                       AND (A.CDGRUPOFISC = V_CDGRUPOFISC)
                       AND (A.CDPRODUTO IS NULL)
                       AND ((A.CDPAISORIG = P_PAISORIG)
                       AND (A.SGESTAORIG = P_ESTAORIG) OR V_UTUFORIG = w_N)
                       AND ((A.CDPAISDEST = P_PAISDEST)
                       AND (A.SGESTADEST = P_ESTADEST) OR V_UTUFDEST = w_N)
                       AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                       AND ((A.VRINIFAIXA < V_VRITEMPROD)
                       AND (A.VRFIMFAIXA >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                       AND (INSTR(NVL(P_CDTIPOOPER,'_'), NVL(RTRIM(CDTIPOOPER), NVL(P_CDTIPOOPER,'_'))) = 1  OR V_IDUTALIQTPOPER = w_N)
                       AND (A.DTINIVALID = (SELECT MAX(DTINIVALID)
                                              FROM ALIQUOTA
                                             WHERE (CDIMPOSTO = P_IMPOSTO)
                                               AND (IDENTRSAIDAL = P_ENTRSAIDAL)
                                               AND (CDEMPRESA = P_EMPRESA)
                                               AND (CDINSCESTA = RTRIM(P_INSCESTA))
                                               AND (A.CDGRUPOFISC = V_CDGRUPOFISC)
                                               AND (CDPRODUTO IS NULL)
                                               AND ((CDPAISORIG = P_PAISORIG)
                                               AND (SGESTAORIG = P_ESTAORIG) OR V_UTUFORIG = w_N)
                                               AND ((CDPAISDEST = P_PAISDEST)
                                               AND (SGESTADEST = P_ESTADEST) OR V_UTUFDEST = w_N)
                                               AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                                               AND ((VRINIFAIXA < V_VRITEMPROD)
                                               AND (VRFIMFAIXA >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                                               AND (INSTR(NVL(P_CDTIPOOPER,'_'), NVL(RTRIM(CDTIPOOPER), NVL(P_CDTIPOOPER,'_'))) = 1  OR V_IDUTALIQTPOPER = w_N)
                                               AND (DTINIVALID <= P_INIVALID)))) LOOP
                  SELECT COUNT(*)
                    INTO V_EXISTE
                    FROM ALIQTEMP
                   WHERE NRALIQTEMP = P_FILIAL||P_LANCTONF;
                  IF V_EXISTE > 0 THEN
                     DELETE FROM ALIQTEMP
                     WHERE NRALIQTEMP = P_FILIAL||P_LANCTONF;
                  END IF;
                  SELECT COUNT(*)
                    INTO V_COUNTMENS
                    FROM MENSAGEM
                   WHERE CDMENSAGEM = C_ALIQUOTA.CDMENSAGEM
                     AND IDSITUACAOMENS = 'I';
                  IF V_COUNTMENS > 0 THEN
                     V_DSMENSALIQU := NULL;
                  ELSE
                     V_DSMENSALIQU := C_ALIQUOTA.DSMENSALIQU;
                  END IF;
                  INSERT INTO ALIQTEMP
                     (NRALIQTEMP, NRSEQUALIQ, VRPREDBCTMP, VRPARDEDTMP,
                      VRALIQUTMP, DSMENSALITMP, IDTRIMPSTTMP, VRPBCSTTMP,
                      IDPMCBSCALTMP, VR1PREDBCTMP, CDINSCESTAATMP, VRADICALIQFECP,
                      CDBENEFFISCAL, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF)
                  VALUES
                     (P_FILIAL||P_LANCTONF, V_SEQUENCIA, C_ALIQUOTA.VRPERREDBC, C_ALIQUOTA.VRPARDEDUZ,
                      C_ALIQUOTA.VRALIQUOTA, V_DSMENSALIQU, C_ALIQUOTA.IDTRATIMPST, C_ALIQUOTA.VRPBCSUBTRIB,
                      C_ALIQUOTA.IDPMCBASECAL, C_ALIQUOTA.VR1PERREDBC, P_INSCESTA, C_ALIQUOTA.VRADICALIQFECP, 
                      C_ALIQUOTA.CDBENEFFISCAL, C_ALIQUOTA.IDCONSDIFALIQ, C_ALIQUOTA.IDIMPODESONERA, C_ALIQUOTA.IDCONSDESONVRNF);
                  V_SEQUENCIA := LPAD(RTRIM(V_SEQUENCIA + '01'),2,0);
               END LOOP;
            END IF;
         END IF;
      END IF;
   ----------------------
   /* Verificação das aliquotas referente as filiais parametrizadas na tela Parâmetros de Grupo Fiscal (Imposto/Inscrição Estadual) */
      /*Por Fornecedor*/
      V_CDGRUPOFISC := NULL;
      BEGIN
         SELECT MAX(G.CDGRUPOFISC)
           INTO V_CDGRUPOFISC
           FROM GRFISIMPIEFORN G, (SELECT CDFORNECED
                                     FROM NOTAFISCAL
                                    WHERE CDFILIAL = P_FILIAL
                                      AND NRLANCTONF = P_LANCTONF
                                      AND P_CDFORNECED IS NULL
                                    UNION ALL
                                   SELECT CDFORNECED
                                     FROM FORNECEDOR
                                    WHERE CDFORNECED = P_CDFORNECED) F
          WHERE G.CDIMPOSTO = P_IMPOSTO
            AND G.CDFORNECED = F.CDFORNECED
            AND G.CDEMPRESA = P_EMPRESA
            AND G.CDINSCESTA = P_INSCESTA;
      EXCEPTION
         WHEN No_Data_Found THEN
            V_CDGRUPOFISC := NULL;
      END;
      IF NOT (V_CDGRUPOFISC IS NULL) THEN /*Se há grupo fiscal na tela Parâmetros de Grupo Fiscal na aba Imposto/Inscrição Estadual*/
         IF V_IDPRODNOTA = w_P THEN /*Se imposto do item*/
            SELECT MAX(CDTIPOOPER), COUNT(*)
              INTO V_CDTIPOOPER, V_CONTADOR
              FROM ALIQUOTA A, PRODUTO P
             WHERE (CDIMPOSTO    = P_IMPOSTO)
               AND (IDENTRSAIDAL = P_ENTRSAIDAL)
               AND (CDEMPRESA    = P_EMPRESA)
               AND (CDINSCESTA   = RTRIM(P_INSCESTA))
               AND (CDGRUPOFISC  = V_CDGRUPOFISC)
               AND ((CDPAISORIG  = P_PAISORIG) AND (SGESTAORIG  = P_ESTAORIG) OR V_UTUFORIG = w_N)
               AND ((CDPAISDEST  = P_PAISDEST) AND (SGESTADEST  = P_ESTADEST) OR V_UTUFDEST = w_N)
               AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
               AND ((VRINIFAIXA  < V_VRITEMPROD) AND (VRFIMFAIXA  >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
               AND (INSTR(NVL(P_CDTIPOOPER,'_'), NVL(RTRIM(CDTIPOOPER), NVL(P_CDTIPOOPER,'_'))) = 1  OR V_IDUTALIQTPOPER = w_N)
               AND (A.CDPRODUTO = P.CDPRODUTO(+))
               AND (INSTR(NVL(P_PRODUTO,'_'),NVL(RTRIM(P.CDARVPROD),NVL(P_PRODUTO,'_'))) = 1);
            IF NOT (V_CDTIPOOPER IS NULL) THEN /*Se possui alíquota por tipo de operação*/
               SELECT MAX(P.CDARVPROD)
                 INTO V_CDARVPROD
                 FROM ALIQUOTA A, PRODUTO P
                WHERE (CDIMPOSTO    = P_IMPOSTO)
                  AND (IDENTRSAIDAL = P_ENTRSAIDAL)
                  AND (CDEMPRESA    = P_EMPRESA)
                  AND (CDINSCESTA   = RTRIM(P_INSCESTA))
                  AND (CDGRUPOFISC  = V_CDGRUPOFISC)
                  AND ((CDPAISORIG  = P_PAISORIG) AND (SGESTAORIG  = P_ESTAORIG) OR V_UTUFORIG = w_N)
                  AND ((CDPAISDEST  = P_PAISDEST) AND (SGESTADEST  = P_ESTADEST) OR V_UTUFDEST = w_N)
                  AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                  AND ((VRINIFAIXA  < V_VRITEMPROD) AND (VRFIMFAIXA  >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                  AND (CDTIPOOPER = V_CDTIPOOPER OR V_IDUTALIQTPOPER = w_N)
                  AND (A.CDPRODUTO = P.CDPRODUTO(+))
                  AND (INSTR(NVL(P_PRODUTO,'_'),NVL(RTRIM(P.CDARVPROD),NVL(P_PRODUTO,'_'))) = 1);
            ELSIF (V_CDTIPOOPER IS NULL) THEN /*Se não possui alíquota por tipo de operação*/
               SELECT MAX(P.CDARVPROD)
               INTO V_CDARVPROD
               FROM ALIQUOTA A, PRODUTO P
               WHERE (CDIMPOSTO    = P_IMPOSTO)
                 AND (IDENTRSAIDAL = P_ENTRSAIDAL)
                 AND (CDEMPRESA    = P_EMPRESA)
                 AND (CDINSCESTA   = RTRIM(P_INSCESTA))
                 AND (CDGRUPOFISC  = V_CDGRUPOFISC)
                 AND ((CDPAISORIG  = P_PAISORIG) AND (SGESTAORIG  = P_ESTAORIG) OR V_UTUFORIG = w_N)
                 AND ((CDPAISDEST  = P_PAISDEST) AND (SGESTADEST  = P_ESTADEST) OR V_UTUFDEST = w_N)
                 AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                 AND ((VRINIFAIXA  < V_VRITEMPROD) AND (VRFIMFAIXA  >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                 AND (INSTR(NVL(P_CDTIPOOPER,'_'), NVL(RTRIM(CDTIPOOPER), NVL(P_CDTIPOOPER,'_'))) = 1  OR V_IDUTALIQTPOPER = w_N)
                 AND (A.CDPRODUTO = P.CDPRODUTO(+))
                 AND (INSTR(NVL(P_PRODUTO,'_'),NVL(RTRIM(P.CDARVPROD),NVL(P_PRODUTO,'_'))) = 1);
            END IF;
         ELSE /*Se imposto da nota*/
            SELECT MAX(A.CDPRODUTO), COUNT(*), MAX(CDTIPOOPER)
            INTO V_CDARVPROD, V_CONTADOR, V_CDTIPOOPER
            FROM ALIQUOTA A
            WHERE (CDIMPOSTO    = P_IMPOSTO)
              AND (IDENTRSAIDAL = P_ENTRSAIDAL)
              AND (CDEMPRESA    = P_EMPRESA)
              AND (CDINSCESTA   = RTRIM(P_INSCESTA))
              AND (CDGRUPOFISC  = V_CDGRUPOFISC)
              AND ((CDPAISORIG  = P_PAISORIG) AND (SGESTAORIG  = P_ESTAORIG) OR V_UTUFORIG = w_N)
              AND ((CDPAISDEST  = P_PAISDEST) AND (SGESTADEST  = P_ESTADEST) OR V_UTUFDEST = w_N)
              AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
              AND ((VRINIFAIXA  < V_VRITEMPROD) AND (VRFIMFAIXA  >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
              AND (INSTR(NVL(P_CDTIPOOPER,'_'), NVL(RTRIM(CDTIPOOPER), NVL(P_CDTIPOOPER,'_'))) = 1  OR V_IDUTALIQTPOPER = w_N)
              AND (A.CDPRODUTO IS NULL);
         END IF;
         IF NOT (V_CDTIPOOPER IS NULL) THEN /*Se possui alíquota por tipo de operação*/
            IF NOT (V_CDARVPROD IS NULL) THEN /*Se há alíquota para o maior nivel*/
               FOR C_ALIQUOTA IN (
                    SELECT A.NRALIQUOTA, VRPERREDBC, VR1PERREDBC, VRPARDEDUZ, VRALIQUOTA, DSMENSALIQU, IDTRATIMPST, VRPBCSUBTRIB, IDPMCBASECAL, CDTIPOOPER,
                           CDMENSAGEM, VRADICALIQFECP, CDBENEFFISCAL, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF
                      FROM ALIQUOTA A, MENSALIQU M, PRODUTO P
                     WHERE (A.NRALIQUOTA = M.NRALIQUOTA(+))
                       AND (A.CDIMPOSTO = P_IMPOSTO)
                       AND (A.IDENTRSAIDAL = P_ENTRSAIDAL)
                       AND (A.CDEMPRESA = P_EMPRESA)
                       AND (A.CDINSCESTA = RTRIM(P_INSCESTA))
                       AND (A.CDGRUPOFISC = V_CDGRUPOFISC)
                       AND (A.CDPRODUTO = P.CDPRODUTO(+))
                       AND (P.CDARVPROD = V_CDARVPROD)
                       AND ((A.CDPAISORIG = P_PAISORIG)
                       AND (A.SGESTAORIG = P_ESTAORIG) OR V_UTUFORIG = w_N)
                       AND ((A.CDPAISDEST = P_PAISDEST)
                       AND (A.SGESTADEST = P_ESTADEST) OR V_UTUFDEST = w_N)
                       AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                       AND ((A.VRINIFAIXA < V_VRITEMPROD)
                       AND (A.VRFIMFAIXA >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                       AND (CDTIPOOPER = V_CDTIPOOPER)
                       AND (A.DTINIVALID = (SELECT MAX(DTINIVALID)
                                              FROM ALIQUOTA A, PRODUTO P
                                             WHERE (CDIMPOSTO = P_IMPOSTO)
                                               AND (IDENTRSAIDAL = P_ENTRSAIDAL)
                                               AND (CDEMPRESA = P_EMPRESA)
                                               AND (CDINSCESTA = RTRIM(P_INSCESTA))
                                               AND (A.CDGRUPOFISC = V_CDGRUPOFISC)
                                               AND (A.CDPRODUTO = P.CDPRODUTO(+))
                                               AND (P.CDARVPROD = V_CDARVPROD)
                                               AND ((CDPAISORIG = P_PAISORIG)
                                               AND (SGESTAORIG = P_ESTAORIG) OR V_UTUFORIG = w_N)
                                               AND ((CDPAISDEST = P_PAISDEST)
                                               AND (SGESTADEST = P_ESTADEST) OR V_UTUFDEST = w_N)
                                               AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                                               AND ((VRINIFAIXA < V_VRITEMPROD)
                                               AND (VRFIMFAIXA >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                                               AND (CDTIPOOPER = V_CDTIPOOPER)
                                               AND (DTINIVALID <= P_INIVALID)))) LOOP
                  SELECT COUNT(*)
                    INTO V_EXISTE
                    FROM ALIQTEMP
                   WHERE NRALIQTEMP = P_FILIAL||P_LANCTONF;
                  IF V_EXISTE > 0 THEN
                     DELETE FROM ALIQTEMP
                     WHERE NRALIQTEMP = P_FILIAL||P_LANCTONF;
                  END IF;
                  SELECT COUNT(*)
                    INTO V_COUNTMENS
                    FROM MENSAGEM
                   WHERE CDMENSAGEM = C_ALIQUOTA.CDMENSAGEM
                     AND IDSITUACAOMENS = 'I';
                  IF V_COUNTMENS > 0 THEN
                     V_DSMENSALIQU := NULL;
                  ELSE
                     V_DSMENSALIQU := C_ALIQUOTA.DSMENSALIQU;
                  END IF;
                  INSERT INTO ALIQTEMP
                     (NRALIQTEMP, NRSEQUALIQ, VRPREDBCTMP, VRPARDEDTMP,
                      VRALIQUTMP, DSMENSALITMP, IDTRIMPSTTMP, VRPBCSTTMP,
                      IDPMCBSCALTMP, CDTIPOOPERTMP, VR1PREDBCTMP, CDINSCESTAATMP,
                      VRADICALIQFECP, CDBENEFFISCAL, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF)
                  VALUES
                     (P_FILIAL||P_LANCTONF, V_SEQUENCIA, C_ALIQUOTA.VRPERREDBC, C_ALIQUOTA.VRPARDEDUZ,
                      C_ALIQUOTA.VRALIQUOTA, V_DSMENSALIQU, C_ALIQUOTA.IDTRATIMPST, C_ALIQUOTA.VRPBCSUBTRIB,
                      C_ALIQUOTA.IDPMCBASECAL, C_ALIQUOTA.CDTIPOOPER,C_ALIQUOTA.VR1PERREDBC, P_INSCESTA,
                      C_ALIQUOTA.VRADICALIQFECP, C_ALIQUOTA.CDBENEFFISCAL, C_ALIQUOTA.IDCONSDIFALIQ, C_ALIQUOTA.IDIMPODESONERA, C_ALIQUOTA.IDCONSDESONVRNF);
                  V_SEQUENCIA := LPAD(RTRIM(V_SEQUENCIA + '01'),2,0);
               END LOOP;
            ELSIF (V_CDARVPROD IS NULL) THEN /*Se há alíquota para o produto todos*/
               FOR C_ALIQUOTA IN (
                    SELECT A.NRALIQUOTA, VRPERREDBC, VR1PERREDBC, VRPARDEDUZ, VRALIQUOTA, DSMENSALIQU, IDTRATIMPST, VRPBCSUBTRIB, IDPMCBASECAL, A.CDTIPOOPER, CDMENSAGEM,
                           VRADICALIQFECP, CDBENEFFISCAL, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF
                      FROM ALIQUOTA A, MENSALIQU M
                     WHERE (A.NRALIQUOTA = M.NRALIQUOTA(+))
                       AND (A.CDIMPOSTO = P_IMPOSTO)
                       AND (A.IDENTRSAIDAL = P_ENTRSAIDAL)
                       AND (A.CDEMPRESA = P_EMPRESA)
                       AND (A.CDINSCESTA = RTRIM(P_INSCESTA))
                       AND (A.CDGRUPOFISC = V_CDGRUPOFISC)
                       AND (A.CDPRODUTO IS NULL)
                       AND ((A.CDPAISORIG = P_PAISORIG)
                       AND (A.SGESTAORIG = P_ESTAORIG) OR V_UTUFORIG = w_N)
                       AND ((A.CDPAISDEST = P_PAISDEST)
                       AND (A.SGESTADEST = P_ESTADEST) OR V_UTUFDEST = w_N)
                       AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                       AND ((A.VRINIFAIXA < V_VRITEMPROD)
                       AND (A.VRFIMFAIXA >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                       AND (CDTIPOOPER = V_CDTIPOOPER)
                       AND (A.DTINIVALID = (SELECT MAX(DTINIVALID)
                                              FROM ALIQUOTA
                                             WHERE (CDIMPOSTO = P_IMPOSTO)
                                               AND (IDENTRSAIDAL = P_ENTRSAIDAL)
                                               AND (CDEMPRESA = P_EMPRESA)
                                               AND (CDINSCESTA = RTRIM(P_INSCESTA))
                                               AND (A.CDGRUPOFISC = V_CDGRUPOFISC)
                                               AND (CDPRODUTO IS NULL)
                                               AND ((CDPAISORIG = P_PAISORIG)
                                               AND (SGESTAORIG = P_ESTAORIG) OR V_UTUFORIG = w_N)
                                               AND ((CDPAISDEST = P_PAISDEST)
                                               AND (SGESTADEST = P_ESTADEST) OR V_UTUFDEST = w_N)
                                               AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                                               AND ((VRINIFAIXA < V_VRITEMPROD)
                                               AND (VRFIMFAIXA >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                                               AND (CDTIPOOPER = V_CDTIPOOPER)
                                               AND (DTINIVALID <= P_INIVALID)))) LOOP
                  SELECT COUNT(*)
                    INTO V_EXISTE
                    FROM ALIQTEMP
                   WHERE NRALIQTEMP = P_FILIAL||P_LANCTONF;
                  IF V_EXISTE > 0 THEN
                     DELETE FROM ALIQTEMP
                     WHERE NRALIQTEMP = P_FILIAL||P_LANCTONF;
                  END IF;
                  SELECT COUNT(*)
                    INTO V_COUNTMENS
                    FROM MENSAGEM
                   WHERE CDMENSAGEM = C_ALIQUOTA.CDMENSAGEM
                     AND IDSITUACAOMENS = 'I';
                  IF V_COUNTMENS > 0 THEN
                     V_DSMENSALIQU := NULL;
                  ELSE
                     V_DSMENSALIQU := C_ALIQUOTA.DSMENSALIQU;
                  END IF;
                  INSERT INTO ALIQTEMP
                     (NRALIQTEMP, NRSEQUALIQ, VRPREDBCTMP, VRPARDEDTMP,
                      VRALIQUTMP, DSMENSALITMP, IDTRIMPSTTMP, VRPBCSTTMP,
                      IDPMCBSCALTMP, CDTIPOOPERTMP, VR1PREDBCTMP, CDINSCESTAATMP,
                      VRADICALIQFECP, CDBENEFFISCAL, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF)
                  VALUES
                     (P_FILIAL||P_LANCTONF, V_SEQUENCIA, C_ALIQUOTA.VRPERREDBC, C_ALIQUOTA.VRPARDEDUZ,
                      C_ALIQUOTA.VRALIQUOTA, V_DSMENSALIQU, C_ALIQUOTA.IDTRATIMPST, C_ALIQUOTA.VRPBCSUBTRIB,
                      C_ALIQUOTA.IDPMCBASECAL, C_ALIQUOTA.CDTIPOOPER,C_ALIQUOTA.VR1PERREDBC, P_INSCESTA,
                      C_ALIQUOTA.VRADICALIQFECP, C_ALIQUOTA.CDBENEFFISCAL, C_ALIQUOTA.IDCONSDIFALIQ, C_ALIQUOTA.IDIMPODESONERA, C_ALIQUOTA.IDCONSDESONVRNF);
                  V_SEQUENCIA := LPAD(RTRIM(V_SEQUENCIA + '01'),2,0);
               END LOOP;
            END IF;
         ELSIF (V_CDTIPOOPER IS NULL) THEN /*Se não possui alíquota por tipo de operação*/
            IF NOT (V_CDARVPROD IS NULL) THEN /*Se há alíquota para o maior nivel*/
               FOR C_ALIQUOTA IN (
                    SELECT A.NRALIQUOTA, VRPERREDBC, VR1PERREDBC, VRPARDEDUZ, VRALIQUOTA, DSMENSALIQU, IDTRATIMPST, VRPBCSUBTRIB, IDPMCBASECAL,
                           CDMENSAGEM, VRADICALIQFECP, CDBENEFFISCAL, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF
                      FROM ALIQUOTA A, MENSALIQU M, PRODUTO P
                     WHERE (A.NRALIQUOTA = M.NRALIQUOTA(+))
                       AND (A.CDIMPOSTO = P_IMPOSTO)
                       AND (A.IDENTRSAIDAL = P_ENTRSAIDAL)
                       AND (A.CDEMPRESA = P_EMPRESA)
                       AND (A.CDINSCESTA = RTRIM(P_INSCESTA))
                       AND (A.CDGRUPOFISC = V_CDGRUPOFISC)
                       AND (A.CDPRODUTO = P.CDPRODUTO(+))
                       AND (P.CDARVPROD = V_CDARVPROD)
                       AND ((A.CDPAISORIG = P_PAISORIG)
                       AND (A.SGESTAORIG = P_ESTAORIG) OR V_UTUFORIG = w_N)
                       AND ((A.CDPAISDEST = P_PAISDEST)
                       AND (A.SGESTADEST = P_ESTADEST) OR V_UTUFDEST = w_N)
                       AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                       AND ((A.VRINIFAIXA < V_VRITEMPROD)
                       AND (A.VRFIMFAIXA >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                       AND (INSTR(NVL(P_CDTIPOOPER,'_'), NVL(RTRIM(CDTIPOOPER), NVL(P_CDTIPOOPER,'_'))) = 1  OR V_IDUTALIQTPOPER = w_N)
                       AND (A.DTINIVALID = (SELECT MAX(DTINIVALID)
                                              FROM ALIQUOTA A, PRODUTO P
                                             WHERE (CDIMPOSTO = P_IMPOSTO)
                                               AND (IDENTRSAIDAL = P_ENTRSAIDAL)
                                               AND (CDEMPRESA = P_EMPRESA)
                                               AND (CDINSCESTA = RTRIM(P_INSCESTA))
                                               AND (A.CDGRUPOFISC = V_CDGRUPOFISC)
                                               AND (A.CDPRODUTO = P.CDPRODUTO(+))
                                               AND (P.CDARVPROD = V_CDARVPROD)
                                               AND ((CDPAISORIG = P_PAISORIG)
                                               AND (SGESTAORIG = P_ESTAORIG) OR V_UTUFORIG = w_N)
                                               AND ((CDPAISDEST = P_PAISDEST)
                                               AND (SGESTADEST = P_ESTADEST) OR V_UTUFDEST = w_N)
                                               AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                                               AND ((VRINIFAIXA < V_VRITEMPROD)
                                               AND (VRFIMFAIXA >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                                               AND (INSTR(NVL(P_CDTIPOOPER,'_'), NVL(RTRIM(CDTIPOOPER), NVL(P_CDTIPOOPER,'_'))) = 1  OR V_IDUTALIQTPOPER = w_N)
                                               AND (DTINIVALID <= P_INIVALID)))) LOOP
                  SELECT COUNT(*)
                    INTO V_EXISTE
                    FROM ALIQTEMP
                   WHERE NRALIQTEMP = P_FILIAL||P_LANCTONF;
                  IF V_EXISTE > 0 THEN
                     DELETE FROM ALIQTEMP
                     WHERE NRALIQTEMP = P_FILIAL||P_LANCTONF;
                  END IF;
                  SELECT COUNT(*)
                    INTO V_COUNTMENS
                    FROM MENSAGEM
                   WHERE CDMENSAGEM = C_ALIQUOTA.CDMENSAGEM
                     AND IDSITUACAOMENS = 'I';
                  IF V_COUNTMENS > 0 THEN
                     V_DSMENSALIQU := NULL;
                  ELSE
                     V_DSMENSALIQU := C_ALIQUOTA.DSMENSALIQU;
                  END IF;
                  INSERT INTO ALIQTEMP
                     (NRALIQTEMP, NRSEQUALIQ, VRPREDBCTMP, VRPARDEDTMP,
                      VRALIQUTMP, DSMENSALITMP, IDTRIMPSTTMP, VRPBCSTTMP,
                      IDPMCBSCALTMP, VR1PREDBCTMP, CDINSCESTAATMP, VRADICALIQFECP,
                      CDBENEFFISCAL, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF)
                  VALUES
                     (P_FILIAL||P_LANCTONF, V_SEQUENCIA, C_ALIQUOTA.VRPERREDBC, C_ALIQUOTA.VRPARDEDUZ,
                      C_ALIQUOTA.VRALIQUOTA, V_DSMENSALIQU, C_ALIQUOTA.IDTRATIMPST, C_ALIQUOTA.VRPBCSUBTRIB,
                      C_ALIQUOTA.IDPMCBASECAL, C_ALIQUOTA.VR1PERREDBC, P_INSCESTA, C_ALIQUOTA.VRADICALIQFECP, 
                      C_ALIQUOTA.CDBENEFFISCAL, C_ALIQUOTA.IDCONSDIFALIQ, C_ALIQUOTA.IDIMPODESONERA, C_ALIQUOTA.IDCONSDESONVRNF);
                  V_SEQUENCIA := LPAD(RTRIM(V_SEQUENCIA + '01'),2,0);
               END LOOP;
            ELSIF (V_CDARVPROD IS NULL) THEN /*Se há alíquota para o produto todos*/
               FOR C_ALIQUOTA IN (
                    SELECT A.NRALIQUOTA, VRPERREDBC, VR1PERREDBC, VRPARDEDUZ, VRALIQUOTA, DSMENSALIQU, IDTRATIMPST, VRPBCSUBTRIB, IDPMCBASECAL, CDMENSAGEM,
                           VRADICALIQFECP, CDBENEFFISCAL, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF
                      FROM ALIQUOTA A, MENSALIQU M
                     WHERE (A.NRALIQUOTA = M.NRALIQUOTA(+))
                       AND (A.CDIMPOSTO = P_IMPOSTO)
                       AND (A.IDENTRSAIDAL = P_ENTRSAIDAL)
                       AND (A.CDEMPRESA = P_EMPRESA)
                       AND (A.CDINSCESTA = RTRIM(P_INSCESTA))
                       AND (A.CDGRUPOFISC = V_CDGRUPOFISC)
                       AND (A.CDPRODUTO IS NULL)
                       AND ((A.CDPAISORIG = P_PAISORIG)
                       AND (A.SGESTAORIG = P_ESTAORIG) OR V_UTUFORIG = w_N)
                       AND ((A.CDPAISDEST = P_PAISDEST)
                       AND (A.SGESTADEST = P_ESTADEST) OR V_UTUFDEST = w_N)
                       AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                       AND ((A.VRINIFAIXA < V_VRITEMPROD)
                       AND (A.VRFIMFAIXA >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                       AND (INSTR(NVL(P_CDTIPOOPER,'_'), NVL(RTRIM(CDTIPOOPER), NVL(P_CDTIPOOPER,'_'))) = 1  OR V_IDUTALIQTPOPER = w_N)
                       AND (A.DTINIVALID = (SELECT MAX(DTINIVALID)
                                              FROM ALIQUOTA
                                             WHERE (CDIMPOSTO = P_IMPOSTO)
                                               AND (IDENTRSAIDAL = P_ENTRSAIDAL)
                                               AND (CDEMPRESA = P_EMPRESA)
                                               AND (CDINSCESTA = RTRIM(P_INSCESTA))
                                               AND (A.CDGRUPOFISC = V_CDGRUPOFISC)
                                               AND (CDPRODUTO IS NULL)
                                               AND ((CDPAISORIG = P_PAISORIG)
                                               AND (SGESTAORIG = P_ESTAORIG) OR V_UTUFORIG = w_N)
                                               AND ((CDPAISDEST = P_PAISDEST)
                                               AND (SGESTADEST = P_ESTADEST) OR V_UTUFDEST = w_N)
                                               AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                                               AND ((VRINIFAIXA < V_VRITEMPROD)
                                               AND (VRFIMFAIXA >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                                               AND (INSTR(NVL(P_CDTIPOOPER,'_'), NVL(RTRIM(CDTIPOOPER), NVL(P_CDTIPOOPER,'_'))) = 1  OR V_IDUTALIQTPOPER = w_N)
                                               AND (DTINIVALID <= P_INIVALID)))) LOOP
                  SELECT COUNT(*)
                    INTO V_EXISTE
                    FROM ALIQTEMP
                   WHERE NRALIQTEMP = P_FILIAL||P_LANCTONF;
                  IF V_EXISTE > 0 THEN
                     DELETE FROM ALIQTEMP
                     WHERE NRALIQTEMP = P_FILIAL||P_LANCTONF;
                  END IF;
                  SELECT COUNT(*)
                    INTO V_COUNTMENS
                    FROM MENSAGEM
                   WHERE CDMENSAGEM = C_ALIQUOTA.CDMENSAGEM
                     AND IDSITUACAOMENS = 'I';
                  IF V_COUNTMENS > 0 THEN
                     V_DSMENSALIQU := NULL;
                  ELSE
                     V_DSMENSALIQU := C_ALIQUOTA.DSMENSALIQU;
                  END IF;
                  INSERT INTO ALIQTEMP
                     (NRALIQTEMP, NRSEQUALIQ, VRPREDBCTMP, VRPARDEDTMP,
                      VRALIQUTMP, DSMENSALITMP, IDTRIMPSTTMP, VRPBCSTTMP,
                      IDPMCBSCALTMP, VR1PREDBCTMP, CDINSCESTAATMP, VRADICALIQFECP,
                      CDBENEFFISCAL, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF)
                  VALUES
                     (P_FILIAL||P_LANCTONF, V_SEQUENCIA, C_ALIQUOTA.VRPERREDBC, C_ALIQUOTA.VRPARDEDUZ,
                      C_ALIQUOTA.VRALIQUOTA, V_DSMENSALIQU, C_ALIQUOTA.IDTRATIMPST, C_ALIQUOTA.VRPBCSUBTRIB,
                      C_ALIQUOTA.IDPMCBASECAL,C_ALIQUOTA.VR1PERREDBC, P_INSCESTA, C_ALIQUOTA.VRADICALIQFECP, 
                      C_ALIQUOTA.CDBENEFFISCAL, C_ALIQUOTA.IDCONSDIFALIQ, C_ALIQUOTA.IDIMPODESONERA, C_ALIQUOTA.IDCONSDESONVRNF);
                  V_SEQUENCIA := LPAD(RTRIM(V_SEQUENCIA + '01'),2,0);
               END LOOP;
            END IF;
         END IF;
      END IF;
      /*Por Cliente*/
      V_CDGRUPOFISC := NULL;
      BEGIN
         SELECT MAX(G.CDGRUPOFISC)
           INTO V_CDGRUPOFISC
           FROM GRFISIMPIECLIE G, (SELECT CDCLIENTE
                                     FROM NOTAFISCAL
                                    WHERE CDFILIAL = P_FILIAL
                                      AND NRLANCTONF = P_LANCTONF
                                      AND P_CDCLIENTE IS NULL
                                    UNION ALL
                                   SELECT CDCLIENTE
                                     FROM CLIENTE
                                    WHERE CDCLIENTE = P_CDCLIENTE) F
          WHERE G.CDIMPOSTO = P_IMPOSTO
            AND G.CDCLIENTE = F.CDCLIENTE
            AND G.CDEMPRESA = P_EMPRESA
            AND G.CDINSCESTA = P_INSCESTA;
      EXCEPTION
         WHEN No_Data_Found THEN
            V_CDGRUPOFISC := NULL;
      END;
      IF NOT (V_CDGRUPOFISC IS NULL) THEN /*Se há grupo fiscal na tela Parâmetros de Grupo Fiscal na aba Imposto/Inscrição Estadual*/
         IF V_IDPRODNOTA = w_P THEN /*Se imposto do item*/
            SELECT MAX(CDTIPOOPER), COUNT(*)
              INTO V_CDTIPOOPER, V_CONTADOR
              FROM ALIQUOTA A, PRODUTO P
             WHERE (CDIMPOSTO    = P_IMPOSTO)
               AND (IDENTRSAIDAL = P_ENTRSAIDAL)
               AND (CDEMPRESA    = P_EMPRESA)
               AND (CDINSCESTA   = RTRIM(P_INSCESTA))
               AND (CDGRUPOFISC  = V_CDGRUPOFISC)
               AND ((CDPAISORIG  = P_PAISORIG) AND (SGESTAORIG  = P_ESTAORIG) OR V_UTUFORIG = w_N)
               AND ((CDPAISDEST  = P_PAISDEST) AND (SGESTADEST  = P_ESTADEST) OR V_UTUFDEST = w_N)
               AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
               AND ((VRINIFAIXA  < V_VRITEMPROD) AND (VRFIMFAIXA  >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
               AND (INSTR(NVL(P_CDTIPOOPER,'_'), NVL(RTRIM(CDTIPOOPER), NVL(P_CDTIPOOPER,'_'))) = 1  OR V_IDUTALIQTPOPER = w_N)
               AND (A.CDPRODUTO = P.CDPRODUTO(+))
               AND (INSTR(NVL(P_PRODUTO,'_'),NVL(RTRIM(P.CDARVPROD),NVL(P_PRODUTO,'_'))) = 1);
            IF NOT (V_CDTIPOOPER IS NULL) THEN /*Se possui alíquota por tipo de operação*/
               SELECT MAX(P.CDARVPROD)
                 INTO V_CDARVPROD
                 FROM ALIQUOTA A, PRODUTO P
                WHERE (CDIMPOSTO    = P_IMPOSTO)
                  AND (IDENTRSAIDAL = P_ENTRSAIDAL)
                  AND (CDEMPRESA    = P_EMPRESA)
                  AND (CDINSCESTA   = RTRIM(P_INSCESTA))
                  AND (CDGRUPOFISC  = V_CDGRUPOFISC)
                  AND ((CDPAISORIG  = P_PAISORIG) AND (SGESTAORIG  = P_ESTAORIG) OR V_UTUFORIG = w_N)
                  AND ((CDPAISDEST  = P_PAISDEST) AND (SGESTADEST  = P_ESTADEST) OR V_UTUFDEST = w_N)
                  AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                  AND ((VRINIFAIXA  < V_VRITEMPROD) AND (VRFIMFAIXA  >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                  AND (CDTIPOOPER = V_CDTIPOOPER OR V_IDUTALIQTPOPER = w_N)
                  AND (A.CDPRODUTO = P.CDPRODUTO(+))
                  AND (INSTR(NVL(P_PRODUTO,'_'),NVL(RTRIM(P.CDARVPROD),NVL(P_PRODUTO,'_'))) = 1);
            ELSIF (V_CDTIPOOPER IS NULL) THEN /*Se não possui alíquota por tipo de operação*/
               SELECT MAX(P.CDARVPROD)
               INTO V_CDARVPROD
               FROM ALIQUOTA A, PRODUTO P
               WHERE (CDIMPOSTO    = P_IMPOSTO)
                 AND (IDENTRSAIDAL = P_ENTRSAIDAL)
                 AND (CDEMPRESA    = P_EMPRESA)
                 AND (CDINSCESTA   = RTRIM(P_INSCESTA))
                 AND (CDGRUPOFISC  = V_CDGRUPOFISC)
                 AND ((CDPAISORIG  = P_PAISORIG) AND (SGESTAORIG  = P_ESTAORIG) OR V_UTUFORIG = w_N)
                 AND ((CDPAISDEST  = P_PAISDEST) AND (SGESTADEST  = P_ESTADEST) OR V_UTUFDEST = w_N)
                 AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                 AND ((VRINIFAIXA  < V_VRITEMPROD) AND (VRFIMFAIXA  >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                 AND (INSTR(NVL(P_CDTIPOOPER,'_'), NVL(RTRIM(CDTIPOOPER), NVL(P_CDTIPOOPER,'_'))) = 1  OR V_IDUTALIQTPOPER = w_N)
                 AND (A.CDPRODUTO = P.CDPRODUTO(+))
                 AND (INSTR(NVL(P_PRODUTO,'_'),NVL(RTRIM(P.CDARVPROD),NVL(P_PRODUTO,'_'))) = 1);
            END IF;
         ELSE /*Se imposto da nota*/
            SELECT MAX(A.CDPRODUTO), COUNT(*), MAX(CDTIPOOPER)
            INTO V_CDARVPROD, V_CONTADOR, V_CDTIPOOPER
            FROM ALIQUOTA A
            WHERE (CDIMPOSTO    = P_IMPOSTO)
              AND (IDENTRSAIDAL = P_ENTRSAIDAL)
              AND (CDEMPRESA    = P_EMPRESA)
              AND (CDINSCESTA   = RTRIM(P_INSCESTA))
              AND (CDGRUPOFISC  = V_CDGRUPOFISC)
              AND ((CDPAISORIG  = P_PAISORIG) AND (SGESTAORIG  = P_ESTAORIG) OR V_UTUFORIG = w_N)
              AND ((CDPAISDEST  = P_PAISDEST) AND (SGESTADEST  = P_ESTADEST) OR V_UTUFDEST = w_N)
              AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
              AND ((VRINIFAIXA  < V_VRITEMPROD) AND (VRFIMFAIXA  >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
              AND (INSTR(NVL(P_CDTIPOOPER,'_'), NVL(RTRIM(CDTIPOOPER), NVL(P_CDTIPOOPER,'_'))) = 1  OR V_IDUTALIQTPOPER = w_N)
              AND (A.CDPRODUTO IS NULL);
         END IF;
         IF NOT (V_CDTIPOOPER IS NULL) THEN /*Se possui alíquota por tipo de operação*/
            IF NOT (V_CDARVPROD IS NULL) THEN /*Se há alíquota para o maior nivel*/
               FOR C_ALIQUOTA IN (
                    SELECT A.NRALIQUOTA, VRPERREDBC, VR1PERREDBC, VRPARDEDUZ, VRALIQUOTA, DSMENSALIQU, IDTRATIMPST, VRPBCSUBTRIB, IDPMCBASECAL, CDTIPOOPER, CDMENSAGEM,
                           VRADICALIQFECP, CDBENEFFISCAL, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF
                      FROM ALIQUOTA A, MENSALIQU M, PRODUTO P
                     WHERE (A.NRALIQUOTA = M.NRALIQUOTA(+))
                       AND (A.CDIMPOSTO = P_IMPOSTO)
                       AND (A.IDENTRSAIDAL = P_ENTRSAIDAL)
                       AND (A.CDEMPRESA = P_EMPRESA)
                       AND (A.CDINSCESTA = RTRIM(P_INSCESTA))
                       AND (A.CDGRUPOFISC = V_CDGRUPOFISC)
                       AND (A.CDPRODUTO = P.CDPRODUTO(+))
                       AND (P.CDARVPROD = V_CDARVPROD)
                       AND ((A.CDPAISORIG = P_PAISORIG)
                       AND (A.SGESTAORIG = P_ESTAORIG) OR V_UTUFORIG = w_N)
                       AND ((A.CDPAISDEST = P_PAISDEST)
                       AND (A.SGESTADEST = P_ESTADEST) OR V_UTUFDEST = w_N)
                       AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                       AND ((A.VRINIFAIXA < V_VRITEMPROD)
                       AND (A.VRFIMFAIXA >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                       AND (CDTIPOOPER = V_CDTIPOOPER)
                       AND (A.DTINIVALID = (SELECT MAX(DTINIVALID)
                                              FROM ALIQUOTA A, PRODUTO P
                                             WHERE (CDIMPOSTO = P_IMPOSTO)
                                               AND (IDENTRSAIDAL = P_ENTRSAIDAL)
                                               AND (CDEMPRESA = P_EMPRESA)
                                               AND (CDINSCESTA = RTRIM(P_INSCESTA))
                                               AND (A.CDGRUPOFISC = V_CDGRUPOFISC)
                                               AND (A.CDPRODUTO = P.CDPRODUTO(+))
                                               AND (P.CDARVPROD = V_CDARVPROD)
                                               AND ((CDPAISORIG = P_PAISORIG)
                                               AND (SGESTAORIG = P_ESTAORIG) OR V_UTUFORIG = w_N)
                                               AND ((CDPAISDEST = P_PAISDEST)
                                               AND (SGESTADEST = P_ESTADEST) OR V_UTUFDEST = w_N)
                                               AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                                               AND ((VRINIFAIXA < V_VRITEMPROD)
                                               AND (VRFIMFAIXA >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                                               AND (CDTIPOOPER = V_CDTIPOOPER)
                                               AND (DTINIVALID <= P_INIVALID)))) LOOP
                  SELECT COUNT(*)
                    INTO V_EXISTE
                    FROM ALIQTEMP
                   WHERE NRALIQTEMP = P_FILIAL||P_LANCTONF;
                  IF V_EXISTE > 0 THEN
                     DELETE FROM ALIQTEMP
                     WHERE NRALIQTEMP = P_FILIAL||P_LANCTONF;
                  END IF;
                  SELECT COUNT(*)
                    INTO V_COUNTMENS
                    FROM MENSAGEM
                   WHERE CDMENSAGEM = C_ALIQUOTA.CDMENSAGEM
                     AND IDSITUACAOMENS = 'I';
                  IF V_COUNTMENS > 0 THEN
                     V_DSMENSALIQU := NULL;
                  ELSE
                     V_DSMENSALIQU := C_ALIQUOTA.DSMENSALIQU;
                  END IF;
                  INSERT INTO ALIQTEMP
                     (NRALIQTEMP, NRSEQUALIQ, VRPREDBCTMP, VRPARDEDTMP,
                      VRALIQUTMP, DSMENSALITMP, IDTRIMPSTTMP, VRPBCSTTMP,
                      IDPMCBSCALTMP, CDTIPOOPERTMP, VR1PREDBCTMP, CDINSCESTAATMP,
                      VRADICALIQFECP, CDBENEFFISCAL, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF)
                  VALUES
                     (P_FILIAL||P_LANCTONF, V_SEQUENCIA, C_ALIQUOTA.VRPERREDBC, C_ALIQUOTA.VRPARDEDUZ,
                      C_ALIQUOTA.VRALIQUOTA, V_DSMENSALIQU, C_ALIQUOTA.IDTRATIMPST, C_ALIQUOTA.VRPBCSUBTRIB,
                      C_ALIQUOTA.IDPMCBASECAL, C_ALIQUOTA.CDTIPOOPER, C_ALIQUOTA.VR1PERREDBC, P_INSCESTA,
                      C_ALIQUOTA.VRADICALIQFECP, C_ALIQUOTA.CDBENEFFISCAL, C_ALIQUOTA.IDCONSDIFALIQ, C_ALIQUOTA.IDIMPODESONERA, C_ALIQUOTA.IDCONSDESONVRNF);
                  V_SEQUENCIA := LPAD(RTRIM(V_SEQUENCIA + '01'),2,0);
               END LOOP;
            ELSIF (V_CDARVPROD IS NULL) THEN /*Se há alíquota para o produto todos*/
               FOR C_ALIQUOTA IN (
                    SELECT A.NRALIQUOTA, VRPERREDBC, VR1PERREDBC, VRPARDEDUZ, VRALIQUOTA, DSMENSALIQU, IDTRATIMPST, VRPBCSUBTRIB, IDPMCBASECAL, A.CDTIPOOPER, CDMENSAGEM,
                           VRADICALIQFECP, CDBENEFFISCAL, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF
                      FROM ALIQUOTA A, MENSALIQU M
                     WHERE (A.NRALIQUOTA = M.NRALIQUOTA(+))
                       AND (A.CDIMPOSTO = P_IMPOSTO)
                       AND (A.IDENTRSAIDAL = P_ENTRSAIDAL)
                       AND (A.CDEMPRESA = P_EMPRESA)
                       AND (A.CDINSCESTA = RTRIM(P_INSCESTA))
                       AND (A.CDGRUPOFISC = V_CDGRUPOFISC)
                       AND (A.CDPRODUTO IS NULL)
                       AND ((A.CDPAISORIG = P_PAISORIG)
                       AND (A.SGESTAORIG = P_ESTAORIG) OR V_UTUFORIG = w_N)
                       AND ((A.CDPAISDEST = P_PAISDEST)
                       AND (A.SGESTADEST = P_ESTADEST) OR V_UTUFDEST = w_N)
                       AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                       AND ((A.VRINIFAIXA < V_VRITEMPROD)
                       AND (A.VRFIMFAIXA >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                       AND (CDTIPOOPER = V_CDTIPOOPER)
                       AND (A.DTINIVALID = (SELECT MAX(DTINIVALID)
                                              FROM ALIQUOTA
                                             WHERE (CDIMPOSTO = P_IMPOSTO)
                                               AND (IDENTRSAIDAL = P_ENTRSAIDAL)
                                               AND (CDEMPRESA = P_EMPRESA)
                                               AND (CDINSCESTA = RTRIM(P_INSCESTA))
                                               AND (A.CDGRUPOFISC = V_CDGRUPOFISC)
                                               AND (CDPRODUTO IS NULL)
                                               AND ((CDPAISORIG = P_PAISORIG)
                                               AND (SGESTAORIG = P_ESTAORIG) OR V_UTUFORIG = w_N)
                                               AND ((CDPAISDEST = P_PAISDEST)
                                               AND (SGESTADEST = P_ESTADEST) OR V_UTUFDEST = w_N)
                                               AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                                               AND ((VRINIFAIXA < V_VRITEMPROD)
                                               AND (VRFIMFAIXA >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                                               AND (CDTIPOOPER = V_CDTIPOOPER)
                                               AND (DTINIVALID <= P_INIVALID)))) LOOP
                  SELECT COUNT(*)
                    INTO V_EXISTE
                    FROM ALIQTEMP
                   WHERE NRALIQTEMP = P_FILIAL||P_LANCTONF;
                  IF V_EXISTE > 0 THEN
                     DELETE FROM ALIQTEMP
                     WHERE NRALIQTEMP = P_FILIAL||P_LANCTONF;
                  END IF;
                  SELECT COUNT(*)
                    INTO V_COUNTMENS
                    FROM MENSAGEM
                   WHERE CDMENSAGEM = C_ALIQUOTA.CDMENSAGEM
                     AND IDSITUACAOMENS = 'I';
                  IF V_COUNTMENS > 0 THEN
                     V_DSMENSALIQU := NULL;
                  ELSE
                     V_DSMENSALIQU := C_ALIQUOTA.DSMENSALIQU;
                  END IF;
                  INSERT INTO ALIQTEMP
                     (NRALIQTEMP, NRSEQUALIQ, VRPREDBCTMP, VRPARDEDTMP,
                      VRALIQUTMP, DSMENSALITMP, IDTRIMPSTTMP, VRPBCSTTMP,
                      IDPMCBSCALTMP, CDTIPOOPERTMP, VR1PREDBCTMP, CDINSCESTAATMP,
                      VRADICALIQFECP, CDBENEFFISCAL, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF)
                  VALUES
                     (P_FILIAL||P_LANCTONF, V_SEQUENCIA, C_ALIQUOTA.VRPERREDBC, C_ALIQUOTA.VRPARDEDUZ,
                      C_ALIQUOTA.VRALIQUOTA, V_DSMENSALIQU, C_ALIQUOTA.IDTRATIMPST, C_ALIQUOTA.VRPBCSUBTRIB,
                      C_ALIQUOTA.IDPMCBASECAL, C_ALIQUOTA.CDTIPOOPER, C_ALIQUOTA.VR1PERREDBC, P_INSCESTA,
                      C_ALIQUOTA.VRADICALIQFECP, C_ALIQUOTA.CDBENEFFISCAL, C_ALIQUOTA.IDCONSDIFALIQ, C_ALIQUOTA.IDIMPODESONERA, C_ALIQUOTA.IDCONSDESONVRNF);
                  V_SEQUENCIA := LPAD(RTRIM(V_SEQUENCIA + '01'),2,0);
               END LOOP;
            END IF;
         ELSIF (V_CDTIPOOPER IS NULL) THEN /*Se não possui alíquota por tipo de operação*/
            IF NOT (V_CDARVPROD IS NULL) THEN /*Se há alíquota para o maior nivel*/
               FOR C_ALIQUOTA IN (
                    SELECT A.NRALIQUOTA, VRPERREDBC, VR1PERREDBC, VRPARDEDUZ, VRALIQUOTA, DSMENSALIQU, IDTRATIMPST, VRPBCSUBTRIB, IDPMCBASECAL,
                           CDMENSAGEM, VRADICALIQFECP, CDBENEFFISCAL, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF
                      FROM ALIQUOTA A, MENSALIQU M, PRODUTO P
                     WHERE (A.NRALIQUOTA = M.NRALIQUOTA(+))
                       AND (A.CDIMPOSTO = P_IMPOSTO)
                       AND (A.IDENTRSAIDAL = P_ENTRSAIDAL)
                       AND (A.CDEMPRESA = P_EMPRESA)
                       AND (A.CDINSCESTA = RTRIM(P_INSCESTA))
                       AND (A.CDGRUPOFISC = V_CDGRUPOFISC)
                       AND (A.CDPRODUTO = P.CDPRODUTO(+))
                       AND (P.CDARVPROD = V_CDARVPROD)
                       AND ((A.CDPAISORIG = P_PAISORIG)
                       AND (A.SGESTAORIG = P_ESTAORIG) OR V_UTUFORIG = w_N)
                       AND ((A.CDPAISDEST = P_PAISDEST)
                       AND (A.SGESTADEST = P_ESTADEST) OR V_UTUFDEST = w_N)
                       AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                       AND ((A.VRINIFAIXA < V_VRITEMPROD)
                       AND (A.VRFIMFAIXA >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                       AND (INSTR(NVL(P_CDTIPOOPER,'_'), NVL(RTRIM(CDTIPOOPER), NVL(P_CDTIPOOPER,'_'))) = 1  OR V_IDUTALIQTPOPER = w_N)
                       AND (A.DTINIVALID = (SELECT MAX(DTINIVALID)
                                              FROM ALIQUOTA A, PRODUTO P
                                             WHERE (CDIMPOSTO = P_IMPOSTO)
                                               AND (IDENTRSAIDAL = P_ENTRSAIDAL)
                                               AND (CDEMPRESA = P_EMPRESA)
                                               AND (CDINSCESTA = RTRIM(P_INSCESTA))
                                               AND (A.CDGRUPOFISC = V_CDGRUPOFISC)
                                               AND (A.CDPRODUTO = P.CDPRODUTO(+))
                                               AND (P.CDARVPROD = V_CDARVPROD)
                                               AND ((CDPAISORIG = P_PAISORIG)
                                               AND (SGESTAORIG = P_ESTAORIG) OR V_UTUFORIG = w_N)
                                               AND ((CDPAISDEST = P_PAISDEST)
                                               AND (SGESTADEST = P_ESTADEST) OR V_UTUFDEST = w_N)
                                               AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                                               AND ((VRINIFAIXA < V_VRITEMPROD)
                                               AND (VRFIMFAIXA >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                                               AND (INSTR(NVL(P_CDTIPOOPER,'_'), NVL(RTRIM(CDTIPOOPER), NVL(P_CDTIPOOPER,'_'))) = 1  OR V_IDUTALIQTPOPER = w_N)
                                               AND (DTINIVALID <= P_INIVALID)))) LOOP
                  SELECT COUNT(*)
                    INTO V_EXISTE
                    FROM ALIQTEMP
                   WHERE NRALIQTEMP = P_FILIAL||P_LANCTONF;
                  IF V_EXISTE > 0 THEN
                     DELETE FROM ALIQTEMP
                     WHERE NRALIQTEMP = P_FILIAL||P_LANCTONF;
                  END IF;
                  SELECT COUNT(*)
                    INTO V_COUNTMENS
                    FROM MENSAGEM
                   WHERE CDMENSAGEM = C_ALIQUOTA.CDMENSAGEM
                     AND IDSITUACAOMENS = 'I';
                  IF V_COUNTMENS > 0 THEN
                     V_DSMENSALIQU := NULL;
                  ELSE
                     V_DSMENSALIQU := C_ALIQUOTA.DSMENSALIQU;
                  END IF;
                  INSERT INTO ALIQTEMP
                     (NRALIQTEMP, NRSEQUALIQ, VRPREDBCTMP, VRPARDEDTMP,
                      VRALIQUTMP, DSMENSALITMP, IDTRIMPSTTMP, VRPBCSTTMP,
                      IDPMCBSCALTMP, VR1PREDBCTMP, CDINSCESTAATMP, VRADICALIQFECP,
                      CDBENEFFISCAL, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF)
                  VALUES
                     (P_FILIAL||P_LANCTONF, V_SEQUENCIA, C_ALIQUOTA.VRPERREDBC, C_ALIQUOTA.VRPARDEDUZ,
                      C_ALIQUOTA.VRALIQUOTA, V_DSMENSALIQU, C_ALIQUOTA.IDTRATIMPST, C_ALIQUOTA.VRPBCSUBTRIB,
                      C_ALIQUOTA.IDPMCBASECAL, C_ALIQUOTA.VR1PERREDBC, P_INSCESTA, C_ALIQUOTA.VRADICALIQFECP, 
                      C_ALIQUOTA.CDBENEFFISCAL, C_ALIQUOTA.IDCONSDIFALIQ, C_ALIQUOTA.IDIMPODESONERA, C_ALIQUOTA.IDCONSDESONVRNF);
                  V_SEQUENCIA := LPAD(RTRIM(V_SEQUENCIA + '01'),2,0);
               END LOOP;
            ELSIF (V_CDARVPROD IS NULL) THEN /*Se há alíquota para o produto todos*/
               FOR C_ALIQUOTA IN (
                    SELECT A.NRALIQUOTA, VRPERREDBC, VR1PERREDBC, VRPARDEDUZ, VRALIQUOTA, DSMENSALIQU, IDTRATIMPST, VRPBCSUBTRIB, IDPMCBASECAL,
                           CDMENSAGEM, VRADICALIQFECP, CDBENEFFISCAL, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF
                      FROM ALIQUOTA A, MENSALIQU M
                     WHERE (A.NRALIQUOTA = M.NRALIQUOTA(+))
                       AND (A.CDIMPOSTO = P_IMPOSTO)
                       AND (A.IDENTRSAIDAL = P_ENTRSAIDAL)
                       AND (A.CDEMPRESA = P_EMPRESA)
                       AND (A.CDINSCESTA = RTRIM(P_INSCESTA))
                       AND (A.CDGRUPOFISC = V_CDGRUPOFISC)
                       AND (A.CDPRODUTO IS NULL)
                       AND ((A.CDPAISORIG = P_PAISORIG)
                       AND (A.SGESTAORIG = P_ESTAORIG) OR V_UTUFORIG = w_N)
                       AND ((A.CDPAISDEST = P_PAISDEST)
                       AND (A.SGESTADEST = P_ESTADEST) OR V_UTUFDEST = w_N)
                       AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                       AND ((A.VRINIFAIXA < V_VRITEMPROD)
                       AND (A.VRFIMFAIXA >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                       AND (INSTR(NVL(P_CDTIPOOPER,'_'), NVL(RTRIM(CDTIPOOPER), NVL(P_CDTIPOOPER,'_'))) = 1  OR V_IDUTALIQTPOPER = w_N)
                       AND (A.DTINIVALID = (SELECT MAX(DTINIVALID)
                                              FROM ALIQUOTA
                                             WHERE (CDIMPOSTO = P_IMPOSTO)
                                               AND (IDENTRSAIDAL = P_ENTRSAIDAL)
                                               AND (CDEMPRESA = P_EMPRESA)
                                               AND (CDINSCESTA = RTRIM(P_INSCESTA))
                                               AND (A.CDGRUPOFISC = V_CDGRUPOFISC)
                                               AND (CDPRODUTO IS NULL)
                                               AND ((CDPAISORIG = P_PAISORIG)
                                               AND (SGESTAORIG = P_ESTAORIG) OR V_UTUFORIG = w_N)
                                               AND ((CDPAISDEST = P_PAISDEST)
                                               AND (SGESTADEST = P_ESTADEST) OR V_UTUFDEST = w_N)
                                               AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                                               AND ((VRINIFAIXA < V_VRITEMPROD)
                                               AND (VRFIMFAIXA >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                                               AND (INSTR(NVL(P_CDTIPOOPER,'_'), NVL(RTRIM(CDTIPOOPER), NVL(P_CDTIPOOPER,'_'))) = 1  OR V_IDUTALIQTPOPER = w_N)
                                               AND (DTINIVALID <= P_INIVALID)))) LOOP
                  SELECT COUNT(*)
                    INTO V_EXISTE
                    FROM ALIQTEMP
                   WHERE NRALIQTEMP = P_FILIAL||P_LANCTONF;
                  IF V_EXISTE > 0 THEN
                     DELETE FROM ALIQTEMP
                     WHERE NRALIQTEMP = P_FILIAL||P_LANCTONF;
                  END IF;
                  SELECT COUNT(*)
                    INTO V_COUNTMENS
                    FROM MENSAGEM
                   WHERE CDMENSAGEM = C_ALIQUOTA.CDMENSAGEM
                     AND IDSITUACAOMENS = 'I';
                  IF V_COUNTMENS > 0 THEN
                     V_DSMENSALIQU := NULL;
                  ELSE
                     V_DSMENSALIQU := C_ALIQUOTA.DSMENSALIQU;
                  END IF;
                  INSERT INTO ALIQTEMP
                     (NRALIQTEMP, NRSEQUALIQ, VRPREDBCTMP, VRPARDEDTMP,
                      VRALIQUTMP, DSMENSALITMP, IDTRIMPSTTMP, VRPBCSTTMP,
                      IDPMCBSCALTMP, VR1PREDBCTMP, CDINSCESTAATMP, VRADICALIQFECP,
                      CDBENEFFISCAL, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF)
                  VALUES
                     (P_FILIAL||P_LANCTONF, V_SEQUENCIA, C_ALIQUOTA.VRPERREDBC, C_ALIQUOTA.VRPARDEDUZ,
                      C_ALIQUOTA.VRALIQUOTA, V_DSMENSALIQU, C_ALIQUOTA.IDTRATIMPST, C_ALIQUOTA.VRPBCSUBTRIB,
                      C_ALIQUOTA.IDPMCBASECAL, C_ALIQUOTA.VR1PERREDBC, P_INSCESTA, C_ALIQUOTA.VRADICALIQFECP, 
                      C_ALIQUOTA.CDBENEFFISCAL, C_ALIQUOTA.IDCONSDIFALIQ, C_ALIQUOTA.IDIMPODESONERA, C_ALIQUOTA.IDCONSDESONVRNF);
                  V_SEQUENCIA := LPAD(RTRIM(V_SEQUENCIA + '01'),2,0);
               END LOOP;
            END IF;
         END IF;
      END IF;
      /*------------------------IMPOSTOS FEDERAIS--------------------------------------*/
      SELECT COUNT(*)
        INTO V_COUNT
        FROM ALIQTEMP
       WHERE NRALIQTEMP = P_FILIAL||P_LANCTONF;
      IF V_COUNT = 0 THEN
         IF P_CDGRUPOFISC IS NOT NULL THEN /*Se há grupo fiscal*/
            IF V_IDPRODNOTA = w_P THEN /*Se imposto do item*/
               SELECT MAX(CDTIPOOPER), COUNT(*)
                 INTO V_CDTIPOOPER, V_CONTADOR
                 FROM ALIQUOTA A, PRODUTO P
                WHERE (CDIMPOSTO    = P_IMPOSTO)
                  AND (IDENTRSAIDAL = P_ENTRSAIDAL)
                  AND (CDEMPRESA    = P_EMPRESA)
                  AND (CDINSCESTA   IS NULL)
                  AND (CDGRUPOFISC  = P_CDGRUPOFISC)
                  AND ((CDPAISORIG  = P_PAISORIG) AND (SGESTAORIG  = P_ESTAORIG) OR V_UTUFORIG = w_N)
                  AND ((CDPAISDEST  = P_PAISDEST) AND (SGESTADEST  = P_ESTADEST) OR V_UTUFDEST = w_N)
                  AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                  AND ((VRINIFAIXA  < V_VRITEMPROD) AND (VRFIMFAIXA  >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                  AND (INSTR(NVL(P_CDTIPOOPER,'_'), NVL(RTRIM(CDTIPOOPER), NVL(P_CDTIPOOPER,'_'))) = 1  OR V_IDUTALIQTPOPER = w_N)
                  AND (A.CDPRODUTO = P.CDPRODUTO(+))
                  AND (INSTR(NVL(P_PRODUTO,'_'),NVL(RTRIM(P.CDARVPROD),NVL(P_PRODUTO,'_'))) = 1);
               IF NOT (V_CDTIPOOPER IS NULL) THEN /*Se possui alíquota por tipo de operação*/
                  SELECT MAX(P.CDARVPROD)
                    INTO V_CDARVPROD
                    FROM ALIQUOTA A, PRODUTO P
                   WHERE (CDIMPOSTO    = P_IMPOSTO)
                     AND (IDENTRSAIDAL = P_ENTRSAIDAL)
                     AND (CDEMPRESA    = P_EMPRESA)
                     AND (CDINSCESTA   IS NULL)
                     AND (CDGRUPOFISC  = P_CDGRUPOFISC)
                     AND ((CDPAISORIG  = P_PAISORIG) AND (SGESTAORIG  = P_ESTAORIG) OR V_UTUFORIG = w_N)
                     AND ((CDPAISDEST  = P_PAISDEST) AND (SGESTADEST  = P_ESTADEST) OR V_UTUFDEST = w_N)
                     AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                     AND ((VRINIFAIXA  < V_VRITEMPROD) AND (VRFIMFAIXA  >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                     AND (CDTIPOOPER = V_CDTIPOOPER OR V_IDUTALIQTPOPER = w_N)
                     AND (A.CDPRODUTO = P.CDPRODUTO(+))
                     AND (INSTR(NVL(P_PRODUTO,'_'),NVL(RTRIM(P.CDARVPROD),NVL(P_PRODUTO,'_'))) = 1);
               ELSIF (V_CDTIPOOPER IS NULL) THEN /*Se não possui alíquota por tipo de operação*/
                  SELECT MAX(P.CDARVPROD)
                    INTO V_CDARVPROD
                    FROM ALIQUOTA A, PRODUTO P
                   WHERE (CDIMPOSTO    = P_IMPOSTO)
                     AND (IDENTRSAIDAL = P_ENTRSAIDAL)
                     AND (CDEMPRESA    = P_EMPRESA)
                     AND (CDINSCESTA   IS NULL)
                     AND (CDGRUPOFISC  = P_CDGRUPOFISC)
                     AND ((CDPAISORIG  = P_PAISORIG) AND (SGESTAORIG  = P_ESTAORIG) OR V_UTUFORIG = w_N)
                     AND ((CDPAISDEST  = P_PAISDEST) AND (SGESTADEST  = P_ESTADEST) OR V_UTUFDEST = w_N)
                     AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                     AND ((VRINIFAIXA  < V_VRITEMPROD) AND (VRFIMFAIXA  >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                     AND (INSTR(NVL(P_CDTIPOOPER,'_'), NVL(RTRIM(CDTIPOOPER), NVL(P_CDTIPOOPER,'_'))) = 1  OR V_IDUTALIQTPOPER = w_N)
                     AND (A.CDPRODUTO = P.CDPRODUTO(+))
                     AND (INSTR(NVL(P_PRODUTO,'_'),NVL(RTRIM(P.CDARVPROD),NVL(P_PRODUTO,'_'))) = 1);
               END IF;
            ELSE /*Se imposto da nota*/
               SELECT MAX(A.CDPRODUTO), COUNT(*), MAX(CDTIPOOPER)
                 INTO V_CDARVPROD, V_CONTADOR, V_CDTIPOOPER
                 FROM ALIQUOTA A
                WHERE (CDIMPOSTO    = P_IMPOSTO)
                  AND (IDENTRSAIDAL = P_ENTRSAIDAL)
                  AND (CDEMPRESA    = P_EMPRESA)
                  AND (CDINSCESTA   IS NULL)
                  AND (CDGRUPOFISC  = P_CDGRUPOFISC)
                  AND ((CDPAISORIG  = P_PAISORIG) AND (SGESTAORIG  = P_ESTAORIG) OR V_UTUFORIG = w_N)
                  AND ((CDPAISDEST  = P_PAISDEST) AND (SGESTADEST  = P_ESTADEST) OR V_UTUFDEST = w_N)
                  AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                  AND ((VRINIFAIXA  < V_VRITEMPROD) AND (VRFIMFAIXA  >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                  AND (INSTR(NVL(P_CDTIPOOPER,'_'), NVL(RTRIM(CDTIPOOPER), NVL(P_CDTIPOOPER,'_'))) = 1  OR V_IDUTALIQTPOPER = w_N)
                  AND (A.CDPRODUTO IS NULL);
            END IF;
            IF V_CONTADOR > 0 THEN /*Se encontrou alíquota para o grupo fiscal*/
               IF NOT (V_CDTIPOOPER IS NULL) THEN /*Se possui alíquota por tipo de operação*/
                  IF NOT (V_CDARVPROD IS NULL) THEN /*Se há alíquota para o produto de maior nível*/
                     FOR C_ALIQUOTA IN (
                        SELECT A.NRALIQUOTA, VRPERREDBC, VR1PERREDBC, VRPARDEDUZ, VRALIQUOTA, DSMENSALIQU, IDTRATIMPST,
                               VRPBCSUBTRIB, IDPMCBASECAL, A.CDTIPOOPER, CDMENSAGEM, VRADICALIQFECP, CDBENEFFISCAL,
                               IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF
                          FROM ALIQUOTA A, MENSALIQU, PRODUTO P
                         WHERE (A.NRALIQUOTA = MENSALIQU.NRALIQUOTA(+))
                           AND (A.CDIMPOSTO = P_IMPOSTO)
                           AND (A.IDENTRSAIDAL = P_ENTRSAIDAL)
                           AND (A.CDEMPRESA = P_EMPRESA)
                           AND (A.CDINSCESTA IS NULL)
                           AND (A.CDGRUPOFISC = P_CDGRUPOFISC)
                           AND (A.CDPRODUTO = P.CDPRODUTO(+))
                           AND (P.CDARVPROD = V_CDARVPROD)
                           AND ((A.CDPAISORIG = P_PAISORIG)
                           AND (A.SGESTAORIG = P_ESTAORIG) OR V_UTUFORIG = w_N)
                           AND ((A.CDPAISDEST = P_PAISDEST) AND (A.SGESTADEST = P_ESTADEST) OR V_UTUFDEST = w_N)
                           AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                           AND ((A.VRINIFAIXA < V_VRITEMPROD) AND (A.VRFIMFAIXA >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                           AND (CDTIPOOPER = V_CDTIPOOPER)
                           AND (A.DTINIVALID = ( SELECT MAX(DTINIVALID)
                                                   FROM ALIQUOTA A, PRODUTO P
                                                  WHERE (CDIMPOSTO = P_IMPOSTO)
                                                    AND (IDENTRSAIDAL = P_ENTRSAIDAL)
                                                    AND (CDEMPRESA = P_EMPRESA)
                                                    AND (CDINSCESTA IS NULL)
                                                    AND (CDGRUPOFISC = P_CDGRUPOFISC)
                                                    AND (A.CDPRODUTO = P.CDPRODUTO(+))
                                                    AND (P.CDARVPROD = V_CDARVPROD)
                                                    AND ((CDPAISORIG = P_PAISORIG)
                                                    AND (SGESTAORIG = P_ESTAORIG) OR V_UTUFORIG = w_N)
                                                    AND ((CDPAISDEST = P_PAISDEST) AND (SGESTADEST = P_ESTADEST) OR V_UTUFDEST = w_N)
                                                    AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                                                    AND ((VRINIFAIXA < V_VRITEMPROD) AND (VRFIMFAIXA >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                                                    AND (CDTIPOOPER = V_CDTIPOOPER)
                                                    AND (DTINIVALID <= P_INIVALID)))) LOOP
                        SELECT COUNT(*)
                          INTO V_COUNTMENS
                          FROM MENSAGEM
                         WHERE CDMENSAGEM = C_ALIQUOTA.CDMENSAGEM
                           AND IDSITUACAOMENS = 'I';
                        IF V_COUNTMENS > 0 THEN
                           V_DSMENSALIQU := NULL;
                        ELSE
                           V_DSMENSALIQU := C_ALIQUOTA.DSMENSALIQU;
                        END IF;
                        INSERT INTO ALIQTEMP
                           (NRALIQTEMP, NRSEQUALIQ, VRPREDBCTMP, VRPARDEDTMP,
                            VRALIQUTMP, DSMENSALITMP, IDTRIMPSTTMP, VRPBCSTTMP,
                            IDPMCBSCALTMP, CDTIPOOPERTMP, CDINSCESTAATMP, VR1PREDBCTMP,
                            VRADICALIQFECP, CDBENEFFISCAL, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF)
                        VALUES
                           (P_FILIAL||P_LANCTONF, V_SEQUENCIA, C_ALIQUOTA.VRPERREDBC, C_ALIQUOTA.VRPARDEDUZ,
                            C_ALIQUOTA.VRALIQUOTA, V_DSMENSALIQU, C_ALIQUOTA.IDTRATIMPST, C_ALIQUOTA.VRPBCSUBTRIB, 
                            C_ALIQUOTA.IDPMCBASECAL, C_ALIQUOTA.CDTIPOOPER, NULL, C_ALIQUOTA.VR1PERREDBC, 
                            C_ALIQUOTA.VRADICALIQFECP, C_ALIQUOTA.CDBENEFFISCAL, C_ALIQUOTA.IDCONSDIFALIQ, C_ALIQUOTA.IDIMPODESONERA, C_ALIQUOTA.IDCONSDESONVRNF);
                        V_SEQUENCIA := LPAD(RTRIM(V_SEQUENCIA + '01'),2,0);
                     END LOOP;
                  ELSIF (V_CDARVPROD IS NULL) THEN /*Se há alíquota para o produto todos*/
                     FOR C_ALIQUOTA IN (
                        SELECT A.NRALIQUOTA, VRPERREDBC, VR1PERREDBC, VRPARDEDUZ, VRALIQUOTA, DSMENSALIQU, IDTRATIMPST, VRPBCSUBTRIB, IDPMCBASECAL, A.CDTIPOOPER,
                               CDMENSAGEM, VRADICALIQFECP, CDBENEFFISCAL, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF
                          FROM ALIQUOTA A, MENSALIQU
                         WHERE (A.NRALIQUOTA = MENSALIQU.NRALIQUOTA(+))
                           AND (A.CDIMPOSTO = P_IMPOSTO)
                           AND (A.IDENTRSAIDAL = P_ENTRSAIDAL)
                           AND (A.CDEMPRESA = P_EMPRESA)
                           AND (A.CDINSCESTA IS NULL)
                           AND (A.CDGRUPOFISC = P_CDGRUPOFISC)
                           AND (A.CDPRODUTO IS NULL)
                           AND ((A.CDPAISORIG = P_PAISORIG)
                           AND (A.SGESTAORIG = P_ESTAORIG) OR V_UTUFORIG = w_N)
                           AND ((A.CDPAISDEST = P_PAISDEST) AND (A.SGESTADEST = P_ESTADEST) OR V_UTUFDEST = w_N)
                           AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                           AND ((A.VRINIFAIXA < V_VRITEMPROD) AND (A.VRFIMFAIXA >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                           AND (CDTIPOOPER = V_CDTIPOOPER)
                           AND (A.DTINIVALID = ( SELECT MAX(DTINIVALID)
                                                   FROM ALIQUOTA
                                                  WHERE (CDIMPOSTO = P_IMPOSTO)
                                                    AND (IDENTRSAIDAL = P_ENTRSAIDAL)
                                                    AND (CDEMPRESA = P_EMPRESA)
                                                    AND (CDINSCESTA IS NULL)
                                                    AND (CDGRUPOFISC = P_CDGRUPOFISC)
                                                    AND (CDPRODUTO IS NULL)
                                                    AND ((CDPAISORIG = P_PAISORIG)
                                                    AND (SGESTAORIG = P_ESTAORIG) OR V_UTUFORIG = w_N)
                                                    AND ((CDPAISDEST = P_PAISDEST)
                                                    AND (SGESTADEST = P_ESTADEST) OR V_UTUFDEST = w_N)
                                                    AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                                                    AND ((VRINIFAIXA < V_VRITEMPROD)
                                                    AND (VRFIMFAIXA >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                                                    AND (CDTIPOOPER = V_CDTIPOOPER)
                                                    AND (DTINIVALID <= P_INIVALID)))) LOOP
                        SELECT COUNT(*)
                          INTO V_COUNTMENS
                          FROM MENSAGEM
                         WHERE CDMENSAGEM = C_ALIQUOTA.CDMENSAGEM
                           AND IDSITUACAOMENS = 'I';
                        IF V_COUNTMENS > 0 THEN
                           V_DSMENSALIQU := NULL;
                        ELSE
                           V_DSMENSALIQU := C_ALIQUOTA.DSMENSALIQU;
                        END IF;
                        INSERT INTO ALIQTEMP
                           (NRALIQTEMP, NRSEQUALIQ, VRPREDBCTMP, VRPARDEDTMP,
                            VRALIQUTMP, DSMENSALITMP, IDTRIMPSTTMP, VRPBCSTTMP,
                            IDPMCBSCALTMP, CDTIPOOPERTMP, CDINSCESTAATMP, VR1PREDBCTMP,
                            VRADICALIQFECP, CDBENEFFISCAL, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF)
                        VALUES
                           (P_FILIAL||P_LANCTONF, V_SEQUENCIA, C_ALIQUOTA.VRPERREDBC, C_ALIQUOTA.VRPARDEDUZ,
                            C_ALIQUOTA.VRALIQUOTA, V_DSMENSALIQU, C_ALIQUOTA.IDTRATIMPST, C_ALIQUOTA.VRPBCSUBTRIB, 
                            C_ALIQUOTA.IDPMCBASECAL, C_ALIQUOTA.CDTIPOOPER, NULL, C_ALIQUOTA.VR1PERREDBC, 
                            C_ALIQUOTA.VRADICALIQFECP, C_ALIQUOTA.CDBENEFFISCAL, C_ALIQUOTA.IDCONSDIFALIQ, C_ALIQUOTA.IDIMPODESONERA, C_ALIQUOTA.IDCONSDESONVRNF);
                        V_SEQUENCIA := LPAD(RTRIM(V_SEQUENCIA + '01'),2,0);
                     END LOOP;
                  END IF;
               ELSIF (V_CDTIPOOPER IS NULL) THEN /*Se não possui alíquota por tipo de operação*/
                  IF NOT (V_CDARVPROD IS NULL) THEN /*Se há alíquota para o produto de maior nível*/
                     FOR C_ALIQUOTA IN (
                         SELECT A.NRALIQUOTA, VRPERREDBC, VR1PERREDBC, VRPARDEDUZ, VRALIQUOTA, DSMENSALIQU, IDTRATIMPST, VRPBCSUBTRIB, IDPMCBASECAL, CDMENSAGEM,
                                VRADICALIQFECP, CDBENEFFISCAL, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF
                           FROM ALIQUOTA A, MENSALIQU, PRODUTO P
                          WHERE (A.NRALIQUOTA = MENSALIQU.NRALIQUOTA(+))
                            AND (A.CDIMPOSTO = P_IMPOSTO)
                            AND (A.IDENTRSAIDAL = P_ENTRSAIDAL)
                            AND (A.CDEMPRESA = P_EMPRESA)
                            AND (A.CDINSCESTA IS NULL)
                            AND (A.CDGRUPOFISC = P_CDGRUPOFISC)
                            AND (A.CDPRODUTO = P.CDPRODUTO(+))
                            AND (P.CDARVPROD = V_CDARVPROD)
                            AND ((A.CDPAISORIG = P_PAISORIG)
                            AND (A.SGESTAORIG = P_ESTAORIG) OR V_UTUFORIG = w_N)
                            AND ((A.CDPAISDEST = P_PAISDEST) AND (A.SGESTADEST = P_ESTADEST) OR V_UTUFDEST = w_N)
                            AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                            AND ((A.VRINIFAIXA < V_VRITEMPROD) AND (A.VRFIMFAIXA >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                            AND (INSTR(NVL(P_CDTIPOOPER,'_'), NVL(RTRIM(CDTIPOOPER), NVL(P_CDTIPOOPER,'_'))) = 1  OR V_IDUTALIQTPOPER = w_N)
                            AND (A.DTINIVALID = ( SELECT MAX(DTINIVALID)
                                                    FROM ALIQUOTA A, PRODUTO P
                                                   WHERE (CDIMPOSTO = P_IMPOSTO)
                                                     AND (IDENTRSAIDAL = P_ENTRSAIDAL)
                                                     AND (CDEMPRESA = P_EMPRESA)
                                                     AND (CDINSCESTA IS NULL)
                                                     AND (CDGRUPOFISC = P_CDGRUPOFISC)
                                                     AND (A.CDPRODUTO = P.CDPRODUTO(+))
                                                     AND (P.CDARVPROD = V_CDARVPROD)
                                                     AND ((CDPAISORIG = P_PAISORIG)
                                                     AND (SGESTAORIG = P_ESTAORIG) OR V_UTUFORIG = w_N)
                                                     AND ((CDPAISDEST = P_PAISDEST) AND (SGESTADEST = P_ESTADEST) OR V_UTUFDEST = w_N)
                                                     AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                                                     AND ((VRINIFAIXA < V_VRITEMPROD) AND (VRFIMFAIXA >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                                                     AND (INSTR(NVL(P_CDTIPOOPER,'_'), NVL(RTRIM(CDTIPOOPER), NVL(P_CDTIPOOPER,'_'))) = 1  OR V_IDUTALIQTPOPER = w_N)
                                                     AND (DTINIVALID <= P_INIVALID)))) LOOP
                        SELECT COUNT(*)
                          INTO V_COUNTMENS
                          FROM MENSAGEM
                         WHERE CDMENSAGEM = C_ALIQUOTA.CDMENSAGEM
                           AND IDSITUACAOMENS = 'I';
                        IF V_COUNTMENS > 0 THEN
                           V_DSMENSALIQU := NULL;
                        ELSE
                           V_DSMENSALIQU := C_ALIQUOTA.DSMENSALIQU;
                        END IF;
                        INSERT INTO ALIQTEMP
                           (NRALIQTEMP, NRSEQUALIQ, VRPREDBCTMP, VRPARDEDTMP,
                            VRALIQUTMP, DSMENSALITMP, IDTRIMPSTTMP, VRPBCSTTMP,
                            IDPMCBSCALTMP, CDINSCESTAATMP, VR1PREDBCTMP, VRADICALIQFECP,
                            CDBENEFFISCAL, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF)
                        VALUES
                           (P_FILIAL||P_LANCTONF, V_SEQUENCIA, C_ALIQUOTA.VRPERREDBC, C_ALIQUOTA.VRPARDEDUZ,
                            C_ALIQUOTA.VRALIQUOTA, V_DSMENSALIQU, C_ALIQUOTA.IDTRATIMPST, C_ALIQUOTA.VRPBCSUBTRIB, 
                            C_ALIQUOTA.IDPMCBASECAL, NULL, C_ALIQUOTA.VR1PERREDBC, C_ALIQUOTA.VRADICALIQFECP, 
                            C_ALIQUOTA.CDBENEFFISCAL, C_ALIQUOTA.IDCONSDIFALIQ, C_ALIQUOTA.IDIMPODESONERA, C_ALIQUOTA.IDCONSDESONVRNF);
                        V_SEQUENCIA := LPAD(RTRIM(V_SEQUENCIA + '01'),2,0);
                     END LOOP;
                  ELSIF (V_CDARVPROD IS NULL) THEN /*Se há alíquota para o produto todos*/
                     FOR C_ALIQUOTA IN (
                        SELECT A.NRALIQUOTA, VRPERREDBC, VR1PERREDBC, VRPARDEDUZ, VRALIQUOTA, DSMENSALIQU, IDTRATIMPST, VRPBCSUBTRIB, IDPMCBASECAL, CDMENSAGEM,
                               VRADICALIQFECP, CDBENEFFISCAL, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF
                          FROM ALIQUOTA A, MENSALIQU
                         WHERE (A.NRALIQUOTA = MENSALIQU.NRALIQUOTA(+))
                           AND (A.CDIMPOSTO = P_IMPOSTO)
                           AND (A.IDENTRSAIDAL = P_ENTRSAIDAL)
                           AND (A.CDEMPRESA = P_EMPRESA)
                           AND (A.CDINSCESTA IS NULL)
                           AND (A.CDGRUPOFISC = P_CDGRUPOFISC)
                           AND (A.CDPRODUTO IS NULL)
                           AND ((A.CDPAISORIG = P_PAISORIG)
                           AND (A.SGESTAORIG = P_ESTAORIG) OR V_UTUFORIG = w_N)
                           AND ((A.CDPAISDEST = P_PAISDEST) AND (A.SGESTADEST = P_ESTADEST) OR V_UTUFDEST = w_N)
                           AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                           AND ((A.VRINIFAIXA < V_VRITEMPROD) AND (A.VRFIMFAIXA >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                           AND (INSTR(NVL(P_CDTIPOOPER,'_'), NVL(RTRIM(CDTIPOOPER), NVL(P_CDTIPOOPER,'_'))) = 1  OR V_IDUTALIQTPOPER = w_N)
                           AND (A.DTINIVALID = ( SELECT MAX(DTINIVALID)
                                                   FROM ALIQUOTA
                                                  WHERE (CDIMPOSTO = P_IMPOSTO)
                                                    AND (IDENTRSAIDAL = P_ENTRSAIDAL)
                                                    AND (CDEMPRESA = P_EMPRESA)
                                                    AND (CDINSCESTA IS NULL)
                                                    AND (CDGRUPOFISC = P_CDGRUPOFISC)
                                                    AND (CDPRODUTO IS NULL)
                                                    AND ((CDPAISORIG = P_PAISORIG)
                                                    AND (SGESTAORIG = P_ESTAORIG) OR V_UTUFORIG = w_N)
                                                    AND ((CDPAISDEST = P_PAISDEST)
                                                    AND (SGESTADEST = P_ESTADEST) OR V_UTUFDEST = w_N)
                                                    AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                                                    AND ((VRINIFAIXA < V_VRITEMPROD)
                                                    AND (VRFIMFAIXA >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                                                    AND (INSTR(NVL(P_CDTIPOOPER,'_'), NVL(RTRIM(CDTIPOOPER), NVL(P_CDTIPOOPER,'_'))) = 1  OR V_IDUTALIQTPOPER = w_N)
                                                    AND (DTINIVALID <= P_INIVALID)))) LOOP
                        SELECT COUNT(*)
                          INTO V_COUNTMENS
                          FROM MENSAGEM
                         WHERE CDMENSAGEM = C_ALIQUOTA.CDMENSAGEM
                           AND IDSITUACAOMENS = 'I';
                        IF V_COUNTMENS > 0 THEN
                           V_DSMENSALIQU := NULL;
                        ELSE
                           V_DSMENSALIQU := C_ALIQUOTA.DSMENSALIQU;
                        END IF;
                        INSERT INTO ALIQTEMP
                           (NRALIQTEMP, NRSEQUALIQ, VRPREDBCTMP, VRPARDEDTMP,
                            VRALIQUTMP, DSMENSALITMP, IDTRIMPSTTMP, VRPBCSTTMP,
                            IDPMCBSCALTMP, CDINSCESTAATMP, VR1PREDBCTMP, VRADICALIQFECP,
                            CDBENEFFISCAL, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF)
                        VALUES
                           (P_FILIAL||P_LANCTONF, V_SEQUENCIA, C_ALIQUOTA.VRPERREDBC, C_ALIQUOTA.VRPARDEDUZ,
                            C_ALIQUOTA.VRALIQUOTA, V_DSMENSALIQU, C_ALIQUOTA.IDTRATIMPST, C_ALIQUOTA.VRPBCSUBTRIB, 
                            C_ALIQUOTA.IDPMCBASECAL, NULL, C_ALIQUOTA.VR1PERREDBC, C_ALIQUOTA.VRADICALIQFECP, 
                            C_ALIQUOTA.CDBENEFFISCAL, C_ALIQUOTA.IDCONSDIFALIQ, C_ALIQUOTA.IDIMPODESONERA, C_ALIQUOTA.IDCONSDESONVRNF);
                        V_SEQUENCIA := LPAD(RTRIM(V_SEQUENCIA + '01'),2,0);
                     END LOOP;
                  END IF;
               END IF;
            END IF;
         ELSE /*Se não há grupo fiscal*/
            SELECT MAX(A.CDTIPOOPER)
              INTO V_CDTIPOOPER
              FROM ALIQUOTA A, PRODUTO P
             WHERE (CDIMPOSTO    = P_IMPOSTO)
               AND (IDENTRSAIDAL = P_ENTRSAIDAL)
               AND (CDEMPRESA    = P_EMPRESA)
               AND (CDINSCESTA   IS NULL)
               AND (CDGRUPOFISC IS NULL)
               AND ((CDPAISORIG  = P_PAISORIG) AND (SGESTAORIG  = P_ESTAORIG) OR V_UTUFORIG = w_N)
               AND ((CDPAISDEST  = P_PAISDEST) AND (SGESTADEST  = P_ESTADEST) OR V_UTUFDEST = w_N)
               AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
               AND ((VRINIFAIXA  < V_VRITEMPROD) AND (VRFIMFAIXA  >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
               AND (INSTR(NVL(P_CDTIPOOPER,'_'), NVL(RTRIM(CDTIPOOPER), NVL(P_CDTIPOOPER,'_'))) = 1  OR V_IDUTALIQTPOPER = w_N)
               AND (A.CDPRODUTO = P.CDPRODUTO(+))
               AND (INSTR(NVL(P_PRODUTO,'_'),NVL(RTRIM(P.CDARVPROD),NVL(P_PRODUTO,'_'))) = 1);
            IF NOT (V_CDTIPOOPER IS NULL) THEN /*Se possui alíquota por tipo de operação*/
               SELECT MAX(P.CDARVPROD)
                 INTO V_CDARVPROD
                 FROM ALIQUOTA A, PRODUTO P
                WHERE (CDIMPOSTO    = P_IMPOSTO)
                  AND (IDENTRSAIDAL = P_ENTRSAIDAL)
                  AND (CDEMPRESA    = P_EMPRESA)
                  AND (CDINSCESTA   IS NULL)
                  AND (CDGRUPOFISC IS NULL)
                  AND ((CDPAISORIG  = P_PAISORIG) AND (SGESTAORIG  = P_ESTAORIG) OR V_UTUFORIG = w_N)
                  AND ((CDPAISDEST  = P_PAISDEST) AND (SGESTADEST  = P_ESTADEST) OR V_UTUFDEST = w_N)
                  AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                  AND ((VRINIFAIXA  < V_VRITEMPROD) AND (VRFIMFAIXA  >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                  AND (CDTIPOOPER = V_CDTIPOOPER OR V_IDUTALIQTPOPER = w_N)
                  AND (A.CDPRODUTO = P.CDPRODUTO(+))
                  AND (INSTR(NVL(P_PRODUTO,'_'),NVL(RTRIM(P.CDARVPROD),NVL(P_PRODUTO,'_'))) = 1);
            ELSIF (V_CDTIPOOPER IS NULL) THEN /*Se não possui alíquota por tipo de operação*/
               SELECT MAX(P.CDARVPROD)
                 INTO V_CDARVPROD
                 FROM ALIQUOTA A, PRODUTO P
                WHERE (CDIMPOSTO    = P_IMPOSTO)
                  AND (IDENTRSAIDAL = P_ENTRSAIDAL)
                  AND (CDEMPRESA    = P_EMPRESA)
                  AND (CDINSCESTA   IS NULL)
                  AND (CDGRUPOFISC IS NULL)
                  AND ((CDPAISORIG  = P_PAISORIG) AND (SGESTAORIG  = P_ESTAORIG) OR V_UTUFORIG = w_N)
                  AND ((CDPAISDEST  = P_PAISDEST) AND (SGESTADEST  = P_ESTADEST) OR V_UTUFDEST = w_N)
                  AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                  AND ((VRINIFAIXA  < V_VRITEMPROD) AND (VRFIMFAIXA  >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                  AND (INSTR(NVL(P_CDTIPOOPER,'_'), NVL(RTRIM(CDTIPOOPER), NVL(P_CDTIPOOPER,'_'))) = 1  OR V_IDUTALIQTPOPER = w_N)
                  AND (A.CDPRODUTO = P.CDPRODUTO(+))
                  AND (INSTR(NVL(P_PRODUTO,'_'),NVL(RTRIM(P.CDARVPROD),NVL(P_PRODUTO,'_'))) = 1);
            END IF;
            IF NOT (V_CDARVPROD IS NULL) THEN /*Se há alíquota para o maior nivel*/
               IF NOT (V_CDTIPOOPER IS NULL) THEN /*Se possui alíquota por tipo de operação*/
                  FOR C_ALIQUOTA IN (
                     SELECT A.NRALIQUOTA, VRPERREDBC, VR1PERREDBC, VRPARDEDUZ, VRALIQUOTA, DSMENSALIQU, IDTRATIMPST, VRPBCSUBTRIB, IDPMCBASECAL, A.CDTIPOOPER,
                            CDMENSAGEM, VRADICALIQFECP, CDBENEFFISCAL, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF
                       FROM ALIQUOTA A, MENSALIQU, PRODUTO P
                      WHERE (A.NRALIQUOTA = MENSALIQU.NRALIQUOTA(+))
                        AND (A.CDIMPOSTO = P_IMPOSTO)
                        AND (A.IDENTRSAIDAL = P_ENTRSAIDAL)
                        AND (A.CDEMPRESA = P_EMPRESA)
                        AND (A.CDINSCESTA IS NULL)
                        AND (A.CDGRUPOFISC IS NULL)
                        AND (A.CDPRODUTO = P.CDPRODUTO(+))
                        AND (P.CDARVPROD = V_CDARVPROD)
                        AND ((A.CDPAISORIG = P_PAISORIG)
                        AND (A.SGESTAORIG = P_ESTAORIG) OR V_UTUFORIG = w_N)
                        AND ((A.CDPAISDEST = P_PAISDEST)
                        AND (A.SGESTADEST = P_ESTADEST) OR V_UTUFDEST = w_N)
                        AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                        AND ((A.VRINIFAIXA < V_VRITEMPROD)
                        AND (A.VRFIMFAIXA >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                        AND (CDTIPOOPER = V_CDTIPOOPER)
                        AND (A.DTINIVALID = ( SELECT MAX(DTINIVALID)
                                                FROM ALIQUOTA A, PRODUTO P
                                               WHERE (CDIMPOSTO = P_IMPOSTO)
                                                 AND (IDENTRSAIDAL = P_ENTRSAIDAL)
                                                 AND (CDEMPRESA = P_EMPRESA)
                                                 AND (CDINSCESTA IS NULL)
                                                 AND (CDGRUPOFISC IS NULL)
                                                 AND (A.CDPRODUTO = P.CDPRODUTO(+))
                                                 AND (P.CDARVPROD = V_CDARVPROD)
                                                 AND ((CDPAISORIG = P_PAISORIG)
                                                 AND (SGESTAORIG = P_ESTAORIG) OR V_UTUFORIG = w_N)
                                                 AND ((CDPAISDEST = P_PAISDEST)
                                                 AND (SGESTADEST = P_ESTADEST) OR V_UTUFDEST = w_N)
                                                 AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                                                 AND ((VRINIFAIXA < V_VRITEMPROD)
                                                 AND (VRFIMFAIXA >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                                                 AND (CDTIPOOPER = V_CDTIPOOPER)
                                                 AND (DTINIVALID <= P_INIVALID)))) LOOP
                     SELECT COUNT(*)
                       INTO V_COUNTMENS
                       FROM MENSAGEM
                      WHERE CDMENSAGEM = C_ALIQUOTA.CDMENSAGEM
                        AND IDSITUACAOMENS = 'I';
                     IF V_COUNTMENS > 0 THEN
                        V_DSMENSALIQU := NULL;
                     ELSE
                        V_DSMENSALIQU := C_ALIQUOTA.DSMENSALIQU;
                     END IF;
                     INSERT INTO ALIQTEMP
                       (NRALIQTEMP, NRSEQUALIQ, VRPREDBCTMP, VRPARDEDTMP,
                        VRALIQUTMP, DSMENSALITMP, IDTRIMPSTTMP, VRPBCSTTMP,
                        IDPMCBSCALTMP, CDTIPOOPERTMP, CDINSCESTAATMP, VR1PREDBCTMP,
                        VRADICALIQFECP, CDBENEFFISCAL, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF)
                     VALUES
                       (P_FILIAL||P_LANCTONF, V_SEQUENCIA, C_ALIQUOTA.VRPERREDBC, C_ALIQUOTA.VRPARDEDUZ,
                        C_ALIQUOTA.VRALIQUOTA, V_DSMENSALIQU, C_ALIQUOTA.IDTRATIMPST, C_ALIQUOTA.VRPBCSUBTRIB, 
                        C_ALIQUOTA.IDPMCBASECAL, C_ALIQUOTA.CDTIPOOPER, NULL, C_ALIQUOTA.VR1PERREDBC, 
                        C_ALIQUOTA.VRADICALIQFECP, C_ALIQUOTA.CDBENEFFISCAL, C_ALIQUOTA.IDCONSDIFALIQ, C_ALIQUOTA.IDIMPODESONERA, C_ALIQUOTA.IDCONSDESONVRNF);
                     V_SEQUENCIA := LPAD(RTRIM(V_SEQUENCIA + '01'),2,0);
                  END LOOP;
               ELSIF (V_CDTIPOOPER IS NULL) THEN /*Se não possui alíquota por tipo de operação*/
                  FOR C_ALIQUOTA IN (
                      SELECT A.NRALIQUOTA, VRPERREDBC, VR1PERREDBC, VRPARDEDUZ, VRALIQUOTA, DSMENSALIQU, IDTRATIMPST, VRPBCSUBTRIB, IDPMCBASECAL,
                             CDMENSAGEM, VRADICALIQFECP, CDBENEFFISCAL, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF
                        FROM ALIQUOTA A, MENSALIQU, PRODUTO P
                       WHERE (A.NRALIQUOTA = MENSALIQU.NRALIQUOTA(+))
                         AND (A.CDIMPOSTO = P_IMPOSTO)
                         AND (A.IDENTRSAIDAL = P_ENTRSAIDAL)
                         AND (A.CDEMPRESA = P_EMPRESA)
                         AND (A.CDINSCESTA IS NULL)
                         AND (A.CDGRUPOFISC IS NULL)
                         AND (A.CDPRODUTO = P.CDPRODUTO(+))
                         AND (P.CDARVPROD = V_CDARVPROD)
                         AND ((A.CDPAISORIG = P_PAISORIG)
                         AND (A.SGESTAORIG = P_ESTAORIG) OR V_UTUFORIG = w_N)
                         AND ((A.CDPAISDEST = P_PAISDEST)
                         AND (A.SGESTADEST = P_ESTADEST) OR V_UTUFDEST = w_N)
                         AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                         AND ((A.VRINIFAIXA < V_VRITEMPROD)
                         AND (A.VRFIMFAIXA >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                         AND (INSTR(NVL(P_CDTIPOOPER,'_'), NVL(RTRIM(CDTIPOOPER), NVL(P_CDTIPOOPER,'_'))) = 1  OR V_IDUTALIQTPOPER = w_N)
                         AND (A.DTINIVALID = ( SELECT MAX(DTINIVALID)
                                                 FROM ALIQUOTA A, PRODUTO P
                                                WHERE (CDIMPOSTO = P_IMPOSTO)
                                                  AND (IDENTRSAIDAL = P_ENTRSAIDAL)
                                                  AND (CDEMPRESA = P_EMPRESA)
                                                  AND (CDINSCESTA IS NULL)
                                                  AND (CDGRUPOFISC IS NULL)
                                                  AND (A.CDPRODUTO = P.CDPRODUTO(+))
                                                  AND (P.CDARVPROD = V_CDARVPROD)
                                                  AND ((CDPAISORIG = P_PAISORIG)
                                                  AND (SGESTAORIG = P_ESTAORIG) OR V_UTUFORIG = w_N)
                                                  AND ((CDPAISDEST = P_PAISDEST)
                                                  AND (SGESTADEST = P_ESTADEST) OR V_UTUFDEST = w_N)
                                                  AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                                                  AND ((VRINIFAIXA < V_VRITEMPROD)
                                                  AND (VRFIMFAIXA >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                                                  AND (INSTR(NVL(P_CDTIPOOPER,'_'), NVL(RTRIM(CDTIPOOPER), NVL(P_CDTIPOOPER,'_'))) = 1  OR V_IDUTALIQTPOPER = w_N)
                                                  AND (DTINIVALID <= P_INIVALID)))) LOOP
                     SELECT COUNT(*)
                       INTO V_COUNTMENS
                       FROM MENSAGEM
                      WHERE CDMENSAGEM = C_ALIQUOTA.CDMENSAGEM
                        AND IDSITUACAOMENS = 'I';
                     IF V_COUNTMENS > 0 THEN
                        V_DSMENSALIQU := NULL;
                     ELSE
                        V_DSMENSALIQU := C_ALIQUOTA.DSMENSALIQU;
                     END IF;
                     INSERT INTO ALIQTEMP
                       (NRALIQTEMP, NRSEQUALIQ, VRPREDBCTMP, VRPARDEDTMP,
                        VRALIQUTMP, DSMENSALITMP, IDTRIMPSTTMP, VRPBCSTTMP,
                        IDPMCBSCALTMP, CDINSCESTAATMP, VR1PREDBCTMP, VRADICALIQFECP,
                        CDBENEFFISCAL, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF)
                     VALUES
                       (P_FILIAL||P_LANCTONF, V_SEQUENCIA, C_ALIQUOTA.VRPERREDBC, C_ALIQUOTA.VRPARDEDUZ,
                        C_ALIQUOTA.VRALIQUOTA, V_DSMENSALIQU, C_ALIQUOTA.IDTRATIMPST, C_ALIQUOTA.VRPBCSUBTRIB, 
                        C_ALIQUOTA.IDPMCBASECAL, NULL, C_ALIQUOTA.VR1PERREDBC, C_ALIQUOTA.VRADICALIQFECP, 
                        C_ALIQUOTA.CDBENEFFISCAL, C_ALIQUOTA.IDCONSDIFALIQ, C_ALIQUOTA.IDIMPODESONERA, C_ALIQUOTA.IDCONSDESONVRNF);
                     V_SEQUENCIA := LPAD(RTRIM(V_SEQUENCIA + '01'),2,0);
                  END LOOP;
               END IF;
            ELSIF (V_CDARVPROD IS NULL) THEN /*Se há alíquota para todos*/
               IF NOT (V_CDTIPOOPER IS NULL) THEN /*Se há alíquota por tipo de operação*/
                  FOR C_ALIQUOTA IN (
                     SELECT A.NRALIQUOTA, VRPERREDBC, VR1PERREDBC, VRPARDEDUZ, VRALIQUOTA, DSMENSALIQU, IDTRATIMPST, VRPBCSUBTRIB, IDPMCBASECAL, A.CDTIPOOPER,
                            CDMENSAGEM, VRADICALIQFECP, CDBENEFFISCAL, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF
                       FROM ALIQUOTA A, MENSALIQU
                      WHERE (A.NRALIQUOTA = MENSALIQU.NRALIQUOTA(+))
                        AND (A.CDIMPOSTO = P_IMPOSTO)
                        AND (A.IDENTRSAIDAL = P_ENTRSAIDAL)
                        AND (A.CDEMPRESA = P_EMPRESA)
                        AND (A.CDINSCESTA IS NULL)
                        AND (A.CDGRUPOFISC IS NULL)
                        AND (A.CDPRODUTO IS NULL)
                        AND ((A.CDPAISORIG = P_PAISORIG)
                        AND (A.SGESTAORIG = P_ESTAORIG) OR V_UTUFORIG = w_N)
                        AND ((A.CDPAISDEST = P_PAISDEST)
                        AND (A.SGESTADEST = P_ESTADEST) OR V_UTUFDEST = w_N)
                        AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                        AND ((A.VRINIFAIXA < V_VRITEMPROD)
                        AND (A.VRFIMFAIXA >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                        AND (CDTIPOOPER = V_CDTIPOOPER)
                        AND (A.DTINIVALID = ( SELECT MAX(DTINIVALID)
                                                FROM ALIQUOTA
                                               WHERE (CDIMPOSTO = P_IMPOSTO)
                                                 AND (IDENTRSAIDAL = P_ENTRSAIDAL)
                                                 AND (CDEMPRESA = P_EMPRESA)
                                                 AND (CDINSCESTA IS NULL)
                                                 AND (CDGRUPOFISC IS NULL)
                                                 AND (CDPRODUTO IS NULL)
                                                 AND ((CDPAISORIG = P_PAISORIG)
                                                 AND (SGESTAORIG = P_ESTAORIG) OR V_UTUFORIG = w_N)
                                                 AND ((CDPAISDEST = P_PAISDEST)
                                                 AND (SGESTADEST = P_ESTADEST) OR V_UTUFDEST = w_N)
                                                 AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                                                 AND ((VRINIFAIXA < V_VRITEMPROD)
                                                 AND (VRFIMFAIXA >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                                                 AND (CDTIPOOPER = V_CDTIPOOPER)
                                                 AND (DTINIVALID <= P_INIVALID)))) LOOP
                     SELECT COUNT(*)
                       INTO V_COUNTMENS
                       FROM MENSAGEM
                      WHERE CDMENSAGEM = C_ALIQUOTA.CDMENSAGEM
                        AND IDSITUACAOMENS = 'I';
                     IF V_COUNTMENS > 0 THEN
                        V_DSMENSALIQU := NULL;
                     ELSE
                        V_DSMENSALIQU := C_ALIQUOTA.DSMENSALIQU;
                     END IF;
                     INSERT INTO ALIQTEMP
                        (NRALIQTEMP, NRSEQUALIQ, VRPREDBCTMP, VRPARDEDTMP,
                         VRALIQUTMP, DSMENSALITMP, IDTRIMPSTTMP, VRPBCSTTMP,
                         IDPMCBSCALTMP, CDTIPOOPERTMP, CDINSCESTAATMP, VR1PREDBCTMP,
                         VRADICALIQFECP, CDBENEFFISCAL, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF)
                     VALUES
                        (P_FILIAL||P_LANCTONF, V_SEQUENCIA, C_ALIQUOTA.VRPERREDBC, C_ALIQUOTA.VRPARDEDUZ,
                         C_ALIQUOTA.VRALIQUOTA, V_DSMENSALIQU, C_ALIQUOTA.IDTRATIMPST, C_ALIQUOTA.VRPBCSUBTRIB, 
                         C_ALIQUOTA.IDPMCBASECAL, C_ALIQUOTA.CDTIPOOPER, NULL, C_ALIQUOTA.VR1PERREDBC, 
                         C_ALIQUOTA.VRADICALIQFECP, C_ALIQUOTA.CDBENEFFISCAL, C_ALIQUOTA.IDCONSDIFALIQ, C_ALIQUOTA.IDIMPODESONERA, C_ALIQUOTA.IDCONSDESONVRNF);
                     V_SEQUENCIA := LPAD(RTRIM(V_SEQUENCIA + '01'),2,0);
                  END LOOP;
               ELSIF (V_CDTIPOOPER IS NULL) THEN /*Se não possui alíquota por tipo de operação*/
                  FOR C_ALIQUOTA IN (
                     SELECT A.NRALIQUOTA, VRPERREDBC, VR1PERREDBC, VRPARDEDUZ, VRALIQUOTA, DSMENSALIQU, IDTRATIMPST, VRPBCSUBTRIB, IDPMCBASECAL,
                            CDMENSAGEM, VRADICALIQFECP, CDBENEFFISCAL, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF
                       FROM ALIQUOTA A, MENSALIQU
                      WHERE (A.NRALIQUOTA = MENSALIQU.NRALIQUOTA(+))
                        AND (A.CDIMPOSTO = P_IMPOSTO)
                        AND (A.IDENTRSAIDAL = P_ENTRSAIDAL)
                        AND (A.CDEMPRESA = P_EMPRESA)
                        AND (A.CDINSCESTA IS NULL)
                        AND (A.CDGRUPOFISC IS NULL)
                        AND (A.CDPRODUTO IS NULL)
                        AND ((A.CDPAISORIG = P_PAISORIG)
                        AND (A.SGESTAORIG = P_ESTAORIG) OR V_UTUFORIG = w_N)
                        AND ((A.CDPAISDEST = P_PAISDEST)
                        AND (A.SGESTADEST = P_ESTADEST) OR V_UTUFDEST = w_N)
                        AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                        AND ((A.VRINIFAIXA < V_VRITEMPROD)
                        AND (A.VRFIMFAIXA >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                        AND (INSTR(NVL(P_CDTIPOOPER,'_'), NVL(RTRIM(CDTIPOOPER), NVL(P_CDTIPOOPER,'_'))) = 1  OR V_IDUTALIQTPOPER = w_N)
                        AND (A.DTINIVALID = ( SELECT MAX(DTINIVALID)
                                                FROM ALIQUOTA
                                               WHERE (CDIMPOSTO = P_IMPOSTO)
                                                 AND (IDENTRSAIDAL = P_ENTRSAIDAL)
                                                 AND (CDEMPRESA = P_EMPRESA)
                                                 AND (CDINSCESTA IS NULL)
                                                 AND (CDGRUPOFISC IS NULL)
                                                 AND (CDPRODUTO IS NULL)
                                                 AND ((CDPAISORIG = P_PAISORIG)
                                                 AND (SGESTAORIG = P_ESTAORIG) OR V_UTUFORIG = w_N)
                                                 AND ((CDPAISDEST = P_PAISDEST)
                                                 AND (SGESTADEST = P_ESTADEST) OR V_UTUFDEST = w_N)
                                                 AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                                                 AND ((VRINIFAIXA < V_VRITEMPROD)
                                                 AND (VRFIMFAIXA >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                                                 AND (INSTR(NVL(P_CDTIPOOPER,'_'), NVL(RTRIM(CDTIPOOPER), NVL(P_CDTIPOOPER,'_'))) = 1  OR V_IDUTALIQTPOPER = w_N)
                                                 AND (DTINIVALID <= P_INIVALID)))) LOOP
                     SELECT COUNT(*)
                       INTO V_COUNTMENS
                       FROM MENSAGEM
                      WHERE CDMENSAGEM = C_ALIQUOTA.CDMENSAGEM
                        AND IDSITUACAOMENS = 'I';
                     IF V_COUNTMENS > 0 THEN
                        V_DSMENSALIQU := NULL;
                     ELSE
                        V_DSMENSALIQU := C_ALIQUOTA.DSMENSALIQU;
                     END IF;
                     INSERT INTO ALIQTEMP
                        (NRALIQTEMP, NRSEQUALIQ, VRPREDBCTMP, VRPARDEDTMP,
                         VRALIQUTMP, DSMENSALITMP, IDTRIMPSTTMP, VRPBCSTTMP,
                         IDPMCBSCALTMP, CDINSCESTAATMP, VR1PREDBCTMP, VRADICALIQFECP,
                         CDBENEFFISCAL, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF)
                     VALUES
                        (P_FILIAL||P_LANCTONF, V_SEQUENCIA, C_ALIQUOTA.VRPERREDBC, C_ALIQUOTA.VRPARDEDUZ,
                         C_ALIQUOTA.VRALIQUOTA, V_DSMENSALIQU, C_ALIQUOTA.IDTRATIMPST, C_ALIQUOTA.VRPBCSUBTRIB, 
                         C_ALIQUOTA.IDPMCBASECAL, NULL, C_ALIQUOTA.VR1PERREDBC, C_ALIQUOTA.VRADICALIQFECP, 
                         C_ALIQUOTA.CDBENEFFISCAL, C_ALIQUOTA.IDCONSDIFALIQ, C_ALIQUOTA.IDIMPODESONERA, C_ALIQUOTA.IDCONSDESONVRNF);
                     V_SEQUENCIA := LPAD(RTRIM(V_SEQUENCIA + '01'),2,0);
                  END LOOP;
               END IF;
            END IF;
         END IF;
         /* Verificação das aliquotas referente as filiais parametrizadas na tela Parâmetros de Grupo Fiscal (Imposto/Filial) */
         V_CDGRUPOFISC := NULL;
         BEGIN
            SELECT MAX(G.CDGRUPOFISC)
              INTO V_CDGRUPOFISC
              FROM GRUPOFISCIMPFIL G, (SELECT DECODE(P_ENTRSAIDAL, 'E', CDFILIRECE, CDFILIEMIT) AS CDFILIAL
                                         FROM NOTAFISCAL
                                        WHERE CDFILIAL = P_FILIAL
                                          AND NRLANCTONF = P_LANCTONF
                                          AND P_IDSISTEMA IS NULL
                                          AND P_CDFILIRECE IS NULL
                                       UNION ALL
                                       SELECT CDFILIAL
                                         FROM PEDIDO
                                        WHERE CDFILIAL = SUBSTR(P_FILIAL,1,4)
                                          AND NRPEDIDO = SUBSTR(P_FILIAL,5,10)
                                          AND P_IDSISTEMA = 'PED'
                                        UNION ALL
                                       SELECT CDFILIAL
                                         FROM FILIAL
                                        WHERE CDFILIAL = P_CDFILIRECE) F
             WHERE G.CDIMPOSTO = P_IMPOSTO
               AND G.CDFILIAL = F.CDFILIAL;
         EXCEPTION
            WHEN No_Data_Found THEN
               V_CDGRUPOFISC := NULL;
         END;
         IF NOT (V_CDGRUPOFISC IS NULL) THEN /*Se há grupo fiscal na tela Parâmetros de Grupo Fiscal na aba Imposto/Filial*/
            IF V_IDPRODNOTA = w_P THEN /*Se imposto do item*/
               SELECT MAX(CDTIPOOPER), COUNT(*)
                 INTO V_CDTIPOOPER, V_CONTADOR
                 FROM ALIQUOTA A, PRODUTO P
                WHERE (CDIMPOSTO    = P_IMPOSTO)
                  AND (IDENTRSAIDAL = P_ENTRSAIDAL)
                  AND (CDEMPRESA    = P_EMPRESA)
                  AND (CDINSCESTA   IS NULL)
                  AND (CDGRUPOFISC  = V_CDGRUPOFISC)
                  AND ((CDPAISORIG  = P_PAISORIG) AND (SGESTAORIG  = P_ESTAORIG) OR V_UTUFORIG = w_N)
                  AND ((CDPAISDEST  = P_PAISDEST) AND (SGESTADEST  = P_ESTADEST) OR V_UTUFDEST = w_N)
                  AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                  AND ((VRINIFAIXA  < V_VRITEMPROD) AND (VRFIMFAIXA  >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                  AND (INSTR(NVL(P_CDTIPOOPER,'_'), NVL(RTRIM(CDTIPOOPER), NVL(P_CDTIPOOPER,'_'))) = 1  OR V_IDUTALIQTPOPER = w_N)
                  AND (A.CDPRODUTO = P.CDPRODUTO(+))
                  AND (INSTR(NVL(P_PRODUTO,'_'),NVL(RTRIM(P.CDARVPROD),NVL(P_PRODUTO,'_'))) = 1);
               IF NOT (V_CDTIPOOPER IS NULL) THEN /*Se possui alíquota por tipo de operação*/
                  SELECT MAX(P.CDARVPROD)
                    INTO V_CDARVPROD
                    FROM ALIQUOTA A, PRODUTO P
                   WHERE (CDIMPOSTO    = P_IMPOSTO)
                     AND (IDENTRSAIDAL = P_ENTRSAIDAL)
                     AND (CDEMPRESA    = P_EMPRESA)
                     AND (CDINSCESTA   IS NULL)
                     AND (CDGRUPOFISC  = V_CDGRUPOFISC)
                     AND ((CDPAISORIG  = P_PAISORIG) AND (SGESTAORIG  = P_ESTAORIG) OR V_UTUFORIG = w_N)
                     AND ((CDPAISDEST  = P_PAISDEST) AND (SGESTADEST  = P_ESTADEST) OR V_UTUFDEST = w_N)
                     AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                     AND ((VRINIFAIXA  < V_VRITEMPROD) AND (VRFIMFAIXA  >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                     AND (CDTIPOOPER = V_CDTIPOOPER OR V_IDUTALIQTPOPER = w_N)
                     AND (A.CDPRODUTO = P.CDPRODUTO(+))
                     AND (INSTR(NVL(P_PRODUTO,'_'),NVL(RTRIM(P.CDARVPROD),NVL(P_PRODUTO,'_'))) = 1);
               ELSIF (V_CDTIPOOPER IS NULL) THEN /*Se não possui alíquota por tipo de operação*/
                  SELECT MAX(P.CDARVPROD)
                    INTO V_CDARVPROD
                    FROM ALIQUOTA A, PRODUTO P
                   WHERE (CDIMPOSTO    = P_IMPOSTO)
                     AND (IDENTRSAIDAL = P_ENTRSAIDAL)
                      AND (CDEMPRESA    = P_EMPRESA)
                      AND (CDINSCESTA   IS NULL)
                      AND (CDGRUPOFISC  = V_CDGRUPOFISC)
                      AND ((CDPAISORIG  = P_PAISORIG) AND (SGESTAORIG  = P_ESTAORIG) OR V_UTUFORIG = w_N)
                      AND ((CDPAISDEST  = P_PAISDEST) AND (SGESTADEST  = P_ESTADEST) OR V_UTUFDEST = w_N)
                      AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                      AND ((VRINIFAIXA  < V_VRITEMPROD) AND (VRFIMFAIXA  >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                      AND (INSTR(NVL(P_CDTIPOOPER,'_'), NVL(RTRIM(CDTIPOOPER), NVL(P_CDTIPOOPER,'_'))) = 1  OR V_IDUTALIQTPOPER = w_N)
                      AND (A.CDPRODUTO = P.CDPRODUTO(+))
                      AND (INSTR(NVL(P_PRODUTO,'_'),NVL(RTRIM(P.CDARVPROD),NVL(P_PRODUTO,'_'))) = 1);
               END IF;
            ELSE /*Se imposto da nota*/
               SELECT MAX(A.CDPRODUTO), COUNT(*), MAX(CDTIPOOPER)
                 INTO V_CDARVPROD, V_CONTADOR, V_CDTIPOOPER
                 FROM ALIQUOTA A
                WHERE (CDIMPOSTO    = P_IMPOSTO)
                  AND (IDENTRSAIDAL = P_ENTRSAIDAL)
                  AND (CDEMPRESA    = P_EMPRESA)
                  AND (CDINSCESTA   IS NULL)
                  AND (CDGRUPOFISC  = V_CDGRUPOFISC)
                  AND ((CDPAISORIG  = P_PAISORIG) AND (SGESTAORIG  = P_ESTAORIG) OR V_UTUFORIG = w_N)
                  AND ((CDPAISDEST  = P_PAISDEST) AND (SGESTADEST  = P_ESTADEST) OR V_UTUFDEST = w_N)
                  AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                  AND ((VRINIFAIXA  < V_VRITEMPROD) AND (VRFIMFAIXA  >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                  AND (INSTR(NVL(P_CDTIPOOPER,'_'), NVL(RTRIM(CDTIPOOPER), NVL(P_CDTIPOOPER,'_'))) = 1  OR V_IDUTALIQTPOPER = w_N)
                  AND (A.CDPRODUTO IS NULL);
            END IF;
            IF NOT (V_CDTIPOOPER IS NULL) THEN /*Se possui alíquota por tipo de operação*/
               IF NOT (V_CDARVPROD IS NULL) THEN /*Se há alíquota para o maior nivel*/
                  FOR C_ALIQUOTA IN (
                       SELECT A.NRALIQUOTA, VRPERREDBC, VR1PERREDBC, VRPARDEDUZ, VRALIQUOTA, DSMENSALIQU, IDTRATIMPST, VRPBCSUBTRIB, IDPMCBASECAL, CDTIPOOPER,
                              CDMENSAGEM, VRADICALIQFECP, CDBENEFFISCAL, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF
                         FROM ALIQUOTA A, MENSALIQU M, PRODUTO P
                        WHERE (A.NRALIQUOTA = M.NRALIQUOTA(+))
                          AND (A.CDIMPOSTO = P_IMPOSTO)
                          AND (A.IDENTRSAIDAL = P_ENTRSAIDAL)
                          AND (A.CDEMPRESA = P_EMPRESA)
                          AND (A.CDINSCESTA IS NULL)
                          AND (A.CDGRUPOFISC = V_CDGRUPOFISC)
                          AND (A.CDPRODUTO = P.CDPRODUTO(+))
                          AND (P.CDARVPROD = V_CDARVPROD)
                          AND ((A.CDPAISORIG = P_PAISORIG)
                          AND (A.SGESTAORIG = P_ESTAORIG) OR V_UTUFORIG = w_N)
                          AND ((A.CDPAISDEST = P_PAISDEST)
                          AND (A.SGESTADEST = P_ESTADEST) OR V_UTUFDEST = w_N)
                          AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                          AND ((A.VRINIFAIXA < V_VRITEMPROD)
                          AND (A.VRFIMFAIXA >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                          AND (CDTIPOOPER = V_CDTIPOOPER)
                          AND (A.DTINIVALID = (SELECT MAX(DTINIVALID)
                                                 FROM ALIQUOTA A, PRODUTO P
                                                WHERE (CDIMPOSTO = P_IMPOSTO)
                                                  AND (IDENTRSAIDAL = P_ENTRSAIDAL)
                                                  AND (CDEMPRESA = P_EMPRESA)
                                                  AND (CDINSCESTA IS NULL)
                                                  AND (A.CDGRUPOFISC = V_CDGRUPOFISC)
                                                  AND (A.CDPRODUTO = P.CDPRODUTO(+))
                                                  AND (P.CDARVPROD = V_CDARVPROD)
                                                  AND ((CDPAISORIG = P_PAISORIG)
                                                  AND (SGESTAORIG = P_ESTAORIG) OR V_UTUFORIG = w_N)
                                                  AND ((CDPAISDEST = P_PAISDEST)
                                                  AND (SGESTADEST = P_ESTADEST) OR V_UTUFDEST = w_N)
                                                  AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                                                  AND ((VRINIFAIXA < V_VRITEMPROD)
                                                  AND (VRFIMFAIXA >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                                                  AND (CDTIPOOPER = V_CDTIPOOPER)
                                                  AND (DTINIVALID <= P_INIVALID)))) LOOP
                     SELECT COUNT(*)
                       INTO V_EXISTE
                       FROM ALIQTEMP
                      WHERE NRALIQTEMP = P_FILIAL||P_LANCTONF;
                     IF V_EXISTE > 0 THEN
                        DELETE FROM ALIQTEMP
                        WHERE NRALIQTEMP = P_FILIAL||P_LANCTONF;
                     END IF;
                     SELECT COUNT(*)
                       INTO V_COUNTMENS
                       FROM MENSAGEM
                      WHERE CDMENSAGEM = C_ALIQUOTA.CDMENSAGEM
                        AND IDSITUACAOMENS = 'I';
                     IF V_COUNTMENS > 0 THEN
                        V_DSMENSALIQU := NULL;
                     ELSE
                        V_DSMENSALIQU := C_ALIQUOTA.DSMENSALIQU;
                     END IF;
                     INSERT INTO ALIQTEMP
                        (NRALIQTEMP, NRSEQUALIQ, VRPREDBCTMP, VRPARDEDTMP,
                         VRALIQUTMP, DSMENSALITMP, IDTRIMPSTTMP, VRPBCSTTMP,
                         IDPMCBSCALTMP, CDTIPOOPERTMP, CDINSCESTAATMP, VR1PREDBCTMP,
                         VRADICALIQFECP, CDBENEFFISCAL, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF)
                     VALUES
                        (P_FILIAL||P_LANCTONF, V_SEQUENCIA, C_ALIQUOTA.VRPERREDBC, C_ALIQUOTA.VRPARDEDUZ,
                         C_ALIQUOTA.VRALIQUOTA, V_DSMENSALIQU, C_ALIQUOTA.IDTRATIMPST, C_ALIQUOTA.VRPBCSUBTRIB,
                         C_ALIQUOTA.IDPMCBASECAL, C_ALIQUOTA.CDTIPOOPER, NULL, C_ALIQUOTA.VR1PERREDBC, 
                         C_ALIQUOTA.VRADICALIQFECP, C_ALIQUOTA.CDBENEFFISCAL, C_ALIQUOTA.IDCONSDIFALIQ, C_ALIQUOTA.IDIMPODESONERA, C_ALIQUOTA.IDCONSDESONVRNF);
                     V_SEQUENCIA := LPAD(RTRIM(V_SEQUENCIA + '01'),2,0);
                  END LOOP;
               ELSIF (V_CDARVPROD IS NULL) THEN /*Se há alíquota para o produto todos*/
                  FOR C_ALIQUOTA IN (
                       SELECT A.NRALIQUOTA, VRPERREDBC, VR1PERREDBC, VRPARDEDUZ, VRALIQUOTA, DSMENSALIQU, IDTRATIMPST, VRPBCSUBTRIB, IDPMCBASECAL, A.CDTIPOOPER,
                              CDMENSAGEM, VRADICALIQFECP, CDBENEFFISCAL, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF
                         FROM ALIQUOTA A, MENSALIQU M
                        WHERE (A.NRALIQUOTA = M.NRALIQUOTA(+))
                          AND (A.CDIMPOSTO = P_IMPOSTO)
                          AND (A.IDENTRSAIDAL = P_ENTRSAIDAL)
                          AND (A.CDEMPRESA = P_EMPRESA)
                          AND (A.CDINSCESTA IS NULL)
                          AND (A.CDGRUPOFISC = V_CDGRUPOFISC)
                          AND (A.CDPRODUTO IS NULL)
                          AND ((A.CDPAISORIG = P_PAISORIG)
                          AND (A.SGESTAORIG = P_ESTAORIG) OR V_UTUFORIG = w_N)
                          AND ((A.CDPAISDEST = P_PAISDEST)
                          AND (A.SGESTADEST = P_ESTADEST) OR V_UTUFDEST = w_N)
                          AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                          AND ((A.VRINIFAIXA < V_VRITEMPROD)
                          AND (A.VRFIMFAIXA >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                          AND (CDTIPOOPER = V_CDTIPOOPER)
                          AND (A.DTINIVALID = (SELECT MAX(DTINIVALID)
                                                 FROM ALIQUOTA
                                                WHERE (CDIMPOSTO = P_IMPOSTO)
                                                  AND (IDENTRSAIDAL = P_ENTRSAIDAL)
                                                  AND (CDEMPRESA = P_EMPRESA)
                                                  AND (CDINSCESTA IS NULL)
                                                  AND (A.CDGRUPOFISC = V_CDGRUPOFISC)
                                                  AND (CDPRODUTO IS NULL)
                                                  AND ((CDPAISORIG = P_PAISORIG)
                                                  AND (SGESTAORIG = P_ESTAORIG) OR V_UTUFORIG = w_N)
                                                  AND ((CDPAISDEST = P_PAISDEST)
                                                  AND (SGESTADEST = P_ESTADEST) OR V_UTUFDEST = w_N)
                                                  AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                                                  AND ((VRINIFAIXA < V_VRITEMPROD)
                                                  AND (VRFIMFAIXA >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                                                  AND (CDTIPOOPER = V_CDTIPOOPER)
                                                  AND (DTINIVALID <= P_INIVALID)))) LOOP
                     SELECT COUNT(*)
                       INTO V_EXISTE
                       FROM ALIQTEMP
                      WHERE NRALIQTEMP = P_FILIAL||P_LANCTONF;
                     IF V_EXISTE > 0 THEN
                        DELETE FROM ALIQTEMP
                        WHERE NRALIQTEMP = P_FILIAL||P_LANCTONF;
                     END IF;
                     SELECT COUNT(*)
                       INTO V_COUNTMENS
                       FROM MENSAGEM
                      WHERE CDMENSAGEM = C_ALIQUOTA.CDMENSAGEM
                        AND IDSITUACAOMENS = 'I';
                     IF V_COUNTMENS > 0 THEN
                        V_DSMENSALIQU := NULL;
                     ELSE
                        V_DSMENSALIQU := C_ALIQUOTA.DSMENSALIQU;
                     END IF;
                     INSERT INTO ALIQTEMP
                        (NRALIQTEMP, NRSEQUALIQ, VRPREDBCTMP, VRPARDEDTMP,
                         VRALIQUTMP, DSMENSALITMP, IDTRIMPSTTMP, VRPBCSTTMP,
                         IDPMCBSCALTMP, CDTIPOOPERTMP, CDINSCESTAATMP, VR1PREDBCTMP,
                         VRADICALIQFECP, CDBENEFFISCAL, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF)
                     VALUES
                        (P_FILIAL||P_LANCTONF, V_SEQUENCIA, C_ALIQUOTA.VRPERREDBC, C_ALIQUOTA.VRPARDEDUZ,
                         C_ALIQUOTA.VRALIQUOTA, V_DSMENSALIQU, C_ALIQUOTA.IDTRATIMPST, C_ALIQUOTA.VRPBCSUBTRIB, 
                         C_ALIQUOTA.IDPMCBASECAL, C_ALIQUOTA.CDTIPOOPER, NULL, C_ALIQUOTA.VR1PERREDBC, 
                         C_ALIQUOTA.VRADICALIQFECP, C_ALIQUOTA.CDBENEFFISCAL, C_ALIQUOTA.IDCONSDIFALIQ, C_ALIQUOTA.IDIMPODESONERA, C_ALIQUOTA.IDCONSDESONVRNF);
                     V_SEQUENCIA := LPAD(RTRIM(V_SEQUENCIA + '01'),2,0);
                  END LOOP;
               END IF;
            ELSIF (V_CDTIPOOPER IS NULL) THEN /*Se não possui alíquota por tipo de operação*/
               IF NOT (V_CDARVPROD IS NULL) THEN /*Se há alíquota para o maior nivel*/
                  FOR C_ALIQUOTA IN (
                       SELECT A.NRALIQUOTA, VRPERREDBC, VR1PERREDBC, VRPARDEDUZ, VRALIQUOTA, DSMENSALIQU, IDTRATIMPST, VRPBCSUBTRIB, IDPMCBASECAL, CDMENSAGEM,
                              VRADICALIQFECP, CDBENEFFISCAL, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF
                         FROM ALIQUOTA A, MENSALIQU M, PRODUTO P
                        WHERE (A.NRALIQUOTA = M.NRALIQUOTA(+))
                          AND (A.CDIMPOSTO = P_IMPOSTO)
                          AND (A.IDENTRSAIDAL = P_ENTRSAIDAL)
                          AND (A.CDEMPRESA = P_EMPRESA)
                          AND (A.CDINSCESTA IS NULL)
                          AND (A.CDGRUPOFISC = V_CDGRUPOFISC)
                          AND (A.CDPRODUTO = P.CDPRODUTO(+))
                          AND (P.CDARVPROD = V_CDARVPROD)
                          AND ((A.CDPAISORIG = P_PAISORIG)
                          AND (A.SGESTAORIG = P_ESTAORIG) OR V_UTUFORIG = w_N)
                          AND ((A.CDPAISDEST = P_PAISDEST)
                          AND (A.SGESTADEST = P_ESTADEST) OR V_UTUFDEST = w_N)
                          AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                          AND ((A.VRINIFAIXA < V_VRITEMPROD)
                          AND (A.VRFIMFAIXA >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                          AND (INSTR(NVL(P_CDTIPOOPER,'_'), NVL(RTRIM(CDTIPOOPER), NVL(P_CDTIPOOPER,'_'))) = 1  OR V_IDUTALIQTPOPER = w_N)
                          AND (A.DTINIVALID = (SELECT MAX(DTINIVALID)
                                                 FROM ALIQUOTA A, PRODUTO P
                                                WHERE (CDIMPOSTO = P_IMPOSTO)
                                                  AND (IDENTRSAIDAL = P_ENTRSAIDAL)
                                                  AND (CDEMPRESA = P_EMPRESA)
                                                  AND (CDINSCESTA IS NULL)
                                                  AND (A.CDGRUPOFISC = V_CDGRUPOFISC)
                                                  AND (A.CDPRODUTO = P.CDPRODUTO(+))
                                                  AND (P.CDARVPROD = V_CDARVPROD)
                                                  AND ((CDPAISORIG = P_PAISORIG)
                                                  AND (SGESTAORIG = P_ESTAORIG) OR V_UTUFORIG = w_N)
                                                  AND ((CDPAISDEST = P_PAISDEST)
                                                  AND (SGESTADEST = P_ESTADEST) OR V_UTUFDEST = w_N)
                                                  AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                                                  AND ((VRINIFAIXA < V_VRITEMPROD)
                                                  AND (VRFIMFAIXA >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                                                  AND (INSTR(NVL(P_CDTIPOOPER,'_'), NVL(RTRIM(CDTIPOOPER), NVL(P_CDTIPOOPER,'_'))) = 1  OR V_IDUTALIQTPOPER = w_N)
                                                  AND (DTINIVALID <= P_INIVALID)))) LOOP
                     SELECT COUNT(*)
                       INTO V_EXISTE
                       FROM ALIQTEMP
                      WHERE NRALIQTEMP = P_FILIAL||P_LANCTONF;
                     IF V_EXISTE > 0 THEN
                        DELETE FROM ALIQTEMP
                        WHERE NRALIQTEMP = P_FILIAL||P_LANCTONF;
                     END IF;
                     SELECT COUNT(*)
                       INTO V_COUNTMENS
                       FROM MENSAGEM
                      WHERE CDMENSAGEM = C_ALIQUOTA.CDMENSAGEM
                        AND IDSITUACAOMENS = 'I';
                     IF V_COUNTMENS > 0 THEN
                        V_DSMENSALIQU := NULL;
                     ELSE
                        V_DSMENSALIQU := C_ALIQUOTA.DSMENSALIQU;
                     END IF;
                     INSERT INTO ALIQTEMP
                        (NRALIQTEMP, NRSEQUALIQ, VRPREDBCTMP, VRPARDEDTMP,
                         VRALIQUTMP, DSMENSALITMP, IDTRIMPSTTMP, VRPBCSTTMP,
                         IDPMCBSCALTMP, CDINSCESTAATMP, VR1PREDBCTMP, VRADICALIQFECP,
                         CDBENEFFISCAL, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF)
                     VALUES
                        (P_FILIAL||P_LANCTONF, V_SEQUENCIA, C_ALIQUOTA.VRPERREDBC, C_ALIQUOTA.VRPARDEDUZ,
                         C_ALIQUOTA.VRALIQUOTA, V_DSMENSALIQU, C_ALIQUOTA.IDTRATIMPST, C_ALIQUOTA.VRPBCSUBTRIB, 
                         C_ALIQUOTA.IDPMCBASECAL, NULL, C_ALIQUOTA.VR1PERREDBC, C_ALIQUOTA.VRADICALIQFECP, 
                         C_ALIQUOTA.CDBENEFFISCAL, C_ALIQUOTA.IDCONSDIFALIQ, C_ALIQUOTA.IDIMPODESONERA, C_ALIQUOTA.IDCONSDESONVRNF);
                     V_SEQUENCIA := LPAD(RTRIM(V_SEQUENCIA + '01'),2,0);
                  END LOOP;
               ELSIF (V_CDARVPROD IS NULL) THEN /*Se há alíquota para o produto todos*/
                  FOR C_ALIQUOTA IN (
                       SELECT A.NRALIQUOTA, VRPERREDBC, VR1PERREDBC, VRPARDEDUZ, VRALIQUOTA, DSMENSALIQU, IDTRATIMPST, VRPBCSUBTRIB, IDPMCBASECAL, CDMENSAGEM,
                              VRADICALIQFECP, CDBENEFFISCAL, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF
                         FROM ALIQUOTA A, MENSALIQU M
                        WHERE (A.NRALIQUOTA = M.NRALIQUOTA(+))
                          AND (A.CDIMPOSTO = P_IMPOSTO)
                          AND (A.IDENTRSAIDAL = P_ENTRSAIDAL)
                          AND (A.CDEMPRESA = P_EMPRESA)
                          AND (A.CDINSCESTA IS NULL)
                          AND (A.CDGRUPOFISC = V_CDGRUPOFISC)
                          AND (A.CDPRODUTO IS NULL)
                          AND ((A.CDPAISORIG = P_PAISORIG)
                          AND (A.SGESTAORIG = P_ESTAORIG) OR V_UTUFORIG = w_N)
                          AND ((A.CDPAISDEST = P_PAISDEST)
                          AND (A.SGESTADEST = P_ESTADEST) OR V_UTUFDEST = w_N)
                          AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                          AND ((A.VRINIFAIXA < V_VRITEMPROD)
                          AND (A.VRFIMFAIXA >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                          AND (INSTR(NVL(P_CDTIPOOPER,'_'), NVL(RTRIM(CDTIPOOPER), NVL(P_CDTIPOOPER,'_'))) = 1  OR V_IDUTALIQTPOPER = w_N)
                          AND (A.DTINIVALID = (SELECT MAX(DTINIVALID)
                                                 FROM ALIQUOTA
                                                WHERE (CDIMPOSTO = P_IMPOSTO)
                                                  AND (IDENTRSAIDAL = P_ENTRSAIDAL)
                                                  AND (CDEMPRESA = P_EMPRESA)
                                                  AND (CDINSCESTA IS NULL)
                                                  AND (A.CDGRUPOFISC = V_CDGRUPOFISC)
                                                  AND (CDPRODUTO IS NULL)
                                                  AND ((CDPAISORIG = P_PAISORIG)
                                                  AND (SGESTAORIG = P_ESTAORIG) OR V_UTUFORIG = w_N)
                                                  AND ((CDPAISDEST = P_PAISDEST)
                                                  AND (SGESTADEST = P_ESTADEST) OR V_UTUFDEST = w_N)
                                                  AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                                                  AND ((VRINIFAIXA < V_VRITEMPROD)
                                                  AND (VRFIMFAIXA >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                                                  AND (INSTR(NVL(P_CDTIPOOPER,'_'), NVL(RTRIM(CDTIPOOPER), NVL(P_CDTIPOOPER,'_'))) = 1  OR V_IDUTALIQTPOPER = w_N)
                                                  AND (DTINIVALID <= P_INIVALID)))) LOOP
                     SELECT COUNT(*)
                       INTO V_EXISTE
                       FROM ALIQTEMP
                      WHERE NRALIQTEMP = P_FILIAL||P_LANCTONF;
                     IF V_EXISTE > 0 THEN
                        DELETE FROM ALIQTEMP
                        WHERE NRALIQTEMP = P_FILIAL||P_LANCTONF;
                     END IF;
                     SELECT COUNT(*)
                       INTO V_COUNTMENS
                       FROM MENSAGEM
                      WHERE CDMENSAGEM = C_ALIQUOTA.CDMENSAGEM
                        AND IDSITUACAOMENS = 'I';
                     IF V_COUNTMENS > 0 THEN
                        V_DSMENSALIQU := NULL;
                     ELSE
                        V_DSMENSALIQU := C_ALIQUOTA.DSMENSALIQU;
                     END IF;
                     INSERT INTO ALIQTEMP
                        (NRALIQTEMP, NRSEQUALIQ, VRPREDBCTMP, VRPARDEDTMP,
                         VRALIQUTMP, DSMENSALITMP, IDTRIMPSTTMP, VRPBCSTTMP,
                         IDPMCBSCALTMP, CDINSCESTAATMP, VR1PREDBCTMP, VRADICALIQFECP,
                         CDBENEFFISCAL, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF)
                     VALUES
                        (P_FILIAL||P_LANCTONF, V_SEQUENCIA, C_ALIQUOTA.VRPERREDBC, C_ALIQUOTA.VRPARDEDUZ,
                         C_ALIQUOTA.VRALIQUOTA, V_DSMENSALIQU, C_ALIQUOTA.IDTRATIMPST, C_ALIQUOTA.VRPBCSUBTRIB, 
                         C_ALIQUOTA.IDPMCBASECAL, NULL, C_ALIQUOTA.VR1PERREDBC, C_ALIQUOTA.VRADICALIQFECP, 
                         C_ALIQUOTA.CDBENEFFISCAL, C_ALIQUOTA.IDCONSDIFALIQ, C_ALIQUOTA.IDIMPODESONERA, C_ALIQUOTA.IDCONSDESONVRNF);
                     V_SEQUENCIA := LPAD(RTRIM(V_SEQUENCIA + '01'),2,0);
                  END LOOP;
               END IF;
            END IF;
         END IF;
         ----------------------
         /* Verificação das aliquotas referente as filiais parametrizadas na tela Parâmetros de Grupo Fiscal (Imposto/Inscrição Estadual) */
         /*Por Fornecedor*/
         V_CDGRUPOFISC := NULL;
         BEGIN
            SELECT MAX(G.CDGRUPOFISC)
              INTO V_CDGRUPOFISC
              FROM GRFISIMPIEFORN G, (SELECT CDFORNECED
                                        FROM NOTAFISCAL
                                       WHERE CDFILIAL = P_FILIAL
                                         AND NRLANCTONF = P_LANCTONF
                                         AND P_CDFORNECED IS NULL
                                       UNION ALL
                                      SELECT CDFORNECED
                                        FROM FORNECEDOR
                                       WHERE CDFORNECED = P_CDFORNECED) F
             WHERE G.CDIMPOSTO = P_IMPOSTO
               AND G.CDFORNECED = F.CDFORNECED
               AND G.CDEMPRESA = P_EMPRESA
               AND G.CDINSCESTA = P_INSCESTA;
         EXCEPTION
             WHEN No_Data_Found THEN
                V_CDGRUPOFISC := NULL;
          END;
         IF NOT (V_CDGRUPOFISC IS NULL) THEN /*Se há grupo fiscal na tela Parâmetros de Grupo Fiscal na aba Imposto/Inscrição Estadual*/
            IF V_IDPRODNOTA = w_P THEN /*Se imposto do item*/
               SELECT MAX(CDTIPOOPER), COUNT(*)
                 INTO V_CDTIPOOPER, V_CONTADOR
                 FROM ALIQUOTA A, PRODUTO P
                WHERE (CDIMPOSTO    = P_IMPOSTO)
                  AND (IDENTRSAIDAL = P_ENTRSAIDAL)
                  AND (CDEMPRESA    = P_EMPRESA)
                  AND (CDINSCESTA   IS NULL)
                  AND (CDGRUPOFISC  = V_CDGRUPOFISC)
                  AND ((CDPAISORIG  = P_PAISORIG) AND (SGESTAORIG  = P_ESTAORIG) OR V_UTUFORIG = w_N)
                  AND ((CDPAISDEST  = P_PAISDEST) AND (SGESTADEST  = P_ESTADEST) OR V_UTUFDEST = w_N)
                  AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                  AND ((VRINIFAIXA  < V_VRITEMPROD) AND (VRFIMFAIXA  >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                  AND (INSTR(NVL(P_CDTIPOOPER,'_'), NVL(RTRIM(CDTIPOOPER), NVL(P_CDTIPOOPER,'_'))) = 1  OR V_IDUTALIQTPOPER = w_N)
                  AND (A.CDPRODUTO = P.CDPRODUTO(+))
                  AND (INSTR(NVL(P_PRODUTO,'_'),NVL(RTRIM(P.CDARVPROD),NVL(P_PRODUTO,'_'))) = 1);
               IF NOT (V_CDTIPOOPER IS NULL) THEN /*Se possui alíquota por tipo de operação*/
                  SELECT MAX(P.CDARVPROD)
                    INTO V_CDARVPROD
                    FROM ALIQUOTA A, PRODUTO P
                   WHERE (CDIMPOSTO    = P_IMPOSTO)
                     AND (IDENTRSAIDAL = P_ENTRSAIDAL)
                     AND (CDEMPRESA    = P_EMPRESA)
                     AND (CDINSCESTA   IS NULL)
                     AND (CDGRUPOFISC  = V_CDGRUPOFISC)
                     AND ((CDPAISORIG  = P_PAISORIG) AND (SGESTAORIG  = P_ESTAORIG) OR V_UTUFORIG = w_N)
                     AND ((CDPAISDEST  = P_PAISDEST) AND (SGESTADEST  = P_ESTADEST) OR V_UTUFDEST = w_N)
                     AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                     AND ((VRINIFAIXA  < V_VRITEMPROD) AND (VRFIMFAIXA  >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                     AND (CDTIPOOPER = V_CDTIPOOPER OR V_IDUTALIQTPOPER = w_N)
                     AND (A.CDPRODUTO = P.CDPRODUTO(+))
                     AND (INSTR(NVL(P_PRODUTO,'_'),NVL(RTRIM(P.CDARVPROD),NVL(P_PRODUTO,'_'))) = 1);
               ELSIF (V_CDTIPOOPER IS NULL) THEN /*Se não possui alíquota por tipo de operação*/
                  SELECT MAX(P.CDARVPROD)
                    INTO V_CDARVPROD
                    FROM ALIQUOTA A, PRODUTO P
                   WHERE (CDIMPOSTO    = P_IMPOSTO)
                     AND (IDENTRSAIDAL = P_ENTRSAIDAL)
                     AND (CDEMPRESA    = P_EMPRESA)
                     AND (CDINSCESTA   IS NULL)
                     AND (CDGRUPOFISC  = V_CDGRUPOFISC)
                     AND ((CDPAISORIG  = P_PAISORIG) AND (SGESTAORIG  = P_ESTAORIG) OR V_UTUFORIG = w_N)
                     AND ((CDPAISDEST  = P_PAISDEST) AND (SGESTADEST  = P_ESTADEST) OR V_UTUFDEST = w_N)
                     AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                     AND ((VRINIFAIXA  < V_VRITEMPROD) AND (VRFIMFAIXA  >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                     AND (INSTR(NVL(P_CDTIPOOPER,'_'), NVL(RTRIM(CDTIPOOPER), NVL(P_CDTIPOOPER,'_'))) = 1  OR V_IDUTALIQTPOPER = w_N)
                     AND (A.CDPRODUTO = P.CDPRODUTO(+))
                     AND (INSTR(NVL(P_PRODUTO,'_'),NVL(RTRIM(P.CDARVPROD),NVL(P_PRODUTO,'_'))) = 1);
               END IF;
            ELSE /*Se imposto da nota*/
               SELECT MAX(A.CDPRODUTO), COUNT(*), MAX(CDTIPOOPER)
                 INTO V_CDARVPROD, V_CONTADOR, V_CDTIPOOPER
                 FROM ALIQUOTA A
                WHERE (CDIMPOSTO    = P_IMPOSTO)
                  AND (IDENTRSAIDAL = P_ENTRSAIDAL)
                  AND (CDEMPRESA    = P_EMPRESA)
                  AND (CDINSCESTA   IS NULL)
                  AND (CDGRUPOFISC  = V_CDGRUPOFISC)
                  AND ((CDPAISORIG  = P_PAISORIG) AND (SGESTAORIG  = P_ESTAORIG) OR V_UTUFORIG = w_N)
                  AND ((CDPAISDEST  = P_PAISDEST) AND (SGESTADEST  = P_ESTADEST) OR V_UTUFDEST = w_N)
                  AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                  AND ((VRINIFAIXA  < V_VRITEMPROD) AND (VRFIMFAIXA  >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                  AND (INSTR(NVL(P_CDTIPOOPER,'_'), NVL(RTRIM(CDTIPOOPER), NVL(P_CDTIPOOPER,'_'))) = 1  OR V_IDUTALIQTPOPER = w_N)
                  AND (A.CDPRODUTO IS NULL);
            END IF;
            IF NOT (V_CDTIPOOPER IS NULL) THEN /*Se possui alíquota por tipo de operação*/
               IF NOT (V_CDARVPROD IS NULL) THEN /*Se há alíquota para o maior nivel*/
                  FOR C_ALIQUOTA IN (
                       SELECT A.NRALIQUOTA, VRPERREDBC, VR1PERREDBC, VRPARDEDUZ, VRALIQUOTA, DSMENSALIQU, IDTRATIMPST, VRPBCSUBTRIB, IDPMCBASECAL, CDTIPOOPER,
                              CDMENSAGEM, VRADICALIQFECP, CDBENEFFISCAL, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF
                         FROM ALIQUOTA A, MENSALIQU M, PRODUTO P
                        WHERE (A.NRALIQUOTA = M.NRALIQUOTA(+))
                          AND (A.CDIMPOSTO = P_IMPOSTO)
                          AND (A.IDENTRSAIDAL = P_ENTRSAIDAL)
                          AND (A.CDEMPRESA = P_EMPRESA)
                          AND (A.CDINSCESTA IS NULL)
                          AND (A.CDGRUPOFISC = V_CDGRUPOFISC)
                          AND (A.CDPRODUTO = P.CDPRODUTO(+))
                          AND (P.CDARVPROD = V_CDARVPROD)
                          AND ((A.CDPAISORIG = P_PAISORIG)
                          AND (A.SGESTAORIG = P_ESTAORIG) OR V_UTUFORIG = w_N)
                          AND ((A.CDPAISDEST = P_PAISDEST)
                          AND (A.SGESTADEST = P_ESTADEST) OR V_UTUFDEST = w_N)
                          AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                          AND ((A.VRINIFAIXA < V_VRITEMPROD)
                          AND (A.VRFIMFAIXA >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                          AND (CDTIPOOPER = V_CDTIPOOPER)
                          AND (A.DTINIVALID = (SELECT MAX(DTINIVALID)
                                                 FROM ALIQUOTA A, PRODUTO P
                                                WHERE (CDIMPOSTO = P_IMPOSTO)
                                                  AND (IDENTRSAIDAL = P_ENTRSAIDAL)
                                                  AND (CDEMPRESA = P_EMPRESA)
                                                  AND (CDINSCESTA IS NULL)
                                                  AND (A.CDGRUPOFISC = V_CDGRUPOFISC)
                                                  AND (A.CDPRODUTO = P.CDPRODUTO(+))
                                                  AND (P.CDARVPROD = V_CDARVPROD)
                                                  AND ((CDPAISORIG = P_PAISORIG)
                                                  AND (SGESTAORIG = P_ESTAORIG) OR V_UTUFORIG = w_N)
                                                  AND ((CDPAISDEST = P_PAISDEST)
                                                  AND (SGESTADEST = P_ESTADEST) OR V_UTUFDEST = w_N)
                                                  AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                                                  AND ((VRINIFAIXA < V_VRITEMPROD)
                                                  AND (VRFIMFAIXA >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                                                  AND (CDTIPOOPER = V_CDTIPOOPER)
                                                  AND (DTINIVALID <= P_INIVALID)))) LOOP
                    SELECT COUNT(*)
                      INTO V_EXISTE
                      FROM ALIQTEMP
                     WHERE NRALIQTEMP = P_FILIAL||P_LANCTONF;
                    IF V_EXISTE > 0 THEN
                       DELETE FROM ALIQTEMP
                       WHERE NRALIQTEMP = P_FILIAL||P_LANCTONF;
                    END IF;
                    SELECT COUNT(*)
                      INTO V_COUNTMENS
                      FROM MENSAGEM
                     WHERE CDMENSAGEM = C_ALIQUOTA.CDMENSAGEM
                       AND IDSITUACAOMENS = 'I';
                    IF V_COUNTMENS > 0 THEN
                       V_DSMENSALIQU := NULL;
                    ELSE
                       V_DSMENSALIQU := C_ALIQUOTA.DSMENSALIQU;
                    END IF;
                    INSERT INTO ALIQTEMP
                       (NRALIQTEMP, NRSEQUALIQ, VRPREDBCTMP, VRPARDEDTMP,
                        VRALIQUTMP, DSMENSALITMP, IDTRIMPSTTMP, VRPBCSTTMP,
                        IDPMCBSCALTMP, CDTIPOOPERTMP, CDINSCESTAATMP, VR1PREDBCTMP,
                        VRADICALIQFECP, CDBENEFFISCAL, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF)
                    VALUES
                       (P_FILIAL||P_LANCTONF, V_SEQUENCIA, C_ALIQUOTA.VRPERREDBC, C_ALIQUOTA.VRPARDEDUZ,
                        C_ALIQUOTA.VRALIQUOTA, V_DSMENSALIQU, C_ALIQUOTA.IDTRATIMPST, C_ALIQUOTA.VRPBCSUBTRIB, 
                        C_ALIQUOTA.IDPMCBASECAL, C_ALIQUOTA.CDTIPOOPER, NULL, C_ALIQUOTA.VR1PERREDBC, 
                        C_ALIQUOTA.VRADICALIQFECP, C_ALIQUOTA.CDBENEFFISCAL, C_ALIQUOTA.IDCONSDIFALIQ, C_ALIQUOTA.IDIMPODESONERA, C_ALIQUOTA.IDCONSDESONVRNF);
                    V_SEQUENCIA := LPAD(RTRIM(V_SEQUENCIA + '01'),2,0);
                  END LOOP;
               ELSIF (V_CDARVPROD IS NULL) THEN /*Se há alíquota para o produto todos*/
                  FOR C_ALIQUOTA IN (
                       SELECT A.NRALIQUOTA, VRPERREDBC, VR1PERREDBC, VRPARDEDUZ, VRALIQUOTA, DSMENSALIQU, IDTRATIMPST, VRPBCSUBTRIB, IDPMCBASECAL, A.CDTIPOOPER, CDMENSAGEM,
                              VRADICALIQFECP, CDBENEFFISCAL, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF
                         FROM ALIQUOTA A, MENSALIQU M
                        WHERE (A.NRALIQUOTA = M.NRALIQUOTA(+))
                          AND (A.CDIMPOSTO = P_IMPOSTO)
                          AND (A.IDENTRSAIDAL = P_ENTRSAIDAL)
                          AND (A.CDEMPRESA = P_EMPRESA)
                          AND (A.CDINSCESTA IS NULL)
                          AND (A.CDGRUPOFISC = V_CDGRUPOFISC)
                          AND (A.CDPRODUTO IS NULL)
                          AND ((A.CDPAISORIG = P_PAISORIG)
                          AND (A.SGESTAORIG = P_ESTAORIG) OR V_UTUFORIG = w_N)
                          AND ((A.CDPAISDEST = P_PAISDEST)
                          AND (A.SGESTADEST = P_ESTADEST) OR V_UTUFDEST = w_N)
                          AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                          AND ((A.VRINIFAIXA < V_VRITEMPROD)
                          AND (A.VRFIMFAIXA >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                          AND (CDTIPOOPER = V_CDTIPOOPER)
                          AND (A.DTINIVALID = (SELECT MAX(DTINIVALID)
                                                 FROM ALIQUOTA
                                                WHERE (CDIMPOSTO = P_IMPOSTO)
                                                  AND (IDENTRSAIDAL = P_ENTRSAIDAL)
                                                  AND (CDEMPRESA = P_EMPRESA)
                                                  AND (CDINSCESTA IS NULL)
                                                  AND (A.CDGRUPOFISC = V_CDGRUPOFISC)
                                                  AND (CDPRODUTO IS NULL)
                                                  AND ((CDPAISORIG = P_PAISORIG)
                                                  AND (SGESTAORIG = P_ESTAORIG) OR V_UTUFORIG = w_N)
                                                  AND ((CDPAISDEST = P_PAISDEST)
                                                  AND (SGESTADEST = P_ESTADEST) OR V_UTUFDEST = w_N)
                                                  AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                                                  AND ((VRINIFAIXA < V_VRITEMPROD)
                                                  AND (VRFIMFAIXA >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                                                  AND (CDTIPOOPER = V_CDTIPOOPER)
                                                  AND (DTINIVALID <= P_INIVALID)))) LOOP
                     SELECT COUNT(*)
                       INTO V_EXISTE
                       FROM ALIQTEMP
                      WHERE NRALIQTEMP = P_FILIAL||P_LANCTONF;
                     IF V_EXISTE > 0 THEN
                        DELETE FROM ALIQTEMP
                        WHERE NRALIQTEMP = P_FILIAL||P_LANCTONF;
                     END IF;
                     SELECT COUNT(*)
                       INTO V_COUNTMENS
                       FROM MENSAGEM
                      WHERE CDMENSAGEM = C_ALIQUOTA.CDMENSAGEM
                        AND IDSITUACAOMENS = 'I';
                     IF V_COUNTMENS > 0 THEN
                        V_DSMENSALIQU := NULL;
                     ELSE
                        V_DSMENSALIQU := C_ALIQUOTA.DSMENSALIQU;
                     END IF;
                     INSERT INTO ALIQTEMP
                        (NRALIQTEMP, NRSEQUALIQ, VRPREDBCTMP, VRPARDEDTMP,
                         VRALIQUTMP, DSMENSALITMP, IDTRIMPSTTMP, VRPBCSTTMP,
                         IDPMCBSCALTMP, CDTIPOOPERTMP, CDINSCESTAATMP, VR1PREDBCTMP,
                         VRADICALIQFECP, CDBENEFFISCAL, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF)
                     VALUES
                        (P_FILIAL||P_LANCTONF, V_SEQUENCIA, C_ALIQUOTA.VRPERREDBC, C_ALIQUOTA.VRPARDEDUZ,
                         C_ALIQUOTA.VRALIQUOTA, V_DSMENSALIQU, C_ALIQUOTA.IDTRATIMPST, C_ALIQUOTA.VRPBCSUBTRIB, 
                         C_ALIQUOTA.IDPMCBASECAL, C_ALIQUOTA.CDTIPOOPER, NULL, C_ALIQUOTA.VR1PERREDBC, 
                         C_ALIQUOTA.VRADICALIQFECP, C_ALIQUOTA.CDBENEFFISCAL, C_ALIQUOTA.IDCONSDIFALIQ, C_ALIQUOTA.IDIMPODESONERA, C_ALIQUOTA.IDCONSDESONVRNF);
                     V_SEQUENCIA := LPAD(RTRIM(V_SEQUENCIA + '01'),2,0);
                  END LOOP;
               END IF;
            ELSIF (V_CDTIPOOPER IS NULL) THEN /*Se não possui alíquota por tipo de operação*/
               IF NOT (V_CDARVPROD IS NULL) THEN /*Se há alíquota para o maior nivel*/
                  FOR C_ALIQUOTA IN (
                       SELECT A.NRALIQUOTA, VRPERREDBC, VR1PERREDBC, VRPARDEDUZ, VRALIQUOTA, DSMENSALIQU, IDTRATIMPST, VRPBCSUBTRIB, IDPMCBASECAL,
                              CDMENSAGEM, VRADICALIQFECP, CDBENEFFISCAL, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF
                         FROM ALIQUOTA A, MENSALIQU M, PRODUTO P
                        WHERE (A.NRALIQUOTA = M.NRALIQUOTA(+))
                          AND (A.CDIMPOSTO = P_IMPOSTO)
                          AND (A.IDENTRSAIDAL = P_ENTRSAIDAL)
                          AND (A.CDEMPRESA = P_EMPRESA)
                          AND (A.CDINSCESTA IS NULL)
                          AND (A.CDGRUPOFISC = V_CDGRUPOFISC)
                          AND (A.CDPRODUTO = P.CDPRODUTO(+))
                          AND (P.CDARVPROD = V_CDARVPROD)
                          AND ((A.CDPAISORIG = P_PAISORIG)
                          AND (A.SGESTAORIG = P_ESTAORIG) OR V_UTUFORIG = w_N)
                          AND ((A.CDPAISDEST = P_PAISDEST)
                          AND (A.SGESTADEST = P_ESTADEST) OR V_UTUFDEST = w_N)
                          AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                          AND ((A.VRINIFAIXA < V_VRITEMPROD)
                          AND (A.VRFIMFAIXA >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                          AND (INSTR(NVL(P_CDTIPOOPER,'_'), NVL(RTRIM(CDTIPOOPER), NVL(P_CDTIPOOPER,'_'))) = 1  OR V_IDUTALIQTPOPER = w_N)
                          AND (A.DTINIVALID = (SELECT MAX(DTINIVALID)
                                                 FROM ALIQUOTA A, PRODUTO P
                                                WHERE (CDIMPOSTO = P_IMPOSTO)
                                                  AND (IDENTRSAIDAL = P_ENTRSAIDAL)
                                                  AND (CDEMPRESA = P_EMPRESA)
                                                  AND (CDINSCESTA IS NULL)
                                                  AND (A.CDGRUPOFISC = V_CDGRUPOFISC)
                                                  AND (A.CDPRODUTO = P.CDPRODUTO(+))
                                                  AND (P.CDARVPROD = V_CDARVPROD)
                                                  AND ((CDPAISORIG = P_PAISORIG)
                                                  AND (SGESTAORIG = P_ESTAORIG) OR V_UTUFORIG = w_N)
                                                  AND ((CDPAISDEST = P_PAISDEST)
                                                  AND (SGESTADEST = P_ESTADEST) OR V_UTUFDEST = w_N)
                                                  AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                                                  AND ((VRINIFAIXA < V_VRITEMPROD)
                                                  AND (VRFIMFAIXA >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                                                  AND (INSTR(NVL(P_CDTIPOOPER,'_'), NVL(RTRIM(CDTIPOOPER), NVL(P_CDTIPOOPER,'_'))) = 1  OR V_IDUTALIQTPOPER = w_N)
                                                  AND (DTINIVALID <= P_INIVALID)))) LOOP
                     SELECT COUNT(*)
                       INTO V_EXISTE
                       FROM ALIQTEMP
                      WHERE NRALIQTEMP = P_FILIAL||P_LANCTONF;
                     IF V_EXISTE > 0 THEN
                        DELETE FROM ALIQTEMP
                        WHERE NRALIQTEMP = P_FILIAL||P_LANCTONF;
                     END IF;
                     SELECT COUNT(*)
                       INTO V_COUNTMENS
                       FROM MENSAGEM
                      WHERE CDMENSAGEM = C_ALIQUOTA.CDMENSAGEM
                        AND IDSITUACAOMENS = 'I';
                     IF V_COUNTMENS > 0 THEN
                        V_DSMENSALIQU := NULL;
                     ELSE
                        V_DSMENSALIQU := C_ALIQUOTA.DSMENSALIQU;
                     END IF;
                     INSERT INTO ALIQTEMP
                        (NRALIQTEMP, NRSEQUALIQ, VRPREDBCTMP, VRPARDEDTMP,
                         VRALIQUTMP, DSMENSALITMP, IDTRIMPSTTMP, VRPBCSTTMP,
                         IDPMCBSCALTMP, CDINSCESTAATMP, VR1PREDBCTMP, VRADICALIQFECP,
                         CDBENEFFISCAL, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF)
                     VALUES
                        (P_FILIAL||P_LANCTONF, V_SEQUENCIA, C_ALIQUOTA.VRPERREDBC, C_ALIQUOTA.VRPARDEDUZ,
                         C_ALIQUOTA.VRALIQUOTA, V_DSMENSALIQU, C_ALIQUOTA.IDTRATIMPST, C_ALIQUOTA.VRPBCSUBTRIB, 
                         C_ALIQUOTA.IDPMCBASECAL, NULL, C_ALIQUOTA.VR1PERREDBC, C_ALIQUOTA.VRADICALIQFECP, 
                         C_ALIQUOTA.CDBENEFFISCAL, C_ALIQUOTA.IDCONSDIFALIQ, C_ALIQUOTA.IDIMPODESONERA, C_ALIQUOTA.IDCONSDESONVRNF);
                     V_SEQUENCIA := LPAD(RTRIM(V_SEQUENCIA + '01'),2,0);
                  END LOOP;
               ELSIF (V_CDARVPROD IS NULL) THEN /*Se há alíquota para o produto todos*/
                  FOR C_ALIQUOTA IN (
                       SELECT A.NRALIQUOTA, VRPERREDBC, VR1PERREDBC, VRPARDEDUZ, VRALIQUOTA, DSMENSALIQU, IDTRATIMPST, VRPBCSUBTRIB, IDPMCBASECAL, CDMENSAGEM,
                              VRADICALIQFECP, CDBENEFFISCAL, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF
                         FROM ALIQUOTA A, MENSALIQU M
                        WHERE (A.NRALIQUOTA = M.NRALIQUOTA(+))
                          AND (A.CDIMPOSTO = P_IMPOSTO)
                          AND (A.IDENTRSAIDAL = P_ENTRSAIDAL)
                          AND (A.CDEMPRESA = P_EMPRESA)
                          AND (A.CDINSCESTA IS NULL)
                          AND (A.CDGRUPOFISC = V_CDGRUPOFISC)
                          AND (A.CDPRODUTO IS NULL)
                          AND ((A.CDPAISORIG = P_PAISORIG)
                          AND (A.SGESTAORIG = P_ESTAORIG) OR V_UTUFORIG = w_N)
                          AND ((A.CDPAISDEST = P_PAISDEST)
                          AND (A.SGESTADEST = P_ESTADEST) OR V_UTUFDEST = w_N)
                          AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                          AND ((A.VRINIFAIXA < V_VRITEMPROD)
                          AND (A.VRFIMFAIXA >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                          AND (INSTR(NVL(P_CDTIPOOPER,'_'), NVL(RTRIM(CDTIPOOPER), NVL(P_CDTIPOOPER,'_'))) = 1  OR V_IDUTALIQTPOPER = w_N)
                          AND (A.DTINIVALID = (SELECT MAX(DTINIVALID)
                                                 FROM ALIQUOTA
                                                WHERE (CDIMPOSTO = P_IMPOSTO)
                                                  AND (IDENTRSAIDAL = P_ENTRSAIDAL)
                                                  AND (CDEMPRESA = P_EMPRESA)
                                                  AND (CDINSCESTA IS NULL)
                                                  AND (A.CDGRUPOFISC = V_CDGRUPOFISC)
                                                  AND (CDPRODUTO IS NULL)
                                                  AND ((CDPAISORIG = P_PAISORIG)
                                                  AND (SGESTAORIG = P_ESTAORIG) OR V_UTUFORIG = w_N)
                                                  AND ((CDPAISDEST = P_PAISDEST)
                                                  AND (SGESTADEST = P_ESTADEST) OR V_UTUFDEST = w_N)
                                                  AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                                                  AND ((VRINIFAIXA < V_VRITEMPROD)
                                                  AND (VRFIMFAIXA >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                                                  AND (INSTR(NVL(P_CDTIPOOPER,'_'), NVL(RTRIM(CDTIPOOPER), NVL(P_CDTIPOOPER,'_'))) = 1  OR V_IDUTALIQTPOPER = w_N)
                                                  AND (DTINIVALID <= P_INIVALID)))) LOOP
                     SELECT COUNT(*)
                       INTO V_EXISTE
                       FROM ALIQTEMP
                      WHERE NRALIQTEMP = P_FILIAL||P_LANCTONF;
                     IF V_EXISTE > 0 THEN
                        DELETE FROM ALIQTEMP
                        WHERE NRALIQTEMP = P_FILIAL||P_LANCTONF;
                     END IF;
                     SELECT COUNT(*)
                       INTO V_COUNTMENS
                       FROM MENSAGEM
                      WHERE CDMENSAGEM = C_ALIQUOTA.CDMENSAGEM
                        AND IDSITUACAOMENS = 'I';
                     IF V_COUNTMENS > 0 THEN
                        V_DSMENSALIQU := NULL;
                     ELSE
                        V_DSMENSALIQU := C_ALIQUOTA.DSMENSALIQU;
                     END IF;
                     INSERT INTO ALIQTEMP
                        (NRALIQTEMP, NRSEQUALIQ, VRPREDBCTMP, VRPARDEDTMP,
                         VRALIQUTMP, DSMENSALITMP, IDTRIMPSTTMP, VRPBCSTTMP,
                         IDPMCBSCALTMP, CDINSCESTAATMP, VR1PREDBCTMP, VRADICALIQFECP,
                         CDBENEFFISCAL, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF)
                     VALUES
                        (P_FILIAL||P_LANCTONF, V_SEQUENCIA, C_ALIQUOTA.VRPERREDBC, C_ALIQUOTA.VRPARDEDUZ,
                         C_ALIQUOTA.VRALIQUOTA, V_DSMENSALIQU, C_ALIQUOTA.IDTRATIMPST, C_ALIQUOTA.VRPBCSUBTRIB, 
                         C_ALIQUOTA.IDPMCBASECAL, NULL, C_ALIQUOTA.VR1PERREDBC, C_ALIQUOTA.VRADICALIQFECP, 
                         C_ALIQUOTA.CDBENEFFISCAL, C_ALIQUOTA.IDCONSDIFALIQ, C_ALIQUOTA.IDIMPODESONERA, C_ALIQUOTA.IDCONSDESONVRNF);
                     V_SEQUENCIA := LPAD(RTRIM(V_SEQUENCIA + '01'),2,0);
                  END LOOP;
               END IF;
            END IF;
         END IF;
         /*Por Cliente*/
         V_CDGRUPOFISC := NULL;
         BEGIN
            SELECT MAX(G.CDGRUPOFISC)
              INTO V_CDGRUPOFISC
              FROM GRFISIMPIECLIE G, (SELECT CDCLIENTE
                                        FROM NOTAFISCAL
                                       WHERE CDFILIAL = P_FILIAL
                                         AND NRLANCTONF = P_LANCTONF
                                         AND P_CDCLIENTE IS NULL
                                       UNION ALL
                                      SELECT CDCLIENTE
                                        FROM CLIENTE
                                       WHERE CDCLIENTE = P_CDCLIENTE) F
             WHERE G.CDIMPOSTO = P_IMPOSTO
               AND G.CDCLIENTE = F.CDCLIENTE
               AND G.CDEMPRESA = P_EMPRESA
               AND G.CDINSCESTA = P_INSCESTA;
         EXCEPTION
            WHEN No_Data_Found THEN
               V_CDGRUPOFISC := NULL;
         END;
         IF NOT (V_CDGRUPOFISC IS NULL) THEN /*Se há grupo fiscal na tela Parâmetros de Grupo Fiscal na aba Imposto/Inscrição Estadual*/
            IF V_IDPRODNOTA = w_P THEN /*Se imposto do item*/
               SELECT MAX(CDTIPOOPER), COUNT(*)
                 INTO V_CDTIPOOPER, V_CONTADOR
                 FROM ALIQUOTA A, PRODUTO P
                WHERE (CDIMPOSTO    = P_IMPOSTO)
                  AND (IDENTRSAIDAL = P_ENTRSAIDAL)
                  AND (CDEMPRESA    = P_EMPRESA)
                  AND (CDINSCESTA   IS NULL)
                  AND (CDGRUPOFISC  = V_CDGRUPOFISC)
                  AND ((CDPAISORIG  = P_PAISORIG) AND (SGESTAORIG  = P_ESTAORIG) OR V_UTUFORIG = w_N)
                  AND ((CDPAISDEST  = P_PAISDEST) AND (SGESTADEST  = P_ESTADEST) OR V_UTUFDEST = w_N)
                  AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                  AND ((VRINIFAIXA  < V_VRITEMPROD) AND (VRFIMFAIXA  >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                  AND (INSTR(NVL(P_CDTIPOOPER,'_'), NVL(RTRIM(CDTIPOOPER), NVL(P_CDTIPOOPER,'_'))) = 1  OR V_IDUTALIQTPOPER = w_N)
                  AND (A.CDPRODUTO = P.CDPRODUTO(+))
                  AND (INSTR(NVL(P_PRODUTO,'_'),NVL(RTRIM(P.CDARVPROD),NVL(P_PRODUTO,'_'))) = 1);
               IF NOT (V_CDTIPOOPER IS NULL) THEN /*Se possui alíquota por tipo de operação*/
                  SELECT MAX(P.CDARVPROD)
                    INTO V_CDARVPROD
                    FROM ALIQUOTA A, PRODUTO P
                   WHERE (CDIMPOSTO    = P_IMPOSTO)
                     AND (IDENTRSAIDAL = P_ENTRSAIDAL)
                     AND (CDEMPRESA    = P_EMPRESA)
                     AND (CDINSCESTA  IS NULL)
                     AND (CDGRUPOFISC  = V_CDGRUPOFISC)
                     AND ((CDPAISORIG  = P_PAISORIG) AND (SGESTAORIG  = P_ESTAORIG) OR V_UTUFORIG = w_N)
                     AND ((CDPAISDEST  = P_PAISDEST) AND (SGESTADEST  = P_ESTADEST) OR V_UTUFDEST = w_N)
                     AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                     AND ((VRINIFAIXA  < V_VRITEMPROD) AND (VRFIMFAIXA  >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                     AND (CDTIPOOPER = V_CDTIPOOPER OR V_IDUTALIQTPOPER = w_N)
                     AND (A.CDPRODUTO = P.CDPRODUTO(+))
                     AND (INSTR(NVL(P_PRODUTO,'_'),NVL(RTRIM(P.CDARVPROD),NVL(P_PRODUTO,'_'))) = 1);
               ELSIF (V_CDTIPOOPER IS NULL) THEN /*Se não possui alíquota por tipo de operação*/
                  SELECT MAX(P.CDARVPROD)
                    INTO V_CDARVPROD
                    FROM ALIQUOTA A, PRODUTO P
                   WHERE (CDIMPOSTO    = P_IMPOSTO)
                     AND (IDENTRSAIDAL = P_ENTRSAIDAL)
                     AND (CDEMPRESA    = P_EMPRESA)
                     AND (CDINSCESTA   IS NULL)
                     AND (CDGRUPOFISC  = V_CDGRUPOFISC)
                     AND ((CDPAISORIG  = P_PAISORIG) AND (SGESTAORIG  = P_ESTAORIG) OR V_UTUFORIG = w_N)
                     AND ((CDPAISDEST  = P_PAISDEST) AND (SGESTADEST  = P_ESTADEST) OR V_UTUFDEST = w_N)
                     AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                     AND ((VRINIFAIXA  < V_VRITEMPROD) AND (VRFIMFAIXA  >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                     AND (INSTR(NVL(P_CDTIPOOPER,'_'), NVL(RTRIM(CDTIPOOPER), NVL(P_CDTIPOOPER,'_'))) = 1  OR V_IDUTALIQTPOPER = w_N)
                     AND (A.CDPRODUTO = P.CDPRODUTO(+))
                     AND (INSTR(NVL(P_PRODUTO,'_'),NVL(RTRIM(P.CDARVPROD),NVL(P_PRODUTO,'_'))) = 1);
               END IF;
            ELSE /*Se imposto da nota*/
               SELECT MAX(A.CDPRODUTO), COUNT(*), MAX(CDTIPOOPER)
                 INTO V_CDARVPROD, V_CONTADOR, V_CDTIPOOPER
                 FROM ALIQUOTA A
                WHERE (CDIMPOSTO    = P_IMPOSTO)
                  AND (IDENTRSAIDAL = P_ENTRSAIDAL)
                  AND (CDEMPRESA    = P_EMPRESA)
                  AND (CDINSCESTA   IS NULL)
                  AND (CDGRUPOFISC  = V_CDGRUPOFISC)
                  AND ((CDPAISORIG  = P_PAISORIG) AND (SGESTAORIG  = P_ESTAORIG) OR V_UTUFORIG = w_N)
                  AND ((CDPAISDEST  = P_PAISDEST) AND (SGESTADEST  = P_ESTADEST) OR V_UTUFDEST = w_N)
                  AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                  AND ((VRINIFAIXA  < V_VRITEMPROD) AND (VRFIMFAIXA  >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                  AND (INSTR(NVL(P_CDTIPOOPER,'_'), NVL(RTRIM(CDTIPOOPER), NVL(P_CDTIPOOPER,'_'))) = 1  OR V_IDUTALIQTPOPER = w_N)
                  AND (A.CDPRODUTO IS NULL);
            END IF;
            IF NOT (V_CDTIPOOPER IS NULL) THEN /*Se possui alíquota por tipo de operação*/
               IF NOT (V_CDARVPROD IS NULL) THEN /*Se há alíquota para o maior nivel*/
                  FOR C_ALIQUOTA IN (
                       SELECT A.NRALIQUOTA, VRPERREDBC, VR1PERREDBC, VRPARDEDUZ, VRALIQUOTA, DSMENSALIQU, IDTRATIMPST, VRPBCSUBTRIB, IDPMCBASECAL, CDTIPOOPER, CDMENSAGEM,
                              VRADICALIQFECP, CDBENEFFISCAL, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF
                         FROM ALIQUOTA A, MENSALIQU M, PRODUTO P
                        WHERE (A.NRALIQUOTA = M.NRALIQUOTA(+))
                          AND (A.CDIMPOSTO = P_IMPOSTO)
                          AND (A.IDENTRSAIDAL = P_ENTRSAIDAL)
                          AND (A.CDEMPRESA = P_EMPRESA)
                          AND (A.CDINSCESTA IS NULL)
                          AND (A.CDGRUPOFISC = V_CDGRUPOFISC)
                          AND (A.CDPRODUTO = P.CDPRODUTO(+))
                          AND (P.CDARVPROD = V_CDARVPROD)
                          AND ((A.CDPAISORIG = P_PAISORIG)
                          AND (A.SGESTAORIG = P_ESTAORIG) OR V_UTUFORIG = w_N)
                          AND ((A.CDPAISDEST = P_PAISDEST)
                          AND (A.SGESTADEST = P_ESTADEST) OR V_UTUFDEST = w_N)
                          AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                          AND ((A.VRINIFAIXA < V_VRITEMPROD)
                          AND (A.VRFIMFAIXA >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                          AND (CDTIPOOPER = V_CDTIPOOPER)
                          AND (A.DTINIVALID = (SELECT MAX(DTINIVALID)
                                                 FROM ALIQUOTA A, PRODUTO P
                                                WHERE (CDIMPOSTO = P_IMPOSTO)
                                                  AND (IDENTRSAIDAL = P_ENTRSAIDAL)
                                                  AND (CDEMPRESA = P_EMPRESA)
                                                  AND (CDINSCESTA IS NULL)
                                                  AND (A.CDGRUPOFISC = V_CDGRUPOFISC)
                                                  AND (A.CDPRODUTO = P.CDPRODUTO(+))
                                                  AND (P.CDARVPROD = V_CDARVPROD)
                                                  AND ((CDPAISORIG = P_PAISORIG)
                                                  AND (SGESTAORIG = P_ESTAORIG) OR V_UTUFORIG = w_N)
                                                  AND ((CDPAISDEST = P_PAISDEST)
                                                  AND (SGESTADEST = P_ESTADEST) OR V_UTUFDEST = w_N)
                                                  AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                                                  AND ((VRINIFAIXA < V_VRITEMPROD)
                                                  AND (VRFIMFAIXA >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                                                  AND (CDTIPOOPER = V_CDTIPOOPER)
                                                  AND (DTINIVALID <= P_INIVALID)))) LOOP
                     SELECT COUNT(*)
                       INTO V_EXISTE
                       FROM ALIQTEMP
                      WHERE NRALIQTEMP = P_FILIAL||P_LANCTONF;
                     IF V_EXISTE > 0 THEN
                        DELETE FROM ALIQTEMP
                        WHERE NRALIQTEMP = P_FILIAL||P_LANCTONF;
                     END IF;
                     SELECT COUNT(*)
                       INTO V_COUNTMENS
                       FROM MENSAGEM
                      WHERE CDMENSAGEM = C_ALIQUOTA.CDMENSAGEM
                        AND IDSITUACAOMENS = 'I';
                     IF V_COUNTMENS > 0 THEN
                        V_DSMENSALIQU := NULL;
                     ELSE
                        V_DSMENSALIQU := C_ALIQUOTA.DSMENSALIQU;
                     END IF;
                     INSERT INTO ALIQTEMP
                        (NRALIQTEMP, NRSEQUALIQ, VRPREDBCTMP, VRPARDEDTMP,
                         VRALIQUTMP, DSMENSALITMP, IDTRIMPSTTMP, VRPBCSTTMP,
                         IDPMCBSCALTMP, CDTIPOOPERTMP, CDINSCESTAATMP, VR1PREDBCTMP,
                         VRADICALIQFECP, CDBENEFFISCAL, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF)
                     VALUES
                        (P_FILIAL||P_LANCTONF, V_SEQUENCIA, C_ALIQUOTA.VRPERREDBC, C_ALIQUOTA.VRPARDEDUZ,
                         C_ALIQUOTA.VRALIQUOTA, V_DSMENSALIQU, C_ALIQUOTA.IDTRATIMPST, C_ALIQUOTA.VRPBCSUBTRIB, 
                         C_ALIQUOTA.IDPMCBASECAL, C_ALIQUOTA.CDTIPOOPER, NULL, C_ALIQUOTA.VR1PERREDBC, 
                         C_ALIQUOTA.VRADICALIQFECP, C_ALIQUOTA.CDBENEFFISCAL, C_ALIQUOTA.IDCONSDIFALIQ, C_ALIQUOTA.IDIMPODESONERA, C_ALIQUOTA.IDCONSDESONVRNF);
                     V_SEQUENCIA := LPAD(RTRIM(V_SEQUENCIA + '01'),2,0);
                  END LOOP;
               ELSIF (V_CDARVPROD IS NULL) THEN /*Se há alíquota para o produto todos*/
                  FOR C_ALIQUOTA IN (
                       SELECT A.NRALIQUOTA, VRPERREDBC, VR1PERREDBC, VRPARDEDUZ, VRALIQUOTA, DSMENSALIQU, IDTRATIMPST, VRPBCSUBTRIB, IDPMCBASECAL, A.CDTIPOOPER, CDMENSAGEM,
                              VRADICALIQFECP, CDBENEFFISCAL, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF
                         FROM ALIQUOTA A, MENSALIQU M
                        WHERE (A.NRALIQUOTA = M.NRALIQUOTA(+))
                          AND (A.CDIMPOSTO = P_IMPOSTO)
                          AND (A.IDENTRSAIDAL = P_ENTRSAIDAL)
                          AND (A.CDEMPRESA = P_EMPRESA)
                          AND (A.CDINSCESTA IS NULL)
                          AND (A.CDGRUPOFISC = V_CDGRUPOFISC)
                          AND (A.CDPRODUTO IS NULL)
                          AND ((A.CDPAISORIG = P_PAISORIG)
                          AND (A.SGESTAORIG = P_ESTAORIG) OR V_UTUFORIG = w_N)
                          AND ((A.CDPAISDEST = P_PAISDEST)
                          AND (A.SGESTADEST = P_ESTADEST) OR V_UTUFDEST = w_N)
                          AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                          AND ((A.VRINIFAIXA < V_VRITEMPROD)
                          AND (A.VRFIMFAIXA >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                          AND (CDTIPOOPER = V_CDTIPOOPER)
                          AND (A.DTINIVALID = (SELECT MAX(DTINIVALID)
                                                 FROM ALIQUOTA
                                                WHERE (CDIMPOSTO = P_IMPOSTO)
                                                  AND (IDENTRSAIDAL = P_ENTRSAIDAL)
                                                  AND (CDEMPRESA = P_EMPRESA)
                                                  AND (CDINSCESTA IS NULL)
                                                  AND (A.CDGRUPOFISC = V_CDGRUPOFISC)
                                                  AND (CDPRODUTO IS NULL)
                                                  AND ((CDPAISORIG = P_PAISORIG)
                                                  AND (SGESTAORIG = P_ESTAORIG) OR V_UTUFORIG = w_N)
                                                  AND ((CDPAISDEST = P_PAISDEST)
                                                  AND (SGESTADEST = P_ESTADEST) OR V_UTUFDEST = w_N)
                                                  AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                                                  AND ((VRINIFAIXA < V_VRITEMPROD)
                                                  AND (VRFIMFAIXA >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                                                  AND (CDTIPOOPER = V_CDTIPOOPER)
                                                  AND (DTINIVALID <= P_INIVALID)))) LOOP
                     SELECT COUNT(*)
                       INTO V_EXISTE
                       FROM ALIQTEMP
                      WHERE NRALIQTEMP = P_FILIAL||P_LANCTONF;
                     IF V_EXISTE > 0 THEN
                        DELETE FROM ALIQTEMP
                        WHERE NRALIQTEMP = P_FILIAL||P_LANCTONF;
                     END IF;
                     SELECT COUNT(*)
                       INTO V_COUNTMENS
                       FROM MENSAGEM
                      WHERE CDMENSAGEM = C_ALIQUOTA.CDMENSAGEM
                        AND IDSITUACAOMENS = 'I';
                     IF V_COUNTMENS > 0 THEN
                        V_DSMENSALIQU := NULL;
                     ELSE
                        V_DSMENSALIQU := C_ALIQUOTA.DSMENSALIQU;
                     END IF;
                     INSERT INTO ALIQTEMP
                        (NRALIQTEMP, NRSEQUALIQ, VRPREDBCTMP, VRPARDEDTMP,
                         VRALIQUTMP, DSMENSALITMP, IDTRIMPSTTMP, VRPBCSTTMP,
                         IDPMCBSCALTMP, CDTIPOOPERTMP, CDINSCESTAATMP, VR1PREDBCTMP,
                         VRADICALIQFECP, CDBENEFFISCAL, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF)
                     VALUES
                        (P_FILIAL||P_LANCTONF, V_SEQUENCIA, C_ALIQUOTA.VRPERREDBC, C_ALIQUOTA.VRPARDEDUZ,
                         C_ALIQUOTA.VRALIQUOTA, V_DSMENSALIQU, C_ALIQUOTA.IDTRATIMPST, C_ALIQUOTA.VRPBCSUBTRIB, 
                         C_ALIQUOTA.IDPMCBASECAL, C_ALIQUOTA.CDTIPOOPER, NULL, C_ALIQUOTA.VR1PERREDBC, 
                         C_ALIQUOTA.VRADICALIQFECP, C_ALIQUOTA.CDBENEFFISCAL, C_ALIQUOTA.IDCONSDIFALIQ, C_ALIQUOTA.IDIMPODESONERA, C_ALIQUOTA.IDCONSDESONVRNF);
                     V_SEQUENCIA := LPAD(RTRIM(V_SEQUENCIA + '01'),2,0);
                  END LOOP;
               END IF;
            ELSIF (V_CDTIPOOPER IS NULL) THEN /*Se não possui alíquota por tipo de operação*/
               IF NOT (V_CDARVPROD IS NULL) THEN /*Se há alíquota para o maior nivel*/
                  FOR C_ALIQUOTA IN (
                       SELECT A.NRALIQUOTA, VRPERREDBC, VR1PERREDBC, VRPARDEDUZ, VRALIQUOTA, DSMENSALIQU, IDTRATIMPST, VRPBCSUBTRIB, IDPMCBASECAL,
                              CDMENSAGEM, VRADICALIQFECP, CDBENEFFISCAL, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF
                         FROM ALIQUOTA A, MENSALIQU M, PRODUTO P
                        WHERE (A.NRALIQUOTA = M.NRALIQUOTA(+))
                          AND (A.CDIMPOSTO = P_IMPOSTO)
                          AND (A.IDENTRSAIDAL = P_ENTRSAIDAL)
                          AND (A.CDEMPRESA = P_EMPRESA)
                          AND (A.CDINSCESTA IS NULL)
                          AND (A.CDGRUPOFISC = V_CDGRUPOFISC)
                          AND (A.CDPRODUTO = P.CDPRODUTO(+))
                          AND (P.CDARVPROD = V_CDARVPROD)
                          AND ((A.CDPAISORIG = P_PAISORIG)
                          AND (A.SGESTAORIG = P_ESTAORIG) OR V_UTUFORIG = w_N)
                          AND ((A.CDPAISDEST = P_PAISDEST)
                          AND (A.SGESTADEST = P_ESTADEST) OR V_UTUFDEST = w_N)
                          AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                          AND ((A.VRINIFAIXA < V_VRITEMPROD)
                          AND (A.VRFIMFAIXA >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                          AND (INSTR(NVL(P_CDTIPOOPER,'_'), NVL(RTRIM(CDTIPOOPER), NVL(P_CDTIPOOPER,'_'))) = 1  OR V_IDUTALIQTPOPER = w_N)
                          AND (A.DTINIVALID = (SELECT MAX(DTINIVALID)
                                                 FROM ALIQUOTA A, PRODUTO P
                                                WHERE (CDIMPOSTO = P_IMPOSTO)
                                                  AND (IDENTRSAIDAL = P_ENTRSAIDAL)
                                                  AND (CDEMPRESA = P_EMPRESA)
                                                  AND (CDINSCESTA IS NULL)
                                                  AND (A.CDGRUPOFISC = V_CDGRUPOFISC)
                                                  AND (A.CDPRODUTO = P.CDPRODUTO(+))
                                                  AND (P.CDARVPROD = V_CDARVPROD)
                                                  AND ((CDPAISORIG = P_PAISORIG)
                                                  AND (SGESTAORIG = P_ESTAORIG) OR V_UTUFORIG = w_N)
                                                  AND ((CDPAISDEST = P_PAISDEST)
                                                  AND (SGESTADEST = P_ESTADEST) OR V_UTUFDEST = w_N)
                                                  AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                                                  AND ((VRINIFAIXA < V_VRITEMPROD)
                                                  AND (VRFIMFAIXA >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                                                  AND (INSTR(NVL(P_CDTIPOOPER,'_'), NVL(RTRIM(CDTIPOOPER), NVL(P_CDTIPOOPER,'_'))) = 1  OR V_IDUTALIQTPOPER = w_N)
                                                  AND (DTINIVALID <= P_INIVALID)))) LOOP
                     SELECT COUNT(*)
                       INTO V_EXISTE
                       FROM ALIQTEMP
                      WHERE NRALIQTEMP = P_FILIAL||P_LANCTONF;
                     IF V_EXISTE > 0 THEN
                        DELETE FROM ALIQTEMP
                        WHERE NRALIQTEMP = P_FILIAL||P_LANCTONF;
                     END IF;
                     SELECT COUNT(*)
                       INTO V_COUNTMENS
                       FROM MENSAGEM
                      WHERE CDMENSAGEM = C_ALIQUOTA.CDMENSAGEM
                        AND IDSITUACAOMENS = 'I';
                     IF V_COUNTMENS > 0 THEN
                        V_DSMENSALIQU := NULL;
                     ELSE
                        V_DSMENSALIQU := C_ALIQUOTA.DSMENSALIQU;
                     END IF;
                     INSERT INTO ALIQTEMP
                        (NRALIQTEMP, NRSEQUALIQ, VRPREDBCTMP, VRPARDEDTMP,
                         VRALIQUTMP, DSMENSALITMP, IDTRIMPSTTMP, VRPBCSTTMP,
                         IDPMCBSCALTMP, CDINSCESTAATMP, VR1PREDBCTMP, VRADICALIQFECP,
                         CDBENEFFISCAL, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF)
                     VALUES
                        (P_FILIAL||P_LANCTONF, V_SEQUENCIA, C_ALIQUOTA.VRPERREDBC, C_ALIQUOTA.VRPARDEDUZ,
                         C_ALIQUOTA.VRALIQUOTA, V_DSMENSALIQU, C_ALIQUOTA.IDTRATIMPST, C_ALIQUOTA.VRPBCSUBTRIB, 
                         C_ALIQUOTA.IDPMCBASECAL, NULL, C_ALIQUOTA.VR1PERREDBC, C_ALIQUOTA.VRADICALIQFECP, 
                         C_ALIQUOTA.CDBENEFFISCAL, C_ALIQUOTA.IDCONSDIFALIQ, C_ALIQUOTA.IDIMPODESONERA, C_ALIQUOTA.IDCONSDESONVRNF);
                     V_SEQUENCIA := LPAD(RTRIM(V_SEQUENCIA + '01'),2,0);
                  END LOOP;
               ELSIF (V_CDARVPROD IS NULL) THEN /*Se há alíquota para o produto todos*/
                  FOR C_ALIQUOTA IN (
                       SELECT A.NRALIQUOTA, VRPERREDBC, VR1PERREDBC, VRPARDEDUZ, VRALIQUOTA, DSMENSALIQU, IDTRATIMPST, VRPBCSUBTRIB, IDPMCBASECAL,
                              CDMENSAGEM, VRADICALIQFECP, CDBENEFFISCAL, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF
                         FROM ALIQUOTA A, MENSALIQU M
                        WHERE (A.NRALIQUOTA = M.NRALIQUOTA(+))
                          AND (A.CDIMPOSTO = P_IMPOSTO)
                          AND (A.IDENTRSAIDAL = P_ENTRSAIDAL)
                          AND (A.CDEMPRESA = P_EMPRESA)
                          AND (A.CDINSCESTA IS NULL)
                          AND (A.CDGRUPOFISC = V_CDGRUPOFISC)
                          AND (A.CDPRODUTO IS NULL)
                          AND ((A.CDPAISORIG = P_PAISORIG)
                          AND (A.SGESTAORIG = P_ESTAORIG) OR V_UTUFORIG = w_N)
                          AND ((A.CDPAISDEST = P_PAISDEST)
                          AND (A.SGESTADEST = P_ESTADEST) OR V_UTUFDEST = w_N)
                          AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                          AND ((A.VRINIFAIXA < V_VRITEMPROD)
                          AND (A.VRFIMFAIXA >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                          AND (INSTR(NVL(P_CDTIPOOPER,'_'), NVL(RTRIM(CDTIPOOPER), NVL(P_CDTIPOOPER,'_'))) = 1  OR V_IDUTALIQTPOPER = w_N)
                          AND (A.DTINIVALID = (SELECT MAX(DTINIVALID)
                                                 FROM ALIQUOTA
                                                WHERE (CDIMPOSTO = P_IMPOSTO)
                                                  AND (IDENTRSAIDAL = P_ENTRSAIDAL)
                                                  AND (CDEMPRESA = P_EMPRESA)
                                                  AND (CDINSCESTA IS NULL)
                                                  AND (A.CDGRUPOFISC = V_CDGRUPOFISC)
                                                  AND (CDPRODUTO IS NULL)
                                                  AND ((CDPAISORIG = P_PAISORIG)
                                                  AND (SGESTAORIG = P_ESTAORIG) OR V_UTUFORIG = w_N)
                                                  AND ((CDPAISDEST = P_PAISDEST)
                                                  AND (SGESTADEST = P_ESTADEST) OR V_UTUFDEST = w_N)
                                                  AND ((CDMUNIORIG   = P_MUNIORIG and V_UTMUNIORIG = w_O) OR (CDMUNIDEST   = P_MUNIORIG and V_UTMUNIORIG = w_D) OR (V_UTMUNIORIG = w_N))
                                                  AND ((VRINIFAIXA < V_VRITEMPROD)
                                                  AND (VRFIMFAIXA >= V_VRITEMPROD) OR V_UTFAIXVLR = w_N)
                                                  AND (INSTR(NVL(P_CDTIPOOPER,'_'), NVL(RTRIM(CDTIPOOPER), NVL(P_CDTIPOOPER,'_'))) = 1  OR V_IDUTALIQTPOPER = w_N)
                                                  AND (DTINIVALID <= P_INIVALID)))) LOOP
                     SELECT COUNT(*)
                       INTO V_EXISTE
                       FROM ALIQTEMP
                      WHERE NRALIQTEMP = P_FILIAL||P_LANCTONF;
                     IF V_EXISTE > 0 THEN
                        DELETE FROM ALIQTEMP
                        WHERE NRALIQTEMP = P_FILIAL||P_LANCTONF;
                     END IF;
                     SELECT COUNT(*)
                       INTO V_COUNTMENS
                       FROM MENSAGEM
                      WHERE CDMENSAGEM = C_ALIQUOTA.CDMENSAGEM
                        AND IDSITUACAOMENS = 'I';
                     IF V_COUNTMENS > 0 THEN
                        V_DSMENSALIQU := NULL;
                     ELSE
                        V_DSMENSALIQU := C_ALIQUOTA.DSMENSALIQU;
                     END IF;
                     INSERT INTO ALIQTEMP
                        (NRALIQTEMP, NRSEQUALIQ, VRPREDBCTMP, VRPARDEDTMP,
                         VRALIQUTMP, DSMENSALITMP, IDTRIMPSTTMP, VRPBCSTTMP,
                         IDPMCBSCALTMP, CDINSCESTAATMP, VR1PREDBCTMP, VRADICALIQFECP,
                         CDBENEFFISCAL, IDCONSDIFALIQ, IDIMPODESONERA, IDCONSDESONVRNF)
                     VALUES
                        (P_FILIAL||P_LANCTONF, V_SEQUENCIA, C_ALIQUOTA.VRPERREDBC, C_ALIQUOTA.VRPARDEDUZ,
                         C_ALIQUOTA.VRALIQUOTA, V_DSMENSALIQU, C_ALIQUOTA.IDTRATIMPST, C_ALIQUOTA.VRPBCSUBTRIB, 
                         C_ALIQUOTA.IDPMCBASECAL, NULL, C_ALIQUOTA.VR1PERREDBC, C_ALIQUOTA.VRADICALIQFECP, 
                         C_ALIQUOTA.CDBENEFFISCAL, C_ALIQUOTA.IDCONSDIFALIQ, C_ALIQUOTA.IDIMPODESONERA, C_ALIQUOTA.IDCONSDESONVRNF);
                     V_SEQUENCIA := LPAD(RTRIM(V_SEQUENCIA + '01'),2,0);
                  END LOOP;
               END IF;
            END IF;
         END IF;
      END IF;
   END IF;
END;
/
CREATE OR REPLACE PROCEDURE CONSULTA_DESONERACAO(
   P_CDFILIAL IN VARCHAR2,
   P_NRLANCTONF IN VARCHAR2,
   P_CDPAISDEST IN VARCHAR2,
   P_SGESTADODEST IN VARCHAR2,
   P_VRDESONERA OUT FLOAT)
IS
   V_VRDESONERA FLOAT;
   V_CDDESTINO VARCHAR2(50);
   V_IDORIGDESTNF VARCHAR2(1);
   V_VRIMPOSTODESON FLOAT;
   V_CDPAISEMIT VARCHAR2(04);
   V_SGESTADOEMIT VARCHAR2(02);
   V_VRPERREDBCIT FLOAT;
   V_VRALIQNORMAL FLOAT;
BEGIN
   V_VRDESONERA := 0;
   BEGIN
      SELECT NVL(N.CDCLIENTE, NVL(N.CDFORNECED, DECODE(N.IDENTRSAIDOP, 'S', N.CDFILIRECE, N.CDFILIEMIT))) AS CDDESTINO, 
             N.IDORIGDESTNF,
             I.CDPAIS,
             I.SGESTADO          
        INTO V_CDDESTINO, 
             V_IDORIGDESTNF,
             V_CDPAISEMIT,
             V_SGESTADOEMIT
        FROM NOTAFISCAL N JOIN INSCRESTAD I ON (N.CDEMPRESA = I.CDEMPRESA)
                                           AND (N.CDINSCESTA = I.CDINSCESTA)
       WHERE N.CDFILIAL = P_CDFILIAL
         AND N.NRLANCTONF = P_NRLANCTONF;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN BEGIN
         V_CDDESTINO := NULL;
         V_IDORIGDESTNF := NULL;
         V_CDPAISEMIT := NULL;
         V_SGESTADOEMIT := NULL;
      END;
   END;
   FOR C_ITEMPROIMPOS IN (SELECT IP.CDFILIAL, 
                                 IP.NRLANCTONF, 
                                 IP.NRSEQITPROD, 
                                 IP.CDIMPOSTO,
                                 NVL(IP.IDCONSDESONVRNF, 'N') AS IDCONSDESONVRNF,
                                 IP.VRIMPOSTOIT,
                                 IP.CDSITUTRIBITNFE,
                                 (IT.VRTOTAITEM - IT.VRDESCITEM) AS VRTOTAITEM,
                                 (IP.VRALIQITEM / 100) AS VRALIQITEM,
                                 (IP.VRPERREDBCIT / 100) AS VRPERREDBCIT
                            FROM ITEMPRODUTO IT LEFT JOIN ITEMPROIMPOS IP ON (IT.CDFILIAL = IP.CDFILIAL)
                                                                         AND (IT.NRLANCTONF = IP.NRLANCTONF)
                           WHERE IT.CDFILIAL = P_CDFILIAL
                             AND IT.NRLANCTONF = P_NRLANCTONF
                             AND IP.IDDESONERAREGRA = 'S'
                             AND IP.NRITPROIMPOS = '1')
   LOOP
      V_VRIMPOSTODESON := C_ITEMPROIMPOS.VRIMPOSTOIT;
      IF (V_CDPAISEMIT = '0055') AND (V_SGESTADOEMIT = 'RJ') THEN
         IF C_ITEMPROIMPOS.CDSITUTRIBITNFE IN ('20', '70') THEN
            IF (NVL(C_ITEMPROIMPOS.VRPERREDBCIT, 0) = 0) THEN
               BEGIN
                  SELECT (NVL(CONSULTA_QUADRO_ALIQUOTAS(V_SGESTADOEMIT, P_SGESTADODEST), 0) / 100)
                    INTO V_VRALIQNORMAL
                    FROM DUAL;
               EXCEPTION
                  WHEN NO_DATA_FOUND THEN BEGIN
                     V_VRALIQNORMAL := 0;
                  END;
               END;
               V_VRPERREDBCIT := 1 - (C_ITEMPROIMPOS.VRALIQITEM / V_VRALIQNORMAL);
            ELSE
               V_VRPERREDBCIT := 1 - C_ITEMPROIMPOS.VRPERREDBCIT;
            END IF;
            -- VALOR DO ICMS DESONERADO = PREÇO NA NOTA FISCAL * (1 - (ALÍQUOTA * (1 - PERCENTUAL DE REDUÇÃO DA BC))) / (1 - ALÍQUOTA) - PREÇO NA NOTA FISCAL
            V_VRIMPOSTODESON := ROUND(C_ITEMPROIMPOS.VRTOTAITEM * (1 - (C_ITEMPROIMPOS.VRALIQITEM * (1 - V_VRPERREDBCIT))) / (1 - C_ITEMPROIMPOS.VRALIQITEM) - C_ITEMPROIMPOS.VRTOTAITEM, 2);
         END IF;
         IF C_ITEMPROIMPOS.CDSITUTRIBITNFE IN ('30', '40') THEN
            -- VALOR DO ICMS DESONERADO = (PREÇO NA NOTA FISCAL / (1 - ALÍQUOTA)) * ALÍQUOTA
            V_VRIMPOSTODESON := ROUND((C_ITEMPROIMPOS.VRTOTAITEM / (1 - C_ITEMPROIMPOS.VRALIQITEM)) * C_ITEMPROIMPOS.VRALIQITEM, 2);
         END IF;
      END IF;
      IF C_ITEMPROIMPOS.IDCONSDESONVRNF = 'S' THEN
         V_VRDESONERA := V_VRDESONERA + V_VRIMPOSTODESON; --C_ITEMPROIMPOS.VRIMPOSTOIT;
      END IF;
      UPDATE ITEMPROIMPOS
         SET IDIMPDESONERAIT = CASE C_ITEMPROIMPOS.IDCONSDESONVRNF WHEN 'S' THEN 'S' ELSE 'N' END,
             VRIMPOSTODESON = V_VRIMPOSTODESON
       WHERE CDFILIAL = C_ITEMPROIMPOS.CDFILIAL
         AND NRLANCTONF = C_ITEMPROIMPOS.NRLANCTONF
         AND NRSEQITPROD = C_ITEMPROIMPOS.NRSEQITPROD
         AND CDIMPOSTO = C_ITEMPROIMPOS.CDIMPOSTO
         AND NRITPROIMPOS = '1';
      UPDATE TRABITPROIMPOS
         SET IDIMPDESOTRABIT = CASE C_ITEMPROIMPOS.IDCONSDESONVRNF WHEN 'S' THEN 'S' ELSE 'N' END
       WHERE CDFILIMPOIT = C_ITEMPROIMPOS.CDFILIAL
         AND NRLANCIMPOIT = C_ITEMPROIMPOS.NRLANCTONF
         AND NRSEQIMPOIT = C_ITEMPROIMPOS.NRSEQITPROD
         AND CDIMPOSTOIT = C_ITEMPROIMPOS.CDIMPOSTO;
      UPDATE IMPOSTONF
         SET IDIMPDESONERANF = CASE C_ITEMPROIMPOS.IDCONSDESONVRNF WHEN 'S' THEN 'S' ELSE 'N' END
       WHERE CDFILIAL = C_ITEMPROIMPOS.CDFILIAL
         AND NRLANCTONF = C_ITEMPROIMPOS.NRLANCTONF
         AND CDIMPOSTO = C_ITEMPROIMPOS.CDIMPOSTO;
      UPDATE ITEMPRODUTO
         SET VRCONTITEM = CASE C_ITEMPROIMPOS.IDCONSDESONVRNF WHEN 'S' THEN VRCONTITEM - V_VRIMPOSTODESON ELSE VRCONTITEM END
       WHERE CDFILIAL = C_ITEMPROIMPOS.CDFILIAL
         AND NRLANCTONF = C_ITEMPROIMPOS.NRLANCTONF
         AND NRSEQITPROD = C_ITEMPROIMPOS.NRSEQITPROD;
   END LOOP;
   FOR C_IMPOSTO IN (SELECT IT.CDFILIAL, 
                            IT.NRLANCTONF, 
                            IT.NRSEQITPROD, 
                            IT.CDPRODUTO,
                            IP.CDIMPOSTO, 
                            IP.CDFISCALIT, 
                            IP.IDIMPDESONERAIT, 
                            IP.VRIMPOSTOIT
                       FROM ITEMPRODUTO IT, ITEMPROIMPOS IP, IMPOSTO IM, PRODUTO PR
                      WHERE IP.CDFILIAL = IT.CDFILIAL
                        AND IP.NRLANCTONF = IT.NRLANCTONF
                        AND IP.NRSEQITPROD = IT.NRSEQITPROD
                        AND IM.CDIMPOSTO = IP.CDIMPOSTO
                        AND PR.CDPRODUTO = IT.CDPRODUTO
                        AND IT.CDFILIAL = P_CDFILIAL
                        AND IT.NRLANCTONF = P_NRLANCTONF
                        AND IM.IDDESONERAIMPO = 'S'
                        AND IP.NRITPROIMPOS = '1'
                        AND IP.IDDESONERAREGRA = 'N'
                        AND EXISTS (SELECT PC.CDPRODUTO, PC.CDCLIENTE AS DESTINO
                                      FROM PRODESONERAIMCLI PC, PRODUTO PRO
                                     WHERE PRO.CDPRODUTO = PC.CDPRODUTO
                                       AND PC.CDCLIENTE = V_CDDESTINO
                                       AND V_IDORIGDESTNF = 'C'
                                       AND INSTR(PR.CDARVPROD, NVL(RTRIM(PRO.CDARVPROD), PR.CDARVPROD)) = 1
                                     UNION ALL
                                    SELECT PF.CDPRODUTO, PF.CDFORNECED AS DESTINO
                                      FROM PRODESONERAIMFOR PF, PRODUTO PRO
                                     WHERE PRO.CDPRODUTO = PF.CDPRODUTO
                                       AND PF.CDFORNECED = V_CDDESTINO
                                       AND V_IDORIGDESTNF = 'F'
                                       AND INSTR(PR.CDARVPROD, NVL(RTRIM(PRO.CDARVPROD), PR.CDARVPROD)) = 1
                                     UNION ALL
                                    SELECT PL.CDPRODUTO, PL.CDFILIAL AS DESTINO
                                      FROM PRODESONERAIMFIL PL, PRODUTO PRO
                                     WHERE PRO.CDPRODUTO = PL.CDPRODUTO
                                       AND PL.CDFILIAL = V_CDDESTINO
                                       AND V_IDORIGDESTNF = 'L'
                                       AND INSTR(PR.CDARVPROD, NVL(RTRIM(PRO.CDARVPROD), PR.CDARVPROD)) = 1)) LOOP
      V_VRDESONERA := V_VRDESONERA + C_IMPOSTO.VRIMPOSTOIT;
      UPDATE ITEMPROIMPOS
         SET IDIMPDESONERAIT = 'S',
             VRIMPOSTODESON = C_IMPOSTO.VRIMPOSTOIT
       WHERE CDFILIAL = C_IMPOSTO.CDFILIAL
         AND NRLANCTONF = C_IMPOSTO.NRLANCTONF
         AND NRSEQITPROD = C_IMPOSTO.NRSEQITPROD
         AND CDIMPOSTO = C_IMPOSTO.CDIMPOSTO
         AND NRITPROIMPOS = '1';
      UPDATE TRABITPROIMPOS
         SET IDIMPDESOTRABIT = 'S'
       WHERE CDFILIMPOIT = C_IMPOSTO.CDFILIAL
         AND NRLANCIMPOIT = C_IMPOSTO.NRLANCTONF
         AND NRSEQIMPOIT = C_IMPOSTO.NRSEQITPROD
         AND CDIMPOSTOIT = C_IMPOSTO.CDIMPOSTO;
      UPDATE IMPOSTONF
         SET IDIMPDESONERANF = 'S'
       WHERE CDFILIAL = C_IMPOSTO.CDFILIAL
         AND NRLANCTONF = C_IMPOSTO.NRLANCTONF
         AND CDIMPOSTO = C_IMPOSTO.CDIMPOSTO;
      UPDATE ITEMPRODUTO
         SET VRCONTITEM = VRCONTITEM - C_IMPOSTO.VRIMPOSTOIT
       WHERE CDFILIAL = C_IMPOSTO.CDFILIAL
         AND NRLANCTONF = C_IMPOSTO.NRLANCTONF
         AND NRSEQITPROD = C_IMPOSTO.NRSEQITPROD;
   END LOOP;
   P_VRDESONERA := V_VRDESONERA;
END;
/
/*
 @C:\Web_619\Sql\End_Conv\Oracle\5102_DFSSTPO_Imposto_Saida.SQL
 Descrição:
 Procedure para geração dos impostos e valor final das notas de saída e dos valores contabéis
 Parâmetros
 P_EMPRESA     - Código da empresa
 P_PRODUTO     - Código de árvore do prduto(CDARVPROD)
 P_INSCESTA    - Inscrição estadual do lançamento
 P_TIPOOPER    - Tipo de operação do lançamento
 P_CLIENTE     - Código do destinatário da nota (CDCLIENTE, CDFORNECED ou CDFILIAL)
 P_FILIAL      - Código da filial do lançamento (CDFILIAL)
 P_LANCTONF    - Número do lançamento (NRLANCTONF)
 P_INIVALID    - Data de saída do lançamento
 P_VRNOTAFISC  - Valor final da nota
 P_LANCESTQ    - Número do lançamento de estoque
 P_CDOPERADOR  - Operador gravado na LANCTOESTOQ
 raise_application_error(-20501,  , True);
*/
CREATE OR REPLACE PROCEDURE IMPOSTO_SAIDA(
   P_EMPRESA    IN ALIQUOTA.CDEMPRESA%TYPE,
   P_INSCESTA   IN ALIQUOTA.CDINSCESTA%TYPE,
   P_TIPOOPER   IN INCIDENCIA.CDTIPOOPER%TYPE,
   P_CLIENTE    IN CLIENTE.CDCLIENTE%TYPE,
   P_FILIAL     IN NOTAFISCAL.CDFILIAL%TYPE,
   P_LANCTONF   IN NOTAFISCAL.NRLANCTONF%TYPE,
   P_INIVALID   IN ALIQUOTA.DTINIVALID%TYPE,
   P_VRNOTAFISC OUT NUMBER,
   P_LANCESTQ   IN LANCTOESTOQ.NRLANCESTQ%TYPE DEFAULT NULL,
   P_CDOPERADOR IN LANCTOESTOQ.CDOPERADOR%TYPE DEFAULT NULL)
IS
   V_TESTE          VARCHAR2(50);
   V_IDTRATIMPO     VARCHAR2(01);
   V_PAISORIG       VARCHAR2(04); -- Pais de origem (utiliza UF de Origem)
   V_ESTAORIG       VARCHAR2(02); -- Estado de origem (utiliza UF de Origem)
   V_MUNIORIG       VARCHAR2(04); -- Municipio de origem (utiliza municipio)
   V_PAISDEST       VARCHAR2(04);
   V_ESTADEST       VARCHAR2(02);
   V_MUNIDEST       VARCHAR2(04);
   V_IDUTMUNIORIG   VARCHAR2(04);
   V_PAISCFOP       VARCHAR2(04);
   V_ESTACFOP       VARCHAR2(02);
   V_CDPAISST       VARCHAR2(04);
   V_SGESTADOST     VARCHAR2(02);
   V_CDMUNICIPIOST  VARCHAR2(04);
   V_CDINSCESTAST   VARCHAR2(16);
   V_ALIQTEMP       VARCHAR2(14);
   V_NRALIQTEMP     VARCHAR2(14);
   V_DADOADIC       VARCHAR2(03);
   V_INCITEMP       VARCHAR2(14);
   V_CST1DIGT       VARCHAR2(1);
   V_CSTTEMP        VARCHAR2(14);
   V_FISCALIT       VARCHAR2(20);
   V_CFOPTEMP       VARCHAR2(14);
   V_FISOPEITEM     VARCHAR2(11);
   V_SUFXCFOPPR     VARCHAR2(03);
   V_SITUTRIBPR     VARCHAR2(03);
   V_NRINSJURNF     VARCHAR2(20);
   V_SERIE          VARCHAR2(05);
   V_TIPOMOVI       VARCHAR2(01);
   V_CDFISCOPER     VARCHAR2(11);
   V_CDFILIEMIT     VARCHAR2(04);
   V_CDFILIRECE     VARCHAR2(04);
   V_ORIGDESTOP     VARCHAR2(01);
   V_CDFISOPENTF    VARCHAR2(11);
   V_IDENDCFOP      VARCHAR2(01);
   V_IDENDEMIS      VARCHAR2(01);
   V_CDEMPRESA      VARCHAR2(02);
   V_CDINSCESTA     VARCHAR2(16);
   V_CDINTEGRACAO   VARCHAR2(16);
   V_IDORIGDESTNF   VARCHAR2(01);
   V_NRLANBOLREC    VARCHAR2(10);
   V_IDDOCFINANC    VARCHAR2(01);
   V_IDERROAVISO    VARCHAR2(01);
   V_IDDOCREPLIC    VARCHAR2(14);
   V_IDDOCESTOQ     VARCHAR2(14);
   V_IDSISTEMA      VARCHAR2(03);
   V_IDRETPROEXP    VARCHAR2(01);
   V_IDATUEST       VARCHAR2(01);
   V_NMTIPOOPER     VARCHAR2(30);
   V_NMFILIRECE     VARCHAR2(60);
   V_DESCLANC       VARCHAR2(60);
   V_CDFISCTEMP     VARCHAR2(01);
   V_CDDETALHEPRODTEMP VARCHAR2(05);
   V_TRATIMPST      VARCHAR2(01);
   V_IDTRIMPSTII    VARCHAR2(01);
   V_CDIMPOSTRIB    VARCHAR2(250);
   V_CDIMPOSICMS    VARCHAR2(250);
   V_IDCTRLESTQ     VARCHAR2(01);
   V_CDFILIAPFATU   VARCHAR2(04);
   V_NRAPFATUTNF    VARCHAR2(10);
   V_IDITEMISSAO    VARCHAR2(01);
   V_CDIMPOBCALC    VARCHAR2(02);
   V_IDIMPOSTONF    VARCHAR2(01);
   V_IDVRIMPSTRIB   VARCHAR2(01);
   V_IDDEVOLIST     VARCHAR2(01);
   V_IDUTILALMOX    VARCHAR2(01);
   V_IDUTILLCESTQ   VARCHAR2(01);
   V_IDUTILLOTE     VARCHAR2(01);
   V_IDPMCBASECAL   VARCHAR2(01);
   V_IDTPCOMPPROD   VARCHAR2(01);
   V_NRINSJURCLIE   VARCHAR2(20);
   V_UTIBB          VARCHAR2(01);
   V_CDSITTRIBTMP    CODSITUTRIBNFE.CDSITUTRIBNFE%TYPE;
   V_IDMODBCNFE      CODSITUTRIBNFE.IDMODBCNFE%TYPE;
   V_IDMOTIDESSTNFE  CODSITUTRIBNFE.IDMOTIDESSTNFE%TYPE;
   V_IDMODBCSTNFE    CODSITUTRIBNFE.IDMODBCSTNFE%TYPE;
   V_CDTPCRPICOSTNFE CODSITUTRIBNFE.CDTPCRPICOSTNFE%TYPE;
   V_CDNATUBCPCSTNFE CODSITUTRIBNFE.CDNATUBCPCSTNFE%TYPE;
   V_CDSITUTRIBNFE     CODSITUTRIBNFE.CDSITUTRIBNFE%TYPE;
   V_IDMODBCNFEIT      CODSITUTRIBNFE.IDMODBCNFE%TYPE;
   V_IDMODBCSTNFEIT    CODSITUTRIBNFE.IDMODBCSTNFE%TYPE;
   V_CDTPCRPICOSTNFEIT CODSITUTRIBNFE.CDTPCRPICOSTNFE%TYPE;
   V_CDNATUBCPCSTNFEIT CODSITUTRIBNFE.CDNATUBCPCSTNFE%TYPE;
   V_IDINTEREST   VARCHAR2(01);
   V_IDCONSPARFIS VARCHAR2(01);
   V_CDFISCOPERSN ITEMPRODUTO.CDFISCOPERSN%TYPE;
   V_IDINTERNA VARCHAR2(01);
   V_PARDEDTMP    NUMBER;
   V_PREDBCTMP    NUMBER;
   V_ALIQUTMP     NUMBER;
   V_COUNT        NUMBER;
   V_ERROAVISO    NUMBER;
   V_LIQUIITEM    NUMBER;
   V_TOTALNOTA    NUMBER;
   V_LIQUIDO      NUMBER;
   V_SOMAENCA     NUMBER;
   V_MENOENCA     NUMBER;
   V_SOMAIMPO     NUMBER;
   V_MENOIMPO     NUMBER;
   V_TOTAPRODENCA NUMBER;
   V_TOTAPRENIMPO NUMBER;
   V_TOTAIMPBCALC NUMBER;
   V_TOTAIMPBCDES NUMBER;
   V_TAXABASECALC NUMBER;
   V_TAXABCSUBSTR NUMBER;
   V_TAXAALIQUOTA NUMBER;
   V_PRODUENCARGO NUMBER;
   V_SEQUIMPOSTNF NUMBER;
   V_SOMAITEM     NUMBER;
   V_DESCITEM     NUMBER;
   V_BASECALCIT   NUMBER;
   V_BASECALCTO   NUMBER;
   V_BASECALCIRRF NUMBER;
   V_PBCSUBTRIB   NUMBER;
   V_IMPOSTOIT    NUMBER;
   V_VRIMPOSTO    NUMBER;
   V_FATOCONV     NUMBER;
   V_TOTABRUT     NUMBER;
   V_SOMAIMPONF   NUMBER;
   V_DESCIMPONF   NUMBER;
   V_QTDELANCTO   NUMBER;
   V_VRUNITLANCTO NUMBER;
   V_VRTOTALANCTO NUMBER;
   V_TOTACONTAB   NUMBER;
   V_VRBRUTO      NUMBER;
   V_VRCONTAB     NUMBER;
   V_IMPOCONTAB   NUMBER;
   V_TOTIMPOCONT  NUMBER;
   V_TOTIMPOBRUT  NUMBER;
   V_CONTIMPO     NUMBER;
   V_IMPOSRETI    NUMBER;
   V_CONTABCALC   NUMBER;
   V_PERDBCALC    NUMBER;
   V_FAIXATOLER   NUMBER;
   V_NRDECITOTANF NUMBER;
   V_IMPOSINFUSU  NUMBER;
   V_VRCONTAREC   NUMBER;
   V_VRDIFERENCA  NUMBER;
   V_EXISTE_ROT   NUMBER;
   V_NRSEQITPROD  NUMBER;
   V_VRFATOCONV   NUMBER;
   V_VRLIQUORIG   NUMBER;
   V_VRPESOBRUTO  NUMBER;
   V_VRIMPOSTOST  NUMBER;
   V_VRREDUCAO    NUMBER;
   V_VALOR        NUMBER;
   V_VRTOTAITEM   NUMBER;
   V_SOMATOTAITEM NUMBER;
   V_PERCENTITEM  NUMBER;
   V_SOMAQITEMPROD  NUMBER;
   V_SOMAVRBRUTITEM NUMBER;
   V_SOMAVRCONTITEM NUMBER;
   V_CDGRUPOFISC  VARCHAR2(03);
   V_CDGRPFISCSV  VARCHAR2(03);
   V_UTGRUPFISCS  VARCHAR2(01);
   V_CDORIGDESTNF VARCHAR2(21);
   V_IDOPERDEVONF VARCHAR2(01);
   V_CHAVE        VARCHAR2(21);
   V_IMPOSTO      VARCHAR2(02);
   V_IDRECALCULO  VARCHAR2(01);
   V_CDFILIMOVI   VARCHAR2(04);
   V_CDTIPOOPER   VARCHAR2(02);
   V_CDENCDESCBONDEV VARCHAR2(02);
   V_CDAJUCTPAG   VARCHAR2(04);
   V_VRPEDESCFORN FLOAT;
   V_VRENCARBONI  FLOAT;
   V_IDCONDESBONFORN VARCHAR2(01);
   V_DTINIVRPDESC DATE;
   V_IMPOSDESONERA NUMBER;
   V_DIFERENCA     FLOAT;
   V_VRFRETEITEM   FLOAT;
   V_VRSEGURITEM   FLOAT;
   V_VRENCARGODESC FLOAT;
   V_SUMVRDESCITEM FLOAT;
   V_VROUTRASDESPITEM FLOAT;
   V_VRDESPADUANEIRA  FLOAT;
   V_DSCDFISOPEIT VARCHAR2(450);
   V_DTVINGENTE   DATE;
   V_DTINIREFEFAT DATE;
   V_ICMS         VARCHAR2(01);
   V_IMPOICMS     VARCHAR2(02);
   V_CDSITUCRT         VARCHAR2(01);
   V_CDSIMPLESNACIONAL VARCHAR2(5);
   V_RBT12             FLOAT; --RECEITA BRUTA TOTAL DOS ÚLTIMOS 12 MESES
   V_RBA               FLOAT; --RECEITA BRUTA ACUMULADA
   V_VRSUBLIMITESN     FLOAT;
   V_VRALIQSIMPLES     FLOAT;
   V_APROVICMS         FLOAT;
   V_ALIQAPROVICMS     FLOAT;
   V_SIMPLES           VARCHAR2(01);
   V_CDFAIXA           VARCHAR2(5);
   V_ESTORNOCANC       VARCHAR2(01);
   /*Alíquota do imposto que possui diferencial de alíquota*/
   V_DIFALIQ           FLOAT;
   V_CDFISCOPERREGRA     VARCHAR2(10);
   V_DSCDFISOPEITREGRA   VARCHAR2(50);
   V_IDDIFEALIQREGRA     VARCHAR2(10);
   V_IDDIFALIQCUSPRREGRA VARCHAR2(10);
   V_CFOPINFUSU          VARCHAR2(01);
   V_CFOP1DIGT           VARCHAR2(01);
   w_A            CHAR(1):= 'A';
   w_C            CHAR(1):= 'C';
   w_D            CHAR(1):= 'D';
   w_N            CHAR(1):= 'N';
   w_S            CHAR(1):= 'S';
   w_R            CHAR(1):= 'R';
   w_P            CHAR(1):= 'P';
   w_I            CHAR(1):= 'I';
   w_L            CHAR(1):= 'L';
   w_V            CHAR(1):= 'V';
   w_O            CHAR(1):= 'O';
   w_F            CHAR(1):= 'F';
   w_U            CHAR(1):= 'U';
   w_0            CHAR(1):= '0';
   w_1            CHAR(1):= '1';
   w_2            CHAR(1):= '2';
   w_3            CHAR(1):= '3';
   w_4            CHAR(1):= '4';
   w_5            CHAR(1):= '5';
   w_8            CHAR(1):= '8';
   w_9            CHAR(1):= '9';
   w_01           CHAR(2):= '01';
   w_03           CHAR(2):= '03';
   w_09           CHAR(2):= '09';
   w_11           CHAR(2):= '11';
   w_12           CHAR(2):= '12';
   w_90           CHAR(2):= '90';
   w_000          CHAR(3):= '000';
   w_001          CHAR(3):= '001';
   w_101          CHAR(3):= '101';
   w_00000        CHAR(5):= '00000';
   w_VMN          CHAR(3):= 'VMN';
   w_EXP          CHAR(3):= 'EXP';
   w_VND          CHAR(3):= 'VND';
   w_Av04         CHAR(4):= 'AV04';
   w_Av05         CHAR(4):= 'AV05';
   w_Av06         CHAR(4):= 'AV06';
   w_Av09         CHAR(4):= 'AV09';
   w_Av10         CHAR(4):= 'AV10';
   w_Er03         CHAR(4):= 'ER03';
   w_Er04         CHAR(4):= 'ER04';
   w_Er06         CHAR(4):= 'ER06';
   V_IDIMPOBCALTPOP  VARCHAR2(01);
   V_IDIMBCALTPOPDE  VARCHAR2(01);
   V_QTITEMPROD      FLOAT;
   V_CDIMPOSTO       VARCHAR2(02);
   V_IDUTCTRLLOTE    VARCHAR2(01);
   V_MEDIA           NUMBER;
   V_BCICMSSTRETIDO  FLOAT;
   V_VRICMSSTRETIDO  FLOAT;
   V_NRLOTEESTQ      VARCHAR2(20);
   V_EXISTDSDADOSADIC  INTEGER;
   V_BCICMSRET       FLOAT;
   V_ICMSRET         FLOAT;
   V_IDCALCPESONF    VARCHAR2(01);
   V_IDUTDESCICMS    VARCHAR2(01);
   V_CDREGRAITALIQ    VARCHAR2(10);
   V_CARGA            FLOAT;
   V_CDIMPOSRECALC    VARCHAR2(200);
   V_CDCFOPINFUSU     VARCHAR2(11);
   V_DSCFOPINFUSU     VARCHAR2(50);
   V_IDUTVLRQTDEIMPO  VARCHAR2(01);
   V_VRFATOCONVES     FLOAT;
   V_DTENTRSAID       DATE;
   V_CDIMPOSTOI       VARCHAR2(02);
   V_CDPRODUTO        VARCHAR2(10);
   V_VRIMPOSTOVISUIT  FLOAT;
   V_IDALTERADO_ENCA  VARCHAR2(01);
   V_CDGRUPOFISCAUX   VARCHAR2(03);
   V_CDIMPOSIPI        VARCHAR2(02);
   V_IDGERIPIDESPA     VARCHAR2(01);
   V_IDGERICMSTDESPA   VARCHAR2(01);
   V_VRTOTALIPI        FLOAT;
   V_CDENCARGOOD       VARCHAR2(02);
   V_VRTOTALICMSST     FLOAT;
   V_CDENCARGOICMST    VARCHAR2(02);
   V_IDPEINFICMSTDEME  VARCHAR2(01);
   V_VRENCAICMSSTIT    FLOAT;
   V_VRICMSST          FLOAT;
   V_VRBASECALC        FLOAT;
   V_SOMAVRNOTAFISC    FLOAT;
   V_IDUTCTRLFISSAID   VARCHAR2(01);
   V_IDUTCTRLFISFIL    VARCHAR2(01);
   V_IDUTCTRLFIS       VARCHAR2(01);
   V_IDPERVISIMPSCRE   VARCHAR2(01);
   V_VRIMPOSST         FLOAT;
   V_VRADICFECPST      FLOAT;
   V_VRADICFECPSTAUX   FLOAT;
   V_DIFEVRBRUTO       FLOAT;
   V_VRPERDIFERE       FLOAT;
   V_PERDIFERE         FLOAT;
   V_IMPOSTOOPERA      FLOAT;
   V_IMPOSTODIFER      FLOAT;
   V_IDCONTCONFORIG    VARCHAR2(01);
   V_IDDESCIMPRECCONT  VARCHAR2(01);
   V_IDIMPORECUP       VARCHAR2(01);
   V_CDCCTBLATIV       VARCHAR2(20);
   V_IDATUESTTPOP      TIPOOPERAC.IDATUESTTPOP%TYPE;
   V_IDREMESSAINDU     TIPOOPERAC.IDREMESSAINDU%TYPE;
   V_CDALMOXINFO       AGENTETERCECLI.CDALMOXINFOCLI%TYPE;
   V_CDLOCALINFO       AGENTETERCECLI.CDLOCALINFOCLI%TYPE;
   V_CDFILIALENTR      CTRLMOVIESTQ.CDFILIALENTR%TYPE;
   V_NRLANESTENTR      NOVOCODIGO.NRSEQUENCIAL%TYPE;
   V_NRCTRLMOVEST      NOVOCODIGO.NRSEQUENCIAL%TYPE;
   V_BOLANESTENTR      BOOLEAN := TRUE;
   V_DSENDEDEVOEMBA    VARCHAR2(255);
   V_CDENQLEGALIPI     VARCHAR2(03);
   V_CDCEST            VARCHAR2(09);
   /* variáveis para geração de entrada no estoque (filial agente de terceiração */
   V_CDFILIAGENT       VARCHAR2(04);
   V_BOLANESTENTRAG    BOOLEAN := TRUE;
   V_NRLANESTENTRAG    NOVOCODIGO.NRSEQUENCIAL%TYPE;
   V_CDALMOXARIFEAG    ALMOXARIFADO.CDALMOXARIFE%TYPE;
   V_CDLOCALESTOQAG    LOCALESTOQUE.CDLOCALESTOQ%TYPE;
   V_IDUTILLOTEAG      VARCHAR2(01);
   V_NRLOTEESTQAG      VARCHAR2(20);
   V_NRSUBLOTEAG       VARCHAR2(04);
   V_NRLANCTONFAG      VARCHAR2(20);
   V_IDTPIJURNF        VARCHAR2(01);
   V_CDEMPRESAAG       VARCHAR2(02);
   V_CDINSCESTAAG      VARCHAR2(16);
   V_CDINSCMUNIAG      VARCHAR2(16);
   V_CDFILIORIG        VARCHAR2(04);
   V_TPOPERRETORNO     VARCHAR2(02);
   V_IDUTORIGPROD       VARCHAR2(01);
   V_VRPRODUTOBC       FLOAT;
   V_VRALIQUTMPDEST    VARCHAR2(14);
   V_CDIMPOSTOICMS     VARCHAR2(02);
   V_VRIMPOSTOICMS     FLOAT;
   V_VRBASECALCICMS    FLOAT;
   V_IDIMPSTCARGTRIB   VARCHAR2(01);
   V_VRIMPOSTOOPERAIT  FLOAT;
   V_VRPERDIFEREIT     FLOAT;
   V_VRIMPOSTODIFERIT  FLOAT;
   V_CDPAISFCT      VARCHAR2(04);
   V_SGESTADOFCT    VARCHAR2(02);
   V_CDMUNICIPIOFCT VARCHAR2(04);
   V_QTDREGFCT      FLOAT;
   V_IDPRESENCIAL      VARCHAR2(01);
   V_IDUTILPVRIMPBC    VARCHAR2(01);
   V_VRADICALIQFECP    FLOAT(126);
   V_VRADICFECP        FLOAT(126);
   V_IDCONSFINAL       VARCHAR2(01);
   V_STRVRADICALIQFECP VARCHAR2(15);
   V_STRVRADICFECP     VARCHAR2(15);
   V_NRINSESTDESNF     VARCHAR2(20);
   V_IDCONTRIBICMS     VARCHAR2(01);
   V_IDCONTRIBICMSAUX  VARCHAR2(01);
   V_ALIQICMSDEST      FLOAT;
   V_ALIQFECPDEST      FLOAT;
   V_CDIMPOSTOFECP     VARCHAR2(02);
   V_IDDIFECLI         VARCHAR2(01);
   V_CDFILIALPED       VARCHAR2(04);
   V_NRPEDIDO          VARCHAR2(10);
   V_DADOSADICENDPED   VARCHAR2(400);
   V_IDPRODPERIG       VARCHAR2(01);
   V_MSGPRODPERIG      VARCHAR2(500);
   V_GRAVAMSGPRODPERIG INTEGER;
   V_IDCALCDIFALDENT   VARCHAR2(01);
   V_NRREGISTROANP     VARCHAR2(10);
   V_DSREGISTROANP     VARCHAR2(255);
   V_IDUTILVENC        VARCHAR2(01);
   V_IDNOTADEVO        VARCHAR2(01);
   V_IDNFAJUSTE        VARCHAR2(01);
   V_IDVERLEIAUTENFE   VARCHAR2(04);
   V_MAJORAOUREDUZ     VARCHAR2(01);
   /* Variáveis para geração dos encargos de acordo com os impostos relacionados na nota fiscal de origem(importação de XML) */
   V_VRENCARGOIMPXML NUMBER;
   V_VRIMPENCXMLORIG NUMBER;
   V_UPDENCIMPXML    VARCHAR2(01);
   V_NRSEQITORIG     VARCHAR2(04);
   V_NRACESSONFORIG  VARCHAR2(44);
   V_IDNFORIGVIAXML  VARCHAR2(01);
   V_VRIMPORETNF     FLOAT;
   V_VRIMPORELAC     FLOAT;
   V_IDOPTANTESNCLIE VARCHAR2(01);
   V_CDCNAECLIE      VARCHAR2(07);
   V_VRMVA           FLOAT;
   V_IDENDEMISTPOPFIL VARCHAR2(01);
   V_CDBENEFFISCAL    VARCHAR2(10);
   V_IDUTILNFSE      VARCHAR2(01);
   /* Variáveis prestação de serviço */
   V_CDPAISSERV      VARCHAR2(04);
   V_SGESTADOSERV    VARCHAR2(02);
   V_CDMUNICIPIOSERV VARCHAR2(04);
   V_QTDREGSERV      NUMBER;
   V_IDENDCFOPCLIPRES VARCHAR2(01);
   V_IDCONSMVAPMC VARCHAR2(01);
   V_IDCONSCOMPBCPMC VARCHAR2(01);
   V_IDCONSDIFALIQ VARCHAR2(01);
   V_VRADICFECPNFTOT FLOAT;
   V_IDIMPODESONERA  VARCHAR2(01);
   V_IDCONSDESONVRNF VARCHAR2(01);
   V_CDPAISEMIT      VARCHAR2(04);
   V_SGESTADOEMIT    VARCHAR2(02);
BEGIN
--VARIÁVEIS COM A CHAVE PARA AS TABELAS TEMPORÁRIAS
   V_ALIQTEMP := P_FILIAL||P_LANCTONF;/* ALIQUOTA */
   V_INCITEMP := P_FILIAL||P_LANCTONF;/* INCIDENCIA */
   V_CSTTEMP  := P_FILIAL||P_LANCTONF;/* CST */
   V_CFOPTEMP := P_FILIAL||P_LANCTONF;/* CFOP */
   V_TOTALNOTA  := 0; /*VALOR TOTAL DA NOTA*/
   V_FAIXATOLER := 0.02; /* FAIXA DE TOLERANCIA DE VALORES (CONSISTE VRNOTAFISC X VRPRODUTOS E VENCIMENTOS X VALOR TOTAL DA NOTA)*/
   V_VRADICALIQFECP := NULL;
   V_VRADICFECP := NULL;
   V_CDBENEFFISCAL := NULL;
   Begin
      SELECT N.NRINSJURNF,
             N.CDSERIE,
             N.CDFILIEMIT,
             N.CDFILIRECE,
             NVL(P.IDUTILALMOX, w_N),
             NVL(P.IDUTILLCESTQ, w_N),
             NVL(P.IDUTILLOTE, w_N),
             N.CDINTEGRACAO,
             N.IDORIGDESTNF,
             N.IDDOCFINANC,
             N.IDDOCREPLIC,
             N.IDSISTEMA,
             NVL(P.IDCTRLESTQ, w_S),
             N.DTINIREFEFAT,
             N.CDINSCESTA,
             N.CDEMPRESA,
             N.IDTPIJURNF,
             NVL(N.IDPRESENCIAL, w_9),
             NVL(I.IDVERLEIAUTENFE, '3.10'),
             NVL(CDSITUCRT, '3'),
             NVL(VRSUBLIMITESN, 0),
             I.CDPAIS,
             I.SGESTADO
        INTO V_NRINSJURNF,
             V_SERIE,
             V_CDFILIEMIT,
             V_CDFILIRECE,
             V_IDUTILALMOX,
             V_IDUTILLCESTQ,
             V_IDUTILLOTE,
             V_CDINTEGRACAO,
             V_IDORIGDESTNF,
             V_IDDOCFINANC,
             V_IDDOCREPLIC,
             V_IDSISTEMA,
             V_IDCTRLESTQ,
             V_DTINIREFEFAT,
             V_CDINSCESTA,
             V_CDEMPRESA,
             V_IDTPIJURNF,
             V_IDPRESENCIAL,
             V_IDVERLEIAUTENFE,
             V_CDSITUCRT,
             V_VRSUBLIMITESN,
             V_CDPAISEMIT,
             V_SGESTADOEMIT
        FROM NOTAFISCAL N, PARAMFILIAL P, INSCRESTAD I, PARAMEMPRESA PE
       WHERE N.CDFILIAL = P_FILIAL   
         AND N.NRLANCTONF = P_LANCTONF 
         AND N.CDFILIEMIT = P.CDFILIAL(+)
         AND N.CDEMPRESA = I.CDEMPRESA
         AND N.CDINSCESTA = I.CDINSCESTA
         AND N.CDEMPRESA = PE.CDEMPRESA(+);
   Exception
      When No_Data_Found Then
         V_NRINSJURNF := Null;
         V_SERIE := Null;
         V_CDFILIEMIT := Null;
         V_CDFILIRECE := Null;
         V_IDUTILALMOX := w_N;
         V_IDUTILLCESTQ := w_N;
         V_IDUTILLOTE := w_N;
         V_CDINTEGRACAO := Null;
         V_IDORIGDESTNF:= Null;
         V_IDDOCFINANC := Null;
         V_IDDOCREPLIC := Null;
         V_IDSISTEMA := Null;
         V_IDCTRLESTQ := w_S;
         V_DTINIREFEFAT := Null;
         V_CDINSCESTA := Null;
         V_CDEMPRESA := Null;
         V_IDTPIJURNF := NULL;
         V_IDPRESENCIAL := w_9;
         V_IDVERLEIAUTENFE := '3.10';
         V_CDSITUCRT := '3';
         V_VRSUBLIMITESN := 0;
         V_CDPAISEMIT := Null;
         V_SGESTADOEMIT := Null;
   End;
   /* LANCAMENTO DE ESTOQUE DO DOCUMENTO GERADO ATRAVES DE REPLICACAO */
   Begin
      SELECT CDFILIAL||NRLANCESTQ
      INTO   V_IDDOCESTOQ
      FROM LANCTOESTOQ
      WHERE CDFILIAL   = SUBSTR(V_IDDOCREPLIC, 1, 4) AND
            NRLANCTONF = SUBSTR(V_IDDOCREPLIC, 5, 10);
   Exception
      When No_Data_Found Then
         V_IDDOCESTOQ := Null;
   End;
   IF V_IDDOCESTOQ IS NULL THEN
      /* LANCAMENTO DE ESTOQUE DO DOCUMENTO GERADO ATRAVES DE INTEGRACAO (EX: IMPORTACAO DE NFS)*/
      Begin
         SELECT CDFILIAL||NRLANCESTQ
         INTO   V_IDDOCESTOQ
         FROM LANCTOESTOQ
         WHERE CDFILIAL   = SUBSTR(V_CDINTEGRACAO, 1, 4) AND
               NRLANCTONF = SUBSTR(V_CDINTEGRACAO, 5, 10);
      Exception
         When No_Data_Found Then
            V_IDDOCESTOQ := Null;
      End;
   END IF;
   /*NUMERO MAXIMO DE CASAS DECIMAIS*/
   SELECT NVL(NRDECITOTANF,2), 
          NVL(IDUTORIGPROD, 'N')
     INTO V_NRDECITOTANF, 
          V_IDUTORIGPROD
     FROM PARAMGERAL;
--MAIOR REGISTRO DA TABELA DE DADOS ADICIONAIS
   SELECT MAX(NRDADOADIC)
     INTO   V_DADOADIC
     FROM DADOSADIC
    WHERE (CDFILIAL   = P_FILIAL) AND
          (NRLANCTONF = P_LANCTONF);
   IF (V_DADOADIC IS NULL) THEN
      V_DADOADIC := W_001;
   ELSE
      V_DADOADIC := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_DADOADIC) + 1)),3,0);
      /*GERA O PROXIMO SEQUENCIAL A SER INSERIDO*/
   END IF;
   FOR C_MENSINSC IN (SELECT M.CDMENSAGEM, I.DSMENSINSCRESTA
                        FROM MENSINSCRESTAD I LEFT JOIN MENSAGEM M ON (M.CDMENSAGEM = I.CDMENSAGEM)
                       WHERE (I.CDEMPRESA = P_EMPRESA)
                         AND (I.CDINSCESTA = P_INSCESTA)
                         AND (I.IDENTRSAIDMENS <> 'E')
                         AND (((I.CDMENSAGEM IS NOT NULL) AND (M.IDSITUACAOMENS  = 'A')) OR (I.CDMENSAGEM IS NULL))
                         AND NOT EXISTS (SELECT DSDADOADIC
                                           FROM DADOSADIC
                                          WHERE (CDFILIAL = P_FILIAL)
                                            AND (NRLANCTONF = P_LANCTONF)
                                            AND (DSDADOADIC LIKE I.DSMENSINSCRESTA || '%'))
                       ORDER BY I.NRMENSINSCRESTA) LOOP
      /*PREENCHE AS MENSAGENS ATRELADAS A INSCRICAO ESTADUAL*/
      INSERT INTO DADOSADIC(CDFILIAL, NRLANCTONF, NRDADOADIC, CDMENSAGEM, DSDADOADIC)
                     VALUES(P_FILIAL, P_LANCTONF, V_DADOADIC, C_MENSINSC.CDMENSAGEM, C_MENSINSC.DSMENSINSCRESTA);
      V_DADOADIC := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_DADOADIC) + 1)),3,0);
   END LOOP;
   IF V_IDORIGDESTNF = 'C' THEN
      FOR C_MENSCLIENTE IN (SELECT M.CDMENSAGEM, C.DSMENSCLIENTE
                              FROM MENSCLIENTE C LEFT JOIN MENSAGEM M ON (M.CDMENSAGEM = C.CDMENSAGEM)
                             WHERE C.CDCLIENTE = P_CLIENTE
                               AND C.IDENTRSAIDMENS <> 'E'
                               AND (((C.CDMENSAGEM IS NOT NULL) AND (M.IDSITUACAOMENS  = 'A')) OR (C.CDMENSAGEM IS NULL))
                               AND NOT EXISTS (SELECT DSDADOADIC
                                                 FROM DADOSADIC
                                                WHERE (CDFILIAL = P_FILIAL)
                                                  AND (NRLANCTONF = P_LANCTONF)
                                                  AND (DSDADOADIC LIKE C.DSMENSCLIENTE || '%'))
                             ORDER BY C.NRMENSCLIENTE) 
      LOOP
         INSERT INTO DADOSADIC
            (CDFILIAL, 
             NRLANCTONF, 
             NRDADOADIC, 
             CDMENSAGEM, 
             DSDADOADIC)
         VALUES
            (P_FILIAL, 
             P_LANCTONF, 
             V_DADOADIC, 
             C_MENSCLIENTE.CDMENSAGEM, 
             C_MENSCLIENTE.DSMENSCLIENTE);
         V_DADOADIC := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_DADOADIC) + 1)),3,0);
      END LOOP;
   END IF;
   BEGIN
      SELECT TRANSLATE(SUBSTR('Devolver as embalagens vazias no seguinte endereço: ' || 
             PRE.DSPOSTORECEMB ||
             ', ' || PRE.DSENDERECEMB || 
             CASE NVL(PRE.DSCOMPENDERECEMB, '!X!X!') WHEN '!X!X!' THEN '' ELSE ', ' || PRE.DSCOMPENDERECEMB END ||
             ', ' || B.NMBAIRRO ||
             ', CEP:' || PRE.NRCEPRECEMB ||
             ', ' || M.NMMUNICIPIO ||
             ', ' || E.SGESTADO ||
             ', ' || P.NMPAIS ||
             CASE NVL(PRE.NRTELERECEMB, '!X!X!') WHEN '!X!X!' THEN '' ELSE '. Telefone: ' || PRE.NRTELERECEMB END ||
             CASE NVL(PRE.NRFAXRECEMB, '!X!X!') WHEN '!X!X!' THEN '' ELSE '. FAX: ' || PRE.NRFAXRECEMB END, 1, 255), 'áâãäæèïéìëíîçåñòóôöõàøúüûùýÁÂÃÄÆÈÏÉÌËÍÎÅÑÒÓÔÖÕÀØÚÜÛÙÝÇ', 'aaaaaeieieiicanoooooaouuuuyAAAAAEIEIEIIANOOOOOAOUUUUYC') AS DSENDEDEVOEMBA
        INTO V_DSENDEDEVOEMBA
        FROM NOTAFISCAL N JOIN ITEMPRODUTO I ON (N.CDFILIAL = I.CDFILIAL) AND
                                                (N.NRLANCTONF = I.NRLANCTONF)
                          JOIN PRODUTO PR ON (I.CDPRODUTO = PR.CDPRODUTO)
                          JOIN (SELECT P.CDPOSTORECEMB, PR.CDARVPROD
                                  FROM PRODPOSTORECEMB P JOIN PRODUTO PR ON (P.CDPRODUTO = PR.CDPRODUTO)) PPRE ON (INSTR(PR.CDARVPROD, NVL(RTRIM(PPRE.CDARVPROD), PR.CDARVPROD)) = 1)
                          JOIN CLIEPOSTORECEMB C ON (N.CDCLIENTE = C.CDCLIENTE) AND
                                                    (PPRE.CDPOSTORECEMB = C.CDPOSTORECEMB)
                          JOIN POSTORECEMB PRE ON (C.CDPOSTORECEMB = PRE.CDPOSTORECEMB)
                          JOIN PAIS P ON (PRE.CDPAIS = P.CDPAIS)
                          JOIN ESTADO E ON (PRE.CDPAIS = E.CDPAIS) AND
                                           (PRE.SGESTADO = E.SGESTADO)
                          JOIN MUNICIPIO M ON (PRE.CDPAIS = M.CDPAIS) AND
                                              (PRE.SGESTADO = M.SGESTADO) AND
                                              (PRE.CDMUNICIPIO = M.CDMUNICIPIO)
                          JOIN BAIRRO B ON (PRE.CDPAIS = B.CDPAIS) AND
                                           (PRE.SGESTADO = B.SGESTADO) AND
                                           (PRE.CDMUNICIPIO = B.CDMUNICIPIO) AND
                                           (PRE.CDBAIRRO = B.CDBAIRRO)
       WHERE N.CDFILIAL = P_FILIAL
         AND N.NRLANCTONF = P_LANCTONF
         AND NOT EXISTS (SELECT DSDADOADIC
                           FROM DADOSADIC
                          WHERE (CDFILIAL = P_FILIAL)
                            AND (NRLANCTONF = P_LANCTONF)
                            AND (DSDADOADIC LIKE TRANSLATE(SUBSTR('Devolver as embalagens vazias no seguinte endereço: ' || 
                                                 PRE.DSPOSTORECEMB ||
                                                 ', ' || PRE.DSENDERECEMB || 
                                                 CASE NVL(PRE.DSCOMPENDERECEMB, '!X!X!') WHEN '!X!X!' THEN '' ELSE ', ' || PRE.DSCOMPENDERECEMB END ||
                                                 ', ' || B.NMBAIRRO ||
                                                 ', CEP:' || PRE.NRCEPRECEMB ||
                                                 ', ' || M.NMMUNICIPIO ||
                                                 ', ' || E.SGESTADO ||
                                                 ', ' || P.NMPAIS ||
                                                 CASE NVL(PRE.NRTELERECEMB, '!X!X!') WHEN '!X!X!' THEN '' ELSE '. Telefone: ' || PRE.NRTELERECEMB END ||
                                                 CASE NVL(PRE.NRFAXRECEMB, '!X!X!') WHEN '!X!X!' THEN '' ELSE '. FAX: ' || PRE.NRFAXRECEMB END, 1, 255), 'áâãäæèïéìëíîçåñòóôöõàøúüûùýÁÂÃÄÆÈÏÉÌËÍÎÅÑÒÓÔÖÕÀØÚÜÛÙÝÇ', 'aaaaaeieieiicanoooooaouuuuyAAAAAEIEIEIIANOOOOOAOUUUUYC') || '%'));
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_DSENDEDEVOEMBA := NULL;
      WHEN TOO_MANY_ROWS THEN
         RAISE_APPLICATION_ERROR(-20501, 'Operação bloqueada. Existem mais de um posto de recolhimento de embalagens cadastradas no sistema.', TRUE);
   END;
   IF (V_DSENDEDEVOEMBA IS NOT NULL) THEN
      INSERT INTO DADOSADIC
         (CDFILIAL, 
          NRLANCTONF, 
          NRDADOADIC, 
          CDMENSAGEM, 
          DSDADOADIC)
      VALUES
         (P_FILIAL, 
          P_LANCTONF, 
          V_DADOADIC, 
          '',
          V_DSENDEDEVOEMBA);
      V_DADOADIC := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_DADOADIC) + 1)),3,0);
   END IF;
   --VARIÁVEIS PARA CONSULTA DE ALÍQUOTA, INCIDÊNCIA, CFOP
   Begin
      SELECT NVL(IDENDCFOPFIL,w_I), CDEMPRESA,   CDINSCESTA
      INTO   V_IDENDCFOP,           V_CDEMPRESA, V_CDINSCESTA
      FROM FILIAL
      WHERE (CDFILIAL = V_CDFILIEMIT);
   Exception
      When No_Data_Found Then
         V_IDENDCFOP:= w_I; V_CDEMPRESA:= Null; V_CDINSCESTA:= Null;
   End;
   BEGIN
      SELECT NVL(IDENDEMISTPOPFIL, w_P)
        INTO V_IDENDEMISTPOPFIL
        FROM TIPOOPERACFIL
       WHERE IDENTRSAIDOP = w_S
         AND CDTIPOOPER = P_TIPOOPER
         AND CDFILIAL = V_CDFILIEMIT;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_IDENDEMISTPOPFIL := w_P;
   END;
   IF V_IDENDEMISTPOPFIL <> w_P THEN
      IF V_IDENDEMISTPOPFIL = w_I THEN
         BEGIN
            SELECT CDPAIS, 
                   SGESTADO,
                   CDMUNICIPIO
              INTO V_PAISORIG,
                   V_ESTAORIG,
                   V_MUNIORIG
              FROM INSCRESTAD
             WHERE CDEMPRESA  = P_EMPRESA 
               AND CDINSCESTA = P_INSCESTA;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_PAISORIG := NULL; 
               V_ESTAORIG := NULL; 
               V_MUNIORIG := NULL;
         END;
      ELSE
         BEGIN
            SELECT CDPAIS,
                   SGESTADO,
                   CDMUNICIPIO
              INTO V_PAISORIG,
                   V_ESTAORIG,
                   V_MUNIORIG
              FROM ENDEFILI
             WHERE CDFILIAL     = V_CDFILIEMIT
               AND IDTPENDEFILI = V_IDENDEMISTPOPFIL;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_PAISORIG := NULL;
               V_ESTAORIG := NULL;
               V_MUNIORIG := NULL;
         END;
      END IF;
   ELSE   
      IF V_IDENDCFOP = w_I THEN
         Begin
            SELECT CDPAIS    , SGESTADO  , CDMUNICIPIO
            INTO   V_PAISORIG, V_ESTAORIG, V_MUNIORIG
            FROM INSCRESTAD
            WHERE CDEMPRESA  = P_EMPRESA AND
                  CDINSCESTA = P_INSCESTA;
         Exception
            When No_Data_Found Then
               V_PAISORIG := Null; V_ESTAORIG := Null; V_MUNIORIG := Null;
         End;
      ELSE
         Begin
            SELECT CDPAIS    , SGESTADO  , CDMUNICIPIO
            INTO   V_PAISORIG, V_ESTAORIG, V_MUNIORIG
            FROM ENDEFILI
            WHERE (CDFILIAL     = V_CDFILIEMIT) AND
                  (IDTPENDEFILI = V_IDENDCFOP);
         Exception
            When No_Data_Found Then
               V_PAISORIG := Null; V_ESTAORIG := Null; V_MUNIORIG := Null;
         End;
      END IF;
   END IF;
   /*DESTINATÁRIO-REMETENTE DA NOTA*/
   IF V_IDORIGDESTNF IS NULL THEN
      Begin
         SELECT IDORIGDESTOP
         INTO   V_ORIGDESTOP
         FROM TIPOOPERAC
         WHERE IDENTRSAIDOP = w_S AND
               CDTIPOOPER   = P_TIPOOPER;
      Exception
         When No_Data_Found Then
            V_ORIGDESTOP := Null;
      End;
   ELSE
      V_ORIGDESTOP := V_IDORIGDESTNF;
   END IF;
   V_CDORIGDESTNF := P_CLIENTE;
   V_IDCONSFINAL := w_N;
   IF V_ORIGDESTOP = w_L THEN /*DESTINATARIO -> FILIAL */
      Begin
         SELECT NVL(IDENDCFOPFIL,w_I), NVL(IDENDEMISFIL,w_I), CDEMPRESA  , CDINSCESTA
         INTO   V_IDENDCFOP          , V_IDENDEMIS          , V_CDEMPRESA, V_CDINSCESTA
         FROM FILIAL
         WHERE (CDFILIAL = V_CDFILIRECE);
      Exception
         When No_Data_Found Then
            V_IDENDCFOP := w_I; V_IDENDEMIS := w_I; V_CDEMPRESA := Null; V_CDINSCESTA := Null;
      End;
      SELECT MAX(CDPAIS), MAX(SGESTADO), MAX(CDMUNICIPIO)
        INTO V_CDPAISST, V_SGESTADOST, V_CDMUNICIPIOST
        FROM ENDEFILI
       WHERE CDFILIAL = V_CDFILIRECE
         AND IDTPENDEFILI = 'P';
      SELECT MAX(CDINSCESTAST)
        INTO V_CDINSCESTAST
        FROM INSCRESTADST
       WHERE CDEMPRESA = P_EMPRESA
         AND CDINSCESTA = P_INSCESTA
         AND CDPAIS = V_CDPAISST
         AND SGESTADO = V_SGESTADOST;
      IF V_IDENDCFOP = w_I THEN
         Begin
            SELECT CDPAIS    , SGESTADO
            INTO   V_PAISCFOP, V_ESTACFOP
            FROM INSCRESTAD
            WHERE CDEMPRESA  = V_CDEMPRESA AND
                  CDINSCESTA = V_CDINSCESTA;
         Exception
            When No_Data_Found Then
               V_PAISCFOP := Null; V_ESTACFOP := Null;
         End;
      ELSE
         Begin
            SELECT CDPAIS    , SGESTADO
            INTO   V_PAISCFOP, V_ESTACFOP
            FROM ENDEFILI
            WHERE (CDFILIAL     = V_CDFILIRECE) AND
                  (IDTPENDEFILI = V_IDENDCFOP);
         Exception
            When No_Data_Found Then
               V_PAISCFOP := Null; V_ESTACFOP := Null;
         End;
      END IF;
      IF V_IDENDEMIS = w_I THEN
         Begin
            SELECT CDPAIS    , SGESTADO  , CDMUNICIPIO
            INTO   V_PAISDEST, V_ESTADEST, V_MUNIDEST
            FROM INSCRESTAD
            WHERE CDEMPRESA  = V_CDEMPRESA AND
                  CDINSCESTA = V_CDINSCESTA;
         Exception
            When No_Data_Found Then
               V_PAISDEST := Null; V_ESTADEST := Null; V_MUNIDEST := Null;
         End;
      ELSE
         Begin
            SELECT CDPAIS    , SGESTADO  , CDMUNICIPIO
            INTO   V_PAISDEST, V_ESTADEST, V_MUNIDEST
            FROM ENDEFILI
            WHERE CDFILIAL     = V_CDFILIRECE AND
                  IDTPENDEFILI = V_IDENDEMIS;
         Exception
            When No_Data_Found Then
               V_PAISDEST := Null; V_ESTADEST := Null; V_MUNIDEST := Null;
         End;
      END IF;
      V_CDORIGDESTNF := V_CDFILIRECE;
   ELSIF V_ORIGDESTOP = w_F THEN /*DESTINATARIO -> FORNECEDOR */
      BEGIN
         SELECT NVL(IDENDCFOPFOR,w_P), 
                NVL(IDENDEMISFOR,w_P),
                NVL(IDCONSFINAL,w_N),
                NRINSESTFORN,
                NVL(IDCONTRIBICMS,w_N)
           INTO V_IDENDCFOP,
                V_IDENDEMIS,
                V_IDCONSFINAL,
                V_NRINSESTDESNF,
                V_IDCONTRIBICMS
           FROM FORNECEDOR
          WHERE (CDFORNECED = P_CLIENTE);
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_IDENDCFOP := w_P; 
            V_IDENDEMIS := w_P;
            V_IDCONSFINAL := w_N;
            V_NRINSESTDESNF := NULL;
            V_IDCONTRIBICMS := w_N;
      END;
      SELECT MAX(CDPAIS), MAX(SGESTADO), MAX(CDMUNICIPIO)
        INTO V_CDPAISST, V_SGESTADOST, V_CDMUNICIPIOST
        FROM ENDEFORN
       WHERE CDFORNECED = P_CLIENTE
         AND IDTPENDEFORN = 'P';
      SELECT MAX(CDINSCESTAST)
        INTO V_CDINSCESTAST
        FROM INSCRESTADST
       WHERE CDEMPRESA = P_EMPRESA
         AND CDINSCESTA = P_INSCESTA
         AND CDPAIS = V_CDPAISST
         AND SGESTADO = V_SGESTADOST;
      IF V_IDENDCFOP = w_I THEN
         Begin
            SELECT CDPAIS    , SGESTADO
            INTO   V_PAISCFOP, V_ESTACFOP
            FROM INSCRESTAD
            WHERE CDEMPRESA  = P_EMPRESA AND
                  CDINSCESTA = P_INSCESTA;
         Exception
            When No_Data_Found Then
               V_PAISCFOP := Null; V_ESTACFOP := Null;
         End;
      ELSE
         Begin
            SELECT CDPAIS    , SGESTADO
            INTO   V_PAISCFOP, V_ESTACFOP
            FROM ENDEFORN
            WHERE (CDFORNECED   = P_CLIENTE) AND
                  (IDTPENDEFORN = V_IDENDCFOP);
         Exception
            When No_Data_Found Then
               V_PAISCFOP := Null; V_ESTACFOP := Null;
         End;
      END IF;
      Begin
         SELECT CDPAIS,     SGESTADO,   CDMUNICIPIO
         INTO   V_PAISDEST, V_ESTADEST, V_MUNIDEST
         FROM ENDEFORN
         WHERE (CDFORNECED   = P_CLIENTE) AND
               (IDTPENDEFORN = V_IDENDEMIS);
      Exception
         When No_Data_Found Then
            V_PAISDEST := Null; V_ESTADEST := Null; V_MUNIDEST := Null;
      End;
   ELSE /*DESTINATARIO -> CLIENTE(DEFAULT) */
      BEGIN
         SELECT NVL(IDENDCFOPCLI,w_P),
                NVL(IDENDEMISCLI,w_P),
                NVL(IDUTDESCICMS, w_N),
                NVL(IDCONSFINAL,w_N),
                NRINSESTCLIE,
                NVL(IDCONTRIBICMS,w_N),
                CDCNAECLIE,
                NVL(IDOPTANTESNCLIE,w_N),
                NVL(IDENDCFOPCLIPRES, 'I')
           INTO V_IDENDCFOP,
                V_IDENDEMIS,
                V_IDUTDESCICMS,
                V_IDCONSFINAL,
                V_NRINSESTDESNF,
                V_IDCONTRIBICMS,
                V_CDCNAECLIE,
                V_IDOPTANTESNCLIE,
                V_IDENDCFOPCLIPRES
           FROM CLIENTE
          WHERE (CDCLIENTE = P_CLIENTE);
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_IDENDCFOP := w_P;
            V_IDENDEMIS := w_P;
            V_IDUTDESCICMS := w_N;
            V_IDCONSFINAL := w_N;
            V_NRINSESTDESNF := NULL;
            V_IDCONTRIBICMS := w_N;
            V_CDCNAECLIE := NULL;
            V_IDOPTANTESNCLIE := w_N;
            V_IDENDCFOPCLIPRES := 'I';
      END;
      SELECT MAX(CDPAIS), MAX(SGESTADO), MAX(CDMUNICIPIO)
        INTO V_CDPAISST, V_SGESTADOST, V_CDMUNICIPIOST
        FROM ENDECLIE
       WHERE CDCLIENTE = P_CLIENTE
         AND IDTPENDECLIE = 'P';
      SELECT MAX(CDINSCESTAST)
        INTO V_CDINSCESTAST
        FROM INSCRESTADST
       WHERE CDEMPRESA = P_EMPRESA
         AND CDINSCESTA = P_INSCESTA
         AND CDPAIS = V_CDPAISST
         AND SGESTADO = V_SGESTADOST;
      IF V_IDENDCFOP = w_I THEN
         Begin
            SELECT CDPAIS    , SGESTADO, CDMUNICIPIO
            INTO   V_PAISCFOP, V_ESTACFOP, V_MUNIDEST
            FROM INSCRESTAD
            WHERE CDEMPRESA  = P_EMPRESA AND
                  CDINSCESTA = P_INSCESTA;
         Exception
            When No_Data_Found Then
               V_PAISCFOP := Null; V_ESTACFOP := Null; V_MUNIDEST := Null;
         End;
         V_PAISDEST := V_PAISCFOP;
         V_ESTADEST := V_ESTACFOP;
      ELSE
         Begin
            SELECT CDPAIS    , SGESTADO
            INTO   V_PAISCFOP, V_ESTACFOP
            FROM ENDECLIE
            WHERE (CDCLIENTE    = P_CLIENTE) AND
                  (IDTPENDECLIE = V_IDENDCFOP);
         Exception
            When No_Data_Found Then
               V_PAISCFOP := Null; V_ESTACFOP := Null;
         End;
         Begin
            SELECT CDPAIS    , SGESTADO  , CDMUNICIPIO
            INTO   V_PAISDEST, V_ESTADEST, V_MUNIDEST
            FROM ENDECLIE
            WHERE (CDCLIENTE    = P_CLIENTE) AND
                  (IDTPENDECLIE = V_IDENDEMIS);
         Exception
            When No_Data_Found Then
               V_PAISDEST := Null; V_ESTADEST := Null; V_MUNIDEST := Null;
         End;
      END IF;
   END IF;
   IF (V_NRINSESTDESNF IS NULL) OR (V_NRINSESTDESNF = '') THEN
      V_IDCONTRIBICMSAUX := 'N';
   ELSE
      V_IDCONTRIBICMSAUX := V_IDCONTRIBICMS;
   END IF;
   IF (V_CDINSCESTAST IS NOT NULL) OR (V_CDINSCESTAST = '')  THEN
      UPDATE NOTAFISCAL
         SET CDINSCESTAST = V_CDINSCESTAST
       WHERE CDFILIAL = P_FILIAL
         AND NRLANCTONF = P_LANCTONF;
      FOR C_MENSINSCESTAST IN (SELECT M.CDMENSAGEM, I.DSMENSINSCESTAST
                                 FROM MENSINSCESTAST I LEFT JOIN MENSAGEM M ON (M.CDMENSAGEM = I.CDMENSAGEM)
                                WHERE I.CDEMPRESA = P_EMPRESA
                                  AND I.CDINSCESTA = P_INSCESTA
                                  AND I.CDINSCESTAST = V_CDINSCESTAST
                                  AND I.IDENTRSAIDMENSST <> 'E'
                                  AND (((I.CDMENSAGEM IS NOT NULL) AND (M.IDSITUACAOMENS  = 'A')) OR (I.CDMENSAGEM IS NULL))
                                  AND NOT EXISTS (SELECT DSDADOADIC
                                                    FROM DADOSADIC
                                                   WHERE (CDFILIAL = P_FILIAL)
                                                     AND (NRLANCTONF = P_LANCTONF)
                                                     AND (DSDADOADIC LIKE I.DSMENSINSCESTAST || '%'))
                                ORDER BY NRMENSINSCESTAST) LOOP
         /*PREENCHE AS MENSAGENS ATRELADAS A INSCRICAO ESTADUAL DO SUBSTITUTO TRIBUTÁRIO*/
         INSERT INTO DADOSADIC(CDFILIAL, NRLANCTONF, NRDADOADIC, CDMENSAGEM, DSDADOADIC)
                        VALUES(P_FILIAL, P_LANCTONF, V_DADOADIC, C_MENSINSCESTAST.CDMENSAGEM, C_MENSINSCESTAST.DSMENSINSCESTAST);
         V_DADOADIC := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_DADOADIC) + 1)),3,0);
      END LOOP;
   END IF;
    -- PREENCHER CLASSIFICACAO FISCAL NCM NA TABELA ITEMPRODUTO
    FOR C_ITEMPRODUTO IN (SELECT I.CDFILIAL, I.NRLANCTONF, I.NRSEQITPROD, P.CDCLASFISC
                            FROM ITEMPRODUTO I, PRODUTO P
                           WHERE I.CDFILIAL   = P_FILIAL
                             AND I.NRLANCTONF = P_LANCTONF
                             AND I.CDPRODUTO = P.CDPRODUTO)
    LOOP
      UPDATE ITEMPRODUTO
         SET CDPRODNCMTRANS = C_ITEMPRODUTO.CDCLASFISC
       WHERE CDFILIAL    = C_ITEMPRODUTO.CDFILIAL
         AND NRLANCTONF  = C_ITEMPRODUTO.NRLANCTONF
         AND NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD;
   END LOOP;
   /*
   ROTINA PARA VERIFICAR AS NOTAS DO SISTEMA FACILITIES. NESTAS NOTAS O SISTEMA
   NÃO VERIFICARÁ O PAIS, O ESTADO E NEM O MUNICÍPIO DO DESTINATÁRIO DA NOTA FISCAL
   E SIM DO LOCAL DE ATENDIMENTO DAQUELA PRESTAÇÃO DE SERVIÇO
   */
   V_QTDREGFCT := 0;
   BEGIN
      SELECT CDPAIS,
             SGESTADO,
             CDMUNICIPIO,
             COUNT(*)
        INTO V_CDPAISFCT,
             V_SGESTADOFCT,
             V_CDMUNICIPIOFCT,
             V_QTDREGFCT
        FROM FCT_DADOSNF
       WHERE CDFILIAL = P_FILIAL
         AND NRLANCTONF = P_LANCTONF
       GROUP BY CDPAIS, 
             SGESTADO, 
             CDMUNICIPIO;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_CDPAISFCT := NULL;
         V_SGESTADOFCT := NULL;
         V_CDMUNICIPIOFCT := NULL;
         V_QTDREGFCT := 0;
   END;
   IF (V_QTDREGFCT > 0) THEN
      V_PAISDEST := V_CDPAISFCT;
      V_ESTADEST := V_SGESTADOFCT;
      V_MUNIDEST := V_CDMUNICIPIOFCT;
   END IF;
   /*
   QUANDO A OPERAÇÃO DA NOTA FISCAL FOR PRESENCIAL O SISTEMA USARÁ COMO ENDEREÇO
   DE DESTINO O MESMO ENDEREÇO DA ORIGEM. ESTÁ CONDIÇÃO FOI NECESSÁRIA PARA ATENDER
   A NOTA TÉCNICA 2015/003
   */
   IF V_IDPRESENCIAL = W_1 THEN
      V_PAISDEST := V_PAISORIG;
      V_ESTADEST := V_ESTAORIG;
      V_MUNIDEST := V_MUNIORIG;
      -- Verificar identificador de endereço CFOP conforme operação presencial
      IF (NVL(V_IDORIGDESTNF, 'C') = 'C') THEN
         IF V_IDENDCFOPCLIPRES = w_I THEN
            Begin
               SELECT CDPAIS, SGESTADO
                 INTO V_PAISCFOP, V_ESTACFOP
                 FROM INSCRESTAD
                WHERE CDEMPRESA  = P_EMPRESA
                  AND CDINSCESTA = P_INSCESTA;
            Exception
               When No_Data_Found Then
                  V_PAISCFOP := Null; V_ESTACFOP := Null;
            End;
         ELSE
            Begin
               SELECT CDPAIS, SGESTADO
                 INTO V_PAISCFOP, V_ESTACFOP
                 FROM ENDECLIE
                WHERE CDCLIENTE    = P_CLIENTE
                  AND IDTPENDECLIE = V_IDENDCFOPCLIPRES;
            Exception
               When No_Data_Found Then
                  V_PAISCFOP := Null; V_ESTACFOP := Null;
            End;
         END IF;
      END IF;   
   END IF;
   V_IDINTEREST := 'N';
   V_IDINTERNA  := 'N';
   IF ((V_PAISDEST = V_PAISORIG) AND (V_ESTADEST <> V_ESTAORIG)) THEN
      V_IDINTEREST := 'S';
   ELSIF (V_PAISDEST <> V_PAISORIG) THEN
      V_IDINTERNA := 'S';
   END IF;
   IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (NVL(V_IDORIGDESTNF, 'C') <> 'L') THEN
      UPDATE ITEMPRODUTO
      SET VRTOTAITEM = TRUNC(VRTOTAITEM,2)
      WHERE CDFILIAL   = P_FILIAL AND
            NRLANCTONF = P_LANCTONF;
   ELSE
      UPDATE ITEMPRODUTO
      SET VRTOTAITEM = ROUND(VRTOTAITEM,5)  
      WHERE CDFILIAL   = P_FILIAL AND
            NRLANCTONF = P_LANCTONF;
   END IF;
   SELECT SUM(VRLIQUIDO)
     INTO V_LIQUIDO
     FROM (SELECT DECODE(QTITEMPROD, 0, (VRTOTAITEM - VRDESCITEM), (ROUND(QTITEMPROD,4) * ROUND(VRUNITITEM,10)) - ROUND(VRDESCITEM, 2)) AS VRLIQUIDO
             FROM ITEMPRODUTO
            WHERE CDFILIAL   = P_FILIAL
              AND NRLANCTONF = P_LANCTONF);
   /*PREENCHE O GRUPO FISCAL*/
   IF V_IDORIGDESTNF = w_U THEN /*LICENCA DE USO*/
      CONSULTA_GRUPOFISCAL(w_C           , V_CDORIGDESTNF, V_CDFILIEMIT, w_S, P_TIPOOPER, V_CDGRUPOFISC);
   ELSE /*DEMAIS DESTINATARIOS*/
      CONSULTA_GRUPOFISCAL(V_IDORIGDESTNF, V_CDORIGDESTNF, V_CDFILIEMIT, w_S, P_TIPOOPER, V_CDGRUPOFISC);
   END IF;
   /*VERIFICA SE A NOTA UTILIZA DOCUMENTO DE ORIGEM E SE O TIPO DE OPERAÇÃO É DE ESTORNO DE CANCELAMENTO*/
   BEGIN
      SELECT IDOPERDEVONF, 
             IDCONSPARFIS, 
             IDNFESTCANC,
             IDCALCDIFALDENT,
             IDUTILVENC,
             IDNOTADEVO,
             IDNFAJUSTE,
             IDUTILNFSE,
             NVL(IDCONTCONFORIG, 'S')
        INTO V_IDOPERDEVONF, 
             V_IDCONSPARFIS, 
             V_ESTORNOCANC,
             V_IDCALCDIFALDENT,
             V_IDUTILVENC,
             V_IDNOTADEVO,
             V_IDNFAJUSTE,
             V_IDUTILNFSE,
             V_IDCONTCONFORIG
        FROM TIPOOPERAC
       WHERE IDENTRSAIDOP = w_S
         AND CDTIPOOPER = P_TIPOOPER;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN BEGIN
         V_IDOPERDEVONF := w_N;
         V_IDCONSPARFIS := w_S;
         V_ESTORNOCANC := w_N;
         V_IDCALCDIFALDENT := w_N;
         V_IDUTILVENC := w_N;
         V_IDNOTADEVO := w_N;
         V_IDNFAJUSTE := w_N;
         V_IDUTILNFSE := w_N;
         V_IDCONTCONFORIG := w_S;
      END;
   END;
   IF (V_IDUTILNFSE = 'S') THEN
      V_QTDREGSERV := 0;
      BEGIN
         SELECT CDPAISPRESSERV,
                SGESTADOPRESSERV,
                CDMUNICIPRESSERV,
                COUNT(*)
           INTO V_CDPAISSERV,
                V_SGESTADOSERV,
                V_CDMUNICIPIOSERV,
                V_QTDREGSERV
           FROM DADOSERVPRES
          WHERE CDFILIAL   = P_FILIAL
            AND NRLANCTONF = P_LANCTONF
          GROUP BY CDPAISPRESSERV,
                   SGESTADOPRESSERV,
                   CDMUNICIPRESSERV;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_CDPAISSERV      := NULL;
            V_SGESTADOSERV    := NULL;
            V_CDMUNICIPIOSERV := NULL;
            V_QTDREGSERV      := 0;
      END;
       IF (V_QTDREGSERV > 0) THEN
         V_PAISDEST := V_CDPAISSERV;
         V_ESTADEST := V_SGESTADOSERV;
         V_MUNIDEST := V_CDMUNICIPIOSERV;
      END IF;
   END IF;
   IF V_IDOPERDEVONF <> w_S THEN  /*SE NAO UTILIZA DOCUMENTO DE ORIGEM*/
      IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (NVL(V_IDORIGDESTNF, 'C') <> 'L') THEN
         UPDATE ITEMPRODUTO
         SET VRBRUTITEM   = TRUNC((VRTOTAITEM - VRDESCITEM),2),
             VRCONTITEM   = TRUNC((VRTOTAITEM - VRDESCITEM),2)
         WHERE CDFILIAL   = P_FILIAL   AND
               NRLANCTONF = P_LANCTONF;
      ELSE
         UPDATE ITEMPRODUTO
         SET VRBRUTITEM   = ROUND((VRTOTAITEM - VRDESCITEM),5),
             VRCONTITEM   = ROUND((VRTOTAITEM - VRDESCITEM),5)
         WHERE CDFILIAL   = P_FILIAL   AND
               NRLANCTONF = P_LANCTONF;
      END IF;
      V_IDOPERDEVONF := w_N;
   ELSE
      IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (NVL(V_IDORIGDESTNF, 'C') <> 'L') THEN
         UPDATE ITEMPRODUTO
         SET VRBRUTITEM   = TRUNC((VRTOTAITEM - VRDESCITEM),2),
             VRCONTITEM   = TRUNC((VRTOTAITEM - VRDESCITEM),2)
         WHERE CDFILIAL   = P_FILIAL   AND
               NRLANCTONF = P_LANCTONF;
      ELSE
         UPDATE ITEMPRODUTO
         SET VRBRUTITEM   = ROUND((VRTOTAITEM - VRDESCITEM),5),
             VRCONTITEM   = ROUND((VRTOTAITEM - VRDESCITEM),5)
         WHERE CDFILIAL   = P_FILIAL   AND
               NRLANCTONF = P_LANCTONF;
      END IF;
      SELECT COUNT(*)
      INTO   V_COUNT
      FROM ITEMNOTAFISC
      WHERE CDFILIAL   = P_FILIAL AND
            NRLANCTONF = P_LANCTONF;
      V_IDDEVOLIST := w_N; /*SE O DOCUMENTO DE ORIGEM E DE LISTA OU NAO*/
      IF (V_COUNT > 1) THEN
         V_IDDEVOLIST := w_S;
      END IF;
      IF (V_COUNT = 0) THEN
         V_IDOPERDEVONF := w_N;
         IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (NVL(V_IDORIGDESTNF, 'C') <> 'L') THEN
            UPDATE ITEMPRODUTO
            SET VRBRUTITEM   = TRUNC((VRTOTAITEM - VRDESCITEM),2),
                VRCONTITEM   = TRUNC((VRTOTAITEM - VRDESCITEM),2)
            WHERE CDFILIAL   = P_FILIAL   AND
                  NRLANCTONF = P_LANCTONF;
         ELSE
            UPDATE ITEMPRODUTO
            SET VRBRUTITEM   = ROUND((VRTOTAITEM - VRDESCITEM),5),
                VRCONTITEM   = ROUND((VRTOTAITEM - VRDESCITEM),5)
            WHERE CDFILIAL   = P_FILIAL   AND
                  NRLANCTONF = P_LANCTONF;
         END IF;
      ELSE
         V_IDOPERDEVONF := w_S;
         IF (P_TIPOOPER = '03') OR (P_TIPOOPER = '05') OR (P_TIPOOPER = '11') THEN
            V_IDOPERDEVONF := w_N;
         END IF;
      END IF;
   END IF;
   DELETE 
     FROM DETESPCOMBNFE
    WHERE CDFILIAL = P_FILIAL
      AND NRLANCTONF = P_LANCTONF;
   /* GRAVA INFORMAÇÕES ADICIONAIS DO PRODUTO */
   V_IDPRODPERIG := 'N';
   FOR C_ITEMPRODINF IN (SELECT I.NRSEQITPROD, P.IDPRODPERIG, P.DSINFADICPROD, I.CDPRODUTO
                           FROM ITEMPRODUTO I, PRODUTO P
                          WHERE I.CDFILIAL = P_FILIAL
                            AND I.NRLANCTONF = P_LANCTONF
                            AND I.CDPRODUTO = P.CDPRODUTO)
   LOOP
      UPDATE ITEMPRODUTO
         SET DSINFADICPROD = C_ITEMPRODINF.DSINFADICPROD
       WHERE CDFILIAL = P_FILIAL
         AND NRLANCTONF = P_LANCTONF
         AND NRSEQITPROD = C_ITEMPRODINF.NRSEQITPROD;
      BEGIN
         SELECT NRREGISTROANP,
                DSREGISTROANP
           INTO V_NRREGISTROANP,
                V_DSREGISTROANP
           FROM INFADICPROD
          WHERE CDPRODUTO = C_ITEMPRODINF.CDPRODUTO;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_NRREGISTROANP := NULL;
            V_DSREGISTROANP := NULL;
      END;
      IF V_NRREGISTROANP IS NOT NULL THEN
         INSERT INTO DETESPCOMBNFE
            (CDFILIAL, NRLANCTONF, NRSEQITPROD, CDPAIS, 
             SGESTADO, CDPRODANP, DSPRODANP)
         VALUES
            (P_FILIAL, P_LANCTONF, C_ITEMPRODINF.NRSEQITPROD, V_PAISORIG, 
             V_ESTAORIG, SUBSTR(V_NRREGISTROANP, 1, 9), SUBSTR(V_DSREGISTROANP, 1, 255));
      END IF;
      IF C_ITEMPRODINF.IDPRODPERIG = 'S' THEN
         V_IDPRODPERIG := 'S';
      END IF;
   END LOOP;
   /* GRAVA MENSAGEM REFERENTE A PRODUTO PERIGOSO */
   IF V_IDPRODPERIG = 'S' THEN
      V_MSGPRODPERIG := 'Declaro que os produtos perigosos estão adequadamente ' ||
                        'classificados, embalados, identificados, e estivados ' ||
                        'para suportar os riscos das operações de transporte e ' ||
                        'que atendem às exigências da regulamentação.';
      BEGIN
         SELECT COUNT(DSDADOADIC)
           INTO V_GRAVAMSGPRODPERIG
           FROM DADOSADIC
          WHERE (CDFILIAL = P_FILIAL)
            AND (NRLANCTONF = P_LANCTONF)
            AND (DSDADOADIC LIKE SUBSTR(V_MSGPRODPERIG, 1, LENGTH(V_MSGPRODPERIG) - 19) || '%');
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_GRAVAMSGPRODPERIG := 0;
      END;
      IF (V_GRAVAMSGPRODPERIG = 0) THEN
         INSERT INTO DADOSADIC(CDFILIAL, NRLANCTONF, NRDADOADIC, CDMENSAGEM, DSDADOADIC)
                        VALUES(P_FILIAL, P_LANCTONF, V_DADOADIC, NULL, V_MSGPRODPERIG);
         V_DADOADIC := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_DADOADIC) + 1)),3,0);
      END IF;
   End If;
   DELETE FROM DADOSADIC
    WHERE CDFILIAL = P_FILIAL
      AND NRLANCTONF = P_LANCTONF
      AND DSDADOADIC LIKE 'ICMS retido anteriormente por substituição tributária: BC %';
   DELETE FROM DADOSADIC
     WHERE CDFILIAL = P_FILIAL
       AND NRLANCTONF = P_LANCTONF
       AND DSDADOADIC LIKE 'Permite o aproveitamento do credito do ICMS no valor de R$ %';
-- ATUALIZAÇÃO DAS TABELAS DE NOTAFISCAL, ITEMPRODUTO E DADOS ADICIONAIS
   IF NOT(P_TIPOOPER IN ('03','07','09','10','12')) AND (V_IDOPERDEVONF <> w_S) THEN
   /*AS NOTAS QUE NAO UTILIZAM DOCUMENTO DE ORIGEM*/
      FOR C_ITEMPRODUTO IN (SELECT VRTOTAITEM, VRDESCITEM, IT.CDPRODUTO, NRSEQITPROD,
                                   CDCSTINFUSU, CDCFOPINFUSU, CDSUFXINFUSU, P.CDARVPROD,
                                   IT.QTITEMPROD, IT.IDORIGEMPROD, IT.VRUNITITEM
                            FROM ITEMPRODUTO IT, PRODUTO P
                            WHERE IT.CDFILIAL   = P_FILIAL   AND
                                  IT.NRLANCTONF = P_LANCTONF AND
                                  IT.CDPRODUTO  = P.CDPRODUTO) LOOP
         V_LIQUIITEM := C_ITEMPRODUTO.VRTOTAITEM - C_ITEMPRODUTO.VRDESCITEM;
         /*VERIFICA O CST POR ITEM*/
         CONSULTA_CST(w_S, P_EMPRESA, C_ITEMPRODUTO.CDARVPROD, P_INSCESTA, P_TIPOOPER, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC, V_IDINTEREST, V_IDINTERNA, NULL, C_ITEMPRODUTO.IDORIGEMPROD);
         FOR C_CSTTEMP IN (SELECT DSMENSCSTTMP
                           FROM CSTTEMP
                           WHERE (NRCSTTEMP = V_CSTTEMP)    AND
                                 (DSMENSCSTTMP IS NOT NULL) AND
                                 (NOT EXISTS(SELECT DSDADOADIC
                                             FROM DADOSADIC
                                             WHERE (CDFILIAL   = P_FILIAL)   AND
                                                   (NRLANCTONF = P_LANCTONF) AND
                                                   (DSDADOADIC LIKE CSTTEMP.DSMENSCSTTMP || '%')))) LOOP
            IF NOT (C_CSTTEMP.DSMENSCSTTMP IS NULL) THEN
               /*PREENCHE AS MENSAGENS ATRELADAS AO CST*/
               INSERT INTO DADOSADIC(CDFILIAL, NRLANCTONF, NRDADOADIC, DSDADOADIC)
               VALUES(P_FILIAL, P_LANCTONF, V_DADOADIC, C_CSTTEMP.DSMENSCSTTMP);
               V_DADOADIC := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_DADOADIC) + 1)),3,0);
            END IF;
         END LOOP;
         IF V_PAISORIG = V_PAISCFOP THEN
            IF V_ESTAORIG = V_ESTACFOP THEN
               V_CFOP1DIGT := '5';
            ELSE
               V_CFOP1DIGT := '6';
            END IF;
         ELSE
            V_CFOP1DIGT := '7';
         END IF;
         /*VERIFICA CFOP POR ITEM*/
         CONSULTA_CFOP(w_S, P_EMPRESA, C_ITEMPRODUTO.CDARVPROD, P_INSCESTA, P_TIPOOPER, V_PAISORIG,
                        V_ESTAORIG, V_PAISCFOP, V_ESTACFOP, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC, P_INIVALID, C_ITEMPRODUTO.IDORIGEMPROD );
         FOR C_CFOPTEMP IN (SELECT DSMENSCFOTMP
                            FROM CFOPTEMP
                            WHERE (NRCFOPTEMP = V_CFOPTEMP)  AND
                                  (DSMENSCFOTMP IS NOT NULL) AND
                                  (NOT EXISTS(SELECT DSDADOADIC
                                              FROM DADOSADIC
                                              WHERE (CDFILIAL   = P_FILIAL)   AND
                                                    (NRLANCTONF = P_LANCTONF) AND
                                                    (DSDADOADIC LIKE CFOPTEMP.DSMENSCFOTMP || '%')))) LOOP
            IF NOT (C_CFOPTEMP.DSMENSCFOTMP IS NULL) THEN
               /*PREENCHE AS MENSAGENS ATRELADAS AO CFOP*/
               INSERT INTO DADOSADIC(CDFILIAL, NRLANCTONF, NRDADOADIC, DSDADOADIC)
                              VALUES(P_FILIAL, P_LANCTONF, V_DADOADIC, C_CFOPTEMP.DSMENSCFOTMP);
               V_DADOADIC := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_DADOADIC) + 1)),3,0);
            END IF;
         END LOOP;
         V_CFOPINFUSU := 'N';         
         IF C_ITEMPRODUTO.CDCFOPINFUSU IS NULL THEN /*SE NAO HOUVER CFOP INFORMADO PELO USUARIO PARA O PRODUTO*/
            /*SE A DESCRIÇÃO DO CFOP NAO TIVER SIDO INFORMADA PELO USUARIO O SISTEMA ASSUME A DESCRICAO DO CFOP DOS ITENS*/
            UPDATE NOTAFISCAL
               SET DSCDFISOPENF = (SELECT MAX(DSCFOPTMP) FROM CFOPTEMP
                                  WHERE NRCFOPTEMP = V_CFOPTEMP)
            WHERE CDFILIAL   = P_FILIAL   AND
                  NRLANCTONF = P_LANCTONF;
            SELECT MAX(CDFISOPETMP), MAX(CDSUFCFOPTMP), SUBSTR(MAX(DSCFOPTMP),1,50)
            INTO   V_FISOPEITEM    , V_SUFXCFOPPR, V_DSCDFISOPEIT
            FROM CFOPTEMP
            WHERE NRCFOPTEMP = V_CFOPTEMP;
            SELECT MAX(CDSITTRIBTMP)
            INTO   V_SITUTRIBPR
            FROM CSTTEMP
            WHERE NRCSTTEMP = V_CSTTEMP;
         ELSE /*SE HOUVER CFOP INFORMADO PELO USUARIO PARA O PRODUTO*/
            V_CFOPINFUSU := 'S';
            V_FISOPEITEM := C_ITEMPRODUTO.CDCFOPINFUSU;
            V_SUFXCFOPPR := C_ITEMPRODUTO.CDSUFXINFUSU;
            V_SITUTRIBPR := C_ITEMPRODUTO.CDCSTINFUSU;
         END IF;
         IF V_IDDOCREPLIC IS NOT NULL THEN /*SE A NF FOI REPLICADA*/
            IF LENGTH(V_SITUTRIBPR) = 3 THEN
               V_SITUTRIBPR := SUBSTR(V_SITUTRIBPR,1,1) || w_90;
            ELSE
               V_SITUTRIBPR := w_90;
            END IF;
         END IF;
         /*VERIFICA CSOSN POR IMPOSTO*/
         CONSULTA_CSOSN('S', P_EMPRESA, C_ITEMPRODUTO.CDARVPROD, P_INSCESTA, P_TIPOOPER, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC, V_IDINTEREST, V_CDFISCOPERSN);
         UPDATE ITEMPRODUTO
         SET CDFISOPEITEM  = V_FISOPEITEM,
             CDSUFXCFOPPR  = V_SUFXCFOPPR,
             CDSITUTRIBPR  = V_SITUTRIBPR,
             DSCDFISOPEIT  = V_DSCDFISOPEIT,
             CDFISCOPERSN  = V_CDFISCOPERSN
         WHERE CDFILIAL    = P_FILIAL AND
               NRLANCTONF  = P_LANCTONF AND
               NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD;
         DELETE CFOPTEMP
         WHERE NRCFOPTEMP = V_CFOPTEMP;
         DELETE CSTTEMP
         WHERE NRCSTTEMP = V_CSTTEMP;
   -- ATUALIZAÇÃO DA TABELA DE IMPOSTOS POR ITEM.
         DELETE ITEMPROIMPOS
         WHERE (CDFILIAL    = P_FILIAL)   AND
               (NRLANCTONF  = P_LANCTONF) AND
               (NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD);
         DELETE ITEMPROIMPOSORIG
         WHERE (CDFILIAL    = P_FILIAL)   AND
               (NRLANCTONF  = P_LANCTONF) AND
               (NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD);
         SELECT COUNT(*)
         INTO   V_IMPOSINFUSU
         FROM IMPOSINFUSU
         WHERE (CDFILIAL    = P_FILIAL)   AND
               (NRLANCTONF  = P_LANCTONF) AND
               (NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD);
         IF V_IMPOSINFUSU = 0 THEN
-- Verifica se há grupo fiscal por servico
            SELECT MAX(CDGRUPOFISC)
            INTO V_CDGRPFISCSV
            FROM SERVCLIE SC, SERVICO S
            WHERE SC.CDFILIAL   = V_CDFILIEMIT AND
                  SC.CDCLIENTE  = P_CLIENTE    AND
                  SC.CDFILIAL   = S.CDFILIAL   AND
                  SC.CDSERVFILI = S.CDSERVFILI AND
                  S.CDPRODUTO   = C_ITEMPRODUTO.CDPRODUTO;
            IF V_CDGRPFISCSV IS NULL THEN
               -- Verifica se há grupo fiscal por cliente da filial
               SELECT MAX(CDGRUPOFISC)
               INTO V_CDGRPFISCSV
               FROM CLIENFILIAL
               WHERE CDFILIAL   = V_CDFILIEMIT AND
                     CDCLIENTE  = P_CLIENTE;
            END IF;
            CONSULTA_INCIDENCIA(w_S, P_EMPRESA, C_ITEMPRODUTO.CDARVPROD, P_INSCESTA, P_TIPOOPER, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC, V_CDGRPFISCSV,
                                V_IDINTEREST, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, C_ITEMPRODUTO.IDORIGEMPROD);
            FOR C_INCITEMP IN (SELECT DSMENSINCTMP
                               FROM INCITEMP
                               WHERE (NRINCITEMP = V_INCITEMP)  AND
                                     (DSMENSINCTMP IS NOT NULL) AND
                                     (NOT EXISTS(SELECT DSDADOADIC
                                                 FROM DADOSADIC
                                                 WHERE (CDFILIAL   = P_FILIAL)   AND
                                                       (NRLANCTONF = P_LANCTONF) AND
                                                       (DSDADOADIC LIKE INCITEMP.DSMENSINCTMP || '%')))) LOOP
               IF NOT(C_INCITEMP.DSMENSINCTMP IS NULL) THEN
               /*PREENCHE AS MENSAGENS ATRELADAS A INCIDENCIA*/
                  INSERT INTO DADOSADIC(CDFILIAL, NRLANCTONF, NRDADOADIC, DSDADOADIC)
                                 VALUES(P_FILIAL, P_LANCTONF, V_DADOADIC, C_INCITEMP.DSMENSINCTMP);
                  V_DADOADIC := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_DADOADIC) + 1)),3,0);
               END IF;
            END LOOP;
            FOR C_INCIDENCIA IN (SELECT DISTINCT (CDIMPOTEMP) AS CDIMPOTEMP, CDFISCTEMP, IDTRATIMPTMP, IDUTMUNIORIG,
                                        IDCONSISTENT, IDIMPORECUP, IDUTVLRQTDEIMPO, CDDETALHEPROD,
                                        CDREGRATMP, IP.CDIMPOSTONFE, IT.CDENQLEGALIPI, IT.CDCEST,
                                        IT.VRADICALIQFECP, IP.CDIMPOBASERET, IP.IDDESCRFONTE , IP.IDDESONERAIMPO
                                 FROM INCITEMP IT, IMPOSTO IP
                                 WHERE (IT.NRINCITEMP = V_INCITEMP)    AND
                                       (IP.CDIMPOSTO  = IT.CDIMPOTEMP) AND
                                       (IP.IDPRODNOTA = w_P)
                                 ORDER BY CDIMPOTEMP) LOOP
               -- Se o imposto é retido (valor NF) e se utiliza o valor de outro imposto como base de cálculo
               IF ((C_INCIDENCIA.IDTRATIMPTMP = 'R') AND (C_INCIDENCIA.CDIMPOBASERET IS NOT NULL)) THEN
                  V_VRIMPORELAC := 0;
                  SELECT NVL(MAX(VRIMPOSTOIT),0)
                    INTO V_VRIMPORELAC
                    FROM ITEMPROIMPOS
                   WHERE CDFILIAL     = P_FILIAL
                     AND NRLANCTONF   = P_LANCTONF
                     AND NRSEQITPROD  = C_ITEMPRODUTO.NRSEQITPROD
                     AND CDIMPOSTO    = C_INCIDENCIA.CDIMPOBASERET
                     AND NRITPROIMPOS = W_1;
                  IF V_VRIMPORELAC <> 0 THEN
                     V_LIQUIITEM := V_VRIMPORELAC;
                  END IF;
               ELSE
                  V_LIQUIITEM := C_ITEMPRODUTO.VRTOTAITEM - C_ITEMPRODUTO.VRDESCITEM;   
               END IF;
               V_ALIQUTMP := 0;
               V_SIMPLES  := 'N';
               V_UTIBB    := 'N';
               V_VRADICALIQFECP := C_INCIDENCIA.VRADICALIQFECP;
               V_CDBENEFFISCAL := NULL;
--integração fiscal especifica com Compass_Argentina atraves da importação de aliquota do imposto IBB
--A aliquota de imposto 03(ibb) sera cadastrada na tabela paramintegraibb e tera prioridade sobre o
-- cadastro de aliquota realizado em sistema
               IF C_INCIDENCIA.CDIMPOTEMP = '03' THEN
                  IF V_IDORIGDESTNF = 'C' THEN
                     V_ALIQUTMP := 0;
                     V_DTVINGENTE := NVL(V_DTINIREFEFAT, P_INIVALID);
                     SELECT NVL(MAX(VRALIQUOTAIBB),NULL)
                     INTO   V_ALIQUTMP
                     FROM PARAMINTEGRAIBB
                     WHERE CDCLIENTE = P_CLIENTE AND
                           V_DTVINGENTE BETWEEN DTVIGINICIALIBB AND DTVIGFINALIBB;
                     IF V_ALIQUTMP IS NOT NULL THEN
                        V_NRALIQTEMP   := 0;
                        V_PARDEDTMP    := 0;
                        V_PREDBCTMP    := 0;
                        V_TRATIMPST    := w_0;
                        V_PBCSUBTRIB   := 0;
                        V_IDPMCBASECAL := 'N';
                        V_UTIBB        := 'S';
                     END IF;
                  END IF;
               END IF;
               /*VERIFICA CST POR IMPOSTO*/
               V_IMPOICMS := NULL;
               V_CDGRUPOFISCAUX := NULL;
               SELECT MAX(G.CDGRUPOFISC)
                 INTO V_CDGRUPOFISCAUX
                 FROM GRUPOFISCIMPFIL G,
                      (SELECT CDFILIEMIT AS CDFILIAL
                         FROM NOTAFISCAL
                        WHERE CDFILIAL = P_FILIAL
                              AND NRLANCTONF = P_LANCTONF) F
                WHERE G.CDFILIAL = F.CDFILIAL
                  AND NOT G.CDGRUPOFISC IS NULL
                  AND G.CDIMPOSTO = C_INCIDENCIA.CDIMPOTEMP;
               IF V_IDORIGDESTNF = 'C' THEN
                  SELECT NVL(MAX(G.CDGRUPOFISC), V_CDGRUPOFISCAUX)
                    INTO V_CDGRUPOFISCAUX
                    FROM GRFISIMPIECLIE G,
                         (SELECT CDCLIENTE
                            FROM NOTAFISCAL
                           WHERE CDFILIAL = P_FILIAL
                             AND NRLANCTONF = P_LANCTONF) N
                   WHERE G.CDCLIENTE = N.CDCLIENTE
                     AND G.CDEMPRESA = P_EMPRESA
                     AND G.CDINSCESTA = P_INSCESTA
                     AND NOT G.CDGRUPOFISC IS NULL
                     AND G.CDIMPOSTO = C_INCIDENCIA.CDIMPOTEMP;
               ELSE
                  SELECT NVL(MAX(G.CDGRUPOFISC), V_CDGRUPOFISCAUX)
                    INTO V_CDGRUPOFISCAUX
                    FROM GRFISIMPIEFORN G,
                        (SELECT CDFORNECED
                           FROM NOTAFISCAL
                          WHERE CDFILIAL = P_FILIAL
                            AND NRLANCTONF = P_LANCTONF) N
                   WHERE G.CDFORNECED = N.CDFORNECED
                     AND G.CDEMPRESA = P_EMPRESA
                     AND G.CDINSCESTA = P_INSCESTA
                     AND NOT G.CDGRUPOFISC IS NULL
                     AND G.CDIMPOSTO = C_INCIDENCIA.CDIMPOTEMP;
               END IF;
               IF V_CDGRUPOFISCAUX IS NULL THEN
                  CONSULTA_CST_NFE(w_S, P_EMPRESA, C_ITEMPRODUTO.CDARVPROD, P_INSCESTA, P_TIPOOPER, V_CDGRUPOFISC,C_INCIDENCIA.CDIMPOTEMP, V_IDINTEREST, V_IDINTERNA, P_FILIAL, P_LANCTONF, '', V_CDSITTRIBTMP, V_IDMODBCNFE, V_IDMODBCSTNFE, V_CDTPCRPICOSTNFE, V_CDNATUBCPCSTNFE, V_IDMOTIDESSTNFE, C_ITEMPRODUTO.IDORIGEMPROD);
               ELSE
                  CONSULTA_CST_NFE(w_S, P_EMPRESA, C_ITEMPRODUTO.CDARVPROD, P_INSCESTA, P_TIPOOPER, V_CDGRUPOFISCAUX,C_INCIDENCIA.CDIMPOTEMP, V_IDINTEREST, V_IDINTERNA, P_FILIAL, P_LANCTONF, '', V_CDSITTRIBTMP, V_IDMODBCNFE, V_IDMODBCSTNFE, V_CDTPCRPICOSTNFE, V_CDNATUBCPCSTNFE, V_IDMOTIDESSTNFE, C_ITEMPRODUTO.IDORIGEMPROD);
               END IF;
               V_CDSIMPLESNACIONAL := NULL;
               V_CDFAIXA := NULL;
               V_BCICMSSTRETIDO := 0;
               V_VRICMSSTRETIDO := 0;
               V_CDREGRAITALIQ  := NULL;
               /*SIMPLES NACIONAL*/
               IF (V_CDSITUCRT <> '3') THEN
                  CALCULA_ALIQUOTA_SN(P_EMPRESA, 
                                      P_TIPOOPER, 
                                      P_INIVALID,
                                      SUBSTR(V_FISOPEITEM, 2, 3), 
                                      C_INCIDENCIA.CDIMPOSTONFE, 
                                      V_VRSUBLIMITESN,
                                      'N',
                                      V_RBT12,
                                      V_RBA,
                                      V_CDSIMPLESNACIONAL,
                                      V_CDFAIXA,
                                      V_VRALIQSIMPLES);
                  IF (V_CDFAIXA IS NOT NULL) OR ((C_INCIDENCIA.CDIMPOSTONFE IN ('00', '31')) AND (V_RBT12 >= 3600000)) THEN
                     UPDATE ITEMPRODUTO
                        SET CDSIMPLESNACIONAL = V_CDSIMPLESNACIONAL
                      WHERE CDFILIAL    = P_FILIAL
                        AND NRLANCTONF  = P_LANCTONF
                        AND NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD;
                     V_ALIQUTMP      := V_VRALIQSIMPLES;
                     V_CDREGRAITALIQ := C_INCIDENCIA.CDREGRATMP;
                     V_NRALIQTEMP    := 0;
                     V_PARDEDTMP     := 0;
                     V_PREDBCTMP     := 0;
                     V_TRATIMPST     := w_0;
                     V_PBCSUBTRIB    := 0;
                     V_IDPMCBASECAL  := 'N';
                     V_SIMPLES       := 'S';
                  END IF;
                  IF (V_CDFISCOPERSN = '500') OR (SUBSTR(V_CDFISCOPERSN,2, 3) = '500') THEN
                     V_CDIMPOSICMS  := null;
                     SELECT MAX(CDIMPOSTO)
                       INTO V_CDIMPOSICMS
                       FROM IMPOSTO
                      WHERE CDIMPOSTONFE = '00'
                        AND CDIMPOSTO = C_INCIDENCIA.CDIMPOTEMP;
                     IF V_CDIMPOSICMS IS NOT NULL THEN
                        V_ALIQUTMP := 0;
                     END IF;
                     /*Verifica se o imposto de st (hj o sistema só aceita o icms st)*/
                     /*IMPOSTO DE SUBSTITUICAO TRIBUTARIA*/
                     V_CDIMPOSTRIB  := null;
                     V_IDVRIMPSTRIB := null;
                     FOR C_ICMSST IN (SELECT CDIMPOSTRIB
                                        FROM IMPOSTO
                                       WHERE CDIMPOSTRIB = C_INCIDENCIA.CDIMPOTEMP)
                     LOOP
                        V_CDIMPOSTRIB := V_CDIMPOSTRIB||C_ICMSST.CDIMPOSTRIB||'_';
                     END LOOP;
                     V_BCICMSSTRETIDO := 0;
                     V_VRICMSSTRETIDO := 0;
                     IF V_CDIMPOSTRIB IS NOT NULL THEN
                        IF V_IDUTILLOTE = 'S' THEN
                           SELECT MAX(IDUTCTRLLOTE)
                             INTO V_IDUTCTRLLOTE
                             FROM PRODFILI
                            WHERE CDFILIAL  = V_CDFILIEMIT
                              AND CDPRODUTO = C_ITEMPRODUTO.CDPRODUTO;
                           IF V_IDUTCTRLLOTE = 'S' THEN
                              SELECT MAX(NRLOTEESTQ)
                                INTO V_NRLOTEESTQ
                                FROM ITEMPRODUTO
                               WHERE CDFILIAL    = P_FILIAL
                                 AND NRLANCTONF  = P_LANCTONF
                                 AND NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD;
                              V_MEDIA := 0;
                              V_BCICMSSTRETIDO := 0;
                              V_VRICMSSTRETIDO := 0;
                              FOR C_ICMSSTRETIDO IN (SELECT II.CDFILIAL, II.NRLANCTONF, II.NRSEQITPROD, II.CDIMPOSTO,
                                                            ROUND(II.VRBASECALCIT/I.QTITEMPROD,2) AS VRBASE, ROUND(II.VRIMPOSTOIT/I.QTITEMPROD,2) AS VRIMPOSTO
                                                       FROM NOTAFISCAL N, ITEMPRODUTO I, ITEMPROIMPOS II
                                                      WHERE N.CDFILIAL = I.CDFILIAL
                                                        AND N.NRLANCTONF = I.NRLANCTONF
                                                        AND I.CDFILIAL = II.CDFILIAL
                                                        AND I.NRLANCTONF = II.NRLANCTONF
                                                        AND I.NRSEQITPROD = II.NRSEQITPROD
                                                        AND II.NRITPROIMPOS = '1'
                                                        AND N.IDENTRSAIDOP = 'E'
                                                        AND I.CDPRODUTO = C_ITEMPRODUTO.CDPRODUTO
                                                        AND I.NRLOTEESTQ = V_NRLOTEESTQ
                                                        AND N.DTENTRSAID <= P_INIVALID
                                                        AND (INSTR(V_CDIMPOSTRIB,II.CDIMPOSTO||'_') > 0))
                              LOOP
                                  V_MEDIA := V_MEDIA + 1;
                                  V_BCICMSSTRETIDO := V_BCICMSSTRETIDO + C_ICMSSTRETIDO.VRBASE;
                                  V_VRICMSSTRETIDO := V_VRICMSSTRETIDO + C_ICMSSTRETIDO.VRIMPOSTO;
                              END LOOP;
                              IF V_MEDIA > 0 THEN
                                 V_BCICMSSTRETIDO := ROUND(V_BCICMSSTRETIDO/V_MEDIA,2);
                                 V_VRICMSSTRETIDO := ROUND(V_VRICMSSTRETIDO/V_MEDIA,2);
                              ELSE
                                 V_BCICMSSTRETIDO := 0;
                                 V_VRICMSSTRETIDO := 0;
                              END IF;
                              V_BCICMSSTRETIDO := ROUND(V_BCICMSSTRETIDO * C_ITEMPRODUTO.QTITEMPROD,2);
                              V_VRICMSSTRETIDO := ROUND(V_VRICMSSTRETIDO * C_ITEMPRODUTO.QTITEMPROD,2);
                              IF V_BCICMSSTRETIDO <> 0 THEN
                                 SELECT COUNT(*)
                                   INTO V_EXISTDSDADOSADIC
                                   FROM DADOSADIC
                                  WHERE CDFILIAL = P_FILIAL
                                    AND NRLANCTONF = P_LANCTONF
                                    AND DSDADOADIC LIKE 'ICMS retido anteriormente por substituição tributária: BC %';
                                 IF V_EXISTDSDADOSADIC = 0 THEN
                                    /*PREENCHE AS MENSAGENS ATRELADAS A INSCRICAO ESTADUAL*/
                                    INSERT INTO DADOSADIC(CDFILIAL, NRLANCTONF, NRDADOADIC, DSDADOADIC)
                                                   VALUES(P_FILIAL, P_LANCTONF, V_DADOADIC, 'ICMS retido anteriormente por substituição tributária: BC '||DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(V_BCICMSSTRETIDO, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(V_BCICMSSTRETIDO, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(V_BCICMSSTRETIDO, 2), '9999999999999.99')))|| ' Valor '|| DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(V_VRICMSSTRETIDO, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(V_VRICMSSTRETIDO, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(V_VRICMSSTRETIDO, 2), '9999999999999.99'))));
                                    V_DADOADIC := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_DADOADIC) + 1)),3,0);
                                 ELSE
                                    UPDATE DADOSADIC
                                       SET DSDADOADIC = 'ICMS retido anteriormente por substituição tributária: BC '||DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(V_BCICMSSTRETIDO, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(V_BCICMSSTRETIDO, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(V_BCICMSSTRETIDO, 2), '9999999999999.99')))|| ' Valor '|| DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(V_VRICMSSTRETIDO, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(V_VRICMSSTRETIDO, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(V_VRICMSSTRETIDO, 2), '9999999999999.99')))
                                      WHERE CDFILIAL = P_FILIAL
                                        AND NRLANCTONF = P_LANCTONF
                                        AND DSDADOADIC LIKE 'ICMS retido anteriormente por substituição tributária: BC %';
                                 END IF;
                              END IF;
                           END IF;
                        ELSE
                           V_MEDIA := 0;
                           V_BCICMSSTRETIDO := 0;
                           V_VRICMSSTRETIDO := 0;
                           SELECT MAX(N.DTENTRSAID), MAX(II.CDIMPOSTO), MAX(I.CDPRODUTO),
                                  ROUND(SUM(II.VRBASECALCIT)/SUM(I.QTITEMPROD),2) AS VRBASE, ROUND(SUM(II.VRIMPOSTOIT)/SUM(I.QTITEMPROD),2) AS VRIMPOSTO
                             INTO V_DTENTRSAID, V_CDIMPOSTOI, V_CDPRODUTO, V_BCICMSSTRETIDO, V_VRICMSSTRETIDO
                             FROM NOTAFISCAL N, ITEMPRODUTO I, ITEMPROIMPOS II
                            WHERE N.CDFILIAL = I.CDFILIAL
                              AND N.NRLANCTONF = I.NRLANCTONF
                              AND I.CDFILIAL = II.CDFILIAL
                              AND I.NRLANCTONF = II.NRLANCTONF
                              AND I.NRSEQITPROD = II.NRSEQITPROD
                              AND II.NRITPROIMPOS = '1'
                              AND N.IDENTRSAIDOP = 'E'
                              AND I.CDPRODUTO = C_ITEMPRODUTO.CDPRODUTO
                              AND N.DTENTRSAID <= P_INIVALID
                              AND (INSTR(V_CDIMPOSTRIB,II.CDIMPOSTO||'_') > 0);
                           V_BCICMSSTRETIDO := ROUND(V_BCICMSSTRETIDO * C_ITEMPRODUTO.QTITEMPROD,2);
                           V_VRICMSSTRETIDO := ROUND(V_VRICMSSTRETIDO * C_ITEMPRODUTO.QTITEMPROD,2);
                           IF V_BCICMSSTRETIDO <> 0 THEN
                              SELECT COUNT(*)
                                INTO V_EXISTDSDADOSADIC
                                FROM DADOSADIC
                               WHERE CDFILIAL = P_FILIAL
                                 AND NRLANCTONF = P_LANCTONF
                                 AND DSDADOADIC LIKE 'ICMS retido anteriormente por substituição tributária: BC %';
                              IF V_EXISTDSDADOSADIC = 0 THEN
                                 /*PREENCHE AS MENSAGENS ATRELADAS A INSCRICAO ESTADUAL*/
                                 INSERT INTO DADOSADIC(CDFILIAL, NRLANCTONF, NRDADOADIC, DSDADOADIC)
                                                VALUES(P_FILIAL, P_LANCTONF, V_DADOADIC, 'ICMS retido anteriormente por substituição tributária: BC '||DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(V_BCICMSSTRETIDO, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(V_BCICMSSTRETIDO, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(V_BCICMSSTRETIDO, 2), '9999999999999.99')))|| ' Valor '|| DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(V_VRICMSSTRETIDO, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(V_VRICMSSTRETIDO, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(V_VRICMSSTRETIDO, 2), '9999999999999.99'))));
                                 V_DADOADIC := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_DADOADIC) + 1)),3,0);
                              ELSE
                                 UPDATE DADOSADIC
                                    SET DSDADOADIC = 'ICMS retido anteriormente por substituição tributária: BC '||DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(V_BCICMSSTRETIDO, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(V_BCICMSSTRETIDO, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(V_BCICMSSTRETIDO, 2), '9999999999999.99')))|| ' Valor '|| DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(V_VRICMSSTRETIDO, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(V_VRICMSSTRETIDO, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(V_VRICMSSTRETIDO, 2), '9999999999999.99')))
                                  WHERE CDFILIAL = P_FILIAL
                                    AND NRLANCTONF = P_LANCTONF
                                    AND DSDADOADIC LIKE 'ICMS retido anteriormente por substituição tributária: BC %';
                              END IF;
                           END IF;
                        END IF;
                     END IF;
                  END IF;
               END IF;
               IF (V_SIMPLES = 'N') OR ((V_SIMPLES = 'S') AND (C_INCIDENCIA.CDIMPOSTONFE = '00') AND (V_RBA > (V_VRSUBLIMITESN * 1.2))) THEN
                  DELETE ALIQTEMP
                   WHERE NRALIQTEMP = V_ALIQTEMP;
                  V_CDSIMPLESNACIONAL := NULL;
                  V_CDFAIXA := NULL;
                  V_VRADICALIQFECP := NULL;
                  IF (V_UTIBB = 'N')  THEN
                     IF C_INCIDENCIA.IDUTMUNIORIG = w_D THEN
                        SELECT MAX(IDGRUPFISSRV)
                        INTO V_UTGRUPFISCS
                        FROM IMPOSTO
                        WHERE CDIMPOSTO   = C_INCIDENCIA.CDIMPOTEMP;
                        IF V_UTGRUPFISCS = 'S' THEN
                           V_CDGRPFISCSV := NULL;
                           SELECT MAX(CDGRUPOFISC)
                           INTO V_CDGRPFISCSV
                           FROM SERVCLIE SC, SERVICO S
                           WHERE SC.CDFILIAL   = V_CDFILIEMIT AND
                                 SC.CDCLIENTE  = P_CLIENTE    AND
                                 SC.CDFILIAL   = S.CDFILIAL   AND
                                 SC.CDSERVFILI = S.CDSERVFILI AND
                                 S.CDPRODUTO   = C_ITEMPRODUTO.CDPRODUTO;
                           IF V_CDGRPFISCSV IS NULL THEN
                              SELECT MAX(CDGRUPOFISC)
                              INTO V_CDGRPFISCSV
                              FROM CLIENFILIAL
                             WHERE CDFILIAL   = V_CDFILIEMIT AND
                                   CDCLIENTE  = P_CLIENTE ;
                           END IF;
                           CONSULTA_ALIQUOTA(C_INCIDENCIA.CDIMPOTEMP, w_S, P_EMPRESA, C_ITEMPRODUTO.CDARVPROD, P_INSCESTA, V_PAISORIG,
                                             V_ESTAORIG, V_PAISDEST, V_ESTADEST, V_MUNIDEST, V_LIQUIITEM, P_INIVALID, P_FILIAL, P_LANCTONF, V_CDGRPFISCSV,P_TIPOOPER,
                                             NULL, NULL, NULL, NULL, NULL, NULL, C_ITEMPRODUTO.IDORIGEMPROD);
                        ELSE
                            /* CONSIDERA O MUNICIPIO DE DESTINO */
                            CONSULTA_ALIQUOTA(C_INCIDENCIA.CDIMPOTEMP, w_S, P_EMPRESA, C_ITEMPRODUTO.CDARVPROD, P_INSCESTA, V_PAISORIG,
                                              V_ESTAORIG, V_PAISDEST, V_ESTADEST, V_MUNIDEST, V_LIQUIITEM, P_INIVALID, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC, P_TIPOOPER,
                                              NULL, NULL, NULL, NULL, NULL, NULL, C_ITEMPRODUTO.IDORIGEMPROD);
                        END IF;
                     ELSE
                       /* CONSIDERA O MUNICIPIO DE ORIGEM */
                        SELECT MAX(IDGRUPFISSRV)
                        INTO V_UTGRUPFISCS
                        FROM IMPOSTO
                        WHERE CDIMPOSTO   = C_INCIDENCIA.CDIMPOTEMP;
                        IF V_UTGRUPFISCS = 'S' THEN
                           V_CDGRPFISCSV := NULL;
                           SELECT MAX(CDGRUPOFISC)
                           INTO V_CDGRPFISCSV
                           FROM SERVCLIE SC, SERVICO S
                           WHERE SC.CDFILIAL   = V_CDFILIEMIT AND
                                 SC.CDCLIENTE  = P_CLIENTE    AND
                                 SC.CDFILIAL   = S.CDFILIAL   AND
                                 SC.CDSERVFILI = S.CDSERVFILI AND
                                 S.CDPRODUTO   = C_ITEMPRODUTO.CDPRODUTO;
                           IF V_CDGRPFISCSV IS NULL THEN
                              SELECT MAX(CDGRUPOFISC)
                              INTO V_CDGRPFISCSV
                              FROM CLIENFILIAL
                             WHERE CDFILIAL   = V_CDFILIEMIT AND
                                   CDCLIENTE  = P_CLIENTE ;
                           END IF;
                           CONSULTA_ALIQUOTA(C_INCIDENCIA.CDIMPOTEMP, w_S, P_EMPRESA, C_ITEMPRODUTO.CDARVPROD, P_INSCESTA, V_PAISORIG,
                                             V_ESTAORIG, V_PAISDEST, V_ESTADEST, V_MUNIORIG, V_LIQUIITEM, P_INIVALID, P_FILIAL, P_LANCTONF, V_CDGRPFISCSV, P_TIPOOPER,
                                             NULL, NULL, NULL, NULL, NULL, NULL, C_ITEMPRODUTO.IDORIGEMPROD);
                        ELSE
                            CONSULTA_ALIQUOTA(C_INCIDENCIA.CDIMPOTEMP, w_S, P_EMPRESA, C_ITEMPRODUTO.CDARVPROD, P_INSCESTA, V_PAISORIG,
                                              V_ESTAORIG, V_PAISDEST, V_ESTADEST, V_MUNIORIG, V_LIQUIITEM, P_INIVALID, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC, P_TIPOOPER,
                                              NULL, NULL, NULL, NULL, NULL, NULL, C_ITEMPRODUTO.IDORIGEMPROD);
                        END IF;
                     END IF;
                     V_NRALIQTEMP      := 0;
                     V_PARDEDTMP       := 0;
                     V_PREDBCTMP       := 0;
                     V_ALIQUTMP        := 0;
                     V_IMPOSTOIT       := 0;
                     V_VRADICALIQFECP  := NULL;
                     V_IDCONSMVAPMC    := '3';
                     V_IDCONSCOMPBCPMC := '3';
                     V_IDIMPODESONERA  := w_N;
                     V_IDCONSDESONVRNF := w_N;
                     SELECT NVL(MAX(NRALIQTEMP),0),      NVL(MAX(VRPARDEDTMP),0),     NVL(MAX(VRPREDBCTMP),0),        NVL(MAX(VRALIQUTMP),0),
                            NVL(MAX(IDTRIMPSTTMP), w_0), NVL(MAX(VRPBCSTTMP),0),      NVL(MAX(IDPMCBSCALTMP), w_S),   MAX(CDREGRATMP),
                            MAX(CDFISCOPER),             MAX(IDDIFEALIQ),             MAX(IDDIFALIQCUSPR),            MAX(VRADICALIQFECP),
                            MAX(CDBENEFFISCAL),          NVL(MAX(IDCONSMVAPMC), '3'), NVL(MAX(IDCONSCOMPBCPMC), '3'), NVL(MAX(IDCONSDIFALIQ), 'N'),
                            MAX(IDIMPODESONERA),         MAX(IDCONSDESONVRNF)
                     INTO   V_NRALIQTEMP,                V_PARDEDTMP,                 V_PREDBCTMP,                    V_ALIQUTMP,
                            V_TRATIMPST,                 V_PBCSUBTRIB,                V_IDPMCBASECAL,                 V_CDREGRAITALIQ,
                            V_CDFISCOPERREGRA,           V_IDDIFEALIQREGRA,           V_IDDIFALIQCUSPRREGRA,          V_VRADICALIQFECP,
                            V_CDBENEFFISCAL,             V_IDCONSMVAPMC,              V_IDCONSCOMPBCPMC,              V_IDCONSDIFALIQ,
                            V_IDIMPODESONERA,            V_IDCONSDESONVRNF
                     FROM ALIQTEMP
                     WHERE (NRALIQTEMP = V_ALIQTEMP);
                     V_ICMS := 'N';
                     FOR C_ICMS IN (SELECT CDIMPOSTO
                                      FROM IMPOSTONFE N, IMPOSTO I
                                     WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                                       AND N.CDIMPOSTONFE = '00'
                                       AND I.CDIMPOSTO = C_INCIDENCIA.CDIMPOTEMP)
                     LOOP
                        V_ICMS := 'S';
                     END LOOP;
                     IF V_ICMS = 'S' THEN
                        IF (V_CDFISCOPERREGRA IS NOT NULL) THEN
                           V_CDFISCOPERREGRA   := V_CFOP1DIGT||V_CDFISCOPERREGRA;
                           V_DSCDFISOPEITREGRA := SUBSTR(DESCRICAO_CFOP(V_CDFISCOPERREGRA),1,45);
                           IF V_CFOPINFUSU <> 'S' THEN
                              V_FISOPEITEM := V_CDFISCOPERREGRA;
                           END IF;
                        END IF;
                        IF V_CFOPINFUSU <> 'S' THEN
                           IF (V_DSCDFISOPEITREGRA IS NOT NULL) THEN
                              UPDATE NOTAFISCAL
                                 SET DSCDFISOPENF = V_DSCDFISOPEITREGRA
                               WHERE CDFILIAL   = P_FILIAL   AND
                                     NRLANCTONF = P_LANCTONF;
                           ELSE
                              UPDATE NOTAFISCAL
                                 SET DSCDFISOPENF = (SELECT MAX(DSCFOPTMP)
                                                       FROM CFOPTEMP
                                                      WHERE NRCFOPTEMP = V_CFOPTEMP)
                               WHERE CDFILIAL   = P_FILIAL
                                 AND NRLANCTONF = P_LANCTONF;
                           END IF;
                        END IF;
                        UPDATE ITEMPRODUTO
                           SET CDFISOPEITEM  = V_FISOPEITEM,
                               CDSUFXCFOPPR  = V_SUFXCFOPPR,
                               CDSITUTRIBPR  = V_SITUTRIBPR,
                               DSCDFISOPEIT  = V_DSCDFISOPEIT,
                               CDFISCOPERSN  = V_CDFISCOPERSN
                         WHERE CDFILIAL    = P_FILIAL AND
                               NRLANCTONF  = P_LANCTONF AND
                               NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD;
                     END IF;
                  END IF;
               END IF;
               V_CDIMPOSTRIB  := null;
               V_IDVRIMPSTRIB := null;
               /*IMPOSTO DE SUBSTITUICAO TRIBUTARIA*/
               FOR C_ICMSST IN (SELECT CDIMPOSTO
                                      FROM IMPOSTO
                                     WHERE CDIMPOSTRIB = C_INCIDENCIA.CDIMPOTEMP)
               LOOP
                  V_CDIMPOSTRIB := V_CDIMPOSTRIB||C_ICMSST.CDIMPOSTO||'_';
               END LOOP;
               -- UTILIZA O PRÓPRIO VALOR DO IMPOSTO NA SUA BASE DE CÁLCULO (IMPOSTO POR DENTRO)
               BEGIN
                  SELECT NVL(MAX(IDUTILPVRIMPBC), 'N')
                    INTO V_IDUTILPVRIMPBC
                    FROM IMPOSTO
                   WHERE CDIMPOSTO = C_INCIDENCIA.CDIMPOTEMP;
               EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                     V_IDUTILPVRIMPBC := 'N';
               END;
               V_TAXABASECALC := (100 - V_PREDBCTMP)/100;
               V_TAXAALIQUOTA := (V_ALIQUTMP/100);
               V_TAXABCSUBSTR := 1 + (V_PBCSUBTRIB/100);
               V_BASECALCIT   := V_LIQUIITEM * V_TAXABASECALC;
               -- EM MG O CÁLCULO DA BASE É REALIZADO DE UMA FORMA DIFERENTE DE ACORDO COM A 
               -- ORIENTAÇÃO TRIBUTÁRIA DOLT/SUTRI Nº 003/2016. PARA ESTE PROCESSO É NECESSÁRIO
               -- CALCULAR O IMPOSTO POR DENTRO (ELE COMPONDO A BASE DE CÁLCULO DELE MESMO)
               IF (V_IDCALCDIFALDENT = 'S') THEN
                  IF ((V_PAISDEST = '0055') AND (UPPER(V_ESTADEST) = 'MG')) AND ((V_PAISORIG = '0055') AND (UPPER(V_ESTAORIG) = 'MG')) THEN
                     IF (V_IDCONSFINAL = 'S') THEN
                        IF (V_VRADICALIQFECP IS NOT NULL) AND (V_VRADICALIQFECP > 0) THEN
                           IF (V_IDUTILPVRIMPBC = 'S') THEN
                              IF C_INCIDENCIA.CDIMPOSTONFE = '00' THEN
                                 V_BASECALCIT := V_BASECALCIT/((100-V_ALIQUTMP)/100);
                              END IF;
                           END IF;
                        END IF;
                    END IF;
                  ELSIF ((V_PAISORIG = '0055') AND (UPPER(V_ESTAORIG) = 'MG')) THEN
                     V_ALIQICMSDEST := 0;
                     V_ALIQFECPDEST := 0;
                     IF (V_IDINTEREST = 'S') AND (V_IDCONSFINAL = 'S') AND (V_IDCONTRIBICMSAUX = 'N') AND (V_IDPRESENCIAL <> '1') THEN
                        IF C_INCIDENCIA.CDIMPOSTONFE = '00' THEN
                           -- CONSULTANDO A ALÍQUOTA INTERNA DO IMPOSTO
                           DELETE 
                             FROM ALIQTEMP
                            WHERE NRALIQTEMP = V_ALIQTEMP;
                           IF C_INCIDENCIA.IDUTMUNIORIG = w_D THEN
                              CONSULTA_ALIQUOTA(C_INCIDENCIA.CDIMPOTEMP, w_S, P_EMPRESA, C_ITEMPRODUTO.CDARVPROD, P_INSCESTA, V_PAISDEST,
                                                V_ESTADEST, V_PAISDEST, V_ESTADEST, V_MUNIDEST, V_LIQUIITEM, P_INIVALID, P_FILIAL, P_LANCTONF, V_CDGRPFISCSV, P_TIPOOPER,
                                                NULL, NULL, NULL, NULL, NULL, NULL, C_ITEMPRODUTO.IDORIGEMPROD);
                           ELSE
                              CONSULTA_ALIQUOTA(C_INCIDENCIA.CDIMPOTEMP, w_S, P_EMPRESA, C_ITEMPRODUTO.CDARVPROD, P_INSCESTA, V_PAISDEST,
                                                V_ESTADEST, V_PAISDEST, V_ESTADEST, V_MUNIORIG, V_LIQUIITEM, P_INIVALID, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC, P_TIPOOPER,
                                                NULL, NULL, NULL, NULL, NULL, NULL, C_ITEMPRODUTO.IDORIGEMPROD);
                           END IF;
                           BEGIN
                              SELECT MAX(VRALIQUTMP)
                                INTO V_ALIQICMSDEST
                                FROM ALIQTEMP
                               WHERE NRALIQTEMP = V_ALIQTEMP;
                           EXCEPTION
                              WHEN NO_DATA_FOUND THEN
                                 V_ALIQICMSDEST := NULL;
                           END;
                           IF V_ALIQICMSDEST IS NULL THEN
                              BEGIN
                                 SELECT NVL(CONSULTA_QUADRO_ALIQUOTAS(V_ESTADEST, V_ESTADEST), 0)
                                   INTO V_ALIQICMSDEST
                                   FROM DUAL;
                              EXCEPTION
                                 WHEN NO_DATA_FOUND THEN
                                    V_ALIQICMSDEST := 0;
                              END;
                           END IF;
                            -- CONSULTANDO A ALÍQUOTA DO FCP (FUNDO DE COMBATE A POBREZA)
                           BEGIN
                              SELECT CDIMPOSTO
                                INTO V_CDIMPOSTOFECP
                                FROM IMPOSTO
                               WHERE CDIMPOSTONFE = '01';
                           EXCEPTION
                              WHEN NO_DATA_FOUND THEN
                                 V_CDIMPOSTOFECP := NULL;
                           END;
                           IF V_CDIMPOSTOFECP IS NOT NULL THEN
                              DELETE
                                FROM ALIQTEMP
                               WHERE NRALIQTEMP = V_ALIQTEMP;
                              --VERIFICANDO SE EXISTE A INCIDÊNCIA DE FECP PARA O PRODUTO
                              IF C_INCIDENCIA.IDUTMUNIORIG = w_D THEN
                                 CONSULTA_ALIQUOTA(V_CDIMPOSTOFECP, w_S, P_EMPRESA, C_ITEMPRODUTO.CDARVPROD, P_INSCESTA, V_PAISDEST,
                                                   V_ESTADEST, V_PAISDEST, V_ESTADEST, V_MUNIDEST, V_LIQUIITEM, P_INIVALID, P_FILIAL, P_LANCTONF, V_CDGRPFISCSV, P_TIPOOPER,
                                                   NULL, NULL, NULL, NULL, NULL, NULL, C_ITEMPRODUTO.IDORIGEMPROD);
                              ELSE
                                 CONSULTA_ALIQUOTA(V_CDIMPOSTOFECP, w_S, P_EMPRESA, C_ITEMPRODUTO.CDARVPROD, P_INSCESTA, V_PAISDEST,
                                                   V_ESTADEST, V_PAISDEST, V_ESTADEST, V_MUNIORIG, V_LIQUIITEM, P_INIVALID, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC, P_TIPOOPER,
                                                   NULL, NULL, NULL, NULL, NULL, NULL, C_ITEMPRODUTO.IDORIGEMPROD);
                              END IF;
                              BEGIN
                                 SELECT NVL(MAX(VRALIQUTMP), 0)
                                   INTO V_ALIQFECPDEST
                                   FROM ALIQTEMP
                                  WHERE NRALIQTEMP = V_ALIQTEMP;
                              EXCEPTION
                                 WHEN NO_DATA_FOUND THEN
                                    V_ALIQFECPDEST := 0;
                              END;
                           ELSE
                              V_ALIQFECPDEST := 0;
                           END IF;                        
                           -- REALIZANDO O CÁLCULO DA BASE COM O IMPOSTO POR DENTRO
                           -- BASE DE CÁLCULO REAL = BASE DE CÁLCULO / (1 - ((ALIQUOTA DO IMPOSTO + ALIQUOTA DO FCP) / 100)
                           V_BASECALCIT := V_BASECALCIT/((100-(V_ALIQICMSDEST+V_ALIQFECPDEST))/100);
                        END IF;
                     END IF;
                  END IF;
               END IF;
               IF V_CDIMPOSTRIB IS NULL THEN
                  V_IDTRIMPSTII := '';
                  V_PERDBCALC := 100 - V_PREDBCTMP;
                  IF V_PBCSUBTRIB > 0 THEN
                     V_BASECALCIT := (V_BASECALCIT * V_TAXABCSUBSTR);
                     V_PREDBCTMP  := V_PBCSUBTRIB;
                     V_PERDBCALC  := 0;
                  END IF;
                  IF (C_INCIDENCIA.IDUTVLRQTDEIMPO = 'S') THEN
                     SELECT NVL(MAX(VRFATOCONVES), 1)
                       INTO V_VRFATOCONVES
                       FROM CONVPRODUTO
                      WHERE CDPRODUTO = C_ITEMPRODUTO.CDPRODUTO;
                     V_BASECALCTO  := (C_ITEMPRODUTO.QTITEMPROD * V_VRFATOCONVES);
                     V_IMPOSTOIT   := ((C_ITEMPRODUTO.QTITEMPROD * V_VRFATOCONVES) * V_ALIQUTMP) - V_PARDEDTMP;
                  ELSE
                     V_BASECALCTO  := V_BASECALCIT;
                     V_IMPOSTOIT   := (V_BASECALCIT * V_TAXAALIQUOTA) - V_PARDEDTMP;
                  END IF;
               ELSE
                  IF SUBSTR(V_SITUTRIBPR, 2, 2) = '60' THEN
                     V_IDTRIMPSTII := w_2;
                  ELSE 
                     V_IDTRIMPSTII := V_TRATIMPST;
                  END IF;
                  IF NVL(V_IDPMCBASECAL, W_N) = W_S THEN
                     CALCULA_BC_PMC(P_FILIAL,
                                    P_LANCTONF,
                                    C_ITEMPRODUTO.NRSEQITPROD,
                                    C_INCIDENCIA.CDIMPOTEMP,
                                    V_IDCONSMVAPMC,
                                    V_IDCONSCOMPBCPMC,
                                    V_PAISDEST,
                                    V_ESTADEST,
                                    C_ITEMPRODUTO.CDPRODUTO,
                                    C_ITEMPRODUTO.QTITEMPROD,
                                    C_ITEMPRODUTO.VRUNITITEM,
                                    C_ITEMPRODUTO.VRDESCITEM,
                                    V_PBCSUBTRIB,
                                    V_PREDBCTMP,
                                    NULL,
                                    NULL,
                                    NULL,
                                    NULL,
                                    NULL,
                                    NULL,
                                    'N',
                                    V_BASECALCTO);
                     V_IMPOSTOIT := (V_BASECALCTO * V_TAXAALIQUOTA) - V_PARDEDTMP;
                  ELSIF (V_IDCONSDIFALIQ = 'S') AND (C_INCIDENCIA.CDIMPOSTONFE = '80') THEN
                     CONSIDERA_DIFAL_ICMS(P_FILIAL,
                                          P_LANCTONF,
                                          C_ITEMPRODUTO.NRSEQITPROD,
                                          V_CDGRPFISCSV,
                                          V_PAISDEST,
                                          V_ESTADEST,
                                          V_MUNIDEST,
                                          V_PBCSUBTRIB,
                                          V_PREDBCTMP,
                                          V_BASECALCTO,
                                          V_IMPOSTOIT,
                                          V_VRADICFECP);
                  ELSE
                     UPDATE ITEMPRODUTO
                        SET IDUTILBCPMC = 'N'
                      WHERE CDFILIAL = P_FILIAL
                        AND NRLANCTONF = P_LANCTONF
                        AND NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD;
                     V_PERDBCALC := 100 - V_PREDBCTMP;
                     IF V_PBCSUBTRIB > 0 THEN
                        V_BASECALCIT := (V_BASECALCIT * V_TAXABCSUBSTR);
                        V_PREDBCTMP  := V_PBCSUBTRIB;
                        V_PERDBCALC  := 0;
                     END IF;
                     V_BASECALCTO  := V_BASECALCIT;
                     V_IMPOSTOIT   := (V_BASECALCIT * V_TAXAALIQUOTA) - V_PARDEDTMP;
                  END IF;
               END IF; 
               V_CONTABCALC  := V_LIQUIITEM - (V_LIQUIITEM * V_TAXABASECALC);
               IF (V_IMPOSTOIT < 0) THEN
                  V_IMPOSTOIT := 0;
               END IF;
               IF (V_IDCONSDIFALIQ = 'N') THEN
                  V_VRADICFECPST := 0;
                  V_VRADICFECPSTAUX := 0;
                  IF (V_VRADICALIQFECP IS NOT NULL) AND (V_VRADICALIQFECP > 0) THEN
                     V_VRADICFECP := ROUND(V_BASECALCTO*(V_VRADICALIQFECP/100), 2);
                  END IF;
                  IF (V_CDIMPOSTRIB IS NOT NULL) THEN
                     V_VRIMPOSST   := 0;
                     V_VRIMPOSTOST := 0;
                     FOR C_SUBSTRIB IN (SELECT NVL(IDVRIMPSTRIB, 'N') IDVRIMPSTRIB, I.CDIMPOSTO
                                          FROM ITEMPROIMPOS I, IMPOSTO II
                                         WHERE (CDFILIAL     = P_FILIAL)
                                           AND (NRLANCTONF   = P_LANCTONF)
                                           AND (NRSEQITPROD  = C_ITEMPRODUTO.NRSEQITPROD)
                                           AND (NRITPROIMPOS = '1')
                                           AND (INSTR(V_CDIMPOSTRIB,II.CDIMPOSTO||'_') > 0)
                                           AND (I.CDIMPOSTO = II.CDIMPOSTO))
                     LOOP
                        IF (C_SUBSTRIB.IDVRIMPSTRIB = w_S) THEN
                           Begin
                              SELECT NVL(ROUND(MAX(VRIMPOSTOIT), 2),0),
                                     NVL(ROUND(MAX(VRADICFECP), 2),0)
                              INTO   V_VRIMPOSST,
                                     V_VRADICFECPSTAUX
                              FROM ITEMPROIMPOS I
                              WHERE (CDFILIAL     = P_FILIAL)                   AND
                                    (NRLANCTONF   = P_LANCTONF)                 AND
                                    (NRSEQITPROD  = C_ITEMPRODUTO.NRSEQITPROD)  AND
                                    (CDIMPOSTO    = C_SUBSTRIB.CDIMPOSTO)       AND
                                    (INSTR(V_CDIMPOSTRIB,CDIMPOSTO||'_') > 0)   AND
                                    (NRITPROIMPOS = w_1);
                           Exception
                              When No_Data_Found Then
                                 V_VRIMPOSST := 0;
                                 V_VRADICFECPSTAUX := 0;
                           End;
                        ELSE
                           V_VRIMPOSST := 0;
                           V_VRADICFECPSTAUX := 0;
                        END IF;
                        V_VRIMPOSTOST := V_VRIMPOSTOST + V_VRIMPOSST;
                        V_VRADICFECPST := V_VRADICFECPST + V_VRADICFECPSTAUX;
                     END LOOP;
                     V_IMPOSTOIT := V_IMPOSTOIT - V_VRIMPOSTOST;
                     IF V_IMPOSTOIT < 0 THEN
                        V_IMPOSTOIT := 0;
                     END IF;
                  END IF;
                  IF (V_VRADICALIQFECP IS NOT NULL) AND (V_VRADICALIQFECP > 0) THEN
                     V_VRADICFECP := V_VRADICFECP - V_VRADICFECPST;
                  END IF;
               END IF;
               /* Rotina para calcular o ICMS ST considerando % carga tributária média */
               V_IDIMPSTCARGTRIB := 'N';
               IF V_CDIMPOSTRIB IS NOT NULL THEN
                  BEGIN
                     SELECT NVL(VRCNAEBC, 0),
                            NVL(VRMVA, 0)
                       INTO V_VRPRODUTOBC,
                            V_VRMVA
                       FROM VRPERCCARGTRIBCNAE
                      WHERE IDENTRSAIDOP = w_S
                        AND CDTIPOOPER   = P_TIPOOPER
                        AND CDPAIS       = V_PAISDEST
                        AND SGESTADO     = V_ESTADEST
                        AND CDCNAE       = V_CDCNAECLIE
                        AND IDOPTANTESN  = V_IDOPTANTESNCLIE;
                  EXCEPTION
                     WHEN NO_DATA_FOUND THEN
                        V_VRPRODUTOBC := 0;
                        V_VRMVA := 0;
                  END;
                  IF V_VRPRODUTOBC = 0 THEN
                     BEGIN
                        SELECT NVL(VRPRODUTOBC, 0)
                          INTO V_VRPRODUTOBC
                          FROM VRPERCCARGTRIB
                         WHERE IDENTRSAIDOP = w_S
                           AND CDTIPOOPER   = P_TIPOOPER
                           AND CDPAIS       = V_PAISDEST
                           AND SGESTADO     = V_ESTADEST
                           AND CDPRODUTO    = C_ITEMPRODUTO.CDPRODUTO;
                     EXCEPTION
                        WHEN NO_DATA_FOUND THEN
                           V_VRPRODUTOBC := 0;
                     END;
                  END IF;
                  IF (V_VRPRODUTOBC > 0) THEN
                     BEGIN
                        SELECT I.CDIMPOSTO, I.VRIMPOSTOIT
                          INTO V_CDIMPOSTOICMS, V_VRIMPOSTOICMS
                          FROM IMPOSTONFE N, IMPOSTO P, ITEMPROIMPOS I
                         WHERE N.CDIMPOSTONFE = P.CDIMPOSTONFE
                           AND N.CDIMPOSTONFE = '00'
                           AND I.CDFILIAL     = P_FILIAL
                           AND I.NRLANCTONF   = P_LANCTONF
                           AND I.NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD
                           AND I.CDIMPOSTO = NVL(P.CDIMPOSREGNORMA, P.CDIMPOSTO)
                           AND NOT P.CDIMPOSTRIB IS NULL
                           AND I.NRITPROIMPOS = '1';
                     EXCEPTION
                        When No_Data_Found Then
                           V_CDIMPOSTOICMS := NULL; V_VRIMPOSTOICMS := 0;
                     END;
                     DELETE ALIQTEMP
                      WHERE NRALIQTEMP = V_ALIQTEMP;
                     /* Verifica grupo fiscal */
                     SELECT MAX(IDGRUPFISSRV)
                     INTO V_UTGRUPFISCS
                     FROM IMPOSTO
                     WHERE CDIMPOSTO = V_CDIMPOSTOICMS;
                     IF V_UTGRUPFISCS = 'S' THEN
                        V_CDGRPFISCSV := NULL;
                        SELECT MAX(CDGRUPOFISC)
                        INTO V_CDGRPFISCSV
                        FROM SERVCLIE SC, SERVICO S
                        WHERE SC.CDFILIAL   = V_CDFILIEMIT AND
                              SC.CDCLIENTE  = P_CLIENTE    AND
                              SC.CDFILIAL   = S.CDFILIAL   AND
                              SC.CDSERVFILI = S.CDSERVFILI AND
                              S.CDPRODUTO   = C_ITEMPRODUTO.CDPRODUTO;
                        IF V_CDGRPFISCSV IS NULL THEN
                           SELECT MAX(CDGRUPOFISC)
                           INTO V_CDGRPFISCSV
                           FROM CLIENFILIAL
                          WHERE CDFILIAL   = V_CDFILIEMIT AND
                                CDCLIENTE  = P_CLIENTE;
                        END IF;
                        CONSULTA_ALIQUOTA(V_CDIMPOSTOICMS, w_S, P_EMPRESA, C_ITEMPRODUTO.CDARVPROD, P_INSCESTA, V_PAISDEST,
                                          V_ESTADEST, V_PAISDEST, V_ESTADEST, V_MUNIDEST, V_LIQUIITEM, P_INIVALID, P_FILIAL, P_LANCTONF, V_CDGRPFISCSV, P_TIPOOPER,
                                          NULL, NULL, NULL, NULL, NULL, NULL, C_ITEMPRODUTO.IDORIGEMPROD);
                     ELSE
                        CONSULTA_ALIQUOTA(V_CDIMPOSTOICMS, w_S, P_EMPRESA, C_ITEMPRODUTO.CDARVPROD, P_INSCESTA, V_PAISDEST,
                                          V_ESTADEST, V_PAISDEST, V_ESTADEST, V_MUNIDEST, V_LIQUIITEM, P_INIVALID, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC, P_TIPOOPER,
                                          NULL, NULL, NULL, NULL, NULL, NULL, C_ITEMPRODUTO.IDORIGEMPROD);
                     END IF;
                     SELECT NVL(MAX(VRALIQUTMP),0)
                       INTO V_VRALIQUTMPDEST
                       FROM ALIQTEMP
                      WHERE (NRALIQTEMP = V_ALIQTEMP);
                     IF (V_VRALIQUTMPDEST <> 0) THEN
                        V_IMPOSTOIT  :=  ROUND(V_BASECALCIT * (V_VRPRODUTOBC/100), 2);
                        V_BASECALCTO :=  ROUND(((V_VRIMPOSTOICMS + V_IMPOSTOIT) / (V_VRALIQUTMPDEST/100)),5);  
                        V_IDIMPSTCARGTRIB := 'S';
                     END IF;
                     DELETE ALIQTEMP
                      WHERE NRALIQTEMP = V_ALIQTEMP;
                  END IF;
               END IF;
               /* ROTINA PARA CALCULAR O DIFERIMENTO DO IMPOSTO */
               V_PERDIFERE    := NULL;
               V_IMPOSTOOPERA := NULL;
               V_IMPOSTODIFER := NULL;
               IF C_INCIDENCIA.CDIMPOSTONFE = '00' THEN
                  IF V_CDSITTRIBTMP = 51 THEN
                     BEGIN
                        SELECT PD.VRPERDIFERE, 'S' 
                          INTO V_VRPERDIFERE, V_IDDIFECLI
                          FROM PRODDIFEREIMPCLI PD, PRODUTO PR
                         WHERE PD.CDPRODUTO = PR.CDPRODUTO
                           AND PD.CDPAIS = V_PAISORIG
                           AND PD.SGESTADO = V_ESTAORIG
                           AND PD.CDCLIENTE = P_CLIENTE
                           AND PR.CDARVPROD IN (SELECT MAX(PR.CDARVPROD) AS CDARVPROD
                                                  FROM PRODDIFEREIMPCLI PD, PRODUTO PR
                                                 WHERE PD.CDPRODUTO = PR.CDPRODUTO
                                                   AND PD.CDPAIS = V_PAISORIG
                                                   AND PD.SGESTADO = V_ESTAORIG
                                                   AND PD.CDCLIENTE = P_CLIENTE
                                                   AND INSTR(NVL(RTRIM(C_ITEMPRODUTO.CDARVPROD), PR.CDARVPROD), PR.CDARVPROD) = 1);
                     EXCEPTION
                        WHEN NO_DATA_FOUND THEN
                           V_VRPERDIFERE := NULL; V_IDDIFECLI := 'N';
                     END;
                     IF V_IDDIFECLI = 'N' THEN
                        BEGIN
                           SELECT PD.VRPERDIFERE
                             INTO V_VRPERDIFERE
                             FROM PRODDIFEREIMPOS PD, PRODUTO PR
                            WHERE PD.CDPRODUTO = PR.CDPRODUTO
                              AND PD.CDPAIS = V_PAISORIG
                              AND PD.SGESTADO = V_ESTAORIG
                              AND PR.CDARVPROD IN (SELECT MAX(PR.CDARVPROD) AS CDARVPROD
                                                     FROM PRODDIFEREIMPOS PD, PRODUTO PR
                                                    WHERE PD.CDPRODUTO = PR.CDPRODUTO
                                                      AND PD.CDPAIS = V_PAISORIG
                                                      AND PD.SGESTADO = V_ESTAORIG
                                                      AND INSTR(NVL(RTRIM(C_ITEMPRODUTO.CDARVPROD), PR.CDARVPROD), PR.CDARVPROD) = 1);
                        EXCEPTION
                           WHEN NO_DATA_FOUND THEN
                              V_VRPERDIFERE := NULL;
                        END;
                     END IF;
                     IF V_VRPERDIFERE IS NOT NULL THEN
                        V_PERDIFERE    := ROUND(V_VRPERDIFERE, 2);
                        V_IMPOSTOOPERA := ROUND(V_IMPOSTOIT, 2);
                        /* 
                           Foi comentado este cálculo pois ao implementá-lo de acordo com a resolução nº13 de 14 de fevereiro de 2019
                           a sefaz passou a rejeitar as notas com a rejeição 352 (Rejeicao: Valor do ICMS Diferido no CST=51 difere do 
                           produto Valor ICMS Operacao e percentual diferimento)
                        */
                        --IF (V_CDPAISEMIT = 0055) AND (V_SGESTADOEMIT = RJ) THEN
                        --   V_IMPOSTODIFER := ROUND((((V_BASECALCTO / (1 - V_TAXAALIQUOTA)) * V_TAXAALIQUOTA) * (V_VRPERDIFERE/100)), 2);
                        --ELSE
                           V_IMPOSTODIFER := ROUND((V_IMPOSTOOPERA * (V_VRPERDIFERE/100)), 2);
                        --END IF;
                        V_IMPOSTOIT := ROUND(V_IMPOSTOOPERA, 2) - ROUND(V_IMPOSTODIFER, 2);
                     END IF;
                  END IF;
               END IF;
               V_BASECALCIRRF := V_BASECALCTO;
               IF (V_ALIQUTMP = 0) AND (V_IMPOSTOIT = 0) THEN
                  V_BASECALCTO := 0;
               END IF;
               SELECT NVL(MAX(IDPERVISIMPSCRE),'S')
                 INTO V_IDPERVISIMPSCRE
                 FROM PARAMGERAL;
               IF V_IDPERVISIMPSCRE = 'S' THEN
                  V_VRIMPOSTOVISUIT := V_IMPOSTOIT;
               ELSE
                  IF (C_INCIDENCIA.CDFISCTEMP = '1') THEN
                     V_VRIMPOSTOVISUIT := V_IMPOSTOIT;
                  ELSE
                     V_VRIMPOSTOVISUIT := 0;
                  END IF;
               END IF;
               V_ICMS := 'N';
               FOR C_ICMS IN (SELECT CDIMPOSTO
                                FROM IMPOSTONFE N, IMPOSTO I
                               WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                                 AND N.CDIMPOSTONFE = '00'
                                 AND I.CDIMPOSTO = C_INCIDENCIA.CDIMPOTEMP)
               LOOP
                  V_ICMS := 'S';
               END LOOP;
               Begin
                  SELECT CDFILIAL
                  INTO   V_CHAVE
                  FROM ITEMPROIMPOS
                  WHERE CDFILIAL     = P_FILIAL                 AND
                        NRLANCTONF   = P_LANCTONF               AND
                        NRSEQITPROD  = C_ITEMPRODUTO.NRSEQITPROD  AND
                        CDIMPOSTO    = C_INCIDENCIA.CDIMPOTEMP AND
                        NRITPROIMPOS = w_1;
               Exception
                  When No_Data_Found Then
                     V_CHAVE := Null;
               End;
               IF V_CHAVE IS NULL THEN
                  IF (V_ICMS = 'S') THEN
                     IF C_ITEMPRODUTO.CDCFOPINFUSU IS NULL THEN
                        V_CDGRUPOFISCAUX := NULL;
                        SELECT MAX(G.CDGRUPOFISC)
                          INTO V_CDGRUPOFISCAUX
                          FROM GRUPOFISCIMPFIL G,
                               (SELECT CDFILIEMIT AS CDFILIAL
                                  FROM NOTAFISCAL
                                 WHERE CDFILIAL = P_FILIAL
                                       AND NRLANCTONF = P_LANCTONF) F
                         WHERE G.CDFILIAL = F.CDFILIAL
                           AND NOT G.CDGRUPOFISC IS NULL
                           AND G.CDIMPOSTO = C_INCIDENCIA.CDIMPOTEMP;
                        IF V_IDORIGDESTNF = 'C' THEN
                           SELECT NVL(MAX(G.CDGRUPOFISC), V_CDGRUPOFISCAUX)
                             INTO V_CDGRUPOFISCAUX
                             FROM GRFISIMPIECLIE G,
                                  (SELECT CDCLIENTE
                                     FROM NOTAFISCAL
                                    WHERE CDFILIAL = P_FILIAL
                                      AND NRLANCTONF = P_LANCTONF) N
                            WHERE G.CDCLIENTE = N.CDCLIENTE
                              AND G.CDEMPRESA = P_EMPRESA
                              AND G.CDINSCESTA = P_INSCESTA
                              AND NOT G.CDGRUPOFISC IS NULL
                              AND G.CDIMPOSTO = C_INCIDENCIA.CDIMPOTEMP;
                        ELSE
                           SELECT NVL(MAX(G.CDGRUPOFISC), V_CDGRUPOFISCAUX)
                             INTO V_CDGRUPOFISCAUX
                             FROM GRFISIMPIEFORN G,
                                 (SELECT CDFORNECED
                                    FROM NOTAFISCAL
                                   WHERE CDFILIAL = P_FILIAL
                                     AND NRLANCTONF = P_LANCTONF) N
                            WHERE G.CDFORNECED = N.CDFORNECED
                              AND G.CDEMPRESA = P_EMPRESA
                              AND G.CDINSCESTA = P_INSCESTA
                              AND NOT G.CDGRUPOFISC IS NULL
                              AND G.CDIMPOSTO = C_INCIDENCIA.CDIMPOTEMP;
                        END IF;
                        IF (V_CDGRUPOFISCAUX IS NOT NULL) THEN
                           CONSULTA_CFOP(w_S, P_EMPRESA, C_ITEMPRODUTO.CDARVPROD, P_INSCESTA, P_TIPOOPER, V_PAISORIG,
                                         V_ESTAORIG, V_PAISCFOP, V_ESTACFOP, P_FILIAL, P_LANCTONF, V_CDGRUPOFISCAUX, P_INIVALID, C_ITEMPRODUTO.IDORIGEMPROD);
                        ELSE
                           CONSULTA_CFOP(w_S, P_EMPRESA, C_ITEMPRODUTO.CDARVPROD, P_INSCESTA, P_TIPOOPER, V_PAISORIG,
                                         V_ESTAORIG, V_PAISCFOP, V_ESTACFOP, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC, P_INIVALID, C_ITEMPRODUTO.IDORIGEMPROD);
                        END IF;
                        IF (V_CDFISCOPERREGRA IS NOT NULL) THEN
                           IF (LENGTH(V_CDFISCOPERREGRA) < 4) THEN
                              V_CDFISCOPERREGRA := V_CFOP1DIGT||V_CDFISCOPERREGRA;
                           END IF;
                           V_DSCDFISOPEITREGRA := SUBSTR(DESCRICAO_CFOP(V_CDFISCOPERREGRA),1,45);
                        END IF;
                        IF (V_DSCDFISOPEITREGRA IS NOT NULL) THEN
                           UPDATE NOTAFISCAL
                              SET DSCDFISOPENF = V_DSCDFISOPEITREGRA
                            WHERE CDFILIAL   = P_FILIAL   AND
                                  NRLANCTONF = P_LANCTONF;
                        ELSE
                           UPDATE NOTAFISCAL
                              SET DSCDFISOPENF = (SELECT MAX(DSCFOPTMP)
                                                    FROM CFOPTEMP
                                                   WHERE NRCFOPTEMP = V_CFOPTEMP)
                            WHERE CDFILIAL   = P_FILIAL
                              AND NRLANCTONF = P_LANCTONF;
                        END IF;
                        SELECT MAX(CDFISOPETMP), MAX(CDSUFCFOPTMP), SUBSTR(MAX(DSCFOPTMP),1,50)
                          INTO V_FISOPEITEM    , V_SUFXCFOPPR, V_DSCDFISOPEIT
                          FROM CFOPTEMP
                         WHERE NRCFOPTEMP = V_CFOPTEMP;
                        UPDATE ITEMPRODUTO
                           SET CDFISOPEITEM  = NVL(V_CDFISCOPERREGRA, V_FISOPEITEM),
                               CDSUFXCFOPPR  = V_SUFXCFOPPR,
                               DSCDFISOPEIT  = NVL(V_DSCDFISOPEITREGRA, V_DSCDFISOPEIT)
                         WHERE CDFILIAL    = P_FILIAL AND
                               NRLANCTONF  = P_LANCTONF AND
                               NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD;
                        DELETE CFOPTEMP
                         WHERE NRCFOPTEMP = V_CFOPTEMP;
                     END IF;
                     Begin
                        SELECT MAX(CDCSTDIG1PROD)
                          INTO V_CST1DIGT
                          FROM PRODUTO
                         WHERE (CDARVPROD = C_ITEMPRODUTO.CDARVPROD);
                        IF V_CST1DIGT IS NULL THEN
                           SELECT MAX(CDCSTDIG1SAI)
                             INTO   V_CST1DIGT
                             FROM INSCRESTAD
                            WHERE (CDEMPRESA  = P_EMPRESA) AND
                                  (CDINSCESTA = P_INSCESTA);
                        END IF;
                     Exception
                        When No_Data_Found Then
                           V_CST1DIGT := Null;
                     End;
                     IF (V_IDUTORIGPROD = 'S') AND (C_ITEMPRODUTO.IDORIGEMPROD = 'E') THEN
                        V_CST1DIGT := '2';
                     END IF;
                     UPDATE ITEMPRODUTO
                        SET CDSITUTRIBPR  = V_CST1DIGT||NVL(V_CDSITTRIBTMP, SUBSTR(V_SITUTRIBPR, 2,2))
                      WHERE CDFILIAL    = P_FILIAL AND
                            NRLANCTONF  = P_LANCTONF AND
                            NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD;
                     V_SITUTRIBPR := V_CST1DIGT||NVL(V_CDSITTRIBTMP, SUBSTR(V_SITUTRIBPR, 2,2));
                  END IF;
                  IF (NVL(V_CFOPINFUSU, 'N') <> 'S') AND (V_CDFISCOPERREGRA IS NOT NULL) THEN
                     V_FISOPEITEM := NVL(V_CDFISCOPERREGRA, V_FISOPEITEM);
                     V_DSCDFISOPEITREGRA := SUBSTR(DESCRICAO_CFOP(V_CDFISCOPERREGRA),1,45);
                  END IF;
                  /*IF (V_VRADICALIQFECP IS NOT NULL) AND (V_VRADICALIQFECP > 0) THEN
                     V_VRADICFECP := ROUND(V_BASECALCTO*(V_VRADICALIQFECP/100), 2);
                  END IF;*/
                  INSERT INTO ITEMPROIMPOS(
                     CDFILIAL, NRLANCTONF, NRSEQITPROD, CDIMPOSTO, NRITPROIMPOS, CDFISCALIT,
                     CDSITUTRIBIT, CDFISCOPERIT, CDSUFXCFOPIT, VRALIQITEM, VRPERREDBCIT, VRPARDEDIT,
                     VRCONTITIMP, VRBASECALCIT, VRIMPOSTOIT, IDERROSIMPIT, IDAVISIMPIT, IDTRIMPSTII,
                     CDSITUTRIBITNFE, IDMODBCITNFE, IDMODBCSTITNFE, CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT,
                     CDSIMPLESNACIONAL, CDFAIXA, VRBCICMSSTRETIDO, VRICMSSTRETIDO, CDREGRAIT, CDDETALHEPROD,
                     VRIMPOSTOVISUIT, VRBCALCIRRF, VRPERDIFEREIT, VRIMPOSTOOPERAIT, VRIMPOSTODIFERIT,
                     CDENQLEGALIPI, CDCEST, IDIMPSTCARGTRIB, VRADICALIQFECP, VRADICFECP,
                     VRALIQINTEDEST, VRALIQFCP, CDBENEFFISCAL, IDCONSDIFALIQ, IDDESONERAREGRA, IDCONSDESONVRNF)
                  VALUES(
                     P_FILIAL, P_LANCTONF, C_ITEMPRODUTO.NRSEQITPROD, C_INCIDENCIA.CDIMPOTEMP, w_1, C_INCIDENCIA.CDFISCTEMP,
                     V_SITUTRIBPR, V_FISOPEITEM, V_SUFXCFOPPR, V_ALIQUTMP, V_PREDBCTMP, V_PARDEDTMP,
                     ROUND(V_BASECALCTO,5), ROUND(V_BASECALCTO,2), V_IMPOSTOIT, w_00000, w_00000, V_IDTRIMPSTII,   
                     V_CDSITTRIBTMP, V_IDMODBCNFE, V_IDMODBCSTNFE, V_CDTPCRPICOSTNFE, V_CDNATUBCPCSTNFE, V_IDMOTIDESSTNFE,
                     V_CDSIMPLESNACIONAL, V_CDFAIXA, V_BCICMSSTRETIDO, V_VRICMSSTRETIDO, V_CDREGRAITALIQ, C_INCIDENCIA.CDDETALHEPROD,
                     V_VRIMPOSTOVISUIT, V_BASECALCIRRF, V_PERDIFERE, V_IMPOSTOOPERA, V_IMPOSTODIFER,
                     C_INCIDENCIA.CDENQLEGALIPI, C_INCIDENCIA.CDCEST, V_IDIMPSTCARGTRIB, V_VRADICALIQFECP, V_VRADICFECP, 
                     V_ALIQICMSDEST, V_ALIQFECPDEST, V_CDBENEFFISCAL, NVL(V_IDCONSDIFALIQ, 'N'), V_IDIMPODESONERA, V_IDCONSDESONVRNF);
                  IF (V_PREDBCTMP > 0) AND (V_PBCSUBTRIB = 0) THEN
                     IF V_SITUTRIBPR = '060' THEN
                        INSERT INTO ITEMPROIMPOS(
                           CDFILIAL, NRLANCTONF, NRSEQITPROD, CDIMPOSTO, NRITPROIMPOS, CDFISCALIT,
                           CDSITUTRIBIT, CDFISCOPERIT, CDSUFXCFOPIT, VRALIQITEM, VRPERREDBCIT, VRPARDEDIT,
                           VRCONTITIMP, VRBASECALCIT, VRIMPOSTOIT, IDERROSIMPIT, IDAVISIMPIT, CDSITUTRIBITNFE,
                           IDMODBCITNFE, IDMODBCSTITNFE, CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT, CDSIMPLESNACIONAL,
                           CDFAIXA, VRBCICMSSTRETIDO, VRICMSSTRETIDO, CDREGRAIT, CDDETALHEPROD,
                           VRIMPOSTOVISUIT, CDENQLEGALIPI, CDCEST, IDIMPSTCARGTRIB)
                        VALUES(
                           P_FILIAL, P_LANCTONF, C_ITEMPRODUTO.NRSEQITPROD, C_INCIDENCIA.CDIMPOTEMP, w_2, w_2,
                           V_SITUTRIBPR, V_FISOPEITEM, V_SUFXCFOPPR, 0, V_PERDBCALC, V_PARDEDTMP,
                           V_CONTABCALC, 0, 0, w_00000, w_00000, V_CDSITTRIBTMP,
                           V_IDMODBCNFE, V_IDMODBCSTNFE, V_CDTPCRPICOSTNFE, V_CDNATUBCPCSTNFE, V_IDMOTIDESSTNFE, V_CDSIMPLESNACIONAL,
                           V_CDFAIXA, V_BCICMSSTRETIDO, V_VRICMSSTRETIDO, V_CDREGRAITALIQ, C_INCIDENCIA.CDDETALHEPROD,
                           V_VRIMPOSTOVISUIT, C_INCIDENCIA.CDENQLEGALIPI, C_INCIDENCIA.CDCEST, V_IDIMPSTCARGTRIB);
                     ELSE
                        INSERT INTO ITEMPROIMPOS(
                           CDFILIAL, NRLANCTONF, NRSEQITPROD, CDIMPOSTO, NRITPROIMPOS, CDFISCALIT,
                           CDSITUTRIBIT, CDFISCOPERIT, CDSUFXCFOPIT, VRALIQITEM, VRPERREDBCIT, VRPARDEDIT,
                           VRCONTITIMP, VRBASECALCIT, VRIMPOSTOIT, IDERROSIMPIT, IDAVISIMPIT, CDSITUTRIBITNFE,
                           IDMODBCITNFE, IDMODBCSTITNFE, CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT, CDSIMPLESNACIONAL,
                           CDFAIXA, VRBCICMSSTRETIDO, VRICMSSTRETIDO, CDREGRAIT, CDDETALHEPROD,
                           VRIMPOSTOVISUIT, CDENQLEGALIPI, CDCEST, IDIMPSTCARGTRIB)
                        VALUES(
                           P_FILIAL, P_LANCTONF, C_ITEMPRODUTO.NRSEQITPROD, C_INCIDENCIA.CDIMPOTEMP, w_2, w_2,
                           V_SITUTRIBPR, V_FISOPEITEM, V_SUFXCFOPPR, 0, V_PERDBCALC, V_PARDEDTMP,
                           V_CONTABCALC, 0, 0, w_00000, w_00000, V_CDSITTRIBTMP,
                           V_IDMODBCNFE, V_IDMODBCSTNFE, V_CDTPCRPICOSTNFE, V_CDNATUBCPCSTNFE, V_IDMOTIDESSTNFE, V_CDSIMPLESNACIONAL,
                           V_CDFAIXA, V_BCICMSSTRETIDO, V_VRICMSSTRETIDO, V_CDREGRAITALIQ, C_INCIDENCIA.CDDETALHEPROD,
                           V_VRIMPOSTOVISUIT, C_INCIDENCIA.CDENQLEGALIPI, C_INCIDENCIA.CDCEST, V_IDIMPSTCARGTRIB);
                     END IF;
                  END IF;
               END IF;
               FOR C_ALIQTEMP IN (SELECT DSMENSALITMP
                                  FROM ALIQTEMP
                                  WHERE (NRALIQTEMP = V_ALIQTEMP)  AND
                                        (DSMENSALITMP IS NOT NULL) AND
                                        (NOT EXISTS(SELECT DSDADOADIC
                                                    FROM DADOSADIC
                                                    WHERE (CDFILIAL   = P_FILIAL)   AND
                                                          (NRLANCTONF = P_LANCTONF) AND
                                                          (DSDADOADIC LIKE ALIQTEMP.DSMENSALITMP || '%')))) LOOP
                  IF NOT(C_ALIQTEMP.DSMENSALITMP IS NULL) THEN
                     /*PREENCHE AS MENSAGENS ATRELADAS A ALIQUOTA*/
                     INSERT INTO DADOSADIC(CDFILIAL, NRLANCTONF, NRDADOADIC, DSDADOADIC)
                                    VALUES(P_FILIAL, P_LANCTONF, V_DADOADIC, C_ALIQTEMP.DSMENSALITMP);
                     V_DADOADIC := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_DADOADIC) + 1)),3,0);
                  END IF;
               END LOOP;
               DELETE ALIQTEMP
                WHERE NRALIQTEMP = V_ALIQTEMP;
               V_VRADICALIQFECP := NULL;
               V_VRADICFECP := NULL;
            END LOOP; --FIM DO LOOP DAS INCIDÊNCIAS
            DELETE INCITEMP
            WHERE NRINCITEMP = V_INCITEMP;
         ELSE
            /*IMPOSTOS INFORMADOS PELO USUARIO*/
            FOR C_IMPOSINFUSU IN (SELECT II.CDIMPOSTO, II.CDFISCINFUSU,
                                         II.VRALIQINFUSU, II.VRRDBCINFUSU, II.VRPDEDINFUSU,
                                         I.IDTRATIMPO, I.IDCONSISTENT, I.IDIMPORECUP
                                  FROM IMPOSINFUSU II, IMPOSTO I
                                  WHERE (II.CDFILIAL    = P_FILIAL)                  AND
                                        (II.NRLANCTONF  = P_LANCTONF)                AND
                                        (II.NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD) AND
                                        (II.CDIMPOSTO   = I.CDIMPOSTO)) LOOP
               V_TAXABASECALC := (100 - C_IMPOSINFUSU.VRRDBCINFUSU)/100;
               V_TAXAALIQUOTA := (C_IMPOSINFUSU.VRALIQINFUSU/100);
               V_IMPOSTOIT  := ((V_LIQUIITEM * V_TAXABASECALC) * V_TAXAALIQUOTA) - C_IMPOSINFUSU.VRPDEDINFUSU;
               V_CONTABCALC := V_LIQUIITEM - (V_LIQUIITEM * V_TAXABASECALC);
               V_PERDBCALC  := 100 - C_IMPOSINFUSU.VRRDBCINFUSU;
               IF (V_IMPOSTOIT < 0) THEN
                  V_IMPOSTOIT := 0;
               END IF;
               IF (C_IMPOSINFUSU.VRALIQINFUSU = 0) AND (V_IMPOSTOIT = 0) THEN
                  V_BASECALCIT := 0;
               ELSE
                  V_BASECALCIT := V_LIQUIITEM * V_TAXABASECALC;
               END IF;
               Begin
                  SELECT CDFILIAL
                  INTO   V_CHAVE
                  FROM ITEMPROIMPOS
                  WHERE CDFILIAL     = P_FILIAL                 AND
                        NRLANCTONF   = P_LANCTONF               AND
                        NRSEQITPROD  = C_ITEMPRODUTO.NRSEQITPROD  AND
                        CDIMPOSTO    = C_IMPOSINFUSU.CDIMPOSTO AND
                        NRITPROIMPOS = w_1;
               Exception
                  When No_Data_Found Then
                     V_CHAVE := Null;
               End;
               SELECT NVL(MAX(IDPERVISIMPSCRE),'S')
                 INTO V_IDPERVISIMPSCRE
                 FROM PARAMGERAL;
               IF V_IDPERVISIMPSCRE = 'S' THEN
                  V_VRIMPOSTOVISUIT := V_IMPOSTOIT;
               ELSE
                  IF (C_IMPOSINFUSU.CDFISCINFUSU = '1') THEN
                     V_VRIMPOSTOVISUIT := V_IMPOSTOIT;
                  ELSE
                     V_VRIMPOSTOVISUIT := 0;
                  END IF;
               END IF;
               IF V_CHAVE IS NULL THEN
                  INSERT INTO ITEMPROIMPOS(
                     CDFILIAL, NRLANCTONF, NRSEQITPROD, CDIMPOSTO, NRITPROIMPOS, CDFISCALIT, CDSITUTRIBIT,
                     CDFISCOPERIT, CDSUFXCFOPIT, VRALIQITEM, VRPERREDBCIT, VRPARDEDIT, VRCONTITIMP,
                     VRBASECALCIT, VRIMPOSTOIT, IDERROSIMPIT, IDAVISIMPIT, VRIMPOSTOVISUIT)
                  VALUES(
                     P_FILIAL, P_LANCTONF, C_ITEMPRODUTO.NRSEQITPROD, C_IMPOSINFUSU.CDIMPOSTO, w_1, C_IMPOSINFUSU.CDFISCINFUSU, V_SITUTRIBPR,
                     V_FISOPEITEM, V_SUFXCFOPPR, C_IMPOSINFUSU.VRALIQINFUSU, C_IMPOSINFUSU.VRRDBCINFUSU, C_IMPOSINFUSU.VRPDEDINFUSU, V_BASECALCIT,
                     V_BASECALCIT, V_IMPOSTOIT, w_00000, w_00000, V_VRIMPOSTOVISUIT);
                  IF V_PREDBCTMP > 0 THEN
                     INSERT INTO ITEMPROIMPOS(
                        CDFILIAL, NRLANCTONF, NRSEQITPROD, CDIMPOSTO, NRITPROIMPOS, CDFISCALIT, CDSITUTRIBIT,
                        CDFISCOPERIT, CDSUFXCFOPIT, VRALIQITEM, VRPERREDBCIT, VRPARDEDIT, VRCONTITIMP,
                        VRBASECALCIT, VRIMPOSTOIT, IDERROSIMPIT, IDAVISIMPIT, VRIMPOSTOVISUIT)
                     VALUES(
                        P_FILIAL, P_LANCTONF, C_ITEMPRODUTO.NRSEQITPROD, C_IMPOSINFUSU.CDIMPOSTO, w_2, w_2, V_SITUTRIBPR,
                        V_FISOPEITEM, V_SUFXCFOPPR, 0, V_PERDBCALC, C_IMPOSINFUSU.VRPDEDINFUSU, ROUND(V_CONTABCALC,5),  
                        0, 0, w_00000, w_00000, 0);
                  END IF;
               END IF;
            END LOOP; --FIM DO LOOP DOS IMPOSTOS INFORMADOS PELO USUARIO
         END IF;
      END LOOP; --FIM DO LOOP DOS PRODUTOS
      DELETE FROM REGRANOTA
      WHERE CDFILIAL = P_FILIAL
        AND NRLANCTONF = P_LANCTONF;
      FOR C_IMPOSNOTA IN (SELECT DISTINCT CDREGRAIT
                            FROM ITEMPROIMPOS
                           WHERE CDFILIAL = P_FILIAL
                             AND NRLANCTONF = P_LANCTONF
                             AND CDREGRAIT IS NOT NULL
                          ORDER BY CDREGRAIT)
      LOOP
         FOR C_REGRAMSG IN (SELECT CDREGRAFISC, DSMENSREGRAFISC
                              FROM TABLE(MSG_REGRAFISCAL(C_IMPOSNOTA.CDREGRAIT, P_EMPRESA, 'S', P_TIPOOPER, P_INSCESTA)) M
                             WHERE NOT EXISTS(SELECT DSDADOADIC
                                             FROM DADOSADIC
                                             WHERE (CDFILIAL   = P_FILIAL)   AND
                                                   (NRLANCTONF = P_LANCTONF) AND
                                                   (DSDADOADIC = M.DSMENSREGRAFISC))) LOOP
            INSERT INTO DADOSADIC(CDFILIAL, NRLANCTONF, NRDADOADIC, DSDADOADIC)
                           VALUES(P_FILIAL, P_LANCTONF, V_DADOADIC, C_REGRAMSG.DSMENSREGRAFISC);
            V_DADOADIC := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_DADOADIC) + 1)),3,0);
         END LOOP;
         INSERT INTO REGRANOTA(CDFILIAL, NRLANCTONF, CDREGRAFISC)
                           VALUES(P_FILIAL, P_LANCTONF, C_IMPOSNOTA.CDREGRAIT);
      END LOOP;
      --RATEIO DOS ENCARGOS--------------------------------------------------------------------------------------------------------
      FOR C_ITEMENCARGO IN (SELECT IE.CDENCARGO AS CDENCARGO, VRITEMENCA, IDENCARGO,
                                   EN.CDCTBLENTREN, EN.CDCTBLSAIDEN
                            FROM ITEMENCARGO IE, ENCARGO EN
                            WHERE (IE.CDFILIAL   = P_FILIAL)     AND
                                  (IE.NRLANCTONF = P_LANCTONF)   AND
                                  (IE.VRITEMENCA > 0)            AND
                                  (EN.CDENCARGO  = IE.CDENCARGO)) LOOP
         V_TOTAPRODENCA := 0;
         FOR C_VRLIQRATEIO IN (SELECT DISTINCT(IP.NRSEQITPROD) AS NRSEQITPROD, (VRTOTAITEM - VRDESCITEM) AS VRLIQUIDO
                               FROM ITEMPRODUTO IP, ITEMPROIMPOS II
                               WHERE (IP.CDFILIAL    = P_FILIAL)       AND
                                     (IP.NRLANCTONF  = P_LANCTONF)     AND
                                     (II.CDFILIAL    = IP.CDFILIAL)    AND
                                     (II.NRLANCTONF  = IP.NRLANCTONF)  AND
                                     (II.NRSEQITPROD = IP.NRSEQITPROD) AND
                                     (EXISTS(SELECT BC.CDIMPOSTO
                                             FROM BASECALC BC
                                             WHERE (BC.CDENCARGO = C_ITEMENCARGO.CDENCARGO) AND
                                                   (BC.CDIMPOSTO = II.CDIMPOSTO)            AND
                                                   (BC.CDIMPOSTO IN (SELECT B.CDIMPOSTO
                                                                    FROM BASECALC B
                                                                    WHERE B.CDENCARGO = C_ITEMENCARGO.CDENCARGO))))) LOOP
            IF NOT (C_VRLIQRATEIO.VRLIQUIDO IS NULL) THEN
               V_TOTAPRODENCA := V_TOTAPRODENCA + C_VRLIQRATEIO.VRLIQUIDO;
            END IF;
         END LOOP;
         IF V_TOTAPRODENCA = 0 THEN
            SELECT SUM(VRTOTAITEM - VRDESCITEM)
            INTO   V_TOTAPRODENCA
            FROM ITEMPRODUTO IP
            WHERE (IP.CDFILIAL   = P_FILIAL)   AND
                  (IP.NRLANCTONF = P_LANCTONF);
            IF NOT V_TOTAPRODENCA IS NULL THEN
               FOR C_ATUAVRCONT IN (SELECT IP.NRSEQITPROD, (VRTOTAITEM - VRDESCITEM) AS VRLIQUIDO
                                    FROM ITEMPRODUTO IP
                                    WHERE (IP.CDFILIAL    = P_FILIAL) AND
                                          (IP.NRLANCTONF  = P_LANCTONF)) LOOP
                  IF (C_ITEMENCARGO.IDENCARGO = w_A) THEN
                     V_VRBRUTO  := (C_ITEMENCARGO.VRITEMENCA/V_TOTAPRODENCA);
                  ELSIF (C_ITEMENCARGO.IDENCARGO = w_D) THEN
                     V_VRBRUTO  := - (C_ITEMENCARGO.VRITEMENCA/V_TOTAPRODENCA);
                  ELSE
                     V_VRBRUTO := 0;
                  END IF;
                  IF (C_ITEMENCARGO.CDCTBLSAIDEN IS NULL) THEN
                     V_VRCONTAB := V_VRBRUTO;
                  ELSE
                     V_VRCONTAB := 0;
                  END IF;
                  IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (NVL(V_IDORIGDESTNF, 'C') <> 'L') THEN
                     UPDATE ITEMPRODUTO
                     SET VRBRUTITEM = TRUNC(VRBRUTITEM + (V_VRBRUTO  * (VRTOTAITEM - VRDESCITEM)),2),
                         VRCONTITEM = TRUNC(VRCONTITEM + (V_VRCONTAB * (VRTOTAITEM - VRDESCITEM)),2)
                     WHERE CDFILIAL    = P_FILIAL   AND
                           NRLANCTONF  = P_LANCTONF AND
                           NRSEQITPROD = C_ATUAVRCONT.NRSEQITPROD;
                  ELSE
                     UPDATE ITEMPRODUTO
                     SET VRBRUTITEM = ROUND(VRBRUTITEM + (V_VRBRUTO  * (VRTOTAITEM - VRDESCITEM)),5),
                         VRCONTITEM = ROUND(VRCONTITEM + (V_VRCONTAB * (VRTOTAITEM - VRDESCITEM)),5)
                     WHERE CDFILIAL    = P_FILIAL   AND
                           NRLANCTONF  = P_LANCTONF AND
                           NRSEQITPROD = C_ATUAVRCONT.NRSEQITPROD;
                  END IF;
               END LOOP;
            END IF;
         ELSE
            FOR C_ATUAVRCONT IN (SELECT DISTINCT(IP.NRSEQITPROD) AS NRSEQITPROD, (VRTOTAITEM - VRDESCITEM) AS VRLIQUIDO
                                 FROM ITEMPRODUTO IP, ITEMPROIMPOS II
                                 WHERE (IP.CDFILIAL    = P_FILIAL)       AND
                                       (IP.NRLANCTONF  = P_LANCTONF)     AND
                                       (II.CDFILIAL    = IP.CDFILIAL)    AND
                                       (II.NRLANCTONF  = IP.NRLANCTONF)  AND
                                       (II.NRSEQITPROD = IP.NRSEQITPROD) AND
                                       (EXISTS(SELECT BC.CDIMPOSTO
                                               FROM BASECALC BC
                                               WHERE (BC.CDENCARGO = C_ITEMENCARGO.CDENCARGO) AND
                                                     (BC.CDIMPOSTO = II.CDIMPOSTO)            AND
                                                     (BC.CDIMPOSTO IN (SELECT B.CDIMPOSTO
                                                                       FROM BASECALC B
                                                                       WHERE B.CDENCARGO = C_ITEMENCARGO.CDENCARGO))))) LOOP
               IF (C_ITEMENCARGO.IDENCARGO = w_A) THEN
                  V_VRBRUTO  := (C_ITEMENCARGO.VRITEMENCA/V_TOTAPRODENCA);
               ELSIF (C_ITEMENCARGO.IDENCARGO = w_D) THEN
                  V_VRBRUTO  := - (C_ITEMENCARGO.VRITEMENCA/V_TOTAPRODENCA);
               ELSE
                  V_VRBRUTO := 0;
               END IF;
               IF (C_ITEMENCARGO.CDCTBLSAIDEN IS NULL) THEN
                  V_VRCONTAB := V_VRBRUTO;
               ELSE
                  V_VRCONTAB := 0;
               END IF;
               IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (NVL(V_IDORIGDESTNF, 'C') <> 'L') THEN
                  UPDATE ITEMPRODUTO
                  SET VRBRUTITEM = TRUNC(VRBRUTITEM + (V_VRBRUTO  * (VRTOTAITEM - VRDESCITEM)),2),
                      VRCONTITEM = TRUNC(VRCONTITEM + (V_VRCONTAB * (VRTOTAITEM - VRDESCITEM)),2)
                  WHERE CDFILIAL    = P_FILIAL   AND
                        NRLANCTONF  = P_LANCTONF AND
                        NRSEQITPROD = C_ATUAVRCONT.NRSEQITPROD;
               ELSE
                  UPDATE ITEMPRODUTO
                  SET VRBRUTITEM = ROUND(VRBRUTITEM + (V_VRBRUTO  * (VRTOTAITEM - VRDESCITEM)),5),
                      VRCONTITEM = ROUND(VRCONTITEM + (V_VRCONTAB * (VRTOTAITEM - VRDESCITEM)),5)
                  WHERE CDFILIAL    = P_FILIAL   AND
                        NRLANCTONF  = P_LANCTONF AND
                        NRSEQITPROD = C_ATUAVRCONT.NRSEQITPROD;
               END IF;
            END LOOP;
            FOR C_ITEMPROIMPOS IN (SELECT II.NRSEQITPROD, II.NRITPROIMPOS, II.CDIMPOSTO, II.VRPERREDBCIT, II.VRALIQITEM,
                                          II.VRPARDEDIT, II.IDTRIMPSTII, (VRTOTAITEM - VRDESCITEM) AS VRLIQUIDO,
                                          NVL(II.VRALIQINTEDEST, 0) AS VRALIQINTEDEST, NVL(II.VRALIQFCP, 0) AS VRALIQFCP,
                                          NVL(IP.IDUTILBCPMC, 'N') AS IDUTILBCPMC, I.CDIMPOSTONFE, NVL(II.IDCONSDIFALIQ, 'N') AS IDCONSDIFALIQ 
                                   FROM ITEMPROIMPOS II, ITEMPRODUTO IP, BASECALC BC, IMPOSTO I
                                   WHERE (II.CDFILIAL     = P_FILIAL)                AND
                                         (II.NRLANCTONF   = P_LANCTONF)              AND
                                         (IP.CDFILIAL     = P_FILIAL)                AND
                                         (IP.NRLANCTONF   = P_LANCTONF)              AND
                                         (IP.NRSEQITPROD  = II.NRSEQITPROD)          AND
                                         (BC.CDIMPOSTO    = II.CDIMPOSTO)            AND
                                         (II.CDIMPOSTO    = I.CDIMPOSTO)             AND
                                         (BC.CDENCARGO    = C_ITEMENCARGO.CDENCARGO)
                                   ORDER BY 1, 2, 3) LOOP
               IF NOT((C_ITEMPROIMPOS.IDUTILBCPMC = W_S) AND (C_ITEMPROIMPOS.CDIMPOSTONFE = '80')) OR (C_ITEMPROIMPOS.IDUTILBCPMC <> W_S) THEN
                  IF C_ITEMPROIMPOS.IDCONSDIFALIQ <> W_S THEN
                     SELECT SUM(VRTOTAITEM - VRDESCITEM)
                       INTO V_TOTAPRENIMPO
                       FROM ITEMPRODUTO IP
                      WHERE IP.CDFILIAL   = P_FILIAL
                        AND IP.NRLANCTONF = P_LANCTONF;
                     IF (V_TOTAPRODENCA <> 0) THEN
                        IF (C_ITEMENCARGO.IDENCARGO = w_A) THEN
                           V_PRODUENCARGO := +(C_ITEMENCARGO.VRITEMENCA/V_TOTAPRENIMPO)*C_ITEMPROIMPOS.VRLIQUIDO;
                        ELSIF (C_ITEMENCARGO.IDENCARGO = w_D) THEN
                           V_PRODUENCARGO := -(C_ITEMENCARGO.VRITEMENCA/V_TOTAPRENIMPO)*C_ITEMPROIMPOS.VRLIQUIDO;
                        ELSE
                           V_PRODUENCARGO := 0;
                        END IF;
                     END IF;
                     V_IDVRIMPSTRIB := null;
                     BEGIN
                        SELECT CASE COUNT(*) WHEN 0 THEN 'M' ELSE 'R' END
                          INTO V_MAJORAOUREDUZ
                          FROM ITEMPROIMPOS
                         WHERE CDFILIAL = P_FILIAL 
                           AND NRLANCTONF = P_LANCTONF
                           AND NRSEQITPROD = C_ITEMPROIMPOS.NRSEQITPROD
                           AND CDIMPOSTO = C_ITEMPROIMPOS.CDIMPOSTO
                           AND NRITPROIMPOS = w_2;
                     EXCEPTION
                        WHEN NO_DATA_FOUND THEN
                           V_MAJORAOUREDUZ := 'M';
                     END;
                     V_VRIMPOSTOST := 0;
                     IF V_MAJORAOUREDUZ = 'R' THEN
                        V_TAXABASECALC := (100 - C_ITEMPROIMPOS.VRPERREDBCIT)/100;
                        V_TAXAALIQUOTA := (C_ITEMPROIMPOS.VRALIQITEM/100);
                     ELSE
                        V_TAXABASECALC := 1 + (C_ITEMPROIMPOS.VRPERREDBCIT)/100;
                        V_TAXAALIQUOTA := (C_ITEMPROIMPOS.VRALIQITEM/100);
                        SELECT NVL(MAX(IDVRIMPSTRIB), 'N')
                          INTO V_IDVRIMPSTRIB
                          FROM ITEMPROIMPOS I, IMPOSTO II
                         WHERE (CDFILIAL     = P_FILIAL)
                           AND (NRLANCTONF   = P_LANCTONF)
                           AND (NRSEQITPROD  = C_ITEMPROIMPOS.NRITPROIMPOS)
                           AND (INSTR(V_CDIMPOSTRIB,II.CDIMPOSTO||'_') > 0)
                           AND (I.CDIMPOSTO = II.CDIMPOSTO);
                        IF (C_ITEMPROIMPOS.IDTRIMPSTII <> w_1) AND (NVL(V_IDVRIMPSTRIB,w_N) = w_S) THEN
                           Begin
                              SELECT NVL(MAX(VRIMPOSTOIT),0)
                              INTO   V_VRIMPOSTOST
                              FROM ITEMPROIMPOS I
                              WHERE (CDFILIAL     = P_FILIAL)                   AND
                                    (NRLANCTONF   = P_LANCTONF)                 AND
                                    (INSTR(V_CDIMPOSTRIB,CDIMPOSTO||'_') > 0)   AND
                                    (NRITPROIMPOS = C_ITEMPROIMPOS.NRITPROIMPOS);
                           Exception
                              When No_Data_Found Then
                                 V_VRIMPOSTOST := 0;
                           End;
                        END IF;
                     END IF;
                     V_ICMS := 'N';
                     FOR C_ICMS IN (SELECT CDIMPOSTO
                                      FROM IMPOSTONFE N, IMPOSTO I
                                     WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                                       AND N.CDIMPOSTONFE = '00'
                                       AND I.CDIMPOSTO = C_ITEMPROIMPOS.CDIMPOSTO)
                     LOOP
                        V_ICMS := 'S';
                     END LOOP;
                     SELECT NVL(MAX(IDPERVISIMPSCRE), 'S')
                       INTO V_IDPERVISIMPSCRE
                       FROM PARAMGERAL;
                     UPDATE ITEMPROIMPOS
                        SET VRCONTITIMP  = VRCONTITIMP  + (V_PRODUENCARGO * V_TAXABASECALC),
                            VRBASECALCIT = VRBASECALCIT + ((V_PRODUENCARGO * V_TAXABASECALC) / (1 - ((C_ITEMPROIMPOS.VRALIQINTEDEST + C_ITEMPROIMPOS.VRALIQFCP) / 100))),
                            VRIMPOSTOIT  = (VRIMPOSTOIT  + (((V_PRODUENCARGO * V_TAXABASECALC) / (1 - ((C_ITEMPROIMPOS.VRALIQINTEDEST + C_ITEMPROIMPOS.VRALIQFCP) / 100))) * V_TAXAALIQUOTA)) - (((V_VRIMPOSTOST * V_TAXABASECALC) / (1 - ((C_ITEMPROIMPOS.VRALIQINTEDEST + C_ITEMPROIMPOS.VRALIQFCP) / 100))) * V_TAXAALIQUOTA),
                            VRIMPOSTOVISUIT = DECODE(V_IDPERVISIMPSCRE, 'S', (VRIMPOSTOIT  + ((V_PRODUENCARGO * V_TAXABASECALC) * V_TAXAALIQUOTA)) - ((V_VRIMPOSTOST * V_TAXABASECALC) * V_TAXAALIQUOTA),  DECODE(CDFISCALIT , '1', (VRIMPOSTOIT  + ((V_PRODUENCARGO * V_TAXABASECALC) * V_TAXAALIQUOTA)) - ((V_VRIMPOSTOST * V_TAXABASECALC) * V_TAXAALIQUOTA),0)),
                            VRADICFECP  = VRADICFECP  + ROUND((V_PRODUENCARGO * (VRADICALIQFECP / 100) * V_TAXABASECALC),2)
                      WHERE (CDFILIAL     = P_FILIAL)                   AND
                            (NRLANCTONF   = P_LANCTONF)                 AND
                            (NRSEQITPROD  = C_ITEMPROIMPOS.NRSEQITPROD) AND
                            (CDIMPOSTO    = C_ITEMPROIMPOS.CDIMPOSTO)   AND
                            (NRITPROIMPOS = C_ITEMPROIMPOS.NRITPROIMPOS);
                  END IF;
               END IF;
               /* ROTINA PARA RECALCULAR O DIFERIMENTO DO IMPOSTO */
               BEGIN
                  SELECT MAX(VRIMPOSTOOPERAIT), MAX(VRPERDIFEREIT)
                    INTO V_VRIMPOSTOOPERAIT, V_VRPERDIFEREIT
                    FROM ITEMPROIMPOS
                   WHERE (CDFILIAL     = P_FILIAL)                    AND
                         (NRLANCTONF   = P_LANCTONF)                  AND
                         (NRSEQITPROD  = C_ITEMPROIMPOS.NRSEQITPROD)  AND
                         (CDIMPOSTO    = C_ITEMPROIMPOS.CDIMPOSTO)    AND
                         (NRITPROIMPOS = C_ITEMPROIMPOS.NRITPROIMPOS) AND
                         (VRPERDIFEREIT <> 0);
               EXCEPTION
                  When No_Data_Found Then
                     V_VRIMPOSTOOPERAIT := 0; V_VRPERDIFEREIT := 0;
               END;
               IF V_VRPERDIFEREIT <> 0 THEN
                  V_VRIMPOSTOOPERAIT := ROUND((V_VRIMPOSTOOPERAIT + ((ROUND(V_PRODUENCARGO, 2) * V_TAXABASECALC) * V_TAXAALIQUOTA)) - ((V_VRIMPOSTOST * V_TAXABASECALC) * V_TAXAALIQUOTA),2);
                  /*
                     Foi comentado este cálculo pois ao implementá-lo de acordo com a resolução nº13 de 14 de fevereiro de 2019
                     a sefaz passou a rejeitar as notas com a rejeição 352 (Rejeicao: Valor do ICMS Diferido no CST=51 difere do 
                     produto Valor ICMS Operacao e percentual diferimento)
                  */
                  --IF (V_CDPAISEMIT = 0055) AND (V_SGESTADOEMIT = RJ) THEN
                  --   V_VRIMPOSTODIFERIT := ROUND((((V_TAXABASECALC / (1 - V_TAXAALIQUOTA)) * V_TAXAALIQUOTA) * (V_VRPERDIFEREIT/100)), 2);
                  --ELSE
                     V_VRIMPOSTODIFERIT := ROUND((V_VRIMPOSTOOPERAIT * V_VRPERDIFEREIT/100), 2);
                  --END IF;
                  UPDATE ITEMPROIMPOS
                     SET VRIMPOSTOOPERAIT = VRIMPOSTOOPERAIT + V_VRIMPOSTOOPERAIT,
                         VRIMPOSTODIFERIT = VRIMPOSTODIFERIT + V_VRIMPOSTODIFERIT,
                         VRIMPOSTOIT = VRIMPOSTOIT + (V_VRIMPOSTOOPERAIT - V_VRIMPOSTODIFERIT),
                         VRIMPOSTOVISUIT = VRIMPOSTOVISUIT + (V_VRIMPOSTOOPERAIT - V_VRIMPOSTODIFERIT)
                   WHERE (CDFILIAL     = P_FILIAL)                    AND
                         (NRLANCTONF   = P_LANCTONF)                  AND
                         (NRSEQITPROD  = C_ITEMPROIMPOS.NRSEQITPROD)  AND
                         (CDIMPOSTO    = C_ITEMPROIMPOS.CDIMPOSTO)    AND
                         (NRITPROIMPOS = C_ITEMPROIMPOS.NRITPROIMPOS) AND
                         (VRPERDIFEREIT <> 0);
               END IF;
            END LOOP;
         END IF;
      END LOOP;
      UPDATE ITEMPROIMPOS
      SET VRIMPOSTOIT = 0,
          VRIMPOSTOVISUIT = 0
      WHERE (NRLANCTONF  = P_LANCTONF) AND
            (CDFILIAL    = P_FILIAL)   AND
            (VRIMPOSTOIT < 0);
      UPDATE ITEMPROIMPOS
      SET VRBASECALCIT = 0
      WHERE (NRLANCTONF  = P_LANCTONF) AND
            (CDFILIAL    = P_FILIAL)   AND
            (VRBASECALCIT < 0);
      --CÁLCULO DO VALOR DOS IMPOSTOS QUE CONTÉM OUTROS IMPOSTOS NA SUA BASE DE CÁLCULO
      FOR C_PRODUTO IN (SELECT IP.NRSEQITPROD AS NRSEQITPROD, II.CDIMPOSTO, VRPERREDBCIT,
                               VRALIQITEM, VRPARDEDIT, CDFISCALIT, VRIMPOSTOIT, IDTRATIMPO,
                               IM.IDIMPORECUP, IM.CDCCTBLPASS, IM.CDCCTBLATIV, NRITPROIMPOS,
                               IDTRIMPSTII, IM.IDTIPCONTAB, II.VRBASECALCIT, II.IDIMPSTCARGTRIB,
                               IP.CDPRODUTO, P.CDARVPROD, IP.IDORIGEMPROD, IM.IDDESCRFONTE,
                               NVL(IP.IDUTILBCPMC, W_N) AS IDUTILBCPMC, NVL(VRADICFECP, 0) AS VRADICFECP,
                               NVL(VRADICALIQFECP, 0) AS VRADICALIQFECP, NVL(II.IDCONSDIFALIQ, W_N) AS IDCONSDIFALIQ 
                        FROM ITEMPRODUTO IP, ITEMPROIMPOS II, IMPOSTO IM, PRODUTO P
                        WHERE (IP.CDFILIAL     = P_FILIAL)      AND
                              (IP.NRLANCTONF   = P_LANCTONF)    AND
                              (II.CDFILIAL     = IP.CDFILIAL)   AND
                              (II.NRLANCTONF   = IP.NRLANCTONF) AND
                              (IM.CDIMPOSTO    = II.CDIMPOSTO)  AND
                              (II.NRITPROIMPOS = w_1)           AND
                              (II.NRSEQITPROD  = IP.NRSEQITPROD) AND
                              P.CDPRODUTO = IP.CDPRODUTO
                        ORDER BY NRSEQITPROD, CDIMPOSTO) LOOP
         V_IDIMPOBCALTPOP := NULL;
         SELECT TO_CHAR(MAX('S')) , NVL(SUM(VRIMPOSTOIT),0) AS VRIMPOBCALC
           INTO   V_IDIMPOBCALTPOP, V_TOTAIMPBCALC
           FROM ITEMPRODUTO IP, ITEMPROIMPOS II, BASECALCTPOPER BC , IMPOSTO I
          WHERE (BC.CDIMPOSTO    = C_PRODUTO.CDIMPOSTO)
            AND (IP.CDFILIAL     = P_FILIAL)
            AND (IP.NRLANCTONF   = P_LANCTONF)
            AND (II.NRLANCTONF   = IP.NRLANCTONF)
            AND (II.CDFILIAL     = IP.CDFILIAL)
            AND (IP.NRSEQITPROD  = C_PRODUTO.NRSEQITPROD)
            AND (II.NRSEQITPROD  = C_PRODUTO.NRSEQITPROD)
            AND (II.NRITPROIMPOS = C_PRODUTO.NRITPROIMPOS)
            AND ((SUBSTR(IP.CDSITUTRIBPR,2,2) = BC.CDCSTIMPOTPOP)  OR (BC.CDCSTIMPOTPOP  IS NULL))
            AND ((SUBSTR(IP.CDFISOPEITEM,2,4) = BC.CDCFOPIMPOTPOP) OR (BC.CDCFOPIMPOTPOP IS NULL))
            AND ((C_PRODUTO.CDFISCALIT        = BC.CDFISCIMPOTPOP) OR (BC.CDFISCIMPOTPOP IS NULL))
            AND (BC.IDENTRSAIDOP = 'S')
            AND (BC.CDTIPOOPER = P_TIPOOPER)
            AND (II.CDIMPOSTO = BC.CDIMPOBCALC)
            AND (BC.CDIMPOBCALC = I.CDIMPOSTO)
            AND (NVL(BC.IDTRATIMPOBCTPOP, I.IDTRATIMPO) <> 'D');
         IF V_IDIMPOBCALTPOP IS NULL THEN
            SELECT NVL(SUM(VRIMPOSTOIT),0) AS VRIMPOBCALC
              INTO   V_TOTAIMPBCALC
              FROM ITEMPRODUTO IP, ITEMPROIMPOS II, BASECALC BC, IMPOSTO I
             WHERE (BC.CDIMPOSTO    = C_PRODUTO.CDIMPOSTO)    AND
                   (IP.CDFILIAL     = P_FILIAL)               AND
                   (IP.NRLANCTONF   = P_LANCTONF)             AND
                   (II.NRLANCTONF   = IP.NRLANCTONF)          AND
                   (II.CDFILIAL     = IP.CDFILIAL)            AND
                   (IP.NRSEQITPROD  = C_PRODUTO.NRSEQITPROD)  AND
                   (II.NRSEQITPROD  = C_PRODUTO.NRSEQITPROD)  AND
                   (II.NRITPROIMPOS = C_PRODUTO.NRITPROIMPOS) AND
                   ((SUBSTR(IP.CDSITUTRIBPR,2,2) = BC.CDCSTIMPO)  OR (BC.CDCSTIMPO  IS NULL)) AND
                   ((SUBSTR(IP.CDFISOPEITEM,2,4) = BC.CDCFOPIMPO) OR (BC.CDCFOPIMPO IS NULL)) AND
                   ((C_PRODUTO.CDFISCALIT        = BC.CDFISCIMPO) OR (BC.CDFISCIMPO IS NULL)) AND
                   (II.CDIMPOSTO = BC.CDIMPOBCALC) AND
                   (BC.IDTIPOBCALC   = w_I)AND
                   (BC.CDIMPOBCALC = I.CDIMPOSTO)  AND
                   (NVL(BC.IDTRATIMPOBC, I.IDTRATIMPO) <> 'D');
         END IF;
         V_IDIMBCALTPOPDE := NULL;
         SELECT TO_CHAR(MAX('S')), (NVL(SUM(VRIMPOSTOIT),0)*-1) AS VRIMPOBCALC
           INTO V_IDIMBCALTPOPDE, V_TOTAIMPBCDES
           FROM ITEMPRODUTO IP, ITEMPROIMPOS II, BASECALCTPOPER BC, IMPOSTO I
          WHERE (BC.CDIMPOSTO    = C_PRODUTO.CDIMPOSTO)
            AND (IP.CDFILIAL     = P_FILIAL)
            AND (IP.NRLANCTONF   = P_LANCTONF)
            AND (II.NRLANCTONF   = IP.NRLANCTONF)
            AND (II.CDFILIAL     = IP.CDFILIAL)
            AND (IP.NRSEQITPROD  = C_PRODUTO.NRSEQITPROD)
            AND (II.NRSEQITPROD  = C_PRODUTO.NRSEQITPROD)
            AND (II.NRITPROIMPOS = C_PRODUTO.NRITPROIMPOS)
            AND ((SUBSTR(IP.CDSITUTRIBPR,2,2) = BC.CDCSTIMPOTPOP)  OR (BC.CDCSTIMPOTPOP  IS NULL))
            AND ((SUBSTR(IP.CDFISOPEITEM,2,4) = BC.CDCFOPIMPOTPOP) OR (BC.CDCFOPIMPOTPOP IS NULL))
            AND ((C_PRODUTO.CDFISCALIT        = BC.CDFISCIMPOTPOP) OR (BC.CDFISCIMPOTPOP IS NULL))
            AND (BC.IDENTRSAIDOP = 'S')
            AND (BC.CDTIPOOPER = P_TIPOOPER)
            AND (II.CDIMPOSTO = BC.CDIMPOBCALC)
            AND (BC.CDIMPOBCALC = I.CDIMPOSTO)
            AND (NVL(BC.IDTRATIMPOBCTPOP, I.IDTRATIMPO) = 'D');
         IF V_IDIMBCALTPOPDE IS NULL THEN
            SELECT (NVL(SUM(VRIMPOSTOIT),0)*-1) AS VRIMPOBCALC INTO V_TOTAIMPBCDES
              FROM ITEMPRODUTO IP, ITEMPROIMPOS II, BASECALC BC, IMPOSTO I
             WHERE (BC.CDIMPOSTO    = C_PRODUTO.CDIMPOSTO)    AND
                   (IP.CDFILIAL     = P_FILIAL)               AND
                   (IP.NRLANCTONF   = P_LANCTONF)             AND
                   (II.NRLANCTONF   = IP.NRLANCTONF)          AND
                   (II.CDFILIAL     = IP.CDFILIAL)            AND
                   (IP.NRSEQITPROD  = C_PRODUTO.NRSEQITPROD)  AND
                   (II.NRSEQITPROD  = C_PRODUTO.NRSEQITPROD)  AND
                   (II.NRITPROIMPOS = C_PRODUTO.NRITPROIMPOS) AND
                   ((SUBSTR(IP.CDSITUTRIBPR,2,2) = BC.CDCSTIMPO)  OR (BC.CDCSTIMPO  IS NULL)) AND
                   ((SUBSTR(IP.CDFISOPEITEM,2,4) = BC.CDCFOPIMPO) OR (BC.CDCFOPIMPO IS NULL)) AND
                   ((C_PRODUTO.CDFISCALIT        = BC.CDFISCIMPO) OR (BC.CDFISCIMPO IS NULL)) AND
                   (II.CDIMPOSTO = BC.CDIMPOBCALC) AND
                   (BC.IDTIPOBCALC   = 'I')        AND
                   (BC.CDIMPOBCALC = I.CDIMPOSTO)  AND
                   (NVL(BC.IDTRATIMPOBC, I.IDTRATIMPO) = 'D');
         END IF;
         V_VRIMPOSTO := C_PRODUTO.VRIMPOSTOIT;
         /*IMPOSTO PARA SUBSTITUIÇÃO TRIBUTARIA*/
         V_CDIMPOSTRIB  := null;
         V_IDVRIMPSTRIB := null;
         FOR C_ICMSST IN (SELECT CDIMPOSTO
                            FROM IMPOSTO
                           WHERE CDIMPOSTRIB = C_PRODUTO.CDIMPOSTO)
         LOOP
            V_CDIMPOSTRIB := V_CDIMPOSTRIB||C_ICMSST.CDIMPOSTO||'_';
         END LOOP;
         V_VRIMPOSTOST := 0;
         /*Só irá fazer o cálculo de outro imposto compondo a base de cálculo,
           se o valor do mesmo não estiver zerado OU
           se for o imposto de st, pois o icms pode ter sido recalculado(por ter alguem compondo sua bc)
           e o imposto st precisa retirar o valor final do st*/
         IF (NOT(V_TOTAIMPBCALC IS NULL) OR (V_TOTAIMPBCALC <> 0)) OR
            (NOT(V_TOTAIMPBCDES IS NULL) OR (V_TOTAIMPBCDES <> 0)) OR
            (V_CDIMPOSTRIB IS NOT NULL) THEN
            IF V_CDIMPOSTRIB IS NULL THEN
               V_TAXABASECALC := (100 - C_PRODUTO.VRPERREDBCIT)/100;
               V_TAXAALIQUOTA := (C_PRODUTO.VRALIQITEM/100);
               V_VRIMPOSTO    := V_VRIMPOSTO + (((V_TOTAIMPBCALC+V_TOTAIMPBCDES) * V_TAXABASECALC) * V_TAXAALIQUOTA);
               SELECT NVL(MAX(IDPERVISIMPSCRE), 'S')
                 INTO V_IDPERVISIMPSCRE
                 FROM PARAMGERAL;
               UPDATE ITEMPROIMPOS
                  SET VRBASECALCIT = VRBASECALCIT + ((V_TOTAIMPBCALC+V_TOTAIMPBCDES) * V_TAXABASECALC),
                      VRIMPOSTOIT  = VRIMPOSTOIT  + (((V_TOTAIMPBCALC+V_TOTAIMPBCDES) * V_TAXABASECALC) * V_TAXAALIQUOTA),
                      VRIMPOSTOVISUIT = DECODE(V_IDPERVISIMPSCRE, 'S', VRIMPOSTOIT  + (((V_TOTAIMPBCALC+V_TOTAIMPBCDES) * V_TAXABASECALC) * V_TAXAALIQUOTA), DECODE(CDFISCALIT, '1', VRIMPOSTOIT  + (((V_TOTAIMPBCALC+V_TOTAIMPBCDES) * V_TAXABASECALC) * V_TAXAALIQUOTA), 0)),
                      VRADICFECP  = VRADICFECP  + ROUND((((V_TOTAIMPBCALC+V_TOTAIMPBCDES) * V_TAXABASECALC) * (VRADICALIQFECP/100)),2)
                WHERE (CDFILIAL     = P_FILIAL)              AND
                      (NRLANCTONF   = P_LANCTONF)            AND
                      (NRSEQITPROD  = C_PRODUTO.NRSEQITPROD) AND
                      (CDIMPOSTO    = C_PRODUTO.CDIMPOSTO)   AND
                      (NRITPROIMPOS = C_PRODUTO.NRITPROIMPOS);
               /* ROTINA PARA RECALCULAR O DIFERIMENTO DO IMPOSTO */
               IF (NVL(V_TOTAIMPBCALC, 0) > 0) OR (NVL(V_TOTAIMPBCDES, 0) > 0) THEN
                  BEGIN
                     SELECT MAX(VRIMPOSTOOPERAIT), MAX(VRPERDIFEREIT)
                       INTO V_VRIMPOSTOOPERAIT, V_VRPERDIFEREIT
                       FROM ITEMPROIMPOS
                      WHERE (CDFILIAL     = P_FILIAL)               AND
                            (NRLANCTONF   = P_LANCTONF)             AND
                            (NRSEQITPROD  = C_PRODUTO.NRSEQITPROD)  AND
                            (CDIMPOSTO    = C_PRODUTO.CDIMPOSTO)    AND
                            (NRITPROIMPOS = C_PRODUTO.NRITPROIMPOS) AND
                            (VRPERDIFEREIT <> 0);
                  EXCEPTION
                     When No_Data_Found Then
                        V_VRIMPOSTOOPERAIT := 0; V_VRPERDIFEREIT := 0;
                  END;
                  IF V_VRPERDIFEREIT <> 0 THEN
                     V_VRIMPOSTOOPERAIT := ROUND(((ROUND((V_TOTAIMPBCALC + V_TOTAIMPBCDES), 2) * V_TAXABASECALC) * V_TAXAALIQUOTA),2);
                     /*
                        Foi comentado este cálculo pois ao implementá-lo de acordo com a resolução nº13 de 14 de fevereiro de 2019
                        a sefaz passou a rejeitar as notas com a rejeição 352 (Rejeicao: Valor do ICMS Diferido no CST=51 difere do
                        produto Valor ICMS Operacao e percentual diferimento)
                     */
                     --IF (V_CDPAISEMIT = 0055) AND (V_SGESTADOEMIT = RJ) THEN
                     --   V_VRIMPOSTODIFERIT := ROUND((((V_TAXABASECALC / (1 - V_TAXAALIQUOTA)) * V_TAXAALIQUOTA) * (V_VRPERDIFEREIT/100)), 2);
                     --ELSE
                        V_VRIMPOSTODIFERIT := ROUND((V_VRIMPOSTOOPERAIT * V_VRPERDIFEREIT/100), 2);
                     --END IF;
                     UPDATE ITEMPROIMPOS
                        SET VRIMPOSTOOPERAIT = VRIMPOSTOOPERAIT + V_VRIMPOSTOOPERAIT,
                            VRIMPOSTODIFERIT = VRIMPOSTODIFERIT + V_VRIMPOSTODIFERIT,
                            VRIMPOSTOIT = VRIMPOSTOIT + (V_VRIMPOSTOOPERAIT - V_VRIMPOSTODIFERIT),
                            VRIMPOSTOVISUIT = VRIMPOSTOVISUIT + (V_VRIMPOSTOOPERAIT - V_VRIMPOSTODIFERIT)
                      WHERE (CDFILIAL     = P_FILIAL)               AND
                            (NRLANCTONF   = P_LANCTONF)             AND
                            (NRSEQITPROD  = C_PRODUTO.NRSEQITPROD)  AND
                            (CDIMPOSTO    = C_PRODUTO.CDIMPOSTO)    AND
                            (NRITPROIMPOS = C_PRODUTO.NRITPROIMPOS) AND
                            (VRPERDIFEREIT <> 0);
                  END IF;
               END IF;
            ELSE
               V_VRIMPOSST   := 0;
               V_VRIMPOSTOST := 0;
               FOR C_SUBSTRIB IN (SELECT NVL(IDVRIMPSTRIB, 'N') IDVRIMPSTRIB, I.CDIMPOSTO
                                    FROM ITEMPROIMPOS I, IMPOSTO II
                                   WHERE (CDFILIAL     = P_FILIAL)
                                     AND (NRLANCTONF   = P_LANCTONF)
                                     AND (NRSEQITPROD  = C_PRODUTO.NRSEQITPROD)
                                     AND (NRITPROIMPOS = '1')
                                     AND (INSTR(V_CDIMPOSTRIB,II.CDIMPOSTO||'_') > 0)
                                     AND (I.CDIMPOSTO = II.CDIMPOSTO))
               LOOP
                  IF (C_SUBSTRIB.IDVRIMPSTRIB = w_S) THEN
                     Begin
                        SELECT NVL(ROUND(MAX(VRIMPOSTOIT), 2),0)
                        INTO   V_VRIMPOSST
                        FROM ITEMPROIMPOS I
                        WHERE (CDFILIAL     = P_FILIAL)                   AND
                              (NRLANCTONF   = P_LANCTONF)                 AND
                              (NRSEQITPROD  = C_PRODUTO.NRSEQITPROD)  AND
                              (CDIMPOSTO    = C_SUBSTRIB.CDIMPOSTO)       AND
                              (INSTR(V_CDIMPOSTRIB,CDIMPOSTO||'_') > 0)   AND
                              (NRITPROIMPOS = w_1);
                     Exception
                        When No_Data_Found Then
                           V_VRIMPOSST := 0;
                     End;
                  ELSE
                     V_VRIMPOSST := 0;
                  END IF;
                  V_VRIMPOSTOST := V_VRIMPOSTOST + V_VRIMPOSST;
               END LOOP;
               IF (C_PRODUTO.IDUTILBCPMC = W_S) THEN 
                  V_TAXAALIQUOTA := C_PRODUTO.VRALIQITEM / 100;
                  V_VRIMPOSTO := C_PRODUTO.VRBASECALCIT * V_TAXAALIQUOTA;
               ELSIF (C_PRODUTO.IDCONSDIFALIQ = W_S) THEN
                  V_TAXAALIQUOTA := C_PRODUTO.VRALIQITEM / 100;
                  V_VRIMPOSTO := C_PRODUTO.VRIMPOSTOIT;
               ELSE
                  BEGIN
                     SELECT CASE COUNT(*) WHEN 0 THEN 'M' ELSE 'R' END
                       INTO V_MAJORAOUREDUZ
                       FROM ITEMPROIMPOS
                      WHERE CDFILIAL = P_FILIAL 
                        AND NRLANCTONF = P_LANCTONF
                        AND NRSEQITPROD = C_PRODUTO.NRSEQITPROD
                        AND CDIMPOSTO = C_PRODUTO.CDIMPOSTO
                        AND NRITPROIMPOS = w_2;
                  EXCEPTION
                     WHEN NO_DATA_FOUND THEN
                        V_MAJORAOUREDUZ := 'M';
                  END;
                  IF V_MAJORAOUREDUZ = 'R' THEN
                     V_TAXABASECALC := (100 - C_PRODUTO.VRPERREDBCIT)/100;
                  ELSE
                     V_TAXABASECALC := 1 + (C_PRODUTO.VRPERREDBCIT)/100;
                  END IF;
                  V_TAXAALIQUOTA := (C_PRODUTO.VRALIQITEM/100);
                  V_VRIMPOSTO := ((C_PRODUTO.VRBASECALCIT + ((V_TOTAIMPBCALC + V_TOTAIMPBCDES) * V_TAXABASECALC)) * V_TAXAALIQUOTA);
               END IF;
               SELECT NVL(MAX(IDPERVISIMPSCRE), 'S')
                 INTO V_IDPERVISIMPSCRE
                 FROM PARAMGERAL;
               -- ESSA CONDIÇÃO SERÁ FEITA PORQUE A BASE DE CÁLCULO NÃO SERÁ ALTERADO QUANDO O PRODUTO TIVER CONSIDERANDO 
               -- O DIFERENCIAL DE ALÍQUOTA DO ICMS, ISTO PORQUE A BASE DE CÁLCULO JÁ FOI CALCULADA NA PROCEDURE CONSIDERA_DIFAL_ICMS
               IF (C_PRODUTO.IDCONSDIFALIQ = W_S) THEN
                  UPDATE ITEMPROIMPOS
                     SET VRIMPOSTOVISUIT = DECODE(V_IDPERVISIMPSCRE, 'S', (VRIMPOSTOIT), DECODE(CDFISCALIT, '1', (VRIMPOSTOIT),0))
                   WHERE (CDFILIAL     = P_FILIAL)              AND
                         (NRLANCTONF   = P_LANCTONF)            AND
                         (NRSEQITPROD  = C_PRODUTO.NRSEQITPROD) AND
                         (CDIMPOSTO    = C_PRODUTO.CDIMPOSTO)   AND
                         (NRITPROIMPOS = C_PRODUTO.NRITPROIMPOS);
               ELSIF C_PRODUTO.IDIMPSTCARGTRIB <> 'S' THEN
                  IF V_VRIMPOSTOST > V_VRIMPOSTO THEN
                     UPDATE ITEMPROIMPOS
                     SET VRBASECALCIT = VRBASECALCIT + ((V_TOTAIMPBCALC+V_TOTAIMPBCDES) * V_TAXABASECALC),
                         VRIMPOSTOIT  = 0,
                         VRIMPOSTOVISUIT = 0
                     WHERE (CDFILIAL     = P_FILIAL)              AND
                           (NRLANCTONF   = P_LANCTONF)            AND
                           (NRSEQITPROD  = C_PRODUTO.NRSEQITPROD) AND
                           (CDIMPOSTO    = C_PRODUTO.CDIMPOSTO)   AND
                           (NRITPROIMPOS = C_PRODUTO.NRITPROIMPOS);
                     V_VRIMPOSTO := 0;
                  ELSE
                     -- ESSA CONDIÇÃO SERÁ FEITA PORQUE A BASE DE CÁLCULO NÃO SERÁ ALTERADO QUANDO O PRODUTO TIVER PMC,
                     -- ISTO PORQUE A BASE DE CÁLCULO JÁ FOI CALCULADA NA PROCEDURE CALCULA_BC_PMC
                     IF (C_PRODUTO.IDUTILBCPMC = W_S) THEN
                        UPDATE ITEMPROIMPOS
                           SET VRBASECALCIT = VRBASECALCIT,
                               VRIMPOSTOIT  = V_VRIMPOSTO - V_VRIMPOSTOST,
                               VRIMPOSTOVISUIT = DECODE(V_IDPERVISIMPSCRE, 'S', (V_VRIMPOSTO - V_VRIMPOSTOST), DECODE(CDFISCALIT, '1', (V_VRIMPOSTO - V_VRIMPOSTOST),0))
                         WHERE (CDFILIAL     = P_FILIAL)              AND
                               (NRLANCTONF   = P_LANCTONF)            AND
                               (NRSEQITPROD  = C_PRODUTO.NRSEQITPROD) AND
                               (CDIMPOSTO    = C_PRODUTO.CDIMPOSTO)   AND
                               (NRITPROIMPOS = C_PRODUTO.NRITPROIMPOS);
                     ELSE
                        UPDATE ITEMPROIMPOS
                           SET VRBASECALCIT = VRBASECALCIT + ((V_TOTAIMPBCALC+V_TOTAIMPBCDES) * V_TAXABASECALC),
                               VRIMPOSTOIT  = V_VRIMPOSTO - V_VRIMPOSTOST,
                               VRIMPOSTOVISUIT = DECODE(V_IDPERVISIMPSCRE, 'S', (V_VRIMPOSTO - V_VRIMPOSTOST), DECODE(CDFISCALIT, '1', (V_VRIMPOSTO - V_VRIMPOSTOST),0)),
                               VRADICFECP  = VRADICFECP + ROUND((((V_TOTAIMPBCALC+V_TOTAIMPBCDES) * V_TAXABASECALC) * (VRADICALIQFECP/100)),2)
                         WHERE (CDFILIAL     = P_FILIAL)              AND
                               (NRLANCTONF   = P_LANCTONF)            AND
                               (NRSEQITPROD  = C_PRODUTO.NRSEQITPROD) AND
                               (CDIMPOSTO    = C_PRODUTO.CDIMPOSTO)   AND
                               (NRITPROIMPOS = C_PRODUTO.NRITPROIMPOS);
                     END IF;
                     V_VRIMPOSTO := V_VRIMPOSTO - V_VRIMPOSTOST;
                  END IF;
               END IF;
            END IF;
            /* Rotina para calcular o ICMS ST considerando % carga tributária média */
            IF V_CDIMPOSTRIB IS NOT NULL THEN
               BEGIN
                  SELECT NVL(VRCNAEBC, 0),
                         NVL(VRMVA, 0)
                    INTO V_VRPRODUTOBC,
                         V_VRMVA
                    FROM VRPERCCARGTRIBCNAE
                   WHERE IDENTRSAIDOP = w_S
                     AND CDTIPOOPER   = P_TIPOOPER
                     AND CDPAIS       = V_PAISDEST
                     AND SGESTADO     = V_ESTADEST
                     AND CDCNAE       = V_CDCNAECLIE
                     AND IDOPTANTESN  = V_IDOPTANTESNCLIE;
               EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                     V_VRPRODUTOBC := 0;
                     V_VRMVA := 0;
               END;
               IF V_VRPRODUTOBC = 0 THEN
                  BEGIN
                     SELECT NVL(VRPRODUTOBC, 0)
                       INTO V_VRPRODUTOBC
                       FROM VRPERCCARGTRIB
                      WHERE IDENTRSAIDOP = w_S
                        AND CDTIPOOPER   = P_TIPOOPER
                        AND CDPAIS       = V_PAISDEST
                        AND SGESTADO     = V_ESTADEST
                        AND CDPRODUTO    = C_PRODUTO.CDPRODUTO;
                  EXCEPTION
                     When No_Data_Found Then
                        V_VRPRODUTOBC := 0;
                  END;
               END IF;
               IF (V_VRPRODUTOBC > 0) THEN
                  BEGIN
                     SELECT I.CDIMPOSTO, I.VRIMPOSTOIT, I.VRBASECALCIT
                       INTO V_CDIMPOSTOICMS, V_VRIMPOSTOICMS, V_VRBASECALCICMS
                       FROM IMPOSTONFE N, IMPOSTO P, ITEMPROIMPOS I
                      WHERE N.CDIMPOSTONFE = P.CDIMPOSTONFE
                        AND N.CDIMPOSTONFE = '00'
                        AND I.CDFILIAL     = P_FILIAL
                        AND I.NRLANCTONF   = P_LANCTONF
                        AND I.NRSEQITPROD = C_PRODUTO.NRSEQITPROD
                        AND I.CDIMPOSTO = NVL(P.CDIMPOSREGNORMA, P.CDIMPOSTO)
                        AND NOT P.CDIMPOSTRIB IS NULL
                        AND I.NRITPROIMPOS = '1';
                  EXCEPTION
                     When No_Data_Found Then
                        V_CDIMPOSTOICMS := NULL; V_VRIMPOSTOICMS := 0; V_VRBASECALCICMS := 0;
                  END;
                  DELETE ALIQTEMP
                   WHERE NRALIQTEMP = V_ALIQTEMP;
                  /* Verifica grupo fiscal */
                  SELECT MAX(IDGRUPFISSRV)
                  INTO V_UTGRUPFISCS
                  FROM IMPOSTO
                  WHERE CDIMPOSTO = V_CDIMPOSTOICMS;
                  IF V_UTGRUPFISCS = 'S' THEN
                     V_CDGRPFISCSV := NULL;
                     SELECT MAX(CDGRUPOFISC)
                     INTO V_CDGRPFISCSV
                     FROM SERVCLIE SC, SERVICO S
                     WHERE SC.CDFILIAL   = V_CDFILIEMIT AND
                           SC.CDCLIENTE  = P_CLIENTE    AND
                           SC.CDFILIAL   = S.CDFILIAL   AND
                           SC.CDSERVFILI = S.CDSERVFILI AND
                           S.CDPRODUTO   = C_PRODUTO.CDPRODUTO;
                     IF V_CDGRPFISCSV IS NULL THEN
                        SELECT MAX(CDGRUPOFISC)
                        INTO V_CDGRPFISCSV
                        FROM CLIENFILIAL
                       WHERE CDFILIAL   = V_CDFILIEMIT AND
                             CDCLIENTE  = P_CLIENTE;
                     END IF;
                     CONSULTA_ALIQUOTA(V_CDIMPOSTOICMS, w_S, P_EMPRESA, C_PRODUTO.CDARVPROD, P_INSCESTA, V_PAISDEST,
                                       V_ESTADEST, V_PAISDEST, V_ESTADEST, V_MUNIDEST, V_LIQUIITEM, P_INIVALID, P_FILIAL, P_LANCTONF, V_CDGRPFISCSV, P_TIPOOPER,
                                       NULL, NULL, NULL, NULL, NULL, NULL, C_PRODUTO.IDORIGEMPROD);
                  ELSE
                     CONSULTA_ALIQUOTA(V_CDIMPOSTOICMS, w_S, P_EMPRESA, C_PRODUTO.CDARVPROD, P_INSCESTA, V_PAISDEST,
                                       V_ESTADEST, V_PAISDEST, V_ESTADEST, V_MUNIDEST, V_LIQUIITEM, P_INIVALID, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC, P_TIPOOPER,
                                       NULL, NULL, NULL, NULL, NULL, NULL, C_PRODUTO.IDORIGEMPROD);
                  END IF;
                  SELECT NVL(MAX(VRALIQUTMP),0)
                    INTO V_VRALIQUTMPDEST
                    FROM ALIQTEMP
                   WHERE (NRALIQTEMP = V_ALIQTEMP);
                  IF (V_VRALIQUTMPDEST <> 0) THEN
                     IF V_VRMVA > 0 THEN
                        V_VRBASECALCICMS :=  /*V_VRBASECALCICMS + */(V_VRBASECALCICMS * (V_VRMVA/100));
                     END IF;
                     V_IMPOSTOIT  :=  ROUND(V_VRBASECALCICMS * (V_VRPRODUTOBC/100), 2);
                     V_BASECALCTO :=  ROUND(((V_VRIMPOSTOICMS + V_IMPOSTOIT) / (V_VRALIQUTMPDEST/100)),5);  
                     UPDATE ITEMPROIMPOS
                        SET VRBASECALCIT = V_BASECALCTO,
                            VRIMPOSTOIT  = V_IMPOSTOIT,
                            VRIMPOSTOVISUIT = DECODE(V_IDPERVISIMPSCRE, 'S', V_IMPOSTOIT, DECODE(CDFISCALIT, '1', V_IMPOSTOIT,0))
                      WHERE (CDFILIAL     = P_FILIAL)              AND
                            (NRLANCTONF   = P_LANCTONF)            AND
                            (NRSEQITPROD  = C_PRODUTO.NRSEQITPROD) AND
                            (CDIMPOSTO    = C_PRODUTO.CDIMPOSTO)   AND
                            (NRITPROIMPOS = C_PRODUTO.NRITPROIMPOS);
                  END IF;
                  DELETE ALIQTEMP
                   WHERE NRALIQTEMP = V_ALIQTEMP;
               END IF;
            END IF;
         END IF;
         V_IMPOCONTAB := 0;
         IF (C_PRODUTO.IDTRATIMPO = w_A) THEN
            IF (((C_PRODUTO.IDIMPORECUP = w_S)  AND (C_PRODUTO.CDFISCALIT = w_1)) OR
                ((C_PRODUTO.IDIMPORECUP <> w_S) AND (C_PRODUTO.CDCCTBLPASS IS NOT NULL))) AND
               (V_CDIMPOSTRIB IS NULL) AND (C_PRODUTO.IDTIPCONTAB = w_D) THEN
               IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (NVL(V_IDORIGDESTNF, 'C') <> 'L') THEN
                  UPDATE ITEMPRODUTO
                  SET VRBRUTITEM = TRUNC((VRBRUTITEM + V_VRIMPOSTO),2)
                  WHERE CDFILIAL    = P_FILIAL   AND
                        NRLANCTONF  = P_LANCTONF AND
                        NRSEQITPROD = C_PRODUTO.NRSEQITPROD;
               ELSE
                  UPDATE ITEMPRODUTO
                  SET VRBRUTITEM = ROUND((VRBRUTITEM + V_VRIMPOSTO),5)
                  WHERE CDFILIAL    = P_FILIAL   AND
                        NRLANCTONF  = P_LANCTONF AND
                        NRSEQITPROD = C_PRODUTO.NRSEQITPROD;
               END IF;
            ELSE
               IF ((V_CDIMPOSTRIB IS NOT NULL) AND (C_PRODUTO.IDTRIMPSTII = w_0)) OR
                   (V_CDIMPOSTRIB IS NULL) THEN
                  IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (NVL(V_IDORIGDESTNF, 'C') <> 'L') THEN
                     UPDATE ITEMPRODUTO
                     SET VRBRUTITEM = TRUNC((VRBRUTITEM + V_VRIMPOSTO + C_PRODUTO.VRADICFECP), 2),
                         VRCONTITEM = TRUNC((VRCONTITEM + V_VRIMPOSTO + C_PRODUTO.VRADICFECP), 2)
                     WHERE CDFILIAL    = P_FILIAL   AND
                           NRLANCTONF  = P_LANCTONF AND
                           NRSEQITPROD = C_PRODUTO.NRSEQITPROD;
                  ELSE
                     UPDATE ITEMPRODUTO
                     SET VRBRUTITEM = ROUND(VRBRUTITEM + V_VRIMPOSTO + C_PRODUTO.VRADICFECP, 5),
                         VRCONTITEM = ROUND(VRCONTITEM + V_VRIMPOSTO + C_PRODUTO.VRADICFECP, 5)
                     WHERE CDFILIAL    = P_FILIAL   AND
                           NRLANCTONF  = P_LANCTONF AND
                           NRSEQITPROD = C_PRODUTO.NRSEQITPROD;
                  END IF;
               END IF;
            END IF;
         ELSIF (C_PRODUTO.IDTRATIMPO = w_D) THEN
            IF ((C_PRODUTO.IDIMPORECUP = w_S) AND (C_PRODUTO.CDFISCALIT = w_1)) OR
               ((C_PRODUTO.IDIMPORECUP <> w_S) AND (C_PRODUTO.CDCCTBLATIV IS NOT NULL)) AND
               (C_PRODUTO.IDTIPCONTAB = w_D) THEN
               IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (NVL(V_IDORIGDESTNF, 'C') <> 'L') THEN
                  UPDATE ITEMPRODUTO
                  SET VRBRUTITEM = TRUNC((VRBRUTITEM - V_VRIMPOSTO),2)
                  WHERE CDFILIAL    = P_FILIAL   AND
                        NRLANCTONF  = P_LANCTONF AND
                        NRSEQITPROD = C_PRODUTO.NRSEQITPROD;
               ELSE
                  UPDATE ITEMPRODUTO
                  SET VRBRUTITEM = ROUND(VRBRUTITEM - V_VRIMPOSTO,5)
                  WHERE CDFILIAL    = P_FILIAL   AND
                        NRLANCTONF  = P_LANCTONF AND
                        NRSEQITPROD = C_PRODUTO.NRSEQITPROD;
               END IF;
            ELSE
               IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (NVL(V_IDORIGDESTNF, 'C') <> 'L') THEN
                  UPDATE ITEMPRODUTO
                  SET VRBRUTITEM = TRUNC((VRBRUTITEM - V_VRIMPOSTO),2),
                      VRCONTITEM = TRUNC((VRCONTITEM - V_VRIMPOSTO),2)
                  WHERE CDFILIAL    = P_FILIAL   AND
                        NRLANCTONF  = P_LANCTONF AND
                        NRSEQITPROD = C_PRODUTO.NRSEQITPROD;
               ELSE
                  UPDATE ITEMPRODUTO
                  SET VRBRUTITEM = ROUND(VRBRUTITEM - V_VRIMPOSTO,5),
                      VRCONTITEM = ROUND(VRCONTITEM - V_VRIMPOSTO,5)
                  WHERE CDFILIAL    = P_FILIAL   AND
                        NRLANCTONF  = P_LANCTONF AND
                        NRSEQITPROD = C_PRODUTO.NRSEQITPROD;
               END IF;
            END IF;
         ELSIF (C_PRODUTO.IDTRATIMPO = w_R) THEN
            IF (C_PRODUTO.IDIMPORECUP = w_S) THEN
               IF (C_PRODUTO.CDCCTBLATIV IS NULL) OR
                  (C_PRODUTO.CDFISCALIT <> w_1) THEN
                  V_IMPOCONTAB := - V_VRIMPOSTO;
               END IF;
            ELSE
               IF (C_PRODUTO.CDCCTBLATIV IS NULL) THEN
                  V_IMPOCONTAB := - V_VRIMPOSTO;
               ELSE
                  IF C_PRODUTO.IDDESCRFONTE = 'N' THEN
                     V_IMPOCONTAB := - V_VRIMPOSTO;
                     UPDATE ITEMPRODUTO
                     SET VRBRUTITEM = ROUND(VRBRUTITEM - V_VRIMPOSTO,5)
                     WHERE CDFILIAL    = P_FILIAL   AND
                           NRLANCTONF  = P_LANCTONF AND
                           NRSEQITPROD = C_PRODUTO.NRSEQITPROD;
                  END IF;
               END IF;
            END IF;
            IF C_PRODUTO.IDTIPCONTAB = w_D THEN
               IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (NVL(V_IDORIGDESTNF, 'C') <> 'L') THEN
                  UPDATE ITEMPRODUTO
                  SET VRCONTITEM = TRUNC((VRCONTITEM + V_IMPOCONTAB),2)
                  WHERE CDFILIAL    = P_FILIAL   AND
                        NRLANCTONF  = P_LANCTONF AND
                        NRSEQITPROD = C_PRODUTO.NRSEQITPROD;
               ELSE
                  UPDATE ITEMPRODUTO
                  SET VRCONTITEM = VRCONTITEM + V_IMPOCONTAB
                  WHERE CDFILIAL    = P_FILIAL   AND
                        NRLANCTONF  = P_LANCTONF AND
                        NRSEQITPROD = C_PRODUTO.NRSEQITPROD;
               END IF;
            END IF;
         ELSIF C_PRODUTO.IDTRATIMPO = w_V THEN
            IF (V_ORIGDESTOP = w_L) THEN
               V_IDDESCIMPRECCONT := 'N';
               BEGIN
                  SELECT NVL(IDDESCIMPRECCOFI, 'N')
                    INTO V_IDDESCIMPRECCONT
                    FROM TIPOOPERAC
                   WHERE CDTIPOOPER   = P_TIPOOPER
                     AND IDORIGDESTOP = w_L
                     AND IDENTRSAIDOP = w_S;
               EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                     V_IDDESCIMPRECCONT := 'N';
               END;
            END IF;
            IF (C_PRODUTO.IDIMPORECUP = w_S) AND (V_IDORIGDESTNF = w_L) AND (V_IDDESCIMPRECCONT = 'N')THEN
               IF (C_PRODUTO.CDCCTBLPASS IS NOT NULL) AND
                  (C_PRODUTO.CDFISCALIT = w_1) THEN
                  V_IMPOCONTAB := - V_VRIMPOSTO;
               END IF;
            END IF;
            IF C_PRODUTO.IDTIPCONTAB = w_D THEN
               IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (NVL(V_IDORIGDESTNF, 'C') <> 'L') THEN
                  UPDATE ITEMPRODUTO
                  SET VRCONTITEM = TRUNC((VRCONTITEM + V_IMPOCONTAB),2)
                  WHERE CDFILIAL    = P_FILIAL   AND
                        NRLANCTONF  = P_LANCTONF AND
                        NRSEQITPROD = C_PRODUTO.NRSEQITPROD;
               ELSE
                  UPDATE ITEMPRODUTO
                  SET VRCONTITEM = VRCONTITEM + V_IMPOCONTAB
                  WHERE CDFILIAL    = P_FILIAL   AND
                        NRLANCTONF  = P_LANCTONF AND
                        NRSEQITPROD = C_PRODUTO.NRSEQITPROD;
               END IF;
            END IF;
         END IF;
      END LOOP;
      FOR C_ITEM IN (SELECT II.CDIMPOSTO,  I.NRSEQITPROD, II.NRITPROIMPOS
                  FROM ITEMPRODUTO I, ITEMPROIMPOS II
                  WHERE I.CDFILIAL    = P_FILIAL       AND
                        I.NRLANCTONF  = P_LANCTONF     AND
                        I.CDFILIAL    = II.CDFILIAL    AND
                        I.NRLANCTONF  = II.NRLANCTONF  AND
                        I.NRSEQITPROD = II.NRSEQITPROD ) LOOP
         V_ICMS := 'N';
         FOR C_ICMS IN (SELECT CDIMPOSTO
                          FROM IMPOSTONFE N, IMPOSTO I
                         WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                           AND N.CDIMPOSTONFE = '00'
                           AND I.CDIMPOSTO = C_ITEM.CDIMPOSTO)
         LOOP
            V_ICMS := 'S';
         END LOOP;
         IF (V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')  AND (V_ICMS = 'S') THEN
            UPDATE ITEMPROIMPOS
               SET VRCONTITIMP  = TRUNC(VRCONTITIMP,2),
                   VRBASECALCIT = TRUNC(VRBASECALCIT,2),
                   VRIMPOSTOIT  = TRUNC(VRIMPOSTOIT,2),
                   VRIMPOSTOVISUIT = TRUNC(VRIMPOSTOVISUIT,2)
             WHERE (CDFILIAL     = P_FILIAL) AND
                   (NRLANCTONF   = P_LANCTONF) AND
                   (CDIMPOSTO    = C_ITEM.CDIMPOSTO) AND
                   (NRSEQITPROD  = C_ITEM.NRSEQITPROD) AND
                   (NRITPROIMPOS = C_ITEM.NRITPROIMPOS);
         ELSE
           UPDATE ITEMPROIMPOS
               SET VRCONTITIMP  = ROUND(VRCONTITIMP,5),    
                   VRBASECALCIT = ROUND(VRBASECALCIT,2),
                   VRIMPOSTOIT  = ROUND(VRIMPOSTOIT,2),
                   VRIMPOSTOVISUIT = ROUND(VRIMPOSTOVISUIT,2)
             WHERE (CDFILIAL     = P_FILIAL) AND
                   (NRLANCTONF   = P_LANCTONF) AND
                   (CDIMPOSTO    = C_ITEM.CDIMPOSTO) AND
                   (NRSEQITPROD  = C_ITEM.NRSEQITPROD) AND
                   (NRITPROIMPOS = C_ITEM.NRITPROIMPOS);
         END IF;
      END LOOP;
   --FIM DA ATUALIZAÇÃO NA TABELA DE ITEMPROIMPOS
   --TOTALIZAÇÃO DOS IMPOSTOS
      DELETE IMPOSNFTOT
      WHERE (CDFILIAL = P_FILIAL) AND
            (NRLANCTONF = P_LANCTONF);
      FOR C_IMPOSNFTOT IN (SELECT IT.CDIMPOSTO
                           FROM ITEMPROIMPOS IT
                           WHERE (IT.CDFILIAL   = P_FILIAL) AND
                                 (IT.NRLANCTONF = P_LANCTONF)
                           GROUP BY IT.CDIMPOSTO) LOOP
         V_IMPOSTOIT  := 0;
         V_BASECALCIT := 0;
         SELECT NVL(SUM(IT.VRIMPOSTOIT),0), 
                NVL(SUM(IT.VRBASECALCIT),0), 
                NVL(SUM(IT.VRADICFECP),0)
         INTO   V_IMPOSTOIT, 
                V_BASECALCIT,
                V_VRADICFECPNFTOT
         FROM ITEMPROIMPOS IT, IMPOSTO I
         WHERE (IT.CDFILIAL   = P_FILIAL)               AND
               (IT.NRLANCTONF = P_LANCTONF)             AND
               (IT.CDIMPOSTO  = C_IMPOSNFTOT.CDIMPOSTO) AND
               (IT.CDIMPOSTO  = I.CDIMPOSTO);
         V_ICMS := 'N';
         FOR C_ICMS IN (SELECT CDIMPOSTO
                          FROM IMPOSTONFE N, IMPOSTO I
                         WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                           AND N.CDIMPOSTONFE = '00'
                           AND I.CDIMPOSTO = C_IMPOSNFTOT.CDIMPOSTO)
         LOOP
            V_ICMS := 'S';
         END LOOP;
         IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (V_ICMS = 'S') THEN
            INSERT INTO IMPOSNFTOT(CDFILIAL, NRLANCTONF, CDIMPOSTO, VRTOTIMPONF, VRTOTBCALCNF,
                                   VRADICFECP)
                           VALUES (P_FILIAL, P_LANCTONF, C_IMPOSNFTOT.CDIMPOSTO, TRUNC(V_IMPOSTOIT ,V_NRDECITOTANF), TRUNC(V_BASECALCIT, V_NRDECITOTANF),
                                   V_VRADICFECPNFTOT);
         ELSE
            INSERT INTO IMPOSNFTOT(CDFILIAL, NRLANCTONF, CDIMPOSTO, VRTOTIMPONF, VRTOTBCALCNF,
                                   VRADICFECP)
                           VALUES (P_FILIAL, P_LANCTONF, C_IMPOSNFTOT.CDIMPOSTO, ROUND(V_IMPOSTOIT ,V_NRDECITOTANF), ROUND(V_BASECALCIT, V_NRDECITOTANF),
                                   V_VRADICFECPNFTOT);
         END IF;
      END LOOP;
   --INCLUSÃO DOS IMPOSTOS DE CORPO DE NOTA EM CASO DE NOTA FISCAL--------------------------------------------------------------------------
      V_SEQUIMPOSTNF := w_01;
      DELETE IMPOSTONF
      WHERE (CDFILIAL   = P_FILIAL) AND
            (NRLANCTONF = P_LANCTONF);
      CONSULTA_INCIDENCIA(w_S, P_EMPRESA, '', P_INSCESTA, P_TIPOOPER, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC, NULL, V_IDINTEREST);
      FOR C_INCIDENCIA IN (SELECT DISTINCT (CDIMPOTEMP) AS CDIMPOTEMP, CDFISCTEMP, IDUTMUNIORIG,
                                  IDTRATIMPTMP, IDIMPORECUP, CDDETALHEPROD, IP.CDIMPOSTONFE
                           FROM INCITEMP IT, IMPOSTO IP
                           WHERE (IT.NRINCITEMP  = V_INCITEMP)       AND
                                 (IT.CDIMPOTEMP  = IP.CDIMPOSTO)     AND
                                 (IP.IDPRODNOTA  = w_C)) LOOP
         V_ALIQUTMP := 0;
         V_UTIBB    := 'N';
         V_SIMPLES  := 'N';
--integração fiscal especifica com Compass_Argentina atraves da importação de aliquota do imposto IBB
--A aliquota de imposto 03(ibb) sera cadastrada na tabela paramintegraibb e tera prioridade sobre o
-- cadastro de aliquota realizado em sistema
         /*VERIFICA CST POR IMPOSTO*/
         V_IMPOICMS := NULL;
         V_CDGRUPOFISCAUX := NULL;
         SELECT MAX(G.CDGRUPOFISC)
           INTO V_CDGRUPOFISCAUX
           FROM GRUPOFISCIMPFIL G,
                (SELECT CDFILIEMIT AS CDFILIAL
                   FROM NOTAFISCAL
                  WHERE CDFILIAL = P_FILIAL
                        AND NRLANCTONF = P_LANCTONF) F
          WHERE G.CDFILIAL = F.CDFILIAL
            AND NOT G.CDGRUPOFISC IS NULL
            AND G.CDIMPOSTO = C_INCIDENCIA.CDIMPOTEMP;
         IF V_IDORIGDESTNF = 'C' THEN
            SELECT NVL(MAX(G.CDGRUPOFISC), V_CDGRUPOFISCAUX)
              INTO V_CDGRUPOFISCAUX
              FROM GRFISIMPIECLIE G,
                   (SELECT CDCLIENTE
                      FROM NOTAFISCAL
                     WHERE CDFILIAL = P_FILIAL
                       AND NRLANCTONF = P_LANCTONF) N
             WHERE G.CDCLIENTE = N.CDCLIENTE
               AND G.CDEMPRESA = P_EMPRESA
               AND G.CDINSCESTA = P_INSCESTA
               AND NOT G.CDGRUPOFISC IS NULL
               AND G.CDIMPOSTO = C_INCIDENCIA.CDIMPOTEMP;
         ELSE
            SELECT NVL(MAX(G.CDGRUPOFISC), V_CDGRUPOFISCAUX)
              INTO V_CDGRUPOFISCAUX
              FROM GRFISIMPIEFORN G,
                  (SELECT CDFORNECED
                     FROM NOTAFISCAL
                    WHERE CDFILIAL = P_FILIAL
                      AND NRLANCTONF = P_LANCTONF) N
             WHERE G.CDFORNECED = N.CDFORNECED
               AND G.CDEMPRESA = P_EMPRESA
               AND G.CDINSCESTA = P_INSCESTA
               AND NOT G.CDGRUPOFISC IS NULL
               AND G.CDIMPOSTO = C_INCIDENCIA.CDIMPOTEMP;
         END IF;
         IF V_CDGRUPOFISCAUX IS NULL THEN
            CONSULTA_CST_NFE(w_S, P_EMPRESA, '', P_INSCESTA, P_TIPOOPER, V_CDGRUPOFISC,C_INCIDENCIA.CDIMPOTEMP, V_IDINTEREST, V_IDINTERNA, P_FILIAL, P_LANCTONF, '', V_CDSITTRIBTMP, V_IDMODBCNFE, V_IDMODBCSTNFE, V_CDTPCRPICOSTNFE, V_CDNATUBCPCSTNFE, V_IDMOTIDESSTNFE);
         ELSE
            CONSULTA_CST_NFE(w_S, P_EMPRESA, '', P_INSCESTA, P_TIPOOPER, V_CDGRUPOFISCAUX,C_INCIDENCIA.CDIMPOTEMP, V_IDINTEREST, V_IDINTERNA, P_FILIAL, P_LANCTONF, '', V_CDSITTRIBTMP, V_IDMODBCNFE, V_IDMODBCSTNFE, V_CDTPCRPICOSTNFE, V_CDNATUBCPCSTNFE, V_IDMOTIDESSTNFE);
         END IF;
         V_CDSIMPLESNACIONAL := NULL;
         V_CDFAIXA := NULL;
         /*SIMPLES NACIONAL*/
         IF (V_CDSITUCRT <> '3') THEN
            CALCULA_ALIQUOTA_SN(P_EMPRESA, 
                                P_TIPOOPER, 
                                P_INIVALID, 
                                SUBSTR(V_FISOPEITEM, 2, 3), 
                                C_INCIDENCIA.CDIMPOSTONFE, 
                                V_VRSUBLIMITESN,
                                'N',
                                V_RBT12,
                                V_RBA,
                                V_CDSIMPLESNACIONAL,
                                V_CDFAIXA,
                                V_VRALIQSIMPLES);
            IF (V_CDFAIXA IS NOT NULL) OR ((C_INCIDENCIA.CDIMPOSTONFE IN ('00', '31')) AND (V_RBT12 >= 3600000)) THEN
               V_ALIQUTMP     := V_VRALIQSIMPLES;
               V_NRALIQTEMP   := 0;
               V_PARDEDTMP    := 0;
               V_PREDBCTMP    := 0;
               V_TRATIMPST    := w_0;
               V_PBCSUBTRIB   := 0;
               V_IDPMCBASECAL := 'N';
               V_SIMPLES      := 'S';
            END IF;
         END IF;
         IF C_INCIDENCIA.CDIMPOTEMP = '03' THEN
            IF V_IDORIGDESTNF = 'C' THEN
               V_ALIQUTMP := NULL;
               V_DTVINGENTE := NVL(V_DTINIREFEFAT, P_INIVALID);
               SELECT NVL(MAX(VRALIQUOTAIBB),NULL)
               INTO   V_ALIQUTMP
               FROM PARAMINTEGRAIBB
               WHERE CDCLIENTE = P_CLIENTE AND
                     V_DTVINGENTE BETWEEN DTVIGINICIALIBB AND DTVIGFINALIBB;
               IF V_ALIQUTMP IS NOT NULL THEN
                  V_NRALIQTEMP   := 0;
                  V_PARDEDTMP    := 0;
                  V_PREDBCTMP    := 0;
                  V_TRATIMPST    := w_0;
                  V_PBCSUBTRIB   := 0;
                  V_IDPMCBASECAL := 'N';
                  V_UTIBB        := 'S';
               END IF;
            END IF;
         END IF;
         IF (V_SIMPLES = 'N') THEN
            V_CDSIMPLESNACIONAL := NULL;
            V_CDFAIXA := NULL;
            IF (V_UTIBB = 'N')  THEN
               V_ALIQUTMP  := 0;
               V_PARDEDTMP := 0;
               V_PREDBCTMP := 0;
               V_ALIQUTMP  := 0;
               IF C_INCIDENCIA.IDUTMUNIORIG = w_D THEN
                  /* CONSIDERA O MUNICIPIO DE DESTINO */
                  CONSULTA_ALIQUOTA(C_INCIDENCIA.CDIMPOTEMP, w_S, P_EMPRESA, '', P_INSCESTA, V_PAISORIG,
                                    V_ESTAORIG, V_PAISDEST, V_ESTADEST, V_MUNIDEST, V_LIQUIITEM, P_INIVALID, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC, P_TIPOOPER);
               ELSE
                  /* CONSIDERA O MUNICIPIO DE ORIGEM*/
                  CONSULTA_ALIQUOTA(C_INCIDENCIA.CDIMPOTEMP, w_S, P_EMPRESA, '', P_INSCESTA, V_PAISORIG,
                                    V_ESTAORIG, V_PAISDEST, V_ESTADEST, V_MUNIORIG, V_LIQUIITEM, P_INIVALID, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC, P_TIPOOPER);
               END IF;
               SELECT MAX(NRALIQTEMP), MAX(VRPARDEDTMP),            MAX(VRPREDBCTMP),
                      MAX(VRALIQUTMP), NVL(MAX(IDTRIMPSTTMP), w_0), NVL(MAX(VRPBCSTTMP),0)
               INTO   V_NRALIQTEMP, V_PARDEDTMP, V_PREDBCTMP,
                      V_ALIQUTMP,   V_TRATIMPST, V_PBCSUBTRIB
               FROM ALIQTEMP
               WHERE (NRALIQTEMP = V_ALIQTEMP);
               IF (V_ALIQUTMP IS NULL) THEN
                  V_ALIQUTMP := 0;
               END IF;
            END IF;
         END IF;
         V_PRODUENCARGO := 0;
         SELECT SUM(VRITEMENCA) AS VRSOMAITEM
         INTO   V_SOMAITEM
         FROM ITEMENCARGO IE, ENCARGO EN, BASECALC BC
         WHERE (IE.CDFILIAL   = P_FILIAL)                AND
               (IE.NRLANCTONF = P_LANCTONF)              AND
               (EN.CDENCARGO  = IE.CDENCARGO)            AND
               (BC.CDENCARGO  = IE.CDENCARGO)            AND
               (BC.CDIMPOSTO  = C_INCIDENCIA.CDIMPOTEMP) AND
               (EN.IDENCARGO  = w_A);
         SELECT SUM(VRITEMENCA) AS VRDESCITEM
         INTO   V_DESCITEM
         FROM ITEMENCARGO IE, ENCARGO EN, BASECALC BC
         WHERE (IE.CDFILIAL   = P_FILIAL)                AND
               (IE.NRLANCTONF = P_LANCTONF)              AND
               (EN.CDENCARGO  = IE.CDENCARGO)            AND
               (BC.CDENCARGO  = IE.CDENCARGO)            AND
               (BC.CDIMPOSTO  = C_INCIDENCIA.CDIMPOTEMP) AND
               (EN.IDENCARGO  = w_D);
         IF V_SOMAITEM IS NULL THEN
            V_SOMAITEM := 0;
         END IF;
         IF V_DESCITEM IS NULL THEN
            V_DESCITEM := 0;
         END IF;
         IF (V_ALIQUTMP IS NULL) THEN --VERIFICAR VALOR DA ALÍQUOTA P/ IMPOSTO RECUPERÁVEL COM COD. FISCAL = 3
            V_ALIQUTMP := 0;
         END IF;
         IF (V_PREDBCTMP IS NULL) THEN
            V_PREDBCTMP := 0;
         END IF;
         IF (V_PARDEDTMP IS NULL) THEN
             V_PARDEDTMP := 0;
         END IF;
         V_PRODUENCARGO := V_SOMAITEM - V_DESCITEM;
         V_TAXABASECALC := (100 - V_PREDBCTMP)/100;
         V_TAXAALIQUOTA := (V_ALIQUTMP/100);
         V_TAXABCSUBSTR := 1 + (V_PBCSUBTRIB/100);
         V_BASECALCIT   := (V_LIQUIDO + V_PRODUENCARGO) * V_TAXABASECALC;
         V_PERDBCALC    := 100 - V_PREDBCTMP;
         IF V_PBCSUBTRIB > 0 THEN
            V_BASECALCIT := (V_BASECALCIT * V_TAXABCSUBSTR);
            V_PREDBCTMP  := V_PBCSUBTRIB;
            V_PERDBCALC  := 0;
         END IF;
         V_CONTIMPO     := V_BASECALCIT;
         V_IMPOSTOIT    := (V_BASECALCIT * V_TAXAALIQUOTA) - V_PARDEDTMP;
         IF V_BASECALCIT < 0 THEN
            V_BASECALCIT := 0;
         END IF;
         V_CONTABCALC := (V_LIQUIDO + V_PRODUENCARGO) - ((V_LIQUIDO + V_PRODUENCARGO) * V_TAXABASECALC);
         V_PERDBCALC  := 100 - V_PREDBCTMP;
         IF V_IMPOSTOIT < 0 THEN
            V_IMPOSTOIT := 0;
         END IF;
         V_ICMS := 'N';
         FOR C_ICMS IN (SELECT CDIMPOSTO
                          FROM IMPOSTONFE N, IMPOSTO I
                         WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                           AND N.CDIMPOSTONFE = '00'
                           AND I.CDIMPOSTO = C_INCIDENCIA.CDIMPOTEMP)
         LOOP
            V_ICMS := 'S';
         END LOOP;
         IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (V_ICMS = 'S') THEN
            INSERT INTO IMPOSNFTOT(CDFILIAL, NRLANCTONF, CDIMPOSTO              , VRTOTIMPONF                              , VRTOTBCALCNF)
                           VALUES (P_FILIAL, P_LANCTONF, C_INCIDENCIA.CDIMPOTEMP, TRUNC(NVL(V_IMPOSTOIT,0), V_NRDECITOTANF), TRUNC(NVL(V_BASECALCIT,0),V_NRDECITOTANF));
         ELSE
            INSERT INTO IMPOSNFTOT(CDFILIAL, NRLANCTONF, CDIMPOSTO              , VRTOTIMPONF                              , VRTOTBCALCNF)
                           VALUES (P_FILIAL, P_LANCTONF, C_INCIDENCIA.CDIMPOTEMP, ROUND(NVL(V_IMPOSTOIT,0), V_NRDECITOTANF), ROUND(NVL(V_BASECALCIT,0),V_NRDECITOTANF));
         END IF;
         IF (C_INCIDENCIA.IDIMPORECUP = w_S) OR (C_INCIDENCIA.IDIMPORECUP <> w_S AND V_ALIQUTMP <> 0) THEN
            IF (C_INCIDENCIA.IDIMPORECUP = w_S) AND
               (C_INCIDENCIA.CDFISCTEMP <> w_1) THEN
               V_BASECALCIT := 0;
               V_ALIQUTMP   := 0;
               V_IMPOSTOIT  := 0;
               V_PREDBCTMP  := 0;
               V_PARDEDTMP  := 0;
            END IF;
            V_ICMS := 'N';
            FOR C_ICMS IN (SELECT CDIMPOSTO
                             FROM IMPOSTONFE N, IMPOSTO I
                            WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                              AND N.CDIMPOSTONFE = '00'
                              AND I.CDIMPOSTO = C_INCIDENCIA.CDIMPOTEMP)
            LOOP
               V_ICMS := 'S';
            END LOOP;
            IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (V_ICMS = 'S') THEN
               INSERT INTO IMPOSTONF(
                  CDFILIAL, NRLANCTONF, CDIMPOSTO, NRIMPOSNF, VRCONTABILNF, VRPERREDBCNF, VRBASECALCNF,
                  VRALIQNF, VRPARDEDNF, VRIMPOSTONF, CDFISCALNF, IDTRIMPOSTNF, CDSITUTRIBIMNFE,  CDTPCREDPICONF, CDNATUBCALPCNF, IDMOTDESONERANF)
               VALUES(
                  P_FILIAL, P_LANCTONF, C_INCIDENCIA.CDIMPOTEMP, V_SEQUIMPOSTNF, TRUNC(V_CONTIMPO,2), V_PREDBCTMP,
                  TRUNC(V_BASECALCIT,2), V_ALIQUTMP, TRUNC(V_PARDEDTMP,2), TRUNC(V_IMPOSTOIT,2), C_INCIDENCIA.CDFISCTEMP, V_TRATIMPST, V_CDSITTRIBTMP, V_CDTPCRPICOSTNFE, V_CDNATUBCPCSTNFE, V_IDMOTIDESSTNFE);
            ELSE
               INSERT INTO IMPOSTONF(
                  CDFILIAL, NRLANCTONF, CDIMPOSTO, NRIMPOSNF, VRCONTABILNF, VRPERREDBCNF, VRBASECALCNF,
                  VRALIQNF, VRPARDEDNF, VRIMPOSTONF, CDFISCALNF, IDTRIMPOSTNF, CDSITUTRIBIMNFE, CDTPCREDPICONF, CDNATUBCALPCNF, IDMOTDESONERANF)
               VALUES(
                  P_FILIAL, P_LANCTONF, C_INCIDENCIA.CDIMPOTEMP, V_SEQUIMPOSTNF, ROUND(V_CONTIMPO,2), V_PREDBCTMP,
                  ROUND(V_BASECALCIT,2), V_ALIQUTMP, ROUND(V_PARDEDTMP,2), ROUND(V_IMPOSTOIT,2), C_INCIDENCIA.CDFISCTEMP, V_TRATIMPST, V_CDSITTRIBTMP, V_CDTPCRPICOSTNFE, V_CDNATUBCPCSTNFE, V_IDMOTIDESSTNFE);
            END IF;
            V_SEQUIMPOSTNF := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_SEQUIMPOSTNF) + 1)),2,0);
            IF (C_INCIDENCIA.IDIMPORECUP = w_S) AND
               (V_PREDBCTMP > 0) AND
               (C_INCIDENCIA.CDFISCTEMP = w_1) THEN
               INSERT INTO IMPOSTONF(
                  CDFILIAL, NRLANCTONF, CDIMPOSTO, NRIMPOSNF, VRCONTABILNF, VRPERREDBCNF, VRBASECALCNF,
                  VRALIQNF, VRPARDEDNF, VRIMPOSTONF, CDFISCALNF, CDSITUTRIBIMNFE,
				      CDTPCREDPICONF, CDNATUBCALPCNF, IDMOTDESONERANF)
               VALUES(
                  P_FILIAL, P_LANCTONF, C_INCIDENCIA.CDIMPOTEMP, V_SEQUIMPOSTNF, V_CONTABCALC, V_PERDBCALC,
                  0, 0, V_PARDEDTMP, 0, w_2, V_CDSITTRIBTMP, V_CDTPCRPICOSTNFE, V_CDNATUBCPCSTNFE, V_IDMOTIDESSTNFE);
               V_SEQUIMPOSTNF := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_SEQUIMPOSTNF) + 1)),2,0);
            END IF;
         END IF;
         DELETE ALIQTEMP
         WHERE NRALIQTEMP = V_ALIQTEMP;
      END LOOP;
      V_TOTIMPOCONT := 0;
      V_TOTIMPOBRUT := 0;
      /*CONTABILIZACAO DOS IMPOSTOS DE CORPO DE NOTA*/
      FOR C_IMPOSCONTAB IN (SELECT VRTOTIMPONF, IDIMPORECUP, CDCCTBLPASS, CDCCTBLATIV,
                                   IDTRATIMPO,  CDFISCTEMP, IDTIPCONTAB
                            FROM IMPOSNFTOT INF, IMPOSTO IP, INCITEMP IT
                            WHERE CDFILIAL      = P_FILIAL      AND
                                  NRLANCTONF    = P_LANCTONF    AND
                                  IP.CDIMPOSTO  = INF.CDIMPOSTO AND
                                  IT.CDIMPOTEMP = IP.CDIMPOSTO  AND
                                  IT.NRINCITEMP = V_INCITEMP    AND
                                  IP.IDPRODNOTA = w_C) LOOP
         IF (C_IMPOSCONTAB.IDTRATIMPO = w_A) THEN
            IF C_IMPOSCONTAB.IDTIPCONTAB = w_D THEN
               V_TOTIMPOCONT := V_TOTIMPOCONT + C_IMPOSCONTAB.VRTOTIMPONF;
            END IF;
            V_TOTIMPOBRUT := V_TOTIMPOBRUT + C_IMPOSCONTAB.VRTOTIMPONF;
         ELSIF (C_IMPOSCONTAB.IDTRATIMPO = w_D) THEN
            IF C_IMPOSCONTAB.IDTIPCONTAB = w_D THEN
               V_TOTIMPOCONT := V_TOTIMPOCONT - C_IMPOSCONTAB.VRTOTIMPONF;
            END IF;
            V_TOTIMPOBRUT := V_TOTIMPOBRUT - C_IMPOSCONTAB.VRTOTIMPONF;
         ELSIF (C_IMPOSCONTAB.IDTRATIMPO = w_R) THEN
            IF (C_IMPOSCONTAB.IDIMPORECUP = w_S) THEN
               IF (C_IMPOSCONTAB.CDCCTBLATIV IS NULL) OR
                  (C_IMPOSCONTAB.CDFISCTEMP <> w_1) AND (C_IMPOSCONTAB.IDTIPCONTAB = w_D) THEN
                  V_TOTIMPOCONT := V_TOTIMPOCONT - C_IMPOSCONTAB.VRTOTIMPONF;
               END IF;
            ELSE
               IF (C_IMPOSCONTAB.CDCCTBLATIV IS NULL) AND (C_IMPOSCONTAB.IDTIPCONTAB = w_D) THEN
                  V_TOTIMPOCONT := V_TOTIMPOCONT - C_IMPOSCONTAB.VRTOTIMPONF;
               END IF;
            END IF;
         END IF;
      END LOOP;
      IF (V_TOTIMPOBRUT <> 0) OR (V_TOTIMPOCONT <> 0) THEN
         FOR C_ITPRODUTO IN (SELECT NRSEQITPROD, (VRTOTAITEM - VRDESCITEM) AS VRLIQUIDO
                             FROM ITEMPRODUTO
                             WHERE CDFILIAL   = P_FILIAL AND
                                   NRLANCTONF = P_LANCTONF)LOOP
            IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (NVL(V_IDORIGDESTNF, 'C') <> 'L') THEN
               UPDATE ITEMPRODUTO
               SET VRBRUTITEM = TRUNC(VRBRUTITEM + ((V_TOTIMPOBRUT / V_LIQUIDO) * C_ITPRODUTO.VRLIQUIDO),2),
                   VRCONTITEM = TRUNC(VRCONTITEM + ((V_TOTIMPOCONT / V_LIQUIDO) * C_ITPRODUTO.VRLIQUIDO),2)
               WHERE CDFILIAL    = P_FILIAL   AND
                     NRLANCTONF  = P_LANCTONF AND
                     NRSEQITPROD = C_ITPRODUTO.NRSEQITPROD;
            ELSE
               UPDATE ITEMPRODUTO
               SET VRBRUTITEM = ROUND(VRBRUTITEM + ((V_TOTIMPOBRUT / V_LIQUIDO) * C_ITPRODUTO.VRLIQUIDO),5),
                   VRCONTITEM = ROUND(VRCONTITEM + ((V_TOTIMPOCONT / V_LIQUIDO) * C_ITPRODUTO.VRLIQUIDO),5)
               WHERE CDFILIAL    = P_FILIAL   AND
                     NRLANCTONF  = P_LANCTONF AND
                     NRSEQITPROD = C_ITPRODUTO.NRSEQITPROD;
            END IF;
         END LOOP;
      END IF;
      DELETE INCITEMP
      WHERE NRINCITEMP = V_INCITEMP;
      SELECT SUM(NVL(VRBCICMSSTRETIDO,0)), SUM(NVL(VRICMSSTRETIDO,0))
        INTO V_BCICMSRET, V_ICMSRET
        FROM ITEMPROIMPOS
       WHERE CDFILIAL = P_FILIAL
         AND NRLANCTONF = P_LANCTONF;
      IF V_ICMSRET <> 0 THEN
         SELECT COUNT(*)
           INTO V_EXISTDSDADOSADIC
           FROM DADOSADIC
          WHERE CDFILIAL = P_FILIAL
            AND NRLANCTONF = P_LANCTONF
            AND DSDADOADIC LIKE 'ICMS retido anteriormente por substituição tributária: BC %';
         IF V_EXISTDSDADOSADIC = 0 THEN
            /*PREENCHE AS MENSAGENS ATRELADAS A INSCRICAO ESTADUAL*/
            INSERT INTO DADOSADIC(CDFILIAL, NRLANCTONF, NRDADOADIC, DSDADOADIC)
                           VALUES(P_FILIAL, P_LANCTONF, V_DADOADIC, 'ICMS retido anteriormente por substituição tributária: BC '||DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(V_BCICMSRET, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(V_BCICMSRET, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(V_BCICMSRET, 2), '9999999999999.99')))|| ' Valor '|| DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(V_ICMSRET, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(V_ICMSRET, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(V_ICMSRET, 2), '9999999999999.99'))));
            V_DADOADIC := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_DADOADIC) + 1)),3,0);
         ELSE
            UPDATE DADOSADIC
               SET DSDADOADIC = 'ICMS retido anteriormente por substituição tributária: BC '||DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(V_BCICMSRET, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(V_BCICMSRET, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(V_BCICMSRET, 2), '9999999999999.99')))|| ' Valor '|| DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(V_ICMSRET, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(V_ICMSRET, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(V_ICMSRET, 2), '9999999999999.99')))
             WHERE CDFILIAL = P_FILIAL
               AND NRLANCTONF = P_LANCTONF
               AND DSDADOADIC LIKE 'ICMS retido anteriormente por substituição tributária: BC %';
         END IF;
      END IF;
      FOR C_ITEMPRODUTO_DIFAL IN (SELECT NRSEQITPROD
                                    FROM ITEMPRODUTO
                                   WHERE CDFILIAL = P_FILIAL
                                     AND NRLANCTONF = P_LANCTONF) LOOP
         GERA_ICMS_INTERESTADUAL(P_FILIAL, P_LANCTONF, C_ITEMPRODUTO_DIFAL.NRSEQITPROD, P_INIVALID);
      END LOOP;
      SELECT MAX(NRDADOADIC)
        INTO V_DADOADIC
        FROM DADOSADIC
       WHERE (CDFILIAL = P_FILIAL) 
         AND (NRLANCTONF = P_LANCTONF);
      IF (V_DADOADIC IS NULL) THEN
         V_DADOADIC := W_001;
      ELSE
         V_DADOADIC := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_DADOADIC) + 1)),3,0);
      END IF;
-- FIM DA TOTALIZAÇÃO DOS IMPOSTOS
-- NOTAS COM DOCUMENTO DE ORIGEM
   ELSIF (P_TIPOOPER IN ('07','10')) OR (V_IDOPERDEVONF = w_S) OR (V_ESTORNOCANC = w_S) THEN
      DELETE FROM ITEMPROIMPOS
      WHERE CDFILIAL   = P_FILIAL AND
            NRLANCTONF = P_LANCTONF;
      DELETE FROM ITEMPROIMPOSORIG
      WHERE CDFILIAL   = P_FILIAL AND
            NRLANCTONF = P_LANCTONF;
      V_VRTOTALIPI := 0;
      V_VRTOTALICMSST := 0;
      V_CDENCARGOICMST := NULL;
      V_CDENQLEGALIPI := NULL;
      V_CDCEST := NULL;
      SELECT NVL(MAX(IDGERICMSTDESPA), 'N'), MAX(CDENCARGOICMST), NVL(MAX(IDPEINFICMSTDEME), 'N'), NVL(MAX(IDGERIPIDESPA), 'N')
        INTO V_IDGERICMSTDESPA, V_CDENCARGOICMST, V_IDPEINFICMSTDEME, V_IDGERIPIDESPA
        FROM TIPOOPERAC
       WHERE IDENTRSAIDOP = 'S'
         AND CDTIPOOPER = P_TIPOOPER;
      SELECT MAX(IDUTCTRLFISSAID)
        INTO V_IDUTCTRLFISSAID
        FROM PARAMGERAL;
      SELECT MAX(IDUTCTRLFISSAID)
        INTO V_IDUTCTRLFISFIL
        FROM PARAMFILIAL
       WHERE CDFILIAL = V_CDFILIEMIT;
      IF V_IDUTCTRLFISSAID = 'S' THEN
         V_IDUTCTRLFIS := 'S';
      ELSE
         IF V_IDUTCTRLFISFIL = 'S' THEN
            V_IDUTCTRLFIS := 'S';
         ELSE
            V_IDUTCTRLFIS := 'N';
         END IF;
      END IF;
      V_UPDENCIMPXML := 'N';
      FOR C_ITEMPROD IN (SELECT IT.*, P.CDARVPROD
                         FROM ITEMPRODUTO IT, PRODUTO P
                         WHERE IT.CDFILIAL   = P_FILIAL   AND
                               IT.NRLANCTONF = P_LANCTONF AND
                               IT.CDPRODUTO  = P.CDPRODUTO) LOOP
         V_LIQUIITEM := C_ITEMPROD.VRTOTAITEM - C_ITEMPROD.VRDESCITEM;
         CONSULTA_CST(w_S, P_EMPRESA, C_ITEMPROD.CDARVPROD, P_INSCESTA, P_TIPOOPER, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC, V_IDINTEREST, V_IDINTERNA, NULL, C_ITEMPROD.IDORIGEMPROD);
         SELECT MAX(CDSITTRIBTMP)
         INTO   V_SITUTRIBPR
         FROM CSTTEMP
         WHERE (NRCSTTEMP = V_CSTTEMP);
         IF (V_IDOPERDEVONF <> w_S) THEN
            FOR C_CSTTEMP IN (SELECT DSMENSCSTTMP
                              FROM CSTTEMP
                              WHERE (NRCSTTEMP = V_CSTTEMP) AND
                                    (DSMENSCSTTMP IS NOT NULL) AND
                                    (NOT EXISTS(SELECT DSDADOADIC
                                                FROM DADOSADIC
                                                WHERE (CDFILIAL   = P_FILIAL)   AND
                                                      (NRLANCTONF = P_LANCTONF) AND
                                                      (DSDADOADIC LIKE CSTTEMP.DSMENSCSTTMP || '%')))) LOOP
               IF NOT (C_CSTTEMP.DSMENSCSTTMP IS NULL) THEN
                  /*PREENCHE AS MENSAGENS ATRELADAS AO CST*/
                  INSERT INTO DADOSADIC(CDFILIAL, NRLANCTONF, NRDADOADIC, DSDADOADIC)
                                 VALUES(P_FILIAL, P_LANCTONF, V_DADOADIC, C_CSTTEMP.DSMENSCSTTMP);
                  V_DADOADIC := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_DADOADIC) + 1)),3,0);
               END IF;
            END LOOP;
         END IF;
         CONSULTA_CFOP(w_S, P_EMPRESA, C_ITEMPROD.CDARVPROD, P_INSCESTA, P_TIPOOPER, V_PAISORIG,
                        V_ESTAORIG, V_PAISCFOP, V_ESTACFOP, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC, P_INIVALID, C_ITEMPROD.IDORIGEMPROD);
         FOR C_CFOPTEMP IN (SELECT DSMENSCFOTMP
                            FROM CFOPTEMP
                            WHERE (NRCFOPTEMP = V_CFOPTEMP) AND
                                  (DSMENSCFOTMP IS NOT NULL) AND
                                  (NOT EXISTS(SELECT DSDADOADIC
                                              FROM DADOSADIC
                                              WHERE (CDFILIAL   = P_FILIAL)   AND
                                                    (NRLANCTONF = P_LANCTONF) AND
                                                    (DSDADOADIC LIKE CFOPTEMP.DSMENSCFOTMP || '%')))) LOOP
            IF NOT(C_CFOPTEMP.DSMENSCFOTMP IS NULL) THEN
               /*PREENCHE AS MENSAGENS ATRELADAS AO CFOP*/
               INSERT INTO DADOSADIC(CDFILIAL, NRLANCTONF, NRDADOADIC, DSDADOADIC)
                              VALUES(P_FILIAL, P_LANCTONF, V_DADOADIC, C_CFOPTEMP.DSMENSCFOTMP);
               V_DADOADIC := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_DADOADIC) + 1)),3,0);
            END IF;
         END LOOP;
         IF (NVL(V_CFOPINFUSU, 'N') <> 'S') AND (V_CDFISCOPERREGRA IS NOT NULL) THEN
            V_DSCDFISOPEITREGRA := SUBSTR(DESCRICAO_CFOP(V_CDFISCOPERREGRA),1,45);
         END IF;
         IF (V_DSCDFISOPEITREGRA IS NOT NULL) THEN
            UPDATE NOTAFISCAL
               SET DSCDFISOPENF = V_DSCDFISOPEITREGRA
             WHERE CDFILIAL   = P_FILIAL   AND
                   NRLANCTONF = P_LANCTONF;
         ELSE
            UPDATE NOTAFISCAL
               SET DSCDFISOPENF = (SELECT MAX(DSCFOPTMP)
                                     FROM CFOPTEMP
                                    WHERE NRCFOPTEMP = V_CFOPTEMP)
             WHERE CDFILIAL   = P_FILIAL
               AND NRLANCTONF = P_LANCTONF;
         END IF;
         SELECT MAX(CDFISOPETMP), MAX(CDSUFCFOPTMP),SUBSTR(MAX(DSCFOPTMP),1,50)
         INTO   V_FISOPEITEM,     V_SUFXCFOPPR,     V_DSCDFISOPEIT
         FROM CFOPTEMP
         WHERE NRCFOPTEMP = V_CFOPTEMP;
         CONSULTA_CSOSN('S', P_EMPRESA, C_ITEMPROD.CDARVPROD, P_INSCESTA, P_TIPOOPER, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC,V_IDINTEREST, V_CDFISCOPERSN);
         IF (NVL(V_CFOPINFUSU, 'N') <> 'S') AND (V_CDFISCOPERREGRA IS NOT NULL) THEN
            V_FISOPEITEM := NVL(V_CDFISCOPERREGRA, V_FISOPEITEM);
            V_DSCDFISOPEITREGRA := SUBSTR(DESCRICAO_CFOP(V_CDFISCOPERREGRA),1,45);
         END IF;
         UPDATE ITEMPRODUTO
         SET CDFISOPEITEM = V_FISOPEITEM,
             CDSUFXCFOPPR = V_SUFXCFOPPR,
             CDSITUTRIBPR  = NVL(V_SITUTRIBPR, C_ITEMPROD.CDSITUTRIBPR),
             DSCDFISOPEIT = V_DSCDFISOPEIT,
             CDFISCOPERSN = V_CDFISCOPERSN
         WHERE CDFILIAL    = P_FILIAL     AND
               NRLANCTONF  = P_LANCTONF   AND
               NRSEQITPROD = C_ITEMPROD.NRSEQITPROD;
         IF V_IDOPERDEVONF = w_S THEN
            FOR C_ITEMNOTAFISC IN (SELECT CDFILIALIT, NRLANCTONFIT
                                   FROM ITEMNOTAFISC
                                   WHERE CDFILIAL   = P_FILIAL AND
                                         NRLANCTONF = P_LANCTONF) LOOP
               IF V_IDDEVOLIST = w_S THEN /*SE A NOTA POSSUI VARIOS DOCUMENTOS DE ORIGEM*/
                  SELECT SUM(I.QTITEMPROD)
                    INTO V_SOMAQITEMPROD
                    FROM ITEMPRODUTO I
                   WHERE CDFILIAL    = C_ITEMNOTAFISC.CDFILIALIT                                               AND
                         NRLANCTONF  = C_ITEMNOTAFISC.NRLANCTONFIT                                             AND
                         CDPRODUTO   = C_ITEMPROD.CDPRODUTO                                                    AND
                         ROUND(VRUNITITEM, V_NRDECITOTANF) = ROUND(C_ITEMPROD.VRUNITITEM, V_NRDECITOTANF)      AND
                         (NVL(NRLOTEESTQ, ' ')  = (NVL(C_ITEMPROD.NRLOTEESTQ, ' ')))                           AND
                         (NVL(NRSUBLOTE , ' ')  = (NVL(C_ITEMPROD.NRSUBLOTE , ' ')));
                  SELECT NVL(MAX(C_ITEMPROD.QTITEMPROD / V_SOMAQITEMPROD),1) AS VRFATOCONV,
                         NVL(MAX(VRBRUTITEM),0), NVL(MAX(VRCONTITEM),0)
                  INTO   V_VRFATOCONV, V_VRBRUTO, V_VRCONTAB
                  FROM ITEMPRODUTO I
                  WHERE CDFILIAL    = C_ITEMNOTAFISC.CDFILIALIT                                               AND
                        NRLANCTONF  = C_ITEMNOTAFISC.NRLANCTONFIT                                             AND
                        CDPRODUTO   = C_ITEMPROD.CDPRODUTO                                                    AND
                        ROUND(VRUNITITEM, V_NRDECITOTANF) = ROUND(C_ITEMPROD.VRUNITITEM, V_NRDECITOTANF)      AND
                        (NVL(NRLOTEESTQ, ' ')  = (NVL(C_ITEMPROD.NRLOTEESTQ, ' ')))                           AND
                        (NVL(NRSUBLOTE , ' ')  = (NVL(C_ITEMPROD.NRSUBLOTE , ' ')));
                  IF V_CDINTEGRACAO IS NOT NULL THEN
                     IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (NVL(V_IDORIGDESTNF, 'C') <> 'L') THEN
                        UPDATE ITEMPRODUTO
                        SET VRCONTITEM = TRUNC((V_VRCONTAB * V_VRFATOCONV),2),
                            VRBRUTITEM = TRUNC((V_VRBRUTO * V_VRFATOCONV),2)
                        WHERE CDFILIAL    = P_FILIAL                                                          AND
                              NRLANCTONF  = P_LANCTONF                                                        AND
                              CDPRODUTO   = C_ITEMPROD.CDPRODUTO                                              AND
                             ROUND(VRUNITITEM, V_NRDECITOTANF) = ROUND(C_ITEMPROD.VRUNITITEM, V_NRDECITOTANF) AND
                             (NVL(NRLOTEESTQ, ' ')  = (NVL(C_ITEMPROD.NRLOTEESTQ, ' ')))                      AND
                             (NVL(NRSUBLOTE , ' ')  = (NVL(C_ITEMPROD.NRSUBLOTE , ' ')));
                     ELSE
                        UPDATE ITEMPRODUTO
                        SET VRCONTITEM = ROUND(V_VRCONTAB * V_VRFATOCONV,5),
                            VRBRUTITEM = ROUND(V_VRBRUTO * V_VRFATOCONV,5)
                        WHERE CDFILIAL    = P_FILIAL                                                          AND
                              NRLANCTONF  = P_LANCTONF                                                        AND
                              CDPRODUTO   = C_ITEMPROD.CDPRODUTO                                              AND
                              VRUNITITEM  = C_ITEMPROD.VRUNITITEM                                             AND
                             (NVL(NRLOTEESTQ, ' ')  = (NVL(C_ITEMPROD.NRLOTEESTQ, ' ')))                      AND
                             (NVL(NRSUBLOTE , ' ')  = (NVL(C_ITEMPROD.NRSUBLOTE , ' ')));
                     END IF;
                  END IF;
                  /*IMPOSTOS POR ITEM DA NOTA DE ORIGEM*/
                  FOR C_ITEMPROIMPOS IN (SELECT VRPERREDBCIT, NRITPROIMPOS, IT.CDIMPOSTO, CDFISCALIT,
                                                VRALIQITEM, VRPARDEDIT, SUM(VRCONTITIMP) AS VRCONTITIMP,
                                                SUM(VRBASECALCIT) AS VRBASECALCIT, SUM(VRIMPOSTOIT) AS VRIMPOSTOIT,
                                                CDSITUTRIBITNFE AS CDSITUTRIBNFE, IDMODBCITNFE AS IDMODBCNFE, IDMODBCSTITNFE AS IDMODBCSTNFE,
                                                CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT, IDTRIMPSTII, NVL(IDDIFALIQCUSPRI, 'N') AS IDDIFALIQCUSPRI,
                                                IM.CDIMPOSTONFE, IT.CDENQLEGALIPI, IT.CDCEST, IT.CDBENEFFISCAL
                                          FROM ITEMPROIMPOS IT, ITEMPRODUTO I, IMPOSTO IM
                                         WHERE IT.CDFILIAL    = C_ITEMNOTAFISC.CDFILIALIT                                         AND
                                               IT.NRLANCTONF  = C_ITEMNOTAFISC.NRLANCTONFIT                                       AND
                                               I.CDFILIAL     = C_ITEMNOTAFISC.CDFILIALIT                                         AND
                                               I.NRLANCTONF   = C_ITEMNOTAFISC.NRLANCTONFIT                                       AND
                                               IT.NRSEQITPROD = I.NRSEQITPROD                                                     AND
                                               IT.CDIMPOSTO   = IM.CDIMPOSTO                                                      AND
                                               I.CDPRODUTO = C_ITEMPROD.CDPRODUTO                                                 AND
                                               IT.NRITPROIMPOS = '1'                                                              AND
                                               ROUND(I.VRUNITITEM, V_NRDECITOTANF) = ROUND(C_ITEMPROD.VRUNITITEM, V_NRDECITOTANF) AND
                                               (NVL(I.NRLOTEESTQ, ' ') = (NVL(C_ITEMPROD.NRLOTEESTQ, ' ')))                       AND
                                               (NVL(I.NRSUBLOTE, ' ')  = (NVL(C_ITEMPROD.NRSUBLOTE,  ' ')))
                                         GROUP BY VRPERREDBCIT, IT.CDIMPOSTO, NRITPROIMPOS, CDFISCALIT, VRALIQITEM,
                                                  VRPARDEDIT,   CDSITUTRIBITNFE, IDMODBCITNFE, IDMODBCSTITNFE,
                                                  CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT, IDTRIMPSTII, IDDIFALIQCUSPRI,
                                                  IM.CDIMPOSTONFE, IT.CDENQLEGALIPI, IT.CDCEST
                                         ORDER BY CDIMPOSTO) LOOP
                     V_CDBENEFFISCAL := NULL;
                     CONSULTA_INCIDENCIA(w_S, P_EMPRESA, C_ITEMPROD.CDARVPROD, P_INSCESTA, P_TIPOOPER, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC,
                                        NULL, V_IDINTEREST, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, C_ITEMPROD.IDORIGEMPROD);
                     IF V_CDSITTRIBTMP IS NULL THEN
                        V_CDSITTRIBTMP := SUBSTR(V_SITUTRIBPR, 2, 2);
                     END IF;
                     BEGIN
                        SELECT MAX(CDFISCTEMP), MAX(CDDETALHEPROD), MAX(CDENQLEGALIPI), MAX(CDCEST)
                          INTO V_CDFISCTEMP, V_CDDETALHEPRODTEMP, V_CDENQLEGALIPI, V_CDCEST
                          FROM INCITEMP IT, IMPOSTO IP
                        WHERE IT.NRINCITEMP = V_INCITEMP
                          AND IP.CDIMPOSTO  = IT.CDIMPOTEMP
                          AND IP.IDPRODNOTA = w_P
                          AND IT.CDIMPOTEMP = C_ITEMPROIMPOS.CDIMPOSTO;
                     EXCEPTION
                        WHEN NO_DATA_FOUND THEN
                           V_CDFISCTEMP        := NULL;
                           V_CDDETALHEPRODTEMP := NULL;
                           V_CDENQLEGALIPI     := NULL;
                           V_CDCEST            := NULL;
                     END;
                     IF (C_ITEMPROIMPOS.VRPERREDBCIT > 0.00) AND
                        (C_ITEMPROIMPOS.NRITPROIMPOS = w_2) THEN
                        V_CDFISCTEMP := w_2;
                     ELSE
                        IF (V_CDFISCTEMP IS NULL) THEN
                            V_CDFISCTEMP := C_ITEMPROIMPOS.CDFISCALIT;
                        END IF;
                     END IF;
                     IF V_CDENQLEGALIPI IS NULL THEN
                        V_CDENQLEGALIPI := C_ITEMPROIMPOS.CDENQLEGALIPI;
                     END IF;
                     IF V_CDCEST IS NULL THEN
                        V_CDCEST := C_ITEMPROIMPOS.CDCEST;
                     END IF;
                     DELETE INCITEMP
                      WHERE NRINCITEMP = V_INCITEMP;
                     /*VERIFICA CST POR IMPOSTO*/
                     V_IMPOICMS := NULL;
                     V_CDGRUPOFISCAUX := NULL;
                     SELECT MAX(G.CDGRUPOFISC)
                       INTO V_CDGRUPOFISCAUX
                       FROM GRUPOFISCIMPFIL G,
                            (SELECT CDFILIEMIT AS CDFILIAL
                               FROM NOTAFISCAL
                              WHERE CDFILIAL = P_FILIAL
                                    AND NRLANCTONF = P_LANCTONF) F
                      WHERE G.CDFILIAL = F.CDFILIAL
                        AND NOT G.CDGRUPOFISC IS NULL
                        AND G.CDIMPOSTO = C_ITEMPROIMPOS.CDIMPOSTO;
                     IF V_IDORIGDESTNF = 'C' THEN
                        SELECT NVL(MAX(G.CDGRUPOFISC), V_CDGRUPOFISCAUX)
                          INTO V_CDGRUPOFISCAUX
                          FROM GRFISIMPIECLIE G,
                               (SELECT CDCLIENTE
                                  FROM NOTAFISCAL
                                 WHERE CDFILIAL = P_FILIAL
                                   AND NRLANCTONF = P_LANCTONF) N
                         WHERE G.CDCLIENTE = N.CDCLIENTE
                           AND G.CDEMPRESA = P_EMPRESA
                           AND G.CDINSCESTA = P_INSCESTA
                           AND NOT G.CDGRUPOFISC IS NULL
                           AND G.CDIMPOSTO = C_ITEMPROIMPOS.CDIMPOSTO;
                     ELSE
                        SELECT NVL(MAX(G.CDGRUPOFISC), V_CDGRUPOFISCAUX)
                          INTO V_CDGRUPOFISCAUX
                          FROM GRFISIMPIEFORN G,
                              (SELECT CDFORNECED
                                 FROM NOTAFISCAL
                                WHERE CDFILIAL = P_FILIAL
                                  AND NRLANCTONF = P_LANCTONF) N
                         WHERE G.CDFORNECED = N.CDFORNECED
                           AND G.CDEMPRESA = P_EMPRESA
                           AND G.CDINSCESTA = P_INSCESTA
                           AND NOT G.CDGRUPOFISC IS NULL
                           AND G.CDIMPOSTO = C_ITEMPROIMPOS.CDIMPOSTO;
                     END IF;
                     IF V_CDGRUPOFISCAUX IS NULL THEN
                        CONSULTA_CST_NFE(w_S, P_EMPRESA, C_ITEMPROD.CDARVPROD, P_INSCESTA, P_TIPOOPER, V_CDGRUPOFISC,C_ITEMPROIMPOS.CDIMPOSTO, V_IDINTEREST, V_IDINTERNA, P_FILIAL, P_LANCTONF, '', V_CDSITTRIBTMP, V_IDMODBCNFE, V_IDMODBCSTNFE, V_CDTPCRPICOSTNFE, V_CDNATUBCPCSTNFE, V_IDMOTIDESSTNFE, C_ITEMPROD.IDORIGEMPROD);
                     ELSE
                        CONSULTA_CST_NFE(w_S, P_EMPRESA, C_ITEMPROD.CDARVPROD, P_INSCESTA, P_TIPOOPER, V_CDGRUPOFISCAUX,C_ITEMPROIMPOS.CDIMPOSTO, V_IDINTEREST, V_IDINTERNA, P_FILIAL, P_LANCTONF, '', V_CDSITTRIBTMP, V_IDMODBCNFE, V_IDMODBCSTNFE, V_CDTPCRPICOSTNFE, V_CDNATUBCPCSTNFE, V_IDMOTIDESSTNFE, C_ITEMPROD.IDORIGEMPROD);
                     END IF;
                     IF (V_CDSITTRIBTMP IS NULL) THEN
                        V_CDSITUTRIBNFE := C_ITEMPROIMPOS.CDSITUTRIBNFE;
                     ELSE
                        V_CDSITUTRIBNFE := V_CDSITTRIBTMP;
                     END IF;
                     IF (V_IDMODBCNFE IS NULL) THEN
                        V_IDMODBCNFEIT := C_ITEMPROIMPOS.IDMODBCNFE;
                     ELSE
                        V_IDMODBCNFEIT := V_IDMODBCNFE;
                     END IF;
                     IF (V_IDMODBCSTNFE IS NULL) THEN
                        V_IDMODBCSTNFEIT := C_ITEMPROIMPOS.IDMODBCSTNFE;
                     ELSE
                        V_IDMODBCSTNFEIT := V_IDMODBCSTNFE;
                     END IF;
                     IF (C_ITEMPROIMPOS.CDTPCREDPICOITE IS NULL) THEN
                        V_CDTPCRPICOSTNFEIT := V_CDTPCRPICOSTNFE;
                     ELSE
                        V_CDTPCRPICOSTNFEIT := C_ITEMPROIMPOS.CDTPCREDPICOITE;
                     END IF;
                     IF (C_ITEMPROIMPOS.CDNATUBCALPCIT IS NULL) THEN
                        V_CDNATUBCPCSTNFEIT := V_CDNATUBCPCSTNFE;
                     ELSE
                        V_CDNATUBCPCSTNFEIT := C_ITEMPROIMPOS.CDNATUBCALPCIT;
                     END IF;
                     IF (V_IDMOTIDESSTNFE IS NULL) THEN
                        V_IDMOTIDESSTNFE := C_ITEMPROIMPOS.IDMOTDESONERAIT;
                     ELSE
                        V_IDMOTIDESSTNFE := V_IDMOTIDESSTNFE;
                     END IF;
                     SELECT NVL(MAX(IDUTMUNIORIG),'N')
                       INTO V_IDUTMUNIORIG
                       FROM IMPOSTO
                      WHERE CDIMPOSTO = C_ITEMPROIMPOS.CDIMPOSTO;
                     IF ((V_IDUTMUNIORIG = 'O') OR (V_IDUTMUNIORIG = 'N')) THEN
                        CONSULTA_ALIQUOTA(C_ITEMPROIMPOS.CDIMPOSTO, w_S, P_EMPRESA, C_ITEMPROD.CDARVPROD, P_INSCESTA, V_PAISORIG,
                                          V_ESTAORIG, V_PAISDEST, V_ESTADEST, V_MUNIORIG, V_LIQUIITEM, P_INIVALID, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC, P_TIPOOPER,
                                          NULL, NULL, NULL, NULL, NULL, NULL, C_ITEMPROD.IDORIGEMPROD);
                     ELSE
                        CONSULTA_ALIQUOTA(C_ITEMPROIMPOS.CDIMPOSTO, w_S, P_EMPRESA, C_ITEMPROD.CDARVPROD, P_INSCESTA, V_PAISORIG,
                                          V_ESTAORIG, V_PAISDEST, V_ESTADEST, V_MUNIDEST, V_LIQUIITEM, P_INIVALID, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC, P_TIPOOPER,
                                          NULL, NULL, NULL, NULL, NULL, NULL, C_ITEMPROD.IDORIGEMPROD);
                     END IF;
                     V_NRALIQTEMP := 0;
                     V_PARDEDTMP  := 0;
                     V_PREDBCTMP  := 0;
                     V_ALIQUTMP   := 0;
                     V_IMPOSTOIT  := 0;
                     V_CDTIPOOPER    := NULL;
                     V_CDREGRAITALIQ := NULL;
                     SELECT NVL(MAX(NRALIQTEMP),0),      NVL(MAX(VRPARDEDTMP),0), NVL(MAX(VRPREDBCTMP),0), NVL(MAX(VRALIQUTMP),0),
                            NVL(MAX(IDTRIMPSTTMP), w_0), NVL(MAX(VRPBCSTTMP),0),  NVL(MAX(IDPMCBSCALTMP), w_S),
                            MAX(CDTIPOOPERTMP),          MAX(CDREGRATMP),
                            MAX(CDFISCOPER),             MAX(IDDIFEALIQ),         MAX(IDDIFALIQCUSPR),
                            MAX(CDBENEFFISCAL)
                     INTO   V_NRALIQTEMP,                V_PARDEDTMP,             V_PREDBCTMP,             V_ALIQUTMP,
                            V_TRATIMPST,                 V_PBCSUBTRIB,            V_IDPMCBASECAL,
                            V_CDTIPOOPER,                V_CDREGRAITALIQ,
                            V_CDFISCOPERREGRA,           V_IDDIFEALIQREGRA,       V_IDDIFALIQCUSPRREGRA,
                            V_CDBENEFFISCAL
                     FROM ALIQTEMP
                     WHERE (NRALIQTEMP = V_ALIQTEMP);
                     IF V_CDBENEFFISCAL IS NULL THEN
                        V_CDBENEFFISCAL := C_ITEMPROIMPOS.CDBENEFFISCAL;
                     END IF;
                     /*Verifica alíquota parametrizada por tipo de operação desde que não seja nota de estorno de cancelamento*/
                     IF V_PAISORIG = V_PAISCFOP THEN
                        IF V_ESTAORIG = V_ESTACFOP THEN
                           V_CFOP1DIGT := '5';
                        ELSE
                           V_CFOP1DIGT := '6';
                        END IF;
                     ELSE
                        V_CFOP1DIGT := '7';
                     END IF;
                     IF V_CDFISCOPERREGRA IS NOT NULL THEN
                        IF (LENGTH(V_CDFISCOPERREGRA) < 4) THEN
                           V_CDFISCOPERREGRA := V_CFOP1DIGT||V_CDFISCOPERREGRA;
                        END IF;
                     END IF;
                     IF ((V_NRALIQTEMP IS NOT NULL) AND (V_CDTIPOOPER IS NOT NULL) AND (V_ESTORNOCANC <> w_S))THEN
                        IF /*(C_ITEMPROIMPOS.VRPERREDBCIT > 0.00) AND*/
                           (C_ITEMPROIMPOS.NRITPROIMPOS = w_2) THEN
                           V_CDIMPOSTRIB  := null;
                           V_IDVRIMPSTRIB := null;
                        ELSE
                           V_CDIMPOSTRIB  := null;
                           V_IDVRIMPSTRIB := null;
                           /*IMPOSTO DE SUBSTITUICAO TRIBUTARIA*/
                           FOR C_ICMSST IN (SELECT CDIMPOSTO
                                              FROM IMPOSTO
                                             WHERE CDIMPOSTRIB = C_ITEMPROIMPOS.CDIMPOSTO)
                           LOOP
                              V_CDIMPOSTRIB := V_CDIMPOSTRIB||C_ICMSST.CDIMPOSTO||'_';
                           END LOOP;
                           V_TAXABASECALC := (100 - V_PREDBCTMP)/100;
                           V_TAXAALIQUOTA := (V_ALIQUTMP/100);
                           V_TAXABCSUBSTR := 1 + (V_PBCSUBTRIB/100);
                           V_BASECALCIT   := V_LIQUIITEM * V_TAXABASECALC;
                           V_PERDBCALC    := 100 - V_PREDBCTMP;
                           IF V_PBCSUBTRIB > 0 THEN
                              V_BASECALCIT := (V_BASECALCIT * V_TAXABCSUBSTR);
                              V_PREDBCTMP  := V_PBCSUBTRIB;
                              V_PERDBCALC  := 0;
                           END IF;
                           V_BASECALCTO  := V_BASECALCIT;
                           V_IMPOSTOIT   := (V_BASECALCIT * V_TAXAALIQUOTA) - V_PARDEDTMP;
                           IF V_CDIMPOSTRIB IS NULL THEN
                              V_IDTRIMPSTII := '';
                           ELSE
                              IF SUBSTR(V_SITUTRIBPR, 2, 2) = '60' THEN
                                 V_IDTRIMPSTII := w_2;
                              ELSE 
                                 V_IDTRIMPSTII := V_TRATIMPST;
                              END IF;
                           END IF;
                           V_CONTABCALC  := V_LIQUIITEM - (V_LIQUIITEM * V_TAXABASECALC);
                           IF V_CDIMPOSTRIB IS NOT NULL THEN
                              SELECT NVL(MAX(IDVRIMPSTRIB), 'N')
                                INTO V_IDVRIMPSTRIB
                                FROM ITEMPROIMPOS I, IMPOSTO II
                               WHERE (CDFILIAL     = P_FILIAL)
                                 AND (NRLANCTONF   = P_LANCTONF)
                                 AND (NRSEQITPROD  = C_ITEMPROD.NRSEQITPROD)
                                 AND(INSTR(V_CDIMPOSTRIB,II.CDIMPOSTO||'_') > 0)
                                 AND (I.CDIMPOSTO = II.CDIMPOSTO);
                              IF (V_TRATIMPST = w_1) OR (NVL(V_IDVRIMPSTRIB,w_N) = w_N) THEN
                                 V_VRIMPOSTOST := 0;
                              ELSE
                                 Begin
                                    SELECT NVL(MAX(VRIMPOSTOIT),0)
                                      INTO   V_VRIMPOSTOST
                                      FROM ITEMPROIMPOS I
                                     WHERE (CDFILIAL     = P_FILIAL)
                                       AND (NRLANCTONF   = P_LANCTONF)
                                       AND (NRSEQITPROD  = C_ITEMPROD.NRSEQITPROD)
                                       AND (INSTR(V_CDIMPOSTRIB,CDIMPOSTO||'_') > 0)
                                       AND (NRITPROIMPOS = w_1);
                                 Exception
                                    When No_Data_Found Then
                                       V_VRIMPOSTOST := 0;
                                 End;
                              END IF;
                              V_IMPOSTOIT := V_IMPOSTOIT - V_VRIMPOSTOST;
                              IF V_IMPOSTOIT < 0 THEN
                                 V_IMPOSTOIT := 0;
                              END IF;
                           END IF;
                           IF (V_ALIQUTMP = 0) AND (V_IMPOSTOIT = 0) THEN
                              V_BASECALCTO := 0;
                           END IF;
                           Begin
                             SELECT CDFILIAL
                             INTO   V_CHAVE
                             FROM ITEMPROIMPOS
                             WHERE CDFILIAL     = P_FILIAL                 AND
                                   NRLANCTONF   = P_LANCTONF               AND
                                   NRSEQITPROD  = C_ITEMPROD.NRSEQITPROD   AND
                                   CDIMPOSTO    = C_ITEMPROIMPOS.CDIMPOSTO AND
                                   NRITPROIMPOS = C_ITEMPROIMPOS.NRITPROIMPOS;
                          Exception
                             When No_Data_Found Then
                                V_CHAVE := Null;
                          End;
                          IF V_CHAVE IS NULL THEN
                             V_ICMS := 'N';
                             FOR C_ICMS IN (SELECT CDIMPOSTO
                                              FROM IMPOSTONFE N, IMPOSTO I
                                             WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                                               AND N.CDIMPOSTONFE = '00'
                                               AND I.CDIMPOSTO = C_ITEMPROIMPOS.CDIMPOSTO)
                             LOOP
                                V_ICMS := 'S';
                             END LOOP;
                             IF (V_ICMS = 'S') THEN
                                V_CDGRUPOFISCAUX := NULL;
                                SELECT MAX(G.CDGRUPOFISC)
                                  INTO V_CDGRUPOFISCAUX
                                  FROM GRUPOFISCIMPFIL G,
                                       (SELECT CDFILIEMIT AS CDFILIAL
                                          FROM NOTAFISCAL
                                         WHERE CDFILIAL = P_FILIAL
                                               AND NRLANCTONF = P_LANCTONF) F
                                 WHERE G.CDFILIAL = F.CDFILIAL
                                   AND NOT G.CDGRUPOFISC IS NULL
                                   AND G.CDIMPOSTO = C_ITEMPROIMPOS.CDIMPOSTO;
                                IF V_IDORIGDESTNF = 'C' THEN
                                   SELECT NVL(MAX(G.CDGRUPOFISC), V_CDGRUPOFISCAUX)
                                     INTO V_CDGRUPOFISCAUX
                                     FROM GRFISIMPIECLIE G,
                                          (SELECT CDCLIENTE
                                             FROM NOTAFISCAL
                                            WHERE CDFILIAL = P_FILIAL
                                              AND NRLANCTONF = P_LANCTONF) N
                                    WHERE G.CDCLIENTE = N.CDCLIENTE
                                      AND G.CDEMPRESA = P_EMPRESA
                                      AND G.CDINSCESTA = P_INSCESTA
                                      AND NOT G.CDGRUPOFISC IS NULL
                                      AND G.CDIMPOSTO = C_ITEMPROIMPOS.CDIMPOSTO;
                                ELSE
                                   SELECT NVL(MAX(G.CDGRUPOFISC), V_CDGRUPOFISCAUX)
                                     INTO V_CDGRUPOFISCAUX
                                     FROM GRFISIMPIEFORN G,
                                         (SELECT CDFORNECED
                                            FROM NOTAFISCAL
                                           WHERE CDFILIAL = P_FILIAL
                                             AND NRLANCTONF = P_LANCTONF) N
                                    WHERE G.CDFORNECED = N.CDFORNECED
                                      AND G.CDEMPRESA = P_EMPRESA
                                      AND G.CDINSCESTA = P_INSCESTA
                                      AND NOT G.CDGRUPOFISC IS NULL
                                      AND G.CDIMPOSTO = C_ITEMPROIMPOS.CDIMPOSTO;
                                END IF;
                                IF (V_CDGRUPOFISCAUX IS NOT NULL) THEN
                                   CONSULTA_CFOP(w_S, P_EMPRESA, C_ITEMPROD.CDARVPROD, P_INSCESTA, P_TIPOOPER, V_PAISORIG,
                                                 V_ESTAORIG, V_PAISCFOP, V_ESTACFOP, P_FILIAL, P_LANCTONF, V_CDGRUPOFISCAUX, P_INIVALID, C_ITEMPROD.IDORIGEMPROD);
                                ELSE
                                   CONSULTA_CFOP(w_S, P_EMPRESA, C_ITEMPROD.CDARVPROD, P_INSCESTA, P_TIPOOPER, V_PAISORIG,
                                                 V_ESTAORIG, V_PAISCFOP, V_ESTACFOP, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC, P_INIVALID, C_ITEMPROD.IDORIGEMPROD);
                                END IF;
                                IF (NVL(V_CFOPINFUSU, 'N') <> 'S') AND (V_CDFISCOPERREGRA IS NOT NULL) THEN
                                   V_FISOPEITEM        := NVL(V_CDFISCOPERREGRA, V_FISOPEITEM);
                                   V_DSCDFISOPEITREGRA := SUBSTR(DESCRICAO_CFOP(V_CDFISCOPERREGRA),1,45);
                                END IF;
                                UPDATE NOTAFISCAL
                                   SET DSCDFISOPENF = NVL(V_DSCDFISOPEITREGRA, (SELECT MAX(DSCFOPTMP)
                                                                                    FROM CFOPTEMP
                                                                                   WHERE NRCFOPTEMP = V_CFOPTEMP))
                                 WHERE CDFILIAL   = P_FILIAL   AND
                                       NRLANCTONF = P_LANCTONF;
                                SELECT MAX(CDFISOPETMP), MAX(CDSUFCFOPTMP), SUBSTR(MAX(DSCFOPTMP),1,50)
                                  INTO V_FISOPEITEM    , V_SUFXCFOPPR, V_DSCDFISOPEIT
                                  FROM CFOPTEMP
                                 WHERE NRCFOPTEMP = V_CFOPTEMP;
                                IF (NVL(V_CFOPINFUSU, 'N') <> 'S') AND (V_CDFISCOPERREGRA IS NOT NULL) THEN
                                   V_FISOPEITEM        := NVL(V_CDFISCOPERREGRA, V_FISOPEITEM);
                                   V_DSCDFISOPEITREGRA := SUBSTR(DESCRICAO_CFOP(V_CDFISCOPERREGRA),1,45);
                                END IF;
                                UPDATE ITEMPRODUTO
                                   SET CDFISOPEITEM  = V_FISOPEITEM,
                                       CDSUFXCFOPPR  = V_SUFXCFOPPR,
                                       DSCDFISOPEIT  = V_DSCDFISOPEIT
                                 WHERE CDFILIAL    = P_FILIAL AND
                                       NRLANCTONF  = P_LANCTONF AND
                                       NRSEQITPROD = C_ITEMPROD.NRSEQITPROD;
                                DELETE CFOPTEMP
                                 WHERE NRCFOPTEMP = V_CFOPTEMP;
                                Begin
                                   SELECT MAX(CDCSTDIG1PROD)
                                     INTO V_CST1DIGT
                                     FROM PRODUTO
                                    WHERE (CDARVPROD = C_ITEMPROD.CDARVPROD);
                                   IF V_CST1DIGT IS NULL THEN
                                      SELECT MAX(CDCSTDIG1SAI)
                                        INTO   V_CST1DIGT
                                        FROM INSCRESTAD
                                       WHERE (CDEMPRESA  = P_EMPRESA) AND
                                             (CDINSCESTA = P_INSCESTA);
                                   END IF;
                                Exception
                                   When No_Data_Found Then
                                      V_CST1DIGT := Null;
                                End;
                                IF (V_IDUTORIGPROD = 'S') AND (C_ITEMPROD.IDORIGEMPROD = 'E') THEN
                                   V_CST1DIGT := '2';
                                END IF;
                                UPDATE ITEMPRODUTO
                                   SET CDSITUTRIBPR  = V_CST1DIGT||NVL(V_CDSITTRIBTMP, SUBSTR(V_SITUTRIBPR, 2,2))
                                 WHERE CDFILIAL    = P_FILIAL AND
                                       NRLANCTONF  = P_LANCTONF AND
                                       NRSEQITPROD = C_ITEMPROD.NRSEQITPROD;
                                V_SITUTRIBPR := V_CST1DIGT||NVL(V_CDSITTRIBTMP, SUBSTR(V_SITUTRIBPR, 2,2));
                             END IF;
                             SELECT NVL(MAX(IDPERVISIMPSCRE), 'S')
                               INTO V_IDPERVISIMPSCRE
                               FROM PARAMGERAL;
                             IF V_IDPERVISIMPSCRE = 'S' THEN
                                V_VRIMPOSTOVISUIT := V_IMPOSTOIT;
                             ELSE
                                IF (V_CDFISCTEMP = '1') THEN
                                   V_VRIMPOSTOVISUIT := V_IMPOSTOIT;
                                ELSE
                                   V_VRIMPOSTOVISUIT := 0;
                                END IF;
                             END IF;
                             /* ROTINA PARA CALCULAR O DIFERIMENTO DO IMPOSTO */
                             V_PERDIFERE    := NULL;
                             V_IMPOSTOOPERA := NULL;
                             V_IMPOSTODIFER := NULL;
                             IF C_ITEMPROIMPOS.CDIMPOSTONFE = '00' THEN
                                IF V_CDSITTRIBTMP = 51 THEN
                                   BEGIN
                                      SELECT PD.VRPERDIFERE, 'S'
                                        INTO V_VRPERDIFERE, V_IDDIFECLI
                                        FROM PRODDIFEREIMPCLI PD, PRODUTO PR
                                       WHERE PD.CDPRODUTO = PR.CDPRODUTO
                                         AND PD.CDPAIS = V_PAISORIG
                                         AND PD.SGESTADO = V_ESTAORIG
                                         AND PD.CDCLIENTE = P_CLIENTE
                                         AND PR.CDARVPROD IN (SELECT MAX(PR.CDARVPROD) AS CDARVPROD
                                                                FROM PRODDIFEREIMPCLI PD, PRODUTO PR
                                                               WHERE PD.CDPRODUTO = PR.CDPRODUTO
                                                                 AND PD.CDPAIS = V_PAISORIG
                                                                 AND PD.SGESTADO = V_ESTAORIG
                                                                 AND PD.CDCLIENTE = P_CLIENTE
                                                                 AND INSTR(NVL(RTRIM(C_ITEMPROD.CDARVPROD), PR.CDARVPROD), PR.CDARVPROD) = 1);
                                   EXCEPTION
                                      WHEN NO_DATA_FOUND THEN
                                         V_VRPERDIFERE := NULL; V_IDDIFECLI := 'N';
                                   END;
                                   IF V_IDDIFECLI = 'N' THEN
                                      BEGIN
                                         SELECT PD.VRPERDIFERE
                                           INTO V_VRPERDIFERE
                                           FROM PRODDIFEREIMPOS PD, PRODUTO PR
                                          WHERE PD.CDPRODUTO = PR.CDPRODUTO
                                            AND PD.CDPAIS = V_PAISORIG
                                            AND PD.SGESTADO = V_ESTAORIG
                                            AND PR.CDARVPROD IN (SELECT MAX(PR.CDARVPROD) AS CDARVPROD
                                                                   FROM PRODDIFEREIMPOS PD, PRODUTO PR
                                                                  WHERE PD.CDPRODUTO = PR.CDPRODUTO
                                                                    AND PD.CDPAIS = V_PAISORIG
                                                                    AND PD.SGESTADO = V_ESTAORIG
                                                                    AND INSTR(NVL(RTRIM(C_ITEMPROD.CDARVPROD), PR.CDARVPROD), PR.CDARVPROD) = 1);
                                      EXCEPTION
                                         WHEN NO_DATA_FOUND THEN
                                            V_VRPERDIFERE := NULL;
                                      END;
                                   END IF;
                                   IF V_VRPERDIFERE IS NOT NULL THEN
                                      V_PERDIFERE    := V_VRPERDIFERE;
                                      V_IMPOSTOOPERA := V_IMPOSTOIT;
                                      V_IMPOSTODIFER := V_IMPOSTOOPERA * (V_VRPERDIFERE/100);
                                      V_IMPOSTOIT := V_IMPOSTOOPERA - V_IMPOSTODIFER;
                                   END IF;
                                END IF;
                             END IF;
                             IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (V_ICMS = 'S') THEN
                                INSERT INTO ITEMPROIMPOS(
                                   CDFILIAL,        NRLANCTONF,   NRSEQITPROD,    CDIMPOSTO,       NRITPROIMPOS,   CDFISCALIT,
                                   CDSITUTRIBIT,    CDFISCOPERIT, CDSUFXCFOPIT,   VRALIQITEM,      VRPERREDBCIT,   VRPARDEDIT,
                                   VRCONTITIMP,     VRBASECALCIT, VRIMPOSTOIT,    IDERROSIMPIT,    IDAVISIMPIT,    IDTRIMPSTII,
                                   CDSITUTRIBITNFE, IDMODBCITNFE, IDMODBCSTITNFE, CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT,
                                   CDDETALHEPROD, VRIMPOSTOVISUIT, CDREGRAIT, VRPERDIFEREIT, VRIMPOSTOOPERAIT, VRIMPOSTODIFERIT,
                                   CDENQLEGALIPI, CDCEST, CDBENEFFISCAL)
                                VALUES(
                                   P_FILIAL,                P_LANCTONF,     C_ITEMPROD.NRSEQITPROD, C_ITEMPROIMPOS.CDIMPOSTO, w_1,                 V_CDFISCTEMP,
                                   NVL(V_SITUTRIBPR, C_ITEMPROD.CDSITUTRIBPR), V_FISOPEITEM,   V_SUFXCFOPPR,           V_ALIQUTMP,               V_PREDBCTMP,         V_PARDEDTMP,
                                   TRUNC(V_BASECALCTO,2),   V_BASECALCTO,   TRUNC(V_IMPOSTOIT,2),   w_00000,                  w_00000,             V_IDTRIMPSTII,
                                   V_CDSITUTRIBNFE,         V_IDMODBCNFEIT, V_IDMODBCSTNFEIT,       V_CDTPCRPICOSTNFEIT,      V_CDNATUBCPCSTNFEIT, V_IDMOTIDESSTNFE,
                                   V_CDDETALHEPRODTEMP, TRUNC(V_VRIMPOSTOVISUIT,2), V_CDREGRAITALIQ, V_PERDIFERE, V_IMPOSTOOPERA, V_IMPOSTODIFER,
                                   V_CDENQLEGALIPI, V_CDCEST, V_CDBENEFFISCAL);
                             ELSE
                                INSERT INTO ITEMPROIMPOS(
                                   CDFILIAL,        NRLANCTONF,   NRSEQITPROD,     CDIMPOSTO,       NRITPROIMPOS,   CDFISCALIT,
                                   CDSITUTRIBIT,    CDFISCOPERIT, CDSUFXCFOPIT,    VRALIQITEM,      VRPERREDBCIT,   VRPARDEDIT,
                                   VRCONTITIMP,     VRBASECALCIT, VRIMPOSTOIT,     IDERROSIMPIT,    IDAVISIMPIT,    IDTRIMPSTII,
                                   CDSITUTRIBITNFE, IDMODBCITNFE, IDMODBCSTITNFE,  CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT,
                                   CDDETALHEPROD, VRIMPOSTOVISUIT,   CDREGRAIT, VRPERDIFEREIT, VRIMPOSTOOPERAIT, VRIMPOSTODIFERIT,
                                   CDENQLEGALIPI, CDCEST, CDBENEFFISCAL)
                                VALUES(
                                   P_FILIAL,                P_LANCTONF,     C_ITEMPROD.NRSEQITPROD, C_ITEMPROIMPOS.CDIMPOSTO, w_1,                 V_CDFISCTEMP,
                                   NVL(V_SITUTRIBPR, C_ITEMPROD.CDSITUTRIBPR), V_FISOPEITEM,   V_SUFXCFOPPR,           V_ALIQUTMP,               V_PREDBCTMP,         V_PARDEDTMP,
                                   ROUND(V_BASECALCTO,5),   ROUND(V_BASECALCTO,2),   ROUND(V_IMPOSTOIT,2),   w_00000,                  w_00000,             V_IDTRIMPSTII,  
                                   V_CDSITUTRIBNFE,         V_IDMODBCNFEIT, V_IDMODBCSTNFEIT,       V_CDTPCRPICOSTNFEIT,      V_CDNATUBCPCSTNFEIT, V_IDMOTIDESSTNFE,
                                   V_CDDETALHEPRODTEMP, ROUND(V_VRIMPOSTOVISUIT,2), V_CDREGRAITALIQ, V_PERDIFERE, V_IMPOSTOOPERA, V_IMPOSTODIFER,
                                   V_CDENQLEGALIPI, V_CDCEST, V_CDBENEFFISCAL);
                             END IF;
                             IF (C_ITEMPROIMPOS.NRITPROIMPOS = w_1) THEN
                                IF (V_PREDBCTMP > 0) AND (V_PBCSUBTRIB = 0) THEN
                                   IF C_ITEMPROD.CDSITUTRIBPR = '060' THEN
                                      INSERT INTO ITEMPROIMPOS(
                                         CDFILIAL,        NRLANCTONF,      NRSEQITPROD,     CDIMPOSTO,       NRITPROIMPOS,   CDFISCALIT,
                                         CDSITUTRIBIT,    CDFISCOPERIT,    CDSUFXCFOPIT,    VRALIQITEM,      VRPERREDBCIT,   VRPARDEDIT,
                                         VRCONTITIMP,     VRBASECALCIT,    VRIMPOSTOIT,     IDERROSIMPIT,    IDAVISIMPIT,    IDTRIMPSTII,
                                         CDSITUTRIBITNFE, IDMODBCITNFE,    IDMODBCSTITNFE,  CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT,
                                         CDDETALHEPROD, VRIMPOSTOVISUIT,   CDREGRAIT, CDENQLEGALIPI, CDCEST, CDBENEFFISCAL)
                                      VALUES(
                                         P_FILIAL,                P_LANCTONF,      C_ITEMPROD.NRSEQITPROD, C_ITEMPROIMPOS.CDIMPOSTO, w_2,                 w_2,
                                         NVL(V_SITUTRIBPR, C_ITEMPROD.CDSITUTRIBPR), V_FISOPEITEM,    V_SUFXCFOPPR,           0,                        V_PERDBCALC,         V_PARDEDTMP,
                                         V_CONTABCALC,            0,               0,                      w_00000,                  w_00000,             V_IDTRIMPSTII,
                                         V_CDSITUTRIBNFE,         V_IDMODBCNFEIT,  V_IDMODBCSTNFEIT,       V_CDTPCRPICOSTNFEIT,      V_CDNATUBCPCSTNFEIT, V_IDMOTIDESSTNFE,
                                         V_CDDETALHEPRODTEMP, 0, V_CDREGRAITALIQ, V_CDENQLEGALIPI, V_CDCEST, V_CDBENEFFISCAL);
                                   ELSE
                                      INSERT INTO ITEMPROIMPOS(
                                         CDFILIAL,        NRLANCTONF,     NRSEQITPROD,     CDIMPOSTO,       NRITPROIMPOS,   CDFISCALIT,
                                         CDSITUTRIBIT,    CDFISCOPERIT,   CDSUFXCFOPIT,    VRALIQITEM,      VRPERREDBCIT,   VRPARDEDIT,
                                         VRCONTITIMP,     VRBASECALCIT,   VRIMPOSTOIT,     IDERROSIMPIT,    IDAVISIMPIT,    IDTRIMPSTII,
                                         CDSITUTRIBITNFE, IDMODBCITNFE,   IDMODBCSTITNFE,  CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT,
                                         CDDETALHEPROD,   VRIMPOSTOVISUIT,   CDREGRAIT, CDENQLEGALIPI,      CDCEST,         CDBENEFFISCAL)
                                      VALUES(
                                         P_FILIAL,                P_LANCTONF,     C_ITEMPROD.NRSEQITPROD, C_ITEMPROIMPOS.CDIMPOSTO, w_2,                 w_2,
                                         NVL(V_SITUTRIBPR, C_ITEMPROD.CDSITUTRIBPR), V_FISOPEITEM,   V_SUFXCFOPPR,           0,                        V_PERDBCALC,         V_PARDEDTMP,
                                         V_CONTABCALC,            0,              0,                      w_00000,                  w_00000,             V_IDTRIMPSTII,
                                         V_CDSITUTRIBNFE,         V_IDMODBCNFEIT, V_IDMODBCSTNFEIT,       V_CDTPCRPICOSTNFEIT,      V_CDNATUBCPCSTNFEIT, V_IDMOTIDESSTNFE,
                                         V_CDDETALHEPRODTEMP, 0, V_CDREGRAITALIQ, V_CDENQLEGALIPI,        V_CDCEST,                 V_CDBENEFFISCAL);
                                   END IF;
                                END IF;
                             END IF;
                          END IF;
                       END IF;
                     ELSE
                        Begin
                           SELECT CDFILIAL
                           INTO   V_CHAVE
                           FROM ITEMPROIMPOS
                           WHERE CDFILIAL     = P_FILIAL                 AND
                                 NRLANCTONF   = P_LANCTONF               AND
                                 NRSEQITPROD  = C_ITEMPROD.NRSEQITPROD   AND
                                 CDIMPOSTO    = C_ITEMPROIMPOS.CDIMPOSTO AND
                                 NRITPROIMPOS = C_ITEMPROIMPOS.NRITPROIMPOS;
                        Exception
                           When No_Data_Found Then
                              V_CHAVE := Null;
                        End;
                        SELECT NVL(MAX(IDPERVISIMPSCRE), 'S')
                          INTO V_IDPERVISIMPSCRE
                          FROM PARAMGERAL;
                        IF V_IDPERVISIMPSCRE = 'S' THEN
                           V_VRIMPOSTOVISUIT := (C_ITEMPROIMPOS.VRIMPOSTOIT * V_VRFATOCONV);
                        ELSE
                           IF (V_CDFISCTEMP = '1') THEN
                              V_VRIMPOSTOVISUIT := (C_ITEMPROIMPOS.VRIMPOSTOIT * V_VRFATOCONV);
                           ELSE
                              V_VRIMPOSTOVISUIT := 0;
                           END IF;
                        END IF;
                        IF V_CHAVE IS NULL THEN
                           V_ICMS := 'N';
                           FOR C_ICMS IN (SELECT CDIMPOSTO
                                            FROM IMPOSTONFE N, IMPOSTO I
                                           WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                                             AND N.CDIMPOSTONFE = '00'
                                             AND I.CDIMPOSTO = C_ITEMPROIMPOS.CDIMPOSTO)
                           LOOP
                              V_ICMS := 'S';
                           END LOOP;
                           IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (V_ICMS = 'S') THEN
                              INSERT INTO ITEMPROIMPOS(CDFILIAL,     NRLANCTONF,     NRSEQITPROD,     CDIMPOSTO,      NRITPROIMPOS,    CDFISCALIT,
                                                       CDSITUTRIBIT, CDFISCOPERIT,   CDSUFXCFOPIT,    VRALIQITEM,     VRPERREDBCIT,    VRPARDEDIT,
                                                       VRCONTITIMP,  VRBASECALCIT,   VRIMPOSTOIT,     IDERROSIMPIT,   IDAVISIMPIT,     CDSITUTRIBITNFE,
                                                       IDMODBCITNFE, IDMODBCSTITNFE, CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT, IDTRIMPSTII,
                                                       CDDETALHEPROD, VRIMPOSTOVISUIT, CDENQLEGALIPI, CDCEST, CDBENEFFISCAL)
                              VALUES(P_FILIAL, P_LANCTONF, C_ITEMPROD.NRSEQITPROD, C_ITEMPROIMPOS.CDIMPOSTO, C_ITEMPROIMPOS.NRITPROIMPOS, V_CDFISCTEMP,
                                     NVL(V_SITUTRIBPR, C_ITEMPROD.CDSITUTRIBPR), V_FISOPEITEM, V_SUFXCFOPPR, C_ITEMPROIMPOS.VRALIQITEM, C_ITEMPROIMPOS.VRPERREDBCIT, TRUNC((C_ITEMPROIMPOS.VRPARDEDIT * V_VRFATOCONV),2),
                                     TRUNC((C_ITEMPROIMPOS.VRCONTITIMP * V_VRFATOCONV),2), TRUNC((C_ITEMPROIMPOS.VRBASECALCIT * V_VRFATOCONV),2),
                                     TRUNC((C_ITEMPROIMPOS.VRIMPOSTOIT * V_VRFATOCONV),2), w_00000, w_00000, V_CDSITUTRIBNFE,
                                     V_IDMODBCNFEIT, V_IDMODBCSTNFEIT, V_CDTPCRPICOSTNFEIT, V_CDNATUBCPCSTNFEIT, V_IDMOTIDESSTNFE, C_ITEMPROIMPOS.IDTRIMPSTII,
                                     V_CDDETALHEPRODTEMP, V_VRIMPOSTOVISUIT, V_CDENQLEGALIPI, V_CDCEST, V_CDBENEFFISCAL);
                           ELSE
                              IF (C_ITEMPROIMPOS.NRITPROIMPOS = w_3)  THEN
                                 /*Inserir a linha de diferencial de alíquota*/
                                 V_DIFALIQ := 0;
                                 SELECT MAX(VRALIQITEM)
                                   INTO V_DIFALIQ
                                   FROM ITEMPROIMPOS IT, ITEMPRODUTO I
                                  WHERE IT.CDFILIAL     = C_ITEMNOTAFISC.CDFILIALIT
                                    AND IT.NRLANCTONF   = C_ITEMNOTAFISC.NRLANCTONFIT
                                    AND I.CDFILIAL      = C_ITEMNOTAFISC.CDFILIALIT
                                    AND I.NRLANCTONF    = C_ITEMNOTAFISC.NRLANCTONFIT
                                    AND IT.NRSEQITPROD  = I.NRSEQITPROD
                                    AND I.CDPRODUTO     = C_ITEMPROD.CDPRODUTO
                                    AND ROUND(I.VRUNITITEM, V_NRDECITOTANF) = ROUND(C_ITEMPROD.VRUNITITEM, V_NRDECITOTANF)
                                    AND (NVL(NRLOTEESTQ, ' ') = (NVL(C_ITEMPROD.NRLOTEESTQ, ' ')))
                                    AND (NVL(NRSUBLOTE, ' ')  = (NVL(C_ITEMPROD.NRSUBLOTE , ' ')))
                                    AND IT.CDIMPOSTO    = C_ITEMPROIMPOS.CDIMPOSTO
                                    AND IT.NRITPROIMPOS = w_1;
                                 IF  (V_ALIQUTMP = V_DIFALIQ) THEN
                                    INSERT INTO ITEMPROIMPOS(
                                       CDFILIAL,        NRLANCTONF,   NRSEQITPROD,    CDIMPOSTO,       NRITPROIMPOS,   CDFISCALIT,
                                       CDSITUTRIBIT,    CDFISCOPERIT, CDSUFXCFOPIT,   VRALIQITEM,      VRPERREDBCIT,   VRPARDEDIT,
                                       VRCONTITIMP,     VRBASECALCIT, VRIMPOSTOIT,    IDERROSIMPIT,    IDAVISIMPIT,    IDTRIMPSTII,
                                       CDSITUTRIBITNFE, IDMODBCITNFE, IDMODBCSTITNFE, CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT,
                                       CDDETALHEPROD,   VRIMPOSTOVISUIT,   CDREGRAIT, IDDIFALIQCUSPRI, CDENQLEGALIPI,  CDCEST,
                                       CDBENEFFISCAL)
                                    VALUES(
                                       P_FILIAL, P_LANCTONF, C_ITEMPROD.NRSEQITPROD, C_ITEMPROIMPOS.CDIMPOSTO, C_ITEMPROIMPOS.NRITPROIMPOS, C_ITEMPROIMPOS.CDFISCALIT,
                                       C_ITEMPROD.CDSITUTRIBPR, V_FISOPEITEM, V_SUFXCFOPPR, C_ITEMPROIMPOS.VRALIQITEM, C_ITEMPROIMPOS.VRPERREDBCIT, (C_ITEMPROIMPOS.VRPARDEDIT * V_VRFATOCONV),
                                       ROUND((C_ITEMPROIMPOS.VRCONTITIMP * V_VRFATOCONV),5), (C_ITEMPROIMPOS.VRBASECALCIT * V_VRFATOCONV), 
                                       (C_ITEMPROIMPOS.VRIMPOSTOIT * V_VRFATOCONV), w_00000, w_00000, C_ITEMPROIMPOS.IDTRIMPSTII, C_ITEMPROIMPOS.CDSITUTRIBNFE,
                                       C_ITEMPROIMPOS.IDMODBCNFE, C_ITEMPROIMPOS.IDMODBCSTNFE, C_ITEMPROIMPOS.CDTPCREDPICOITE, C_ITEMPROIMPOS.CDNATUBCALPCIT, NVL(C_ITEMPROIMPOS.IDMOTDESONERAIT,'9'),
                                       V_CDDETALHEPRODTEMP, (C_ITEMPROIMPOS.VRIMPOSTOIT * V_VRFATOCONV), V_CDREGRAITALIQ, C_ITEMPROIMPOS.IDDIFALIQCUSPRI, V_CDENQLEGALIPI, V_CDCEST,
                                       V_CDBENEFFISCAL);
                                 END IF;
                                 /*Inserir a linha de diferencial de alíquota*/
                              ELSE
                                 INSERT INTO ITEMPROIMPOS(CDFILIAL,     NRLANCTONF,     NRSEQITPROD,     CDIMPOSTO,      NRITPROIMPOS,    CDFISCALIT,
                                                          CDSITUTRIBIT, CDFISCOPERIT,   CDSUFXCFOPIT,    VRALIQITEM,     VRPERREDBCIT,    VRPARDEDIT,
                                                          VRCONTITIMP,  VRBASECALCIT,   VRIMPOSTOIT,     IDERROSIMPIT,   IDAVISIMPIT,     CDSITUTRIBITNFE,
                                                          IDMODBCITNFE, IDMODBCSTITNFE, CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT, IDTRIMPSTII,
                                                          CDDETALHEPROD, VRIMPOSTOVISUIT, IDDIFALIQCUSPRI, CDENQLEGALIPI, CDCEST,         CDBENEFFISCAL)
                                 VALUES(P_FILIAL, P_LANCTONF, C_ITEMPROD.NRSEQITPROD, C_ITEMPROIMPOS.CDIMPOSTO, C_ITEMPROIMPOS.NRITPROIMPOS, V_CDFISCTEMP,
                                        NVL(V_SITUTRIBPR, C_ITEMPROD.CDSITUTRIBPR), V_FISOPEITEM, V_SUFXCFOPPR, C_ITEMPROIMPOS.VRALIQITEM, C_ITEMPROIMPOS.VRPERREDBCIT, (C_ITEMPROIMPOS.VRPARDEDIT * V_VRFATOCONV),
                                        ROUND((C_ITEMPROIMPOS.VRCONTITIMP * V_VRFATOCONV),5), (C_ITEMPROIMPOS.VRBASECALCIT * V_VRFATOCONV),  
                                        (C_ITEMPROIMPOS.VRIMPOSTOIT * V_VRFATOCONV), w_00000, w_00000, V_CDSITUTRIBNFE,
                                        V_IDMODBCNFEIT, V_IDMODBCSTNFEIT, V_CDTPCRPICOSTNFEIT, V_CDNATUBCPCSTNFEIT, V_IDMOTIDESSTNFE, C_ITEMPROIMPOS.IDTRIMPSTII,
                                        V_CDDETALHEPRODTEMP, V_VRIMPOSTOVISUIT, C_ITEMPROIMPOS.IDDIFALIQCUSPRI, V_CDENQLEGALIPI, V_CDCEST, V_CDBENEFFISCAL);
                              END IF;
                           END IF;
                        END IF;
                     END IF;
                     DELETE ALIQTEMP
                      WHERE NRALIQTEMP = V_ALIQTEMP;
                  END LOOP;
               ELSE /*SE A NOTA POSSUI UM UNICO DOCUMENTO DE ORIGEM*/
                  Begin
                     SELECT SUM(I.QTITEMPROD)
                       INTO V_SOMAQITEMPROD
                       FROM ITEMPRODUTO I
                      WHERE CDFILIAL    = C_ITEMNOTAFISC.CDFILIALIT                                          AND
                            NRLANCTONF  = C_ITEMNOTAFISC.NRLANCTONFIT                                        AND
                            CDPRODUTO   = C_ITEMPROD.CDPRODUTO                                               AND
                            ROUND(VRUNITITEM, V_NRDECITOTANF) = ROUND(C_ITEMPROD.VRUNITITEM, V_NRDECITOTANF) AND
                            (NVL(NRLOTEESTQ, ' ')  = (NVL(C_ITEMPROD.NRLOTEESTQ, ' ')))                      AND
                            (NVL(NRSUBLOTE , ' ')  = (NVL(C_ITEMPROD.NRSUBLOTE , ' ')));
                     SELECT NVL(MAX(C_ITEMPROD.QTITEMPROD / V_SOMAQITEMPROD),1) AS VRFATOCONV,
                            NVL(SUM(VRBRUTITEM),0), NVL(SUM(VRCONTITEM),0), NVL(SUM(VRENCARGOIMPXML), 0)
                       INTO V_VRFATOCONV, V_VRBRUTO, V_VRCONTAB, V_VRENCARGOIMPXML
                       FROM ITEMPRODUTO I
                      WHERE CDFILIAL    = C_ITEMNOTAFISC.CDFILIALIT                                          AND
                            NRLANCTONF  = C_ITEMNOTAFISC.NRLANCTONFIT                                        AND
                            CDPRODUTO   = C_ITEMPROD.CDPRODUTO                                               AND
                            ROUND(VRUNITITEM, V_NRDECITOTANF) = ROUND(C_ITEMPROD.VRUNITITEM, V_NRDECITOTANF) AND
                            (NVL(NRLOTEESTQ, ' ')  = (NVL(C_ITEMPROD.NRLOTEESTQ, ' ')))                      AND
                            (NVL(NRSUBLOTE , ' ')  = (NVL(C_ITEMPROD.NRSUBLOTE , ' ')));
                  Exception
                     When No_Data_Found Then
                        V_VRFATOCONV := 1; V_VRBRUTO := 0; V_VRCONTAB := 0;
                  End;
                 /*IF P_TIPOOPER = 03 THEN
                    Begin
                       SELECT NVL(C_ITEMPROD.VRTOTAITEM / SUM(I.VRTOTAITEM) ,1) AS VRFATOCONV,
                              NVL(SUM(VRBRUTITEM),0), NVL(SUM(VRCONTITEM),0)
                       INTO   V_VRFATOCONV, V_VRBRUTO, V_VRCONTAB
                       FROM ITEMPRODUTO I
                       WHERE CDFILIAL    = C_ITEMNOTAFISC.CDFILIALIT                                          AND
                             NRLANCTONF  = C_ITEMNOTAFISC.NRLANCTONFIT                                        AND
                             CDPRODUTO   = C_ITEMPROD.CDPRODUTO                                               AND
                             ROUND(VRUNITITEM, V_NRDECITOTANF) = ROUND(C_ITEMPROD.VRUNITITEM, V_NRDECITOTANF) AND
                             (NVL(NRLOTEESTQ,  )  = (NVL(C_ITEMPROD.NRLOTEESTQ,  )))                      AND
                             (NVL(NRSUBLOTE ,  )  = (NVL(C_ITEMPROD.NRSUBLOTE ,  )));
                    Exception
                       When No_Data_Found Then
                          V_VRFATOCONV := 1; V_VRBRUTO := 0; V_VRCONTAB := 0;
                    End;
                 END IF;*/
                  IF P_TIPOOPER <> '03' THEN
                    UPDATE ITEMPRODUTO
                       SET VRCONTITEMORIG = ROUND(V_VRCONTAB * V_VRFATOCONV,5),
                           VRBRUTITEMORIG = ROUND(V_VRBRUTO * V_VRFATOCONV,5),
                           VRCONTITEM = ROUND(V_VRCONTAB * V_VRFATOCONV,5),
                           VRBRUTITEM = ROUND(V_VRBRUTO * V_VRFATOCONV,5),
                           VRENCARGOIMPXML = ROUND(V_VRENCARGOIMPXML * V_VRFATOCONV,2)
                     WHERE CDFILIAL    = P_FILIAL                                                           AND
                           NRLANCTONF  = P_LANCTONF                                                         AND
                           CDPRODUTO   = C_ITEMPROD.CDPRODUTO                                               AND
                           ROUND(VRUNITITEM, V_NRDECITOTANF) = ROUND(C_ITEMPROD.VRUNITITEM, V_NRDECITOTANF) AND
                           (NVL(NRLOTEESTQ, ' ') = (NVL(C_ITEMPROD.NRLOTEESTQ, ' ')))                        AND
                           (NVL(NRSUBLOTE , ' ') = (NVL(C_ITEMPROD.NRSUBLOTE , ' ')));
                  END IF;
                  IF V_CDINTEGRACAO IS NOT NULL THEN
                     IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (NVL(V_IDORIGDESTNF, 'C') <> 'L') THEN
                        UPDATE ITEMPRODUTO
                        SET VRCONTITEM = TRUNC((V_VRCONTAB * V_VRFATOCONV),2),
                            VRBRUTITEM = TRUNC((V_VRBRUTO * V_VRFATOCONV),2)
                        WHERE CDFILIAL    = P_FILIAL                                                           AND
                              NRLANCTONF  = P_LANCTONF                                                         AND
                              CDPRODUTO   = C_ITEMPROD.CDPRODUTO                                               AND
                              ROUND(VRUNITITEM, V_NRDECITOTANF) = ROUND(C_ITEMPROD.VRUNITITEM, V_NRDECITOTANF) AND
                             (NVL(NRLOTEESTQ, ' ') = (NVL(C_ITEMPROD.NRLOTEESTQ, ' ')))                        AND
                             (NVL(NRSUBLOTE , ' ') = (NVL(C_ITEMPROD.NRSUBLOTE , ' ')));
                     ELSE
                        UPDATE ITEMPRODUTO
                        SET VRCONTITEM = ROUND(V_VRCONTAB * V_VRFATOCONV,5),
                            VRBRUTITEM = ROUND(V_VRBRUTO * V_VRFATOCONV,5)
                        WHERE CDFILIAL    = P_FILIAL                                                           AND
                              NRLANCTONF  = P_LANCTONF                                                         AND
                              CDPRODUTO   = C_ITEMPROD.CDPRODUTO                                               AND
                              ROUND(VRUNITITEM, V_NRDECITOTANF) = ROUND(C_ITEMPROD.VRUNITITEM, V_NRDECITOTANF) AND
                             (NVL(NRLOTEESTQ, ' ') = (NVL(C_ITEMPROD.NRLOTEESTQ, ' ')))                        AND
                             (NVL(NRSUBLOTE , ' ') = (NVL(C_ITEMPROD.NRSUBLOTE , ' ')));
                     END IF;
                  END IF;
                  V_CDIMPOSRECALC := NULL;
                  UPDATE ITEMPRODUTO
                     SET IDUTILBCPMC = 'N'
                   WHERE CDFILIAL = P_FILIAL
                     AND NRLANCTONF = P_LANCTONF
                     AND NRSEQITPROD = C_ITEMPROD.NRSEQITPROD;
                  IF (V_IDCONTCONFORIG = 'N') THEN
                     UPDATE ITEMPRODUTO
                        SET VRCONTITEMORIG = (VRTOTAITEM - VRDESCITEM),
                            VRCONTITEM     = (VRTOTAITEM - VRDESCITEM),
                            VRBRUTITEMORIG = VRTOTAITEM,
                            VRBRUTITEM     = VRTOTAITEM
                      WHERE CDFILIAL       = P_FILIAL
                        AND NRLANCTONF     = P_LANCTONF
                        AND NRSEQITPROD    = C_ITEMPROD.NRSEQITPROD;
                  END IF;
                  /*IMPOSTOS POR ITEM DA NOTA DE ORIGEM*/
                  FOR C_ITEMPROIMPOS IN (SELECT VRPERREDBCIT, NRITPROIMPOS, IT.CDIMPOSTO, CDFISCALIT,
                                                VRALIQITEM, VRPARDEDIT, SUM(VRCONTITIMP) AS VRCONTITIMP,
                                                SUM(VRBASECALCIT) AS VRBASECALCIT, SUM(VRIMPOSTOIT) AS VRIMPOSTOIT,
                                                CDSITUTRIBITNFE AS CDSITUTRIBNFE, IDMODBCITNFE AS IDMODBCNFE, IDMODBCSTITNFE AS IDMODBCSTNFE,
                                                CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT, IDTRIMPSTII, NVL(IDDIFALIQCUSPRI, 'N') AS IDDIFALIQCUSPRI,
                                                IM.CDIMPOSTONFE, IT.CDENQLEGALIPI, IT.CDCEST,
                                                NVL(IT.VRADICFECP, 0) AS VRADICFECP, NVL(SUM(IT.VRADICALIQFECP), 0) AS VRADICALIQFECP,
                                                IT.CDBENEFFISCAL, I.CDFISOPEITEM
                                          FROM ITEMPROIMPOS IT, ITEMPRODUTO I, IMPOSTO IM
                                         WHERE IT.CDFILIAL    = C_ITEMNOTAFISC.CDFILIALIT                                         AND
                                               IT.NRLANCTONF  = C_ITEMNOTAFISC.NRLANCTONFIT                                       AND
                                               I.CDFILIAL     = C_ITEMNOTAFISC.CDFILIALIT                                         AND
                                               I.NRLANCTONF   = C_ITEMNOTAFISC.NRLANCTONFIT                                       AND
                                               IT.NRSEQITPROD = I.NRSEQITPROD                                                     AND
                                               IT.CDIMPOSTO   = IM.CDIMPOSTO                                                      AND
                                               I.CDPRODUTO = C_ITEMPROD.CDPRODUTO                                                 AND
                                               IT.NRITPROIMPOS = '1'                                                              AND
                                               ROUND(I.VRUNITITEM, V_NRDECITOTANF) = ROUND(C_ITEMPROD.VRUNITITEM, V_NRDECITOTANF) AND
                                               (NVL(I.NRLOTEESTQ, ' ') = (NVL(C_ITEMPROD.NRLOTEESTQ, ' ')))                       AND
                                               (NVL(I.NRSUBLOTE, ' ')  = (NVL(C_ITEMPROD.NRSUBLOTE,  ' ')))
                                         GROUP BY VRPERREDBCIT, IT.CDIMPOSTO, NRITPROIMPOS, CDFISCALIT, VRALIQITEM,
                                                  VRPARDEDIT,   CDSITUTRIBITNFE, IDMODBCITNFE, IDMODBCSTITNFE,
                                                  CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT, IDTRIMPSTII, IDDIFALIQCUSPRI,
                                                  IM.CDIMPOSTONFE, IT.CDENQLEGALIPI, IT.CDCEST, IT.VRADICFECP,
                                                  IT.CDBENEFFISCAL, I.CDFISOPEITEM
                                         ORDER BY CDIMPOSTO) LOOP
                     /*IMPOSTO DE SUBSTITUICAO TRIBUTARIA*/
                     V_CDIMPOSTRIB  := null;
                     V_CDBENEFFISCAL := NULL;
                     FOR C_ICMSST IN (SELECT CDIMPOSTO
                                        FROM IMPOSTO
                                       WHERE CDIMPOSTRIB = C_ITEMPROIMPOS.CDIMPOSTO)
                     LOOP
                        V_CDIMPOSTRIB := V_CDIMPOSTRIB||C_ICMSST.CDIMPOSTO||'_';
                     END LOOP;
                     V_CDIMPOSIPI := null;
                     SELECT NVL(MAX(IDGERIPIDESPA), 'N'), MAX(CDIMPOSTOIPI)
                       INTO V_IDGERIPIDESPA, V_CDIMPOSIPI
                       FROM TIPOOPERAC
                      WHERE IDENTRSAIDOP = 'S'
                        AND CDTIPOOPER = P_TIPOOPER
                        AND CDIMPOSTOIPI = C_ITEMPROIMPOS.CDIMPOSTO;
                     IF (V_IDGERICMSTDESPA = 'S') AND (V_CDIMPOSTRIB IS NOT NULL) AND (V_IDUTCTRLFIS = 'S') THEN
                        IF NOT((C_ITEMPROIMPOS.VRPERREDBCIT > 0.00) AND (C_ITEMPROIMPOS.NRITPROIMPOS = w_2)) THEN
                           V_VRTOTALICMSST := V_VRTOTALICMSST + (C_ITEMPROIMPOS.VRIMPOSTOIT * V_VRFATOCONV);
                        END IF;
                        IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (V_ICMS = 'S') THEN
                           INSERT INTO ITEMPROIMPOSORIG(CDFILIAL,     NRLANCTONF,     NRSEQITPROD,     CDIMPOSTO,      NRITPROIMPOS,    CDFISCALIT,
                                                    CDSITUTRIBIT, CDFISCOPERIT,   CDSUFXCFOPIT,    VRALIQITEM,     VRPERREDBCIT,    VRPARDEDIT,
                                                    VRCONTITIMP,  VRBASECALCIT,   VRIMPOSTOIT,     IDERROSIMPIT,   IDAVISIMPIT,     CDSITUTRIBITNFE,
                                                    IDMODBCITNFE, IDMODBCSTITNFE, CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT, IDTRIMPSTII,
                                                    CDDETALHEPROD, CDENQLEGALIPI, CDCEST,          CDBENEFFISCAL)
                           VALUES(P_FILIAL, P_LANCTONF, C_ITEMPROD.NRSEQITPROD, C_ITEMPROIMPOS.CDIMPOSTO, C_ITEMPROIMPOS.NRITPROIMPOS, C_ITEMPROIMPOS.CDFISCALIT,
                                  C_ITEMPROD.CDSITUTRIBPR, V_FISOPEITEM, V_SUFXCFOPPR, C_ITEMPROIMPOS.VRALIQITEM, C_ITEMPROIMPOS.VRPERREDBCIT, TRUNC((C_ITEMPROIMPOS.VRPARDEDIT * V_VRFATOCONV),2),
                                  TRUNC((C_ITEMPROIMPOS.VRCONTITIMP * V_VRFATOCONV),2), TRUNC((C_ITEMPROIMPOS.VRBASECALCIT * V_VRFATOCONV),2),
                                  TRUNC((C_ITEMPROIMPOS.VRIMPOSTOIT * V_VRFATOCONV),2), w_00000, w_00000, C_ITEMPROIMPOS.CDSITUTRIBNFE,
                                  C_ITEMPROIMPOS.IDMODBCNFE, C_ITEMPROIMPOS.IDMODBCSTNFE, C_ITEMPROIMPOS.CDTPCREDPICOITE, C_ITEMPROIMPOS.CDNATUBCALPCIT, NVL(C_ITEMPROIMPOS.IDMOTDESONERAIT,'9'), C_ITEMPROIMPOS.IDTRIMPSTII,
                                  V_CDDETALHEPRODTEMP, C_ITEMPROIMPOS.CDENQLEGALIPI, C_ITEMPROIMPOS.CDCEST, C_ITEMPROIMPOS.CDBENEFFISCAL);
                        ELSE
                           INSERT INTO ITEMPROIMPOSORIG(CDFILIAL,     NRLANCTONF,     NRSEQITPROD,     CDIMPOSTO,      NRITPROIMPOS,    CDFISCALIT,
                                                    CDSITUTRIBIT, CDFISCOPERIT,   CDSUFXCFOPIT,    VRALIQITEM,     VRPERREDBCIT,    VRPARDEDIT,
                                                    VRCONTITIMP,  VRBASECALCIT,   VRIMPOSTOIT,     IDERROSIMPIT,   IDAVISIMPIT,     CDSITUTRIBITNFE,
                                                    IDMODBCITNFE, IDMODBCSTITNFE, CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT, IDTRIMPSTII,
                                                    CDDETALHEPROD, CDENQLEGALIPI, CDCEST,          CDBENEFFISCAL)
                           VALUES(P_FILIAL, P_LANCTONF, C_ITEMPROD.NRSEQITPROD, C_ITEMPROIMPOS.CDIMPOSTO, C_ITEMPROIMPOS.NRITPROIMPOS, C_ITEMPROIMPOS.CDFISCALIT,
                                  C_ITEMPROD.CDSITUTRIBPR, V_FISOPEITEM, V_SUFXCFOPPR, C_ITEMPROIMPOS.VRALIQITEM, C_ITEMPROIMPOS.VRPERREDBCIT, (C_ITEMPROIMPOS.VRPARDEDIT * V_VRFATOCONV),
                                  ROUND((C_ITEMPROIMPOS.VRCONTITIMP * V_VRFATOCONV),2), (C_ITEMPROIMPOS.VRBASECALCIT * V_VRFATOCONV),
                                  (C_ITEMPROIMPOS.VRIMPOSTOIT * V_VRFATOCONV), w_00000, w_00000, C_ITEMPROIMPOS.CDSITUTRIBNFE,
                                  C_ITEMPROIMPOS.IDMODBCNFE, C_ITEMPROIMPOS.IDMODBCSTNFE, C_ITEMPROIMPOS.CDTPCREDPICOITE, C_ITEMPROIMPOS.CDNATUBCALPCIT, NVL(C_ITEMPROIMPOS.IDMOTDESONERAIT,'9'), C_ITEMPROIMPOS.IDTRIMPSTII,
                                  V_CDDETALHEPRODTEMP, C_ITEMPROIMPOS.CDENQLEGALIPI, C_ITEMPROIMPOS.CDCEST, C_ITEMPROIMPOS.CDBENEFFISCAL);
                        END IF;
                     END IF;
                     IF (V_IDGERIPIDESPA = 'S') AND (V_CDIMPOSIPI IS NOT NULL) AND (V_IDUTCTRLFIS = 'S') THEN
                        IF NOT((C_ITEMPROIMPOS.VRPERREDBCIT > 0.00) AND (C_ITEMPROIMPOS.NRITPROIMPOS = w_2)) THEN
                           V_VRTOTALIPI := V_VRTOTALIPI + (C_ITEMPROIMPOS.VRIMPOSTOIT * V_VRFATOCONV);
                        END IF;
                        IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (V_ICMS = 'S') THEN
                           INSERT INTO ITEMPROIMPOSORIG(CDFILIAL,     NRLANCTONF,     NRSEQITPROD,     CDIMPOSTO,      NRITPROIMPOS,    CDFISCALIT,
                                                    CDSITUTRIBIT, CDFISCOPERIT,   CDSUFXCFOPIT,    VRALIQITEM,     VRPERREDBCIT,    VRPARDEDIT,
                                                    VRCONTITIMP,  VRBASECALCIT,   VRIMPOSTOIT,     IDERROSIMPIT,   IDAVISIMPIT,     CDSITUTRIBITNFE,
                                                    IDMODBCITNFE, IDMODBCSTITNFE, CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT, IDTRIMPSTII,
                                                    CDDETALHEPROD, CDENQLEGALIPI, CDCEST, CDBENEFFISCAL)
                           VALUES(P_FILIAL, P_LANCTONF, C_ITEMPROD.NRSEQITPROD, C_ITEMPROIMPOS.CDIMPOSTO, C_ITEMPROIMPOS.NRITPROIMPOS, C_ITEMPROIMPOS.CDFISCALIT,
                                  C_ITEMPROD.CDSITUTRIBPR, V_FISOPEITEM, V_SUFXCFOPPR, C_ITEMPROIMPOS.VRALIQITEM, C_ITEMPROIMPOS.VRPERREDBCIT, TRUNC((C_ITEMPROIMPOS.VRPARDEDIT * V_VRFATOCONV),2),
                                  TRUNC((C_ITEMPROIMPOS.VRCONTITIMP * V_VRFATOCONV),2), TRUNC((C_ITEMPROIMPOS.VRBASECALCIT * V_VRFATOCONV),2),
                                  TRUNC((C_ITEMPROIMPOS.VRIMPOSTOIT * V_VRFATOCONV),2), w_00000, w_00000, C_ITEMPROIMPOS.CDSITUTRIBNFE,
                                  C_ITEMPROIMPOS.IDMODBCNFE, C_ITEMPROIMPOS.IDMODBCSTNFE, C_ITEMPROIMPOS.CDTPCREDPICOITE, C_ITEMPROIMPOS.CDNATUBCALPCIT, NVL(C_ITEMPROIMPOS.IDMOTDESONERAIT,'9'), C_ITEMPROIMPOS.IDTRIMPSTII,
                                  V_CDDETALHEPRODTEMP, C_ITEMPROIMPOS.CDENQLEGALIPI, C_ITEMPROIMPOS.CDCEST, C_ITEMPROIMPOS.CDBENEFFISCAL);
                        ELSE
                           INSERT INTO ITEMPROIMPOSORIG(CDFILIAL,     NRLANCTONF,     NRSEQITPROD,     CDIMPOSTO,      NRITPROIMPOS,    CDFISCALIT,
                                                    CDSITUTRIBIT, CDFISCOPERIT,   CDSUFXCFOPIT,    VRALIQITEM,     VRPERREDBCIT,    VRPARDEDIT,
                                                    VRCONTITIMP,  VRBASECALCIT,   VRIMPOSTOIT,     IDERROSIMPIT,   IDAVISIMPIT,     CDSITUTRIBITNFE,
                                                    IDMODBCITNFE, IDMODBCSTITNFE, CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT, IDTRIMPSTII,
                                                    CDDETALHEPROD, CDENQLEGALIPI, CDCEST, CDBENEFFISCAL)
                           VALUES(P_FILIAL, P_LANCTONF, C_ITEMPROD.NRSEQITPROD, C_ITEMPROIMPOS.CDIMPOSTO, C_ITEMPROIMPOS.NRITPROIMPOS, C_ITEMPROIMPOS.CDFISCALIT,
                                  C_ITEMPROD.CDSITUTRIBPR, V_FISOPEITEM, V_SUFXCFOPPR, C_ITEMPROIMPOS.VRALIQITEM, C_ITEMPROIMPOS.VRPERREDBCIT, (C_ITEMPROIMPOS.VRPARDEDIT * V_VRFATOCONV),
                                  ROUND((C_ITEMPROIMPOS.VRCONTITIMP * V_VRFATOCONV),5), (C_ITEMPROIMPOS.VRBASECALCIT * V_VRFATOCONV),  
                                  (C_ITEMPROIMPOS.VRIMPOSTOIT * V_VRFATOCONV), w_00000, w_00000, C_ITEMPROIMPOS.CDSITUTRIBNFE,
                                  C_ITEMPROIMPOS.IDMODBCNFE, C_ITEMPROIMPOS.IDMODBCSTNFE, C_ITEMPROIMPOS.CDTPCREDPICOITE, C_ITEMPROIMPOS.CDNATUBCALPCIT, NVL(C_ITEMPROIMPOS.IDMOTDESONERAIT,'9'), C_ITEMPROIMPOS.IDTRIMPSTII,
                                  V_CDDETALHEPRODTEMP, C_ITEMPROIMPOS.CDENQLEGALIPI, C_ITEMPROIMPOS.CDCEST, C_ITEMPROIMPOS.CDBENEFFISCAL);
                        END IF;
                     END IF;
                     IF (NOT((V_IDGERICMSTDESPA = 'S') AND (V_CDIMPOSTRIB IS NOT NULL) OR (V_IDGERIPIDESPA = 'S')
                        AND (V_CDIMPOSIPI IS NOT NULL)) AND (V_IDUTCTRLFIS = 'S')) OR (V_IDUTCTRLFIS = 'N') THEN
                        -- Verifica se há grupo fiscal por servico
                        SELECT MAX(CDGRUPOFISC)
                        INTO V_CDGRPFISCSV
                        FROM SERVCLIE SC, SERVICO S
                        WHERE SC.CDFILIAL   = V_CDFILIEMIT AND
                              SC.CDCLIENTE  = P_CLIENTE    AND
                              SC.CDFILIAL   = S.CDFILIAL   AND
                              SC.CDSERVFILI = S.CDSERVFILI AND
                              S.CDPRODUTO   = C_ITEMPROD.CDPRODUTO;
                        IF V_CDGRPFISCSV IS NULL THEN
                        -- Verifica se há grupo fiscal por cliente da filial
                           SELECT MAX(CDGRUPOFISC)
                           INTO V_CDGRPFISCSV
                           FROM CLIENFILIAL
                           WHERE CDFILIAL   = V_CDFILIEMIT AND
                                 CDCLIENTE  = P_CLIENTE;
                        END IF;
                        CONSULTA_INCIDENCIA(w_S, P_EMPRESA, C_ITEMPROD.CDARVPROD, P_INSCESTA, P_TIPOOPER, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC,
                                            V_CDGRPFISCSV, V_IDINTEREST, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, C_ITEMPROD.IDORIGEMPROD);
                        BEGIN
                           SELECT MAX(CDFISCTEMP), MAX(CDDETALHEPROD), MAX(CDENQLEGALIPI), MAX(CDCEST)
                             INTO   V_CDFISCTEMP, V_CDDETALHEPRODTEMP, V_CDENQLEGALIPI, V_CDCEST
                            FROM INCITEMP IT, IMPOSTO IP
                            WHERE IT.NRINCITEMP = V_INCITEMP
                              AND IP.CDIMPOSTO  = IT.CDIMPOTEMP
                              AND IP.IDPRODNOTA = w_P
                              AND IT.CDIMPOTEMP = C_ITEMPROIMPOS.CDIMPOSTO;
                        EXCEPTION
                           WHEN NO_DATA_FOUND THEN
                              V_CDFISCTEMP        := NULL;
                              V_CDDETALHEPRODTEMP := NULL;
                              V_CDENQLEGALIPI     := NULL;
                              V_CDCEST            := NULL;
                        END;
                        IF (C_ITEMPROIMPOS.VRPERREDBCIT > 0.00) AND
                           (C_ITEMPROIMPOS.NRITPROIMPOS = w_2) THEN
                           V_CDFISCTEMP := w_2;
                        ELSE
                           IF (V_CDFISCTEMP IS NULL) THEN
                               V_CDFISCTEMP := C_ITEMPROIMPOS.CDFISCALIT;
                           END IF;
                        END IF;
                        IF V_CDENQLEGALIPI IS NULL THEN
                           V_CDENQLEGALIPI := C_ITEMPROIMPOS.CDENQLEGALIPI;
                        END IF;
                        IF V_CDCEST IS NULL THEN
                           V_CDCEST := C_ITEMPROIMPOS.CDCEST;
                        END IF;
                        DELETE INCITEMP
                         WHERE NRINCITEMP = V_INCITEMP;
                        /*VERIFICA CST POR IMPOSTO*/
                        V_IMPOICMS := NULL;
                        V_CDGRUPOFISCAUX := NULL;
                        SELECT MAX(G.CDGRUPOFISC)
                          INTO V_CDGRUPOFISCAUX
                          FROM GRUPOFISCIMPFIL G,
                               (SELECT CDFILIEMIT AS CDFILIAL
                                  FROM NOTAFISCAL
                                 WHERE CDFILIAL = P_FILIAL
                                       AND NRLANCTONF = P_LANCTONF) F
                         WHERE G.CDFILIAL = F.CDFILIAL
                           AND NOT G.CDGRUPOFISC IS NULL
                           AND G.CDIMPOSTO = C_ITEMPROIMPOS.CDIMPOSTO;
                        IF V_IDORIGDESTNF = 'C' THEN
                           SELECT NVL(MAX(G.CDGRUPOFISC), V_CDGRUPOFISCAUX)
                             INTO V_CDGRUPOFISCAUX
                             FROM GRFISIMPIECLIE G,
                                  (SELECT CDCLIENTE
                                     FROM NOTAFISCAL
                                    WHERE CDFILIAL = P_FILIAL
                                      AND NRLANCTONF = P_LANCTONF) N
                            WHERE G.CDCLIENTE = N.CDCLIENTE
                              AND G.CDEMPRESA = P_EMPRESA
                              AND G.CDINSCESTA = P_INSCESTA
                              AND NOT G.CDGRUPOFISC IS NULL
                              AND G.CDIMPOSTO = C_ITEMPROIMPOS.CDIMPOSTO;
                        ELSE
                           SELECT NVL(MAX(G.CDGRUPOFISC), V_CDGRUPOFISCAUX)
                             INTO V_CDGRUPOFISCAUX
                             FROM GRFISIMPIEFORN G,
                                 (SELECT CDFORNECED
                                    FROM NOTAFISCAL
                                   WHERE CDFILIAL = P_FILIAL
                                     AND NRLANCTONF = P_LANCTONF) N
                            WHERE G.CDFORNECED = N.CDFORNECED
                              AND G.CDEMPRESA = P_EMPRESA
                              AND G.CDINSCESTA = P_INSCESTA
                              AND NOT G.CDGRUPOFISC IS NULL
                              AND G.CDIMPOSTO = C_ITEMPROIMPOS.CDIMPOSTO;
                        END IF;
                        IF V_CDGRUPOFISCAUX IS NULL THEN
                           CONSULTA_CST_NFE(w_S, P_EMPRESA, C_ITEMPROD.CDARVPROD, P_INSCESTA, P_TIPOOPER, V_CDGRUPOFISC,C_ITEMPROIMPOS.CDIMPOSTO, V_IDINTEREST, V_IDINTERNA, P_FILIAL, P_LANCTONF, '', V_CDSITTRIBTMP, V_IDMODBCNFE, V_IDMODBCSTNFE, V_CDTPCRPICOSTNFE, V_CDNATUBCPCSTNFE, V_IDMOTIDESSTNFE, C_ITEMPROD.IDORIGEMPROD);
                        ELSE
                           CONSULTA_CST_NFE(w_S, P_EMPRESA, C_ITEMPROD.CDARVPROD, P_INSCESTA, P_TIPOOPER, V_CDGRUPOFISCAUX,C_ITEMPROIMPOS.CDIMPOSTO, V_IDINTEREST, V_IDINTERNA, P_FILIAL, P_LANCTONF, '', V_CDSITTRIBTMP, V_IDMODBCNFE, V_IDMODBCSTNFE, V_CDTPCRPICOSTNFE, V_CDNATUBCPCSTNFE, V_IDMOTIDESSTNFE, C_ITEMPROD.IDORIGEMPROD);
                        END IF;
                        IF (V_CDSITTRIBTMP IS NULL) THEN
                           V_CDSITUTRIBNFE := C_ITEMPROIMPOS.CDSITUTRIBNFE;
                        ELSE
                           V_CDSITUTRIBNFE := V_CDSITTRIBTMP;
                        END IF;
                        IF (V_IDMODBCNFE IS NULL) THEN
                           V_IDMODBCNFEIT := C_ITEMPROIMPOS.IDMODBCNFE;
                        ELSE
                           V_IDMODBCNFEIT := V_IDMODBCNFE;
                        END IF;
                        IF (V_IDMODBCSTNFE IS NULL) THEN
                           V_IDMODBCSTNFEIT := C_ITEMPROIMPOS.IDMODBCSTNFE;
                        ELSE
                           V_IDMODBCSTNFEIT := V_IDMODBCSTNFE;
                        END IF;
                        IF (C_ITEMPROIMPOS.CDTPCREDPICOITE IS NULL) THEN
                           V_CDTPCRPICOSTNFEIT := V_CDTPCRPICOSTNFE;
                        ELSE
                           V_CDTPCRPICOSTNFEIT := C_ITEMPROIMPOS.CDTPCREDPICOITE;
                        END IF;
                        IF (C_ITEMPROIMPOS.CDNATUBCALPCIT IS NULL) THEN
                           V_CDNATUBCPCSTNFEIT := V_CDNATUBCPCSTNFE;
                        ELSE
                           V_CDNATUBCPCSTNFEIT := C_ITEMPROIMPOS.CDNATUBCALPCIT;
                        END IF;
                        IF (V_IDMOTIDESSTNFE IS NULL) THEN
                           V_IDMOTIDESSTNFE := C_ITEMPROIMPOS.IDMOTDESONERAIT;
                        ELSE
                           V_IDMOTIDESSTNFE := V_IDMOTIDESSTNFE;
                        END IF;
                        SELECT NVL(MAX(IDUTMUNIORIG),'N')
                          INTO V_IDUTMUNIORIG
                          FROM IMPOSTO
                         WHERE CDIMPOSTO = C_ITEMPROIMPOS.CDIMPOSTO;
                        IF ((V_IDUTMUNIORIG = 'O') OR (V_IDUTMUNIORIG = 'N')) THEN
                           CONSULTA_ALIQUOTA(C_ITEMPROIMPOS.CDIMPOSTO, w_S, P_EMPRESA, C_ITEMPROD.CDARVPROD, P_INSCESTA, V_PAISORIG,
                                             V_ESTAORIG, V_PAISDEST, V_ESTADEST, V_MUNIORIG, V_LIQUIITEM, P_INIVALID, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC, P_TIPOOPER,
                                             NULL, NULL, NULL, NULL, NULL, NULL, C_ITEMPROD.IDORIGEMPROD);
                        ELSE
                           CONSULTA_ALIQUOTA(C_ITEMPROIMPOS.CDIMPOSTO, w_S, P_EMPRESA, C_ITEMPROD.CDARVPROD, P_INSCESTA, V_PAISORIG,
                                             V_ESTAORIG, V_PAISDEST, V_ESTADEST, V_MUNIDEST, V_LIQUIITEM, P_INIVALID, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC, P_TIPOOPER,
                                             NULL, NULL, NULL, NULL, NULL, NULL, C_ITEMPROD.IDORIGEMPROD);
                        END IF;
                        V_NRALIQTEMP := 0;
                        V_PARDEDTMP  := 0;
                        V_PREDBCTMP  := 0;
                        V_ALIQUTMP   := 0;
                        V_IMPOSTOIT  := 0;
                        V_CDTIPOOPER    := NULL;
                        V_CDREGRAITALIQ := NULL;
                        SELECT NVL(MAX(NRALIQTEMP),0),      NVL(MAX(VRPARDEDTMP),0), NVL(MAX(VRPREDBCTMP),0), NVL(MAX(VRALIQUTMP),0),
                               NVL(MAX(IDTRIMPSTTMP), w_0), NVL(MAX(VRPBCSTTMP),0),  NVL(MAX(IDPMCBSCALTMP), w_S),
                               MAX(CDTIPOOPERTMP),          MAX(CDREGRATMP),
                               MAX(CDFISCOPER),             MAX(IDDIFEALIQ),         MAX(IDDIFALIQCUSPR),
                               MAX(CDBENEFFISCAL),          NVL(MAX(IDCONSMVAPMC), '3'), NVL(MAX(IDCONSCOMPBCPMC), '3')
                        INTO   V_NRALIQTEMP,                V_PARDEDTMP,             V_PREDBCTMP,             V_ALIQUTMP,
                               V_TRATIMPST,                 V_PBCSUBTRIB,            V_IDPMCBASECAL,
                               V_CDTIPOOPER,                V_CDREGRAITALIQ,
                               V_CDFISCOPERREGRA,           V_IDDIFEALIQREGRA,       V_IDDIFALIQCUSPRREGRA,
                               V_CDBENEFFISCAL,             V_IDCONSMVAPMC,          V_IDCONSCOMPBCPMC
                        FROM ALIQTEMP
                        WHERE (NRALIQTEMP = V_ALIQTEMP);
                        IF V_CDBENEFFISCAL IS NULL THEN
                           V_CDBENEFFISCAL := C_ITEMPROIMPOS.CDBENEFFISCAL;
                        END IF;
                        IF V_PAISORIG = V_PAISCFOP THEN
                           IF V_ESTAORIG = V_ESTACFOP THEN
                              V_CFOP1DIGT := '5';
                           ELSE
                              V_CFOP1DIGT := '6';
                           END IF;
                        ELSE
                           V_CFOP1DIGT := '7';
                        END IF;
                        IF V_CDFISCOPERREGRA IS NOT NULL THEN
                           IF (LENGTH(V_CDFISCOPERREGRA) < 4) THEN
                              V_CDFISCOPERREGRA := V_CFOP1DIGT||V_CDFISCOPERREGRA;
                           END IF;
                        ELSE
                           IF C_ITEMPROIMPOS.CDFISOPEITEM IS NOT NULL THEN
                              V_CDFISCOPERREGRA := V_CFOP1DIGT||SUBSTR(C_ITEMPROIMPOS.CDFISOPEITEM, 2, 3);
                           END IF;
                        END IF;       
                        V_ICMS := 'N';
                        FOR C_ICMS IN (SELECT CDIMPOSTO
                                         FROM IMPOSTONFE N, IMPOSTO I
                                        WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                                          AND N.CDIMPOSTONFE = '00'
                                          AND I.CDIMPOSTO = C_ITEMPROIMPOS.CDIMPOSTO)
                        LOOP
                           V_ICMS := 'S';
                        END LOOP;
                        IF (V_ICMS = 'S') THEN
                           IF (NVL(V_CFOPINFUSU, 'N') <> 'S') AND (V_CDFISCOPERREGRA IS NOT NULL) THEN
                              V_FISOPEITEM        := NVL(V_CDFISCOPERREGRA, V_FISOPEITEM);
                              V_DSCDFISOPEITREGRA := SUBSTR(DESCRICAO_CFOP(V_CDFISCOPERREGRA),1,45);
                           END IF;
                           UPDATE NOTAFISCAL
                              SET DSCDFISOPENF = NVL(V_DSCDFISOPEITREGRA, (SELECT MAX(DSCFOPTMP)
                                                                               FROM CFOPTEMP
                                                                              WHERE NRCFOPTEMP = V_CFOPTEMP))
                            WHERE CDFILIAL   = P_FILIAL   AND
                                  NRLANCTONF = P_LANCTONF;
                           SELECT MAX(CDFISOPETMP), MAX(CDSUFCFOPTMP), SUBSTR(MAX(DSCFOPTMP),1,50)
                             INTO V_FISOPEITEM    , V_SUFXCFOPPR, V_DSCDFISOPEIT
                             FROM CFOPTEMP
                            WHERE NRCFOPTEMP = V_CFOPTEMP;
                           IF (NVL(V_CFOPINFUSU, 'N') <> 'S') AND (V_CDFISCOPERREGRA IS NOT NULL) THEN
                              V_FISOPEITEM        := NVL(V_CDFISCOPERREGRA, V_FISOPEITEM);
                              V_DSCDFISOPEITREGRA := SUBSTR(DESCRICAO_CFOP(V_CDFISCOPERREGRA),1,45);
                           END IF;
                           UPDATE ITEMPRODUTO
                              SET CDFISOPEITEM  = V_FISOPEITEM,
                                  CDSUFXCFOPPR  = V_SUFXCFOPPR,
                                  DSCDFISOPEIT  = V_DSCDFISOPEIT
                            WHERE CDFILIAL    = P_FILIAL AND
                                  NRLANCTONF  = P_LANCTONF AND
                                  NRSEQITPROD = C_ITEMPROD.NRSEQITPROD;
                        END IF;
                        /*Verifica alíquota parametrizada por tipo de operação desde que não seja nota de estorno de cancelamento*/
                        IF ((V_NRALIQTEMP IS NOT NULL) AND (V_CDTIPOOPER IS NOT NULL) AND (V_ESTORNOCANC <> w_S)) THEN
                           V_CDIMPOSRECALC := V_CDIMPOSRECALC||C_ITEMPROIMPOS.CDIMPOSTO||'_';
                           IF (C_ITEMPROIMPOS.NRITPROIMPOS = w_2) THEN
                              V_CDIMPOSTRIB  := null;
                              V_IDVRIMPSTRIB := null;
                           ELSE
                              V_CDIMPOSTRIB  := null;
                              V_IDVRIMPSTRIB := null;
                              /*IMPOSTO DE SUBSTITUICAO TRIBUTARIA*/
                              FOR C_ICMSST IN (SELECT CDIMPOSTO
                                                 FROM IMPOSTO
                                                WHERE CDIMPOSTRIB = C_ITEMPROIMPOS.CDIMPOSTO)
                              LOOP
                                 V_CDIMPOSTRIB := V_CDIMPOSTRIB||C_ICMSST.CDIMPOSTO||'_';
                              END LOOP;
                              V_TAXABASECALC := (100 - V_PREDBCTMP)/100;
                              V_TAXAALIQUOTA := (V_ALIQUTMP/100);
                              V_TAXABCSUBSTR := 1 + (V_PBCSUBTRIB/100);
                              V_BASECALCIT   := V_LIQUIITEM * V_TAXABASECALC;
                              IF V_CDIMPOSTRIB IS NULL THEN
                                 V_IDTRIMPSTII := '';
                              ELSE
                                 IF SUBSTR(V_SITUTRIBPR, 2, 2) = '60' THEN
                                    V_IDTRIMPSTII := 2;
                                 ELSE 
                                    V_IDTRIMPSTII := V_TRATIMPST;
                                 END IF;
                                 IF NVL(V_IDPMCBASECAL, W_N) = W_S THEN
                                    CALCULA_BC_PMC(P_FILIAL,
                                                   P_LANCTONF,
                                                   C_ITEMPROD.NRSEQITPROD,
                                                   C_ITEMPROIMPOS.CDIMPOSTO,
                                                   V_IDCONSMVAPMC,
                                                   V_IDCONSCOMPBCPMC,
                                                   V_PAISDEST,
                                                   V_ESTADEST,
                                                   C_ITEMPROD.CDPRODUTO,
                                                   C_ITEMPROD.QTITEMPROD,
                                                   C_ITEMPROD.VRUNITITEM,
                                                   C_ITEMPROD.VRDESCITEM,
                                                   V_PBCSUBTRIB,
                                                   V_PREDBCTMP,
                                                   NULL,
                                                   NULL,
                                                   NULL,
                                                   NULL,
                                                   NULL,
                                                   NULL,
                                                   'N',
                                                   V_BASECALCTO);
                                    V_IMPOSTOIT := (V_BASECALCTO * V_TAXAALIQUOTA) - V_PARDEDTMP;
                                 ELSE
                                    V_BASECALCTO  := V_BASECALCIT;
                                    V_IMPOSTOIT   := (V_BASECALCIT * V_TAXAALIQUOTA) - V_PARDEDTMP;
                                 END IF;
                                 SELECT NVL(MAX(IDVRIMPSTRIB), 'N')
                                   INTO V_IDVRIMPSTRIB
                                   FROM ITEMPROIMPOS I, IMPOSTO II
                                  WHERE (CDFILIAL = P_FILIAL)
                                    AND (NRLANCTONF = P_LANCTONF)
                                    AND (NRSEQITPROD = C_ITEMPROD.NRSEQITPROD)
                                    AND (INSTR(V_CDIMPOSTRIB,II.CDIMPOSTO||'_') > 0)
                                    AND (I.CDIMPOSTO = II.CDIMPOSTO);
                                 IF (V_TRATIMPST = W_1) OR (NVL(V_IDVRIMPSTRIB, W_N) = W_N) THEN
                                    V_VRIMPOSTOST := 0;
                                 ELSE
                                    BEGIN
                                       SELECT NVL(MAX(VRIMPOSTOIT),0)
                                         INTO V_VRIMPOSTOST
                                         FROM ITEMPROIMPOS I
                                        WHERE (CDFILIAL = P_FILIAL)
                                          AND (NRLANCTONF = P_LANCTONF)
                                          AND (NRSEQITPROD = C_ITEMPROD.NRSEQITPROD)
                                          AND (INSTR(V_CDIMPOSTRIB,CDIMPOSTO||'_') > 0)
                                          AND (NRITPROIMPOS = w_1);
                                    EXCEPTION
                                       WHEN NO_DATA_FOUND THEN BEGIN
                                          V_VRIMPOSTOST := 0;
                                       END;
                                    END;
                                 END IF;
                                 V_IMPOSTOIT := V_IMPOSTOIT - V_VRIMPOSTOST;
                                 IF V_IMPOSTOIT < 0 THEN
                                    V_IMPOSTOIT := 0;
                                 END IF;
                                 IF (V_IDCONTCONFORIG = 'N') THEN
                                    IF NVL(V_IDPMCBASECAL, W_N) = W_S THEN
                                       UPDATE ITEMPRODUTO
                                          SET VRBRUTITEM = VRBRUTITEM + V_IMPOSTOIT,
                                              VRCONTITEM = VRCONTITEM + V_IMPOSTOIT
                                        WHERE CDFILIAL = P_FILIAL
                                          AND NRLANCTONF = P_LANCTONF
                                          AND NRSEQITPROD = C_ITEMPROD.NRSEQITPROD;
                                     END IF;
                                 END IF;
                              END IF;
                              IF NVL(V_IDPMCBASECAL, W_N) = W_N THEN
                                 V_PERDBCALC    := 100 - V_PREDBCTMP;
                                 IF V_PBCSUBTRIB > 0 THEN
                                    V_BASECALCIT := (V_BASECALCIT * V_TAXABCSUBSTR);
                                    V_PREDBCTMP  := V_PBCSUBTRIB;
                                    V_PERDBCALC  := 0;
                                 END IF;
                                 SELECT NVL(MAX(IDUTVLRQTDEIMPO), 'N')
                                   INTO V_IDUTVLRQTDEIMPO
                                   FROM IMPOSTO
                                  WHERE CDIMPOSTO = C_ITEMPROIMPOS.CDIMPOSTO;
                                 IF (V_IDUTVLRQTDEIMPO = 'S') THEN
                                    SELECT NVL(MAX(VRFATOCONVES), 1)
                                      INTO V_VRFATOCONVES
                                      FROM CONVPRODUTO
                                     WHERE CDPRODUTO = C_ITEMPROD.CDPRODUTO;
                                    V_BASECALCTO  := (C_ITEMPROD.QTITEMPROD * V_VRFATOCONVES);
                                    V_IMPOSTOIT   := ((C_ITEMPROD.QTITEMPROD * V_VRFATOCONVES) * V_ALIQUTMP) - V_PARDEDTMP;
                                 ELSE
                                    V_BASECALCTO  := V_BASECALCIT;
                                    V_IMPOSTOIT   := (V_BASECALCIT * V_TAXAALIQUOTA) - V_PARDEDTMP;
                                 END IF;
                              END IF;
                              V_CONTABCALC  := V_LIQUIITEM - (V_LIQUIITEM * V_TAXABASECALC);
                              IF (V_ALIQUTMP = 0) AND (V_IMPOSTOIT = 0) THEN
                                 V_BASECALCTO := 0;
                              END IF;
                              -- Alterar o valor contábil caso o parâmetro Contabiliza conforme NF de origem esteja desmarcado
                              IF (V_IDCONTCONFORIG = 'N') THEN
                                 V_IMPOCONTAB  := 0;
                                 V_IDIMPORECUP := NULL;
                                 V_CDCCTBLATIV := NULL;
                                 V_IDTRATIMPO  := NULL;
                                 SELECT NVL(IDIMPORECUP, 'N'), IDTRATIMPO, CDCCTBLATIV
                                   INTO V_IDIMPORECUP, V_IDTRATIMPO, V_CDCCTBLATIV
                                   FROM IMPOSTO
                                  WHERE CDIMPOSTO = C_ITEMPROIMPOS.CDIMPOSTO;
                                 IF (V_IDIMPORECUP = W_S) THEN
                                    IF (V_CDFISCTEMP = W_1) THEN
                                       IF (V_CDCCTBLATIV IS NOT NULL) THEN
                                          IF V_IDTRATIMPO = W_V THEN
                                             V_IMPOCONTAB := - V_IMPOSTOIT;
                                          END IF;
                                       END IF;
                                    ELSE
                                       IF V_IDTRATIMPO = W_A THEN
                                          V_IMPOCONTAB := V_IMPOSTOIT;
                                       ELSIF V_IDTRATIMPO IN (W_D,W_R) THEN
                                          V_IMPOCONTAB := - V_IMPOSTOIT;
                                       END IF;
                                    END IF;
                                 END IF;
                                 IF (ABS(NVL(V_IMPOCONTAB, 0)) > 0) THEN
                                    UPDATE ITEMPRODUTO
                                       SET VRCONTITEMORIG = (VRCONTITEM) + NVL(V_IMPOCONTAB, 0),
                                           VRCONTITEM     = (VRCONTITEM) + NVL(V_IMPOCONTAB, 0)
                                     WHERE CDFILIAL       = P_FILIAL
                                       AND NRLANCTONF     = P_LANCTONF
                                       AND NRSEQITPROD    = C_ITEMPROD.NRSEQITPROD;
                                 END IF;
                              END IF;
                              -- Alterar o valor contábil caso o parâmetro Contabiliza conforme NF de origem esteja desmarcado
                              Begin
                                 SELECT CDFILIAL
                                 INTO   V_CHAVE
                                 FROM ITEMPROIMPOS
                                 WHERE CDFILIAL     = P_FILIAL                 AND
                                       NRLANCTONF   = P_LANCTONF               AND
                                       NRSEQITPROD  = C_ITEMPROD.NRSEQITPROD   AND
                                       CDIMPOSTO    = C_ITEMPROIMPOS.CDIMPOSTO AND
                                       NRITPROIMPOS = C_ITEMPROIMPOS.NRITPROIMPOS;
                              Exception
                                 When No_Data_Found Then
                                    V_CHAVE := Null;
                              End;
                              SELECT NVL(MAX(IDPERVISIMPSCRE),'S')
                                INTO V_IDPERVISIMPSCRE
                                FROM PARAMGERAL;
                              IF V_IDPERVISIMPSCRE = 'S' THEN
                                 V_VRIMPOSTOVISUIT := V_IMPOSTOIT;
                              ELSE
                                 IF (V_CDFISCTEMP = '1') THEN
                                    V_VRIMPOSTOVISUIT := V_IMPOSTOIT;
                                 ELSE
                                    V_VRIMPOSTOVISUIT := 0;
                                 END IF;
                              END IF;
                              /* ROTINA PARA CALCULAR O DIFERIMENTO DO IMPOSTO */
                              V_PERDIFERE    := NULL;
                              V_IMPOSTOOPERA := NULL;
                              V_IMPOSTODIFER := NULL;
                              IF C_ITEMPROIMPOS.CDIMPOSTONFE = '00' THEN
                                 IF V_CDSITTRIBTMP = 51 THEN
                                    BEGIN
                                       SELECT PD.VRPERDIFERE, 'S'
                                         INTO V_VRPERDIFERE, V_IDDIFECLI
                                         FROM PRODDIFEREIMPCLI PD, PRODUTO PR
                                        WHERE PD.CDPRODUTO = PR.CDPRODUTO
                                          AND PD.CDPAIS = V_PAISORIG
                                          AND PD.SGESTADO = V_ESTAORIG
                                          AND PD.CDCLIENTE = P_CLIENTE
                                          AND PR.CDARVPROD IN (SELECT MAX(PR.CDARVPROD) AS CDARVPROD
                                                                 FROM PRODDIFEREIMPCLI PD, PRODUTO PR
                                                                WHERE PD.CDPRODUTO = PR.CDPRODUTO
                                                                  AND PD.CDPAIS = V_PAISORIG
                                                                  AND PD.SGESTADO = V_ESTAORIG
                                                                  AND PD.CDCLIENTE = P_CLIENTE
                                                                  AND INSTR(NVL(RTRIM(C_ITEMPROD.CDARVPROD), PR.CDARVPROD), PR.CDARVPROD) = 1);
                                    EXCEPTION
                                       WHEN NO_DATA_FOUND THEN
                                          V_VRPERDIFERE := NULL; V_IDDIFECLI := 'N';
                                    END;
                                    IF V_IDDIFECLI = 'N' THEN
                                       BEGIN
                                          SELECT PD.VRPERDIFERE
                                            INTO V_VRPERDIFERE
                                            FROM PRODDIFEREIMPOS PD, PRODUTO PR
                                           WHERE PD.CDPRODUTO = PR.CDPRODUTO
                                             AND PD.CDPAIS = V_PAISORIG
                                             AND PD.SGESTADO = V_ESTAORIG
                                             AND PR.CDARVPROD IN (SELECT MAX(PR.CDARVPROD) AS CDARVPROD
                                                                    FROM PRODDIFEREIMPOS PD, PRODUTO PR
                                                                   WHERE PD.CDPRODUTO = PR.CDPRODUTO
                                                                     AND PD.CDPAIS = V_PAISORIG
                                                                     AND PD.SGESTADO = V_ESTAORIG
                                                                     AND INSTR(NVL(RTRIM(C_ITEMPROD.CDARVPROD), PR.CDARVPROD), PR.CDARVPROD) = 1);
                                       EXCEPTION
                                          WHEN NO_DATA_FOUND THEN
                                             V_VRPERDIFERE := NULL;
                                       END;
                                    END IF;
                                    IF V_VRPERDIFERE IS NOT NULL THEN
                                       V_PERDIFERE    := V_VRPERDIFERE;
                                       V_IMPOSTOOPERA := V_IMPOSTOIT;
                                       V_IMPOSTODIFER := V_IMPOSTOOPERA * (V_VRPERDIFERE/100);
                                       V_IMPOSTOIT := V_IMPOSTOOPERA - V_IMPOSTODIFER;
                                    END IF;
                                 END IF;
                              END IF;
                              IF V_CHAVE IS NULL THEN
                                 V_ICMS := 'N';
                                 FOR C_ICMS IN (SELECT CDIMPOSTO
                                                  FROM IMPOSTONFE N, IMPOSTO I
                                                 WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                                                   AND N.CDIMPOSTONFE = '00'
                                                   AND I.CDIMPOSTO = C_ITEMPROIMPOS.CDIMPOSTO)
                                 LOOP
                                    V_ICMS := 'S';
                                 END LOOP;
                                 IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (V_ICMS = 'S') THEN
                                    INSERT INTO ITEMPROIMPOS(
                                       CDFILIAL,        NRLANCTONF,   NRSEQITPROD,    CDIMPOSTO,       NRITPROIMPOS,   CDFISCALIT,
                                       CDSITUTRIBIT,    CDFISCOPERIT, CDSUFXCFOPIT,   VRALIQITEM,      VRPERREDBCIT,   VRPARDEDIT,
                                       VRCONTITIMP,     VRBASECALCIT, VRIMPOSTOIT,    IDERROSIMPIT,    IDAVISIMPIT,    IDTRIMPSTII,
                                       CDSITUTRIBITNFE, IDMODBCITNFE, IDMODBCSTITNFE, CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT,
                                       CDDETALHEPROD,   VRIMPOSTOVISUIT,   CDREGRAIT, VRPERDIFEREIT, VRIMPOSTOOPERAIT, VRIMPOSTODIFERIT,
                                       CDENQLEGALIPI,   CDCEST,            CDBENEFFISCAL)
                                    VALUES(
                                       P_FILIAL,                P_LANCTONF,     C_ITEMPROD.NRSEQITPROD, C_ITEMPROIMPOS.CDIMPOSTO, w_1,                 V_CDFISCTEMP,
                                       NVL(V_SITUTRIBPR, C_ITEMPROD.CDSITUTRIBPR), V_FISOPEITEM,   V_SUFXCFOPPR,           V_ALIQUTMP,               V_PREDBCTMP,         V_PARDEDTMP,
                                       ROUND(V_BASECALCTO,2),   V_BASECALCTO,   TRUNC(V_IMPOSTOIT,2),   w_00000,                  w_00000,             V_IDTRIMPSTII,
                                       V_CDSITUTRIBNFE,         V_IDMODBCNFEIT, V_IDMODBCSTNFEIT,       V_CDTPCRPICOSTNFEIT,      V_CDNATUBCPCSTNFEIT, V_IDMOTIDESSTNFE,
                                       V_CDDETALHEPRODTEMP, TRUNC(V_VRIMPOSTOVISUIT,2), V_CDREGRAITALIQ, V_PERDIFERE, V_IMPOSTOOPERA, V_IMPOSTODIFER,
                                       V_CDENQLEGALIPI, V_CDCEST, V_CDBENEFFISCAL);
                                 ELSE
                                    IF (C_ITEMPROIMPOS.NRITPROIMPOS = w_3)  THEN
                                       /*Inserir a linha de diferencial de alíquota*/
                                       V_DIFALIQ := 0;
                                       SELECT MAX(VRALIQITEM)
                                         INTO V_DIFALIQ
                                         FROM ITEMPROIMPOS IT, ITEMPRODUTO I
                                        WHERE IT.CDFILIAL     = C_ITEMNOTAFISC.CDFILIALIT
                                          AND IT.NRLANCTONF   = C_ITEMNOTAFISC.NRLANCTONFIT
                                          AND I.CDFILIAL      = C_ITEMNOTAFISC.CDFILIALIT
                                          AND I.NRLANCTONF    = C_ITEMNOTAFISC.NRLANCTONFIT
                                          AND IT.NRSEQITPROD  = I.NRSEQITPROD
                                          AND I.CDPRODUTO     = C_ITEMPROD.CDPRODUTO
                                          AND ROUND(I.VRUNITITEM, V_NRDECITOTANF) = ROUND(C_ITEMPROD.VRUNITITEM, V_NRDECITOTANF)
                                          AND (NVL(NRLOTEESTQ, ' ') = (NVL(C_ITEMPROD.NRLOTEESTQ, ' ')))
                                          AND (NVL(NRSUBLOTE, ' ')  = (NVL(C_ITEMPROD.NRSUBLOTE , ' ')))
                                          AND IT.CDIMPOSTO    = C_ITEMPROIMPOS.CDIMPOSTO
                                          AND IT.NRITPROIMPOS = w_1;
                                       IF  (V_ALIQUTMP = V_DIFALIQ) THEN
                                          INSERT INTO ITEMPROIMPOS(
                                             CDFILIAL,        NRLANCTONF,   NRSEQITPROD,    CDIMPOSTO,       NRITPROIMPOS,   CDFISCALIT,
                                             CDSITUTRIBIT,    CDFISCOPERIT, CDSUFXCFOPIT,   VRALIQITEM,      VRPERREDBCIT,   VRPARDEDIT,
                                             VRCONTITIMP,     VRBASECALCIT, VRIMPOSTOIT,    IDERROSIMPIT,    IDAVISIMPIT,    IDTRIMPSTII,
                                             CDSITUTRIBITNFE, IDMODBCITNFE, IDMODBCSTITNFE, CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT,
                                             CDDETALHEPROD,   VRIMPOSTOVISUIT, CDREGRAIT, IDDIFALIQCUSPRI,
                                             CDENQLEGALIPI,   CDCEST,          CDBENEFFISCAL)
                                          VALUES(
                                             P_FILIAL, P_LANCTONF, C_ITEMPROD.NRSEQITPROD, C_ITEMPROIMPOS.CDIMPOSTO, C_ITEMPROIMPOS.NRITPROIMPOS, C_ITEMPROIMPOS.CDFISCALIT,
                                             C_ITEMPROD.CDSITUTRIBPR, V_FISOPEITEM, V_SUFXCFOPPR, C_ITEMPROIMPOS.VRALIQITEM, C_ITEMPROIMPOS.VRPERREDBCIT, (C_ITEMPROIMPOS.VRPARDEDIT * V_VRFATOCONV),
                                             ROUND((C_ITEMPROIMPOS.VRCONTITIMP * V_VRFATOCONV),5), (C_ITEMPROIMPOS.VRBASECALCIT * V_VRFATOCONV),
                                             (C_ITEMPROIMPOS.VRIMPOSTOIT * V_VRFATOCONV), w_00000, w_00000, C_ITEMPROIMPOS.IDTRIMPSTII, C_ITEMPROIMPOS.CDSITUTRIBNFE,
                                             C_ITEMPROIMPOS.IDMODBCNFE, C_ITEMPROIMPOS.IDMODBCSTNFE, C_ITEMPROIMPOS.CDTPCREDPICOITE, C_ITEMPROIMPOS.CDNATUBCALPCIT, NVL(C_ITEMPROIMPOS.IDMOTDESONERAIT,'9'),
                                             V_CDDETALHEPRODTEMP, (C_ITEMPROIMPOS.VRIMPOSTOIT * V_VRFATOCONV), V_CDREGRAITALIQ, C_ITEMPROIMPOS.IDDIFALIQCUSPRI,
                                             V_CDENQLEGALIPI, V_CDCEST, V_CDBENEFFISCAL);
                                       /*Inserir a linha de diferencial de alíquota*/
                                       END IF;
                                    ELSE
                                       INSERT INTO ITEMPROIMPOS(
                                          CDFILIAL,        NRLANCTONF,   NRSEQITPROD,    CDIMPOSTO,       NRITPROIMPOS,   CDFISCALIT,
                                          CDSITUTRIBIT,    CDFISCOPERIT, CDSUFXCFOPIT,   VRALIQITEM,      VRPERREDBCIT,   VRPARDEDIT,
                                          VRCONTITIMP,     VRBASECALCIT, VRIMPOSTOIT,    IDERROSIMPIT,    IDAVISIMPIT,    IDTRIMPSTII,
                                          CDSITUTRIBITNFE, IDMODBCITNFE, IDMODBCSTITNFE, CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT,
                                          CDDETALHEPROD,   VRIMPOSTOVISUIT,   CDREGRAIT, IDDIFALIQCUSPRI, VRPERDIFEREIT, VRIMPOSTOOPERAIT,
                                          VRIMPOSTODIFERIT, CDENQLEGALIPI, CDCEST, VRADICFECP, VRADICALIQFECP, 
                                          CDBENEFFISCAL)
                                       VALUES(
                                          P_FILIAL,                P_LANCTONF,     C_ITEMPROD.NRSEQITPROD, C_ITEMPROIMPOS.CDIMPOSTO, w_1,               V_CDFISCTEMP,
                                          NVL(V_SITUTRIBPR, C_ITEMPROD.CDSITUTRIBPR), V_FISOPEITEM,   V_SUFXCFOPPR,           V_ALIQUTMP,               V_PREDBCTMP,         V_PARDEDTMP,
                                          ROUND(V_BASECALCTO,5),   ROUND(V_BASECALCTO,2),   ROUND(V_IMPOSTOIT,2),   w_00000,                  w_00000,             V_IDTRIMPSTII,
                                          V_CDSITUTRIBNFE,         V_IDMODBCNFEIT, V_IDMODBCSTNFEIT,       V_CDTPCRPICOSTNFEIT,      V_CDNATUBCPCSTNFEIT, V_IDMOTIDESSTNFE,
                                          V_CDDETALHEPRODTEMP,     ROUND(V_VRIMPOSTOVISUIT,2),     V_CDREGRAITALIQ, C_ITEMPROIMPOS.IDDIFALIQCUSPRI, V_PERDIFERE, V_IMPOSTOOPERA,
                                          V_IMPOSTODIFER, V_CDENQLEGALIPI, V_CDCEST, (C_ITEMPROIMPOS.VRADICFECP * V_VRFATOCONV), C_ITEMPROIMPOS.VRADICALIQFECP,
                                          V_CDBENEFFISCAL);
                                    END IF;
                                 END IF;
                                 IF (C_ITEMPROIMPOS.NRITPROIMPOS = w_1) THEN
                                    IF (V_PREDBCTMP > 0) AND (V_PBCSUBTRIB = 0) THEN
                                       IF C_ITEMPROD.CDSITUTRIBPR = '060' THEN
                                          INSERT INTO ITEMPROIMPOS(
                                             CDFILIAL,        NRLANCTONF,     NRSEQITPROD,    CDIMPOSTO,       NRITPROIMPOS,   CDFISCALIT,
                                             CDSITUTRIBIT,    CDFISCOPERIT,   CDSUFXCFOPIT,   VRALIQITEM,      VRPERREDBCIT,   VRPARDEDIT,
                                             VRCONTITIMP,     VRBASECALCIT,   VRIMPOSTOIT,    IDERROSIMPIT,    IDAVISIMPIT,    IDTRIMPSTII,
                                             CDSITUTRIBITNFE, IDMODBCITNFE,   IDMODBCSTITNFE, CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT,
                                             CDDETALHEPROD,   VRIMPOSTOVISUIT,   CDREGRAIT, CDENQLEGALIPI, CDCEST, VRADICFECP, VRADICALIQFECP,
                                             CDBENEFFISCAL)
                                          VALUES(
                                             P_FILIAL,                P_LANCTONF,     C_ITEMPROD.NRSEQITPROD, C_ITEMPROIMPOS.CDIMPOSTO, w_2,                 w_2,
                                             NVL(V_SITUTRIBPR, C_ITEMPROD.CDSITUTRIBPR), V_FISOPEITEM,   V_SUFXCFOPPR,           0,                        V_PERDBCALC,         V_PARDEDTMP,
                                             V_CONTABCALC,            0,              0,                      w_00000,                  w_00000,             V_IDTRIMPSTII,
                                             V_CDSITUTRIBNFE,         V_IDMODBCNFEIT, V_IDMODBCSTNFEIT,       V_CDTPCRPICOSTNFEIT,      V_CDNATUBCPCSTNFEIT, V_IDMOTIDESSTNFE,
                                             V_CDDETALHEPRODTEMP, 0,     V_CDREGRAITALIQ, V_CDENQLEGALIPI, V_CDCEST, (C_ITEMPROIMPOS.VRADICFECP * V_VRFATOCONV), C_ITEMPROIMPOS.VRADICALIQFECP,
                                             V_CDBENEFFISCAL);
                                       ELSE
                                          INSERT INTO ITEMPROIMPOS(
                                             CDFILIAL,        NRLANCTONF,     NRSEQITPROD,     CDIMPOSTO,       NRITPROIMPOS,   CDFISCALIT,
                                             CDSITUTRIBIT,    CDFISCOPERIT,   CDSUFXCFOPIT,    VRALIQITEM,      VRPERREDBCIT,   VRPARDEDIT,
                                             VRCONTITIMP,     VRBASECALCIT,   VRIMPOSTOIT,     IDERROSIMPIT,    IDAVISIMPIT,    IDTRIMPSTII,
                                             CDSITUTRIBITNFE, IDMODBCITNFE,   IDMODBCSTITNFE,  CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT,
                                             CDDETALHEPROD,   VRIMPOSTOVISUIT,   CDREGRAIT, CDENQLEGALIPI, CDCEST, VRADICFECP, VRADICALIQFECP,
                                             CDBENEFFISCAL)
                                          VALUES(
                                             P_FILIAL,                P_LANCTONF,     C_ITEMPROD.NRSEQITPROD, C_ITEMPROIMPOS.CDIMPOSTO, w_2,                 w_2,
                                             NVL(V_SITUTRIBPR, C_ITEMPROD.CDSITUTRIBPR), V_FISOPEITEM,   V_SUFXCFOPPR,           0,                        V_PERDBCALC,         V_PARDEDTMP,
                                             V_CONTABCALC,            0,              0,                      w_00000,                  w_00000,             V_IDTRIMPSTII,
                                             V_CDSITUTRIBNFE,         V_IDMODBCNFEIT, V_IDMODBCSTNFEIT,       V_CDTPCRPICOSTNFEIT,      V_CDNATUBCPCSTNFEIT, V_IDMOTIDESSTNFE,
                                             V_CDDETALHEPRODTEMP,     0,     V_CDREGRAITALIQ, V_CDENQLEGALIPI, V_CDCEST, (C_ITEMPROIMPOS.VRADICFECP * V_VRFATOCONV), C_ITEMPROIMPOS.VRADICALIQFECP,
                                             V_CDBENEFFISCAL);
                                       END IF;
                                    END IF;
                                 END IF;
                                 IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (V_ICMS = 'S') THEN
                                    INSERT INTO ITEMPROIMPOSORIG(CDFILIAL,     NRLANCTONF,     NRSEQITPROD,     CDIMPOSTO,      NRITPROIMPOS,    CDFISCALIT,
                                                             CDSITUTRIBIT, CDFISCOPERIT,   CDSUFXCFOPIT,    VRALIQITEM,     VRPERREDBCIT,    VRPARDEDIT,
                                                             VRCONTITIMP,  VRBASECALCIT,   VRIMPOSTOIT,     IDERROSIMPIT,   IDAVISIMPIT,     CDSITUTRIBITNFE,
                                                             IDMODBCITNFE, IDMODBCSTITNFE, CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT, IDTRIMPSTII,
                                                             CDDETALHEPROD, CDENQLEGALIPI, CDCEST, CDBENEFFISCAL)
                                    VALUES(P_FILIAL, P_LANCTONF, C_ITEMPROD.NRSEQITPROD, C_ITEMPROIMPOS.CDIMPOSTO, C_ITEMPROIMPOS.NRITPROIMPOS, C_ITEMPROIMPOS.CDFISCALIT,
                                           C_ITEMPROD.CDSITUTRIBPR, V_FISOPEITEM, V_SUFXCFOPPR, C_ITEMPROIMPOS.VRALIQITEM, C_ITEMPROIMPOS.VRPERREDBCIT, TRUNC((C_ITEMPROIMPOS.VRPARDEDIT * V_VRFATOCONV),2),
                                           TRUNC((C_ITEMPROIMPOS.VRCONTITIMP * V_VRFATOCONV),5), TRUNC((C_ITEMPROIMPOS.VRBASECALCIT * V_VRFATOCONV),2), 
                                           TRUNC((C_ITEMPROIMPOS.VRIMPOSTOIT * V_VRFATOCONV),2), w_00000, w_00000, C_ITEMPROIMPOS.CDSITUTRIBNFE,
                                           C_ITEMPROIMPOS.IDMODBCNFE, C_ITEMPROIMPOS.IDMODBCSTNFE, C_ITEMPROIMPOS.CDTPCREDPICOITE, C_ITEMPROIMPOS.CDNATUBCALPCIT, NVL(C_ITEMPROIMPOS.IDMOTDESONERAIT,'9'), C_ITEMPROIMPOS.IDTRIMPSTII,
                                           V_CDDETALHEPRODTEMP, V_CDENQLEGALIPI, V_CDCEST, V_CDBENEFFISCAL);
                                 ELSE
                                    INSERT INTO ITEMPROIMPOSORIG(CDFILIAL,     NRLANCTONF,     NRSEQITPROD,     CDIMPOSTO,      NRITPROIMPOS,    CDFISCALIT,
                                                             CDSITUTRIBIT, CDFISCOPERIT,   CDSUFXCFOPIT,    VRALIQITEM,     VRPERREDBCIT,    VRPARDEDIT,
                                                             VRCONTITIMP,  VRBASECALCIT,   VRIMPOSTOIT,     IDERROSIMPIT,   IDAVISIMPIT,     CDSITUTRIBITNFE,
                                                             IDMODBCITNFE, IDMODBCSTITNFE, CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT, IDTRIMPSTII,
                                                             CDDETALHEPROD, CDENQLEGALIPI, CDCEST, CDBENEFFISCAL)
                                    VALUES(P_FILIAL, P_LANCTONF, C_ITEMPROD.NRSEQITPROD, C_ITEMPROIMPOS.CDIMPOSTO, C_ITEMPROIMPOS.NRITPROIMPOS, C_ITEMPROIMPOS.CDFISCALIT,
                                           C_ITEMPROD.CDSITUTRIBPR, V_FISOPEITEM, V_SUFXCFOPPR, C_ITEMPROIMPOS.VRALIQITEM, C_ITEMPROIMPOS.VRPERREDBCIT, (C_ITEMPROIMPOS.VRPARDEDIT * V_VRFATOCONV),
                                           ROUND((C_ITEMPROIMPOS.VRCONTITIMP * V_VRFATOCONV),5), (C_ITEMPROIMPOS.VRBASECALCIT * V_VRFATOCONV), 
                                           (C_ITEMPROIMPOS.VRIMPOSTOIT * V_VRFATOCONV), w_00000, w_00000, C_ITEMPROIMPOS.CDSITUTRIBNFE,
                                           C_ITEMPROIMPOS.IDMODBCNFE, C_ITEMPROIMPOS.IDMODBCSTNFE, C_ITEMPROIMPOS.CDTPCREDPICOITE, C_ITEMPROIMPOS.CDNATUBCALPCIT, NVL(C_ITEMPROIMPOS.IDMOTDESONERAIT,'9'), C_ITEMPROIMPOS.IDTRIMPSTII,
                                           V_CDDETALHEPRODTEMP, V_CDENQLEGALIPI, V_CDCEST, V_CDBENEFFISCAL);
                                 END IF;
                              END IF;
                           END IF;
                        ELSE
                           Begin
                              SELECT CDFILIAL
                              INTO   V_CHAVE
                              FROM ITEMPROIMPOS
                              WHERE CDFILIAL     = P_FILIAL                 AND
                                    NRLANCTONF   = P_LANCTONF               AND
                                    NRSEQITPROD  = C_ITEMPROD.NRSEQITPROD   AND
                                    CDIMPOSTO    = C_ITEMPROIMPOS.CDIMPOSTO AND
                                    NRITPROIMPOS = C_ITEMPROIMPOS.NRITPROIMPOS;
                           Exception
                              When No_Data_Found Then
                                 V_CHAVE := Null;
                           End;
                           SELECT NVL(MAX(IDPERVISIMPSCRE), 'S')
                             INTO V_IDPERVISIMPSCRE
                             FROM PARAMGERAL;
                           IF V_IDPERVISIMPSCRE = 'S' THEN
                              V_VRIMPOSTOVISUIT := (C_ITEMPROIMPOS.VRIMPOSTOIT * V_VRFATOCONV);
                           ELSE
                              IF (V_CDFISCTEMP = '1') THEN
                                V_VRIMPOSTOVISUIT := (C_ITEMPROIMPOS.VRIMPOSTOIT * V_VRFATOCONV);
                              ELSE
                                V_VRIMPOSTOVISUIT := 0;
                              END IF;
                           END IF;
                           -- Alterar o valor contábil caso o parâmetro Contabiliza conforme NF de origem esteja desmarcado
                           IF (V_IDCONTCONFORIG =  'N') THEN
                              V_IMPOCONTAB  := 0;
                              V_IDIMPORECUP := NULL;
                              V_CDCCTBLATIV := NULL;
                              V_IDTRATIMPO  := NULL;
                              SELECT NVL(IDIMPORECUP, 'N'), IDTRATIMPO, CDCCTBLATIV
                                INTO V_IDIMPORECUP, V_IDTRATIMPO, V_CDCCTBLATIV
                                FROM IMPOSTO
                               WHERE CDIMPOSTO = C_ITEMPROIMPOS.CDIMPOSTO;
                              IF (V_IDIMPORECUP = W_S) THEN
                                 IF (V_CDFISCTEMP = W_1) THEN
                                    IF (V_CDCCTBLATIV IS NOT NULL) THEN
                                       IF V_IDTRATIMPO = W_V THEN
                                          V_IMPOCONTAB := - C_ITEMPROIMPOS.VRIMPOSTOIT;
                                       END IF;
                                    END IF;
                                 ELSE
                                    IF V_IDTRATIMPO = W_A THEN
                                       V_IMPOCONTAB := V_IMPOSTOIT;
                                    ELSIF V_IDTRATIMPO IN (W_D,W_R) THEN
                                       V_IMPOCONTAB := - C_ITEMPROIMPOS.VRIMPOSTOIT;
                                    END IF;
                                 END IF;
                              END IF;
                              IF (ABS(NVL(V_IMPOCONTAB, 0)) > 0) THEN
                                 UPDATE ITEMPRODUTO
                                    SET VRCONTITEMORIG = (VRCONTITEM) + NVL(V_IMPOCONTAB, 0),
                                        VRCONTITEM     = (VRCONTITEM) + NVL(V_IMPOCONTAB, 0)
                                  WHERE CDFILIAL       = P_FILIAL
                                    AND NRLANCTONF     = P_LANCTONF
                                    AND NRSEQITPROD    = C_ITEMPROD.NRSEQITPROD;
                              END IF;
                           END IF;
                           -- Alterar o valor contábil caso o parâmetro Contabiliza conforme NF de origem esteja desmarcado
                           IF V_CHAVE IS NULL THEN
                              V_ICMS := 'N';
                              FOR C_ICMS IN (SELECT CDIMPOSTO
                                               FROM IMPOSTONFE N, IMPOSTO I
                                              WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                                                AND N.CDIMPOSTONFE = '00'
                                                AND I.CDIMPOSTO = C_ITEMPROIMPOS.CDIMPOSTO)
                              LOOP
                                 V_ICMS := 'S';
                              END LOOP;
                              IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (V_ICMS = 'S') THEN
                                 INSERT INTO ITEMPROIMPOS(CDFILIAL,     NRLANCTONF,     NRSEQITPROD,     CDIMPOSTO,      NRITPROIMPOS,    CDFISCALIT,
                                                          CDSITUTRIBIT, CDFISCOPERIT,   CDSUFXCFOPIT,    VRALIQITEM,     VRPERREDBCIT,    VRPARDEDIT,
                                                          VRCONTITIMP,  VRBASECALCIT,   VRIMPOSTOIT,     IDERROSIMPIT,   IDAVISIMPIT,     CDSITUTRIBITNFE,
                                                          IDMODBCITNFE, IDMODBCSTITNFE, CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT, IDTRIMPSTII,
                                                          CDDETALHEPROD, VRIMPOSTOVISUIT, CDENQLEGALIPI, CDCEST, CDBENEFFISCAL)
                                 VALUES(P_FILIAL, P_LANCTONF, C_ITEMPROD.NRSEQITPROD, C_ITEMPROIMPOS.CDIMPOSTO, C_ITEMPROIMPOS.NRITPROIMPOS, V_CDFISCTEMP,
                                        NVL(V_SITUTRIBPR, C_ITEMPROD.CDSITUTRIBPR), V_FISOPEITEM, V_SUFXCFOPPR, C_ITEMPROIMPOS.VRALIQITEM, C_ITEMPROIMPOS.VRPERREDBCIT, TRUNC((C_ITEMPROIMPOS.VRPARDEDIT * V_VRFATOCONV),2),
                                        TRUNC((C_ITEMPROIMPOS.VRCONTITIMP * V_VRFATOCONV),2), TRUNC((C_ITEMPROIMPOS.VRBASECALCIT * V_VRFATOCONV),2),
                                        TRUNC((C_ITEMPROIMPOS.VRIMPOSTOIT * V_VRFATOCONV),2), w_00000, w_00000, V_CDSITUTRIBNFE,
                                        V_IDMODBCNFEIT, V_IDMODBCSTNFEIT, V_CDTPCRPICOSTNFEIT, V_CDNATUBCPCSTNFEIT, V_IDMOTIDESSTNFE, C_ITEMPROIMPOS.IDTRIMPSTII,
                                        V_CDDETALHEPRODTEMP, TRUNC(V_VRIMPOSTOVISUIT,2), V_CDENQLEGALIPI, V_CDCEST, V_CDBENEFFISCAL);
                              ELSE
                                 INSERT INTO ITEMPROIMPOS(CDFILIAL,     NRLANCTONF,     NRSEQITPROD,     CDIMPOSTO,      NRITPROIMPOS,    CDFISCALIT,
                                                          CDSITUTRIBIT, CDFISCOPERIT,   CDSUFXCFOPIT,    VRALIQITEM,     VRPERREDBCIT,    VRPARDEDIT,
                                                          VRCONTITIMP,  VRBASECALCIT,   VRIMPOSTOIT,     IDERROSIMPIT,   IDAVISIMPIT,     CDSITUTRIBITNFE,
                                                          IDMODBCITNFE, IDMODBCSTITNFE, CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT, IDTRIMPSTII,
                                                          CDDETALHEPROD, VRIMPOSTOVISUIT, CDENQLEGALIPI, CDCEST, VRADICFECP, VRADICALIQFECP, 
                                                          CDBENEFFISCAL)
                                 VALUES(P_FILIAL, P_LANCTONF, C_ITEMPROD.NRSEQITPROD, C_ITEMPROIMPOS.CDIMPOSTO, C_ITEMPROIMPOS.NRITPROIMPOS, V_CDFISCTEMP,
                                        NVL(V_SITUTRIBPR, C_ITEMPROD.CDSITUTRIBPR), V_FISOPEITEM, V_SUFXCFOPPR, C_ITEMPROIMPOS.VRALIQITEM, C_ITEMPROIMPOS.VRPERREDBCIT, (C_ITEMPROIMPOS.VRPARDEDIT * V_VRFATOCONV),
                                        ROUND((C_ITEMPROIMPOS.VRCONTITIMP * V_VRFATOCONV),5), (C_ITEMPROIMPOS.VRBASECALCIT * V_VRFATOCONV),  
                                        (C_ITEMPROIMPOS.VRIMPOSTOIT * V_VRFATOCONV), w_00000, w_00000, V_CDSITUTRIBNFE,
                                        V_IDMODBCNFEIT, V_IDMODBCSTNFEIT, V_CDTPCRPICOSTNFEIT, V_CDNATUBCPCSTNFEIT, V_IDMOTIDESSTNFE, C_ITEMPROIMPOS.IDTRIMPSTII,
                                        V_CDDETALHEPRODTEMP, ROUND(V_VRIMPOSTOVISUIT,2), V_CDENQLEGALIPI, V_CDCEST, (C_ITEMPROIMPOS.VRADICFECP * V_VRFATOCONV), C_ITEMPROIMPOS.VRADICALIQFECP,
                                        V_CDBENEFFISCAL);
                              END IF;
                              IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (V_ICMS = 'S') THEN
                                 INSERT INTO ITEMPROIMPOSORIG(CDFILIAL,     NRLANCTONF,     NRSEQITPROD,     CDIMPOSTO,      NRITPROIMPOS,    CDFISCALIT,
                                                          CDSITUTRIBIT, CDFISCOPERIT,   CDSUFXCFOPIT,    VRALIQITEM,     VRPERREDBCIT,    VRPARDEDIT,
                                                          VRCONTITIMP,  VRBASECALCIT,   VRIMPOSTOIT,     IDERROSIMPIT,   IDAVISIMPIT,     CDSITUTRIBITNFE,
                                                          IDMODBCITNFE, IDMODBCSTITNFE, CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT, IDTRIMPSTII,
                                                          CDDETALHEPROD, CDENQLEGALIPI, CDCEST, CDBENEFFISCAL)
                                 VALUES(P_FILIAL, P_LANCTONF, C_ITEMPROD.NRSEQITPROD, C_ITEMPROIMPOS.CDIMPOSTO, C_ITEMPROIMPOS.NRITPROIMPOS, C_ITEMPROIMPOS.CDFISCALIT,
                                        C_ITEMPROD.CDSITUTRIBPR, V_FISOPEITEM, V_SUFXCFOPPR, C_ITEMPROIMPOS.VRALIQITEM, C_ITEMPROIMPOS.VRPERREDBCIT, TRUNC((C_ITEMPROIMPOS.VRPARDEDIT * V_VRFATOCONV),2),
                                        TRUNC((C_ITEMPROIMPOS.VRCONTITIMP * V_VRFATOCONV),2), TRUNC((C_ITEMPROIMPOS.VRBASECALCIT * V_VRFATOCONV),2),
                                        TRUNC((C_ITEMPROIMPOS.VRIMPOSTOIT * V_VRFATOCONV),2), w_00000, w_00000, C_ITEMPROIMPOS.CDSITUTRIBNFE,
                                        C_ITEMPROIMPOS.IDMODBCNFE, C_ITEMPROIMPOS.IDMODBCSTNFE, C_ITEMPROIMPOS.CDTPCREDPICOITE, C_ITEMPROIMPOS.CDNATUBCALPCIT, NVL(C_ITEMPROIMPOS.IDMOTDESONERAIT,'9'), C_ITEMPROIMPOS.IDTRIMPSTII,
                                        V_CDDETALHEPRODTEMP, C_ITEMPROIMPOS.CDENQLEGALIPI, C_ITEMPROIMPOS.CDCEST, V_CDBENEFFISCAL);
                              ELSE
                                 INSERT INTO ITEMPROIMPOSORIG(CDFILIAL,     NRLANCTONF,     NRSEQITPROD,     CDIMPOSTO,      NRITPROIMPOS,    CDFISCALIT,
                                                          CDSITUTRIBIT, CDFISCOPERIT,   CDSUFXCFOPIT,    VRALIQITEM,     VRPERREDBCIT,    VRPARDEDIT,
                                                          VRCONTITIMP,  VRBASECALCIT,   VRIMPOSTOIT,     IDERROSIMPIT,   IDAVISIMPIT,     CDSITUTRIBITNFE,
                                                          IDMODBCITNFE, IDMODBCSTITNFE, CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT, IDTRIMPSTII,
                                                          CDDETALHEPROD, CDENQLEGALIPI, CDCEST, CDBENEFFISCAL)
                                 VALUES(P_FILIAL, P_LANCTONF, C_ITEMPROD.NRSEQITPROD, C_ITEMPROIMPOS.CDIMPOSTO, C_ITEMPROIMPOS.NRITPROIMPOS, C_ITEMPROIMPOS.CDFISCALIT,
                                        C_ITEMPROD.CDSITUTRIBPR, V_FISOPEITEM, V_SUFXCFOPPR, C_ITEMPROIMPOS.VRALIQITEM, C_ITEMPROIMPOS.VRPERREDBCIT, (C_ITEMPROIMPOS.VRPARDEDIT * V_VRFATOCONV),
                                        ROUND((C_ITEMPROIMPOS.VRCONTITIMP * V_VRFATOCONV),5), (C_ITEMPROIMPOS.VRBASECALCIT * V_VRFATOCONV), 
                                        (C_ITEMPROIMPOS.VRIMPOSTOIT * V_VRFATOCONV), w_00000, w_00000, C_ITEMPROIMPOS.CDSITUTRIBNFE,
                                        C_ITEMPROIMPOS.IDMODBCNFE, C_ITEMPROIMPOS.IDMODBCSTNFE, C_ITEMPROIMPOS.CDTPCREDPICOITE, C_ITEMPROIMPOS.CDNATUBCALPCIT, NVL(C_ITEMPROIMPOS.IDMOTDESONERAIT,'9'), C_ITEMPROIMPOS.IDTRIMPSTII,
                                        V_CDDETALHEPRODTEMP, C_ITEMPROIMPOS.CDENQLEGALIPI, C_ITEMPROIMPOS.CDCEST, V_CDBENEFFISCAL);
                              END IF;
                           END IF;
                        END IF;
                     END IF;
                     DELETE ALIQTEMP
                      WHERE NRALIQTEMP = V_ALIQTEMP;
                  END LOOP;
                  /*Imposto gerado como encargo na importaçdo de xml */
                  BEGIN
                     SELECT NVL(IDNFGERADAVIAXML, 'N')
                       INTO V_IDNFORIGVIAXML
                       FROM NOTAFISCAL N, ITEMPRODUTO IP
                      WHERE N.CDFILIAL   = C_ITEMNOTAFISC.CDFILIALIT
                        AND N.NRLANCTONF = C_ITEMNOTAFISC.NRLANCTONFIT
                        AND N.CDFILIAL   = IP.CDFILIAL
                        AND N.NRLANCTONF = IP.NRLANCTONF
                        AND IP.VRENCARGOIMPXML > 0
                        AND ROWNUM = 1;
                  EXCEPTION
                     WHEN NO_DATA_FOUND THEN
                        V_IDNFORIGVIAXML := 'N';
                  END;
                  /*Imposto gerado como encargo na importaçdo de xml*/
                  IF (V_IDNFORIGVIAXML = 'S') AND (V_UPDENCIMPXML = 'N') THEN
                     FOR C_ENCARGO IN (SELECT IMP.CDENCARGOIMPXML
                                         FROM IMPOSTONFE NFE, IMPOSTO IMP
                                        WHERE IMP.CDIMPOSTOXML(+) = NFE.CDIMPOSTONFE
                                          AND IMP.CDENCARGOIMPXML IS NOT NULL
                                         ORDER BY NFE.CDIMPOSTONFE) LOOP
                        UPDATE ITEMENCARGO
                           SET VRITEMENCA = 0
                         WHERE CDFILIAL   = P_FILIAL
                           AND NRLANCTONF = P_LANCTONF
                           AND CDENCARGO  = C_ENCARGO.CDENCARGOIMPXML
                           AND IDALTERADO = 'N';
                     END LOOP;
                     V_UPDENCIMPXML := 'S';
                  END IF;
                  IF (V_IDNFORIGVIAXML = 'S') THEN
                     BEGIN
                        SELECT SUM(I.VRENCARGOIMPXML), SUM(VRTOTAITEM - VRDESCITEM) AS VRLIQUORIG, I.NRSEQITPROD, N.NRACESSONFE
                          INTO V_VRENCARGOIMPXML, V_VRLIQUORIG, V_NRSEQITORIG, V_NRACESSONFORIG
                          FROM ITEMPRODUTO I, NOTAFISCAL N
                         WHERE I.CDFILIAL    = C_ITEMNOTAFISC.CDFILIALIT
                           AND I.NRLANCTONF  = C_ITEMNOTAFISC.NRLANCTONFIT
                           AND I.CDPRODUTO   = C_ITEMPROD.CDPRODUTO
                           AND I.CDFILIAL    = N.CDFILIAL
                           AND I.NRLANCTONF  = N.NRLANCTONF
                           AND ROUND(I.VRUNITITEM, V_NRDECITOTANF) = ROUND(C_ITEMPROD.VRUNITITEM, V_NRDECITOTANF)
                           AND (NVL(I.NRLOTEESTQ, ' ')  = (NVL(C_ITEMPROD.NRLOTEESTQ, ' ')))
                           AND (NVL(I.NRSUBLOTE , ' ')  = (NVL(C_ITEMPROD.NRSUBLOTE , ' ')))
                           AND  I.VRENCARGOIMPXML > 0
                           AND ROWNUM = 1 
                         GROUP BY I.NRSEQITPROD, N.NRACESSONFE;
                     EXCEPTION
                        WHEN NO_DATA_FOUND THEN
                           V_VRENCARGOIMPXML := 0; V_VRLIQUORIG := 0; V_NRSEQITORIG := NULL; V_NRACESSONFORIG := NULL;
                     END;
                     IF (V_VRENCARGOIMPXML > 0) THEN
                        V_VRFATOCONV :=  (C_ITEMPROD.VRTOTAITEM - C_ITEMPROD.VRDESCITEM)/ V_VRLIQUORIG;
                        FOR C_ENCARGOXML IN (SELECT IMP.CDENCARGOIMPXML, IMP.CDIMPOSTO
                                               FROM IMPOSTONFE NFE, IMPOSTO IMP
                                              WHERE IMP.CDIMPOSTOXML(+) = NFE.CDIMPOSTONFE
                                                AND IMP.CDENCARGOIMPXML IS NOT NULL) LOOP
                           BEGIN
                              SELECT IT.VRIMPOSTOIT
                                INTO V_VRIMPENCXMLORIG
                                FROM INTG_TRABITPROIMPOS IT, IMPOSTO I
                               WHERE IT.NRACESSONFE  = V_NRACESSONFORIG
                                 AND IT.CDIMPOSTOIT  = I.CDIMPOSTO
                                 AND LPAD(IT.NRSEQIMPOIT, 4, '0') = V_NRSEQITORIG
                                 AND IT.CDIMPOSTOIT = C_ENCARGOXML.CDIMPOSTO;
                           EXCEPTION
                              WHEN NO_DATA_FOUND THEN
                                 V_VRIMPENCXMLORIG := 0;
                           END;
                           IF V_VRIMPENCXMLORIG > 0 THEN
                              UPDATE ITEMENCARGO
                                 SET VRITEMENCA = VRITEMENCA + (V_VRIMPENCXMLORIG * V_VRFATOCONV)
                               WHERE CDFILIAL   = P_FILIAL
                                 AND NRLANCTONF = P_LANCTONF
                                 AND CDENCARGO  = C_ENCARGOXML.CDENCARGOIMPXML;
                           END IF;
                        END LOOP;
                     END IF;
                  END IF; -- Pegar o valor proporcional do imposto
               END IF;
            END LOOP;
         END IF;
         DELETE CFOPTEMP
          WHERE NRCFOPTEMP = V_CFOPTEMP;
         IF (V_IDOPERDEVONF <> w_S) THEN
            IF V_IDDOCREPLIC IS NOT NULL THEN
               IF LENGTH(V_SITUTRIBPR) = 3 THEN
                  V_SITUTRIBPR := SUBSTR(V_SITUTRIBPR,1,1) || w_90;
               ELSE
                  V_SITUTRIBPR := w_90;
               END IF;
            END IF;
            UPDATE ITEMPRODUTO
            SET CDSITUTRIBPR  = V_SITUTRIBPR
            WHERE CDFILIAL    = P_FILIAL   AND
                  NRLANCTONF  = P_LANCTONF AND
                  NRSEQITPROD = C_ITEMPROD.NRSEQITPROD;
         END IF;
         DELETE CSTTEMP
         WHERE NRCSTTEMP = V_CSTTEMP;
         V_IMPOCONTAB := 0;
      END LOOP;
      SELECT MAX(IDUTCTRLFISSAID)
        INTO V_IDUTCTRLFISSAID
        FROM PARAMGERAL;
      SELECT MAX(IDUTCTRLFISSAID)
        INTO V_IDUTCTRLFISFIL
        FROM PARAMFILIAL
       WHERE CDFILIAL = V_CDFILIEMIT;
      IF V_IDUTCTRLFISSAID = 'S' THEN
         V_IDUTCTRLFIS := 'S';
      ELSE
         IF V_IDUTCTRLFISFIL = 'S' THEN
            V_IDUTCTRLFIS := 'S';
         ELSE
            V_IDUTCTRLFIS := 'N';
         END IF;
      END IF;
      SELECT NVL(MAX(IDGERICMSTDESPA), 'N'), MAX(CDENCARGOICMST), NVL(MAX(IDPEINFICMSTDEME), 'N'), NVL(MAX(IDGERIPIDESPA), 'N')
        INTO V_IDGERICMSTDESPA, V_CDENCARGOICMST, V_IDPEINFICMSTDEME, V_IDGERIPIDESPA
        FROM TIPOOPERAC
       WHERE IDENTRSAIDOP = 'S'
         AND CDTIPOOPER = P_TIPOOPER;
      IF ((V_IDGERICMSTDESPA = 'S') OR (V_IDGERIPIDESPA = 'S')) AND (V_IDUTCTRLFIS = 'S') AND (V_IDNFORIGVIAXML = 'N') THEN
         UPDATE ITEMENCARGO
            SET VRITEMENCA = 0
          WHERE CDFILIAL = P_FILIAL
            AND NRLANCTONF = P_LANCTONF
            AND IDALTERADO = 'N';
      END IF;
      V_VRENCAICMSSTIT := 0;
      FOR C_ITEMNOTAFISC IN (SELECT CDFILIALIT, NRLANCTONFIT
                             FROM ITEMNOTAFISC
                             WHERE CDFILIAL   = P_FILIAL AND
                                   NRLANCTONF = P_LANCTONF) LOOP
         SELECT SUM(VRTOTAITEM - VRDESCITEM) AS VRLIQUORIG
         INTO   V_VRLIQUORIG
         FROM ITEMPRODUTO I
         WHERE CDFILIAL    = C_ITEMNOTAFISC.CDFILIALIT AND
               NRLANCTONF  = C_ITEMNOTAFISC.NRLANCTONFIT;
         IF V_VRLIQUORIG = 0 THEN
            V_VRFATOCONV := 0;
         ELSE
            V_VRFATOCONV := V_LIQUIDO / V_VRLIQUORIG;
         END IF;
         IF (V_IDNFORIGVIAXML = 'N') THEN
            SELECT SUM(VRITEMENCA)
              INTO V_VRENCAICMSSTIT
              FROM ITEMENCARGO
             WHERE CDFILIAL = C_ITEMNOTAFISC.CDFILIALIT
               AND NRLANCTONF = C_ITEMNOTAFISC.NRLANCTONFIT
               AND CDENCARGO = V_CDENCARGOICMST;
            FOR C_ITEMENCARGO IN (SELECT CDENCARGO, SUM(VRITEMENCA) AS VRITEMENCA
                                  FROM ITEMENCARGO
                                  WHERE CDFILIAL   = C_ITEMNOTAFISC.CDFILIALIT   AND
                                        NRLANCTONF = C_ITEMNOTAFISC.NRLANCTONFIT AND
                                        VRITEMENCA > 0
                                  GROUP BY CDENCARGO) LOOP
                SELECT NVL(MAX(IDALTERADO), 'N')
                  INTO V_IDALTERADO_ENCA
                  FROM ITEMENCARGO
                WHERE CDFILIAL   = P_FILIAL
                  AND NRLANCTONF = P_LANCTONF
                  AND CDENCARGO = C_ITEMENCARGO.CDENCARGO;
                IF V_IDALTERADO_ENCA = 'N' THEN
                   UPDATE ITEMENCARGO
                   SET VRITEMENCA = (C_ITEMENCARGO.VRITEMENCA * V_VRFATOCONV)
                   WHERE CDFILIAL   = P_FILIAL   AND
                         NRLANCTONF = P_LANCTONF AND
                         CDENCARGO  = C_ITEMENCARGO.CDENCARGO;
                END IF;
            END LOOP;
         END IF;   
      END LOOP;
      /*CALCULA DESCONTO DE BONIFICAÇÃO NA DEVOLUÇÃO DE NOTAS */
      SELECT MAX(CDENCDESCBONDEV)
        INTO V_CDENCDESCBONDEV
        FROM PARAMGERAL;
      IF V_CDENCDESCBONDEV IS NOT NULL THEN
         SELECT NVL(MAX(IDCONDESBONFORN), 'S') INTO V_IDCONDESBONFORN
           FROM PARAMFILIAL
          WHERE CDFILIAL = V_CDFILIEMIT;
         SELECT MAX(F.CDAJUCTPAG), MAX(F.VRPEDESCFORN), TO_DATE(NVL(MAX(DTINIVRPDESC), '01/01/0100'))
           INTO V_CDAJUCTPAG, V_VRPEDESCFORN, V_DTINIVRPDESC
           FROM FORNECEDOR F
          WHERE (F.CDFORNECED   = P_CLIENTE)
            AND (NOT F.VRPEDESCFORN IS NULL)
            AND (F.IDTPDESCFORN = 'B');
         IF (V_VRPEDESCFORN IS NOT NULL) AND (V_VRPEDESCFORN <> 0) AND (V_IDCONDESBONFORN = 'S') THEN
            IF (P_INIVALID >= V_DTINIVRPDESC) THEN
               V_VRENCARBONI := ROUND(V_LIQUIDO * (V_VRPEDESCFORN/100),2);
               UPDATE ITEMENCARGO
               SET VRITEMENCA = V_VRENCARBONI
               WHERE CDFILIAL = P_FILIAL
                 AND NRLANCTONF = P_LANCTONF
                 AND CDENCARGO = V_CDENCDESCBONDEV;
            END IF;
         END IF;
      END IF;
      DELETE FROM DADOSADIC
       WHERE CDFILIAL   = P_FILIAL
         AND NRLANCTONF = P_LANCTONF
         AND DSDADOADIC LIKE 'Base de Cálculo do ICMS ST%';
      DELETE FROM DADOSADIC
       WHERE CDFILIAL   = P_FILIAL
         AND NRLANCTONF = P_LANCTONF
         AND DSDADOADIC LIKE 'ICMS ST: R$%';
      DELETE FROM DADOSADIC
       WHERE CDFILIAL   = P_FILIAL
         AND NRLANCTONF = P_LANCTONF
         AND DSDADOADIC LIKE 'Valor de IPI: R$%';
      IF (V_IDUTCTRLFIS = 'S') THEN
         IF V_IDGERICMSTDESPA = 'S' THEN
            IF V_CDENCARGOICMST IS NOT NULL THEN
               SELECT NVL(MAX(IDALTERADO), 'N')
                 INTO V_IDALTERADO_ENCA
                 FROM ITEMENCARGO
               WHERE CDFILIAL   = P_FILIAL
                 AND NRLANCTONF = P_LANCTONF
                 AND CDENCARGO = V_CDENCARGOICMST;
               IF V_IDALTERADO_ENCA = 'N' THEN
                  UPDATE ITEMENCARGO
                     SET VRITEMENCA = 0
                   WHERE CDFILIAL = P_FILIAL
                     AND NRLANCTONF = P_LANCTONF
                     AND CDENCARGO = V_CDENCARGOICMST;
               END IF;
               SELECT MAX(CDENCARGO)
                 INTO V_CDENCARGOOD
                 FROM ENCARGO
                WHERE CDENCARGONFE = '04';
               IF V_CDENCARGOOD IS NOT NULL THEN
                  SELECT NVL(MAX(IDALTERADO), 'N')
                    INTO V_IDALTERADO_ENCA
                    FROM ITEMENCARGO
                   WHERE CDFILIAL = P_FILIAL
                     AND NRLANCTONF = P_LANCTONF
                     AND CDENCARGO = V_CDENCARGOOD;
                  IF V_IDALTERADO_ENCA = 'N' THEN
                     IF (V_VRENCAICMSSTIT > 0) OR (V_VRTOTALICMSST > 0) THEN
                        IF V_IDPEINFICMSTDEME = 'S' THEN
                           SELECT NVL(SUM(VRICMSST),0), NVL(SUM(VRBASECALC),0)
                             INTO V_VRICMSST, V_VRBASECALC
                             FROM INFICMSST
                            WHERE CDFILIAL = P_FILIAL
                              AND NRLANCTONF = P_LANCTONF;
                           IF V_VRICMSST > 0 THEN
                              UPDATE ITEMENCARGO
                                 SET VRITEMENCA = ROUND(VRITEMENCA + V_VRICMSST,2)
                               WHERE CDFILIAL = P_FILIAL
                                 AND NRLANCTONF = P_LANCTONF
                                 AND CDENCARGO = V_CDENCARGOOD;
                              IF V_VRBASECALC > 0 THEN
                                 SELECT COUNT(*)
                                   INTO V_EXISTDSDADOSADIC
                                   FROM DADOSADIC
                                  WHERE CDFILIAL = P_FILIAL
                                    AND NRLANCTONF = P_LANCTONF
                                    AND DSDADOADIC LIKE 'Base de Cálculo do ICMS ST%';
                                 IF V_EXISTDSDADOSADIC = 0 THEN
                                    INSERT INTO DADOSADIC(CDFILIAL, NRLANCTONF, NRDADOADIC, DSDADOADIC)
                                                   VALUES(P_FILIAL, P_LANCTONF, V_DADOADIC, 'Base de Cálculo do ICMS ST: R$'||DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(V_VRBASECALC , 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(V_VRBASECALC , 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(V_VRBASECALC , 2), '9999999999999.99')))|| ' ICMS ST: R$'|| DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(V_VRICMSST, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(V_VRICMSST, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(V_VRICMSST, 2), '9999999999999.99'))));
                                    V_DADOADIC := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_DADOADIC) + 1)),3,0);
                                 ELSE
                                    UPDATE DADOSADIC
                                       SET DSDADOADIC = 'Base de Cálculo do ICMS ST: R$'||DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(V_VRBASECALC, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(V_VRBASECALC, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(V_VRBASECALC, 2), '9999999999999.99')))|| ' ICMS ST: R$'|| DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(V_VRICMSST, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(V_VRICMSST, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(V_VRICMSST, 2), '9999999999999.99')))
                                      WHERE CDFILIAL = P_FILIAL
                                        AND NRLANCTONF = P_LANCTONF
                                        AND DSDADOADIC LIKE 'Base de Cálculo do ICMS ST%';
                                 END IF;
                              ELSE
                                 SELECT COUNT(*)
                                   INTO V_EXISTDSDADOSADIC
                                   FROM DADOSADIC
                                  WHERE CDFILIAL = P_FILIAL
                                    AND NRLANCTONF = P_LANCTONF
                                    AND DSDADOADIC LIKE 'ICMS ST: R$%';
                                 IF V_EXISTDSDADOSADIC = 0 THEN
                                    INSERT INTO DADOSADIC(CDFILIAL, NRLANCTONF, NRDADOADIC, DSDADOADIC)
                                                   VALUES(P_FILIAL, P_LANCTONF, V_DADOADIC, 'ICMS ST: R$ '||DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(V_VRICMSST, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(V_VRICMSST, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(V_VRICMSST, 2), '9999999999999.99'))));
                                    V_DADOADIC := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_DADOADIC) + 1)),3,0);
                                 ELSE
                                    UPDATE DADOSADIC
                                       SET DSDADOADIC = 'ICMS ST: R$ '||DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(V_VRICMSST, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(V_VRICMSST, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(V_VRICMSST, 2), '9999999999999.99')))
                                      WHERE CDFILIAL = P_FILIAL
                                        AND NRLANCTONF = P_LANCTONF
                                        AND DSDADOADIC LIKE 'ICMS ST: R$%';
                                 END IF;
                              END IF;
                           END IF;
                        ELSE
                           UPDATE ITEMENCARGO
                              SET VRITEMENCA = ROUND(VRITEMENCA + (V_VRENCAICMSSTIT * V_VRFATOCONV) + V_VRTOTALICMSST,2)
                            WHERE CDFILIAL = P_FILIAL
                              AND NRLANCTONF = P_LANCTONF
                              AND CDENCARGO = V_CDENCARGOOD;
                           SELECT COUNT(*)
                             INTO V_EXISTDSDADOSADIC
                             FROM DADOSADIC
                            WHERE CDFILIAL = P_FILIAL
                              AND NRLANCTONF = P_LANCTONF
                              AND DSDADOADIC LIKE 'ICMS ST: R$%';
                           IF V_EXISTDSDADOSADIC = 0 THEN
                              INSERT INTO DADOSADIC(CDFILIAL, NRLANCTONF, NRDADOADIC, DSDADOADIC)
                                             VALUES(P_FILIAL, P_LANCTONF, V_DADOADIC, 'ICMS ST: R$ '||DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(V_VRTOTALICMSST + (V_VRENCAICMSSTIT * V_VRFATOCONV), 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(V_VRTOTALICMSST + (V_VRENCAICMSSTIT * V_VRFATOCONV), 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(V_VRTOTALICMSST + (V_VRENCAICMSSTIT * V_VRFATOCONV), 2), '9999999999999.99'))));
                              V_DADOADIC := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_DADOADIC) + 1)),3,0);
                           ELSE
                              UPDATE DADOSADIC
                                 SET DSDADOADIC = 'ICMS ST: R$ '||DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(V_VRTOTALICMSST + (V_VRENCAICMSSTIT * V_VRFATOCONV), 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(V_VRTOTALICMSST + (V_VRENCAICMSSTIT * V_VRFATOCONV), 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(V_VRTOTALICMSST + (V_VRENCAICMSSTIT * V_VRFATOCONV), 2), '9999999999999.99')))
                                WHERE CDFILIAL = P_FILIAL
                                  AND NRLANCTONF = P_LANCTONF
                                  AND DSDADOADIC LIKE 'ICMS ST: R$%';
                           END IF;
                        END IF;
                     END IF;
                  END IF;
               END IF;
            END IF;
         END IF;
         IF (V_IDGERIPIDESPA = 'S') THEN
            SELECT MAX(CDENCARGO)
              INTO V_CDENCARGOOD
              FROM ENCARGO
             WHERE CDENCARGONFE = '04';
            IF V_CDENCARGOOD IS NOT NULL THEN
               SELECT NVL(MAX(IDALTERADO), 'N')
                 INTO V_IDALTERADO_ENCA
                 FROM ITEMENCARGO
                WHERE CDFILIAL   = P_FILIAL
                  AND NRLANCTONF = P_LANCTONF
                  AND CDENCARGO  = V_CDENCARGOOD;
               IF V_IDALTERADO_ENCA = 'N' THEN
                  IF (V_VRTOTALIPI > 0) THEN
                     UPDATE ITEMENCARGO
                        SET VRITEMENCA = ROUND(VRITEMENCA + V_VRTOTALIPI, 2)
                      WHERE CDFILIAL = P_FILIAL
                        AND NRLANCTONF = P_LANCTONF
                        AND CDENCARGO = V_CDENCARGOOD;
                     SELECT COUNT(*)
                       INTO V_EXISTDSDADOSADIC
                       FROM DADOSADIC
                      WHERE CDFILIAL = P_FILIAL
                        AND NRLANCTONF = P_LANCTONF
                        AND DSDADOADIC LIKE 'Valor de IPI: R$%';
                     IF (V_EXISTDSDADOSADIC = 0) THEN
                        INSERT INTO DADOSADIC(CDFILIAL, NRLANCTONF, NRDADOADIC, DSDADOADIC)
                                       VALUES(P_FILIAL, P_LANCTONF, V_DADOADIC, 'Valor de IPI: R$ '||DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(V_VRTOTALIPI, 2),'9999999999999.99')),1, 1),'.','0'||LTRIM(TO_CHAR(ROUND(V_VRTOTALIPI, 2),'9999999999999.99')),LTRIM(TO_CHAR(ROUND(V_VRTOTALIPI, 2),'9999999999999.99'))));
                        V_DADOADIC := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_DADOADIC) + 1)),3,0);
                     ELSE
                        UPDATE DADOSADIC
                           SET DSDADOADIC = 'Valor de IPI: R$ '||DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(V_VRTOTALIPI, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(V_VRTOTALIPI, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(V_VRTOTALIPI, 2), '9999999999999.99')))
                          WHERE CDFILIAL = P_FILIAL
                            AND NRLANCTONF = P_LANCTONF
                            AND DSDADOADIC LIKE 'Valor de IPI: R$%';
                     END IF;
                  END IF;
               END IF;
            END IF;
         END IF;
      END IF;
      --RATEIO DOS ENCARGOS--------------------------------------------------------------------------------------------------------
      FOR C_ITEMENCARGO IN (SELECT IE.CDENCARGO AS CDENCARGO, VRITEMENCA, IDENCARGO,
                                   EN.CDCTBLENTREN, EN.CDCTBLSAIDEN
                            FROM ITEMENCARGO IE, ENCARGO EN
                            WHERE (IE.CDFILIAL   = P_FILIAL)     AND
                                  (IE.NRLANCTONF = P_LANCTONF)   AND
                                  (IE.VRITEMENCA > 0)            AND
                                  (EN.CDENCARGO  = IE.CDENCARGO)) LOOP
         V_TOTAPRODENCA := 0;
         FOR C_VRLIQRATEIO IN (SELECT DISTINCT(IP.NRSEQITPROD) AS NRSEQITPROD, (VRTOTAITEM - VRDESCITEM) AS VRLIQUIDO
                               FROM ITEMPRODUTO IP, ITEMPROIMPOS II
                               WHERE (IP.CDFILIAL    = P_FILIAL)       AND
                                     (IP.NRLANCTONF  = P_LANCTONF)     AND
                                     (II.CDFILIAL    = IP.CDFILIAL)    AND
                                     (II.NRLANCTONF  = IP.NRLANCTONF)  AND
                                     (II.NRSEQITPROD = IP.NRSEQITPROD) AND
                                     (EXISTS(SELECT BC.CDIMPOSTO
                                             FROM BASECALC BC
                                             WHERE (BC.CDENCARGO = C_ITEMENCARGO.CDENCARGO) AND
                                                   (BC.CDIMPOSTO = II.CDIMPOSTO)            AND
                                                   (BC.CDIMPOSTO IN (SELECT B.CDIMPOSTO
                                                                    FROM BASECALC B
                                                                    WHERE B.CDENCARGO = C_ITEMENCARGO.CDENCARGO))))) LOOP
            IF NOT (C_VRLIQRATEIO.VRLIQUIDO IS NULL) THEN
               V_TOTAPRODENCA := V_TOTAPRODENCA + C_VRLIQRATEIO.VRLIQUIDO;
            END IF;
         END LOOP;
         IF V_TOTAPRODENCA = 0 THEN
            IF (V_IDCONTCONFORIG = 'N') THEN
               SELECT SUM(VRTOTAITEM - VRDESCITEM)
               INTO   V_TOTAPRODENCA
               FROM ITEMPRODUTO IP
               WHERE (IP.CDFILIAL   = P_FILIAL)   AND
                     (IP.NRLANCTONF = P_LANCTONF);
               IF NOT V_TOTAPRODENCA IS NULL THEN
                  FOR C_ATUAVRCONT IN (SELECT IP.NRSEQITPROD, (VRTOTAITEM - VRDESCITEM) AS VRLIQUIDO
                                       FROM ITEMPRODUTO IP
                                       WHERE (IP.CDFILIAL    = P_FILIAL) AND
                                             (IP.NRLANCTONF  = P_LANCTONF)) LOOP
                     IF (C_ITEMENCARGO.IDENCARGO = w_A) THEN
                        V_VRBRUTO  := (C_ITEMENCARGO.VRITEMENCA/V_TOTAPRODENCA);
                     ELSIF (C_ITEMENCARGO.IDENCARGO = w_D) THEN
                        V_VRBRUTO  := - (C_ITEMENCARGO.VRITEMENCA/V_TOTAPRODENCA);
                     ELSE
                        V_VRBRUTO := 0;
                     END IF;
                     IF (C_ITEMENCARGO.CDCTBLSAIDEN IS NULL) THEN
                        V_VRCONTAB := V_VRBRUTO;
                     ELSE
                        V_VRCONTAB := 0;
                     END IF;
                     IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (NVL(V_IDORIGDESTNF, 'C') <> 'L') THEN
                        UPDATE ITEMPRODUTO
                        SET VRBRUTITEM = TRUNC(VRBRUTITEM + (V_VRBRUTO  * (VRTOTAITEM - VRDESCITEM)),2),
                            VRCONTITEM = TRUNC(VRCONTITEM + (V_VRCONTAB * (VRTOTAITEM - VRDESCITEM)),2)
                        WHERE CDFILIAL    = P_FILIAL   AND
                              NRLANCTONF  = P_LANCTONF AND
                              NRSEQITPROD = C_ATUAVRCONT.NRSEQITPROD;
                     ELSE
                        UPDATE ITEMPRODUTO
                        SET VRBRUTITEM = ROUND(VRBRUTITEM + (V_VRBRUTO  * (VRTOTAITEM - VRDESCITEM)),5),
                            VRCONTITEM = ROUND(VRCONTITEM + (V_VRCONTAB * (VRTOTAITEM - VRDESCITEM)),5)
                        WHERE CDFILIAL    = P_FILIAL   AND
                              NRLANCTONF  = P_LANCTONF AND
                              NRSEQITPROD = C_ATUAVRCONT.NRSEQITPROD;
                     END IF;
                  END LOOP;
               END IF;
            END IF;
         ELSE
            IF (V_IDCONTCONFORIG = 'N') THEN
               FOR C_ATUAVRCONT IN (SELECT DISTINCT(IP.NRSEQITPROD) AS NRSEQITPROD, (VRTOTAITEM - VRDESCITEM) AS VRLIQUIDO
                                    FROM ITEMPRODUTO IP, ITEMPROIMPOS II
                                    WHERE (IP.CDFILIAL    = P_FILIAL)       AND
                                          (IP.NRLANCTONF  = P_LANCTONF)     AND
                                          (II.CDFILIAL    = IP.CDFILIAL)    AND
                                          (II.NRLANCTONF  = IP.NRLANCTONF)  AND
                                          (II.NRSEQITPROD = IP.NRSEQITPROD) AND
                                          (EXISTS(SELECT BC.CDIMPOSTO
                                                  FROM BASECALC BC
                                                  WHERE (BC.CDENCARGO = C_ITEMENCARGO.CDENCARGO) AND
                                                        (BC.CDIMPOSTO = II.CDIMPOSTO)            AND
                                                        (BC.CDIMPOSTO IN (SELECT B.CDIMPOSTO
                                                                          FROM BASECALC B
                                                                          WHERE B.CDENCARGO = C_ITEMENCARGO.CDENCARGO))))) LOOP
                  IF (C_ITEMENCARGO.IDENCARGO = w_A) THEN
                     V_VRBRUTO  := (C_ITEMENCARGO.VRITEMENCA/V_TOTAPRODENCA);
                  ELSIF (C_ITEMENCARGO.IDENCARGO = w_D) THEN
                     V_VRBRUTO  := - (C_ITEMENCARGO.VRITEMENCA/V_TOTAPRODENCA);
                  ELSE
                     V_VRBRUTO := 0;
                  END IF;
                  IF (C_ITEMENCARGO.CDCTBLSAIDEN IS NULL) THEN
                     V_VRCONTAB := V_VRBRUTO;
                  ELSE
                     V_VRCONTAB := 0;
                  END IF;
                  IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (NVL(V_IDORIGDESTNF, 'C') <> 'L') THEN
                     UPDATE ITEMPRODUTO
                     SET VRBRUTITEM = TRUNC(VRBRUTITEM + (V_VRBRUTO  * (VRTOTAITEM - VRDESCITEM)),2),
                         VRCONTITEM = TRUNC(VRCONTITEM + (V_VRCONTAB * (VRTOTAITEM - VRDESCITEM)),2)
                     WHERE CDFILIAL    = P_FILIAL   AND
                           NRLANCTONF  = P_LANCTONF AND
                           NRSEQITPROD = C_ATUAVRCONT.NRSEQITPROD;
                  ELSE
                     UPDATE ITEMPRODUTO
                     SET VRBRUTITEM = ROUND(VRBRUTITEM + (V_VRBRUTO  * (VRTOTAITEM - VRDESCITEM)),5),
                         VRCONTITEM = ROUND(VRCONTITEM + (V_VRCONTAB * (VRTOTAITEM - VRDESCITEM)),5)
                     WHERE CDFILIAL    = P_FILIAL   AND
                           NRLANCTONF  = P_LANCTONF AND
                           NRSEQITPROD = C_ATUAVRCONT.NRSEQITPROD;
                  END IF;
               END LOOP;
            END IF;
            FOR C_ITEMPROIMPOS IN (SELECT II.NRSEQITPROD, II.NRITPROIMPOS, II.CDIMPOSTO, II.VRPERREDBCIT, II.VRALIQITEM,
                                          II.VRPARDEDIT, II.IDTRIMPSTII, (VRTOTAITEM - VRDESCITEM) AS VRLIQUIDO,
                                          NVL(II.VRALIQINTEDEST, 0) AS VRALIQINTEDEST, NVL(II.VRALIQFCP, 0) AS VRALIQFCP,
                                          NVL(IP.IDUTILBCPMC, 'N') AS IDUTILBCPMC, I.CDIMPOSTONFE
                                   FROM ITEMPROIMPOS II, ITEMPRODUTO IP, BASECALC BC, IMPOSTO I
                                   WHERE (II.CDFILIAL     = P_FILIAL)                AND
                                         (II.NRLANCTONF   = P_LANCTONF)              AND
                                         (IP.CDFILIAL     = P_FILIAL)                AND
                                         (IP.NRLANCTONF   = P_LANCTONF)              AND
                                         (IP.NRSEQITPROD  = II.NRSEQITPROD)          AND
                                         (BC.CDIMPOSTO    = II.CDIMPOSTO)            AND
                                         (II.CDIMPOSTO    = I.CDIMPOSTO)             AND
                                         (BC.CDENCARGO    = C_ITEMENCARGO.CDENCARGO)
                                   ORDER BY 1, 2, 3) LOOP
               IF NOT((C_ITEMPROIMPOS.IDUTILBCPMC = W_S) AND (C_ITEMPROIMPOS.CDIMPOSTONFE = '80')) OR (C_ITEMPROIMPOS.IDUTILBCPMC <> W_S) THEN
                  SELECT SUM(VRTOTAITEM - VRDESCITEM)
                    INTO V_TOTAPRENIMPO
                    FROM ITEMPRODUTO IP
                   WHERE IP.CDFILIAL   = P_FILIAL
                     AND IP.NRLANCTONF = P_LANCTONF;
                  IF (V_TOTAPRODENCA <> 0) THEN
                     IF (C_ITEMENCARGO.IDENCARGO = w_A) THEN
                        V_PRODUENCARGO := +(C_ITEMENCARGO.VRITEMENCA/V_TOTAPRENIMPO)*C_ITEMPROIMPOS.VRLIQUIDO;
                     ELSIF (C_ITEMENCARGO.IDENCARGO = w_D) THEN
                        V_PRODUENCARGO := -(C_ITEMENCARGO.VRITEMENCA/V_TOTAPRENIMPO)*C_ITEMPROIMPOS.VRLIQUIDO;
                     ELSE
                        V_PRODUENCARGO := 0;
                     END IF;
                  END IF;
                  V_IDVRIMPSTRIB := null;
                  BEGIN
                     SELECT CASE COUNT(*) WHEN 0 THEN 'M' ELSE 'R' END
                       INTO V_MAJORAOUREDUZ
                       FROM ITEMPROIMPOS
                      WHERE CDFILIAL = P_FILIAL 
                        AND NRLANCTONF = P_LANCTONF
                        AND NRSEQITPROD = C_ITEMPROIMPOS.NRSEQITPROD
                        AND CDIMPOSTO = C_ITEMPROIMPOS.CDIMPOSTO
                        AND NRITPROIMPOS = w_2;
                  EXCEPTION
                     WHEN NO_DATA_FOUND THEN
                        V_MAJORAOUREDUZ := 'M';
                  END;
                  V_VRIMPOSTOST := 0;
                  IF V_MAJORAOUREDUZ = 'R' THEN
                     V_TAXABASECALC := (100 - C_ITEMPROIMPOS.VRPERREDBCIT)/100;
                     V_TAXAALIQUOTA := (C_ITEMPROIMPOS.VRALIQITEM/100);
                  ELSE
                     V_TAXABASECALC := 1 + (C_ITEMPROIMPOS.VRPERREDBCIT)/100;
                     V_TAXAALIQUOTA := (C_ITEMPROIMPOS.VRALIQITEM/100);
                     SELECT NVL(MAX(IDVRIMPSTRIB), 'N')
                       INTO V_IDVRIMPSTRIB
                       FROM ITEMPROIMPOS I, IMPOSTO II
                      WHERE (CDFILIAL     = P_FILIAL)
                        AND (NRLANCTONF   = P_LANCTONF)
                        AND (NRSEQITPROD  = C_ITEMPROIMPOS.NRITPROIMPOS)
                        AND (INSTR(V_CDIMPOSTRIB,II.CDIMPOSTO||'_') > 0)
                        AND (I.CDIMPOSTO = II.CDIMPOSTO);
                     IF (C_ITEMPROIMPOS.IDTRIMPSTII <> w_1) AND (NVL(V_IDVRIMPSTRIB,w_N) = w_S) THEN
                        Begin
                           SELECT NVL(MAX(VRIMPOSTOIT),0)
                           INTO   V_VRIMPOSTOST
                           FROM ITEMPROIMPOS I
                           WHERE (CDFILIAL     = P_FILIAL)                   AND
                                 (NRLANCTONF   = P_LANCTONF)                 AND
                                 (INSTR(V_CDIMPOSTRIB,CDIMPOSTO||'_') > 0)   AND
                                 (NRITPROIMPOS = C_ITEMPROIMPOS.NRITPROIMPOS);
                        Exception
                           When No_Data_Found Then
                              V_VRIMPOSTOST := 0;
                        End;
                     END IF;
                  END IF;
                  V_ICMS := 'N';
                  FOR C_ICMS IN (SELECT CDIMPOSTO
                                   FROM IMPOSTONFE N, IMPOSTO I
                                  WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                                    AND N.CDIMPOSTONFE = '00'
                                    AND I.CDIMPOSTO = C_ITEMPROIMPOS.CDIMPOSTO)
                  LOOP
                     V_ICMS := 'S';
                  END LOOP;
                  SELECT NVL(MAX(IDPERVISIMPSCRE), 'S')
                    INTO V_IDPERVISIMPSCRE
                    FROM PARAMGERAL;
                  UPDATE ITEMPROIMPOS
                     SET VRCONTITIMP  = VRCONTITIMP  + (V_PRODUENCARGO * V_TAXABASECALC),
                         VRBASECALCIT = VRBASECALCIT + ((V_PRODUENCARGO * V_TAXABASECALC) / (1 - ((C_ITEMPROIMPOS.VRALIQINTEDEST + C_ITEMPROIMPOS.VRALIQFCP) / 100))),
                         VRIMPOSTOIT  = (VRIMPOSTOIT  + (((V_PRODUENCARGO * V_TAXABASECALC) / (1 - ((C_ITEMPROIMPOS.VRALIQINTEDEST + C_ITEMPROIMPOS.VRALIQFCP) / 100))) * V_TAXAALIQUOTA)) - (((V_VRIMPOSTOST * V_TAXABASECALC) / (1 - ((C_ITEMPROIMPOS.VRALIQINTEDEST + C_ITEMPROIMPOS.VRALIQFCP) / 100))) * V_TAXAALIQUOTA),
                         VRIMPOSTOVISUIT = DECODE(V_IDPERVISIMPSCRE, 'S', (VRIMPOSTOIT  + ((V_PRODUENCARGO * V_TAXABASECALC) * V_TAXAALIQUOTA)) - ((V_VRIMPOSTOST * V_TAXABASECALC) * V_TAXAALIQUOTA),  DECODE(CDFISCALIT , '1', (VRIMPOSTOIT  + ((V_PRODUENCARGO * V_TAXABASECALC) * V_TAXAALIQUOTA)) - ((V_VRIMPOSTOST * V_TAXABASECALC) * V_TAXAALIQUOTA),0)),
                         VRADICFECP  = VRADICFECP  + ROUND((V_PRODUENCARGO * (VRADICALIQFECP / 100) * V_TAXABASECALC),2)
                   WHERE (CDFILIAL     = P_FILIAL)                   AND
                         (NRLANCTONF   = P_LANCTONF)                 AND
                         (NRSEQITPROD  = C_ITEMPROIMPOS.NRSEQITPROD) AND
                         (CDIMPOSTO    = C_ITEMPROIMPOS.CDIMPOSTO)   AND
                         (NRITPROIMPOS = C_ITEMPROIMPOS.NRITPROIMPOS);
               END IF;
               /* ROTINA PARA RECALCULAR O DIFERIMENTO DO IMPOSTO */
               BEGIN
                  SELECT MAX(VRIMPOSTOOPERAIT), MAX(VRPERDIFEREIT)
                    INTO V_VRIMPOSTOOPERAIT, V_VRPERDIFEREIT
                    FROM ITEMPROIMPOS
                   WHERE (CDFILIAL     = P_FILIAL)                    AND
                         (NRLANCTONF   = P_LANCTONF)                  AND
                         (NRSEQITPROD  = C_ITEMPROIMPOS.NRSEQITPROD)  AND
                         (CDIMPOSTO    = C_ITEMPROIMPOS.CDIMPOSTO)    AND
                         (NRITPROIMPOS = C_ITEMPROIMPOS.NRITPROIMPOS) AND
                         (VRPERDIFEREIT <> 0);
               EXCEPTION
                  When No_Data_Found Then
                     V_VRIMPOSTOOPERAIT := 0; V_VRPERDIFEREIT := 0;
               END;
               IF V_VRPERDIFEREIT <> 0 THEN
                  V_VRIMPOSTOOPERAIT := ROUND((V_VRIMPOSTOOPERAIT + ((ROUND(V_PRODUENCARGO, 2) * V_TAXABASECALC) * V_TAXAALIQUOTA)) - ((V_VRIMPOSTOST * V_TAXABASECALC) * V_TAXAALIQUOTA),2);
                  V_VRIMPOSTODIFERIT := ROUND((V_VRIMPOSTOOPERAIT * V_VRPERDIFEREIT/100), 2);
                  UPDATE ITEMPROIMPOS
                     SET VRIMPOSTOOPERAIT = V_VRIMPOSTOOPERAIT,
                         VRIMPOSTODIFERIT = V_VRIMPOSTODIFERIT,
                         VRIMPOSTOIT = (V_VRIMPOSTOOPERAIT - V_VRIMPOSTODIFERIT),
                         VRIMPOSTOVISUIT = (V_VRIMPOSTOOPERAIT - V_VRIMPOSTODIFERIT)
                   WHERE (CDFILIAL     = P_FILIAL)                    AND
                         (NRLANCTONF   = P_LANCTONF)                  AND
                         (NRSEQITPROD  = C_ITEMPROIMPOS.NRSEQITPROD)  AND
                         (CDIMPOSTO    = C_ITEMPROIMPOS.CDIMPOSTO)    AND
                         (NRITPROIMPOS = C_ITEMPROIMPOS.NRITPROIMPOS) AND
                         (VRPERDIFEREIT <> 0);
               END IF;
            END LOOP;
         END IF;
      END LOOP;
      FOR C_PRODUTO IN (SELECT IP.NRSEQITPROD AS NRSEQITPROD, II.CDIMPOSTO, VRPERREDBCIT,
                               VRALIQITEM, VRPARDEDIT, CDFISCALIT, VRIMPOSTOIT, IDTRATIMPO,
                               IM.IDIMPORECUP, IM.CDCCTBLPASS, IM.CDCCTBLATIV, NRITPROIMPOS,
                               IDTRIMPSTII, IM.IDTIPCONTAB, II.VRBASECALCIT, IP.IDUTILBCPMC,
                               IM.CDIMPOSTONFE
                        FROM ITEMPRODUTO IP, ITEMPROIMPOS II, IMPOSTO IM
                        WHERE (IP.CDFILIAL     = P_FILIAL)      AND
                              (IP.NRLANCTONF   = P_LANCTONF)    AND
                              (II.CDFILIAL     = IP.CDFILIAL)   AND
                              (II.NRLANCTONF   = IP.NRLANCTONF) AND
                              (IM.CDIMPOSTO    = II.CDIMPOSTO)  AND
                              --(INSTR(V_CDIMPOSRECALC,II.CDIMPOSTO||_) > 0) AND
                              (II.NRITPROIMPOS = w_1)           AND
                              (II.NRSEQITPROD  = IP.NRSEQITPROD)
                        ORDER BY NRSEQITPROD, CDIMPOSTO) LOOP
         IF NOT((C_PRODUTO.IDUTILBCPMC = W_S) AND (C_PRODUTO.CDIMPOSTONFE = '80')) OR (C_PRODUTO.IDUTILBCPMC <> W_S) THEN
            V_IDIMPOBCALTPOP := NULL;
            SELECT TO_CHAR(MAX('S')) , NVL(SUM(VRIMPOSTOIT),0) AS VRIMPOBCALC
              INTO   V_IDIMPOBCALTPOP, V_TOTAIMPBCALC
              FROM ITEMPRODUTO IP, ITEMPROIMPOS II, BASECALCTPOPER BC , IMPOSTO I
             WHERE (BC.CDIMPOSTO    = C_PRODUTO.CDIMPOSTO)
               AND (IP.CDFILIAL     = P_FILIAL)
               AND (IP.NRLANCTONF   = P_LANCTONF)
               AND (II.NRLANCTONF   = IP.NRLANCTONF)
               AND (II.CDFILIAL     = IP.CDFILIAL)
               AND (IP.NRSEQITPROD  = C_PRODUTO.NRSEQITPROD)
               AND (II.NRSEQITPROD  = C_PRODUTO.NRSEQITPROD)
               AND (II.NRITPROIMPOS = C_PRODUTO.NRITPROIMPOS)
               AND ((SUBSTR(IP.CDSITUTRIBPR,2,2) = BC.CDCSTIMPOTPOP)  OR (BC.CDCSTIMPOTPOP  IS NULL))
               AND ((SUBSTR(IP.CDFISOPEITEM,2,4) = BC.CDCFOPIMPOTPOP) OR (BC.CDCFOPIMPOTPOP IS NULL))
               AND ((C_PRODUTO.CDFISCALIT        = BC.CDFISCIMPOTPOP) OR (BC.CDFISCIMPOTPOP IS NULL))
               AND (BC.IDENTRSAIDOP = 'S')
               AND (BC.CDTIPOOPER = P_TIPOOPER)
               AND (II.CDIMPOSTO = BC.CDIMPOBCALC)
               AND (BC.CDIMPOBCALC = I.CDIMPOSTO)
               AND (NVL(BC.IDTRATIMPOBCTPOP, I.IDTRATIMPO) <> 'D');
            IF V_IDIMPOBCALTPOP IS NULL THEN
               SELECT NVL(SUM(VRIMPOSTOIT),0) AS VRIMPOBCALC
                 INTO   V_TOTAIMPBCALC
                 FROM ITEMPRODUTO IP, ITEMPROIMPOS II, BASECALC BC, IMPOSTO I
                WHERE (BC.CDIMPOSTO    = C_PRODUTO.CDIMPOSTO)    AND
                      (IP.CDFILIAL     = P_FILIAL)               AND
                      (IP.NRLANCTONF   = P_LANCTONF)             AND
                      (II.NRLANCTONF   = IP.NRLANCTONF)          AND
                      (II.CDFILIAL     = IP.CDFILIAL)            AND
                      (IP.NRSEQITPROD  = C_PRODUTO.NRSEQITPROD)  AND
                      (II.NRSEQITPROD  = C_PRODUTO.NRSEQITPROD)  AND
                      (II.NRITPROIMPOS = C_PRODUTO.NRITPROIMPOS) AND
                      ((SUBSTR(IP.CDSITUTRIBPR,2,2) = BC.CDCSTIMPO)  OR (BC.CDCSTIMPO  IS NULL)) AND
                      ((SUBSTR(IP.CDFISOPEITEM,2,4) = BC.CDCFOPIMPO) OR (BC.CDCFOPIMPO IS NULL)) AND
                      ((C_PRODUTO.CDFISCALIT        = BC.CDFISCIMPO) OR (BC.CDFISCIMPO IS NULL)) AND
                      (II.CDIMPOSTO = BC.CDIMPOBCALC) AND
                      (BC.IDTIPOBCALC   = w_I)AND
                      (BC.CDIMPOBCALC = I.CDIMPOSTO)  AND
                      (NVL(BC.IDTRATIMPOBC, I.IDTRATIMPO) <> 'D');
            END IF;
            V_IDIMBCALTPOPDE := NULL;
            SELECT TO_CHAR(MAX('S')), (NVL(SUM(VRIMPOSTOIT),0)*-1) AS VRIMPOBCALC
              INTO V_IDIMBCALTPOPDE, V_TOTAIMPBCDES
              FROM ITEMPRODUTO IP, ITEMPROIMPOS II, BASECALCTPOPER BC, IMPOSTO I
             WHERE (BC.CDIMPOSTO    = C_PRODUTO.CDIMPOSTO)
               AND (IP.CDFILIAL     = P_FILIAL)
               AND (IP.NRLANCTONF   = P_LANCTONF)
               AND (II.NRLANCTONF   = IP.NRLANCTONF)
               AND (II.CDFILIAL     = IP.CDFILIAL)
               AND (IP.NRSEQITPROD  = C_PRODUTO.NRSEQITPROD)
               AND (II.NRSEQITPROD  = C_PRODUTO.NRSEQITPROD)
               AND (II.NRITPROIMPOS = C_PRODUTO.NRITPROIMPOS)
               AND ((SUBSTR(IP.CDSITUTRIBPR,2,2) = BC.CDCSTIMPOTPOP)  OR (BC.CDCSTIMPOTPOP  IS NULL))
               AND ((SUBSTR(IP.CDFISOPEITEM,2,4) = BC.CDCFOPIMPOTPOP) OR (BC.CDCFOPIMPOTPOP IS NULL))
               AND ((C_PRODUTO.CDFISCALIT        = BC.CDFISCIMPOTPOP) OR (BC.CDFISCIMPOTPOP IS NULL))
               AND (BC.IDENTRSAIDOP = 'S')
               AND (BC.CDTIPOOPER = P_TIPOOPER)
               AND (II.CDIMPOSTO = BC.CDIMPOBCALC)
               AND (BC.CDIMPOBCALC = I.CDIMPOSTO)
               AND (NVL(BC.IDTRATIMPOBCTPOP, I.IDTRATIMPO) = 'D');
            IF V_IDIMBCALTPOPDE IS NULL THEN
               SELECT (NVL(SUM(VRIMPOSTOIT),0)*-1) AS VRIMPOBCALC INTO V_TOTAIMPBCDES
                 FROM ITEMPRODUTO IP, ITEMPROIMPOS II, BASECALC BC, IMPOSTO I
                WHERE (BC.CDIMPOSTO    = C_PRODUTO.CDIMPOSTO)    AND
                      (IP.CDFILIAL     = P_FILIAL)               AND
                      (IP.NRLANCTONF   = P_LANCTONF)             AND
                      (II.NRLANCTONF   = IP.NRLANCTONF)          AND
                      (II.CDFILIAL     = IP.CDFILIAL)            AND
                      (IP.NRSEQITPROD  = C_PRODUTO.NRSEQITPROD)  AND
                      (II.NRSEQITPROD  = C_PRODUTO.NRSEQITPROD)  AND
                      (II.NRITPROIMPOS = C_PRODUTO.NRITPROIMPOS) AND
                      ((SUBSTR(IP.CDSITUTRIBPR,2,2) = BC.CDCSTIMPO)  OR (BC.CDCSTIMPO  IS NULL)) AND
                      ((SUBSTR(IP.CDFISOPEITEM,2,4) = BC.CDCFOPIMPO) OR (BC.CDCFOPIMPO IS NULL)) AND
                      ((C_PRODUTO.CDFISCALIT        = BC.CDFISCIMPO) OR (BC.CDFISCIMPO IS NULL)) AND
                      (II.CDIMPOSTO = BC.CDIMPOBCALC) AND
                      (BC.IDTIPOBCALC   = 'I')        AND
                      (BC.CDIMPOBCALC = I.CDIMPOSTO)  AND
                      (NVL(BC.IDTRATIMPOBC, I.IDTRATIMPO) = 'D');
            END IF;
            V_VRIMPOSTO := C_PRODUTO.VRIMPOSTOIT;
            /*IMPOSTO PARA SUBSTITUIÇÃO TRIBUTARIA*/
            V_CDIMPOSTRIB  := null;
            V_IDVRIMPSTRIB := null;
            FOR C_ICMSST IN (SELECT CDIMPOSTO
                               FROM IMPOSTO
                              WHERE CDIMPOSTRIB = C_PRODUTO.CDIMPOSTO)
            LOOP
               V_CDIMPOSTRIB := V_CDIMPOSTRIB||C_ICMSST.CDIMPOSTO||'_';
            END LOOP;
            V_VRIMPOSTOST := 0;
            /*Só irá fazer o cálculo de outro imposto compondo a base de cálculo,
              se o valor do mesmo não estiver zerado OU
              se for o imposto de st, pois o icms pode ter sido recalculado(por ter alguem compondo sua bc)
              e o imposto st precisa retirar o valor final do st*/
            IF (NOT(V_TOTAIMPBCALC IS NULL) OR (V_TOTAIMPBCALC <> 0)) OR
               (NOT(V_TOTAIMPBCDES IS NULL) OR (V_TOTAIMPBCDES <> 0)) OR
               (V_CDIMPOSTRIB IS NOT NULL) THEN
               SELECT NVL(MAX(IDPERVISIMPSCRE),'S')
                 INTO V_IDPERVISIMPSCRE
                 FROM PARAMGERAL;
               IF V_CDIMPOSTRIB IS NULL THEN
                  V_TAXABASECALC := (100 - C_PRODUTO.VRPERREDBCIT)/100;
                  V_TAXAALIQUOTA := (C_PRODUTO.VRALIQITEM/100);
                  V_VRIMPOSTO    := V_VRIMPOSTO + (((V_TOTAIMPBCALC+V_TOTAIMPBCDES) * V_TAXABASECALC) * V_TAXAALIQUOTA);
                  UPDATE ITEMPROIMPOS
                     SET VRBASECALCIT = VRBASECALCIT + ((V_TOTAIMPBCALC+V_TOTAIMPBCDES) * V_TAXABASECALC),
                         VRIMPOSTOIT  = VRIMPOSTOIT  + (((V_TOTAIMPBCALC+V_TOTAIMPBCDES) * V_TAXABASECALC) * V_TAXAALIQUOTA),
                         VRIMPOSTOVISUIT = DECODE(V_IDPERVISIMPSCRE, 'S', VRIMPOSTOIT  + (((V_TOTAIMPBCALC+V_TOTAIMPBCDES) * V_TAXABASECALC) * V_TAXAALIQUOTA), DECODE(CDFISCALIT, '1', VRIMPOSTOIT  + (((V_TOTAIMPBCALC+V_TOTAIMPBCDES) * V_TAXABASECALC) * V_TAXAALIQUOTA), 0))
                   WHERE (CDFILIAL     = P_FILIAL)              AND
                         (NRLANCTONF   = P_LANCTONF)            AND
                         (NRSEQITPROD  = C_PRODUTO.NRSEQITPROD) AND
                         (CDIMPOSTO    = C_PRODUTO.CDIMPOSTO)   AND
                         (NRITPROIMPOS = C_PRODUTO.NRITPROIMPOS);
                  /* ROTINA PARA RECALCULAR O DIFERIMENTO DO IMPOSTO */
                  BEGIN
                     SELECT MAX(VRIMPOSTOOPERAIT), MAX(VRPERDIFEREIT)
                       INTO V_VRIMPOSTOOPERAIT, V_VRPERDIFEREIT
                       FROM ITEMPROIMPOS
                      WHERE (CDFILIAL     = P_FILIAL)               AND
                            (NRLANCTONF   = P_LANCTONF)             AND
                            (NRSEQITPROD  = C_PRODUTO.NRSEQITPROD)  AND
                            (CDIMPOSTO    = C_PRODUTO.CDIMPOSTO)    AND
                            (NRITPROIMPOS = C_PRODUTO.NRITPROIMPOS) AND
                            (VRPERDIFEREIT <> 0);
                  EXCEPTION
                     When No_Data_Found Then
                        V_VRIMPOSTOOPERAIT := 0; V_VRPERDIFEREIT := 0;
                  END;
                  IF V_VRPERDIFEREIT <> 0 THEN
                     V_VRIMPOSTOOPERAIT := ROUND((V_VRIMPOSTOOPERAIT + ((ROUND((V_TOTAIMPBCALC+V_TOTAIMPBCDES), 2) * V_TAXABASECALC) * V_TAXAALIQUOTA)),2);
                     V_VRIMPOSTODIFERIT := ROUND((V_VRIMPOSTOOPERAIT * V_VRPERDIFEREIT/100), 2);
                     UPDATE ITEMPROIMPOS
                        SET VRIMPOSTOOPERAIT = V_VRIMPOSTOOPERAIT,
                            VRIMPOSTODIFERIT = V_VRIMPOSTODIFERIT,
                            VRIMPOSTOIT = (V_VRIMPOSTOOPERAIT - V_VRIMPOSTODIFERIT),
                            VRIMPOSTOVISUIT = (V_VRIMPOSTOOPERAIT - V_VRIMPOSTODIFERIT)
                      WHERE (CDFILIAL     = P_FILIAL)               AND
                            (NRLANCTONF   = P_LANCTONF)             AND
                            (NRSEQITPROD  = C_PRODUTO.NRSEQITPROD)  AND
                            (CDIMPOSTO    = C_PRODUTO.CDIMPOSTO)    AND
                            (NRITPROIMPOS = C_PRODUTO.NRITPROIMPOS) AND
                            (VRPERDIFEREIT <> 0);
                  END IF;
               ELSE
                  V_VRIMPOSST   := 0;
                  V_VRIMPOSTOST := 0;
                  FOR C_SUBSTRIB IN (SELECT NVL(IDVRIMPSTRIB, 'N') IDVRIMPSTRIB, I.CDIMPOSTO
                                       FROM ITEMPROIMPOS I, IMPOSTO II
                                      WHERE (CDFILIAL     = P_FILIAL)
                                        AND (NRLANCTONF   = P_LANCTONF)
                                        AND (NRSEQITPROD  = C_PRODUTO.NRSEQITPROD)
                                        AND (NRITPROIMPOS = '1')
                                        AND (INSTR(V_CDIMPOSTRIB,II.CDIMPOSTO||'_') > 0)
                                        AND (I.CDIMPOSTO = II.CDIMPOSTO))
                  LOOP
                     IF (C_SUBSTRIB.IDVRIMPSTRIB = w_S) THEN
                        Begin
                           SELECT NVL(ROUND(MAX(VRIMPOSTOIT), 2),0)
                           INTO   V_VRIMPOSST
                           FROM ITEMPROIMPOS I
                           WHERE (CDFILIAL     = P_FILIAL)                   AND
                                 (NRLANCTONF   = P_LANCTONF)                 AND
                                 (NRSEQITPROD  = C_PRODUTO.NRSEQITPROD)  AND
                                 (CDIMPOSTO    = C_SUBSTRIB.CDIMPOSTO)       AND
                                 (INSTR(V_CDIMPOSTRIB,CDIMPOSTO||'_') > 0)   AND
                                 (NRITPROIMPOS = w_1);
                        Exception
                           When No_Data_Found Then
                              V_VRIMPOSST := 0;
                        End;
                     ELSE
                        V_VRIMPOSST := 0;
                     END IF;
                     V_VRIMPOSTOST := V_VRIMPOSTOST + V_VRIMPOSST;
                  END LOOP;
                  V_TAXABASECALC := 1 + (C_PRODUTO.VRPERREDBCIT)/100;
                  V_TAXAALIQUOTA := (C_PRODUTO.VRALIQITEM/100);
                  V_VRIMPOSTO := ((C_PRODUTO.VRBASECALCIT+ ((V_TOTAIMPBCALC+V_TOTAIMPBCDES) * V_TAXABASECALC)) * V_TAXAALIQUOTA);
                  SELECT NVL(MAX(IDPERVISIMPSCRE), 'S')
                    INTO V_IDPERVISIMPSCRE
                    FROM PARAMGERAL;
                  IF V_VRIMPOSTOST > V_VRIMPOSTO THEN
                     UPDATE ITEMPROIMPOS
                     SET VRBASECALCIT = VRBASECALCIT + ((V_TOTAIMPBCALC+V_TOTAIMPBCDES) * V_TAXABASECALC),
                         VRIMPOSTOIT  = 0,
                         VRIMPOSTOVISUIT = 0
                     WHERE (CDFILIAL     = P_FILIAL)              AND
                           (NRLANCTONF   = P_LANCTONF)            AND
                           (NRSEQITPROD  = C_PRODUTO.NRSEQITPROD) AND
                           (CDIMPOSTO    = C_PRODUTO.CDIMPOSTO)   AND
                           (NRITPROIMPOS = C_PRODUTO.NRITPROIMPOS);
                     V_VRIMPOSTO := 0;
                  ELSE
                     UPDATE ITEMPROIMPOS
                        SET VRBASECALCIT = VRBASECALCIT + ((V_TOTAIMPBCALC+V_TOTAIMPBCDES) * V_TAXABASECALC),
                            VRIMPOSTOIT  = V_VRIMPOSTO - V_VRIMPOSTOST,
                            VRIMPOSTOVISUIT = DECODE(V_IDPERVISIMPSCRE, 'S', V_VRIMPOSTO - V_VRIMPOSTOST, DECODE(CDFISCALIT, '1', V_VRIMPOSTO - V_VRIMPOSTOST, 0))
                      WHERE (CDFILIAL     = P_FILIAL)              AND
                            (NRLANCTONF   = P_LANCTONF)            AND
                            (NRSEQITPROD  = C_PRODUTO.NRSEQITPROD) AND
                            (CDIMPOSTO    = C_PRODUTO.CDIMPOSTO)   AND
                            (NRITPROIMPOS = C_PRODUTO.NRITPROIMPOS);
                     V_VRIMPOSTO := V_VRIMPOSTO - V_VRIMPOSTOST;
                     IF (V_IDCONTCONFORIG = 'N') THEN
                        UPDATE ITEMPRODUTO
                           SET VRBRUTITEM = VRBRUTITEM + V_VRIMPOSTO,
                               VRCONTITEM = VRCONTITEM + V_VRIMPOSTO
                         WHERE CDFILIAL = P_FILIAL
                           AND NRLANCTONF = P_LANCTONF
                           AND NRSEQITPROD = C_PRODUTO.NRSEQITPROD;
                     END IF;
                  END IF;
               END IF;
            END IF;
         END IF;
      END LOOP;
      IF V_IDOPERDEVONF = w_S THEN
         V_SEQUIMPOSTNF := w_01;
         DELETE ITEMPRODUTO
         WHERE (CDFILIAL   = P_FILIAL)   AND
               (NRLANCTONF = P_LANCTONF) AND
               (QTITEMPROD = 0);
         DELETE IMPOSNFTOT
         WHERE (CDFILIAL   = P_FILIAL) AND
               (NRLANCTONF = P_LANCTONF);
         --TOTALIZAÇÃO DOS IMPOSTOS
         FOR C_IMPOSNFTOT IN (SELECT IT.CDIMPOSTO
                              FROM ITEMPROIMPOS IT
                              WHERE (IT.CDFILIAL   = P_FILIAL) AND
                                    (IT.NRLANCTONF = P_LANCTONF)
                              GROUP BY IT.CDIMPOSTO) LOOP
            V_IMPOSTOIT  := 0;
            V_BASECALCIT := 0;
            SELECT NVL(SUM(IT.VRIMPOSTOIT),0), 
                   NVL(SUM(IT.VRBASECALCIT),0),
                   NVL(SUM(IT.VRADICFECP),0)
            INTO   V_IMPOSTOIT,
                   V_BASECALCIT,
                   V_VRADICFECPNFTOT
            FROM ITEMPROIMPOS IT, IMPOSTO I
            WHERE (IT.CDFILIAL   = P_FILIAL)               AND
                  (IT.NRLANCTONF = P_LANCTONF)             AND
                  (IT.CDIMPOSTO  = C_IMPOSNFTOT.CDIMPOSTO) AND
                  (IT.CDIMPOSTO  = I.CDIMPOSTO);
            V_ICMS := 'N';
            FOR C_ICMS IN (SELECT CDIMPOSTO
                             FROM IMPOSTONFE N, IMPOSTO I
                            WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                              AND N.CDIMPOSTONFE = '00'
                              AND I.CDIMPOSTO = C_IMPOSNFTOT.CDIMPOSTO)
            LOOP
               V_ICMS := 'S';
            END LOOP;
            IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (V_ICMS = 'S') THEN
               INSERT INTO IMPOSNFTOT
                  (CDFILIAL, NRLANCTONF, CDIMPOSTO, VRTOTIMPONF, VRTOTBCALCNF,
                   VRADICFECP)
               VALUES 
                  (P_FILIAL, P_LANCTONF, C_IMPOSNFTOT.CDIMPOSTO, TRUNC(V_IMPOSTOIT ,V_NRDECITOTANF), TRUNC(V_BASECALCIT,V_NRDECITOTANF),
                   V_VRADICFECPNFTOT);
            ELSE
               INSERT INTO IMPOSNFTOT
                  (CDFILIAL, NRLANCTONF, CDIMPOSTO, VRTOTIMPONF, VRTOTBCALCNF,
                   VRADICFECP)
               VALUES
                  (P_FILIAL, P_LANCTONF, C_IMPOSNFTOT.CDIMPOSTO, ROUND(V_IMPOSTOIT ,V_NRDECITOTANF), ROUND(V_BASECALCIT,V_NRDECITOTANF),
                   V_VRADICFECPNFTOT);
            END IF;
         END LOOP;
         DELETE IMPOSTONF
         WHERE (CDFILIAL   = P_FILIAL) AND
               (NRLANCTONF = P_LANCTONF);
         FOR C_ITEMNOTAFISC IN (SELECT CDFILIALIT, NRLANCTONFIT
                                FROM ITEMNOTAFISC
                                WHERE CDFILIAL   = P_FILIAL AND
                                      NRLANCTONF = P_LANCTONF) LOOP
            SELECT SUM(VRTOTAITEM - VRDESCITEM) AS VRLIQUORIG
            INTO   V_VRLIQUORIG
            FROM ITEMPRODUTO I
            WHERE CDFILIAL    = C_ITEMNOTAFISC.CDFILIALIT AND
                  NRLANCTONF  = C_ITEMNOTAFISC.NRLANCTONFIT;
            IF V_VRLIQUORIG = 0 THEN
               V_VRFATOCONV := 0;
            ELSE
               V_VRFATOCONV := V_LIQUIDO / V_VRLIQUORIG;
            END IF;
            /*IMPOSTOS DE CORPO DA NOTA DE ORIGEM*/
            FOR C_IMPOSNFTOT IN (SELECT IT.CDIMPOSTO, IT.VRTOTIMPONF, IT.VRTOTBCALCNF
                                 FROM IMPOSNFTOT IT, IMPOSTO IP
                                 WHERE IT.CDFILIAL   = C_ITEMNOTAFISC.CDFILIALIT   AND
                                       IT.NRLANCTONF = C_ITEMNOTAFISC.NRLANCTONFIT AND
                                       IT.CDIMPOSTO  = IP.CDIMPOSTO AND
                                       IP.IDPRODNOTA = w_C) LOOP
               SELECT NVL(MAX(IDUTMUNIORIG),'N')
                 INTO V_IDUTMUNIORIG
                 FROM IMPOSTO
                WHERE CDIMPOSTO = C_IMPOSNFTOT.CDIMPOSTO;
               IF ((V_IDUTMUNIORIG = 'O') OR (V_IDUTMUNIORIG = 'N')) THEN
                  CONSULTA_ALIQUOTA(C_IMPOSNFTOT.CDIMPOSTO, w_S, P_EMPRESA, '', P_INSCESTA, V_PAISORIG,
                                    V_ESTAORIG, V_PAISDEST, V_ESTADEST, V_MUNIORIG, V_LIQUIITEM, P_INIVALID, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC, P_TIPOOPER);
               ELSE
                  CONSULTA_ALIQUOTA(C_IMPOSNFTOT.CDIMPOSTO, w_S, P_EMPRESA, '', P_INSCESTA, V_PAISORIG,
                                    V_ESTAORIG, V_PAISDEST, V_ESTADEST, V_MUNIDEST, V_LIQUIITEM, P_INIVALID, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC, P_TIPOOPER);
               END IF;
               SELECT MAX(NRALIQTEMP), MAX(VRPARDEDTMP), MAX(VRPREDBCTMP), MAX(VRALIQUTMP), NVL(MAX(IDTRIMPSTTMP), w_0), MAX(CDTIPOOPERTMP)
                 INTO   V_NRALIQTEMP,    V_PARDEDTMP,      V_PREDBCTMP,      V_ALIQUTMP,      V_TRATIMPST, V_CDTIPOOPER
                 FROM ALIQTEMP
                WHERE (NRALIQTEMP = V_ALIQTEMP);
               IF ((V_NRALIQTEMP IS NOT NULL) AND (V_CDTIPOOPER IS NOT NULL) AND (V_ESTORNOCANC <> w_S)) THEN
                  IF (V_ALIQUTMP IS NULL) THEN
                     V_ALIQUTMP := 0;
                  END IF;
                  V_PRODUENCARGO := 0;
                  SELECT SUM(VRITEMENCA) AS VRSOMAITEM
                    INTO   V_SOMAITEM
                    FROM ITEMENCARGO IE, ENCARGO EN, BASECALC BC
                   WHERE (IE.CDFILIAL   = P_FILIAL)
                     AND (IE.NRLANCTONF = P_LANCTONF)
                     AND (EN.CDENCARGO  = IE.CDENCARGO)
                     AND (BC.CDENCARGO  = IE.CDENCARGO)
                     AND (BC.CDIMPOSTO  = C_IMPOSNFTOT.CDIMPOSTO)
                     AND (EN.IDENCARGO  = w_A);
                  SELECT SUM(VRITEMENCA) AS VRDESCITEM
                    INTO   V_DESCITEM
                    FROM ITEMENCARGO IE, ENCARGO EN, BASECALC BC
                   WHERE (IE.CDFILIAL   = P_FILIAL)
                     AND (IE.NRLANCTONF = P_LANCTONF)
                     AND (EN.CDENCARGO  = IE.CDENCARGO)
                     AND (BC.CDENCARGO  = IE.CDENCARGO)
                     AND (BC.CDIMPOSTO  = C_IMPOSNFTOT.CDIMPOSTO)
                     AND (EN.IDENCARGO  = w_D);
                  IF V_SOMAITEM IS NULL THEN
                     V_SOMAITEM := 0;
                  END IF;
                  IF V_DESCITEM IS NULL THEN
                     V_DESCITEM := 0;
                  END IF;
                  IF (V_ALIQUTMP IS NULL) THEN
                     V_ALIQUTMP := 0;
                  END IF;
                  IF (V_PREDBCTMP IS NULL) THEN
                     V_PREDBCTMP := 0;
                  END IF;
                  IF (V_PARDEDTMP IS NULL) THEN
                     V_PARDEDTMP := 0;
                  END IF;
                  V_PRODUENCARGO := V_SOMAITEM - V_DESCITEM;
                  V_TAXABASECALC := (100 - V_PREDBCTMP)/100;
                  V_TAXAALIQUOTA := (V_ALIQUTMP/100);
                  V_BASECALCIT   := (V_LIQUIDO + V_PRODUENCARGO) * V_TAXABASECALC;
                  V_CONTIMPO     := V_BASECALCIT;
                  V_IMPOSTOIT    := (V_BASECALCIT * V_TAXAALIQUOTA) - V_PARDEDTMP;
                  IF V_BASECALCIT < 0 THEN
                     V_BASECALCIT := 0;
                  END IF;
                  V_CONTABCALC := (V_LIQUIDO + V_PRODUENCARGO) - ((V_LIQUIDO + V_PRODUENCARGO) * V_TAXABASECALC);
                  V_PERDBCALC  := 100 - V_PREDBCTMP;
                  IF V_IMPOSTOIT < 0 THEN
                     V_IMPOSTOIT := 0;
                  END IF;
                  V_ICMS := 'N';
                  FOR C_ICMS IN (SELECT CDIMPOSTO
                                   FROM IMPOSTONFE N, IMPOSTO I
                                  WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                                    AND N.CDIMPOSTONFE = '00'
                                    AND I.CDIMPOSTO = C_IMPOSNFTOT.CDIMPOSTO)
                  LOOP
                     V_ICMS := 'S';
                  END LOOP;
                  IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (V_ICMS = 'S') THEN
                     INSERT INTO IMPOSNFTOT(CDFILIAL, NRLANCTONF, CDIMPOSTO, VRTOTIMPONF, VRTOTBCALCNF)
                                       VALUES (P_FILIAL, P_LANCTONF, C_IMPOSNFTOT.CDIMPOSTO, TRUNC(V_IMPOSTOIT ,V_NRDECITOTANF), TRUNC(V_BASECALCIT,V_NRDECITOTANF));
                  ELSE
                     INSERT INTO IMPOSNFTOT(CDFILIAL, NRLANCTONF, CDIMPOSTO, VRTOTIMPONF, VRTOTBCALCNF)
                                       VALUES (P_FILIAL, P_LANCTONF, C_IMPOSNFTOT.CDIMPOSTO, ROUND(V_IMPOSTOIT ,V_NRDECITOTANF), ROUND(V_BASECALCIT,V_NRDECITOTANF));
                  END IF;
               ELSE
                  V_IMPOSTOIT  := (C_IMPOSNFTOT.VRTOTIMPONF * V_VRFATOCONV);
                  V_BASECALCIT := (C_IMPOSNFTOT.VRTOTBCALCNF * V_VRFATOCONV);
                  V_ALIQUTMP   := NULL;
                  V_UTIBB      := 'N';
                  --integração fiscal especifica com Compass_Argentina atraves da importação de aliquota do imposto IBB
                  --A aliquota de imposto 03(ibb) sera cadastrada na tabela paramintegraibb e tera prioridade sobre o
                  -- cadastro de aliquota realizado em sistema
                  /*IF C_IMPOSNFTOT.CDIMPOSTO = 03 THEN
                     IF V_IDORIGDESTNF = C THEN
                        V_DTVINGENTE := NVL(V_DTINIREFEFAT, P_INIVALID);
                        SELECT NVL(MAX(VRALIQUOTAIBB),NULL)
                        INTO   V_ALIQUTMP
                        FROM PARAMINTEGRAIBB
                        WHERE CDCLIENTE = P_CLIENTE AND
                              V_DTVINGENTE BETWEEN DTVIGINICIALIBB AND DTVIGFINALIBB;
                        IF V_ALIQUTMP IS NOT NULL THEN
                           V_UTIBB := S;
                        END IF;
                     END IF;
                  END IF;
                  IF V_UTIBB = S THEN
                     INSERT INTO IMPOSNFTOT(CDFILIAL, NRLANCTONF, CDIMPOSTO, VRTOTIMPONF, VRTOTBCALCNF)
                                    VALUES (P_FILIAL, P_LANCTONF, C_IMPOSNFTOT.CDIMPOSTO, ROUND((V_LIQUIDO * (V_ALIQUTMP/100))  ,V_NRDECITOTANF), ROUND(V_LIQUIDO,V_NRDECITOTANF));
                  ELSE*/
                     V_ICMS := 'N';
                     FOR C_ICMS IN (SELECT CDIMPOSTO
                                      FROM IMPOSTONFE N, IMPOSTO I
                                     WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                                       AND N.CDIMPOSTONFE = '00'
                                       AND I.CDIMPOSTO = C_IMPOSNFTOT.CDIMPOSTO)
                      LOOP
                         V_ICMS := 'S';
                      END LOOP;
                     IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (V_ICMS = 'S') THEN
                        INSERT INTO IMPOSNFTOT(CDFILIAL, NRLANCTONF, CDIMPOSTO, VRTOTIMPONF, VRTOTBCALCNF)
                                       VALUES (P_FILIAL, P_LANCTONF, C_IMPOSNFTOT.CDIMPOSTO, TRUNC(V_IMPOSTOIT ,V_NRDECITOTANF), TRUNC(V_BASECALCIT,V_NRDECITOTANF));
                     ELSE
                        INSERT INTO IMPOSNFTOT(CDFILIAL, NRLANCTONF, CDIMPOSTO, VRTOTIMPONF, VRTOTBCALCNF)
                                       VALUES (P_FILIAL, P_LANCTONF, C_IMPOSNFTOT.CDIMPOSTO, ROUND(V_IMPOSTOIT ,V_NRDECITOTANF), ROUND(V_BASECALCIT,V_NRDECITOTANF));
                     END IF;
                  --END IF;
               END IF;
               DELETE ALIQTEMP
               WHERE NRALIQTEMP = V_ALIQTEMP;
            END LOOP;
            FOR C_IMPOSTONF IN (SELECT IT.CDIMPOSTO, IT.NRIMPOSNF, IT.VRCONTABILNF, IT.VRPERREDBCNF, IT.VRBASECALCNF,
                                       IT.VRALIQNF, IT.VRPARDEDNF, IT.VRIMPOSTONF, IT.CDFISCALNF, IT.CDSITUTRIBNF,
                                       IT.CDFISCOPERNF, IT.CDSUFXCFOPNF, IDTRIMPOSTNF, IT.CDSITUTRIBIMNFE, IP.IDIMPORECUP,
									                     IT.CDTPCREDPICONF, IT.CDNATUBCALPCNF, IT.IDMOTDESONERANF
                                FROM IMPOSTONF IT, IMPOSTO IP
                                WHERE IT.CDFILIAL   = C_ITEMNOTAFISC.CDFILIALIT   AND
                                      IT.NRLANCTONF = C_ITEMNOTAFISC.NRLANCTONFIT AND
                                      IT.CDIMPOSTO  = IP.CDIMPOSTO                AND
                                      IP.IDPRODNOTA = w_C) LOOP
               /*VERIFICA CST POR IMPOSTO*/
               V_IMPOICMS := NULL;
               V_CDGRUPOFISCAUX := NULL;
               SELECT MAX(G.CDGRUPOFISC)
                 INTO V_CDGRUPOFISCAUX
                 FROM GRUPOFISCIMPFIL G,
                      (SELECT CDFILIEMIT AS CDFILIAL
                         FROM NOTAFISCAL
                        WHERE CDFILIAL = P_FILIAL
                              AND NRLANCTONF = P_LANCTONF) F
                WHERE G.CDFILIAL = F.CDFILIAL
                  AND NOT G.CDGRUPOFISC IS NULL
                  AND G.CDIMPOSTO = C_IMPOSTONF.CDIMPOSTO;
               IF V_IDORIGDESTNF = 'C' THEN
                  SELECT NVL(MAX(G.CDGRUPOFISC), V_CDGRUPOFISCAUX)
                    INTO V_CDGRUPOFISCAUX
                    FROM GRFISIMPIECLIE G,
                         (SELECT CDCLIENTE
                            FROM NOTAFISCAL
                           WHERE CDFILIAL = P_FILIAL
                             AND NRLANCTONF = P_LANCTONF) N
                   WHERE G.CDCLIENTE = N.CDCLIENTE
                     AND G.CDEMPRESA = P_EMPRESA
                     AND G.CDINSCESTA = P_INSCESTA
                     AND NOT G.CDGRUPOFISC IS NULL
                     AND G.CDIMPOSTO = C_IMPOSTONF.CDIMPOSTO;
               ELSE
                  SELECT NVL(MAX(G.CDGRUPOFISC), V_CDGRUPOFISCAUX)
                    INTO V_CDGRUPOFISCAUX
                    FROM GRFISIMPIEFORN G,
                        (SELECT CDFORNECED
                           FROM NOTAFISCAL
                          WHERE CDFILIAL = P_FILIAL
                            AND NRLANCTONF = P_LANCTONF) N
                   WHERE G.CDFORNECED = N.CDFORNECED
                     AND G.CDEMPRESA = P_EMPRESA
                     AND G.CDINSCESTA = P_INSCESTA
                     AND NOT G.CDGRUPOFISC IS NULL
                     AND G.CDIMPOSTO = C_IMPOSTONF.CDIMPOSTO;
               END IF;
               IF V_CDGRUPOFISCAUX IS NULL THEN
                  CONSULTA_CST_NFE(w_S, P_EMPRESA, '', P_INSCESTA, P_TIPOOPER, V_CDGRUPOFISC,C_IMPOSTONF.CDIMPOSTO, V_IDINTEREST, V_IDINTERNA, P_FILIAL, P_LANCTONF, '', V_CDSITTRIBTMP, V_IDMODBCNFE, V_IDMODBCSTNFE, V_CDTPCRPICOSTNFE, V_CDNATUBCPCSTNFE, V_IDMOTIDESSTNFE);
               ELSE
                  CONSULTA_CST_NFE(w_S, P_EMPRESA, '', P_INSCESTA, P_TIPOOPER, V_CDGRUPOFISCAUX,C_IMPOSTONF.CDIMPOSTO, V_IDINTEREST, V_IDINTERNA, P_FILIAL, P_LANCTONF, '', V_CDSITTRIBTMP, V_IDMODBCNFE, V_IDMODBCSTNFE, V_CDTPCRPICOSTNFE, V_CDNATUBCPCSTNFE, V_IDMOTIDESSTNFE);
               END IF;
               IF (C_IMPOSTONF.CDSITUTRIBIMNFE IS NULL) THEN
                  V_CDSITUTRIBNFE := V_CDSITTRIBTMP;
               ELSE
                  V_CDSITUTRIBNFE := C_IMPOSTONF.CDSITUTRIBIMNFE;
               END IF;
               IF (C_IMPOSTONF.CDTPCREDPICONF IS NULL) THEN
                  V_CDTPCRPICOSTNFEIT := V_CDTPCRPICOSTNFE;
               ELSE
                  V_CDTPCRPICOSTNFEIT := C_IMPOSTONF.CDTPCREDPICONF;
               END IF;
               IF (C_IMPOSTONF.CDNATUBCALPCNF IS NULL) THEN
                  V_CDNATUBCPCSTNFEIT := V_CDNATUBCPCSTNFE;
               ELSE
                  V_CDNATUBCPCSTNFEIT := C_IMPOSTONF.CDNATUBCALPCNF;
               END IF;
               IF (C_IMPOSTONF.IDMOTDESONERANF IS NULL) THEN
                  V_IDMOTIDESSTNFE := V_IDMOTIDESSTNFE;
               ELSE
                  V_IDMOTIDESSTNFE := C_IMPOSTONF.IDMOTDESONERANF;
               END IF;
               SELECT NVL(MAX(IDUTMUNIORIG),'N')
                 INTO V_IDUTMUNIORIG
                 FROM IMPOSTO
                WHERE CDIMPOSTO = C_IMPOSTONF.CDIMPOSTO;
               IF ((V_IDUTMUNIORIG = 'O') OR (V_IDUTMUNIORIG = 'N')) THEN
                  CONSULTA_ALIQUOTA(C_IMPOSTONF.CDIMPOSTO, w_S, P_EMPRESA, '', P_INSCESTA, V_PAISORIG,
                                    V_ESTAORIG, V_PAISDEST, V_ESTADEST, V_MUNIORIG, V_LIQUIITEM, P_INIVALID, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC,P_TIPOOPER);
               ELSE
                  CONSULTA_ALIQUOTA(C_IMPOSTONF.CDIMPOSTO, w_S, P_EMPRESA, '', P_INSCESTA, V_PAISORIG,
                                    V_ESTAORIG, V_PAISDEST, V_ESTADEST, V_MUNIDEST, V_LIQUIITEM, P_INIVALID, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC, P_TIPOOPER);
               END IF;
               SELECT MAX(NRALIQTEMP), MAX(VRPARDEDTMP), MAX(VRPREDBCTMP), MAX(VRALIQUTMP), NVL(MAX(IDTRIMPSTTMP), w_0), MAX(CDTIPOOPERTMP)
                 INTO   V_NRALIQTEMP,    V_PARDEDTMP,      V_PREDBCTMP,      V_ALIQUTMP,      V_TRATIMPST, V_CDTIPOOPER
                 FROM ALIQTEMP
                WHERE (NRALIQTEMP = V_ALIQTEMP);
               IF ((V_NRALIQTEMP IS NOT NULL) AND (V_CDTIPOOPER IS NOT NULL)) THEN
                  IF (V_ALIQUTMP IS NULL) THEN
                     V_ALIQUTMP := 0;
                  END IF;
                  V_PRODUENCARGO := 0;
                  SELECT SUM(VRITEMENCA) AS VRSOMAITEM
                    INTO   V_SOMAITEM
                    FROM ITEMENCARGO IE, ENCARGO EN, BASECALC BC
                   WHERE (IE.CDFILIAL   = P_FILIAL)
                     AND (IE.NRLANCTONF = P_LANCTONF)
                     AND (EN.CDENCARGO  = IE.CDENCARGO)
                     AND (BC.CDENCARGO  = IE.CDENCARGO)
                     AND (BC.CDIMPOSTO  = C_IMPOSTONF.CDIMPOSTO)
                     AND (EN.IDENCARGO  = w_A);
                  SELECT SUM(VRITEMENCA) AS VRDESCITEM
                    INTO   V_DESCITEM
                    FROM ITEMENCARGO IE, ENCARGO EN, BASECALC BC
                   WHERE (IE.CDFILIAL   = P_FILIAL)
                     AND (IE.NRLANCTONF = P_LANCTONF)
                     AND (EN.CDENCARGO  = IE.CDENCARGO)
                     AND (BC.CDENCARGO  = IE.CDENCARGO)
                     AND (BC.CDIMPOSTO  = C_IMPOSTONF.CDIMPOSTO)
                     AND (EN.IDENCARGO  = w_D);
                  IF V_SOMAITEM IS NULL THEN
                     V_SOMAITEM := 0;
                  END IF;
                  IF V_DESCITEM IS NULL THEN
                     V_DESCITEM := 0;
                  END IF;
                  IF (V_ALIQUTMP IS NULL) THEN
                     V_ALIQUTMP := 0;
                  END IF;
                  IF (V_PREDBCTMP IS NULL) THEN
                     V_PREDBCTMP := 0;
                  END IF;
                  IF (V_PARDEDTMP IS NULL) THEN
                     V_PARDEDTMP := 0;
                  END IF;
                  V_PRODUENCARGO := V_SOMAITEM - V_DESCITEM;
                  V_TAXABASECALC := (100 - V_PREDBCTMP)/100;
                  V_TAXAALIQUOTA := (V_ALIQUTMP/100);
                  V_BASECALCIT   := (V_LIQUIDO + V_PRODUENCARGO) * V_TAXABASECALC;
                  V_CONTIMPO     := V_BASECALCIT;
                  V_IMPOSTOIT    := (V_BASECALCIT * V_TAXAALIQUOTA) - V_PARDEDTMP;
                  IF V_BASECALCIT < 0 THEN
                     V_BASECALCIT := 0;
                  END IF;
                  V_CONTABCALC := (V_LIQUIDO + V_PRODUENCARGO) - ((V_LIQUIDO + V_PRODUENCARGO) * V_TAXABASECALC);
                  V_PERDBCALC  := 100 - V_PREDBCTMP;
                  IF V_IMPOSTOIT < 0 THEN
                     V_IMPOSTOIT := 0;
                  END IF;
                  IF (C_IMPOSTONF.IDIMPORECUP = w_S) OR (C_IMPOSTONF.IDIMPORECUP <> w_S AND V_ALIQUTMP <> 0) THEN
                     IF ((C_IMPOSTONF.IDIMPORECUP = w_S) AND (C_IMPOSTONF.CDFISCALNF <> w_1)) THEN
                        V_BASECALCIT := 0;
                        V_ALIQUTMP   := 0;
                        V_IMPOSTOIT  := 0;
                        V_PREDBCTMP  := 0;
                        V_PARDEDTMP  := 0;
                     END IF;
                     V_ICMS := 'N';
                     FOR C_ICMS IN (SELECT CDIMPOSTO
                                      FROM IMPOSTONFE N, IMPOSTO I
                                     WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                                       AND N.CDIMPOSTONFE = '00'
                                       AND I.CDIMPOSTO = C_IMPOSTONF.CDIMPOSTO)
                     LOOP
                        V_ICMS := 'S';
                     END LOOP;
                     IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (V_ICMS = 'S') THEN
                        INSERT INTO IMPOSTONF(
                           CDFILIAL, NRLANCTONF, CDIMPOSTO, NRIMPOSNF, VRCONTABILNF, VRPERREDBCNF, VRBASECALCNF,
                           VRALIQNF, VRPARDEDNF, VRIMPOSTONF, CDFISCALNF, IDTRIMPOSTNF, CDSITUTRIBIMNFE, CDTPCREDPICONF, CDNATUBCALPCNF, IDMOTDESONERANF)
                        VALUES(
                           P_FILIAL, P_LANCTONF, C_IMPOSTONF.CDIMPOSTO, C_IMPOSTONF.NRIMPOSNF, TRUNC(V_CONTIMPO,2), V_PREDBCTMP,
                           TRUNC(V_BASECALCIT,2), V_ALIQUTMP, TRUNC(V_PARDEDTMP,2), TRUNC(V_IMPOSTOIT,2), C_IMPOSTONF.CDSUFXCFOPNF, C_IMPOSTONF.IDTRIMPOSTNF, V_CDSITTRIBTMP, V_CDTPCRPICOSTNFEIT, V_CDNATUBCPCSTNFEIT, V_IDMOTIDESSTNFE);
                     ELSE
                        INSERT INTO IMPOSTONF(
                           CDFILIAL, NRLANCTONF, CDIMPOSTO, NRIMPOSNF, VRCONTABILNF, VRPERREDBCNF, VRBASECALCNF,
                           VRALIQNF, VRPARDEDNF, VRIMPOSTONF, CDFISCALNF, IDTRIMPOSTNF, CDSITUTRIBIMNFE, CDTPCREDPICONF, CDNATUBCALPCNF, IDMOTDESONERANF)
                        VALUES(
                           P_FILIAL, P_LANCTONF, C_IMPOSTONF.CDIMPOSTO, C_IMPOSTONF.NRIMPOSNF, ROUND(V_CONTIMPO,2), V_PREDBCTMP,
                           V_BASECALCIT, V_ALIQUTMP, V_PARDEDTMP, V_IMPOSTOIT, C_IMPOSTONF.CDSUFXCFOPNF, C_IMPOSTONF.IDTRIMPOSTNF, V_CDSITTRIBTMP, V_CDTPCRPICOSTNFEIT, V_CDNATUBCPCSTNFEIT, V_IDMOTIDESSTNFE);
                     END IF;
                     IF ((C_IMPOSTONF.IDIMPORECUP = w_S) AND (V_PREDBCTMP > 0) AND (C_IMPOSTONF.CDFISCALNF = w_1)) THEN
                        INSERT INTO IMPOSTONF(
                           CDFILIAL, NRLANCTONF, CDIMPOSTO, NRIMPOSNF, VRCONTABILNF, VRPERREDBCNF, VRBASECALCNF,
                           VRALIQNF, VRPARDEDNF, VRIMPOSTONF, CDFISCALNF, CDSITUTRIBIMNFE, CDTPCREDPICONF, CDNATUBCALPCNF, IDMOTDESONERANF)
                        VALUES(
                           P_FILIAL, P_LANCTONF, C_IMPOSTONF.CDIMPOSTO, C_IMPOSTONF.NRIMPOSNF, V_CONTABCALC, V_PERDBCALC,
                           0, 0, V_PARDEDTMP, 0, w_2, V_CDSITTRIBTMP, V_CDTPCRPICOSTNFEIT, V_CDNATUBCPCSTNFEIT, V_IDMOTIDESSTNFE);
                     END IF;
                  END IF;
                  DELETE ALIQTEMP
                  WHERE NRALIQTEMP = V_ALIQTEMP;
               ELSE
                  V_ALIQUTMP   := NULL;
                  V_UTIBB      := 'N';
                  --integração fiscal especifica com Compass_Argentina atraves da importação de aliquota do imposto IBB
                  --A aliquota de imposto 03(ibb) sera cadastrada na tabela paramintegraibb e tera prioridade sobre o
                  -- cadastro de aliquota realizado em sistema
                  /*IF C_IMPOSTONF.CDIMPOSTO = 03 THEN
                     IF V_IDORIGDESTNF = C THEN
                        V_DTVINGENTE := NVL(V_DTINIREFEFAT, P_INIVALID);
                        SELECT NVL(MAX(VRALIQUOTAIBB),NULL)
                        INTO   V_ALIQUTMP
                        FROM PARAMINTEGRAIBB
                        WHERE CDCLIENTE = P_CLIENTE AND
                              V_DTVINGENTE BETWEEN DTVIGINICIALIBB AND DTVIGFINALIBB;
                        IF V_ALIQUTMP IS NOT NULL THEN
                           V_UTIBB := S;
                        END IF;
                     END IF;
                  END IF;*/
                  IF V_UTIBB = 'S' THEN
                     V_ICMS := 'N';
                     FOR C_ICMS IN (SELECT CDIMPOSTO
                                      FROM IMPOSTONFE N, IMPOSTO I
                                     WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                                       AND N.CDIMPOSTONFE = '00'
                                       AND I.CDIMPOSTO = C_IMPOSTONF.CDIMPOSTO)
                     LOOP
                        V_ICMS := 'S';
                     END LOOP;
                     IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (V_ICMS = 'S') THEN
                        INSERT INTO IMPOSTONF(
                           CDFILIAL, NRLANCTONF, CDIMPOSTO, NRIMPOSNF, VRCONTABILNF, VRPERREDBCNF, VRBASECALCNF,
                           VRALIQNF, VRPARDEDNF, VRIMPOSTONF, CDFISCALNF, CDSITUTRIBNF, CDFISCOPERNF, CDSUFXCFOPNF, IDTRIMPOSTNF, CDSITUTRIBIMNFE, CDTPCREDPICONF, CDNATUBCALPCNF, IDMOTDESONERANF)
                        VALUES(P_FILIAL, P_LANCTONF, C_IMPOSTONF.CDIMPOSTO, C_IMPOSTONF.NRIMPOSNF,
                               V_LIQUIDO, 0, V_LIQUIDO,
                               V_ALIQUTMP, 0, TRUNC((V_LIQUIDO * (V_ALIQUTMP/100)),2), C_IMPOSTONF.CDFISCALNF,
                               C_IMPOSTONF.CDSITUTRIBNF, C_IMPOSTONF.CDFISCOPERNF, C_IMPOSTONF.CDSUFXCFOPNF, C_IMPOSTONF.IDTRIMPOSTNF, C_IMPOSTONF.CDSITUTRIBIMNFE, V_CDTPCRPICOSTNFEIT, V_CDNATUBCPCSTNFEIT, V_IDMOTIDESSTNFE);
                     ELSE
                        INSERT INTO IMPOSTONF(
                           CDFILIAL, NRLANCTONF, CDIMPOSTO, NRIMPOSNF, VRCONTABILNF, VRPERREDBCNF, VRBASECALCNF,
                           VRALIQNF, VRPARDEDNF, VRIMPOSTONF, CDFISCALNF, CDSITUTRIBNF, CDFISCOPERNF, CDSUFXCFOPNF, IDTRIMPOSTNF, CDSITUTRIBIMNFE, CDTPCREDPICONF, CDNATUBCALPCNF, IDMOTDESONERANF)
                        VALUES(P_FILIAL, P_LANCTONF, C_IMPOSTONF.CDIMPOSTO, C_IMPOSTONF.NRIMPOSNF,
                               V_LIQUIDO, 0, V_LIQUIDO,
                               V_ALIQUTMP, 0, (V_LIQUIDO * (V_ALIQUTMP/100)), C_IMPOSTONF.CDFISCALNF,
                               C_IMPOSTONF.CDSITUTRIBNF, C_IMPOSTONF.CDFISCOPERNF, C_IMPOSTONF.CDSUFXCFOPNF, C_IMPOSTONF.IDTRIMPOSTNF, C_IMPOSTONF.CDSITUTRIBIMNFE, V_CDTPCRPICOSTNFEIT, V_CDNATUBCPCSTNFEIT, V_IDMOTIDESSTNFE);
                     END IF;
                  ELSE
                     V_ICMS := 'N';
                     FOR C_ICMS IN (SELECT CDIMPOSTO
                                      FROM IMPOSTONFE N, IMPOSTO I
                                     WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                                       AND N.CDIMPOSTONFE = '00'
                                       AND I.CDIMPOSTO = C_IMPOSTONF.CDIMPOSTO)
                     LOOP
                        V_ICMS := 'S';
                     END LOOP;
                     IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (V_ICMS = 'S') THEN
                        INSERT INTO IMPOSTONF(
                           CDFILIAL, NRLANCTONF, CDIMPOSTO, NRIMPOSNF, VRCONTABILNF, VRPERREDBCNF, VRBASECALCNF,
                           VRALIQNF, VRPARDEDNF, VRIMPOSTONF, CDFISCALNF, CDSITUTRIBNF, CDFISCOPERNF, CDSUFXCFOPNF, IDTRIMPOSTNF, CDSITUTRIBIMNFE, CDTPCREDPICONF, CDNATUBCALPCNF, IDMOTDESONERANF)
                        VALUES(P_FILIAL, P_LANCTONF, C_IMPOSTONF.CDIMPOSTO, C_IMPOSTONF.NRIMPOSNF,
                               TRUNC((C_IMPOSTONF.VRCONTABILNF * V_VRFATOCONV),2), C_IMPOSTONF.VRPERREDBCNF, TRUNC((C_IMPOSTONF.VRBASECALCNF * V_VRFATOCONV),2),
                               C_IMPOSTONF.VRALIQNF, TRUNC((C_IMPOSTONF.VRPARDEDNF * V_VRFATOCONV),2), TRUNC((C_IMPOSTONF.VRIMPOSTONF * V_VRFATOCONV),2), C_IMPOSTONF.CDFISCALNF,
                               C_IMPOSTONF.CDSITUTRIBNF, C_IMPOSTONF.CDFISCOPERNF, C_IMPOSTONF.CDSUFXCFOPNF, C_IMPOSTONF.IDTRIMPOSTNF, C_IMPOSTONF.CDSITUTRIBIMNFE, V_CDTPCRPICOSTNFEIT, V_CDNATUBCPCSTNFEIT, V_IDMOTIDESSTNFE);
                     ELSE
                        INSERT INTO IMPOSTONF(
                           CDFILIAL, NRLANCTONF, CDIMPOSTO, NRIMPOSNF, VRCONTABILNF, VRPERREDBCNF, VRBASECALCNF,
                           VRALIQNF, VRPARDEDNF, VRIMPOSTONF, CDFISCALNF, CDSITUTRIBNF, CDFISCOPERNF, CDSUFXCFOPNF, IDTRIMPOSTNF, CDSITUTRIBIMNFE, CDTPCREDPICONF, CDNATUBCALPCNF, IDMOTDESONERANF)
                        VALUES(P_FILIAL, P_LANCTONF, C_IMPOSTONF.CDIMPOSTO, C_IMPOSTONF.NRIMPOSNF,
                               ROUND((C_IMPOSTONF.VRCONTABILNF * V_VRFATOCONV),2), C_IMPOSTONF.VRPERREDBCNF, (C_IMPOSTONF.VRBASECALCNF * V_VRFATOCONV),
                               C_IMPOSTONF.VRALIQNF, (C_IMPOSTONF.VRPARDEDNF * V_VRFATOCONV), (C_IMPOSTONF.VRIMPOSTONF * V_VRFATOCONV), C_IMPOSTONF.CDFISCALNF,
                               C_IMPOSTONF.CDSITUTRIBNF, C_IMPOSTONF.CDFISCOPERNF, C_IMPOSTONF.CDSUFXCFOPNF, C_IMPOSTONF.IDTRIMPOSTNF, C_IMPOSTONF.CDSITUTRIBIMNFE,  V_CDTPCRPICOSTNFEIT, V_CDNATUBCPCSTNFEIT, V_IDMOTIDESSTNFE);
                     END IF;
                  END IF;
                   V_SEQUIMPOSTNF := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_SEQUIMPOSTNF) + 1)),2,0);
               END IF;
               DELETE ALIQTEMP
               WHERE NRALIQTEMP = V_ALIQTEMP;
            END LOOP;
         END LOOP;
         DELETE FROM DADOSADIC
         WHERE CDFILIAL = P_FILIAL
           AND NRLANCTONF = P_LANCTONF
           AND DSDADOADIC LIKE 'Nota de Origem:%';   
         IF (V_IDCONTCONFORIG = 'N') THEN
            DELETE ITEMPROIMPOSORIG
             WHERE CDFILIAL   = P_FILIAL
               AND NRLANCTONF = P_LANCTONF;
            FOR C_IMPOSTOITENS IN (SELECT CDFILIAL,     NRLANCTONF,     NRSEQITPROD,     CDIMPOSTO,      NRITPROIMPOS,    CDFISCALIT,
                                          CDSITUTRIBIT, CDFISCOPERIT,   CDSUFXCFOPIT,    VRALIQITEM,     VRPERREDBCIT,    VRPARDEDIT,
                                          VRCONTITIMP,  VRBASECALCIT,   VRIMPOSTOIT,     IDERROSIMPIT,   IDAVISIMPIT,     CDSITUTRIBITNFE,
                                          IDMODBCITNFE, IDMODBCSTITNFE, CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT, IDTRIMPSTII,
                                          CDDETALHEPROD, CDENQLEGALIPI, CDCEST,          CDBENEFFISCAL
                                     FROM ITEMPROIMPOS
                                    WHERE CDFILIAL   = P_FILIAL
                                      AND NRLANCTONF = P_LANCTONF) LOOP
               INSERT INTO ITEMPROIMPOSORIG(CDFILIAL,      NRLANCTONF,     NRSEQITPROD,     CDIMPOSTO,      NRITPROIMPOS,    CDFISCALIT,
                                            CDSITUTRIBIT,  CDFISCOPERIT,   CDSUFXCFOPIT,    VRALIQITEM,     VRPERREDBCIT,    VRPARDEDIT,
                                            VRCONTITIMP,   VRBASECALCIT,   VRIMPOSTOIT,     IDERROSIMPIT,   IDAVISIMPIT,     CDSITUTRIBITNFE,
                                            IDMODBCITNFE,  IDMODBCSTITNFE, CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT, IDTRIMPSTII,
                                            CDDETALHEPROD, CDENQLEGALIPI,  CDCEST,          CDBENEFFISCAL)
                    VALUES (C_IMPOSTOITENS.CDFILIAL,      C_IMPOSTOITENS.NRLANCTONF,     C_IMPOSTOITENS.NRSEQITPROD,     C_IMPOSTOITENS.CDIMPOSTO,      C_IMPOSTOITENS.NRITPROIMPOS,    C_IMPOSTOITENS.CDFISCALIT,
                            C_IMPOSTOITENS.CDSITUTRIBIT,  C_IMPOSTOITENS.CDFISCOPERIT,   C_IMPOSTOITENS.CDSUFXCFOPIT,    C_IMPOSTOITENS.VRALIQITEM,     C_IMPOSTOITENS.VRPERREDBCIT,    C_IMPOSTOITENS.VRPARDEDIT,
                            C_IMPOSTOITENS.VRCONTITIMP,   C_IMPOSTOITENS.VRBASECALCIT,   C_IMPOSTOITENS.VRIMPOSTOIT,     C_IMPOSTOITENS.IDERROSIMPIT,   C_IMPOSTOITENS.IDAVISIMPIT,     C_IMPOSTOITENS.CDSITUTRIBITNFE,
                            C_IMPOSTOITENS.IDMODBCITNFE,  C_IMPOSTOITENS.IDMODBCSTITNFE, C_IMPOSTOITENS.CDTPCREDPICOITE, C_IMPOSTOITENS.CDNATUBCALPCIT, C_IMPOSTOITENS.IDMOTDESONERAIT, C_IMPOSTOITENS.IDTRIMPSTII,
                            C_IMPOSTOITENS.CDDETALHEPROD, C_IMPOSTOITENS.CDENQLEGALIPI,  C_IMPOSTOITENS.CDCEST,          C_IMPOSTOITENS.CDBENEFFISCAL);
            END LOOP;
         END IF;
         FOR C_ITEMNOTAFISC IN (SELECT IT.CDFILIALIT, IT.NRLANCTONFIT, NVL(N.NRNOTAFISCALELE, N.NRNOTAFISC) AS NRNOTA,
                                       TO_CHAR(N.DTEMISSAO,  'DD/MM/YYYY') AS DTEMISSAO, N.VRNOTAFISC
                             FROM ITEMNOTAFISC IT, NOTAFISCAL N
                             WHERE IT.CDFILIAL   = P_FILIAL
                               AND IT.NRLANCTONF = P_LANCTONF
                               AND IT.CDFILIALIT   = N.CDFILIAL
                               AND IT.NRLANCTONFIT = N.NRLANCTONF) LOOP
            INSERT INTO DADOSADIC(CDFILIAL, NRLANCTONF, NRDADOADIC, DSDADOADIC)
                           VALUES(P_FILIAL, P_LANCTONF, V_DADOADIC, 'Nota de Origem: '|| C_ITEMNOTAFISC.NRNOTA||' (Emissão: '|| C_ITEMNOTAFISC.DTEMISSAO||' Total: '||DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(C_ITEMNOTAFISC.VRNOTAFISC, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(C_ITEMNOTAFISC.VRNOTAFISC, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(C_ITEMNOTAFISC.VRNOTAFISC, 2), '9999999999999.99')))|| ' )');
            V_DADOADIC := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_DADOADIC) + 1)),3,0);
         END LOOP;
      END IF;
-------------------
   ELSIF (P_TIPOOPER = w_03) THEN /*NOTA DE COMPLEMENTO*/
      FOR C_IMPOSITEMCOM IN (SELECT II.NRSEQITPROD,  II.CDIMPOSTO,     II.NRITPROIMPOS,   II.VRCONTITIMP,
                                    II.VRPERREDBCIT, II.VRBASECALCIT,  II.VRALIQITEM,     II.VRPARDEDIT,
                                    II.VRIMPOSTOIT,  II.CDFISCALIT,    I.IDUTVLRQTDEIMPO, II.CDSITUTRIBIT ,
                                    II.CDFISCOPERIT, II.VRPERMAJBCIT,  IT.CDPRODUTO,      IT.QTITEMPROD, 
                                    P.CDARVPROD,     II.CDENQLEGALIPI, II.CDCEST
                               FROM ITEMPROIMPOS II, IMPOSTO I, ITEMPRODUTO IT, PRODUTO P
                              WHERE (II.CDFILIAL   = P_FILIAL)
                                AND (II.NRLANCTONF = P_LANCTONF)
                                AND (II.NRITPROIMPOS = '1')
                                AND (II.CDIMPOSTO = I.CDIMPOSTO)
                                AND (P.CDPRODUTO  = IT.CDPRODUTO)
                                AND (II.CDFILIAL = IT.CDFILIAL)
                                AND (II.NRLANCTONF = IT.NRLANCTONF)
                                AND (II.NRSEQITPROD = IT.NRSEQITPROD)
                           ORDER BY II.NRSEQITPROD, II.CDIMPOSTO, II.NRITPROIMPOS) LOOP
         /*VERIFICA CSOSN POR IMPOSTO*/
         CONSULTA_CSOSN('S', P_EMPRESA, C_IMPOSITEMCOM.CDARVPROD, P_INSCESTA, P_TIPOOPER, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC, V_IDINTEREST, V_CDFISCOPERSN);
         UPDATE ITEMPRODUTO
            SET CDFISCOPERSN  = V_CDFISCOPERSN
          WHERE CDFILIAL    = P_FILIAL
            AND NRLANCTONF  = P_LANCTONF
            AND NRSEQITPROD = C_IMPOSITEMCOM.NRSEQITPROD;
         IF (C_IMPOSITEMCOM.VRIMPOSTOIT = 0)  THEN
            IF (C_IMPOSITEMCOM.VRALIQITEM <> 0)  THEN
               V_TAXAALIQUOTA := (C_IMPOSITEMCOM.VRALIQITEM/100);
               V_TAXABASECALC := (100 - C_IMPOSITEMCOM.VRPERREDBCIT)/100;
               V_TAXABCSUBSTR := (100 + C_IMPOSITEMCOM.VRPERMAJBCIT)/100;
               SELECT MAX(VRTOTAITEM), MAX(QTITEMPROD)
                 INTO V_VRTOTAITEM, V_QTITEMPROD
                 FROM ITEMPRODUTO
                WHERE CDFILIAL = P_FILIAL
                  AND NRLANCTONF = P_LANCTONF
                  AND NRSEQITPROD = C_IMPOSITEMCOM.NRSEQITPROD;
               IF C_IMPOSITEMCOM.VRBASECALCIT > 0 THEN
                  V_BASECALCIT := C_IMPOSITEMCOM.VRBASECALCIT;
               ELSE
                  V_BASECALCIT := V_VRTOTAITEM * V_TAXABASECALC;
               END IF;
               V_PERDBCALC := 100 - C_IMPOSITEMCOM.VRPERREDBCIT;
               V_CONTABCALC  := V_VRTOTAITEM - (V_VRTOTAITEM * V_TAXABASECALC);
               IF C_IMPOSITEMCOM.VRPERMAJBCIT > 0 THEN
                  SELECT MAX(CDIMPOSTO)
                    INTO V_CDIMPOSTO
                    FROM IMPOSTO
                   WHERE CDIMPOSTRIB = C_IMPOSITEMCOM.CDIMPOSTO;
                  IF (V_CDIMPOSTO IS NOT NULL) THEN
                     V_BASECALCIT := (V_BASECALCIT * V_TAXABCSUBSTR);
                  ELSE
                     UPDATE ITEMPROIMPOS
                     SET VRPERMAJBCIT = 0
                    WHERE CDFILIAL = P_FILIAL
                      AND NRLANCTONF = P_LANCTONF
                      AND NRSEQITPROD = C_IMPOSITEMCOM.NRSEQITPROD
                      AND CDIMPOSTO = C_IMPOSITEMCOM.CDIMPOSTO;
                  END IF;
               END IF;
               /* ICMS-ST para nota fiscal de complento */
               V_CDIMPOSTRIB  := null;
               V_IDVRIMPSTRIB := null;
               /*IMPOSTO DE SUBSTITUICAO TRIBUTARIA*/
               FOR C_ICMSST IN (SELECT CDIMPOSTO
                                      FROM IMPOSTO
                                     WHERE CDIMPOSTRIB = C_IMPOSITEMCOM.CDIMPOSTO)
               LOOP
                  V_CDIMPOSTRIB := V_CDIMPOSTRIB||C_ICMSST.CDIMPOSTO||'_';
               END LOOP;
               IF V_CDIMPOSTRIB IS NOT NULL THEN
                  SELECT NVL(MAX(IDVRIMPSTRIB), 'N')
                    INTO V_IDVRIMPSTRIB
                    FROM ITEMPROIMPOS I, IMPOSTO II
                   WHERE (CDFILIAL     = P_FILIAL)
                     AND (NRLANCTONF   = P_LANCTONF)
                     AND (NRSEQITPROD  = C_IMPOSITEMCOM.NRSEQITPROD)
                     AND (INSTR(V_CDIMPOSTRIB,II.CDIMPOSTO||'_') > 0)
                     AND (I.CDIMPOSTO = II.CDIMPOSTO);
                  IF (NVL(V_IDVRIMPSTRIB,w_N) = w_N) THEN
                     V_VRIMPOSTOST := 0;
                  ELSE
                     Begin
                        SELECT NVL(MAX(VRIMPOSTOIT),0)
                        INTO   V_VRIMPOSTOST
                        FROM ITEMPROIMPOS I
                        WHERE (CDFILIAL     = P_FILIAL)                   AND
                              (NRLANCTONF   = P_LANCTONF)                 AND
                              (NRSEQITPROD  = C_IMPOSITEMCOM.NRSEQITPROD) AND
                              (INSTR(V_CDIMPOSTRIB,CDIMPOSTO||'_') > 0)  AND
                              (NRITPROIMPOS = w_1);
                     Exception
                        When No_Data_Found Then
                           V_VRIMPOSTOST := 0;
                     End;
                  END IF;
               END IF;
               /* ICMS-ST para nota fiscal de complento */
               IF (C_IMPOSITEMCOM.IDUTVLRQTDEIMPO = 'S') THEN
                  SELECT NVL(MAX(VRFATOCONVES), 1)
                    INTO V_VRFATOCONVES
                    FROM CONVPRODUTO
                   WHERE CDPRODUTO = C_IMPOSITEMCOM.CDPRODUTO;
                  IF (NVL(V_IDVRIMPSTRIB,w_N) = w_N) THEN
                     V_BASECALCTO  := (V_QTITEMPROD * V_VRFATOCONVES);
                     V_IMPOSTOIT   := ((V_QTITEMPROD * V_VRFATOCONVES) * C_IMPOSITEMCOM.VRALIQITEM) - C_IMPOSITEMCOM.VRPARDEDIT;
                  ELSE
                     V_BASECALCTO  := (V_QTITEMPROD * V_VRFATOCONVES);
                     V_IMPOSTOIT   := ((V_QTITEMPROD * V_VRFATOCONVES) * C_IMPOSITEMCOM.VRALIQITEM) - C_IMPOSITEMCOM.VRPARDEDIT - V_VRIMPOSTOST;
                     IF V_IMPOSTOIT < 0 THEN
                        V_IMPOSTOIT := 0;
                     END IF;
                  END IF;
               ELSE
                  IF (NVL(V_IDVRIMPSTRIB,w_N) = w_N) THEN
                     V_BASECALCTO  := V_BASECALCIT;
                     V_IMPOSTOIT   := (V_BASECALCIT * V_TAXAALIQUOTA) - C_IMPOSITEMCOM.VRPARDEDIT;
                  ELSE
                     V_BASECALCTO  := V_BASECALCIT;
                     V_IMPOSTOIT   := (V_BASECALCIT * V_TAXAALIQUOTA) - C_IMPOSITEMCOM.VRPARDEDIT - V_VRIMPOSTOST;
                     IF V_IMPOSTOIT < 0 THEN
                        V_IMPOSTOIT := 0;
                     END IF;
                  END IF;
               END IF;
               SELECT NVL(MAX(IDPERVISIMPSCRE),'S')
                 INTO V_IDPERVISIMPSCRE
                 FROM PARAMGERAL;
               IF V_IDPERVISIMPSCRE = 'S' THEN
                  V_VRIMPOSTOVISUIT := V_IMPOSTOIT;
               ELSE
                  IF C_IMPOSITEMCOM.CDFISCALIT = '1' THEN
                     V_VRIMPOSTOVISUIT := V_IMPOSTOIT;
                  ELSE
                     V_VRIMPOSTOVISUIT := 0;
                  END IF;
               END IF;
               IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (V_ICMS = 'S') THEN
                  UPDATE ITEMPROIMPOS
                     SET VRCONTITIMP = V_BASECALCTO,
                         VRBASECALCIT = V_BASECALCTO,
                         VRIMPOSTOIT = TRUNC(V_IMPOSTOIT,2),
                         VRIMPOSTOVISUIT = TRUNC(VRIMPOSTOVISUIT,2)
                    WHERE CDFILIAL = P_FILIAL
                      AND NRLANCTONF = P_LANCTONF
                      AND NRSEQITPROD = C_IMPOSITEMCOM.NRSEQITPROD
                      AND CDIMPOSTO = C_IMPOSITEMCOM.CDIMPOSTO
                      AND NRITPROIMPOS = '1';
               ELSE
                  UPDATE ITEMPROIMPOS
                     SET VRCONTITIMP = V_BASECALCTO,
                         VRBASECALCIT = V_BASECALCTO,
                         VRIMPOSTOIT = ROUND(V_IMPOSTOIT,2),
                         VRIMPOSTOVISUIT = ROUND(V_VRIMPOSTOVISUIT,2)
                    WHERE CDFILIAL = P_FILIAL
                      AND NRLANCTONF = P_LANCTONF
                      AND NRSEQITPROD = C_IMPOSITEMCOM.NRSEQITPROD
                      AND CDIMPOSTO = C_IMPOSITEMCOM.CDIMPOSTO
                      AND NRITPROIMPOS = '1';
               END IF;
               IF (C_IMPOSITEMCOM.VRPERREDBCIT > 0)  THEN
                  Begin
                     SELECT CDFILIAL
                     INTO   V_CHAVE
                     FROM ITEMPROIMPOS
                     WHERE CDFILIAL     = P_FILIAL                 AND
                           NRLANCTONF   = P_LANCTONF               AND
                           NRSEQITPROD  = C_IMPOSITEMCOM.NRSEQITPROD  AND
                           CDIMPOSTO    = C_IMPOSITEMCOM.CDIMPOSTO AND
                           NRITPROIMPOS = '2';
                  Exception
                     When No_Data_Found Then
                        V_CHAVE := Null;
                  End;
                  IF V_CHAVE IS NULL THEN
                     INSERT INTO ITEMPROIMPOS(
                        CDFILIAL, NRLANCTONF, NRSEQITPROD, CDIMPOSTO,
                        NRITPROIMPOS, CDFISCALIT, VRALIQITEM, VRPERREDBCIT,
                        VRCONTITIMP, VRBASECALCIT, VRIMPOSTOIT, VRPARDEDIT,
                        CDSITUTRIBIT, CDFISCOPERIT, VRIMPOSTOVISUIT, CDENQLEGALIPI,
                        CDCEST)
                     VALUES(
                        P_FILIAL, P_LANCTONF, C_IMPOSITEMCOM.NRSEQITPROD, C_IMPOSITEMCOM.CDIMPOSTO,
                        '2', '2', 0, V_PERDBCALC,
                        V_CONTABCALC, 0, 0, 0,
                        C_IMPOSITEMCOM.CDSITUTRIBIT, C_IMPOSITEMCOM.CDFISCOPERIT, 0, C_IMPOSITEMCOM.CDENQLEGALIPI,
                        C_IMPOSITEMCOM.CDCEST);
                  ELSE
                     UPDATE ITEMPROIMPOS
                        SET VRCONTITIMP = V_CONTABCALC,
                            VRBASECALCIT = 0,
                            VRIMPOSTOIT = 0,
                            VRPERREDBCIT = V_PERDBCALC,
                            VRIMPOSTOVISUIT = 0
                    WHERE CDFILIAL = P_FILIAL
                      AND NRLANCTONF = P_LANCTONF
                      AND NRSEQITPROD = C_IMPOSITEMCOM.NRSEQITPROD
                      AND CDIMPOSTO = C_IMPOSITEMCOM.CDIMPOSTO
                      AND NRITPROIMPOS = '2';
                  END IF;
               END IF;
            END IF;
         END IF;
      END LOOP;
   --TOTALIZAÇÃO DOS IMPOSTOS
      FOR C_IMPOSNFCOMP IN (SELECT IT.CDFILIAL, IT.NRLANCTONF, IT.CDIMPOSTO
                           FROM IMPOSNFTOT IT, IMPOSTO I
                           WHERE IT.CDIMPOSTO  = I.CDIMPOSTO AND
                                 I.IDPRODNOTA  <> w_C        AND
                                 IT.CDFILIAL   = P_FILIAL    AND
                                 IT.NRLANCTONF = P_LANCTONF) LOOP
          DELETE IMPOSNFTOT
          WHERE (CDFILIAL   = P_FILIAL) AND
                (NRLANCTONF = P_LANCTONF) AND
                (CDIMPOSTO = C_IMPOSNFCOMP.CDIMPOSTO);
      END LOOP;
      DELETE IMPOSTONF
      WHERE (CDFILIAL   = P_FILIAL) AND
            (NRLANCTONF = P_LANCTONF);
      FOR C_IMPOSNFTOT IN (SELECT CDIMPOSTO, 
                                  NVL(SUM(ROUND(VRIMPOSTOIT,2)),0) AS VRIMPOSTOIT, 
                                  NVL(SUM(ROUND(VRBASECALCIT,2)),0) AS VRBASECALCIT,
                                  NVL(SUM(ROUND(VRADICFECP,2)),0) AS VRADICFECP
                           FROM ITEMPROIMPOS
                           WHERE (CDFILIAL   = P_FILIAL)   AND
                                 (NRLANCTONF = P_LANCTONF)
                           GROUP BY CDIMPOSTO) LOOP
         V_ICMS := 'N';
         FOR C_ICMS IN (SELECT CDIMPOSTO
                          FROM IMPOSTONFE N, IMPOSTO I
                         WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                           AND N.CDIMPOSTONFE = '00'
                           AND I.CDIMPOSTO = C_IMPOSNFTOT.CDIMPOSTO)
         LOOP
             V_ICMS := 'S';
         END LOOP;
         IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (V_ICMS = 'S') THEN
            INSERT INTO IMPOSNFTOT(CDFILIAL, NRLANCTONF, CDIMPOSTO, VRTOTIMPONF, VRTOTBCALCNF,
                                   VRADICFECP)
                           VALUES (P_FILIAL, P_LANCTONF, C_IMPOSNFTOT.CDIMPOSTO, TRUNC(C_IMPOSNFTOT.VRIMPOSTOIT,V_NRDECITOTANF), TRUNC(C_IMPOSNFTOT.VRBASECALCIT,V_NRDECITOTANF),
                                   C_IMPOSNFTOT.VRADICFECP);
         ELSE
            INSERT INTO IMPOSNFTOT(CDFILIAL, NRLANCTONF, CDIMPOSTO, VRTOTIMPONF, VRTOTBCALCNF,
                                   VRADICFECP)
                           VALUES (P_FILIAL, P_LANCTONF, C_IMPOSNFTOT.CDIMPOSTO, ROUND(C_IMPOSNFTOT.VRIMPOSTOIT,V_NRDECITOTANF), ROUND(C_IMPOSNFTOT.VRBASECALCIT,V_NRDECITOTANF),
                                   C_IMPOSNFTOT.VRADICFECP);
         END IF;
      END LOOP;
      UPDATE ITEMPROIMPOS
         SET IDMODBCITNFE = '3'
       WHERE CDFILIAL = P_FILIAL
         AND NRLANCTONF = P_LANCTONF;
   ELSIF (P_TIPOOPER = w_09) OR (P_TIPOOPER = w_12) THEN /*VALE DE TRANSFERENCIA E NOTA DE DEBITO/CREDITO*/
      IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (NVL(V_IDORIGDESTNF, 'C') <> 'L') THEN
         UPDATE ITEMPRODUTO
         SET VRBRUTITEM   = TRUNC((VRTOTAITEM - VRDESCITEM),2),
             VRCONTITEM   = TRUNC((VRTOTAITEM - VRDESCITEM),2)
         WHERE CDFILIAL   = P_FILIAL   AND
               NRLANCTONF = P_LANCTONF;
      ELSE
         UPDATE ITEMPRODUTO
         SET VRBRUTITEM   = ROUND((VRTOTAITEM - VRDESCITEM),5),
             VRCONTITEM   = ROUND((VRTOTAITEM - VRDESCITEM),5)
         WHERE CDFILIAL   = P_FILIAL   AND
               NRLANCTONF = P_LANCTONF;
      END IF;
      FOR C_ITPROD IN (SELECT I.CDPRODUTO, I.CDCFOPINFUSU, I.CDSUFXINFUSU, I.CDCSTINFUSU, I.NRSEQITPROD,
                              P.CDARVPROD, I.IDORIGEMPROD
                       FROM ITEMPRODUTO I, PRODUTO P
                       WHERE CDFILIAL   = P_FILIAL
                         AND NRLANCTONF = P_LANCTONF
                         AND I.CDPRODUTO = P.CDPRODUTO) LOOP
         CONSULTA_CST(w_S, P_EMPRESA, C_ITPROD.CDARVPROD, P_INSCESTA, P_TIPOOPER, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC, V_IDINTEREST, V_IDINTERNA, NULL, C_ITPROD.IDORIGEMPROD);
         FOR C_CSTTEMP IN (SELECT DSMENSCSTTMP
                           FROM CSTTEMP
                           WHERE (NRCSTTEMP = V_CSTTEMP)    AND
                                 (DSMENSCSTTMP IS NOT NULL) AND
                                 (NOT EXISTS(SELECT DSDADOADIC
                                             FROM DADOSADIC
                                             WHERE (CDFILIAL   = P_FILIAL)   AND
                                                   (NRLANCTONF = P_LANCTONF) AND
                                                   (DSDADOADIC LIKE CSTTEMP.DSMENSCSTTMP || '%')))) LOOP
            IF NOT (C_CSTTEMP.DSMENSCSTTMP IS NULL) THEN
               INSERT INTO DADOSADIC(CDFILIAL, NRLANCTONF, NRDADOADIC, DSDADOADIC)
               VALUES(P_FILIAL, P_LANCTONF, V_DADOADIC, C_CSTTEMP.DSMENSCSTTMP);
               V_DADOADIC := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_DADOADIC) + 1)),3,0);
            END IF;
         END LOOP;
         CONSULTA_CFOP(w_S, P_EMPRESA, C_ITPROD.CDARVPROD, P_INSCESTA, P_TIPOOPER, V_PAISORIG,
                       V_ESTAORIG, V_PAISCFOP, V_ESTACFOP, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC, P_INIVALID, C_ITPROD.IDORIGEMPROD);
         FOR C_CFOPTEMP IN (SELECT DSMENSCFOTMP
                            FROM CFOPTEMP
                            WHERE (NRCFOPTEMP = V_CFOPTEMP)  AND
                                  (DSMENSCFOTMP IS NOT NULL) AND
                                  (NOT EXISTS(SELECT DSDADOADIC
                                              FROM DADOSADIC
                                              WHERE (CDFILIAL   = P_FILIAL)   AND
                                                    (NRLANCTONF = P_LANCTONF) AND
                                                    (DSDADOADIC LIKE CFOPTEMP.DSMENSCFOTMP || '%')))) LOOP
            IF NOT (C_CFOPTEMP.DSMENSCFOTMP IS NULL) THEN
               INSERT INTO DADOSADIC(CDFILIAL, NRLANCTONF, NRDADOADIC, DSDADOADIC)
               VALUES(P_FILIAL, P_LANCTONF, V_DADOADIC, C_CFOPTEMP.DSMENSCFOTMP);
               V_DADOADIC := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_DADOADIC) + 1)),3,0);
            END IF;
         END LOOP;
         IF C_ITPROD.CDCFOPINFUSU IS NULL THEN
            UPDATE NOTAFISCAL
            SET DSCDFISOPENF = (SELECT MAX(DSCFOPTMP)
                                  FROM CFOPTEMP
                                  WHERE NRCFOPTEMP = V_CFOPTEMP)
            WHERE CDFILIAL   = P_FILIAL   AND
                  NRLANCTONF = P_LANCTONF;
            SELECT MAX(CDFISOPETMP), MAX(CDSUFCFOPTMP), SUBSTR(MAX(DSCFOPTMP),1,50)
            INTO   V_FISOPEITEM    , V_SUFXCFOPPR, V_DSCDFISOPEIT
            FROM CFOPTEMP
            WHERE NRCFOPTEMP = V_CFOPTEMP;
            SELECT MAX(CDSITTRIBTMP)
            INTO   V_SITUTRIBPR
            FROM CSTTEMP
            WHERE NRCSTTEMP = V_CSTTEMP;
         ELSE
            V_CFOPINFUSU := 'S';
            V_FISOPEITEM := C_ITPROD.CDCFOPINFUSU;
            V_SUFXCFOPPR := C_ITPROD.CDSUFXINFUSU;
            V_SITUTRIBPR := C_ITPROD.CDCSTINFUSU;
         END IF;
         IF V_IDDOCREPLIC IS NOT NULL THEN
            IF LENGTH(V_SITUTRIBPR) = 3 THEN
               V_SITUTRIBPR := SUBSTR(V_SITUTRIBPR,1,1) || w_90;
            ELSE
               V_SITUTRIBPR := w_90;
            END IF;
         END IF;
         CONSULTA_CSOSN('S', P_EMPRESA, C_ITPROD.CDARVPROD, P_INSCESTA, P_TIPOOPER, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC, V_IDINTEREST,V_CDFISCOPERSN);
         UPDATE ITEMPRODUTO
         SET CDFISOPEITEM  = V_FISOPEITEM,
             CDSUFXCFOPPR  = V_SUFXCFOPPR,
             CDSITUTRIBPR  = V_SITUTRIBPR,
             DSCDFISOPEIT  = V_DSCDFISOPEIT,
             CDFISCOPERSN  = V_CDFISCOPERSN
         WHERE CDFILIAL    = P_FILIAL   AND
               NRLANCTONF  = P_LANCTONF AND
               NRSEQITPROD = C_ITPROD.NRSEQITPROD;
         DELETE CFOPTEMP
         WHERE NRCFOPTEMP = V_CFOPTEMP;
         DELETE CSTTEMP
         WHERE NRCSTTEMP = V_CSTTEMP;
         /*Consulta de nfe*/
         V_CDSITTRIBTMP    := NULL;
         V_IDMODBCNFE      := NULL;
         V_IDMODBCSTNFE    := NULL;
         V_CDTPCRPICOSTNFE := NULL;
         V_CDNATUBCPCSTNFE := NULL;
         FOR C_ITPROI IN (SELECT II.CDIMPOSTO, II.NRITPROIMPOS
                            FROM ITEMPROIMPOS II, IMPOSTO I
                           WHERE II.CDFILIAL   = P_FILIAL
                             AND II.NRLANCTONF = P_LANCTONF
                             AND II.NRSEQITPROD = C_ITPROD.NRSEQITPROD
                             AND II.CDIMPOSTO = I.CDIMPOSTO
                             AND I.IDPRODNOTA = 'P'
                          ORDER BY II.CDIMPOSTO) LOOP
             V_IMPOICMS := NULL;
             V_CDGRUPOFISCAUX := NULL;
             SELECT MAX(G.CDGRUPOFISC)
              INTO V_CDGRUPOFISCAUX
              FROM GRUPOFISCIMPFIL G,
                   (SELECT CDFILIEMIT AS CDFILIAL
                      FROM NOTAFISCAL
                     WHERE CDFILIAL = P_FILIAL
                           AND NRLANCTONF = P_LANCTONF) F
             WHERE G.CDFILIAL = F.CDFILIAL
               AND NOT G.CDGRUPOFISC IS NULL
               AND G.CDIMPOSTO = C_ITPROI.CDIMPOSTO;
             IF V_IDORIGDESTNF = 'C' THEN
                SELECT NVL(MAX(G.CDGRUPOFISC), V_CDGRUPOFISCAUX)
                 INTO V_CDGRUPOFISCAUX
                 FROM GRFISIMPIECLIE G,
                      (SELECT CDCLIENTE
                         FROM NOTAFISCAL
                        WHERE CDFILIAL = P_FILIAL
                          AND NRLANCTONF = P_LANCTONF) N
                WHERE G.CDCLIENTE = N.CDCLIENTE
                  AND G.CDEMPRESA = P_EMPRESA
                  AND G.CDINSCESTA = P_INSCESTA
                  AND NOT G.CDGRUPOFISC IS NULL
                  AND G.CDIMPOSTO = C_ITPROI.CDIMPOSTO;
             ELSE
                SELECT NVL(MAX(G.CDGRUPOFISC), V_CDGRUPOFISCAUX)
                  INTO V_CDGRUPOFISCAUX
                  FROM GRFISIMPIEFORN G,
                      (SELECT CDFORNECED
                         FROM NOTAFISCAL
                        WHERE CDFILIAL = P_FILIAL
                          AND NRLANCTONF = P_LANCTONF) N
                 WHERE G.CDFORNECED = N.CDFORNECED
                   AND G.CDEMPRESA = P_EMPRESA
                   AND G.CDINSCESTA = P_INSCESTA
                   AND NOT G.CDGRUPOFISC IS NULL
                   AND G.CDIMPOSTO = C_ITPROI.CDIMPOSTO;
             END IF;
             IF V_CDGRUPOFISCAUX IS NULL THEN
               CONSULTA_CST_NFE(w_S, P_EMPRESA, C_ITPROD.CDARVPROD, P_INSCESTA, P_TIPOOPER, V_CDGRUPOFISC,C_ITPROI.CDIMPOSTO, V_IDINTEREST, V_IDINTERNA, P_FILIAL, P_LANCTONF, '', V_CDSITTRIBTMP, V_IDMODBCNFE, V_IDMODBCSTNFE, V_CDTPCRPICOSTNFE, V_CDNATUBCPCSTNFE, V_IDMOTIDESSTNFE, C_ITPROD.IDORIGEMPROD);
             ELSE
               CONSULTA_CST_NFE(w_S, P_EMPRESA, C_ITPROD.CDARVPROD, P_INSCESTA, P_TIPOOPER, V_CDGRUPOFISCAUX,C_ITPROI.CDIMPOSTO, V_IDINTEREST, V_IDINTERNA, P_FILIAL, P_LANCTONF, '', V_CDSITTRIBTMP, V_IDMODBCNFE, V_IDMODBCSTNFE, V_CDTPCRPICOSTNFE, V_CDNATUBCPCSTNFE, V_IDMOTIDESSTNFE, C_ITPROD.IDORIGEMPROD);
             END IF;
             UPDATE ITEMPROIMPOS
               SET CDSITUTRIBITNFE = V_CDSITTRIBTMP,
                   IDMODBCITNFE = V_IDMODBCNFE,
                   IDMODBCSTITNFE = V_IDMODBCSTNFE,
                   CDTPCREDPICOITE = V_CDTPCRPICOSTNFE,
                   CDNATUBCALPCIT  = V_CDNATUBCPCSTNFE,
                   IDMOTDESONERAIT = V_IDMOTIDESSTNFE
               WHERE (CDFILIAL     = P_FILIAL)                   AND
                     (NRLANCTONF   = P_LANCTONF)                 AND
                     (NRSEQITPROD  = C_ITPROD.NRSEQITPROD) AND
                     (CDIMPOSTO    = C_ITPROI.CDIMPOSTO)   AND
                     (NRITPROIMPOS = C_ITPROI.NRITPROIMPOS);
         END LOOP;
      END LOOP;
   END IF;
   V_DIFERENCA := 0;
   /* RATEIO DOS ENCARGOS PARA OS PRODUTOS DA NOTA. ESTE RATEIO É NECESSÁRIO PARA A NOTA FISCAL ELETRÔNICA */
   FOR C_ITEMENCARGO IN (SELECT ENCARGO.CDENCARGONFE, SUM(ITEMENCARGO.VRITEMENCA) AS VRITEMENCA
                           FROM ITEMENCARGO, ENCARGO
                          WHERE ITEMENCARGO.CDENCARGO = ENCARGO.CDENCARGO
                            AND ENCARGO.CDENCARGONFE IN ('01', '02', '03', '04', '05')
                            AND NVL(ITEMENCARGO.VRITEMENCA, 0) >= 0
                            AND CDFILIAL = P_FILIAL
                            AND NRLANCTONF = P_LANCTONF
                          GROUP BY ENCARGO.CDENCARGONFE) LOOP
      /* ENCARGO FRETE */
      IF (C_ITEMENCARGO.CDENCARGONFE = '01') THEN
         IF (C_ITEMENCARGO.VRITEMENCA > 0) THEN
            FOR C_ITEMPRODUTO IN (SELECT NRSEQITPROD, VRTOTAITEM
                                    FROM ITEMPRODUTO
                                   WHERE CDFILIAL = P_FILIAL
                                     AND NRLANCTONF = P_LANCTONF) LOOP
               SELECT ITEMPRODUTO.VRTOTAITEM,
                      TOTAL.SOMATOTAITEM,
                      DECODE(TOTAL.SOMATOTAITEM, 0, 0, ((100 * ITEMPRODUTO.VRTOTAITEM) / TOTAL.SOMATOTAITEM)) AS PERCENTITEM
                 INTO V_VRTOTAITEM, V_SOMATOTAITEM, V_PERCENTITEM
                 FROM ITEMPRODUTO, (SELECT CDFILIAL, NRLANCTONF, SUM(VRTOTAITEM) SOMATOTAITEM
                                      FROM ITEMPRODUTO
                                     WHERE CDFILIAL = P_FILIAL
                                       AND NRLANCTONF = P_LANCTONF
                                     GROUP BY CDFILIAL, NRLANCTONF) TOTAL
                WHERE ITEMPRODUTO.CDFILIAL = TOTAL.CDFILIAL
                  AND ITEMPRODUTO.NRLANCTONF = TOTAL.NRLANCTONF
                  AND ITEMPRODUTO.NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD;
               IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (NVL(V_IDORIGDESTNF, 'C') <> 'L') THEN
                  UPDATE ITEMPRODUTO
                     SET VRFRETEITEM = TRUNC(C_ITEMENCARGO.VRITEMENCA * (V_PERCENTITEM / 100), 2)
                   WHERE CDFILIAL  = P_FILIAL
                     AND NRLANCTONF = P_LANCTONF
                     AND NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD;
               ELSE
                  UPDATE ITEMPRODUTO
                     SET VRFRETEITEM = ROUND(C_ITEMENCARGO.VRITEMENCA * (V_PERCENTITEM / 100), 2)
                   WHERE CDFILIAL  = P_FILIAL
                     AND NRLANCTONF = P_LANCTONF
                     AND NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD;
               END IF;
            END LOOP;
            /*AJUSTE DE VALORES*/
            SELECT SUM(VRFRETEITEM)
              INTO V_VRFRETEITEM
              FROM ITEMPRODUTO
             WHERE CDFILIAL = P_FILIAL
               AND NRLANCTONF = P_LANCTONF;
            V_DIFERENCA := C_ITEMENCARGO.VRITEMENCA - V_VRFRETEITEM;
            IF V_DIFERENCA <> 0 THEN
               UPDATE ITEMPRODUTO
                  SET VRFRETEITEM = VRFRETEITEM + V_DIFERENCA
                WHERE CDFILIAL = P_FILIAL
                  AND NRLANCTONF = P_LANCTONF
                  AND NRSEQITPROD = (SELECT MAX(NRSEQITPROD)
                                      FROM ITEMPRODUTO
                                      WHERE CDFILIAL = P_FILIAL
                                        AND NRLANCTONF = P_LANCTONF
                                        AND VRTOTAITEM = (SELECT MAX(VRTOTAITEM)
                                                           FROM ITEMPRODUTO
                                                          WHERE CDFILIAL = P_FILIAL
                                                            AND NRLANCTONF = P_LANCTONF));
            END IF;
         ELSE
            UPDATE ITEMPRODUTO
               SET VRFRETEITEM = 0
             WHERE CDFILIAL  = P_FILIAL
               AND NRLANCTONF = P_LANCTONF;
         END IF;
      END IF;
      /* ENCARGO SEGURO */
      IF (C_ITEMENCARGO.CDENCARGONFE = '02') THEN
         IF (C_ITEMENCARGO.VRITEMENCA > 0) THEN
            FOR C_ITEMPRODUTO IN (SELECT NRSEQITPROD, VRTOTAITEM
                                    FROM ITEMPRODUTO
                                   WHERE CDFILIAL = P_FILIAL
                                     AND NRLANCTONF = P_LANCTONF) LOOP
               SELECT ITEMPRODUTO.VRTOTAITEM,
                      TOTAL.SOMATOTAITEM,
                      DECODE(TOTAL.SOMATOTAITEM, 0, 0, ((100 * ITEMPRODUTO.VRTOTAITEM) / TOTAL.SOMATOTAITEM)) AS PERCENTITEM
                 INTO V_VRTOTAITEM, V_SOMATOTAITEM, V_PERCENTITEM
                 FROM ITEMPRODUTO, (SELECT CDFILIAL, NRLANCTONF, SUM(VRTOTAITEM) SOMATOTAITEM
                                      FROM ITEMPRODUTO
                                     WHERE CDFILIAL = P_FILIAL
                                       AND NRLANCTONF = P_LANCTONF
                                     GROUP BY CDFILIAL, NRLANCTONF) TOTAL
                WHERE ITEMPRODUTO.CDFILIAL = TOTAL.CDFILIAL
                  AND ITEMPRODUTO.NRLANCTONF = TOTAL.NRLANCTONF
                  AND ITEMPRODUTO.NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD;
               IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (NVL(V_IDORIGDESTNF, 'C') <> 'L') THEN
                  UPDATE ITEMPRODUTO
                     SET VRSEGURITEM = TRUNC(C_ITEMENCARGO.VRITEMENCA * (V_PERCENTITEM / 100), 2)
                   WHERE CDFILIAL  = P_FILIAL
                     AND NRLANCTONF = P_LANCTONF
                     AND NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD;
               ELSE
                  UPDATE ITEMPRODUTO
                     SET VRSEGURITEM = ROUND(C_ITEMENCARGO.VRITEMENCA * (V_PERCENTITEM / 100), 2)
                   WHERE CDFILIAL  = P_FILIAL
                     AND NRLANCTONF = P_LANCTONF
                     AND NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD;
               END IF;
            END LOOP;
            /*AJUSTE DE VALORES*/
            SELECT SUM(VRSEGURITEM)
              INTO V_VRSEGURITEM
              FROM ITEMPRODUTO
             WHERE CDFILIAL = P_FILIAL
               AND NRLANCTONF = P_LANCTONF;
            V_DIFERENCA := C_ITEMENCARGO.VRITEMENCA - V_VRSEGURITEM;
            IF V_DIFERENCA <> 0 THEN
               UPDATE ITEMPRODUTO
                  SET VRSEGURITEM = VRSEGURITEM + V_DIFERENCA
                WHERE CDFILIAL = P_FILIAL
                  AND NRLANCTONF = P_LANCTONF
                  AND NRSEQITPROD = (SELECT MAX(NRSEQITPROD)
                                      FROM ITEMPRODUTO
                                      WHERE CDFILIAL = P_FILIAL
                                        AND NRLANCTONF = P_LANCTONF
                                        AND VRTOTAITEM = (SELECT MAX(VRTOTAITEM)
                                                           FROM ITEMPRODUTO
                                                          WHERE CDFILIAL = P_FILIAL
                                                            AND NRLANCTONF = P_LANCTONF));
            END IF;
         ELSE
            UPDATE ITEMPRODUTO
               SET VRSEGURITEM = 0
             WHERE CDFILIAL  = P_FILIAL
               AND NRLANCTONF = P_LANCTONF;
         END IF;
      END IF;
      /* ENCARGO DESCONTO */
      IF (C_ITEMENCARGO.CDENCARGONFE = '03') THEN
         IF (C_ITEMENCARGO.VRITEMENCA > 0) THEN
            FOR C_ITEMPRODUTO IN (SELECT NRSEQITPROD, VRTOTAITEM
                                    FROM ITEMPRODUTO
                                   WHERE CDFILIAL = P_FILIAL
                                     AND NRLANCTONF = P_LANCTONF) LOOP
               SELECT ITEMPRODUTO.VRTOTAITEM,
                      TOTAL.SOMATOTAITEM,
                      DECODE(TOTAL.SOMATOTAITEM, 0, 0, ((100 * ITEMPRODUTO.VRTOTAITEM) / TOTAL.SOMATOTAITEM)) AS PERCENTITEM
                 INTO V_VRTOTAITEM, V_SOMATOTAITEM, V_PERCENTITEM
                 FROM ITEMPRODUTO, (SELECT CDFILIAL, NRLANCTONF, SUM(VRTOTAITEM) SOMATOTAITEM
                                      FROM ITEMPRODUTO
                                     WHERE CDFILIAL = P_FILIAL
                                       AND NRLANCTONF = P_LANCTONF
                                     GROUP BY CDFILIAL, NRLANCTONF) TOTAL
                WHERE ITEMPRODUTO.CDFILIAL = TOTAL.CDFILIAL
                  AND ITEMPRODUTO.NRLANCTONF = TOTAL.NRLANCTONF
                  AND ITEMPRODUTO.NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD;
               IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (NVL(V_IDORIGDESTNF, 'C') <> 'L') THEN
                  UPDATE ITEMPRODUTO
                     SET VRENCARGODESC = TRUNC(VRDESCITEM + (C_ITEMENCARGO.VRITEMENCA * (V_PERCENTITEM / 100)), 2)
                   WHERE CDFILIAL  = P_FILIAL
                     AND NRLANCTONF = P_LANCTONF
                     AND NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD;
               ELSE
                  UPDATE ITEMPRODUTO
                     SET VRENCARGODESC = ROUND(VRDESCITEM + (C_ITEMENCARGO.VRITEMENCA * (V_PERCENTITEM / 100)), 2)
                   WHERE CDFILIAL  = P_FILIAL
                     AND NRLANCTONF = P_LANCTONF
                     AND NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD;
               END IF;
            END LOOP;
            /*AJUSTE DE VALORES*/
            SELECT SUM(VRENCARGODESC)
              INTO V_VRENCARGODESC
              FROM ITEMPRODUTO
             WHERE CDFILIAL = P_FILIAL
               AND NRLANCTONF = P_LANCTONF;
            SELECT SUM(VRDESCITEM)
              INTO V_SUMVRDESCITEM
              FROM ITEMPRODUTO
             WHERE CDFILIAL  = P_FILIAL
               AND NRLANCTONF = P_LANCTONF;
            V_DIFERENCA := (C_ITEMENCARGO.VRITEMENCA+V_SUMVRDESCITEM) - V_VRENCARGODESC;
            IF V_DIFERENCA <> 0 THEN
               UPDATE ITEMPRODUTO
                  SET VRENCARGODESC = VRENCARGODESC + V_DIFERENCA
                WHERE CDFILIAL = P_FILIAL
                  AND NRLANCTONF = P_LANCTONF
                  AND NRSEQITPROD = (SELECT MAX(NRSEQITPROD)
                                      FROM ITEMPRODUTO
                                      WHERE CDFILIAL = P_FILIAL
                                        AND NRLANCTONF = P_LANCTONF
                                        AND VRTOTAITEM = (SELECT MAX(VRTOTAITEM)
                                                           FROM ITEMPRODUTO
                                                          WHERE CDFILIAL = P_FILIAL
                                                            AND NRLANCTONF = P_LANCTONF));
            END IF;
         ELSE
            UPDATE ITEMPRODUTO
               SET VRENCARGODESC = VRDESCITEM + 0
             WHERE CDFILIAL  = P_FILIAL
               AND NRLANCTONF = P_LANCTONF;
         END IF;
      END IF;
           /*ENCARGO OUTRAS DESPESAS*/
      IF (C_ITEMENCARGO.CDENCARGONFE = '04') THEN
         IF (C_ITEMENCARGO.VRITEMENCA > 0) THEN
            IF (V_IDNFORIGVIAXML = 'S') THEN
               FOR C_ITEMPRODUTO IN (SELECT NRSEQITPROD, VRTOTAITEM, VRENCARGOIMPXML
                                       FROM ITEMPRODUTO
                                      WHERE CDFILIAL = P_FILIAL
                                        AND NRLANCTONF = P_LANCTONF
                                        AND VRENCARGOIMPXML > 0) LOOP
                  SELECT ITEMPRODUTO.VRTOTAITEM,
                         TOTAL.SOMATOTAITEM,
                         DECODE(TOTAL.SOMATOTAITEM, 0, 0, ((100 * ITEMPRODUTO.VRTOTAITEM) / TOTAL.SOMATOTAITEM)) AS PERCENTITEM
                    INTO V_VRTOTAITEM, V_SOMATOTAITEM, V_PERCENTITEM
                    FROM ITEMPRODUTO, (SELECT CDFILIAL, NRLANCTONF, SUM(VRTOTAITEM) SOMATOTAITEM
                                         FROM ITEMPRODUTO
                                        WHERE CDFILIAL = P_FILIAL
                                          AND NRLANCTONF = P_LANCTONF
                                        GROUP BY CDFILIAL, NRLANCTONF) TOTAL
                   WHERE ITEMPRODUTO.CDFILIAL = TOTAL.CDFILIAL
                     AND ITEMPRODUTO.NRLANCTONF = TOTAL.NRLANCTONF
                     AND ITEMPRODUTO.NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD;
                  IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (NVL(V_IDORIGDESTNF, 'C') <> 'L') THEN
                     UPDATE ITEMPRODUTO
                        SET VROUTRASDESPITEM = VRENCARGOIMPXML
                      WHERE CDFILIAL  = P_FILIAL
                        AND NRLANCTONF = P_LANCTONF
                        AND NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD;
                  ELSE
                     UPDATE ITEMPRODUTO
                        SET VROUTRASDESPITEM = VRENCARGOIMPXML
                      WHERE CDFILIAL  = P_FILIAL
                        AND NRLANCTONF = P_LANCTONF
                        AND NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD;
                  END IF;
               END LOOP;
            ELSE
               FOR C_ITEMPRODUTO IN (SELECT NRSEQITPROD, VRTOTAITEM
                                       FROM ITEMPRODUTO
                                      WHERE CDFILIAL = P_FILIAL
                                        AND NRLANCTONF = P_LANCTONF) LOOP
                  SELECT ITEMPRODUTO.VRTOTAITEM,
                         TOTAL.SOMATOTAITEM,
                         DECODE(TOTAL.SOMATOTAITEM, 0, 0, ((100 * ITEMPRODUTO.VRTOTAITEM) / TOTAL.SOMATOTAITEM)) AS PERCENTITEM
                    INTO V_VRTOTAITEM, V_SOMATOTAITEM, V_PERCENTITEM
                    FROM ITEMPRODUTO, (SELECT CDFILIAL, NRLANCTONF, SUM(VRTOTAITEM) SOMATOTAITEM
                                         FROM ITEMPRODUTO
                                        WHERE CDFILIAL = P_FILIAL
                                          AND NRLANCTONF = P_LANCTONF
                                        GROUP BY CDFILIAL, NRLANCTONF) TOTAL
                   WHERE ITEMPRODUTO.CDFILIAL = TOTAL.CDFILIAL
                     AND ITEMPRODUTO.NRLANCTONF = TOTAL.NRLANCTONF
                     AND ITEMPRODUTO.NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD;
                  IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (NVL(V_IDORIGDESTNF, 'C') <> 'L') THEN
                     UPDATE ITEMPRODUTO
                        SET VROUTRASDESPITEM = TRUNC((C_ITEMENCARGO.VRITEMENCA * (V_PERCENTITEM / 100)), 2)
                      WHERE CDFILIAL  = P_FILIAL
                        AND NRLANCTONF = P_LANCTONF
                        AND NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD;
                  ELSE
                     UPDATE ITEMPRODUTO
                        SET VROUTRASDESPITEM = ROUND((C_ITEMENCARGO.VRITEMENCA * (V_PERCENTITEM / 100)), 2)
                      WHERE CDFILIAL  = P_FILIAL
                        AND NRLANCTONF = P_LANCTONF
                        AND NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD;
                  END IF;
               END LOOP;
            END IF;
            /*AJUSTE DE VALORES*/
            SELECT SUM(VROUTRASDESPITEM)
              INTO V_VROUTRASDESPITEM
              FROM ITEMPRODUTO
             WHERE CDFILIAL = P_FILIAL
               AND NRLANCTONF = P_LANCTONF;
            V_DIFERENCA := C_ITEMENCARGO.VRITEMENCA - V_VROUTRASDESPITEM;
            IF V_DIFERENCA <> 0 THEN
               UPDATE ITEMPRODUTO
                  SET VROUTRASDESPITEM = VROUTRASDESPITEM + V_DIFERENCA
                WHERE CDFILIAL = P_FILIAL
                  AND NRLANCTONF = P_LANCTONF
                  AND NRSEQITPROD = (SELECT MAX(NRSEQITPROD)
                                      FROM ITEMPRODUTO
                                      WHERE CDFILIAL = P_FILIAL
                                        AND NRLANCTONF = P_LANCTONF
                                        AND VRTOTAITEM = (SELECT MAX(VRTOTAITEM)
                                                           FROM ITEMPRODUTO
                                                          WHERE CDFILIAL = P_FILIAL
                                                            AND NRLANCTONF = P_LANCTONF));
            END IF;
         ELSE
            UPDATE ITEMPRODUTO
               SET VROUTRASDESPITEM = 0
             WHERE CDFILIAL  = P_FILIAL
               AND NRLANCTONF = P_LANCTONF;
         END IF;
      END IF;
      /*ENCARGO DESPESAS ADUANEIRAS*/
      IF (C_ITEMENCARGO.CDENCARGONFE = '05') THEN
         /*REFAZ O RATEIO DO ENCARGO VERIFICANDO A INCIDENCIA DO IMPOSTO DE IMPORTACAO*/
         UPDATE ITEMPRODUTO
            SET VRDESPADUANEIRA = 0
          WHERE CDFILIAL  = P_FILIAL
            AND NRLANCTONF = P_LANCTONF;
         IF (C_ITEMENCARGO.VRITEMENCA > 0) THEN
            FOR C_ITEMPRODUTO IN (SELECT DISTINCT(I.NRSEQITPROD)
                                    FROM ITEMPROIMPOS I, IMPOSTO II
                                   WHERE I.NRLANCTONF    = P_LANCTONF
                                     AND I.CDFILIAL      = P_FILIAL
                                     AND I.CDIMPOSTO     = II.CDIMPOSTO
                                     AND II.CDIMPOSTONFE = '20') LOOP
               SELECT ITEMPRODUTO.VRTOTAITEM,
                      TOTAL.SOMATOTAITEM,
                      DECODE(TOTAL.SOMATOTAITEM, 0, 0, ((100 * ITEMPRODUTO.VRTOTAITEM) / TOTAL.SOMATOTAITEM)) AS PERCENTITEM
                 INTO V_VRTOTAITEM, V_SOMATOTAITEM, V_PERCENTITEM
                 FROM ITEMPRODUTO, (SELECT CDFILIAL, NRLANCTONF, SUM(VRTOTAITEM) SOMATOTAITEM
                                      FROM ITEMPRODUTO
                                     WHERE CDFILIAL = P_FILIAL
                                       AND NRLANCTONF = P_LANCTONF
                                     GROUP BY CDFILIAL, NRLANCTONF) TOTAL
                WHERE ITEMPRODUTO.CDFILIAL = TOTAL.CDFILIAL
                  AND ITEMPRODUTO.NRLANCTONF = TOTAL.NRLANCTONF
                  AND ITEMPRODUTO.NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD;
               IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (NVL(V_IDORIGDESTNF, 'C') <> 'L') THEN
                  UPDATE ITEMPRODUTO
                     SET VRDESPADUANEIRA = TRUNC((C_ITEMENCARGO.VRITEMENCA * (V_PERCENTITEM / 100)), 2)
                   WHERE CDFILIAL  = P_FILIAL
                     AND NRLANCTONF = P_LANCTONF
                     AND NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD;
               ELSE
                  UPDATE ITEMPRODUTO
                     SET VRDESPADUANEIRA = ROUND((C_ITEMENCARGO.VRITEMENCA * (V_PERCENTITEM / 100)), 2)
                   WHERE CDFILIAL  = P_FILIAL
                     AND NRLANCTONF = P_LANCTONF
                     AND NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD;
               END IF;
            END LOOP;
            /*AJUSTE DE VALORES*/
            SELECT SUM(VRDESPADUANEIRA)
              INTO V_VRDESPADUANEIRA
              FROM ITEMPRODUTO
             WHERE CDFILIAL = P_FILIAL
               AND NRLANCTONF = P_LANCTONF;
            V_DIFERENCA := C_ITEMENCARGO.VRITEMENCA - V_VRDESPADUANEIRA;
            IF V_DIFERENCA <> 0 THEN
               UPDATE ITEMPRODUTO
                  SET VRDESPADUANEIRA = VRDESPADUANEIRA + V_DIFERENCA
                WHERE CDFILIAL = P_FILIAL
                  AND NRLANCTONF = P_LANCTONF
                  AND NRSEQITPROD = (SELECT MAX(II.NRSEQITPROD)
                                       FROM ITEMPRODUTO I, ITEMPROIMPOS II, IMPOSTO S
                                      WHERE I.CDFILIAL     = P_FILIAL
                                        AND I.NRLANCTONF   = P_LANCTONF
                                        AND I.CDFILIAL     = II.CDFILIAL
                                        AND I.NRLANCTONF   = II.NRLANCTONF
                                        AND I.NRSEQITPROD  = II.NRSEQITPROD
                                        AND II.CDIMPOSTO   = S.CDIMPOSTO
                                        AND S.CDIMPOSTONFE = '20'
                                        AND VRTOTAITEM = (SELECT MAX(VRTOTAITEM)
                                                            FROM ITEMPRODUTO I, ITEMPROIMPOS II, IMPOSTO S
                                                           WHERE I.CDFILIAL     = P_FILIAL
                                                             AND I.NRLANCTONF   = P_LANCTONF
                                                             AND I.CDFILIAL     = II.CDFILIAL
                                                             AND I.NRLANCTONF   = II.NRLANCTONF
                                                             AND I.NRSEQITPROD  = II.NRSEQITPROD
                                                             AND II.CDIMPOSTO   = S.CDIMPOSTO
                                                             AND S.CDIMPOSTONFE = '20'));
            END IF;
         ELSE
            UPDATE ITEMPRODUTO
               SET VRDESPADUANEIRA = 0
             WHERE CDFILIAL  = P_FILIAL
               AND NRLANCTONF = P_LANCTONF;
         END IF;
      END IF;      
   END LOOP;
--CÁLCULO DO VALOR TOTAL DA NOTA FISCAL
   SELECT SUM(VRITEMENCA)
   INTO   V_SOMAENCA
   FROM ITEMENCARGO IE, ENCARGO EN
   WHERE IE.CDFILIAL   = P_FILIAL     AND
         IE.NRLANCTONF = P_LANCTONF   AND
         IE.CDENCARGO  = EN.CDENCARGO AND
         IDENCARGO     = w_A;
   SELECT SUM(VRITEMENCA)
   INTO   V_MENOENCA
   FROM ITEMENCARGO IE, ENCARGO EN
   WHERE IE.CDFILIAL   = P_FILIAL     AND
         IE.NRLANCTONF = P_LANCTONF   AND
         IE.CDENCARGO  = EN.CDENCARGO AND
         IDENCARGO     = w_D;
   IF V_IDOPERDEVONF = 'S' THEN
      SELECT SUM(VRTOTIMPONF)
      INTO   V_SOMAIMPO
      FROM IMPOSNFTOT, IMPOSTO
      WHERE IMPOSNFTOT.CDFILIAL   = P_FILIAL          AND
            IMPOSNFTOT.NRLANCTONF = P_LANCTONF        AND
            IMPOSNFTOT.CDIMPOSTO  = IMPOSTO.CDIMPOSTO AND
            IDTRATIMPO            = w_A               AND
            NVL(IDACRPRODENTRNF, 'N') = 'N' AND
            NOT EXISTS(SELECT CDIMPOSTO
                       FROM IMPOSTO
                       WHERE IMPOSTO.CDIMPOSTRIB = IMPOSNFTOT.CDIMPOSTO);
   ELSE
      SELECT SUM(VRTOTIMPONF)
      INTO   V_SOMAIMPO
      FROM IMPOSNFTOT, IMPOSTO
      WHERE IMPOSNFTOT.CDFILIAL   = P_FILIAL          AND
            IMPOSNFTOT.NRLANCTONF = P_LANCTONF        AND
            IMPOSNFTOT.CDIMPOSTO  = IMPOSTO.CDIMPOSTO AND
            IDTRATIMPO            = w_A               AND
            NOT EXISTS(SELECT CDIMPOSTO
                       FROM IMPOSTO
                       WHERE IMPOSTO.CDIMPOSTRIB = IMPOSNFTOT.CDIMPOSTO);
   END IF;
   SELECT SUM(VRTOTIMPONF)
   INTO   V_MENOIMPO
   FROM IMPOSNFTOT, IMPOSTO
   WHERE IMPOSNFTOT.CDFILIAL   = P_FILIAL          AND
         IMPOSNFTOT.NRLANCTONF = P_LANCTONF        AND
         IMPOSNFTOT.CDIMPOSTO  = IMPOSTO.CDIMPOSTO AND
         IDTRATIMPO = w_D;
   IF NOT (V_LIQUIDO IS NULL) AND (P_TIPOOPER <> w_12) THEN
      V_TOTALNOTA := V_LIQUIDO;
   END IF;
   IF NOT (V_SOMAIMPO IS NULL) THEN
      V_TOTALNOTA := V_TOTALNOTA + V_SOMAIMPO;
   END IF;
   IF NOT (V_MENOIMPO IS NULL) THEN
      V_TOTALNOTA := V_TOTALNOTA - V_MENOIMPO;
   END IF;
   IF NOT (V_SOMAENCA IS NULL) THEN
      V_TOTALNOTA := V_TOTALNOTA + V_SOMAENCA;
   END IF;
   IF NOT (V_MENOENCA IS NULL) THEN
      V_TOTALNOTA := V_TOTALNOTA - V_MENOENCA;
   END IF;
   --VALOR SUBSTITUIÇÃO TRIBUTÁRIA COM IDENTIFICAÇÃO PARA ACRESCER AO TOTAL DA NF
   IF V_IDOPERDEVONF = 'S' THEN
      SELECT NVL(ROUND(SUM(VRIMPOSTOIT + NVL(VRADICFECP, 0)), V_NRDECITOTANF),0)
        INTO   V_SOMAIMPO
        FROM ITEMPROIMPOS IT, IMPOSTO I
       WHERE CDFILIAL     = P_FILIAL           AND
             NRLANCTONF   = P_LANCTONF         AND
             IT.CDIMPOSTO = I.CDIMPOSTO        AND
             NVL(I.IDACRPRODENTRNF, 'N') = 'N' AND
             NVL(IT.IDTRIMPSTII, '0')     = '0' AND
         EXISTS(SELECT CDIMPOSTO
                  FROM IMPOSTO
                 WHERE CDIMPOSTRIB = IT.CDIMPOSTO);
   ELSE
      SELECT NVL(ROUND(SUM(IT.VRIMPOSTOIT + NVL(VRADICFECP, 0)), V_NRDECITOTANF),0)
      INTO   V_SOMAIMPO
      FROM ITEMPROIMPOS IT, IMPOSTO I
      WHERE IT.CDFILIAL    = P_FILIAL    AND
            IT.NRLANCTONF  = P_LANCTONF  AND
            IT.CDIMPOSTO   = I.CDIMPOSTO AND
            NVL(IT.IDTRIMPSTII, '0')     = '0' AND
            EXISTS(SELECT CDIMPOSTO
                   FROM IMPOSTO
                   WHERE CDIMPOSTRIB = IT.CDIMPOSTO);
   END IF;
   IF NOT (V_SOMAIMPO IS NULL) THEN
      V_TOTALNOTA := V_TOTALNOTA + V_SOMAIMPO;
   END IF;
   -- Subtrai o valor dos importos a reter no valor da nota fiscal
   BEGIN
      SELECT SUM(VRIMPOSTOIT)
        INTO V_VRIMPORETNF
        FROM ITEMPROIMPOS T, IMPOSTO I
       WHERE CDFILIAL     = P_FILIAL
         AND NRLANCTONF   = P_LANCTONF
         AND I.CDIMPOSTO  = T.CDIMPOSTO
         AND IDTRATIMPO   = 'R'
         AND IDDESCRFONTE = 'N';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_VRIMPORETNF := 0;
   END;
   IF NOT (V_VRIMPORETNF IS NULL) THEN
      V_TOTALNOTA := V_TOTALNOTA - ROUND(V_VRIMPORETNF, 2);
   END IF;
   IF P_TIPOOPER = w_12 THEN
      FOR C_NOTABEBICRED IN (SELECT I.CDPRODUTO, VRTOTAITEM, IDITEMISSAO, IDTPNFCREDEB
                             FROM   ITEMPRODUTO I, ITEMISSAO T
                             WHERE  I.CDFILIAL   = P_FILIAL      AND
                                    I.NRLANCTONF = P_LANCTONF    AND
                                    I.CDPRODUTO  = T.CDPRODUTO
                             ORDER BY IDITEMISSAO) LOOP
          SELECT IDITEMISSAO
          INTO V_IDITEMISSAO
          FROM ITEMISSAO
          WHERE CDPRODUTO = C_NOTABEBICRED.CDPRODUTO;
          IF (V_IDITEMISSAO = w_D) THEN
             UPDATE ITEMPRODUTO
             SET IDTPNFCREDEB = w_2
             WHERE CDFILIAL   = P_FILIAL   AND
                   NRLANCTONF = P_LANCTONF AND
                   CDPRODUTO  = C_NOTABEBICRED.CDPRODUTO;
             V_TOTALNOTA := V_TOTALNOTA + C_NOTABEBICRED.VRTOTAITEM;
          ELSIF (V_IDITEMISSAO = w_C)  THEN
             UPDATE ITEMPRODUTO
             SET IDTPNFCREDEB = w_1
             WHERE CDFILIAL   = P_FILIAL   AND
                   NRLANCTONF = P_LANCTONF AND
                   CDPRODUTO  = C_NOTABEBICRED.CDPRODUTO;
             V_TOTALNOTA := V_TOTALNOTA - C_NOTABEBICRED.VRTOTAITEM;
          ELSE
             UPDATE ITEMPRODUTO
             SET IDTPNFCREDEB = w_3
             WHERE CDFILIAL   = P_FILIAL   AND
                   NRLANCTONF = P_LANCTONF AND
                   CDPRODUTO  = C_NOTABEBICRED.CDPRODUTO;
             V_TOTALNOTA := V_TOTALNOTA - C_NOTABEBICRED.VRTOTAITEM;
          END IF;
          SELECT CDFILIAPFATU, NRAPFATUTNF
          INTO V_CDFILIAPFATU, V_NRAPFATUTNF
          FROM NOTAFISCAL
          WHERE CDFILIAL   = P_FILIAL   AND
                NRLANCTONF = P_LANCTONF;
          IF NOT(V_CDFILIAPFATU IS NULL) AND NOT(V_NRAPFATUTNF IS NULL) THEN
             IF ((C_NOTABEBICRED.IDITEMISSAO = w_D) OR  (C_NOTABEBICRED.IDITEMISSAO = w_O)) AND
                (C_NOTABEBICRED.IDTPNFCREDEB IS NULL)  THEN
                V_TOTALNOTA := V_TOTALNOTA + C_NOTABEBICRED.VRTOTAITEM;
             ELSIF (C_NOTABEBICRED.IDITEMISSAO = w_C)  THEN
                V_TOTALNOTA := V_TOTALNOTA - C_NOTABEBICRED.VRTOTAITEM;
             ELSE
                V_TOTALNOTA := V_TOTALNOTA + C_NOTABEBICRED.VRTOTAITEM;
             END IF;
          END IF;
      END LOOP;
   END IF;
   /* AJUSTANDO O VALOR DO DIFERIMENTO CASO OCORRA ALGUMA DIFERENÇA DEVIDO AOS ARREDONDAMENTOS */
   FOR C_AJUSTA_DIFERIMENTO IN (SELECT IT.NRSEQITPROD, IT.VRIMPOSTOIT, IT.VRIMPOSTOOPERAIT, IT.VRIMPOSTODIFERIT, 
                                       IT.VRPERDIFEREIT
                                  FROM ITEMPROIMPOS IT JOIN IMPOSTO IM ON (IT.CDIMPOSTO = IM.CDIMPOSTO)
                                 WHERE (IT.VRIMPOSTOIT <> (IT.VRIMPOSTOOPERAIT - IT.VRIMPOSTODIFERIT))
                                   AND (IT.VRPERDIFEREIT IS NOT NULL)
                                   AND (IM.CDIMPOSTONFE = '00')
                                   AND (IT.NRITPROIMPOS = '1')
                                   AND (IT.CDFILIAL = P_FILIAL)
                                   AND (IT.NRLANCTONF = P_LANCTONF)
                                 ORDER BY IT.NRSEQITPROD)
   LOOP
      UPDATE ITEMPROIMPOS
         SET VRIMPOSTODIFERIT = VRIMPOSTODIFERIT + (C_AJUSTA_DIFERIMENTO.VRIMPOSTOOPERAIT - C_AJUSTA_DIFERIMENTO.VRIMPOSTOIT - C_AJUSTA_DIFERIMENTO.VRIMPOSTODIFERIT)
       WHERE CDFILIAL = P_FILIAL
         AND NRLANCTONF = P_LANCTONF
         AND NRSEQITPROD = C_AJUSTA_DIFERIMENTO.NRSEQITPROD;
   END LOOP;
   CONSULTA_DESONERACAO(P_FILIAL, 
                        P_LANCTONF, 
                        V_PAISDEST,
                        V_ESTADEST,
                        V_IMPOSDESONERA);
   V_TOTALNOTA := V_TOTALNOTA - V_IMPOSDESONERA;
   IF V_NRDECITOTANF <> 0 THEN
      V_TOTALNOTA := ROUND(V_TOTALNOTA, 2);
   END IF;
   IF (V_IDCONTCONFORIG = 'N') OR (V_IDOPERDEVONF <> w_S) THEN
      SELECT NVL(V_TOTALNOTA,0) - SUM(ROUND(NVL(VRBRUTITEM,0), 5))
        INTO V_DIFEVRBRUTO
        FROM ITEMPRODUTO
       WHERE CDFILIAL = P_FILIAL
         AND NRLANCTONF = P_LANCTONF;
      IF V_DIFEVRBRUTO <> 0 THEN
         UPDATE ITEMPRODUTO
            SET VRBRUTITEM = ROUND(VRBRUTITEM + V_DIFEVRBRUTO,5)
          WHERE CDFILIAL = P_FILIAL
            AND NRLANCTONF = P_LANCTONF
            AND NRSEQITPROD = (SELECT MAX(I.NRSEQITPROD)
                                 FROM ITEMPRODUTO I
                                WHERE I.CDFILIAL     = P_FILIAL
                                  AND I.NRLANCTONF   = P_LANCTONF
                                  AND VRTOTAITEM = (SELECT MAX(VRTOTAITEM)
                                                      FROM ITEMPRODUTO I
                                                     WHERE I.CDFILIAL     = P_FILIAL
                                                       AND I.NRLANCTONF   = P_LANCTONF));
      END IF;
   END IF;
-- RECALCULO DO VALOR CONTABIL DO ITEM
   FOR C_ITEM IN (SELECT II.CDIMPOSTO, I.VRBRUTITEM, I.NRSEQITPROD, I.VRCONTITEM
                  FROM ITEMPRODUTO I, ITEMPROIMPOS II
                  WHERE I.CDFILIAL    = P_FILIAL       AND
                        I.NRLANCTONF  = P_LANCTONF     AND
                        I.CDFILIAL    = II.CDFILIAL    AND
                        I.NRLANCTONF  = II.NRLANCTONF  AND
                        I.NRSEQITPROD = II.NRSEQITPROD ) LOOP
      V_ICMS := 'N';
      FOR C_ICMS IN (SELECT CDIMPOSTO
                       FROM IMPOSTONFE N, IMPOSTO I
                      WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                        AND N.CDIMPOSTONFE = '00'
                        AND I.CDIMPOSTO = C_ITEM.CDIMPOSTO)
      LOOP
         V_ICMS := 'S';
      END LOOP;
      IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (V_ICMS = 'S') THEN
         UPDATE ITEMPROIMPOS
         SET VRCONTITIMP = TRUNC(VRCONTITIMP,2)
         WHERE (NRLANCTONF   = P_LANCTONF)         AND
               (CDFILIAL     = P_FILIAL)           AND
               (NRSEQITPROD  = C_ITEM.NRSEQITPROD) AND
               (CDIMPOSTO    = C_ITEM.CDIMPOSTO)   AND
               (NRITPROIMPOS = w_2);
      ELSE
         UPDATE ITEMPROIMPOS
         SET VRCONTITIMP = ROUND(VRCONTITIMP,5)    
         WHERE (NRLANCTONF   = P_LANCTONF)         AND
               (CDFILIAL     = P_FILIAL)           AND
               (NRSEQITPROD  = C_ITEM.NRSEQITPROD) AND
               (CDIMPOSTO    = C_ITEM.CDIMPOSTO)   AND
               (NRITPROIMPOS = w_2);
      END IF;
      Begin
         SELECT NVL(VRCONTITIMP,0)
         INTO   V_VRREDUCAO
         FROM ITEMPROIMPOS
         WHERE (NRLANCTONF   = P_LANCTONF)         AND
               (CDFILIAL     = P_FILIAL)           AND
               (NRSEQITPROD  = C_ITEM.NRSEQITPROD) AND
               (CDIMPOSTO    = C_ITEM.CDIMPOSTO)   AND
               (NRITPROIMPOS = w_2);
      Exception
         When No_Data_Found Then
            V_VRREDUCAO := 0;
      End;
      IF V_VRREDUCAO IS NULL THEN
         V_VRREDUCAO := 0;
      END IF;
      V_ICMS := 'N';
      FOR C_ICMS IN (SELECT CDIMPOSTO
                       FROM IMPOSTONFE N, IMPOSTO I
                      WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                        AND N.CDIMPOSTONFE = '00'
                        AND I.CDIMPOSTO = C_ITEM.CDIMPOSTO)
      LOOP
         V_ICMS := 'S';
      END LOOP;
      IF (NVL(V_IDUTDESCICMS, 'N') <> 'S') THEN
         IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (V_ICMS = 'S') THEN
            UPDATE ITEMPROIMPOS
            SET VRCONTITIMP = TRUNC((C_ITEM.VRBRUTITEM - V_VRREDUCAO),2)
            WHERE (NRLANCTONF   = P_LANCTONF)         AND
                  (CDFILIAL     = P_FILIAL)           AND
                  (NRSEQITPROD  = C_ITEM.NRSEQITPROD) AND
                  (CDIMPOSTO    = C_ITEM.CDIMPOSTO)   AND
                  (NRITPROIMPOS = w_1)                AND
                  (NOT EXISTS(SELECT CDIMPOSTO
                              FROM IMPOSTO
                              WHERE CDIMPOSTRIB = ITEMPROIMPOS.CDIMPOSTO));
         ELSE
            UPDATE ITEMPROIMPOS
            SET VRCONTITIMP = ROUND((C_ITEM.VRBRUTITEM - V_VRREDUCAO),5)  
            WHERE (NRLANCTONF   = P_LANCTONF)         AND
                  (CDFILIAL     = P_FILIAL)           AND
                  (NRSEQITPROD  = C_ITEM.NRSEQITPROD) AND
                  (CDIMPOSTO    = C_ITEM.CDIMPOSTO)   AND
                  (NRITPROIMPOS = w_1)                AND
                  (NOT EXISTS(SELECT CDIMPOSTO
                              FROM IMPOSTO
                              WHERE CDIMPOSTRIB = ITEMPROIMPOS.CDIMPOSTO));
         END IF;
      ELSE
         IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (V_ICMS = 'S') THEN
            UPDATE ITEMPROIMPOS
            SET VRCONTITIMP = TRUNC((C_ITEM.VRCONTITEM- V_VRREDUCAO),2)
            WHERE (NRLANCTONF   = P_LANCTONF)         AND
                  (CDFILIAL     = P_FILIAL)           AND
                  (NRSEQITPROD  = C_ITEM.NRSEQITPROD) AND
                  (CDIMPOSTO    = C_ITEM.CDIMPOSTO)   AND
                  (NRITPROIMPOS = w_1)                AND
                  (NOT EXISTS(SELECT CDIMPOSTO
                              FROM IMPOSTO
                              WHERE CDIMPOSTRIB = ITEMPROIMPOS.CDIMPOSTO));
         ELSE
            UPDATE ITEMPROIMPOS
            SET VRCONTITIMP = ROUND((C_ITEM.VRCONTITEM - V_VRREDUCAO),5)  
            WHERE (NRLANCTONF   = P_LANCTONF)         AND
                  (CDFILIAL     = P_FILIAL)           AND
                  (NRSEQITPROD  = C_ITEM.NRSEQITPROD) AND
                  (CDIMPOSTO    = C_ITEM.CDIMPOSTO)   AND
                  (NRITPROIMPOS = w_1)                AND
                  (NOT EXISTS(SELECT CDIMPOSTO
                              FROM IMPOSTO
                              WHERE CDIMPOSTRIB = ITEMPROIMPOS.CDIMPOSTO));
         END IF;
      END IF;
      IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (V_ICMS = 'S') THEN
         UPDATE ITEMPROIMPOS
         SET VRCONTITIMP = TRUNC(C_ITEM.VRBRUTITEM,2)
         WHERE (NRLANCTONF   = P_LANCTONF)         AND
               (CDFILIAL     = P_FILIAL)           AND
               (NRSEQITPROD  = C_ITEM.NRSEQITPROD) AND
               (CDIMPOSTO    = C_ITEM.CDIMPOSTO)   AND
               (NRITPROIMPOS = w_1)                AND
               (EXISTS(SELECT CDIMPOSTO
                       FROM IMPOSTO
                       WHERE CDIMPOSTRIB = ITEMPROIMPOS.CDIMPOSTO));
      ELSE
         UPDATE ITEMPROIMPOS
         SET VRCONTITIMP = ROUND(C_ITEM.VRBRUTITEM,5)   
         WHERE (NRLANCTONF   = P_LANCTONF)         AND
               (CDFILIAL     = P_FILIAL)           AND
               (NRSEQITPROD  = C_ITEM.NRSEQITPROD) AND
               (CDIMPOSTO    = C_ITEM.CDIMPOSTO)   AND
               (NRITPROIMPOS = w_1)                AND
               (EXISTS(SELECT CDIMPOSTO
                       FROM IMPOSTO
                       WHERE CDIMPOSTRIB = ITEMPROIMPOS.CDIMPOSTO));
      END IF;
   END LOOP;
   ARREDONDA_BASECALC(w_S, P_FILIAL, P_LANCTONF);
   V_SEQUIMPOSTNF := w_01;
   UPDATE ITEMPROIMPOS
      SET CDFISCALIT = '2',
          VRBASECALCIT = 0	      
    WHERE CDFILIAL = P_FILIAL
      AND NRLANCTONF = P_LANCTONF
      AND VRPERREDBCIT > 0.00
      AND NRITPROIMPOS = '2';
   /*ESTE UPDATE ESTA SENDO REALIZADO PARA EVITAR QUE EXISTAM LANCAMENTOS COM BASE DE CÁLCULO E SEM IMPOSTO E SEM ALIQUOTA*/
   UPDATE ITEMPROIMPOS
      SET VRBASECALCIT = 0
    WHERE CDFILIAL     = P_FILIAL
      AND NRLANCTONF   = P_LANCTONF
      AND NRITPROIMPOS = W_1
      AND CDFISCALIT   = W_1
      AND VRALIQITEM   = 0.00
      AND VRIMPOSTOIT  = 0.00;
   /* GERANDO INFORMAÇÕES NA TABELA IMPOSTONF */
   IF V_NRDECITOTANF = 0 THEN
      IF V_IDOPERDEVONF = W_S THEN
         FOR C_IMPOSTONF IN (SELECT IT.CDIMPOSTO, 
                                    VRALIQITEM, 
                                    VRPERREDBCIT, 
                                    VRPARDEDIT, 
                                    CDFISCALIT,
                                    CDSITUTRIBIT, 
                                    CDFISCOPERIT, 
                                    CDSUFXCFOPIT, 
                                    IDTRIMPSTII,
                                    IT.VRADICALIQFECP,
                                    SUM(VRCONTITIMP) AS VRCONTITIMP,
                                    SUM(VRBASECALCIT) AS VRBASECALCIT, 
                                    SUM(VRIMPOSTOIT) AS VRIMPOSTOIT,
                                    MAX(NRITPROIMPOS) AS NRITPROIMPOS,
                                    SUM(VRBCICMSSTRETIDO) AS VRBCICMSSTRETIDO, 
                                    SUM(VRICMSSTRETIDO) VRICMSSTRETIDO,
                                    SUM(IT.VRADICFECP) AS VRADICFECP,
                                    NVL(IDDIFALIQCUSPRI, 'N') AS IDDIFALIQCUSPRI
                               FROM ITEMPROIMPOS IT, IMPOSTO I
                              WHERE (CDFILIAL = P_FILIAL)
                                AND (NRLANCTONF = P_LANCTONF)
                                AND (IT.CDIMPOSTO = I.CDIMPOSTO) 
                                AND (((CDFISCALIT = w_1) AND (IDIMPORECUP = w_S)) OR ((IDIMPORECUP <> w_S) AND (VRALIQITEM <> 0)))
                              GROUP BY IT.CDIMPOSTO, 
                                    VRALIQITEM, 
                                    VRPERREDBCIT, 
                                    VRPARDEDIT, 
                                    CDFISCALIT,
                                    CDSITUTRIBIT, 
                                    CDFISCOPERIT, 
                                    CDSUFXCFOPIT, 
                                    IDTRIMPSTII, 
                                    IT.VRADICALIQFECP,
                                    IDDIFALIQCUSPRI
                              UNION
                             SELECT IT.CDIMPOSTO, 
                                    0 AS VRALIQITEM, 
                                    0 AS VRPERREDBCIT, 
                                    0 AS VRPARDEDIT, 
                                    CDFISCALIT,
                                    CDSITUTRIBIT, 
                                    CDFISCOPERIT, 
                                    CDSUFXCFOPIT, 
                                    IDTRIMPSTII, 
                                    IT.VRADICALIQFECP,
                                    SUM(VRCONTITIMP) AS VRCONTITIMP,
                                    0 AS VRBASECALCIT, 
                                    0 AS VRIMPOSTOIT,
                                    MAX(NRITPROIMPOS) AS NRITPROIMPOS,
                                    SUM(VRBCICMSSTRETIDO) AS VRBCICMSSTRETIDO, 
                                    SUM(VRICMSSTRETIDO) AS VRICMSSTRETIDO,
                                    SUM(IT.VRADICFECP) AS VRADICFECP,
                                    NVL(IDDIFALIQCUSPRI, 'N') AS IDDIFALIQCUSPRI
                               FROM ITEMPROIMPOS IT, IMPOSTO I
                              WHERE (CDFILIAL = P_FILIAL)
                                AND (NRLANCTONF = P_LANCTONF)
                                AND (IT.CDIMPOSTO = I.CDIMPOSTO) 
                                AND (NRITPROIMPOS <> w_3)
                                AND (((CDFISCALIT <> w_1) AND (IDIMPORECUP = w_S)) OR ((IDIMPORECUP <> w_S) AND (VRALIQITEM = 0))) 
                              GROUP BY IT.CDIMPOSTO, 
                                    CDFISCALIT, 
                                    CDSITUTRIBIT,
                                    CDFISCOPERIT, 
                                    CDSUFXCFOPIT, 
                                    IDTRIMPSTII, 
                                    IT.VRADICALIQFECP,
                                    IDDIFALIQCUSPRI
                              UNION
                             SELECT IT.CDIMPOSTO, 
                                    VRALIQITEM, 
                                    VRPERREDBCIT, 
                                    VRPARDEDIT, 
                                    CDFISCALIT,
                                    CDSITUTRIBIT, 
                                    CDFISCOPERIT, 
                                    CDSUFXCFOPIT, 
                                    IDTRIMPSTII, 
                                    IT.VRADICALIQFECP,
                                    SUM(VRCONTITIMP) AS VRCONTITIMP,
                                    SUM(VRBASECALCIT) AS VRBASECALCIT, 
                                    SUM(VRIMPOSTOIT) AS VRIMPOSTOIT,
                                    MAX(NRITPROIMPOS) AS NRITPROIMPOS,
                                    SUM(VRBCICMSSTRETIDO) VRBCICMSSTRETIDO, 
                                    SUM(VRICMSSTRETIDO) VRICMSSTRETIDO,
                                    SUM(IT.VRADICFECP) AS VRADICFECP,
                                    NVL(IDDIFALIQCUSPRI, 'N') AS IDDIFALIQCUSPRI
                               FROM ITEMPROIMPOS IT, IMPOSTO I
                              WHERE (CDFILIAL = P_FILIAL)
                                AND (NRLANCTONF = P_LANCTONF)
                                AND (IT.CDIMPOSTO = I.CDIMPOSTO)
                                AND (NRITPROIMPOS = w_3)
                              GROUP BY 
                                    IT.CDIMPOSTO, 
                                    VRALIQITEM, 
                                    VRPERREDBCIT, 
                                    VRPARDEDIT, 
                                    CDFISCALIT,
                                    CDSITUTRIBIT, 
                                    CDFISCOPERIT, 
                                    CDSUFXCFOPIT, 
                                    IDTRIMPSTII, 
                                    IT.VRADICALIQFECP,
                                    IDDIFALIQCUSPRI) 
         LOOP
            V_ICMS := 'N';
            FOR C_ICMS IN (SELECT CDIMPOSTO
                             FROM IMPOSTONFE N, IMPOSTO I
                            WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                              AND N.CDIMPOSTONFE = '00'
                              AND I.CDIMPOSTO = C_IMPOSTONF.CDIMPOSTO)
            LOOP
               V_ICMS := 'S';
            END LOOP;
            IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (V_ICMS = 'S') THEN
               INSERT INTO IMPOSTONF(
                  CDFILIAL, NRLANCTONF, CDIMPOSTO, NRIMPOSNF, 
                  VRCONTABILNF, VRPERREDBCNF, VRBASECALCNF, VRALIQNF, 
                  VRPARDEDNF, VRIMPOSTONF, CDFISCALNF, CDSITUTRIBNF,
                  CDFISCOPERNF, CDSUFXCFOPNF, IDIMPOSTONF, VRBCICMSSTRETIDO, 
                  VRICMSSTRETIDO, IDTRIMPOSTNF, IDDIFALIQCUSPRN, VRADICALIQFECP, 
                  VRADICFECP)
               VALUES(
                  P_FILIAL, P_LANCTONF, C_IMPOSTONF.CDIMPOSTO, V_SEQUIMPOSTNF, 
                  C_IMPOSTONF.VRCONTITIMP, C_IMPOSTONF.VRPERREDBCIT, C_IMPOSTONF.VRBASECALCIT, C_IMPOSTONF.VRALIQITEM, 
                  C_IMPOSTONF.VRPARDEDIT, TRUNC(C_IMPOSTONF.VRIMPOSTOIT,0), C_IMPOSTONF.CDFISCALIT, C_IMPOSTONF.CDSITUTRIBIT,
                  C_IMPOSTONF.CDFISCOPERIT, C_IMPOSTONF.CDSUFXCFOPIT, C_IMPOSTONF.NRITPROIMPOS, C_IMPOSTONF.VRBCICMSSTRETIDO, 
                  C_IMPOSTONF.VRICMSSTRETIDO, C_IMPOSTONF.IDTRIMPSTII, C_IMPOSTONF.IDDIFALIQCUSPRI, C_IMPOSTONF.VRADICALIQFECP, 
                  C_IMPOSTONF.VRADICFECP);
            ELSE
               INSERT INTO IMPOSTONF(
                  CDFILIAL, NRLANCTONF, CDIMPOSTO, NRIMPOSNF, 
                  VRCONTABILNF, VRPERREDBCNF, VRBASECALCNF, VRALIQNF, 
                  VRPARDEDNF, VRIMPOSTONF, CDFISCALNF, CDSITUTRIBNF,
                  CDFISCOPERNF, CDSUFXCFOPNF, IDIMPOSTONF, VRBCICMSSTRETIDO, 
                  VRICMSSTRETIDO, IDTRIMPOSTNF, IDDIFALIQCUSPRN, VRADICALIQFECP, 
                  VRADICFECP)
               VALUES(
                  P_FILIAL, P_LANCTONF, C_IMPOSTONF.CDIMPOSTO, V_SEQUIMPOSTNF, 
                  C_IMPOSTONF.VRCONTITIMP, C_IMPOSTONF.VRPERREDBCIT, C_IMPOSTONF.VRBASECALCIT, C_IMPOSTONF.VRALIQITEM, 
                  C_IMPOSTONF.VRPARDEDIT, ROUND(C_IMPOSTONF.VRIMPOSTOIT,0), C_IMPOSTONF.CDFISCALIT, C_IMPOSTONF.CDSITUTRIBIT,
                  C_IMPOSTONF.CDFISCOPERIT, C_IMPOSTONF.CDSUFXCFOPIT, C_IMPOSTONF.NRITPROIMPOS, C_IMPOSTONF.VRBCICMSSTRETIDO, 
                  C_IMPOSTONF.VRICMSSTRETIDO, C_IMPOSTONF.IDTRIMPSTII, C_IMPOSTONF.IDDIFALIQCUSPRI, C_IMPOSTONF.VRADICALIQFECP, 
                  C_IMPOSTONF.VRADICFECP);
            END IF;
            V_SEQUIMPOSTNF := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_SEQUIMPOSTNF) + 1)),2,0);
         END LOOP;
      ELSE
         FOR C_IMPOSTONF IN (SELECT IT.CDIMPOSTO, 
                                    VRALIQITEM, 
                                    VRPERREDBCIT, 
                                    VRPARDEDIT, 
                                    CDFISCALIT, 
                                    CDSITUTRIBIT,
                                    CDFISCOPERIT, 
                                    CDSUFXCFOPIT, 
                                    IDTRIMPSTII, 
                                    IT.VRADICALIQFECP,
                                    SUM(ROUND(VRCONTITIMP,5)) AS VRCONTITIMP, 
                                    SUM(VRBASECALCIT) AS VRBASECALCIT, 
                                    SUM(VRIMPOSTOIT) AS VRIMPOSTOIT, 
                                    NRITPROIMPOS, 
                                    SUM(VRBCICMSSTRETIDO) AS VRBCICMSSTRETIDO, 
                                    SUM(IT.VRADICFECP) AS VRADICFECP,
                                    SUM(VRICMSSTRETIDO) VRICMSSTRETIDO
                             FROM ITEMPROIMPOS IT, IMPOSTO I
                             WHERE (CDFILIAL = P_FILIAL)
                               AND (NRLANCTONF = P_LANCTONF)
                               AND (IT.CDIMPOSTO = I.CDIMPOSTO)
                               AND (((CDFISCALIT = w_1) AND (IDIMPORECUP = w_S)) OR ((IDIMPORECUP <> w_S) AND (VRALIQITEM <> 0)))
                             GROUP BY IT.CDIMPOSTO, 
                                   VRALIQITEM, 
                                   VRPERREDBCIT, 
                                   VRPARDEDIT, 
                                   CDFISCALIT,
                                   CDSITUTRIBIT,
                                   CDFISCOPERIT,
                                   CDSUFXCFOPIT,
                                   IDTRIMPSTII,
                                   IT.VRADICALIQFECP,
                                   NRITPROIMPOS
                             UNION
                            SELECT IT.CDIMPOSTO, 
                                   0 AS VRALIQITEM, 
                                   0 AS VRPERREDBCIT, 
                                   0 AS VRPARDEDIT, 
                                   CDFISCALIT, 
                                   CDSITUTRIBIT,
                                   CDFISCOPERIT, 
                                   CDSUFXCFOPIT, 
                                   IDTRIMPSTII, 
                                   IT.VRADICALIQFECP,
                                   SUM(ROUND(VRCONTITIMP,5)) AS VRCONTITIMP, 
                                   0 AS VRBASECALCIT, 
                                   0 AS VRIMPOSTOIT,  
                                   NRITPROIMPOS, 
                                   SUM(VRBCICMSSTRETIDO) AS VRBCICMSSTRETIDO, 
                                   SUM(IT.VRADICFECP) AS VRADICFECP,
                                   SUM(VRICMSSTRETIDO) AS VRICMSSTRETIDO
                              FROM ITEMPROIMPOS IT, IMPOSTO I
                             WHERE (CDFILIAL = P_FILIAL)
                               AND (NRLANCTONF = P_LANCTONF)
                               AND (IT.CDIMPOSTO = I.CDIMPOSTO)
                               AND (((IT.CDFISCALIT <> w_1) AND (IDIMPORECUP = w_S)) OR ((I.IDIMPORECUP  <> w_S) AND (VRALIQITEM = 0)))
                             GROUP BY IT.CDIMPOSTO, 
                                   CDFISCALIT, 
                                   CDSITUTRIBIT,
                                   CDFISCOPERIT, 
                                   CDSUFXCFOPIT, 
                                   IDTRIMPSTII, 
                                   IT.VRADICALIQFECP,
                                   NRITPROIMPOS) 
         LOOP
            V_ICMS := 'N';
            FOR C_ICMS IN (SELECT CDIMPOSTO
                             FROM IMPOSTONFE N, IMPOSTO I
                            WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                              AND N.CDIMPOSTONFE = '00'
                              AND I.CDIMPOSTO = C_IMPOSTONF.CDIMPOSTO)
            LOOP
               V_ICMS := 'S';
            END LOOP;
            IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (V_ICMS = 'S') THEN
               INSERT INTO IMPOSTONF(
                  CDFILIAL, NRLANCTONF, CDIMPOSTO, NRIMPOSNF, 
                  VRCONTABILNF, VRPERREDBCNF, VRBASECALCNF, VRALIQNF, 
                  VRPARDEDNF, VRIMPOSTONF, CDFISCALNF, CDSITUTRIBNF,
                  CDFISCOPERNF, CDSUFXCFOPNF, IDIMPOSTONF, VRBCICMSSTRETIDO, 
                  VRICMSSTRETIDO, IDTRIMPOSTNF, VRADICALIQFECP, VRADICFECP)
               VALUES(
                  P_FILIAL, P_LANCTONF, C_IMPOSTONF.CDIMPOSTO, V_SEQUIMPOSTNF, 
                  C_IMPOSTONF.VRCONTITIMP, C_IMPOSTONF.VRPERREDBCIT, C_IMPOSTONF.VRBASECALCIT, C_IMPOSTONF.VRALIQITEM, 
                  C_IMPOSTONF.VRPARDEDIT, TRUNC(C_IMPOSTONF.VRIMPOSTOIT,0), C_IMPOSTONF.CDFISCALIT, C_IMPOSTONF.CDSITUTRIBIT,
                  C_IMPOSTONF.CDFISCOPERIT, C_IMPOSTONF.CDSUFXCFOPIT, C_IMPOSTONF.NRITPROIMPOS, C_IMPOSTONF.VRBCICMSSTRETIDO, 
                  C_IMPOSTONF.VRICMSSTRETIDO, C_IMPOSTONF.IDTRIMPSTII, C_IMPOSTONF.VRADICALIQFECP, C_IMPOSTONF.VRADICFECP);
            ELSE
               INSERT INTO IMPOSTONF(
                  CDFILIAL, NRLANCTONF, CDIMPOSTO, NRIMPOSNF, 
                  VRCONTABILNF, VRPERREDBCNF, VRBASECALCNF, VRALIQNF, 
                  VRPARDEDNF, VRIMPOSTONF, CDFISCALNF, CDSITUTRIBNF,
                  CDFISCOPERNF, CDSUFXCFOPNF, IDIMPOSTONF, VRBCICMSSTRETIDO, 
                  VRICMSSTRETIDO, IDTRIMPOSTNF, VRADICALIQFECP, VRADICFECP)
               VALUES(
                  P_FILIAL, P_LANCTONF, C_IMPOSTONF.CDIMPOSTO, V_SEQUIMPOSTNF, 
                  C_IMPOSTONF.VRCONTITIMP, C_IMPOSTONF.VRPERREDBCIT, C_IMPOSTONF.VRBASECALCIT, C_IMPOSTONF.VRALIQITEM, 
                  C_IMPOSTONF.VRPARDEDIT, ROUND(C_IMPOSTONF.VRIMPOSTOIT,0), C_IMPOSTONF.CDFISCALIT, C_IMPOSTONF.CDSITUTRIBIT,
                  C_IMPOSTONF.CDFISCOPERIT, C_IMPOSTONF.CDSUFXCFOPIT, C_IMPOSTONF.NRITPROIMPOS, C_IMPOSTONF.VRBCICMSSTRETIDO, 
                  C_IMPOSTONF.VRICMSSTRETIDO, C_IMPOSTONF.IDTRIMPSTII, C_IMPOSTONF.VRADICALIQFECP, C_IMPOSTONF.VRADICFECP);
            END IF;
            V_SEQUIMPOSTNF := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_SEQUIMPOSTNF) + 1)),2,0);
         END LOOP;
      END IF;
   ELSE
      IF V_IDOPERDEVONF = w_S THEN
         FOR C_IMPOSTONF IN (SELECT IT.CDIMPOSTO, 
                                    VRALIQITEM, 
                                    VRPERREDBCIT, 
                                    VRPARDEDIT, 
                                    CDFISCALIT, 
                                    CDSITUTRIBIT,
                                    CDFISCOPERIT, 
                                    CDSUFXCFOPIT, 
                                    IDTRIMPSTII, 
                                    IT.VRADICALIQFECP,
                                    SUM(VRCONTITIMP) AS VRCONTITIMP, 
                                    SUM(VRBASECALCIT) AS VRBASECALCIT, 
                                    SUM(VRIMPOSTOIT) AS VRIMPOSTOIT,
                                    MAX(NRITPROIMPOS) AS NRITPROIMPOS, 
                                    SUM(VRBCICMSSTRETIDO) AS VRBCICMSSTRETIDO, 
                                    SUM(VRICMSSTRETIDO) AS VRICMSSTRETIDO,
                                    SUM(IT.VRADICFECP) AS VRADICFECP,
                                    NVL(IDDIFALIQCUSPRI, 'N') AS IDDIFALIQCUSPRI
                               FROM ITEMPROIMPOS IT, IMPOSTO I
                              WHERE (CDFILIAL = P_FILIAL)
                                AND (NRLANCTONF = P_LANCTONF)
                                AND (IT.CDIMPOSTO = I.CDIMPOSTO)
                                AND (((CDFISCALIT = w_1) AND (IDIMPORECUP = w_S)) OR ((IDIMPORECUP <> w_S) AND (VRALIQITEM <> 0)))
                              GROUP BY IT.CDIMPOSTO, 
                                    VRALIQITEM, 
                                    VRPERREDBCIT, 
                                    VRPARDEDIT, 
                                    CDFISCALIT,
                                    CDSITUTRIBIT, 
                                    CDFISCOPERIT, 
                                    CDSUFXCFOPIT, 
                                    IDTRIMPSTII, 
                                    IT.VRADICALIQFECP,
                                    IDDIFALIQCUSPRI
                              UNION
                             SELECT IT.CDIMPOSTO, 
                                    0 AS VRALIQITEM, 
                                    0 AS VRPERREDBCIT, 
                                    0 AS VRPARDEDIT, 
                                    CDFISCALIT, 
                                    CDSITUTRIBIT,
                                    CDFISCOPERIT, 
                                    CDSUFXCFOPIT, 
                                    IDTRIMPSTII, 
                                    IT.VRADICALIQFECP,
                                    SUM(VRCONTITIMP) AS VRCONTITIMP, 
                                    0 AS VRBASECALCIT, 
                                    0 AS VRIMPOSTOIT,
                                    MAX(NRITPROIMPOS) AS NRITPROIMPOS, 
                                    SUM(VRBCICMSSTRETIDO) AS VRBCICMSSTRETIDO, 
                                    SUM(VRICMSSTRETIDO) AS VRICMSSTRETIDO,
                                    SUM(IT.VRADICFECP) AS VRADICFECP,
                                    NVL(IDDIFALIQCUSPRI, 'N') AS IDDIFALIQCUSPRI
                               FROM ITEMPROIMPOS IT, IMPOSTO I
                              WHERE (CDFILIAL = P_FILIAL)
                                AND (NRLANCTONF = P_LANCTONF)
                                AND (IT.CDIMPOSTO = I.CDIMPOSTO)
                                AND (NRITPROIMPOS <> w_3)
                                AND (((CDFISCALIT <> w_1) AND (IDIMPORECUP = w_S)) OR ((IDIMPORECUP <> w_S) AND (VRALIQITEM = 0)))
                              GROUP BY IT.CDIMPOSTO, 
                                    CDFISCALIT, 
                                    CDSITUTRIBIT,
                                    CDFISCOPERIT, 
                                    CDSUFXCFOPIT, 
                                    IDTRIMPSTII, 
                                    IT.VRADICALIQFECP,
                                    IDDIFALIQCUSPRI
                              UNION
                             SELECT IT.CDIMPOSTO, 
                                    VRALIQITEM, 
                                    VRPERREDBCIT, 
                                    VRPARDEDIT, 
                                    CDFISCALIT, 
                                    CDSITUTRIBIT,
                                    CDFISCOPERIT, 
                                    CDSUFXCFOPIT, 
                                    IDTRIMPSTII, 
                                    IT.VRADICALIQFECP,
                                    SUM(VRCONTITIMP) AS VRCONTITIMP, 
                                    SUM(VRBASECALCIT) AS VRBASECALCIT, 
                                    SUM(VRIMPOSTOIT) AS VRIMPOSTOIT,
                                    MAX(NRITPROIMPOS) AS NRITPROIMPOS, 
                                    SUM(VRBCICMSSTRETIDO) AS VRBCICMSSTRETIDO, 
                                    SUM(VRICMSSTRETIDO) AS VRICMSSTRETIDO,
                                    SUM(IT.VRADICFECP) AS VRADICFECP,
                                    NVL(IDDIFALIQCUSPRI, 'N') AS IDDIFALIQCUSPRI
                               FROM ITEMPROIMPOS IT, IMPOSTO I
                              WHERE (CDFILIAL = P_FILIAL)
                                AND (NRLANCTONF = P_LANCTONF)
                                AND (IT.CDIMPOSTO = I.CDIMPOSTO) 
                                AND (NRITPROIMPOS = w_3)
                              GROUP BY IT.CDIMPOSTO, 
                                    VRALIQITEM, 
                                    VRPERREDBCIT, 
                                    VRPARDEDIT, 
                                    CDFISCALIT,
                                    CDSITUTRIBIT,
                                    CDFISCOPERIT,
                                    CDSUFXCFOPIT,
                                    IDTRIMPSTII,
                                    IT.VRADICALIQFECP,
                                    IDDIFALIQCUSPRI) 
         LOOP
            V_ICMS := 'N';
            FOR C_ICMS IN (SELECT CDIMPOSTO
                             FROM IMPOSTONFE N, IMPOSTO I
                            WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                              AND N.CDIMPOSTONFE = '00'
                              AND I.CDIMPOSTO = C_IMPOSTONF.CDIMPOSTO)
            LOOP
               V_ICMS := 'S';
            END LOOP;
            IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (V_ICMS = 'S') THEN
               INSERT INTO IMPOSTONF(
                  CDFILIAL, NRLANCTONF, CDIMPOSTO, NRIMPOSNF, 
                  VRCONTABILNF, VRPERREDBCNF, VRBASECALCNF, VRALIQNF, 
                  VRPARDEDNF, VRIMPOSTONF, CDFISCALNF, CDSITUTRIBNF,
                  CDFISCOPERNF, CDSUFXCFOPNF, IDIMPOSTONF, VRBCICMSSTRETIDO, 
                  VRICMSSTRETIDO, IDTRIMPOSTNF, IDDIFALIQCUSPRN, VRADICALIQFECP, 
                  VRADICFECP)
               VALUES(
                  P_FILIAL, P_LANCTONF, C_IMPOSTONF.CDIMPOSTO, V_SEQUIMPOSTNF, 
                  TRUNC(C_IMPOSTONF.VRCONTITIMP,V_NRDECITOTANF), C_IMPOSTONF.VRPERREDBCIT, C_IMPOSTONF.VRBASECALCIT, C_IMPOSTONF.VRALIQITEM, 
                  C_IMPOSTONF.VRPARDEDIT, TRUNC(C_IMPOSTONF.VRIMPOSTOIT,V_NRDECITOTANF), C_IMPOSTONF.CDFISCALIT, C_IMPOSTONF.CDSITUTRIBIT,
                  C_IMPOSTONF.CDFISCOPERIT, C_IMPOSTONF.CDSUFXCFOPIT, C_IMPOSTONF.NRITPROIMPOS, C_IMPOSTONF.VRBCICMSSTRETIDO, 
                  C_IMPOSTONF.VRICMSSTRETIDO, C_IMPOSTONF.IDTRIMPSTII, C_IMPOSTONF.IDDIFALIQCUSPRI, C_IMPOSTONF.VRADICALIQFECP, 
                  C_IMPOSTONF.VRADICFECP);
            ELSE
               INSERT INTO IMPOSTONF(
                  CDFILIAL, NRLANCTONF, CDIMPOSTO, NRIMPOSNF, 
                  VRCONTABILNF, VRPERREDBCNF, VRBASECALCNF, VRALIQNF, 
                  VRPARDEDNF, VRIMPOSTONF, CDFISCALNF, CDSITUTRIBNF,
                  CDFISCOPERNF, CDSUFXCFOPNF, IDIMPOSTONF, VRBCICMSSTRETIDO, 
                  VRICMSSTRETIDO, IDTRIMPOSTNF, IDDIFALIQCUSPRN, VRADICALIQFECP, 
                  VRADICFECP)
               VALUES(
                  P_FILIAL, P_LANCTONF, C_IMPOSTONF.CDIMPOSTO, V_SEQUIMPOSTNF, 
                  ROUND(C_IMPOSTONF.VRCONTITIMP,5), C_IMPOSTONF.VRPERREDBCIT, C_IMPOSTONF.VRBASECALCIT, C_IMPOSTONF.VRALIQITEM, 
                  C_IMPOSTONF.VRPARDEDIT, ROUND(C_IMPOSTONF.VRIMPOSTOIT,V_NRDECITOTANF), C_IMPOSTONF.CDFISCALIT, C_IMPOSTONF.CDSITUTRIBIT,
                  C_IMPOSTONF.CDFISCOPERIT, C_IMPOSTONF.CDSUFXCFOPIT, C_IMPOSTONF.NRITPROIMPOS, C_IMPOSTONF.VRBCICMSSTRETIDO, 
                  C_IMPOSTONF.VRICMSSTRETIDO, C_IMPOSTONF.IDTRIMPSTII, C_IMPOSTONF.IDDIFALIQCUSPRI, C_IMPOSTONF.VRADICALIQFECP, 
                  C_IMPOSTONF.VRADICFECP);
            END IF;
            V_SEQUIMPOSTNF := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_SEQUIMPOSTNF) + 1)),2,0);
         END LOOP;
      ELSE
         FOR C_IMPOSTONF IN (SELECT IT.CDIMPOSTO, 
                                    VRALIQITEM, 
                                    VRPERREDBCIT, 
                                    VRPARDEDIT, 
                                    CDFISCALIT, 
                                    CDSITUTRIBIT,
                                    CDFISCOPERIT, 
                                    CDSUFXCFOPIT, 
                                    IDTRIMPSTII, 
                                    IT.VRADICALIQFECP,
                                    SUM(ROUND(VRCONTITIMP,5)) AS VRCONTITIMP,
                                    SUM(VRBASECALCIT) AS VRBASECALCIT, 
                                    SUM(VRIMPOSTOIT) AS VRIMPOSTOIT,  
                                    NRITPROIMPOS, 
                                    SUM(VRBCICMSSTRETIDO) AS VRBCICMSSTRETIDO, 
                                    SUM(IT.VRADICFECP) AS VRADICFECP,
                                    SUM(VRICMSSTRETIDO) AS VRICMSSTRETIDO
                               FROM ITEMPROIMPOS IT, IMPOSTO I
                              WHERE (CDFILIAL = P_FILIAL)
                                AND (NRLANCTONF = P_LANCTONF) 
                                AND (IT.CDIMPOSTO = I.CDIMPOSTO) 
                                AND (((CDFISCALIT  = w_1) AND (IDIMPORECUP = w_S)) OR ((IDIMPORECUP <> w_S) AND (VRALIQITEM <> 0)))
                              GROUP BY IT.CDIMPOSTO, 
                                    VRALIQITEM, 
                                    VRPERREDBCIT, 
                                    VRPARDEDIT, 
                                    CDFISCALIT,
                                    CDSITUTRIBIT, 
                                    CDFISCOPERIT, 
                                    CDSUFXCFOPIT, 
                                    IDTRIMPSTII, 
                                    IT.VRADICALIQFECP,
                                    NRITPROIMPOS
                              UNION
                             SELECT IT.CDIMPOSTO, 
                                    0 AS VRALIQITEM, 
                                    0 AS VRPERREDBCIT, 
                                    0 AS VRPARDEDIT, 
                                    CDFISCALIT, 
                                    CDSITUTRIBIT,
                                    CDFISCOPERIT, 
                                    CDSUFXCFOPIT, 
                                    IDTRIMPSTII, 
                                    IT.VRADICALIQFECP,
                                    SUM(ROUND(VRCONTITIMP,5)) AS VRCONTITIMP, 
                                    0 AS VRBASECALCIT, 
                                    0 AS VRIMPOSTOIT,
                                    NRITPROIMPOS, 
                                    SUM(VRBCICMSSTRETIDO) AS VRBCICMSSTRETIDO, 
                                    SUM(IT.VRADICFECP) AS VRADICFECP,
                                    SUM(VRICMSSTRETIDO) AS VRICMSSTRETIDO
                               FROM ITEMPROIMPOS IT, IMPOSTO I
                              WHERE (CDFILIAL      = P_FILIAL)
                                AND (NRLANCTONF    = P_LANCTONF)
                                AND (IT.CDIMPOSTO  = I.CDIMPOSTO)
                                AND (((IT.CDFISCALIT <> w_1) AND (IDIMPORECUP = w_S)) OR ((I.IDIMPORECUP  <> w_S) AND (VRALIQITEM = 0)))
                              GROUP BY 
                                    IT.CDIMPOSTO,
                                    CDFISCALIT,
                                    CDSITUTRIBIT,
                                    CDFISCOPERIT, 
                                    CDSUFXCFOPIT, 
                                    IDTRIMPSTII, 
                                    IT.VRADICALIQFECP,
                                    NRITPROIMPOS) 
         LOOP
            V_ICMS := 'N';
            FOR C_ICMS IN (SELECT CDIMPOSTO
                             FROM IMPOSTONFE N, IMPOSTO I
                            WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                              AND N.CDIMPOSTONFE = '00'
                              AND I.CDIMPOSTO = C_IMPOSTONF.CDIMPOSTO)
            LOOP
               V_ICMS := 'S';
            END LOOP;
            IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (V_ICMS = 'S') THEN
               INSERT INTO IMPOSTONF(
                  CDFILIAL, NRLANCTONF, CDIMPOSTO, NRIMPOSNF, 
                  VRCONTABILNF, VRPERREDBCNF, VRBASECALCNF, VRALIQNF, 
                  VRPARDEDNF, VRIMPOSTONF, CDFISCALNF, CDSITUTRIBNF,
                  CDFISCOPERNF, CDSUFXCFOPNF, IDIMPOSTONF, VRBCICMSSTRETIDO, 
                  VRICMSSTRETIDO, IDTRIMPOSTNF, VRADICALIQFECP, VRADICFECP)
               VALUES(
                  P_FILIAL, P_LANCTONF, C_IMPOSTONF.CDIMPOSTO, V_SEQUIMPOSTNF, 
                  C_IMPOSTONF.VRCONTITIMP, C_IMPOSTONF.VRPERREDBCIT, C_IMPOSTONF.VRBASECALCIT, C_IMPOSTONF.VRALIQITEM, 
                  C_IMPOSTONF.VRPARDEDIT, TRUNC(C_IMPOSTONF.VRIMPOSTOIT, V_NRDECITOTANF), C_IMPOSTONF.CDFISCALIT, C_IMPOSTONF.CDSITUTRIBIT,
                  C_IMPOSTONF.CDFISCOPERIT, C_IMPOSTONF.CDSUFXCFOPIT, C_IMPOSTONF.NRITPROIMPOS, C_IMPOSTONF.VRBCICMSSTRETIDO, 
                  C_IMPOSTONF.VRICMSSTRETIDO, C_IMPOSTONF.IDTRIMPSTII, C_IMPOSTONF.VRADICALIQFECP, C_IMPOSTONF.VRADICFECP);
            ELSE
               INSERT INTO IMPOSTONF(
                  CDFILIAL, NRLANCTONF, CDIMPOSTO, NRIMPOSNF, 
                  VRCONTABILNF, VRPERREDBCNF, VRBASECALCNF, VRALIQNF, 
                  VRPARDEDNF, VRIMPOSTONF, CDFISCALNF, CDSITUTRIBNF,
                  CDFISCOPERNF, CDSUFXCFOPNF, IDIMPOSTONF, VRBCICMSSTRETIDO, 
                  VRICMSSTRETIDO, IDTRIMPOSTNF, VRADICALIQFECP, VRADICFECP)
               VALUES(
                  P_FILIAL, P_LANCTONF, C_IMPOSTONF.CDIMPOSTO, V_SEQUIMPOSTNF, 
                  C_IMPOSTONF.VRCONTITIMP, C_IMPOSTONF.VRPERREDBCIT, C_IMPOSTONF.VRBASECALCIT, C_IMPOSTONF.VRALIQITEM, 
                  C_IMPOSTONF.VRPARDEDIT, ROUND(C_IMPOSTONF.VRIMPOSTOIT, V_NRDECITOTANF), C_IMPOSTONF.CDFISCALIT, C_IMPOSTONF.CDSITUTRIBIT,
                  C_IMPOSTONF.CDFISCOPERIT, C_IMPOSTONF.CDSUFXCFOPIT, C_IMPOSTONF.NRITPROIMPOS, C_IMPOSTONF.VRBCICMSSTRETIDO, 
                  C_IMPOSTONF.VRICMSSTRETIDO, C_IMPOSTONF.IDTRIMPSTII, C_IMPOSTONF.VRADICALIQFECP, C_IMPOSTONF.VRADICFECP);
            END IF;
            V_SEQUIMPOSTNF := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_SEQUIMPOSTNF) + 1)),2,0);
         END LOOP;
      END IF;
   END IF;
   FOR C_CARGA IN (SELECT DISTINCT CDIMPOSTO
                     FROM IMPOSTONF
                     WHERE CDFILIAL = P_FILIAL
                       AND NRLANCTONF = P_LANCTONF) LOOP
      V_CARGA := VALOR_CARGA_TRIBUTARIA(C_CARGA.CDIMPOSTO, P_FILIAL, P_LANCTONF);
      IF V_CARGA > 0 THEN
         UPDATE IMPOSTONF
            SET VRIMPCARGATRIBI = V_CARGA
           WHERE CDFILIAL = P_FILIAL
             AND NRLANCTONF = P_LANCTONF
             AND CDIMPOSTO = C_CARGA.CDIMPOSTO
             AND NRIMPOSNF = (SELECT MAX(NRIMPOSNF)
                                      FROM IMPOSTONF
                                      WHERE CDFILIAL = P_FILIAL
                                        AND NRLANCTONF = P_LANCTONF
                                        AND CDIMPOSTO = C_CARGA.CDIMPOSTO);
      END IF;
   END LOOP;
   FOR C_IMPOSTORETI IN (SELECT N.CDEMPRESA, I.CDIMPOSTO, N.IDTPIJURNF, N.NRINSJURNF, N.DTENTRSAID
                         FROM IMPOSTO I, NOTAFISCAL N, IMPOSTONF IP
                         WHERE N.CDFILIAL   = P_FILIAL      AND
                               N.NRLANCTONF = P_LANCTONF    AND
                               N.CDFILIAL   = IP.CDFILIAL   AND
                               N.NRLANCTONF = IP.NRLANCTONF AND
                               IP.CDIMPOSTO = I.CDIMPOSTO   AND
                               I.IDTRATIMPO   = w_R         AND
                               I.IDUTVRMENSBC = w_S) LOOP
      BASECALC_RETIDO('S', P_FILIAL, P_LANCTONF, C_IMPOSTORETI.IDTPIJURNF, C_IMPOSTORETI.NRINSJURNF,
                         C_IMPOSTORETI.DTENTRSAID, C_IMPOSTORETI.CDIMPOSTO, w_S, C_IMPOSTORETI.CDEMPRESA,
                         P_INSCESTA, V_PAISORIG, V_ESTAORIG, V_PAISDEST, V_ESTADEST, V_CDGRUPOFISC, V_CDGRPFISCSV, P_TIPOOPER);
   END LOOP;
/* SE O IPI COMPOR A BASE DE CALCULO DO ICMS E O ICMS TIVER O CODIGO FISCAL IGUAL A 1 SERA ATUALIZADO COM O IDENTIFICADOR 4 */
   FOR C_IMPFISC IN (SELECT CDFILIAL, NRLANCTONF, CDIMPOSTO, CDSITUTRIBNF, CDFISCOPERNF, CDFISCALNF
                       FROM IMPOSTONF IP
                      WHERE IP.CDFILIAL = P_FILIAL
                        AND IP.NRLANCTONF = P_LANCTONF
                        AND IP.IDIMPOSTONF = w_1
                        AND IP.CDFISCALNF = w_1) LOOP
      SELECT MAX(BC.CDIMPOBCALC) AS CDIMPOBCALC
        INTO V_CDIMPOBCALC
        FROM BASECALCTPOPER BC
       WHERE (BC.IDENTRSAIDOP = 'S')
         AND (BC.CDTIPOOPER = P_TIPOOPER)
         AND (BC.CDIMPOSTO = C_IMPFISC.CDIMPOSTO)
         AND (BC.CDIMPOBCALC IS NOT NULL)
         AND ((SUBSTR(C_IMPFISC.CDSITUTRIBNF,2,2)  = BC.CDCSTIMPOTPOP)  OR (BC.CDCSTIMPOTPOP  IS NULL))
         AND ((SUBSTR(C_IMPFISC.CDFISCOPERNF,2,4) = BC.CDCFOPIMPOTPOP) OR (BC.CDCFOPIMPOTPOP IS NULL))
         AND (C_IMPFISC.CDFISCALNF = BC.CDFISCIMPOTPOP) OR (BC.CDFISCIMPOTPOP IS NULL);
      IF V_CDIMPOBCALC IS NULL THEN
         SELECT MAX(BC.CDIMPOBCALC) AS CDIMPOBCALC
           INTO V_CDIMPOBCALC
           FROM BASECALC BC
          WHERE BC.CDIMPOSTO = C_IMPFISC.CDIMPOSTO
            AND BC.CDIMPOBCALC IS NOT NULL
            AND ((SUBSTR(C_IMPFISC.CDSITUTRIBNF,2,2)  = BC.CDCSTIMPO)  OR (BC.CDCSTIMPO  IS NULL))
            AND ((SUBSTR(C_IMPFISC.CDFISCOPERNF,2,10) = BC.CDCFOPIMPO) OR (BC.CDCFOPIMPO IS NULL))
            AND (C_IMPFISC.CDFISCALNF = BC.CDFISCIMPO) OR (BC.CDFISCIMPO IS NULL)
            AND BC.IDTIPOBCALC = 'I';
         IF NOT V_CDIMPOBCALC IS NULL THEN
            UPDATE IMPOSTONF
               SET IDIMPOSTONF = w_4
             WHERE CDFILIAL   = C_IMPFISC.CDFILIAL
               AND NRLANCTONF = C_IMPFISC.NRLANCTONF
               AND CDIMPOSTO  = V_CDIMPOBCALC;
         END IF;
      ELSE
         UPDATE IMPOSTONF
         SET IDIMPOSTONF = '4'
         WHERE CDFILIAL   = C_IMPFISC.CDFILIAL   AND
               NRLANCTONF = C_IMPFISC.NRLANCTONF AND
               CDIMPOSTO  = V_CDIMPOBCALC;
      END IF;
   END LOOP;
   UPDATE NOTAFISCAL
   SET VRNOTAFISC = NVL(V_TOTALNOTA,0),
       VRPRODUTOS = NVL(V_LIQUIDO,0),
       VRDISPNFDEVO = NVL(V_TOTALNOTA,0),
       IDERROS    = w_000
   WHERE CDFILIAL   = P_FILIAL AND
         NRLANCTONF = P_LANCTONF;
   DELETE
     FROM INFOPAGANFE
    WHERE CDFILIAL = P_FILIAL
      AND NRLANCTONF = P_LANCTONF;
   SELECT ROUND(NVL(SUM(IT.VRTOTIMPONF),0), V_NRDECITOTANF)
     INTO V_IMPOSRETI
     FROM IMPOSNFTOT IT, IMPOSTO I
    WHERE I.CDIMPOSTO    = IT.CDIMPOSTO
      AND IT.CDFILIAL    = P_FILIAL
      AND IT.NRLANCTONF  = P_LANCTONF
      AND ((I.IDDESCRFONTE <> w_A) AND (I.IDDESCRFONTE <> 'N'))
      AND I.IDTRATIMPO   = w_R;
   V_TOTALNOTA  := V_TOTALNOTA - V_IMPOSRETI;
   P_VRNOTAFISC := V_TOTALNOTA;
   SELECT NVL(SUM(VRORIGREC),0), MAX(NRLANBOLREC)
   INTO   V_VRCONTAREC,          V_NRLANBOLREC
   FROM CONTARECEBER
   WHERE CDFILIAL   = P_FILIAL AND
         NRLANCTONF = P_LANCTONF;
   /*IF (V_VRCONTAREC <> V_TOTALNOTA) AND (V_IMPOSRETI > 0) AND
      (V_IDDOCFINANC <> w_L) AND (V_NRLANBOLREC IS NULL) THEN
      APURAC_VENC(P_FILIAL, P_CLIENTE, P_LANCTONF);
   END IF;*/
   --ATUALIZAÇÃO DO CÓDIGO FISCAL DA OPERAÇÃO NA TABELA DE NOTA FISCAL
   SELECT MAX(CDCFOPINFUSU), MAX(DSCFOPINFUSU)
     INTO V_CDCFOPINFUSU,    V_DSCFOPINFUSU
     FROM NOTAFISCAL
    WHERE CDFILIAL = P_FILIAL
      AND NRLANCTONF = P_LANCTONF;
   IF (V_CDCFOPINFUSU IS NULL)  THEN
      SELECT COUNT(DISTINCT CDFISOPEITEM), MAX(CDFISOPEITEM)
        INTO   V_COUNT                     , V_CDFISOPENTF
        FROM ITEMPRODUTO
       WHERE (CDFILIAL   = P_FILIAL) AND
             (NRLANCTONF = P_LANCTONF);
      IF (V_COUNT > 1) THEN
         UPDATE NOTAFISCAL
         SET CDFISOPENTF = '***'
         WHERE CDFILIAL   = P_FILIAL
           AND NRLANCTONF = P_LANCTONF;
      ELSIF (V_COUNT <= 1) THEN
         UPDATE NOTAFISCAL
            SET CDFISOPENTF = V_CDFISOPENTF
          WHERE (CDFILIAL   = P_FILIAL)
            AND (NRLANCTONF = P_LANCTONF);
      END IF;
   ELSE
      UPDATE NOTAFISCAL
         SET CDFISOPENTF  = V_CDCFOPINFUSU
       WHERE CDFILIAL   = P_FILIAL
         AND NRLANCTONF = P_LANCTONF;
      UPDATE ITEMPRODUTO
         SET CDFISOPEITEM = V_CDCFOPINFUSU
       WHERE CDFILIAL   = P_FILIAL
         AND NRLANCTONF = P_LANCTONF;
      UPDATE ITEMPROIMPOS
         SET CDFISCOPERIT = V_CDCFOPINFUSU
       WHERE CDFILIAL   = P_FILIAL
         AND NRLANCTONF = P_LANCTONF;
      UPDATE IMPOSTONF
         SET CDFISCOPERNF = V_CDCFOPINFUSU
       WHERE CDFILIAL   = P_FILIAL
         AND NRLANCTONF = P_LANCTONF;
   END IF;
   IF (V_DSCFOPINFUSU IS NOT NULL)  THEN
      UPDATE NOTAFISCAL
         SET DSCDFISOPENF = V_DSCFOPINFUSU
       WHERE CDFILIAL   = P_FILIAL
         AND NRLANCTONF = P_LANCTONF;
   END IF;
   UPDATE ITEMPRODUTO
   SET IDAVISOSITEM  = w_00000
   WHERE (CDFILIAL   = P_FILIAL) AND
         (NRLANCTONF = P_LANCTONF);
   UPDATE ITEMPROIMPOS
   SET IDAVISIMPIT   = w_00000,
       IDERROSIMPIT  = w_00000
   WHERE (CDFILIAL   = P_FILIAL) AND
         (NRLANCTONF = P_LANCTONF);
--IDENTIFICADOR DE ERROS E AVISOS
   IF NOT(P_TIPOOPER IN ('09', '10', '12')) THEN /*VALE DE TRANSFERENCIA, SAIDA SEM NOTA, NOTA DE CREDITO/DEBITO*/
      /* (AVISO) ITEM COM CÓDIGO DA SITUAÇÃO TRIBUTÁRIA INVÁLIDO */
      Begin
         SELECT IDERROAVISOFIL
         INTO   V_IDERROAVISO
         FROM ERROAVISONFFIL
         WHERE CDERROAVISOFIL = w_Av09
           AND CDFILIAL = V_CDFILIEMIT;
      Exception
         When No_Data_Found Then
            V_IDERROAVISO := Null;
      End;
      IF V_IDERROAVISO IS NULL THEN
         Begin
            SELECT IDERROAVISO
            INTO   V_IDERROAVISO
            FROM ERROAVISONF
            WHERE CDERROAVISO = w_Av09;
         Exception
            When No_Data_Found Then
               V_IDERROAVISO := Null;
         End;
      END IF;
      UPDATE ITEMPRODUTO
      SET IDAVISOSITEM = w_1 || SUBSTR(IDAVISOSITEM,2,4)
      WHERE (CDFILIAL   = P_FILIAL)   AND
            (NRLANCTONF = P_LANCTONF) AND
            ((CDSITUTRIBPR IS NULL) OR (LENGTH(TRIM(CDSITUTRIBPR)) < 3)) AND
            (V_IDERROAVISO <> w_N) AND
            (V_IDCONSPARFIS <> w_N);
      /* (AVISO) ITEM COM CÓDIGO FISCAL DE OPERAÇÃO INVÁLIDO */
      Begin
         SELECT IDERROAVISOFIL
         INTO   V_IDERROAVISO
         FROM ERROAVISONFFIL
         WHERE CDERROAVISOFIL = w_Av10
           AND CDFILIAL = V_CDFILIEMIT;
      Exception
         When No_Data_Found Then
            V_IDERROAVISO := Null;
      End;
      IF V_IDERROAVISO IS NULL THEN
         Begin
            SELECT IDERROAVISO
            INTO   V_IDERROAVISO
            FROM ERROAVISONF
            WHERE CDERROAVISO = w_Av10;
         Exception
            When No_Data_Found Then
               V_IDERROAVISO := Null;
         End;
      END IF;
      UPDATE ITEMPRODUTO
      SET IDAVISOSITEM = SUBSTR(IDAVISOSITEM,1,1) || w_1 || SUBSTR(IDAVISOSITEM,3,3)
      WHERE (CDFILIAL   = P_FILIAL)   AND
            (NRLANCTONF = P_LANCTONF) AND
            ((CDFISOPEITEM IS NULL) OR (LENGTH(CDFISOPEITEM) < 3)) AND
            (V_IDERROAVISO <> w_N) AND
            (V_IDCONSPARFIS <> w_N);
      IF NOT(P_TIPOOPER IN ('07', '12')) THEN
         /* (AVISO) IMPOSTO DO ITEM DA ENTRADA COM CÓDIGO FISCAL INVÁLIDO */
         Begin
            SELECT IDERROAVISOFIL
            INTO   V_IDERROAVISO
            FROM ERROAVISONFFIL
            WHERE CDERROAVISOFIL = w_Av04
              AND CDFILIAL = V_CDFILIEMIT;
         Exception
            When No_Data_Found Then
               V_IDERROAVISO := Null;
         End;
         IF V_IDERROAVISO IS NULL THEN
            Begin
               SELECT IDERROAVISO
               INTO   V_IDERROAVISO
               FROM ERROAVISONF
               WHERE CDERROAVISO = w_Av04;
            Exception
               When No_Data_Found Then
                  V_IDERROAVISO := Null;
            End;
         END IF;
         UPDATE ITEMPROIMPOS
         SET IDAVISIMPIT = SUBSTR(IDAVISIMPIT,1,1) || w_1 || SUBSTR(IDAVISIMPIT,3,3)
         WHERE (CDFILIAL   = P_FILIAL)   AND
               (NRLANCTONF = P_LANCTONF) AND
               ((CDFISCALIT IS NULL) OR LENGTH(CDFISCALIT) <> 1) AND
               (V_IDERROAVISO <> w_N);
         /* (AVISO) IMPOSTO DO ITEM COM SITUAÇÃO TRIBUTÁRIA(CST) INVÁLIDA */
         Begin
            SELECT IDERROAVISOFIL
            INTO   V_IDERROAVISO
            FROM ERROAVISONFFIL
            WHERE CDERROAVISOFIL = w_Av05
              AND CDFILIAL = V_CDFILIEMIT;
         Exception
            When No_Data_Found Then
               V_IDERROAVISO := Null;
         End;
         IF V_IDERROAVISO IS NULL THEN
            Begin
               SELECT IDERROAVISO
               INTO   V_IDERROAVISO
               FROM ERROAVISONF
               WHERE CDERROAVISO = w_Av05;
            Exception
               When No_Data_Found Then
                  V_IDERROAVISO := Null;
            End;
         END IF;
         UPDATE ITEMPROIMPOS
         SET IDAVISIMPIT = SUBSTR(IDAVISIMPIT,1,2) || w_1 || SUBSTR(IDAVISIMPIT,4,2)
         WHERE (CDFILIAL   = P_FILIAL)   AND
               (NRLANCTONF = P_LANCTONF) AND
               ((CDSITUTRIBIT IS NULL) OR (LENGTH(CDSITUTRIBIT) < 2))AND
               (V_IDERROAVISO <> w_N)    AND
               (V_IDCONSPARFIS <> w_N);
         /* (AVISO) IMPOSTO DO ITEM COM CÓD. FISCAL OPERAÇÃO - CFOP INVÁLIDO */
         Begin
            SELECT IDERROAVISOFIL
            INTO   V_IDERROAVISO
            FROM ERROAVISONFFIL
            WHERE CDERROAVISOFIL = w_Av06
              AND CDFILIAL = V_CDFILIEMIT;
         Exception
            When No_Data_Found Then
               V_IDERROAVISO := Null;
         End;
         IF V_IDERROAVISO IS NULL THEN
            Begin
               SELECT IDERROAVISO
               INTO   V_IDERROAVISO
               FROM ERROAVISONF
               WHERE CDERROAVISO = w_Av06;
            Exception
               When No_Data_Found Then
                  V_IDERROAVISO := Null;
            End;
         END IF;
         UPDATE ITEMPROIMPOS
         SET IDAVISIMPIT = SUBSTR(IDAVISIMPIT,1,3) || w_1 || SUBSTR(IDAVISIMPIT,5,1)
         WHERE (CDFILIAL   = P_FILIAL)   AND
               (NRLANCTONF = P_LANCTONF) AND
               ((CDFISCOPERIT IS NULL) OR (LENGTH(CDFISCOPERIT) < 3)) AND
               (V_IDERROAVISO <> w_N)    AND
               (V_IDCONSPARFIS <> w_N);
      END IF;
   END IF;
   SELECT MAX(TO_NUMBER(IDAVISOSITEM))
   INTO   V_ERROAVISO
   FROM ITEMPRODUTO
   WHERE (CDFILIAL   = P_FILIAL) AND
         (NRLANCTONF = P_LANCTONF);
   IF (V_ERROAVISO > 0) THEN
      UPDATE NOTAFISCAL
      SET IDAVISOS = w_1
      WHERE (CDFILIAL   = P_FILIAL) AND
            (NRLANCTONF = P_LANCTONF);
   ELSE
      SELECT MAX(TO_NUMBER(IDAVISIMPIT))
      INTO   V_ERROAVISO
      FROM ITEMPROIMPOS
      WHERE (CDFILIAL   = P_FILIAL) AND
            (NRLANCTONF = P_LANCTONF);
      IF (V_ERROAVISO > 0) THEN
         UPDATE NOTAFISCAL
         SET IDAVISOS = w_1
         WHERE (CDFILIAL   = P_FILIAL) AND
               (NRLANCTONF = P_LANCTONF);
      ELSE
         UPDATE NOTAFISCAL
         SET IDAVISOS = w_0
         WHERE (CDFILIAL   = P_FILIAL) AND
               (NRLANCTONF = P_LANCTONF);
      END IF;
   END IF;
   /*(ERRO) ITEM COM VALOR UNITARIO IGUAL A ZERO*/
   Begin
     SELECT IDERROAVISOFIL
      INTO  V_IDERROAVISO
      FROM ERROAVISONFFIL
      WHERE CDERROAVISOFIL = w_Er04
        AND CDFILIAL = V_CDFILIEMIT;
   Exception
      When No_Data_Found Then
         V_IDERROAVISO := Null;
   End;
   IF V_IDERROAVISO IS NULL THEN
      Begin
        SELECT IDERROAVISO
         INTO  V_IDERROAVISO
         FROM ERROAVISONF
         WHERE CDERROAVISO = w_Er04;
      Exception
         When No_Data_Found Then
            V_IDERROAVISO := Null;
      End;
   END IF;
   IF P_TIPOOPER <> '03' THEN
      UPDATE NOTAFISCAL
      SET IDERROS = w_101
      WHERE CDFILIAL   =  P_FILIAL    AND
            NRLANCTONF =  P_LANCTONF  AND
            V_IDERROAVISO <> w_N      AND
            NRLANCTONF = (SELECT MAX(NRLANCTONF)
                          FROM ITEMPRODUTO
                          WHERE CDFILIAL   =  P_FILIAL   AND
                                NRLANCTONF =  P_LANCTONF AND
                                VRUNITITEM = 0           AND
                                QTITEMPROD > 0);
   END IF;
   IF P_TIPOOPER = w_11 THEN
      Begin
         SELECT IDERROAVISOFIL
         INTO   V_IDERROAVISO
         FROM ERROAVISONFFIL
         WHERE CDERROAVISOFIL = w_Er06
           AND CDFILIAL = V_CDFILIEMIT;
      Exception
         When No_Data_Found Then
            V_IDERROAVISO := Null;
      End;
      IF V_IDERROAVISO IS NULL THEN
         Begin
            SELECT IDERROAVISO
            INTO   V_IDERROAVISO
            FROM ERROAVISONF
            WHERE CDERROAVISO = w_Er06;
         Exception
            When No_Data_Found Then
               V_IDERROAVISO := Null;
         End;
      END IF;
      /* (ERRO) SOMA DAS SAÍDAS SEM NOTA FISCAL DIFERE DO VALOR TOTAL DA NOTA */
      UPDATE NOTAFISCAL
      SET IDERROS = w_1||SUBSTR(IDERROS,2,2)
      WHERE CDFILIAL   =  P_FILIAL    AND
            NRLANCTONF =  P_LANCTONF  AND
            V_IDERROAVISO <> w_N      AND
            V_FAIXATOLER < (SELECT ABS(SUM(N.VRNOTAFISC) - NOTAFISCAL.VRNOTAFISC)
                            FROM ITEMNOTAFISC I, NOTAFISCAL N
                            WHERE I.CDFILIAL   = P_FILIAL      AND
                                  I.NRLANCTONF = P_LANCTONF    AND
                                  N.CDFILIAL   = I.CDFILIALIT  AND
                                  N.NRLANCTONF = I.NRLANCTONFIT);
   END IF;
   -- CALCULANDO PESO BRUTO DOS PRODUTOS DA NOTA FISCAL
   BEGIN
      SELECT VRPBRUTOVOLU
      INTO V_VRPESOBRUTO
      FROM NOTAFISCAL
      WHERE CDFILIAL   = P_FILIAL AND
            NRLANCTONF = P_LANCTONF;
   EXCEPTION
      WHEN No_Data_Found THEN
         V_VRPESOBRUTO := Null;
   END;
   IF (V_VRPESOBRUTO IS NULL) OR (V_VRPESOBRUTO = 0) THEN
      BEGIN
         SELECT SUM(QTITEMPROD * PR.VRPESOBRUTPR)
           INTO V_VRPESOBRUTO
           FROM ITEMPRODUTO I, PRODUTO PR
          WHERE I.CDFILIAL    = P_FILIAL
            AND I.NRLANCTONF  = P_LANCTONF
            AND PR.CDPRODUTO  = I.CDPRODUTO;
      EXCEPTION
         WHEN No_Data_Found THEN
            V_VRPESOBRUTO := Null;
      END;
      IF (V_VRPESOBRUTO IS NULL) OR (V_VRPESOBRUTO = 0) THEN
         SELECT SUM(QTITEMPROD * PA.VRPESOUNID * PR.VRFATOCONV)
         INTO   V_VRPESOBRUTO
         FROM ITEMPRODUTO I, PRODUTO PR, PRODUTO PA
         WHERE I.CDFILIAL    = P_FILIAL       AND
               I.NRLANCTONF  = P_LANCTONF     AND
               PR.CDPRODUTO  = I.CDPRODUTO    AND
               PR.CDPRODESTO = PA.CDPRODUTO;
         IF (V_VRPESOBRUTO <> 0) THEN
            UPDATE NOTAFISCAL
            SET VRPBRUTOVOLU = V_VRPESOBRUTO
            WHERE (CDFILIAL   = P_FILIAL)   AND
                  (NRLANCTONF = P_LANCTONF);
         END IF;
      ELSE
         UPDATE NOTAFISCAL
            SET VRPBRUTOVOLU = V_VRPESOBRUTO
          WHERE CDFILIAL   = P_FILIAL
            AND NRLANCTONF = P_LANCTONF;
      END IF;
   END IF;
   -- CALCULANDO PESO LÍQUIDO DOS PRODUTOS DA NOTA FISCAL
   BEGIN
      SELECT VRPLIQUVOLU
      INTO V_VRLIQUORIG
      FROM NOTAFISCAL
      WHERE CDFILIAL   = P_FILIAL AND
            NRLANCTONF = P_LANCTONF;
   EXCEPTION
      WHEN No_Data_Found THEN
         V_VRLIQUORIG := Null;
   END;
   IF (V_VRLIQUORIG IS NULL) OR (V_VRLIQUORIG = 0) THEN
      SELECT NVL(IDCALCPESONF,'N')
      INTO   V_IDCALCPESONF
      FROM PARAMGERAL;
      IF(V_IDCALCPESONF = 'S') THEN
         SELECT SUM(I.QTITEMPROD * NVL(P.VRPESOLIQUPR, 0)) VRPLIQUEVOLU
           INTO V_VRLIQUORIG
           FROM ITEMPRODUTO I, PRODUTO P
          WHERE I.CDPRODUTO   = P.CDPRODUTO
            AND I.CDFILIAL    = P_FILIAL
            AND I.NRLANCTONF  = P_LANCTONF;
         IF V_VRLIQUORIG IS NOT NULL AND V_VRLIQUORIG <> 0 THEN
            UPDATE NOTAFISCAL
               SET VRPLIQUVOLU = V_VRLIQUORIG
             WHERE CDFILIAL   = P_FILIAL
               AND NRLANCTONF = P_LANCTONF;
         END IF;
      END IF;
   END IF;
--ATUALIZAÇÃO DO CÓDIGO FISCAL DA OPERAÇÃO NA TABELA DE NOTA FISCAL
   SELECT COUNT(DISTINCT CDFISOPEITEM), MAX(CDFISOPEITEM)
   INTO   V_COUNT                     , V_CDFISOPENTF
   FROM ITEMPRODUTO
   WHERE (CDFILIAL   = P_FILIAL) AND
         (NRLANCTONF = P_LANCTONF);
   IF (V_COUNT > 1) THEN
      UPDATE NOTAFISCAL
      SET CDFISOPENTF = '***'
      WHERE CDFILIAL   = P_FILIAL   AND
            NRLANCTONF = P_LANCTONF AND
            CDFISOPENTF IS NULL;
   ELSIF (V_COUNT = 1) THEN
      Begin
         SELECT CDFISOPENTF
         INTO   V_CDFISOPENTF
         FROM NOTAFISCAL
         WHERE CDFILIAL   = P_FILIAL AND
               NRLANCTONF = P_LANCTONF;
      Exception
         When No_Data_Found Then
            V_CDFISOPENTF := Null;
      End;
      IF (V_CDFISOPENTF IS NULL) OR (V_CDFISOPENTF = '***') THEN
         UPDATE NOTAFISCAL
         SET (CDFISOPENTF) = (SELECT MAX(CDFISOPEITEM) AS CDFISOPEITEM
                              FROM ITEMPRODUTO
                              WHERE (CDFILIAL   = P_FILIAL) AND
                                    (NRLANCTONF = P_LANCTONF))
         WHERE (CDFILIAL   = P_FILIAL)   AND
               (NRLANCTONF = P_LANCTONF) AND
               (NVL(CDFISOPENTF, '***') = '***');
      ELSE
         UPDATE ITEMPRODUTO
         SET CDFISOPEITEM = V_CDFISOPENTF
         WHERE CDFILIAL   = P_FILIAL   AND
               NRLANCTONF = P_LANCTONF;
         UPDATE ITEMPROIMPOS
         SET CDFISCOPERIT = V_CDFISOPENTF
         WHERE CDFILIAL   = P_FILIAL   AND
               NRLANCTONF = P_LANCTONF;
         UPDATE IMPOSTONF
         SET CDFISCOPERNF = V_CDFISOPENTF
         WHERE CDFILIAL   = P_FILIAL   AND
               NRLANCTONF = P_LANCTONF;
      END IF;
   END IF;
   IF V_CDINTEGRACAO IS NOT NULL THEN
--INCLUSÃO DOS ENCARGOS DA NF EM CASO DE IMPORTAÇÃO
      INSERT INTO ITEMENCARGO
      (CDFILIAL, NRLANCTONF, CDENCARGO, VRITEMENCA)
      (SELECT P_FILIAL, P_LANCTONF, CDENCARGO, 0 AS VRITEMENCA
       FROM ENCARGO
       MINUS
       SELECT CDFILIAL, NRLANCTONF, CDENCARGO, 0 AS VRITEMENCA
       FROM ITEMENCARGO
       WHERE CDFILIAL   = P_FILIAL AND
             NRLANCTONF = P_LANCTONF);
      Begin
         SELECT IDERROAVISO
         INTO   V_IDERROAVISO
         FROM ERROAVISONF
         WHERE CDERROAVISO = w_Er03;
      Exception
         When No_Data_Found Then
            V_IDERROAVISO := Null;
      End;
      UPDATE NOTAFISCAL N
      SET IDERROS = w_11||SUBSTR(IDERROS, 3, 1)
      WHERE CDFILIAL   =  P_FILIAL   AND
            NRLANCTONF =  P_LANCTONF AND
            V_IDERROAVISO <> w_N     AND
            V_FAIXATOLER < (SELECT NVL(ABS(NVL(SUM(C.VRORIGREC), (N.VRNOTAFISC - MAX(I.VRIMPOSRETI))) - (N.VRNOTAFISC - MAX(I.VRIMPOSRETI))), V_FAIXATOLER)
                            FROM CONTARECEBER C,
                                 (SELECT NVL(SUM(IT.VRTOTIMPONF),0) AS VRIMPOSRETI
                                  FROM IMPOSNFTOT IT, IMPOSTO I
                                  WHERE I.CDIMPOSTO    = IT.CDIMPOSTO AND
                                        IT.CDFILIAL    = P_FILIAL     AND
                                        IT.NRLANCTONF  = P_LANCTONF   AND
                                        I.IDDESCRFONTE <> w_A         AND
                                        I.IDTRATIMPO   = w_R) I
                            WHERE C.CDFILIAL   = P_FILIAL AND
                                  C.NRLANCTONF = P_LANCTONF);
   END IF;
   /* ESTA ROTINA ABAIXO SERVE PARA ATUALIZAR O VALOR CONTÁBIL E BRUTO DOS PRODUTOS COM A DIFERENÇA
      DE CENTAVOS ENTRE O VALOR DOS IMPOSTOS POR ÍTEM E A SUA RESPECTIVA TOTALIZAÇÃO. ESTA DIFERENÇA
      É IGNORADA NO FECHAMENTO DA NF CASO O CLIENTE TRABALHE COM UM NÚMERO MENOR DE CASAS DECIMAIS E
      PROVOCA ERROS NA CONTABILIZAÇÃO*/
   IF (V_NRDECITOTANF <> 2) AND (V_IDOPERDEVONF <> w_S) THEN
      FOR C_ATUAVRCONT IN (SELECT T.CDIMPOSTO, SUM(T.VRIMPOSTOIT) AS VRIMPOSTOIT, T.CDFISCALIT,
                                  I.IDIMPORECUP, I.CDCCTBLATIV, I.CDCCTBLPASS, I.IDTRATIMPO, I.IDTIPCONTAB, I.IDDESCRFONTE
                           FROM ITEMPROIMPOS T, IMPOSTO I
                           WHERE T.CDFILIAL     = P_FILIAL    AND
                                 T.NRLANCTONF   = P_LANCTONF  AND
                                 T.NRITPROIMPOS = w_1         AND
                                 T.CDIMPOSTO    = I.CDIMPOSTO
                           GROUP BY T.CDIMPOSTO, T.CDFISCALIT, I.IDIMPORECUP,
                                    I.CDCCTBLATIV, I.CDCCTBLPASS, I.IDTRATIMPO, I.IDTIPCONTAB, I.IDDESCRFONTE) LOOP
         SELECT SUM(VRTOTIMPONF) - C_ATUAVRCONT.VRIMPOSTOIT
         INTO   V_VRDIFERENCA
         FROM IMPOSNFTOT
         WHERE CDFILIAL   = P_FILIAL   AND
               NRLANCTONF = P_LANCTONF AND
               CDIMPOSTO  = C_ATUAVRCONT.CDIMPOSTO;
         SELECT SUM(VRBRUTITEM), SUM(VRCONTITEM)
         INTO   V_VRBRUTO      , V_VRCONTAB
         FROM ITEMPRODUTO I, ITEMPROIMPOS T
         WHERE T.CDFILIAL     = I.CDFILIAL    AND
               T.NRLANCTONF   = I.NRLANCTONF  AND
               T.NRSEQITPROD  = I.NRSEQITPROD AND
               T.CDFILIAL     = P_FILIAL      AND
               T.NRLANCTONF   = P_LANCTONF    AND
               T.NRITPROIMPOS = w_1           AND
               T.CDIMPOSTO    = C_ATUAVRCONT.CDIMPOSTO;
         IF V_VRDIFERENCA <> 0 THEN
            IF (C_ATUAVRCONT.IDTRATIMPO = w_A) THEN
               IF ((C_ATUAVRCONT.IDIMPORECUP = w_S)  AND (C_ATUAVRCONT.CDFISCALIT = w_1)) OR
                  ((C_ATUAVRCONT.IDIMPORECUP <> w_S) AND (C_ATUAVRCONT.CDCCTBLPASS IS NOT NULL)) AND
                  (C_ATUAVRCONT.IDTIPCONTAB = w_D) THEN
                  V_ICMS := 'N';
                  FOR C_ICMS IN (SELECT CDIMPOSTO
                                   FROM IMPOSTONFE N, IMPOSTO I
                                  WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                                    AND N.CDIMPOSTONFE = '00'
                                    AND I.CDIMPOSTO = C_ATUAVRCONT.CDIMPOSTO)
                  LOOP
                     V_ICMS := 'S';
                  END LOOP;
                  IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (V_ICMS = 'S') THEN
                     UPDATE ITEMPRODUTO
                     SET VRBRUTITEM = TRUNC(VRBRUTITEM + ((V_VRDIFERENCA / V_VRBRUTO)  * VRBRUTITEM),2)
                     WHERE EXISTS(SELECT CDFILIAL, NRLANCTONF, NRSEQITPROD
                                  FROM ITEMPROIMPOS T
                                  WHERE T.CDFILIAL    = P_FILIAL                AND
                                        T.NRLANCTONF  = P_LANCTONF              AND
                                        T.NRSEQITPROD = ITEMPRODUTO.NRSEQITPROD AND
                                        T.CDIMPOSTO   = C_ATUAVRCONT.CDIMPOSTO);
                  ELSE
                     UPDATE ITEMPRODUTO
                     SET VRBRUTITEM = ROUND(VRBRUTITEM + ((V_VRDIFERENCA / V_VRBRUTO)  * VRBRUTITEM),5)
                     WHERE EXISTS(SELECT CDFILIAL, NRLANCTONF, NRSEQITPROD
                                  FROM ITEMPROIMPOS T
                                  WHERE T.CDFILIAL    = P_FILIAL                AND
                                        T.NRLANCTONF  = P_LANCTONF              AND
                                        T.NRSEQITPROD = ITEMPRODUTO.NRSEQITPROD AND
                                        T.CDIMPOSTO   = C_ATUAVRCONT.CDIMPOSTO);
                  END IF;
               ELSE
                  V_ICMS := 'N';
                  FOR C_ICMS IN (SELECT CDIMPOSTO
                                   FROM IMPOSTONFE N, IMPOSTO I
                                  WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                                    AND N.CDIMPOSTONFE = '00'
                                    AND I.CDIMPOSTO = C_ATUAVRCONT.CDIMPOSTO)
                  LOOP
                     V_ICMS := 'S';
                  END LOOP;
                  IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (V_ICMS = 'S') THEN
                     UPDATE ITEMPRODUTO
                     SET VRBRUTITEM = TRUNC(VRBRUTITEM + ((V_VRDIFERENCA / V_VRBRUTO)  * VRBRUTITEM),2),
                         VRCONTITEM = TRUNC(VRCONTITEM + ((V_VRDIFERENCA / V_VRCONTAB) * VRCONTITEM),2)
                     WHERE EXISTS(SELECT CDFILIAL, NRLANCTONF, NRSEQITPROD
                                  FROM ITEMPROIMPOS T
                                  WHERE T.CDFILIAL    = P_FILIAL                AND
                                        T.NRLANCTONF  = P_LANCTONF              AND
                                        T.NRSEQITPROD = ITEMPRODUTO.NRSEQITPROD AND
                                        T.CDIMPOSTO   = C_ATUAVRCONT.CDIMPOSTO);
                  ELSE
                     UPDATE ITEMPRODUTO
                     SET VRBRUTITEM = ROUND(VRBRUTITEM + ((V_VRDIFERENCA / V_VRBRUTO)  * VRBRUTITEM),5),
                         VRCONTITEM = ROUND(VRCONTITEM + ((V_VRDIFERENCA / V_VRCONTAB) * VRCONTITEM),5)
                     WHERE EXISTS(SELECT CDFILIAL, NRLANCTONF, NRSEQITPROD
                                  FROM ITEMPROIMPOS T
                                  WHERE T.CDFILIAL    = P_FILIAL                AND
                                        T.NRLANCTONF  = P_LANCTONF              AND
                                        T.NRSEQITPROD = ITEMPRODUTO.NRSEQITPROD AND
                                        T.CDIMPOSTO   = C_ATUAVRCONT.CDIMPOSTO);
                  END IF;
               END IF;
            ELSIF (C_ATUAVRCONT.IDTRATIMPO = w_D) THEN
               IF ((C_ATUAVRCONT.IDIMPORECUP = w_S) AND (C_ATUAVRCONT.CDFISCALIT = w_1))  OR
                  ((C_ATUAVRCONT.IDIMPORECUP <> w_S) AND (C_ATUAVRCONT.CDCCTBLATIV IS NOT NULL)) AND
                  (C_ATUAVRCONT.IDTIPCONTAB = w_D) THEN
                  V_ICMS := 'N';
                  FOR C_ICMS IN (SELECT CDIMPOSTO
                                   FROM IMPOSTONFE N, IMPOSTO I
                                  WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                                    AND N.CDIMPOSTONFE = '00'
                                    AND I.CDIMPOSTO = C_ATUAVRCONT.CDIMPOSTO)
                  LOOP
                     V_ICMS := 'S';
                  END LOOP;
                  IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (V_ICMS = 'S') THEN
                     UPDATE ITEMPRODUTO
                     SET VRBRUTITEM = TRUNC(VRBRUTITEM - ((V_VRDIFERENCA / V_VRBRUTO)  * VRBRUTITEM),2)
                     WHERE EXISTS(SELECT CDFILIAL, NRLANCTONF, NRSEQITPROD
                                  FROM ITEMPROIMPOS T
                                  WHERE T.CDFILIAL    = P_FILIAL                AND
                                        T.NRLANCTONF  = P_LANCTONF              AND
                                        T.NRSEQITPROD = ITEMPRODUTO.NRSEQITPROD AND
                                        T.CDIMPOSTO   = C_ATUAVRCONT.CDIMPOSTO);
                  ELSE
                     UPDATE ITEMPRODUTO
                     SET VRBRUTITEM = ROUND(VRBRUTITEM - ((V_VRDIFERENCA / V_VRBRUTO)  * VRBRUTITEM),5)
                     WHERE EXISTS(SELECT CDFILIAL, NRLANCTONF, NRSEQITPROD
                                  FROM ITEMPROIMPOS T
                                  WHERE T.CDFILIAL    = P_FILIAL                AND
                                        T.NRLANCTONF  = P_LANCTONF              AND
                                        T.NRSEQITPROD = ITEMPRODUTO.NRSEQITPROD AND
                                        T.CDIMPOSTO   = C_ATUAVRCONT.CDIMPOSTO);
                  END IF;
               ELSE
                  V_ICMS := 'N';
                  FOR C_ICMS IN (SELECT CDIMPOSTO
                                   FROM IMPOSTONFE N, IMPOSTO I
                                  WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                                    AND N.CDIMPOSTONFE = '00'
                                    AND I.CDIMPOSTO = C_ATUAVRCONT.CDIMPOSTO)
                  LOOP
                     V_ICMS := 'S';
                  END LOOP;
                  IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (V_ICMS = 'S') THEN
                     UPDATE ITEMPRODUTO
                     SET VRBRUTITEM = TRUNC(VRBRUTITEM - ((V_VRDIFERENCA / V_VRBRUTO)  * VRBRUTITEM),2),
                         VRCONTITEM = TRUNC(VRCONTITEM - ((V_VRDIFERENCA / V_VRCONTAB) * VRCONTITEM),2)
                     WHERE EXISTS(SELECT CDFILIAL, NRLANCTONF, NRSEQITPROD
                                  FROM ITEMPROIMPOS T
                                  WHERE T.CDFILIAL    = P_FILIAL                AND
                                        T.NRLANCTONF  = P_LANCTONF              AND
                                        T.NRSEQITPROD = ITEMPRODUTO.NRSEQITPROD AND
                                        T.CDIMPOSTO   = C_ATUAVRCONT.CDIMPOSTO);
                  ELSE
                     UPDATE ITEMPRODUTO
                     SET VRBRUTITEM = ROUND(VRBRUTITEM - ((V_VRDIFERENCA / V_VRBRUTO)  * VRBRUTITEM),5),
                         VRCONTITEM = ROUND(VRCONTITEM - ((V_VRDIFERENCA / V_VRCONTAB) * VRCONTITEM),5)
                     WHERE EXISTS(SELECT CDFILIAL, NRLANCTONF, NRSEQITPROD
                                  FROM ITEMPROIMPOS T
                                  WHERE T.CDFILIAL    = P_FILIAL                AND
                                        T.NRLANCTONF  = P_LANCTONF              AND
                                        T.NRSEQITPROD = ITEMPRODUTO.NRSEQITPROD AND
                                        T.CDIMPOSTO   = C_ATUAVRCONT.CDIMPOSTO);
                  END IF;
               END IF;
            ELSIF (C_ATUAVRCONT.IDTRATIMPO = w_R) THEN
               IF (C_ATUAVRCONT.IDIMPORECUP = w_S) THEN
                  IF (C_ATUAVRCONT.CDCCTBLATIV IS NULL) OR
                     (C_ATUAVRCONT.CDFISCALIT <> w_1) THEN
                     V_IMPOCONTAB := - V_VRIMPOSTO;
                  END IF;
               ELSE
                  IF (C_ATUAVRCONT.CDCCTBLATIV IS NULL) THEN
                     V_IMPOCONTAB := - V_VRIMPOSTO;
                  ELSE
                     IF C_ATUAVRCONT.IDDESCRFONTE = 'N' THEN
                        V_IMPOCONTAB := - V_VRIMPOSTO;
                     END IF;
                  END IF;
               END IF;
               IF (C_ATUAVRCONT.IDTIPCONTAB = w_D) THEN
                  V_ICMS := 'N';
                  FOR C_ICMS IN (SELECT CDIMPOSTO
                                   FROM IMPOSTONFE N, IMPOSTO I
                                  WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                                    AND N.CDIMPOSTONFE = '00'
                                    AND I.CDIMPOSTO = C_ATUAVRCONT.CDIMPOSTO)
                  LOOP
                     V_ICMS := 'S';
                  END LOOP;
                  IF ((V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV')) AND (V_ICMS = 'S') THEN
                     UPDATE ITEMPRODUTO
                     SET VRCONTITEM = TRUNC(VRCONTITEM + ((V_VRDIFERENCA / V_VRCONTAB) * VRCONTITEM),2)
                     WHERE EXISTS(SELECT CDFILIAL, NRLANCTONF, NRSEQITPROD
                                  FROM ITEMPROIMPOS T
                                  WHERE T.CDFILIAL    = P_FILIAL                AND
                                        T.NRLANCTONF  = P_LANCTONF              AND
                                        T.NRSEQITPROD = ITEMPRODUTO.NRSEQITPROD AND
                                        T.CDIMPOSTO   = C_ATUAVRCONT.CDIMPOSTO);
                  ELSE
                     UPDATE ITEMPRODUTO
                     SET VRCONTITEM = ROUND(VRCONTITEM + ((V_VRDIFERENCA / V_VRCONTAB) * VRCONTITEM),5)
                     WHERE EXISTS(SELECT CDFILIAL, NRLANCTONF, NRSEQITPROD
                                  FROM ITEMPROIMPOS T
                                  WHERE T.CDFILIAL    = P_FILIAL                AND
                                        T.NRLANCTONF  = P_LANCTONF              AND
                                        T.NRSEQITPROD = ITEMPRODUTO.NRSEQITPROD AND
                                        T.CDIMPOSTO   = C_ATUAVRCONT.CDIMPOSTO);
                  END IF;
               END IF;
            END IF;
         END IF;
      END LOOP;
   END IF;
   BEGIN
      SELECT CDFILIALPED, NRPEDIDO
        INTO V_CDFILIALPED, V_NRPEDIDO
        FROM ITEMPRODUTO
       WHERE CDFILIAL = P_FILIAL
         AND NRLANCTONF = P_LANCTONF
         AND ROWNUM = 1;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_CDFILIALPED := NULL;
         V_NRPEDIDO := NULL;
   END;
   IF (V_CDFILIALPED IS NOT NULL) AND (V_NRPEDIDO IS NOT NULL) THEN
      BEGIN
         SELECT DADOSADICENDPED
           INTO V_DADOSADICENDPED
           FROM (SELECT ('DADO PARA ENTREGA - CLIENTE: '||C.NRINSJURCLIE||' '||C.NMRAZSOCCLIE||
                         ' - ENDEREÇO: '|| D.DSENDEPED||
                         ' - BAIRRO: '||D.NMBAIRROPED||
                         ' - MUNICIPIO: '||D.NMMUNIPED||
                         ' - ESTADO: '||D.SGESTADOPED||
                         ' - CEP: '||NRCEPPED) AS DADOSADICENDPED
                   FROM DADOSENDPED D, CLIENTE C
                  WHERE D.CDCLIENTE = C.CDCLIENTE
                    AND C.IDENDEMISCLI <> D.IDTPENDECLIE
                    AND D.CDFILIAL = V_CDFILIALPED
                    AND NRPEDIDO = V_NRPEDIDO) DEP
          WHERE NOT EXISTS(SELECT DSDADOADIC
                             FROM DADOSADIC                                     
                            WHERE CDFILIAL   = P_FILIAL
                              AND NRLANCTONF = P_LANCTONF
                              AND DSDADOADIC = DEP.DADOSADICENDPED);
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_DADOSADICENDPED := NULL;
      END;
      IF V_DADOSADICENDPED IS NOT NULL THEN
         INSERT INTO DADOSADIC
            (CDFILIAL, NRLANCTONF, NRDADOADIC, DSDADOADIC)
         VALUES
            (P_FILIAL, P_LANCTONF, V_DADOADIC, SUBSTR(V_DADOSADICENDPED, 1, 250));
         V_DADOADIC := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_DADOADIC) + 1)),3,0);
      END IF;
   ELSE
      FOR C_ENDDADOSADIC IN (SELECT DSDADOADIC FROM (
                             SELECT '' AS NRDADOADIC,'999' AS CDMENSAGEM,('DESTINO - FILIAL: '||F.NRINSJURFILI||' '||F.NMFILIAL||' -  ENDEREÇO: '||
                                    E.DSENDEFILI||' - BAIRRO: '||E.NMBAIRFILI||' - MUNICIPIO: '||M.NMMUNICIPIO||' - ESTADO: '||M.SGESTADO) AS DSDADOADIC
                               FROM NOTAFISCAL N INNER JOIN ENDEFILI E ON (CASE WHEN N.IDENTRSAIDOP = 'S' THEN N.CDFILIRECE ELSE N.CDFILIEMIT END) = E.CDFILIAL
                                                 INNER JOIN FILIAL F    ON E.CDFILIAL   = F.CDFILIAL
                                                 INNER JOIN MUNICIPIO M ON E.CDMUNICIPIO = M.CDMUNICIPIO
                                                                       AND E.CDPAIS      = M.CDPAIS
                                                                       AND E.SGESTADO    = M.SGESTADO
                              WHERE N.CDFILIAL     = P_FILIAL
                                AND N.NRLANCTONF   = P_LANCTONF
                                AND N.IDORIGDESTNF = 'L'
                                AND E.IDTPENDEFILI = 'T'
                             UNION ALL
                             SELECT '' AS NRDADOADIC, '999' AS CDMENSAGEM,('DESTINO - CLIENTE: '||C.NRINSJURCLIE||' '||C.NMRAZSOCCLIE||' -  ENDEREÇO: '||
                                    E.DSENDECLIE||' - BAIRRO: '||E.NMBAIRCLIE||' - MUNICIPIO: '||M.NMMUNICIPIO||' - ESTADO: '||M.SGESTADO) AS DSDADOADIC
                               FROM NOTAFISCAL N INNER JOIN ENDECLIE E ON N.CDCLIENTE = E.CDCLIENTE
                                                 INNER JOIN CLIENTE  C ON E.CDCLIENTE = C.CDCLIENTE
                                                 INNER JOIN MUNICIPIO M ON E.CDMUNICIPIO = M.CDMUNICIPIO
                                                                       AND E.CDPAIS      = M.CDPAIS
                                                                       AND E.SGESTADO    = M.SGESTADO
                              WHERE N.CDFILIAL     = P_FILIAL
                                AND N.NRLANCTONF   = P_LANCTONF
                                AND E.IDTPENDECLIE = 'T'
                             UNION ALL
                             SELECT '' AS NRDADOADIC, '999' AS CDMENSAGEM,('DESTINO - FORNECEDOR: '||F.NRINSJURFORN||' '||F.NMRAZSOCFORN||' -  ENDEREÇO: '||
                                    E.DSENDEFORN||' - BAIRRO: '||E.NMBAIRFORN||' - MUNICIPIO: '||M.NMMUNICIPIO||' - ESTADO: '||M.SGESTADO) AS DSDADOADIC
                               FROM NOTAFISCAL N INNER JOIN ENDEFORN E   ON N.CDFORNECED = E.CDFORNECED
                                                 INNER JOIN FORNECEDOR F ON E.CDFORNECED = F.CDFORNECED
                                                 INNER JOIN MUNICIPIO M  ON E.CDMUNICIPIO = M.CDMUNICIPIO
                                                                        AND E.CDPAIS      = M.CDPAIS
                                                                        AND E.SGESTADO    = M.SGESTADO
                              WHERE N.CDFILIAL     = P_FILIAL
                                AND N.NRLANCTONF   = P_LANCTONF
                                AND E.IDTPENDEFORN = 'T'
                             ORDER BY CDMENSAGEM) I
                              WHERE NOT EXISTS(SELECT DSDADOADIC
                                                 FROM DADOSADIC                                     
                                                WHERE (CDFILIAL   = P_FILIAL)
                                                  AND (NRLANCTONF = P_LANCTONF)
                                                  AND (DSDADOADIC = I.DSDADOADIC))) LOOP
          INSERT INTO DADOSADIC(CDFILIAL, NRLANCTONF, NRDADOADIC, DSDADOADIC)
                         VALUES(P_FILIAL, P_LANCTONF, V_DADOADIC, SUBSTR(C_ENDDADOSADIC.DSDADOADIC,1,250));
          V_DADOADIC := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_DADOADIC) + 1)),3,0);
      END LOOP;
   END IF;
   /*PREENCHENDO A TABELA DADOSADIC DE ACORDO COM OS VALORES DO ADICIONAL DE ALÍQUOTA DO FECP*/
   DELETE 
     FROM DADOSADIC
    WHERE CDFILIAL = P_FILIAL
      AND NRLANCTONF = P_LANCTONF
      AND UPPER(DSDADOADIC) LIKE 'ADICIONAL DE ALÍQUOTA DO IMPOSTO % DE % (FUNDO ESTADUAL DE COMBATE A POBREZA):%';
   V_STRVRADICALIQFECP := NULL;
   V_STRVRADICFECP := NULL;
   FOR C_VRADICALIQFECP IN (SELECT CASE P.CDIMPOSTONFE WHEN '00' THEN 'ICMS' WHEN '80' THEN 'ICMS-ST' END AS CDIMPOSTONFE, 
                                   I.VRADICALIQFECP, 
                                   SUM(NVL(I.VRADICFECP, 0)) AS VRADICFECP
                              FROM ITEMPROIMPOS I JOIN IMPOSTO P ON (I.CDIMPOSTO = P.CDIMPOSTO)
                             WHERE I.CDFILIAL = P_FILIAL
                               AND I.NRLANCTONF = P_LANCTONF
                               AND NVL(I.VRADICALIQFECP, 0) > 0
                               AND I.NRITPROIMPOS = '1'
                             GROUP BY P.CDIMPOSTONFE, 
                                   I.VRADICALIQFECP)
   LOOP
      SELECT DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(C_VRADICALIQFECP.VRADICALIQFECP, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(C_VRADICALIQFECP.VRADICALIQFECP, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(C_VRADICALIQFECP.VRADICALIQFECP, 2), '9999999999999.99'))),
             DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(C_VRADICALIQFECP.VRADICFECP, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(C_VRADICALIQFECP.VRADICFECP, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(C_VRADICALIQFECP.VRADICFECP, 2), '9999999999999.99')))
        INTO V_STRVRADICALIQFECP,
             V_STRVRADICFECP
        FROM DUAL;
      INSERT INTO DADOSADIC
         (CDFILIAL, 
          NRLANCTONF, 
          NRDADOADIC, 
          DSDADOADIC)
      VALUES
         (P_FILIAL, 
          P_LANCTONF, 
          V_DADOADIC,
          'Adicional de alíquota do imposto '||C_VRADICALIQFECP.CDIMPOSTONFE||' de '||V_STRVRADICALIQFECP||'% (Fundo Estadual de Combate a Pobreza): R$ '||V_STRVRADICFECP);
      V_DADOADIC := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_DADOADIC) + 1)),3,0);
   END LOOP;
   IF NOT(P_LANCESTQ IS NULL) AND (V_IDCTRLESTQ <> w_N) THEN
      /* INSERIDO POR LUCIANA CORREA PARA O SISTEMA DE PDV */
      IF (V_IDSISTEMA <> w_VMN) THEN
         BEGIN
            SELECT NRCTRLMOVEST, CDFILIALENTR, NRLANESTENTR
              INTO V_NRCTRLMOVEST, V_CDFILIALENTR, V_NRLANESTENTR
              FROM CTRLMOVIESTQ
             WHERE CDFILIALSAID = P_FILIAL
               AND NRLANESTSAID = P_LANCESTQ;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_CDFILIALENTR := NULL;
               V_NRCTRLMOVEST := NULL;
               V_NRLANESTENTR := NULL;
         END;
         IF V_NRCTRLMOVEST IS NOT NULL THEN
            DELETE 
              FROM CTRLMOVIESTQ
             WHERE CDFILIAL = V_CDFILIEMIT
               AND NRCTRLMOVEST = V_NRCTRLMOVEST;
            DELETE 
              FROM ITLANCTOEST
             WHERE CDFILIAL = V_CDFILIALENTR
               AND NRLANCESTQ = V_NRLANESTENTR;
            DELETE 
              FROM LANCTOESTOQ
             WHERE CDFILIAL = V_CDFILIALENTR
               AND NRLANCESTQ = V_NRLANESTENTR;
         END IF;
         SELECT COUNT(*)
         INTO   V_COUNT
         FROM LANCTOESTOQ L, NOTAFISCAL N
         WHERE L.CDFILIAL   = P_FILIAL      AND
               L.NRLANCESTQ = P_LANCESTQ    AND
               L.NRLANCTONF = P_LANCTONF    AND
               L.CDFILIAL   = N.CDFILIAL    AND
               L.NRLANCTONF = N.NRLANCTONF;
         IF V_COUNT > 0 THEN
            DELETE FROM ITLANCTOEST
            WHERE CDFILIAL   = P_FILIAL AND
                  NRLANCESTQ = P_LANCESTQ;
            DELETE FROM LANCTOESTOQ
            WHERE CDFILIAL   = P_FILIAL AND
                  NRLANCESTQ = P_LANCESTQ;
         END IF;
      ELSE
         UPDATE LANCTOESTOQ
         SET DTLANCESTQ = P_INIVALID
         WHERE CDFILIAL   = P_FILIAL AND
               NRLANCESTQ = P_LANCESTQ;
         DELETE FROM ITLANCTOEST
         WHERE CDFILIAL   = P_FILIAL AND
               NRLANCESTQ = P_LANCESTQ;
      END IF;
      Begin
         SELECT T.NMTIPOOPER, F.NMFILIAL
         INTO   V_NMTIPOOPER, V_NMFILIRECE
         FROM NOTAFISCAL N, TIPOOPERAC T, FILIAL F
         WHERE
            (N.CDFILIAL     = P_FILIAL)       AND
            (N.NRLANCTONF   = P_LANCTONF)     AND
            (N.CDTIPOOPER   = T.CDTIPOOPER)   AND
            (N.IDENTRSAIDOP = T.IDENTRSAIDOP) AND
            (N.CDFILIRECE   = F.CDFILIAL(+));
      Exception
         When No_Data_Found Then
            V_NMTIPOOPER := Null; V_NMFILIRECE := Null;
      End;
      IF V_IDORIGDESTNF = w_L THEN
         V_DESCLANC := 'NF: '||P_LANCTONF||' - '||SUBSTR(V_NMTIPOOPER,1,25)||' - '||SUBSTR(V_NMFILIRECE,1,15);
      ELSE
         V_DESCLANC := 'LANC. ORIGEM: '||V_NRINSJURNF||' Nº'||P_LANCTONF||' SERIE '||V_SERIE;
      END IF;
      SELECT COUNT(*)
      INTO   V_COUNT
      FROM LANCTOESTOQ L, NOTAFISCAL N
      WHERE L.CDFILIAL   = P_FILIAL      AND
            L.NRLANCESTQ = P_LANCESTQ    AND
            L.NRLANCTONF = P_LANCTONF    AND
            L.CDFILIAL   = N.CDFILIAL    AND
            L.NRLANCTONF = N.NRLANCTONF;
      IF V_COUNT = 0 THEN
         INSERT INTO LANCTOESTOQ
            (CDFILIAL,NRLANCESTQ,NRLANCTONF,DSLANCESTQ,IDTPLANCTO,DTLANCESTQ,CDOPERADOR, CDFILIMOVI)
         VALUES
            (P_FILIAL, P_LANCESTQ, P_LANCTONF, V_DESCLANC, w_S, P_INIVALID,P_CDOPERADOR, V_CDFILIEMIT);
      END IF;
      IF (V_IDOPERDEVONF = w_S) THEN
         V_TIPOMOVI := w_5;
      ELSE
         V_TIPOMOVI := w_4;
      END IF;
      IF (V_IDSISTEMA = w_EXP) THEN
         Begin
            SELECT NVL(MAX(IDRETPROEXP),1)
              INTO V_IDRETPROEXP
              FROM PAREXPEDICAO
             WHERE CDFILIAL = V_CDFILIEMIT;
         Exception
            When No_Data_Found Then
               V_IDRETPROEXP := 1;
         End;
      END IF;
      IF (V_IDSISTEMA = w_VND) THEN
         SELECT CDFILIMOVI
         INTO   V_CDFILIMOVI
         FROM LANCTOESTOQ
         WHERE CDFILIAL   = P_FILIAL AND
               NRLANCTONF = P_LANCTONF;
         Begin
            SELECT NVL(IDATUEST,1)
            INTO   V_IDATUEST
            FROM PARAVEND
            WHERE CDFILIAL = V_CDFILIMOVI;
         Exception
            When No_Data_Found Then
               V_IDATUEST := 1;
         End;
      END IF;
      IF ((V_IDSISTEMA = w_EXP) AND (V_IDRETPROEXP = w_2)) OR ((V_IDSISTEMA = w_VND) AND (V_IDATUEST = w_1)) THEN
         FOR C_ITLANCTOEST IN (SELECT NRSEQITPROD,IP.CDPRODUTO,VRUNITITEM,VRTOTAITEM, NVL(CDFILIMOVI, CDFILIEMIT) AS CDFILIMOVI,
                                      QTITEMPROD,CDPRODESTO,VRBRUTITEM,VRDESCITEM,VRCONTITEM,
                                      NVL(IP.CDALMOXARIFE,' ') AS CDALMOXARIFE,
                                      NVL(IP.CDLOCALESTOQ,' ') AS CDLOCALESTOQ,
                                      NVL(NRLOTEESTQ,' ')      AS NRLOTEESTQ,
                                      NVL(NRSUBLOTE,' ')       AS NRSUBLOTE, IDCNTRESTOQ,
                                      IP.NRPEDIDO, IP.NRITEMPED, CDARVPROD, NMPRODUTO,
                                      NVL(IP.IDORIGEMPROD, 'N') AS IDORIGEMPROD
                               FROM ITEMPRODUTO IP, PRODUTO P, PRODFILI PF, NOTAFISCAL N
                               WHERE IP.CDFILIAL    = P_FILIAL     AND
                                     IP.NRLANCTONF  = N.NRLANCTONF AND
                                     IP.CDFILIAL    = N.CDFILIAL   AND
                                     IP.NRLANCTONF  = P_LANCTONF   AND
                                     P.CDPRODUTO    = IP.CDPRODUTO AND
                                     PF.CDFILIAL    = V_CDFILIEMIT AND
                                     PF.CDPRODUTO   = P.CDPRODESTO AND
                                     NVL(IP.IDATUESTPROD, 'S') = 'S') LOOP
            IF (C_ITLANCTOEST.IDCNTRESTOQ = w_S) THEN
               UPDATE ITEMPRODUTO
               SET CDPRODMOVI = C_ITLANCTOEST.CDPRODESTO
               WHERE (CDFILIAL    = P_FILIAL)    AND
                     (NRLANCTONF  = P_LANCTONF ) AND
                     (NRSEQITPROD = C_ITLANCTOEST.NRSEQITPROD);
            END IF;
            IF (V_IDUTILALMOX <> w_S AND  V_IDUTILLCESTQ <> w_S AND V_IDUTILLOTE <> w_S) THEN
               UPDATE ITEMPRODUTO
               SET CDALMOXARIFE  = ' ',
                   CDLOCALESTOQ  = ' ',
                   NRLOTEESTQ    = ' ',
                   NRSUBLOTE     = ' '
               WHERE (CDFILIAL     = P_FILIAL)    AND
                     (NRLANCTONF   = P_LANCTONF ) AND
                     (NRSEQITPROD  = C_ITLANCTOEST.NRSEQITPROD)  AND
                     ((CDALMOXARIFE IS NULL)       OR
                      (CDLOCALESTOQ IS NULL)       OR
                      (NRLOTEESTQ   IS NULL)       OR
                      (NRSUBLOTE    IS NULL));
            END IF;
            IF (V_IDSISTEMA = w_EXP) THEN
               BEGIN
                  SELECT IDTPCOMPPROD
                  INTO  V_IDTPCOMPPROD
                  FROM
                     PARAMPEDIDO
                  WHERE
                     CDFILIAL  = P_FILIAL;
               EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                     V_IDTPCOMPPROD := W_F;
               END;
            ELSE
               V_IDTPCOMPPROD := W_F;
            END IF;
            SELECT COUNT(*)
            INTO   V_EXISTE_ROT
            FROM   ROTFABLOCAL
            WHERE  CDFILIAL  = C_ITLANCTOEST.CDFILIMOVI AND
                   CDPRODUTO = C_ITLANCTOEST.CDPRODUTO;
            IF (V_EXISTE_ROT > 0)AND(V_IDTPCOMPPROD = W_F) THEN
               V_EXISTE_ROT := V_EXISTE_ROT;
               INSERE_SUBPRODMAN(P_FILIAL,P_LANCESTQ,P_TIPOOPER,C_ITLANCTOEST.CDPRODUTO,
                                 C_ITLANCTOEST.QTITEMPROD,
                                 C_ITLANCTOEST.VRTOTAITEM,C_ITLANCTOEST.VRDESCITEM,
                                 C_ITLANCTOEST.VRBRUTITEM,C_ITLANCTOEST.VRCONTITEM,
                                 V_VRTOTALANCTO,V_QTDELANCTO,V_TIPOMOVI,P_INIVALID,
                                 C_ITLANCTOEST.CDPRODESTO,
                                 C_ITLANCTOEST.NRPEDIDO, C_ITLANCTOEST.NRITEMPED, V_IDTPCOMPPROD,
                                 C_ITLANCTOEST.CDALMOXARIFE,
                                 C_ITLANCTOEST.CDLOCALESTOQ, V_IDSISTEMA);
            ELSE
               SELECT COUNT(*)
               INTO   V_EXISTE_ROT
               FROM   ROTFABRICA
               WHERE  CDPRODUTO = C_ITLANCTOEST.CDPRODUTO;
               IF (V_EXISTE_ROT > 0)AND(V_IDTPCOMPPROD = W_F)  THEN
                  V_EXISTE_ROT := V_EXISTE_ROT;
                  INSERE_SUBPRODMAN(P_FILIAL,P_LANCESTQ,P_TIPOOPER,C_ITLANCTOEST.CDPRODUTO,
                                    C_ITLANCTOEST.QTITEMPROD,
                                    C_ITLANCTOEST.VRTOTAITEM,C_ITLANCTOEST.VRDESCITEM,
                                    C_ITLANCTOEST.VRBRUTITEM,C_ITLANCTOEST.VRCONTITEM,
                                    V_VRTOTALANCTO,V_QTDELANCTO,V_TIPOMOVI,P_INIVALID,
                                    C_ITLANCTOEST.CDPRODESTO,
                                    C_ITLANCTOEST.NRPEDIDO, C_ITLANCTOEST.NRITEMPED, V_IDTPCOMPPROD,
                                    C_ITLANCTOEST.CDALMOXARIFE, C_ITLANCTOEST.CDLOCALESTOQ, V_IDSISTEMA);
               ELSE
                  SELECT COUNT(*)
                  INTO V_EXISTE_ROT
                  FROM COMPITEMPED
                  WHERE
                     CDFILIAL = C_ITLANCTOEST.CDFILIMOVI  AND
                     NRPEDIDO = C_ITLANCTOEST.NRPEDIDO    AND
                     NRITEMPED  = C_ITLANCTOEST.NRITEMPED AND
                     CDPRODUTO = C_ITLANCTOEST.CDPRODUTO;
                  IF (V_EXISTE_ROT > 0)AND(V_IDTPCOMPPROD = W_V)  THEN
                     INSERE_SUBPRODMAN(P_FILIAL,P_LANCESTQ,P_TIPOOPER,C_ITLANCTOEST.CDPRODUTO,
                                       C_ITLANCTOEST.QTITEMPROD,
                                       C_ITLANCTOEST.VRTOTAITEM,C_ITLANCTOEST.VRDESCITEM,
                                       C_ITLANCTOEST.VRBRUTITEM,C_ITLANCTOEST.VRCONTITEM,
                                       V_VRTOTALANCTO,V_QTDELANCTO,V_TIPOMOVI,P_INIVALID,
                                       C_ITLANCTOEST.CDPRODESTO,
                                       C_ITLANCTOEST.NRPEDIDO, C_ITLANCTOEST.NRITEMPED, V_IDTPCOMPPROD,
                                       C_ITLANCTOEST.CDALMOXARIFE, C_ITLANCTOEST.CDLOCALESTOQ, V_IDSISTEMA);
                  ELSE
                     IF (C_ITLANCTOEST.IDCNTRESTOQ = w_S) THEN
                        Begin
                           SELECT VRFATOCONV
                           INTO   V_FATOCONV
                           FROM   PRODUTO
                           WHERE  CDPRODUTO = C_ITLANCTOEST.CDPRODUTO;
                        Exception
                           When No_Data_Found Then
                              V_FATOCONV := Null;
                        End;
                        IF (V_FATOCONV IS NULL) OR (V_FATOCONV = 0) THEN
                           V_FATOCONV := 1;
                        END IF;
                        V_QTDELANCTO   := C_ITLANCTOEST.QTITEMPROD;
                        V_VRTOTALANCTO := C_ITLANCTOEST.VRTOTAITEM - C_ITLANCTOEST.VRDESCITEM;
                        IF NOT(V_QTDELANCTO = 0) THEN
                           V_VRUNITLANCTO := V_VRTOTALANCTO/V_QTDELANCTO;
                        ELSE
                           V_VRUNITLANCTO := V_VRTOTALANCTO;
                        END IF;
                        IF (V_IDOPERDEVONF = w_S) THEN
                           IF (V_QTDELANCTO <> 0) THEN
                              V_TOTABRUT   := (C_ITLANCTOEST.VRBRUTITEM/V_QTDELANCTO)/V_FATOCONV;
                              V_TOTACONTAB := (C_ITLANCTOEST.VRCONTITEM/V_QTDELANCTO)/V_FATOCONV;
                           ELSE
                              V_TOTABRUT   := C_ITLANCTOEST.VRBRUTITEM/V_FATOCONV;
                              V_TOTACONTAB := C_ITLANCTOEST.VRCONTITEM/V_FATOCONV;
                           END IF;
                        ELSE
                           V_TOTABRUT   := 0;
                           V_TOTACONTAB := 0;
                        END IF;
                        IF (V_IDOPERDEVONF <> w_S) OR
                           ((V_IDOPERDEVONF = w_S) AND (V_QTDELANCTO <> 0)) THEN
                           SELECT NVL(MAX(NRSEQUITEM),0) + 1
                           INTO   V_NRSEQITPROD
                           FROM   ITLANCTOEST
                           WHERE  CDFILIAL   = P_FILIAL AND
                                  NRLANCESTQ = P_LANCESTQ;
                           INSERT INTO ITLANCTOEST
                              (CDFILIAL,NRLANCESTQ,NRSEQUITEM,CDPRODUTO,QTTOTLANCTO,VRUNILANCTO,VRTOTLANCTO,
                               IDTIPOMOVI,DTLANCMOVI,IDORDEMCLC,CDPRODMOVI,QTLANCTOEST,VRLANCTOBRUT, VRLANCTOEST,
                               CDFILIMOVI,CDALMOXARIFE,CDLOCALESTOQ,NRLOTEESTQ,NRSUBLOTE,NRLANCORIGRP, IDORIGEMPROD)
                           VALUES
                              (P_FILIAL,P_LANCESTQ,LPAD(V_NRSEQITPROD,4,w_0),C_ITLANCTOEST.CDPRODUTO,
                               V_QTDELANCTO,V_VRUNITLANCTO,V_VRTOTALANCTO,
                               V_TIPOMOVI,P_INIVALID,w_8,C_ITLANCTOEST.CDPRODESTO,
                               (V_QTDELANCTO * V_FATOCONV),V_TOTABRUT, V_TOTACONTAB,
                               V_CDFILIEMIT,C_ITLANCTOEST.CDALMOXARIFE,C_ITLANCTOEST.CDLOCALESTOQ,C_ITLANCTOEST.NRLOTEESTQ,
                               C_ITLANCTOEST.NRSUBLOTE,V_IDDOCESTOQ, C_ITLANCTOEST.IDORIGEMPROD);
                        END IF;
                     END IF;
                  END IF;
               END IF;
            END IF;     /* FIM DO IF DO SISTEMA */
         END LOOP;
      ELSE  /* DEMAIS SISTEMAS QUE NÃO SEJAM EXPEDICAO NEM GESTÃO DE VENDAS */
         BEGIN
            SELECT MAX(CDFILIAL)
              INTO V_CDFILIORIG
              FROM ITEMNOTAFISC
             WHERE CDFILIALIT   = P_FILIAL
               AND NRLANCTONFIT = P_LANCTONF;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_CDFILIORIG := NULL;
         END;
         FOR C_ITLANCTOEST IN (SELECT NRSEQITPROD,
                                      IP.CDPRODUTO,
                                      VRUNITITEM,
                                      VRTOTAITEM,
                                      QTITEMPROD,
                                      CDPRODESTO,
                                      VRBRUTITEM,
                                      VRDESCITEM,
                                      VRCONTITEM,
                                      NVL(IP.CDALMOXARIFE,' ') AS CDALMOXARIFE,
                                      NVL(IP.CDLOCALESTOQ,' ') AS CDLOCALESTOQ,
                                      NVL(NRLOTEESTQ,' ')      AS NRLOTEESTQ,
                                      NVL(NRSUBLOTE,' ')       AS NRSUBLOTE,
                                      NVL(VRCONTITEMORIG, 0) VRCONTITEMORIG,
                                      NVL(VRBRUTITEMORIG, 0) VRBRUTITEMORIG,
                                      CDARVPROD,
                                      NMPRODUTO,
                                      NVL(IP.IDORIGEMPROD, 'N') AS IDORIGEMPROD
                               FROM ITEMPRODUTO IP, PRODUTO P, PRODFILI PF
                               WHERE IP.CDFILIAL    = P_FILIAL     AND
                                     IP.NRLANCTONF  = P_LANCTONF   AND
                                     P.CDPRODUTO    = IP.CDPRODUTO AND
                                     PF.CDFILIAL    = V_CDFILIEMIT AND
                                     PF.CDPRODUTO   = P.CDPRODESTO AND
                                     NVL(IDCNTRESTOQ, w_S) <> w_N AND
                                     NVL(IP.IDATUESTPROD, 'S') = 'S') LOOP
            UPDATE ITEMPRODUTO
            SET CDPRODMOVI = C_ITLANCTOEST.CDPRODESTO
            WHERE (CDFILIAL    = P_FILIAL)    AND
                  (NRLANCTONF  = P_LANCTONF ) AND
                  (NRSEQITPROD = C_ITLANCTOEST.NRSEQITPROD);
            BEGIN
               SELECT NVL(IDATUESTTPOP, 'S') AS IDATUESTTPOP, NVL(IDREMESSAINDU, 'N') AS IDREMESSAINDU
                 INTO V_IDATUESTTPOP, V_IDREMESSAINDU
                 FROM TIPOOPERAC
                WHERE IDENTRSAIDOP = w_S
                  AND CDTIPOOPER = P_TIPOOPER;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_IDATUESTTPOP := 'S';
                  V_IDREMESSAINDU := 'N';
            END;
            IF (V_IDUTILALMOX <> w_S AND V_IDUTILLCESTQ <> w_S AND V_IDUTILLOTE <> w_S) THEN
               UPDATE ITEMPRODUTO
               SET CDALMOXARIFE  = ' ',
                   CDLOCALESTOQ  = ' ',
                   NRLOTEESTQ    = ' ',
                   NRSUBLOTE     = ' '
               WHERE (CDFILIAL     = P_FILIAL)    AND
                     (NRLANCTONF   = P_LANCTONF ) AND
                     (NRSEQITPROD  = C_ITLANCTOEST.NRSEQITPROD)  AND
                     ((CDALMOXARIFE IS NULL)       OR
                      (CDLOCALESTOQ IS NULL)       OR
                      (NRLOTEESTQ   IS NULL)       OR
                      (NRSUBLOTE    IS NULL));
            END IF;
            BEGIN
               SELECT VRFATOCONV
               INTO   V_FATOCONV
               FROM PRODUTO P, ITEMPRODUTO IP
               WHERE P.CDPRODUTO    = IP.CDPRODUTO AND
                     IP.CDFILIAL    = P_FILIAL     AND
                     IP.NRLANCTONF  = P_LANCTONF   AND
                     IP.NRSEQITPROD = C_ITLANCTOEST.NRSEQITPROD;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_FATOCONV := NULL;
            END;
            IF (V_FATOCONV IS NULL) OR (V_FATOCONV = 0) THEN
               V_FATOCONV := 1;
            END IF;
            V_QTDELANCTO   := C_ITLANCTOEST.QTITEMPROD;
            V_VRTOTALANCTO := C_ITLANCTOEST.VRTOTAITEM - C_ITLANCTOEST.VRDESCITEM;
            IF NOT(V_QTDELANCTO = 0) THEN
               V_VRUNITLANCTO := V_VRTOTALANCTO/V_QTDELANCTO;
            ELSE
               V_VRUNITLANCTO := V_VRTOTALANCTO;
            END IF;
            IF (V_IDOPERDEVONF = w_S) OR (V_IDREMESSAINDU = w_S) THEN
               IF (V_QTDELANCTO <> 0) THEN
                  V_TOTABRUT   := (C_ITLANCTOEST.VRBRUTITEM/V_QTDELANCTO)/V_FATOCONV;
                  V_TOTACONTAB := (C_ITLANCTOEST.VRCONTITEM/V_QTDELANCTO)/V_FATOCONV;
                  IF C_ITLANCTOEST.VRBRUTITEMORIG <> 0 THEN
                     V_TOTABRUT := (C_ITLANCTOEST.VRBRUTITEMORIG/V_QTDELANCTO)/V_FATOCONV;
                  END IF;
                  IF C_ITLANCTOEST.VRCONTITEMORIG <> 0 THEN
                     V_TOTACONTAB := (C_ITLANCTOEST.VRCONTITEMORIG/V_QTDELANCTO)/V_FATOCONV;
                  END IF;
               ELSE
                  V_TOTABRUT   := C_ITLANCTOEST.VRBRUTITEM/V_FATOCONV;
                  V_TOTACONTAB := C_ITLANCTOEST.VRCONTITEM/V_FATOCONV;
               END IF;
            ELSE
               V_TOTABRUT   := 0;
               V_TOTACONTAB := 0;
            END IF;
            IF (V_IDOPERDEVONF <> w_S) OR ((V_IDOPERDEVONF = w_S) AND (V_QTDELANCTO <> 0)) THEN
               INSERT INTO ITLANCTOEST
                  (CDFILIAL, NRLANCESTQ, NRSEQUITEM,               CDPRODUTO,
                   QTTOTLANCTO, VRUNILANCTO,    VRTOTLANCTO,
                   IDTIPOMOVI, DTLANCMOVI, IDORDEMCLC,CDPRODMOVI,
                   QTLANCTOEST,               VRLANCTOBRUT, VRLANCTOEST,
                   CDFILIMOVI,  CDALMOXARIFE,               CDLOCALESTOQ,               NRLOTEESTQ,
                   NRSUBLOTE,              NRLANCORIGRP, IDORIGEMPROD)
               VALUES
                  (P_FILIAL, P_LANCESTQ, C_ITLANCTOEST.NRSEQITPROD,C_ITLANCTOEST.CDPRODUTO,
                   V_QTDELANCTO,V_VRUNITLANCTO, V_VRTOTALANCTO,
                   V_TIPOMOVI, P_INIVALID, w_8,       C_ITLANCTOEST.CDPRODESTO,
                  (V_QTDELANCTO * V_FATOCONV),V_TOTABRUT,   V_TOTACONTAB,
                   V_CDFILIEMIT,C_ITLANCTOEST.CDALMOXARIFE, C_ITLANCTOEST.CDLOCALESTOQ, C_ITLANCTOEST.NRLOTEESTQ,
                   C_ITLANCTOEST.NRSUBLOTE,V_IDDOCESTOQ, C_ITLANCTOEST.IDORIGEMPROD);
            END IF;
            /* Se NF Remessa para Industrialização e Operação Atualiza Estoque */
            IF (V_IDREMESSAINDU = 'S') AND (V_IDATUESTTPOP = 'S') THEN
               IF V_IDORIGDESTNF = 'C' THEN
                  BEGIN
                     SELECT NVL(CDALMOXINFOCLI, ' ') AS CDALMOXINFOCLI, NVL(CDLOCALINFOCLI, ' ') AS CDLOCALINFOCLI
                       INTO V_CDALMOXINFO, V_CDLOCALINFO
                       FROM AGENTETERCECLI
                      WHERE CDFILIAL = V_CDFILIEMIT
                        AND CDCLIENTE = P_CLIENTE;
                  EXCEPTION
                     WHEN NO_DATA_FOUND THEN
                        V_CDALMOXINFO := ' ';
                        V_CDLOCALINFO := ' ';
                  END;
               END IF;
               IF V_IDORIGDESTNF = 'F' THEN
                  BEGIN
                     SELECT NVL(CDALMOXINFOFOR, ' ') AS CDALMOXINFOFOR, NVL(CDLOCALINFOFOR, ' ') AS CDLOCALINFOFOR
                       INTO V_CDALMOXINFO, V_CDLOCALINFO
                       FROM AGENTETERCEFOR
                      WHERE CDFILIAL = V_CDFILIEMIT
                        AND CDFORNECED = P_CLIENTE;
                  EXCEPTION
                     WHEN NO_DATA_FOUND THEN
                        V_CDALMOXINFO := ' ';
                        V_CDLOCALINFO := ' ';
                  END;
                  BEGIN
                     SELECT CDFILIAL
                       INTO V_CDFILIAGENT
                       FROM FILIAL
                      WHERE CDFORNAGETERC = P_CLIENTE;
                  EXCEPTION
                     WHEN NO_DATA_FOUND THEN
                        V_CDFILIAGENT := NULL;
                  END;
                  IF NOT V_CDFILIAGENT IS NULL THEN
                     BEGIN
                        SELECT NVL(NVL(P.CDALMOXARIFE, F.CDALMOXARIFE), ' ') AS CDALMOXARIFE, NVL(NVL(P.CDLOCALESTOQ, F.CDLOCALESTOQ), ' ') AS CDLOCALESTOQ,
                               NVL(F.IDUTILLOTE, 'N') AS IDUTILLOTE
                          INTO V_CDALMOXARIFEAG, V_CDLOCALESTOQAG, V_IDUTILLOTEAG
                          FROM PARAMFILIAL F, PRODFILI P
                         WHERE F.CDFILIAL  = V_CDFILIAGENT
                           AND P.CDFILIAL  = V_CDFILIAGENT
                           AND P.CDPRODUTO = C_ITLANCTOEST.CDPRODESTO;
                     EXCEPTION
                        WHEN NO_DATA_FOUND THEN
                           V_CDALMOXARIFEAG := ' ';
                           V_CDLOCALESTOQAG := ' ';
                           V_IDUTILLOTEAG   := 'N';
                     END;
                     BEGIN
                        SELECT CDEMPRESA, CDINSCESTA, CDINSCMUNI
                          INTO V_CDEMPRESAAG, V_CDINSCESTAAG, V_CDINSCMUNIAG
                          FROM FILIAL
                         WHERE CDFILIAL  = V_CDFILIAGENT;
                     EXCEPTION
                        WHEN NO_DATA_FOUND THEN
                           V_CDEMPRESAAG  := NULL;
                           V_CDINSCESTAAG := NULL;
                           V_CDINSCMUNIAG := NULL;
                     END;
                     IF V_IDUTILLOTEAG = 'S' THEN
                        IF (V_NRLOTEESTQAG IS NULL) OR (V_NRLOTEESTQAG = ' ') THEN
                           PRXLOTEPRODEST(V_CDFILIAGENT, P_INIVALID, C_ITLANCTOEST.CDPRODESTO, V_NRLOTEESTQAG);
                           V_NRSUBLOTEAG := ' ';
                        END IF;
                     ELSE
                        V_NRLOTEESTQAG := ' ';
                        V_NRSUBLOTEAG  := ' ';
                     END IF;
                  END IF;
               END IF;
               IF (V_CDALMOXINFO IS NOT NULL) AND (V_CDALMOXINFO <> ' ') AND (V_CDFILIAGENT IS NULL) THEN
                  IF V_BOLANESTENTR THEN
                     --GERANDO O REGISTRO NA TABELA LANCTOESTOQ PARA A ENTRADA NO ALMOXAXARIFADO
                     IF (V_NRLANESTENTR IS NULL) OR (V_NRLANESTENTR = '') THEN
                        NOVO_CODIGO_NT('LANCTOEST'||P_FILIAL, V_NRLANESTENTR);
                        V_NRLANESTENTR := SUBSTR(V_NRLANESTENTR, 11, 10);
                     END IF;
                     INSERT INTO LANCTOESTOQ
                        (CDFILIAL,
                         NRLANCESTQ,
                         IDTPLANCTO,
                         DTLANCESTQ,
                         DSLANCESTQ,
                         CDFILIMOVI,
                         CDOPERADOR)
                     VALUES
                        (P_FILIAL,
                         V_NRLANESTENTR,
                         W_2,
                         P_INIVALID,
                         'Transferência de Estoque ' || V_NRLANESTENTR,
                         V_CDFILIEMIT,
                         P_CDOPERADOR);
                     --GERANDO O REGISTRO NA TABELA CTRLMOVIESTQ
                     IF (V_NRCTRLMOVEST IS NULL) OR (V_NRCTRLMOVEST = '') THEN
                        NOVO_CODIGO_NT('NRTRANSESTQ'||V_CDFILIEMIT, V_NRCTRLMOVEST);
                        V_NRCTRLMOVEST := SUBSTR(V_NRCTRLMOVEST, 11, 10);
                     END IF;
                     INSERT INTO CTRLMOVIESTQ
                        (CDFILIAL,
                         NRCTRLMOVEST,
                         CDFILIALENTR,
                         NRLANESTENTR,
                         CDFILIALSAID,
                         NRLANESTSAID,
                         CDALMOXENTR,
                         CDALMOXSAID,
                         CDLCESTENTR,
                         CDLCESTSAID,
                         DTMOVIESTQ,
                         NRREQUESTO)
                     VALUES
                        (V_CDFILIEMIT,
                         V_NRCTRLMOVEST,
                         P_FILIAL,
                         V_NRLANESTENTR,
                         P_FILIAL,
                         P_LANCESTQ,
                         V_CDALMOXINFO,
                         C_ITLANCTOEST.CDALMOXARIFE,
                         V_CDLOCALINFO,
                         C_ITLANCTOEST.CDLOCALESTOQ,
                         P_INIVALID,
                         '');
                     V_BOLANESTENTR := FALSE;
                  END IF;
                  --GERANDO O REGISTRO NA TABELA ITLANCTOEST
                  INSERT INTO ITLANCTOEST
                     (CDFILIAL,
                      NRLANCESTQ,
                      NRSEQUITEM,
                      CDPRODUTO,
                      DSLANCESTIT,
                      CDALMOXARIFE,
                      CDLOCALESTOQ,
                      NRLOTEESTQ,
                      NRSUBLOTE,
                      CDFILIMOVI,
                      CDPRODMOVI,
                      IDORDEMCLC,
                      DTLANCMOVI,
                      IDEVOLESTOQ,
                      QTTOTLANCTO,
                      IDTIPOMOVI,
                      QTLANCTOEST,
                      VRUNILANCTO,
                      VRTOTLANCTO,
                      VRLANCTOEST,
                      VRLANCTOBRUT,
                      IDORIGEMPROD)
                  VALUES
                     (P_FILIAL,
                     V_NRLANESTENTR,
                     C_ITLANCTOEST.NRSEQITPROD,
                     C_ITLANCTOEST.CDPRODUTO,
                     '',
                     V_CDALMOXINFO,
                     V_CDLOCALINFO,
                     C_ITLANCTOEST.NRLOTEESTQ,
                     C_ITLANCTOEST.NRSUBLOTE,
                     V_CDFILIEMIT,
                     C_ITLANCTOEST.CDPRODESTO,
                     W_2,
                     P_INIVALID,
                     W_S,
                     V_QTDELANCTO,
                     W_2,
                     V_QTDELANCTO * V_FATOCONV,
                     V_VRUNITLANCTO,
                     V_VRTOTALANCTO,
                     V_TOTACONTAB,
                     V_TOTABRUT,
                     C_ITLANCTOEST.IDORIGEMPROD);
               ELSE
                  /* Se o fornecedor da nota fiscal for agente de terceirização */
                  IF NOT V_CDFILIAGENT IS NULL THEN
                     IF V_CDFILIORIG IS NULL THEN
                        IF V_BOLANESTENTRAG THEN
                           /* Gerando o registro na tabela LANCTOESTOQ para a entrada na filial relacionada ao agente de terceirização */
                           NOVO_CODIGO_NT('LANCNF/FILIAL' || V_CDFILIAGENT, V_NRLANCTONFAG);
                           V_NRLANCTONFAG := SUBSTR(V_NRLANCTONFAG, 11, 10);
                           NOVO_CODIGO_NT('LANCTOEST'||V_CDFILIAGENT, V_NRLANESTENTRAG);
                           V_NRLANESTENTRAG := SUBSTR(V_NRLANESTENTRAG, 11, 10);
                           V_TPOPERRETORNO := NULL;
                           BEGIN
                              SELECT CDTPOOPRETORNO
                                INTO V_TPOPERRETORNO
                                FROM PARAMGERAL
                               WHERE CDPARGERAL = '0001';
                           EXCEPTION
                           WHEN NO_DATA_FOUND THEN
                              V_TPOPERRETORNO := NULL;
                           END;
                           IF (V_TPOPERRETORNO IS NULL) THEN
                              RAISE_APPLICATION_ERROR(-20501, 'Tipo de operação para geração de lançamento de estoque deve ser informado - (Parâmetros para Documentos Fiscais de Saída - Operador Logístico)', TRUE);
                           END IF;
                           INSERT INTO NOTAFISCAL
                              (CDFILIAL, NRLANCTONF, CDFILIRECE, CDEMPRESA, CDINSCESTA, CDSERIE, CDINSCMUNI,
                               IDTPIJURNF, NRINSJURNF, CDFORNECED, IDBLOQUEADO, IDDOCFISCAL, IDDOCFINANC,
                               NRNOTAFISC, DTEMISSAO, DTENTRSAID, VRPRODUTOS, VRNOTAFISC, IDENTRSAIDOP,
                               CDTIPOOPER, CDSERIEENTR, CDCLIENTE, CDFILIEMIT, IDORIGDESTNF)
                           VALUES
                              (V_CDFILIAGENT, V_NRLANCTONFAG, V_CDFILIAGENT, V_CDEMPRESAAG, V_CDINSCESTAAG, NULL, V_CDINSCMUNIAG,
                               V_IDTPIJURNF, V_NRINSJURNF, P_CLIENTE, 'N', 'N', 'S',
                               NULL, P_INIVALID, P_INIVALID, NVL(V_LIQUIDO,0), NVL(V_TOTALNOTA,0), 'E',
                               V_TPOPERRETORNO, NULL, NULL, NULL, V_IDORIGDESTNF);
                           INSERT INTO ITEMNOTAFISC
                              (CDFILIAL, NRLANCTONF, NRSEQUITNOTA, CDFILIALIT, NRLANCTONFIT)
                           VALUES
                              (V_CDFILIAGENT, V_NRLANCTONFAG, '001', P_FILIAL, P_LANCTONF);
                           INSERT INTO LANCTOESTOQ
                              (CDFILIAL,
                               NRLANCESTQ,
                               NRLANCTONF,
                               IDTPLANCTO,
                               DTLANCESTQ,
                               DSLANCESTQ,
                               CDFILIMOVI,
                               CDOPERADOR)
                           VALUES
                              (V_CDFILIAGENT,
                               V_NRLANESTENTRAG,
                               V_NRLANCTONFAG,
                               'E',
                               P_INIVALID,
                               'NF Remessa Armazenagem - lanç. ' || V_CDFILIEMIT || ' ' || P_LANCTONF,
                               V_CDFILIAGENT,
                               P_CDOPERADOR);
                           V_BOLANESTENTRAG := FALSE;
                        END IF;
                        INSERT INTO ITEMPRODUTO
                           (CDFILIAL, NRLANCTONF, NRSEQITPROD, CDPRODUTO,
                            CDPRODEMIS, DSPRODEMIS, IDATUVRESTOQ, QTITEMPROD,
                            VRUNITITEM, VRDESCITEM, VRTOTAITEM, VRCONTITEM,
                            VRBRUTITEM, IDCONFORITEM, CDFILIMOVI,
                            CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE,
                            CDPRODMOVI)
                        VALUES
                           (V_CDFILIAGENT, V_NRLANCTONFAG, C_ITLANCTOEST.NRSEQITPROD, C_ITLANCTOEST.CDPRODUTO,
                            C_ITLANCTOEST.CDARVPROD, C_ITLANCTOEST.NMPRODUTO, 'S', V_QTDELANCTO,
                            V_VRUNITLANCTO, C_ITLANCTOEST.VRDESCITEM, V_VRTOTALANCTO, V_VRTOTALANCTO,
                            V_VRTOTALANCTO, 'S', V_CDFILIAGENT,
                            V_CDALMOXARIFEAG, V_CDLOCALESTOQAG, V_NRLOTEESTQAG, V_NRSUBLOTEAG,
                            C_ITLANCTOEST.CDPRODESTO);
                        INSERT INTO ITLANCTOEST
                           (CDFILIAL,
                            NRLANCESTQ,
                            NRSEQUITEM,
                            CDPRODUTO,
                            DSLANCESTIT,
                            CDALMOXARIFE,
                            CDLOCALESTOQ,
                            NRLOTEESTQ,
                            NRSUBLOTE,
                            CDFILIMOVI,
                            CDPRODMOVI,
                            IDORDEMCLC,
                            DTLANCMOVI,
                            IDEVOLESTOQ,
                            QTTOTLANCTO,
                            IDTIPOMOVI,
                            QTLANCTOEST,
                            VRUNILANCTO,
                            VRTOTLANCTO,
                            VRLANCTOEST,
                            VRLANCTOBRUT,
                            IDORIGEMPROD)
                        VALUES
                           (V_CDFILIAGENT,
                            V_NRLANESTENTRAG,
                            C_ITLANCTOEST.NRSEQITPROD,
                            C_ITLANCTOEST.CDPRODUTO,
                            '',
                            V_CDALMOXARIFEAG,
                            V_CDLOCALESTOQAG,
                            V_NRLOTEESTQAG,
                            V_NRSUBLOTEAG,
                            V_CDFILIAGENT,
                            C_ITLANCTOEST.CDPRODESTO,
                            W_2,
                            P_INIVALID,
                            W_S,
                            V_QTDELANCTO,
                            W_2,
                            V_QTDELANCTO * V_FATOCONV,
                            V_VRUNITLANCTO,
                            V_VRTOTALANCTO,
                            V_TOTACONTAB,
                            V_TOTABRUT,
                            C_ITLANCTOEST.IDORIGEMPROD);
                     END IF;
                  END IF;
               END IF;
            END IF;
         END LOOP;
      END IF;
   END IF;
   IF (V_CDSITUCRT <> '3') THEN
      SELECT COUNT(*)
         INTO V_EXISTDSDADOSADIC
         FROM ITEMPRODUTO
      WHERE CDFILIAL   = P_FILIAL
        AND NRLANCTONF = P_LANCTONF
        AND (CDFISCOPERSN IN ('101', '201') OR SUBSTR(CDFISCOPERSN,2, 3) IN ('101', '201'));
      IF V_EXISTDSDADOSADIC > 0 THEN
         V_CDIMPOSICMS  := null;
         FOR C_ICMS IN (SELECT CDIMPOSTO
                          FROM IMPOSTO
                         WHERE CDIMPOSTONFE = '00')
         LOOP
            V_CDIMPOSICMS := V_CDIMPOSICMS||C_ICMS.CDIMPOSTO||'_';
         END LOOP;
         IF V_CDIMPOSICMS IS NOT NULL THEN
            SELECT SUM(VRIMPOSTOIT) VRIMPOSTOICMS, MAX(VRALIQITEM) VRALIQUOTAICMS
              INTO V_APROVICMS, V_ALIQAPROVICMS
              FROM ITEMPROIMPOS I
             WHERE I.CDFILIAL   = P_FILIAL
               AND I.NRLANCTONF   = P_LANCTONF
               AND I.NRITPROIMPOS = '1'
               AND (INSTR(V_CDIMPOSICMS,I.CDIMPOSTO||'_') > 0)
               AND I.NRSEQITPROD IN (SELECT NRSEQITPROD
                                       FROM ITEMPRODUTO IP
                                      WHERE IP.CDFILIAL = P_FILIAL
                                        AND IP.NRLANCTONF = P_LANCTONF
                                        AND (IP.CDFISCOPERSN IN ('101', '201') OR SUBSTR(IP.CDFISCOPERSN,2, 3) IN ('101', '201')));
            SELECT COUNT(*)
              INTO V_EXISTDSDADOSADIC
              FROM DADOSADIC
             WHERE CDFILIAL = P_FILIAL
               AND NRLANCTONF = P_LANCTONF
               AND DSDADOADIC LIKE 'Permite o aproveitamento do credito do ICMS no valor de R$ %';
            IF V_EXISTDSDADOSADIC = 0 THEN
               INSERT INTO DADOSADIC(CDFILIAL, NRLANCTONF, NRDADOADIC, DSDADOADIC)
                              VALUES(P_FILIAL, P_LANCTONF, V_DADOADIC, 'Permite o aproveitamento do credito do ICMS no valor de R$ '||DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(V_APROVICMS, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(V_APROVICMS, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(V_APROVICMS, 2), '9999999999999.99')))|| ' corresp. a alíquota de '|| DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(V_ALIQAPROVICMS, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(V_ALIQAPROVICMS, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(V_ALIQAPROVICMS, 2), '9999999999999.99'))) || '% conf. Art.23 da LC 123/06.');
               V_DADOADIC := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_DADOADIC) + 1)),3,0);
            ELSE
               UPDATE DADOSADIC
                  SET DSDADOADIC = 'Permite o aproveitamento do credito do ICMS no valor de R$ '||DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(V_APROVICMS, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(V_APROVICMS, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(V_APROVICMS, 2), '9999999999999.99')))|| ' corresp. a alíquota de '|| DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(V_ALIQAPROVICMS, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(V_ALIQAPROVICMS, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(V_ALIQAPROVICMS, 2), '9999999999999.99'))) || '% conf. Art.23 da LC 123/06.'
                 WHERE CDFILIAL = P_FILIAL
                   AND NRLANCTONF = P_LANCTONF
                   AND DSDADOADIC LIKE 'Permite o aproveitamento do credito do ICMS no valor de R$ %';
            END IF;
         END IF;
      END IF;
   END IF;
END;
/
/*
@C:\WEB_619\SQL\END_CONV\ORACLE\5201_DFESTPO_IMPOSTO_ENTRADA.SQL
 DESCRIÇÃO:
 PROCEDURE PARA GERAÇÃO DOS IMPOSTOS E VALOR FINAL DAS NOTAS DE ENTRADA
  PARÂMETROS
 P_EMPRESA     - CÓDDIGO DA EMPRESA
 P_PRODUTO     - CÓDIGO DE ÁRVORE DO PRODUTO(CDARVPROD)
 P_INSCESTA    - INSCRIÇÃO ESTADUAL DO LANÇAMENTO
 P_TIPOOPER    - TIPO DE OPERAÇÃO DO LANÇAMENTO
 P_FORNECED    - CÓDIGO DO FORNECEDOR DA NOTA (CDCLIENTE, CDFORNECED OU CDFILIAL)
 P_FILIAL      - CÓDIGO DA FILIAL DO LANÇAMENTO (CDFILIAL)
 P_LANCTONF    - NÚMERO DO LANÇAMENTO (NRLANCTONF)
 P_INIVALID    - DATA DE SAÍDA DO LANÇAMENTO
 P_VRNOTAFISC  - VALOR FINAL DA NOTA
 P_LANCESTQ    - NÚMERO DO LANÇAMENTO DE ESTOQUE
 P_CDOPERADOR  - OPERADOR GRAVADO NA LANCTOESTOQ
 RAISE_APPLICATION_ERROR(-20501,  , TRUE);
*/
CREATE OR REPLACE PROCEDURE IMPOSTO_ENTRADA
(
        P_EMPRESA  IN ALIQUOTA.CDEMPRESA%TYPE,                    --EMPRESA
        P_INSCESTA IN ALIQUOTA.CDINSCESTA%TYPE,                   --INSCRIÇÃO ESTADUAL
        P_TIPOOPER IN INCIDENCIA.CDTIPOOPER%TYPE,                 --TIPO DE OPERAÇÃO
        P_FORNECED IN FORNECEDOR.CDFORNECED%TYPE,                 --CÓDIGO FORNECEDOR
        P_FILIAL   IN NOTAFISCAL.CDFILIAL%TYPE,                   --FILIAL
        P_LANCTONF IN NOTAFISCAL.NRLANCTONF%TYPE,                 --Nº LANCAMENTO
        P_INIVALID IN ALIQUOTA.DTINIVALID%TYPE,                   --DATA DE INICIO DE VALIDADDE
        P_VRNOTAFISC OUT NUMBER,                                  --VALOR DA NF RETORNADO
        P_LANCESTQ IN LANCTOESTOQ.NRLANCESTQ%TYPE DEFAULT NULL,   --Nº LANCAMENTO DE ESTOQUE. SE NULO, NÃO ATUALIZA ESTOQUE
        P_ENTRSAID IN NOTAFISCAL.IDENTRSAIDOP%TYPE DEFAULT 'E',   --PARÂMETRO P/ IMPORTACAO DE NOTAS DE SAÍDA
        P_CDOPERADOR IN LANCTOESTOQ.CDOPERADOR%TYPE DEFAULT NULL,
        P_AUDIT      IN VARCHAR2 DEFAULT NULL) --CÓDIGO OPERADOR
IS
   V_PAISORIG     VARCHAR2(04);
   V_ESTAORIG     VARCHAR2(02);
   V_MUNIORIG     VARCHAR2(04);
   V_PAISDEST     VARCHAR2(04);
   V_ESTADEST     VARCHAR2(02);
   V_MUNIDEST     VARCHAR2(04);
   V_PAISCFOP     VARCHAR2(04);
   V_ESTACFOP     VARCHAR2(02);
   V_CDPAISST     VARCHAR2(04);
   V_SGESTADOST   VARCHAR2(02);
   V_CDMUNICIPIOST VARCHAR2(04);
   V_CDINSCESTAST VARCHAR2(16);
   V_ALIQTEMP     VARCHAR2(14);
   V_INCITEMP     VARCHAR2(14);
   V_CSTTEMP      VARCHAR2(14);
   V_CFOPTEMP     VARCHAR2(14);
   V_FISOPEITEM   VARCHAR2(11);
   V_SUFXCFOPPR   VARCHAR2(03);
   V_SITUTRIBPR   VARCHAR2(03);
   V_IDTRIMPSTII  CHAR(1);
   V_CDIMPOSTRIB  VARCHAR2(250);
   V_IMPOSTRIBCOMPLANC VARCHAR2(02);
   V_NRINSJURNF   VARCHAR2(20);
   V_SERIE        VARCHAR2(05);
   V_TIPOMOVI     CHAR(1);
   V_CDFILIRECE   VARCHAR2(04);
   V_CDFILIEMIT   VARCHAR2(04);
   V_INTEGRACAO   VARCHAR2(16);
   V_CDFISOPENTF  VARCHAR2(11);
   V_IDVALORINFO  CHAR(1);
   V_NRNOTAFISC   VARCHAR2(20);
   V_NRSEQITPROD  VARCHAR2(04);
   V_CDPRGENEREV  VARCHAR2(10);
   V_IDDOCFINANC  CHAR(1);
   V_IDSTATUS     CHAR(1);
   V_IDORIGDESTNF CHAR(1);
   V_NMTIPOOPER   VARCHAR2(30);
   V_NMFILIEMIT   VARCHAR2(60);
   V_DESCLANC     VARCHAR2(60);
   V_IDDOCREPLIC  VARCHAR2(14);
   V_IDSISTEMA    VARCHAR2(03);
   V_IDRETPROEXP  CHAR(1);
   V_FILIORIG     VARCHAR2(04);
   V_DEVOLORIG    VARCHAR2(10);
   V_IDCTRLESTQ   CHAR(1);
   V_IDORDPRIMDFENT VARCHAR2(02);
   V_IDTPFORPGTFO CHAR(1);
   V_IDFORMAPUR   CHAR(1);
   V_IDATUEST     CHAR(1);
   V_IDTPIJURNF   CHAR(1);
   V_DTENTRSAID   DATE;
   V_NOTAFISC     NUMBER;
   V_IDVRIMPSTRIB CHAR(1);
   V_CDSITTRIBTMP    CODSITUTRIBNFE.CDSITUTRIBNFE%TYPE;
   V_IDMODBCNFE      CODSITUTRIBNFE.IDMODBCNFE%TYPE;
   V_IDMODBCSTNFE    CODSITUTRIBNFE.IDMODBCSTNFE%TYPE;
   V_CDTPCRPICOSTNFE CODSITUTRIBNFE.CDTPCRPICOSTNFE%TYPE;
   V_CDNATUBCPCSTNFE CODSITUTRIBNFE.CDNATUBCPCSTNFE%TYPE;
   V_IDMOTIDESSTNFE  CODSITUTRIBNFE.IDMOTIDESSTNFE%TYPE;
   --VARIÁVEIS PARA NOTA DE COMPLEMENTO
   V_CDFISCALCOMP     VARCHAR2(01);
   V_SITUTRIBCOMP     CODSITUTRIBNFE.CDSITUTRIBNFE%TYPE;
   V_IDMODBCNFECOMP   CODSITUTRIBNFE.IDMODBCNFE%TYPE;
   V_IDMODBCSTNFECOMP CODSITUTRIBNFE.IDMODBCSTNFE%TYPE;
   V_TOTALITEMCOMP    NUMBER;
   V_IDINTEREST   VARCHAR2(01);
   V_IDINTERNAC   VARCHAR2(01);
   V_PARDEDTMP    NUMBER;
   V_PREDBCTMP    NUMBER;
   V_PREDBCTMP1   NUMBER;
   V_ALIQUTMP     NUMBER;
   V_PBCSUBTRIB   NUMBER;
   V_TAXABCSUBSTR NUMBER;
   V_VRIMPOSTOST  NUMBER;
   V_VRPPRIIMPST  NUMBER;
   V_COUNT        NUMBER;
   V_LIQUIITEM    NUMBER;
   V_LIQUIDOPROD  NUMBER;
   V_TOTALNOTA    NUMBER;
   V_LIQUIDO      NUMBER;
   V_VRPRODUTOS   NUMBER;
   V_VRCOMPLEMEN  NUMBER;
   V_SOMAENCA     NUMBER;
   V_MENOENCA     NUMBER;
   V_SOMAIMPO     NUMBER;
   V_MENOIMPO     NUMBER;
   V_TOTAPRODENCA NUMBER;
   V_TOTAPRENIMPO NUMBER;
   V_TOTAIMPBCALC NUMBER;
   V_TOTAIMPBCINF NUMBER;
   V_TAXABASECALC NUMBER;
   V_TOTAIMPBCDES NUMBER;
   V_TAXAALIQFECP NUMBER;   
   V_TAXAALIQUOTA NUMBER;
   V_PRODUENCARGO NUMBER;
   V_SEQUIMPOSTNF NUMBER;
   V_SOMAITEM     NUMBER;
   V_DESCITEM     NUMBER;
   V_BASECALCIT   NUMBER;
   V_IMPOSTOIT    NUMBER;
   V_IMPOSTORED1  NUMBER;
   V_FATOCONV     NUMBER;
   V_TOTABRUT     NUMBER;
   V_QTDELANCTO   NUMBER;
   V_VRUNITLANCTO NUMBER;
   V_VRTOTALANCTO NUMBER;
   V_TOTACONTAB   NUMBER;
   V_VRBRUTO      NUMBER;
   V_VRCONTAB     NUMBER;
   V_IMPOCONTAB   NUMBER;
   V_TOTIMPOCONT  NUMBER;
   V_TOTIMPOBRUT  NUMBER;
   V_CONTIMPO     NUMBER;
   V_ALIQINFO     NUMBER;
   V_TAXAALIQINFO NUMBER;
   V_IMPOSINFO    NUMBER;
   V_VRPERREDBCIT NUMBER;
   V_VRBASECALCIT NUMBER;
   V_CONTABCALC   NUMBER;
   V_PERDBCALC    NUMBER;
   V_TOTAPROD     NUMBER;
   V_VRDIFERENCA  NUMBER;
   V_VRNOTAFISC   NUMBER;
   V_VRTOTIMPONF  NUMBER;
   V_IMPOSRETI    NUMBER;
   V_VRCONTAREC   NUMBER;
   V_NRDECITOTANF NUMBER;
   V_EXISTE_ROT   NUMBER;
   V_VRCUSTENTR   NUMBER;
   V_VALRDESCITEM NUMBER;
   V_VRIMPOSCONT  NUMBER;
   V_VRREDUCAO    NUMBER;
   V_NRIMPOSTO    NUMBER;
   V_MINBCPROD    NUMBER;
   V_VRTOTAITEM   NUMBER;
   V_SOMATOTAITEM NUMBER;
   V_PERCENTITEM  NUMBER;
   /*VARIÁVEIS PARA DIFERENCIAL DE ALÍQUOTA*/
   V_ALIQDIFE     NUMBER;
   V_ALIQDEST     NUMBER;
   V_IMPOSTODIFE  NUMBER;
   V_BCALCDIFCOMP NUMBER;
   V_IDCALCDIFENTFISC VARCHAR2(01);
   V_CDGRUPOFISC  VARCHAR2(03);
   V_CDGRPFISCSV  VARCHAR2(03);
   V_UTGRUPFISCS  VARCHAR2(01);
   V_CDORIGDESTNF VARCHAR2(21);
   V_CDALMOXARIFE VARCHAR2(06);
   V_CDLOCALESTOQ VARCHAR2(06);
   V_DIFALIQITEM      CHAR(01);
   V_IDDIFALIQCUSPRC  CHAR(01);
   V_CDCSTDIGI    VARCHAR2(03);
   V_IMPOSITEM    VARCHAR2(14);
   V_IDOPERDEVONF CHAR(1);
   V_IDUTCUSORIGEST CHAR(1);   
   V_IDNFOUTRASNF CHAR(1);
   V_QTDEREGTRAB  NUMBER;
   V_IDACRPRODENTRNF VARCHAR2(01);
   /* NOTA FISCAL DE IMPORTAÇÃO */
   V_IDNFIMPORTACAO VARCHAR2(01);
   /*VARIÁVEIS PARA CALCULO DO CUSTO LOGISTICO*/
   V_VRPESOBRUTPR   NUMBER;
   V_VRPECUSTOLOG   NUMBER;
   V_VRVRCUSTOLOG   NUMBER;
   V_VRPESEGURLOG   NUMBER;
   V_VRCUSTOLOG     NUMBER;
   V_VRCUSTOSEG     NUMBER;
   V_CDFORNECED     VARCHAR2(21);
   V_IDENDCFOP      VARCHAR2(01);
   V_DSCDFISOPEIT   VARCHAR2(100);
   V_DADOADIC       VARCHAR(03);
   V_CDEMPRESA      VARCHAR(02);
   V_CDINSCESTA     VARCHAR(16);
   V_VRFRETEITEM        FLOAT;
   V_VRSEGURITEM        FLOAT;
   V_VRENCARGODESC      FLOAT;
   V_DIFERENCA          FLOAT;
   V_VROUTRASDESPITEM   FLOAT;
   V_VRDESPADUANEIRA    FLOAT;
   V_SUMVRDESCITEM      FLOAT;
   V_IMPOSDESONERA      FLOAT;
   W_F              CHAR(1) := 'F';
   W_S              CHAR(1) := 'S';
   W_N              CHAR(1) := 'N';
   W_DFE            CHAR(3) := 'DFE';
   W_L              CHAR(1) := 'L';
   W_C              CHAR(1) := 'C';
   W_E              CHAR(1) := 'E';
   W_P              CHAR(1) := 'P';
   W_R              CHAR(1) := 'R';
   W_D              CHAR(1) := 'D';
   W_A              CHAR(1) := 'A';
   W_V              CHAR(1) := 'V';
   W_M              CHAR(1) := 'M';
   W_1              CHAR(1) := '1';
   W_2              CHAR(1) := '2';
   W_3              CHAR(1) := '3';
   W_00000          CHAR(5) := '00000';
   W_000            CHAR(3) := '000';
   W_EXP            CHAR(3) := 'EXP';
   W_PDV            CHAR(3) := 'PDV';
   W_VMN            CHAR(3) := 'VMN';
   W_I              CHAR(1) := 'I';
   V_VRIMPDIFALIQ   NUMBER;
   V_CDTIPCUSTEST   NUMBER;
   V_DTSAIDNFORIG   DATE;
   V_DTATUAL        DATE;
   V_NRSEQITIMP     VARCHAR2(04);
   V_NRIMPOSNF      VARCHAR2(02);
   V_CDFISCOPERSN   VARCHAR2(04);
   V_IMPOICMS       VARCHAR(02);
   V_VRFATOCONV     NUMBER;
   V_IDIMPOBCALTPOP  VARCHAR2(01);
   V_IDIMBCALTPOPDE  VARCHAR2(01);
   V_CDIMPOBCALC     VARCHAR2(02);
   V_IDNOTADEVO      VARCHAR2(01);
   V_IDPERALTCSTFENF VARCHAR2(01);
   V_CDSITUTRIBIT  VARCHAR2(03);
   V_CDFISCOPERIT  VARCHAR2(11);
   V_CDSUFXCFOPIT  VARCHAR2(03);
   V_CFOP1DIGT     VARCHAR2(01);
   V_CDFILIREDU    VARCHAR2(04);
   V_VRCONTITIMP   FLOAT;
   V_IDREDUCAO     VARCHAR2(01);
   V_CDGRUPOFISCAUX  VARCHAR2(03);
   V_CDREGRAITALIQ VARCHAR2(10);
   V_IDSUGMODNF    VARCHAR2(01);
   V_VRTOTBRUT     FLOAT;
   V_VRTOTANF      FLOAT;
   V_DIFBRUTNF     FLOAT;
   V_ICMS          VARCHAR2(01);
   V_CDCFOPINFUSU  VARCHAR2(11);
   V_DSCFOPINFUSU  VARCHAR2(50);
   V_CST1DIGT      VARCHAR2(1);
   V_IDNFGERADAVIAXML VARCHAR2(01);
   V_IDGERNFIGUALXML VARCHAR2(01);
   V_POSSUIFINANC   FLOAT;
   P_RESULTADO      VARCHAR2(50);
   V_IDUTILVENC     VARCHAR2(01);
   V_IDUTILPVRIMPBC VARCHAR2(01);
   V_ALIQPISIMP     FLOAT;
   V_CALCPISIMP     VARCHAR2(01);
   V_CDPISIMP       VARCHAR2(02);
   V_NRITPISIMP     VARCHAR2(01);
   V_CDPISNFE       VARCHAR2(02);
   V_PRODPISIMP     VARCHAR2(04);
   V_VRPISIMP       FLOAT;
   V_ALIQCOFIMP     FLOAT;
   V_CALCCOFIMP     VARCHAR2(01);
   V_CDCOFIMP       VARCHAR2(02);
   V_NRITCOFIMP     VARCHAR2(01);
   V_CDCOFNFE       VARCHAR2(02);
   V_PRODCOFIMP     VARCHAR2(04);
   V_VRCOFIMP       FLOAT;
   V_ALIQIMPII      FLOAT;
   V_CALCIIIMP      VARCHAR2(01);
   V_CDIIIMP        VARCHAR2(02);
   V_NRITIIIMP      VARCHAR2(01);
   V_CDIINFE        VARCHAR2(02);
   V_PRODIIIMP      VARCHAR2(04);
   V_VRIIIMP        FLOAT;
   V_ALIQIPIIMP     FLOAT;
   V_CALCIPIIMP     VARCHAR2(01);
   V_CDIPIIMP       VARCHAR2(02);
   V_NRITIPIIMP     VARCHAR2(01);
   V_CDIPINFE       VARCHAR2(02);
   V_PRODIPIIMP     VARCHAR2(04);
   V_VRIPIIMP       FLOAT;
   V_ALIQICMSIMP    FLOAT;
   V_CALCICMSIMP    VARCHAR2(01);
   V_CDICMSIMP      VARCHAR2(02);
   V_NRITICMSIMP    VARCHAR2(01);
   V_CDICMSNFE      VARCHAR2(02);
   V_PRODICMSIMP    VARCHAR2(04);
   V_VRICMSIMP      FLOAT;
   V_IDNFPRESTSERV  VARCHAR2(01);
   V_IDEMISFILNFSERV VARCHAR2(01);
   V_IDUTLOCPRESTSERV VARCHAR2(01);
   V_ESTAPRESTSERV    VARCHAR2(02);
   V_MUNIPRESTSERV    VARCHAR2(04);
   V_IDCOMPRABONI   VARCHAR2(01);
   V_COMPCUSTPROD   VARCHAR2(01);
   V_CARGA          FLOAT;
   V_IDENDEMIS     VARCHAR2(01);
   V_CDFISCOPERREGRA     VARCHAR2(10);
   V_DSCDFISOPEITREGRA   VARCHAR2(50);
   V_IDDIFEALIQREGRA     VARCHAR2(10);
   V_IDDIFALIQCUSPRREGRA VARCHAR2(10);
   V_IDIMPORTAIMPXML     VARCHAR2(01);
   --VARIÁVEIS PARA ATUALIZAR ESTOQUE POR CFOP
   V_ATUPORCFOP    VARCHAR2(01);
   V_CFOPTPOPER    FLOAT;
   V_CFOPATUEST    FLOAT;
   V_IDNFRETIND    VARCHAR2(01);
   V_CDPRODORIG    VARCHAR2(10);
   V_DSENDEDEVOEMBA    VARCHAR2(255);
   V_RESULT_GERA_EST   VARCHAR2(50);
   V_NRACESSONFE       VARCHAR2(44);
   V_ENCIMPXML         VARCHAR2(05);
   /* variáveis para geração de saída no estoque (filial agente de terceiração) */
   V_CDFILIAGENT       VARCHAR2(04);
   V_BOLANESTSAIDAG    BOOLEAN := TRUE;
   V_NRLANESTENTRAG    NOVOCODIGO.NRSEQUENCIAL%TYPE;
   V_CDALMOXARIFEAG    ALMOXARIFADO.CDALMOXARIFE%TYPE;
   V_CDLOCALESTOQAG    LOCALESTOQUE.CDLOCALESTOQ%TYPE;
   V_IDUTILLOTEAG      VARCHAR2(01);
   V_NRLOTEESTQAG      VARCHAR2(20);
   V_NRSUBLOTEAG       VARCHAR2(04);
   V_NRLANCTONFAG      VARCHAR2(20);
   V_CDEMPRESAAG       VARCHAR2(02);
   V_CDINSCESTAAG      VARCHAR2(16);
   V_CDINSCMUNIAG      VARCHAR2(16);
   V_CDFORNAGETERC     VARCHAR2(21);
   V_IDUTORIGPROD      VARCHAR2(01);
   V_TPOPERREMESSA     VARCHAR2(02);
   V_VRPERDIFERE       FLOAT;
   V_PERDIFERE         FLOAT;
   V_IMPOSTOOPERA      FLOAT;
   V_IMPOSTODIFER      FLOAT;
   V_VRIMPOSTOOPERAIT  FLOAT;
   V_VRPERDIFEREIT     FLOAT;
   V_VRIMPOSTODIFERIT  FLOAT;
   V_CDFILIALSAGA      VARCHAR2(20);
   V_IDATUESTLANCNFE   VARCHAR2(1);
   V_CDFILIOLAGETERC   VARCHAR2(04);
   V_IDTRATIMPO        VARCHAR2(01);
   V_VRIMPANTE         FLOAT;
   V_VRIMPAPOS         FLOAT;
   V_IDNFAJUSTE        VARCHAR2(01);
   V_IDIMPDESONERA     VARCHAR2(01);
   V_IDENTEMIS         VARCHAR2(01);
   V_VRADICALIQFECP    FLOAT;
   V_VRADICFECP        FLOAT;
   V_SOMAVRADICFECP    FLOAT;
   V_VRIMPORETNF       FLOAT;
   V_VRIMPORELAC       FLOAT;
   V_IDCALCVRTOTANFE   VARCHAR2(01);
   V_CDBENEFFISCAL     VARCHAR2(10);
   V_CDCEST            VARCHAR2(09);
   V_CASASDEC     NUMBER;
   V_DSNOTAFISORIGOL VARCHAR2(14);
   V_IDCONSDIFALIQ     VARCHAR2(01);
   V_VRICMSNF          NUMBER;
   V_VRALIQICMSINT     NUMBER;
   V_ALIQICMS          NUMBER;
   V_CDIMPOSTOICMS     VARCHAR2(02);
   V_ALIQSTDIF         NUMBER;
   V_BASECALCDIF       NUMBER;
   V_IMPOSTODIF        NUMBER;
BEGIN
   V_CDCFOPINFUSU := '';
--VARIÁVEIS COM A CHAVE PARA AS TABELAS TEMPORÁRIAS
   V_ALIQTEMP := P_FILIAL||P_LANCTONF;
   V_INCITEMP := P_FILIAL||P_LANCTONF;
   V_CSTTEMP  := P_FILIAL||P_LANCTONF;
   V_CFOPTEMP := P_FILIAL||P_LANCTONF;
---------------------------------------------------------------------------------------------------------
   BEGIN
      SELECT
         IDTPIJURNF,             NRINSJURNF,     CDSERIEENTR,    CDFILIRECE,
         CDINTEGRACAO,           NVL(VRNOTAFISC,0),     CDFILIEMIT,     DTENTRSAID,
         NRNOTAFISC,             IDDOCFINANC,    IDSTATUS,
         NVL(IDORIGDESTNF, W_F), IDDOCREPLIC,
         NVL(P.IDCTRLESTQ, W_S), NVL(IDSISTEMA, W_DFE), NVL(TO_NUMBER(P.CDTIPCUSTEST),3), NVL(P.DTPROCESSA, SYSDATE),
         IDNFGERADAVIAXML, CDFILIALSAGA, IDATUESTLANCNFE, SGESTADO, CDMUNICIPIO, NRACESSONFE, DSNOTAFISORIGOL,
         CDCFOPINFUSU, DSCFOPINFUSU
      INTO V_IDTPIJURNF,   V_NRINSJURNF,  V_SERIE,       V_CDFILIRECE,
           V_INTEGRACAO,   V_NOTAFISC,    V_CDFILIEMIT,  V_DTENTRSAID,
           V_NRNOTAFISC,   V_IDDOCFINANC, V_IDSTATUS,
           V_IDORIGDESTNF, V_IDDOCREPLIC,
           V_IDCTRLESTQ,   V_IDSISTEMA, V_CDTIPCUSTEST, V_DTATUAL,
           V_IDNFGERADAVIAXML, V_CDFILIALSAGA, V_IDATUESTLANCNFE, V_ESTAPRESTSERV, V_MUNIPRESTSERV, V_NRACESSONFE, V_DSNOTAFISORIGOL,
           V_CDCFOPINFUSU,    V_DSCFOPINFUSU
      FROM NOTAFISCAL N, PARAMFILIAL P
      WHERE N.CDFILIAL = P_FILIAL      AND
            NRLANCTONF = P_LANCTONF    AND
            CDFILIRECE = P.CDFILIAL(+);
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_IDTPIJURNF   := NULL;  V_NRINSJURNF    := NULL;   V_SERIE      := NULL;   V_CDFILIRECE := NULL;
         V_INTEGRACAO   := NULL;  V_NOTAFISC      := 0;      V_CDFILIEMIT := NULL;   V_DTENTRSAID := NULL;
         V_NRNOTAFISC   := NULL;  V_IDDOCFINANC   := NULL;   V_IDSTATUS   := NULL;
         V_IDORIGDESTNF := W_F;   V_IDDOCREPLIC   := NULL;
         V_IDCTRLESTQ   := W_S;   V_IDSISTEMA     := W_DFE;  V_CDTIPCUSTEST := 3; V_DTATUAL := SYSDATE;
         V_ESTAPRESTSERV := NULL; V_MUNIPRESTSERV := NULL;   V_NRACESSONFE := NULL; V_DSNOTAFISORIGOL := NULL;
         V_CDCFOPINFUSU  := NULL; V_DSCFOPINFUSU  := NULL;
   END;
   BEGIN
      SELECT CDFILIAL||NRLANCESTQ
      INTO V_IDDOCREPLIC
      FROM LANCTOESTOQ
      WHERE CDFILIAL   = SUBSTR(V_IDDOCREPLIC, 1, 4) AND
            NRLANCTONF = SUBSTR(V_IDDOCREPLIC, 5, 10);
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_IDDOCREPLIC := NULL;
   END;
   --SE O DOCUMENTO NÃO FOI CRIADO POR REPLICAÇÃO DE DOCUMENTOS
   IF V_IDDOCREPLIC IS NULL THEN
      BEGIN
         SELECT CDFILIAL||NRLANCESTQ
         INTO V_IDDOCREPLIC
         FROM LANCTOESTOQ
         WHERE CDFILIAL   = SUBSTR(V_INTEGRACAO, 1, 4) AND
               NRLANCTONF = SUBSTR(V_INTEGRACAO, 5, 10);
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_IDDOCREPLIC := NULL;
      END;
   END IF;
   --VARIÁVEIS PARA ARMAZENAMENTO DOS PARÂMETROS DE FATURAMENTO GERAIS,
   --NÚMERO DE CASAS DECIMAIS UTILIZADO NAS TOTALIZAÇÕES DAS NF´S
   --IDENTIFICADOR DE PERMISSÃO DE LANÇAMENTO DE NF ATRAVÉS DE OUTRAS NF´S (ESNF X ATRASADA)
   BEGIN
      SELECT SUBSTR(DSPARAMFATGE,73,10), NVL(NRDECITOTANF, 2), NVL(IDNFOUTRASNF, W_N), IDPERALTCSTFENF, NVL(IDSUGMODNF, W_N),
             NVL(IDGERNFIGUALXML, 'N'), NVL(IDUTORIGPROD, 'N') AS IDUTORIGPROD, NVL(IDCALCVRTOTANFE, 'N') AS IDCALCVRTOTANFE
      INTO   V_CDPRGENEREV,              V_NRDECITOTANF,       V_IDNFOUTRASNF,         V_IDPERALTCSTFENF, V_IDSUGMODNF,
             V_IDGERNFIGUALXML, V_IDUTORIGPROD, V_IDCALCVRTOTANFE
      FROM PARAMGERAL;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_CDPRGENEREV := NULL; V_NRDECITOTANF := 2; V_IDNFOUTRASNF := W_N; V_IDPERALTCSTFENF := W_N; V_IDUTORIGPROD := 'N';
         V_IDCALCVRTOTANFE := 'N';
   END;
   IF V_INTEGRACAO IS NOT NULL THEN
      IF P_ENTRSAID = W_S THEN
         V_CDFILIRECE := V_CDFILIEMIT;
      END IF;
   END IF;
-------------------------------------------------------------------------------------------------------
--MAIOR REGISTRO DA TABELA DE DADOS ADICIONAIS
   SELECT MAX(NRDADOADIC)
     INTO   V_DADOADIC
     FROM DADOSADIC
    WHERE (CDFILIAL   = P_FILIAL) AND
          (NRLANCTONF = P_LANCTONF);
   IF (V_DADOADIC IS NULL) THEN
      V_DADOADIC := '001';
   ELSE
      V_DADOADIC := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_DADOADIC) + 1)),3,0);
      /*GERA O PROXIMO SEQUENCIAL A SER INSERIDO*/
   END IF;
   FOR C_MENSINSC IN (SELECT M.CDMENSAGEM, M.DSMENSAGEM
                        FROM MENSINSCRESTAD I, MENSAGEM M
                       WHERE (I.CDEMPRESA = P_EMPRESA)
                         AND (I.CDINSCESTA = P_INSCESTA)
                         AND (I.CDMENSAGEM = M.CDMENSAGEM)
                         AND (I.IDENTRSAIDMENS <> 'S')
                         AND (M.IDSITUACAOMENS  = 'A')
                         AND (I.DSMENSINSCRESTA NOT IN (SELECT DSDADOADIC
                                                          FROM DADOSADIC
                                                         WHERE (CDFILIAL = P_FILIAL)
                                                           AND (NRLANCTONF = P_LANCTONF)))) LOOP
      /*PREENCHE AS MENSAGENS ATRELADAS A INSCRICAO ESTADUAL*/
      INSERT INTO DADOSADIC(CDFILIAL, NRLANCTONF, NRDADOADIC, CDMENSAGEM, DSDADOADIC)
                     VALUES(P_FILIAL, P_LANCTONF, V_DADOADIC, C_MENSINSC.CDMENSAGEM, C_MENSINSC.DSMENSAGEM);
      V_DADOADIC := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_DADOADIC) + 1)),3,0);
   END LOOP;
----------------------------------------------------------------------------------------------------------
   IF V_IDORIGDESTNF = 'C' THEN
      FOR C_MENSCLIENTE IN (SELECT M.CDMENSAGEM, C.DSMENSCLIENTE
                              FROM MENSCLIENTE C LEFT JOIN MENSAGEM M ON (M.CDMENSAGEM = C.CDMENSAGEM)
                             WHERE C.CDCLIENTE = P_FORNECED
                               AND C.IDENTRSAIDMENS <> 'S'
                               AND (((C.CDMENSAGEM IS NOT NULL) AND (M.IDSITUACAOMENS  = 'A')) OR (C.CDMENSAGEM IS NULL))
                               AND NOT EXISTS (SELECT DSDADOADIC
                                                 FROM DADOSADIC
                                                WHERE (CDFILIAL = P_FILIAL)
                                                  AND (NRLANCTONF = P_LANCTONF)
                                                  AND (DSDADOADIC LIKE C.DSMENSCLIENTE || '%'))
                             ORDER BY C.NRMENSCLIENTE)
      LOOP
         INSERT INTO DADOSADIC
            (CDFILIAL,
             NRLANCTONF,
             NRDADOADIC,
             CDMENSAGEM,
             DSDADOADIC)
         VALUES
            (P_FILIAL,
             P_LANCTONF,
             V_DADOADIC,
             C_MENSCLIENTE.CDMENSAGEM,
             C_MENSCLIENTE.DSMENSCLIENTE);
         V_DADOADIC := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_DADOADIC) + 1)),3,0);
      END LOOP;
   END IF;
   BEGIN
      SELECT TRANSLATE(SUBSTR('Devolver as embalagens vazias no seguinte endereço: ' ||
             PRE.DSPOSTORECEMB ||
             ', ' || PRE.DSENDERECEMB ||
             CASE NVL(PRE.DSCOMPENDERECEMB, '!X!X!') WHEN '!X!X!' THEN '' ELSE ', ' || PRE.DSCOMPENDERECEMB END ||
             ', ' || B.NMBAIRRO ||
             ', CEP:' || PRE.NRCEPRECEMB ||
             ', ' || M.NMMUNICIPIO ||
             ', ' || E.SGESTADO ||
             ', ' || P.NMPAIS ||
             CASE NVL(PRE.NRTELERECEMB, '!X!X!') WHEN '!X!X!' THEN '' ELSE '. Telefone: ' || PRE.NRTELERECEMB END ||
             CASE NVL(PRE.NRFAXRECEMB, '!X!X!') WHEN '!X!X!' THEN '' ELSE '. FAX: ' || PRE.NRFAXRECEMB END, 1, 255), 'áâãäæèïéìëíîçåñòóôöõàøúüûùýÁÂÃÄÆÈÏÉÌËÍÎÅÑÒÓÔÖÕÀØÚÜÛÙÝÇ', 'aaaaaeieieiicanoooooaouuuuyAAAAAEIEIEIIANOOOOOAOUUUUYC') AS DSENDEDEVOEMBA
        INTO V_DSENDEDEVOEMBA
        FROM NOTAFISCAL N JOIN ITEMPRODUTO I ON (N.CDFILIAL = I.CDFILIAL) AND
                                                (N.NRLANCTONF = I.NRLANCTONF)
                          JOIN PRODUTO PR ON (I.CDPRODUTO = PR.CDPRODUTO)
                          JOIN (SELECT P.CDPOSTORECEMB, PR.CDARVPROD
                                  FROM PRODPOSTORECEMB P JOIN PRODUTO PR ON (P.CDPRODUTO = PR.CDPRODUTO)) PPRE ON (INSTR(PR.CDARVPROD, NVL(RTRIM(PPRE.CDARVPROD), PR.CDARVPROD)) = 1)
                          JOIN CLIEPOSTORECEMB C ON (N.CDCLIENTE = C.CDCLIENTE) AND
                                                    (PPRE.CDPOSTORECEMB = C.CDPOSTORECEMB)
                          JOIN POSTORECEMB PRE ON (C.CDPOSTORECEMB = PRE.CDPOSTORECEMB)
                          JOIN PAIS P ON (PRE.CDPAIS = P.CDPAIS)
                          JOIN ESTADO E ON (PRE.CDPAIS = E.CDPAIS) AND
                                           (PRE.SGESTADO = E.SGESTADO)
                          JOIN MUNICIPIO M ON (PRE.CDPAIS = M.CDPAIS) AND
                                              (PRE.SGESTADO = M.SGESTADO) AND
                                              (PRE.CDMUNICIPIO = M.CDMUNICIPIO)
                          JOIN BAIRRO B ON (PRE.CDPAIS = B.CDPAIS) AND
                                           (PRE.SGESTADO = B.SGESTADO) AND
                                           (PRE.CDMUNICIPIO = B.CDMUNICIPIO) AND
                                           (PRE.CDBAIRRO = B.CDBAIRRO)
       WHERE N.CDFILIAL = P_FILIAL
         AND N.NRLANCTONF = P_LANCTONF
         AND NOT EXISTS (SELECT DSDADOADIC
                           FROM DADOSADIC
                          WHERE (CDFILIAL = P_FILIAL)
                            AND (NRLANCTONF = P_LANCTONF)
                            AND (DSDADOADIC LIKE TRANSLATE(SUBSTR('Devolver as embalagens vazias no seguinte endereço: ' ||
                                                 PRE.DSPOSTORECEMB ||
                                                 ', ' || PRE.DSENDERECEMB ||
                                                 CASE NVL(PRE.DSCOMPENDERECEMB, '!X!X!') WHEN '!X!X!' THEN '' ELSE ', ' || PRE.DSCOMPENDERECEMB END ||
                                                 ', ' || B.NMBAIRRO ||
                                                 ', CEP:' || PRE.NRCEPRECEMB ||
                                                 ', ' || M.NMMUNICIPIO ||
                                                 ', ' || E.SGESTADO ||
                                                 ', ' || P.NMPAIS ||
                                                 CASE NVL(PRE.NRTELERECEMB, '!X!X!') WHEN '!X!X!' THEN '' ELSE '. Telefone: ' || PRE.NRTELERECEMB END ||
                                                 CASE NVL(PRE.NRFAXRECEMB, '!X!X!') WHEN '!X!X!' THEN '' ELSE '. FAX: ' || PRE.NRFAXRECEMB END, 1, 255), 'áâãäæèïéìëíîçåñòóôöõàøúüûùýÁÂÃÄÆÈÏÉÌËÍÎÅÑÒÓÔÖÕÀØÚÜÛÙÝÇ', 'aaaaaeieieiicanoooooaouuuuyAAAAAEIEIEIIANOOOOOAOUUUUYC') || '%'));
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_DSENDEDEVOEMBA := NULL;
      WHEN TOO_MANY_ROWS THEN
         RAISE_APPLICATION_ERROR(-20501, 'Operação bloqueada. Existem mais de um posto de recolhimento de embalagens cadastradas no sistema.', TRUE);
   END;
   IF (V_DSENDEDEVOEMBA IS NOT NULL) THEN
      INSERT INTO DADOSADIC
         (CDFILIAL,
          NRLANCTONF,
          NRDADOADIC,
          CDMENSAGEM,
          DSDADOADIC)
      VALUES
         (P_FILIAL,
          P_LANCTONF,
          V_DADOADIC,
          '',
          V_DSENDEDEVOEMBA);
      V_DADOADIC := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_DADOADIC) + 1)),3,0);
   END IF;
   --VARIÁVEIS (IDENTIFICADOR PARA OPERAÇÃO DE DEVOLUÇÃO,)
   BEGIN
      SELECT NVL(IDOPERDEVONF, W_N), NVL(IDATUESTTPOP, V_IDCTRLESTQ), NVL(IDUTCUSORIGEST, W_N),
             NVL(IDNOTADEVO, W_N),   NVL(IDNFPRESTSERV, W_N),         NVL(IDCMPVNDBONI, W_N),
             NVL(IDUTLOCPRESTSERV, W_N),  NVL(IDUTILVENC, 'N'), NVL(IDNFAJUSTE, 'N'),
             NVL(IDNFIMPORTACAO, 'N')
        INTO V_IDOPERDEVONF, V_IDCTRLESTQ,    V_IDUTCUSORIGEST,
             V_IDNOTADEVO,   V_IDNFPRESTSERV, V_IDCOMPRABONI,
             V_IDUTLOCPRESTSERV, V_IDUTILVENC, V_IDNFAJUSTE,
             V_IDNFIMPORTACAO
        FROM TIPOOPERAC
       WHERE IDENTRSAIDOP = P_ENTRSAID
         AND CDTIPOOPER   = P_TIPOOPER;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_IDOPERDEVONF   := W_N; V_IDCTRLESTQ       := V_IDCTRLESTQ;
         V_IDUTCUSORIGEST := W_N; V_IDNOTADEVO       := W_N;
         V_IDNFPRESTSERV  := W_N; V_IDUTLOCPRESTSERV := W_N;
         V_IDUTILVENC     := W_N; V_IDNFAJUSTE       := W_N;
         V_IDNFIMPORTACAO := W_N;
   END;
   --VARIÁVEIS PARA CONSULTA DE ALÍQUOTA, INCIDÊNCIA, CFOP
   BEGIN
      SELECT CDPAIS,     SGESTADO,   CDMUNICIPIO, IDCALCDIFENTFISC
      INTO   V_PAISDEST, V_ESTADEST, V_MUNIDEST, V_IDCALCDIFENTFISC
      FROM INSCRESTAD
      WHERE (CDEMPRESA  = P_EMPRESA) AND
            (CDINSCESTA = P_INSCESTA);
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_PAISDEST := NULL; V_ESTADEST := NULL; V_MUNIDEST := NULL; V_IDCALCDIFENTFISC := 'N';
   END;
   IF V_IDNFPRESTSERV = 'S' THEN
      BEGIN
         SELECT NVL(MAX(IDEMISFILNFSERV),'P')
           INTO V_IDEMISFILNFSERV
           FROM FILIAL
          WHERE (CDFILIAL     = V_CDFILIRECE);
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_IDEMISFILNFSERV := 'P';
      END;
      IF (V_IDEMISFILNFSERV <> 'I') THEN
         BEGIN
            SELECT MAX(CDPAIS), MAX(SGESTADO), MAX(CDMUNICIPIO)
              INTO V_PAISDEST, V_ESTADEST, V_MUNIDEST
              FROM ENDEFILI
             WHERE (CDFILIAL     = V_CDFILIRECE) AND
                   (IDTPENDEFILI = V_IDEMISFILNFSERV);
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_PAISDEST := NULL; V_ESTADEST := NULL; V_MUNIDEST := NULL;
         END;
      END IF;
   END IF;
   IF (V_IDNFPRESTSERV = 'S') AND (V_IDUTLOCPRESTSERV = 'S') THEN
      V_ESTADEST := NVL(V_ESTAPRESTSERV , V_ESTADEST);
      V_MUNIDEST := NVL(V_MUNIPRESTSERV, V_MUNIDEST);
   END IF;
   V_CDORIGDESTNF := P_FORNECED;
   --SE O IDENTIFICADOR DE ORIGEM DO LANÇAMENTO FOR IGUAL A FILIAL
   IF V_IDORIGDESTNF = W_L THEN
      BEGIN
         SELECT NVL(MAX(IDENDCFOPFIL),'I'), NVL(MAX(IDENDEMISFIL),'I'), MAX(CDEMPRESA), MAX(CDINSCESTA)
           INTO V_IDENDCFOP, V_IDENDEMIS, V_CDEMPRESA, V_CDINSCESTA
           FROM FILIAL
          WHERE (CDFILIAL = V_CDFILIEMIT);
      EXCEPTION
         When No_Data_Found Then
            V_IDENDCFOP := 'I'; V_IDENDEMIS := 'I'; V_CDEMPRESA := Null; V_CDINSCESTA := Null;
      END;
      SELECT MAX(CDPAIS), MAX(SGESTADO), MAX(CDMUNICIPIO)
        INTO V_CDPAISST, V_SGESTADOST, V_CDMUNICIPIOST
        FROM ENDEFILI
       WHERE CDFILIAL = V_CDFILIEMIT
         AND IDTPENDEFILI = 'P';
      SELECT MAX(CDINSCESTAST)
        INTO V_CDINSCESTAST
        FROM INSCRESTADST
       WHERE CDEMPRESA = P_EMPRESA
         AND CDINSCESTA = P_INSCESTA
         AND CDPAIS = V_CDPAISST
         AND SGESTADO = V_SGESTADOST;
      IF V_IDENDCFOP = W_I THEN
         BEGIN
            SELECT CDPAIS    , SGESTADO
            INTO   V_PAISCFOP, V_ESTACFOP
            FROM INSCRESTAD
            WHERE CDEMPRESA  = V_CDEMPRESA AND
                  CDINSCESTA = V_CDINSCESTA;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_PAISCFOP := NULL; V_ESTACFOP := NULL;
         END;
      ELSE
         BEGIN
            SELECT CDPAIS, SGESTADO
            INTO V_PAISCFOP, V_ESTACFOP
            FROM ENDEFILI
            WHERE (CDFILIAL     = V_CDFILIEMIT) AND
                  (IDTPENDEFILI = V_IDENDCFOP);
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_PAISCFOP := NULL; V_ESTACFOP := NULL;
         END;
      END IF;
      IF V_IDENDEMIS = 'I' THEN
         Begin
            SELECT MAX(CDPAIS)    , MAX(SGESTADO)  , MAX(CDMUNICIPIO)
            INTO   V_PAISORIG, V_ESTAORIG, V_MUNIORIG
            FROM INSCRESTAD
            WHERE CDEMPRESA  = V_CDEMPRESA AND
                  CDINSCESTA = V_CDINSCESTA;
         Exception
            When No_Data_Found Then
               V_PAISORIG := Null; V_ESTAORIG := Null; V_MUNIORIG := Null;
         End;
      ELSE
         Begin
            SELECT MAX(CDPAIS)    , MAX(SGESTADO)  , MAX(CDMUNICIPIO)
            INTO   V_PAISORIG, V_ESTAORIG, V_MUNIORIG
            FROM ENDEFILI
            WHERE CDFILIAL     = V_CDFILIEMIT AND
                  IDTPENDEFILI = V_IDENDEMIS;
         Exception
            When No_Data_Found Then
               V_PAISORIG := Null; V_ESTAORIG := Null; V_MUNIORIG := Null;
         End;
      END IF;
      V_CDORIGDESTNF := V_CDFILIEMIT;
   --SE O IDENTIFICADOR DE ORIGEM DO LANÇAMENTO FOR IGUAL A CLIENTE
   ELSIF V_IDORIGDESTNF = W_C THEN
      BEGIN
         SELECT NVL(MAX(IDENDCFOPCLI),W_P)
           INTO   V_IDENDCFOP
           FROM CLIENTE
          WHERE (CDCLIENTE = P_FORNECED);
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_IDENDCFOP := W_P;
      END;
      SELECT MAX(CDPAIS), MAX(SGESTADO), MAX(CDMUNICIPIO)
        INTO V_CDPAISST, V_SGESTADOST, V_CDMUNICIPIOST
        FROM ENDECLIE
       WHERE CDCLIENTE = P_FORNECED
         AND IDTPENDECLIE = 'P';
      SELECT MAX(CDINSCESTAST)
        INTO V_CDINSCESTAST
        FROM INSCRESTADST
       WHERE CDEMPRESA = P_EMPRESA
         AND CDINSCESTA = P_INSCESTA
         AND CDPAIS = V_CDPAISST
         AND SGESTADO = V_SGESTADOST;
      IF V_IDENDCFOP = W_I THEN
         BEGIN
            SELECT CDPAIS    , SGESTADO
            INTO   V_PAISCFOP, V_ESTACFOP
            FROM INSCRESTAD
            WHERE CDEMPRESA  = P_EMPRESA AND
                  CDINSCESTA = P_INSCESTA;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_PAISCFOP := NULL; V_ESTACFOP := NULL;
         END;
      ELSE
         BEGIN
            SELECT CDPAIS, SGESTADO
            INTO V_PAISCFOP, V_ESTACFOP
            FROM ENDECLIE
            WHERE (CDCLIENTE    = P_FORNECED) AND
                  (IDTPENDECLIE = V_IDENDCFOP);
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_PAISCFOP := NULL; V_ESTACFOP := NULL;
         END;
      END IF;
      BEGIN
        SELECT CDPAIS, SGESTADO, CDMUNICIPIO
          INTO V_PAISORIG, V_ESTAORIG, V_MUNIORIG
          FROM ENDECLIE
         WHERE (CDCLIENTE    = P_FORNECED) AND
               (IDTPENDECLIE = W_P);
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_PAISORIG := NULL; V_ESTAORIG := NULL; V_MUNIORIG := NULL;
      END;
   --SE O IDENTIFICADOR DE ORIGEM DO LANÇAMENTO FOR IGUAL A FORNECEDOR
   ELSIF V_IDORIGDESTNF = W_F THEN
      BEGIN
         SELECT NVL(IDENDCFOPFOR,W_P)
         INTO   V_IDENDCFOP
         FROM FORNECEDOR
         WHERE (CDFORNECED = P_FORNECED);
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_IDENDCFOP := W_P;
      END;
      SELECT MAX(CDPAIS), MAX(SGESTADO), MAX(CDMUNICIPIO)
        INTO V_CDPAISST, V_SGESTADOST, V_CDMUNICIPIOST
        FROM ENDEFORN
       WHERE CDFORNECED = P_FORNECED
         AND IDTPENDEFORN = 'P';
      SELECT MAX(CDINSCESTAST)
        INTO V_CDINSCESTAST
        FROM INSCRESTADST
       WHERE CDEMPRESA = P_EMPRESA
         AND CDINSCESTA = P_INSCESTA
         AND CDPAIS = V_CDPAISST
         AND SGESTADO = V_SGESTADOST;
      IF V_IDENDCFOP = W_I THEN
         BEGIN
            SELECT CDPAIS    , SGESTADO
            INTO   V_PAISCFOP, V_ESTACFOP
            FROM INSCRESTAD
            WHERE CDEMPRESA  = P_EMPRESA AND
                  CDINSCESTA = P_INSCESTA;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_PAISCFOP := NULL; V_ESTACFOP := NULL;
         END;
      ELSE
         BEGIN
            SELECT CDPAIS, SGESTADO
              INTO V_PAISCFOP, V_ESTACFOP
              FROM ENDEFORN
             WHERE (CDFORNECED   = P_FORNECED) AND
                   (IDTPENDEFORN = V_IDENDCFOP);
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_PAISCFOP := NULL; V_ESTACFOP := NULL;
         END;
      END IF;
      BEGIN
         SELECT CDPAIS, SGESTADO, CDMUNICIPIO
           INTO V_PAISORIG, V_ESTAORIG, V_MUNIORIG
           FROM ENDEFORN
          WHERE (CDFORNECED   = P_FORNECED) AND
                (IDTPENDEFORN = W_P);
       EXCEPTION
          WHEN NO_DATA_FOUND THEN
             V_PAISORIG := NULL; V_ESTAORIG := NULL; V_MUNIORIG := NULL;
       END;
   ELSE
      --SE O IDENTIFICADOR DE ORIGEM DO LANÇAMENTO FOR IGUAL A LICENCA DE USO OU OUTRO VALOR DIFERENTE DE L,C,F
      IF P_ENTRSAID = W_E THEN
         BEGIN
            SELECT CDPAIS, SGESTADO, CDMUNICIPIO
            INTO V_PAISORIG, V_ESTAORIG, V_MUNIORIG
            FROM ENDEFORN
            WHERE (CDFORNECED   = P_FORNECED) AND
                  (IDTPENDEFORN = W_P);
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_PAISORIG := NULL; V_ESTAORIG := NULL; V_MUNIORIG := NULL;
         END;
         SELECT MAX(CDPAIS), MAX(SGESTADO), MAX(CDMUNICIPIO)
           INTO V_CDPAISST, V_SGESTADOST, V_CDMUNICIPIOST
           FROM ENDEFORN
          WHERE CDFORNECED = P_FORNECED
            AND IDTPENDEFORN = 'P';
         SELECT MAX(CDINSCESTAST)
           INTO V_CDINSCESTAST
           FROM INSCRESTADST
          WHERE CDEMPRESA = P_EMPRESA
            AND CDINSCESTA = P_INSCESTA
            AND CDPAIS = V_CDPAISST
            AND SGESTADO = V_SGESTADOST;
      ELSIF P_ENTRSAID = W_S THEN
         BEGIN
            SELECT CDPAIS, SGESTADO, CDMUNICIPIO
            INTO V_PAISORIG, V_ESTAORIG, V_MUNIORIG
            FROM ENDECLIE
            WHERE (CDCLIENTE    = P_FORNECED) AND
                  (IDTPENDECLIE = W_P);
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_PAISORIG := NULL; V_ESTAORIG := NULL; V_MUNIORIG := NULL;
         END;
         SELECT MAX(CDPAIS), MAX(SGESTADO), MAX(CDMUNICIPIO)
           INTO V_CDPAISST, V_SGESTADOST, V_CDMUNICIPIOST
           FROM ENDECLIE
          WHERE CDCLIENTE = P_FORNECED
            AND IDTPENDECLIE = 'P';
         SELECT MAX(CDINSCESTAST)
           INTO V_CDINSCESTAST
           FROM INSCRESTADST
          WHERE CDEMPRESA = P_EMPRESA
            AND CDINSCESTA = P_INSCESTA
            AND CDPAIS = V_CDPAISST
            AND SGESTADO = V_SGESTADOST;
      END IF;
   END IF;
   IF (V_CDINSCESTAST IS NOT NULL) OR (V_CDINSCESTAST = '')  THEN
      UPDATE NOTAFISCAL
         SET CDINSCESTAST = V_CDINSCESTAST
       WHERE CDFILIAL = P_FILIAL
         AND NRLANCTONF = P_LANCTONF;
      FOR C_MENSINSCESTAST IN (SELECT M.CDMENSAGEM, I.DSMENSINSCESTAST
                                 FROM MENSINSCESTAST I LEFT JOIN MENSAGEM M ON (M.CDMENSAGEM = I.CDMENSAGEM)
                                WHERE I.CDEMPRESA = P_EMPRESA
                                  AND I.CDINSCESTA = P_INSCESTA
                                  AND I.CDINSCESTAST = V_CDINSCESTAST
                                  AND I.IDENTRSAIDMENSST <> 'S'
                                  AND (((I.CDMENSAGEM IS NOT NULL) AND (M.IDSITUACAOMENS  = 'A')) OR (I.CDMENSAGEM IS NULL))
                                  AND NOT EXISTS (SELECT DSDADOADIC
                                                    FROM DADOSADIC
                                                   WHERE (CDFILIAL = P_FILIAL)
                                                     AND (NRLANCTONF = P_LANCTONF)
                                                     AND (DSDADOADIC LIKE I.DSMENSINSCESTAST || '%'))
                                ORDER BY NRMENSINSCESTAST) LOOP
         /*PREENCHE AS MENSAGENS ATRELADAS A INSCRICAO ESTADUAL DO SUBSTITUTO TRIBUTÁRIO*/
         INSERT INTO DADOSADIC(CDFILIAL, NRLANCTONF, NRDADOADIC, CDMENSAGEM, DSDADOADIC)
                        VALUES(P_FILIAL, P_LANCTONF, V_DADOADIC, C_MENSINSCESTAST.CDMENSAGEM, C_MENSINSCESTAST.DSMENSINSCESTAST);
         V_DADOADIC := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_DADOADIC) + 1)),3,0);
      END LOOP;
   END IF;
---------------------------------------------------------------------------------------------------------
   V_IDINTEREST := 'N';
   V_IDINTERNAC := 'N';
   IF ((V_PAISDEST = V_PAISORIG) AND (V_ESTADEST <> V_ESTAORIG)) THEN
      V_IDINTEREST := 'S';
   ELSIF (V_PAISDEST <> V_PAISORIG) THEN
      V_IDINTERNAC := 'S';
   END IF;
   -- RETORNA O VALOR LÍQUIDO TOTAL DA NOTA FISCAL
   SELECT SUM(VRLIQUIDO)
     INTO V_LIQUIDO
     FROM (SELECT DECODE(QTITEMPROD, 0, (VRTOTAITEM - VRDESCITEM), (ROUND(QTITEMPROD,4) * ROUND(VRUNITITEM,10)) - ROUND(VRDESCITEM, 2)) AS VRLIQUIDO
             FROM ITEMPRODUTO
            WHERE CDFILIAL   = P_FILIAL
              AND NRLANCTONF = P_LANCTONF);
   -- PREENCHER CLASSIFICACAO FISCAL NCM NA TABELA ITEMPRODUTO
   FOR C_ITEMPRODUTO IN (SELECT I.CDFILIAL, I.NRLANCTONF, I.NRSEQITPROD, P.CDCLASFISC
                           FROM ITEMPRODUTO I, PRODUTO P
                          WHERE I.CDFILIAL   = P_FILIAL
                            AND I.NRLANCTONF = P_LANCTONF
                            AND I.CDPRODUTO = P.CDPRODUTO)
   LOOP
     UPDATE ITEMPRODUTO
        SET CDPRODNCMTRANS = C_ITEMPRODUTO.CDCLASFISC
      WHERE CDFILIAL    = C_ITEMPRODUTO.CDFILIAL
        AND NRLANCTONF  = C_ITEMPRODUTO.NRLANCTONF
        AND NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD;
   END LOOP;
   --INSERE TODOS OS ENCARGOS QUE NÃO POSSUEM NA NOTA FISCAL COM O VALOR IGUAL A ZERO (0)
   INSERT INTO ITEMENCARGO
      (CDFILIAL, NRLANCTONF, CDENCARGO, VRITEMENCA)
      (SELECT P_FILIAL, P_LANCTONF, CDENCARGO, 0
         FROM ENCARGO
        WHERE NOT EXISTS(SELECT CDENCARGO
                           FROM ITEMENCARGO
                          WHERE CDFILIAL   = P_FILIAL
                            AND NRLANCTONF = P_LANCTONF
                            AND CDENCARGO  = ENCARGO.CDENCARGO));
   CONSULTA_GRUPOFISCAL(V_IDORIGDESTNF, V_CDORIGDESTNF, V_CDFILIRECE, W_E, P_TIPOOPER, V_CDGRUPOFISC);
   -- TIPO DE OPERAÇÃO 11 COM PARÂMETRO PARA GERAR NOTA FISCAL INFORMANDO APENAS AS NOTAS FISCAIS 10 DEVE SER GRAVADO IMPOSTO NA TRABITPROIMPOS
   IF (P_TIPOOPER = '11' AND V_IDNFOUTRASNF = W_S) THEN
      SELECT COUNT(*)
        INTO V_QTDEREGTRAB
        FROM TRABITPROIMPOS
       WHERE CDFILIMPOIT  = P_FILIAL
         AND NRLANCIMPOIT = P_LANCTONF;
      IF V_QTDEREGTRAB = 0 THEN
         DELETE
           FROM TRABITPROIMPOS
          WHERE CDFILIMPOIT  = P_FILIAL
            AND NRLANCIMPOIT = P_LANCTONF;
         DELETE
           FROM ALIQTEMPPROD
          WHERE NRALIQTEMP = P_FILIAL||P_LANCTONF;
         DELETE
           FROM INCITEMP
          WHERE NRINCITEMP = P_FILIAL||P_LANCTONF;
         FOR C_ITENSSEMNF IN (SELECT PR.CDARVPROD,  I.VRUNITITEM, I.VRDESCITEM,
                                     I.NRSEQITPROD, I.VRTOTAITEM, PR.CDPRODUTO,
                                     I.QTITEMPROD,  NVL(I.IDORIGEMPROD, 'N') AS IDORIGEMPROD
                                FROM ITEMPRODUTO I, PRODUTO PR
                               WHERE I.CDFILIAL   = P_FILIAL
                                 AND I.NRLANCTONF = P_LANCTONF
                                 AND PR.CDPRODUTO = I.CDPRODUTO) LOOP
            IMPOSTO_ENTRADA_PRODUTO(P_EMPRESA, P_INSCESTA, P_TIPOOPER, P_FORNECED, P_FILIAL, P_LANCTONF,
                                    P_INIVALID, 'E', P_CDOPERADOR, V_CDGRUPOFISC, V_IDINTEREST, C_ITENSSEMNF.CDARVPROD,
                                    '', 'F', V_CDFILIRECE, NULL, NULL, C_ITENSSEMNF.VRTOTAITEM, C_ITENSSEMNF.IDORIGEMPROD);
            FOR C_ALIQITEM IN(SELECT IM.CDIMPOSTO, IM.SGIMPOSTO, IM.IDTRATIMPO, IM.IDPREIMPENTR,
                                     I.CDFISCTEMP, NVL(AL.VRALIQUTMP, 0) AS VRALIQUOTA,
                                     NVL(AL.VRADICALIQFECP, 0) AS VRADICALIQFECP
                                FROM INCITEMP I, IMPOSTO IM, ALIQTEMPPROD AL
                               WHERE I.CDIMPOTEMP  = IM.CDIMPOSTO
                                 AND I.NRINCITEMP  = P_FILIAL||P_LANCTONF
                                 AND I.NRINCITEMP  = AL.NRALIQTEMP(+)
                                 AND I.CDIMPOTEMP  = AL.CDIMPOTEMP(+)
                                 AND IM.IDPRODNOTA <> 'C') LOOP
               INSERT INTO TRABITPROIMPOS
                  (CDFILIMPOIT, NRLANCIMPOIT, NRSEQIMPOIT, CDIMPOSTOIT, VRCONTIMPOIT,
                   VRREDBCIMPOIT, VRBCALCIMPOIT, VRALIQIMPOIT, VRPDEDIMPOIT, VRIMPOSIT,
                   CDFISCIMPOIT,  NRSEQITPRO, IDVALORINFO,
                   VR1REDBCIMPOIT, IDTRIMPSTTI, VRIMPOSVISUIT, VRADICALIQFECP)
               VALUES
                  (P_FILIAL, P_LANCTONF,   LPAD(C_ITENSSEMNF.NRSEQITPROD, 4, '0'), C_ALIQITEM.CDIMPOSTO, (C_ITENSSEMNF.VRTOTAITEM - C_ITENSSEMNF.VRDESCITEM),
                   0, C_ITENSSEMNF.VRTOTAITEM, C_ALIQITEM.VRALIQUOTA, 0, 0,
                   C_ALIQITEM.CDFISCTEMP, '1', 'N',
                   0, '0', 0, C_ALIQITEM.VRADICALIQFECP);
            END LOOP;
            DELETE
              FROM ALIQTEMPPROD
             WHERE NRALIQTEMP = P_FILIAL||P_LANCTONF;
            DELETE
              FROM INCITEMP
             WHERE NRINCITEMP = P_FILIAL||P_LANCTONF;
         END LOOP;
         DELETE TRABIMPOSNFTOT WHERE CDFILIMPTOT = P_FILIAL AND NRLANCIMPTOT = P_LANCTONF;
         FOR C_TRABIMPOTOTSEMNF IN (SELECT SUM(T.VRIMPOSIT) VRTOTAIMPO, T.CDIMPOSTOIT
                                      FROM TRABITPROIMPOS T, IMPOSTO I
                                     WHERE CDFILIMPOIT  = P_FILIAL
                                       AND NRLANCIMPOIT = P_LANCTONF
                                       AND IDPRODNOTA <> 'C'
                                       AND T.CDIMPOSTOIT = I.CDIMPOSTO
                                     GROUP BY CDIMPOSTOIT
                                     ORDER BY CDIMPOSTOIT)LOOP
             INSERT INTO TRABIMPOSNFTOT
                        (CDFILIMPTOT, NRLANCIMPTOT, CDIMPOSTOT, VRIMPOSTOT, VRBCALIMPTOT)
                  VALUES(P_FILIAL, P_LANCTONF, C_TRABIMPOTOTSEMNF.CDIMPOSTOIT, (0 + C_TRABIMPOTOTSEMNF.VRTOTAIMPO), 0);
         END LOOP;
      END IF;   
   END IF;
   -- TIPO DE OPERAÇÃO 11 COM PARÂMETRO PARA GERAR NOTA FISCAL INFORMANDO APENAS AS NOTAS FISCAIS 10 DEVE SER GRAVADO IMPOSTO NA TRABITPROIMPOS
   --SE O TIPO DE OPERAÇÃO DA NOTA FISCAL FOR DEVOLUÇÃO
   IF V_IDOPERDEVONF = W_S THEN
      SELECT MAX(CDFILIALIT), MAX(NRLANCTONFIT)
      INTO V_FILIORIG, V_DEVOLORIG
      FROM ITEMNOTAFISC
      WHERE CDFILIAL   = P_FILIAL   AND
            NRLANCTONF = P_LANCTONF;
      BEGIN
         SELECT MAX(IDIMPDESONERAIT)
           INTO V_IDIMPDESONERA
           FROM ITEMPROIMPOS
          WHERE CDFILIAL   = V_FILIORIG
            AND NRLANCTONF = V_DEVOLORIG
            AND IDIMPDESONERAIT = 'S';
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_IDIMPDESONERA := 'N';
      END;
   END IF;
   IF (V_DEVOLORIG IS NOT NULL) THEN
      UPDATE ITEMPRODUTO
         SET VRTOTAITEM = ROUND(VRTOTAITEM, 2)
       WHERE CDFILIAL   = P_FILIAL
         AND NRLANCTONF = P_LANCTONF;
      SELECT (SUM(VRTOTAITEM) - SUM(VRDESCITEM))
        INTO V_LIQUIDO
        FROM ITEMPRODUTO
       WHERE CDFILIAL   = P_FILIAL AND
             NRLANCTONF = P_LANCTONF;
   END IF;
   -- PARA DOCUMENTOS DE ENTRADA QUE NÃO SEJAM DEVOLUÇÃO SERÁ SUBTRAÍDO AO VALOR TOTAL
   -- E AO VALOR CONTÁBIL O VALOR DO DESCONTO
   IF ((V_INTEGRACAO IS NULL) OR (P_ENTRSAID = W_E)) AND (V_DEVOLORIG IS NULL) THEN
      UPDATE ITEMPRODUTO
      SET VRBRUTITEM   = ROUND((VRTOTAITEM - VRDESCITEM) + NVL(VRICMSSTITORIG, 0), 5),
          VRCONTITEM   = ROUND((VRTOTAITEM - VRDESCITEM) + NVL(VRICMSSTITORIG, 0), 5),
          IDUTVRPAUTAPROD = NULL  
      WHERE CDFILIAL   = P_FILIAL    AND
            NRLANCTONF = P_LANCTONF;
   END IF;
   V_IDNFRETIND   := 'N';
   SELECT NVL(IDNFRETIND, 'N')
     INTO V_IDNFRETIND
     FROM TIPOOPERAC
    WHERE CDTIPOOPER   = P_TIPOOPER
      AND IDENTRSAIDOP = w_E;
   IF (V_IDNFRETIND = 'S') THEN
      UPDATE ITEMPRODUTO
      SET VRBRUTITEM   = ROUND((VRTOTAITEM - VRDESCITEM), 5),
          VRCONTITEM   = ROUND((VRTOTAITEM - VRDESCITEM), 5)
      WHERE CDFILIAL   = P_FILIAL    AND
            NRLANCTONF = P_LANCTONF;
   END IF;
   -- ATUALIZAÇÃO DAS TABELAS DE NOTAFISCAL, ITEMPRODUTO E DADOS ADICIONAIS
   -- PARA OS TIPOS DE OPERAÇÕES DIFERENTES DE ENTRADA SEM NF, VALE DE TRANSFERÊNCIA E OUTRAS SAÍDAS
   IF ((NOT P_TIPOOPER IN ('07','09','10')) AND (V_IDOPERDEVONF <> W_S)) OR ((V_IDOPERDEVONF = W_S) AND (V_DEVOLORIG IS NULL)) OR (V_IDNFRETIND = 'S') THEN
      --IMPORTAÇÃO DE NFS DE ENTRADA NÃO ORIUNDAS DOS
      IF (V_INTEGRACAO IS NULL) OR (P_ENTRSAID = W_E) THEN
         FOR C_ITEMPRODUTO IN (SELECT VRTOTAITEM, VRDESCITEM, I.CDPRODUTO, NRSEQITPROD, P.CDARVPROD,
                                      QTITEMPROD, CDFISOPEITEM, CDSITUTRIBPR, IDORIGEMPROD
                               FROM ITEMPRODUTO I, PRODUTO P
                               WHERE CDFILIAL    = P_FILIAL   AND
                                     NRLANCTONF  = P_LANCTONF AND
                                     I.CDPRODUTO = P.CDPRODUTO) LOOP
            V_LIQUIDOPROD := C_ITEMPRODUTO.VRTOTAITEM - C_ITEMPRODUTO.VRDESCITEM;
            CONSULTA_CST(P_ENTRSAID, P_EMPRESA, C_ITEMPRODUTO.CDARVPROD, P_INSCESTA, P_TIPOOPER, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC, V_IDINTEREST, V_IDINTERNAC, NULL, C_ITEMPRODUTO.IDORIGEMPROD);
            IF V_IDCOMPRABONI = 'N' THEN
               CONSULTA_CFOP(P_ENTRSAID, P_EMPRESA, C_ITEMPRODUTO.CDARVPROD, P_INSCESTA, P_TIPOOPER, V_PAISCFOP,
                              V_ESTACFOP, V_PAISDEST, V_ESTADEST, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC, P_INIVALID, C_ITEMPRODUTO.IDORIGEMPROD );
            END IF;
            -- ALTERA NATUREZA DE OPERAÇÃO DA NOTA FISCAL CASO NÃO EXISTA  E SE O USUARIO NAO INFORMOU
            IF C_ITEMPRODUTO.CDFISOPEITEM IS NULL THEN
               UPDATE NOTAFISCAL
               SET DSCDFISOPENF = (SELECT MAX(DSCFOPTMP) FROM CFOPTEMP
                                     WHERE NRCFOPTEMP = V_CFOPTEMP)
               WHERE CDFILIAL   = P_FILIAL   AND
                     NRLANCTONF = P_LANCTONF AND
                     DSCDFISOPENF IS NULL    AND
                     DSCFOPINFUSU IS NULL;
            END IF;
            SELECT MAX(CDFISOPETMP), MAX(CDSUFCFOPTMP), MAX(IDDIFALIQTMP),
                   MAX(DSCFOPTMP), NVL(MAX(IDDIFALIQCUSPRC),W_N)
            INTO V_FISOPEITEM, V_SUFXCFOPPR, V_DIFALIQITEM,
                 V_DSCDFISOPEIT, V_IDDIFALIQCUSPRC
            FROM CFOPTEMP
            WHERE NRCFOPTEMP = V_CFOPTEMP;
            SELECT MAX(IDORDPRIMDFENT)
              INTO V_IDORDPRIMDFENT
              FROM PARAMGERAL;
            V_FISOPEITEM        := NVL(V_CDFISCOPERREGRA, V_FISOPEITEM);
            V_DSCDFISOPEIT      := NVL(V_DSCDFISOPEITREGRA, V_DSCDFISOPEIT);
            V_DIFALIQITEM       := NVL(V_IDDIFEALIQREGRA, V_DIFALIQITEM);
            V_IDDIFALIQCUSPRC   := NVL(V_IDDIFALIQCUSPRREGRA, V_IDDIFALIQCUSPRC);
            CONSULTA_CSOSN(P_ENTRSAID, P_EMPRESA, C_ITEMPRODUTO.CDARVPROD, P_INSCESTA, P_TIPOOPER, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC, V_IDINTEREST, V_CDFISCOPERSN);
            -- ALTERA O CFOP DO ITEM E
            IF (V_FISOPEITEM IS NULL) AND (C_ITEMPRODUTO.CDFISOPEITEM IS NOT NULL) AND (V_IDGERNFIGUALXML = 'S') AND (V_IDNFGERADAVIAXML = 'S') THEN
               V_FISOPEITEM := C_ITEMPRODUTO.CDFISOPEITEM;
            END IF;
            UPDATE ITEMPRODUTO
            SET CDFISOPEITEM = V_FISOPEITEM,
                CDSUFXCFOPPR = V_SUFXCFOPPR,
                DSCDFISOPEIT =  V_DSCDFISOPEIT,
                CDFISCOPERSN = V_CDFISCOPERSN
            WHERE CDFILIAL    = P_FILIAL   AND
                  NRLANCTONF  = P_LANCTONF AND
                  NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD;
            DELETE CFOPTEMP
            WHERE NRCFOPTEMP = V_CFOPTEMP;
            SELECT MAX(CDSITTRIBTMP) INTO V_SITUTRIBPR
            FROM CSTTEMP
            WHERE NRCSTTEMP = V_CSTTEMP;
            BEGIN
               SELECT CDSITUTRIBPR INTO V_CDCSTDIGI
               FROM ITEMPRODUTO
               WHERE CDFILIAL    = P_FILIAL   AND
                     NRLANCTONF  = P_LANCTONF AND
                     NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_CDCSTDIGI := NULL;
            END;
            IF (SUBSTR(V_CDCSTDIGI,1,1) = SUBSTR(V_SITUTRIBPR,1,1)) OR
               (V_CDCSTDIGI IS NULL) THEN
               UPDATE ITEMPRODUTO
               SET CDSITUTRIBPR  = V_SITUTRIBPR
               WHERE CDFILIAL    = P_FILIAL   AND
                     NRLANCTONF  = P_LANCTONF AND
                     NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD;
            ELSE
               V_SITUTRIBPR := V_CDCSTDIGI;
            END IF;
            DELETE CSTTEMP
            WHERE NRCSTTEMP = V_CSTTEMP;
            -- VERIFICA SE HÁ GRUPO FISCAL POR SERVICO
            SELECT MAX(CDGRUPOFISC)
            INTO V_CDGRPFISCSV
            FROM SERVCLIE SC, SERVICO S
            WHERE SC.CDFILIAL   = V_CDFILIEMIT AND
                  SC.CDCLIENTE  = P_FORNECED    AND
                  SC.CDFILIAL   = S.CDFILIAL   AND
                  SC.CDSERVFILI = S.CDSERVFILI AND
                  S.CDPRODUTO   = C_ITEMPRODUTO.CDPRODUTO;
            IF V_CDGRPFISCSV IS NULL THEN
               -- VERIFICA SE HÁ GRUPO FISCAL POR CLIENTE DA FILIAL
               SELECT MAX(CDGRUPOFISC)
               INTO V_CDGRPFISCSV
               FROM CLIENFILIAL
               WHERE CDFILIAL   = V_CDFILIEMIT AND
                     CDCLIENTE  = P_FORNECED;
            END IF;
            CONSULTA_INCIDENCIA(P_ENTRSAID, P_EMPRESA, C_ITEMPRODUTO.CDARVPROD, P_INSCESTA, P_TIPOOPER, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC,
                                V_CDGRPFISCSV, V_IDINTEREST, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, C_ITEMPRODUTO.IDORIGEMPROD,
                                V_ESTAPRESTSERV, V_MUNIPRESTSERV);
            FOR C_INCITEMP IN (SELECT DSMENSINCTMP
                            FROM INCITEMP
                            WHERE (NRINCITEMP = V_INCITEMP)  AND
                                  (DSMENSINCTMP IS NOT NULL) AND
                                  (NOT EXISTS(SELECT DSDADOADIC
                                              FROM DADOSADIC
                                              WHERE (CDFILIAL   = P_FILIAL)   AND
                                                    (NRLANCTONF = P_LANCTONF) AND
                                                    (DSDADOADIC LIKE INCITEMP.DSMENSINCTMP || '%')))) LOOP
               IF NOT(C_INCITEMP.DSMENSINCTMP IS NULL) THEN
               /*PREENCHE AS MENSAGENS ATRELADAS A INCIDENCIA*/
                  INSERT INTO DADOSADIC(CDFILIAL, NRLANCTONF, NRDADOADIC, DSDADOADIC)
                                 VALUES(P_FILIAL, P_LANCTONF, V_DADOADIC, C_INCITEMP.DSMENSINCTMP);
                  V_DADOADIC := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_DADOADIC) + 1)),3,0);
               END IF;
            END LOOP;
            --ATUALIZAÇÃO DA TABELA DE IMPOSTOS POR ITEM.
            DELETE ITEMPROIMPOS
            WHERE (CDFILIAL    = P_FILIAL)   AND
                  (NRLANCTONF  = P_LANCTONF) AND
                  (NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD);
            FOR C_INCIDENCIA IN (SELECT IT.CDIMPOTEMP, MAX(IT.CDFISCTEMP) AS CDFISCTEMP,
                                        MAX(IT.IDTRATIMPTMP) AS IDTRATIMPTMP, MAX(IP.IDCONSISTENT) AS IDCONSISTENT, MAX(NVL(IP.IDUTMUNIORIG, W_N)) AS IDUTMUNIORIG,
                                        MAX(IP.IDIMPORECUP)  AS IDIMPORECUP, MAX(NVL(IP.IDPREIMPENTR, W_N)) AS IDPREIMPENTR,
                                        MAX(IP.IDORGARRECAD) AS IDORGARRECAD, MAX(IDUTVLRQTDEIMPO) AS IDUTVLRQTDEIMPO,
                                        MAX(IP.IDUTVRPAUTA) AS IDUTVRPAUTA,
                                        MAX(IT.CDDETALHEPROD) AS CDDETALHEPROD,
                                        MAX(CDENQLEGALIPI)   AS CDENQLEGALIPI,
                                        MAX(IP.CDIMPOSTONFE) AS CDIMPOSTONFE,
                                        MAX(IP.CDIMPOBASERET) AS CDIMPOBASERET, MAX(IP.IDDESCRFONTE) AS IDDESCRFONTE,
                                        MAX(IT.CDCEST) AS CDCEST
                                 FROM INCITEMP IT, IMPOSTO IP
                                 WHERE (IT.NRINCITEMP = V_INCITEMP)    AND
                                       (IP.CDIMPOSTO  = IT.CDIMPOTEMP) AND
                                       (IP.IDPRODNOTA = W_P)
                                 GROUP BY IT.CDIMPOTEMP
                                 ORDER BY IT.CDIMPOTEMP) LOOP
               V_MINBCPROD := 0;
               IF C_INCIDENCIA.IDUTVRPAUTA = 'S' THEN
                  CALCULO_MINBCPRODUTO(P_EMPRESA, P_TIPOOPER, P_INSCESTA, P_ENTRSAID, V_PAISORIG, V_ESTAORIG,
                                       C_ITEMPRODUTO.CDPRODUTO, V_CDGRUPOFISC, P_INIVALID, P_LANCTONF, P_FILIAL,
                                       C_ITEMPRODUTO.NRSEQITPROD, V_MINBCPROD);
               END IF;
               -- Desconsidera valor do desconto para cáculo do valor do ST
               BEGIN
                  SELECT MAX(CDIMPOSTO), MAX(IDVRIMPSTRIB)
                    INTO V_CDIMPOSTRIB, V_IDVRIMPSTRIB
                    FROM IMPOSTO
                   WHERE CDIMPOSTRIB = C_INCIDENCIA.CDIMPOTEMP;
               EXCEPTION
                   WHEN NO_DATA_FOUND THEN
                      V_CDIMPOSTRIB := NULL; V_IDVRIMPSTRIB := NULL;
               END;
               IF (V_CDIMPOSTRIB IS NOT NULL) THEN
                  IF V_MINBCPROD = 0 THEN
                     V_LIQUIITEM := C_ITEMPRODUTO.VRTOTAITEM;
                  ELSE
                     V_LIQUIITEM := V_MINBCPROD;
                     IF (C_INCIDENCIA.IDUTVRPAUTA = 'S') THEN
                        UPDATE ITEMPRODUTO
                           SET IDUTVRPAUTAPROD = 'S'
                         WHERE CDFILIAL    = P_FILIAL
                           AND NRLANCTONF  = P_LANCTONF
                           AND NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD;
                     END IF;
                  END IF;
               ELSE
                  -- Se o imposto é retido (valor NF) e se utiliza o valor de outro imposto como base de cálculo
                  IF ((C_INCIDENCIA.IDTRATIMPTMP = 'R') AND (C_INCIDENCIA.CDIMPOBASERET IS NOT NULL) AND (C_INCIDENCIA.IDDESCRFONTE = 'N')) THEN
                     SELECT NVL(MAX(VRIMPOSIT),0)
                       INTO V_VRIMPORELAC
                       FROM TRABITPROIMPOS
                      WHERE CDFILIMPOIT  = P_FILIAL
                        AND NRLANCIMPOIT = P_LANCTONF
                        AND NRSEQIMPOIT  = C_ITEMPRODUTO.NRSEQITPROD
                        AND CDIMPOSTOIT  = C_INCIDENCIA.CDIMPOBASERET
                        AND NRSEQITPRO   = W_1;
                     IF V_VRIMPORELAC <> 0 THEN
                        V_LIQUIITEM := V_VRIMPORELAC;
                     ELSE
                        V_LIQUIITEM := C_ITEMPRODUTO.VRTOTAITEM - C_ITEMPRODUTO.VRDESCITEM;
                     END IF;
                  ELSE
                     IF V_MINBCPROD = 0 THEN
                        V_LIQUIITEM := C_ITEMPRODUTO.VRTOTAITEM - C_ITEMPRODUTO.VRDESCITEM;
                     ELSE
                        V_LIQUIITEM := V_MINBCPROD - C_ITEMPRODUTO.VRDESCITEM;
                        IF (C_INCIDENCIA.IDUTVRPAUTA = 'S') THEN
                           UPDATE ITEMPRODUTO
                              SET IDUTVRPAUTAPROD = 'S'
                            WHERE CDFILIAL    = P_FILIAL
                              AND NRLANCTONF  = P_LANCTONF
                              AND NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD;
                        END IF;
                     END IF;
                  END IF;
               END IF;
               -- Desconsidera valor do desconto para cáculo do valor do ST
               IF C_INCIDENCIA.IDUTMUNIORIG = W_D THEN
                  /* CONSIDERA O MUNICIPIO DE DESTINO */
                  IF V_UTGRUPFISCS = 'S' THEN
                     V_CDGRPFISCSV := NULL;
                     SELECT MAX(CDGRUPOFISC)
                     INTO V_CDGRPFISCSV
                     FROM SERVCLIE SC, SERVICO S
                     WHERE SC.CDFILIAL   = V_CDFILIEMIT AND
                           SC.CDCLIENTE  = P_FORNECED    AND
                           SC.CDFILIAL   = S.CDFILIAL   AND
                           SC.CDSERVFILI = S.CDSERVFILI AND
                           S.CDPRODUTO   = C_ITEMPRODUTO.CDPRODUTO;
                     IF V_CDGRPFISCSV IS NULL THEN
                        SELECT MAX(CDGRUPOFISC)
                        INTO V_CDGRPFISCSV
                        FROM CLIENFILIAL
                       WHERE CDFILIAL   = V_CDFILIEMIT AND
                             CDCLIENTE  = P_FORNECED;
                     END IF;
                     CONSULTA_ALIQUOTA(C_INCIDENCIA.CDIMPOTEMP, P_ENTRSAID, P_EMPRESA, C_ITEMPRODUTO.CDARVPROD, P_INSCESTA, V_PAISORIG,
                                       V_ESTAORIG, V_PAISDEST, V_ESTADEST, V_MUNIDEST, V_LIQUIITEM, P_INIVALID, P_FILIAL, P_LANCTONF, V_CDGRPFISCSV,P_TIPOOPER,
                                       NULL, NULL, NULL, NULL, P_FORNECED, NULL, C_ITEMPRODUTO.IDORIGEMPROD);
                  ELSE
                     CONSULTA_ALIQUOTA(C_INCIDENCIA.CDIMPOTEMP, P_ENTRSAID, P_EMPRESA, C_ITEMPRODUTO.CDARVPROD, P_INSCESTA, V_PAISORIG,
                                       V_ESTAORIG, V_PAISDEST, V_ESTADEST, V_MUNIDEST, V_LIQUIITEM, P_INIVALID, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC, P_TIPOOPER,
                                       NULL, NULL, NULL, NULL, P_FORNECED, NULL, C_ITEMPRODUTO.IDORIGEMPROD);
                  END IF;
               ELSE
                 /* CONSIDERA O MUNICIPIO DE ORIGEM */
                  SELECT MAX(IDGRUPFISSRV)
                  INTO V_UTGRUPFISCS
                  FROM IMPOSTO
                  WHERE CDIMPOSTO   = C_INCIDENCIA.CDIMPOTEMP;
                  IF V_UTGRUPFISCS = 'S' THEN
                     V_CDGRPFISCSV := NULL;
                     SELECT MAX(CDGRUPOFISC)
                     INTO V_CDGRPFISCSV
                     FROM SERVCLIE SC, SERVICO S
                     WHERE SC.CDFILIAL   = V_CDFILIEMIT AND
                           SC.CDCLIENTE  = P_FORNECED    AND
                           SC.CDFILIAL   = S.CDFILIAL   AND
                           SC.CDSERVFILI = S.CDSERVFILI AND
                           S.CDPRODUTO   = C_ITEMPRODUTO.CDPRODUTO;
                     IF V_CDGRPFISCSV IS NULL THEN
                        SELECT MAX(CDGRUPOFISC)
                        INTO V_CDGRPFISCSV
                        FROM CLIENFILIAL
                       WHERE CDFILIAL   = V_CDFILIEMIT AND
                             CDCLIENTE  = P_FORNECED;
                     END IF;
                     CONSULTA_ALIQUOTA(C_INCIDENCIA.CDIMPOTEMP, P_ENTRSAID, P_EMPRESA, C_ITEMPRODUTO.CDARVPROD, P_INSCESTA, V_PAISORIG,
                                       V_ESTAORIG, V_PAISDEST, V_ESTADEST, V_MUNIORIG, V_LIQUIITEM, P_INIVALID, P_FILIAL, P_LANCTONF, V_CDGRPFISCSV, P_TIPOOPER,
                                       NULL, NULL, NULL, NULL, P_FORNECED, NULL, C_ITEMPRODUTO.IDORIGEMPROD);
                  ELSE
                     CONSULTA_ALIQUOTA(C_INCIDENCIA.CDIMPOTEMP, P_ENTRSAID, P_EMPRESA, C_ITEMPRODUTO.CDARVPROD, P_INSCESTA, V_PAISORIG,
                                       V_ESTAORIG, V_PAISDEST, V_ESTADEST, V_MUNIORIG, V_LIQUIITEM, P_INIVALID, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC, P_TIPOOPER,
                                       NULL, NULL, NULL, NULL, P_FORNECED, NULL, C_ITEMPRODUTO.IDORIGEMPROD);
                  END IF;
               END IF;
               V_PARDEDTMP    := 0;
               V_PREDBCTMP1   := 0;
               V_PREDBCTMP    := 0;
               V_ALIQUTMP     := 0;
               V_IMPOSTOIT    := 0;
               V_IMPOSTORED1  := 0;
               V_ALIQINFO     := 0;
               V_IMPOSINFO    := 0;
               V_VRPERREDBCIT := 0;
               V_VRBASECALCIT := 0;
               V_VRIMPOSTOST  := 0;
               V_VRPPRIIMPST  := 0;
               V_IDREDUCAO    := 'N';
               /*VERIFICA CST POR IMPOSTO*/
               V_IMPOICMS := NULL;
               V_CDGRUPOFISCAUX := NULL;
               SELECT MAX(G.CDGRUPOFISC)
                 INTO V_CDGRUPOFISCAUX
                 FROM GRUPOFISCIMPFIL G,
                      (SELECT DECODE('E', 'E', CDFILIRECE, CDFILIEMIT) AS CDFILIAL
                         FROM NOTAFISCAL
                        WHERE CDFILIAL = P_FILIAL
                              AND NRLANCTONF = P_LANCTONF) F
                WHERE G.CDFILIAL = F.CDFILIAL
                  AND NOT G.CDGRUPOFISC IS NULL
                  AND G.CDIMPOSTO = C_INCIDENCIA.CDIMPOTEMP;
               IF V_IDORIGDESTNF = 'F' THEN
                  SELECT NVL(MAX(G.CDGRUPOFISC), V_CDGRUPOFISCAUX)
                    INTO V_CDGRUPOFISCAUX
                    FROM GRFISIMPIEFORN G,
                         (SELECT CDFORNECED
                            FROM NOTAFISCAL
                           WHERE CDFILIAL = P_FILIAL
                             AND NRLANCTONF = P_LANCTONF) N
                   WHERE G.CDFORNECED = N.CDFORNECED
                     AND G.CDEMPRESA = P_EMPRESA
                     AND G.CDINSCESTA = P_INSCESTA
                     AND NOT G.CDGRUPOFISC IS NULL
                     AND G.CDIMPOSTO = C_INCIDENCIA.CDIMPOTEMP;
               ELSE
                  SELECT NVL(MAX(G.CDGRUPOFISC), V_CDGRUPOFISCAUX)
                    INTO V_CDGRUPOFISCAUX
                    FROM GRFISIMPIECLIE G,
                         (SELECT CDCLIENTE
                            FROM NOTAFISCAL
                           WHERE CDFILIAL = P_FILIAL
                             AND NRLANCTONF = P_LANCTONF) N
                   WHERE G.CDCLIENTE = N.CDCLIENTE
                     AND G.CDEMPRESA = P_EMPRESA
                     AND G.CDINSCESTA = P_INSCESTA
                     AND NOT G.CDGRUPOFISC IS NULL
                     AND G.CDIMPOSTO = C_INCIDENCIA.CDIMPOTEMP;
               END IF;
               IF V_CDGRUPOFISCAUX IS NULL THEN
                  CONSULTA_CST_NFE(W_E, P_EMPRESA, C_ITEMPRODUTO.CDARVPROD, P_INSCESTA, P_TIPOOPER, V_CDGRUPOFISC,C_INCIDENCIA.CDIMPOTEMP, V_IDINTEREST, V_IDINTERNAC,  P_FILIAL, P_LANCTONF, '', V_CDSITTRIBTMP, V_IDMODBCNFE, V_IDMODBCSTNFE, V_CDTPCRPICOSTNFE, V_CDNATUBCPCSTNFE, V_IDMOTIDESSTNFE, C_ITEMPRODUTO.IDORIGEMPROD);
               ELSE
                  CONSULTA_CST_NFE(W_E, P_EMPRESA, C_ITEMPRODUTO.CDARVPROD, P_INSCESTA, P_TIPOOPER, V_CDGRUPOFISCAUX,C_INCIDENCIA.CDIMPOTEMP, V_IDINTEREST, V_IDINTERNAC,  P_FILIAL, P_LANCTONF, '', V_CDSITTRIBTMP, V_IDMODBCNFE, V_IDMODBCSTNFE, V_CDTPCRPICOSTNFE, V_CDNATUBCPCSTNFE, V_IDMOTIDESSTNFE, C_ITEMPRODUTO.IDORIGEMPROD);
               END IF;
               V_ICMS := 'N';
               FOR C_ICMS IN (SELECT CDIMPOSTO
                                FROM IMPOSTONFE N, IMPOSTO I
                               WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                                 AND N.CDIMPOSTONFE = '00'
                                 AND I.CDIMPOSTO = C_INCIDENCIA.CDIMPOTEMP
                              UNION ALL
                              SELECT CDIMPOSTO
                                FROM IMPOSTO
                               WHERE CDIMPOSTRIB = C_INCIDENCIA.CDIMPOTEMP)
               LOOP
                  V_ICMS := 'S';
               END LOOP;
               --IF (C_ITEMPRODUTO.CDSITUTRIBPR IS NOT NULL) AND (V_ICMS = S)  THEN
               --   V_CDSITTRIBTMP := SUBSTR(C_ITEMPRODUTO.CDSITUTRIBPR, 2, LENGTH(C_ITEMPRODUTO.CDSITUTRIBPR));
               --END IF;                   
               V_CDREGRAITALIQ  := NULL;
               SELECT MAX(CDIMPOSTO)
                 INTO V_IMPOICMS
                 FROM IMPOSTONFE N, IMPOSTO I
                WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                  AND N.CDIMPOSTONFE = '00'
                  AND I.CDIMPOSTO = C_INCIDENCIA.CDIMPOTEMP;
               SELECT NVL(MAX(VRPARDEDTMP),0), NVL(MAX(VRPREDBCTMP),0),     NVL(MAX(VRALIQUTMP),0),
                      NVL(MAX(VRPBCSTTMP),0),  NVL(MAX(IDTRIMPSTTMP), '0'), NVL(MAX(VR1PREDBCTMP), '0'),
                      MAX(CDREGRATMP),         MAX(CDFISCOPER),             MAX(IDDIFEALIQ),
                      MAX(IDDIFALIQCUSPR),     MAX(CDBENEFFISCAL),          MAX(IDCONSDIFALIQ)
                 INTO V_PARDEDTMP, V_PREDBCTMP, V_ALIQUTMP,
                      V_PBCSUBTRIB, V_IDTRIMPSTII, V_PREDBCTMP1,
                      V_CDREGRAITALIQ, V_CDFISCOPERREGRA, V_IDDIFEALIQREGRA,
                      V_IDDIFALIQCUSPRREGRA, V_CDBENEFFISCAL, V_IDCONSDIFALIQ
                 FROM ALIQTEMP
                WHERE (NRALIQTEMP = V_ALIQTEMP);
               V_IDCONSDIFALIQ := NVL(V_IDCONSDIFALIQ, 'N'); 
               IF V_PREDBCTMP > 0 THEN
                  V_IDREDUCAO := 'S';
               END IF;
               /* Verifica primeiro digito do CFOP */
               V_CFOP1DIGT := '';
               IF V_PAISCFOP = V_PAISDEST THEN
                  IF V_ESTACFOP = V_ESTADEST THEN
                     V_CFOP1DIGT := '1';
                  ELSE
                     V_CFOP1DIGT := '2';
                  END IF;
               ELSE
                  V_CFOP1DIGT := '3';
               END IF;
               IF (V_CDFISCOPERREGRA IS NOT NULL) AND (V_IDCOMPRABONI <> 'S') THEN
                  V_CDFISCOPERREGRA := V_CFOP1DIGT||V_CDFISCOPERREGRA;
                  V_DSCDFISOPEITREGRA := SUBSTR(DESCRICAO_CFOP(V_CDFISCOPERREGRA),1,45);
               END IF;
               IF (V_IDCOMPRABONI = 'S') THEN
                  V_FISOPEITEM        := C_ITEMPRODUTO.CDFISOPEITEM;
                  V_CDFISCOPERREGRA   := V_FISOPEITEM;
                  V_DSCDFISOPEITREGRA := SUBSTR(DESCRICAO_CFOP(V_FISOPEITEM),1,45);
               END IF;
               V_FISOPEITEM      := NVL(V_CDFISCOPERREGRA, V_FISOPEITEM);
               V_DSCDFISOPEIT    := NVL(V_DSCDFISOPEITREGRA, V_DSCDFISOPEIT);
               V_DIFALIQITEM     := NVL(V_IDDIFEALIQREGRA, V_DIFALIQITEM);
               V_IDDIFALIQCUSPRC := NVL(V_IDDIFALIQCUSPRREGRA, V_IDDIFALIQCUSPRC);
               IF (V_CDFISCOPERREGRA IS NOT NULL) THEN
                  IF (LENGTH(V_CDFISCOPERREGRA) < 4) THEN
                     V_CDFISCOPERREGRA := V_CFOP1DIGT||V_CDFISCOPERREGRA;
                  END IF;
                  UPDATE ITEMPRODUTO
                     SET CDFISOPEITEM = V_CDFISCOPERREGRA
                   WHERE CDFILIAL     = P_FILIAL
                     AND NRLANCTONF  = P_LANCTONF
                     AND NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD;
               END IF;
               SELECT NVL(MAX(VRALIQIMPOIT),0), NVL(MAX(VRIMPOSIT),0),
                      NVL(MAX(IDVALORINFO),W_N), COUNT(*),
                      NVL(MAX(VRREDBCIMPOIT),0), NVL(MAX(VRBCALCIMPOIT),0),
                      NVL(MAX(CDFISCIMPOIT), '3'), MAX(CDSTRIBITNFE),
                      NVL(MAX(IDMODBCITEMNFE), '3'), NVL(MAX(IDMODBCSTITENFE), '4'),
                      NVL(MAX(VRADICALIQFECP), 0),  NVL(MAX(VRADICFECP),0)
               INTO V_ALIQINFO, V_IMPOSINFO, V_IDVALORINFO, V_NRIMPOSTO,
                    V_VRPERREDBCIT, V_VRBASECALCIT, V_CDFISCALCOMP,
                    V_SITUTRIBCOMP, V_IDMODBCNFECOMP, V_IDMODBCSTNFECOMP,
                    V_VRADICALIQFECP, V_VRADICFECP
               FROM TRABITPROIMPOS
               WHERE CDFILIMPOIT  = P_FILIAL                  AND
                     NRLANCIMPOIT = P_LANCTONF                AND
                     NRSEQIMPOIT  = C_ITEMPRODUTO.NRSEQITPROD AND
                     CDIMPOSTOIT  = C_INCIDENCIA.CDIMPOTEMP;
               V_TAXABASECALC := (100 - V_PREDBCTMP1)/100;
               V_BASECALCIT   := V_LIQUIITEM * V_TAXABASECALC;
               V_TAXABASECALC := (100 - V_PREDBCTMP)/100;
               V_TAXAALIQUOTA := (V_ALIQUTMP/100);
               V_TAXAALIQFECP := (V_VRADICALIQFECP/100);
               V_TAXAALIQINFO := (V_ALIQINFO/100);
               V_TAXABCSUBSTR := 1 + (V_PBCSUBTRIB/100);
               IF V_PREDBCTMP1 <> 0 THEN
                  V_IMPOSTORED1 := V_BASECALCIT * V_TAXAALIQUOTA;
                  V_BASECALCIT  := V_BASECALCIT * V_TAXABASECALC;
               ELSE
                  V_BASECALCIT := V_LIQUIITEM * V_TAXABASECALC;
               END IF;
               V_PERDBCALC    := 100 - V_PREDBCTMP;
               IF V_PBCSUBTRIB > 0 THEN
                  V_BASECALCIT := (V_BASECALCIT * V_TAXABCSUBSTR);
                  V_PREDBCTMP  := V_PBCSUBTRIB;
                  V_PERDBCALC  := 0;
               END IF;
               V_VRPPRIIMPST := 0;
               V_CDIMPOSTRIB := NULL;
               V_VRIMPOSTOST := 0;
               IF (V_IDCONSDIFALIQ = 'S') AND (C_INCIDENCIA.CDIMPOSTONFE = '80') THEN
                  SELECT II.VRIMPOSIT, II.CDIMPOSTOIT, II.VRALIQIMPOIT
                    INTO V_VRICMSNF, V_CDIMPOSTOICMS, V_ALIQICMS
                    FROM TRABITPROIMPOS II, IMPOSTO I
                   WHERE (II.CDFILIMPOIT  = P_FILIAL)
                     AND (II.NRLANCIMPOIT = P_LANCTONF)
                     AND (II.NRSEQIMPOIT  = C_ITEMPRODUTO.NRSEQITPROD)
                     AND (II.NRSEQITPRO   = W_1)
                     AND (I.CDIMPOSTONFE  = '00')
                     AND (II.CDIMPOSTOIT  = I.CDIMPOSTO);
                  DELETE ALIQTEMP
                   WHERE NRALIQTEMP = V_ALIQTEMP;
                  CONSULTA_ALIQUOTA(V_CDIMPOSTOICMS, P_ENTRSAID, P_EMPRESA, C_ITEMPRODUTO.CDARVPROD, P_INSCESTA, V_PAISDEST,
                                       V_ESTADEST, V_PAISDEST, V_ESTADEST, V_MUNIDEST, V_LIQUIITEM, P_INIVALID, P_FILIAL, P_LANCTONF, V_CDGRPFISCSV,P_TIPOOPER,
                                       NULL, NULL, NULL, NULL, P_FORNECED, NULL, C_ITEMPRODUTO.IDORIGEMPROD);
                  SELECT MAX(VRALIQUTMP)
                    INTO V_VRALIQICMSINT
                    FROM ALIQTEMP
                   WHERE (NRALIQTEMP = V_ALIQTEMP);
                  IF ((V_VRALIQICMSINT IS NULL) OR (V_VRALIQICMSINT < V_ALIQICMS)) THEN
                     BEGIN
                        SELECT NVL(CONSULTA_QUADRO_ALIQUOTAS(V_ESTADEST, V_ESTADEST), 0)
                          INTO V_VRALIQICMSINT
                          FROM DUAL;
                     EXCEPTION
                        WHEN NO_DATA_FOUND THEN
                           V_VRALIQICMSINT := 0;
                     END;
                  END IF;
                  V_ALIQSTDIF   := V_VRALIQICMSINT;
                  V_BASECALCDIF :=  ROUND((V_BASECALCIT - V_VRICMSNF)/(1-(V_VRALIQICMSINT/100)), 2);
                  V_IMPOSTODIF  := ROUND(((V_BASECALCDIF * (V_VRALIQICMSINT/100)) - V_VRICMSNF), 2);
                  IF (V_IMPOSTODIF < 0) THEN
                     V_IMPOSTODIF := 0;
                  END IF;
                  DELETE ALIQTEMP
                   WHERE NRALIQTEMP = V_ALIQTEMP;   
               ELSE
                  /* Caso o st esteja relacionado a mais de um ICMS, o sistema calculo sobre o ICMS que incide na NF */
                  FOR C_ICMSST IN (SELECT CDIMPOSTO
                                          FROM IMPOSTO
                                         WHERE CDIMPOSTRIB = C_INCIDENCIA.CDIMPOTEMP)
                  LOOP
                     V_CDIMPOSTRIB := V_CDIMPOSTRIB||C_ICMSST.CDIMPOSTO||'_';
                  END LOOP;
                  IF V_CDIMPOSTRIB IS NOT NULL THEN
                     SELECT NVL(MAX(IDVRIMPSTRIB), 'N')
                       INTO V_IDVRIMPSTRIB
                       FROM TRABITPROIMPOS I, IMPOSTO II
                      WHERE (CDFILIMPOIT     = P_FILIAL)
                        AND (NRLANCIMPOIT   = P_LANCTONF)
                        AND (NRSEQIMPOIT  = C_ITEMPRODUTO.NRSEQITPROD)
                        AND (INSTR(V_CDIMPOSTRIB,II.CDIMPOSTO||'_') > 0)
                        AND (I.CDIMPOSTOIT = II.CDIMPOSTO);
                     IF (V_IDTRIMPSTII = W_1) OR (NVL(V_IDVRIMPSTRIB,W_N) = W_N) THEN
                        V_VRIMPOSTOST := 0;
                        V_VRPPRIIMPST := 0;
                     ELSE
                        BEGIN
                           SELECT NVL(VRIMPOSIT,0), NVL(VR1IMPOSTOIT, 0)
                           INTO V_VRIMPOSTOST, V_VRPPRIIMPST
                           FROM TRABITPROIMPOS I
                           WHERE (CDFILIMPOIT  = P_FILIAL)                   AND
                                 (NRLANCIMPOIT = P_LANCTONF)                 AND
                                 (NRSEQIMPOIT  = C_ITEMPRODUTO.NRSEQITPROD)  AND
                                 (INSTR(V_CDIMPOSTRIB,CDIMPOSTOIT||'_') > 0) AND
                                 (NRSEQITPRO   = W_1);
                        EXCEPTION
                        WHEN NO_DATA_FOUND THEN
                           V_VRIMPOSTOST := 0;
                           V_VRPPRIIMPST := 0;
                        END;
                     END IF;
                  END IF;
               END IF;
               IF (C_INCIDENCIA.IDUTVLRQTDEIMPO = W_S) THEN
                  V_IMPOSTOIT := (C_ITEMPRODUTO.QTITEMPROD * V_ALIQUTMP) - V_PARDEDTMP;
                  IF V_VRPPRIIMPST <> 0 THEN
                     V_IMPOSTOIT := V_IMPOSTOIT - V_VRPPRIIMPST;
                  ELSE
                     V_IMPOSTOIT := V_IMPOSTOIT - V_VRIMPOSTOST;
                  END IF;
               ELSE
                  V_IMPOSTOIT := (V_BASECALCIT * V_TAXAALIQUOTA) - V_PARDEDTMP;
                  IF NOT(V_VRADICFECP > 0) THEN
                     V_VRADICFECP := (V_BASECALCIT * V_TAXAALIQFECP);
                  END IF;
                  IF V_VRPPRIIMPST <> 0 THEN
                     V_IMPOSTOIT := V_IMPOSTOIT - V_VRPPRIIMPST;
                  ELSE
                     V_IMPOSTOIT := V_IMPOSTOIT - V_VRIMPOSTOST;
                  END IF;
               END IF;
               IF P_AUDIT = W_S THEN
                  IF (V_IDVALORINFO <> W_S) THEN
                     IF (C_INCIDENCIA.IDUTVLRQTDEIMPO = W_S) THEN
                        V_IMPOSINFO := (V_ALIQINFO * C_ITEMPRODUTO.QTITEMPROD) - V_PARDEDTMP;
                        IF V_VRPPRIIMPST <> 0 THEN
                           V_IMPOSINFO := V_IMPOSINFO - V_VRPPRIIMPST;
                        ELSE
                           V_IMPOSINFO := V_IMPOSINFO - V_VRIMPOSTOST;
                        END IF;
                     ELSE
                        V_IMPOSINFO := (V_BASECALCIT * V_TAXAALIQINFO) - V_PARDEDTMP;
                        IF V_VRPPRIIMPST <> 0 THEN
                           V_IMPOSINFO := V_IMPOSINFO - V_VRPPRIIMPST;
                        ELSE
                           V_IMPOSINFO := V_IMPOSINFO - V_VRIMPOSTOST;
                        END IF;
                     END IF;
                  ELSE
                     V_ALIQUTMP := V_ALIQINFO;
                     V_IMPOSTOIT := V_IMPOSINFO;
                     BEGIN
                        SELECT NVL(IDVALORINFO, 'N')
                          INTO V_IDIMPORTAIMPXML
                          FROM TRABITPROIMPOS
                         WHERE CDFILIMPOIT  = P_FILIAL
                           AND NRLANCIMPOIT = P_LANCTONF
                           AND NRSEQIMPOIT  = C_ITEMPRODUTO.NRSEQITPROD
                           AND CDIMPOSTOIT  = C_INCIDENCIA.CDIMPOTEMP
                           AND NRSEQITPRO   = '1';
                     EXCEPTION
                        WHEN NO_DATA_FOUND THEN
                           V_IDIMPORTAIMPXML := 'N';
                     END;
                     IF (V_IDNFGERADAVIAXML = 'S') AND ((V_IDIMPORTAIMPXML = 'S') OR (V_IDGERNFIGUALXML = 'S')) THEN
                        V_PREDBCTMP  := V_VRPERREDBCIT;
                        V_BASECALCIT := V_VRBASECALCIT;
                     END IF;
                     --NF DE COMPLEMENTO
                     IF (P_TIPOOPER = '03') THEN
                        V_PREDBCTMP    := V_VRPERREDBCIT;
                        V_BASECALCIT   := V_VRBASECALCIT;
                        V_CDSITTRIBTMP := V_SITUTRIBCOMP;
                        V_IDMODBCNFE   := V_IDMODBCNFECOMP;
                        V_IDMODBCSTNFE := V_IDMODBCSTNFECOMP;
                     END IF;
                  END IF;
               ELSE
                  IF (V_IDVALORINFO <> W_S) THEN
                     IF (C_INCIDENCIA.IDUTVLRQTDEIMPO = W_S) THEN
                        V_IMPOSINFO := (V_ALIQINFO * C_ITEMPRODUTO.QTITEMPROD) - V_PARDEDTMP;
                        IF V_VRPPRIIMPST <> 0 THEN
                           V_IMPOSINFO := V_IMPOSINFO - V_VRPPRIIMPST;
                        ELSE
                           V_IMPOSINFO := V_IMPOSINFO - V_VRIMPOSTOST;
                        END IF;
                     ELSE
                        V_IMPOSINFO := (V_BASECALCIT * V_TAXAALIQINFO) - V_PARDEDTMP;
                        IF V_VRPPRIIMPST <> 0 THEN
                           V_IMPOSINFO := V_IMPOSINFO - V_VRPPRIIMPST;
                        ELSE
                           V_IMPOSINFO := V_IMPOSINFO - V_VRIMPOSTOST;
                        END IF;
                     END IF;
                  ELSE
                     V_ALIQUTMP := V_ALIQINFO;
                     V_IMPOSTOIT := V_IMPOSINFO;
                     BEGIN
                        SELECT NVL(IDVALORINFO, 'N')
                          INTO V_IDIMPORTAIMPXML
                          FROM TRABITPROIMPOS
                         WHERE CDFILIMPOIT  = P_FILIAL
                           AND NRLANCIMPOIT = P_LANCTONF
                           AND NRSEQIMPOIT  = C_ITEMPRODUTO.NRSEQITPROD
                           AND CDIMPOSTOIT  = C_INCIDENCIA.CDIMPOTEMP
                           AND NRSEQITPRO   = '1';
                     EXCEPTION
                        WHEN NO_DATA_FOUND THEN
                           V_IDIMPORTAIMPXML := 'N';
                     END;
                     IF (V_IDNFGERADAVIAXML = 'S') AND ((V_IDIMPORTAIMPXML = 'S') OR (V_IDGERNFIGUALXML = 'S')) THEN
                        V_PREDBCTMP  := V_VRPERREDBCIT;
                        V_BASECALCIT := V_VRBASECALCIT;     
                     END IF;
                     --NF DE COMPLEMENTO
                     IF (P_TIPOOPER = '03') THEN
                        V_PREDBCTMP    := V_VRPERREDBCIT;
                        V_BASECALCIT   := V_VRBASECALCIT;
                        V_CDSITTRIBTMP := V_SITUTRIBCOMP;
                        V_IDMODBCNFE   := V_IDMODBCNFECOMP;
                        V_IDMODBCSTNFE := V_IDMODBCSTNFECOMP;
                     END IF;
                  END IF;
               END IF;
               V_CONTABCALC := V_LIQUIDOPROD - (V_LIQUIDOPROD * V_TAXABASECALC);
               /* ROTINA PARA CALCULAR O DIFERIMENTO DO IMPOSTO */
               V_PERDIFERE    := NULL;
               V_IMPOSTOOPERA := NULL;
               V_IMPOSTODIFER := NULL;
               IF C_INCIDENCIA.CDIMPOSTONFE = '00' THEN
                  IF V_CDSITTRIBTMP = '51' THEN
                     BEGIN
                        SELECT PD.VRPERDIFERE
                          INTO V_VRPERDIFERE
                          FROM PRODDIFEREIMPOS PD, PRODUTO PR
                         WHERE PD.CDPRODUTO = PR.CDPRODUTO
                           AND PD.CDPAIS = V_PAISORIG
                           AND PD.SGESTADO = V_ESTAORIG
                           AND PR.CDARVPROD IN (SELECT MAX(PR.CDARVPROD) AS CDARVPROD
                                                  FROM PRODDIFEREIMPOS PD, PRODUTO PR
                                                 WHERE PD.CDPRODUTO = PR.CDPRODUTO
                                                   AND PD.CDPAIS = V_PAISORIG
                                                   AND PD.SGESTADO = V_ESTAORIG
                                                   AND INSTR(NVL(RTRIM(C_ITEMPRODUTO.CDARVPROD), PR.CDARVPROD), PR.CDARVPROD) = 1);
                     EXCEPTION
                        WHEN NO_DATA_FOUND THEN
                           V_VRPERDIFERE := NULL;
                    END;
                     IF V_VRPERDIFERE IS NOT NULL THEN
                        V_PERDIFERE    := ROUND(V_VRPERDIFERE, 2);
                        V_IMPOSTOOPERA := ROUND(V_IMPOSTOIT, 2);
                        IF ((V_IDNFGERADAVIAXML = 'S') AND ((NVL(V_IDIMPORTAIMPXML, 'N') = 'S') OR (V_IDGERNFIGUALXML = 'S'))) THEN
                           V_IMPOSTOOPERA := ROUND((V_BASECALCIT * V_ALIQUTMP/100), 2);
                        END IF;
                        V_IMPOSTODIFER := ROUND(((V_BASECALCIT * V_ALIQUTMP/100) * (V_VRPERDIFERE/100)), 2);
                        IF NOT((V_IDNFGERADAVIAXML = 'S') AND ((NVL(V_IDIMPORTAIMPXML, 'N') = 'S') OR (V_IDGERNFIGUALXML = 'S'))) THEN
                           V_IMPOSTOIT := ROUND(V_IMPOSTOOPERA, 2) - ROUND(V_IMPOSTODIFER, 2);
                        END IF;
                        V_IMPOSINFO := V_IMPOSTOIT;
                     END IF;
                  END IF;
               END IF;
               IF (V_IMPOSTOIT < 0) THEN
                  V_IMPOSTOIT := 0;
               END IF;
               IF (V_IMPOSINFO < 0) THEN
                  V_IMPOSINFO := 0;
               END IF;
               BEGIN
                  SELECT CDFISOPEITEM, CDSUFXCFOPPR
                  INTO V_FISOPEITEM, V_SUFXCFOPPR
                  FROM ITEMPRODUTO
                  WHERE CDFILIAL    = P_FILIAL   AND
                        NRLANCTONF  = P_LANCTONF AND
                        NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD;
               EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                     V_FISOPEITEM := NULL; V_SUFXCFOPPR := NULL;
               END;
               V_IMPOICMS := NULL;
               V_CST1DIGT := NULL;
               SELECT MAX(CDIMPOSTO)
                 INTO V_IMPOICMS
                 FROM IMPOSTONFE N, IMPOSTO I
                WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                  AND N.CDIMPOSTONFE = '00'
                  AND I.CDIMPOSTO = C_INCIDENCIA.CDIMPOTEMP;
               IF (V_IMPOICMS IS NOT NULL) THEN
                  IF V_IDORIGDESTNF = 'L' THEN
                     Begin
                        SELECT MAX(CDCSTDIG1PROD)
                          INTO V_CST1DIGT
                          FROM PRODUTO
                         WHERE (CDARVPROD = C_ITEMPRODUTO.CDARVPROD);
                        IF V_CST1DIGT IS NULL THEN
                           SELECT MAX(CDCSTDIG1SAI)
                           INTO   V_CST1DIGT
                           FROM INSCRESTAD
                           WHERE CDEMPRESA  = P_EMPRESA AND
                                 CDINSCESTA = P_INSCESTA;
                        END IF;
                     Exception
                        When No_Data_Found Then
                           V_CST1DIGT := Null;
                     End;
                  ELSIF V_IDORIGDESTNF = 'C' THEN
                     Begin
                        SELECT MAX(CDCSTDIG1PROD)
                          INTO V_CST1DIGT
                          FROM PRODUTO
                         WHERE (CDARVPROD = C_ITEMPRODUTO.CDARVPROD);
                        IF V_CST1DIGT IS NULL THEN
                           SELECT MAX(CDCSTDIG1CLI)
                             INTO V_CST1DIGT
                             FROM NOTAFISCAL N, CLIENTE C
                            WHERE CDFILIAL     = P_FILIAL    AND
                                  NRLANCTONF   = P_LANCTONF  AND
                                  N.CDCLIENTE  = C.CDCLIENTE;
                        END IF;
                     Exception
                        When No_Data_Found Then
                           V_CST1DIGT := Null;
                     End;
                  ELSE
                     Begin
                        SELECT MAX(CDCSTDIG1PROD)
                          INTO V_CST1DIGT
                          FROM PRODUTO
                         WHERE (CDARVPROD = C_ITEMPRODUTO.CDARVPROD);
                        IF V_CST1DIGT IS NULL THEN
                           SELECT MAX(CDCSTDIG1ENT)
                             INTO   V_CST1DIGT
                             FROM NOTAFISCAL N, FORNECEDOR F
                            WHERE CDFILIAL     = P_FILIAL   AND
                                 NRLANCTONF    = P_LANCTONF AND
                                 N.CDFORNECED  = F.CDFORNECED;
                        END IF;
                     Exception
                        When No_Data_Found Then
                           V_CST1DIGT := Null;
                     End;
                  END IF;
                  IF (V_IDUTORIGPROD = 'S') AND (C_ITEMPRODUTO.IDORIGEMPROD = 'E') AND (NVL(V_IDNFGERADAVIAXML, 'N') <> 'S') THEN
                     V_CST1DIGT := '2';
                  END IF;       
                  IF (V_CDSITTRIBTMP IS NOT NULL) THEN
                     UPDATE ITEMPRODUTO
                        SET CDSITUTRIBPR  = V_CST1DIGT||V_CDSITTRIBTMP
                      WHERE CDFILIAL      = P_FILIAL AND
                            NRLANCTONF    = P_LANCTONF AND
                            NRSEQITPROD   = C_ITEMPRODUTO.NRSEQITPROD;
                     V_SITUTRIBPR := V_CST1DIGT||V_CDSITTRIBTMP;
                  END IF;
                  V_CDGRUPOFISCAUX := NULL;
                  SELECT MAX(G.CDGRUPOFISC)
                    INTO V_CDGRUPOFISCAUX
                    FROM GRUPOFISCIMPFIL G,
                         (SELECT DECODE('E', 'E', CDFILIRECE, CDFILIEMIT) AS CDFILIAL
                            FROM NOTAFISCAL
                           WHERE CDFILIAL = P_FILIAL
                                 AND NRLANCTONF = P_LANCTONF) F
                   WHERE G.CDFILIAL = F.CDFILIAL
                     AND NOT G.CDGRUPOFISC IS NULL
                     AND G.CDIMPOSTO = C_INCIDENCIA.CDIMPOTEMP;
                  IF V_IDORIGDESTNF = 'F' THEN
                     SELECT NVL(MAX(G.CDGRUPOFISC), V_CDGRUPOFISCAUX)
                       INTO V_CDGRUPOFISCAUX
                       FROM GRFISIMPIEFORN G,
                            (SELECT CDFORNECED
                               FROM NOTAFISCAL
                              WHERE CDFILIAL = P_FILIAL
                                AND NRLANCTONF = P_LANCTONF) N
                      WHERE G.CDFORNECED = N.CDFORNECED
                        AND G.CDEMPRESA = P_EMPRESA
                        AND G.CDINSCESTA = P_INSCESTA
                        AND NOT G.CDGRUPOFISC IS NULL
                        AND G.CDIMPOSTO = C_INCIDENCIA.CDIMPOTEMP;
                  ELSE
                     SELECT NVL(MAX(G.CDGRUPOFISC), V_CDGRUPOFISCAUX)
                       INTO V_CDGRUPOFISCAUX
                       FROM GRFISIMPIECLIE G,
                            (SELECT CDCLIENTE
                               FROM NOTAFISCAL
                              WHERE CDFILIAL = P_FILIAL
                                AND NRLANCTONF = P_LANCTONF) N
                      WHERE G.CDCLIENTE = N.CDCLIENTE
                        AND G.CDEMPRESA = P_EMPRESA
                        AND G.CDINSCESTA = P_INSCESTA
                        AND NOT G.CDGRUPOFISC IS NULL
                        AND G.CDIMPOSTO = C_INCIDENCIA.CDIMPOTEMP;
                  END IF;
                  IF (V_IDCOMPRABONI = 'N') THEN
                     IF (V_CDGRUPOFISCAUX IS NOT NULL) THEN
                        CONSULTA_CFOP(P_ENTRSAID, P_EMPRESA, C_ITEMPRODUTO.CDARVPROD, P_INSCESTA, P_TIPOOPER, V_PAISCFOP,
                                      V_ESTACFOP, V_PAISDEST, V_ESTADEST, P_FILIAL, P_LANCTONF, V_CDGRUPOFISCAUX, P_INIVALID, C_ITEMPRODUTO.IDORIGEMPROD);
                     ELSE
                        CONSULTA_CFOP(P_ENTRSAID, P_EMPRESA, C_ITEMPRODUTO.CDARVPROD, P_INSCESTA, P_TIPOOPER, V_PAISCFOP,
                                      V_ESTACFOP, V_PAISDEST, V_ESTADEST, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC, P_INIVALID, C_ITEMPRODUTO.IDORIGEMPROD);
                     END IF;
                     SELECT MAX(CDFISOPETMP), MAX(CDSUFCFOPTMP), MAX(IDDIFALIQTMP),
                            MAX(DSCFOPTMP), NVL(MAX(IDDIFALIQCUSPRC),W_N)
                       INTO V_FISOPEITEM, V_SUFXCFOPPR, V_DIFALIQITEM,
                            V_DSCDFISOPEIT, V_IDDIFALIQCUSPRC
                       FROM CFOPTEMP
                      WHERE NRCFOPTEMP = V_CFOPTEMP;
                      V_FISOPEITEM      := NVL(V_CDFISCOPERREGRA, V_FISOPEITEM);
                      V_DSCDFISOPEIT    := NVL(V_DSCDFISOPEITREGRA, V_DSCDFISOPEIT);
                      V_DIFALIQITEM     := NVL(V_IDDIFEALIQREGRA, V_DIFALIQITEM);
                      V_IDDIFALIQCUSPRC := NVL(V_IDDIFALIQCUSPRREGRA, V_IDDIFALIQCUSPRC);
                      -- ALTERA NATUREZA DE OPERAÇÃO DA NOTA FISCAL CASO NÃO EXISTA
                      IF (V_DSCDFISOPEITREGRA IS NOT NULL) THEN
                         UPDATE NOTAFISCAL
                            SET DSCDFISOPENF = V_DSCDFISOPEITREGRA
                          WHERE CDFILIAL   = P_FILIAL   AND
                                NRLANCTONF = P_LANCTONF;
                      ELSE
                         UPDATE NOTAFISCAL
                            SET DSCDFISOPENF = (SELECT MAX(DSCFOPTMP)
                                                  FROM CFOPTEMP
                                                 WHERE NRCFOPTEMP = V_CFOPTEMP)
                          WHERE CDFILIAL   = P_FILIAL
                            AND NRLANCTONF = P_LANCTONF
                            AND DSCDFISOPENF IS NULL;
                      END IF;
                      -- ALTERA O CFOP DO ITEM E
                      UPDATE ITEMPRODUTO
                      SET CDFISOPEITEM = NVL(V_CDFISCOPERREGRA, V_FISOPEITEM),
                          CDSUFXCFOPPR = V_SUFXCFOPPR,
                          DSCDFISOPEIT = NVL(V_DSCDFISOPEITREGRA, V_DSCDFISOPEIT)
                      WHERE CDFILIAL    = P_FILIAL   AND
                            NRLANCTONF  = P_LANCTONF AND
                            NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD;
                     DELETE CFOPTEMP
                      WHERE NRCFOPTEMP = V_CFOPTEMP;
                  END IF;
               END IF;
               INSERT INTO ITEMPROIMPOS(
                  CDFILIAL, NRLANCTONF, NRSEQITPROD, CDIMPOSTO, NRITPROIMPOS, CDFISCALIT, CDSITUTRIBIT,
                  CDFISCOPERIT, CDSUFXCFOPIT, VRALIQITEM, VRPERREDBCIT, VRPARDEDIT, VRCONTITIMP,
                  VRBASECALCIT, VRIMPOSTOIT, IDERROSIMPIT, IDAVISIMPIT, IDTRIMPSTII, CDSITUTRIBITNFE, IDMODBCITNFE, IDMODBCSTITNFE,
                  VR1PERREDBCIT, VR1IMPREDBCIT, CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT, CDREGRAIT, VRBCALCIRRF, CDDETALHEPROD,
                  VRPERDIFEREIT, VRIMPOSTOOPERAIT, VRIMPOSTODIFERIT, VRADICALIQFECP, VRADICFECP, CDBENEFFISCAL, IDCONSDIFALIQ, CDCEST)
               VALUES(
                  P_FILIAL, P_LANCTONF, C_ITEMPRODUTO.NRSEQITPROD, C_INCIDENCIA.CDIMPOTEMP, W_1, C_INCIDENCIA.CDFISCTEMP,
                  V_SITUTRIBPR, NVL(V_CDFISCOPERREGRA, V_FISOPEITEM), V_SUFXCFOPPR, V_ALIQUTMP, V_PREDBCTMP, V_PARDEDTMP, ROUND(V_BASECALCIT, 5), ROUND(V_BASECALCIT, 2), V_IMPOSTOIT,
                  W_00000, W_00000, V_IDTRIMPSTII, V_CDSITTRIBTMP, V_IDMODBCNFE, V_IDMODBCSTNFE, V_PREDBCTMP1, V_IMPOSTORED1,
                  V_CDTPCRPICOSTNFE, V_CDNATUBCPCSTNFE, V_IDMOTIDESSTNFE, V_CDREGRAITALIQ, V_BASECALCIT, C_INCIDENCIA.CDDETALHEPROD,
                  V_PERDIFERE, V_IMPOSTOOPERA, V_IMPOSTODIFER, V_VRADICALIQFECP, V_VRADICFECP, V_CDBENEFFISCAL, V_IDCONSDIFALIQ,
                  C_INCIDENCIA.CDCEST);
               IF (P_TIPOOPER = '03') THEN
                  V_CDFISCALCOMP := NVL(V_CDFISCALCOMP, C_INCIDENCIA.CDFISCTEMP);
               ELSE
                  V_CDFISCALCOMP := C_INCIDENCIA.CDFISCTEMP;
               END IF;
               IF (V_IDCONSDIFALIQ = 'S') AND (C_INCIDENCIA.CDIMPOSTONFE = '80') THEN
                  V_BASECALCIT := V_BASECALCDIF;
                  V_ALIQINFO   := V_ALIQSTDIF;
                  V_IMPOSINFO  := V_IMPOSTODIF;
               END IF;
               UPDATE TRABITPROIMPOS
               SET VRALIQIMPOIT     = V_ALIQINFO,
                   VRCONTIMPOIT     = ROUND(V_BASECALCIT, 5),
                   VRREDBCIMPOIT    = V_PREDBCTMP,
                   VRBCALCIMPOIT    = ROUND(V_BASECALCIT, 2),
                   VRPDEDIMPOIT     = V_PARDEDTMP,
                   VRIMPOSIT        = V_IMPOSINFO,
                   CDFISCIMPOIT     = V_CDFISCALCOMP,
                   CDSTRIBIMPOIT    = V_SITUTRIBPR,
                   CDFOPERIMPOIT    = NVL(V_CDFISCOPERREGRA, V_FISOPEITEM),
                   CDSCFOPIMPOIT    = V_SUFXCFOPPR,
                   IDERRIMPOIT      = W_00000,
                   IDAVISIMPOIT     = W_00000,
                   IDTRIMPSTTI      = V_IDTRIMPSTII,
                   CDSTRIBITNFE     = V_CDSITTRIBTMP,
                   IDMODBCITEMNFE   = V_IDMODBCNFE,
                   IDMODBCSTITENFE  = V_IDMODBCSTNFE,
                   VR1REDBCIMPOIT   = V_PREDBCTMP1,
                   VR1IMPOSTOIT     = V_IMPOSTORED1,
                   CDTPCREDPICOITE  = V_CDTPCRPICOSTNFE,
                   CDNATUBCALPCIT   = V_CDNATUBCPCSTNFE,
                   IDMOTDESOTRABIT  = V_IDMOTIDESSTNFE,
                   CDREGRATRABIT    = V_CDREGRAITALIQ,
                   VRBCALCIRRF      = V_BASECALCIT,
                   CDDETALHEPROD    = C_INCIDENCIA.CDDETALHEPROD,
                   CDENQLEGALIPI    = C_INCIDENCIA.CDENQLEGALIPI,
                   VRPERDIFEREIT    = V_PERDIFERE,
                   VRIMPOSTOOPERAIT = V_IMPOSTOOPERA,
                   VRIMPOSTODIFERIT = V_IMPOSTODIFER,
                   VRADICALIQFECP   = V_VRADICALIQFECP,
                   VRADICFECP       = V_VRADICFECP,
                   CDBENEFFISCAL    = V_CDBENEFFISCAL,
                   IDCONSDIFALIQ    = V_IDCONSDIFALIQ,
                   CDCEST           = C_INCIDENCIA.CDCEST
               WHERE CDFILIMPOIT  = P_FILIAL                  AND
                     NRLANCIMPOIT = P_LANCTONF                AND
                     NRSEQIMPOIT  = C_ITEMPRODUTO.NRSEQITPROD AND
                     CDIMPOSTOIT  = C_INCIDENCIA.CDIMPOTEMP   AND
                     NRSEQITPRO   = W_1;
               IF V_IDREDUCAO = 'S' THEN
                  INSERT INTO ITEMPROIMPOS(
                     CDFILIAL, NRLANCTONF, NRSEQITPROD, CDIMPOSTO, NRITPROIMPOS, CDFISCALIT, CDSITUTRIBIT,
                     CDFISCOPERIT, CDSUFXCFOPIT, VRALIQITEM, VRPERREDBCIT, VRPARDEDIT, VRCONTITIMP,
                     VRBASECALCIT, VRIMPOSTOIT, IDERROSIMPIT, IDAVISIMPIT, CDSITUTRIBITNFE, IDMODBCITNFE, IDMODBCSTITNFE,
                     CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT, CDREGRAIT, CDCEST)
                  VALUES(
                     P_FILIAL, P_LANCTONF, C_ITEMPRODUTO.NRSEQITPROD, C_INCIDENCIA.CDIMPOTEMP, W_2, W_2,
                     V_SITUTRIBPR, NVL(V_CDFISCOPERREGRA, V_FISOPEITEM), V_SUFXCFOPPR, 0, V_PERDBCALC, V_PARDEDTMP, ROUND(V_CONTABCALC,5), 0, 0,
                     W_00000, W_00000, V_CDSITTRIBTMP, V_IDMODBCNFE, V_IDMODBCSTNFE,
                     V_CDTPCRPICOSTNFE, V_CDNATUBCPCSTNFE, V_IDMOTIDESSTNFE, V_CDREGRAITALIQ, C_INCIDENCIA.CDCEST);
                  DELETE TRABITPROIMPOS
                  WHERE CDFILIMPOIT  = P_FILIAL   AND
                        NRLANCIMPOIT = P_LANCTONF AND
                        NRSEQIMPOIT  = C_ITEMPRODUTO.NRSEQITPROD AND
                        CDIMPOSTOIT  = C_INCIDENCIA.CDIMPOTEMP   AND
                        NRSEQITPRO   = W_2;
                  IF  V_NRIMPOSTO  > 0 THEN
                     INSERT INTO TRABITPROIMPOS(
                        CDFILIMPOIT, NRLANCIMPOIT, NRSEQIMPOIT, CDIMPOSTOIT, NRSEQITPRO, CDFISCIMPOIT,
                        CDSTRIBIMPOIT, CDFOPERIMPOIT, CDSCFOPIMPOIT, VRALIQIMPOIT, VRREDBCIMPOIT, VRPDEDIMPOIT,
                        VRCONTIMPOIT, VRBCALCIMPOIT, VRIMPOSIT, IDERRIMPOIT, IDAVISIMPOIT, IDVALORINFO,
                        CDSTRIBITNFE, IDMODBCITEMNFE, IDMODBCSTITENFE, CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESOTRABIT, CDREGRATRABIT, CDCEST)
                     VALUES(
                        P_FILIAL, P_LANCTONF, C_ITEMPRODUTO.NRSEQITPROD, C_INCIDENCIA.CDIMPOTEMP, W_2, W_2,
                        V_SITUTRIBPR, NVL(V_CDFISCOPERREGRA, V_FISOPEITEM), V_SUFXCFOPPR, 0, V_PERDBCALC, V_PARDEDTMP, ROUND(V_CONTABCALC, 5), 0, 0,
                        W_00000, W_00000, V_IDVALORINFO, V_CDSITTRIBTMP, V_IDMODBCNFE, V_IDMODBCSTNFE,
                        V_CDTPCRPICOSTNFE, V_CDNATUBCPCSTNFE, V_IDMOTIDESSTNFE, V_CDREGRAITALIQ, C_INCIDENCIA.CDCEST);
                  END IF;
               ELSE
                  DELETE TRABITPROIMPOS
                  WHERE CDFILIMPOIT  = P_FILIAL   AND
                        NRLANCIMPOIT = P_LANCTONF AND
                        NRSEQIMPOIT  = C_ITEMPRODUTO.NRSEQITPROD AND
                        CDIMPOSTOIT  = C_INCIDENCIA.CDIMPOTEMP   AND
                        NRSEQITPRO   = W_2;
               END IF;
               DELETE ALIQTEMP
               WHERE NRALIQTEMP = V_ALIQTEMP;
               IF (V_DIFALIQITEM = W_S)             AND
                  (C_INCIDENCIA.IDIMPORECUP = W_S)  AND
                  (C_INCIDENCIA.IDORGARRECAD = W_E) THEN
                  V_ALIQDIFE    := 0;
                  V_ALIQDEST    := 0;
                  V_IMPOSTODIFE := 0;
                  IF C_INCIDENCIA.IDUTMUNIORIG = W_D THEN
                     /* CONSIDERA O MUNICIPIO DE DESTINO */
                     CONSULTA_ALIQUOTA(C_INCIDENCIA.CDIMPOTEMP, P_ENTRSAID, P_EMPRESA, C_ITEMPRODUTO.CDARVPROD, P_INSCESTA, V_PAISORIG,
                                       V_ESTAORIG, V_PAISDEST, V_ESTADEST, V_MUNIDEST, V_LIQUIITEM, P_INIVALID, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC,P_TIPOOPER,
                                       NULL, NULL, NULL, NULL, P_FORNECED, NULL, C_ITEMPRODUTO.IDORIGEMPROD);
                  ELSE
                     /* CONSIDERA O MUNICIPIO DE ORIGEM */
                     CONSULTA_ALIQUOTA(C_INCIDENCIA.CDIMPOTEMP, W_E, P_EMPRESA, C_ITEMPRODUTO.CDARVPROD, P_INSCESTA, V_PAISDEST,
                                       V_ESTADEST, V_PAISDEST, V_ESTADEST, V_MUNIORIG, V_LIQUIITEM, P_INIVALID, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC, P_TIPOOPER,
                                       NULL, NULL, NULL, NULL, P_FORNECED, NULL, C_ITEMPRODUTO.IDORIGEMPROD);
                  END IF;
                  SELECT MAX(VRALIQUTMP)
                  INTO V_ALIQDEST
                  FROM ALIQTEMP
                  WHERE (NRALIQTEMP = V_ALIQTEMP);
                  IF V_ALIQDEST IS NULL THEN
                     V_ALIQDEST := 0;
                  END IF;
                  IF V_ALIQUTMP < V_ALIQDEST THEN
                     V_ALIQDIFE     := V_ALIQDEST - V_ALIQUTMP;
                     V_BCALCDIFCOMP := 0;
                     IF (V_IDCALCDIFENTFISC = 'S') THEN
                        V_BCALCDIFCOMP := ROUND(((V_BASECALCIT - V_IMPOSTOIT) / ((100 - V_ALIQDEST)/100)) , V_NRDECITOTANF);
                        V_IMPOSTODIFE  := ROUND(((V_BCALCDIFCOMP * (V_ALIQDEST/100)) - V_IMPOSTOIT), V_NRDECITOTANF);
                      ELSE
                        V_IMPOSTODIFE  := ROUND((V_BASECALCIT * (V_ALIQDIFE/100)), V_NRDECITOTANF);
                        V_BCALCDIFCOMP := V_BASECALCIT;
                     END IF;
                     INSERT INTO ITEMPROIMPOS(
                        CDFILIAL, NRLANCTONF, NRSEQITPROD, CDIMPOSTO, NRITPROIMPOS, CDFISCALIT, CDSITUTRIBIT,
                        CDFISCOPERIT, CDSUFXCFOPIT, VRALIQITEM, VRPERREDBCIT, VRPARDEDIT, VRCONTITIMP,
                        VRBASECALCIT, VRIMPOSTOIT, IDERROSIMPIT, IDAVISIMPIT, IDVALORINFIT,
                        CDSITUTRIBITNFE, IDMODBCITNFE, IDMODBCSTITNFE, IDDIFALIQCUSPRI,
                        CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT, CDREGRAIT,
                        VRPERDIFEREIT, VRIMPOSTOOPERAIT, VRIMPOSTODIFERIT, CDCEST)
                     VALUES(
                        P_FILIAL, P_LANCTONF, C_ITEMPRODUTO.NRSEQITPROD, C_INCIDENCIA.CDIMPOTEMP, W_3, C_INCIDENCIA.CDFISCTEMP,
                        V_SITUTRIBPR, NVL(V_CDFISCOPERREGRA, V_FISOPEITEM), V_SUFXCFOPPR, V_ALIQDIFE, V_PREDBCTMP, V_PARDEDTMP, ROUND(V_BCALCDIFCOMP, 5), ROUND(V_BCALCDIFCOMP, 2),
                        V_IMPOSTODIFE, W_00000, W_00000, V_IDVALORINFO, V_CDSITTRIBTMP, V_IDMODBCNFE, V_IDMODBCSTNFE, V_IDDIFALIQCUSPRC,
                        V_CDTPCRPICOSTNFE, V_CDNATUBCPCSTNFE, V_IDMOTIDESSTNFE, V_CDREGRAITALIQ,
                        V_PERDIFERE, V_IMPOSTOOPERA, V_IMPOSTODIFER, C_INCIDENCIA.CDCEST);
                  END IF;
                  IF V_ALIQINFO < V_ALIQDEST THEN
                     V_ALIQDIFE     := V_ALIQDEST - V_ALIQINFO;
                     V_BCALCDIFCOMP := 0;
                     IF (V_IDCALCDIFENTFISC = 'S') THEN
                        V_BCALCDIFCOMP  := ROUND(((V_BASECALCIT - (V_BASECALCIT * (V_ALIQINFO/100))) / ((100 - V_ALIQDEST)/100)) , V_NRDECITOTANF);
                        V_IMPOSTODIFE  := ROUND(((V_BCALCDIFCOMP * (V_ALIQDEST/100)) - V_IMPOSTOIT), V_NRDECITOTANF);
                     ELSE
                        V_IMPOSTODIFE  := ROUND((V_BASECALCIT * (V_ALIQDIFE/100)), V_NRDECITOTANF);
                        V_BCALCDIFCOMP := V_BASECALCIT;
                     END IF;
                     DELETE TRABITPROIMPOS
                     WHERE CDFILIMPOIT  = P_FILIAL                  AND
                           NRLANCIMPOIT = P_LANCTONF                AND
                           NRSEQIMPOIT  = C_ITEMPRODUTO.NRSEQITPROD AND
                           CDIMPOSTOIT  = C_INCIDENCIA.CDIMPOTEMP   AND
                           NRSEQITPRO   = W_3;
                     INSERT INTO TRABITPROIMPOS(
                        CDFILIMPOIT, NRLANCIMPOIT, NRSEQIMPOIT, CDIMPOSTOIT, NRSEQITPRO, CDFISCIMPOIT,
                        CDSTRIBIMPOIT, CDFOPERIMPOIT, CDSCFOPIMPOIT, VRALIQIMPOIT, VRREDBCIMPOIT, VRPDEDIMPOIT,
                        VRCONTIMPOIT, VRBCALCIMPOIT, VRIMPOSIT, IDERRIMPOIT, IDAVISIMPOIT, IDVALORINFO,
                        CDSTRIBITNFE, IDMODBCITEMNFE, IDMODBCSTITENFE, IDDIFALIQCUSPTI, CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESOTRABIT, CDREGRATRABIT,
                        VRPERDIFEREIT, VRIMPOSTOOPERAIT, VRIMPOSTODIFERIT, CDCEST)
                     VALUES(
                        P_FILIAL, P_LANCTONF, C_ITEMPRODUTO.NRSEQITPROD, C_INCIDENCIA.CDIMPOTEMP, W_3, C_INCIDENCIA.CDFISCTEMP,
                        V_SITUTRIBPR, NVL(V_CDFISCOPERREGRA, V_FISOPEITEM), V_SUFXCFOPPR, V_ALIQDIFE, V_PREDBCTMP, V_PARDEDTMP, ROUND(V_BCALCDIFCOMP,5),
                        ROUND(V_BCALCDIFCOMP, 2), V_IMPOSTODIFE, W_00000, W_00000, V_IDVALORINFO, V_CDSITTRIBTMP, V_IDMODBCNFE, V_IDMODBCSTNFE, V_IDDIFALIQCUSPRC,
                        V_CDTPCRPICOSTNFE, V_CDNATUBCPCSTNFE, V_IDMOTIDESSTNFE, V_CDREGRAITALIQ,
                        V_PERDIFERE, V_IMPOSTOOPERA, V_IMPOSTODIFER, C_INCIDENCIA.CDCEST);
                  ELSE
                     DELETE TRABITPROIMPOS
                     WHERE CDFILIMPOIT  = P_FILIAL                  AND
                           NRLANCIMPOIT = P_LANCTONF                AND
                           NRSEQIMPOIT  = C_ITEMPRODUTO.NRSEQITPROD AND
                           CDIMPOSTOIT  = C_INCIDENCIA.CDIMPOTEMP   AND
                           NRSEQITPRO   = W_3;
                  END IF;
               ELSE
                  DELETE TRABITPROIMPOS
                  WHERE CDFILIMPOIT  = P_FILIAL                  AND
                        NRLANCIMPOIT = P_LANCTONF                AND
                        NRSEQIMPOIT  = C_ITEMPRODUTO.NRSEQITPROD AND
                        CDIMPOSTOIT  = C_INCIDENCIA.CDIMPOTEMP   AND
                        NRSEQITPRO   = W_3;
               END IF;
               DELETE ALIQTEMP
               WHERE NRALIQTEMP = V_ALIQTEMP;
            END LOOP;
            DELETE INCITEMP
            WHERE NRINCITEMP = V_INCITEMP;
         END LOOP;
      ELSE
         V_LIQUIDOPROD := 0;
         V_LIQUIITEM   := 0;
         V_MINBCPROD   := 0;
         DELETE ITEMPROIMPOS
         WHERE (CDFILIAL    = P_FILIAL)   AND
               (NRLANCTONF  = P_LANCTONF);
      END IF;
      IF (V_INTEGRACAO IS NOT NULL) AND (P_ENTRSAID = W_S) THEN
         INSERT INTO ITEMPROIMPOS(
            CDFILIAL, NRLANCTONF, NRSEQITPROD, CDIMPOSTO, NRITPROIMPOS, CDFISCALIT, CDSITUTRIBIT,
            CDFISCOPERIT, CDSUFXCFOPIT, VRALIQITEM, VRPERREDBCIT, VRPARDEDIT, VRCONTITIMP,
            VRBASECALCIT, VRIMPOSTOIT, IDERROSIMPIT, IDAVISIMPIT, CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT, CDREGRAIT,
            VRPERDIFEREIT, VRIMPOSTOOPERAIT, VRIMPOSTODIFERIT, CDCEST)
            (SELECT CDFILIMPOIT, NRLANCIMPOIT, NRSEQIMPOIT, CDIMPOSTOIT, NRSEQITPRO, CDFISCIMPOIT, CDSTRIBIMPOIT,
                    CDFOPERIMPOIT, CDSCFOPIMPOIT, VRALIQIMPOIT, VRREDBCIMPOIT, VRPDEDIMPOIT, ROUND(VRCONTIMPOIT,5),
                    ROUND(VRBCALCIMPOIT, 2), VRIMPOSIT, IDERRIMPOIT, IDAVISIMPOIT, CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESOTRABIT, CDREGRATRABIT,
                    VRPERDIFEREIT, VRIMPOSTOOPERAIT, VRIMPOSTODIFERIT, CDCEST
             FROM TRABITPROIMPOS
             WHERE CDFILIMPOIT  = P_FILIAL   AND
                   NRLANCIMPOIT = P_LANCTONF);
         SELECT SUM(VRTOTAITEM - VRDESCITEM) INTO V_TOTAPROD
         FROM ITEMPRODUTO
         WHERE CDFILIAL   = P_FILIAL   AND
               NRLANCTONF = P_LANCTONF;
         IF V_TOTAPROD IS NULL THEN
            V_TOTAPROD := 0;
         END IF;
         IF V_TOTAPROD > 0 THEN
            UPDATE ITEMPRODUTO
            SET VRBRUTITEM   = ROUND((V_NOTAFISC/V_TOTAPROD) * (VRTOTAITEM - VRDESCITEM), 5)
            WHERE CDFILIAL   = P_FILIAL   AND
                  NRLANCTONF = P_LANCTONF;
         END IF;
      END IF;
      ----------------------------------------------------------------------------------------------------
      --RATEIO DOS ENCARGOS.
      IF (V_INTEGRACAO IS NULL) OR (P_ENTRSAID = W_E) THEN
         FOR C_ITEMENCARGO IN (SELECT IE.CDENCARGO AS CDENCARGO, (VRITEMENCA-NVL(I.VRICMSSTITORIG,0)) VRITEMENCA, IDENCARGO,
                                      EN.CDCTBLENTREN, EN.CDCTBLSAIDEN
                                 FROM ENCARGO EN, ITEMENCARGO IE, (SELECT SUM(VRICMSSTITORIG) VRICMSSTITORIG
                                                                     FROM ITEMPRODUTO
                                                                    WHERE CDFILIAL   = P_FILIAL
                                                                      AND NRLANCTONF = P_LANCTONF) I
                                WHERE (IE.CDFILIAL   = P_FILIAL)
                                  AND (IE.NRLANCTONF = P_LANCTONF)
                                  AND (IE.VRITEMENCA-NVL(I.VRICMSSTITORIG,0) > 0)
                                  AND (EN.CDENCARGO  = IE.CDENCARGO)) LOOP
            V_TOTAPRODENCA := 0;
            FOR C_VRLIQRATEIO IN (SELECT DISTINCT(IP.NRSEQITPROD) AS NRSEQITPROD, (VRTOTAITEM - VRDESCITEM) AS VRLIQUIDO
                                  FROM ITEMPRODUTO IP, ITEMPROIMPOS II
                                  WHERE (IP.CDFILIAL     = P_FILIAL)       AND
                                        (IP.NRLANCTONF   = P_LANCTONF)     AND
                                        (II.CDFILIAL     = IP.CDFILIAL)    AND
                                        (II.NRLANCTONF   = IP.NRLANCTONF)  AND
                                        (II.NRSEQITPROD  = IP.NRSEQITPROD) AND
                                        (II.NRITPROIMPOS = W_1)            AND
                                        (EXISTS(SELECT BC.CDIMPOSTO
                                                FROM BASECALC BC
                                                WHERE (BC.CDENCARGO = C_ITEMENCARGO.CDENCARGO) AND
                                                      (BC.CDIMPOSTO = II.CDIMPOSTO)            AND
                                                      (BC.CDIMPOSTO IN (SELECT (B.CDIMPOSTO)
                                                                       FROM BASECALC B
                                                                       WHERE B.CDENCARGO = C_ITEMENCARGO.CDENCARGO))))) LOOP
               IF NOT (C_VRLIQRATEIO.VRLIQUIDO IS NULL) THEN
                  V_TOTAPRODENCA := V_TOTAPRODENCA + C_VRLIQRATEIO.VRLIQUIDO;
               END IF;
            END LOOP;
            IF V_TOTAPRODENCA = 0 THEN
               IF (V_IDNFRETIND = 'S') OR (V_IDCOMPRABONI = 'S') THEN /* Retorno de industrialização ou Compra/Bonificação grava encargo no brutitem do item que vai para o vencimento */
                  SELECT SUM(IP.VRTOTAITEM - IP.VRDESCITEM) INTO V_TOTAPRODENCA
                    FROM ITEMPRODUTO IP, TPOPERCFOP T, NOTAFISCAL N
                   WHERE IP.CDFILIAL     = P_FILIAL
                     AND IP.NRLANCTONF   = P_LANCTONF
                     AND IP.CDFILIAL     = N.CDFILIAL
                     AND IP.NRLANCTONF   = N.NRLANCTONF
                     AND IP.CDFISOPEITEM = T.CDFISCOPER
                     AND N.CDTIPOOPER    = T.CDTIPOOPER
                     AND T.IDCOMPOEVENC  = w_S;
                  IF V_TOTAPRODENCA <> 0 THEN
                     FOR C_ATUAVRCONT IN (SELECT IP.NRSEQITPROD, (IP.VRTOTAITEM - IP.VRDESCITEM) AS VRLIQUIDO,
                                                 IP.CDFISOPEITEM, IP.CDPRODUTO
                                            FROM ITEMPRODUTO IP, TPOPERCFOP T, NOTAFISCAL N
                                           WHERE IP.CDFILIAL     = P_FILIAL
                                             AND IP.NRLANCTONF   = P_LANCTONF
                                             AND IP.CDFILIAL     = N.CDFILIAL
                                             AND IP.NRLANCTONF   = N.NRLANCTONF
                                             AND IP.CDFISOPEITEM = T.CDFISCOPER
                                             AND N.CDTIPOOPER    = T.CDTIPOOPER
                                             AND T.IDCOMPOEVENC  = w_S) LOOP
                        IF (C_ITEMENCARGO.IDENCARGO = W_A) THEN
                           V_VRBRUTO := (C_ITEMENCARGO.VRITEMENCA/V_TOTAPRODENCA);
                        ELSIF (C_ITEMENCARGO.IDENCARGO = W_D) THEN
                           V_VRBRUTO := - (C_ITEMENCARGO.VRITEMENCA/V_TOTAPRODENCA);
                        ELSE
                           V_VRBRUTO := 0;
                        END IF;
                        IF (C_ITEMENCARGO.CDCTBLENTREN IS NULL) THEN
                           V_VRCONTAB := V_VRBRUTO;
                        ELSE
                           V_VRCONTAB := 0;
                        END IF;
                        BEGIN
                           SELECT (VRTOTAITEM - VRDESCITEM)
                           INTO V_VALRDESCITEM
                           FROM ITEMPRODUTO
                           WHERE CDFILIAL    = P_FILIAL   AND
                                 NRLANCTONF  = P_LANCTONF AND
                                 NRSEQITPROD = C_ATUAVRCONT.NRSEQITPROD;
                        EXCEPTION
                            WHEN NO_DATA_FOUND THEN
                               V_VALRDESCITEM := 0;
                        END;
                        UPDATE ITEMPRODUTO
                        SET VRBRUTITEM = ROUND(VRBRUTITEM + (V_VRBRUTO  * (VRTOTAITEM - VRDESCITEM)), 5),
                            VRCONTITEM = ROUND(VRCONTITEM + (V_VRCONTAB * (VRTOTAITEM - VRDESCITEM)), 5)
                        WHERE CDFILIAL    = P_FILIAL   AND
                              NRLANCTONF  = P_LANCTONF AND
                              NRSEQITPROD = C_ATUAVRCONT.NRSEQITPROD;
                        UPDATE TRABITPROIMPOS
                        SET VRCONTIMPOIT = ROUND(VRCONTIMPOIT + ((V_VRBRUTO * V_VALRDESCITEM) * ((100 - VRREDBCIMPOIT)/100)),5)
                        WHERE CDFILIMPOIT  = P_FILIAL   AND
                              NRLANCIMPOIT = P_LANCTONF AND
                              NRSEQIMPOIT  = C_ATUAVRCONT.NRSEQITPROD;
                     END LOOP;
                  END IF;
               ELSE
                  SELECT SUM(VRTOTAITEM - VRDESCITEM) INTO V_TOTAPRODENCA
                  FROM ITEMPRODUTO IP
                  WHERE (IP.CDFILIAL   = P_FILIAL)   AND
                        (IP.NRLANCTONF = P_LANCTONF);
                  IF V_TOTAPRODENCA <> 0 THEN
                     V_ENCIMPXML   := NULL;
                     IF (V_IDNFGERADAVIAXML = 'S') THEN
                        IF (V_NRACESSONFE IS NOT NULL) THEN
                           BEGIN
                              SELECT MAX(CDENCARGOIMPXML)
                                INTO V_ENCIMPXML
                                FROM INTG_TRABITPROIMPOS IT, IMPOSTO I
                               WHERE NRACESSONFE = V_NRACESSONFE
                                 AND IT.CDIMPOSTOIT    = I.CDIMPOSTO
                                 AND I.CDENCARGOIMPXML IS NOT NULL
                                 AND I.IDIMPORTAIMPXML = 'S'
                                 AND IT.VRIMPOSTOIT > 0
                                 AND I.CDENCARGOIMPXML = C_ITEMENCARGO.CDENCARGO;
                           EXCEPTION
                              WHEN NO_DATA_FOUND THEN
                                 V_ENCIMPXML := NULL;
                           END;
                        END IF;
                     END IF;
                     IF V_ENCIMPXML IS NULL THEN
                        FOR C_ATUAVRCONT IN (SELECT IP.NRSEQITPROD, (VRTOTAITEM - VRDESCITEM) AS VRLIQUIDO
                                               FROM ITEMPRODUTO IP
                                              WHERE (IP.CDFILIAL    = P_FILIAL)
                                                AND (IP.NRLANCTONF  = P_LANCTONF)) LOOP
                           IF (C_ITEMENCARGO.IDENCARGO = W_A) THEN
                              V_VRBRUTO := (C_ITEMENCARGO.VRITEMENCA/V_TOTAPRODENCA);
                           ELSIF (C_ITEMENCARGO.IDENCARGO = W_D) THEN
                              V_VRBRUTO := - (C_ITEMENCARGO.VRITEMENCA/V_TOTAPRODENCA);
                           ELSE
                              V_VRBRUTO := 0;
                           END IF;
                           IF (C_ITEMENCARGO.CDCTBLENTREN IS NULL) THEN
                              V_VRCONTAB := V_VRBRUTO;
                           ELSE
                              V_VRCONTAB := 0;
                           END IF;
                           BEGIN
                              SELECT (VRTOTAITEM - VRDESCITEM)
                              INTO V_VALRDESCITEM
                              FROM ITEMPRODUTO
                              WHERE CDFILIAL    = P_FILIAL   AND
                                    NRLANCTONF  = P_LANCTONF AND
                                    NRSEQITPROD = C_ATUAVRCONT.NRSEQITPROD;
                           EXCEPTION
                               WHEN NO_DATA_FOUND THEN
                                  V_VALRDESCITEM := 0;
                           END;
                           UPDATE ITEMPRODUTO
                           SET VRBRUTITEM = ROUND(VRBRUTITEM + (V_VRBRUTO  * (VRTOTAITEM - VRDESCITEM)), 5),
                               VRCONTITEM = ROUND(VRCONTITEM + (V_VRCONTAB * (VRTOTAITEM - VRDESCITEM)), 5)
                           WHERE CDFILIAL    = P_FILIAL   AND
                                 NRLANCTONF  = P_LANCTONF AND
                                 NRSEQITPROD = C_ATUAVRCONT.NRSEQITPROD;
                           UPDATE TRABITPROIMPOS
                           SET VRCONTIMPOIT = ROUND(VRCONTIMPOIT + ((V_VRBRUTO * V_VALRDESCITEM) * ((100 - VRREDBCIMPOIT)/100)),5)
                           WHERE CDFILIMPOIT  = P_FILIAL   AND
                                 NRLANCIMPOIT = P_LANCTONF AND
                                 NRSEQIMPOIT  = C_ATUAVRCONT.NRSEQITPROD;
                        END LOOP;
                     ELSE     /*Rateio encargo/imposto xml*/
                        FOR C_ATUAVRCONT IN (SELECT VRIMPOSTOIT + NVL(VRADICFECP, 0) AS VRIMPOSTOIT, LPAD(NRSEQIMPOIT, 4, '0') AS NRSEQITPROD
                                               FROM INTG_TRABITPROIMPOS IT, IMPOSTO I
                                              WHERE NRACESSONFE = V_NRACESSONFE
                                                AND IT.CDIMPOSTOIT    = I.CDIMPOSTO
                                                AND I.CDENCARGOIMPXML IS NOT NULL
                                                AND I.IDIMPORTAIMPXML = 'S'
                                                AND IT.VRIMPOSTOIT > 0
                                                AND I.CDENCARGOIMPXML = C_ITEMENCARGO.CDENCARGO) LOOP
                           IF (C_ITEMENCARGO.IDENCARGO = W_A) THEN
                              V_VRBRUTO := C_ATUAVRCONT.VRIMPOSTOIT;
                           ELSIF (C_ITEMENCARGO.IDENCARGO = W_D) THEN
                              V_VRBRUTO := - (C_ATUAVRCONT.VRIMPOSTOIT);
                           ELSE
                              V_VRBRUTO := 0;
                           END IF;
                           IF (C_ITEMENCARGO.CDCTBLENTREN IS NULL) THEN
                              V_VRCONTAB := V_VRBRUTO;
                           ELSE
                              V_VRCONTAB := 0;
                           END IF;
                           BEGIN
                              SELECT (VRTOTAITEM - VRDESCITEM)
                              INTO V_VALRDESCITEM
                              FROM ITEMPRODUTO
                              WHERE CDFILIAL    = P_FILIAL   AND
                                    NRLANCTONF  = P_LANCTONF AND
                                    NRSEQITPROD = C_ATUAVRCONT.NRSEQITPROD;
                           EXCEPTION
                               WHEN NO_DATA_FOUND THEN
                                  V_VALRDESCITEM := 0;
                           END;
                           UPDATE ITEMPRODUTO
                              SET VRBRUTITEM = ROUND((VRBRUTITEM + V_VRBRUTO), 5),
                                  VRCONTITEM = ROUND((VRCONTITEM + V_VRCONTAB), 5)
                            WHERE CDFILIAL    = P_FILIAL   AND
                                  NRLANCTONF  = P_LANCTONF AND
                                  NRSEQITPROD = C_ATUAVRCONT.NRSEQITPROD;
                           UPDATE TRABITPROIMPOS
                           SET VRCONTIMPOIT = ROUND((VRCONTIMPOIT + V_VRBRUTO),5)
                           WHERE CDFILIMPOIT  = P_FILIAL   AND
                                 NRLANCIMPOIT = P_LANCTONF AND
                                 NRSEQIMPOIT  = C_ATUAVRCONT.NRSEQITPROD;
                        END LOOP;
                     END IF;  /*Rateio encargo/imposto xml*/
                  END IF;
               END IF;   -- Coloquei isso
            ELSE
               IF (V_IDNFRETIND = 'S') OR (V_IDCOMPRABONI = 'S') THEN /* Retorno de industrialização ou Compra/Bonificação grava encargo no brutitem do item que vai para o vencimento */
                  SELECT SUM(IP.VRTOTAITEM - IP.VRDESCITEM) INTO V_TOTAPRODENCA
                    FROM ITEMPRODUTO IP, TPOPERCFOP T, NOTAFISCAL N
                   WHERE IP.CDFILIAL     = P_FILIAL
                     AND IP.NRLANCTONF   = P_LANCTONF
                     AND IP.CDFILIAL     = N.CDFILIAL
                     AND IP.NRLANCTONF   = N.NRLANCTONF
                     AND IP.CDFISOPEITEM = T.CDFISCOPER
                     AND N.CDTIPOOPER    = T.CDTIPOOPER
                     AND T.IDCOMPOEVENC  = w_S;
                  IF V_TOTAPRODENCA <> 0 THEN
                     FOR C_ATUAVRCONT IN (SELECT IP.NRSEQITPROD, (IP.VRTOTAITEM - IP.VRDESCITEM) AS VRLIQUIDO,
                                                 IP.CDFISOPEITEM, IP.CDPRODUTO
                                            FROM ITEMPRODUTO IP, TPOPERCFOP T, NOTAFISCAL N
                                           WHERE IP.CDFILIAL     = P_FILIAL
                                             AND IP.NRLANCTONF   = P_LANCTONF
                                             AND IP.CDFILIAL     = N.CDFILIAL
                                             AND IP.NRLANCTONF   = N.NRLANCTONF
                                             AND IP.CDFISOPEITEM = T.CDFISCOPER
                                             AND N.CDTIPOOPER    = T.CDTIPOOPER
                                             AND T.IDCOMPOEVENC  = w_S) LOOP
                        IF (C_ITEMENCARGO.IDENCARGO = W_A) THEN
                           V_VRBRUTO := (C_ITEMENCARGO.VRITEMENCA/V_TOTAPRODENCA);
                        ELSIF (C_ITEMENCARGO.IDENCARGO = W_D) THEN
                           V_VRBRUTO := - (C_ITEMENCARGO.VRITEMENCA/V_TOTAPRODENCA);
                        ELSE
                           V_VRBRUTO := 0;
                        END IF;
                        IF (C_ITEMENCARGO.CDCTBLENTREN IS NULL) THEN
                           V_VRCONTAB := V_VRBRUTO;
                        ELSE
                           V_VRCONTAB := 0;
                        END IF;
                        BEGIN
                           SELECT (VRTOTAITEM - VRDESCITEM)
                           INTO V_VALRDESCITEM
                           FROM ITEMPRODUTO
                           WHERE CDFILIAL    = P_FILIAL   AND
                                 NRLANCTONF  = P_LANCTONF AND
                                 NRSEQITPROD = C_ATUAVRCONT.NRSEQITPROD;
                        EXCEPTION
                            WHEN NO_DATA_FOUND THEN
                               V_VALRDESCITEM := 0;
                        END;
                        UPDATE ITEMPRODUTO
                        SET VRBRUTITEM = ROUND(VRBRUTITEM + (V_VRBRUTO  * (VRTOTAITEM - VRDESCITEM)), 5),
                            VRCONTITEM = ROUND(VRCONTITEM + (V_VRCONTAB * (VRTOTAITEM - VRDESCITEM)), 5)
                        WHERE CDFILIAL    = P_FILIAL   AND
                              NRLANCTONF  = P_LANCTONF AND
                              NRSEQITPROD = C_ATUAVRCONT.NRSEQITPROD;
                        UPDATE TRABITPROIMPOS
                        SET VRCONTIMPOIT = ROUND(VRCONTIMPOIT + ((V_VRBRUTO * V_VALRDESCITEM) * ((100 - VRREDBCIMPOIT)/100)),5)
                        WHERE CDFILIMPOIT  = P_FILIAL   AND
                              NRLANCIMPOIT = P_LANCTONF AND
                              NRSEQIMPOIT  = C_ATUAVRCONT.NRSEQITPROD;
                     END LOOP;
                  END IF;
               ELSE
                  V_ENCIMPXML   := NULL;
                  IF (V_IDNFGERADAVIAXML = 'S') THEN
                     IF (V_NRACESSONFE IS NOT NULL) THEN
                        BEGIN
                           SELECT MAX(CDENCARGOIMPXML)
                             INTO V_ENCIMPXML
                             FROM INTG_TRABITPROIMPOS IT, IMPOSTO I
                            WHERE NRACESSONFE = V_NRACESSONFE
                              AND IT.CDIMPOSTOIT    = I.CDIMPOSTO
                              AND I.CDENCARGOIMPXML IS NOT NULL
                              AND I.IDIMPORTAIMPXML = 'S'
                              AND IT.VRIMPOSTOIT > 0
                              AND I.CDENCARGOIMPXML = C_ITEMENCARGO.CDENCARGO;
                        EXCEPTION
                           WHEN NO_DATA_FOUND THEN
                              V_ENCIMPXML := NULL;
                        END;
                     END IF;
                  END IF;
                  IF V_ENCIMPXML IS NULL THEN
                     FOR C_ATUAVRCONT IN (SELECT DISTINCT(IP.NRSEQITPROD) AS NRSEQITPROD, (VRTOTAITEM - VRDESCITEM) AS VRLIQUIDO,
                                                 NRITPROIMPOS
                                           FROM ITEMPRODUTO IP, ITEMPROIMPOS II
                                           WHERE (IP.CDFILIAL     = P_FILIAL)       AND
                                                 (IP.NRLANCTONF   = P_LANCTONF)     AND
                                                 (II.CDFILIAL     = IP.CDFILIAL)    AND
                                                 (II.NRLANCTONF   = IP.NRLANCTONF)  AND
                                                 (II.NRSEQITPROD  = IP.NRSEQITPROD) AND
                                                 (II.NRITPROIMPOS = W_1)            AND
                                                 (EXISTS(SELECT BC.CDIMPOSTO
                                                         FROM BASECALC BC
                                                         WHERE (BC.CDENCARGO = C_ITEMENCARGO.CDENCARGO) AND
                                                               (BC.CDIMPOSTO = II.CDIMPOSTO)            AND
                                                               (BC.CDIMPOSTO IN (SELECT B.CDIMPOSTO
                                                                                FROM BASECALC B
                                                                                WHERE B.CDENCARGO = C_ITEMENCARGO.CDENCARGO))))) LOOP
                        IF (C_ITEMENCARGO.IDENCARGO = W_A) THEN
                           V_VRBRUTO := (C_ITEMENCARGO.VRITEMENCA/V_TOTAPRODENCA);
                        ELSIF (C_ITEMENCARGO.IDENCARGO = W_D) THEN
                           V_VRBRUTO := - (C_ITEMENCARGO.VRITEMENCA/V_TOTAPRODENCA);
                        ELSE
                           V_VRBRUTO := 0;
                        END IF;
                        IF (C_ITEMENCARGO.CDCTBLENTREN IS NULL) THEN
                           V_VRCONTAB := V_VRBRUTO;
                        ELSE
                           V_VRCONTAB := 0;
                        END IF;
                        UPDATE ITEMPRODUTO
                        SET VRBRUTITEM = ROUND(VRBRUTITEM + (V_VRBRUTO  * (VRTOTAITEM - VRDESCITEM)), 5),
                            VRCONTITEM = ROUND(VRCONTITEM + (V_VRCONTAB * (VRTOTAITEM - VRDESCITEM)), 5)
                        WHERE CDFILIAL    = P_FILIAL   AND
                              NRLANCTONF  = P_LANCTONF AND
                              NRSEQITPROD = C_ATUAVRCONT.NRSEQITPROD;
                     END LOOP;
                  ELSE     /*Rateio encargo/imposto xml*/
                     FOR C_ATUAVRCONT IN (SELECT VRIMPOSTOIT + NVL(VRADICFECP, 0) AS VRIMPOSTOIT, LPAD(NRSEQIMPOIT, 4, '0') AS NRSEQITPROD
                                            FROM INTG_TRABITPROIMPOS IT, IMPOSTO I
                                           WHERE NRACESSONFE = V_NRACESSONFE
                                             AND IT.CDIMPOSTOIT    = I.CDIMPOSTO
                                             AND I.CDENCARGOIMPXML IS NOT NULL
                                             AND I.IDIMPORTAIMPXML = 'S'
                                             AND IT.VRIMPOSTOIT > 0
                                             AND I.CDENCARGOIMPXML = C_ITEMENCARGO.CDENCARGO) LOOP
                        IF (C_ITEMENCARGO.IDENCARGO = W_A) THEN
                           V_VRBRUTO := C_ATUAVRCONT.VRIMPOSTOIT;
                        ELSIF (C_ITEMENCARGO.IDENCARGO = W_D) THEN
                           V_VRBRUTO := - (C_ATUAVRCONT.VRIMPOSTOIT);
                        ELSE
                           V_VRBRUTO := 0;
                        END IF;
                        IF (C_ITEMENCARGO.CDCTBLENTREN IS NULL) THEN
                           V_VRCONTAB := V_VRBRUTO;
                        ELSE
                           V_VRCONTAB := 0;
                        END IF;
                        BEGIN
                           SELECT (VRTOTAITEM - VRDESCITEM)
                           INTO V_VALRDESCITEM
                           FROM ITEMPRODUTO
                           WHERE CDFILIAL    = P_FILIAL   AND
                                 NRLANCTONF  = P_LANCTONF AND
                                 NRSEQITPROD = C_ATUAVRCONT.NRSEQITPROD;
                        EXCEPTION
                            WHEN NO_DATA_FOUND THEN
                               V_VALRDESCITEM := 0;
                        END;
                        UPDATE ITEMPRODUTO
                           SET VRBRUTITEM = ROUND((VRBRUTITEM + V_VRBRUTO), 5),
                               VRCONTITEM = ROUND((VRCONTITEM + V_VRCONTAB), 5)    --PAREI AQUI
                         WHERE CDFILIAL    = P_FILIAL   AND
                               NRLANCTONF  = P_LANCTONF AND
                               NRSEQITPROD = C_ATUAVRCONT.NRSEQITPROD;
                        UPDATE TRABITPROIMPOS
                        SET VRCONTIMPOIT = ROUND((VRCONTIMPOIT + V_VRBRUTO),5)
                        WHERE CDFILIMPOIT  = P_FILIAL   AND
                              NRLANCIMPOIT = P_LANCTONF AND
                              NRSEQIMPOIT  = C_ATUAVRCONT.NRSEQITPROD;
                     END LOOP;
                  END IF;  /*Rateio encargo/imposto xml*/
               END IF;
               FOR C_ITEMPROIMPOS IN (
                                      SELECT /*+ index (II,PK_ITEMPROIMPOS)*/
                                             II.NRSEQITPROD, II.NRITPROIMPOS, II.CDIMPOSTO, II.VRPERREDBCIT, II.VRALIQITEM,
                                             II.VRPARDEDIT, TI.VRALIQIMPOIT, (VRTOTAITEM - VRDESCITEM) AS VRLIQUIDO,
                                             TI.IDVALORINFO, TI.VRIMPOSIT, II.IDTRIMPSTII, TI.IDCONSDIFALIQ
                                      FROM ITEMPROIMPOS II, ITEMPRODUTO IP, BASECALC BC, TRABITPROIMPOS TI
                                      WHERE
                                            (IP.CDFILIAL     = P_FILIAL)                AND
                                            (IP.NRLANCTONF   = P_LANCTONF)              AND
                                            (II.CDFILIAL     = IP.CDFILIAL)             AND
                                            (II.NRLANCTONF   = IP.NRLANCTONF)           AND
                                            (II.NRSEQITPROD  = IP.NRSEQITPROD)          AND
                                            (TI.CDFILIMPOIT  = II.CDFILIAL)             AND
                                            (TI.NRLANCIMPOIT = II.NRLANCTONF)           AND
                                            (TI.NRSEQIMPOIT  = II.NRSEQITPROD)          AND
                                            (TI.CDIMPOSTOIT  = II.CDIMPOSTO)            AND
                                            (TI.NRSEQITPRO   = II.NRITPROIMPOS)         AND
                                            (BC.CDIMPOSTO    = II.CDIMPOSTO)            AND
                                            (BC.CDENCARGO    = C_ITEMENCARGO.CDENCARGO)
                                      ORDER BY 1, 2, 3) LOOP
                  SELECT SUM(VRTOTAITEM - VRDESCITEM)
                    INTO V_TOTAPRENIMPO
                    FROM ITEMPRODUTO IP, ITEMPROIMPOS II
                   WHERE (IP.CDFILIAL     = P_FILIAL)       AND
                         (IP.NRLANCTONF   = P_LANCTONF)     AND
                         (II.CDFILIAL     = IP.CDFILIAL)    AND
                         (II.NRLANCTONF   = IP.NRLANCTONF)  AND
                         (II.NRSEQITPROD  = IP.NRSEQITPROD) AND
                         (II.NRITPROIMPOS = W_1)            AND
                         (II.CDIMPOSTO    = C_ITEMPROIMPOS.CDIMPOSTO);
                  IF (C_ITEMENCARGO.IDENCARGO = W_A) THEN
                     V_PRODUENCARGO := +ROUND((C_ITEMENCARGO.VRITEMENCA/V_TOTAPRENIMPO)*C_ITEMPROIMPOS.VRLIQUIDO,2);
                  ELSIF (C_ITEMENCARGO.IDENCARGO = W_D) THEN
                     V_PRODUENCARGO := -ROUND((C_ITEMENCARGO.VRITEMENCA/V_TOTAPRENIMPO)*C_ITEMPROIMPOS.VRLIQUIDO,2);
                  ELSE
                     V_PRODUENCARGO := 0;
                  END IF;
                  BEGIN
                     SELECT NVL(IDVALORINFO, 'N')
                       INTO V_IDIMPORTAIMPXML
                       FROM TRABITPROIMPOS
                      WHERE CDFILIMPOIT  = P_FILIAL
                        AND NRLANCIMPOIT = P_LANCTONF
                        AND CDIMPOSTOIT  = C_ITEMPROIMPOS.CDIMPOSTO
                        AND NRSEQIMPOIT  = C_ITEMPROIMPOS.NRSEQITPROD
                        AND NRSEQITPRO   = '1';
                  EXCEPTION
                     WHEN NO_DATA_FOUND THEN
                        V_IDIMPORTAIMPXML := 'N';
                  END;
                  IF (V_IDNFGERADAVIAXML = 'S') AND ((V_IDIMPORTAIMPXML = 'S') OR (V_IDGERNFIGUALXML = 'S')) THEN
                     V_PRODUENCARGO := 0;
                  END IF;
                  V_TAXAALIQUOTA := (C_ITEMPROIMPOS.VRALIQITEM/100);
                  V_TAXAALIQINFO := (C_ITEMPROIMPOS.VRALIQIMPOIT/100);
                  V_CDIMPOSTRIB := NULL;
                  V_VRIMPOSTOST := 0;
                  FOR C_ICMSST IN (SELECT CDIMPOSTO
                                     FROM IMPOSTO
                                    WHERE CDIMPOSTRIB = C_ITEMPROIMPOS.CDIMPOSTO)
                  LOOP
                     V_CDIMPOSTRIB := V_CDIMPOSTRIB||C_ICMSST.CDIMPOSTO||'_';
                  END LOOP;
                  IF V_CDIMPOSTRIB IS NULL THEN
                     V_TAXABASECALC := (100 - C_ITEMPROIMPOS.VRPERREDBCIT)/100;
                  ELSE
                     V_TAXABASECALC := 1 + (C_ITEMPROIMPOS.VRPERREDBCIT)/100;
                  END IF;
                  V_VRIMPOSTOST := 0;
                  IF V_CDIMPOSTRIB IS NOT NULL THEN
                     SELECT NVL(MAX(IDVRIMPSTRIB), 'N')
                       INTO V_IDVRIMPSTRIB
                       FROM TRABITPROIMPOS I, IMPOSTO II
                      WHERE (CDFILIMPOIT     = P_FILIAL)
                        AND (NRLANCIMPOIT    = P_LANCTONF)
                        AND (NRSEQIMPOIT     = C_ITEMPROIMPOS.NRSEQITPROD)
                        AND (INSTR(V_CDIMPOSTRIB,II.CDIMPOSTO||'_') > 0)
                        AND (I.CDIMPOSTOIT = II.CDIMPOSTO);
                     IF (C_ITEMPROIMPOS.IDTRIMPSTII = W_1) OR (NVL(V_IDVRIMPSTRIB,W_N) = W_N) OR (NVL(V_IDCONSDIFALIQ , W_N) = 'S') THEN
                        V_VRIMPOSTOST := 0;
                     ELSE
                        BEGIN
                           SELECT NVL(VRIMPOSIT,0)
                           INTO V_VRIMPOSTOST
                           FROM TRABITPROIMPOS I
                           WHERE (CDFILIMPOIT  = P_FILIAL)                   AND
                                 (NRLANCIMPOIT = P_LANCTONF)                 AND
                                 (NRSEQIMPOIT  = C_ITEMPROIMPOS.NRSEQITPROD) AND
                                 (INSTR(V_CDIMPOSTRIB,CDIMPOSTOIT||'_') > 0) AND
                                 (NRSEQITPRO   = W_1);
                        EXCEPTION
                           WHEN NO_DATA_FOUND THEN
                              V_VRIMPOSTOST := 0;
                        END;
                     END IF;
                  END IF;
                  IF C_ITEMPROIMPOS.IDVALORINFO = W_S THEN
                     V_IMPOSTOIT := 0;
                  ELSE
                     V_IMPOSTOIT := ((V_PRODUENCARGO * V_TAXABASECALC) * V_TAXAALIQUOTA);
                     V_IMPOSTOIT := V_IMPOSTOIT - ((V_VRIMPOSTOST * V_TAXABASECALC) * V_TAXAALIQUOTA);
                  END IF;
                  UPDATE ITEMPROIMPOS
                     SET VRBASECALCIT = ROUND(VRBASECALCIT + (V_PRODUENCARGO * V_TAXABASECALC), 2),
                         VRCONTITIMP  = ROUND(VRCONTITIMP  + (V_PRODUENCARGO * V_TAXABASECALC),5),
                         VRIMPOSTOIT  = VRIMPOSTOIT  + V_IMPOSTOIT
                   WHERE (NRLANCTONF   = P_LANCTONF) AND
                         (CDFILIAL     = P_FILIAL)   AND
                         (NRSEQITPROD  = C_ITEMPROIMPOS.NRSEQITPROD) AND
                         (CDIMPOSTO    = C_ITEMPROIMPOS.CDIMPOSTO)   AND
                         (NRITPROIMPOS = C_ITEMPROIMPOS.NRITPROIMPOS);
                  IF C_ITEMPROIMPOS.IDVALORINFO = W_S THEN
                     V_IMPOSTOIT := 0;
                  ELSE
                     V_IMPOSTOIT := ((V_PRODUENCARGO * V_TAXABASECALC) * V_TAXAALIQINFO);
                     V_IMPOSTOIT := V_IMPOSTOIT - ((V_VRIMPOSTOST * V_TAXABASECALC) * V_TAXAALIQINFO);
                  END IF;
                  UPDATE TRABITPROIMPOS
                  SET VRBCALCIMPOIT  = ROUND(VRBCALCIMPOIT + (V_PRODUENCARGO * V_TAXABASECALC), 2),
                      VRCONTIMPOIT   = ROUND(VRCONTIMPOIT  + (V_PRODUENCARGO * V_TAXABASECALC),5),
                      VRIMPOSIT      = VRIMPOSIT     + V_IMPOSTOIT
                  WHERE CDFILIMPOIT  = P_FILIAL                   AND
                        NRLANCIMPOIT = P_LANCTONF                 AND
                        NRSEQIMPOIT  = C_ITEMPROIMPOS.NRSEQITPROD AND
                        CDIMPOSTOIT  = C_ITEMPROIMPOS.CDIMPOSTO   AND
                        NRSEQITPRO   = C_ITEMPROIMPOS.NRITPROIMPOS;
                  /* ROTINA PARA RECALCULAR O DIFERIMENTO DO IMPOSTO */
                  IF NOT ((V_IDNFGERADAVIAXML = 'S') AND ((V_IDIMPORTAIMPXML = 'S') OR (V_IDGERNFIGUALXML = 'S'))) THEN
                     BEGIN
                        SELECT MAX(VRIMPOSTOOPERAIT), MAX(VRPERDIFEREIT)
                          INTO V_VRIMPOSTOOPERAIT, V_VRPERDIFEREIT
                          FROM ITEMPROIMPOS
                         WHERE (CDFILIAL     = P_FILIAL)                    AND
                               (NRLANCTONF   = P_LANCTONF)                  AND
                               (NRSEQITPROD  = C_ITEMPROIMPOS.NRSEQITPROD)  AND
                               (CDIMPOSTO    = C_ITEMPROIMPOS.CDIMPOSTO)    AND
                               (NRITPROIMPOS = C_ITEMPROIMPOS.NRITPROIMPOS) AND
                               (IDVALORINFIT = 'N') AND
                               (VRPERDIFEREIT <> 0);
                     EXCEPTION
                        When No_Data_Found Then
                           V_VRIMPOSTOOPERAIT := 0; V_VRPERDIFEREIT := 0;
                     END;
                     IF V_VRPERDIFEREIT <> 0 THEN
                        V_VRIMPOSTOOPERAIT := ROUND((V_VRIMPOSTOOPERAIT + ((V_PRODUENCARGO * V_TAXABASECALC) * V_TAXAALIQUOTA)) - ((V_VRIMPOSTOST * V_TAXABASECALC) * V_TAXAALIQUOTA),2);
                        V_VRIMPOSTODIFERIT := ROUND((V_VRIMPOSTOOPERAIT * V_VRPERDIFEREIT/100), 2);
                        IF NOT ((V_IDNFGERADAVIAXML = 'S') AND ((V_IDIMPORTAIMPXML = 'S') OR (V_IDGERNFIGUALXML = 'S'))) THEN
                           UPDATE ITEMPROIMPOS
                              SET VRIMPOSTOOPERAIT = V_VRIMPOSTOOPERAIT,
                                  VRIMPOSTODIFERIT = V_VRIMPOSTODIFERIT
                            WHERE (CDFILIAL     = P_FILIAL)                    AND
                                  (NRLANCTONF   = P_LANCTONF)                  AND
                                  (NRSEQITPROD  = C_ITEMPROIMPOS.NRSEQITPROD)  AND
                                  (CDIMPOSTO    = C_ITEMPROIMPOS.CDIMPOSTO)    AND
                                  (NRITPROIMPOS = C_ITEMPROIMPOS.NRITPROIMPOS) AND
                                  (VRPERDIFEREIT <> 0);
                           UPDATE TRABITPROIMPOS
                              SET VRIMPOSTOOPERAIT = V_VRIMPOSTOOPERAIT,
                                  VRIMPOSTODIFERIT = V_VRIMPOSTODIFERIT
                            WHERE CDFILIMPOIT  = P_FILIAL                    AND
                                  NRLANCIMPOIT = P_LANCTONF                  AND
                                  NRSEQIMPOIT  = C_ITEMPROIMPOS.NRSEQITPROD  AND
                                  CDIMPOSTOIT  = C_ITEMPROIMPOS.CDIMPOSTO    AND
                                  NRSEQITPRO   = C_ITEMPROIMPOS.NRITPROIMPOS AND
                                  VRPERDIFEREIT <> 0;
                        END IF;
                     END IF;
                  ELSE
                     BEGIN
                        SELECT MAX(VRIMPOSTOOPERAIT), MAX(VRPERDIFEREIT)
                          INTO V_VRIMPOSTOOPERAIT, V_VRPERDIFEREIT
                          FROM ITEMPROIMPOS
                         WHERE (CDFILIAL     = P_FILIAL)                    AND
                               (NRLANCTONF   = P_LANCTONF)                  AND
                               (NRSEQITPROD  = C_ITEMPROIMPOS.NRSEQITPROD)  AND
                               (CDIMPOSTO    = C_ITEMPROIMPOS.CDIMPOSTO)    AND
                               (NRITPROIMPOS = C_ITEMPROIMPOS.NRITPROIMPOS) AND
                               (IDVALORINFIT = 'N') AND
                               (VRPERDIFEREIT <> 0);
                     EXCEPTION
                        When No_Data_Found Then
                           V_VRIMPOSTOOPERAIT := 0; V_VRPERDIFEREIT := 0;
                     END;
                     IF V_VRPERDIFEREIT <> 0 THEN
                        V_VRIMPOSTOOPERAIT := ROUND((V_VRIMPOSTOOPERAIT + ((V_PRODUENCARGO * V_TAXABASECALC) * V_TAXAALIQUOTA)) - ((V_VRIMPOSTOST * V_TAXABASECALC) * V_TAXAALIQUOTA),2);
                        V_VRIMPOSTODIFERIT := ROUND((V_VRIMPOSTOOPERAIT * V_VRPERDIFEREIT/100), 2);
                        UPDATE ITEMPROIMPOS
                           SET VRIMPOSTOOPERAIT = V_VRIMPOSTOOPERAIT,
                               VRIMPOSTODIFERIT = V_VRIMPOSTODIFERIT,
                               VRIMPOSTOIT = (V_VRIMPOSTOOPERAIT - V_VRIMPOSTODIFERIT),
                               VRIMPOSTOVISUIT = (V_VRIMPOSTOOPERAIT - V_VRIMPOSTODIFERIT)
                         WHERE (CDFILIAL     = P_FILIAL)                    AND
                               (NRLANCTONF   = P_LANCTONF)                  AND
                               (NRSEQITPROD  = C_ITEMPROIMPOS.NRSEQITPROD)  AND
                               (CDIMPOSTO    = C_ITEMPROIMPOS.CDIMPOSTO)    AND
                               (NRITPROIMPOS = C_ITEMPROIMPOS.NRITPROIMPOS) AND
                               (VRPERDIFEREIT <> 0);
                         UPDATE TRABITPROIMPOS
                            SET VRIMPOSTOOPERAIT = V_VRIMPOSTOOPERAIT,
                                VRIMPOSTODIFERIT = V_VRIMPOSTODIFERIT,
                                VRIMPOSIT = (V_VRIMPOSTOOPERAIT - V_VRIMPOSTODIFERIT)
                          WHERE CDFILIMPOIT  = P_FILIAL                    AND
                                NRLANCIMPOIT = P_LANCTONF                  AND
                                NRSEQIMPOIT  = C_ITEMPROIMPOS.NRSEQITPROD  AND
                                CDIMPOSTOIT  = C_ITEMPROIMPOS.CDIMPOSTO    AND
                                NRSEQITPRO   = C_ITEMPROIMPOS.NRITPROIMPOS AND
                                VRPERDIFEREIT <> 0;
                     END IF;
                  END IF;
               END LOOP;
            END IF;
         END LOOP;
         UPDATE ITEMPROIMPOS
         SET VRIMPOSTOIT = 0
         WHERE (CDFILIAL    = P_FILIAL)   AND
               (NRLANCTONF  = P_LANCTONF) AND
               (VRIMPOSTOIT < 0);
         UPDATE TRABITPROIMPOS
         SET VRIMPOSIT      = 0
         WHERE CDFILIMPOIT  = P_FILIAL   AND
               NRLANCIMPOIT = P_LANCTONF AND
               VRIMPOSIT    < 0;
         UPDATE ITEMPROIMPOS
         SET VRBASECALCIT = 0
         WHERE (CDFILIAL    = P_FILIAL)   AND
               (NRLANCTONF  = P_LANCTONF) AND
               (VRBASECALCIT < 0);
         UPDATE TRABITPROIMPOS
         SET VRBCALCIMPOIT = 0
         WHERE CDFILIMPOIT  = P_FILIAL   AND
               NRLANCIMPOIT = P_LANCTONF AND
               (VRBCALCIMPOIT < 0);
         ---------------------------------------------------------------------------------------------------------
         -- CÁLCULO DO VALOR DOS IMPOSTOS QUE CONTÉM OUTROS IMPOSTOS NA SUA BASE DE CÁLCULO
         IF (V_IDNFIMPORTACAO = 'N') THEN
            FOR C_PRODUTO IN (
                              SELECT /*+ index (II,PK_ITEMPROIMPOS)*/
                                     IP.NRSEQITPROD AS NRSEQITPROD, TI.CDIMPOSTOIT AS CDIMPOSTO,
                                     NVL(II.VRPERREDBCIT, 0) VRPERREDBCIT, NVL(II.VRALIQITEM, 0) VRALIQITEM,
                                     NVL(II.VRPARDEDIT, 0) VRPARDEDIT, II.CDFISCALIT, NVL(TI.VRIMPOSIT, 0) VRIMPOSIT,
                                     IM.IDTRATIMPO, IM.IDIMPORECUP, IM.CDCCTBLPASS, IM.CDCCTBLATIV, TI.VRALIQIMPOIT,
                                     II.NRITPROIMPOS, TI.NRSEQITPRO, NVL(TI.IDVALORINFO,W_N) AS IDVALORINFO,
                                     II.IDTRIMPSTII, IM.IDTIPCONTAB, NVL(II.VRBASECALCIT, 0) VRBASECALCIT, NVL(TI.VRADICFECP, 0) VRADICFECP,
                                     P.CDARVPROD, P.CDPRODUTO, IP.VRTOTAITEM, IP.VRDESCITEM, NVL(IM.IDCONTAIMPADIC, 'N')IDCONTAIMPADIC,
                                     IP.IDORIGEMPROD, IM.IDDESCRFONTE, TI.IDCONSDIFALIQ
                              FROM ITEMPRODUTO IP, ITEMPROIMPOS II, TRABITPROIMPOS TI, IMPOSTO IM, PRODUTO P
                              WHERE (IP.CDFILIAL     = P_FILIAL)           AND
                                    (IP.NRLANCTONF   = P_LANCTONF)         AND
                                    (TI.CDFILIMPOIT  = IP.CDFILIAL)        AND
                                    (TI.NRLANCIMPOIT = IP.NRLANCTONF)      AND
                                    (TI.NRSEQIMPOIT  = IP.NRSEQITPROD)     AND
                                    (TI.CDIMPOSTOIT  = IM.CDIMPOSTO)       AND
                                    (TI.NRSEQITPRO   = W_1)                AND
                                    (TI.CDFILIMPOIT  = II.CDFILIAL(+))     AND
                                    (TI.NRLANCIMPOIT = II.NRLANCTONF(+))   AND
                                    (TI.NRSEQIMPOIT  = II.NRSEQITPROD(+))  AND
                                    (TI.CDIMPOSTOIT  = II.CDIMPOSTO(+))    AND
                                    (TI.NRSEQITPRO   = II.NRITPROIMPOS(+)) AND
                                    (IP.CDPRODUTO    = P.CDPRODUTO)
                              UNION ALL
                              SELECT /*+ index (II,PK_ITEMPROIMPOS)*/
                                     IP.NRSEQITPROD AS NRSEQITPROD, II.CDIMPOSTO AS CDIMPOSTO,
                                     NVL(II.VRPERREDBCIT, 0) VRPERREDBCIT, NVL(II.VRALIQITEM, 0) VRALIQITEM,
                                     NVL(II.VRPARDEDIT, 0) VRPARDEDIT, II.CDFISCALIT, NVL(II.VRIMPOSTOIT, 0) AS VRIMPOSIT,
                                     IM.IDTRATIMPO, IM.IDIMPORECUP, IM.CDCCTBLPASS, IM.CDCCTBLATIV, II.VRALIQITEM AS VRALIQIMPOIT,
                                     II.NRITPROIMPOS, II.NRSEQITPROD AS NRSEQITPRO, NVL(II.IDVALORINFIT,W_N) AS IDVALORINFO,
                                     II.IDTRIMPSTII, IM.IDTIPCONTAB, NVL(II.VRBASECALCIT, 0) VRBASECALCIT, NVL(II.VRADICFECP, 0) VRADICFECP,
                                     P.CDARVPROD, P.CDPRODUTO, IP.VRTOTAITEM, IP.VRDESCITEM, NVL(IM.IDCONTAIMPADIC, 'N')IDCONTAIMPADIC,
                                     IP.IDORIGEMPROD, IM.IDDESCRFONTE, II.IDCONSDIFALIQ
                              FROM ITEMPRODUTO IP, ITEMPROIMPOS II, IMPOSTO IM, PRODUTO P
                              WHERE (IP.CDFILIAL     = P_FILIAL)           AND
                                    (IP.NRLANCTONF   = P_LANCTONF)         AND
                                    (II.CDFILIAL     = IP.CDFILIAL)        AND
                                    (II.NRLANCTONF   = IP.NRLANCTONF)      AND
                                    (II.NRSEQITPROD  = IP.NRSEQITPROD)     AND
                                    (II.CDIMPOSTO    = IM.CDIMPOSTO)       AND
                                    (II.NRITPROIMPOS = W_1)                AND
                                    (IP.CDPRODUTO    = P.CDPRODUTO)        AND
                                    NOT EXISTS (SELECT T.CDFILIMPOIT
                                                FROM  TRABITPROIMPOS T
                                                WHERE T.CDFILIMPOIT  = IP.CDFILIAL    AND
                                                      T.NRLANCIMPOIT = IP.NRLANCTONF)
                              ORDER BY NRSEQITPROD, CDIMPOSTO) LOOP
               V_IDIMPOBCALTPOP := NULL;
               SELECT TO_CHAR(MAX('S')), NVL(SUM(TI.VRIMPOSIT),0) AS VRIMPOBCALC, NVL(SUM(TI.VRIMPOSIT),0) AS VRIMPOBCINF
                 INTO V_IDIMPOBCALTPOP, V_TOTAIMPBCALC, V_TOTAIMPBCINF
                 FROM ITEMPRODUTO IP, ITEMPROIMPOS II, TRABITPROIMPOS TI, BASECALCTPOPER BC, IMPOSTO I
                WHERE BC.IDENTRSAIDOP = P_ENTRSAID
                  AND BC.CDTIPOOPER = P_TIPOOPER
                  AND BC.CDIMPOSTO = C_PRODUTO.CDIMPOSTO
                  AND IP.CDFILIAL     = P_FILIAL
                  AND IP.NRLANCTONF   = P_LANCTONF
                  AND IP.NRSEQITPROD  = C_PRODUTO.NRSEQITPROD
                  AND TI.CDFILIMPOIT  = P_FILIAL
                  AND TI.NRLANCIMPOIT = P_LANCTONF
                  AND TI.NRSEQIMPOIT  = C_PRODUTO.NRSEQITPROD
                  AND TI.CDIMPOSTOIT  = BC.CDIMPOBCALC
                  AND II.CDIMPOSTO    = BC.CDIMPOBCALC
                  AND TI.CDFILIMPOIT  = II.CDFILIAL(+)
                  AND TI.NRLANCIMPOIT = II.NRLANCTONF(+)
                  AND TI.NRSEQIMPOIT  = II.NRSEQITPROD(+)
                  AND (NVL(IP.IDUTVRPAUTAPROD, 'N') = 'N')
                  AND ((SUBSTR(IP.CDSITUTRIBPR,2,2) = BC.CDCSTIMPOTPOP)  OR (BC.CDCSTIMPOTPOP IS NULL))
                  AND ((SUBSTR(IP.CDFISOPEITEM,2,10) = BC.CDCFOPIMPOTPOP) OR (BC.CDCFOPIMPOTPOP IS NULL))
                  AND ((C_PRODUTO.CDFISCALIT        = BC.CDFISCIMPOTPOP) OR (BC.CDFISCIMPOTPOP IS NULL))
                  AND BC.CDIMPOBCALC = I.CDIMPOSTO
                  AND I.IDTRATIMPO <> 'D';
               IF V_IDIMPOBCALTPOP IS NULL THEN
                  SELECT NVL(SUM(TI.VRIMPOSIT),0) AS VRIMPOBCALC, NVL(SUM(TI.VRIMPOSIT),0) AS VRIMPOBCINF
                  INTO V_TOTAIMPBCALC, V_TOTAIMPBCINF
                  FROM ITEMPRODUTO IP, ITEMPROIMPOS II, TRABITPROIMPOS TI, BASECALC BC, IMPOSTO I
                  WHERE (BC.CDIMPOSTO    = C_PRODUTO.CDIMPOSTO)    AND
                        (IP.CDFILIAL     = P_FILIAL)               AND
                        (IP.NRLANCTONF   = P_LANCTONF)             AND
                        (IP.NRSEQITPROD  = C_PRODUTO.NRSEQITPROD)  AND
                        (TI.CDFILIMPOIT  = P_FILIAL)               AND
                        (TI.NRLANCIMPOIT = P_LANCTONF)             AND
                        (TI.NRSEQIMPOIT  = C_PRODUTO.NRSEQITPROD)  AND
                        (TI.CDIMPOSTOIT  = BC.CDIMPOBCALC)         AND
                        (II.CDIMPOSTO    = BC.CDIMPOBCALC)         AND
                        (TI.CDFILIMPOIT  = II.CDFILIAL(+))         AND
                        (TI.NRLANCIMPOIT = II.NRLANCTONF(+))       AND
                        (TI.NRSEQIMPOIT  = II.NRSEQITPROD(+))      AND
                        (NVL(IP.IDUTVRPAUTAPROD, 'N') = 'N')       AND
                        ((SUBSTR(IP.CDSITUTRIBPR,2,2) = BC.CDCSTIMPO)  OR (BC.CDCSTIMPO  IS NULL)) AND
                        ((SUBSTR(IP.CDFISOPEITEM,2,10) = BC.CDCFOPIMPO) OR (BC.CDCFOPIMPO IS NULL)) AND
                        ((C_PRODUTO.CDFISCALIT        = BC.CDFISCIMPO) OR (BC.CDFISCIMPO IS NULL)) AND
                        (BC.IDTIPOBCALC   = 'I')        AND
                        (BC.CDIMPOBCALC = I.CDIMPOSTO)  AND
                        (I.IDTRATIMPO <> 'D');
               END IF;
               V_IDIMBCALTPOPDE := NULL;
               SELECT TO_CHAR(MAX('S')), (NVL(SUM(VRIMPOSTOIT),0)*-1) AS VRIMPOBCALC
                 INTO V_IDIMBCALTPOPDE, V_TOTAIMPBCDES
                 FROM ITEMPRODUTO IP, ITEMPROIMPOS II, TRABITPROIMPOS TI, BASECALCTPOPER BC, IMPOSTO I
                WHERE BC.IDENTRSAIDOP = P_ENTRSAID
                  AND BC.CDTIPOOPER = P_TIPOOPER
                  AND BC.CDIMPOSTO = C_PRODUTO.CDIMPOSTO
                  AND IP.CDFILIAL     = P_FILIAL
                  AND IP.NRLANCTONF   = P_LANCTONF
                  AND IP.NRSEQITPROD  = C_PRODUTO.NRSEQITPROD
                  AND TI.CDFILIMPOIT  = P_FILIAL
                  AND TI.NRLANCIMPOIT = P_LANCTONF
                  AND TI.NRSEQIMPOIT  = C_PRODUTO.NRSEQITPROD
                  AND TI.CDIMPOSTOIT  = BC.CDIMPOBCALC
                  AND II.CDIMPOSTO    = BC.CDIMPOBCALC
                  AND TI.CDFILIMPOIT  = II.CDFILIAL(+)
                  AND TI.NRLANCIMPOIT = II.NRLANCTONF(+)
                  AND TI.NRSEQIMPOIT  = II.NRSEQITPROD(+)
                  AND (NVL(IP.IDUTVRPAUTAPROD, 'N') = 'N')
                  AND ((SUBSTR(IP.CDSITUTRIBPR,2,2) = BC.CDCSTIMPOTPOP)  OR (BC.CDCSTIMPOTPOP IS NULL))
                  AND ((SUBSTR(IP.CDFISOPEITEM,2,10) = BC.CDCFOPIMPOTPOP) OR (BC.CDCFOPIMPOTPOP IS NULL))
                  AND ((C_PRODUTO.CDFISCALIT        = BC.CDFISCIMPOTPOP) OR (BC.CDFISCIMPOTPOP IS NULL))
                  AND BC.CDIMPOBCALC = I.CDIMPOSTO
                  AND I.IDTRATIMPO = 'D';
               IF V_IDIMBCALTPOPDE IS NULL THEN
                  SELECT (NVL(SUM(VRIMPOSTOIT),0)*-1) AS VRIMPOBCALC INTO V_TOTAIMPBCDES
                  FROM ITEMPRODUTO IP, ITEMPROIMPOS II, TRABITPROIMPOS TI, BASECALC BC, IMPOSTO I
                  WHERE (BC.CDIMPOSTO    = C_PRODUTO.CDIMPOSTO)    AND
                        (IP.CDFILIAL     = P_FILIAL)               AND
                        (IP.NRLANCTONF   = P_LANCTONF)             AND
                        (IP.NRSEQITPROD  = C_PRODUTO.NRSEQITPROD)  AND
                        (TI.CDFILIMPOIT  = P_FILIAL)               AND
                        (TI.NRLANCIMPOIT = P_LANCTONF)             AND
                        (TI.NRSEQIMPOIT  = C_PRODUTO.NRSEQITPROD)  AND
                        (TI.CDIMPOSTOIT  = BC.CDIMPOBCALC)         AND
                        (II.CDIMPOSTO    = BC.CDIMPOBCALC)         AND
                        (TI.CDFILIMPOIT  = II.CDFILIAL(+))         AND
                        (TI.NRLANCIMPOIT = II.NRLANCTONF(+))       AND
                        (TI.NRSEQIMPOIT  = II.NRSEQITPROD(+))      AND
                        (NVL(IP.IDUTVRPAUTAPROD, 'N') = 'N')       AND
                        ((SUBSTR(IP.CDSITUTRIBPR,2,2) = BC.CDCSTIMPO)  OR (BC.CDCSTIMPO  IS NULL)) AND
                        ((SUBSTR(IP.CDFISOPEITEM,2,10) = BC.CDCFOPIMPO) OR (BC.CDCFOPIMPO IS NULL)) AND
                        ((C_PRODUTO.CDFISCALIT        = BC.CDFISCIMPO) OR (BC.CDFISCIMPO IS NULL)) AND
                        (BC.IDTIPOBCALC   = 'I')        AND
                        (BC.CDIMPOBCALC = I.CDIMPOSTO)  AND
                        (I.IDTRATIMPO = 'D');
               END IF;
               V_IMPOSINFO := C_PRODUTO.VRIMPOSIT;
               V_CDIMPOSTRIB := NULL;
               V_VRIMPOSTOST := 0;
               FOR C_ICMSST IN (SELECT CDIMPOSTO
                                       FROM IMPOSTO
                                      WHERE CDIMPOSTRIB = C_PRODUTO.CDIMPOSTO)
               LOOP
                  V_CDIMPOSTRIB := V_CDIMPOSTRIB||C_ICMSST.CDIMPOSTO||'_';
               END LOOP;
               V_IMPOSTRIBCOMPLANC := NULL;
               IF (V_CDIMPOSTRIB IS NOT NULL)  THEN
                  SELECT MAX(CDIMPOSTOIT)
                    INTO V_IMPOSTRIBCOMPLANC
                    FROM TRABITPROIMPOS
                   WHERE CDFILIMPOIT  = P_FILIAL
                     AND NRLANCIMPOIT = P_LANCTONF
                     AND (INSTR(V_CDIMPOSTRIB,CDIMPOSTOIT||'_') > 0);
               END IF;
               IF (V_IMPOSTRIBCOMPLANC IS NULL) THEN
                  V_CDIMPOSTRIB := NULL;
               END IF;
               IF ((V_IDGERNFIGUALXML = 'N') AND (C_PRODUTO.IDVALORINFO <> W_S)) OR (V_IDNFGERADAVIAXML = 'N') THEN
                  /*ALTERAÇÃO 01/02/2011*/
                  IF (NOT(V_TOTAIMPBCALC IS NULL) OR (V_TOTAIMPBCALC <> 0)) OR
                     (NOT(V_TOTAIMPBCDES IS NULL) OR (V_TOTAIMPBCDES <> 0)) OR
                     (V_CDIMPOSTRIB IS NOT NULL) THEN
                     IF (C_PRODUTO.IDCONSDIFALIQ = 'S') THEN
                        V_CDIMPOSTRIB := NULL;
                     END IF;
                     IF V_CDIMPOSTRIB IS NULL THEN
                        IF (C_PRODUTO.IDCONSDIFALIQ = 'N') THEN
                           V_TAXABASECALC := (100 - C_PRODUTO.VRPERREDBCIT)/100;
                           V_TAXAALIQUOTA := (C_PRODUTO.VRALIQITEM/100);
                           V_IMPOSINFO    := V_IMPOSINFO + (((V_TOTAIMPBCALC + V_TOTAIMPBCDES) * V_TAXABASECALC) * V_TAXAALIQUOTA);
                           UPDATE ITEMPROIMPOS
                              SET VRBASECALCIT = VRBASECALCIT + ((V_TOTAIMPBCALC + V_TOTAIMPBCDES) * V_TAXABASECALC),
                                  VRIMPOSTOIT  = VRIMPOSTOIT  + (((V_TOTAIMPBCALC + V_TOTAIMPBCDES) * V_TAXABASECALC) * V_TAXAALIQUOTA)
                            WHERE (CDFILIAL     = P_FILIAL)              AND
                                  (NRLANCTONF   = P_LANCTONF)            AND
                                  (NRSEQITPROD  = C_PRODUTO.NRSEQITPROD) AND
                                  (CDIMPOSTO    = C_PRODUTO.CDIMPOSTO)   AND
                                  (NRITPROIMPOS = C_PRODUTO.NRITPROIMPOS);
                           UPDATE TRABITPROIMPOS
                              SET VRBCALCIMPOIT  = VRBCALCIMPOIT + (V_TOTAIMPBCINF * V_TAXABASECALC),
                                  VRIMPOSIT      = V_IMPOSINFO
                              WHERE CDFILIMPOIT  = P_FILIAL              AND
                                    NRLANCIMPOIT = P_LANCTONF            AND
                                    NRSEQIMPOIT  = C_PRODUTO.NRSEQITPROD AND
                                    CDIMPOSTOIT  = C_PRODUTO.CDIMPOSTO   AND
                                    NRSEQITPRO   = C_PRODUTO.NRSEQITPRO;
                           UPDATE ITEMPROIMPOS
                              SET VRBASECALCIT = VRBASECALCIT + (V_TOTAIMPBCALC * ((100 - VRPERREDBCIT)/100)),
                                  VRIMPOSTOIT  = VRIMPOSTOIT  + ((V_TOTAIMPBCALC * ((100 - VRPERREDBCIT)/100)) * (VRALIQITEM/100))
                            WHERE (CDFILIAL     = P_FILIAL)              AND
                                  (NRLANCTONF   = P_LANCTONF)            AND
                                  (NRSEQITPROD  = C_PRODUTO.NRSEQITPROD) AND
                                  (CDIMPOSTO    = C_PRODUTO.CDIMPOSTO)   AND
                                  (NRITPROIMPOS = W_2);
                           UPDATE TRABITPROIMPOS
                              SET VRBCALCIMPOIT  = VRBCALCIMPOIT + (V_TOTAIMPBCINF * ((100 - VRREDBCIMPOIT)/100)),
                                  VRIMPOSIT      = VRIMPOSIT + ((V_TOTAIMPBCINF * ((100 - VRREDBCIMPOIT)/100)) * (VRALIQIMPOIT/100))
                            WHERE CDFILIMPOIT  = P_FILIAL              AND
                                  NRLANCIMPOIT = P_LANCTONF            AND
                                  NRSEQIMPOIT  = C_PRODUTO.NRSEQITPROD AND
                                  CDIMPOSTOIT  = C_PRODUTO.CDIMPOSTO   AND
                                  NRSEQITPRO   = W_2;
                           UPDATE TRABITPROIMPOS
                              SET VRBCALCIMPOIT  = VRBCALCIMPOIT + (V_TOTAIMPBCINF * V_TAXABASECALC),
                                  VRIMPOSIT      = VRIMPOSIT + ((V_TOTAIMPBCINF * V_TAXABASECALC) * (VRALIQIMPOIT/100))
                            WHERE CDFILIMPOIT  = P_FILIAL              AND
                                  NRLANCIMPOIT = P_LANCTONF            AND
                                  NRSEQIMPOIT  = C_PRODUTO.NRSEQITPROD AND
                                  CDIMPOSTOIT  = C_PRODUTO.CDIMPOSTO   AND
                                  NRSEQITPRO   = W_3;
                        ELSE
                           -- SE CONSIDERA DIFERENÇA DE ALÍQUOTA DE ICMS PARA CÁLCULO DO ICMS-ST
                           SELECT VRIMPOSIT, CDIMPOSTOIT, VRBCALCIMPOIT, II.VRALIQIMPOIT
                             INTO V_VRICMSNF, V_CDIMPOSTOICMS, V_BASECALCDIF, V_ALIQICMS
                             FROM TRABITPROIMPOS II, IMPOSTO I
                            WHERE (II.CDFILIMPOIT  = P_FILIAL)
                              AND (II.NRLANCIMPOIT = P_LANCTONF)
                              AND (II.NRSEQIMPOIT  = C_PRODUTO.NRSEQITPROD)
                              AND (II.NRSEQITPRO   = W_1)
                              AND (I.CDIMPOSTONFE  = '00')
                              AND (II.CDIMPOSTOIT  = I.CDIMPOSTO);
                           DELETE ALIQTEMP
                            WHERE NRALIQTEMP = V_ALIQTEMP;
                           CONSULTA_ALIQUOTA(V_CDIMPOSTOICMS, P_ENTRSAID, P_EMPRESA, C_PRODUTO.CDARVPROD, P_INSCESTA, V_PAISDEST,
                                                V_ESTADEST, V_PAISDEST, V_ESTADEST, V_MUNIDEST, V_LIQUIITEM, P_INIVALID, P_FILIAL, P_LANCTONF, V_CDGRPFISCSV,P_TIPOOPER,
                                                NULL, NULL, NULL, NULL, P_FORNECED, NULL, C_PRODUTO.IDORIGEMPROD);
                           SELECT MAX(VRALIQUTMP)
                             INTO V_VRALIQICMSINT
                             FROM ALIQTEMP
                            WHERE (NRALIQTEMP = V_ALIQTEMP);
                           IF ((V_VRALIQICMSINT IS NULL) OR (V_VRALIQICMSINT < V_ALIQICMS)) THEN
                              BEGIN
                                 SELECT NVL(CONSULTA_QUADRO_ALIQUOTAS(V_ESTADEST, V_ESTADEST), 0)
                                   INTO V_VRALIQICMSINT
                                   FROM DUAL;
                              EXCEPTION
                                 WHEN NO_DATA_FOUND THEN
                                    V_VRALIQICMSINT := 0;
                              END;
                           END IF;
                           V_ALIQSTDIF   := V_VRALIQICMSINT;
                           V_BASECALCDIF :=  ROUND((V_BASECALCDIF - V_VRICMSNF)/(1-(V_VRALIQICMSINT/100)), 2);
                           V_IMPOSTODIF  := ROUND(((V_BASECALCDIF * (V_VRALIQICMSINT/100)) - V_VRICMSNF), 2);
                           IF (V_IMPOSTODIF < 0) THEN
                              V_IMPOSTODIF := 0;
                           END IF;
                           V_IMPOSINFO   := V_IMPOSTODIF;
                           DELETE ALIQTEMP
                            WHERE NRALIQTEMP = V_ALIQTEMP;
                           UPDATE ITEMPROIMPOS
                              SET VRBASECALCIT = V_BASECALCDIF,
                                  VRIMPOSTOIT  = V_IMPOSTODIF,
                                  VRALIQITEM   = V_ALIQSTDIF
                            WHERE (CDFILIAL     = P_FILIAL)              AND
                                  (NRLANCTONF   = P_LANCTONF)            AND
                                  (NRSEQITPROD  = C_PRODUTO.NRSEQITPROD) AND
                                  (CDIMPOSTO    = C_PRODUTO.CDIMPOSTO)   AND
                                  (NRITPROIMPOS = C_PRODUTO.NRITPROIMPOS);
                           UPDATE TRABITPROIMPOS
                              SET VRBCALCIMPOIT  = V_BASECALCDIF,
                                  VRIMPOSIT      = V_IMPOSTODIF,
                                  VRALIQIMPOIT   = V_ALIQSTDIF
                            WHERE CDFILIMPOIT  = P_FILIAL              AND
                                  NRLANCIMPOIT = P_LANCTONF            AND
                                  NRSEQIMPOIT  = C_PRODUTO.NRSEQITPROD AND
                                  CDIMPOSTOIT  = C_PRODUTO.CDIMPOSTO   AND
                                  NRSEQITPRO   = C_PRODUTO.NRSEQITPRO;
                           UPDATE ITEMPROIMPOS
                              SET VRBASECALCIT = V_BASECALCDIF + (V_TOTAIMPBCALC * ((100 - VRPERREDBCIT)/100)),
                                  VRIMPOSTOIT  = V_IMPOSTODIF  + ((V_TOTAIMPBCALC * ((100 - VRPERREDBCIT)/100)) * (VRALIQITEM/100))
                            WHERE (CDFILIAL     = P_FILIAL)              AND
                                  (NRLANCTONF   = P_LANCTONF)            AND
                                  (NRSEQITPROD  = C_PRODUTO.NRSEQITPROD) AND
                                  (CDIMPOSTO    = C_PRODUTO.CDIMPOSTO)   AND
                                  (NRITPROIMPOS = W_2);
                           UPDATE TRABITPROIMPOS
                              SET VRBCALCIMPOIT  = V_BASECALCDIF + (V_TOTAIMPBCINF * ((100 - VRREDBCIMPOIT)/100)),
                                  VRIMPOSIT      = V_IMPOSTODIF + ((V_TOTAIMPBCINF * ((100 - VRREDBCIMPOIT)/100)) * (VRALIQIMPOIT/100))
                            WHERE CDFILIMPOIT  = P_FILIAL              AND
                                  NRLANCIMPOIT = P_LANCTONF            AND
                                  NRSEQIMPOIT  = C_PRODUTO.NRSEQITPROD AND
                                  CDIMPOSTOIT  = C_PRODUTO.CDIMPOSTO   AND
                                  NRSEQITPRO   = W_2;
                           UPDATE TRABITPROIMPOS
                              SET VRBCALCIMPOIT  = V_BASECALCDIF + (V_TOTAIMPBCINF * V_TAXABASECALC),
                                  VRIMPOSIT      = V_IMPOSTODIF + ((V_TOTAIMPBCINF * V_TAXABASECALC) * (VRALIQIMPOIT/100))
                            WHERE CDFILIMPOIT  = P_FILIAL              AND
                                  NRLANCIMPOIT = P_LANCTONF            AND
                                  NRSEQIMPOIT  = C_PRODUTO.NRSEQITPROD AND
                                  CDIMPOSTOIT  = C_PRODUTO.CDIMPOSTO   AND
                                  NRSEQITPRO   = W_3;
                        END IF;
                     ELSE
                        SELECT NVL(MAX(IDVRIMPSTRIB), 'N')
                          INTO V_IDVRIMPSTRIB
                          FROM TRABITPROIMPOS I, IMPOSTO II
                         WHERE (CDFILIMPOIT  = P_FILIAL)
                           AND (NRLANCIMPOIT = P_LANCTONF)
                           AND (NRSEQIMPOIT  = C_PRODUTO.NRSEQITPROD)
                           AND (INSTR(V_CDIMPOSTRIB,II.CDIMPOSTO||'_') > 0)
                           AND (I.CDIMPOSTOIT = II.CDIMPOSTO);
                        IF (C_PRODUTO.IDTRIMPSTII = '1') OR (NVL(V_IDVRIMPSTRIB,'N') = 'N') OR (NVL(V_IDCONSDIFALIQ , W_N) = 'S') THEN
                           V_VRIMPOSTOST := 0;
                        ELSE
                           BEGIN
                              SELECT NVL(VRIMPOSIT,0)
                              INTO V_VRIMPOSTOST
                              FROM TRABITPROIMPOS I
                              WHERE (CDFILIMPOIT  = P_FILIAL)               AND
                                    (NRLANCIMPOIT = P_LANCTONF)             AND
                                    (NRSEQIMPOIT  = C_PRODUTO.NRSEQITPROD)  AND
                                    (INSTR(V_CDIMPOSTRIB,CDIMPOSTOIT||'_') > 0) AND
                                    (NRSEQITPRO   = W_1);
                           EXCEPTION
                              WHEN NO_DATA_FOUND THEN
                                 V_VRIMPOSTOST := 0;
                           END;
                        END IF;
                        -- VERIFICA SE POSSUI PERCENTUAL DE REDUÇÃO
                        V_UTGRUPFISCS := NULL;
                        V_LIQUIITEM   := 0;
                        V_LIQUIITEM := C_PRODUTO.VRTOTAITEM - C_PRODUTO.VRDESCITEM;
                        SELECT MAX(IDGRUPFISSRV)
                          INTO V_UTGRUPFISCS
                          FROM IMPOSTO
                         WHERE CDIMPOSTO = C_PRODUTO.CDIMPOSTO;
                        IF V_UTGRUPFISCS = 'S' THEN
                           V_CDGRPFISCSV := NULL;
                           SELECT MAX(CDGRUPOFISC)
                             INTO V_CDGRPFISCSV
                             FROM SERVCLIE SC, SERVICO S
                            WHERE SC.CDFILIAL = V_CDFILIEMIT
                              AND SC.CDCLIENTE = P_FORNECED
                              AND SC.CDFILIAL = S.CDFILIAL
                              AND SC.CDSERVFILI = S.CDSERVFILI
                              AND S.CDPRODUTO = C_PRODUTO.CDPRODUTO;
                           IF V_CDGRPFISCSV IS NULL THEN
                              SELECT MAX(CDGRUPOFISC)
                                INTO V_CDGRPFISCSV
                                FROM CLIENFILIAL
                               WHERE CDFILIAL = V_CDFILIEMIT
                                 AND CDCLIENTE = P_FORNECED;
                           END IF;
                           CONSULTA_ALIQUOTA(C_PRODUTO.CDIMPOSTO, P_ENTRSAID, P_EMPRESA, C_PRODUTO.CDARVPROD, P_INSCESTA, V_PAISORIG,
                                             V_ESTAORIG, V_PAISDEST, V_ESTADEST, V_MUNIDEST, V_LIQUIITEM, P_INIVALID, P_FILIAL, P_LANCTONF, V_CDGRPFISCSV, P_TIPOOPER,
                                             NULL, NULL, NULL, NULL, P_FORNECED, NULL, C_PRODUTO.IDORIGEMPROD);
                        ELSE
                           CONSULTA_ALIQUOTA(C_PRODUTO.CDIMPOSTO, P_ENTRSAID, P_EMPRESA, C_PRODUTO.CDARVPROD, P_INSCESTA, V_PAISORIG,
                                             V_ESTAORIG, V_PAISDEST, V_ESTADEST, V_MUNIDEST, V_LIQUIITEM, P_INIVALID, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC, P_TIPOOPER,
                                             NULL, NULL, NULL, NULL, P_FORNECED, NULL, C_PRODUTO.IDORIGEMPROD);
                        END IF;
                        V_PREDBCTMP  := 0;
                        V_PBCSUBTRIB := 0;
                        SELECT (100 - (NVL(MAX(VRPREDBCTMP),0)))/100, NVL(MAX(VRPBCSTTMP),0)
                          INTO V_PREDBCTMP, V_PBCSUBTRIB
                          FROM ALIQTEMP
                         WHERE NRALIQTEMP = V_ALIQTEMP;
                        V_TAXABASECALC := 1 + (C_PRODUTO.VRPERREDBCIT)/100;
                        V_TAXAALIQUOTA := (C_PRODUTO.VRALIQITEM/100);
                        IF V_PBCSUBTRIB <> 0 THEN
                           IF (V_IDVALORINFO <> 'S') THEN
                              V_IMPOSINFO := ((C_PRODUTO.VRBASECALCIT+ ((V_TOTAIMPBCALC + V_TOTAIMPBCDES) * V_TAXABASECALC * V_PREDBCTMP)) * V_TAXAALIQUOTA);
                           END IF;
                        ELSE
                           IF (V_IDVALORINFO <> 'S') THEN
                              V_IMPOSINFO := ((C_PRODUTO.VRBASECALCIT+ ((V_TOTAIMPBCALC + V_TOTAIMPBCDES) * V_TAXABASECALC)) * V_TAXAALIQUOTA);
                           END IF;
                        END IF;
                        DELETE ALIQTEMP
                        WHERE NRALIQTEMP = V_ALIQTEMP;
                        IF V_VRIMPOSTOST > V_IMPOSINFO THEN
                           V_IMPOSINFO := 0;
                           UPDATE ITEMPROIMPOS
                           SET VRBASECALCIT = VRBASECALCIT + ((V_TOTAIMPBCALC + V_TOTAIMPBCDES) * V_TAXABASECALC),
                               VRIMPOSTOIT  = V_IMPOSINFO
                           WHERE (CDFILIAL     = P_FILIAL)              AND
                                 (NRLANCTONF   = P_LANCTONF)            AND
                                 (NRSEQITPROD  = C_PRODUTO.NRSEQITPROD) AND
                                 (CDIMPOSTO    = C_PRODUTO.CDIMPOSTO)   AND
                                 (NRITPROIMPOS = C_PRODUTO.NRITPROIMPOS);
                           UPDATE TRABITPROIMPOS
                              SET VRBCALCIMPOIT  = VRBCALCIMPOIT + (V_TOTAIMPBCINF * V_TAXABASECALC),
                                  VRIMPOSIT      = V_IMPOSINFO
                            WHERE CDFILIMPOIT  = P_FILIAL               AND
                                   NRLANCIMPOIT = P_LANCTONF            AND
                                   NRSEQIMPOIT  = C_PRODUTO.NRSEQITPROD AND
                                   CDIMPOSTOIT  = C_PRODUTO.CDIMPOSTO   AND
                                   NRSEQITPRO   = C_PRODUTO.NRSEQITPRO;
                           UPDATE ITEMPROIMPOS
                              SET VRBASECALCIT = VRBASECALCIT + (V_TOTAIMPBCALC * ((100 - VRPERREDBCIT)/100)),
                                  VRIMPOSTOIT  = VRIMPOSTOIT  + ((V_TOTAIMPBCALC * ((100 - VRPERREDBCIT)/100)) * (VRALIQITEM/100))
                            WHERE (CDFILIAL     = P_FILIAL)              AND
                                  (NRLANCTONF   = P_LANCTONF)            AND
                                  (NRSEQITPROD  = C_PRODUTO.NRSEQITPROD) AND
                                  (CDIMPOSTO    = C_PRODUTO.CDIMPOSTO)   AND
                                  (NRITPROIMPOS = W_2);
                           UPDATE TRABITPROIMPOS
                              SET VRBCALCIMPOIT  = VRBCALCIMPOIT + (V_TOTAIMPBCINF * ((100 - VRREDBCIMPOIT)/100)),
                                  VRIMPOSIT      = VRIMPOSIT + ((V_TOTAIMPBCINF * ((100 - VRREDBCIMPOIT)/100)) * (VRALIQIMPOIT/100))
                            WHERE CDFILIMPOIT  = P_FILIAL              AND
                                  NRLANCIMPOIT = P_LANCTONF            AND
                                  NRSEQIMPOIT  = C_PRODUTO.NRSEQITPROD AND
                                  CDIMPOSTOIT  = C_PRODUTO.CDIMPOSTO   AND
                                  NRSEQITPRO   = W_2;
                           UPDATE TRABITPROIMPOS
                              SET VRBCALCIMPOIT  = VRBCALCIMPOIT + (V_TOTAIMPBCINF * V_TAXABASECALC),
                                  VRIMPOSIT      = VRIMPOSIT + ((V_TOTAIMPBCINF * V_TAXABASECALC) * (VRALIQIMPOIT/100))
                            WHERE CDFILIMPOIT  = P_FILIAL              AND
                                  NRLANCIMPOIT = P_LANCTONF            AND
                                  NRSEQIMPOIT  = C_PRODUTO.NRSEQITPROD AND
                                  CDIMPOSTOIT  = C_PRODUTO.CDIMPOSTO   AND
                                  NRSEQITPRO   = W_3;
                        ELSE
                           IF (V_IDVALORINFO <> 'S') THEN
                              V_IMPOSINFO := V_IMPOSINFO - V_VRIMPOSTOST;
                           END IF;
                           UPDATE ITEMPROIMPOS
                              SET VRBASECALCIT = VRBASECALCIT + ((V_TOTAIMPBCALC + V_TOTAIMPBCDES) * V_TAXABASECALC),
                                  VRIMPOSTOIT  = V_IMPOSINFO
                            WHERE (CDFILIAL     = P_FILIAL)              AND
                                  (NRLANCTONF   = P_LANCTONF)            AND
                                  (NRSEQITPROD  = C_PRODUTO.NRSEQITPROD) AND
                                  (CDIMPOSTO    = C_PRODUTO.CDIMPOSTO)   AND
                                  (NRITPROIMPOS = C_PRODUTO.NRITPROIMPOS);
                           UPDATE TRABITPROIMPOS
                              SET VRBCALCIMPOIT  = VRBCALCIMPOIT + (V_TOTAIMPBCINF * V_TAXABASECALC),
                                  VRIMPOSIT      = V_IMPOSINFO
                            WHERE CDFILIMPOIT  = P_FILIAL              AND
                                  NRLANCIMPOIT = P_LANCTONF            AND
                                  NRSEQIMPOIT  = C_PRODUTO.NRSEQITPROD AND
                                  CDIMPOSTOIT  = C_PRODUTO.CDIMPOSTO   AND
                                  NRSEQITPRO   = C_PRODUTO.NRSEQITPRO;
                           UPDATE ITEMPROIMPOS
                              SET VRBASECALCIT = VRBASECALCIT + (V_TOTAIMPBCALC * ((100 - VRPERREDBCIT)/100)),
                                  VRIMPOSTOIT  = VRIMPOSTOIT  + ((V_TOTAIMPBCALC * ((100 - VRPERREDBCIT)/100)) * (VRALIQITEM/100))
                            WHERE (CDFILIAL     = P_FILIAL)              AND
                                  (NRLANCTONF   = P_LANCTONF)            AND
                                  (NRSEQITPROD  = C_PRODUTO.NRSEQITPROD) AND
                                  (CDIMPOSTO    = C_PRODUTO.CDIMPOSTO)   AND
                                  (NRITPROIMPOS = W_2);
                           UPDATE TRABITPROIMPOS
                              SET VRBCALCIMPOIT  = VRBCALCIMPOIT + (V_TOTAIMPBCINF * ((100 - VRREDBCIMPOIT)/100)),
                                  VRIMPOSIT      = VRIMPOSIT + ((V_TOTAIMPBCINF * ((100 - VRREDBCIMPOIT)/100)) * (VRALIQIMPOIT/100))
                            WHERE CDFILIMPOIT  = P_FILIAL              AND
                                  NRLANCIMPOIT = P_LANCTONF            AND
                                  NRSEQIMPOIT  = C_PRODUTO.NRSEQITPROD AND
                                  CDIMPOSTOIT  = C_PRODUTO.CDIMPOSTO   AND
                                  NRSEQITPRO   = W_2;
                           UPDATE TRABITPROIMPOS
                              SET VRBCALCIMPOIT  = VRBCALCIMPOIT + (V_TOTAIMPBCINF * V_TAXABASECALC),
                                  VRIMPOSIT      = VRIMPOSIT + ((V_TOTAIMPBCINF * V_TAXABASECALC) * (VRALIQIMPOIT/100))
                            WHERE CDFILIMPOIT  = P_FILIAL              AND
                                  NRLANCIMPOIT = P_LANCTONF            AND
                                  NRSEQIMPOIT  = C_PRODUTO.NRSEQITPROD AND
                                  CDIMPOSTOIT  = C_PRODUTO.CDIMPOSTO   AND
                                  NRSEQITPRO   = W_3;
                        END IF;
                     END IF;
                  END IF;
               END IF;
               /* Utiliza o próprio valor do imposto na sua base de cálculo */
               SELECT NVL(MAX(IDUTILPVRIMPBC), 'N'), MAX(IDTRATIMPO)
                 INTO V_IDUTILPVRIMPBC, V_IDTRATIMPO
                 FROM IMPOSTO
                WHERE CDIMPOSTO = C_PRODUTO.CDIMPOSTO;
               IF V_IDUTILPVRIMPBC = 'S' THEN
                  IF V_CDIMPOSTRIB IS NULL THEN
                     BEGIN
                        SELECT VRIMPOSTOIT
                          INTO V_VRIMPANTE
                          FROM ITEMPROIMPOS T
                         WHERE CDFILIAL     = P_FILIAL
                           AND NRLANCTONF   = P_LANCTONF
                           AND NRSEQITPROD  = C_PRODUTO.NRSEQITPROD
                           AND CDIMPOSTO    = C_PRODUTO.CDIMPOSTO
                           AND NRITPROIMPOS = C_PRODUTO.NRITPROIMPOS;
                     EXCEPTION
                        WHEN NO_DATA_FOUND THEN
                           V_VRIMPANTE := 0;
                     END;
                     UPDATE ITEMPROIMPOS
                        SET VRBASECALCIT = (VRBASECALCIT )/((100 -VRALIQITEM)/100),
                            VRIMPOSTOIT  = ((VRBASECALCIT)/((100 -VRALIQITEM)/100))*(VRALIQITEM/100)
                      WHERE CDFILIAL     = P_FILIAL
                        AND NRLANCTONF   = P_LANCTONF
                        AND NRSEQITPROD  = C_PRODUTO.NRSEQITPROD
                        AND CDIMPOSTO    = C_PRODUTO.CDIMPOSTO
                        AND NRITPROIMPOS = C_PRODUTO.NRITPROIMPOS;
                     UPDATE TRABITPROIMPOS
                        SET VRBCALCIMPOIT = (VRBCALCIMPOIT )/((100 -VRALIQIMPOIT)/100),
                            VRIMPOSIT     = ((VRBCALCIMPOIT)/((100 -VRALIQIMPOIT)/100))*(VRALIQIMPOIT/100)
                      WHERE CDFILIMPOIT  = P_FILIAL
                        AND NRLANCIMPOIT = P_LANCTONF
                        AND NRSEQIMPOIT  = C_PRODUTO.NRSEQITPROD
                        AND CDIMPOSTOIT  = C_PRODUTO.CDIMPOSTO
                        AND NRSEQITPRO   = C_PRODUTO.NRSEQITPRO;
                     BEGIN
                        SELECT VRIMPOSTOIT
                          INTO V_VRIMPAPOS
                          FROM ITEMPROIMPOS
                         WHERE CDFILIAL     = P_FILIAL
                           AND NRLANCTONF   = P_LANCTONF
                           AND NRSEQITPROD  = C_PRODUTO.NRSEQITPROD
                           AND CDIMPOSTO    = C_PRODUTO.CDIMPOSTO
                           AND NRITPROIMPOS = C_PRODUTO.NRITPROIMPOS;
                     EXCEPTION
                        WHEN NO_DATA_FOUND THEN
                           V_VRIMPAPOS := 0;
                     END;
                     IF V_IDTRATIMPO = 'A' THEN
                        UPDATE ITEMPRODUTO
                           SET VRBRUTITEM = VRBRUTITEM + (V_VRIMPAPOS - V_VRIMPANTE)
                         WHERE CDFILIAL     = P_FILIAL
                           AND NRLANCTONF   = P_LANCTONF
                           AND NRSEQITPROD  = C_PRODUTO.NRSEQITPROD;
                     END IF;
                  END IF;
               END IF;
               V_IMPOCONTAB := 0;
               IF (P_TIPOOPER = '03') THEN
                  SELECT NVL(MAX(VRTOTAITEM),0)
                    INTO V_TOTALITEMCOMP
                    FROM ITEMPRODUTO
                   WHERE CDFILIAL    = P_FILIAL
                     AND NRLANCTONF  = P_LANCTONF
                     AND NRSEQITPROD = C_PRODUTO.NRSEQITPROD;
               END IF;
               IF NOT(P_TIPOOPER = '03' AND V_TOTALITEMCOMP = 0 AND C_PRODUTO.IDTRATIMPO <> W_A) THEN
                  IF (C_PRODUTO.IDIMPORECUP = W_S) THEN
                     IF (C_PRODUTO.CDFISCALIT = W_1) THEN
                        IF (C_PRODUTO.CDCCTBLATIV IS NOT NULL) THEN
                           IF C_PRODUTO.IDTRATIMPO = W_V THEN
                              V_IMPOCONTAB := - (V_IMPOSINFO + C_PRODUTO.VRADICFECP);
                           END IF;
                        END IF;
                     ELSE
                        IF C_PRODUTO.IDTRATIMPO = W_A THEN
                           IF ((V_CDIMPOSTRIB IS NOT NULL) AND (C_PRODUTO.IDTRIMPSTII = '0')) OR
                              (V_CDIMPOSTRIB IS NULL) THEN
                              V_IMPOCONTAB := V_IMPOSINFO + C_PRODUTO.VRADICFECP;
                           ELSE
                              V_IMPOCONTAB := 0;
                              V_IMPOSINFO  := 0;
                           END IF;
                        ELSIF C_PRODUTO.IDTRATIMPO IN (W_D,W_R) THEN
                           V_IMPOCONTAB := - (V_IMPOSINFO + C_PRODUTO.VRADICFECP);
                        END IF;
                     END IF;
                  ELSE
                     IF NOT(C_PRODUTO.CDCCTBLPASS IS NULL) THEN
                        IF C_PRODUTO.IDTRATIMPO = W_V THEN
                           IF C_PRODUTO.IDCONTAIMPADIC = 'N' THEN
                              V_IMPOCONTAB := - (V_IMPOSINFO + C_PRODUTO.VRADICFECP);
                           END IF;
                        ELSE
                           IF C_PRODUTO.IDTRATIMPO = W_A THEN
                               SELECT NVL(MAX(IDACRPRODENTRNF), 'N')
                               INTO V_IDACRPRODENTRNF
                               FROM IMPOSTO
                               WHERE CDIMPOSTO = C_PRODUTO.CDIMPOSTO;
                               IF V_IDACRPRODENTRNF = 'S' THEN
                                  V_IMPOCONTAB := V_IMPOSINFO + C_PRODUTO.VRADICFECP;
                               END IF;
                           ELSIF (C_PRODUTO.IDTRATIMPO = W_R) AND (C_PRODUTO.IDDESCRFONTE = 'N') THEN
                              V_IMPOCONTAB := - (V_IMPOSINFO + C_PRODUTO.VRADICFECP);
                           END IF;
                        END IF;
                     ELSE
                        IF C_PRODUTO.IDTRATIMPO = W_A THEN
                           IF ((V_CDIMPOSTRIB IS NOT NULL) AND (C_PRODUTO.IDTRIMPSTII = '0')) OR
                              (V_CDIMPOSTRIB IS NULL) THEN
                              V_IMPOCONTAB := V_IMPOSINFO + C_PRODUTO.VRADICFECP;
                           ELSE
                              V_IMPOCONTAB := 0;
                              V_IMPOSINFO  := 0;
                           END IF;
                        ELSIF C_PRODUTO.IDTRATIMPO IN (W_D,W_R) THEN
                           V_IMPOCONTAB := - (V_IMPOSINFO + C_PRODUTO.VRADICFECP);
                        END IF;
                     END IF;
                  END IF;
                  IF (V_IDOPERDEVONF = W_S) OR (P_TIPOOPER = '16') THEN
                     IF (C_PRODUTO.IDTRATIMPO = W_A) THEN
                       IF NOT (((C_PRODUTO.IDIMPORECUP = W_S)  AND (C_PRODUTO.CDFISCALIT = W_1)) OR
                               ((C_PRODUTO.IDIMPORECUP <> W_S) AND (C_PRODUTO.CDCCTBLATIV IS NOT NULL))) THEN
                          IF ((V_CDIMPOSTRIB IS NOT NULL) AND (C_PRODUTO.IDTRIMPSTII = '0')) OR
                             (V_CDIMPOSTRIB IS NULL) THEN
                             V_IMPOCONTAB := V_IMPOSINFO + C_PRODUTO.VRADICFECP;
                          ELSE
                             V_IMPOCONTAB := 0;
                             V_IMPOSINFO  := 0;
                          END IF;
                       END IF;
                     ELSIF (C_PRODUTO.IDTRATIMPO = W_D) THEN
                       IF NOT(((C_PRODUTO.IDIMPORECUP = W_S) AND (C_PRODUTO.CDFISCALIT = W_1)) OR
                              ((C_PRODUTO.IDIMPORECUP <> W_S) AND (C_PRODUTO.CDCCTBLATIV IS NOT NULL))) THEN
                          V_IMPOCONTAB := - (V_IMPOSINFO + C_PRODUTO.VRADICFECP);
                       END IF;
                     ELSIF (C_PRODUTO.IDTRATIMPO = W_R) THEN
                       IF (C_PRODUTO.IDIMPORECUP = W_S) THEN
                          IF (C_PRODUTO.CDCCTBLATIV IS NULL) OR
                             (C_PRODUTO.CDFISCALIT <> W_1) THEN
                             V_IMPOCONTAB := - (V_IMPOSINFO + C_PRODUTO.VRADICFECP);
                          END IF;
                       ELSE
                          IF (C_PRODUTO.CDCCTBLATIV IS NULL) THEN
                             V_IMPOCONTAB := - (V_IMPOSINFO + C_PRODUTO.VRADICFECP);
                          END IF;
                       END IF;
                     ELSE
                        V_IMPOCONTAB := 0;
                     END IF;
                  END IF;
                  IF C_PRODUTO.IDTRATIMPO = W_A THEN
                     IF C_PRODUTO.IDTIPCONTAB = W_D THEN
                        UPDATE ITEMPRODUTO
                        SET VRCONTITEM = VRCONTITEM + V_IMPOCONTAB,
                            VRBRUTITEM = VRBRUTITEM + V_IMPOSINFO + C_PRODUTO.VRADICFECP
                        WHERE CDFILIAL    = P_FILIAL   AND
                              NRLANCTONF  = P_LANCTONF AND
                              NRSEQITPROD = C_PRODUTO.NRSEQITPROD;
                     ELSE
                        UPDATE ITEMPRODUTO
                        SET VRBRUTITEM = VRBRUTITEM + V_IMPOSINFO + C_PRODUTO.VRADICFECP
                        WHERE CDFILIAL    = P_FILIAL   AND
                              NRLANCTONF  = P_LANCTONF AND
                              NRSEQITPROD = C_PRODUTO.NRSEQITPROD;
                     END IF;
                  ELSIF C_PRODUTO.IDTRATIMPO = W_D THEN
                     IF C_PRODUTO.IDTIPCONTAB = W_D THEN
                        UPDATE ITEMPRODUTO
                        SET VRBRUTITEM = VRBRUTITEM - V_IMPOSINFO,
                            VRCONTITEM = VRCONTITEM + V_IMPOCONTAB
                        WHERE CDFILIAL    = P_FILIAL   AND
                              NRLANCTONF  = P_LANCTONF AND
                              NRSEQITPROD = C_PRODUTO.NRSEQITPROD;
                     ELSE
                        UPDATE ITEMPRODUTO
                        SET VRBRUTITEM = VRBRUTITEM - V_IMPOSINFO
                        WHERE CDFILIAL    = P_FILIAL   AND
                              NRLANCTONF  = P_LANCTONF AND
                              NRSEQITPROD = C_PRODUTO.NRSEQITPROD;
                     END IF;
                  ELSE
                     IF C_PRODUTO.IDTIPCONTAB = W_D THEN
                        UPDATE ITEMPRODUTO
                        SET VRCONTITEM = VRCONTITEM + V_IMPOCONTAB
                        WHERE CDFILIAL    = P_FILIAL   AND
                              NRLANCTONF  = P_LANCTONF AND
                              NRSEQITPROD = C_PRODUTO.NRSEQITPROD;
                     END IF;
                     IF (C_PRODUTO.IDTRATIMPO = 'R') AND (C_PRODUTO.IDDESCRFONTE = 'N') THEN
                        UPDATE ITEMPRODUTO
                        SET VRBRUTITEM = VRBRUTITEM - V_IMPOSINFO
                        WHERE CDFILIAL    = P_FILIAL   AND
                              NRLANCTONF  = P_LANCTONF AND
                              NRSEQITPROD = C_PRODUTO.NRSEQITPROD;
                     END IF;
                  END IF;
               END IF; -- NAO ALTERAR VALOR CONTÁBIL DO PRODUTO SE O VALOR DOS PRODUTOS FOR ZERO
            END LOOP;
         ELSE
            FOR C_PRODUTO IN (
                              SELECT /*+ index (II,PK_ITEMPROIMPOS)*/
                                     IP.NRSEQITPROD AS NRSEQITPROD, TI.CDIMPOSTOIT AS CDIMPOSTO,
                                     NVL(II.VRPERREDBCIT, 0) VRPERREDBCIT, NVL(II.VRALIQITEM, 0) VRALIQITEM,
                                     NVL(II.VRPARDEDIT, 0) VRPARDEDIT, II.CDFISCALIT, NVL(TI.VRIMPOSIT, 0) VRIMPOSIT,
                                     IM.IDTRATIMPO, IM.IDIMPORECUP, IM.CDCCTBLPASS, IM.CDCCTBLATIV, TI.VRALIQIMPOIT,
                                     II.NRITPROIMPOS, TI.NRSEQITPRO, NVL(TI.IDVALORINFO,W_N) AS IDVALORINFO,
                                     II.IDTRIMPSTII, IM.IDTIPCONTAB, NVL(II.VRBASECALCIT, 0) VRBASECALCIT, NVL(TI.VRADICFECP, 0) VRADICFECP,
                                     P.CDARVPROD, P.CDPRODUTO, IP.VRTOTAITEM, IP.VRDESCITEM, NVL(IM.IDCONTAIMPADIC, 'N')IDCONTAIMPADIC,
                                     IP.IDORIGEMPROD, IM.IDDESCRFONTE
                              FROM ITEMPRODUTO IP, ITEMPROIMPOS II, TRABITPROIMPOS TI, IMPOSTO IM, PRODUTO P
                              WHERE (IP.CDFILIAL     = P_FILIAL)           AND
                                    (IP.NRLANCTONF   = P_LANCTONF)         AND
                                    (TI.CDFILIMPOIT  = IP.CDFILIAL)        AND
                                    (TI.NRLANCIMPOIT = IP.NRLANCTONF)      AND
                                    (TI.NRSEQIMPOIT  = IP.NRSEQITPROD)     AND
                                    (TI.CDIMPOSTOIT  = IM.CDIMPOSTO)       AND
                                    (TI.NRSEQITPRO   = W_1)                AND
                                    (TI.CDFILIMPOIT  = II.CDFILIAL(+))     AND
                                    (TI.NRLANCIMPOIT = II.NRLANCTONF(+))   AND
                                    (TI.NRSEQIMPOIT  = II.NRSEQITPROD(+))  AND
                                    (TI.CDIMPOSTOIT  = II.CDIMPOSTO(+))    AND
                                    (TI.NRSEQITPRO   = II.NRITPROIMPOS(+)) AND
                                    (IP.CDPRODUTO    = P.CDPRODUTO)
                              UNION ALL
                              SELECT /*+ index (II,PK_ITEMPROIMPOS)*/
                                     IP.NRSEQITPROD AS NRSEQITPROD, II.CDIMPOSTO AS CDIMPOSTO,
                                     NVL(II.VRPERREDBCIT, 0) VRPERREDBCIT, NVL(II.VRALIQITEM, 0) VRALIQITEM,
                                     NVL(II.VRPARDEDIT, 0) VRPARDEDIT, II.CDFISCALIT, NVL(II.VRIMPOSTOIT, 0) AS VRIMPOSIT,
                                     IM.IDTRATIMPO, IM.IDIMPORECUP, IM.CDCCTBLPASS, IM.CDCCTBLATIV, II.VRALIQITEM AS VRALIQIMPOIT,
                                     II.NRITPROIMPOS, II.NRSEQITPROD AS NRSEQITPRO, NVL(II.IDVALORINFIT,W_N) AS IDVALORINFO,
                                     II.IDTRIMPSTII, IM.IDTIPCONTAB, NVL(II.VRBASECALCIT, 0) VRBASECALCIT, NVL(II.VRADICFECP, 0) VRADICFECP,
                                     P.CDARVPROD, P.CDPRODUTO, IP.VRTOTAITEM, IP.VRDESCITEM, NVL(IM.IDCONTAIMPADIC, 'N')IDCONTAIMPADIC,
                                     IP.IDORIGEMPROD, IM.IDDESCRFONTE
                              FROM ITEMPRODUTO IP, ITEMPROIMPOS II, IMPOSTO IM, PRODUTO P
                              WHERE (IP.CDFILIAL     = P_FILIAL)           AND
                                    (IP.NRLANCTONF   = P_LANCTONF)         AND
                                    (II.CDFILIAL     = IP.CDFILIAL)        AND
                                    (II.NRLANCTONF   = IP.NRLANCTONF)      AND
                                    (II.NRSEQITPROD  = IP.NRSEQITPROD)     AND
                                    (II.CDIMPOSTO    = IM.CDIMPOSTO)       AND
                                    (II.NRITPROIMPOS = W_1)                AND
                                    (IP.CDPRODUTO    = P.CDPRODUTO)        AND
                                    NOT EXISTS (SELECT T.CDFILIMPOIT
                                                FROM  TRABITPROIMPOS T
                                                WHERE T.CDFILIMPOIT  = IP.CDFILIAL    AND
                                                      T.NRLANCIMPOIT = IP.NRLANCTONF)
                              ORDER BY NRSEQITPROD, CDIMPOSTO DESC) LOOP
               V_IDIMPOBCALTPOP := NULL;
               SELECT TO_CHAR(MAX('S')), NVL(SUM(TI.VRIMPOSIT),0) AS VRIMPOBCALC, NVL(SUM(TI.VRIMPOSIT),0) AS VRIMPOBCINF
                 INTO V_IDIMPOBCALTPOP, V_TOTAIMPBCALC, V_TOTAIMPBCINF
                 FROM ITEMPRODUTO IP, ITEMPROIMPOS II, TRABITPROIMPOS TI, BASECALCTPOPER BC, IMPOSTO I
                WHERE BC.IDENTRSAIDOP = P_ENTRSAID
                  AND BC.CDTIPOOPER = P_TIPOOPER
                  AND BC.CDIMPOSTO = C_PRODUTO.CDIMPOSTO
                  AND IP.CDFILIAL     = P_FILIAL
                  AND IP.NRLANCTONF   = P_LANCTONF
                  AND IP.NRSEQITPROD  = C_PRODUTO.NRSEQITPROD
                  AND TI.CDFILIMPOIT  = P_FILIAL
                  AND TI.NRLANCIMPOIT = P_LANCTONF
                  AND TI.NRSEQIMPOIT  = C_PRODUTO.NRSEQITPROD
                  AND TI.CDIMPOSTOIT  = BC.CDIMPOBCALC
                  AND II.CDIMPOSTO    = BC.CDIMPOBCALC
                  AND TI.CDFILIMPOIT  = II.CDFILIAL(+)
                  AND TI.NRLANCIMPOIT = II.NRLANCTONF(+)
                  AND TI.NRSEQIMPOIT  = II.NRSEQITPROD(+)
                  AND (NVL(IP.IDUTVRPAUTAPROD, 'N') = 'N')
                  AND ((SUBSTR(IP.CDSITUTRIBPR,2,2) = BC.CDCSTIMPOTPOP)  OR (BC.CDCSTIMPOTPOP IS NULL))
                  AND ((SUBSTR(IP.CDFISOPEITEM,2,10) = BC.CDCFOPIMPOTPOP) OR (BC.CDCFOPIMPOTPOP IS NULL))
                  AND ((C_PRODUTO.CDFISCALIT        = BC.CDFISCIMPOTPOP) OR (BC.CDFISCIMPOTPOP IS NULL))
                  AND BC.CDIMPOBCALC = I.CDIMPOSTO
                  AND I.IDTRATIMPO <> 'D';
               IF V_IDIMPOBCALTPOP IS NULL THEN
                  SELECT NVL(SUM(TI.VRIMPOSIT),0) AS VRIMPOBCALC, NVL(SUM(TI.VRIMPOSIT),0) AS VRIMPOBCINF
                  INTO V_TOTAIMPBCALC, V_TOTAIMPBCINF
                  FROM ITEMPRODUTO IP, ITEMPROIMPOS II, TRABITPROIMPOS TI, BASECALC BC, IMPOSTO I
                  WHERE (BC.CDIMPOSTO    = C_PRODUTO.CDIMPOSTO)    AND
                        (IP.CDFILIAL     = P_FILIAL)               AND
                        (IP.NRLANCTONF   = P_LANCTONF)             AND
                        (IP.NRSEQITPROD  = C_PRODUTO.NRSEQITPROD)  AND
                        (TI.CDFILIMPOIT  = P_FILIAL)               AND
                        (TI.NRLANCIMPOIT = P_LANCTONF)             AND
                        (TI.NRSEQIMPOIT  = C_PRODUTO.NRSEQITPROD)  AND
                        (TI.CDIMPOSTOIT  = BC.CDIMPOBCALC)         AND
                        (II.CDIMPOSTO    = BC.CDIMPOBCALC)         AND
                        (TI.CDFILIMPOIT  = II.CDFILIAL(+))         AND
                        (TI.NRLANCIMPOIT = II.NRLANCTONF(+))       AND
                        (TI.NRSEQIMPOIT  = II.NRSEQITPROD(+))      AND
                        (NVL(IP.IDUTVRPAUTAPROD, 'N') = 'N')       AND
                        ((SUBSTR(IP.CDSITUTRIBPR,2,2) = BC.CDCSTIMPO)  OR (BC.CDCSTIMPO  IS NULL)) AND
                        ((SUBSTR(IP.CDFISOPEITEM,2,10) = BC.CDCFOPIMPO) OR (BC.CDCFOPIMPO IS NULL)) AND
                        ((C_PRODUTO.CDFISCALIT        = BC.CDFISCIMPO) OR (BC.CDFISCIMPO IS NULL)) AND
                        (BC.IDTIPOBCALC   = 'I')        AND
                        (BC.CDIMPOBCALC = I.CDIMPOSTO)  AND
                        (I.IDTRATIMPO <> 'D');
               END IF;
               V_IDIMBCALTPOPDE := NULL;
               SELECT TO_CHAR(MAX('S')), (NVL(SUM(VRIMPOSTOIT),0)*-1) AS VRIMPOBCALC
                 INTO V_IDIMBCALTPOPDE, V_TOTAIMPBCDES
                 FROM ITEMPRODUTO IP, ITEMPROIMPOS II, TRABITPROIMPOS TI, BASECALCTPOPER BC, IMPOSTO I
                WHERE BC.IDENTRSAIDOP = P_ENTRSAID
                  AND BC.CDTIPOOPER = P_TIPOOPER
                  AND BC.CDIMPOSTO = C_PRODUTO.CDIMPOSTO
                  AND IP.CDFILIAL     = P_FILIAL
                  AND IP.NRLANCTONF   = P_LANCTONF
                  AND IP.NRSEQITPROD  = C_PRODUTO.NRSEQITPROD
                  AND TI.CDFILIMPOIT  = P_FILIAL
                  AND TI.NRLANCIMPOIT = P_LANCTONF
                  AND TI.NRSEQIMPOIT  = C_PRODUTO.NRSEQITPROD
                  AND TI.CDIMPOSTOIT  = BC.CDIMPOBCALC
                  AND II.CDIMPOSTO    = BC.CDIMPOBCALC
                  AND TI.CDFILIMPOIT  = II.CDFILIAL(+)
                  AND TI.NRLANCIMPOIT = II.NRLANCTONF(+)
                  AND TI.NRSEQIMPOIT  = II.NRSEQITPROD(+)
                  AND (NVL(IP.IDUTVRPAUTAPROD, 'N') = 'N')
                  AND ((SUBSTR(IP.CDSITUTRIBPR,2,2) = BC.CDCSTIMPOTPOP)  OR (BC.CDCSTIMPOTPOP IS NULL))
                  AND ((SUBSTR(IP.CDFISOPEITEM,2,10) = BC.CDCFOPIMPOTPOP) OR (BC.CDCFOPIMPOTPOP IS NULL))
                  AND ((C_PRODUTO.CDFISCALIT        = BC.CDFISCIMPOTPOP) OR (BC.CDFISCIMPOTPOP IS NULL))
                  AND BC.CDIMPOBCALC = I.CDIMPOSTO
                  AND I.IDTRATIMPO = 'D';
               IF V_IDIMBCALTPOPDE IS NULL THEN
                  SELECT (NVL(SUM(VRIMPOSTOIT),0)*-1) AS VRIMPOBCALC INTO V_TOTAIMPBCDES
                  FROM ITEMPRODUTO IP, ITEMPROIMPOS II, TRABITPROIMPOS TI, BASECALC BC, IMPOSTO I
                  WHERE (BC.CDIMPOSTO    = C_PRODUTO.CDIMPOSTO)    AND
                        (IP.CDFILIAL     = P_FILIAL)               AND
                        (IP.NRLANCTONF   = P_LANCTONF)             AND
                        (IP.NRSEQITPROD  = C_PRODUTO.NRSEQITPROD)  AND
                        (TI.CDFILIMPOIT  = P_FILIAL)               AND
                        (TI.NRLANCIMPOIT = P_LANCTONF)             AND
                        (TI.NRSEQIMPOIT  = C_PRODUTO.NRSEQITPROD)  AND
                        (TI.CDIMPOSTOIT  = BC.CDIMPOBCALC)         AND
                        (II.CDIMPOSTO    = BC.CDIMPOBCALC)         AND
                        (TI.CDFILIMPOIT  = II.CDFILIAL(+))         AND
                        (TI.NRLANCIMPOIT = II.NRLANCTONF(+))       AND
                        (TI.NRSEQIMPOIT  = II.NRSEQITPROD(+))      AND
                        (NVL(IP.IDUTVRPAUTAPROD, 'N') = 'N')       AND
                        ((SUBSTR(IP.CDSITUTRIBPR,2,2) = BC.CDCSTIMPO)  OR (BC.CDCSTIMPO  IS NULL)) AND
                        ((SUBSTR(IP.CDFISOPEITEM,2,10) = BC.CDCFOPIMPO) OR (BC.CDCFOPIMPO IS NULL)) AND
                        ((C_PRODUTO.CDFISCALIT        = BC.CDFISCIMPO) OR (BC.CDFISCIMPO IS NULL)) AND
                        (BC.IDTIPOBCALC   = 'I')        AND
                        (BC.CDIMPOBCALC = I.CDIMPOSTO)  AND
                        (I.IDTRATIMPO = 'D');
               END IF;
               V_IMPOSINFO := C_PRODUTO.VRIMPOSIT;
               V_CDIMPOSTRIB := NULL;
               V_VRIMPOSTOST := 0;
               FOR C_ICMSST IN (SELECT CDIMPOSTO
                                       FROM IMPOSTO
                                      WHERE CDIMPOSTRIB = C_PRODUTO.CDIMPOSTO)
               LOOP
                  V_CDIMPOSTRIB := V_CDIMPOSTRIB||C_ICMSST.CDIMPOSTO||'_';
               END LOOP;
               V_IMPOSTRIBCOMPLANC := NULL;
               IF (V_CDIMPOSTRIB IS NOT NULL)  THEN
                  SELECT MAX(CDIMPOSTOIT)
                    INTO V_IMPOSTRIBCOMPLANC
                    FROM TRABITPROIMPOS
                   WHERE CDFILIMPOIT  = P_FILIAL
                     AND NRLANCIMPOIT = P_LANCTONF
                     AND (INSTR(V_CDIMPOSTRIB,CDIMPOSTOIT||'_') > 0);
               END IF;
               IF V_IMPOSTRIBCOMPLANC IS NULL THEN
                  V_CDIMPOSTRIB := NULL;
               END IF;
               IF ((V_IDGERNFIGUALXML = 'N') AND (C_PRODUTO.IDVALORINFO <> W_S)) OR (V_IDNFGERADAVIAXML = 'N') THEN
                  /*ALTERAÇÃO 01/02/2011*/
                  IF (NOT(V_TOTAIMPBCALC IS NULL) OR (V_TOTAIMPBCALC <> 0)) OR
                     (NOT(V_TOTAIMPBCDES IS NULL) OR (V_TOTAIMPBCDES <> 0)) OR
                     (V_CDIMPOSTRIB IS NOT NULL) THEN
                     IF V_CDIMPOSTRIB IS NULL THEN
                        V_TAXABASECALC := (100 - C_PRODUTO.VRPERREDBCIT)/100;
                        V_TAXAALIQUOTA := (C_PRODUTO.VRALIQITEM/100);
                        V_IMPOSINFO    := V_IMPOSINFO + (((V_TOTAIMPBCALC + V_TOTAIMPBCDES) * V_TAXABASECALC) * V_TAXAALIQUOTA);
                        UPDATE ITEMPROIMPOS
                           SET VRBASECALCIT = VRBASECALCIT + ((V_TOTAIMPBCALC + V_TOTAIMPBCDES) * V_TAXABASECALC),
                               VRIMPOSTOIT  = VRIMPOSTOIT  + (((V_TOTAIMPBCALC + V_TOTAIMPBCDES) * V_TAXABASECALC) * V_TAXAALIQUOTA)
                         WHERE (CDFILIAL     = P_FILIAL)              AND
                               (NRLANCTONF   = P_LANCTONF)            AND
                               (NRSEQITPROD  = C_PRODUTO.NRSEQITPROD) AND
                               (CDIMPOSTO    = C_PRODUTO.CDIMPOSTO)   AND
                               (NRITPROIMPOS = C_PRODUTO.NRITPROIMPOS);
                        UPDATE TRABITPROIMPOS
                           SET VRBCALCIMPOIT  = VRBCALCIMPOIT + (V_TOTAIMPBCINF * V_TAXABASECALC),
                               VRIMPOSIT      = V_IMPOSINFO
                           WHERE CDFILIMPOIT  = P_FILIAL              AND
                                 NRLANCIMPOIT = P_LANCTONF            AND
                                 NRSEQIMPOIT  = C_PRODUTO.NRSEQITPROD AND
                                 CDIMPOSTOIT  = C_PRODUTO.CDIMPOSTO   AND
                                 NRSEQITPRO   = C_PRODUTO.NRSEQITPRO;
                        UPDATE ITEMPROIMPOS
                           SET VRBASECALCIT = VRBASECALCIT + (V_TOTAIMPBCALC * ((100 - VRPERREDBCIT)/100)),
                               VRIMPOSTOIT  = VRIMPOSTOIT  + ((V_TOTAIMPBCALC * ((100 - VRPERREDBCIT)/100)) * (VRALIQITEM/100))
                         WHERE (CDFILIAL     = P_FILIAL)              AND
                               (NRLANCTONF   = P_LANCTONF)            AND
                               (NRSEQITPROD  = C_PRODUTO.NRSEQITPROD) AND
                               (CDIMPOSTO    = C_PRODUTO.CDIMPOSTO)   AND
                               (NRITPROIMPOS = W_2);
                        UPDATE TRABITPROIMPOS
                           SET VRBCALCIMPOIT  = VRBCALCIMPOIT + (V_TOTAIMPBCINF * ((100 - VRREDBCIMPOIT)/100)),
                               VRIMPOSIT      = VRIMPOSIT + ((V_TOTAIMPBCINF * ((100 - VRREDBCIMPOIT)/100)) * (VRALIQIMPOIT/100))
                         WHERE CDFILIMPOIT  = P_FILIAL              AND
                               NRLANCIMPOIT = P_LANCTONF            AND
                               NRSEQIMPOIT  = C_PRODUTO.NRSEQITPROD AND
                               CDIMPOSTOIT  = C_PRODUTO.CDIMPOSTO   AND
                               NRSEQITPRO   = W_2;
                        UPDATE TRABITPROIMPOS
                           SET VRBCALCIMPOIT  = VRBCALCIMPOIT + (V_TOTAIMPBCINF * V_TAXABASECALC),
                               VRIMPOSIT      = VRIMPOSIT + ((V_TOTAIMPBCINF * V_TAXABASECALC) * (VRALIQIMPOIT/100))
                         WHERE CDFILIMPOIT  = P_FILIAL              AND
                               NRLANCIMPOIT = P_LANCTONF            AND
                               NRSEQIMPOIT  = C_PRODUTO.NRSEQITPROD AND
                               CDIMPOSTOIT  = C_PRODUTO.CDIMPOSTO   AND
                               NRSEQITPRO   = W_3;
                     ELSE
                        SELECT NVL(MAX(IDVRIMPSTRIB), 'N')
                          INTO V_IDVRIMPSTRIB
                          FROM TRABITPROIMPOS I, IMPOSTO II
                         WHERE (CDFILIMPOIT  = P_FILIAL)
                           AND (NRLANCIMPOIT = P_LANCTONF)
                           AND (NRSEQIMPOIT  = C_PRODUTO.NRSEQITPROD)
                           AND (INSTR(V_CDIMPOSTRIB,II.CDIMPOSTO||'_') > 0)
                           AND (I.CDIMPOSTOIT = II.CDIMPOSTO);
                        IF (C_PRODUTO.IDTRIMPSTII = '1') OR (NVL(V_IDVRIMPSTRIB,'N') = 'N') OR (NVL(V_IDCONSDIFALIQ , W_N) = 'S') THEN
                           V_VRIMPOSTOST := 0;
                        ELSE
                           BEGIN
                              SELECT NVL(VRIMPOSIT,0)
                              INTO V_VRIMPOSTOST
                              FROM TRABITPROIMPOS I
                              WHERE (CDFILIMPOIT  = P_FILIAL)               AND
                                    (NRLANCIMPOIT = P_LANCTONF)             AND
                                    (NRSEQIMPOIT  = C_PRODUTO.NRSEQITPROD)  AND
                                    (INSTR(V_CDIMPOSTRIB,CDIMPOSTOIT||'_') > 0) AND
                                    (NRSEQITPRO   = W_1);
                           EXCEPTION
                              WHEN NO_DATA_FOUND THEN
                                 V_VRIMPOSTOST := 0;
                           END;
                        END IF;
                        -- VERIFICA SE POSSUI PERCENTUAL DE REDUÇÃO
                        V_UTGRUPFISCS := NULL;
                        V_LIQUIITEM   := 0;
                        V_LIQUIITEM := C_PRODUTO.VRTOTAITEM - C_PRODUTO.VRDESCITEM;
                        SELECT MAX(IDGRUPFISSRV)
                          INTO V_UTGRUPFISCS
                          FROM IMPOSTO
                         WHERE CDIMPOSTO = C_PRODUTO.CDIMPOSTO;
                        IF V_UTGRUPFISCS = 'S' THEN
                           V_CDGRPFISCSV := NULL;
                           SELECT MAX(CDGRUPOFISC)
                             INTO V_CDGRPFISCSV
                             FROM SERVCLIE SC, SERVICO S
                            WHERE SC.CDFILIAL = V_CDFILIEMIT
                              AND SC.CDCLIENTE = P_FORNECED
                              AND SC.CDFILIAL = S.CDFILIAL
                              AND SC.CDSERVFILI = S.CDSERVFILI
                              AND S.CDPRODUTO = C_PRODUTO.CDPRODUTO;
                           IF V_CDGRPFISCSV IS NULL THEN
                              SELECT MAX(CDGRUPOFISC)
                                INTO V_CDGRPFISCSV
                                FROM CLIENFILIAL
                               WHERE CDFILIAL = V_CDFILIEMIT
                                 AND CDCLIENTE = P_FORNECED;
                           END IF;
                           CONSULTA_ALIQUOTA(C_PRODUTO.CDIMPOSTO, P_ENTRSAID, P_EMPRESA, C_PRODUTO.CDARVPROD, P_INSCESTA, V_PAISORIG,
                                             V_ESTAORIG, V_PAISDEST, V_ESTADEST, V_MUNIDEST, V_LIQUIITEM, P_INIVALID, P_FILIAL, P_LANCTONF, V_CDGRPFISCSV, P_TIPOOPER,
                                             NULL, NULL, NULL, NULL, P_FORNECED, NULL, C_PRODUTO.IDORIGEMPROD);
                        ELSE
                           CONSULTA_ALIQUOTA(C_PRODUTO.CDIMPOSTO, P_ENTRSAID, P_EMPRESA, C_PRODUTO.CDARVPROD, P_INSCESTA, V_PAISORIG,
                                             V_ESTAORIG, V_PAISDEST, V_ESTADEST, V_MUNIDEST, V_LIQUIITEM, P_INIVALID, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC, P_TIPOOPER,
                                             NULL, NULL, NULL, NULL, P_FORNECED, NULL, C_PRODUTO.IDORIGEMPROD);
                        END IF;
                        V_PREDBCTMP  := 0;
                        V_PBCSUBTRIB := 0;
                        SELECT (100 - (NVL(MAX(VRPREDBCTMP),0)))/100, NVL(MAX(VRPBCSTTMP),0)
                          INTO V_PREDBCTMP, V_PBCSUBTRIB
                          FROM ALIQTEMP
                         WHERE NRALIQTEMP = V_ALIQTEMP;
                        V_TAXABASECALC := 1 + (C_PRODUTO.VRPERREDBCIT)/100;
                        V_TAXAALIQUOTA := (C_PRODUTO.VRALIQITEM/100);
                        IF V_PBCSUBTRIB <> 0 THEN
                           IF (V_IDVALORINFO <> 'S') THEN
                              V_IMPOSINFO := ((C_PRODUTO.VRBASECALCIT+ ((V_TOTAIMPBCALC + V_TOTAIMPBCDES) * V_TAXABASECALC * V_PREDBCTMP)) * V_TAXAALIQUOTA);
                           END IF;
                        ELSE
                           IF (V_IDVALORINFO <> 'S') THEN
                              V_IMPOSINFO := ((C_PRODUTO.VRBASECALCIT+ ((V_TOTAIMPBCALC + V_TOTAIMPBCDES) * V_TAXABASECALC)) * V_TAXAALIQUOTA);
                           END IF;
                        END IF;
                        DELETE ALIQTEMP
                        WHERE NRALIQTEMP = V_ALIQTEMP;
                        IF V_VRIMPOSTOST > V_IMPOSINFO THEN
                           V_IMPOSINFO := 0;
                           UPDATE ITEMPROIMPOS
                           SET VRBASECALCIT = VRBASECALCIT + ((V_TOTAIMPBCALC + V_TOTAIMPBCDES) * V_TAXABASECALC),
                               VRIMPOSTOIT  = V_IMPOSINFO
                           WHERE (CDFILIAL     = P_FILIAL)              AND
                                 (NRLANCTONF   = P_LANCTONF)            AND
                                 (NRSEQITPROD  = C_PRODUTO.NRSEQITPROD) AND
                                 (CDIMPOSTO    = C_PRODUTO.CDIMPOSTO)   AND
                                 (NRITPROIMPOS = C_PRODUTO.NRITPROIMPOS);
                           UPDATE TRABITPROIMPOS
                              SET VRBCALCIMPOIT  = VRBCALCIMPOIT + (V_TOTAIMPBCINF * V_TAXABASECALC),
                                  VRIMPOSIT      = V_IMPOSINFO
                            WHERE CDFILIMPOIT  = P_FILIAL               AND
                                   NRLANCIMPOIT = P_LANCTONF            AND
                                   NRSEQIMPOIT  = C_PRODUTO.NRSEQITPROD AND
                                   CDIMPOSTOIT  = C_PRODUTO.CDIMPOSTO   AND
                                   NRSEQITPRO   = C_PRODUTO.NRSEQITPRO;
                           UPDATE ITEMPROIMPOS
                              SET VRBASECALCIT = VRBASECALCIT + (V_TOTAIMPBCALC * ((100 - VRPERREDBCIT)/100)),
                                  VRIMPOSTOIT  = VRIMPOSTOIT  + ((V_TOTAIMPBCALC * ((100 - VRPERREDBCIT)/100)) * (VRALIQITEM/100))
                            WHERE (CDFILIAL     = P_FILIAL)              AND
                                  (NRLANCTONF   = P_LANCTONF)            AND
                                  (NRSEQITPROD  = C_PRODUTO.NRSEQITPROD) AND
                                  (CDIMPOSTO    = C_PRODUTO.CDIMPOSTO)   AND
                                  (NRITPROIMPOS = W_2);
                           UPDATE TRABITPROIMPOS
                              SET VRBCALCIMPOIT  = VRBCALCIMPOIT + (V_TOTAIMPBCINF * ((100 - VRREDBCIMPOIT)/100)),
                                  VRIMPOSIT      = VRIMPOSIT + ((V_TOTAIMPBCINF * ((100 - VRREDBCIMPOIT)/100)) * (VRALIQIMPOIT/100))
                            WHERE CDFILIMPOIT  = P_FILIAL              AND
                                  NRLANCIMPOIT = P_LANCTONF            AND
                                  NRSEQIMPOIT  = C_PRODUTO.NRSEQITPROD AND
                                  CDIMPOSTOIT  = C_PRODUTO.CDIMPOSTO   AND
                                  NRSEQITPRO   = W_2;
                           UPDATE TRABITPROIMPOS
                              SET VRBCALCIMPOIT  = VRBCALCIMPOIT + (V_TOTAIMPBCINF * V_TAXABASECALC),
                                  VRIMPOSIT      = VRIMPOSIT + ((V_TOTAIMPBCINF * V_TAXABASECALC) * (VRALIQIMPOIT/100))
                            WHERE CDFILIMPOIT  = P_FILIAL              AND
                                  NRLANCIMPOIT = P_LANCTONF            AND
                                  NRSEQIMPOIT  = C_PRODUTO.NRSEQITPROD AND
                                  CDIMPOSTOIT  = C_PRODUTO.CDIMPOSTO   AND
                                  NRSEQITPRO   = W_3;
                        ELSE
                           IF (V_IDVALORINFO <> 'S') THEN
                              V_IMPOSINFO := V_IMPOSINFO - V_VRIMPOSTOST;
                           END IF;
                           UPDATE ITEMPROIMPOS
                              SET VRBASECALCIT = VRBASECALCIT + ((V_TOTAIMPBCALC + V_TOTAIMPBCDES) * V_TAXABASECALC),
                                  VRIMPOSTOIT  = V_IMPOSINFO
                            WHERE (CDFILIAL     = P_FILIAL)              AND
                                  (NRLANCTONF   = P_LANCTONF)            AND
                                  (NRSEQITPROD  = C_PRODUTO.NRSEQITPROD) AND
                                  (CDIMPOSTO    = C_PRODUTO.CDIMPOSTO)   AND
                                  (NRITPROIMPOS = C_PRODUTO.NRITPROIMPOS);
                           UPDATE TRABITPROIMPOS
                              SET VRBCALCIMPOIT  = VRBCALCIMPOIT + (V_TOTAIMPBCINF * V_TAXABASECALC),
                                  VRIMPOSIT      = V_IMPOSINFO
                            WHERE CDFILIMPOIT  = P_FILIAL              AND
                                  NRLANCIMPOIT = P_LANCTONF            AND
                                  NRSEQIMPOIT  = C_PRODUTO.NRSEQITPROD AND
                                  CDIMPOSTOIT  = C_PRODUTO.CDIMPOSTO   AND
                                  NRSEQITPRO   = C_PRODUTO.NRSEQITPRO;
                           UPDATE ITEMPROIMPOS
                              SET VRBASECALCIT = VRBASECALCIT + (V_TOTAIMPBCALC * ((100 - VRPERREDBCIT)/100)),
                                  VRIMPOSTOIT  = VRIMPOSTOIT  + ((V_TOTAIMPBCALC * ((100 - VRPERREDBCIT)/100)) * (VRALIQITEM/100))
                            WHERE (CDFILIAL     = P_FILIAL)              AND
                                  (NRLANCTONF   = P_LANCTONF)            AND
                                  (NRSEQITPROD  = C_PRODUTO.NRSEQITPROD) AND
                                  (CDIMPOSTO    = C_PRODUTO.CDIMPOSTO)   AND
                                  (NRITPROIMPOS = W_2);
                           UPDATE TRABITPROIMPOS
                              SET VRBCALCIMPOIT  = VRBCALCIMPOIT + (V_TOTAIMPBCINF * ((100 - VRREDBCIMPOIT)/100)),
                                  VRIMPOSIT      = VRIMPOSIT + ((V_TOTAIMPBCINF * ((100 - VRREDBCIMPOIT)/100)) * (VRALIQIMPOIT/100))
                            WHERE CDFILIMPOIT  = P_FILIAL              AND
                                  NRLANCIMPOIT = P_LANCTONF            AND
                                  NRSEQIMPOIT  = C_PRODUTO.NRSEQITPROD AND
                                  CDIMPOSTOIT  = C_PRODUTO.CDIMPOSTO   AND
                                  NRSEQITPRO   = W_2;
                           UPDATE TRABITPROIMPOS
                              SET VRBCALCIMPOIT  = VRBCALCIMPOIT + (V_TOTAIMPBCINF * V_TAXABASECALC),
                                  VRIMPOSIT      = VRIMPOSIT + ((V_TOTAIMPBCINF * V_TAXABASECALC) * (VRALIQIMPOIT/100))
                            WHERE CDFILIMPOIT  = P_FILIAL              AND
                                  NRLANCIMPOIT = P_LANCTONF            AND
                                  NRSEQIMPOIT  = C_PRODUTO.NRSEQITPROD AND
                                  CDIMPOSTOIT  = C_PRODUTO.CDIMPOSTO   AND
                                  NRSEQITPRO   = W_3;
                        END IF;
                     END IF;
                  END IF;
               END IF;
               /* Utiliza o próprio valor do imposto na sua base de cálculo */
               SELECT NVL(MAX(IDUTILPVRIMPBC), 'N'), MAX(IDTRATIMPO)
                 INTO V_IDUTILPVRIMPBC, V_IDTRATIMPO
                 FROM IMPOSTO
                WHERE CDIMPOSTO = C_PRODUTO.CDIMPOSTO;
               IF V_IDUTILPVRIMPBC = 'S' THEN
                  IF V_CDIMPOSTRIB IS NULL THEN
                     BEGIN
                        SELECT VRIMPOSTOIT
                          INTO V_VRIMPANTE
                          FROM ITEMPROIMPOS T
                         WHERE CDFILIAL     = P_FILIAL
                           AND NRLANCTONF   = P_LANCTONF
                           AND NRSEQITPROD  = C_PRODUTO.NRSEQITPROD
                           AND CDIMPOSTO    = C_PRODUTO.CDIMPOSTO
                           AND NRITPROIMPOS = C_PRODUTO.NRITPROIMPOS;
                     EXCEPTION
                        WHEN NO_DATA_FOUND THEN
                           V_VRIMPANTE := 0;
                     END;
                     UPDATE ITEMPROIMPOS
                        SET VRBASECALCIT = (VRBASECALCIT )/((100 -VRALIQITEM)/100),
                            VRIMPOSTOIT  = ((VRBASECALCIT)/((100 -VRALIQITEM)/100))*(VRALIQITEM/100)
                      WHERE CDFILIAL     = P_FILIAL
                        AND NRLANCTONF   = P_LANCTONF
                        AND NRSEQITPROD  = C_PRODUTO.NRSEQITPROD
                        AND CDIMPOSTO    = C_PRODUTO.CDIMPOSTO
                        AND NRITPROIMPOS = C_PRODUTO.NRITPROIMPOS;
                     UPDATE TRABITPROIMPOS
                        SET VRBCALCIMPOIT = (VRBCALCIMPOIT )/((100 -VRALIQIMPOIT)/100),
                            VRIMPOSIT     = ((VRBCALCIMPOIT)/((100 -VRALIQIMPOIT)/100))*(VRALIQIMPOIT/100)
                      WHERE CDFILIMPOIT  = P_FILIAL
                        AND NRLANCIMPOIT = P_LANCTONF
                        AND NRSEQIMPOIT  = C_PRODUTO.NRSEQITPROD
                        AND CDIMPOSTOIT  = C_PRODUTO.CDIMPOSTO
                        AND NRSEQITPRO   = C_PRODUTO.NRSEQITPRO;
                     BEGIN
                        SELECT VRIMPOSTOIT
                          INTO V_VRIMPAPOS
                          FROM ITEMPROIMPOS
                         WHERE CDFILIAL     = P_FILIAL
                           AND NRLANCTONF   = P_LANCTONF
                           AND NRSEQITPROD  = C_PRODUTO.NRSEQITPROD
                           AND CDIMPOSTO    = C_PRODUTO.CDIMPOSTO
                           AND NRITPROIMPOS = C_PRODUTO.NRITPROIMPOS;
                     EXCEPTION
                        WHEN NO_DATA_FOUND THEN
                           V_VRIMPAPOS := 0;
                     END;
                     IF V_IDTRATIMPO = 'A' THEN
                        UPDATE ITEMPRODUTO
                           SET VRBRUTITEM = VRBRUTITEM + (V_VRIMPAPOS - V_VRIMPANTE)
                         WHERE CDFILIAL     = P_FILIAL
                           AND NRLANCTONF   = P_LANCTONF
                           AND NRSEQITPROD  = C_PRODUTO.NRSEQITPROD;
                     END IF;
                  END IF;
               END IF;
               V_IMPOCONTAB := 0;
               IF (P_TIPOOPER = '03') THEN
                  SELECT NVL(MAX(VRTOTAITEM),0)
                    INTO V_TOTALITEMCOMP
                    FROM ITEMPRODUTO
                   WHERE CDFILIAL    = P_FILIAL
                     AND NRLANCTONF  = P_LANCTONF
                     AND NRSEQITPROD = C_PRODUTO.NRSEQITPROD;
               END IF;
               IF NOT(P_TIPOOPER = '03' AND V_TOTALITEMCOMP = 0 AND C_PRODUTO.IDTRATIMPO <> W_A) THEN
                  IF (C_PRODUTO.IDIMPORECUP = W_S) THEN
                     IF (C_PRODUTO.CDFISCALIT = W_1) THEN
                        IF (C_PRODUTO.CDCCTBLATIV IS NOT NULL) THEN
                           IF C_PRODUTO.IDTRATIMPO = W_V THEN
                              V_IMPOCONTAB := - (V_IMPOSINFO + C_PRODUTO.VRADICFECP);
                           END IF;
                        END IF;
                     ELSE
                        IF C_PRODUTO.IDTRATIMPO = W_A THEN
                           IF ((V_CDIMPOSTRIB IS NOT NULL) AND (C_PRODUTO.IDTRIMPSTII = '0')) OR
                              (V_CDIMPOSTRIB IS NULL) THEN
                              V_IMPOCONTAB := (V_IMPOSINFO + C_PRODUTO.VRADICFECP);
                           ELSE
                              V_IMPOCONTAB := 0;
                              V_IMPOSINFO  := 0;
                           END IF;
                        ELSIF C_PRODUTO.IDTRATIMPO IN (W_D,W_R) THEN
                           V_IMPOCONTAB := - (V_IMPOSINFO + C_PRODUTO.VRADICFECP);
                        END IF;
                     END IF;
                  ELSE
                     IF NOT(C_PRODUTO.CDCCTBLPASS IS NULL) THEN
                        IF C_PRODUTO.IDTRATIMPO = W_V THEN
                           IF C_PRODUTO.IDCONTAIMPADIC = 'N' THEN
                              V_IMPOCONTAB := - (V_IMPOSINFO + C_PRODUTO.VRADICFECP);
                           END IF;
                        ELSE
                           IF C_PRODUTO.IDTRATIMPO = W_A THEN
                               SELECT NVL(MAX(IDACRPRODENTRNF), 'N')
                               INTO V_IDACRPRODENTRNF
                               FROM IMPOSTO
                               WHERE CDIMPOSTO = C_PRODUTO.CDIMPOSTO;
                               IF V_IDACRPRODENTRNF = 'S' THEN
                                  V_IMPOCONTAB := (V_IMPOSINFO + C_PRODUTO.VRADICFECP);
                               END IF;
                           ELSIF (C_PRODUTO.IDTRATIMPO = W_R) AND (C_PRODUTO.IDDESCRFONTE = 'N') THEN
                              V_IMPOCONTAB := - (V_IMPOSINFO + C_PRODUTO.VRADICFECP);
                           END IF;
                        END IF;
                     ELSE
                        IF C_PRODUTO.IDTRATIMPO = W_A THEN
                           IF ((V_CDIMPOSTRIB IS NOT NULL) AND (C_PRODUTO.IDTRIMPSTII = '0')) OR
                              (V_CDIMPOSTRIB IS NULL) THEN
                              V_IMPOCONTAB := (V_IMPOSINFO + C_PRODUTO.VRADICFECP);
                           ELSE
                              V_IMPOCONTAB := 0;
                              V_IMPOSINFO  := 0;
                           END IF;
                        ELSIF C_PRODUTO.IDTRATIMPO IN (W_D,W_R) THEN
                           V_IMPOCONTAB := - (V_IMPOSINFO + C_PRODUTO.VRADICFECP);
                        END IF;
                     END IF;
                  END IF;
                  IF (V_IDOPERDEVONF = W_S) OR (P_TIPOOPER = '16') THEN
                     IF (C_PRODUTO.IDTRATIMPO = W_A) THEN
                       IF NOT (((C_PRODUTO.IDIMPORECUP = W_S)  AND (C_PRODUTO.CDFISCALIT = W_1)) OR
                               ((C_PRODUTO.IDIMPORECUP <> W_S) AND (C_PRODUTO.CDCCTBLATIV IS NOT NULL))) THEN
                          IF ((V_CDIMPOSTRIB IS NOT NULL) AND (C_PRODUTO.IDTRIMPSTII = '0')) OR
                             (V_CDIMPOSTRIB IS NULL) THEN
                             V_IMPOCONTAB := (V_IMPOSINFO + C_PRODUTO.VRADICFECP);
                          ELSE
                             V_IMPOCONTAB := 0;
                             V_IMPOSINFO  := 0;
                          END IF;
                       END IF;
                     ELSIF (C_PRODUTO.IDTRATIMPO = W_D) THEN
                       IF NOT(((C_PRODUTO.IDIMPORECUP = W_S) AND (C_PRODUTO.CDFISCALIT = W_1)) OR
                              ((C_PRODUTO.IDIMPORECUP <> W_S) AND (C_PRODUTO.CDCCTBLATIV IS NOT NULL))) THEN
                          V_IMPOCONTAB := - (V_IMPOSINFO + C_PRODUTO.VRADICFECP);
                       END IF;
                     ELSIF (C_PRODUTO.IDTRATIMPO = W_R) THEN
                       IF (C_PRODUTO.IDIMPORECUP = W_S) THEN
                          IF (C_PRODUTO.CDCCTBLATIV IS NULL) OR
                             (C_PRODUTO.CDFISCALIT <> W_1) THEN
                             V_IMPOCONTAB := - (V_IMPOSINFO + C_PRODUTO.VRADICFECP);
                          END IF;
                       ELSE
                          IF (C_PRODUTO.CDCCTBLATIV IS NULL) THEN
                             V_IMPOCONTAB := - (V_IMPOSINFO + C_PRODUTO.VRADICFECP);
                          END IF;
                       END IF;
                     ELSE
                        V_IMPOCONTAB := 0;
                     END IF;
                  END IF;
                  IF C_PRODUTO.IDTRATIMPO = W_A THEN
                     IF C_PRODUTO.IDTIPCONTAB = W_D THEN
                        UPDATE ITEMPRODUTO
                        SET VRCONTITEM = VRCONTITEM + V_IMPOCONTAB,
                            VRBRUTITEM = VRBRUTITEM + V_IMPOSINFO
                        WHERE CDFILIAL    = P_FILIAL   AND
                              NRLANCTONF  = P_LANCTONF AND
                              NRSEQITPROD = C_PRODUTO.NRSEQITPROD;
                     ELSE
                        UPDATE ITEMPRODUTO
                        SET VRBRUTITEM = VRBRUTITEM + V_IMPOSINFO
                        WHERE CDFILIAL    = P_FILIAL   AND
                              NRLANCTONF  = P_LANCTONF AND
                              NRSEQITPROD = C_PRODUTO.NRSEQITPROD;
                     END IF;
                  ELSIF C_PRODUTO.IDTRATIMPO = W_D THEN
                     IF C_PRODUTO.IDTIPCONTAB = W_D THEN
                        UPDATE ITEMPRODUTO
                        SET VRBRUTITEM = VRBRUTITEM - V_IMPOSINFO,
                            VRCONTITEM = VRCONTITEM + V_IMPOCONTAB
                        WHERE CDFILIAL    = P_FILIAL   AND
                              NRLANCTONF  = P_LANCTONF AND
                              NRSEQITPROD = C_PRODUTO.NRSEQITPROD;
                     ELSE
                        UPDATE ITEMPRODUTO
                        SET VRBRUTITEM = VRBRUTITEM - V_IMPOSINFO
                        WHERE CDFILIAL    = P_FILIAL   AND
                              NRLANCTONF  = P_LANCTONF AND
                              NRSEQITPROD = C_PRODUTO.NRSEQITPROD;
                     END IF;
                  ELSE
                     IF C_PRODUTO.IDTIPCONTAB = W_D THEN
                        UPDATE ITEMPRODUTO
                        SET VRCONTITEM = VRCONTITEM + V_IMPOCONTAB
                        WHERE CDFILIAL    = P_FILIAL   AND
                              NRLANCTONF  = P_LANCTONF AND
                              NRSEQITPROD = C_PRODUTO.NRSEQITPROD;
                     END IF;
                     IF (C_PRODUTO.IDTRATIMPO = 'R') AND (C_PRODUTO.IDDESCRFONTE = 'N') THEN
                        UPDATE ITEMPRODUTO
                        SET VRBRUTITEM = VRBRUTITEM - V_IMPOSINFO
                        WHERE CDFILIAL    = P_FILIAL   AND
                              NRLANCTONF  = P_LANCTONF AND
                              NRSEQITPROD = C_PRODUTO.NRSEQITPROD;
                     END IF;
                  END IF;
               END IF; -- NAO ALTERAR VALOR CONTÁBIL DO PRODUTO SE O VALOR DOS PRODUTOS FOR ZERO
            END LOOP;
         END IF;
      END IF;
      ---------------------------------------------------------------------------------------------------------
      --FIM DA ATUALIZAÇÃO NA TABELA DE ITEMPROIMPOS
      ---------------------------------------------------------------------------------------------------------
      --TOTALIZAÇÃO DOS IMPOSTOS
      DELETE IMPOSNFTOT
      WHERE (CDFILIAL   = P_FILIAL) AND
            (NRLANCTONF = P_LANCTONF);
      IF (V_INTEGRACAO IS NULL) OR (P_ENTRSAID = W_E) THEN
         FOR C_IMPOSNFTOT IN (
            SELECT /*+ index (IP,PK_ITEMPROIMPOS)*/
                   IP.CDIMPOSTO, CDIMPOSTOIT, SUM(ROUND(NVL(VRIMPOSIT,0),V_NRDECITOTANF)) AS VRIMPOSTOIT, NVL(SUM(VRBASECALCIT),0) AS VRBASECALCIT,
                   NVL(SUM(VRBCALCIMPOIT),0) AS VRBCALCIMPOIT, MAX(NVL(IDPREIMPENTR, W_N)) AS IDPREIMPENTR
            FROM ITEMPROIMPOS IP, TRABITPROIMPOS TI, IMPOSTO I
            WHERE (IP.CDFILIAL     = P_FILIAL)       AND
                  (IP.NRLANCTONF   = P_LANCTONF)     AND
                  (TI.CDFILIMPOIT  = IP.CDFILIAL)    AND
                  (TI.NRLANCIMPOIT = IP.NRLANCTONF)  AND
                  (TI.NRSEQIMPOIT  = IP.NRSEQITPROD) AND
                  (TI.NRSEQITPRO   = IP.NRITPROIMPOS)  AND
                  (TI.CDIMPOSTOIT  = IP.CDIMPOSTO) AND
                  (I.CDIMPOSTO     = TI.CDIMPOSTOIT) AND
                  (IP.NRITPROIMPOS = 1)
            GROUP BY IP.CDIMPOSTO, TI.CDIMPOSTOIT) LOOP
            INSERT INTO IMPOSNFTOT(CDFILIAL, NRLANCTONF, CDIMPOSTO, VRTOTIMPONF, VRTOTBCALCNF)
                           VALUES (P_FILIAL, P_LANCTONF, C_IMPOSNFTOT.CDIMPOSTO, NVL(C_IMPOSNFTOT.VRIMPOSTOIT,0), NVL(C_IMPOSNFTOT.VRBASECALCIT,0));
            IF C_IMPOSNFTOT.IDPREIMPENTR = W_N THEN
               UPDATE TRABIMPOSNFTOT
               SET VRBCALIMPTOT   = NVL(C_IMPOSNFTOT.VRBCALCIMPOIT,0)
               WHERE CDFILIMPTOT  = P_FILIAL   AND
                     NRLANCIMPTOT = P_LANCTONF AND
                     CDIMPOSTOT   = C_IMPOSNFTOT.CDIMPOSTO;
            ELSE
               UPDATE TRABIMPOSNFTOT
               SET VRBCALIMPTOT = NVL(C_IMPOSNFTOT.VRBCALCIMPOIT,0),
                   VRIMPOSTOT   = NVL(C_IMPOSNFTOT.VRIMPOSTOIT,0)
               WHERE CDFILIMPTOT  = P_FILIAL   AND
                     NRLANCIMPTOT = P_LANCTONF AND
                     CDIMPOSTOT   = C_IMPOSNFTOT.CDIMPOSTO;
            END IF;
         END LOOP;
         --INCLUSÃO DOS IMPOSTOS DE CORPO DE NOTA EM CASO DE NOTA FISCAL DE ENTRADA
         V_SEQUIMPOSTNF := '01';
         DELETE IMPOSTONF
         WHERE (CDFILIAL = P_FILIAL) AND
               (NRLANCTONF = P_LANCTONF);
         CONSULTA_INCIDENCIA(P_ENTRSAID, P_EMPRESA, '', P_INSCESTA, P_TIPOOPER, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC, NULL, V_IDINTEREST);
         FOR C_INCITEMP IN (SELECT DSMENSINCTMP
                              FROM INCITEMP
                             WHERE (NRINCITEMP = V_INCITEMP)  AND
                                   (DSMENSINCTMP IS NOT NULL) AND
                                   (NOT EXISTS(SELECT DSDADOADIC
                                                 FROM DADOSADIC
                                                WHERE (CDFILIAL   = P_FILIAL)   AND
                                                      (NRLANCTONF = P_LANCTONF) AND
                                                      (DSDADOADIC LIKE INCITEMP.DSMENSINCTMP || '%')))) LOOP
            IF NOT(C_INCITEMP.DSMENSINCTMP IS NULL) THEN
               /*PREENCHE AS MENSAGENS ATRELADAS A INCIDENCIA*/
               INSERT INTO DADOSADIC(CDFILIAL, NRLANCTONF, NRDADOADIC, DSDADOADIC)
                              VALUES(P_FILIAL, P_LANCTONF, V_DADOADIC, C_INCITEMP.DSMENSINCTMP);
               V_DADOADIC := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_DADOADIC) + 1)),3,0);
            END IF;
         END LOOP;
         FOR C_INCIDENCIA IN (SELECT DISTINCT (IT.CDIMPOTEMP) AS CDIMPOTEMP, IT.CDFISCTEMP, IP.IDUTMUNIORIG,
                                     IT.IDTRATIMPTMP, IP.IDIMPORECUP, NVL(IP.IDPREIMPENTR, W_N) AS IDPREIMPENTR
                              FROM INCITEMP IT, IMPOSTO IP
                              WHERE (IT.NRINCITEMP  = V_INCITEMP)       AND
                                    (IT.CDIMPOTEMP  = IP.CDIMPOSTO)     AND
                                    (IP.IDPRODNOTA  = W_C)) LOOP
            V_ALIQUTMP   := 0;
            V_PARDEDTMP  := 0;
            V_PREDBCTMP1 := 0;
            V_PREDBCTMP  := 0;
            V_ALIQUTMP   := 0;
            /*VERIFICA CST POR IMPOSTO*/
            V_IMPOICMS := NULL;
            V_CDGRUPOFISCAUX := NULL;
            SELECT MAX(G.CDGRUPOFISC)
              INTO V_CDGRUPOFISCAUX
              FROM GRUPOFISCIMPFIL G,
                   (SELECT DECODE('E', 'E', CDFILIRECE, CDFILIEMIT) AS CDFILIAL
                      FROM NOTAFISCAL
                     WHERE CDFILIAL = P_FILIAL
                           AND NRLANCTONF = P_LANCTONF) F
             WHERE G.CDFILIAL = F.CDFILIAL
               AND NOT G.CDGRUPOFISC IS NULL
               AND G.CDIMPOSTO = C_INCIDENCIA.CDIMPOTEMP;
            IF V_IDORIGDESTNF = 'F' THEN
               SELECT NVL(MAX(G.CDGRUPOFISC), V_CDGRUPOFISCAUX)
                 INTO V_CDGRUPOFISCAUX
                 FROM GRFISIMPIEFORN G,
                      (SELECT CDFORNECED
                         FROM NOTAFISCAL
                        WHERE CDFILIAL = P_FILIAL
                          AND NRLANCTONF = P_LANCTONF) N
                WHERE G.CDFORNECED = N.CDFORNECED
                  AND G.CDEMPRESA = P_EMPRESA
                  AND G.CDINSCESTA = P_INSCESTA
                  AND NOT G.CDGRUPOFISC IS NULL
                  AND G.CDIMPOSTO = C_INCIDENCIA.CDIMPOTEMP;
            ELSE
               SELECT NVL(MAX(G.CDGRUPOFISC), V_CDGRUPOFISCAUX)
                 INTO V_CDGRUPOFISCAUX
                 FROM GRFISIMPIECLIE G,
                      (SELECT CDCLIENTE
                         FROM NOTAFISCAL
                        WHERE CDFILIAL = P_FILIAL
                          AND NRLANCTONF = P_LANCTONF) N
                WHERE G.CDCLIENTE = N.CDCLIENTE
                  AND G.CDEMPRESA = P_EMPRESA
                  AND G.CDINSCESTA = P_INSCESTA
                  AND NOT G.CDGRUPOFISC IS NULL
                  AND G.CDIMPOSTO = C_INCIDENCIA.CDIMPOTEMP;
            END IF;
            IF V_CDGRUPOFISCAUX IS NULL THEN
               CONSULTA_CST_NFE(W_E, P_EMPRESA, '', P_INSCESTA, P_TIPOOPER, V_CDGRUPOFISC,C_INCIDENCIA.CDIMPOTEMP, V_IDINTEREST, V_IDINTERNAC, P_FILIAL, P_LANCTONF, '', V_CDSITTRIBTMP, V_IDMODBCNFE, V_IDMODBCSTNFE, V_CDTPCRPICOSTNFE, V_CDNATUBCPCSTNFE, V_IDMOTIDESSTNFE);
            ELSE
               CONSULTA_CST_NFE(W_E, P_EMPRESA, '', P_INSCESTA, P_TIPOOPER, V_CDGRUPOFISCAUX,C_INCIDENCIA.CDIMPOTEMP, V_IDINTEREST, V_IDINTERNAC, P_FILIAL, P_LANCTONF, '', V_CDSITTRIBTMP, V_IDMODBCNFE, V_IDMODBCSTNFE, V_CDTPCRPICOSTNFE, V_CDNATUBCPCSTNFE, V_IDMOTIDESSTNFE);
            END IF;
            SELECT MAX(CDIMPOSTO)
              INTO V_IMPOICMS
              FROM IMPOSTONFE N, IMPOSTO I
             WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
               AND N.CDIMPOSTONFE = '00'
               AND I.CDIMPOSTO = C_INCIDENCIA.CDIMPOTEMP;
            IF C_INCIDENCIA.IDUTMUNIORIG = W_D THEN
              /* CONSIDERA MUNICIPIO DE DESTINO */
              CONSULTA_ALIQUOTA(C_INCIDENCIA.CDIMPOTEMP, P_ENTRSAID, P_EMPRESA, '', P_INSCESTA, V_PAISORIG,
                                V_ESTAORIG, V_PAISDEST, V_ESTADEST, V_MUNIDEST, V_LIQUIITEM, P_INIVALID, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC,P_TIPOOPER);
            ELSE
              /* CONSIDERA MUNICIPIO DE ORIGEM */
              CONSULTA_ALIQUOTA(C_INCIDENCIA.CDIMPOTEMP, P_ENTRSAID, P_EMPRESA, '', P_INSCESTA, V_PAISORIG,
                                V_ESTAORIG, V_PAISDEST, V_ESTADEST, V_MUNIORIG, V_LIQUIITEM, P_INIVALID, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC,P_TIPOOPER);
            END IF;
            SELECT MAX(VRPARDEDTMP), MAX(VRPREDBCTMP), MAX(VRALIQUTMP), MAX(VR1PREDBCTMP)
            INTO V_PARDEDTMP, V_PREDBCTMP, V_ALIQUTMP, V_PREDBCTMP1
            FROM ALIQTEMP
            WHERE (NRALIQTEMP = V_ALIQTEMP);
            IF (V_PREDBCTMP IS NULL) THEN
               V_PREDBCTMP := 0;
            END IF;
            IF (V_PARDEDTMP IS NULL) THEN
               V_PARDEDTMP := 0;
            END IF;
            IF (V_ALIQUTMP IS NULL) THEN --VERIFICAR VALOR DA ALÍQUOTA P/ IMPOSTO RECUPERÁVEL COM COD. FISCAL = W_3
               V_ALIQUTMP := 0;
            END IF;
            IF (V_PREDBCTMP1 IS NULL) THEN
               V_PREDBCTMP1 := 0;
            END IF;   
            V_PRODUENCARGO := 0;        
            SELECT SUM(VRITEMENCA) AS VRSOMAITEM INTO V_SOMAITEM
            FROM ENCARGO EN, ITEMENCARGO IE, BASECALC BC
            WHERE (IE.CDFILIAL   = P_FILIAL)                AND
                  (IE.NRLANCTONF = P_LANCTONF)              AND
                  (EN.CDENCARGO  = IE.CDENCARGO)            AND
                  (BC.CDENCARGO  = IE.CDENCARGO)            AND
                  (BC.CDIMPOSTO  = C_INCIDENCIA.CDIMPOTEMP) AND
                  (EN.IDENCARGO  = W_A);
            SELECT SUM(VRITEMENCA) AS VRDESCITEM INTO V_DESCITEM
            FROM ENCARGO EN, ITEMENCARGO IE, BASECALC BC
            WHERE (IE.CDFILIAL   = P_FILIAL)                AND
                  (IE.NRLANCTONF = P_LANCTONF)              AND
                  (EN.CDENCARGO  = IE.CDENCARGO)            AND
                  (BC.CDENCARGO  = IE.CDENCARGO)            AND
                  (BC.CDIMPOSTO  = C_INCIDENCIA.CDIMPOTEMP) AND
                  (EN.IDENCARGO  = W_D);
            IF V_SOMAITEM IS NULL THEN
               V_SOMAITEM := 0;
            END IF;
            IF V_DESCITEM IS NULL THEN
               V_DESCITEM := 0;
            END IF;
            V_PRODUENCARGO := V_SOMAITEM - V_DESCITEM;
            BEGIN
               SELECT NVL(IDIMPORTAIMPXML, 'N')
                 INTO V_IDIMPORTAIMPXML
                 FROM IMPOSTO
                WHERE CDIMPOSTO = C_INCIDENCIA.CDIMPOTEMP;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_IDIMPORTAIMPXML := 'N';
            END;
            IF (V_IDNFGERADAVIAXML = 'S') AND ((V_IDIMPORTAIMPXML = 'S') OR (V_IDGERNFIGUALXML = 'S')) THEN
               V_PRODUENCARGO := 0;
            END IF;
            V_TAXABASECALC := (100 - V_PREDBCTMP)/100;
            V_TAXAALIQUOTA := (V_ALIQUTMP/100);
            V_BASECALCIT   := (V_LIQUIDO + V_PRODUENCARGO) * V_TAXABASECALC;
            V_CONTIMPO     := V_BASECALCIT;
            V_IMPOSTOIT    := ROUND((V_BASECALCIT * V_TAXAALIQUOTA) - V_PARDEDTMP, V_NRDECITOTANF);
            V_CONTABCALC := (V_LIQUIDO + V_PRODUENCARGO) - ((V_LIQUIDO + V_PRODUENCARGO) * V_TAXABASECALC);
            V_PERDBCALC  := 100 - V_PREDBCTMP;
            BEGIN
               SELECT VRIMPOSTOT INTO V_IMPOSINFO
               FROM TRABIMPOSNFTOT
               WHERE CDIMPOSTOT   = C_INCIDENCIA.CDIMPOTEMP AND
                     CDFILIMPTOT  = P_FILIAL                AND
                     NRLANCIMPTOT = P_LANCTONF;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_IMPOSINFO := 0;
            END;
            IF (V_BASECALCIT < 0) OR (V_BASECALCIT IS NULL) THEN
               V_BASECALCIT := 0;
            END IF;
            IF (V_IMPOSTOIT < 0) OR (V_IMPOSTOIT IS NULL) THEN
               V_IMPOSTOIT := 0;
            END IF;
            --SE O IMPOSTO FOI INFORMADO NO CORPO DA NF SERÁ CALCULADO O VALOR DA ALIQUOTA E O VALOR DO IMPOSTO.
            IF V_IMPOSINFO > 0 THEN
               V_ALIQUTMP  := ROUND((V_IMPOSINFO * 100)/ V_BASECALCIT,2);
               V_IMPOSTOIT := V_IMPOSINFO;
            END IF;
            --SE O IDENTIFICADOR DE PREENCHIMENTO DE IMPOSTOS NA ENTRADA DE DOCUMENTOS FOR IGUAL A NÃO
            IF C_INCIDENCIA.IDPREIMPENTR = W_N THEN
               UPDATE TRABIMPOSNFTOT
               SET VRBCALIMPTOT   = NVL(V_BASECALCIT,0)
               WHERE CDIMPOSTOT   = C_INCIDENCIA.CDIMPOTEMP AND
                     CDFILIMPTOT  = P_FILIAL                AND
                     NRLANCIMPTOT = P_LANCTONF;
            ELSE
               UPDATE TRABIMPOSNFTOT
               SET VRBCALIMPTOT   = NVL(V_BASECALCIT,0),
                   VRIMPOSTOT     = ROUND(NVL(V_IMPOSTOIT,0), V_NRDECITOTANF)
               WHERE CDIMPOSTOT   = C_INCIDENCIA.CDIMPOTEMP AND
                     CDFILIMPTOT  = P_FILIAL                AND
                     NRLANCIMPTOT = P_LANCTONF;
            END IF;
            INSERT INTO IMPOSNFTOT(CDFILIAL, NRLANCTONF, CDIMPOSTO, VRTOTIMPONF, VRTOTBCALCNF)
                            VALUES (P_FILIAL, P_LANCTONF, C_INCIDENCIA.CDIMPOTEMP, NVL(V_IMPOSTOIT,0), NVL(V_BASECALCIT,0));
            IF (C_INCIDENCIA.IDIMPORECUP = W_S) OR (C_INCIDENCIA.IDIMPORECUP <> W_S AND V_ALIQUTMP <> 0) THEN
               IF (C_INCIDENCIA.IDIMPORECUP = W_S) AND
                  (C_INCIDENCIA.CDFISCTEMP <> W_1) THEN
                  V_BASECALCIT := 0;
                  V_ALIQUTMP   := 0;
                  V_IMPOSTOIT  := 0;
                  V_PREDBCTMP1 := 0;
                  V_PREDBCTMP  := 0;
                  V_PARDEDTMP  := 0;
               END IF;
               BEGIN
                  SELECT IDFORMAPUR
                  INTO V_IDFORMAPUR
                  FROM IMPOSTO
                  WHERE CDIMPOSTO = C_INCIDENCIA.CDIMPOTEMP;
               EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                     V_IDFORMAPUR := NULL;
               END;
               IF V_IDFORMAPUR = W_P THEN
                  INSERT INTO IMPOSTONF(
                     CDFILIAL, NRLANCTONF, CDIMPOSTO, NRIMPOSNF, VRCONTABILNF, VRPERREDBCNF, VRBASECALCNF,
                     VRALIQNF, VRPARDEDNF, VRIMPOSTONF, CDFISCALNF, IDIMPOSTONF, CDSITUTRIBIMNFE,
                     CDTPCREDPICONF, CDNATUBCALPCNF, IDMOTDESONERANF)
                  VALUES(
                     P_FILIAL, P_LANCTONF, C_INCIDENCIA.CDIMPOTEMP, V_SEQUIMPOSTNF, ROUND(V_CONTIMPO,2), V_PREDBCTMP,
                     V_BASECALCIT, V_ALIQUTMP, V_PARDEDTMP, V_IMPOSTOIT, C_INCIDENCIA.CDFISCTEMP, W_1, V_CDSITTRIBTMP,
                     V_CDTPCRPICOSTNFE, V_CDNATUBCPCSTNFE, V_IDMOTIDESSTNFE);
                  V_SEQUIMPOSTNF := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_SEQUIMPOSTNF) + 1)),2,0);
               ELSE
                  INSERT INTO IMPOSTONF(
                     CDFILIAL, NRLANCTONF, CDIMPOSTO, NRIMPOSNF, VRCONTABILNF, VRPERREDBCNF, VRBASECALCNF,
                     VRALIQNF, VRPARDEDNF, VRIMPOSTONF, CDFISCALNF, IDIMPOSTONF, CDSITUTRIBIMNFE,
                     CDTPCREDPICONF, CDNATUBCALPCNF, IDMOTDESONERANF)
                  VALUES(
                     P_FILIAL, P_LANCTONF, C_INCIDENCIA.CDIMPOTEMP, V_SEQUIMPOSTNF, ROUND(V_CONTIMPO,2), V_PREDBCTMP,
                     V_BASECALCIT, V_ALIQUTMP, V_PARDEDTMP, V_IMPOSTOIT, C_INCIDENCIA.CDFISCTEMP, W_1, V_CDSITTRIBTMP,
                     V_CDTPCRPICOSTNFE, V_CDNATUBCPCSTNFE, V_IDMOTIDESSTNFE);
                  V_SEQUIMPOSTNF := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_SEQUIMPOSTNF) + 1)),2,0);
               END IF;
               IF (C_INCIDENCIA.IDIMPORECUP = W_S) AND
                  (V_PREDBCTMP > 0)                AND
                  (C_INCIDENCIA.CDFISCTEMP = W_1)  THEN
                  INSERT INTO IMPOSTONF(
                     CDFILIAL, NRLANCTONF, CDIMPOSTO, NRIMPOSNF, VRCONTABILNF, VRPERREDBCNF, VRBASECALCNF,
                     VRALIQNF, VRPARDEDNF, VRIMPOSTONF, CDFISCALNF, IDIMPOSTONF, CDSITUTRIBIMNFE,
                     CDTPCREDPICONF, CDNATUBCALPCNF, IDMOTDESONERANF)
                  VALUES(
                     P_FILIAL, P_LANCTONF, C_INCIDENCIA.CDIMPOTEMP, V_SEQUIMPOSTNF, ROUND(V_CONTABCALC,2), V_PERDBCALC,
                     0, 0, V_PARDEDTMP, 0, W_2, W_2, V_CDSITTRIBTMP, V_CDTPCRPICOSTNFE, V_CDNATUBCPCSTNFE, V_IDMOTIDESSTNFE);
                  V_SEQUIMPOSTNF := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_SEQUIMPOSTNF) + 1)),2,0);
               END IF;
            END IF;
            DELETE ALIQTEMP
            WHERE NRALIQTEMP = V_ALIQTEMP;
         END LOOP;
         V_TOTIMPOCONT := 0;
         V_TOTIMPOBRUT := 0;
         FOR C_IMPOSCONTAB IN (SELECT VRIMPOSTOT, IDIMPORECUP, CDCCTBLPASS, CDCCTBLATIV,
                                      IDTRATIMPO,  CDFISCTEMP, IDTIPCONTAB
                               FROM TRABIMPOSNFTOT INF, IMPOSTO IP, INCITEMP IT
                               WHERE INF.CDFILIMPTOT   = P_FILIAL    AND
                                     INF.NRLANCIMPTOT  = P_LANCTONF  AND
                                     IP.CDIMPOSTO  = INF.CDIMPOSTOT  AND
                                     IT.CDIMPOTEMP = IP.CDIMPOSTO    AND
                                     IT.NRINCITEMP = V_INCITEMP      AND
                                     IP.IDPRODNOTA = W_C) LOOP
            IF C_IMPOSCONTAB.IDTIPCONTAB = W_D THEN
               IF (C_IMPOSCONTAB.IDIMPORECUP = W_S) THEN
                  IF (NOT(C_IMPOSCONTAB.CDCCTBLATIV IS NULL)) AND
                     (C_IMPOSCONTAB.CDFISCTEMP = W_1) THEN
                     IF C_IMPOSCONTAB.IDTRATIMPO = W_V THEN
                        V_TOTIMPOCONT := V_TOTIMPOCONT - C_IMPOSCONTAB.VRIMPOSTOT;
                     END IF;
                  ELSE
                     IF C_IMPOSCONTAB.IDTRATIMPO = W_A THEN
                        IF C_IMPOSCONTAB.CDCCTBLPASS IS NULL THEN
                           V_TOTIMPOCONT := V_TOTIMPOCONT + C_IMPOSCONTAB.VRIMPOSTOT;
                        END IF;
                     ELSIF C_IMPOSCONTAB.IDTRATIMPO IN (W_D,W_R) THEN
                        V_TOTIMPOCONT := V_TOTIMPOCONT - C_IMPOSCONTAB.VRIMPOSTOT;
                     END IF;
                  END IF;
               ELSE
                  IF NOT(C_IMPOSCONTAB.CDCCTBLPASS IS NULL) THEN
                     IF C_IMPOSCONTAB.IDTRATIMPO = W_V THEN
                        V_TOTIMPOCONT := V_TOTIMPOCONT - C_IMPOSCONTAB.VRIMPOSTOT;
                     END IF;
                  ELSE
                     IF C_IMPOSCONTAB.IDTRATIMPO = W_A THEN
                        IF C_IMPOSCONTAB.CDCCTBLATIV IS NULL THEN
                           V_TOTIMPOCONT := V_TOTIMPOCONT + C_IMPOSCONTAB.VRIMPOSTOT;
                        END IF;
                     ELSIF C_IMPOSCONTAB.IDTRATIMPO IN (W_D,W_R) THEN
                        V_TOTIMPOCONT := V_TOTIMPOCONT - C_IMPOSCONTAB.VRIMPOSTOT;
                     END IF;
                  END IF;
               END IF;
            END IF;
            IF C_IMPOSCONTAB.IDTRATIMPO = W_A THEN
               V_TOTIMPOBRUT := V_TOTIMPOBRUT + C_IMPOSCONTAB.VRIMPOSTOT;
            ELSIF C_IMPOSCONTAB.IDTRATIMPO = W_D THEN
               V_TOTIMPOBRUT := V_TOTIMPOBRUT - C_IMPOSCONTAB.VRIMPOSTOT;
            END IF;
         END LOOP;
         IF (V_TOTIMPOBRUT <> 0) OR (V_TOTIMPOCONT <> 0) THEN
            FOR C_ITPRODUTO IN (SELECT NRSEQITPROD, (VRTOTAITEM - VRDESCITEM) AS VRLIQUIDO
                                  FROM ITEMPRODUTO
                                  WHERE CDFILIAL   = P_FILIAL   AND
                                        NRLANCTONF = P_LANCTONF)LOOP
               UPDATE ITEMPRODUTO
               SET VRBRUTITEM = VRBRUTITEM + ((V_TOTIMPOBRUT / V_LIQUIDO) * C_ITPRODUTO.VRLIQUIDO),
                   VRCONTITEM = VRCONTITEM + ((V_TOTIMPOCONT / V_LIQUIDO) * C_ITPRODUTO.VRLIQUIDO)
               WHERE CDFILIAL    = P_FILIAL   AND
                     NRLANCTONF  = P_LANCTONF AND
                     NRSEQITPROD = C_ITPRODUTO.NRSEQITPROD;
            END LOOP;
         END IF;
         DELETE INCITEMP
         WHERE NRINCITEMP = V_INCITEMP;
      ELSE
         DELETE IMPOSTONF
         WHERE (CDFILIAL   = P_FILIAL) AND
               (NRLANCTONF = P_LANCTONF);
      END IF;
   --FIM DA TOTALIZAÇÃO DOS IMPOSTOS
   ---------------------------------------------------------------------------------------------------------
   -- NOTA FISCAL DE MOVIMENTAÇÃO - 07
   ELSIF P_TIPOOPER IN ('07','10') OR (V_IDOPERDEVONF = W_S) THEN
      IF (V_INTEGRACAO IS NULL) OR (P_ENTRSAID = W_E) THEN
         FOR C_ITEMPROD IN (SELECT I.VRTOTAITEM, I.VRDESCITEM, I.CDSITUTRIBPR, I.NRSEQITPROD,
                                   P.CDARVPROD, I.VRUNITITEM, I.NRLOTEESTQ, I.NRSUBLOTE, I.CDPRODUTO,
                                   I.QTITEMPROD, I.CDFISCOPERSN, NVL(I.IDORIGEMPROD, 'N') AS IDORIGEMPROD, N.IDNFDEVOOL
                            FROM PRODUTO P, ITEMPRODUTO I, NOTAFISCAL N
                            WHERE N.CDFILIAL    = P_FILIAL      AND
                                  N.NRLANCTONF  = P_LANCTONF    AND
                                  I.CDFILIAL  = N.CDFILIAL    AND
                                  I.NRLANCTONF = N.NRLANCTONF AND
                                  P.CDPRODUTO = I.CDPRODUTO) LOOP
            V_LIQUIITEM := C_ITEMPROD.VRTOTAITEM - C_ITEMPROD.VRDESCITEM;
            CONSULTA_CST(P_ENTRSAID, P_EMPRESA, C_ITEMPROD.CDARVPROD, P_INSCESTA, P_TIPOOPER, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC,V_IDINTEREST, V_IDINTERNAC, NULL, C_ITEMPROD.IDORIGEMPROD);
            SELECT MAX(CDSITTRIBTMP) INTO V_SITUTRIBPR
            FROM CSTTEMP
            WHERE (NRCSTTEMP = V_CSTTEMP);
            IF V_IDOPERDEVONF <> w_S THEN
               IF NOT (SUBSTR(C_ITEMPROD.CDSITUTRIBPR,1,1) = SUBSTR(V_SITUTRIBPR,1,1)) AND
                  NOT (C_ITEMPROD.CDSITUTRIBPR IS NULL) THEN
                  V_SITUTRIBPR := C_ITEMPROD.CDSITUTRIBPR;
               END IF;
            ELSE
               IF V_SITUTRIBPR IS NULL THEN
                  V_SITUTRIBPR := C_ITEMPROD.CDSITUTRIBPR;
               END IF;
            END IF;
            /* VERIFICA IMPOSTOS POR REDUCAO REFERENTE A NOTA FISCAL DE ORIGEM */
            IF (V_IDOPERDEVONF = W_S) THEN
               V_VRFATOCONV := 0;
               /* Verifica se é uma devolução ao Operador Logístico */
               V_CDPRODORIG := NULL;
               IF C_ITEMPROD.IDNFDEVOOL = 'S' THEN
                  BEGIN
                     SELECT MAX(CDPRARVORIG)
                       INTO V_CDPRODORIG
                       FROM RELACPRODOL
                      WHERE CDPRODARVOL = C_ITEMPROD.CDPRODUTO;
                  EXCEPTION
                     WHEN NO_DATA_FOUND THEN
                        V_CDPRODORIG := C_ITEMPROD.CDPRODUTO;
                  END;
               ELSE
                  V_CDPRODORIG := C_ITEMPROD.CDPRODUTO;
               END IF;
               FOR C_IMPOSORIG IN (SELECT VRPERREDBCIT, NRITPROIMPOS, CDIMPOSTO, CDFISCALIT,
                                          VRALIQITEM, VRPARDEDIT, IDVALORINFIT, SUM(QTITEMPROD) AS QTITEMPROD,
                                          CDSITUTRIBITNFE, IDMODBCITNFE, IDMODBCSTITNFE,
                                          CDFISCOPERIT, CDSUFXCFOPIT,
                                          SUM(VRCONTITIMP) AS VRCONTITIMP,
                                          SUM(VRBASECALCIT) AS VRBASECALCIT, SUM(VRIMPOSTOIT) AS VRIMPOSTOIT, IDMOTDESONERAIT,
                                          VRPERDIFEREIT, NVL(VRIMPOSTOOPERAIT, 0) AS VRIMPOSTOOPERAIT,
                                          NVL(VRIMPOSTODIFERIT, 0) AS VRIMPOSTODIFERIT, 
                                          IT.CDBENEFFISCAL, IT.CDCEST
                                     FROM ITEMPROIMPOS IT, ITEMPRODUTO I
                                    WHERE IT.CDFILIAL  = V_FILIORIG
                                      AND IT.NRLANCTONF = V_DEVOLORIG
                                      AND I.CDFILIAL    = V_FILIORIG
                                      AND I.NRLANCTONF  = V_DEVOLORIG
                                      AND IT.NRSEQITPROD = I.NRSEQITPROD
                                      AND I.CDPRODUTO = V_CDPRODORIG
                                      AND ROUND(I.VRUNITITEM, V_NRDECITOTANF) = ROUND(C_ITEMPROD.VRUNITITEM, V_NRDECITOTANF)
                                      AND (NVL(I.NRLOTEESTQ  , ' ') = (NVL(C_ITEMPROD.NRLOTEESTQ, ' ')))
                                      AND (NVL(I.NRSUBLOTE , ' ')   = (NVL(C_ITEMPROD.NRSUBLOTE,  ' ')))
                                      AND NVL(I.IDORIGEMPROD, 'N')  = C_ITEMPROD.IDORIGEMPROD
                                    GROUP BY VRPERREDBCIT, NRITPROIMPOS, CDIMPOSTO, CDFISCALIT,
                                             VRALIQITEM, VRPARDEDIT, IDVALORINFIT,
                                             CDSITUTRIBITNFE, IDMODBCITNFE, IDMODBCSTITNFE,
                                             CDFISCOPERIT, CDSUFXCFOPIT, IDMOTDESONERAIT,
                                             VRPERDIFEREIT, VRIMPOSTOOPERAIT, VRIMPOSTODIFERIT,
                                             IT.CDBENEFFISCAL, IT.CDCEST)
               LOOP
                  V_VRFATOCONV := NVL(C_ITEMPROD.QTITEMPROD, 0) / C_IMPOSORIG.QTITEMPROD;
                  DELETE FROM TRABITPROIMPOS
                   WHERE CDFILIMPOIT = P_FILIAL
                     AND NRLANCIMPOIT = P_LANCTONF
                     AND NRSEQIMPOIT = C_ITEMPROD.NRSEQITPROD
                     AND CDIMPOSTOIT = C_IMPOSORIG.CDIMPOSTO
                     AND NRSEQITPRO = C_IMPOSORIG.NRITPROIMPOS;
                  DELETE FROM ITEMPROIMPOS
                   WHERE CDFILIAL = P_FILIAL
                     AND NRLANCTONF = P_LANCTONF
                     AND NRSEQITPROD = C_ITEMPROD.NRSEQITPROD
                     AND CDIMPOSTO = C_IMPOSORIG.CDIMPOSTO
                     AND NRITPROIMPOS = C_IMPOSORIG.NRITPROIMPOS;
                  V_IMPOICMS := NULL;
                  V_CST1DIGT := NULL;
                  V_CDGRUPOFISCAUX := NULL;
                  SELECT MAX(G.CDGRUPOFISC)
                    INTO V_CDGRUPOFISCAUX
                    FROM GRUPOFISCIMPFIL G,
                         (SELECT DECODE('E', 'E', CDFILIRECE, CDFILIEMIT) AS CDFILIAL
                            FROM NOTAFISCAL
                           WHERE CDFILIAL = P_FILIAL
                             AND NRLANCTONF = P_LANCTONF) F
                   WHERE G.CDFILIAL = F.CDFILIAL
                     AND NOT G.CDGRUPOFISC IS NULL
                     AND G.CDIMPOSTO = C_IMPOSORIG.CDIMPOSTO;
                  IF V_IDORIGDESTNF = 'F' THEN
                     SELECT NVL(MAX(G.CDGRUPOFISC), V_CDGRUPOFISCAUX)
                       INTO V_CDGRUPOFISCAUX
                       FROM GRFISIMPIEFORN G,
                            (SELECT CDFORNECED
                               FROM NOTAFISCAL
                              WHERE CDFILIAL = P_FILIAL
                                AND NRLANCTONF = P_LANCTONF) N
                      WHERE G.CDFORNECED = N.CDFORNECED
                        AND G.CDEMPRESA = P_EMPRESA
                        AND G.CDINSCESTA = P_INSCESTA
                        AND NOT G.CDGRUPOFISC IS NULL
                        AND G.CDIMPOSTO = C_IMPOSORIG.CDIMPOSTO;
                  ELSE
                     SELECT NVL(MAX(G.CDGRUPOFISC), V_CDGRUPOFISCAUX)
                       INTO V_CDGRUPOFISCAUX
                       FROM GRFISIMPIECLIE G,
                            (SELECT CDCLIENTE
                               FROM NOTAFISCAL
                              WHERE CDFILIAL = P_FILIAL
                                AND NRLANCTONF = P_LANCTONF) N
                      WHERE G.CDCLIENTE = N.CDCLIENTE
                        AND G.CDEMPRESA = P_EMPRESA
                        AND G.CDINSCESTA = P_INSCESTA
                        AND NOT G.CDGRUPOFISC IS NULL
                        AND G.CDIMPOSTO = C_IMPOSORIG.CDIMPOSTO;
                  END IF;
                  IF V_CDGRUPOFISCAUX IS NULL THEN
                     CONSULTA_CST_NFE(W_E, P_EMPRESA, C_ITEMPROD.CDARVPROD, P_INSCESTA, P_TIPOOPER, V_CDGRUPOFISC,C_IMPOSORIG.CDIMPOSTO, V_IDINTEREST, V_IDINTERNAC, P_FILIAL, P_LANCTONF, '', V_CDSITTRIBTMP, V_IDMODBCNFE, V_IDMODBCSTNFE, V_CDTPCRPICOSTNFE, V_CDNATUBCPCSTNFE, V_IDMOTIDESSTNFE, C_ITEMPROD.IDORIGEMPROD);
                  ELSE
                     CONSULTA_CST_NFE(W_E, P_EMPRESA, C_ITEMPROD.CDARVPROD, P_INSCESTA, P_TIPOOPER, V_CDGRUPOFISCAUX,C_IMPOSORIG.CDIMPOSTO, V_IDINTEREST, V_IDINTERNAC, P_FILIAL, P_LANCTONF, '', V_CDSITTRIBTMP, V_IDMODBCNFE, V_IDMODBCSTNFE, V_CDTPCRPICOSTNFE, V_CDNATUBCPCSTNFE, V_IDMOTIDESSTNFE, C_ITEMPROD.IDORIGEMPROD);
                  END IF;
                  SELECT MAX(CDIMPOSTO)
                    INTO V_IMPOICMS
                    FROM IMPOSTONFE N, IMPOSTO I
                   WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                     AND N.CDIMPOSTONFE = '00'
                     AND I.CDIMPOSTO = C_IMPOSORIG.CDIMPOSTO;
                  IF (V_IMPOICMS IS NOT NULL) THEN
                     IF V_IDORIGDESTNF = 'L' THEN
                        Begin
                           SELECT MAX(CDCSTDIG1PROD)
                             INTO V_CST1DIGT
                             FROM PRODUTO
                            WHERE (CDARVPROD = C_ITEMPROD.CDARVPROD);
                           IF V_CST1DIGT IS NULL THEN
                              SELECT MAX(CDCSTDIG1SAI)
                              INTO   V_CST1DIGT
                              FROM INSCRESTAD
                              WHERE CDEMPRESA  = P_EMPRESA AND
                                    CDINSCESTA = P_INSCESTA;
                           END IF;
                        Exception
                           When No_Data_Found Then
                              V_CST1DIGT := Null;
                        End;
                     ELSIF V_IDORIGDESTNF = 'C' THEN
                        Begin
                           SELECT MAX(CDCSTDIG1PROD)
                             INTO V_CST1DIGT
                             FROM PRODUTO
                            WHERE (CDARVPROD = C_ITEMPROD.CDARVPROD);
                           IF V_CST1DIGT IS NULL THEN
                              SELECT MAX(CDCSTDIG1CLI)
                                INTO V_CST1DIGT
                                FROM NOTAFISCAL N, CLIENTE C
                               WHERE CDFILIAL     = P_FILIAL    AND
                                     NRLANCTONF   = P_LANCTONF  AND
                                     N.CDCLIENTE  = C.CDCLIENTE;
                           END IF;
                        Exception
                           When No_Data_Found Then
                              V_CST1DIGT := Null;
                        End;
                     ELSE
                        Begin
                           SELECT MAX(CDCSTDIG1PROD)
                             INTO V_CST1DIGT
                             FROM PRODUTO
                            WHERE (CDARVPROD = C_ITEMPROD.CDARVPROD);
                           IF V_CST1DIGT IS NULL THEN
                              SELECT MAX(CDCSTDIG1ENT)
                                INTO   V_CST1DIGT
                                FROM NOTAFISCAL N, FORNECEDOR F
                               WHERE CDFILIAL     = P_FILIAL   AND
                                    NRLANCTONF    = P_LANCTONF AND
                                    N.CDFORNECED  = F.CDFORNECED;
                           END IF;
                        Exception
                           When No_Data_Found Then
                              V_CST1DIGT := Null;
                        End;
                     END IF;
                     IF (V_IDUTORIGPROD = 'S') AND (C_ITEMPROD.IDORIGEMPROD = 'E') AND (NVL(V_IDNFGERADAVIAXML, 'N') <> 'S') THEN
                        V_CST1DIGT := '2';
                     END IF;
                     IF (V_CDSITTRIBTMP IS NOT NULL) THEN
                        UPDATE ITEMPRODUTO
                           SET CDSITUTRIBPR  = V_CST1DIGT||V_CDSITTRIBTMP
                         WHERE CDFILIAL      = P_FILIAL AND
                               NRLANCTONF    = P_LANCTONF AND
                               NRSEQITPROD   = C_ITEMPROD.NRSEQITPROD;
                        V_SITUTRIBPR := V_CST1DIGT||V_CDSITTRIBTMP;
                     END IF;
                     V_CDGRUPOFISCAUX := NULL;
                     SELECT MAX(G.CDGRUPOFISC)
                       INTO V_CDGRUPOFISCAUX
                       FROM GRUPOFISCIMPFIL G,
                            (SELECT DECODE('E', 'E', CDFILIRECE, CDFILIEMIT) AS CDFILIAL
                               FROM NOTAFISCAL
                              WHERE CDFILIAL = P_FILIAL
                                    AND NRLANCTONF = P_LANCTONF) F
                      WHERE G.CDFILIAL = F.CDFILIAL
                        AND NOT G.CDGRUPOFISC IS NULL
                        AND G.CDIMPOSTO = C_IMPOSORIG.CDIMPOSTO;
                     IF V_IDORIGDESTNF = 'F' THEN
                        SELECT NVL(MAX(G.CDGRUPOFISC), V_CDGRUPOFISCAUX)
                          INTO V_CDGRUPOFISCAUX
                          FROM GRFISIMPIEFORN G,
                               (SELECT CDFORNECED
                                  FROM NOTAFISCAL
                                 WHERE CDFILIAL = P_FILIAL
                                   AND NRLANCTONF = P_LANCTONF) N
                         WHERE G.CDFORNECED = N.CDFORNECED
                           AND G.CDEMPRESA = P_EMPRESA
                           AND G.CDINSCESTA = P_INSCESTA
                           AND NOT G.CDGRUPOFISC IS NULL
                           AND G.CDIMPOSTO = C_IMPOSORIG.CDIMPOSTO;
                     ELSE
                        SELECT NVL(MAX(G.CDGRUPOFISC), V_CDGRUPOFISCAUX)
                          INTO V_CDGRUPOFISCAUX
                          FROM GRFISIMPIECLIE G,
                               (SELECT CDCLIENTE
                                  FROM NOTAFISCAL
                                 WHERE CDFILIAL = P_FILIAL
                                   AND NRLANCTONF = P_LANCTONF) N
                         WHERE G.CDCLIENTE = N.CDCLIENTE
                           AND G.CDEMPRESA = P_EMPRESA
                           AND G.CDINSCESTA = P_INSCESTA
                           AND NOT G.CDGRUPOFISC IS NULL
                           AND G.CDIMPOSTO = C_IMPOSORIG.CDIMPOSTO;
                     END IF;
                     IF (V_CDGRUPOFISCAUX IS NOT NULL) THEN
                        CONSULTA_CFOP(P_ENTRSAID, P_EMPRESA, C_ITEMPROD.CDARVPROD, P_INSCESTA, P_TIPOOPER, V_PAISCFOP,
                                      V_ESTACFOP, V_PAISDEST, V_ESTADEST, P_FILIAL, P_LANCTONF, V_CDGRUPOFISCAUX, P_INIVALID, C_ITEMPROD.IDORIGEMPROD);
                     ELSE
                        CONSULTA_CFOP(P_ENTRSAID, P_EMPRESA, C_ITEMPROD.CDARVPROD, P_INSCESTA, P_TIPOOPER, V_PAISCFOP,
                                      V_ESTACFOP, V_PAISDEST, V_ESTADEST, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC, P_INIVALID, C_ITEMPROD.IDORIGEMPROD);
                     END IF;
                     -- ALTERA NATUREZA DE OPERAÇÃO DA NOTA FISCAL CASO NÃO EXISTA
                     IF (V_DSCDFISOPEITREGRA IS NOT NULL) THEN
                        UPDATE NOTAFISCAL
                           SET DSCDFISOPENF = V_DSCDFISOPEITREGRA
                         WHERE CDFILIAL   = P_FILIAL   AND
                               NRLANCTONF = P_LANCTONF;
                     ELSE
                        UPDATE NOTAFISCAL
                           SET DSCDFISOPENF = (SELECT MAX(DSCFOPTMP)
                                                 FROM CFOPTEMP
                                                WHERE NRCFOPTEMP = V_CFOPTEMP)
                         WHERE CDFILIAL   = P_FILIAL
                           AND NRLANCTONF = P_LANCTONF
                           AND DSCDFISOPENF IS NULL;
                     END IF;
                     SELECT MAX(CDFISOPETMP), MAX(CDSUFCFOPTMP), MAX(IDDIFALIQTMP),
                            MAX(DSCFOPTMP), NVL(MAX(IDDIFALIQCUSPRC),W_N)
                      INTO V_FISOPEITEM, V_SUFXCFOPPR, V_DIFALIQITEM,
                           V_DSCDFISOPEIT, V_IDDIFALIQCUSPRC
                      FROM CFOPTEMP
                      WHERE NRCFOPTEMP = V_CFOPTEMP;
                      V_FISOPEITEM      := NVL(V_CDFISCOPERREGRA, V_FISOPEITEM);
                      V_DSCDFISOPEIT    := NVL(V_DSCDFISOPEITREGRA, V_DSCDFISOPEIT);
                      V_DIFALIQITEM     := NVL(V_IDDIFEALIQREGRA, V_DIFALIQITEM);
                      V_IDDIFALIQCUSPRC := NVL(V_IDDIFALIQCUSPRREGRA, V_IDDIFALIQCUSPRC);
                      -- ALTERA O CFOP DO ITEM E
                      UPDATE ITEMPRODUTO
                      SET CDFISOPEITEM = NVL(V_CDFISCOPERREGRA, V_FISOPEITEM),
                          CDSUFXCFOPPR = V_SUFXCFOPPR,
                          DSCDFISOPEIT = V_DSCDFISOPEIT
                      WHERE CDFILIAL    = P_FILIAL   AND
                            NRLANCTONF  = P_LANCTONF AND
                            NRSEQITPROD = C_ITEMPROD.NRSEQITPROD;
                     DELETE CFOPTEMP
                      WHERE NRCFOPTEMP = V_CFOPTEMP;
                  END IF;
                  INSERT INTO TRABITPROIMPOS(
                     CDFILIMPOIT, NRLANCIMPOIT, NRSEQIMPOIT, CDIMPOSTOIT, NRSEQITPRO, CDFISCIMPOIT,
                     CDSTRIBIMPOIT, CDFOPERIMPOIT, CDSCFOPIMPOIT, VRALIQIMPOIT, VRREDBCIMPOIT, VRPDEDIMPOIT,
                     VRCONTIMPOIT, VRBCALCIMPOIT, VRIMPOSIT, IDERRIMPOIT, IDAVISIMPOIT, IDVALORINFO,
                     CDSTRIBITNFE, IDMODBCITEMNFE, IDMODBCSTITENFE, CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESOTRABIT, CDREGRATRABIT,
                     VRPERDIFEREIT, VRIMPOSTOOPERAIT, VRIMPOSTODIFERIT, 
                     CDBENEFFISCAL, CDCEST)
                  VALUES(
                     P_FILIAL, P_LANCTONF, C_ITEMPROD.NRSEQITPROD, C_IMPOSORIG.CDIMPOSTO, C_IMPOSORIG.NRITPROIMPOS, C_IMPOSORIG.CDFISCALIT,
                     V_SITUTRIBPR, NVL(V_FISOPEITEM, C_IMPOSORIG.CDFISCOPERIT), NVL(V_SUFXCFOPPR, C_IMPOSORIG.CDSUFXCFOPIT), C_IMPOSORIG.VRALIQITEM, C_IMPOSORIG.VRPERREDBCIT, (C_IMPOSORIG.VRPARDEDIT * V_VRFATOCONV),
                     ROUND((C_IMPOSORIG.VRCONTITIMP * V_VRFATOCONV),5), ROUND((C_IMPOSORIG.VRBASECALCIT * V_VRFATOCONV), 2), (C_IMPOSORIG.VRIMPOSTOIT * V_VRFATOCONV), W_00000, W_00000, C_IMPOSORIG.IDVALORINFIT,
                     V_CDSITTRIBTMP, NVL(V_IDMODBCNFE, C_IMPOSORIG.IDMODBCITNFE), NVL(V_IDMODBCSTNFE, C_IMPOSORIG.IDMODBCSTITNFE),
                     V_CDTPCRPICOSTNFE, V_CDNATUBCPCSTNFE, NVL(V_IDMOTIDESSTNFE, C_IMPOSORIG.IDMOTDESONERAIT), V_CDREGRAITALIQ,
                     C_IMPOSORIG.VRPERDIFEREIT, ROUND((C_IMPOSORIG.VRIMPOSTOOPERAIT * V_VRFATOCONV),2), ROUND((C_IMPOSORIG.VRIMPOSTODIFERIT * V_VRFATOCONV),2), 
                     C_IMPOSORIG.CDBENEFFISCAL, C_IMPOSORIG.CDCEST);
                  INSERT INTO ITEMPROIMPOS(
                     CDFILIAL, NRLANCTONF, NRSEQITPROD, CDIMPOSTO, NRITPROIMPOS, CDFISCALIT,
                     CDSITUTRIBIT, CDFISCOPERIT, CDSUFXCFOPIT, VRALIQITEM, VRPERREDBCIT, VRPARDEDIT,
                     VRCONTITIMP, VRBASECALCIT, VRIMPOSTOIT, IDERROSIMPIT, IDAVISIMPIT, CDSITUTRIBITNFE,
                     IDMODBCITNFE, IDMODBCSTITNFE, CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT, CDREGRAIT,
                     VRPERDIFEREIT, VRIMPOSTOOPERAIT, VRIMPOSTODIFERIT, 
                     CDBENEFFISCAL, CDCEST)
                  VALUES(
                     P_FILIAL, P_LANCTONF, C_ITEMPROD.NRSEQITPROD, C_IMPOSORIG.CDIMPOSTO, C_IMPOSORIG.NRITPROIMPOS, C_IMPOSORIG.CDFISCALIT,
                     V_SITUTRIBPR, NVL(V_FISOPEITEM, C_IMPOSORIG.CDFISCOPERIT), NVL(V_SUFXCFOPPR, C_IMPOSORIG.CDSUFXCFOPIT), C_IMPOSORIG.VRALIQITEM, C_IMPOSORIG.VRPERREDBCIT, (C_IMPOSORIG.VRPARDEDIT * V_VRFATOCONV),
                     ROUND((C_IMPOSORIG.VRCONTITIMP * V_VRFATOCONV),5), ROUND((C_IMPOSORIG.VRBASECALCIT * V_VRFATOCONV), 2), (C_IMPOSORIG.VRIMPOSTOIT * V_VRFATOCONV), W_00000, W_00000, V_CDSITTRIBTMP,
                     NVL(V_IDMODBCNFE, C_IMPOSORIG.IDMODBCITNFE), NVL(V_IDMODBCSTNFE, C_IMPOSORIG.IDMODBCSTITNFE), V_CDTPCRPICOSTNFE, V_CDNATUBCPCSTNFE, NVL(V_IDMOTIDESSTNFE, C_IMPOSORIG.IDMOTDESONERAIT), V_CDREGRAITALIQ,
                     C_IMPOSORIG.VRPERDIFEREIT, ROUND((C_IMPOSORIG.VRIMPOSTOOPERAIT * V_VRFATOCONV),2), ROUND((C_IMPOSORIG.VRIMPOSTODIFERIT * V_VRFATOCONV),2),
                     C_IMPOSORIG.CDBENEFFISCAL, C_IMPOSORIG.CDCEST);
               END LOOP;
            END IF;
            IF (V_IDOPERDEVONF = W_S) THEN
               CONSULTA_INCIDENCIA(P_ENTRSAID, P_EMPRESA, C_ITEMPROD.CDARVPROD, P_INSCESTA, P_TIPOOPER, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC,
                                   NULL, V_IDINTEREST, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, C_ITEMPROD.IDORIGEMPROD);
               FOR C_INCIDITEM IN (SELECT IT.CDIMPOTEMP, MAX(IT.CDFISCTEMP) AS CDFISCTEMP,
                                        MAX(IT.IDTRATIMPTMP) AS IDTRATIMPTMP, MAX(IP.IDCONSISTENT) AS IDCONSISTENT, MAX(NVL(IP.IDUTMUNIORIG, W_N)) AS IDUTMUNIORIG,
                                        MAX(IP.IDIMPORECUP)  AS IDIMPORECUP, MAX(NVL(IP.IDPREIMPENTR, W_N)) AS IDPREIMPENTR,
                                        MAX(IP.IDORGARRECAD) AS IDORGARRECAD, MAX(IDUTVLRQTDEIMPO) AS IDUTVLRQTDEIMPO,
                                        MAX(IP.IDUTVRPAUTA) AS IDUTVRPAUTA,   MAX(CDENQLEGALIPI)   AS CDENQLEGALIPI,
                                        MAX(IT.CDCEST) AS CDCEST
                                 FROM INCITEMP IT, IMPOSTO IP
                                 WHERE (IT.NRINCITEMP = V_INCITEMP)    AND
                                       (IP.CDIMPOSTO  = IT.CDIMPOTEMP)
                                 GROUP BY IT.CDIMPOTEMP
                                 ORDER BY IT.CDIMPOTEMP) LOOP
                  /*VERIFICA CST POR IMPOSTO*/
                  V_IMPOICMS := NULL;
                  V_CDGRUPOFISCAUX := NULL;
                  IF (C_INCIDITEM.CDCEST IS NOT NULL) THEN
                     V_CDCEST := C_INCIDITEM.CDCEST;
                  END IF;
                  SELECT MAX(G.CDGRUPOFISC)
                    INTO V_CDGRUPOFISCAUX
                    FROM GRUPOFISCIMPFIL G,
                         (SELECT DECODE('E', 'E', CDFILIRECE, CDFILIEMIT) AS CDFILIAL
                            FROM NOTAFISCAL
                           WHERE CDFILIAL = P_FILIAL
                                 AND NRLANCTONF = P_LANCTONF) F
                   WHERE G.CDFILIAL = F.CDFILIAL
                     AND NOT G.CDGRUPOFISC IS NULL
                     AND G.CDIMPOSTO = C_INCIDITEM.CDIMPOTEMP;
                  IF V_IDORIGDESTNF = 'F' THEN
                     SELECT NVL(MAX(G.CDGRUPOFISC), V_CDGRUPOFISCAUX)
                       INTO V_CDGRUPOFISCAUX
                       FROM GRFISIMPIEFORN G,
                            (SELECT CDFORNECED
                               FROM NOTAFISCAL
                              WHERE CDFILIAL = P_FILIAL
                                AND NRLANCTONF = P_LANCTONF) N
                      WHERE G.CDFORNECED = N.CDFORNECED
                        AND G.CDEMPRESA = P_EMPRESA
                        AND G.CDINSCESTA = P_INSCESTA
                        AND NOT G.CDGRUPOFISC IS NULL
                        AND G.CDIMPOSTO = C_INCIDITEM.CDIMPOTEMP;
                  ELSE
                     SELECT NVL(MAX(G.CDGRUPOFISC), V_CDGRUPOFISCAUX)
                       INTO V_CDGRUPOFISCAUX
                       FROM GRFISIMPIECLIE G,
                            (SELECT CDCLIENTE
                               FROM NOTAFISCAL
                              WHERE CDFILIAL = P_FILIAL
                                AND NRLANCTONF = P_LANCTONF) N
                      WHERE G.CDCLIENTE = N.CDCLIENTE
                        AND G.CDEMPRESA = P_EMPRESA
                        AND G.CDINSCESTA = P_INSCESTA
                        AND NOT G.CDGRUPOFISC IS NULL
                        AND G.CDIMPOSTO = C_INCIDITEM.CDIMPOTEMP;
                  END IF;
                  DELETE ALIQTEMP
                  WHERE NRALIQTEMP = V_ALIQTEMP;
                  IF C_INCIDITEM.IDUTMUNIORIG = W_D THEN
                     /* CONSIDERA O MUNICIPIO DE DESTINO */
                     IF V_UTGRUPFISCS = 'S' THEN
                        V_CDGRPFISCSV := NULL;
                        SELECT MAX(CDGRUPOFISC)
                        INTO V_CDGRPFISCSV
                        FROM SERVCLIE SC, SERVICO S
                        WHERE SC.CDFILIAL   = V_CDFILIEMIT AND
                              SC.CDCLIENTE  = P_FORNECED    AND
                              SC.CDFILIAL   = S.CDFILIAL   AND
                              SC.CDSERVFILI = S.CDSERVFILI AND
                              S.CDPRODUTO   = V_CDPRODORIG;
                        IF V_CDGRPFISCSV IS NULL THEN
                           SELECT MAX(CDGRUPOFISC)
                           INTO V_CDGRPFISCSV
                           FROM CLIENFILIAL
                          WHERE CDFILIAL   = V_CDFILIEMIT AND
                                CDCLIENTE  = P_FORNECED;
                        END IF;
                        CONSULTA_ALIQUOTA(C_INCIDITEM.CDIMPOTEMP, P_ENTRSAID, P_EMPRESA, C_ITEMPROD.CDARVPROD, P_INSCESTA, V_PAISORIG,
                                          V_ESTAORIG, V_PAISDEST, V_ESTADEST, V_MUNIDEST, V_LIQUIITEM, P_INIVALID, P_FILIAL, P_LANCTONF, V_CDGRPFISCSV,P_TIPOOPER,
                                          NULL, NULL, NULL, NULL, P_FORNECED, NULL, C_ITEMPROD.IDORIGEMPROD);
                     ELSE
                        CONSULTA_ALIQUOTA(C_INCIDITEM.CDIMPOTEMP, P_ENTRSAID, P_EMPRESA, C_ITEMPROD.CDARVPROD, P_INSCESTA, V_PAISORIG,
                                          V_ESTAORIG, V_PAISDEST, V_ESTADEST, V_MUNIDEST, V_LIQUIITEM, P_INIVALID, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC, P_TIPOOPER,
                                          NULL, NULL, NULL, NULL, P_FORNECED, NULL, C_ITEMPROD.IDORIGEMPROD);
                     END IF;
                  ELSE
                    /* CONSIDERA O MUNICIPIO DE ORIGEM */
                     SELECT MAX(IDGRUPFISSRV)
                     INTO V_UTGRUPFISCS
                     FROM IMPOSTO
                     WHERE CDIMPOSTO   = C_INCIDITEM.CDIMPOTEMP;
                     IF V_UTGRUPFISCS = 'S' THEN
                        V_CDGRPFISCSV := NULL;
                        SELECT MAX(CDGRUPOFISC)
                        INTO V_CDGRPFISCSV
                        FROM SERVCLIE SC, SERVICO S
                        WHERE SC.CDFILIAL   = V_CDFILIEMIT AND
                              SC.CDCLIENTE  = P_FORNECED    AND
                              SC.CDFILIAL   = S.CDFILIAL   AND
                              SC.CDSERVFILI = S.CDSERVFILI AND
                              S.CDPRODUTO   = V_CDPRODORIG;
                        IF V_CDGRPFISCSV IS NULL THEN
                           SELECT MAX(CDGRUPOFISC)
                           INTO V_CDGRPFISCSV
                           FROM CLIENFILIAL
                          WHERE CDFILIAL   = V_CDFILIEMIT AND
                                CDCLIENTE  = P_FORNECED;
                        END IF;
                        CONSULTA_ALIQUOTA(C_INCIDITEM.CDIMPOTEMP, P_ENTRSAID, P_EMPRESA, C_ITEMPROD.CDARVPROD, P_INSCESTA, V_PAISORIG,
                                          V_ESTAORIG, V_PAISDEST, V_ESTADEST, V_MUNIORIG, V_LIQUIITEM, P_INIVALID, P_FILIAL, P_LANCTONF, V_CDGRPFISCSV, P_TIPOOPER,
                                          NULL, NULL, NULL, NULL, P_FORNECED, NULL, C_ITEMPROD.IDORIGEMPROD);
                     ELSE
                        CONSULTA_ALIQUOTA(C_INCIDITEM.CDIMPOTEMP, P_ENTRSAID, P_EMPRESA, C_ITEMPROD.CDARVPROD, P_INSCESTA, V_PAISORIG,
                                          V_ESTAORIG, V_PAISDEST, V_ESTADEST, V_MUNIORIG, V_LIQUIITEM, P_INIVALID, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC, P_TIPOOPER,
                                          NULL, NULL, NULL, NULL, P_FORNECED, NULL, C_ITEMPROD.IDORIGEMPROD);
                     END IF;
                  END IF;
                  SELECT NVL(MAX(VRPARDEDTMP),0), NVL(MAX(VRPREDBCTMP),0), NVL(MAX(VRALIQUTMP),0),
                         NVL(MAX(VRPBCSTTMP),0),  NVL(MAX(IDTRIMPSTTMP), '0'), NVL(MAX(VR1PREDBCTMP), '0'),
                         MAX(CDREGRATMP), MAX(CDFISCOPER), MAX(IDDIFEALIQ),
                         MAX(IDDIFALIQCUSPR), MAX(CDBENEFFISCAL)
                    INTO V_PARDEDTMP, V_PREDBCTMP, V_ALIQUTMP,
                         V_PBCSUBTRIB, V_IDTRIMPSTII, V_PREDBCTMP1,
                         V_CDREGRAITALIQ, V_CDFISCOPERREGRA, V_IDDIFEALIQREGRA,
                         V_IDDIFALIQCUSPRREGRA, V_CDBENEFFISCAL
                    FROM ALIQTEMP
                   WHERE (NRALIQTEMP = V_ALIQTEMP);
                  /* Verifica primeiro digito do CFOP */
                  V_CFOP1DIGT := '';
                  IF V_PAISCFOP = V_PAISDEST THEN
                     IF V_ESTACFOP = V_ESTADEST THEN
                        V_CFOP1DIGT := '1';
                     ELSE
                        V_CFOP1DIGT := '2';
                     END IF;
                  ELSE
                     V_CFOP1DIGT := '3';
                  END IF;
                  SELECT MAX(CDIMPOSTO)
                    INTO V_IMPOICMS
                    FROM IMPOSTONFE N, IMPOSTO I
                   WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                     AND N.CDIMPOSTONFE = '00'
                     AND I.CDIMPOSTO = C_INCIDITEM.CDIMPOTEMP;
                  IF (V_IMPOICMS IS NOT NULL) THEN
                     IF (V_CDFISCOPERREGRA IS NOT NULL) THEN
                        IF (LENGTH(V_CDFISCOPERREGRA) < 4) THEN
                           V_CDFISCOPERREGRA := V_CFOP1DIGT||V_CDFISCOPERREGRA;
                        END IF;
                        V_FISOPEITEM := V_CDFISCOPERREGRA;
                        UPDATE ITEMPRODUTO
                           SET CDFISOPEITEM = V_CDFISCOPERREGRA
                         WHERE CDFILIAL     = P_FILIAL
                           AND NRLANCTONF  = P_LANCTONF
                           AND NRSEQITPROD = C_ITEMPROD.NRSEQITPROD;
                     END IF;
                  END IF;
                  IF V_CDGRUPOFISCAUX IS NULL THEN
                     CONSULTA_CST_NFE(W_E, P_EMPRESA, C_ITEMPROD.CDARVPROD, P_INSCESTA, P_TIPOOPER, V_CDGRUPOFISC,C_INCIDITEM.CDIMPOTEMP, V_IDINTEREST, V_IDINTERNAC, P_FILIAL, P_LANCTONF, '', V_CDSITTRIBTMP, V_IDMODBCNFE, V_IDMODBCSTNFE, V_CDTPCRPICOSTNFE, V_CDNATUBCPCSTNFE, V_IDMOTIDESSTNFE, C_ITEMPROD.IDORIGEMPROD);
                  ELSE
                     CONSULTA_CST_NFE(W_E, P_EMPRESA, C_ITEMPROD.CDARVPROD, P_INSCESTA, P_TIPOOPER, V_CDGRUPOFISCAUX,C_INCIDITEM.CDIMPOTEMP, V_IDINTEREST, V_IDINTERNAC, P_FILIAL, P_LANCTONF, '', V_CDSITTRIBTMP, V_IDMODBCNFE, V_IDMODBCSTNFE, V_CDTPCRPICOSTNFE, V_CDNATUBCPCSTNFE, V_IDMOTIDESSTNFE, C_ITEMPROD.IDORIGEMPROD);
                  END IF;
                  V_IMPOICMS := NULL;
                  V_CST1DIGT := NULL;
                  SELECT MAX(CDIMPOSTO)
                    INTO V_IMPOICMS
                    FROM IMPOSTONFE N, IMPOSTO I
                   WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                     AND N.CDIMPOSTONFE = '00'
                     AND I.CDIMPOSTO = C_INCIDITEM.CDIMPOTEMP;
                  IF (V_IMPOICMS IS NOT NULL) THEN
                     IF V_IDORIGDESTNF = 'L' THEN
                        Begin
                           SELECT MAX(CDCSTDIG1PROD)
                             INTO V_CST1DIGT
                             FROM PRODUTO
                            WHERE (CDARVPROD = C_ITEMPROD.CDARVPROD);
                           IF V_CST1DIGT IS NULL THEN
                              SELECT MAX(CDCSTDIG1SAI)
                              INTO   V_CST1DIGT
                              FROM INSCRESTAD
                              WHERE CDEMPRESA  = P_EMPRESA AND
                                    CDINSCESTA = P_INSCESTA;
                           END IF;
                        Exception
                           When No_Data_Found Then
                              V_CST1DIGT := Null;
                        End;
                     ELSIF V_IDORIGDESTNF = 'C' THEN
                        Begin
                           SELECT MAX(CDCSTDIG1PROD)
                             INTO V_CST1DIGT
                             FROM PRODUTO
                            WHERE (CDARVPROD = C_ITEMPROD.CDARVPROD);
                           IF V_CST1DIGT IS NULL THEN
                              SELECT MAX(CDCSTDIG1CLI)
                                INTO V_CST1DIGT
                                FROM NOTAFISCAL N, CLIENTE C
                               WHERE CDFILIAL     = P_FILIAL    AND
                                     NRLANCTONF   = P_LANCTONF  AND
                                     N.CDCLIENTE  = C.CDCLIENTE;
                           END IF;
                        Exception
                           When No_Data_Found Then
                              V_CST1DIGT := Null;
                        End;
                     ELSE
                        Begin
                           SELECT MAX(CDCSTDIG1PROD)
                             INTO V_CST1DIGT
                             FROM PRODUTO
                            WHERE (CDARVPROD = C_ITEMPROD.CDARVPROD);
                           IF V_CST1DIGT IS NULL THEN
                              SELECT MAX(CDCSTDIG1ENT)
                                INTO   V_CST1DIGT
                                FROM NOTAFISCAL N, FORNECEDOR F
                               WHERE CDFILIAL     = P_FILIAL   AND
                                    NRLANCTONF    = P_LANCTONF AND
                                    N.CDFORNECED  = F.CDFORNECED;
                           END IF;
                        Exception
                           When No_Data_Found Then
                              V_CST1DIGT := Null;
                        End;
                     END IF;
                     IF (V_IDUTORIGPROD = 'S') AND (C_ITEMPROD.IDORIGEMPROD = 'E') AND (NVL(V_IDNFGERADAVIAXML, 'N') <> 'S') THEN
                        V_CST1DIGT := '2';
                     END IF;
                     IF (V_IMPOICMS IS NOT NULL) THEN
                        IF (V_CDSITTRIBTMP IS NOT NULL) THEN
                           UPDATE ITEMPRODUTO
                              SET CDSITUTRIBPR  = V_CST1DIGT||V_CDSITTRIBTMP
                            WHERE CDFILIAL      = P_FILIAL AND
                                  NRLANCTONF    = P_LANCTONF AND
                                  NRSEQITPROD   = C_ITEMPROD.NRSEQITPROD;
                           V_SITUTRIBPR := V_CST1DIGT||V_CDSITTRIBTMP;
                        END IF;
                     END IF;
                  END IF;
                  SELECT MAX(CDIMPOSTO)
                    INTO V_IMPOICMS
                    FROM IMPOSTONFE N, IMPOSTO I
                   WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                     AND N.CDIMPOSTONFE = '00'
                     AND I.CDIMPOSTO = C_INCIDITEM.CDIMPOTEMP;
                  UPDATE ITEMPROIMPOS
                  SET CDFISCALIT = C_INCIDITEM.CDFISCTEMP,
                      CDSITUTRIBITNFE = V_CDSITTRIBTMP,
                      IDMODBCITNFE    = V_IDMODBCNFE,
                      IDMODBCSTITNFE  = V_IDMODBCSTNFE,
                      CDTPCREDPICOITE = V_CDTPCRPICOSTNFE,
                      CDNATUBCALPCIT  = V_CDNATUBCPCSTNFE,
                      IDMOTDESONERAIT = V_IDMOTIDESSTNFE,
                      CDREGRAIT       = V_CDREGRAITALIQ,
                      CDENQLEGALIPI   = C_INCIDITEM.CDENQLEGALIPI,
                      CDBENEFFISCAL   = V_CDBENEFFISCAL,
                      CDCEST          = NVL(V_CDCEST, CDCEST)
                  WHERE CDFILIAL      = P_FILIAL                AND
                        NRLANCTONF    = P_LANCTONF              AND
                        NRSEQITPROD   = C_ITEMPROD.NRSEQITPROD  AND
                        CDIMPOSTO     = C_INCIDITEM.CDIMPOTEMP;
                  UPDATE TRABITPROIMPOS
                  SET CDFISCIMPOIT    = C_INCIDITEM.CDFISCTEMP,
                      CDSTRIBITNFE    = V_CDSITTRIBTMP,
                      IDMODBCITEMNFE  = V_IDMODBCNFE,
                      IDMODBCSTITENFE = V_IDMODBCSTNFE,
                      CDTPCREDPICOITE = V_CDTPCRPICOSTNFE,
                      CDNATUBCALPCIT  = V_CDNATUBCPCSTNFE,
                      IDMOTDESOTRABIT = V_IDMOTIDESSTNFE,
                      CDREGRATRABIT   = V_CDREGRAITALIQ,
                      CDENQLEGALIPI   = C_INCIDITEM.CDENQLEGALIPI,
                      CDBENEFFISCAL   = V_CDBENEFFISCAL,
                      CDCEST          = NVL(V_CDCEST, CDCEST)
                  WHERE CDFILIMPOIT   = P_FILIAL               AND
                        NRLANCIMPOIT  = P_LANCTONF             AND
                        NRSEQIMPOIT   = C_ITEMPROD.NRSEQITPROD AND
                        CDIMPOSTOIT   = C_INCIDITEM.CDIMPOTEMP;
                  UPDATE ITEMPROIMPOS
                  SET CDFISCALIT = '2'
                  WHERE CDFILIAL    = P_FILIAL    AND
                        NRLANCTONF  = P_LANCTONF  AND
                        VRPERREDBCIT > 0.00       AND
                        NRITPROIMPOS = '2';
                  UPDATE TRABITPROIMPOS
                  SET CDFISCIMPOIT = '2'
                  WHERE CDFILIMPOIT  = P_FILIAL   AND
                        NRLANCIMPOIT = P_LANCTONF AND
                        VRREDBCIMPOIT > 0.00      AND
                        NRSEQITPRO = '2';
                  DELETE INCITEMP
                  WHERE NRINCITEMP = V_INCITEMP;
                  V_FISOPEITEM      := NVL(V_CDFISCOPERREGRA, V_FISOPEITEM);
                  V_DSCDFISOPEIT    := NVL(V_DSCDFISOPEITREGRA, V_DSCDFISOPEIT);
                  V_DIFALIQITEM     := NVL(V_IDDIFEALIQREGRA, V_DIFALIQITEM);
                  V_IDDIFALIQCUSPRC := NVL(V_IDDIFALIQCUSPRREGRA, V_IDDIFALIQCUSPRC);
                  IF (V_IMPOICMS IS NOT NULL) THEN
                     IF NOT V_FISOPEITEM IS NULL THEN
                        UPDATE NOTAFISCAL
                        SET CDFISOPENTF = NVL(V_CDFISCOPERREGRA, V_FISOPEITEM),
                            DSCDFISOPENF = NVL(V_DSCDFISOPEITREGRA, V_DSCDFISOPEIT)
                        WHERE CDFILIAL   = P_FILIAL   AND
                              NRLANCTONF = P_LANCTONF;
                     END IF;
                  END IF;
                  V_CDGRUPOFISCAUX := NULL;
                  SELECT MAX(G.CDGRUPOFISC)
                    INTO V_CDGRUPOFISCAUX
                    FROM GRUPOFISCIMPFIL G,
                         (SELECT DECODE('E', 'E', CDFILIRECE, CDFILIEMIT) AS CDFILIAL
                            FROM NOTAFISCAL
                           WHERE CDFILIAL = P_FILIAL
                                 AND NRLANCTONF = P_LANCTONF) F
                   WHERE G.CDFILIAL = F.CDFILIAL
                     AND NOT G.CDGRUPOFISC IS NULL
                     AND G.CDIMPOSTO = C_INCIDITEM.CDIMPOTEMP;
                  IF V_IDORIGDESTNF = 'F' THEN
                     SELECT NVL(MAX(G.CDGRUPOFISC), V_CDGRUPOFISCAUX)
                       INTO V_CDGRUPOFISCAUX
                       FROM GRFISIMPIEFORN G,
                            (SELECT CDFORNECED
                               FROM NOTAFISCAL
                              WHERE CDFILIAL = P_FILIAL
                                AND NRLANCTONF = P_LANCTONF) N
                      WHERE G.CDFORNECED = N.CDFORNECED
                        AND G.CDEMPRESA = P_EMPRESA
                        AND G.CDINSCESTA = P_INSCESTA
                        AND NOT G.CDGRUPOFISC IS NULL
                        AND G.CDIMPOSTO = C_INCIDITEM.CDIMPOTEMP;
                  ELSE
                     SELECT NVL(MAX(G.CDGRUPOFISC), V_CDGRUPOFISCAUX)
                       INTO V_CDGRUPOFISCAUX
                       FROM GRFISIMPIECLIE G,
                            (SELECT CDCLIENTE
                               FROM NOTAFISCAL
                              WHERE CDFILIAL = P_FILIAL
                                AND NRLANCTONF = P_LANCTONF) N
                      WHERE G.CDCLIENTE = N.CDCLIENTE
                        AND G.CDEMPRESA = P_EMPRESA
                        AND G.CDINSCESTA = P_INSCESTA
                        AND NOT G.CDGRUPOFISC IS NULL
                        AND G.CDIMPOSTO = C_INCIDITEM.CDIMPOTEMP;
                  END IF;
                  IF (V_CDGRUPOFISCAUX IS NOT NULL) THEN
                     CONSULTA_CFOP(P_ENTRSAID, P_EMPRESA, C_ITEMPROD.CDARVPROD, P_INSCESTA, P_TIPOOPER, V_PAISCFOP,
                                   V_ESTACFOP, V_PAISDEST, V_ESTADEST, P_FILIAL, P_LANCTONF, V_CDGRUPOFISCAUX, P_INIVALID, C_ITEMPROD.IDORIGEMPROD);
                  ELSE
                     CONSULTA_CFOP(P_ENTRSAID, P_EMPRESA, C_ITEMPROD.CDARVPROD, P_INSCESTA, P_TIPOOPER, V_PAISCFOP,
                                   V_ESTACFOP, V_PAISDEST, V_ESTADEST, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC, P_INIVALID, C_ITEMPROD.IDORIGEMPROD);
                  END IF;
                  -- ALTERA NATUREZA DE OPERAÇÃO DA NOTA FISCAL CASO NÃO EXISTA
                  IF (V_DSCDFISOPEITREGRA IS NOT NULL) THEN
                     UPDATE NOTAFISCAL
                        SET DSCDFISOPENF = V_DSCDFISOPEITREGRA
                      WHERE CDFILIAL   = P_FILIAL   AND
                            NRLANCTONF = P_LANCTONF;
                  ELSE
                     UPDATE NOTAFISCAL
                        SET DSCDFISOPENF = (SELECT MAX(DSCFOPTMP)
                                              FROM CFOPTEMP
                                             WHERE NRCFOPTEMP = V_CFOPTEMP)
                      WHERE CDFILIAL   = P_FILIAL
                        AND NRLANCTONF = P_LANCTONF
                        AND DSCDFISOPENF IS NULL;
                  END IF;
                  SELECT MAX(CDFISOPETMP), MAX(CDSUFCFOPTMP), MAX(IDDIFALIQTMP),
                         MAX(DSCFOPTMP), NVL(MAX(IDDIFALIQCUSPRC),W_N)
                   INTO V_FISOPEITEM, V_SUFXCFOPPR, V_DIFALIQITEM,
                        V_DSCDFISOPEIT, V_IDDIFALIQCUSPRC
                   FROM CFOPTEMP
                   WHERE NRCFOPTEMP = V_CFOPTEMP;
                   V_FISOPEITEM      := NVL(V_CDFISCOPERREGRA, V_FISOPEITEM);
                   V_DSCDFISOPEIT    := NVL(V_DSCDFISOPEITREGRA, V_DSCDFISOPEIT);
                   V_DIFALIQITEM     := NVL(V_IDDIFEALIQREGRA, V_DIFALIQITEM);
                   V_IDDIFALIQCUSPRC := NVL(V_IDDIFALIQCUSPRREGRA, V_IDDIFALIQCUSPRC);
                   -- ALTERA O CFOP DO ITEM E
                   UPDATE ITEMPRODUTO
                   SET CDFISOPEITEM = NVL(V_CDFISCOPERREGRA, V_FISOPEITEM),
                       CDSUFXCFOPPR = V_SUFXCFOPPR,
                       DSCDFISOPEIT = V_DSCDFISOPEIT
                   WHERE CDFILIAL    = P_FILIAL   AND
                         NRLANCTONF  = P_LANCTONF AND
                         NRSEQITPROD = C_ITEMPROD.NRSEQITPROD;
                  DELETE CFOPTEMP
                   WHERE NRCFOPTEMP = V_CFOPTEMP;
                  SELECT MAX(IDORDPRIMDFENT)
                    INTO V_IDORDPRIMDFENT
                    FROM PARAMGERAL;
                  CONSULTA_CSOSN(P_ENTRSAID, P_EMPRESA, C_ITEMPROD.CDARVPROD, P_INSCESTA, P_TIPOOPER, P_FILIAL, P_LANCTONF, V_CDGRUPOFISC, V_IDINTEREST, V_CDFISCOPERSN);
                  IF (NOT V_CDFISCOPERSN IS NULL) AND (LENGTH(V_CDFISCOPERSN) = 4) THEN
                     UPDATE ITEMPRODUTO
                        SET CDFISCOPERSN = V_CDFISCOPERSN
                      WHERE CDFILIAL    = P_FILIAL
                        AND NRLANCTONF  = P_LANCTONF
                        AND NRSEQITPROD = C_ITEMPROD.NRSEQITPROD;
                  ELSE
                     UPDATE ITEMPRODUTO
                        SET CDFISCOPERSN = (SELECT MAX(I.CDFISCOPERSN)
                                              FROM ITEMPRODUTO I
                                             WHERE I.CDFILIAL   = V_FILIORIG
                                               AND I.NRLANCTONF = V_DEVOLORIG
                                               AND I.CDPRODUTO  = V_CDPRODORIG)
                      WHERE CDFILIAL    = P_FILIAL
                        AND NRLANCTONF  = P_LANCTONF
                        AND NRSEQITPROD = C_ITEMPROD.NRSEQITPROD;
                  END IF;
                  IF (V_CDFISCOPERREGRA IS NOT NULL) THEN
                     V_DSCDFISOPEITREGRA := SUBSTR(DESCRICAO_CFOP(V_CDFISCOPERREGRA),1,45);
                  END IF;
                  IF (V_IMPOICMS IS NOT NULL) THEN
                     IF NOT V_FISOPEITEM IS NULL THEN
                        UPDATE ITEMPRODUTO
                        SET CDFISOPEITEM = NVL(V_CDFISCOPERREGRA, V_FISOPEITEM),
                            CDSUFXCFOPPR = V_SUFXCFOPPR,
                            DSCDFISOPEIT =  NVL(V_DSCDFISOPEITREGRA, V_DSCDFISOPEIT)
                        WHERE CDFILIAL    = P_FILIAL                 AND
                              NRLANCTONF  = P_LANCTONF               AND
                              NRSEQITPROD = C_ITEMPROD.NRSEQITPROD;
                        IF (V_IDOPERDEVONF = w_S) THEN
                           UPDATE TRABITPROIMPOS
                           SET CDSTRIBIMPOIT = V_SITUTRIBPR,
                               CDFOPERIMPOIT = NVL(V_CDFISCOPERREGRA, V_FISOPEITEM),
                               CDSCFOPIMPOIT = V_SUFXCFOPPR
                           WHERE CDFILIMPOIT = P_FILIAL                AND
                                 NRLANCIMPOIT = P_LANCTONF             AND
                                 NRSEQIMPOIT = C_ITEMPROD.NRSEQITPROD;
                        END IF;
                     ELSE
                        UPDATE ITEMPRODUTO
                           SET CDFISOPEITEM = NVL(V_CDFISCOPERREGRA, V_CFOP1DIGT || SUBSTR(CDFISOPEITEM,2,10))
                         WHERE CDFILIAL    = P_FILIAL                 AND
                               NRLANCTONF  = P_LANCTONF               AND
                               NRSEQITPROD = C_ITEMPROD.NRSEQITPROD;
                        IF (V_IDOPERDEVONF = w_S) THEN
                           UPDATE TRABITPROIMPOS
                           SET CDFOPERIMPOIT = V_CFOP1DIGT || SUBSTR(CDFOPERIMPOIT,2,10)
                           WHERE CDFILIMPOIT = P_FILIAL                AND
                                 NRLANCIMPOIT = P_LANCTONF             AND
                                 NRSEQIMPOIT = C_ITEMPROD.NRSEQITPROD;
                        END IF;
                     END IF;
                  END IF;
                  DELETE CFOPTEMP
                  WHERE NRCFOPTEMP = V_CFOPTEMP;
                  SELECT MAX(CDSITTRIBTMP) INTO V_SITUTRIBPR
                  FROM CSTTEMP
                  WHERE NRCSTTEMP = V_CSTTEMP;
                  IF V_CDSITTRIBTMP IS NOT NULL THEN
                     V_SITUTRIBPR := V_CST1DIGT||V_CDSITTRIBTMP;
                  END IF;
                  IF P_ENTRSAID = W_E THEN
                     IF (SUBSTR(C_ITEMPROD.CDSITUTRIBPR,1,1) = SUBSTR(V_SITUTRIBPR,1,1)) OR
                        (C_ITEMPROD.CDSITUTRIBPR IS NULL) THEN
                        IF (V_IMPOICMS IS NOT NULL) THEN
                           UPDATE ITEMPRODUTO
                           SET CDSITUTRIBPR  = V_SITUTRIBPR
                           WHERE CDFILIAL    = P_FILIAL   AND
                                 NRLANCTONF  = P_LANCTONF AND
                                 NRSEQITPROD = C_ITEMPROD.NRSEQITPROD;
                        END IF;
                     END IF;
                  ELSIF P_ENTRSAID = W_S THEN
                     IF (SUBSTR(C_ITEMPROD.CDSITUTRIBPR,1,1) = SUBSTR(V_SITUTRIBPR,1,1)) OR
                        (C_ITEMPROD.CDSITUTRIBPR IS NULL) THEN
                        UPDATE ITEMPRODUTO
                        SET CDSITUTRIBPR  = V_SITUTRIBPR
                        WHERE CDFILIAL    = P_FILIAL               AND
                              NRLANCTONF  = P_LANCTONF             AND
                              NRSEQITPROD = C_ITEMPROD.NRSEQITPROD AND
                              CDSITUTRIBPR IS NULL;
                     END IF;
                  END IF;
                  DELETE CSTTEMP
                  WHERE NRCSTTEMP = V_CSTTEMP;
               END LOOP;
            END IF;
         END LOOP;
         IF (V_IDOPERDEVONF <> 'S') OR ( V_IDNFRETIND = 'S') OR (V_IDCOMPRABONI = 'S')THEN
            IF (V_IDNFRETIND = 'S') OR (V_IDCOMPRABONI = 'S') THEN
               FOR C_ITEMENCARGO IN (SELECT IE.CDENCARGO AS CDENCARGO, (VRITEMENCA-NVL(I.VRICMSSTITORIG,0)) VRITEMENCA, IDENCARGO,
                                            EN.CDCTBLENTREN, EN.CDCTBLSAIDEN
                                       FROM ENCARGO EN, ITEMENCARGO IE, (SELECT SUM(VRICMSSTITORIG) VRICMSSTITORIG
                                                                           FROM ITEMPRODUTO
                                                                          WHERE CDFILIAL   = P_FILIAL
                                                                            AND NRLANCTONF = P_LANCTONF) I
                                      WHERE (IE.CDFILIAL   = P_FILIAL)
                                        AND (IE.NRLANCTONF = P_LANCTONF)
                                        AND (IE.VRITEMENCA-NVL(I.VRICMSSTITORIG,0) > 0)
                                        AND (EN.CDENCARGO  = IE.CDENCARGO)) LOOP
                  SELECT SUM(VRTOTAITEM - VRDESCITEM) INTO V_TOTAPRODENCA
                  FROM ITEMPRODUTO IP
                  WHERE (IP.CDFILIAL   = P_FILIAL)   AND
                        (IP.NRLANCTONF = P_LANCTONF);
                  IF V_TOTAPRODENCA <> 0 THEN
                     FOR C_ATUAVRCONT IN(SELECT IP.NRSEQITPROD, (IP.VRTOTAITEM - IP.VRDESCITEM) AS VRLIQUIDO,
                                                IP.CDFISOPEITEM, IP.CDPRODUTO
                                           FROM ITEMPRODUTO IP, TPOPERCFOP T, NOTAFISCAL N
                                          WHERE IP.CDFILIAL     = P_FILIAL
                                            AND IP.NRLANCTONF   = P_LANCTONF
                                            AND IP.CDFILIAL     = N.CDFILIAL
                                            AND IP.NRLANCTONF   = N.NRLANCTONF
                                            AND IP.CDFISOPEITEM = T.CDFISCOPER
                                            AND N.CDTIPOOPER    = T.CDTIPOOPER
                                            AND T.IDCOMPOEVENC  = w_S)LOOP
                        IF (C_ITEMENCARGO.IDENCARGO = W_A) THEN
                           V_VRBRUTO := (C_ITEMENCARGO.VRITEMENCA/V_TOTAPRODENCA);
                        ELSIF (C_ITEMENCARGO.IDENCARGO = W_D) THEN
                           V_VRBRUTO := - (C_ITEMENCARGO.VRITEMENCA/V_TOTAPRODENCA);
                        ELSE
                           V_VRBRUTO := 0;
                        END IF;
                        IF (C_ITEMENCARGO.CDCTBLENTREN IS NULL) THEN
                           V_VRCONTAB := V_VRBRUTO;
                        ELSE
                           V_VRCONTAB := 0;
                        END IF;
                        UPDATE ITEMPRODUTO
                        SET VRBRUTITEM = VRBRUTITEM + (V_VRBRUTO  * (VRTOTAITEM - VRDESCITEM)),
                            VRCONTITEM = VRCONTITEM + (V_VRCONTAB * (VRTOTAITEM - VRDESCITEM))
                        WHERE CDFILIAL    = P_FILIAL   AND
                              NRLANCTONF  = P_LANCTONF AND
                              NRSEQITPROD = C_ATUAVRCONT.NRSEQITPROD;
                     END LOOP;
                  END IF;
               END LOOP;
            ELSE
               FOR C_ITEMENCARGO IN (SELECT IE.CDENCARGO AS CDENCARGO, (VRITEMENCA-NVL(I.VRICMSSTITORIG,0)) VRITEMENCA, IDENCARGO,
                                            EN.CDCTBLENTREN, EN.CDCTBLSAIDEN
                                       FROM ENCARGO EN, ITEMENCARGO IE, (SELECT SUM(VRICMSSTITORIG) VRICMSSTITORIG
                                                                           FROM ITEMPRODUTO
                                                                          WHERE CDFILIAL   = P_FILIAL
                                                                            AND NRLANCTONF = P_LANCTONF) I
                                      WHERE (IE.CDFILIAL   = P_FILIAL)
                                        AND (IE.NRLANCTONF = P_LANCTONF)
                                        AND (IE.VRITEMENCA-NVL(I.VRICMSSTITORIG,0) > 0)
                                        AND (EN.CDENCARGO  = IE.CDENCARGO)) LOOP
                  SELECT SUM(VRTOTAITEM - VRDESCITEM) INTO V_TOTAPRODENCA
                  FROM ITEMPRODUTO IP
                  WHERE (IP.CDFILIAL   = P_FILIAL)   AND
                        (IP.NRLANCTONF = P_LANCTONF);
                  IF V_TOTAPRODENCA <> 0 THEN
                     FOR C_ATUAVRCONT IN (SELECT IP.NRSEQITPROD, (VRTOTAITEM - VRDESCITEM) AS VRLIQUIDO
                                           FROM ITEMPRODUTO IP
                                           WHERE (IP.CDFILIAL    = P_FILIAL) AND
                                                 (IP.NRLANCTONF  = P_LANCTONF)) LOOP
                        IF (C_ITEMENCARGO.IDENCARGO = W_A) THEN
                           V_VRBRUTO := (C_ITEMENCARGO.VRITEMENCA/V_TOTAPRODENCA);
                        ELSIF (C_ITEMENCARGO.IDENCARGO = W_D) THEN
                           V_VRBRUTO := - (C_ITEMENCARGO.VRITEMENCA/V_TOTAPRODENCA);
                        ELSE
                           V_VRBRUTO := 0;
                        END IF;
                        IF (C_ITEMENCARGO.CDCTBLENTREN IS NULL) THEN
                           V_VRCONTAB := V_VRBRUTO;
                        ELSE
                           V_VRCONTAB := 0;
                        END IF;
                        UPDATE ITEMPRODUTO
                        SET VRBRUTITEM = VRBRUTITEM + (V_VRBRUTO  * (VRTOTAITEM - VRDESCITEM)),
                            VRCONTITEM = VRCONTITEM + (V_VRCONTAB * (VRTOTAITEM - VRDESCITEM))
                        WHERE CDFILIAL    = P_FILIAL   AND
                              NRLANCTONF  = P_LANCTONF AND
                              NRSEQITPROD = C_ATUAVRCONT.NRSEQITPROD;
                     END LOOP;
                  END IF;
               END LOOP;
            END IF;
         END IF;
         FOR C_QTITEM IN (SELECT NRSEQITPROD
                          FROM ITEMPRODUTO
                          WHERE (CDFILIAL   = P_FILIAL)   AND
                                (NRLANCTONF = P_LANCTONF) AND
                                (QTITEMPROD = 0)) LOOP
            DELETE TRABITPROIMPOS
            WHERE (CDFILIMPOIT  = P_FILIAL) AND
                  (NRLANCIMPOIT = P_LANCTONF) AND
                  (NRSEQIMPOIT = C_QTITEM.NRSEQITPROD);
         END LOOP;
         SELECT MAX(CDFILIMPOIT||NRLANCIMPOIT) AS IMPOSITEM
         INTO V_IMPOSITEM
         FROM TRABITPROIMPOS
         WHERE (CDFILIMPOIT  = P_FILIAL) AND
               (NRLANCIMPOIT = P_LANCTONF);
         IF V_IMPOSITEM IS NULL THEN
            DELETE TRABIMPOSNFTOT
            WHERE (CDFILIMPTOT  = P_FILIAL) AND
                  (NRLANCIMPTOT = P_LANCTONF);
         END IF;
         DELETE ITEMPRODUTO
         WHERE (CDFILIAL   = P_FILIAL)   AND
               (NRLANCTONF = P_LANCTONF) AND
               (QTITEMPROD = 0);
         FOR C_IMPOSPROD IN (SELECT IT.CDIMPOSTOIT,
                                    NVL(SUM(IT.VRIMPOSIT),0)  AS VRIMPOSTOIT,
                                    NVL(SUM(IT.VRBCALCIMPOIT),0) AS VRBASECALCIT
                             FROM TRABITPROIMPOS IT
                             WHERE (IT.CDFILIMPOIT  = P_FILIAL) AND
                                   (IT.NRLANCIMPOIT = P_LANCTONF)
                             GROUP BY IT.CDIMPOSTOIT) LOOP
            UPDATE TRABIMPOSNFTOT
            SET VRIMPOSTOT   = C_IMPOSPROD.VRIMPOSTOIT,
                VRBCALIMPTOT = C_IMPOSPROD.VRBASECALCIT
            WHERE (CDFILIMPTOT  = P_FILIAL)   AND
                  (NRLANCIMPTOT = P_LANCTONF) AND
                  (CDIMPOSTOT   = C_IMPOSPROD.CDIMPOSTOIT);
         END LOOP;
         IF V_IDOPERDEVONF <> 'S' THEN
            FOR C_PREDBCALC IN (SELECT NRSEQIMPOIT, CDIMPOSTOIT, CDSTRIBIMPOIT, CDFOPERIMPOIT,
                                       CDSCFOPIMPOIT, VRCONTIMPOIT, VRREDBCIMPOIT, VRBCALCIMPOIT,
                                       IDVALORINFO, P.CDARVPROD, I.IDORIGEMPROD, T.CDCEST
                                FROM TRABITPROIMPOS T, ITEMPRODUTO I, PRODUTO P
                                WHERE (CDFILIMPOIT   = P_FILIAL)   AND
                                      (NRLANCIMPOIT  = P_LANCTONF) AND
                                      (T.CDFILIMPOIT = I.CDFILIAL) AND
                                      (T.NRLANCIMPOIT = I.NRLANCTONF) AND
                                      (T.NRSEQIMPOIT = I.NRSEQITPROD) AND
                                      (I.CDPRODUTO = P.CDPRODUTO) AND
                                      (VRREDBCIMPOIT > 0)) LOOP
               DELETE ITEMPROIMPOS
               WHERE CDFILIAL     = P_FILIAL                AND
                     NRLANCTONF   = P_LANCTONF              AND
                     NRSEQITPROD  = C_PREDBCALC.NRSEQIMPOIT AND
                     CDIMPOSTO    = C_PREDBCALC.CDIMPOSTOIT AND
                     NRITPROIMPOS = W_2;
               /*VERIFICA CST POR IMPOSTO*/
               V_IMPOICMS := NULL;
               V_CDGRUPOFISCAUX := NULL;
               SELECT MAX(G.CDGRUPOFISC)
                 INTO V_CDGRUPOFISCAUX
                 FROM GRUPOFISCIMPFIL G,
                      (SELECT DECODE('E', 'E', CDFILIRECE, CDFILIEMIT) AS CDFILIAL
                         FROM NOTAFISCAL
                        WHERE CDFILIAL = P_FILIAL
                              AND NRLANCTONF = P_LANCTONF) F
                WHERE G.CDFILIAL = F.CDFILIAL
                  AND NOT G.CDGRUPOFISC IS NULL
                  AND G.CDIMPOSTO = C_PREDBCALC.CDIMPOSTOIT;
               IF V_IDORIGDESTNF = 'F' THEN
                  SELECT NVL(MAX(G.CDGRUPOFISC), V_CDGRUPOFISCAUX)
                    INTO V_CDGRUPOFISCAUX
                    FROM GRFISIMPIEFORN G,
                         (SELECT CDFORNECED
                            FROM NOTAFISCAL
                           WHERE CDFILIAL = P_FILIAL
                             AND NRLANCTONF = P_LANCTONF) N
                   WHERE G.CDFORNECED = N.CDFORNECED
                     AND G.CDEMPRESA = P_EMPRESA
                     AND G.CDINSCESTA = P_INSCESTA
                     AND NOT G.CDGRUPOFISC IS NULL
                     AND G.CDIMPOSTO = C_PREDBCALC.CDIMPOSTOIT;
               ELSE
                  SELECT NVL(MAX(G.CDGRUPOFISC), V_CDGRUPOFISCAUX)
                    INTO V_CDGRUPOFISCAUX
                    FROM GRFISIMPIECLIE G,
                         (SELECT CDCLIENTE
                            FROM NOTAFISCAL
                           WHERE CDFILIAL = P_FILIAL
                             AND NRLANCTONF = P_LANCTONF) N
                   WHERE G.CDCLIENTE = N.CDCLIENTE
                     AND G.CDEMPRESA = P_EMPRESA
                     AND G.CDINSCESTA = P_INSCESTA
                     AND NOT G.CDGRUPOFISC IS NULL
                     AND G.CDIMPOSTO = C_PREDBCALC.CDIMPOSTOIT;
               END IF;
               IF V_CDGRUPOFISCAUX IS NULL THEN
                  CONSULTA_CST_NFE(W_E, P_EMPRESA, C_PREDBCALC.CDARVPROD, P_INSCESTA, P_TIPOOPER, V_CDGRUPOFISC,C_PREDBCALC.CDIMPOSTOIT, V_IDINTEREST, V_IDINTERNAC, P_FILIAL, P_LANCTONF, '', V_CDSITTRIBTMP, V_IDMODBCNFE, V_IDMODBCSTNFE, V_CDTPCRPICOSTNFE, V_CDNATUBCPCSTNFE, V_IDMOTIDESSTNFE, C_PREDBCALC.IDORIGEMPROD);
               ELSE
                  CONSULTA_CST_NFE(W_E, P_EMPRESA, C_PREDBCALC.CDARVPROD, P_INSCESTA, P_TIPOOPER, V_CDGRUPOFISCAUX,C_PREDBCALC.CDIMPOSTOIT, V_IDINTEREST, V_IDINTERNAC, P_FILIAL, P_LANCTONF, '',V_CDSITTRIBTMP, V_IDMODBCNFE, V_IDMODBCSTNFE, V_CDTPCRPICOSTNFE, V_CDNATUBCPCSTNFE, V_IDMOTIDESSTNFE, C_PREDBCALC.IDORIGEMPROD);
               END IF;
               SELECT MAX(CDIMPOSTO)
                 INTO V_IMPOICMS
                 FROM IMPOSTONFE N, IMPOSTO I
                WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                  AND N.CDIMPOSTONFE = '00'
                  AND I.CDIMPOSTO = C_PREDBCALC.CDIMPOSTOIT;
               INSERT INTO ITEMPROIMPOS(
                  CDFILIAL, NRLANCTONF, NRSEQITPROD, CDIMPOSTO, NRITPROIMPOS, CDFISCALIT, CDSITUTRIBIT,
                  CDFISCOPERIT, CDSUFXCFOPIT, VRALIQITEM, VRPERREDBCIT, VRPARDEDIT, VRCONTITIMP,
                  VRBASECALCIT, VRIMPOSTOIT, IDERROSIMPIT, IDAVISIMPIT, CDSITUTRIBITNFE, IDMODBCITNFE, IDMODBCSTITNFE,
                  CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT, CDREGRAIT, CDCEST)
               VALUES(
                  P_FILIAL, P_LANCTONF, C_PREDBCALC.NRSEQIMPOIT, C_PREDBCALC.CDIMPOSTOIT, W_2, W_2,
                  C_PREDBCALC.CDSTRIBIMPOIT, C_PREDBCALC.CDFOPERIMPOIT, C_PREDBCALC.CDSCFOPIMPOIT, 0,
                  0, 0, ROUND(C_PREDBCALC.VRCONTIMPOIT - C_PREDBCALC.VRBCALCIMPOIT,5), 0, 0, W_00000, W_00000,
                  V_CDSITTRIBTMP, V_IDMODBCNFE, V_IDMODBCSTNFE, V_CDTPCRPICOSTNFE, V_CDNATUBCPCSTNFE, V_IDMOTIDESSTNFE, V_CDREGRAITALIQ, C_PREDBCALC.CDCEST);
               DELETE TRABITPROIMPOS
               WHERE CDFILIMPOIT  = P_FILIAL   AND
                     NRLANCIMPOIT = P_LANCTONF AND
                     NRSEQIMPOIT  = C_PREDBCALC.NRSEQIMPOIT AND
                     CDIMPOSTOIT  = C_PREDBCALC.CDIMPOSTOIT AND
                     NRSEQITPRO   = W_2;
               INSERT INTO TRABITPROIMPOS(
                  CDFILIMPOIT, NRLANCIMPOIT, NRSEQIMPOIT, CDIMPOSTOIT, NRSEQITPRO, CDFISCIMPOIT,
                  CDSTRIBIMPOIT, CDFOPERIMPOIT, CDSCFOPIMPOIT, VRALIQIMPOIT, VRREDBCIMPOIT, VRPDEDIMPOIT,
                  VRCONTIMPOIT, VRBCALCIMPOIT, VRIMPOSIT, IDERRIMPOIT, IDAVISIMPOIT, IDVALORINFO,
                  CDSTRIBITNFE, IDMODBCITEMNFE, IDMODBCSTITENFE, CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESOTRABIT, CDREGRATRABIT, CDCEST)
               VALUES(
                  P_FILIAL, P_LANCTONF, C_PREDBCALC.NRSEQIMPOIT, C_PREDBCALC.CDIMPOSTOIT, W_2, W_2,
                  C_PREDBCALC.CDSTRIBIMPOIT, C_PREDBCALC.CDFOPERIMPOIT, C_PREDBCALC.CDSCFOPIMPOIT, 0,
                  0, 0, ROUND(C_PREDBCALC.VRCONTIMPOIT - C_PREDBCALC.VRBCALCIMPOIT,5), 0, 0, W_00000, W_00000,
                  C_PREDBCALC.IDVALORINFO, V_CDSITTRIBTMP, V_IDMODBCNFE, V_IDMODBCSTNFE,
                  V_CDTPCRPICOSTNFE, V_CDNATUBCPCSTNFE, V_IDMOTIDESSTNFE, V_CDREGRAITALIQ, C_PREDBCALC.CDCEST);
            END LOOP;
         END IF;
         DELETE IMPOSTONF
         WHERE (CDFILIAL   = P_FILIAL)   AND
               (NRLANCTONF = P_LANCTONF);
         FOR C_IMPOSUBTRIB IN (SELECT NRSEQITPROD, CDIMPOSTO, IDTRIMPSTII
                               FROM ITEMPROIMPOS I
                               WHERE CDFILIAL     = V_FILIORIG  AND
                                     NRLANCTONF   = V_DEVOLORIG AND
                                     NRITPROIMPOS = W_1         AND
                                     EXISTS (SELECT CDIMPOSTO
                                             FROM IMPOSTO
                                             WHERE CDIMPOSTRIB = I.CDIMPOSTO)) LOOP
            UPDATE TRABITPROIMPOS
            SET IDTRIMPSTTI = C_IMPOSUBTRIB.IDTRIMPSTII
            WHERE CDFILIMPOIT  = P_FILIAL                  AND
                  NRLANCIMPOIT = P_LANCTONF                AND
                  NRSEQIMPOIT  = C_IMPOSUBTRIB.NRSEQITPROD AND
                  CDIMPOSTOIT  = C_IMPOSUBTRIB.CDIMPOSTO   AND
                  NRSEQITPRO   = W_1;
         END LOOP;
      ELSE
         SELECT NVL(SUM(VRTOTAITEM - VRDESCITEM),0) INTO V_TOTAPROD
         FROM ITEMPRODUTO
         WHERE CDFILIAL   = P_FILIAL   AND
               NRLANCTONF = P_LANCTONF;
      END IF;
   ELSE
      SELECT NVL(SUM(VRTOTAITEM - VRDESCITEM),0) INTO V_TOTAPROD
      FROM ITEMPRODUTO
      WHERE CDFILIAL   = P_FILIAL   AND
            NRLANCTONF = P_LANCTONF;
   END IF;
   IF P_TIPOOPER = '11' AND V_IDNFOUTRASNF = W_S THEN
      SELECT COUNT(*)
      INTO V_QTDEREGTRAB
      FROM TRABITPROIMPOS
      WHERE CDFILIMPOIT  = P_FILIAL   AND
            NRLANCIMPOIT = P_LANCTONF;
      IF V_QTDEREGTRAB = 0 THEN
         INSERT INTO TRABITPROIMPOS(
            CDFILIMPOIT, NRLANCIMPOIT, NRSEQIMPOIT, CDIMPOSTOIT, NRSEQITPRO, CDFISCIMPOIT, CDSTRIBIMPOIT,
            CDFOPERIMPOIT, CDSCFOPIMPOIT, VRALIQIMPOIT, VRREDBCIMPOIT, VRPDEDIMPOIT, VRCONTIMPOIT,
            VRBCALCIMPOIT, VRIMPOSIT, IDERRIMPOIT, IDAVISIMPOIT, IDVALORINFO,
            CDSTRIBITNFE, IDMODBCITEMNFE, IDMODBCSTITENFE,
            CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESOTRABIT, CDREGRATRABIT,
            VRPERDIFEREIT, VRIMPOSTOOPERAIT, VRIMPOSTODIFERIT, CDCEST)
            (SELECT CDFILIAL, NRLANCTONF, NRSEQITPROD, CDIMPOSTO, NRITPROIMPOS, CDFISCALIT, CDSITUTRIBIT,
                    CDFISCOPERIT, CDSUFXCFOPIT, VRALIQITEM, VRPERREDBCIT, VRPARDEDIT, ROUND(VRCONTITIMP,5) AS VRCONTITIMP,
                    ROUND(VRBASECALCIT, 2), VRIMPOSTOIT, IDERROSIMPIT, IDAVISIMPIT, NVL(IDVALORINFIT, W_N),
                    CDSITUTRIBITNFE, IDMODBCITNFE, IDMODBCSTITNFE,
                    CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT, CDREGRAIT,
                    VRPERDIFEREIT, VRIMPOSTOOPERAIT, VRIMPOSTODIFERIT, CDCEST
             FROM ITEMPROIMPOS
             WHERE CDFILIAL   = P_FILIAL   AND
                   NRLANCTONF = P_LANCTONF);
         FOR C_IMPOSNFTOT IN (
            SELECT /*+ index (IP,PK_ITEMPROIMPOS)*/
                   IP.CDIMPOSTO, CDIMPOSTOIT, ROUND(SUM(NVL(VRIMPOSIT,0)),V_NRDECITOTANF) AS VRIMPOSTOIT, NVL(SUM(VRBASECALCIT),0) AS VRBASECALCIT,
                   NVL(SUM(VRBCALCIMPOIT),0) AS VRBCALCIMPOIT, MAX(NVL(IDPREIMPENTR, W_N)) AS IDPREIMPENTR
            FROM ITEMPROIMPOS IP, TRABITPROIMPOS TI, IMPOSTO I
            WHERE (IP.CDFILIAL     = P_FILIAL)        AND
                  (IP.NRLANCTONF   = P_LANCTONF)      AND
                  (TI.CDFILIMPOIT  = IP.CDFILIAL)     AND
                  (TI.NRLANCIMPOIT = IP.NRLANCTONF)   AND
                  (TI.NRSEQIMPOIT  = IP.NRSEQITPROD)  AND
                  (TI.NRSEQITPRO   = IP.NRITPROIMPOS) AND
                  (TI.CDIMPOSTOIT  = IP.CDIMPOSTO)    AND
                  (I.CDIMPOSTO     = TI.CDIMPOSTOIT)  AND
                  (IP.NRITPROIMPOS = 1)
            GROUP BY IP.CDIMPOSTO, TI.CDIMPOSTOIT) LOOP
            INSERT INTO IMPOSNFTOT(CDFILIAL, NRLANCTONF, CDIMPOSTO, VRTOTIMPONF, VRTOTBCALCNF)
                           VALUES (P_FILIAL, P_LANCTONF, C_IMPOSNFTOT.CDIMPOSTO, NVL(C_IMPOSNFTOT.VRIMPOSTOIT,0), NVL(C_IMPOSNFTOT.VRBASECALCIT,0));
         END LOOP;
         DELETE TRABIMPOSNFTOT WHERE CDFILIMPTOT = P_FILIAL AND NRLANCIMPTOT = P_LANCTONF;
         INSERT INTO TRABIMPOSNFTOT(
            CDFILIMPTOT, NRLANCIMPTOT, CDIMPOSTOT, VRIMPOSTOT, VRBCALIMPTOT,
                    IDERROSTOT, IDAVISOSTOT)
            (SELECT CDFILIAL, NRLANCTONF, CDIMPOSTO, VRTOTIMPONF, VRTOTBCALCNF,
                    IDERROSIMPTT, IDAVISIMPTT
                     FROM IMPOSNFTOT
                     WHERE CDFILIAL   = P_FILIAL AND
                           NRLANCTONF = P_LANCTONF);
      END IF;
   END IF;
   /* Altera CFOP e CST para as tabelas NOTAFISCAL e ITEMPRODUTO para nfs de devolução e complemento */
   IF (V_IDOPERDEVONF = w_S) OR (P_TIPOOPER = '03') THEN
      FOR C_ITPROD IN (SELECT NRSEQITPROD
                         FROM ITEMPRODUTO
                        WHERE CDFILIAL = P_FILIAL
                          AND NRLANCTONF = P_LANCTONF)
      LOOP
         V_CDSITUTRIBIT := '';
         V_CDFISCOPERIT := '';
         V_CDSUFXCFOPIT := '';
         SELECT MAX(CDSTRIBIMPOIT), MAX(CDFOPERIMPOIT), MAX(CDSCFOPIMPOIT)
           INTO V_CDSITUTRIBIT, V_CDFISCOPERIT, V_CDSUFXCFOPIT
           FROM TRABITPROIMPOS
          WHERE CDFILIMPOIT = P_FILIAL
            AND NRLANCIMPOIT = P_LANCTONF
            AND NRSEQIMPOIT = C_ITPROD.NRSEQITPROD;
      UPDATE ITEMPRODUTO
         SET CDSITUTRIBPR = V_CDSITUTRIBIT,
             CDFISOPEITEM = V_CDFISCOPERIT,
             CDSUFXCFOPPR = V_CDSUFXCFOPIT
       WHERE CDFILIAL = P_FILIAL
         AND NRLANCTONF = P_LANCTONF
         AND NRSEQITPROD = C_ITPROD.NRSEQITPROD;
      END LOOP;
   END IF;
   V_DIFERENCA := 0;
   /* RATEIO DOS ENCARGOS PARA OS PRODUTOS DA NOTA. ESTE RATEIO É NECESSÁRIO PARA A NOTA FISCAL ELETRÔNICA */
   FOR C_ITEMENCARGO IN (SELECT ENCARGO.CDENCARGONFE, SUM(ITEMENCARGO.VRITEMENCA) AS VRITEMENCA
                           FROM ITEMENCARGO, ENCARGO
                          WHERE ITEMENCARGO.CDENCARGO = ENCARGO.CDENCARGO
                            AND ENCARGO.CDENCARGONFE IN ('01', '02', '03', '04', '05')
                            AND NVL(ITEMENCARGO.VRITEMENCA, 0) >= 0
                            AND CDFILIAL = P_FILIAL
                            AND NRLANCTONF = P_LANCTONF
                          GROUP BY ENCARGO.CDENCARGONFE) LOOP
      /* ENCARGO FRETE */
      IF (C_ITEMENCARGO.CDENCARGONFE = '01') THEN
         IF (C_ITEMENCARGO.VRITEMENCA > 0) THEN
            FOR C_ITEMPRODUTO IN (SELECT NRSEQITPROD, VRTOTAITEM
                                    FROM ITEMPRODUTO
                                   WHERE CDFILIAL = P_FILIAL
                                     AND NRLANCTONF = P_LANCTONF) LOOP
               SELECT ITEMPRODUTO.VRTOTAITEM,
                      TOTAL.SOMATOTAITEM,
                      DECODE(TOTAL.SOMATOTAITEM, 0, 0, ((100 * ITEMPRODUTO.VRTOTAITEM) / TOTAL.SOMATOTAITEM)) AS PERCENTITEM
                 INTO V_VRTOTAITEM, V_SOMATOTAITEM, V_PERCENTITEM
                 FROM ITEMPRODUTO, (SELECT CDFILIAL, NRLANCTONF, SUM(VRTOTAITEM) SOMATOTAITEM
                                      FROM ITEMPRODUTO
                                     WHERE CDFILIAL = P_FILIAL
                                       AND NRLANCTONF = P_LANCTONF
                                     GROUP BY CDFILIAL, NRLANCTONF) TOTAL
                WHERE ITEMPRODUTO.CDFILIAL = TOTAL.CDFILIAL
                  AND ITEMPRODUTO.NRLANCTONF = TOTAL.NRLANCTONF
                  AND ITEMPRODUTO.NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD;
               IF (V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV') THEN
                  UPDATE ITEMPRODUTO
                     SET VRFRETEITEM = TRUNC(C_ITEMENCARGO.VRITEMENCA * (V_PERCENTITEM / 100), 2)
                   WHERE CDFILIAL  = P_FILIAL
                     AND NRLANCTONF = P_LANCTONF
                     AND NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD;
               ELSE
                  UPDATE ITEMPRODUTO
                     SET VRFRETEITEM = ROUND(C_ITEMENCARGO.VRITEMENCA * (V_PERCENTITEM / 100), 2)
                   WHERE CDFILIAL  = P_FILIAL
                     AND NRLANCTONF = P_LANCTONF
                     AND NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD;
               END IF;
            END LOOP;
            /*AJUSTE DE VALORES*/
            SELECT SUM(VRFRETEITEM)
              INTO V_VRFRETEITEM
              FROM ITEMPRODUTO
             WHERE CDFILIAL = P_FILIAL
               AND NRLANCTONF = P_LANCTONF;
            V_DIFERENCA := C_ITEMENCARGO.VRITEMENCA - V_VRFRETEITEM;
            IF V_DIFERENCA <> 0 THEN
               UPDATE ITEMPRODUTO
                  SET VRFRETEITEM = VRFRETEITEM + V_DIFERENCA
                WHERE CDFILIAL = P_FILIAL
                  AND NRLANCTONF = P_LANCTONF
                  AND NRSEQITPROD = (SELECT MAX(NRSEQITPROD)
                                      FROM ITEMPRODUTO
                                      WHERE CDFILIAL = P_FILIAL
                                        AND NRLANCTONF = P_LANCTONF
                                        AND VRTOTAITEM = (SELECT MAX(VRTOTAITEM)
                                                           FROM ITEMPRODUTO
                                                          WHERE CDFILIAL = P_FILIAL
                                                            AND NRLANCTONF = P_LANCTONF));
            END IF;
         ELSE
            UPDATE ITEMPRODUTO
               SET VRFRETEITEM = 0
             WHERE CDFILIAL  = P_FILIAL
               AND NRLANCTONF = P_LANCTONF;
         END IF;
      END IF;
      /* ENCARGO SEGURO */
      IF (C_ITEMENCARGO.CDENCARGONFE = '02') THEN
         IF (C_ITEMENCARGO.VRITEMENCA > 0) THEN
            FOR C_ITEMPRODUTO IN (SELECT NRSEQITPROD, VRTOTAITEM
                                    FROM ITEMPRODUTO
                                   WHERE CDFILIAL = P_FILIAL
                                     AND NRLANCTONF = P_LANCTONF) LOOP
               SELECT ITEMPRODUTO.VRTOTAITEM,
                      TOTAL.SOMATOTAITEM,
                      DECODE(TOTAL.SOMATOTAITEM, 0, 0, ((100 * ITEMPRODUTO.VRTOTAITEM) / TOTAL.SOMATOTAITEM)) AS PERCENTITEM
                 INTO V_VRTOTAITEM, V_SOMATOTAITEM, V_PERCENTITEM
                 FROM ITEMPRODUTO, (SELECT CDFILIAL, NRLANCTONF, SUM(VRTOTAITEM) SOMATOTAITEM
                                      FROM ITEMPRODUTO
                                     WHERE CDFILIAL = P_FILIAL
                                       AND NRLANCTONF = P_LANCTONF
                                     GROUP BY CDFILIAL, NRLANCTONF) TOTAL
                WHERE ITEMPRODUTO.CDFILIAL = TOTAL.CDFILIAL
                  AND ITEMPRODUTO.NRLANCTONF = TOTAL.NRLANCTONF
                  AND ITEMPRODUTO.NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD;
               IF (V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV') THEN
                  UPDATE ITEMPRODUTO
                     SET VRSEGURITEM = TRUNC(C_ITEMENCARGO.VRITEMENCA * (V_PERCENTITEM / 100), 2)
                   WHERE CDFILIAL  = P_FILIAL
                     AND NRLANCTONF = P_LANCTONF
                     AND NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD;
               ELSE
                  UPDATE ITEMPRODUTO
                     SET VRSEGURITEM = ROUND(C_ITEMENCARGO.VRITEMENCA * (V_PERCENTITEM / 100), 2)
                   WHERE CDFILIAL  = P_FILIAL
                     AND NRLANCTONF = P_LANCTONF
                     AND NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD;
               END IF;
            END LOOP;
            /*AJUSTE DE VALORES*/
            SELECT SUM(VRSEGURITEM)
              INTO V_VRSEGURITEM
              FROM ITEMPRODUTO
             WHERE CDFILIAL = P_FILIAL
               AND NRLANCTONF = P_LANCTONF;
            V_DIFERENCA := C_ITEMENCARGO.VRITEMENCA - V_VRSEGURITEM;
            IF V_DIFERENCA <> 0 THEN
               UPDATE ITEMPRODUTO
                  SET VRSEGURITEM = VRSEGURITEM + V_DIFERENCA
                WHERE CDFILIAL = P_FILIAL
                  AND NRLANCTONF = P_LANCTONF
                  AND NRSEQITPROD = (SELECT MAX(NRSEQITPROD)
                                      FROM ITEMPRODUTO
                                      WHERE CDFILIAL = P_FILIAL
                                        AND NRLANCTONF = P_LANCTONF
                                        AND VRTOTAITEM = (SELECT MAX(VRTOTAITEM)
                                                           FROM ITEMPRODUTO
                                                          WHERE CDFILIAL = P_FILIAL
                                                            AND NRLANCTONF = P_LANCTONF));
            END IF;
         ELSE
            UPDATE ITEMPRODUTO
               SET VRSEGURITEM = 0
             WHERE CDFILIAL  = P_FILIAL
               AND NRLANCTONF = P_LANCTONF;
         END IF;
      END IF;
      /* ENCARGO DESCONTO */
      IF (C_ITEMENCARGO.CDENCARGONFE = '03') THEN
         IF (C_ITEMENCARGO.VRITEMENCA > 0) THEN
            FOR C_ITEMPRODUTO IN (SELECT NRSEQITPROD, VRTOTAITEM
                                    FROM ITEMPRODUTO
                                   WHERE CDFILIAL = P_FILIAL
                                     AND NRLANCTONF = P_LANCTONF) LOOP
               SELECT ITEMPRODUTO.VRTOTAITEM,
                      TOTAL.SOMATOTAITEM,
                      DECODE(TOTAL.SOMATOTAITEM, 0, 0, ((100 * ITEMPRODUTO.VRTOTAITEM) / TOTAL.SOMATOTAITEM)) AS PERCENTITEM
                 INTO V_VRTOTAITEM, V_SOMATOTAITEM, V_PERCENTITEM
                 FROM ITEMPRODUTO, (SELECT CDFILIAL, NRLANCTONF, SUM(VRTOTAITEM) SOMATOTAITEM
                                      FROM ITEMPRODUTO
                                     WHERE CDFILIAL = P_FILIAL
                                       AND NRLANCTONF = P_LANCTONF
                                     GROUP BY CDFILIAL, NRLANCTONF) TOTAL
                WHERE ITEMPRODUTO.CDFILIAL = TOTAL.CDFILIAL
                  AND ITEMPRODUTO.NRLANCTONF = TOTAL.NRLANCTONF
                  AND ITEMPRODUTO.NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD;
               IF (V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV') THEN
                  UPDATE ITEMPRODUTO
                     SET VRENCARGODESC = TRUNC(VRDESCITEM + (C_ITEMENCARGO.VRITEMENCA * (V_PERCENTITEM / 100)), 2)
                   WHERE CDFILIAL  = P_FILIAL
                     AND NRLANCTONF = P_LANCTONF
                     AND NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD;
               ELSE
                  UPDATE ITEMPRODUTO
                     SET VRENCARGODESC = ROUND(VRDESCITEM + (C_ITEMENCARGO.VRITEMENCA * (V_PERCENTITEM / 100)), 2)
                   WHERE CDFILIAL  = P_FILIAL
                     AND NRLANCTONF = P_LANCTONF
                     AND NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD;
               END IF;
            END LOOP;
            /*AJUSTE DE VALORES*/
            SELECT SUM(VRENCARGODESC)
              INTO V_VRENCARGODESC
              FROM ITEMPRODUTO
             WHERE CDFILIAL = P_FILIAL
               AND NRLANCTONF = P_LANCTONF;
            SELECT SUM(VRDESCITEM)
              INTO V_SUMVRDESCITEM
              FROM ITEMPRODUTO
             WHERE CDFILIAL  = P_FILIAL
               AND NRLANCTONF = P_LANCTONF;
            V_DIFERENCA := (C_ITEMENCARGO.VRITEMENCA+V_SUMVRDESCITEM) - V_VRENCARGODESC;
            IF V_DIFERENCA <> 0 THEN
               UPDATE ITEMPRODUTO
                  SET VRENCARGODESC = VRENCARGODESC + V_DIFERENCA
                WHERE CDFILIAL = P_FILIAL
                  AND NRLANCTONF = P_LANCTONF
                  AND NRSEQITPROD = (SELECT MAX(NRSEQITPROD)
                                      FROM ITEMPRODUTO
                                      WHERE CDFILIAL = P_FILIAL
                                        AND NRLANCTONF = P_LANCTONF
                                        AND VRTOTAITEM = (SELECT MAX(VRTOTAITEM)
                                                           FROM ITEMPRODUTO
                                                          WHERE CDFILIAL = P_FILIAL
                                                            AND NRLANCTONF = P_LANCTONF));
            END IF;
         ELSE
            UPDATE ITEMPRODUTO
               SET VRENCARGODESC = VRDESCITEM + 0
             WHERE CDFILIAL  = P_FILIAL
               AND NRLANCTONF = P_LANCTONF;
         END IF;
      END IF;
      /*ENCARGO OUTRAS DESPESAS*/
      IF (C_ITEMENCARGO.CDENCARGONFE = '04') THEN
         IF (C_ITEMENCARGO.VRITEMENCA > 0) THEN
            FOR C_ITEMPRODUTO IN (SELECT NRSEQITPROD, VRTOTAITEM
                                    FROM ITEMPRODUTO
                                   WHERE CDFILIAL = P_FILIAL
                                     AND NRLANCTONF = P_LANCTONF) LOOP
               SELECT ITEMPRODUTO.VRTOTAITEM,
                      TOTAL.SOMATOTAITEM,
                      DECODE(TOTAL.SOMATOTAITEM, 0, 0, ((100 * ITEMPRODUTO.VRTOTAITEM) / TOTAL.SOMATOTAITEM)) AS PERCENTITEM
                 INTO V_VRTOTAITEM, V_SOMATOTAITEM, V_PERCENTITEM
                 FROM ITEMPRODUTO, (SELECT CDFILIAL, NRLANCTONF, SUM(VRTOTAITEM) SOMATOTAITEM
                                      FROM ITEMPRODUTO
                                     WHERE CDFILIAL = P_FILIAL
                                       AND NRLANCTONF = P_LANCTONF
                                     GROUP BY CDFILIAL, NRLANCTONF) TOTAL
                WHERE ITEMPRODUTO.CDFILIAL = TOTAL.CDFILIAL
                  AND ITEMPRODUTO.NRLANCTONF = TOTAL.NRLANCTONF
                  AND ITEMPRODUTO.NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD;
               IF (V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV') THEN
                  UPDATE ITEMPRODUTO
                     SET VROUTRASDESPITEM = TRUNC((C_ITEMENCARGO.VRITEMENCA * (V_PERCENTITEM / 100)), 2)
                   WHERE CDFILIAL  = P_FILIAL
                     AND NRLANCTONF = P_LANCTONF
                     AND NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD;
               ELSE
                  UPDATE ITEMPRODUTO
                     SET VROUTRASDESPITEM = ROUND((C_ITEMENCARGO.VRITEMENCA * (V_PERCENTITEM / 100)), 2)
                   WHERE CDFILIAL  = P_FILIAL
                     AND NRLANCTONF = P_LANCTONF
                     AND NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD;
               END IF;
            END LOOP;
            /*AJUSTE DE VALORES*/
            SELECT SUM(VROUTRASDESPITEM)
              INTO V_VROUTRASDESPITEM
              FROM ITEMPRODUTO
             WHERE CDFILIAL = P_FILIAL
               AND NRLANCTONF = P_LANCTONF;
            V_DIFERENCA := C_ITEMENCARGO.VRITEMENCA - V_VROUTRASDESPITEM;
            IF V_DIFERENCA <> 0 THEN
               UPDATE ITEMPRODUTO
                  SET VROUTRASDESPITEM = VROUTRASDESPITEM + V_DIFERENCA
                WHERE CDFILIAL = P_FILIAL
                  AND NRLANCTONF = P_LANCTONF
                  AND NRSEQITPROD = (SELECT MAX(NRSEQITPROD)
                                      FROM ITEMPRODUTO
                                      WHERE CDFILIAL = P_FILIAL
                                        AND NRLANCTONF = P_LANCTONF
                                        AND VRTOTAITEM = (SELECT MAX(VRTOTAITEM)
                                                           FROM ITEMPRODUTO
                                                          WHERE CDFILIAL = P_FILIAL
                                                            AND NRLANCTONF = P_LANCTONF));
            END IF;
         ELSE
            UPDATE ITEMPRODUTO
               SET VROUTRASDESPITEM = 0
             WHERE CDFILIAL  = P_FILIAL
               AND NRLANCTONF = P_LANCTONF;
         END IF;
      END IF;
      /*ENCARGO DESPESAS ADUANEIRAS*/
      IF (C_ITEMENCARGO.CDENCARGONFE = '05') THEN
        /*REFAZ O RATEIO DO ENCARGO VERIFICANDO A INCIDENCIA DO IMPOSTO DE IMPORTACAO*/
         UPDATE ITEMPRODUTO
            SET VRDESPADUANEIRA = 0
          WHERE CDFILIAL  = P_FILIAL
            AND NRLANCTONF = P_LANCTONF;
         IF (C_ITEMENCARGO.VRITEMENCA > 0) THEN
            FOR C_ITEMPRODUTO IN (SELECT DISTINCT(I.NRSEQITPROD)
                                    FROM ITEMPROIMPOS I, IMPOSTO II
                                   WHERE I.NRLANCTONF    = P_LANCTONF
                                     AND I.CDFILIAL      = P_FILIAL
                                     AND I.CDIMPOSTO     = II.CDIMPOSTO
                                     AND II.CDIMPOSTONFE = '20') LOOP
               SELECT ITEMPRODUTO.VRTOTAITEM,
                      TOTAL.SOMATOTAITEM,
                      DECODE(TOTAL.SOMATOTAITEM, 0, 0, ((100 * ITEMPRODUTO.VRTOTAITEM) / TOTAL.SOMATOTAITEM)) AS PERCENTITEM
                 INTO V_VRTOTAITEM, V_SOMATOTAITEM, V_PERCENTITEM
                 FROM ITEMPRODUTO, (SELECT CDFILIAL, NRLANCTONF, SUM(VRTOTAITEM) SOMATOTAITEM
                                      FROM ITEMPRODUTO
                                     WHERE CDFILIAL = P_FILIAL
                                       AND NRLANCTONF = P_LANCTONF
                                     GROUP BY CDFILIAL, NRLANCTONF) TOTAL
                WHERE ITEMPRODUTO.CDFILIAL = TOTAL.CDFILIAL
                  AND ITEMPRODUTO.NRLANCTONF = TOTAL.NRLANCTONF
                  AND ITEMPRODUTO.NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD;
               IF (V_IDSISTEMA = 'VND') OR (V_IDSISTEMA = 'PDV') THEN
                  UPDATE ITEMPRODUTO
                     SET VRDESPADUANEIRA = TRUNC((C_ITEMENCARGO.VRITEMENCA * (V_PERCENTITEM / 100)), 2)
                   WHERE CDFILIAL  = P_FILIAL
                     AND NRLANCTONF = P_LANCTONF
                     AND NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD;
               ELSE
                  UPDATE ITEMPRODUTO
                     SET VRDESPADUANEIRA = ROUND((C_ITEMENCARGO.VRITEMENCA * (V_PERCENTITEM / 100)), 2)
                   WHERE CDFILIAL  = P_FILIAL
                     AND NRLANCTONF = P_LANCTONF
                     AND NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD;
               END IF;
            END LOOP;
            /*AJUSTE DE VALORES*/
            SELECT SUM(VRDESPADUANEIRA)
              INTO V_VRDESPADUANEIRA
              FROM ITEMPRODUTO
             WHERE CDFILIAL = P_FILIAL
               AND NRLANCTONF = P_LANCTONF;
            V_DIFERENCA := C_ITEMENCARGO.VRITEMENCA - V_VRDESPADUANEIRA;
            IF V_DIFERENCA <> 0 THEN
               UPDATE ITEMPRODUTO
                  SET VRDESPADUANEIRA = VRDESPADUANEIRA + V_DIFERENCA
                WHERE CDFILIAL = P_FILIAL
                  AND NRLANCTONF = P_LANCTONF
                  AND NRSEQITPROD = (SELECT MAX(II.NRSEQITPROD)
                                       FROM ITEMPRODUTO I, ITEMPROIMPOS II, IMPOSTO S
                                      WHERE I.CDFILIAL     = P_FILIAL
                                        AND I.NRLANCTONF   = P_LANCTONF
                                        AND I.CDFILIAL     = II.CDFILIAL
                                        AND I.NRLANCTONF   = II.NRLANCTONF
                                        AND I.NRSEQITPROD  = II.NRSEQITPROD
                                        AND II.CDIMPOSTO   = S.CDIMPOSTO
                                        AND S.CDIMPOSTONFE = '20'
                                        AND VRTOTAITEM = (SELECT MAX(VRTOTAITEM)
                                                            FROM ITEMPRODUTO I, ITEMPROIMPOS II, IMPOSTO S
                                                           WHERE I.CDFILIAL     = P_FILIAL
                                                             AND I.NRLANCTONF   = P_LANCTONF
                                                             AND I.CDFILIAL     = II.CDFILIAL
                                                             AND I.NRLANCTONF   = II.NRLANCTONF
                                                             AND I.NRSEQITPROD  = II.NRSEQITPROD
                                                             AND II.CDIMPOSTO   = S.CDIMPOSTO
                                                             AND S.CDIMPOSTONFE = '20'));
            END IF;
         ELSE
            UPDATE ITEMPRODUTO
               SET VRDESPADUANEIRA = 0
             WHERE CDFILIAL  = P_FILIAL
               AND NRLANCTONF = P_LANCTONF;
         END IF;
      END IF;
   END LOOP;
   --CÁLCULO DO VALOR TOTAL DA NOTA FISCAL
   SELECT SUM(VRITEMENCA) INTO V_SOMAENCA
   FROM ITEMENCARGO IE, ENCARGO EN
   WHERE IE.CDFILIAL   = P_FILIAL     AND
         IE.NRLANCTONF = P_LANCTONF   AND
         EN.CDENCARGO  = IE.CDENCARGO AND
         EN.IDENCARGO  = W_A;
   SELECT SUM(VRITEMENCA) INTO V_MENOENCA
   FROM ITEMENCARGO IE, ENCARGO EN
   WHERE IE.CDFILIAL   = P_FILIAL     AND
         IE.NRLANCTONF = P_LANCTONF   AND
         EN.CDENCARGO  = IE.CDENCARGO AND
         EN.IDENCARGO  = W_D;
   SELECT SUM(VRIMPOSTOT) INTO V_SOMAIMPO
   FROM TRABIMPOSNFTOT T, IMPOSTO I
   WHERE CDFILIMPTOT  = P_FILIAL     AND
         NRLANCIMPTOT = P_LANCTONF   AND
         I.CDIMPOSTO  = T.CDIMPOSTOT AND
         IDTRATIMPO   = W_A          AND
         NVL(IDACRPRODENTRNF, 'N') = 'N' AND
         NOT EXISTS(SELECT CDIMPOSTO
                    FROM IMPOSTO
                    WHERE IMPOSTO.CDIMPOSTRIB = T.CDIMPOSTOT);
   SELECT NVL(SUM(VRADICFECP), 0)
     INTO V_SOMAVRADICFECP
     FROM TRABITPROIMPOS T, IMPOSTO I
    WHERE T.CDFILIMPOIT  = P_FILIAL     AND
          T.NRLANCIMPOIT = P_LANCTONF   AND
          I.CDIMPOSTO  = T.CDIMPOSTOIT  AND
          IDTRATIMPO   = 'A'            AND
          NRSEQITPRO   = '1';
   V_SOMAIMPO := NVL(V_SOMAIMPO, 0) + V_SOMAVRADICFECP;
   SELECT SUM(VRIMPOSTOT) INTO V_MENOIMPO
   FROM TRABIMPOSNFTOT T, IMPOSTO I
   WHERE CDFILIMPTOT  = P_FILIAL     AND
         NRLANCIMPTOT = P_LANCTONF   AND
         I.CDIMPOSTO  = T.CDIMPOSTOT AND
         IDTRATIMPO   = W_D;
   IF NOT (V_LIQUIDO IS NULL) THEN
      V_TOTALNOTA := V_LIQUIDO;
   END IF;
   IF NOT (V_SOMAIMPO IS NULL) THEN
      V_TOTALNOTA := V_TOTALNOTA + ROUND(V_SOMAIMPO, 2);
   END IF;
   IF NOT (V_MENOIMPO IS NULL) THEN
      V_TOTALNOTA := V_TOTALNOTA - ROUND(V_MENOIMPO, 2);
   END IF;
   IF NOT (V_SOMAENCA IS NULL) THEN
      V_TOTALNOTA := V_TOTALNOTA + V_SOMAENCA;
   END IF;
   IF NOT (V_MENOENCA IS NULL) THEN
      V_TOTALNOTA := V_TOTALNOTA - V_MENOENCA;
   END IF;
   --VALOR SUBSTITUIÇÃO TRIBUTÁRIA COM IDENTIFICAÇÃO PARA ACRESCER AO TOTAL DA NF
   SELECT COUNT(*), NVL(SUM(ROUND(T.VRIMPOSIT, V_NRDECITOTANF)),0)
   INTO V_COUNT, V_SOMAIMPO
   FROM TRABITPROIMPOS T, IMPOSTO I
   WHERE T.CDFILIMPOIT  = P_FILIAL   AND
         T.NRLANCIMPOIT = P_LANCTONF AND
         NVL(T.IDTRIMPSTTI, '0')  = '0'        AND
         T.CDIMPOSTOIT    = I.CDIMPOSTO AND
         NVL(I.IDACRPRODENTRNF, 'N') = 'N' AND
         EXISTS(SELECT CDIMPOSTO
                FROM IMPOSTO
                WHERE CDIMPOSTRIB = T.CDIMPOSTOIT);
   IF NOT (V_SOMAIMPO IS NULL) THEN
      V_TOTALNOTA := V_TOTALNOTA + ROUND(V_SOMAIMPO, 2);
   END IF;
   -- Subtrai o valor dos importos a reter no valor da nota fiscal
   BEGIN
      SELECT SUM(VRIMPOSTOT)
        INTO V_VRIMPORETNF
        FROM TRABIMPOSNFTOT T, IMPOSTO I
       WHERE CDFILIMPTOT  = P_FILIAL
         AND NRLANCIMPTOT = P_LANCTONF
         AND I.CDIMPOSTO  = T.CDIMPOSTOT
         AND IDTRATIMPO   = 'R'
         AND IDDESCRFONTE = 'N';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_VRIMPORETNF := 0;
   END;
   IF NOT (V_VRIMPORETNF IS NULL) THEN
      V_TOTALNOTA := V_TOTALNOTA - ROUND(V_VRIMPORETNF, 2);
   END IF;
   IF (V_INTEGRACAO IS NULL) OR (P_ENTRSAID = W_E) THEN
      IF ((V_TOTALNOTA <> 0) AND (NVL(V_LIQUIDO,0) = 0)) THEN
         SELECT NVL(MAX(VRPRODUTOS),0)
         INTO V_VRPRODUTOS
         FROM NOTAFISCAL
         WHERE CDFILIAL   = P_FILIAL    AND
               NRLANCTONF = P_LANCTONF;
      ELSE
         V_VRPRODUTOS := NVL(V_LIQUIDO, 0);
         UPDATE NOTAFISCAL
         SET VRPRODUTOS = NVL(V_LIQUIDO, 0)
         WHERE CDFILIAL   = P_FILIAL    AND
               NRLANCTONF = P_LANCTONF;
      END IF;
   ELSE
      UPDATE NOTAFISCAL
      SET VRPRODUTOS = NVL(V_TOTAPROD, 0)
      WHERE CDFILIAL   = P_FILIAL    AND
            NRLANCTONF = P_LANCTONF;
   END IF;
   /* Cálculo do valor total da nf de importação*/
   IF (V_IDNFIMPORTACAO = 'S') THEN
      UPDATE NOTAFISCAL
         SET VRNOTAFISC = ROUND(V_TOTALNOTA, 2)
       WHERE CDFILIAL   = P_FILIAL    AND
             NRLANCTONF = P_LANCTONF;
      /*Chamar a procedure para gerar financeiro. */
      V_POSSUIFINANC := 0;
      V_IDUTILVENC   := 'N';
      SELECT NVL(IDUTILVENC, 'N')
        INTO V_IDUTILVENC
        FROM TIPOOPERAC
       WHERE CDTIPOOPER    = P_TIPOOPER
         AND IDENTRSAIDOP = 'E';
      IF (V_IDUTILVENC = 'S') THEN
         SELECT COUNT(*)
           INTO V_POSSUIFINANC
           FROM CONTAPAGAR
          WHERE CDFILIAL   = P_FILIAL
            AND NRLANCTONF = P_LANCTONF;
         IF NOT(V_POSSUIFINANC > 0) THEN
            GERA_DADOS_FINANCEIRO(P_FILIAL, P_LANCTONF, P_FILIAL, 'L', P_RESULTADO);
         END IF;
      END IF;
   END IF;
   CONSULTA_DESONERACAO(P_FILIAL, 
                        P_LANCTONF,
                        V_PAISDEST,
                        V_ESTADEST,
                        V_IMPOSDESONERA);
   IF V_IDIMPDESONERA = 'N' THEN
      P_VRNOTAFISC := ROUND(V_TOTALNOTA, 2);
      V_TOTALNOTA  := ROUND(V_TOTALNOTA, 2);
   ELSE
      P_VRNOTAFISC := ROUND(V_TOTALNOTA - V_IMPOSDESONERA, 2);
      V_TOTALNOTA  := ROUND(V_TOTALNOTA - V_IMPOSDESONERA, 2);
   END IF;
   V_TOTALNOTA := ROUND(V_TOTALNOTA, 2);
   P_VRNOTAFISC := V_TOTALNOTA;
   IF P_TIPOOPER = '08' THEN
      UPDATE NOTAFISCAL
      SET VRNOTAFISC = NVL(V_TOTALNOTA,0),
          VRPRODUTOS = NVL(V_LIQUIDO,0),
          IDERROS    = W_000
      WHERE CDFILIAL   = P_FILIAL    AND
            NRLANCTONF = P_LANCTONF;
   END IF;         
   IF (V_IDOPERDEVONF <> 'S') OR ((V_IDOPERDEVONF = W_S) AND (V_DEVOLORIG IS NULL)) THEN
      FOR C_VRIMPOSTO IN (SELECT II.CDIMPOSTOIT, SUM(II.VRIMPOSIT) AS VRIMPOSIT
                          FROM IMPOSTO I, TRABITPROIMPOS II
                          WHERE II.CDFILIMPOIT  = P_FILIAL        AND
                                II.NRLANCIMPOIT = P_LANCTONF      AND
                                II.NRSEQITPRO   = W_1             AND
                                I.CDIMPOSTO     = II.CDIMPOSTOIT  AND
                                ((I.IDTRATIMPO = W_A) OR (I.IDTRATIMPO = W_D))
                          GROUP BY II.CDIMPOSTOIT) LOOP
         BEGIN
            SELECT VRIMPOSTOT
            INTO V_VRTOTIMPONF
            FROM TRABIMPOSNFTOT
            WHERE CDIMPOSTOT   = C_VRIMPOSTO.CDIMPOSTOIT  AND
                  CDFILIMPTOT  = P_FILIAL                 AND
                  NRLANCIMPTOT = P_LANCTONF;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_VRTOTIMPONF := 0;
         END;
         V_VRDIFERENCA := V_VRTOTIMPONF - C_VRIMPOSTO.VRIMPOSIT;
         SELECT SUM(I.VRBRUTITEM)
         INTO V_VRBRUTO
         FROM ITEMPRODUTO I, TRABITPROIMPOS II
         WHERE I.CDFILIAL      = P_FILIAL      AND
               I.NRLANCTONF    = P_LANCTONF    AND
               II.CDFILIMPOIT  = I.CDFILIAL    AND
               II.NRLANCIMPOIT = I.NRLANCTONF  AND
               II.NRSEQIMPOIT  = I.NRSEQITPROD AND
               II.NRSEQITPRO   = W_1           AND
               II.CDIMPOSTOIT  = C_VRIMPOSTO.CDIMPOSTOIT;
         FOR C_ATUALIZA IN (SELECT NRSEQIMPOIT
                            FROM TRABITPROIMPOS
                            WHERE CDFILIMPOIT  = P_FILIAL                 AND
                                  NRLANCIMPOIT = P_LANCTONF               AND
                                  CDIMPOSTOIT  = C_VRIMPOSTO.CDIMPOSTOIT  AND
                                  NRSEQITPRO   = W_1
                            ORDER BY NRSEQIMPOIT) LOOP
            IF V_VRBRUTO > 0 THEN
               UPDATE ITEMPRODUTO
               SET VRBRUTITEM = VRBRUTITEM + ((VRBRUTITEM/V_VRBRUTO) * NVL(V_VRDIFERENCA,0))
               WHERE CDFILIAL    = P_FILIAL                AND
                     NRLANCTONF  = P_LANCTONF              AND
                     NRSEQITPROD = C_ATUALIZA.NRSEQIMPOIT;
            END IF;
         END LOOP;
      END LOOP;
      SELECT SUM(VRBRUTITEM)
      INTO V_VRBRUTO
      FROM ITEMPRODUTO
      WHERE CDFILIAL   = P_FILIAL AND
            NRLANCTONF = P_LANCTONF;
      BEGIN
         SELECT VRNOTAFISC
         INTO V_VRNOTAFISC
         FROM NOTAFISCAL
         WHERE CDFILIAL   = P_FILIAL AND
               NRLANCTONF = P_LANCTONF;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_VRNOTAFISC := 0;
      END;
      V_VRDIFERENCA := V_VRNOTAFISC - V_VRBRUTO;
      IF (V_VRDIFERENCA <> 0) AND (ABS(V_VRDIFERENCA) <= 0.05) THEN
         SELECT MAX(NRSEQITPROD)
         INTO V_NRSEQITPROD
         FROM ITEMPRODUTO
         WHERE CDFILIAL   = P_FILIAL   AND
               NRLANCTONF = P_LANCTONF AND
               VRBRUTITEM = (SELECT MAX(VRBRUTITEM)
                             FROM ITEMPRODUTO
                             WHERE CDFILIAL = P_FILIAL AND
                                   NRLANCTONF = P_LANCTONF);
         UPDATE ITEMPRODUTO
         SET VRBRUTITEM    = ROUND((VRBRUTITEM + V_VRDIFERENCA), 5)
         WHERE CDFILIAL    = P_FILIAL   AND
               NRLANCTONF  = P_LANCTONF AND
               NRSEQITPROD = V_NRSEQITPROD;
      END IF;
   -- RECALCULO DO VALOR CONTABIL DO ITEM
      IF (P_TIPOOPER <> '03') THEN
         UPDATE ITEMPRODUTO
            SET VRBRUTITEM = ROUND(VRBRUTITEM, 5)
          WHERE CDFILIAL   = P_FILIAL
            AND NRLANCTONF = P_LANCTONF;
         V_VRTOTBRUT := 0;
         V_VRTOTANF  := 0;
         V_DIFBRUTNF := 0;
         SELECT SUM(VRBRUTITEM)
           INTO V_VRTOTBRUT
           FROM ITEMPRODUTO
          WHERE CDFILIAL   = P_FILIAL
            AND NRLANCTONF = P_LANCTONF;
         IF V_VRTOTBRUT IS NULL THEN
            V_VRTOTBRUT := 0;
         END IF;
         IF V_VRNOTAFISC = 0 THEN
            IF (V_VRTOTBRUT <> ROUND(V_TOTALNOTA, 5)) THEN
               V_DIFBRUTNF :=  ROUND(V_TOTALNOTA, 5) - V_VRTOTBRUT;
               IF (ABS(V_DIFBRUTNF) <= 0.3) THEN
                  UPDATE ITEMPRODUTO
                     SET VRBRUTITEM = (VRBRUTITEM + (V_DIFBRUTNF))
                   WHERE CDFILIAL   = P_FILIAL
                     AND NRLANCTONF = P_LANCTONF
                     AND ROWNUM     = '1'
                     AND VRBRUTITEM = (SELECT MAX(VRBRUTITEM)
                                         FROM ITEMPRODUTO
                                        WHERE CDFILIAL   = P_FILIAL
                                          AND NRLANCTONF = P_LANCTONF);
               END IF;
            END IF;
         ELSE
            UPDATE NOTAFISCAL
               SET VRNOTAFISC = ROUND(VRNOTAFISC, 5)
             WHERE CDFILIAL   = P_FILIAL
               AND NRLANCTONF = P_LANCTONF;
            SELECT ROUND(VRNOTAFISC, 5)
              INTO V_VRTOTANF
              FROM NOTAFISCAL
             WHERE CDFILIAL   = P_FILIAL
               AND NRLANCTONF = P_LANCTONF;
            IF (V_VRTOTBRUT <> V_VRTOTANF) THEN
               V_DIFBRUTNF :=  V_VRTOTANF - V_VRTOTBRUT;
               IF (ABS(V_DIFBRUTNF) <= 0.3) THEN
                  UPDATE ITEMPRODUTO
                     SET VRBRUTITEM = (VRBRUTITEM + (V_DIFBRUTNF))
                   WHERE CDFILIAL   = P_FILIAL
                     AND NRLANCTONF = P_LANCTONF
                     AND ROWNUM     = '1'
                     AND VRBRUTITEM = (SELECT MAX(VRBRUTITEM)
                                         FROM ITEMPRODUTO
                                        WHERE CDFILIAL   = P_FILIAL
                                          AND NRLANCTONF = P_LANCTONF);
               END IF;
            END IF;
         END IF;
      END IF;
      FOR C_ITEMPRODUTO IN (SELECT ROUND(VRBRUTITEM,5) AS VRBRUTITEM, NRSEQITPROD
                            FROM ITEMPRODUTO I
                            WHERE CDFILIAL   = P_FILIAL   AND
                                  NRLANCTONF = P_LANCTONF) LOOP
         FOR C_ITEMPROIMPOS IN (
            SELECT CDIMPOSTOIT
            FROM TRABITPROIMPOS
            WHERE (CDFILIMPOIT  = P_FILIAL)                   AND
                  (NRLANCIMPOIT = P_LANCTONF)                 AND
                  (NRSEQIMPOIT  = C_ITEMPRODUTO.NRSEQITPROD)) LOOP
            UPDATE TRABITPROIMPOS
            SET VRCONTIMPOIT = ROUND(VRCONTIMPOIT,5)
            WHERE (CDFILIMPOIT  = P_FILIAL)                   AND
                  (NRLANCIMPOIT = P_LANCTONF)                 AND
                  (NRSEQIMPOIT  = C_ITEMPRODUTO.NRSEQITPROD)  AND
                  (CDIMPOSTOIT  = C_ITEMPROIMPOS.CDIMPOSTOIT) AND
                  (NRSEQITPRO   = W_2);
            SELECT MAX(NVL(VRCONTIMPOIT,0))
            INTO V_VRREDUCAO
            FROM TRABITPROIMPOS
            WHERE (CDFILIMPOIT  = P_FILIAL)                   AND
                  (NRLANCIMPOIT = P_LANCTONF)                 AND
                  (NRSEQIMPOIT  = C_ITEMPRODUTO.NRSEQITPROD)  AND
                  (CDIMPOSTOIT  = C_ITEMPROIMPOS.CDIMPOSTOIT) AND
                  (NRSEQITPRO   = W_2);
            IF V_VRREDUCAO IS NULL THEN
               V_VRREDUCAO := 0;
            END IF;
            UPDATE TRABITPROIMPOS
            SET VRCONTIMPOIT  = ROUND((C_ITEMPRODUTO.VRBRUTITEM - V_VRREDUCAO),5)
            WHERE CDFILIMPOIT  = P_FILIAL                   AND
                  NRLANCIMPOIT = P_LANCTONF                 AND
                  NRSEQIMPOIT  = C_ITEMPRODUTO.NRSEQITPROD  AND
                  CDIMPOSTOIT  = C_ITEMPROIMPOS.CDIMPOSTOIT AND
                  NRSEQITPRO   = W_1;
            UPDATE ITEMPROIMPOS
            SET VRCONTITIMP = ROUND((C_ITEMPRODUTO.VRBRUTITEM - V_VRREDUCAO),5)
            WHERE (NRLANCTONF   = P_LANCTONF)                 AND
                  (CDFILIAL     = P_FILIAL)                   AND
                  (NRSEQITPROD  = C_ITEMPRODUTO.NRSEQITPROD)  AND
                  (CDIMPOSTO    = C_ITEMPROIMPOS.CDIMPOSTOIT) AND
                  (NRITPROIMPOS = W_1);
            /*ESTE UPDATE ESTA SENDO REALIZADO PARA EVITAR QUE EXISTAM LANCAMENTOS COM BASE DE CÁLCULO E SEM IMPOSTO E SEM ALIQUOTA*/
            UPDATE TRABITPROIMPOS
            SET VRBCALCIMPOIT = 0
            WHERE CDFILIMPOIT  = P_FILIAL                   AND
                  NRLANCIMPOIT = P_LANCTONF                 AND
                  NRSEQIMPOIT  = C_ITEMPRODUTO.NRSEQITPROD  AND
                  CDIMPOSTOIT  = C_ITEMPROIMPOS.CDIMPOSTOIT AND
                  NRSEQITPRO   = W_1                        AND
                  CDFISCIMPOIT = W_1                        AND
                  VRALIQIMPOIT = 0.00                       AND
                  VRIMPOSIT = 0.00;
         END LOOP;
      END LOOP;
   END IF;
   ARREDONDA_BASECALC(W_E, P_FILIAL, P_LANCTONF);
   IF V_SEQUIMPOSTNF IS NULL THEN
      V_SEQUIMPOSTNF := '01';
   END IF;
   IF V_SEQUIMPOSTNF = '01' THEN
      DELETE IMPOSTONF
      WHERE (CDFILIAL = P_FILIAL) AND
            (NRLANCTONF = P_LANCTONF);
   END IF;
   FOR C_TRABITPROIMPOS IN (SELECT NRSEQITPROD, CDIMPOSTO, VRALIQITEM
                              FROM ITEMPROIMPOS
                             WHERE CDFILIAL = P_FILIAL
                               AND NRLANCTONF = P_LANCTONF
                               AND NRITPROIMPOS = '3') LOOP
      V_CDFILIREDU := NULL;
      SELECT MAX(CDFILIAL)
        INTO V_CDFILIREDU
        FROM ITEMPROIMPOS
       WHERE CDFILIAL = P_FILIAL
         AND NRLANCTONF = P_LANCTONF
         AND NRSEQITPROD = C_TRABITPROIMPOS.NRSEQITPROD
         AND CDIMPOSTO = C_TRABITPROIMPOS.CDIMPOSTO
         AND NRITPROIMPOS = '2';
      IF ((V_CDFILIREDU IS NULL) AND (NVL(V_IDORIGDESTNF, 'F') <> 'L')) THEN
         V_VRCONTITIMP := 0;
         SELECT MAX(VRCONTITIMP), MAX(VRIMPOSTOIT), MAX(VRALIQITEM)
           INTO V_VRCONTITIMP, V_IMPOSTOIT, V_ALIQINFO
           FROM ITEMPROIMPOS
          WHERE CDFILIAL = P_FILIAL
            AND NRLANCTONF = P_LANCTONF
            AND NRSEQITPROD = C_TRABITPROIMPOS.NRSEQITPROD
            AND CDIMPOSTO = C_TRABITPROIMPOS.CDIMPOSTO
            AND NRITPROIMPOS = '1';
         IF (V_IDCALCDIFENTFISC = 'N') THEN
            UPDATE TRABITPROIMPOS
               SET VRCONTIMPOIT  = V_VRCONTITIMP,
                   VRBCALCIMPOIT = ROUND(V_VRCONTITIMP, 2),
                   VRIMPOSIT     =  ROUND((V_VRCONTITIMP * (VRALIQIMPOIT / 100)), V_NRDECITOTANF)
             WHERE CDFILIMPOIT   = P_FILIAL
               AND NRLANCIMPOIT  = P_LANCTONF
               AND NRSEQIMPOIT   = C_TRABITPROIMPOS.NRSEQITPROD
               AND CDIMPOSTOIT   = C_TRABITPROIMPOS.CDIMPOSTO
               AND NRSEQITPRO    = '3';
            UPDATE ITEMPROIMPOS
               SET VRCONTITIMP  = V_VRCONTITIMP,
                   VRBASECALCIT = ROUND(V_VRCONTITIMP, 2) ,
                   VRIMPOSTOIT  = ROUND((V_VRCONTITIMP * (VRALIQITEM / 100)), V_NRDECITOTANF)
             WHERE CDFILIAL     = P_FILIAL
               AND NRLANCTONF   = P_LANCTONF
               AND NRSEQITPROD  = C_TRABITPROIMPOS.NRSEQITPROD
               AND CDIMPOSTO    = C_TRABITPROIMPOS.CDIMPOSTO
               AND NRITPROIMPOS = '3';
         ELSE
            V_ALIQDEST     := 0;
            V_ALIQDEST     := V_ALIQINFO + C_TRABITPROIMPOS.VRALIQITEM;
            V_BCALCDIFCOMP := ROUND(((V_VRCONTITIMP - V_IMPOSTOIT) / ((100 - V_ALIQDEST)/100)) , V_NRDECITOTANF);
            V_IMPOSTODIFE  := ROUND(((V_BCALCDIFCOMP * (V_ALIQDEST/100)) - V_IMPOSTOIT), V_NRDECITOTANF);
            UPDATE TRABITPROIMPOS
               SET VRCONTIMPOIT  = V_VRCONTITIMP,
                   VRBCALCIMPOIT = V_BCALCDIFCOMP,
                   VRIMPOSIT     = V_IMPOSTODIFE
             WHERE CDFILIMPOIT = P_FILIAL
               AND NRLANCIMPOIT = P_LANCTONF
               AND NRSEQIMPOIT = C_TRABITPROIMPOS.NRSEQITPROD
               AND CDIMPOSTOIT = C_TRABITPROIMPOS.CDIMPOSTO
               AND NRSEQITPRO   = '3';
            UPDATE ITEMPROIMPOS
               SET VRCONTITIMP  = V_VRCONTITIMP,
                   VRBASECALCIT = V_BCALCDIFCOMP,
                   VRIMPOSTOIT  = V_IMPOSTODIFE
             WHERE CDFILIAL = P_FILIAL
               AND NRLANCTONF = P_LANCTONF
               AND NRSEQITPROD = C_TRABITPROIMPOS.NRSEQITPROD
               AND CDIMPOSTO = C_TRABITPROIMPOS.CDIMPOSTO
               AND NRITPROIMPOS = '3';
         END IF;
      END IF;
      IF ((V_CDFILIREDU IS NULL) AND (NVL(V_IDORIGDESTNF, 'F') = 'L')) THEN
         V_VRCONTITIMP := 0;
         SELECT MAX(VRCONTITIMP)
           INTO V_VRCONTITIMP
           FROM ITEMPROIMPOS
          WHERE CDFILIAL = P_FILIAL
            AND NRLANCTONF = P_LANCTONF
            AND NRSEQITPROD = C_TRABITPROIMPOS.NRSEQITPROD
            AND CDIMPOSTO = C_TRABITPROIMPOS.CDIMPOSTO
            AND NRITPROIMPOS = '1';
         UPDATE TRABITPROIMPOS
            SET VRCONTIMPOIT = V_VRCONTITIMP
          WHERE CDFILIMPOIT = P_FILIAL
            AND NRLANCIMPOIT = P_LANCTONF
            AND NRSEQIMPOIT = C_TRABITPROIMPOS.NRSEQITPROD
            AND CDIMPOSTOIT = C_TRABITPROIMPOS.CDIMPOSTO
            AND NRSEQITPRO   = '3';
         UPDATE ITEMPROIMPOS
            SET VRCONTITIMP = V_VRCONTITIMP
          WHERE CDFILIAL = P_FILIAL
            AND NRLANCTONF = P_LANCTONF
            AND NRSEQITPROD = C_TRABITPROIMPOS.NRSEQITPROD
            AND CDIMPOSTO = C_TRABITPROIMPOS.CDIMPOSTO
            AND NRITPROIMPOS = '3';
      END IF;
   END LOOP;
   FOR C_TRABITPROIMPOS IN (SELECT CDIMPOSTO, VRALIQITEM, VRPERREDBCIT, VRPARDEDIT,
                                   CDFISCALIT, CDSITUTRIBIT, CDFISCOPERIT, CDSUFXCFOPIT,
                                   IDDIFALIQCUSPRI,
                                   SUM(VRCONTITIMP) AS VRCONTITIMP,
                                   SUM(VRBASECALCIT) AS VRBASECALCIT,
                                   SUM(VRIMPOSTOIT) AS VRIMPOSTOIT
                              FROM ITEMPROIMPOS
                             WHERE CDFILIAL = P_FILIAL
                               AND NRLANCTONF = P_LANCTONF
                               AND NRITPROIMPOS = '3'
                             GROUP BY CDIMPOSTO, VRALIQITEM, VRPERREDBCIT, VRPARDEDIT,
                                      CDFISCALIT, CDSITUTRIBIT, CDFISCOPERIT, CDSUFXCFOPIT,
                                      IDDIFALIQCUSPRI) LOOP
      UPDATE IMPOSTONF
         SET VRCONTABILNF = C_TRABITPROIMPOS.VRCONTITIMP,
             VRBASECALCNF = C_TRABITPROIMPOS.VRBASECALCIT,
             VRIMPOSTONF  = C_TRABITPROIMPOS.VRIMPOSTOIT
       WHERE CDFILIAL = P_FILIAL
         AND NRLANCTONF = P_LANCTONF
         AND CDIMPOSTO = C_TRABITPROIMPOS.CDIMPOSTO
         AND IDIMPOSTONF = '3'
         AND VRALIQNF = C_TRABITPROIMPOS.VRALIQITEM
         AND VRPERREDBCNF = C_TRABITPROIMPOS.VRPERREDBCIT
         AND VRPARDEDNF = C_TRABITPROIMPOS.VRPARDEDIT
         AND CDFISCALNF = C_TRABITPROIMPOS.CDFISCALIT
         AND CDSITUTRIBNF = C_TRABITPROIMPOS.CDSITUTRIBIT
         AND CDFISCOPERNF = C_TRABITPROIMPOS.CDFISCOPERIT
         AND NVL(IDDIFALIQCUSPRN, 'N') = NVL(C_TRABITPROIMPOS.IDDIFALIQCUSPRI, 'N')
         AND NVL(CDSUFXCFOPNF, 'N') = NVL(C_TRABITPROIMPOS.CDSUFXCFOPIT, 'N');
   END LOOP;
   FOR C_IMPOSTONF IN (
      SELECT IT.CDIMPOSTOIT, VRALIQIMPOIT, VRREDBCIMPOIT, VRPDEDIMPOIT, CDFISCIMPOIT,
             CDSTRIBIMPOIT, CDFOPERIMPOIT, CDSCFOPIMPOIT, NRSEQITPRO, SUM(VRCONTIMPOIT) AS VRCONTIMPOIT,
             SUM(VRBCALCIMPOIT) AS VRBCALCIMPOIT, SUM(VRIMPOSIT) AS VRIMPOSIT, I.IDTRATIMPO,
             SUM(VRIMPOSIT) AS VRIMPOSCONT, NVL(IDDIFALIQCUSPTI, 'N') IDDIFALIQCUSPTI,
             IDMOTDESOTRABIT
      FROM TRABITPROIMPOS IT, IMPOSTO I, NOTAFISCAL N
      WHERE (IT.CDFILIMPOIT  = P_FILIAL)    AND
            (IT.NRLANCIMPOIT = P_LANCTONF)  AND
            (IT.CDFILIMPOIT  = N.CDFILIAL)    AND
            (IT.NRLANCIMPOIT = N.NRLANCTONF)  AND
            (N.CDTIPOOPER    <> '03')         AND
            (I.CDIMPOSTO  = CDIMPOSTOIT) AND
            ((((CDFISCIMPOIT = W_1)) AND (IDIMPORECUP = W_S)) OR
             ((IDIMPORECUP <> W_S) AND (VRIMPOSIT <> 0)) OR (NRSEQITPRO = W_3)) AND
            IT.VRCONTIMPOIT > 0
      GROUP BY IT.CDIMPOSTOIT, VRALIQIMPOIT, VRREDBCIMPOIT, VRPDEDIMPOIT, CDFISCIMPOIT,
               CDSTRIBIMPOIT, CDFOPERIMPOIT, CDSCFOPIMPOIT, NRSEQITPRO, I.IDTRATIMPO,
               NVL(IDDIFALIQCUSPTI, 'N'), IDMOTDESOTRABIT
      UNION
      SELECT IT.CDIMPOSTOIT, 0 AS VRALIQIMPOIT, 0 AS VRREDBCIMPOIT, 0 AS VRPDEDIMPOIT, CDFISCIMPOIT,
             CDSTRIBIMPOIT, CDFOPERIMPOIT, CDSCFOPIMPOIT, NRSEQITPRO, SUM(VRCONTIMPOIT) AS VRCONTIMPOIT,
             0 AS VRBCALCIMPOIT, 0 AS VRIMPOSIT, I.IDTRATIMPO,
             SUM(VRIMPOSIT) AS VRIMPOSCONT, NVL(IDDIFALIQCUSPTI, 'N') IDDIFALIQCUSPTI,
             IDMOTDESOTRABIT
      FROM TRABITPROIMPOS IT, IMPOSTO I, NOTAFISCAL N
      WHERE (CDFILIMPOIT  = P_FILIAL)    AND
            (NRLANCIMPOIT = P_LANCTONF)  AND
            (IT.CDFILIMPOIT  = N.CDFILIAL)    AND
            (IT.NRLANCIMPOIT = N.NRLANCTONF)  AND
            (N.CDTIPOOPER    <> '03')         AND
            (I.CDIMPOSTO  = CDIMPOSTOIT) AND
            (NRSEQITPRO   <> W_3)        AND
            ((((CDFISCIMPOIT <> W_1)) AND (IDIMPORECUP = W_S)) OR
             ((IDIMPORECUP  <> W_S) AND (VRIMPOSIT = 0))) AND
            IT.VRCONTIMPOIT > 0
      GROUP BY IT.CDIMPOSTOIT, CDFISCIMPOIT, CDSTRIBIMPOIT,
               CDFOPERIMPOIT, CDSCFOPIMPOIT, NRSEQITPRO, I.IDTRATIMPO,
               NVL(IDDIFALIQCUSPTI, 'N'), IDMOTDESOTRABIT
      UNION
      SELECT IT.CDIMPOSTOIT, VRALIQIMPOIT, VRREDBCIMPOIT, VRPDEDIMPOIT, CDFISCIMPOIT,
             CDSTRIBIMPOIT, CDFOPERIMPOIT, CDSCFOPIMPOIT, NRSEQITPRO, SUM(VRCONTIMPOIT) AS VRCONTIMPOIT,
             SUM(VRBCALCIMPOIT) AS VRBCALCIMPOIT, SUM(VRIMPOSIT) AS VRIMPOSIT, I.IDTRATIMPO,
             SUM(VRIMPOSIT) AS VRIMPOSCONT, NVL(IDDIFALIQCUSPTI, 'N') IDDIFALIQCUSPTI,
             IDMOTDESOTRABIT
      FROM TRABITPROIMPOS IT, IMPOSTO I, NOTAFISCAL N
      WHERE (IT.CDFILIMPOIT  = P_FILIAL)    AND
            (IT.NRLANCIMPOIT = P_LANCTONF)  AND
            (IT.CDFILIMPOIT  = N.CDFILIAL)    AND
            (IT.NRLANCIMPOIT = N.NRLANCTONF)  AND
            (N.CDTIPOOPER    = '03')         AND
            (I.CDIMPOSTO  = CDIMPOSTOIT) AND
            ((((CDFISCIMPOIT = W_1)) AND (IDIMPORECUP = W_S)) OR
             ((IDIMPORECUP <> W_S) AND (VRIMPOSIT <> 0)) OR (NRSEQITPRO = W_3))
      GROUP BY IT.CDIMPOSTOIT, VRALIQIMPOIT, VRREDBCIMPOIT, VRPDEDIMPOIT, CDFISCIMPOIT,
               CDSTRIBIMPOIT, CDFOPERIMPOIT, CDSCFOPIMPOIT, NRSEQITPRO, I.IDTRATIMPO,
               NVL(IDDIFALIQCUSPTI, 'N'), IDMOTDESOTRABIT
      UNION
      SELECT IT.CDIMPOSTOIT, 0 AS VRALIQIMPOIT, 0 AS VRREDBCIMPOIT, 0 AS VRPDEDIMPOIT, CDFISCIMPOIT,
             CDSTRIBIMPOIT, CDFOPERIMPOIT, CDSCFOPIMPOIT, NRSEQITPRO, SUM(VRCONTIMPOIT) AS VRCONTIMPOIT,
             0 AS VRBCALCIMPOIT, 0 AS VRIMPOSIT, I.IDTRATIMPO,
             SUM(VRIMPOSIT) AS VRIMPOSCONT, NVL(IDDIFALIQCUSPTI, 'N') IDDIFALIQCUSPTI,
             IDMOTDESOTRABIT
      FROM TRABITPROIMPOS IT, IMPOSTO I, NOTAFISCAL N
      WHERE (IT.CDFILIMPOIT  = P_FILIAL)    AND
            (IT.NRLANCIMPOIT = P_LANCTONF)  AND
            (IT.CDFILIMPOIT  = N.CDFILIAL)    AND
            (IT.NRLANCIMPOIT = N.NRLANCTONF)  AND
            (N.CDTIPOOPER    = '03')         AND
            (I.CDIMPOSTO  = CDIMPOSTOIT) AND
            (NRSEQITPRO   <> W_3)        AND
            ((((CDFISCIMPOIT <> W_1)) AND (IDIMPORECUP = W_S)) OR
             ((IDIMPORECUP  <> W_S) AND (VRIMPOSIT = 0)))
      GROUP BY IT.CDIMPOSTOIT, CDFISCIMPOIT, CDSTRIBIMPOIT,
               CDFOPERIMPOIT, CDSCFOPIMPOIT, NRSEQITPRO, I.IDTRATIMPO,
               NVL(IDDIFALIQCUSPTI, 'N'), IDMOTDESOTRABIT
      UNION
      SELECT IT.CDIMPOSTOIT, VRALIQIMPOIT, VRREDBCIMPOIT, VRPDEDIMPOIT, CDFISCIMPOIT,
             CDSTRIBIMPOIT, CDFOPERIMPOIT, CDSCFOPIMPOIT, NRSEQITPRO, SUM(VRCONTIMPOIT) AS VRCONTIMPOIT,
             SUM(VRBCALCIMPOIT) AS VRBCALCIMPOIT, SUM(VRIMPOSIT) AS VRIMPOSIT, I.IDTRATIMPO,
             SUM(VRIMPOSIT) AS VRIMPOSCONT, NVL(IDDIFALIQCUSPTI, 'N') IDDIFALIQCUSPTI,
             IDMOTDESOTRABIT
      FROM TRABITPROIMPOS IT, IMPOSTO I, NOTAFISCAL N, TIPOOPERAC T
      WHERE (IT.CDFILIMPOIT  = P_FILIAL)    AND
            (IT.NRLANCIMPOIT = P_LANCTONF)  AND
            (IT.CDFILIMPOIT  = N.CDFILIAL)    AND
            (IT.NRLANCIMPOIT = N.NRLANCTONF)  AND
            (N.CDTIPOOPER    = T.CDTIPOOPER)  AND
            (N.IDENTRSAIDOP  = T.IDENTRSAIDOP) AND
            (T.IDNFAJUSTE    = 'S')           AND
            (I.CDIMPOSTO  = CDIMPOSTOIT) AND
            ((((CDFISCIMPOIT = W_1)) AND (IDIMPORECUP = W_S)) OR
             ((IDIMPORECUP <> W_S) AND (VRIMPOSIT <> 0)) OR (NRSEQITPRO = W_3))
      GROUP BY IT.CDIMPOSTOIT, VRALIQIMPOIT, VRREDBCIMPOIT, VRPDEDIMPOIT, CDFISCIMPOIT,
               CDSTRIBIMPOIT, CDFOPERIMPOIT, CDSCFOPIMPOIT, NRSEQITPRO, I.IDTRATIMPO,
               NVL(IDDIFALIQCUSPTI, 'N'), IDMOTDESOTRABIT
      UNION
      SELECT IT.CDIMPOSTOIT, 0 AS VRALIQIMPOIT, 0 AS VRREDBCIMPOIT, 0 AS VRPDEDIMPOIT, CDFISCIMPOIT,
             CDSTRIBIMPOIT, CDFOPERIMPOIT, CDSCFOPIMPOIT, NRSEQITPRO, SUM(VRCONTIMPOIT) AS VRCONTIMPOIT,
             0 AS VRBCALCIMPOIT, 0 AS VRIMPOSIT, I.IDTRATIMPO,
             SUM(VRIMPOSIT) AS VRIMPOSCONT, NVL(IDDIFALIQCUSPTI, 'N') IDDIFALIQCUSPTI,
             IDMOTDESOTRABIT
      FROM TRABITPROIMPOS IT, IMPOSTO I, NOTAFISCAL N, TIPOOPERAC T
      WHERE (IT.CDFILIMPOIT  = P_FILIAL)    AND
            (IT.NRLANCIMPOIT = P_LANCTONF)  AND
            (IT.CDFILIMPOIT  = N.CDFILIAL)    AND
            (IT.NRLANCIMPOIT = N.NRLANCTONF)  AND
            (N.CDTIPOOPER    = T.CDTIPOOPER)  AND
            (N.IDENTRSAIDOP  = T.IDENTRSAIDOP) AND
            (T.IDNFAJUSTE    = 'S')           AND
            (I.CDIMPOSTO  = CDIMPOSTOIT) AND
            (NRSEQITPRO   <> W_3)        AND
            ((((CDFISCIMPOIT <> W_1)) AND (IDIMPORECUP = W_S)) OR
             ((IDIMPORECUP  <> W_S) AND (VRIMPOSIT = 0)))
      GROUP BY IT.CDIMPOSTOIT, CDFISCIMPOIT, CDSTRIBIMPOIT,
               CDFOPERIMPOIT, CDSCFOPIMPOIT, NRSEQITPRO, I.IDTRATIMPO,
               NVL(IDDIFALIQCUSPTI, 'N'), IDMOTDESOTRABIT) LOOP
      BEGIN
         SELECT IDFORMAPUR
         INTO V_IDFORMAPUR
         FROM IMPOSTO
         WHERE CDIMPOSTO = C_IMPOSTONF.CDIMPOSTOIT;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_IDFORMAPUR := NULL;
      END;
      V_VRIMPOSCONT := 0;
      IF C_IMPOSTONF.IDTRATIMPO = W_A THEN
         V_VRIMPOSCONT := C_IMPOSTONF.VRIMPOSCONT;
      ELSIF C_IMPOSTONF.IDTRATIMPO = W_D THEN
         V_VRIMPOSCONT := - C_IMPOSTONF.VRIMPOSCONT;
      END IF;
      IF V_IDFORMAPUR = W_P THEN
         INSERT INTO IMPOSTONF(
            CDFILIAL, NRLANCTONF, CDIMPOSTO, NRIMPOSNF, VRCONTABILNF, VRPERREDBCNF, VRBASECALCNF,
            VRALIQNF, VRPARDEDNF, VRIMPOSTONF, CDFISCALNF, CDSITUTRIBNF, CDFISCOPERNF, CDSUFXCFOPNF,
            IDIMPOSTONF, IDDIFALIQCUSPRN, CDTPCREDPICONF, CDNATUBCALPCNF, IDMOTDESONERANF)
         VALUES(
            P_FILIAL, P_LANCTONF, C_IMPOSTONF.CDIMPOSTOIT, V_SEQUIMPOSTNF, ROUND(C_IMPOSTONF.VRCONTIMPOIT,5),
            C_IMPOSTONF.VRREDBCIMPOIT, C_IMPOSTONF.VRBCALCIMPOIT, C_IMPOSTONF.VRALIQIMPOIT,
            C_IMPOSTONF.VRPDEDIMPOIT, C_IMPOSTONF.VRIMPOSIT, C_IMPOSTONF.CDFISCIMPOIT,
            C_IMPOSTONF.CDSTRIBIMPOIT, C_IMPOSTONF.CDFOPERIMPOIT, C_IMPOSTONF.CDSCFOPIMPOIT,
            C_IMPOSTONF.NRSEQITPRO, C_IMPOSTONF.IDDIFALIQCUSPTI, V_CDTPCRPICOSTNFE, V_CDNATUBCPCSTNFE, C_IMPOSTONF.IDMOTDESOTRABIT);
         V_SEQUIMPOSTNF := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_SEQUIMPOSTNF) + 1)),2,0);
      ELSE
         V_CDGRUPOFISCAUX := NULL;
         SELECT MAX(G.CDGRUPOFISC)
           INTO V_CDGRUPOFISCAUX
           FROM GRUPOFISCIMPFIL G,
                (SELECT DECODE('E', 'E', CDFILIRECE, CDFILIEMIT) AS CDFILIAL
                   FROM NOTAFISCAL
                  WHERE CDFILIAL = P_FILIAL
                        AND NRLANCTONF = P_LANCTONF) F
          WHERE G.CDFILIAL = F.CDFILIAL
            AND NOT G.CDGRUPOFISC IS NULL
            AND G.CDIMPOSTO = C_IMPOSTONF.CDIMPOSTOIT;
         IF V_IDORIGDESTNF = 'F' THEN
            SELECT NVL(MAX(G.CDGRUPOFISC), V_CDGRUPOFISCAUX)
              INTO V_CDGRUPOFISCAUX
              FROM GRFISIMPIEFORN G,
                   (SELECT CDFORNECED
                      FROM NOTAFISCAL
                     WHERE CDFILIAL = P_FILIAL
                       AND NRLANCTONF = P_LANCTONF) N
             WHERE G.CDFORNECED = N.CDFORNECED
               AND G.CDEMPRESA = P_EMPRESA
               AND G.CDINSCESTA = P_INSCESTA
               AND NOT G.CDGRUPOFISC IS NULL
               AND G.CDIMPOSTO = C_IMPOSTONF.CDIMPOSTOIT;
         ELSE
            SELECT NVL(MAX(G.CDGRUPOFISC), V_CDGRUPOFISCAUX)
              INTO V_CDGRUPOFISCAUX
              FROM GRFISIMPIECLIE G,
                   (SELECT CDCLIENTE
                      FROM NOTAFISCAL
                     WHERE CDFILIAL = P_FILIAL
                       AND NRLANCTONF = P_LANCTONF) N
             WHERE G.CDCLIENTE = N.CDCLIENTE
               AND G.CDEMPRESA = P_EMPRESA
               AND G.CDINSCESTA = P_INSCESTA
               AND NOT G.CDGRUPOFISC IS NULL
               AND G.CDIMPOSTO = C_IMPOSTONF.CDIMPOSTOIT;
         END IF;
         IF V_CDGRUPOFISCAUX IS NULL THEN
            CONSULTA_CST_NFE(W_E, P_EMPRESA, '', P_INSCESTA, P_TIPOOPER, V_CDGRUPOFISC,C_IMPOSTONF.CDIMPOSTOIT, V_IDINTEREST, V_IDINTERNAC, P_FILIAL, P_LANCTONF, '', V_CDSITTRIBTMP, V_IDMODBCNFE, V_IDMODBCSTNFE, V_CDTPCRPICOSTNFE, V_CDNATUBCPCSTNFE, V_IDMOTIDESSTNFE);
         ELSE
            CONSULTA_CST_NFE(W_E, P_EMPRESA, '', P_INSCESTA, P_TIPOOPER, V_CDGRUPOFISCAUX,C_IMPOSTONF.CDIMPOSTOIT, V_IDINTEREST, V_IDINTERNAC, P_FILIAL, P_LANCTONF, '', V_CDSITTRIBTMP, V_IDMODBCNFE, V_IDMODBCSTNFE, V_CDTPCRPICOSTNFE, V_CDNATUBCPCSTNFE, V_IDMOTIDESSTNFE);
         END IF;
         INSERT INTO IMPOSTONF(
            CDFILIAL, NRLANCTONF, CDIMPOSTO, NRIMPOSNF, VRCONTABILNF, VRPERREDBCNF, VRBASECALCNF,
            VRALIQNF, VRPARDEDNF, VRIMPOSTONF, CDFISCALNF, CDSITUTRIBNF, CDFISCOPERNF, CDSUFXCFOPNF,
            IDIMPOSTONF, IDDIFALIQCUSPRN, CDTPCREDPICONF, CDNATUBCALPCNF, IDMOTDESONERANF)
         VALUES(
            P_FILIAL, P_LANCTONF, C_IMPOSTONF.CDIMPOSTOIT, V_SEQUIMPOSTNF, ROUND(C_IMPOSTONF.VRCONTIMPOIT,5),
            C_IMPOSTONF.VRREDBCIMPOIT, C_IMPOSTONF.VRBCALCIMPOIT, C_IMPOSTONF.VRALIQIMPOIT,
            C_IMPOSTONF.VRPDEDIMPOIT, C_IMPOSTONF.VRIMPOSIT, C_IMPOSTONF.CDFISCIMPOIT,
            C_IMPOSTONF.CDSTRIBIMPOIT, C_IMPOSTONF.CDFOPERIMPOIT, C_IMPOSTONF.CDSCFOPIMPOIT,
            C_IMPOSTONF.NRSEQITPRO, C_IMPOSTONF.IDDIFALIQCUSPTI, V_CDTPCRPICOSTNFE, V_CDNATUBCPCSTNFE, C_IMPOSTONF.IDMOTDESOTRABIT);
         V_SEQUIMPOSTNF := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_SEQUIMPOSTNF) + 1)),2,0);
      END IF;
   END LOOP;
   FOR C_IMPOSTORETI IN (SELECT P_EMPRESA AS CDEMPRESA, I.CDIMPOSTO, V_IDTPIJURNF AS IDTPIJURNF,
                                V_NRINSJURNF AS NRINSJURNF, V_DTENTRSAID AS DTENTRSAID
                         FROM IMPOSTO I, IMPOSTONF IP
                         WHERE I.IDTRATIMPO   = W_R          AND
                               I.IDUTVRMENSBC = W_S          AND
                               IP.CDFILIAL    = P_FILIAL     AND
                               IP.NRLANCTONF  = P_LANCTONF   AND
                               I.CDIMPOSTO    = IP.CDIMPOSTO
                         GROUP BY
                            P_EMPRESA, I.CDIMPOSTO, V_IDTPIJURNF, V_NRINSJURNF, V_DTENTRSAID) LOOP
      BASECALC_RETIDO('S', P_FILIAL, P_LANCTONF, C_IMPOSTORETI.IDTPIJURNF, C_IMPOSTORETI.NRINSJURNF,
                      C_IMPOSTORETI.DTENTRSAID,  C_IMPOSTORETI.CDIMPOSTO, W_E, C_IMPOSTORETI.CDEMPRESA,
                      P_INSCESTA, V_PAISORIG, V_ESTAORIG, V_PAISDEST, V_ESTADEST, V_CDGRUPOFISC, V_CDGRPFISCSV, P_TIPOOPER);
   END LOOP;
   /* SE O IPI COMPOR A BASE DE CALCULO DO ICMS E O ICMS TIVER O CODIGO FISCAL IGUAL A 1 SERA ATUALIZADO COM O IDENTIFICADOR 4 */
   FOR C_IMPFISC IN (SELECT CDFILIAL, NRLANCTONF, CDIMPOSTO, CDSITUTRIBNF, CDFISCOPERNF, CDFISCALNF
                       FROM IMPOSTONF IP
                      WHERE IP.CDFILIAL = P_FILIAL
                        AND IP.NRLANCTONF = P_LANCTONF
                        AND IP.IDIMPOSTONF = W_1
                        AND IP.CDFISCALNF = W_1) LOOP
      SELECT MAX(BC.CDIMPOBCALC) AS CDIMPOBCALC
        INTO V_CDIMPOBCALC
        FROM BASECALCTPOPER BC
       WHERE BC.IDENTRSAIDOP = P_ENTRSAID
         AND BC.CDTIPOOPER = P_TIPOOPER
         AND BC.CDIMPOSTO = C_IMPFISC.CDIMPOSTO
         AND BC.CDIMPOBCALC IS NOT NULL
         AND ((SUBSTR(C_IMPFISC.CDSITUTRIBNF,2,2)  = BC.CDCSTIMPOTPOP)  OR (BC.CDCSTIMPOTPOP IS NULL))
         AND ((SUBSTR(C_IMPFISC.CDFISCOPERNF,2,10) = BC.CDCFOPIMPOTPOP) OR (BC.CDCFOPIMPOTPOP IS NULL))
         AND (C_IMPFISC.CDFISCALNF = BC.CDFISCIMPOTPOP) OR (BC.CDFISCIMPOTPOP IS NULL);
      IF V_CDIMPOBCALC IS NULL THEN
         SELECT MAX(BC.CDIMPOBCALC) AS CDIMPOBCALC
           INTO V_CDIMPOBCALC
           FROM BASECALC BC
          WHERE BC.CDIMPOSTO = C_IMPFISC.CDIMPOSTO
            AND BC.CDIMPOBCALC IS NOT NULL
            AND ((SUBSTR(C_IMPFISC.CDSITUTRIBNF,2,2)  = BC.CDCSTIMPO)  OR (BC.CDCSTIMPO  IS NULL))
            AND ((SUBSTR(C_IMPFISC.CDFISCOPERNF,2,10) = BC.CDCFOPIMPO) OR (BC.CDCFOPIMPO IS NULL))
            AND (C_IMPFISC.CDFISCALNF = BC.CDFISCIMPO) OR (BC.CDFISCIMPO IS NULL)
            AND BC.IDTIPOBCALC = 'I';
         IF NOT V_CDIMPOBCALC IS NULL THEN
            UPDATE IMPOSTONF
               SET IDIMPOSTONF = '4'
             WHERE CDFILIAL = C_IMPFISC.CDFILIAL
               AND NRLANCTONF = C_IMPFISC.NRLANCTONF
               AND CDIMPOSTO = V_CDIMPOBCALC
               AND IDIMPOSTONF = '1';
         END IF;
      ELSE
         UPDATE IMPOSTONF
         SET IDIMPOSTONF = '4'
         WHERE CDFILIAL   = C_IMPFISC.CDFILIAL   AND
               NRLANCTONF = C_IMPFISC.NRLANCTONF AND
               CDIMPOSTO  = V_CDIMPOBCALC        AND
               IDIMPOSTONF = '1';
      END IF;
   END LOOP;
--INCLUSÃO DOS ENCARGOS DA NF EM CASO DE IMPORTAÇÃO
   IF (V_INTEGRACAO IS NOT NULL) THEN
      INSERT INTO ITEMENCARGO
      (CDFILIAL, NRLANCTONF, CDENCARGO, VRITEMENCA)
      (SELECT P_FILIAL, P_LANCTONF, CDENCARGO, 0 AS VRITEMENCA
       FROM ENCARGO
       MINUS
       SELECT CDFILIAL, NRLANCTONF, CDENCARGO, 0 AS VRITEMENCA
       FROM ITEMENCARGO
       WHERE CDFILIAL   = P_FILIAL AND
             NRLANCTONF = P_LANCTONF);
   END IF;
   --ATUALIZAÇÃO DO CÓDIGO FISCAL DA OPERAÇÃO NA TABELA DE NOTA FISCAL
   IF (V_INTEGRACAO IS NULL) OR (P_ENTRSAID = W_E) THEN
      IF NOT(P_TIPOOPER  = '09') THEN
         IF (V_CDCFOPINFUSU IS NULL) OR (V_CDCFOPINFUSU = '***') THEN
            SELECT COUNT(DISTINCT CDFISOPEITEM), MAX(CDFISOPEITEM)
              INTO   V_COUNT                     , V_CDFISOPENTF
              FROM ITEMPRODUTO
             WHERE (CDFILIAL   = P_FILIAL) AND
                   (NRLANCTONF = P_LANCTONF);
            IF (V_COUNT > 1) THEN
               UPDATE NOTAFISCAL
                  SET CDFISOPENTF  = '***'
                WHERE CDFILIAL     = P_FILIAL
                  AND NRLANCTONF   = P_LANCTONF;
               UPDATE NOTAFISCAL
                  SET DSCDFISOPENF = NVL(V_DSCDFISOPEITREGRA, V_DSCDFISOPEIT)
                WHERE (CDFILIAL    = P_FILIAL)
                  AND (NRLANCTONF  = P_LANCTONF)
                  AND DSCDFISOPENF IS NULL;
            ELSIF (V_COUNT = 1) THEN
               UPDATE NOTAFISCAL
                  SET CDFISOPENTF  = V_CDFISOPENTF
                WHERE (CDFILIAL    = P_FILIAL)
                  AND (NRLANCTONF  = P_LANCTONF);
               UPDATE NOTAFISCAL
                  SET DSCDFISOPENF = NVL(V_DSCDFISOPEITREGRA, V_DSCDFISOPEIT)
                WHERE (CDFILIAL    = P_FILIAL)
                  AND (NRLANCTONF  = P_LANCTONF)
                  AND DSCDFISOPENF IS NULL;
            END IF;
         ELSE
            SELECT COUNT(DISTINCT CDFISOPEITEM), MAX(CDFISOPEITEM)
              INTO   V_COUNT , V_CDFISOPENTF
              FROM ITEMPRODUTO
             WHERE (CDFILIAL   = P_FILIAL) AND
                   (NRLANCTONF = P_LANCTONF);
            IF (V_COUNT > 1) THEN
               UPDATE NOTAFISCAL
                  SET CDFISOPENTF  = '***',
                      CDCFOPINFUSU = '***'
                WHERE CDFILIAL   = P_FILIAL
                  AND NRLANCTONF = P_LANCTONF;
            ELSIF (V_COUNT = 1) THEN
               UPDATE NOTAFISCAL
                  SET CDFISOPENTF  = V_CDFISOPENTF,
                      DSCDFISOPENF = NVL(V_DSCDFISOPEITREGRA, V_DSCDFISOPEIT),
                      CDCFOPINFUSU = V_CDCFOPINFUSU,
                      DSCFOPINFUSU = V_DSCFOPINFUSU
                WHERE (CDFILIAL    = P_FILIAL)
                  AND (NRLANCTONF  = P_LANCTONF);
            END IF;
         END IF;
         IF (V_DSCFOPINFUSU IS NOT NULL) THEN
            UPDATE NOTAFISCAL
               SET DSCDFISOPENF = V_DSCFOPINFUSU
             WHERE (CDFILIAL    = P_FILIAL)
               AND (NRLANCTONF  = P_LANCTONF);
         END IF;
      END IF;
   END IF;
   IF (V_INTEGRACAO IS NOT NULL) THEN
      IF (P_ENTRSAID = W_S) THEN
         SELECT NVL(SUM(VRORIGREC),0)
         INTO V_VRCONTAREC
         FROM CONTARECEBER
         WHERE CDFILIAL   = P_FILIAL AND
               NRLANCTONF = P_LANCTONF;
         SELECT NVL(SUM(IT.VRIMPOSTOT),0)
         INTO V_IMPOSRETI
         FROM TRABIMPOSNFTOT IT, IMPOSTO I
         WHERE IT.CDFILIMPTOT  = P_FILIAL      AND
               IT.NRLANCIMPTOT = P_LANCTONF    AND
               I.CDIMPOSTO     = IT.CDIMPOSTOT AND
               I.IDDESCRFONTE  <> W_A          AND
               I.IDTRATIMPO    = W_R;
         IF (V_VRCONTAREC = V_VRNOTAFISC) AND (V_IMPOSRETI > 0) THEN
            APURAC_VENC(P_FILIAL, P_FORNECED, P_LANCTONF);
         END IF;
      ELSE
         IF (V_IDDOCFINANC <> W_L) AND (V_IDSTATUS NOT IN (W_A, W_E)) AND
            (SUBSTR(V_INTEGRACAO,1,1) IN (W_F, W_M)) THEN
            IF V_IDORIGDESTNF = W_F THEN
               BEGIN
                  SELECT IDTPFORPGTFO
                  INTO V_IDTPFORPGTFO
                  FROM FORNECEDOR
                  WHERE CDFORNECED = P_FORNECED;
               EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                     V_IDTPFORPGTFO := NULL;
               END;
               IF V_IDTPFORPGTFO IS NOT NULL THEN
                  GERA_CONTAPAGAR(P_FILIAL, P_FORNECED, P_LANCTONF, W_F);
               END IF;
            END IF;
         END IF;
      END IF;
      BEGIN
         SELECT CDPRODUTO
         INTO V_CDPRGENEREV
         FROM ITEMPRODUTO
         WHERE CDFILIAL   = P_FILIAL      AND
               NRLANCTONF = P_LANCTONF    AND
               CDPRODUTO  = V_CDPRGENEREV;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_CDPRGENEREV := NULL;
      END;
      IF V_CDPRGENEREV IS NOT NULL THEN
         DELETE IMPOSINFUSU
         WHERE CDFILIAL   = P_FILIAL AND
               NRLANCTONF = P_LANCTONF;
         INSERT INTO IMPOSINFUSU
            (CDFILIAL, NRLANCTONF, NRSEQITPROD, CDIMPOSTO,
             CDFISCINFUSU, VRALIQINFUSU, VRRDBCINFUSU, VRPDEDINFUSU)
         (SELECT CDFILIMPOIT, NRLANCIMPOIT, NRSEQIMPOIT, CDIMPOSTOIT,
                 NVL(CDFISCIMPOIT,' '), NVL(VRALIQIMPOIT,0), VRREDBCIMPOIT,
                 VRPDEDIMPOIT
          FROM TRABITPROIMPOS
          WHERE CDFILIMPOIT  = P_FILIAL   AND
                NRLANCIMPOIT = P_LANCTONF AND
                NRSEQITPRO   = W_1);
      END IF;
   END IF;
   /* ESTA ROTINA ABAIXO SERVE PARA ATUALIZAR O VALOR CONTÁBIL E BRUTO DOS PRODUTOS COM A DIFERENÇA
      DE CENTAVOS ENTRE O VALOR DOS IMPOSTOS POR ÍTEM E A SUA RESPECTIVA TOTALIZAÇÃO. ESTA DIFERENÇA
      É IGNORADA NO FECHAMENTO DA NF CASO O CLIENTE TRABALHE COM UM NÚMERO MENOR DE CASAS DECIMAIS E
      PROVOCA ERROS NA CONTABILIZAÇÃO*/
   IF V_NRDECITOTANF <> 2 THEN
      FOR C_ATUAVRCONT IN (SELECT T.CDIMPOSTOIT, SUM(T.VRIMPOSIT) AS VRIMPOSIT, T.CDFISCIMPOIT,
                                  I.IDIMPORECUP, I.CDCCTBLATIV, I.CDCCTBLPASS, I.IDTRATIMPO
                           FROM TRABITPROIMPOS T, IMPOSTO I
                           WHERE T.CDFILIMPOIT  = P_FILIAL      AND
                                 T.NRLANCIMPOIT = P_LANCTONF    AND
                                 T.NRSEQITPRO   = W_1           AND
                                 I.CDIMPOSTO    = T.CDIMPOSTOIT AND
                                 I.IDTIPCONTAB  = W_D
                           GROUP BY T.CDIMPOSTOIT, T.CDFISCIMPOIT, I.IDIMPORECUP,
                                    I.CDCCTBLATIV, I.CDCCTBLPASS, I.IDTRATIMPO) LOOP
         SELECT SUM(VRIMPOSTOT) - C_ATUAVRCONT.VRIMPOSIT
         INTO V_VRDIFERENCA
         FROM TRABIMPOSNFTOT
         WHERE CDFILIMPTOT  = P_FILIAL   AND
               NRLANCIMPTOT = P_LANCTONF AND
               CDIMPOSTOT   = C_ATUAVRCONT.CDIMPOSTOIT;
         SELECT SUM(VRBRUTITEM), SUM(VRCONTITEM)
         INTO V_VRBRUTO, V_VRCONTAB
         FROM ITEMPRODUTO I, TRABITPROIMPOS T
         WHERE I.CDFILIAL     = P_FILIAL                  AND
               I.NRLANCTONF   = P_LANCTONF                AND
               T.CDFILIMPOIT  = I.CDFILIAL                AND
               T.NRLANCIMPOIT = I.NRLANCTONF              AND
               T.NRSEQIMPOIT  = I.NRSEQITPROD             AND
               T.CDIMPOSTOIT  = C_ATUAVRCONT.CDIMPOSTOIT  AND
               T.NRSEQITPRO   = W_1;
         IF V_VRDIFERENCA <> 0 THEN
            V_IMPOCONTAB := 0;
            IF (C_ATUAVRCONT.IDIMPORECUP = W_S) THEN
               IF (C_ATUAVRCONT.CDFISCIMPOIT = W_1) THEN
                  IF (C_ATUAVRCONT.CDCCTBLATIV IS NOT NULL) THEN
                     IF C_ATUAVRCONT.IDTRATIMPO = W_V THEN
                        V_IMPOCONTAB := - V_VRDIFERENCA;
                     END IF;
                  END IF;
               ELSE
                  IF C_ATUAVRCONT.IDTRATIMPO = W_A THEN
                     V_IMPOCONTAB := V_VRDIFERENCA;
                  ELSIF C_ATUAVRCONT.IDTRATIMPO IN (W_D,W_R) THEN
                     V_IMPOCONTAB := - V_VRDIFERENCA;
                  END IF;
               END IF;
            ELSE
               IF NOT(C_ATUAVRCONT.CDCCTBLPASS IS NULL) THEN
                  IF C_ATUAVRCONT.IDTRATIMPO = W_V THEN
                     V_IMPOCONTAB := - V_VRDIFERENCA;
                  END IF;
               ELSE
                  IF C_ATUAVRCONT.IDTRATIMPO = W_A THEN
                     V_IMPOCONTAB := V_VRDIFERENCA;
                  ELSIF C_ATUAVRCONT.IDTRATIMPO IN (W_D,W_R) THEN
                     V_IMPOCONTAB := - V_VRDIFERENCA;
                  END IF;
               END IF;
            END IF;
            IF C_ATUAVRCONT.IDTRATIMPO = W_A THEN
               UPDATE ITEMPRODUTO
               SET VRCONTITEM = VRCONTITEM + ((V_IMPOCONTAB  / V_VRCONTAB) * VRCONTITEM)
               WHERE EXISTS(SELECT CDFILIMPOIT, NRLANCIMPOIT, NRSEQIMPOIT
                            FROM TRABITPROIMPOS T
                            WHERE T.CDFILIMPOIT  = P_FILIAL                 AND
                                  T.NRLANCIMPOIT = P_LANCTONF               AND
                                  T.CDIMPOSTOIT  = C_ATUAVRCONT.CDIMPOSTOIT AND
                                  T.CDFILIMPOIT  = ITEMPRODUTO.CDFILIAL     AND
                                  T.NRLANCIMPOIT = ITEMPRODUTO.NRLANCTONF   AND
                                  T.NRSEQIMPOIT  = ITEMPRODUTO.NRSEQITPROD);
            ELSIF C_ATUAVRCONT.IDTRATIMPO = W_D THEN
               UPDATE ITEMPRODUTO
               SET VRCONTITEM = VRCONTITEM + ((V_IMPOCONTAB  / V_VRCONTAB) * VRCONTITEM)
               WHERE EXISTS(SELECT CDFILIMPOIT, NRLANCIMPOIT, NRSEQIMPOIT
                            FROM TRABITPROIMPOS T
                            WHERE T.CDFILIMPOIT  = P_FILIAL                 AND
                                  T.NRLANCIMPOIT = P_LANCTONF               AND
                                  T.CDIMPOSTOIT  = C_ATUAVRCONT.CDIMPOSTOIT AND
                                  T.CDFILIMPOIT  = ITEMPRODUTO.CDFILIAL     AND
                                  T.NRLANCIMPOIT = ITEMPRODUTO.NRLANCTONF   AND
                                  T.NRSEQIMPOIT  = ITEMPRODUTO.NRSEQITPROD);
            ELSE
               UPDATE ITEMPRODUTO
               SET VRCONTITEM = VRCONTITEM + ((V_IMPOCONTAB  / V_VRCONTAB) * VRCONTITEM)
               WHERE EXISTS(SELECT CDFILIMPOIT, NRLANCIMPOIT, NRSEQIMPOIT
                            FROM TRABITPROIMPOS T
                            WHERE T.CDFILIMPOIT  = P_FILIAL                 AND
                                  T.NRLANCIMPOIT = P_LANCTONF               AND
                                  T.CDIMPOSTOIT  = C_ATUAVRCONT.CDIMPOSTOIT AND
                                  T.CDFILIMPOIT  = ITEMPRODUTO.CDFILIAL     AND
                                  T.NRLANCIMPOIT = ITEMPRODUTO.NRLANCTONF   AND
                                  T.NRSEQIMPOIT  = ITEMPRODUTO.NRSEQITPROD);
            END IF;
         END IF;
      END LOOP;
   END IF;
   IF NOT(P_LANCESTQ IS NULL) AND (V_IDCTRLESTQ <> W_N) THEN
      IF (V_IDOPERDEVONF = W_S) THEN
         IF (V_DEVOLORIG IS NOT NULL) THEN
            V_DTSAIDNFORIG := NULL;
            SELECT MAX(IDSISTEMA), MAX(DTENTRSAID)
            INTO V_IDSISTEMA, V_DTSAIDNFORIG
            FROM NOTAFISCAL N, ITEMNOTAFISC I
            WHERE I.CDFILIAL     = P_FILIAL      AND
                  I.NRLANCTONF   = P_LANCTONF    AND
                  I.CDFILIALIT   = N.CDFILIAL    AND
                  I.NRLANCTONFIT = N.NRLANCTONF;
         ELSE
            V_IDSISTEMA := W_EXP;
            V_DTSAIDNFORIG := V_DTATUAL;
         END IF;
         IF (V_IDSISTEMA = W_EXP) THEN
            SELECT MAX(NVL(IDRETPROEXP,1))
            INTO V_IDRETPROEXP
            FROM PAREXPEDICAO;
         END IF;
      END IF;
      DELETE FROM ITLANCTOEST
      WHERE CDFILIAL   = P_FILIAL    AND
            NRLANCESTQ = P_LANCESTQ;
      IF V_IDSISTEMA <> W_VMN THEN
         DELETE FROM LANCTOESTOQ
         WHERE CDFILIAL   = P_FILIAL    AND
               NRLANCESTQ = P_LANCESTQ;
         DELETE FROM LANCTOESTOQ
         WHERE CDFILIAL   = P_FILIAL    AND
               NRLANCTONF = P_LANCTONF;
      ELSE
         UPDATE LANCTOESTOQ
         SET DTLANCESTQ   = P_INIVALID
         WHERE CDFILIAL   = P_FILIAL    AND
               NRLANCESTQ = P_LANCESTQ;
      END IF;
      IF P_ENTRSAID = W_S THEN
         IF (P_TIPOOPER = '06') THEN
            V_TIPOMOVI := '5';
         ELSE
            V_TIPOMOVI := '4';
         END IF;
      ELSE
         V_TIPOMOVI := W_2;
      END IF;
      SELECT T.NMTIPOOPER, F.NMFILIAL
      INTO V_NMTIPOOPER, V_NMFILIEMIT
      FROM NOTAFISCAL N, TIPOOPERAC T, FILIAL F
      WHERE
         (N.CDFILIAL     = P_FILIAL)       AND
         (N.NRLANCTONF   = P_LANCTONF)     AND
         (T.CDTIPOOPER   = N.CDTIPOOPER)   AND
         (T.IDENTRSAIDOP = N.IDENTRSAIDOP) AND
         (N.CDFILIEMIT   = F.CDFILIAL(+));
      IF V_IDORIGDESTNF = W_L THEN
         V_DESCLANC := SUBSTR('NF: '||P_LANCTONF||' - '||SUBSTR(V_NMTIPOOPER,1,25)||' - '||SUBSTR(V_NMFILIEMIT,1,15),1,60);
      ELSE
         V_DESCLANC := SUBSTR('LANC. ORIGEM: '||V_NRINSJURNF||' Nº'||V_NRNOTAFISC||' SERIE '||V_SERIE,1,60);
      END IF;
      SELECT COUNT(*)
      INTO V_COUNT
      FROM LANCTOESTOQ
      WHERE CDFILIAL   = P_FILIAL    AND
            NRLANCESTQ = P_LANCESTQ;
      IF V_COUNT = 0 THEN
         INSERT INTO LANCTOESTOQ(CDFILIAL,NRLANCESTQ,NRLANCTONF,DSLANCESTQ,IDTPLANCTO,DTLANCESTQ,CDOPERADOR,CDFILIMOVI)
                          VALUES(P_FILIAL, P_LANCESTQ, P_LANCTONF, V_DESCLANC, P_ENTRSAID, P_INIVALID,P_CDOPERADOR, V_CDFILIRECE);
      END IF;
      IF (V_IDSISTEMA = W_PDV) THEN
         SELECT NVL(MAX(IDATUEST),1)
         INTO V_IDATUEST
         FROM PARAVEND
         WHERE CDFILIAL = P_FILIAL;
      END IF;
      IF ((V_IDSISTEMA = W_EXP) AND (V_IDRETPROEXP = W_2)) OR ((V_IDSISTEMA = W_PDV) AND (V_IDATUEST = W_1)) THEN
         FOR C_ITLANCTOEST IN (SELECT NRSEQITPROD,IP.CDPRODUTO,VRUNITITEM,VRTOTAITEM,
                                      QTITEMPROD,CDPRODESTO,VRBRUTITEM,VRDESCITEM,VRCONTITEM,
                                      NVL(IP.CDALMOXARIFE, ' ') CDALMOXARIFE,
                                      NVL(IP.CDLOCALESTOQ, ' ') CDLOCALESTOQ,
                                      NVL(NRLOTEESTQ, ' ') NRLOTEESTQ,
                                      NVL(NRSUBLOTE, ' ') NRSUBLOTE, CDFILIMOVI,
                                      CDFISOPEITEM,
                                      NVL(IDORIGEMPROD, 'N') IDORIGEMPROD
                               FROM ITEMPRODUTO IP, PRODUTO P, PRODFILI PF
                               WHERE IP.CDFILIAL    = P_FILIAL     AND
                                     IP.NRLANCTONF  = P_LANCTONF   AND
                                     P.CDPRODUTO    = IP.CDPRODUTO AND
                                     PF.CDFILIAL    = V_CDFILIRECE AND
                                     PF.CDPRODUTO   = P.CDPRODESTO AND
                                     NVL(IDCNTRESTOQ, W_S) <> W_N) LOOP
            INSERT INTO LOTE
            (CDFILIAL, NRLOTEESTQ, NRSUBLOTE, CDPRODUTO, IDSTATLOTE, DTENTRLOTE)
            (SELECT C_ITLANCTOEST.CDFILIMOVI,  C_ITLANCTOEST.NRLOTEESTQ,
                    C_ITLANCTOEST.NRSUBLOTE,   C_ITLANCTOEST.CDPRODESTO, W_L , SYSDATE
             FROM PARAMGERAL
             MINUS
             SELECT CDFILIAL,      NRLOTEESTQ,  NRSUBLOTE,
                    C_ITLANCTOEST.CDPRODESTO, W_L, SYSDATE
             FROM LOTE
             WHERE  C_ITLANCTOEST.CDFILIMOVI = CDFILIAL     AND
                    C_ITLANCTOEST.NRLOTEESTQ = NRLOTEESTQ   AND
                    C_ITLANCTOEST.NRSUBLOTE  = NRSUBLOTE    AND
                    C_ITLANCTOEST.CDPRODESTO = CDPRODUTO);
            UPDATE ITEMPRODUTO
            SET CDPRODMOVI = C_ITLANCTOEST.CDPRODESTO
            WHERE (CDFILIAL    = P_FILIAL)    AND
                  (NRLANCTONF  = P_LANCTONF)  AND
                  (NRSEQITPROD = C_ITLANCTOEST.NRSEQITPROD);
            SELECT COUNT(*)
            INTO V_EXISTE_ROT
            FROM ROTFABRICA
            WHERE CDPRODUTO = C_ITLANCTOEST.CDPRODUTO;
            IF (V_EXISTE_ROT) > 0 THEN
               INSERE_SUBPRODMAN(P_FILIAL,P_LANCESTQ,P_TIPOOPER,C_ITLANCTOEST.CDPRODUTO,
                                 C_ITLANCTOEST.QTITEMPROD,
                                 C_ITLANCTOEST.VRTOTAITEM, C_ITLANCTOEST.VRDESCITEM,
                                 C_ITLANCTOEST.VRBRUTITEM, C_ITLANCTOEST.VRCONTITEM,
                                 V_VRTOTALANCTO, V_QTDELANCTO, V_TIPOMOVI, P_INIVALID,
                                 C_ITLANCTOEST.CDPRODESTO, '', '', 'F');
            ELSE
               BEGIN
                  SELECT VRFATOCONV INTO V_FATOCONV
                  FROM PRODUTO P, ITEMPRODUTO IP
                  WHERE IP.CDFILIAL    = P_FILIAL                  AND
                        IP.NRLANCTONF  = P_LANCTONF                AND
                        IP.NRSEQITPROD = C_ITLANCTOEST.NRSEQITPROD AND
                        P.CDPRODUTO    = IP.CDPRODUTO;
               EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                     V_FATOCONV := 0;
               END;
               IF (V_FATOCONV IS NULL) OR (V_FATOCONV = 0) THEN
                  V_FATOCONV := 1;
               END IF;
               V_QTDELANCTO   := C_ITLANCTOEST.QTITEMPROD;
               V_VRTOTALANCTO := (C_ITLANCTOEST.VRTOTAITEM - C_ITLANCTOEST.VRDESCITEM);
               IF NOT(V_QTDELANCTO = 0) THEN
                  V_VRUNITLANCTO := V_VRTOTALANCTO/V_QTDELANCTO;
               ELSE
                  V_VRUNITLANCTO := V_VRTOTALANCTO;
               END IF;
               IF (P_TIPOOPER = '06') THEN
                  V_TOTABRUT   := 0;
                  V_TOTACONTAB := 0;
                  V_VRCUSTENTR := 0;
               ELSIF (V_IDCOMPRABONI = 'S') THEN
                  SELECT NVL(MAX(IDCOMPOEVENC),'S')
                    INTO V_COMPCUSTPROD
                    FROM TPOPERCFOP
                   WHERE CDTIPOOPER   = P_TIPOOPER
                     AND IDENTRSAIDOP = P_ENTRSAID
                     AND CDFISCOPER   = C_ITLANCTOEST.CDFISOPEITEM;
                  IF (V_COMPCUSTPROD = 'N') THEN
                     V_TOTABRUT   := 0;
                     V_TOTACONTAB := 0;
                     V_VRCUSTENTR := 0;
                  ELSE
                     IF NOT(V_IDNFRETIND = w_S) THEN
                        IF NOT(V_QTDELANCTO = 0) THEN
                           V_TOTABRUT   := (C_ITLANCTOEST.VRBRUTITEM/V_QTDELANCTO)/V_FATOCONV;
                           V_TOTACONTAB := (C_ITLANCTOEST.VRCONTITEM/V_QTDELANCTO)/V_FATOCONV;
                        ELSE
                           V_TOTABRUT   := C_ITLANCTOEST.VRBRUTITEM;
                           V_TOTACONTAB := C_ITLANCTOEST.VRCONTITEM;
                        END IF;
                        V_VRCUSTENTR := C_ITLANCTOEST.VRCONTITEM;
                     ELSE
                        V_VRCUSTENTR := V_TOTACONTAB;
                     END IF;
                  END IF;
               ELSE
                  IF NOT(V_IDNFRETIND = w_S) THEN
                     IF NOT(V_QTDELANCTO = 0) THEN
                        V_TOTABRUT   := (C_ITLANCTOEST.VRBRUTITEM/V_QTDELANCTO)/V_FATOCONV;
                        V_TOTACONTAB := (C_ITLANCTOEST.VRCONTITEM/V_QTDELANCTO)/V_FATOCONV;
                     ELSE
                        V_TOTABRUT   := C_ITLANCTOEST.VRBRUTITEM;
                        V_TOTACONTAB := C_ITLANCTOEST.VRCONTITEM;
                     END IF;
                     V_VRCUSTENTR := C_ITLANCTOEST.VRCONTITEM;
                  ELSE
                     V_VRCUSTENTR := V_TOTACONTAB;
                  END IF;
               END IF;
               IF (V_IDOPERDEVONF = W_S AND V_IDUTCUSORIGEST = W_S) THEN
                  V_VRCUSTENTR := ROUND(CUSTO_PRODUTO_LCEST(V_CDFILIRECE, C_ITLANCTOEST.CDPRODESTO, V_CDTIPCUSTEST, P_INIVALID,
                                                            V_DTATUAL, C_ITLANCTOEST.CDALMOXARIFE, C_ITLANCTOEST.CDLOCALESTOQ,
                                                            C_ITLANCTOEST.NRLOTEESTQ, C_ITLANCTOEST.NRSUBLOTE), 5);
                  IF V_VRCUSTENTR = 0 THEN
                     V_TOTABRUT   := C_ITLANCTOEST.VRUNITITEM;
                     V_TOTACONTAB := C_ITLANCTOEST.VRUNITITEM;
                  ELSE
                     V_TOTABRUT   := V_VRCUSTENTR;
                     V_TOTACONTAB := V_VRCUSTENTR;
                  END IF;
               END IF;
               SELECT NVL(MAX(NRSEQUITEM),0) + 1
               INTO V_NRSEQITPROD
               FROM ITLANCTOEST
               WHERE CDFILIAL   = P_FILIAL    AND
                     NRLANCESTQ = P_LANCESTQ;
               IF V_IDORIGDESTNF = W_L THEN
                  BEGIN
                     SELECT CDFORNOPELOG
                     INTO V_CDFORNECED
                     FROM FILIAL
                     WHERE CDFILIAL = V_CDFILIEMIT;
                  EXCEPTION
                     WHEN NO_DATA_FOUND THEN
                        V_CDFORNECED := NULL;
                  END;
               ELSE
                  V_CDFORNECED := P_FORNECED;
               END IF;
               SELECT NVL(MAX(X.VRPESOBRUTPR),0),NVL(MAX(VRPECUSTOLOG),0), NVL(MAX(VRVRCUSTOLOG),0),
                      NVL(MAX(VRPESEGURLOG),0)
               INTO V_VRPESOBRUTPR, V_VRPECUSTOLOG,V_VRVRCUSTOLOG,
                    V_VRPESEGURLOG
               FROM PRODUTO P, CUSTOLOGIST C,
                    (SELECT NVL(MAX(A.VRPESOBRUTPR),0) VRPESOBRUTPR,
                           MAX(P.CDARVPROD) CDPRODUTO, MAX(C.DTINIVIGCLOG) DTINIVIGCLOG
                     FROM PRODUTO P, CUSTOLOGIST C, PRODUTO A
                     WHERE
                        (INSTR(A.CDARVPROD,P.CDARVPROD) = 1)         AND
                        A.CDPRODUTO    = C_ITLANCTOEST.CDPRODUTO     AND
                        P.CDPRODUTO    = C.CDPRODUTO                 AND
                        C.CDFILIAL     = C_ITLANCTOEST.CDFILIMOVI    AND
                        C.CDFORNECED   = V_CDFORNECED                AND
                        C.DTINIVIGCLOG = (SELECT MAX(DTINIVIGCLOG)
                                          FROM CUSTOLOGIST A, PRODUTO B, PRODUTO Q
                                          WHERE
                                             A.CDFILIAL     = C.CDFILIAL    AND
                                             A.CDFORNECED   = C.CDFORNECED  AND
                                             (INSTR(B.CDARVPROD,Q.CDARVPROD) = 1)         AND
                                             B.CDPRODUTO    = C_ITLANCTOEST.CDPRODUTO     AND
                                             Q.CDPRODUTO    = A.CDPRODUTO                 AND
                                             A.DTINIVIGCLOG <= P_INIVALID))X
               WHERE C.CDFILIAL     = C_ITLANCTOEST.CDFILIMOVI  AND
                     C.CDPRODUTO    = P.CDPRODUTO               AND
                     C.CDPRODUTO    = X.CDPRODUTO               AND
                     C.CDFORNECED   = V_CDFORNECED              AND
                     C.DTINIVIGCLOG = X.DTINIVIGCLOG;
               V_VRCUSTOLOG := 0;
               V_VRCUSTOSEG := 0;
               IF (V_VRVRCUSTOLOG > 0) AND (V_VRPESOBRUTPR > 0) THEN
                  V_VRCUSTOLOG := (C_ITLANCTOEST.QTITEMPROD*V_VRPESOBRUTPR)*V_VRVRCUSTOLOG;
               END IF;
               IF (V_VRPECUSTOLOG > 0) THEN
                  V_VRCUSTOLOG := (C_ITLANCTOEST.VRTOTAITEM * V_VRPECUSTOLOG)/100;
               END IF;
               IF (V_VRPESEGURLOG > 0) THEN
                  V_VRCUSTOSEG := (C_ITLANCTOEST.VRTOTAITEM * V_VRPESEGURLOG)/100;
               END IF;
               INSERT INTO ITLANCTOEST
                  (CDFILIAL,     NRLANCESTQ, NRSEQUITEM,   CDPRODUTO,    QTTOTLANCTO, VRUNILANCTO,   VRTOTLANCTO,
                   IDTIPOMOVI,   DTLANCMOVI, IDORDEMCLC,   CDPRODMOVI,   QTLANCTOEST, VRLANCTOBRUT,  VRLANCTOEST,
                   VRCUSTENTR,   CDFILIMOVI, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ,  NRSUBLOTE,     NRLANCORIGRP,
                   VRCUSTLOGLAN, VRSEGULOGLAN, IDORIGEMPROD)
               VALUES
                  (P_FILIAL,       P_LANCESTQ,LPAD(V_NRSEQITPROD,4,'0'),  C_ITLANCTOEST.CDPRODUTO, V_QTDELANCTO,
                   V_VRUNITLANCTO, V_VRTOTALANCTO,  V_TIPOMOVI,   P_INIVALID, W_2, C_ITLANCTOEST.CDPRODESTO,
                   (V_QTDELANCTO * V_FATOCONV), V_TOTABRUT,    V_TOTACONTAB,  V_VRCUSTENTR, V_CDFILIRECE,
                   C_ITLANCTOEST.CDALMOXARIFE,C_ITLANCTOEST.CDLOCALESTOQ,C_ITLANCTOEST.NRLOTEESTQ, C_ITLANCTOEST.NRSUBLOTE,
                   V_IDDOCREPLIC, V_VRCUSTOLOG, V_VRCUSTOSEG, C_ITLANCTOEST.IDORIGEMPROD);
            END IF;
         END LOOP;
      ELSE
         FOR C_ITLANCTOEST IN (SELECT NRSEQITPROD,IP.CDPRODUTO,VRUNITITEM,VRTOTAITEM,
                                      QTITEMPROD,CDPRODESTO,VRBRUTITEM,VRDESCITEM,VRCONTITEM,
                                      NVL(IP.CDALMOXARIFE, ' ') CDALMOXARIFE,
                                      NVL(IP.CDLOCALESTOQ, ' ') CDLOCALESTOQ,
                                      NVL(NRLOTEESTQ, ' ') NRLOTEESTQ,
                                      NVL(NRSUBLOTE, ' ') NRSUBLOTE, CDFILIMOVI,
                                      CDFISOPEITEM, NVL(IDORIGEMPROD, 'N') IDORIGEMPROD
                               FROM ITEMPRODUTO IP, PRODUTO P, PRODFILI PF
                               WHERE IP.CDFILIAL    = P_FILIAL     AND
                                     IP.NRLANCTONF  = P_LANCTONF   AND
                                     P.CDPRODUTO    = IP.CDPRODUTO AND
                                     PF.CDFILIAL    = V_CDFILIRECE AND
                                     PF.CDPRODUTO   = P.CDPRODESTO AND
                                     NVL(IDCNTRESTOQ, W_S) <> W_N) LOOP
            --Alteração para verificar se o CFOP atualiza estoque
            V_ATUPORCFOP := w_S;
            V_CFOPTPOPER := 0;
            V_CFOPATUEST := 0;
            SELECT COUNT(CDFISCOPER)
              INTO V_CFOPTPOPER
              FROM TPOPERCFOP
             WHERE IDENTRSAIDOP = w_E
               AND CDTIPOOPER   = P_TIPOOPER
               AND CDFISCOPER   = C_ITLANCTOEST.CDFISOPEITEM;
            IF(V_CFOPTPOPER > 0) THEN
               SELECT COUNT(CDFISCOPER)
                 INTO V_CFOPATUEST
                 FROM(SELECT CDFISCOPER
                        FROM TPOPERCFOP T
                       WHERE T.IDENTRSAIDOP   = w_E
                         AND T.CDTIPOOPER     = P_TIPOOPER
                         AND T.IDATUESTTPCFOP = w_S
                         AND T.CDFISCOPER     = C_ITLANCTOEST.CDFISOPEITEM
                         AND C_ITLANCTOEST.CDPRODUTO NOT IN (SELECT CDPRODUTO
                                                               FROM TPOPERCFOPEXCP TE
                                                              WHERE TE.IDENTRSAIDOP = w_E
                                                                AND TE.CDTIPOOPER   = P_TIPOOPER
                                                                AND TE.CDFISCOPER   = C_ITLANCTOEST.CDFISOPEITEM
                                                                AND TE.CDPRODUTO    = C_ITLANCTOEST.CDPRODUTO)
                       UNION ALL
                      SELECT CDFISCOPER
                        FROM TPOPERCFOP T
                       WHERE T.IDENTRSAIDOP   = w_E
                         AND T.CDTIPOOPER     = P_TIPOOPER
                         AND T.IDATUESTTPCFOP = w_N
                         AND T.CDFISCOPER     = C_ITLANCTOEST.CDFISOPEITEM
                         AND C_ITLANCTOEST.CDPRODUTO IN (SELECT CDPRODUTO
                                                           FROM TPOPERCFOPEXCP TE
                                                          WHERE TE.IDENTRSAIDOP = w_E
                                                            AND TE.CDTIPOOPER   = P_TIPOOPER
                                                            AND TE.CDFISCOPER   = C_ITLANCTOEST.CDFISOPEITEM
                                                            AND TE.CDPRODUTO    = C_ITLANCTOEST.CDPRODUTO));
               IF NOT (V_CFOPATUEST > 0) THEN
                  V_ATUPORCFOP := w_N;
               END IF;
            END IF;
            --Alteração para verificar se o CFOP atualiza estoque
            IF (V_ATUPORCFOP = w_S) THEN
               IF ((V_CDFILIALSAGA IS NULL) OR ((V_CDFILIALSAGA IS NOT NULL) AND (V_IDATUESTLANCNFE = 'S'))) THEN
                  GERA_EST_DISTRIBUICAO(P_FILIAL, P_LANCTONF, C_ITLANCTOEST.NRSEQITPROD, P_LANCESTQ,
                                        P_TIPOOPER, V_TIPOMOVI, P_INIVALID, C_ITLANCTOEST.CDFILIMOVI,
                                        C_ITLANCTOEST.CDPRODUTO, C_ITLANCTOEST.QTITEMPROD, C_ITLANCTOEST.CDALMOXARIFE, C_ITLANCTOEST.CDLOCALESTOQ,
                                        NULL, NULL, V_RESULT_GERA_EST);
               END IF;
            END IF;
         END LOOP;
      END IF;
   END IF;
   IF P_TIPOOPER = '03' THEN
      V_VRCOMPLEMEN := 0;
      FOR C_ENCARGO IN (SELECT EN.IDENCARGO, SUM(VRITEMENCA) AS VRITEMENCA
                        FROM ITEMENCARGO IE, ENCARGO EN
                        WHERE (IE.CDFILIAL   = P_FILIAL)     AND
                              (IE.NRLANCTONF = P_LANCTONF)   AND
                              (IE.VRITEMENCA > 0)            AND
                              (EN.CDENCARGO  = IE.CDENCARGO) AND
                              (EN.CDCTBLENTREN IS NULL)
                        GROUP BY IDENCARGO) LOOP
         IF C_ENCARGO.IDENCARGO = W_A THEN
            V_VRCOMPLEMEN := V_VRCOMPLEMEN + C_ENCARGO.VRITEMENCA;
         ELSIF C_ENCARGO.IDENCARGO = W_D THEN
            V_VRCOMPLEMEN := V_VRCOMPLEMEN - C_ENCARGO.VRITEMENCA;
         END IF;
      END LOOP;
      IF (V_VRCOMPLEMEN > 0) AND (V_LIQUIDO = 0) THEN
         ATUALIZA_CUSTO_COMPLEMENTO(P_FILIAL, P_LANCTONF, (V_VRCOMPLEMEN - V_VRPRODUTOS));
      END IF;
      IF V_VRNOTAFISC = 0 THEN
         UPDATE NOTAFISCAL
            SET VRNOTAFISC = ROUND(V_TOTALNOTA, 2)
          WHERE CDFILIAL   = P_FILIAL    AND
                NRLANCTONF = P_LANCTONF;
      ELSE
         UPDATE NOTAFISCAL
            SET VRNOTAFISC = ROUND(VRNOTAFISC, 2)
          WHERE CDFILIAL   = P_FILIAL    AND
                NRLANCTONF = P_LANCTONF;
      END IF;
      IF V_VRPRODUTOS = 0 THEN
         UPDATE NOTAFISCAL
         SET VRPRODUTOS = V_VRCOMPLEMEN
         WHERE CDFILIAL   = P_FILIAL    AND
               NRLANCTONF = P_LANCTONF;
      END IF;
   END IF;
   IF V_IDOPERDEVONF = 'S' THEN
      V_TOTALNOTA := ROUND(V_TOTALNOTA, 2);
      UPDATE NOTAFISCAL
         SET VRNOTAFISC = ROUND(VRNOTAFISC, 2)
       WHERE CDFILIAL   = P_FILIAL
         AND NRLANCTONF = P_LANCTONF;
   END IF;
   -- Recalcula diferencial de aliquota considerando valor contabil quando não possuir redução de base de cálculo
   FOR C_TRABITPROIMPOS IN (SELECT NRSEQITPROD, CDIMPOSTO, VRALIQITEM
                              FROM ITEMPROIMPOS
                             WHERE CDFILIAL = P_FILIAL
                               AND NRLANCTONF = P_LANCTONF
                               AND NRITPROIMPOS = '3') LOOP
      V_CDFILIREDU := NULL;
      SELECT MAX(CDFILIAL)
        INTO V_CDFILIREDU
        FROM ITEMPROIMPOS
       WHERE CDFILIAL = P_FILIAL
         AND NRLANCTONF = P_LANCTONF
         AND NRSEQITPROD = C_TRABITPROIMPOS.NRSEQITPROD
         AND CDIMPOSTO = C_TRABITPROIMPOS.CDIMPOSTO
         AND NRITPROIMPOS = '2';
      IF ((V_CDFILIREDU IS NULL) AND (NVL(V_IDORIGDESTNF, 'F') <> 'L')) THEN
         V_VRCONTITIMP := 0;
         SELECT MAX(VRCONTITIMP), MAX(VRIMPOSTOIT), MAX(VRALIQITEM)
           INTO V_VRCONTITIMP, V_IMPOSTOIT, V_ALIQINFO
           FROM ITEMPROIMPOS 
          WHERE CDFILIAL = P_FILIAL 
            AND NRLANCTONF = P_LANCTONF 
            AND NRSEQITPROD = C_TRABITPROIMPOS.NRSEQITPROD
            AND CDIMPOSTO = C_TRABITPROIMPOS.CDIMPOSTO 
            AND NRITPROIMPOS = '1';
         IF (V_IDCALCDIFENTFISC = 'N') THEN
            UPDATE TRABITPROIMPOS
               SET VRCONTIMPOIT  = ROUND(V_VRCONTITIMP, 5),
                   VRBCALCIMPOIT = ROUND(V_VRCONTITIMP, 2),
                   VRIMPOSIT = ROUND((V_VRCONTITIMP * (VRALIQIMPOIT / 100)), V_NRDECITOTANF)
             WHERE CDFILIMPOIT = P_FILIAL
               AND NRLANCIMPOIT = P_LANCTONF
               AND NRSEQIMPOIT = C_TRABITPROIMPOS.NRSEQITPROD
               AND CDIMPOSTOIT = C_TRABITPROIMPOS.CDIMPOSTO
               AND NRSEQITPRO   = '3';
            UPDATE ITEMPROIMPOS
               SET VRCONTITIMP = ROUND(V_VRCONTITIMP, 5),
                   VRBASECALCIT = ROUND(V_VRCONTITIMP, 2),
                   VRIMPOSTOIT = ROUND((V_VRCONTITIMP * (VRALIQITEM / 100)), V_NRDECITOTANF)
             WHERE CDFILIAL = P_FILIAL
               AND NRLANCTONF = P_LANCTONF
               AND NRSEQITPROD = C_TRABITPROIMPOS.NRSEQITPROD
               AND CDIMPOSTO = C_TRABITPROIMPOS.CDIMPOSTO
               AND NRITPROIMPOS = '3';
         ELSE
            V_ALIQDEST     := 0;
            V_ALIQDEST     := V_ALIQINFO + C_TRABITPROIMPOS.VRALIQITEM;
            V_BCALCDIFCOMP := ROUND(((V_VRCONTITIMP - V_IMPOSTOIT) / ((100 - V_ALIQDEST)/100)) , V_NRDECITOTANF);
            V_IMPOSTODIFE  := ROUND(((V_BCALCDIFCOMP * (V_ALIQDEST/100)) - V_IMPOSTOIT), V_NRDECITOTANF);
            UPDATE TRABITPROIMPOS
               SET VRCONTIMPOIT  = ROUND(V_VRCONTITIMP, 5),
                   VRBCALCIMPOIT = ROUND(V_BCALCDIFCOMP, 2),
                   VRIMPOSIT     = V_IMPOSTODIFE
             WHERE CDFILIMPOIT = P_FILIAL
               AND NRLANCIMPOIT = P_LANCTONF
               AND NRSEQIMPOIT = C_TRABITPROIMPOS.NRSEQITPROD
               AND CDIMPOSTOIT = C_TRABITPROIMPOS.CDIMPOSTO
               AND NRSEQITPRO   = '3';
             UPDATE ITEMPROIMPOS
               SET VRCONTITIMP  = ROUND(V_VRCONTITIMP, 5),
                   VRBASECALCIT = ROUND(V_BCALCDIFCOMP, 2),
                   VRIMPOSTOIT  = V_IMPOSTODIFE
             WHERE CDFILIAL = P_FILIAL
               AND NRLANCTONF = P_LANCTONF
               AND NRSEQITPROD = C_TRABITPROIMPOS.NRSEQITPROD
               AND CDIMPOSTO = C_TRABITPROIMPOS.CDIMPOSTO
               AND NRITPROIMPOS = '3';
         END IF;
      END IF;
      IF ((V_CDFILIREDU IS NULL) AND (NVL(V_IDORIGDESTNF, 'F') = 'L')) THEN
         V_VRCONTITIMP := 0;
         SELECT MAX(VRCONTITIMP)
           INTO V_VRCONTITIMP
           FROM ITEMPROIMPOS
          WHERE CDFILIAL = P_FILIAL
            AND NRLANCTONF = P_LANCTONF
            AND NRSEQITPROD = C_TRABITPROIMPOS.NRSEQITPROD
            AND CDIMPOSTO = C_TRABITPROIMPOS.CDIMPOSTO
            AND NRITPROIMPOS = '1';
         UPDATE TRABITPROIMPOS
            SET VRCONTIMPOIT = V_VRCONTITIMP
          WHERE CDFILIMPOIT = P_FILIAL
            AND NRLANCIMPOIT = P_LANCTONF
            AND NRSEQIMPOIT = C_TRABITPROIMPOS.NRSEQITPROD
            AND CDIMPOSTOIT = C_TRABITPROIMPOS.CDIMPOSTO
            AND NRSEQITPRO   = '3';
         UPDATE ITEMPROIMPOS
            SET VRCONTITIMP = V_VRCONTITIMP
          WHERE CDFILIAL = P_FILIAL
            AND NRLANCTONF = P_LANCTONF
            AND NRSEQITPROD = C_TRABITPROIMPOS.NRSEQITPROD
            AND CDIMPOSTO = C_TRABITPROIMPOS.CDIMPOSTO
            AND NRITPROIMPOS = '3';
      END IF;
   END LOOP;
   FOR C_TRABITPROIMPOS IN (SELECT CDIMPOSTO, VRALIQITEM, VRPERREDBCIT, VRPARDEDIT,
                                   CDFISCALIT, CDSITUTRIBIT, CDFISCOPERIT, CDSUFXCFOPIT,
                                   IDDIFALIQCUSPRI,
                                   SUM(VRCONTITIMP) AS VRCONTITIMP,
                                   SUM(VRBASECALCIT) AS VRBASECALCIT,
                                   SUM(VRIMPOSTOIT) AS VRIMPOSTOIT
                              FROM ITEMPROIMPOS
                             WHERE CDFILIAL = P_FILIAL
                               AND NRLANCTONF = P_LANCTONF
                               AND NRITPROIMPOS = '3'
                             GROUP BY CDIMPOSTO, VRALIQITEM, VRPERREDBCIT, VRPARDEDIT,
                                      CDFISCALIT, CDSITUTRIBIT, CDFISCOPERIT, CDSUFXCFOPIT,
                                      IDDIFALIQCUSPRI) LOOP
      UPDATE IMPOSTONF
         SET VRCONTABILNF = C_TRABITPROIMPOS.VRCONTITIMP,
             VRBASECALCNF = C_TRABITPROIMPOS.VRBASECALCIT,
             VRIMPOSTONF  = C_TRABITPROIMPOS.VRIMPOSTOIT
       WHERE CDFILIAL = P_FILIAL
         AND NRLANCTONF = P_LANCTONF
         AND CDIMPOSTO = C_TRABITPROIMPOS.CDIMPOSTO
         AND IDIMPOSTONF = '3'
         AND VRALIQNF = C_TRABITPROIMPOS.VRALIQITEM
         AND VRPERREDBCNF = C_TRABITPROIMPOS.VRPERREDBCIT
         AND VRPARDEDNF = C_TRABITPROIMPOS.VRPARDEDIT
         AND CDFISCALNF = C_TRABITPROIMPOS.CDFISCALIT
         AND CDSITUTRIBNF = C_TRABITPROIMPOS.CDSITUTRIBIT
         AND CDFISCOPERNF = C_TRABITPROIMPOS.CDFISCOPERIT
         AND NVL(IDDIFALIQCUSPRN, 'N') = NVL(C_TRABITPROIMPOS.IDDIFALIQCUSPRI, 'N')
         AND NVL(CDSUFXCFOPNF, 'N') = NVL(C_TRABITPROIMPOS.CDSUFXCFOPIT, 'N');
   END LOOP;
   -- Atualiza custo do produto em estoque caso o diferencial compoem o custo do produto
   FOR C_ITLANCTOEST IN (SELECT NRSEQITPROD, VRBRUTITEM, P.VRFATOCONV, QTITEMPROD, VRCONTITEM
                         FROM ITEMPRODUTO IP, PRODUTO P, PRODFILI PF
                         WHERE IP.CDFILIAL    = P_FILIAL     AND
                               IP.NRLANCTONF  = P_LANCTONF   AND
                               P.CDPRODUTO    = IP.CDPRODUTO AND
                               PF.CDFILIAL    = V_CDFILIRECE AND
                               PF.CDPRODUTO   = P.CDPRODESTO) LOOP
      V_VRIMPDIFALIQ := 0;
      SELECT NVL(SUM(VRIMPOSTOIT), 0)
        INTO V_VRIMPDIFALIQ
        FROM ITEMPROIMPOS
       WHERE CDFILIAL = P_FILIAL
         AND NRLANCTONF = P_LANCTONF
         AND NRSEQITPROD = C_ITLANCTOEST.NRSEQITPROD
         AND IDDIFALIQCUSPRI = 'S';
      IF V_VRIMPDIFALIQ > 0 THEN
         UPDATE ITEMPRODUTO
            SET VRCONTITEM   = VRCONTITEM + V_VRIMPDIFALIQ
          WHERE (CDFILIAL    = P_FILIAL)    AND
                (NRLANCTONF  = P_LANCTONF ) AND
                (NRSEQITPROD = C_ITLANCTOEST.NRSEQITPROD);
         IF (P_TIPOOPER = '06') THEN
            UPDATE ITLANCTOEST
               SET VRLANCTOBRUT = (V_VRIMPDIFALIQ / C_ITLANCTOEST.QTITEMPROD) / C_ITLANCTOEST.VRFATOCONV,
                   VRLANCTOEST = (V_VRIMPDIFALIQ / C_ITLANCTOEST.QTITEMPROD) / C_ITLANCTOEST.VRFATOCONV,
                   VRCUSTENTR = VRCUSTENTR + V_VRIMPDIFALIQ
             WHERE CDFILIAL = P_FILIAL
               AND NRLANCESTQ = P_LANCESTQ
               AND NRSEQUITEM = C_ITLANCTOEST.NRSEQITPROD;
         ELSE
            UPDATE ITLANCTOEST
               SET VRLANCTOBRUT = ((C_ITLANCTOEST.VRBRUTITEM + V_VRIMPDIFALIQ) / C_ITLANCTOEST.QTITEMPROD) / C_ITLANCTOEST.VRFATOCONV,
                   VRLANCTOEST = ((C_ITLANCTOEST.VRCONTITEM + V_VRIMPDIFALIQ) / C_ITLANCTOEST.QTITEMPROD) / C_ITLANCTOEST.VRFATOCONV,
                   VRCUSTENTR = VRCUSTENTR + V_VRIMPDIFALIQ
             WHERE CDFILIAL = P_FILIAL
               AND NRLANCESTQ = P_LANCESTQ
               AND NRSEQUITEM = C_ITLANCTOEST.NRSEQITPROD;
         END IF;
      END IF;
   END LOOP;
   DELETE FROM REGRANOTA
    WHERE CDFILIAL = P_FILIAL
      AND NRLANCTONF = P_LANCTONF;
   FOR C_IMPOSNOTA IN (SELECT DISTINCT CDREGRAIT
                         FROM ITEMPROIMPOS
                        WHERE CDFILIAL = P_FILIAL
                          AND NRLANCTONF = P_LANCTONF
                          AND CDREGRAIT IS NOT NULL
                        ORDER BY CDREGRAIT)
   LOOP
      FOR C_REGRAMSG IN (SELECT CDREGRAFISC, DSMENSREGRAFISC
                           FROM TABLE(MSG_REGRAFISCAL(C_IMPOSNOTA.CDREGRAIT, P_EMPRESA, 'E', P_TIPOOPER, P_INSCESTA)) M
                          WHERE NOT EXISTS(SELECT DSDADOADIC
                                             FROM DADOSADIC
                                            WHERE (CDFILIAL   = P_FILIAL)   AND
                                                  (NRLANCTONF = P_LANCTONF) AND
                                                  (DSDADOADIC = M.DSMENSREGRAFISC))) LOOP
          INSERT INTO DADOSADIC(CDFILIAL, NRLANCTONF, NRDADOADIC, DSDADOADIC)
                         VALUES(P_FILIAL, P_LANCTONF, V_DADOADIC, C_REGRAMSG.DSMENSREGRAFISC);
          V_DADOADIC := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_DADOADIC) + 1)),3,0);
      END LOOP;
      INSERT INTO REGRANOTA(CDFILIAL, NRLANCTONF, CDREGRAFISC)
                         VALUES(P_FILIAL, P_LANCTONF, C_IMPOSNOTA.CDREGRAIT);
   END LOOP;
   IF (V_IDCALCVRTOTANFE = 'S') THEN
      UPDATE NOTAFISCAL
         SET VRNOTAFISC = NVL(V_TOTALNOTA,0)
       WHERE CDFILIAL   = P_FILIAL
         AND NRLANCTONF = P_LANCTONF;
      IF (V_IDUTILVENC = 'S') THEN
         SELECT COUNT(*)
           INTO V_POSSUIFINANC
           FROM CONTAPAGAR
          WHERE CDFILIAL   = P_FILIAL
            AND NRLANCTONF = P_LANCTONF;
         IF NOT(V_POSSUIFINANC > 0) THEN
            GERA_DADOS_FINANCEIRO(P_FILIAL, P_LANCTONF, P_FILIAL, 'L', P_RESULTADO);
         END IF;
      END IF;
   END IF;   
   /*Chamar a procedure para gerar financeiro. */
   IF (V_IDNFRETIND = 'S') OR (V_IDSTATUS = 'I') THEN
      V_POSSUIFINANC := 0;
      IF (V_IDUTILVENC = 'S') THEN
         SELECT COUNT(*)
           INTO V_POSSUIFINANC
           FROM CONTAPAGAR
          WHERE CDFILIAL   = P_FILIAL
            AND NRLANCTONF = P_LANCTONF;
         IF NOT(V_POSSUIFINANC > 0) THEN
            GERA_DADOS_FINANCEIRO(P_FILIAL, P_LANCTONF, P_FILIAL, 'L', P_RESULTADO);
         END IF;
      END IF;
   END IF;
   DELETE
     FROM INFOPAGANFE
    WHERE CDFILIAL = P_FILIAL
      AND NRLANCTONF = P_LANCTONF;
   IF (NVL(P_AUDIT, 'N') <> 'S') THEN
      CONFERE_ERROS_NF(P_FILIAL, P_LANCTONF, V_TOTALNOTA);
   END IF;
   IF P_TIPOOPER = '01' THEN
      CONHECIMENTO_TRANSPORTE(P_FILIAL, P_LANCTONF, P_LANCESTQ);
   END IF;
   UPDATE TRABITPROIMPOS
      SET CDFISCIMPOIT = '2',
          VRBCALCIMPOIT = 0
    WHERE CDFILIMPOIT = P_FILIAL
      AND NRLANCIMPOIT = P_LANCTONF
      AND VRREDBCIMPOIT > 0.00
      AND NRSEQITPRO = '2';
   FOR C_CARGA IN (SELECT DISTINCT CDIMPOSTO
                     FROM IMPOSTONF
                    WHERE CDFILIAL = P_FILIAL
                      AND NRLANCTONF = P_LANCTONF) LOOP
      V_CARGA := VALOR_CARGA_TRIBUTARIA(C_CARGA.CDIMPOSTO, P_FILIAL, P_LANCTONF);
      IF V_CARGA > 0 THEN
         UPDATE IMPOSTONF
            SET VRIMPCARGATRIBI = V_CARGA
           WHERE CDFILIAL = P_FILIAL
             AND NRLANCTONF = P_LANCTONF
             AND CDIMPOSTO = C_CARGA.CDIMPOSTO
             AND NRIMPOSNF = (SELECT MAX(NRIMPOSNF)
                                      FROM IMPOSTONF
                                     WHERE CDFILIAL = P_FILIAL
                                       AND NRLANCTONF = P_LANCTONF
                                       AND CDIMPOSTO = C_CARGA.CDIMPOSTO);
      END IF;
   END LOOP;
   DELETE ALIQTEMP
   WHERE  NRALIQTEMP = P_FILIAL||P_LANCTONF;
   /* Rotina para geração de saída no estoque (filial agente de terceirização) */
   IF (NVL(P_AUDIT, 'N') <> 'S') THEN
      BEGIN
         SELECT MAX(CDFORNAGETERC)
           INTO V_CDFORNAGETERC
           FROM ITEMNOTAFISC I, NOTAFISCAL N, FILIAL F
          WHERE I.CDFILIALIT   = P_FILIAL
            AND I.NRLANCTONFIT = P_LANCTONF
            AND N.CDFILIAL     = I.CDFILIAL
            AND N.NRLANCTONF   = I.NRLANCTONF
            AND F.CDFILIAL     = N.CDFILIEMIT;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_CDFORNAGETERC := NULL;
      END;
      IF (V_CDFORNAGETERC IS NULL) AND (V_IDORIGDESTNF = 'F') THEN
         BEGIN
            SELECT CDFILIAL, CDFILIOLAGETERC
              INTO V_CDFILIAGENT, V_CDFILIOLAGETERC
              FROM FILIAL
             WHERE CDFORNAGETERC = P_FORNECED;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_CDFILIAGENT := NULL; V_CDFILIOLAGETERC := NULL;
         END;
         IF NOT V_CDFILIAGENT IS NULL THEN
            BEGIN
               SELECT CDEMPRESA, CDINSCESTA, CDINSCMUNI
                 INTO V_CDEMPRESAAG, V_CDINSCESTAAG, V_CDINSCMUNIAG
                 FROM FILIAL
                WHERE CDFILIAL  = V_CDFILIAGENT;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_CDEMPRESAAG  := NULL;
                  V_CDINSCESTAAG := NULL;
                  V_CDINSCMUNIAG := NULL;
            END;
            IF (V_IDCTRLESTQ = 'S') THEN
               FOR C_ITLANCTOEST IN (SELECT IP.NRSEQITPROD, IP.VRBRUTITEM, IP.QTITEMPROD, IP.CDPRODUTO,
                                            IP.VRCONTITEM, IP.VRUNITITEM, IP.VRTOTAITEM, P.CDARVPROD,
                                            P.NMPRODUTO, IP.VRDESCITEM, P.CDPRODESTO, NVL(P.VRFATOCONV, 1) AS VRFATOCONV,
                                            NVL(IDORIGEMPROD, 'N') IDORIGEMPROD
                                       FROM ITEMPRODUTO IP, PRODUTO P, PRODFILI PF
                                      WHERE IP.CDFILIAL    = P_FILIAL
                                        AND IP.NRLANCTONF  = P_LANCTONF
                                        AND P.CDPRODUTO    = IP.CDPRODUTO
                                        AND PF.CDFILIAL    = V_CDFILIRECE
                                        AND PF.CDPRODUTO   = P.CDPRODESTO
                                        AND NVL(PF.IDCNTRESTOQ, W_S) <> W_N) LOOP
                  BEGIN
                     SELECT NVL(NVL(P.CDALMOXARIFE, F.CDALMOXARIFE), ' ') AS CDALMOXARIFE, NVL(NVL(P.CDLOCALESTOQ, F.CDLOCALESTOQ), ' ') AS CDLOCALESTOQ,
                            NVL(F.IDUTILLOTE, 'N') AS IDUTILLOTE
                       INTO V_CDALMOXARIFEAG, V_CDLOCALESTOQAG, V_IDUTILLOTEAG
                       FROM PARAMFILIAL F, PRODFILI P
                      WHERE F.CDFILIAL  = V_CDFILIAGENT
                        AND P.CDFILIAL  = V_CDFILIAGENT
                        AND P.CDPRODUTO = C_ITLANCTOEST.CDPRODESTO;
                  EXCEPTION
                     WHEN NO_DATA_FOUND THEN
                        V_CDALMOXARIFEAG := ' ';
                        V_CDLOCALESTOQAG := ' ';
                        V_IDUTILLOTEAG   := 'N';
                  END;
                  IF V_IDUTILLOTEAG = 'S' THEN
                     IF (V_NRLOTEESTQAG IS NULL) OR (V_NRLOTEESTQAG = ' ') THEN
                        PRXLOTEPRODEST(V_CDFILIAGENT, P_INIVALID, C_ITLANCTOEST.CDPRODESTO, V_NRLOTEESTQAG);
                        V_NRSUBLOTEAG := ' ';
                     END IF;
                  ELSE
                     V_NRLOTEESTQAG := ' ';
                     V_NRSUBLOTEAG  := ' ';
                  END IF;
                  IF V_BOLANESTSAIDAG THEN
                     /* Gerando o registro na tabela LANCTOESTOQ para a entrada na filial relacionada ao agente de terceirização */
                     NOVO_CODIGO_NT('LANCNF/FILIAL' || V_CDFILIAGENT, V_NRLANCTONFAG);
                     V_NRLANCTONFAG := SUBSTR(V_NRLANCTONFAG, 11, 10);
                     NOVO_CODIGO_NT('LANCTOEST'||V_CDFILIAGENT, V_NRLANESTENTRAG);
                     V_NRLANESTENTRAG := SUBSTR(V_NRLANESTENTRAG, 11, 10);
                     V_TPOPERREMESSA := NULL;
                     BEGIN
                        SELECT CDTPOOPREMESSA
                          INTO V_TPOPERREMESSA
                          FROM PARAMGERAL
                         WHERE CDPARGERAL = '0001';
                     EXCEPTION
                     WHEN NO_DATA_FOUND THEN
                        V_TPOPERREMESSA := NULL;
                     END;
                     IF (V_TPOPERREMESSA IS NULL) THEN
                        RAISE_APPLICATION_ERROR(-20501, 'Tipo de operação para geração de lançamento de estoque deve ser informado - (Parâmetros para Documentos Fiscais de Saída - Operador Logístico)', TRUE);
                     END IF;
                     INSERT INTO NOTAFISCAL
                        (CDFILIAL, CDEMPRESA, CDINSCESTA, CDINSCMUNI, NRLANCTONF, NRINSJURNF,
                         IDTPIJURNF, DTEMISSAO, NRNOTAFISC, CDSERIE, IDBLOQUEADO, IDDOCFISCAL,
                         IDDOCFINANC, VRPRODUTOS, VRNOTAFISC, IDENTRSAIDOP, CDTIPOOPER, CDCLIENTE,
                         DTENTRSAID, CDFILIEMIT, IDORIGDESTNF, CDFORNECED, CDFILIRECE, NRAPURACFAT)
                     VALUES
                        (V_CDFILIAGENT, V_CDEMPRESAAG, V_CDINSCESTAAG, V_CDINSCMUNIAG, V_NRLANCTONFAG, V_NRINSJURNF,
                         V_IDTPIJURNF, P_INIVALID, NULL, NULL, 'N', 'N',
                         'S', V_VRPRODUTOS, V_VRNOTAFISC, 'S', V_TPOPERREMESSA, P_FORNECED,
                         P_INIVALID, V_CDFILIAGENT, 'C', NULL, NULL, NULL);
                     INSERT INTO ITEMNOTAFISC
                        (CDFILIAL, NRLANCTONF, NRSEQUITNOTA, CDFILIALIT, NRLANCTONFIT)
                     VALUES
                        (V_CDFILIAGENT, V_NRLANCTONFAG, '001', P_FILIAL, P_LANCTONF);
                     INSERT INTO LANCTOESTOQ
                        (CDFILIAL, CDFILIMOVI, NRLANCESTQ, IDTPLANCTO,
                         DTLANCESTQ, DSLANCESTQ,
                         NRLANCTONF, CDOPERADOR, CDALMOXARIFE, CDLOCALESTOQ)
                     VALUES
                        (V_CDFILIAGENT, V_CDFILIAGENT, V_NRLANESTENTRAG, '4',
                         P_INIVALID, 'NF Retorno Armazenagem - lanç. ' || V_CDFILIRECE || ' ' || P_LANCTONF,
                         V_NRLANCTONFAG, P_CDOPERADOR, NULL, NULL);
                     V_BOLANESTSAIDAG := FALSE;
                  END IF;
                  INSERT INTO ITEMPRODUTO
                     (CDFILIAL, NRLANCTONF, NRSEQITPROD, CDPRODUTO,
                      CDPRODEMIS, DSPRODEMIS, IDATUVRESTOQ, QTITEMPROD,
                      VRUNITITEM, VRDESCITEM, VRTOTAITEM, VRCONTITEM,
                      VRBRUTITEM, IDCONFORITEM, CDFILIMOVI,
                      CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, CDPRODMOVI)
                  VALUES
                     (V_CDFILIAGENT, V_NRLANCTONFAG, C_ITLANCTOEST.NRSEQITPROD, C_ITLANCTOEST.CDPRODUTO,
                      C_ITLANCTOEST.CDARVPROD, C_ITLANCTOEST.NMPRODUTO, 'S', C_ITLANCTOEST.QTITEMPROD,
                      C_ITLANCTOEST.VRUNITITEM, C_ITLANCTOEST.VRDESCITEM, C_ITLANCTOEST.VRTOTAITEM, C_ITLANCTOEST.VRCONTITEM,
                      C_ITLANCTOEST.VRBRUTITEM, 'S', V_CDFILIAGENT,
                      V_CDALMOXARIFEAG, V_CDLOCALESTOQAG, V_NRLOTEESTQAG, V_NRSUBLOTEAG,
                      C_ITLANCTOEST.CDPRODESTO);
                  INSERT INTO ITLANCTOEST
                     (CDFILIAL, NRLANCESTQ, NRSEQUITEM, CDPRODUTO,
                      CDPRODMOVI, VRUNILANCTO, VRTOTLANCTO, QTTOTLANCTO,
                      QTLANCTOEST, IDTIPOMOVI, DTLANCMOVI, IDORDEMCLC,
                      VRLANCTOBRUT, VRLANCTOEST, CDFILIMOVI, CDALMOXARIFE,
                      CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, IDORIGEMPROD)
                  VALUES
                     (V_CDFILIAGENT, V_NRLANESTENTRAG, C_ITLANCTOEST.NRSEQITPROD, C_ITLANCTOEST.CDPRODUTO,
                       C_ITLANCTOEST.CDPRODESTO, C_ITLANCTOEST.VRUNITITEM, C_ITLANCTOEST.VRTOTAITEM, C_ITLANCTOEST.QTITEMPROD,
                      C_ITLANCTOEST.QTITEMPROD * C_ITLANCTOEST.VRFATOCONV, '4', P_INIVALID, '9',
                      C_ITLANCTOEST.VRBRUTITEM, C_ITLANCTOEST.VRTOTAITEM, V_CDFILIAGENT, V_CDALMOXARIFEAG,
                      V_CDLOCALESTOQAG, V_NRLOTEESTQAG, V_NRSUBLOTEAG, C_ITLANCTOEST.IDORIGEMPROD);
               END LOOP;
            END IF;  
            -- se possuir agente de terceirização e filial OL será efetuada alteração no pedido OL e na reserva do pedido
            IF NOT V_CDFILIOLAGETERC IS NULL THEN
               FOR C_INTG_ITENS IN (SELECT I.NRAUTOFORN, P.CDPRODUTO, SUM(I.QTITEMPROD) AS QTITEMPROD
                                      FROM INTG_NOTAFISCAL N, INTG_ITEMPRODUTO I, PRODFORNXML P
                                     WHERE N.NRACESSONFE = V_NRACESSONFE
                                       AND I.NRACESSONFE = N.NRACESSONFE
                                       AND P.CDFORNECED   = N.CDFORNECED
                                       AND P.CDPRODUTOXML = I.CDPRODUTO
                                     GROUP BY I.NRAUTOFORN, P.CDPRODUTO)
               LOOP
                  FOR C_ITEM_PED IN (SELECT IT.CDFILDEST, IT.CDFILLANC, IT.NRPEDEXOL, IT.CDMARCA, IT.CDPRODUTO, IT.DTPROGENPEOL
                                       FROM PEDIDOEXOL P, ITEMPEDEXOL IT, RELACPRODOL R
                                      WHERE P.USR_NRPEDIDO = C_INTG_ITENS.NRAUTOFORN
                                        AND IT.CDFILDEST = P.CDFILDEST
                                        AND IT.CDFILLANC = P.CDFILLANC
                                        AND IT.NRPEDEXOL = P.NRPEDEXOL
                                        AND IT.IDBAIXENPEOL IS NULL
                                        AND R.CDPRARVORIG = C_INTG_ITENS.CDPRODUTO
                                        AND IT.CDPRODUTO  = R.CDPRARVORIG
                                        AND IT.CDMARCA    = R.CDMARCA
                                      ORDER BY IT.CDPRODUTO, IT.DTPROGENPEOL)
                  LOOP
                     -- altera a qtde atendida do pedido OL com a qtde. da nota fiscal somente para a primeira data de entrega
                     UPDATE ITEMPEDEXOL
                        SET QTATENDPEDOL = C_INTG_ITENS.QTITEMPROD
                      WHERE CDFILDEST    = C_ITEM_PED.CDFILDEST
                        AND CDFILLANC    = C_ITEM_PED.CDFILLANC
                        AND NRPEDEXOL    = C_ITEM_PED.NRPEDEXOL
                        AND CDMARCA      = C_ITEM_PED.CDMARCA
                        AND CDPRODUTO    = C_ITEM_PED.CDPRODUTO
                        AND DTPROGENPEOL = C_ITEM_PED.DTPROGENPEOL;
                     -- altera a qtde reservada do pedido OL e a filial da reserva do pedido para a filial OL
                     UPDATE RESERVAPEDEXOL
                        SET CDFILRESOL    = V_CDFILIOLAGETERC,
                            QTRESERVESTOL = C_INTG_ITENS.QTITEMPROD,
                            CDFILIAL      = P_FILIAL,
                            NRLANCTONF    = P_LANCTONF
                      WHERE CDFILDEST    = C_ITEM_PED.CDFILDEST
                        AND CDFILLANC    = C_ITEM_PED.CDFILLANC
                        AND NRPEDEXOL    = C_ITEM_PED.NRPEDEXOL
                        AND CDMARCA      = C_ITEM_PED.CDMARCA
                        AND CDPRODUTO    = C_ITEM_PED.CDPRODUTO
                        AND DTPROGENPEOL = C_ITEM_PED.DTPROGENPEOL;
                     EXIT;
                  END LOOP;
               END LOOP;
            END IF;
         END IF;
         -- Atualiza valor contábil do produto considerando o custo médio do produto em estoque caso o parâmetro esteja marcado
         IF (V_IDOPERDEVONF = W_S AND V_IDUTCUSORIGEST = W_S) THEN
            FOR C_ITLANCTOEST IN (SELECT CDFILIMOVI, NRSEQITPROD,IP.CDPRODUTO,VRUNITITEM,VRTOTAITEM,
                                         QTITEMPROD,CDPRODESTO,VRBRUTITEM,VRDESCITEM,VRCONTITEM,
                                         NVL(IP.CDALMOXARIFE, ' ') CDALMOXARIFE,
                                         NVL(IP.CDLOCALESTOQ, ' ') CDLOCALESTOQ,
                                         NVL(NRLOTEESTQ, ' ') NRLOTEESTQ,
                                         NVL(NRSUBLOTE, ' ') NRSUBLOTE,
                                         P.VRFATOCONV
                                   FROM ITEMPRODUTO IP, PRODUTO P
                                  WHERE IP.CDFILIAL    = P_FILIAL     AND
                                        IP.NRLANCTONF  = P_LANCTONF   AND
                                        P.CDPRODUTO    = IP.CDPRODUTO) LOOP
               V_VRCUSTENTR := ROUND(CUSTO_PRODUTO_LCEST(C_ITLANCTOEST.CDFILIMOVI, C_ITLANCTOEST.CDPRODESTO, V_CDTIPCUSTEST, P_INIVALID,
                                                         V_DTATUAL, C_ITLANCTOEST.CDALMOXARIFE, C_ITLANCTOEST.CDLOCALESTOQ,
                                                         C_ITLANCTOEST.NRLOTEESTQ, C_ITLANCTOEST.NRSUBLOTE), 5);
               UPDATE ITEMPRODUTO
                  SET VRCONTITEM = ((C_ITLANCTOEST.QTITEMPROD * C_ITLANCTOEST.VRFATOCONV) * V_VRCUSTENTR)
                WHERE CDFILIAL =  P_FILIAL
                  AND NRLANCTONF = P_LANCTONF
                  AND NRSEQITPROD = C_ITLANCTOEST.NRSEQITPROD;
            END LOOP;
         END IF;
      END IF;
   END IF;
---------------------------------------------------------------------------------------------------------
END;
/
DECLARE 
   V_NOVOCODIGO VARCHAR2(20);
   V_EXISTE INTEGER;
BEGIN
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR800000';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR800000', 'Imunidade ou não icidência; Imunidade ou não incidência do imposto reconhecida judicialmente', '01/08/2018', '02/08/2018'); 
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR800000', 'Imunidade ou não incidência; Imunidade ou não incidência do imposto reconhecida judicialmente', '03/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR800001';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR800001', 'Imunidade ou não icidência; Não incidência de que trata o inciso I do “caput” do art. 3º do RICMS/2017', '01/08/2018', '02/08/2018');
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR800001', 'Imunidade ou não incidência; Não incidência de que trata o inciso I do “caput” do art. 3º do RICMS/2017', '03/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR800002';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR800002', 'Imunidade ou não icidência; Não incidência de que trata o inciso II do “caput” do art. 3º do RICMS/2017', '01/08/2018', '02/08/2018');
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR800002', 'Imunidade ou não incidência; Não incidência de que trata o inciso II do “caput” do art. 3º do RICMS/2017', '03/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR800003';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR800003', 'Imunidade ou não icidência; Não incidência de que trata o inciso III do “caput” do art. 3º do RICMS/2017', '01/08/2018', '02/08/2018');
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR800003', 'Imunidade ou não incidência; Não incidência de que trata o inciso III do “caput” do art. 3º do RICMS/2017', '03/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR800004';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR800004', 'Imunidade ou não icidência; Não incidência de que trata o inciso IV do “caput” do art. 3º do RICMS/2017', '01/08/2018', '02/08/2018');
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR800004', 'Imunidade ou não incidência; Não incidência de que trata o inciso IV do “caput” do art. 3º do RICMS/2017', '03/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR800005';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR800005', 'Imunidade ou não icidência; Não incidência de que trata o inciso V do “caput” do art. 3º do RICMS/2017', '01/08/2018', '02/08/2018');
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR800005', 'Imunidade ou não incidência; Não incidência de que trata o inciso V do “caput” do art. 3º do RICMS/2017', '03/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR800006';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR800006', 'Imunidade ou não icidência; Não incidência de que trata o inciso VI do “caput” do art. 3º do RICMS/2017', '01/08/2018', '02/08/2018');
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR800006', 'Imunidade ou não incidência; Não incidência de que trata o inciso VI do “caput” do art. 3º do RICMS/2017', '03/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR800007';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR800007', 'Imunidade ou não icidência; Não incidência de que trata o inciso VII do “caput” do art. 3º do RICMS/2017', '01/08/2018', '02/08/2018');
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR800007', 'Imunidade ou não incidência; Não incidência de que trata o inciso VII do “caput” do art. 3º do RICMS/2017', '03/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR800008';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR800008', 'Imunidade ou não icidência; Não incidência de que trata o inciso VIII do “caput” do art. 3º do RICMS/2017', '01/08/2018', '02/08/2018');
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR800008', 'Imunidade ou não incidência; Não incidência de que trata o inciso VIII do “caput” do art. 3º do RICMS/2017', '03/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR800009';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR800009', 'Imunidade ou não icidência; Não incidência de que trata o inciso IX do “caput” do art. 3º do RICMS/2017', '01/08/2018', '02/08/2018');
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR800009', 'Imunidade ou não incidência; Não incidência de que trata o inciso IX do “caput” do art. 3º do RICMS/2017', '03/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR800010';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR800010', 'Imunidade ou não icidência; Não incidência de que trata o inciso X do “caput” do art. 3º do RICMS/2017', '01/08/2018', '02/08/2018');
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR800010', 'Imunidade ou não incidência; Não incidência de que trata o inciso X do “caput” do art. 3º do RICMS/2017', '03/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR800011';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR800011', 'Imunidade ou não icidência; Não incidência de que trata o inciso XI do “caput” do art. 3º do RICMS/2017', '01/08/2018', '02/08/2018');
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR800011', 'Imunidade ou não incidência; Não incidência de que trata o inciso XI do “caput” do art. 3º do RICMS/2017', '03/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR800012';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR800012', 'Imunidade ou não icidência; Não incidência de que trata o inciso XIII do “caput” do art. 3º do RICMS/2017', '01/08/2018', '02/08/2018');
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR800012', 'Imunidade ou não incidência; Não incidência de que trata o inciso XIII do “caput” do art. 3º do RICMS/2017', '03/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR800013';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR800013', 'Imunidade ou não icidência; Não incidência de que trata o inciso XVI do “caput” do art. 3º do RICMS/2017', '01/08/2018', '02/08/2018');
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR800013', 'Imunidade ou não incidência; Não incidência de que trata o inciso XIV do “caput” do art. 3º do RICMS/2017', '03/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR800014';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR800014', 'Imunidade ou não icidência; Não incidência de que trata o inciso XV do “caput” do art. 3º do RICMS/2017', '01/08/2018', '02/08/2018');
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR800014', 'Imunidade ou não incidência; Não incidência de que trata o inciso XV do “caput” do art. 3º do RICMS/2017', '03/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR800015';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR800015', 'Imunidade ou não icidência; Não incidência de que trata o inciso I do parágrafo único do art. 3º do RICMS/2017', '01/08/2018', '02/08/2018');
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR800015', 'Imunidade ou não incidência; Não incidência de que trata o inciso I do parágrafo único do art. 3º do RICMS/2017', '03/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR800016';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR800016', 'Imunidade ou não icidência; Não incidência de que trata o inciso II do parágrafo único do art. 3º do RICMS/2017', '01/08/2018', '02/08/2018');
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR800016', 'Imunidade ou não incidência; Não incidência de que trata o inciso II do parágrafo único do art. 3º do RICMS/2017', '03/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR809999';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR809999', 'Imunidade ou não icidência; Não Incidência prevista em regime especial e/ou programa de incentivo', '01/08/2018', '02/08/2018');
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR809999', 'Imunidade ou não incidência; Não Incidência prevista em regime especial e/ou programa de incentivo', '03/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR800017';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR800017', 'Imunidade ou não incidência; Não incidência de que trata o inciso XII do “caput” do art. 3º do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810000';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810000', 'Isenção; Isenção do pagamento do imposto reconhecida judicialmente', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810001';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810001', 'Isenção; Isenção prevista no item 1 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810002';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810002', 'Isenção; Isenção prevista no item 2 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810003';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810003', 'Isenção; Isenção prevista no item 3 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810004';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810004', 'Isenção; Isenção prevista no item 4 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810005';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810005', 'Isenção; Isenção prevista no item 5 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810006';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810006', 'Isenção; Isenção prevista no item 6 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810007';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810007', 'Isenção; Isenção prevista no item 7 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810008';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810008', 'Isenção; Isenção prevista no item 8 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810009';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810009', 'Isenção; Isenção prevista no item 9 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810010';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810010', 'Isenção; Isenção prevista no item 10 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810011';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810011', 'Isenção; Isenção prevista no item 11 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810012';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810012', 'Isenção; Isenção prevista no item 12 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810013';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810013', 'Isenção; Isenção prevista no item 13 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810014';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810014', 'Isenção; Isenção prevista no item 14 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810015';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810015', 'Isenção; Isenção prevista no item 15 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810016';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810016', 'Isenção; Isenção prevista no item 16 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810017';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810017', 'Isenção; Isenção prevista no item 17 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810018';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810018', 'Isenção; Isenção prevista no item 18 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810019';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810019', 'Isenção; Isenção prevista no item 19 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810020';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810020', 'Isenção; Isenção prevista no item 20 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810021';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810021', 'Isenção; Isenção prevista no item 21 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810022';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810022', 'Isenção; Isenção prevista no item 22 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810023';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810023', 'Isenção; Isenção prevista no item 23 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810024';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810024', 'Isenção; Isenção prevista no item 24 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810025';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810025', 'Isenção; Isenção prevista no item 25 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810026';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810026', 'Isenção; Isenção prevista no item 26 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810027';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810027', 'Isenção; Isenção prevista no item 27 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810028';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810028', 'Isenção; Isenção prevista no item 28 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810029';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810029', 'Isenção; Isenção prevista no item 29 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810030';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810030', 'Isenção; Isenção prevista no item 30 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810031';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810031', 'Isenção; Isenção prevista no item 31 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810032';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810032', 'Isenção; Isenção prevista no item 32 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810033';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810033', 'Isenção; Isenção prevista no item 33 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810034';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810034', 'Isenção; Isenção prevista no item 34 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810035';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810035', 'Isenção; Isenção prevista no item 35 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810036';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810036', 'Isenção; Isenção prevista no item 36 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810037';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810037', 'Isenção; Isenção prevista no item 37 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810038';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810038', 'Isenção; Isenção prevista no item 38 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810039';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810039', 'Isenção; Isenção prevista no item 39 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810040';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810040', 'Isenção; Isenção prevista no item 40 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810041';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810041', 'Isenção; Isenção prevista no item 41 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810042';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810042', 'Isenção; Isenção prevista no item 42 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810043';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810043', 'Isenção; Isenção prevista no item 43 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810044';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810044', 'Isenção; Isenção prevista no item 44 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810045';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810045', 'Isenção; Isenção prevista no item 45 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810046';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810046', 'Isenção; Isenção prevista no item 46 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810047';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810047', 'Isenção; Isenção prevista no item 47 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810048';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810048', 'Isenção; Isenção prevista no item 48 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810049';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810049', 'Isenção; Isenção prevista no item 49 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810050';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810050', 'Isenção; Isenção prevista no item 50 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810051';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810051', 'Isenção; Isenção prevista no item 51 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810052';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810052', 'Isenção; Isenção prevista no item 52 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810053';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810053', 'Isenção; Isenção prevista no item 53 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810054';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810054', 'Isenção; Isenção prevista no item 54 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810055';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810055', 'Isenção; Isenção prevista no item 55 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810056';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810056', 'Isenção; Isenção prevista no item 56 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810057';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810057', 'Isenção; Isenção prevista no item 57 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810058';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810058', 'Isenção; Isenção prevista no item 58 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810059';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810059', 'Isenção; Isenção prevista no item 59 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810060';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810060', 'Isenção; Isenção prevista no item 60 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810061';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810061', 'Isenção; Isenção prevista no item 61 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810062';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810062', 'Isenção; Isenção prevista no item 62 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810063';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810063', 'Isenção; Isenção prevista no item 63 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810064';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810064', 'Isenção; Isenção prevista no item 64 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810065';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810065', 'Isenção; Isenção prevista no item 65 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810066';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810066', 'Isenção; Isenção prevista no item 66 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810067';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810067', 'Isenção; Isenção prevista no item 67 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810068';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810068', 'Isenção; Isenção prevista no item 68 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810069';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810069', 'Isenção; Isenção prevista no item 69 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810070';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810070', 'Isenção; Isenção prevista no item 70 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810071';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810071', 'Isenção; Isenção prevista no item 71 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810072';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810072', 'Isenção; Isenção prevista no item 72 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810073';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810073', 'Isenção; Isenção prevista no item 73 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810074';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810074', 'Isenção; Isenção prevista no item 74 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810075';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810075', 'Isenção; Isenção prevista no item 75 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810076';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810076', 'Isenção; Isenção prevista no item 76 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810077';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810077', 'Isenção; Isenção prevista no item 77 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810078';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810078', 'Isenção; Isenção prevista no item 78 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810079';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810079', 'Isenção; Isenção prevista no item 79 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810080';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810080', 'Isenção; Isenção prevista no item 80 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810081';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810081', 'Isenção; Isenção prevista no item 81 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810082';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810082', 'Isenção; Isenção prevista no item 82 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810083';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810083', 'Isenção; Isenção prevista no item 83 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810084';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810084', 'Isenção; Isenção prevista no item 84 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810085';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810085', 'Isenção; Isenção prevista no item 85 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810086';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810086', 'Isenção; Isenção prevista no item 86 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810087';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810087', 'Isenção; Isenção prevista no item 87 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810088';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810088', 'Isenção; Isenção prevista no item 88 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810089';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810089', 'Isenção; Isenção prevista no item 89 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810090';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810090', 'Isenção; Isenção prevista no item 90 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810091';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810091', 'Isenção; Isenção prevista no item 91 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810092';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810092', 'Isenção; Isenção prevista no item 92 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810093';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810093', 'Isenção; Isenção prevista no item 93 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810094';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810094', 'Isenção; Isenção prevista no item 94 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810095';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810095', 'Isenção; Isenção prevista no item 95 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810096';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810096', 'Isenção; Isenção prevista no item 96 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810097';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810097', 'Isenção; Isenção prevista no item 97 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810098';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810098', 'Isenção; Isenção prevista no item 98 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810099';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810099', 'Isenção; Isenção prevista no item 99 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810100';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810100', 'Isenção; Isenção prevista no item 100 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810101';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810101', 'Isenção; Isenção prevista no item 101 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810102';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810102', 'Isenção; Isenção prevista no item 102 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810103';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810103', 'Isenção; Isenção prevista no item 103 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810104';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810104', 'Isenção; Isenção prevista no item 104 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810105';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810105', 'Isenção; Isenção prevista no item 105 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810106';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810106', 'Isenção; Isenção prevista no item 106 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810107';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810107', 'Isenção; Isenção prevista no item 107 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810108';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810108', 'Isenção; Isenção prevista no item 108 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810109';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810109', 'Isenção; Isenção prevista no item 109 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810110';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810110', 'Isenção; Isenção prevista no item 110 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810111';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810111', 'Isenção; Isenção prevista no item 111 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810112';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810112', 'Isenção; Isenção prevista no item 112 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810113';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810113', 'Isenção; Isenção prevista no item 113 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810114';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810114', 'Isenção; Isenção prevista no item 114 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810115';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810115', 'Isenção; Isenção prevista no item 115 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810116';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810116', 'Isenção; Isenção prevista no item 116 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810117';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810117', 'Isenção; Isenção prevista no item 117 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810118';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810118', 'Isenção; Isenção prevista no item 118 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810119';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810119', 'Isenção; Isenção prevista no item 119 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810120';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810120', 'Isenção; Isenção prevista no item 120 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810121';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810121', 'Isenção; Isenção prevista no item 121 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810122';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810122', 'Isenção; Isenção prevista no item 122 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810123';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810123', 'Isenção; Isenção prevista no item 123 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810124';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810124', 'Isenção; Isenção prevista no item 124 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810125';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810125', 'Isenção; Isenção prevista no item 125 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810126';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810126', 'Isenção; Isenção prevista no item 126 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810127';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810127', 'Isenção; Isenção prevista no item 127 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810128';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810128', 'Isenção; Isenção prevista no item 128 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810129';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810129', 'Isenção; Isenção prevista no item 129 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810130';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810130', 'Isenção; Isenção prevista no item 130 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810131';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810131', 'Isenção; Isenção prevista no item 131 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810132';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810132', 'Isenção; Isenção prevista no item 132 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810133';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810133', 'Isenção; Isenção prevista no item 133 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810134';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810134', 'Isenção; Isenção prevista no item 134 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810135';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810135', 'Isenção; Isenção prevista no item 135 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810136';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810136', 'Isenção; Isenção prevista no item 136 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810137';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810137', 'Isenção; Isenção prevista no item 137 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810138';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810138', 'Isenção; Isenção prevista no item 138 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810139';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810139', 'Isenção; Isenção prevista no item 139 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810140';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810140', 'Isenção; Isenção prevista no item 140 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810141';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810141', 'Isenção; Isenção prevista no item 141 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810142';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810142', 'Isenção; Isenção prevista no item 142 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810143';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810143', 'Isenção; Isenção prevista no item 143 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810144';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810144', 'Isenção; Isenção prevista no item 144 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810145';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810145', 'Isenção; Isenção prevista no item 145 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810146';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810146', 'Isenção; Isenção prevista no item 146 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810147';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810147', 'Isenção; Isenção prevista no item 147 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810148';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810148', 'Isenção; Isenção prevista no item 148 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810149';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810149', 'Isenção; Isenção prevista no item 149 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810150';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810150', 'Isenção; Isenção prevista no item 150 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810151';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810151', 'Isenção; Isenção prevista no item 151 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810152';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810152', 'Isenção; Isenção prevista no item 152 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810153';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810153', 'Isenção; Isenção prevista no item 153 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810154';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810154', 'Isenção; Isenção prevista no item 154 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810155';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810155', 'Isenção; Isenção prevista no item 155 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810156';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810156', 'Isenção; Isenção prevista no item 156 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810157';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810157', 'Isenção; Isenção prevista no item 157 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810158';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810158', 'Isenção; Isenção prevista no item 158 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810159';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810159', 'Isenção; Isenção prevista no item 159 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810160';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810160', 'Isenção; Isenção prevista no item 160 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810161';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810161', 'Isenção; Isenção prevista no item 161 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810162';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810162', 'Isenção; Isenção prevista no item 162 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810163';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810163', 'Isenção; Isenção prevista no item 163 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810164';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810164', 'Isenção; Isenção prevista no item 164 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810165';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810165', 'Isenção; Isenção prevista no item 165 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810166';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810166', 'Isenção; Isenção prevista no item 166 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810167';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810167', 'Isenção; Isenção prevista no item 167 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810168';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810168', 'Isenção; Isenção prevista no item 168 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810169';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810169', 'Isenção; Isenção prevista no item 169 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810170';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810170', 'Isenção; Isenção prevista no item 170 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810171';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810171', 'Isenção; Isenção prevista no item 171 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810172';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810172', 'Isenção; Isenção prevista no item 172 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810173';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810173', 'Isenção; Isenção prevista no item 173 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810174';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810174', 'Isenção; Isenção prevista no item 174 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR810175';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR810175', 'Isenção; Isenção prevista no item 175 do Anexo V do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR819999';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR819999', 'Isenção; Isenção prevista em regime especial e/ou programa de incentivo', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR820000';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR820000', 'Redução de base de cálculo; Redução de base de cálculo do imposto reconhecida judicialmente', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR820001';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR820001', 'Redução de base de cálculo; Redução de base de cálculo prevista no item 1 do Anexo VI do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR820002';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR820002', 'Redução de base de cálculo; Redução de base de cálculo prevista no item 2 do Anexo VI do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR820003';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR820003', 'Redução de base de cálculo; Redução de base de cálculo prevista no item 3 do Anexo VI do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR820004';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR820004', 'Redução de base de cálculo; Redução de base de cálculo prevista no item 4 do Anexo VI do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR820005';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR820005', 'Redução de base de cálculo; Redução de base de cálculo prevista no item 5 do Anexo VI do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR820006';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR820006', 'Redução de base de cálculo; Redução de base de cálculo prevista no item 6 do Anexo VI do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR820007';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR820007', 'Redução de base de cálculo; Redução de base de cálculo prevista no item 7 do Anexo VI do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR820008';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR820008', 'Redução de base de cálculo; Redução de base de cálculo prevista no item 8 do Anexo VI do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR820009';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR820009', 'Redução de base de cálculo; Redução de base de cálculo prevista no item 9 do Anexo VI do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR820010';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR820010', 'Redução de base de cálculo; Redução de base de cálculo prevista no item 10 do Anexo VI do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR820011';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR820011', 'Redução de base de cálculo; Redução de base de cálculo prevista no item 11 do Anexo VI do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR820012';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR820012', 'Redução de base de cálculo; Redução de base de cálculo prevista no item 12 do Anexo VI do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR820013';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR820013', 'Redução de base de cálculo; Redução de base de cálculo prevista no item 13 do Anexo VI do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR820014';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR820014', 'Redução de base de cálculo; Redução de base de cálculo prevista no item 14 do Anexo VI do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR820015';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR820015', 'Redução de base de cálculo; Redução de base de cálculo prevista no item 15 do Anexo VI do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR820016';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR820016', 'Redução de base de cálculo; Redução de base de cálculo prevista no item 16 do Anexo VI do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR820017';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR820017', 'Redução de base de cálculo; Redução de base de cálculo prevista no item 17 do Anexo VI do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR820018';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR820018', 'Redução de base de cálculo; Redução de base de cálculo prevista no item 18 do Anexo VI do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR820019';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR820019', 'Redução de base de cálculo; Redução de base de cálculo prevista no item 19 do Anexo VI do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR820020';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR820020', 'Redução de base de cálculo; Redução de base de cálculo prevista no item 20 do Anexo VI do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR820021';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR820021', 'Redução de base de cálculo; Redução de base de cálculo prevista no item 21 do Anexo VI do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR820022';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR820022', 'Redução de base de cálculo; Redução de base de cálculo prevista no item 22 do Anexo VI do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR820023';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR820023', 'Redução de base de cálculo; Redução de base de cálculo prevista no item 23 do Anexo VI do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR820024';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR820024', 'Redução de base de cálculo; Redução de base de cálculo prevista no item 24 do Anexo VI do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR820025';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR820025', 'Redução de base de cálculo; Redução de base de cálculo prevista no item 25 do Anexo VI do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR820026';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR820026', 'Redução de base de cálculo; Redução de base de cálculo prevista no item 26 do Anexo VI do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR820027';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR820027', 'Redução de base de cálculo; Redução de base de cálculo prevista no item 27 do Anexo VI do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR820028';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR820028', 'Redução de base de cálculo; Redução de base de cálculo prevista no item 28 do Anexo VI do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR820029';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR820029', 'Redução de base de cálculo; Redução de base de cálculo prevista no item 29 do Anexo VI do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR820030';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR820030', 'Redução de base de cálculo; Redução de base de cálculo prevista no item 30 do Anexo VI do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR820031';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR820031', 'Redução de base de cálculo; Redução de base de cálculo prevista no item 31 do Anexo VI do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR820032';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR820032', 'Redução de base de cálculo; Redução de base de cálculo prevista no item 32 do Anexo VI do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR820033';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR820033', 'Redução de base de cálculo; Redução de base de cálculo prevista no item 33 do Anexo VI do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR820034';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR820034', 'Redução de base de cálculo; Redução de base de cálculo prevista no item 34 do Anexo VI do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR820035';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR820035', 'Redução de base de cálculo; Redução de base de cálculo prevista no item 35 do Anexo VI do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR820036';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR820036', 'Redução de base de cálculo; Redução de base de cálculo prevista no item 36 do Anexo VI do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR820037';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR820037', 'Redução de base de cálculo; Redução de base de cálculo prevista no item 37 do Anexo VI do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR820038';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR820038', 'Redução de base de cálculo; Redução de base de cálculo prevista no item 38 do Anexo VI do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR820039';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR820039', 'Redução de base de cálculo; Redução de base de cálculo prevista no item 39 do Anexo VI do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR820040';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR820040', 'Redução de base de cálculo; Redução de base de cálculo prevista no item 40 do Anexo VI do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR820041';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR820041', 'Redução de base de cálculo; Redução de base de cálculo prevista no item 41 do Anexo VI do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR820042';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR820042', 'Redução de base de cálculo; Redução de base de cálculo prevista no item 8-A do Anexo VI do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR820043';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR820043', 'Redução de base de cálculo; Redução de base de cálculo prevista no item 36-A do Anexo VI do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR820044';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR820044', 'Redução de base de cálculo; Redução de base de cálculo do imposto prevista no inciso II, do art. 5º da Lei 13.212/2001', '01/11/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR820045';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR820045', 'Redução de base de cálculo; Redução de base de cálculo do imposto prevista no inciso IV, do art. 5º da Lei 13.212/2001', '01/11/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR829999';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR829999', 'Redução de base de cálculo; Redução de base de cálculo prevista em regime especial e/ou programa de incentivo', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830000';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830000', 'Diferimento; Diferimento do pagamento do imposto reconhecido judicialmente', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830001';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830001', 'Diferimento; Diferimento previsto no inciso I do “caput” do art. 28 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830002';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830002', 'Diferimento; Diferimento previsto no inciso II do “caput” do art. 28 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830003';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830003', 'Diferimento; Diferimento previsto no inciso III do “caput” do art. 28 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830004';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830004', 'Diferimento; Diferimento previsto no inciso IV do “caput” do art. 28 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830005';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830005', 'Diferimento; Diferimento previsto no item 1 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830006';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830006', 'Diferimento; Diferimento previsto no item 2 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830007';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830007', 'Diferimento; Diferimento previsto no item 3 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830008';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830008', 'Diferimento; Diferimento previsto no subitem 4.1 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830009';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830009', 'Diferimento; Diferimento previsto no subitem 4.2 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830010';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830010', 'Diferimento; Diferimento previsto no item 5 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830011';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830011', 'Diferimento; Diferimento previsto no item 6 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830012';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830012', 'Diferimento; Diferimento previsto no item 7 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830013';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830013', 'Diferimento; Diferimento previsto no item 8 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830014';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830014', 'Diferimento; Diferimento previsto no item 9 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830015';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830015', 'Diferimento; Diferimento previsto no item 10 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830016';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830016', 'Diferimento; Diferimento previsto no item 11 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830017';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830017', 'Diferimento; Diferimento previsto no item 12 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830018';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830018', 'Diferimento; Diferimento previsto no item 13 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830019';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830019', 'Diferimento; Diferimento previsto no item 14 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830020';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830020', 'Diferimento; Diferimento previsto no item 15 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830021';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830021', 'Diferimento; Diferimento previsto no item 16 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830022';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830022', 'Diferimento; Diferimento previsto no item 17 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830023';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830023', 'Diferimento; Diferimento previsto no item 18 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830024';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830024', 'Diferimento; Diferimento previsto no item 19 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830025';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830025', 'Diferimento; Diferimento previsto no item 20 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830026';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830026', 'Diferimento; Diferimento previsto no item 21 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830027';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830027', 'Diferimento; Diferimento previsto no item 22 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830028';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830028', 'Diferimento; Diferimento previsto no item 23 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830029';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830029', 'Diferimento; Diferimento previsto no item 24 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830030';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830030', 'Diferimento; Diferimento previsto no item 25 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830031';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830031', 'Diferimento; Diferimento previsto no item 26 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830032';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830032', 'Diferimento; Diferimento previsto no subitem 27.1 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830033';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830033', 'Diferimento; Diferimento previsto no subitem 27.2 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830034';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830034', 'Diferimento; Diferimento previsto no subitem 27.3 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830035';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830035', 'Diferimento; Diferimento previsto no item 28 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830036';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830036', 'Diferimento; Diferimento previsto no item 29 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830037';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830037', 'Diferimento; Diferimento previsto no item 30 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830038';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830038', 'Diferimento; Diferimento previsto no item 31 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830039';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830039', 'Diferimento; Diferimento previsto no item 32 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830040';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830040', 'Diferimento; Diferimento previsto no item 33 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830041';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830041', 'Diferimento; Diferimento previsto no item 34 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830042';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830042', 'Diferimento; Diferimento previsto no item 35 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830043';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830043', 'Diferimento; Diferimento previsto no item 36 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830044';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830044', 'Diferimento; Diferimento previsto no item 37 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830045';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830045', 'Diferimento; Diferimento previsto no item 38 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830046';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830046', 'Diferimento; Diferimento previsto no item 39 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830047';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830047', 'Diferimento; Diferimento previsto no item 40 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830048';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830048', 'Diferimento; Diferimento previsto no item 41 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830049';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830049', 'Diferimento; Diferimento previsto no item 42 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830050';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830050', 'Diferimento; Diferimento previsto no item 43 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830051';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830051', 'Diferimento; Diferimento previsto no item 44 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830052';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830052', 'Diferimento; Diferimento previsto no item 45 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830053';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830053', 'Diferimento; Diferimento previsto no item 46 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830054';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830054', 'Diferimento; Diferimento previsto no item 47 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830055';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830055', 'Diferimento; Diferimento previsto no item 48 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830056';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830056', 'Diferimento; Diferimento previsto no item 49 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830057';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830057', 'Diferimento; Diferimento previsto no item 50 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830058';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830058', 'Diferimento; Diferimento previsto no item 51 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830059';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830059', 'Diferimento; Diferimento previsto no item 52 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830060';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830060', 'Diferimento; Diferimento previsto no item 53 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830061';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830061', 'Diferimento; Diferimento previsto no item 54 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830062';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830062', 'Diferimento; Diferimento previsto no item 55 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830063';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830063', 'Diferimento; Diferimento previsto no item 56 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830064';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830064', 'Diferimento; Diferimento previsto no item 57 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830065';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830065', 'Diferimento; Diferimento previsto no item 58 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830066';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830066', 'Diferimento; Diferimento previsto no item 59 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830067';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830067', 'Diferimento; Diferimento previsto no item 60 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830068';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830068', 'Diferimento; Diferimento previsto no item 61 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830069';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830069', 'Diferimento; Diferimento previsto no item 62 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830070';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830070', 'Diferimento; Diferimento previsto no item 63 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830071';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830071', 'Diferimento; Diferimento previsto no item 64 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830072';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830072', 'Diferimento; Diferimento previsto no item 65 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830073';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830073', 'Diferimento; Diferimento previsto no item 66 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830074';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830074', 'Diferimento; Diferimento previsto no item 67 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830075';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830075', 'Diferimento; Diferimento previsto no item 68 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830076';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830076', 'Diferimento; Diferimento previsto no item 69 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830077';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830077', 'Diferimento; Diferimento previsto no item 70 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830078';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830078', 'Diferimento; Diferimento previsto no item 71 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830079';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830079', 'Diferimento; Diferimento previsto no item 72 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830080';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830080', 'Diferimento; Diferimento previsto no item 73 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830081';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830081', 'Diferimento; Diferimento previsto no item 74 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830082';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830082', 'Diferimento; Diferimento previsto no item 75 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830083';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830083', 'Diferimento; Diferimento previsto no item 76 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830084';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830084', 'Diferimento; Diferimento previsto no item 77 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830085';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830085', 'Diferimento; Diferimento previsto no item 78 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830086';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830086', 'Diferimento; Diferimento previsto no item 79 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830087';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830087', 'Diferimento; Diferimento previsto no item 80 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830088';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830088', 'Diferimento; Diferimento previsto no item 81 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830089';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830089', 'Diferimento; Diferimento previsto no item 82 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830090';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830090', 'Diferimento; Diferimento previsto no item 83 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830091';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830091', 'Diferimento; Diferimento previsto no item 84 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830092';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830092', 'Diferimento; Diferimento previsto no item 85 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830093';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830093', 'Diferimento; Diferimento previsto no item 86 do “caput” do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830094';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830094', 'Diferimento; Diferimento previsto no § 1º do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830095';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830095', 'Diferimento; Diferimento previsto no § 11 do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830096';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830096', 'Diferimento; Diferimento previsto no § 17 do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830097';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830097', 'Diferimento; Diferimento previsto no § 19 do art. 31 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830098';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830098', 'Diferimento; Diferimento previsto no art. 32 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830099';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830099', 'Diferimento; Diferimento previsto no art. 39 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830100';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830100', 'Diferimento; Diferimento previsto no art. 41 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830101';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830101', 'Diferimento; Diferimento previsto no inciso I do “caput” do art. 42 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830102';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830102', 'Diferimento; Diferimento previsto no inciso II do “caput” do art. 42 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830103';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830103', 'Diferimento; Diferimento previsto no inciso III do “caput” do art. 42 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830104';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830104', 'Diferimento; Diferimento previsto no inciso IV do “caput” do art. 42 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830105';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830105', 'Diferimento; Diferimento previsto no inciso V do “caput” do art. 42 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830106';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830106', 'Diferimento; Diferimento previsto na alínea a do inc. VI do “caput” do art. 42 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830107';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830107', 'Diferimento; Diferimento previsto na alínea a do inc. VI do “caput” do art. 42 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830108';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830108', 'Diferimento; Diferimento previsto no inciso VII do “caput” do art. 42 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830109';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830109', 'Diferimento; Diferimento previsto no inciso VIII do “caput” do art. 42 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830110';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830110', 'Diferimento; Diferimento previsto no inciso IX do “caput” do art. 42 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830111';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830111', 'Diferimento; Diferimento previsto no inciso X do “caput” do art. 42 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830112';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830112', 'Diferimento; Diferimento previsto no inciso I do “caput” do art. 44 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830113';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830113', 'Diferimento; Diferimento previsto no inciso II do “caput” do art. 44 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830114';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830114', 'Diferimento; Diferimento previsto no inciso III do “caput” do art. 44 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830115';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830115', 'Diferimento; Diferimento previsto no inciso IV do “caput” do art. 44 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830116';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830116', 'Diferimento; Diferimento previsto no inciso V do “caput” do art. 44 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830117';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830117', 'Diferimento; Diferimento previsto no inciso VI do “caput” do art. 44 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830118';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830118', 'Diferimento; Diferimento previsto no inciso VII do “caput” do art. 44 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830119';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830119', 'Diferimento; Diferimento previsto no inciso VIII do “caput” do art. 44 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830120';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830120', 'Diferimento; Diferimento previsto no inciso IX do “caput” do art. 44 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830121';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830121', 'Diferimento; Diferimento previsto no inciso X do “caput” do art. 44 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830122';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830122', 'Diferimento; Diferimento previsto no inciso XI do “caput” do art. 44 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830123';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830123', 'Diferimento; Diferimento previsto no inciso XII do “caput” do art. 44 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830124';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830124', 'Diferimento; Diferimento previsto no inciso XIII do “caput” do art. 44 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830125';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830125', 'Diferimento; Diferimento previsto no inciso XIV do “caput” do art. 44 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830126';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830126', 'Diferimento; Diferimento previsto na alínea a do inciso I do “caput” do art. 46 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830127';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830127', 'Diferimento; Diferimento previsto na alínea a do inciso I do “caput” do art. 46 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830128';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830128', 'Diferimento; Diferimento previsto na alínea a do inciso II do “caput” do art. 46 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830129';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830129', 'Diferimento; Diferimento previsto na alínea b do inciso II do “caput” do art. 46 do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR830130';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR830130', 'Diferimento; Diferimento previsto no art. 6º da Lei 13.212/2001', '01/11/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR839999';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR839999', 'Diferimento; Diferimento previsto em regime especial e/ou programa de incentivo', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR840000';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR840000', 'Suspensão; Suspensão do pagamento do imposto reconhecida judicialmente', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR840001';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR840001', 'Suspensão; Suspensão prevista no inciso I do “caput” do art. 1º do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR840002';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR840002', 'Suspensão; Suspensão prevista no inciso II do “caput” do art. 1º do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR840003';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR840003', 'Suspensão; Suspensão prevista no inciso III do “caput” do art. 1º do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR840004';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR840004', 'Suspensão; Suspensão prevista no inciso IV do “caput” do art. 1º do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR840005';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR840005', 'Suspensão; Suspensão prevista no inciso V do “caput” do art. 1º do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR840006';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR840006', 'Suspensão; Suspensão prevista no inciso VI do “caput” do art. 1º do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR840007';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR840007', 'Suspensão; Suspensão prevista no inciso VII do “caput” do art. 1º do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR840008';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR840008', 'Suspensão; Suspensão prevista no inciso VIII do “caput” do art. 1º do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR840009';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR840009', 'Suspensão; Suspensão prevista no inciso IX do “caput” do art. 1º do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR840010';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR840010', 'Suspensão; Suspensão prevista no inciso X do “caput” do art. 1º do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR840011';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR840011', 'Suspensão; Suspensão prevista no inciso XI do “caput” do art. 1º do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR840012';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR840012', 'Suspensão; Suspensão prevista no inciso XII do “caput” do art. 1º do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR840013';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR840013', 'Suspensão; Suspensão prevista no inciso XIII do “caput” do art. 1º do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR840014';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR840014', 'Suspensão; Suspensão prevista no “caput” do art. 2º do Anexo VIII do RICMS/2017', '01/08/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR840015';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR840015', 'Suspensão; Suspensão prevista no art. 12-A, da Subseção II, do Anexo VIII do RICMS/2017', '01/11/2018', NULL);
   END IF;
   BEGIN
      SELECT COUNT(*)
        INTO V_EXISTE
        FROM CODAJUSTEEFDICMS
       WHERE SGESTADO = 'PR'
         AND IDTPAJUSTE = 'B'
         AND CDAJUSTE = 'PR849999';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_EXISTE := 0;
   END;
   IF V_EXISTE = 0 THEN
      NOVO_CODIGO('CODAJUSTEEFDICMS',V_NOVOCODIGO); 
      INSERT INTO CODAJUSTEEFDICMS 
         (NRSEQCODAJUSTE, SGESTADO, IDTPAJUSTE, CDAJUSTE, DSAJUSTE, DTINIVALID, DTFIMVALID) 
      VALUES 
         (V_NOVOCODIGO, 'PR', 'B', 'PR849999', 'Suspensão; Suspensão prevista em regime especial e/ou programa de incentivo', '01/08/2018', NULL);
   END IF;
   COMMIT;
END;